/*************************************************************************
	Crowd animations, score board and pause screen graphics By
    Christopher Deel

		Copyright (C) 1995 Gametek Inc.
		All rights Reserved

*************************************************************************/

#define GAMELOOP_C 1

#include <sys/types.h>

#include <libetc.h>			   /* For Controller routines */
#include <libgte.h>			   /* For LIBGS */
#include <libgpu.h>			   /* For LIBGS */
#include <libgs.h>			   /* Graphics Library */
#include <libsn.h>

#include "prjtypes.h"
#include "prjhdrs.h"    /* Project header files */
#include "debug.h"

#include "camera.h"
#include "multifil.h"
#include "plyranim.h"
#include "gameloop.h"
#include "arcade.h"
#include "coinlog.h"

#include "fbequ.h"
#include "fbram.h"
#include "fbforms.h"
#include "menu.h"
#include "fbmenu.h"

#define TEAM_STADIUM_DATA 1
#include "teamstad.h"

#define DEFINE_TEAM_COLOR_DATA 1
#include "tmcolor.h"

#define  DEFINE_LOGO_WIDTH_DATA	 1
#include "logowide.h"

//#define LINE_SPLIT 14
#define LINE_SPLIT 13

extern char WeekNum;

//SubTexture_t gSkyTex, gSkyGrassTex;
BYTE gSkyMode = SKY_AUTO;
PolySpritePtr gSkySprite = NULL, gSkyGrassSprite = NULL;
USHORT gSkyClutData[16];

//#define MAX_DROPS 100    // Precipitation (Rain & Snow)
#define MAX_DROPS 75    // Precipitation (Rain & Snow)
INT gNumDrops = 0;
typedef struct
{
	PolySpritePtr sprite;
	SVECTOR pos;
} Drop_t;

INT gDropsEnabled;
SubTexture_t gSnowFlakeTex[3], gRainDropTex[3];
Drop_t gDrop[MAX_DROPS];

SubTexture_t gKickTex;
PolySpritePtr gKickSprite[MAX_POINTS_IN_BALL_ARC];

SubTexture_t gButtonFront1Tex, gButtonFront2Tex;
SubTexture_t gButtonTriangleTex, gButtonSquareTex,
			gButtonUpDnTex, gButtonLRTex,
			gButtonCircleTex, gButtonXTex, gButtonStartTex;

vram_t *gPauseTpage = NULL, *gPauseClut = NULL, gBlackClut,
		*gSkyTpage = NULL,
//		*gCenterTpage = NULL,
//		*gPeopleTpage = NULL,
		*gArcadeFontClut = NULL,
		*gKickClut1 = NULL, *gKickClut2 = NULL, *gKickClut3 = NULL;

vram_t *gTransparentClut;

SubTexture_t 	gTex10;

#define PAUSE_WIDTH		190
#define PAUSE_HEIGHT	190
#define PAUSE_X 		(255 - (PAUSE_WIDTH/2))
#define PAUSE_Y 		20

enum PAUSE_ENUM
{
	PAUSE_TITLE,
//	PAUSE_TEAM_NAME,
	PAUSE_REPLAY,
	PAUSE_TIME_OUT,
	PAUSE_SUBSTITUTE ,
	PAUSE_GAME_STATS ,
	PAUSE_PLAYER_STATS ,
	PAUSE_SET_AUDIBLES,
	PAUSE_CAMERA,
	PAUSE_GAME_OPTIONS ,
	PAUSE_PLAYER_OPTIONS ,
	PAUSE_QUIT_GAME,
	PAUSE_EXIT,
	MAX_PAUSE_TEXT
};

//SubTexture_t gPauseGraphic;
//PolySpritePtr gPauseSprite = NULL;
//UBYTE gPauseGraphicFlag = FALSE;

MenuBorder_t gMenuBorder[2];

MenuText_t gPauseText[MAX_PAUSE_TEXT + 1] =
	{
		"PAUSED", 0,		PAUSE_X + 65, 	PAUSE_Y + 10, 0,
//		" \0       ",0, PAUSE_X + 25, 	PAUSE_Y + 23, 0,
		"INSTANT REPLAY", 1,PAUSE_X + 15, 	PAUSE_Y + 35 + 12, 0,
		"TIME OUT     x",1,	-1,	-1, 0,
		"SUBSTITUTIONS", 1,	 -1,-1,0,
		"TEAM STATS", 1,	 -1,-1,0,
		"PLAYER STATS", 1,	 -1,-1,0,
		"SET AUDIBLES", 1,	 -1,-1,0,
		"CAMERA", 1,		 -1,-1,0,
		"GAME OPTIONS", 1,	-1,	-1, 0,
		"PLAYER OPTIONS", 1, -1,-1,0,
		"QUIT PRACTICE", 1, -1,-1,0,
		"CONTINUE", 1, -1,-1,0,
		NULL,0,0,0,0
	};


MenuInfo_t  gMenuInfo;

INT gPausePad = 0;
INT gPauseBox = -1;

//PolySpritePtr gConversionSprite = NULL;
int gConversionMenuBox = -1;
enum ConversionMenuEnum
{
	CONVERSION_MENU_TEAM,
	CONVERSION_MENU_KICK,
	CONVERSION_MENU_LEFT,
	CONVERSION_MENU_MID,
	CONVERSION_MENU_RIGHT,
	CONVERSION_MENU_MAX
};

#define CONVERSION_MENU_WIDTH  210
#define CONVERSION_MENU_HEIGHT 75
#define CONVERSION_MENU_X (255 - (CONVERSION_MENU_WIDTH/2))
#define CONVERSION_MENU_Y 72

MenuText_t gConversionText[CONVERSION_MENU_MAX + 1] =
	{
		"TEAM                ", 1,CONVERSION_MENU_X +13,
									CONVERSION_MENU_Y +10, 0,
		"KICKING FORMATION", 1,CONVERSION_MENU_X +13,
									CONVERSION_MENU_Y +25, 0,
		"2PT FROM LEFT", 1,CONVERSION_MENU_X +13,
									CONVERSION_MENU_Y +25+(1*12), 0,
		"2PT FROM MIDDLE", 1,CONVERSION_MENU_X +13,
									CONVERSION_MENU_Y +25+(2*12), 0,
		"2PT FROM RIGHT", 1,CONVERSION_MENU_X +13,
									CONVERSION_MENU_Y +25+(3*12), 0,
		NULL,0,0,0,0
	};

// ----- Quit Menu ----
int gQuitMenuAnswer = FALSE;
int gQuitMenuBox = -1;
enum QuitMenuEnum
{
	QUIT_MENU_TITLE,
	QUIT_MENU_YES,
	QUIT_MENU_NO,
	QUIT_MENU_MAX
};

#define QUIT_MENU_X 200
#define QUIT_MENU_Y 105
#define QUIT_MENU_WIDTH  120
#define QUIT_MENU_HEIGHT 52

MenuText_t gQuitMenuText[QUIT_MENU_MAX + 1] =
	{
		"QUIT GAME", 1,QUIT_MENU_X +10, QUIT_MENU_Y +10, 0,
		"YES", 1,QUIT_MENU_X +35, QUIT_MENU_Y +25, 0,
		"NO",  1,QUIT_MENU_X +37, QUIT_MENU_Y +25+(1*12), 0,
		NULL,0,0,0,0
	};

// ----- Replay Menu ----
int gReplayMenuBox = -1;

enum ReplayMenuEnum
{
//	REPLAY_MENU_TEAM,
	REPLAY_MENU_TITLE,
	REPLAY_MENU_CENTER,
	REPLAY_MENU_ROTATE,
	REPLAY_MENU_L1,
	REPLAY_MENU_ZOOM_OUT,
	REPLAY_MENU_L2,
	REPLAY_MENU_ZOOM_IN,
	REPLAY_MENU_PLAY,
	REPLAY_MENU_REW,
	REPLAY_MENU_FF,

	REPLAY_MENU_R1,
	REPLAY_MENU_HEIGHT,
	REPLAY_MENU_R2,
	REPLAY_MENU_TILT,
	REPLAY_MENU_CONTINUE,
	REPLAY_MENU_EXIT,
	REPLAY_MENU_MAX
};

#define REPLAY_MENU_WIDTH  355
#define REPLAY_MENU_HEIGHT 190
#define REPLAY_MENU_X  (255 - (REPLAY_MENU_WIDTH/2))
#define REPLAY_MENU_Y 20

MenuText_t gReplayMenuText[REPLAY_MENU_MAX + 1] =
	{
//		"                 ", 0,REPLAY_MENU_X +15,  REPLAY_MENU_Y +12, 0,
//		"INSTANT REPLAY", 	0,REPLAY_MENU_X +155, REPLAY_MENU_Y +12, 0,
		"INSTANT REPLAY", 	0,REPLAY_MENU_X +112, REPLAY_MENU_Y +12, 0,

		"RE-CENTER CAMERA", 0,REPLAY_MENU_X +50, REPLAY_MENU_Y +36, 0,
		"ROTATE",		 	0,REPLAY_MENU_X +70, REPLAY_MENU_Y +42+(18), 0,
		"L",				0,REPLAY_MENU_X +15, REPLAY_MENU_Y +42+(2*18), 0,
		"ZOOM OUT",			0,REPLAY_MENU_X +90, REPLAY_MENU_Y +42+(2*18), 0,
		"L",		  		0,REPLAY_MENU_X +15, REPLAY_MENU_Y +42+(3*18), 0,
		"ZOOM IN",  		0,REPLAY_MENU_X +90, REPLAY_MENU_Y +42+(3*18), 0,

		"PLAY/PAUSE", 		0,REPLAY_MENU_X +225, REPLAY_MENU_Y +42+(1*18), 0,
		"REW", 				0,REPLAY_MENU_X +225, REPLAY_MENU_Y +42+(2*18), 0,
		"FWD", 				0,REPLAY_MENU_X +225, REPLAY_MENU_Y +42+(3*18), 0,

		"R", 				0,REPLAY_MENU_X +15 , REPLAY_MENU_Y +118, 0,
		"CAMERA HEIGHT",	0,REPLAY_MENU_X +170, REPLAY_MENU_Y +118, 0,
		"R", 				0,REPLAY_MENU_X +15 , REPLAY_MENU_Y +142, 0,
		"CAMERA TILT", 		0,REPLAY_MENU_X +170, REPLAY_MENU_Y +142, 0,

//		"CONTINUE", 		1,REPLAY_MENU_X +135, REPLAY_MENU_Y +160, 0,
//		"EXIT",  			1,REPLAY_MENU_X +152, REPLAY_MENU_Y +160+14, 0,

		"CONTINUE REPLAY",	1,REPLAY_MENU_X +100, REPLAY_MENU_Y +160, 0,
		"RETURN TO GAME",	1,REPLAY_MENU_X +103, REPLAY_MENU_Y +160+14, 0,
		NULL,0,0,0,0
	};

#define NUM_REPLAY_MENU_SPRITES 11
PolySpritePtr gReplayMenuSprite[NUM_REPLAY_MENU_SPRITES];
static Point2DType gReplayButtonPos[] =
{
	{ REPLAY_MENU_X-256 +25, REPLAY_MENU_Y-115 +26},
	{ REPLAY_MENU_X-256 +10, REPLAY_MENU_Y-115 +38+(1*18) },
	{ REPLAY_MENU_X-256 +32, REPLAY_MENU_Y-115 +38+(2*18) },
	{ REPLAY_MENU_X-256 +32, REPLAY_MENU_Y-115 +38+(3*18) },
	{ REPLAY_MENU_X-256 +195, REPLAY_MENU_Y-115 +38+(1*18) },
	{ REPLAY_MENU_X-256 +195, REPLAY_MENU_Y-115 +38+(2*18) },
	{ REPLAY_MENU_X-256 +195, REPLAY_MENU_Y-115 +38+(3*18) },

	{ REPLAY_MENU_X-256 +32 , REPLAY_MENU_Y-115 +115 },
	{ REPLAY_MENU_X-256 +120, REPLAY_MENU_Y-115 +110 },
	{ REPLAY_MENU_X-256 +32 , REPLAY_MENU_Y-115 +140 },
	{ REPLAY_MENU_X-256 +106, REPLAY_MENU_Y-115 +140 }
};

#define AUDIBLE_MENU_WIDTH  190
#define AUDIBLE_MENU_HEIGHT 84
#define AUDIBLE_MENU_X (255 - (AUDIBLE_MENU_WIDTH/2))
#define AUDIBLE_MENU_Y 128


enum CameraMenuEnum
{
	CAMERA_MENU_TITLE,
	CAMERA_MENU_CUSTOMIZE,
	CAMERA_MENU_L1,
	CAMERA_MENU_ZOOM_OUT,
	CAMERA_MENU_L2,
	CAMERA_MENU_ZOOM_IN,
	CAMERA_MENU_R1,
	CAMERA_MENU_HEIGHT,
	CAMERA_MENU_R2,
	CAMERA_MENU_TILT,

	CAMERA_MENU_NORMAL,
	CAMERA_MENU_ISOMETRIC_HIGH,
//	CAMERA_MENU_ISOMETRIC_LOW,
	CAMERA_MENU_SIDELINE_HIGH,
//	CAMERA_MENU_SIDELINE_LOW,
//	CAMERA_MENU_EXIT,
	CAMERA_MENU_MAX
};

INT gCameraMenuState;
INT gCameraMenuBox = -1;
enum CameraMenuStateEnum
{
	CAMERA_MENU_OFF_STATE,
	CAMERA_MENU_SELECTING_STATE,
	CAMERA_MENU_START_LOADING_STATE,
	CAMERA_MENU_LOADING_STATE,
	CAMERA_MENU_DONE_STATE
};

#define CAMERA_MENU_WIDTH  262
#define CAMERA_MENU_HEIGHT 172
#define CAMERA_MENU_X (255 - (CAMERA_MENU_WIDTH/2))
#define CAMERA_MENU_Y 20

MenuText_t gCameraMenuText[CAMERA_MENU_MAX + 1] =
	{
		"CAMERA POSITION", 	1,CAMERA_MENU_X +55,	CAMERA_MENU_Y +10, 0,

		"OFFENSE CAN CUSTOMIZE", 1,CAMERA_MENU_X +13, CAMERA_MENU_Y +68, 0,
		"L",		 	1,CAMERA_MENU_X +13, CAMERA_MENU_Y +84, 0,
		"ZOOM OUT", 	1,CAMERA_MENU_X +105, CAMERA_MENU_Y +84, 0,
		"L", 			1,CAMERA_MENU_X +13, CAMERA_MENU_Y +104, 0,
		"ZOOM IN", 		1,CAMERA_MENU_X +105, CAMERA_MENU_Y +104, 0,
		"R", 			1,CAMERA_MENU_X +13, CAMERA_MENU_Y +126, 0,
		"HEIGHT", 1,CAMERA_MENU_X +154, CAMERA_MENU_Y +126, 0,
		"R", 			1,CAMERA_MENU_X +13, CAMERA_MENU_Y +152, 0,
		"TILT", 	1,CAMERA_MENU_X +154, CAMERA_MENU_Y +152, 0,

		"QUARTERBACK", 		1,CAMERA_MENU_X +64,	CAMERA_MENU_Y +28, 0,
		"CORNER",	 		1, CAMERA_MENU_X +88, -1, 0,
		"SIDELINE", 		1, CAMERA_MENU_X +84, -1, 0,

		NULL,0,0,0,0
	};

#define NUM_CAMERA_MENU_SPRITES 6
PolySpritePtr gCameraMenuSprite[NUM_CAMERA_MENU_SPRITES];
SubTexture_t *gCameraButtonTex[NUM_CAMERA_MENU_SPRITES] =
				{
					&gButtonFront1Tex,&gButtonFront2Tex,
					&gButtonFront1Tex, &gButtonUpDnTex,
					&gButtonFront1Tex, &gButtonLRTex
				};

static Point2DType gCameraButtonPos[] =
{
	{ CAMERA_MENU_X-256 +30, CAMERA_MENU_Y-120 +84},
	{ CAMERA_MENU_X-256 +30, CAMERA_MENU_Y-120 +104 },

	{ CAMERA_MENU_X-256 +30 , CAMERA_MENU_Y-120 +128 },
	{ CAMERA_MENU_X-256 +100, CAMERA_MENU_Y-120 +122 },
	{ CAMERA_MENU_X-256 +30 , CAMERA_MENU_Y-120 +154 },
	{ CAMERA_MENU_X-256 +100, CAMERA_MENU_Y-120 +154 }
};


//extern vram_t *gAnimPage[3];

//;;********* Sideline people ***********
#define SIDE_PERSON_TEX_WIDTH 	32
#define SIDE_PERSON_TEX_HEIGHT	64
#define SIDE_PERSON_WIDTH		160
#define SIDE_PERSON_HEIGHT		128
#define SIDE_POLE_MAN_PIC		0
#define SIDE_CHEER1_PIC			1
#define SIDE_CHEER2_PIC			4
#define SIDE_PEOPLE_NORMAL		9
//#define SIDE_PEOPLE_NORMAL		SIDE_CHEER1_PIC
#define MAX_SIDE_PEOPLE_PICS	28
#define SIDE_PLAYER1_PIC		MAX_SIDE_PEOPLE_PICS
#define MAX_SIDE_PLAYER_PICS	3
#define MAX_NORMAL_SIDE_PEOPLE	(MAX_SIDE_PEOPLE_PICS - SIDE_PEOPLE_NORMAL)
#define MAX_POLE_PEOPLE			4
#define SIDE_HOME_PLAYER_NUM	MAX_POLE_PEOPLE
#define SIDE_AWAY_PLAYER_NUM	(SIDE_HOME_PLAYER_NUM + 20)
#define SIDE_CHEER1_NUM			(SIDE_AWAY_PLAYER_NUM+20)
#define SIDE_CHEER2_NUM			(SIDE_CHEER1_NUM+4)
#define SIDE_CHEER3_NUM			(SIDE_CHEER2_NUM+4)
#define SIDE_CHEER4_NUM			(SIDE_CHEER3_NUM+4)
#define SIDE_EZONE1_NUM			(SIDE_CHEER4_NUM+4)
#define SIDE_EZONE2_NUM			(SIDE_EZONE1_NUM+5)
#define SIDE_SPRINKLE1_NUM		(SIDE_EZONE2_NUM+5)
#define SIDE_SPRINKLE2_NUM		(SIDE_SPRINKLE1_NUM+2)
#define MAX_SIDE_PEOPLE			(SIDE_SPRINKLE2_NUM+2)
//#define MAX_SIDE_PEOPLE 		40

struct
{
	UBYTE u,v;
} SidePersonUV[32] =
	{
		0,0, 32,0, 64,0, 96,0, 128,0, 160,0, 192,0, 224,0,
		0,64, 32,64, 64,64, 96,64, 128,64, 160,64, 192,64, 224,64,
		0,128, 32,128, 64,128, 96,128, 128,128, 160,128, 192,128, 224,128,
		0,192, 32,192, 64,192, 96,192, 128,192, 160,192,
//		192,192, 224,192  // not used
	};

vram_t *gSidePersonClut[32] = {NULL, NULL};
char *gCheerClutData = NULL;

SubTexture_t gSidePlayerTex[3];

struct
{
	PolySpritePtr sprite;
	USHORT x,y;
	char texNum;
	char clutNum;
	UBYTE width, height;
} gSidePersonInfo[MAX_SIDE_PEOPLE + 2];  // ?? + 10

//;;*********** ScoreBoard Vars **************
#define DIGITS_U 128
#define DIGITS_V 160
#define MAX_SCOREBOARD_TILES 40
#define SCOREBOARD_HOME 0
#define SCOREBOARD_AWAY 2
#define SCOREBOARD_QTR 7
#define SCOREBOARD_QTR1 18
#define SCOREBOARD_MIN 8
#define SCOREBOARD_SEC 11
#define SCOREBOARD_PCALL 38


struct
{
	vram_t *tex, *clut;
	char *digitPix[11];
	char *ballIcon, *ballBlank;
	SubTexture_t homeTex, awayTex;
	SubTexture_t homeHelmet, awayHelmet;
	SubTexture_t homeTeamName, awayTeamName;
	short texID;
	char digit[40];
	char prevDigit[40];
} gScoreboard;

char *DpcName[2] = {NULL, NULL};
char *DpcNameClut[2] = {NULL, NULL};
SubTexture_t DpcNameTex[2];
PolySpritePtr TeamNameSprite[2] = {NULL, NULL};
//vram_t *DpcNameClutV[2];
//char DpcNameOn[2] = {0,0};

#define VIDEO_BORDER_HEIGHT 244
#define VIDEO_BORDER_WIDTH  516
#define VIDEO_BORDER_INSET	35

struct
{
	PolySpritePtr sprite[4];
	vram_t *clut;
	SubTexture_t tex;
} gVideoBorder;

//struct
//{
//	SVECTOR pos[4];
//	short tpageID[2];
//	INT mode;
//} gVideoPoly;

ULONG gScoreboardScreenSector[30];
ULONG gScoreboardScreenSectorUse = 0;
char *gScoreboardScreenMfl = NULL;
char *gScoreboardScreenPix = NULL;
char *gScoreboardScreenClt = NULL;
INT gScoreboardScreenState = SCOREBOARD_SCREEN_NONE;


struct
{
	ULONG sector;
	SubTexture_t banner;
	char *data;
} gLogo[2];

#define CENTER_LOGO_WIDTH 500
#define CENTER_LOGO_HEIGHT 500
SubTexture_t gCenterTex, gEndzoneTex[2];
PolySpritePtr gCenterSprite[32], gEndzoneSprite[2][64];


INT g5SecString = -1;
PolySpritePtr g5SecSprite = NULL;
PolySpritePtr gPlayClockSprite = NULL;


#define WIND_VANE_X	400
//#define WIND_VANE_X	40
#define WIND_VANE_Y	30
struct
{
	INT on;
	PolySpritePtr sprite, spriteBg, spriteBg2;
	SubTexture_t dirTex, cupTex;
	MultiFile_t *file;
	INT dir0, cup0;
	INT dirFrame, cupFrame;
	INT boxOn;
} gWindVane = {0,0,0,0,0};


#define MAX_ON_SCREEN_NAMES  8
#define ENABLE_ON_SCREEN_NAME_FLAG  1

typedef struct
{
	INT nameStr;
	INT flags;
	INT player;
	INT len;
	INT sx, sy;
} OnScreenNameType;

OnScreenNameType gOnScreenNames[MAX_ON_SCREEN_NAMES];
//INT PlayerNameShow[MAX_ON_SCREEN_NAMES] = {-1,-1,-1,-1, -1,-1,-1,-1};
INT gOnScreenNamesOn = 0;

//;;********************** Code starts ***********************


/*-------------------------------------------------------------
  CreateArcadeString ~
-------------------------------------------------------------*/
INT CreateArcadeString(char *text, INT x, INT y, INT depth)
{
	register INT str;

	str = CreateString(text, fontdpc4, x , y, FONT0 | PROPORTIONAL);
	ChangeStringDepth(strings.string[str], depth);
	return str;
}  /* End CreateArcadeString() */

/*-------------------------------------------------------------
  IsCpuVsCpu ~
-------------------------------------------------------------*/
INT IsCpuVsCpu(void)
{
	if (GameTeamData[0].ControllerNum[0] == -1
		&& GameTeamData[1].ControllerNum[0] == -1)
	{
		return TRUE;
	}
	else
		return FALSE;
}  /* End InCpuVsCpu() */



/*-------------------------------------------------------------
  GetTeamColorPtr ~
-------------------------------------------------------------*/
TeamColorType *GetTeamColorPtr(INT defense)
{
	INT teamNum ;
	TeamColorType *ptr;

	if (defense)
		teamNum = GameTeamData[DEFENSIVE_SLOT_NUM_MACRO].TeamNumber;
	else
		teamNum = GameTeamData[OFFENSIVE_SLOT_NUM_MACRO].TeamNumber;
	ptr = &gTeamColor[teamNum];
	return ptr;
}  /* End GetTeamColorPtr() */

/*-------------------------------------------------------------
  ShowLoadingScreen ~
-------------------------------------------------------------*/
void ShowLoadingScreen(void)
{
	register INT i, r;
	char *ptr, fname[30];

//	r = GetRandom(17);
//	sprintf(fname, "/stadium/loadin%02d.tim", r);
	
	r = GetRandom(30);
	sprintf(fname, "/loading/loadin%02d.tim", r);
	 DebugPrintf(0, "%s\n", fname);
	PreSeek(fname);
	LoadBackgroundCD(0,fname);	// Load & free from memory

	FreeAllDialogBoxes();

	for(i=0; i<2; i++)
	{
		DoFrameLoop(1, Std_Menu_Frame);
	}

/*
	ptr = LoadCDFile(fname);
	SetBackgroundColor(0,0,0);
//	ClearScreen();
	VSync(0);
	ClearMovie();
	ClearScreen();
	if (ptr)
	{
		DrawSync(0);
		initTexture(0, (ULONG*)ptr);
		DrawSync(0);
		FreeFileData(ptr);
	}

//	LoadBackgroundCD(0, "/stadium/loading.tim");
//	LoadBackgroundCD(0, fname);
	for (i = 0; i < 4; i++)
	{
		VSync(0);
      	InitFrame();
		UpdateBackground();
		DrawSync(0);
		VSync(0);
		ShowFrame();
	}
*/
}

/*-------------------------------------------------------------
  ResetArcadeStrings ~
-------------------------------------------------------------*/
void ResetArcadeStrings(void)
{
	ClearOnScreenNames();
	ShowPlayInfoText(FALSE);
	ResetStrings();
}  /* End ResetArcadeStrings() */

/*------------------------------------------------------------------
  SetClutTransparent ~ Set Semi transparent bit in all colors
  			color0: True = Color 0 tranparent
------------------------------------------------------------------*/
void SetClutTransparent(USHORT *data, INT size, INT color0)
{
	register USHORT *ptr;
	register INT i;

	ptr = data;
	for (i = 0; i < size; i++)
	{
		*ptr |= 0x8000; // Semi Transparent
		ptr++;
	}
	if (color0)
		*data = 0;
}

/*-------------------------------------------------------------
  No2MinuteSeason ~   Safety net
-------------------------------------------------------------*/
void No2MinuteSeason(void)
{
    if (GameType == SEASON_GAME
			|| GameType == PLAYOFF_GAME || GameType == CHAMPIONSHIP_GAME)
	{
		if (GameOptions[GAME_OPTNS_QTR_LENGTH] == 0)  // 2 min
			GameOptions[GAME_OPTNS_QTR_LENGTH] = 1;  // 5 min
	}
}  /* End No2MinSeason() */

/*-------------------------------------------------------------
  SetHomeStadium ~
-------------------------------------------------------------*/
void SetHomeStadiumOptions(void)
{
	INT stadium, turf, weather, sunlight, team, dome;

	if (GameType == CHAMPIONSHIP_GAME) // if SuperBowl
		team = SUPERBOWL_STADIUM;
	else
		team = GameTeamData[0].TeamNumber; // home team
	GameOptions[GAME_OPTNS_STADIUM] = gTeamStadiumInfo[team].stadium - 1;
	GameOptions[GAME_OPTNS_FIELD_TYPE] = gTeamStadiumInfo[team].turf;
	if (turf == DOME_TURF_FIELD)
		gDomeStadium = TRUE;
	No2MinuteSeason();
	PickWeather();
}  /* End SetHomeStadium() */

/*-------------------------------------------------------------
  SetStadiumByOptions ~
-------------------------------------------------------------*/
void SetStadiumByOptions(void)
{
	char weatherTable[] = {0, 1, 2, 0, 0};
	char lightTable[] = {0xc0, 0xa0, 0x90, 0xd0, 0xa0};
	register INT stadium, turf, weather, sunlight, team, dome, textures;

//	team = GameTeamData[0].TeamNumber; // home team

//	stadium = gTeamStadiumInfo[team].stadium;
//	turf = gTeamStadiumInfo[team].turf;

	if (GameType == CHAMPIONSHIP_GAME) // if SuperBowl
		SetHomeStadiumOptions();

	team = GameTeamData[0].TeamNumber; // home team
	stadium = GameOptions[GAME_OPTNS_STADIUM] + 1;
	turf = GameOptions[GAME_OPTNS_FIELD_TYPE];
	dome = FALSE;
	if (turf == DOME_TURF_FIELD)
	{
		turf = TURF_FIELD;
		dome = TRUE;
	}

	gDomeStadium = dome;

	limitRange(stadium, 1, 22);	// adjust Max
//	 dome = True;	//debug
//	 stadium = 6; // debug ;;

	weather = weatherTable[ GameOptions[GAME_OPTNS_WEATHER] ];
	sunlight = lightTable[ GameOptions[GAME_OPTNS_WEATHER] ];
	textures = gTeamStadiumInfo[team].textures;
	SetStadiumConditions(team, stadium, turf, weather, sunlight, dome);
}

/*-------------------------------------------------------------
  SetGameBackground ~
-------------------------------------------------------------*/
void SetGameBackground(INT mode)
{
//	static char prevSky = TRUE;
	register INT sky, grass;

	if (mode)
	{
		gSkyMode = mode;
	}


	switch (gSkyMode)
	{
		case SKY_AUTO:
			if ( (gGameLoopFlags & GLOOP_SCOREBOARD_FLAG)
					|| ((BallFlags & BALL_KICKEDOFF_BFLAG)
					&& (gCamera.ref.vy < -300)) )
				grass = FALSE;
			else
				grass = TRUE;

			if (CoinActiveFlag || ((BallFlags & BALL_KICKEDOFF_BFLAG)
			    					&& (gCamera.ref.vy < -300))
			    					&& !AIIsStalled() )
			{
				sky = False;
				grass = False;
				switch(GameOptions[GAME_OPTNS_WEATHER])
				{
				    case RAINY_WEATHER_CONDITION:
						SetBackgroundColor(107, 107, 107);
				    	break;
					case SNOWY_WEATHER_CONDITION:
						SetBackgroundColor(41, 49, 66);
						break;
				    default:
						SetBackgroundColor(103, 155, 215);
				    	break;
			    }
//				if (gDomeStadium)
//					SetBackgroundColor(0x20, 0x20, 0x20);
			}
			else
			{
				SetBackgroundColor(0,0,0);
			}
			if (gInstantReplayMode /* || gDomeStadium*/)
			{
				grass = TRUE;
			}

			break;
		case SKY_ALL:
			sky = True;
			grass = False;
			break;
		case SKY_GRASS:
			sky = True;
			grass = True;
			break;
		case SKY_BLACK:
			sky = False;
			grass = False;
			SetBackgroundColor(0,0,0);
			break;
		default:
			gSkyMode = SKY_AUTO;
			break;
	}

	SetPolySpriteOnOff(grass, gSkyGrassSprite);
	SetPolySpriteOnOff(sky, gSkySprite);
}

/*-------------------------------------------------------------
  InitSky ~
-------------------------------------------------------------*/
void InitSky(void)
{
	vram_t *clut;
//	char *ptr;
	SubTexture_t subtex;

	 Cmarker();
	clut = register_CLUT((ULONG*)&gSkyClutData[0], VRAM_CLUT16);
//	InitSubTexture(&subtex, gStadTexture[7].texture, clut,
//						0,128, 254,127, 0, 0);
	InitSubTexture(&subtex, gStadTexture[0].texture, clut,
						0,136, 254,119, 0, 0);
	gSkySprite = CreatePolySprite(512, 246);
	SetPolySpriteSubTexture(&subtex, gSkySprite);
	MakePolySprite2d(gSkySprite);
	MovePolySpriteTo(-255, -128, (OTSIZE -4), gSkySprite);

//	InitSubTexture(&subtex, gStadTexture[0].texture,
//					gStadTexture[0].clut, 16,16, 238,108, 0, 0);
	InitSubTexture(&subtex, gStadTexture[1].texture,
					gStadTexture[1].clut, 16,16, 170,98, 0, 0);
	gSkyGrassSprite = CreatePolySprite(512, 240);
	SetPolySpriteSubTexture(&subtex, gSkyGrassSprite);
	MakePolySprite2d(gSkyGrassSprite);
	MovePolySpriteTo(-255, -60, (OTSIZE -20), gSkyGrassSprite);

//	 MovePolySpriteTo(0, 0, 4, gSkySprite);
}

/*-------------------------------------------------------------
  InitDrops ~
-------------------------------------------------------------*/
void InitDrops(INT new)
{
	INT i, weather;
	SubTexture_t subtex;


	weather = GameOptions[GAME_OPTNS_WEATHER];
	if ((weather != SNOWY_WEATHER_CONDITION)
	    			&& (weather != RAINY_WEATHER_CONDITION) )
	    return;

//	InitSubTexture(&subtex, gStadTexture[9].texture, gStadTexture[9].clut,
//						144,48, 4,4, 0, 0);
	InitSubTexture(&gSnowFlakeTex[0], gStadTexture[9].texture,
						gStadTexture[9].clut, 80,208, 4,4, 0, 0);
	InitSubTexture(&gSnowFlakeTex[1], gStadTexture[9].texture,
						gStadTexture[9].clut, 88,208, 4,4, 0, 0);
	InitSubTexture(&gSnowFlakeTex[2], gStadTexture[9].texture,
						gStadTexture[9].clut, 96,208, 4,4, 0, 0);

	InitSubTexture(&gRainDropTex[0], gStadTexture[9].texture,
						gStadTexture[9].clut, 80,224, 4,4, 0, 0);
	InitSubTexture(&gRainDropTex[1], gStadTexture[9].texture,
						gStadTexture[9].clut, 88,224, 4,4, 0, 0);
	InitSubTexture(&gRainDropTex[2], gStadTexture[9].texture,
						gStadTexture[9].clut, 88,224, 4,4, 0, 0);
	if (new)
	{
		gDropsEnabled = True;
		for (i = 0; i < MAX_DROPS; i++)
		{
			gDrop[i].sprite = NULL;
		}
//		gNumDrops = GetRandom(MAX_DROPS20) + 30;
		gNumDrops = MAX_DROPS;
		for (i = 0; i < gNumDrops; i++)
		{
			gDrop[i].pos.vx = GetRandom(512);
			gDrop[i].pos.vy = GetRandom(255 * 16);
			gDrop[i].pos.vz = GetRandom(100) + 15;
		}
	}
	for (i = 0; i < gNumDrops; i++)
	{
		if (weather == SNOWY_WEATHER_CONDITION)
		{
			gDrop[i].sprite = CreatePolySprite(4,4);
			SetPolySpriteSubTexture(&gSnowFlakeTex[0], gDrop[i].sprite);
		}
		else
		{
			gDrop[i].sprite = CreatePolySprite(3,6);
			SetPolySpriteSubTexture(&gRainDropTex[0], gDrop[i].sprite);
		}
		MakePolySprite2d(gDrop[i].sprite);
		MovePolySpriteTo(gDrop[i].pos.vx - 255, (gDrop[i].pos.vy / 16) - 115,
				gDrop[i].pos.vz, gDrop[i].sprite);
	}
}

/*-------------------------------------------------------------
  UpdateDrops ~
-------------------------------------------------------------*/
void UpdateDrops(void)
{
	register INT i, z;
	INT speed, speed2, weather, float1;
//	static INT weave = 1;

	weather = GameOptions[GAME_OPTNS_WEATHER];
	if ((weather != SNOWY_WEATHER_CONDITION)
	    			&& (weather != RAINY_WEATHER_CONDITION) )
	    return;

	if (weather == SNOWY_WEATHER_CONDITION)
	{
		speed = (22 * 2) + 15;
		float1 = GetRandom(gNumDrops);
	}
	else
		speed = (22 * 15);
//	if (gGameLoopFlags & GLOOP_SCOREBOARD_FLAG)
//		speed *= 2;
	for (i = 0; i < gNumDrops; i++)
	{
		if (gDrop[i].sprite != NULL)
		{
			if (gDrop[i].pos.vy > (255 * 16))
			{
				if (gDropsEnabled)
				{
					gDrop[i].pos.vy = -50 - GetRandom(30);
					gDrop[i].pos.vx = GetRandom(512 + 30) - 30 ;
					if (i < gNumDrops/3)
						gDrop[i].pos.vz = 20;
					else
						gDrop[i].pos.vz = GetRandom(100) + 20;
					if (weather == 	RAINY_WEATHER_CONDITION)
					{
						if (gDrop[i].pos.vz < 30)
						{
							ResizePolySprite(4,8, gDrop[i].sprite);
							SetPolySpriteSubTexture(&gRainDropTex[0], gDrop[i].sprite);
						}
						else
						{
							ResizePolySprite(3,4, gDrop[i].sprite);
							SetPolySpriteSubTexture(&gRainDropTex[0], gDrop[i].sprite);
						}
					}
					else	//snow
					{
						if (gDrop[i].pos.vz < 30)
						{
							ResizePolySprite(4,4, gDrop[i].sprite);
							SetPolySpriteSubTexture(&gSnowFlakeTex[GetRandom(2)], gDrop[i].sprite);
						}
						else
						{
							ResizePolySprite(1,1, gDrop[i].sprite);
							SetPolySpriteSubTexture(&gSnowFlakeTex[0], gDrop[i].sprite);
						}
					}
				}
				else  // Drops disabled
					gDrop[i].pos.vy = 255 * 16;
			}
			z = gDrop[i].pos.vz;
			if (weather == SNOWY_WEATHER_CONDITION)
			{
				speed2 = speed - z / 3;
				gDrop[i].pos.vx += 1;
				if ((z < 40 ) && i < (float1+20) && i >= float1)
				{
					gDrop[i].pos.vx += (rand() & 7) -3;
					speed2 /= 2 ;
					FlipPolySpriteX((float1 + i) & 1, gDrop[i].sprite);
//					if (i == float1)
//						FlipPolySpriteX(True, gDrop[i].sprite);
//					else if (i == (float1 + 1))
//						FlipPolySpriteX(False, gDrop[i].sprite);
				}
			}
			else // rain
			{
				speed2 = speed - (z * 5) / 3 ;
				gDrop[i].pos.vx += speed2 / 40;
			}

//			if (speed2 < 6 && speed2 > 0)
//				speed2 = 6;
			gDrop[i].pos.vy += speed2;
//			if (gGameLoopFlags & GLOOP_IN_PCALL_FLAG)
			if (gGameLoopState == GLOOP_IN_PCALL_STATE)
				z = 82;
			MovePolySpriteTo(gDrop[i].pos.vx -255,
					(gDrop[i].pos.vy /16)-115, z, gDrop[i].sprite);
		}
	}
}

/*-------------------------------------------------------------
  EnableDrops ~
-------------------------------------------------------------*/
void EnableDrops(INT on, INT instant)
{
	INT i;

	gDropsEnabled = on;
	if (on)
	{
		for (i = 0; i < gNumDrops; i++)
			gDrop[i].pos.vy = GetRandom(255 * 16);
	}

	if (instant)
	{
		for (i = 0; i < gNumDrops; i++)
		{
			SetPolySpriteOnOff(on, gDrop[i].sprite);
		}
	}
}

/*-------------------------------------------------------------
  PickWeather ~
  When: 0= Sept 1 - Oct 31,   week 1-9
    	1= Nov 1 - Nov 30,    week
    	2= Dec 3 - Playoffs	  week
	Sets GameOptions[GAME_OPTNS_WEATHER]
-------------------------------------------------------------*/
INT PickWeather(void)
{
	register INT val, when;
	INT team, weather, rainPct, snowPct, windPct, windSpeed;
	static char whenTbl[22] = {0,0,0,0, 0,0,0,0, 0,1,1,1, 1,1,2,2, 2,2,2,2, 2,2};

	when = whenTbl[WeekNum-1];
	if (gAttractMode)
		when = 2;
	if (GameType == CHAMPIONSHIP_GAME) // if SuperBowl
		team = SUPERBOWL_STADIUM;
	else
		team = GameTeamData[0].TeamNumber; // home team
	windSpeed = 0;
//	if (gTeamStadiumInfo[team].dome)
//	{
//		weather = NORMAL_WEATHER_CONDITION;
//	}
//	else
	{
		when = min(2,when);
		rainPct = gTeamStadiumInfo[team].weather[when].rain;
		snowPct = rainPct + gTeamStadiumInfo[team].weather[when].snow;
		windPct = snowPct + gTeamStadiumInfo[team].weather[when].wind;
		val = GetRandom(100);
		if (val < rainPct)
		    weather = RAINY_WEATHER_CONDITION;
		else if (val < snowPct)
			weather = SNOWY_WEATHER_CONDITION;
		else if (val < windPct)
		{
			weather = NORMAL_WEATHER_CONDITION;
			windSpeed = 1;
		}
		else
			weather = NORMAL_WEATHER_CONDITION;
		 DebugPrintf(0, "PickWeather: %d  %d,%d,%d  %d =%d\n",
					when, rainPct, snowPct, windPct, val, weather);
	}
	if (GameType == EXHIBITION_GAME || GameType == PRACTICE_GAME)
	{
		weather = NORMAL_WEATHER_CONDITION;
		windSpeed = 0;
	}
	
//	 weather = NORMAL_WEATHER_CONDITION;	 windSpeed = 2; //debug
//	 weather = RAINY_WEATHER_CONDITION;  //DEBUG
     
	GameOptions[GAME_OPTNS_WEATHER] = weather;
	GameOptions[GAME_OPTNS_WIND] = windSpeed;
	return weather;
}

/*-------------------------------------------------------------
  Init1FieldLine ~
-------------------------------------------------------------*/
static void Init1FieldLine(INT yard, SubTexture_t *subtex, ULONG extraFlags)
{
	register INT i;
	SVECTOR vec1, vec2;
	PolySpritePtr sprite[LINE_SPLIT];
//	static USHORT clutData[16];
//	USHORT color;
	vram_t *clut;

	for (i = 0; i < LINE_SPLIT; i++)
	{
		sprite[i] = CreatePolySprite(1, 1);
//		SetPolySpriteSubTexture(subtex, sprite);
		SetPolySpriteFlags(PSPRITE_FIELD_LINE, True, sprite[i]);
		SetPolySpriteFlags(PSPRITE_LOW_PRIORITY, True, sprite[i]);
		if (extraFlags)
			SetPolySpriteFlags(extraFlags, True, sprite[i]);
		SetPolySpriteShade(0x80, 0x80, 0x80, 1, 0, sprite[i]);
		MovePolySpriteTo(0, 0, 0, sprite[i]);
	}
	if (yard < (DEF_GOAL_LINE + (98 * YARDS))
	    		&& yard > (DEF_GOAL_LINE + (2 * YARDS)) )
	{
		TranslateAIVector(yard + 24, NORTH_SIDELINE + 75, 0, &vec1);
		TranslateAIVector(yard - 24, SOUTH_SIDELINE - 75, 0, &vec2);
	}
	else
	{
		TranslateAIVector(yard + 24, NORTH_SIDELINE - 20, 0, &vec1);
		TranslateAIVector(yard - 24, SOUTH_SIDELINE + 20, 0, &vec2);
	}

//	 TranslateAIVector(yard + 24, NORTH_SIDELINE, 0, &vec1);
//	 TranslateAIVector(yard - 24, SOUTH_SIDELINE, 0, &vec2);

//	vec2.vy = vec1.vy = 14;
	vec1.vz -= 10;
	vec2.vz -= 10;
	CreateXZSpriteGrid(subtex, &vec1, &vec2, LINE_SPLIT,1, False, False, &sprite[0]);
#undef LINE_SPLIT
}

/*-------------------------------------------------------------
	InitPlayLines ~
-------------------------------------------------------------*/
void InitPlayLines(void)
{
	register INT i;
	SubTexture_t subtex;
	static USHORT clutData[16];
	static USHORT firstClutData[16];
	USHORT color;
	UWORD firstDown, startBall;
	vram_t *clut, *firstClut;

	if (gInstantReplayMode)
	{
		startBall = OneTimeIRP.StartStartBallX;
		firstDown = OneTimeIRP.StartFirstDownX;
	}
	else
	{
		startBall = StartBallX;
		firstDown = FirstDownX;
	}
	
//	 DebugPrintf(0, "FirstDownX %X\n", firstDown);
//	if(PlayType != KICKOFF_PLAY /* && option? */)
	if(firstDown != 0xFFFF /* && option? */)
	{
		DrawSync(0);
		if (GameOptions[GAME_OPTNS_SCRIMMAGE_MARKER] == OPTION_ON)
		{
			color = GenPSXColor(0x90,0x40,0x40, FALSE);
			for (i = 0; i < 16; i++)
				clutData[i] = color;
			clut = register_CLUT((ULONG*)&clutData[0], VRAM_CLUT16);
			InitSubTexture(&subtex, gStadTexture[9].texture, clut,
					106,208, 1,1, 0, 0);
//			Init1FieldLine(StartBallX +20, &subtex, PSPRITE_PLAY_LINE);
			Init1FieldLine(startBall +20, &subtex, PSPRITE_PLAY_LINE);
		}

		if (GameOptions[GAME_OPTNS_1STDOWN_MARKER] == OPTION_ON)
		{
			color = GenPSXColor(0x40,0x40,0x90, FALSE);
			for (i = 0; i < 16; i++)
				clutData[i] = color;
			clut = register_CLUT((ULONG*)&clutData[0], VRAM_CLUT16);
			InitSubTexture(&subtex, gStadTexture[9].texture, clut,
					106,208, 1,1, 0, 0);
//			Init1FieldLine(FirstDownX +20, &subtex, PSPRITE_PLAY_LINE);
			Init1FieldLine(firstDown +20, &subtex, PSPRITE_PLAY_LINE);
		}
	}
	DrawSync(0);
}

/*-------------------------------------------------------------
  DeletePlayLines ~
-------------------------------------------------------------*/
void DeletePlayLines(void)
{
	DeletePolySpritesWithFlags(PSPRITE_PLAY_LINE);
}

/*-------------------------------------------------------------
  InitFieldLines ~
-------------------------------------------------------------*/
void InitFieldLines(void)
{
	register INT i;
	SubTexture_t subtex;
//	SVECTOR vec1, vec2;
//	PolySpritePtr sprite[LINE_SPLIT];
	static USHORT clutData[16];
//	static USHORT firstClutData[16];
	USHORT color;
	vram_t *clut, *firstClut;

//	return(0);
	DrawSync(0);
//	color = GenPSXColor(0xff,0x9f,0x9f, True);
	color = GenPSXColor(0xff,0xff,0xff, True);
	for (i = 0; i < 16; i++)
		clutData[i] = color;
	clut = register_CLUT((ULONG*)&clutData[0], VRAM_CLUT16);
	clut = register_CLUT((ULONG*)&clutData[0], VRAM_CLUT16);
	InitSubTexture(&subtex, gStadTexture[9].texture, clut,
				106,208, 1,1, 0, 0);
	for (i = 0; i < 21; i++)
	{
		Init1FieldLine(DEF_GOAL_LINE + (i * 5 * YARDS), &subtex, 0);
	}
	InitPlayLines();
}

/*-------------------------------------------------------------
  InitScoreboard ~
-------------------------------------------------------------*/
void InitScoreboard(void)
{
	register INT i;
	register char *base, *ptr;
	GsIMAGE tim;

	gScoreboard.tex = gStadTexture[9].texture;
	gScoreboard.clut = gStadTexture[9].clut;
	for (i = 0; i < MAX_SCOREBOARD_TILES; i++)
	{
		gScoreboard.digit[i] = 99;
//		 gScoreboard.digit[i] = i % 10;  //debug
	}

	base = (char*)GetMultiFilePtr( gAnimationsFile[0],"scorenum.mfl");
	for (i = 0; i < 10; i++)
	{
		ptr = (char*)GetMultiFileByNum((MultiFile_t*)base, i);
		GetTimInfo2(ptr, &tim);
		gScoreboard.digitPix[i] = (char*)tim.pixel;
	}
	InitSubTexture(&gScoreboard.homeTex, gScoreboard.tex, gScoreboard.clut,
					DIGITS_U + 32, DIGITS_V + 64, 32,16, 0, 0);
	InitSubTexture(&gScoreboard.awayTex, gScoreboard.tex, gScoreboard.clut,
					DIGITS_U + 64, DIGITS_V + 64, 32,16, 0, 0);
	GetTimInfo2(GetMultiFilePtr((MultiFile_t*)base, "ballicon.tim"), &tim);
	gScoreboard.ballIcon = (char*)tim.pixel;
	GetTimInfo2(GetMultiFilePtr((MultiFile_t*)base, "ballicox.tim"), &tim);
	gScoreboard.ballBlank = (char*)tim.pixel;
}

/*-------------------------------------------------------------
  UpdateScoreboardDigitTexture ~
-------------------------------------------------------------*/
void UpdateScoreboardDigitTexture(INT num)
{
	register INT u,v;
	SubTexture_t subtex;
	INT digit;

	digit = gScoreboard.digit[num];
	if (digit > 11)
		return;

	u = DIGITS_U + ((num % 8) * 16);
	v = DIGITS_V + ((num / 8) * 16);
	InitSubTexture(&subtex, gScoreboard.tex, gScoreboard.clut,
						u,v, 16,16, 0, 0);
	LoadSubTexturePixels((ULONG*)gScoreboard.digitPix[digit], &subtex);

	if (num == SCOREBOARD_HOME)
	{
		if (!OffensiveSlotNum)
		{
			LoadSubTexturePixels((ULONG*)gScoreboard.ballIcon,
				&gScoreboard.homeTex);
			LoadSubTexturePixels((ULONG*)gScoreboard.ballBlank,
				&gScoreboard.awayTex);
		}
		else
		{
			LoadSubTexturePixels((ULONG*)gScoreboard.ballIcon,
				&gScoreboard.awayTex);
			LoadSubTexturePixels((ULONG*)gScoreboard.ballBlank,
				&gScoreboard.homeTex);

		}
	}
}

/*-------------------------------------------------------------
  SetScoreboard2Digits ~
-------------------------------------------------------------*/
void SetScoreboard2Digits(INT value, INT start)
{
	value %= 100;
	gScoreboard.digit[start] = value / 10;
	gScoreboard.digit[start+1] = value % 10;
}

/*-------------------------------------------------------------
  UpdateScoreboard ~
-------------------------------------------------------------*/
void UpdateScoreboard(void)
{
	static INT cnt = 200;
	INT i, team, qtr;
	Time_t gameTime, playTime;


	playTime = VBlankToTime(GetVBlankTimer(PLAY_TIMER_NUM));
	SetScoreboard2Digits(playTime.seconds, SCOREBOARD_PCALL);

//	if (!gGameLoopFlags & GLOOP_SCOREBOARD_FLAG)
//		return;

	gameTime = VBlankToTime(GetVBlankTimer(GAME_TIMER_NUM));
	SetScoreboard2Digits(gameTime.minutes, SCOREBOARD_MIN);
	SetScoreboard2Digits(gameTime.seconds, SCOREBOARD_SEC);
 	gScoreboard.digit[SCOREBOARD_QTR] = TheQuarter;

//	if (gGameLoopFlags & (GLOOP_AT_SCOREBOARD_FLAG | GLOOP_IN_PCALL_FLAG
//	    		 | GLOOP_PAUSED_FLAG) || CoinActiveFlag )
	if ((gGameLoopFlags & GLOOP_AT_SCOREBOARD_FLAG) 
	    		|| gGameLoopState == GLOOP_IN_PCALL_STATE
	    		|| gGameLoopFlags2.Paused || CoinActiveFlag )
	{
		SetScoreboard2Digits(GameTeamData[0].TotalScore, SCOREBOARD_HOME);
		SetScoreboard2Digits(GameTeamData[1].TotalScore, SCOREBOARD_AWAY);
		for (qtr = 0; qtr < 4; qtr++)
		{
			for (team = 0; team < 2; team ++)
			{
				i = (qtr * 4) + (team * 2) + SCOREBOARD_QTR1;
				SetScoreboard2Digits(GameTeamData[team].ScorePerQuarter[qtr],i);
			}
		}
	}

	for (i = 0; i < 6; i++)
	{
		cnt %= MAX_SCOREBOARD_TILES;
		UpdateScoreboardDigitTexture(cnt);
		cnt++;
	}
	UpdateScoreboardDigitTexture(SCOREBOARD_SEC);
	UpdateScoreboardDigitTexture(SCOREBOARD_SEC+1);
}

/*-------------------------------------------------------------
  UpdateAllScoreboard ~
-------------------------------------------------------------*/
void UpdateAllScoreboard(void)
{
	INT i;

	SetBit (gGameLoopFlags, GLOOP_AT_SCOREBOARD_FLAG);
	for (i = 0; i < 20; i++)
		UpdateScoreboard();
	ResetBit (gGameLoopFlags, GLOOP_AT_SCOREBOARD_FLAG);
}

/*-------------------------------------------------------------
  InitButtonTextures ~
-------------------------------------------------------------*/
void InitButtonTextures(void)
{
	register vram_t *texture, *clut;

	texture = gStadTexture[9].texture;
	clut = gStadTexture[9].clut;
	InitSubTexture(&gButtonFront1Tex, 	texture, clut,80,0,  32,16, 0, 0);
	InitSubTexture(&gButtonFront2Tex, 	texture, clut,80,32, 32,16, 0, 0);
	InitSubTexture(&gButtonTriangleTex, texture, clut,80,64, 18,18, 0, 0);
	InitSubTexture(&gButtonSquareTex, 	texture, clut,80,96, 18,18, 0, 0);
	InitSubTexture(&gButtonCircleTex, 	texture, clut,80,128, 18,18, 0, 0);
	InitSubTexture(&gButtonXTex, 		texture, clut,80,160, 18,18, 0, 0);
	InitSubTexture(&gButtonStartTex, 	texture, clut,80,192, 18,18, 0, 0);
	InitSubTexture(&gButtonUpDnTex, 	texture, clut,104,176,16,32, 0, 0);
	InitSubTexture(&gButtonLRTex,	 	texture, clut,80,240, 32,16, 0, 0);
}

/*-------------------------------------------------------------
  AllocPause ~
-------------------------------------------------------------*/
void InitPause(void)
{
//	INT i;
//	static USHORT data[16];
	register char *ptr;

//	for (i = 0; i < 16; i++)
//		data[i] = (0x8 << 10 | 0x8 << 5 | 0x8);
//	gPauseTpage = alloc_VRam(VRAM_TEXTURE, 0);
//	gPauseClut = register_CLUT( (ULONG*)data, VRAM_CLUT256);
//	DpcNameClutV[0] = register_CLUT( (ULONG*)data, VRAM_CLUT16);
//	DpcNameClutV[1] = register_CLUT( (ULONG*)data, VRAM_CLUT16);
	ptr = (char*)GetMultiFilePtr((MultiFile_t*)gAnimationsFile[0], "selected.clt");
	gMenuInfo.selectClut = register_CLUT((ULONG*)ptr, VRAM_CLUT16);
	Set0Transparent(gMenuInfo.selectClut);
	ptr = (char*)GetMultiFilePtr((MultiFile_t*)gAnimationsFile[0], "notselct.clt");
	gMenuInfo.normClut = register_CLUT((ULONG*)ptr, VRAM_CLUT16);
	Set0Transparent(gMenuInfo.normClut);
	ptr = (char*)GetMultiFilePtr((MultiFile_t*)gAnimationsFile[0], "disable.clt");
	gMenuInfo.disableClut = register_CLUT((ULONG*)ptr, VRAM_CLUT16);
	Set0Transparent(gMenuInfo.disableClut);
	gArcadeFontClut = gMenuInfo.normClut ;
	DrawSync(0);
}

/*-------------------------------------------------------------
  AllocCrowdTpages ~
-------------------------------------------------------------*/
void AllocCrowd(void)
{
//	gPauseTpage = alloc_VRam(VRAM_TEXTURE, 0);
//	gPauseSprite = CreatePolySprite(200 , 128 );
}

/*-------------------------------------------------------------
  GetLogoSector ~
   place: 0-home  1-away  2-SuperBowl
-------------------------------------------------------------*/
ULONG GetLogoSector(INT team, INT place)
{
	char *fname;
	ULONG sector;
	char *location[2] = {"home", "away"};
	char *locationSB[2] = {"hmsb", "awsb"};
	char *base = "/stadium/teamsets";

//	 team = 0;  // debug
	fname = (char*)AllocMem(255);
	if (GameType != CHAMPIONSHIP_GAME) // if not SuperBowl
	{
		sprintf(fname, "%s/%d/%s%03d.mfl",
						base, (team/10), location[place], team);
	}
	else  // if SuperBowl
	{
		sprintf(fname, "%s/sb%d/%s%03d.mfl",
						base, (team/10), locationSB[place], team);
	}

	 DebugPrintf(0, "%s\n", fname);
	sector = GetFileSector(fname);
	FreeMem(fname);
	return sector;
}

/*-------------------------------------------------------------
  LoadLogos ~
-------------------------------------------------------------*/
void LoadLogos(void)
{
	register INT i;

	for(i = HOME_SLOT; i <= AWAY_SLOT; i++)
	{
		if (!gLogo[i].sector)
			gLogo[i].sector = GetLogoSector(GameTeamData[i].TeamNumber, i);
		if (gLogo[i].data == NULL)
			gLogo[i].data = LoadFileSectors(gLogo[i].sector);
	}
}

/*-------------------------------------------------------------
  TextureCenterLogo ~
-------------------------------------------------------------*/
void TextureCenterLogo(void)
{
	INT i,j, num, flipx, flipz;
	SVECTOR vec1, vec2;
	INT radius = 5 * YARD - 110;

	TranslateAINoFlip(MID_FIELDX - radius, MID_FIELDY + radius, 0, &vec1);
	TranslateAINoFlip(MID_FIELDX + radius, MID_FIELDY - radius, 0, &vec2);
//	vec2.vy = vec1.vy = 16;
//	if (OffenseDir == 0)
//	{
		flipx = True;
		flipz = True;
//	}
//	else
//	{
//		flipx = False;
//		flipz = False;
//	}
	CreateXZSpriteGrid(&gCenterTex, &vec1, &vec2, 4,8, flipx, flipz, &gCenterSprite[0]);
}

/*-------------------------------------------------------------
  InitLogoTextures ~
-------------------------------------------------------------*/
void InitLogoTextures(void)
{
	register INT i;
	register char *ptr2;
	register ULONG *buff;
	INT j, num, flipx, flipz;
	char *data, *ptr1;
	USHORT tpageID, x,y, u,v, *colorPtr;
	vram_t *tpage, *clut;
	SVECTOR vec1, vec2;
	SubTexture_t subtex;

	buff = (ULONG*)AllocMem(128 * 128);

	// Center Logo
	DrawSync(0);
	clut = alloc_VRam(VRAM_CLUT16, 0);
	data = gLogo[HOME_SLOT].data;
	tpage = gStadTexture[10].texture;
	tpageID = GetTPage(0,0, tpage->x, tpage->y);
	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "center.cmp") );
	ptr2 = (char*)GetMultiFilePtr((MultiFile_t*)data, "center.clt");
	SetClutTransparent((USHORT *)ptr2, 16, True);

	Reload4BitClut(ptr2, clut);
	InitSubTexture(&gCenterTex, gStadTexture[10].texture, clut,
						0,0, 128,128, 0, 0);
	LoadSubTexturePixels(buff, &gCenterTex);
	DrawSync(0);

	// EndZone Logos
	if (GameType != CHAMPIONSHIP_GAME) // if not SuperBowl
	{
		clut = alloc_VRam(VRAM_CLUT16, 0);
		data = gLogo[HOME_SLOT].data;
		tpage = gStadTexture[10].texture;
		tpageID = GetTPage(0,0, tpage->x, tpage->y);
		DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "ezone.cmp") );
		ptr2 = (char*)GetMultiFilePtr((MultiFile_t*)data, "ezone.clt");
		SetClutTransparent((USHORT *)ptr2, 16, True);

		Reload4BitClut(ptr2, clut);
		InitSubTexture(&gEndzoneTex[HOME_SLOT], gStadTexture[10].texture,
					clut, 0,128, 248,120, 0, 0);
		LoadSubTexturePixels(buff, &gEndzoneTex[HOME_SLOT]);
	}
	else	// if SuperBowl
	{
		for(i = HOME_SLOT; i <= AWAY_SLOT; i++)
		{
			clut = alloc_VRam(VRAM_CLUT16, 0);
			data = gLogo[i].data;
			tpage = gStadTexture[10].texture;
			tpageID = GetTPage(0,0, tpage->x, tpage->y);
			DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "ezonesb.cmp") );
			ptr2 = (char*)GetMultiFilePtr((MultiFile_t*)data, "ezonesb.clt");
			SetClutTransparent((USHORT *)ptr2, 16, True);

			Reload4BitClut(ptr2, clut);
			InitSubTexture(&gEndzoneTex[i], gStadTexture[10].texture,
					clut, i*128,128, 128,120, 0, 0);
			LoadSubTexturePixels(buff, &gEndzoneTex[i]);
		}
	}

	// Init Team textures on scoreboard
	data = gLogo[HOME_SLOT].data;
//	InitSubTexture(&gScoreboard.homeTeamName, gStadTexture[9].texture,
//						gStadTexture[9].clut, 128,128, 128,16, 0, 0);
	InitSubTexture(&gScoreboard.homeTeamName, gStadTexture[9].texture,
						gTex10BlackClut, 128,128, 128,16, 0, 0);
	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "tname.cmp") );
	LoadSubTexturePixels(buff, &gScoreboard.homeTeamName);

//	InitSubTexture(&gScoreboard.homeHelmet, gStadTexture[10].texture,
//						NULL, 256-64, 0, 64,64, 0, 0);
//	DecompressFrameBytes(buff, GetMultiFilePtr(data, "helmet.cmp") );
//	LoadSubTexturePixels(buff, &gScoreboard.homeHelmet);
//	ptr2 = (char*)GetMultiFilePtr(data, "helmet.clt");
//	*(USHORT*)ptr2 = 1; 	// color 0 black
//	 DebugPrintf(0, "tex11 %d,%d\n", gStadTexture[10].clut->x, gStadTexture[10].clut->y);
//	Reload4BitClut(ptr2, gStadTexture[10].clut);

	InitSubTexture(&gScoreboard.homeHelmet, gStadTexture[10].texture,
						gStadTexture[10].clut, 128-64, 0, 64,64, 1, 0);
	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "helmetc.cmp") );
	LoadSubTexturePixels(buff, &gScoreboard.homeHelmet);
	ptr2 = (char*)GetMultiFilePtr((MultiFile_t*)data, "helmetc.clt");
//	*(USHORT*)ptr2 = 1; 	// color 0 black
	 DebugPrintf(0, "tex11 %d,%d\n", gStadTexture[10].clut->x, gStadTexture[10].clut->y);
	ReloadCLUT(ptr2, gStadTexture[10].clut);

	data = gLogo[AWAY_SLOT].data;
//	InitSubTexture(&gScoreboard.awayTeamName, gStadTexture[9].texture,
//					gStadTexture[9].clut, 128,144, 128,16, 0, 0);
	InitSubTexture(&gScoreboard.awayTeamName, gStadTexture[9].texture,
					gTex10BlackClut, 128,144, 128,16, 0, 0);
	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "tname.cmp") );
	LoadSubTexturePixels(buff, &gScoreboard.awayTeamName);

//	InitSubTexture(&gScoreboard.awayHelmet, gStadTexture[8].texture,
//						gStadTexture[8].clut,
//						256-64, 256-64, 64,64, 0, 0);
//	DecompressFrameBytes(buff, GetMultiFilePtr(data, "ahelmet.cmp") );
//	LoadSubTexturePixels(buff, &gScoreboard.awayHelmet);
//	ptr2 = (char*)GetMultiFilePtr(data, "ahelmet.clt");
//	*(USHORT*)ptr2 = 1; 	// color 0 black
//	Reload4BitClut(ptr2, gStadTexture[8].clut);

	InitSubTexture(&gScoreboard.awayHelmet, gStadTexture[8].texture,
						gStadTexture[8].clut,
						128-64, 256-64, 64,64, 1, 0);
	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "ahelmetc.cmp") );
	LoadSubTexturePixels(buff, &gScoreboard.awayHelmet);
	ptr2 = (char*)GetMultiFilePtr((MultiFile_t*)data, "ahelmetc.clt");
//	*(USHORT*)ptr2 = 1; 	// color 0 black
	ReloadCLUT(ptr2, gStadTexture[8].clut);

	data = gLogo[HOME_SLOT].data;
	tpage = gStadTexture[1].texture;
///	tpageID = GetTPage(0,0, tpage->x, tpage->y);
//	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "goteam.cmp") );
//	InitSubTexture(&gLogo[HOME_SLOT].banner, tpage, gStadTexture[1].clut,
//						0,0, 248,64, 0, 0);
//	LoadSubTexturePixels(buff, &gLogo[HOME_SLOT].banner);

	data = gLogo[AWAY_SLOT].data;
	tpage = gStadTexture[2].texture;
///	tpageID = GetTPage(0,0, tpage->x, tpage->y);
//	DecompressFrameBytes(buff, GetMultiFilePtr((MultiFile_t*)data, "goteam.cmp") );
//	InitSubTexture(&gLogo[AWAY_SLOT].banner, tpage, gStadTexture[2].clut,
//						0,0, 248,64, 0, 0);
//	LoadSubTexturePixels(buff, &gLogo[AWAY_SLOT].banner);

	 Cmarker();
	for (i = 0; i < 2; i++)
	{
		DpcName[i] = (char*)GetMultiFilePtr((MultiFile_t*)gLogo[i].data, "tnamec.cmp");
		DpcNameClut[i] = (char*)GetMultiFilePtr((MultiFile_t*)gLogo[i].data, "tnamec.clt");

		clut = register_CLUT((ULONG*)DpcNameClut[i], VRAM_CLUT16);
		InitSubTexture(&DpcNameTex[i], gStadTexture[11].texture, clut,
						0,128 + (i*20), 128,21, 0, 0);
		DecompressFrameBytes(buff, DpcName[i] );
		LoadSubTexturePixels(buff, &DpcNameTex[i]);
	}
	DrawSync(0);
	gCheerClutData = (char*)GetMultiFilePtr((MultiFile_t*)gLogo[HOME_SLOT].data, "cheer.clt");
	FreeMem(buff);
}  /* End InitLogoTextures() */

/*-------------------------------------------------------------
  InitLogoSprites ~
-------------------------------------------------------------*/
void InitLogoSprites(void)
{
	INT i,j, num, flipx, flipz;
	char *data, *ptr1, *ptr2;
	USHORT tpageID, x,y, u,v, *colorPtr;
	vram_t *tpage, *clut;
	SVECTOR vec1, vec2;
	SubTexture_t subtex;
	ULONG *buff;
//	 SubTexture_t subtexDb; // debug
//	 PolySpritePtr spriteDb; // debug
	 
//	 Cmarker();  //debug
//	 InitSubTexture(&subtexDb, gStadTexture[9].texture, gStadTexture[9].clut,
//	 				 64, 128, 128, 128, 0,0);
//	 spriteDb = CreatePolySprite(256, 256);  //debug
//	 MakePolySprite2d(spriteDb);
//	 SetPolySpriteSubTexture(&subtexDb, spriteDb);
//	 MovePolySpriteTo(-50, -50, 1, spriteDb); // debug
	
	 DoDebugSprites();
	// Center Logo
	for (num = 0; num < (4*8); num++)
	{
		gCenterSprite[num] = CreatePolySprite(8, 8);	// dummy sizes
		SetPolySpriteShade(0x80, 0x80, 0x80, 1, 0, gCenterSprite[num]);
		MovePolySpriteTo(0, 0, 0, gCenterSprite[num]);
//		SetPolySpriteFlags(PSPRITE_HIGH_PRIORITY, True, gCenterSprite[num]);
		SetPolySpriteFlags(PSPRITE_LOW_PRIORITY, True, gCenterSprite[num]);
	}
	TextureCenterLogo();

	// EndZone Logos
	for (j = 0; j < 2; j++)
	{
		for (num = 0; num < (8*8); num++)
		{
			gEndzoneSprite[j][num] = CreatePolySprite(8, 8);	// dummy sizes
			SetPolySpriteShade(0x80, 0x80, 0x80, 1, 0, gEndzoneSprite[j][num]);
			MovePolySpriteTo(0, 0, 0, gEndzoneSprite[j][num]);
		}
	}
	if (GameType != CHAMPIONSHIP_GAME) // if not SuperBowl
	{
//		TranslateAINoFlip(DEF_END_LINE + 200, SOUTH_SIDELINE, 0, &vec1);
//		TranslateAINoFlip(DEF_GOAL_LINE - 200, NORTH_SIDELINE, 0, &vec2);
//		TranslateAINoFlip(DEF_END_LINE + 50 + 10, SOUTH_SIDELINE, 0, &vec1);
//		TranslateAINoFlip(DEF_GOAL_LINE + 50, NORTH_SIDELINE, 0, &vec2);
		TranslateAIVector(DEF_END_LINE + 50 + 10, SOUTH_SIDELINE, 0, &vec1);
		TranslateAIVector(DEF_GOAL_LINE + 50, NORTH_SIDELINE, 0, &vec2);
		vec2.vy = vec1.vy = 15;
		CreateXZSpriteGrid(&gEndzoneTex[HOME_SLOT], &vec1, &vec2,
							8,8, False,False, &gEndzoneSprite[0][0]);

//		TranslateAINoFlip(OFF_GOAL_LINE + 200, SOUTH_SIDELINE, 0, &vec1);
//		TranslateAINoFlip(OFF_END_LINE - 200, NORTH_SIDELINE, 0, &vec2);
//		TranslateAINoFlip(OFF_GOAL_LINE + 50, SOUTH_SIDELINE, 0, &vec1);
//		TranslateAINoFlip(OFF_END_LINE + 50 - 10, NORTH_SIDELINE, 0, &vec2);
		TranslateAIVector(OFF_GOAL_LINE + 50, SOUTH_SIDELINE, 0, &vec1);
		TranslateAIVector(OFF_END_LINE + 50 - 10, NORTH_SIDELINE, 0, &vec2);
		vec2.vy = vec1.vy = 15;
		CreateXZSpriteGrid(&gEndzoneTex[HOME_SLOT], &vec1, &vec2,
							8,8, True,True, &gEndzoneSprite[1][0]);
    }
    else	// SuperBowl
    {
//    	PolySpritePtr sprite;
//	SubTexture_t tex;

//		 InitSubTexture(&tex, gStadTexture[10].texture,
//					gEndzoneTex[0].clut, 0,128, 248,64, 0, 0);
//		 sprite = CreatePolySprite(200, 200);  // debug
//		 SetPolySpriteSubTexture(&tex, sprite);
//		 MakePolySprite2d(sprite);
//    	 MovePolySpriteTo(-100, -100, 0, sprite);

		TranslateAINoFlip(DEF_END_LINE + 400, SOUTH_SIDELINE -3000, 0, &vec1);
		TranslateAINoFlip(DEF_GOAL_LINE - 400, NORTH_SIDELINE +3000, 0, &vec2);
		vec2.vy = vec1.vy = 15;
		CreateXZSpriteGrid(&gEndzoneTex[HOME_SLOT], &vec1, &vec2,
							8,8, False,False, &gEndzoneSprite[0][0]);

		TranslateAINoFlip(OFF_GOAL_LINE + 400, SOUTH_SIDELINE -3000, 0, &vec1);
		TranslateAINoFlip(OFF_END_LINE - 400, NORTH_SIDELINE +3000, 0, &vec2);
		vec2.vy = vec1.vy = 15;
		CreateXZSpriteGrid(&gEndzoneTex[AWAY_SLOT], &vec1, &vec2,
							8,8, True,True, &gEndzoneSprite[1][0]);
    }

	for (i = 0; i < 2; i++)
	{
		TeamNameSprite[i] = CreatePolySprite(128, 21);
		SetPolySpriteSubTexture(&DpcNameTex[i], TeamNameSprite[i]);
		MakePolySprite2d(TeamNameSprite[i]);
		MovePolySpriteTo(-20,i * 20,3, TeamNameSprite[i]);
		SetPolySpriteOnOff(FALSE, TeamNameSprite[i]);
	}
}  /* End InitLogoSprites() */

/*-------------------------------------------------------------
  FreeLogos ~
-------------------------------------------------------------*/
void FreeLogos(INT perm)
{
	INT i;

	if (perm)
	{
		for(i = HOME_SLOT; i <= AWAY_SLOT; i++)
		{
			gLogo[i].sector = 0;
			FreeMem(gLogo[i].data);
			gLogo[i].data = NULL;
		}
	}
}

/*-------------------------------------------------------------
  GetTeamNameWidth ~ 
-------------------------------------------------------------*/
INT GetTeamNameWidth(INT away)
{
	INT team;
	team = GameTeamData[away].TeamNumber;
	return gTeamLogoWidth[team];
}  /* End GetTeamNameWidth() */

/*-------------------------------------------------------------
  SetTeamNameSpriteOn ~
-------------------------------------------------------------*/
void SetTeamNameSpriteOn(INT num, INT on, INT x, INT y)
{
//	DpcNameOn[num] = on;
	if (x < 0)
	{
		x = 255 - GetTeamNameWidth(num)/2;
	}
	SetPolySpriteOnOff(on, TeamNameSprite[num]);
	MovePolySpriteTo(x - 255, y - 115, 0, TeamNameSprite[num]);
}  /* End SetTeamNameSpriteOn() */

/*-------------------------------------------------------------
  InitExtraStadiumTextures ~
-------------------------------------------------------------*/
void InitExtraStadiumTextures(char *base)
{
//	char *ptr;
//	GsIMAGE tim;
	register INT i;
	vram_t *texture, *clut;
	static USHORT clutBuff[16]; // Clut data
	USHORT color;

	texture = gStadTexture[9].texture;   // point at already loaded texture
	clut = gStadTexture[9].clut;   // point at already loaded texture
	InitSubTexture(&gTex10, texture, clut, 0, 0, 256, 256, 0, 0);
	InitFontsVRAM(texture);

	color = GenPSXColor(0xF, 0xF, 0xF, FALSE);
	for (i = 0; i < 16; i++)
		clutBuff[i] = color;
	gVideoBorder.clut = register_CLUT( (ULONG*)clutBuff, VRAM_CLUT16);

	SetScoreboardScreenState(SCOREBOARD_SCREEN_BLACK);
	DrawSync(0);
	color = GenPSXColor(0x80, 0x80, 0x80, TRUE);
	for (i = 0; i < 16; i++)
		clutBuff[i] = color;
	gTransparentClut = register_CLUT( (ULONG*)clutBuff, VRAM_CLUT16);
}

/*-------------------------------------------------------------
  FreeExtraStadiumTextures ~
-------------------------------------------------------------*/
void FreeExtraStadiumTextures(void)
{
//	free_VRam(gTex10.texture);
//	free_VRam(gTex10.clut);
}

/*-------------------------------------------------------------
  FreeCrowd ~
-------------------------------------------------------------*/
void FreeCrowd(void)
{

}

/*-------------------------------------------------------------
  InitSideCluts ~
-------------------------------------------------------------*/
void InitSideCluts(void)
{
	INT i;
	char *base, *ptr;

	if (gAnimationsFile[0] == NULL)
	{
		Cerror();
		return;
	}
	base = (char*)GetMultiFilePtr( gAnimationsFile[0],"sideline.mfl");
	if (base == NULL)
	{
		Cerror();
		return;
	}

	i = 0;	// Pole man
	ptr = (char*)GetMultiFileByNum((MultiFile_t*)base, i);
	gSidePersonClut[i] = register_CLUT((ULONG*)ptr, VRAM_CLUT16);
//	 DebugPrintf(0, "SideClut#%d %d %d\n", i,gSidePersonClut[i]->x,gSidePersonClut[i]->y);

	for (i = 9; i < MAX_SIDE_PEOPLE_PICS; i++)
	{
		ptr = (char*)GetMultiFileByNum((MultiFile_t*)base, i);
		gSidePersonClut[i] = register_CLUT((ULONG*)ptr, VRAM_CLUT16);
//		 DebugPrintf(0, "SideClut#%d %d %d\n", i,gSidePersonClut[i]->x,gSidePersonClut[i]->y);
	}

	i = SIDE_CHEER1_PIC;   // Cheerleaders
	gSidePersonClut[i] = register_CLUT((ULONG*)gCheerClutData, VRAM_CLUT16);
	for (i = SIDE_CHEER1_PIC +1; i < SIDE_PEOPLE_NORMAL; i++)
	{
		gSidePersonClut[i] = gSidePersonClut[SIDE_CHEER1_PIC];
	}
	DrawSync(0);
}

/*-------------------------------------------------------------
  PositionSideSprites ~
-------------------------------------------------------------*/
void PositionSideSprites(void)
{
	INT i, flip, clutNum;
	SVECTOR vec1;

	for (i = 0; i < MAX_SIDE_PEOPLE; i++)
	{
		if (i < MAX_POLE_PEOPLE)
			TranslateAIVector(gSidePersonInfo[i].x, gSidePersonInfo[i].y, 0, &vec1);
    	else
			TranslateAINoFlip(gSidePersonInfo[i].x, gSidePersonInfo[i].y, 0, &vec1);
		MovePolySpriteTo(vec1.vx, vec1.vy, vec1.vz, gSidePersonInfo[i].sprite);
		 
		 // debug
//		 if (i < SIDE_PLAYER1_PIC)
//		 { 
//		 	MakePolySprite2d(gSidePersonInfo[i].sprite);
//		 	MovePolySpriteTo(-180+(i%10) * 40, -100 + (i/10) * 30, 0, gSidePersonInfo[i].sprite);
//		 	ResizePolySprite(70,30, gSidePersonInfo[i].sprite);
//		 }
		 
		if (gSidePersonInfo[i].y < MID_FIELDY)
		{
			flip = 1;
			clutNum = 1;
		}
		else
		{
			flip = 0;
			clutNum = 12;
		}
		if (GameTeamData[0].OffDefFlag != ON_OFFENSE)
			clutNum = (clutNum + 11) % 22;  // Swap team colors
		if (i >= MAX_POLE_PEOPLE && gCamera.dir > 8)
			flip = flip ^ 1;
		FlipPolySpriteX(flip, gSidePersonInfo[i].sprite);
		if (gSidePersonInfo[i].texNum >= SIDE_PLAYER1_PIC)
		{
//			if (OffenseDir)
//				clutNum = flip*11;
//			else
//				clutNum = (flip ^ 1) * 11;
			SetPolySpriteClut(gPlayerSprite[clutNum].clut->CLUT_ID,
							gSidePersonInfo[i].sprite);
		}
		if (gSidePersonInfo[i].x < 1)
			SetPolySpriteOnOff(FALSE, gSidePersonInfo[i].sprite);
	}
}

/*-------------------------------------------------------------
  SetPolePeople ~
-------------------------------------------------------------*/
void SetPolePeople(void)
{
	register INT i;
	USHORT x1, x2, y1, y2;

	for (i = 0; i < 4; i++)
		gSidePersonInfo[i].texNum = SIDE_POLE_MAN_PIC;
//	x1 = FirstDownX;
//	x2 = x1 - (10 * YARDS);
	x1 = RefMarkerX[0];	// note: don't show if 0
	x2 = RefMarkerX[1];
	y1 = NORTH_SIDELINE - (5 * QTRYARD);
	y2 = SOUTH_SIDELINE + (5 * QTRYARD);
	gSidePersonInfo[0].x = x1;
	gSidePersonInfo[0].y = y1;
	gSidePersonInfo[1].x = x2;
	gSidePersonInfo[1].y = y1;
	gSidePersonInfo[2].x = x1;
	gSidePersonInfo[2].y = y2;
	gSidePersonInfo[3].x = x2;
	gSidePersonInfo[3].y = y2;
}

/*-------------------------------------------------------------
  PlaceSidePersonRandom ~
-------------------------------------------------------------*/
void PlaceSidePersonRandom(INT i)
{
	register INT x, y, pic, rndVB, rnd2;

//	PlaceSidePersonRandom1(i);
//	return;

	rndVB = GetVBlankCount() >> 8;
	rnd2 = ((rndVB >> 4) & 3) + 1;
	
	if (i >= SIDE_SPRINKLE2_NUM)
	{
		x = OFF_GOAL_LINE - (32 * YARDS) - GetRandom(36 * YARDS);
		y = SOUTH_SIDELINE + 4*YARDS + GetRandom(4 * YARDS);
		pic = SIDE_PEOPLE_NORMAL + ((rndVB + (i * rnd2)) % MAX_NORMAL_SIDE_PEOPLE);
	}
	else if (i >= SIDE_SPRINKLE1_NUM)
	{
		x = OFF_GOAL_LINE - (32 * YARDS) - GetRandom(36 * YARDS);
		y = NORTH_SIDELINE - 4*YARDS - GetRandom(4 * YARDS);
		pic = SIDE_PEOPLE_NORMAL + ((rndVB + (i * rnd2)) % MAX_NORMAL_SIDE_PEOPLE);
	}
	else if (i >= SIDE_EZONE2_NUM)
	{
		x = DEF_END_LINE - (11 * YARDS) - GetRandom(5 * YARDS);
//		x = DEF_END_LINE - (12 * YARDS);
//		y = SOUTH_SIDELINE - GetRandom(30 * YARDS);
		y = SOUTH_SIDELINE - GetRandom(4 * YARDS) - ((i % 5) * (6 *YARDS));
		pic = SIDE_PEOPLE_NORMAL + ((rndVB + (i * rnd2)) % MAX_NORMAL_SIDE_PEOPLE);
		SetPolySpriteFlags(PSPRITE_ENDZONE_PERSON, True, gSidePersonInfo[i].sprite);
	}
	else if (i >= SIDE_EZONE1_NUM)
	{
		x = OFF_END_LINE + (11 * YARDS) + GetRandom(5 * YARDS);
//		x = OFF_END_LINE + (12 * YARDS);
//		y = NORTH_SIDELINE + GetRandom(30 * YARDS);
		y = NORTH_SIDELINE + GetRandom(4 * YARDS) + ((i % 5) * (6 *YARDS));
		pic = SIDE_PEOPLE_NORMAL + ((rndVB + (i * rnd2)) % MAX_NORMAL_SIDE_PEOPLE);
		SetPolySpriteFlags(PSPRITE_ENDZONE_PERSON, True, gSidePersonInfo[i].sprite);
	}
	else if (i >= SIDE_CHEER4_NUM)
	{
		x = DEF_GOAL_LINE + GetRandom(18 * YARDS);
		y = SOUTH_SIDELINE + 3*YARDS + GetRandom(4 * YARDS);
		pic = SIDE_CHEER1_PIC + (i & 7);
	}
	else if (i >= SIDE_CHEER3_NUM)
	{
		x = DEF_GOAL_LINE + GetRandom(18 * YARDS);
		y = NORTH_SIDELINE - 3*YARDS - GetRandom(4 * YARDS);
		pic = SIDE_CHEER1_PIC + (i & 7);
	}
	else if (i >= SIDE_CHEER2_NUM)
	{
		x = OFF_GOAL_LINE - GetRandom(18 * YARDS);
		y = SOUTH_SIDELINE + 3*YARDS + GetRandom(4 * YARDS);
		pic = SIDE_CHEER1_PIC + (i & 7);
	}
	else if (i >= SIDE_CHEER1_NUM)
	{
		x = OFF_GOAL_LINE - GetRandom(18 * YARDS);
		y = NORTH_SIDELINE - 3*YARDS - GetRandom(4 * YARDS);
		pic = SIDE_CHEER1_PIC + (i & 7);
	}
	else if (i >= SIDE_AWAY_PLAYER_NUM)
	{
		x = OFF_GOAL_LINE - (32 * YARDS) - GetRandom(36 * YARDS);
		y = SOUTH_SIDELINE + 3*YARDS + GetRandom(4 * YARDS);
		pic = SIDE_PLAYER1_PIC + GetRandom(3);
	}
	else if (i >= SIDE_HOME_PLAYER_NUM)
	{
		x = OFF_GOAL_LINE - (32 * YARDS) - GetRandom(36 * YARDS);
		y = NORTH_SIDELINE - 3*YARDS - GetRandom(4 * YARDS);
		pic = SIDE_PLAYER1_PIC + GetRandom(3);
	}
	else
	{
		x = 0;
		y = 0;
	}
	gSidePersonInfo[i].texNum = pic;
	gSidePersonInfo[i].x = x;
	gSidePersonInfo[i].y = y;
}

/*-------------------------------------------------------------
  IsSidePersonPlacedOk ~
-------------------------------------------------------------*/
INT IsSidePersonPlacedOk(INT i)
{
	register INT x, y;
	INT j, ret;

	ret = TRUE;
	x =	gSidePersonInfo[i].x;
	y = gSidePersonInfo[i].y;

	if (i >= SIDE_CHEER1_NUM && i < SIDE_EZONE1_NUM)
	{
		for (j = SIDE_CHEER1_NUM; (j < SIDE_EZONE1_NUM) & ret; j++)
		{
			if (abs(x - gSidePersonInfo[j].x) < (2 * YARD))
				if (abs(y - gSidePersonInfo[j].y) < YARD)
				{
					ret = FALSE;
				}
		}
	}
	else if (i >= SIDE_EZONE1_NUM && i < MAX_SIDE_PEOPLE)
	{
		for (j = SIDE_EZONE1_NUM; (j < MAX_SIDE_PEOPLE) & ret; j++)
		{
			if (abs(x - gSidePersonInfo[j].x) < (5 * YARD))
				if (abs(y - gSidePersonInfo[j].y) < (5 * YARD))
				{
					ret = FALSE;
				}
		}
	}
	return ret;
}

/*-------------------------------------------------------------
  RandomizeSidePeople ~
-------------------------------------------------------------*/
void RandomizeSidePeople(void)
{
	INT i, retry, working;

	for (i = 0; i < MAX_SIDE_PEOPLE; i++)
	{
		PlaceSidePersonRandom(i);
		gSidePersonInfo[i].width = SIDE_PERSON_WIDTH + GetRandom(20) -10;
		gSidePersonInfo[i].height = SIDE_PERSON_HEIGHT + GetRandom(10) - 5;
	}
	for (i = SIDE_CHEER1_NUM; i < MAX_SIDE_PEOPLE; i++)
	{
		retry = 0;
		working = TRUE;
		while (working && retry < 5)
		{
			if (IsSidePersonPlacedOk(i))
			{
				working = FALSE;
			}
			else
			{
				PlaceSidePersonRandom(i);
				retry++;
			}
		}
	}
}

/*-------------------------------------------------------------
  InitSidePeople ~
-------------------------------------------------------------*/
void InitSidePeople(INT newGame)
{
	INT x,y, i,n, u, v;
	USHORT tpageId, clutId;
	SVECTOR vec1;
	char *ptr;

//	tpageId = gStadTexture[8].texture->tpage;
	tpageId = GetTPage(0,0, gStadTexture[8].texture->x, gStadTexture[8].texture->y);
	clutId = gStadTexture[8].clut->CLUT_ID;
	
	 DebugPrintf(0, "Side: tpageId %d\n", tpageId);
	if (newGame)
	{
		RandomizeSidePeople();
		return;
	}
	InitSideCluts();

	InitSubTexture(&gSidePlayerTex[0], gStadTexture[10].texture,
					 gPlayerSprite[0].clut, 64, 64, 64, 64, 1, 0);
	InitSubTexture(&gSidePlayerTex[1], gStadTexture[11].texture,
					 gPlayerSprite[1].clut, 0, 192, 64, 64, 1, 0);

	if (CoinActiveFlag)
	{
		InitSubTexture(&gSidePlayerTex[2], gStadTexture[11].texture,
					 gPlayerSprite[1].clut, 0, 192, 64, 64, 1, 0);
	}
	else
	{
		InitSubTexture(&gSidePlayerTex[2], gStadTexture[11].texture,
					 gPlayerSprite[2].clut, 64, 192, 64, 64, 1, 0);
	}
//	ptr = GetFramePtr(PG_SHUFFLE_NUM, 6,2);
//	DecompressFrameShorts(gAnimBuff, ptr);
	ptr = (char*)GetMultiFilePtr( gAnimationsFile[0],"side1.cmb");
	DecompressFrameBytes(gAnimBuff, ptr);
	LoadSubTexturePixels((ULONG*)gAnimBuff, &gSidePlayerTex[0]);
	ptr = (char*)GetMultiFilePtr( gAnimationsFile[0],"side2.cmb");
	DecompressFrameBytes(gAnimBuff, ptr);
	LoadSubTexturePixels((ULONG*)gAnimBuff, &gSidePlayerTex[1]);
	ptr = (char*)GetMultiFilePtr( gAnimationsFile[0],"side3.cmb");
	DecompressFrameBytes(gAnimBuff, ptr);
	LoadSubTexturePixels((ULONG*)gAnimBuff, &gSidePlayerTex[2]);

	SetPolePeople();
	for (i = 0; i < MAX_SIDE_PEOPLE; i++)
	{
		gSidePersonInfo[i].sprite =
			CreatePolySprite(SIDE_PERSON_WIDTH, SIDE_PERSON_HEIGHT);
		if (gSidePersonInfo[i].texNum < SIDE_PLAYER1_PIC)
		{
//			gSidePersonInfo[i].sprite =
//				CreatePolySprite(SIDE_PERSON_WIDTH, SIDE_PERSON_HEIGHT);
			clutId = gSidePersonClut[ gSidePersonInfo[i].texNum ]->CLUT_ID;
			TexturePolySprite(tpageId,
				SidePersonUV[ gSidePersonInfo[i].texNum ].u,
				SidePersonUV[ gSidePersonInfo[i].texNum ].v,
				SIDE_PERSON_TEX_WIDTH -1, SIDE_PERSON_TEX_HEIGHT -1,
				clutId, gSidePersonInfo[i].sprite );
//			TexturePolySprite(tpageId,0,0,SIDE_PERSON_TEX_WIDTH -1,SIDE_PERSON_TEX_HEIGHT -1,clutId,gSidePersonInfo[i].sprite );
		}
		else
		{
			n = gSidePersonInfo[i].texNum - SIDE_PLAYER1_PIC;
			limitRange(n , 0, 2);
			SetPolySpriteSubTexture(&gSidePlayerTex[n],
								gSidePersonInfo[i].sprite);
			ResizePolySprite(gSidePersonInfo[i].width,
				gSidePersonInfo[i].height, gSidePersonInfo[i].sprite);
		}
	}
//	SetPolySpriteFlags(PSPRITE_HIGH_PRIORITY, True, gSidePersonInfo[i].sprite);
//	SetPolySpriteFlags(PSPRITE_PLAYER, True, gSidePersonInfo[i].sprite);
	PositionSideSprites();
	DrawSync(0);
}

/*-------------------------------------------------------------
  FreeSidePeople ~
-------------------------------------------------------------*/
void FreeSidePeople(void)
{
	INT i;

	for (i = 0; i < MAX_SIDE_PEOPLE_PICS; i++)
	{
		if (gSidePersonClut[i])
		{
//			free_VRam(gSidePersonClut[i]);
//			gSidePersonClut[i] = NULL;
		}
	}
}

/*-------------------------------------------------------------
  DimField ~
-------------------------------------------------------------*/
void DimField(INT on)
{
	static vram_t *clut;
	SubTexture_t tex;
	static PolySpritePtr sprite[5];
	static INT active = 0;

	static   USHORT clutData[16];
	USHORT color;
	INT i, numSprites = 5;
	TeamColorType *teamColorPtr;

//	 return;
	if (on)
	{
		if (!active)
		{
			active = True;
			DrawSync(0);
			 Cmarker();
			 DumpVramAlloc();
			color = GenPSXColor(0x66,0x66,0x66, True);
//			color = GenPSXColor(0,0,8, True);
			for (i = 0; i < 16; i++)
				clutData[i] = color;
			clut = register_CLUT((ULONG*)&clutData[0], VRAM_CLUT16);
			InitSubTexture(&tex, gStadTexture[9].texture, clut, 0,0, 1,1, 0, 0);
			sprite[0] = CreatePolySprite(535, 250);
			sprite[1] = CreatePolySprite(535, 13);
			sprite[2] = CreatePolySprite(535, 13);
			sprite[3] = CreatePolySprite(88, 18);
			sprite[4] = CreatePolySprite(55, 18);

			for (i = 0; i < numSprites; i++)
			{
				SetPolySpriteSubTexture(&tex, sprite[i]);
				MakePolySprite2d(sprite[i]);
			}
			InitSubTexture(&tex, gStadTexture[9].texture,
						gStadTexture[9].clut, 123, 208, 1,16, 0, 0);
			SetPolySpriteSubTexture(&tex, sprite[1]);
			SetPolySpriteSubTexture(&tex, sprite[2]);

			SetPolySpriteShade(0x10, 0x10, 0x10, 1, 0, sprite[0]);
			MovePolySpriteTo(0-258, 0-127, 80, sprite[0]);
//			 SetPolySpriteOnOff(False, sprite[0]);

			teamColorPtr = GetTeamColorPtr(1);
			SetPolySpriteShade(teamColorPtr->red,
					teamColorPtr->green, teamColorPtr->blue, 0, 0, sprite[1]);
			MovePolySpriteTo(0-258, 30-127, 79, sprite[1]);

			teamColorPtr = GetTeamColorPtr(0);
			SetPolySpriteShade(teamColorPtr->red,
					teamColorPtr->green, teamColorPtr->blue, 0, 0, sprite[2]);
			MovePolySpriteTo(0-258, 136-127, 79, sprite[2]);

			SetPolySpriteShade(0x56, 0x75, 0x75, 0, 0, sprite[3]);
			MovePolySpriteTo(403-256, 25-127, 78, sprite[3]);
			SetPolySpriteShade(0x56, 0x75, 0x75, 0, 0, sprite[4]);
			MovePolySpriteTo(436-256, 131-127, 78, sprite[4]);

			DrawSync(0);
		}
//		SetPolySpriteOnOff(TRUE, sprite);
	}
	else
	{
		if (active)
		{
			active = False;
			for (i = 0; i < numSprites; i++)
			{
				DeletePolySprite(sprite[i]);
				sprite[i] = NULL;
			}
			free_VRam(clut);
		}
	}
}

/*-------------------------------------------------------------
  DoHalfTimeShow ~
-------------------------------------------------------------*/
void DoHalfTimeShow(void)
{
	 DebugPrintf(0, "Half Time\n");
//	 return; // debug

	if (!gAttractMode && !IsCpuVsCpu())
	{
		 DumpHeap();
		DumpArcadeForPause();
		 DumpHeap();

		HalftimeShell();

		ClearAllPolySprites();
		InitDrops(True);
		ClearAllPolySprites();
		SetStadiumByOptions();
		gPermTexLoaded = False;
		ReloadArcadeForPause();
	}
}  /* End DoHalfTimeShow() */

/****************** Arcade Menu routines ;;*************/

/*-------------------------------------------------------------
  ShowLoadingMessage ~ 
-------------------------------------------------------------*/
void ShowLoadingMessage(INT on)
{
	static INT str = -1, box = -1;
	INT x = 200, y = 203, width, height;
	char *text;
	
	if (on)
	{
		ShowPlayInfoText(FALSE);
		ClearOnScreenNames();
		if (str == -1)
		{
			if (gGameLoopFlags2.SavingCard)
			{
				text = "SAVING TO CARD... Please Wait";
				x = 100;
//				y = 203;
				width = 300;
				height = 16;
			}
			else
			{
				text = "LOADING... Please Wait";
				x = 145;
//				y = 203;
				width = 226;
				height = 16;
			}
			box = PopupDialogBox(x, y, width, height, 2, 0x50, 0x0, 0x0);
//			str = CreateString(text, fontdpc4,	x+2, y+1, FONT0 | PROPORTIONAL);
			str = CreateArcadeString(text, x+2, y+1, 0);
			ChangeStringCLUT(strings.string[str], gMenuInfo.normClut->CLUT_ID);
//			CenterString(str, PlayInfoText1, 255);
//			ChangeString(str, PlayInfoText1, FONT0 | PROPORTIONAL); 				
//			ChangeStringDepth(strings.string[str], 0);
		}
	}
	else
	{
		 Cmarker();
		if (box != -1)
		{
			FreeDialogBox(box);
			box = -1;
			
		}
		 Cmarker();
		if (str != -1)
		{
			PopString(str);
			 Cmarker();
		}
		str = -1;
	}
}  /* End ShowLoadingMessage() */

/*-------------------------------------------------------------
  StartMenuText ~
-------------------------------------------------------------*/
void StartMenuText(MenuText_t *textBase, short min)
{
	INT i, str, x, y, working, center;
	MenuText_t *mtextPtr;
	static INT prevX, prevY;

	working = True;
	gMenuInfo.min = min;
	gMenuInfo.menuText = textBase;
	for (i = 0; working; i++)
	{
//		center = False;
		mtextPtr = gMenuInfo.menuText + i;
		if (mtextPtr->text != NULL)
		{
//			 DebugPrintf(0, "%s\n", mtextPtr->text);
			x = mtextPtr->x;
			y = mtextPtr->y;
			if (x == -2)
				center = True;
			else
				center = False;
			if (x == -1)
				x = prevX;
			if (y == -1)
				y = prevY + 12;
			if (gGameLoopState == GLOOP_INPLAY_STATE
					|| gGameLoopState == GLOOP_LOADING_PCALL_STATE)	
				strlwr(mtextPtr->text);
			else
				strupr(mtextPtr->text);
//			str = CreateString(mtextPtr->text, fontdpc4,
//					x, y, FONT0 | PROPORTIONAL);
			str = CreateArcadeString(mtextPtr->text, x, y, 0);
			mtextPtr->stringID = str;
//			if (center)
//				CenterString(str, mtextPtr->text, 255);
//			ChangeStringDepth(strings.string[str], 0);
			prevX = x;
			prevY = y;
		}
		else
		{
			working = False;
			gMenuInfo.max = i;
		}
	}
//	 DebugPrintf(0, "MenuMax %d\n", gMenuInfo.max);
}

/*-------------------------------------------------------------
  EndMenuText ~
-------------------------------------------------------------*/
void EndMenuText(void)
{
	INT i;
	MenuText_t *mtext;

	mtext = gMenuInfo.menuText;
	for (i = 0; i < gMenuInfo.max; i++)
	{
//		mtextPtr = gMenuInfo.menuText + i;
//		FreeString(mtext[i].stringID);
		if(mtext[i].stringID != -1)
			PopString(mtext[i].stringID);
		mtext[i].stringID = -1;
	}
}

/*-------------------------------------------------------------
  SetMenuColors ~
-------------------------------------------------------------*/
void SetMenuColors(void)
{
	INT i, clutID, flash;
	MenuText_t *mtextPtr;

//	mtext = gPauseText;
	flash = GetVBlankCount() / (VBlanksPerSec / 4);
	flash %= 2;
	if (JpadData[gPausePad] & (JPADx | JPADstart | JPADLup | JPADLdown) )
		flash = 1;
	for (i = 0; i < gMenuInfo.max; i++)
	{
//		 DebugPrintf(0, "%s\n", mtext[i].text);
		mtextPtr = gMenuInfo.menuText + i;
		if (i == gMenuInfo.selection && flash)
			clutID = gMenuInfo.selectClut->CLUT_ID;
		else if (mtextPtr->enabled || i < gMenuInfo.min )
			clutID = gMenuInfo.normClut->CLUT_ID;
		else
			clutID = gMenuInfo.disableClut->CLUT_ID;
		ChangeStringCLUT(strings.string[mtextPtr->stringID], clutID);
	}
}

/*-------------------------------------------------------------
  MoveMenuSelect ~ Move Pause Selection
     dir 1 = up  0 = nothing -1 = down
-------------------------------------------------------------*/
INT MoveMenuSelect(INT dir)
{
	INT i;
	MenuText_t *mtextPtr;

//	mtext = gMenuInfo.menuText;
//	mtext = gPauseText;
	do
	{
		gMenuInfo.selection += dir;
		if (gMenuInfo.selection >= gMenuInfo.max)
			gMenuInfo.selection = gMenuInfo.min;
//		if (mtext[i].text == NULL)
//			gMenuInfo.selection = gMenuInfo.min;
		if (gMenuInfo.selection < gMenuInfo.min)
			gMenuInfo.selection = gMenuInfo.max -1;

			mtextPtr = gMenuInfo.menuText + gMenuInfo.selection;
	} while (!mtextPtr->enabled && (dir != 0) );
	SetMenuColors();
//	    DebugPrintf(0, "Out %d %d %d\n", 
//	    		gMenuInfo.selection, gMenuInfo.min, gMenuInfo.max);
	return gMenuInfo.selection;
}

/*-------------------------------------------------------------
  DoMenuPad ~
-------------------------------------------------------------*/
INT DoMenuPad(INT padnum)
{
	INT cmd;
	static char debounce = False;
	static char selectCnt = 0;
	static ULONG debounceVB = 0;
	USHORT pad;
	static USHORT prevPad = 0xFFFF;

	limitRange(padnum, 0, 8);
	pad = JpadData[padnum];
//	pad = pad & (~prevPad);  //no
	cmd = -1;

	if (prevPad == 0xFFFF && (pad & 0xFFFF)
	    || (padnum < 0) ) // wait for all keys released
	{
		return cmd;
	}

	if (debounce)
	{
		if (GetVBlankCount() > (debounceVB + (VBlanksPerSec / 4)) )
		{
			debounce = False;
			debounceVB = 0;
		}
		else if (pad & 0xFFFF)
			return cmd;
		else
			debounce = False;
	}

//	if ( ((pad & JPADx) && !(prevPad & JPADx))
//	    	 || ((pad & JPADstart) && !prevPad) )  // Selection
	if ((pad & JPADx) || (pad & JPADstart))
	{
		if (!prevPad)
		{
			selectCnt++;
		}
		if (selectCnt > 0)
		{
			cmd = MoveMenuSelect(0);
			PlayEffect(SELECT_SFX);
			debounce = False;
			prevPad = 0xFFFF;
			selectCnt = 0;
		}
	}
	if ( pad & JPADLup)
	{
		MoveMenuSelect(-1);
		PlayEffect(CURSOR_SFX);
		debounce = True;
		debounceVB = GetVBlankCount();
		selectCnt = 0;
	}
	if (pad & JPADLdown)
	{
		MoveMenuSelect(1);
		PlayEffect(CURSOR_SFX);
		debounce = True;
		debounceVB = GetVBlankCount();
		selectCnt = 0;
	}
	if (pad == 0)
	{
		selectCnt = 0;
	}
	
	SetMenuColors();
	prevPad = pad;
	return cmd;
}

/*-------------------------------------------------------------
  InitMenuBorder ~
-------------------------------------------------------------*/
void ShowMenuBorder(INT on, RECT *menuRect, INT bnum)
{
//	GsIMAGE tim;
	register PolySpritePtr sprite;
	register INT i,j;
	char *file, *ptr;
	vram_t *tpage, *clut;
	INT num, u,v, baseU, baseV;
	INT x,y, width,height;
	INT teamNum;
	SubTexture_t subtex;
//	INT xtable[4] = {0, 8, PAUSE_WIDTH - 8, PAUSE_WIDTH};
//	INT ytable[4] = {0, 8, PAUSE_HEIGHT - 8, PAUSE_HEIGHT};
	INT xtable[4] = {0, 8};
	INT ytable[4] = {0, 8};
	USHORT *colorPtr;

	xtable[2] = menuRect->w - 8;
	xtable[3] = menuRect->w;
	ytable[2] = menuRect->h - 8;
	ytable[3] = menuRect->h;
//	 return;		// debug
	if (!on)
	{
		free_VRam(gMenuBorder[bnum].clut);
		gMenuBorder[bnum].clut = False;
		for (i = 0; i < 11; i++)
		{
			DeletePolySprite(gMenuBorder[bnum].sprite[i]);
			gMenuBorder[bnum].sprite[i] = NULL;
		}
	}
	else
	{
		DrawSync(0);
		baseU = 128-28;
		baseV = 128+16;
		teamNum = GameTeamData[gMenuInfo.team].TeamNumber;
		tpage = gStadTexture[9].texture;
//		 DebugPrintf(0,"Tex10 %d %d\n", gStadTexture[9].texture->x,
//		 						 gStadTexture[9].texture->y);
		
//		file = (char *)GetMultiFilePtr( gAnimationsFile[0], "pause.tim");
//		GetTimInfo2(file, &tim);
//		colorPtr = (USHORT*)tim.clut;
//		colorPtr += 4;
//		*colorPtr = *colorPtr | 0x8000;
//		SetClutTransparent((USHORT *)tim.clut, 16, True);
//		clut = register_CLUT((ULONG*)tim.clut, VRAM_CLUT16);

		DrawSync(0);
		file = (char *)GetMultiFilePtr( gAnimationsFile[0], "pause.clt");
		SetClutTransparent((USHORT *)file, 16, True);
		clut = register_CLUT((ULONG*)file, VRAM_CLUT16);
		DrawSync(0);
		
		gMenuBorder[bnum].clut = clut;
		InitSubTexture(&subtex, tpage, clut, baseU, baseV, 24,24, 0,0);
//		LoadSubTexturePixels(tim.pixel, &subtex);
		for (j = 0; j < 3; j++)
		{
			for (i = 0; i < 3; i++)
			{
				num = (j*3) + i;
				u = baseU + (i * 8);
				v = baseV + (j * 8);
				x = menuRect->x + xtable[i];
				y = menuRect->y + ytable[j];
				width = xtable[i+1] - xtable[i];
				height = ytable[j+1] - ytable[j];
//				 DebugPrintf(0, "P Border#%d  %d,%d  ", num,u,v);
//				 DebugPrintf(0, "%d,%d,%d,%d\n", x,y,width,height);
				sprite = CreatePolySprite(width, height) ;
				gMenuBorder[bnum].sprite[num] = sprite;
				TexturePolySprite(subtex.texture->tpage,
							u, v, 8, 8,	clut->CLUT_ID, sprite);
				MakePolySprite2d(sprite);
				SetPolySpriteShade(gTeamColor[teamNum].red,
					 gTeamColor[teamNum].green, gTeamColor[teamNum].blue, 
					 1, 0, sprite);
				MovePolySpriteTo(x-256 , y-115, 1, sprite);
			}//for
		}//for
		x = menuRect->x;
		y = menuRect->y;
		width = menuRect->w;
		height = menuRect->h;
		InitSubTexture(&subtex, tpage, clut, baseU+4, baseV+4, 1,1, 0,0);
		for (i = 9; i < 11; i++)
		{
			sprite = CreatePolySprite(width, height) ;
			gMenuBorder[bnum].sprite[i] = sprite;
			SetPolySpriteSubTexture(&subtex, sprite);
			MakePolySprite2d(sprite);
			SetPolySpriteShade(0x10, 0x10, 0x10, 1, 0, sprite);
			MovePolySpriteTo(x-256 , y-115, 1, sprite);
		}
		DrawSync(0);
	}// else
}

/*-------------------------------------------------------------
  ShowArcadeMenuBox ~ 
-------------------------------------------------------------*/
int ShowArcadeMenuBox(int x, int y, int width, int height, int side)
{
	int slot, teamNum, red, green, blue, box;

	switch (side)
	{
		case 0:
			slot = OffensiveSlotNum;
			break;
		case 1:
			slot = DefensiveSlotNum;
			break;
		
		case -1:
		default:	
			slot = gMenuInfo.team;
			break;
	}
	
	teamNum = GameTeamData[slot].TeamNumber;
	red = gTeamColor[teamNum].red / 3;
	green = gTeamColor[teamNum].green / 3;
	blue = gTeamColor[teamNum].blue / 3;
	
	if (side == -2)
	{
		red = green = blue  =  0x40;
	}
	box = PopupDialogBox(x, y, width, height, 3, red, green, blue);
	ChangeDialogDepth(box, 3);
	return box;
}  /* End ShowArcadeMenuBox() */

/*-------------------------------------------------------------
  StartQuitMenu ~
-------------------------------------------------------------*/
void StartQuitMenu(void)
{
//	GsIMAGE tim;
//	char *ptr;
//	vram_t *tpage, *clut;
	RECT rec;

	gMenuInfo.selection = QUIT_MENU_NO;
	if (gPausePad < 0 )
		gPausePad = 0;
	if (gMenuInfo.team < 0)
		gMenuInfo.team = 0;
//	tpage = gTex10.texture;
//	u = 128;
//	v = 128;

	StartMenuText(gQuitMenuText, QUIT_MENU_YES);
//	setRECT(&rec, QUIT_MENU_X, QUIT_MENU_Y,
//					QUIT_MENU_WIDTH, QUIT_MENU_HEIGHT);
//	ShowMenuBorder(True, &rec, 0);
//	MoveMenuSelect(0);
	gQuitMenuBox = ShowArcadeMenuBox(QUIT_MENU_X, QUIT_MENU_Y,	
					QUIT_MENU_WIDTH, QUIT_MENU_HEIGHT, -1);
	gQuitMenuAnswer = FALSE;
	SetBit(gGameLoopFlags, GLOOP_QUIT_MENU_FLAG);
}

/*-------------------------------------------------------------
  EndQuitMenu ~
-------------------------------------------------------------*/
void EndQuitMenu(void)
{
	INT i;
//	MenuText_t *mtext;

//	mtext = gPauseText;
	EndMenuText();
//	ShowMenuBorder(FALSE, NULL, 0);
	FreeDialogBox(gQuitMenuBox);
	ResetBit(gGameLoopFlags, GLOOP_QUIT_MENU_FLAG);
	if (gQuitMenuAnswer)
	{
//		SetBit(gGameLoopFlags, GLOOP_QUIT_GAME_FLAG);
		SignalEndGame(QUIT_GAME_END);
		if ( gGameLoopFlags & GLOOP_DID_REPLAY_FLAG )
				EndInstantReplay();
		gGameLoopFlags2.Paused = FALSE;
	}
	else
	{
		ShowPauseGraphic(TRUE);
		gGameLoopFlags2.Paused = TRUE;
	}
	 Cmarker();
}

/*-------------------------------------------------------------
  UpdateQuitMenu ~
-------------------------------------------------------------*/
void UpdateQuitMenu(void)
{
	INT cmd;
//	USHORT pad;

//	pad = JpadData[gPausePad];
	cmd = DoMenuPad(gPausePad);
	if (cmd != -1)  // Selection
	{
		cmd = MoveMenuSelect(0);
		if (cmd == QUIT_MENU_YES)
			gQuitMenuAnswer = TRUE;
		else
			gQuitMenuAnswer = FALSE;
		EndQuitMenu();
	}
}

/*-------------------------------------------------------------
  ShowAudibleMenu ~
-------------------------------------------------------------*/
void ShowAudibleMenu(INT side, INT on)
{
	INT i, x, y, baseY, form, slot;
	static int str[10] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
	static int box[2] = {-1,-1};
	static PolySpritePtr sprite[2][4];
	char *text;
	int strtmp, idx;
	RECT rec;

	side &= 1;  // Safety Net
	if (side)
	{
		slot = DefensiveSlotNum;
		gGameLoopFlags2.DefenseAudibleMenu = on;
	}
	else	
	{
		slot = OffensiveSlotNum;
		gGameLoopFlags2.OffenseAudibleMenu = on;
	}
	
	gMenuInfo.team = slot;

//	 DebugPrintf(0, "Audible:%d %d\n", side, on); //debug
//	 return;

	if (on)
	{
	    if( box[side] == -1)
		{
			PlayEffect(CURSOR_SFX);
			
			x = AUDIBLE_MENU_X + 36;
			baseY = AUDIBLE_MENU_Y;
			if (side)
				baseY -= 100;
			y = baseY + 4;
							
			form = PositionFormToPCFormTable[GameTeamData[slot].FormationNumber];
			if (side)  // if defense
				form -= DEF_GOALINE_FORM_NUM;
			for (i= 0; i < 5; i++)
			{
				if (i == 0)
				{
					if (side)
						text = "DEFENSE AUDIBLE";
					else
						text = "OFFENSE AUDIBLE";
				}
				else if (i == 4)
					text = "CANCEL";
				else
				{
					if (side)  // if defense
					{
						text = PlayNames[TeamDefensiveAudible[slot][form][i -1]];
					}
					else
						text = PlayNames[TeamOffensiveAudible[slot][form][i -1]];
				}
//				strtmp = CreateString(text, fontdpc4,
//									x, y, FONT0 | PROPORTIONAL);
				strtmp = CreateArcadeString(text, x, y, 0);
				ChangeStringCLUT(strings.string[strtmp], gArcadeFontClut->CLUT_ID);
//				ChangeStringDepth(strings.string[str[i]], 0);
//				str[side][i] = strtmp;
				str[side*5 + i] = strtmp;
				y += 16;
			}
			for (i = 0; i < 4; i++)
			{
				sprite[side][i] = CreatePolySprite(26,18);
				MakePolySprite2d(sprite[side][i]);
			}
//			setRECT(&rec, AUDIBLE_MENU_X, AUDIBLE_MENU_Y,
//						AUDIBLE_MENU_WIDTH, AUDIBLE_MENU_HEIGHT);
//			ShowMenuBorder(True, &rec, 0);
			x = AUDIBLE_MENU_X;
			y = baseY;
//			box[side] = PopupDialogBox( x, y, 
//				AUDIBLE_MENU_WIDTH, AUDIBLE_MENU_HEIGHT, 3, 0x40, 0x40, 0x40);
			box[side] = ShowArcadeMenuBox( x, y, 
				AUDIBLE_MENU_WIDTH, AUDIBLE_MENU_HEIGHT, side);
			ChangeDialogDepth(box[side], 3);
			
			x = AUDIBLE_MENU_X + 10 - 256;
			y = baseY + 14 - 115;
			SetPolySpriteSubTexture(&gButtonSquareTex, sprite[side][0]);
			MovePolySpriteTo(x, y, 0, sprite[side][0]);
			y += 16;
			SetPolySpriteSubTexture(&gButtonTriangleTex, sprite[side][1]);
			MovePolySpriteTo(x, y, 0, sprite[side][1]);
			y += 16;
			SetPolySpriteSubTexture(&gButtonCircleTex, sprite[side][2]);
			MovePolySpriteTo(x, y, 0, sprite[side][2]);
			y += 16;
			SetPolySpriteSubTexture(&gButtonXTex, sprite[side][3]);
			MovePolySpriteTo(x, y, 0, sprite[side][3]);
		}
	}
	else	// Off
	{
		if (box[side] != -1)
		{
			for (i = 0; i < 5; i++)
			{
				idx = (side * 5) + i;
				if (str[idx] != -1)
					PopString(str[idx]);
				str[idx] = -1;
			}
			for (i = 0; i < 4; i++)
			{
				DeletePolySprite(sprite[side][i]);
				sprite[side][i] = NULL;
			}
//			ShowMenuBorder(False, NULL, 0);
			FreeDialogBox(box[side]);
			box[side] = -1;
			PlayEffect(SELECT_SFX);
		}
	}
}

/*-------------------------------------------------------------
  HideAudibleMenus ~ 
-------------------------------------------------------------*/
void HideAudibleMenus(void)
{
	ShowAudibleMenu(0, FALSE);
	ShowAudibleMenu(1, FALSE);
}  /* End HideAudibleMenus() */

/*-------------------------------------------------------------
  ShowActiveAudibleMenus ~ 
-------------------------------------------------------------*/
void ShowActiveAudibleMenus(void)
{
	HideAudibleMenus();
	if (OffAudibleIsActive())
	{
		ShowAudibleMenu(0, TRUE);
	}
	if (DefAudibleIsActive())
	{
		ShowAudibleMenu(1, TRUE);
	}
}  /* End ShowActiveAudibleMenus() */

/*-------------------------------------------------------------
  ControllerToCpuTeam ~ 
-------------------------------------------------------------*/
INT ControllerToCpuTeam(INT pad)
{
	INT team;
	
	if (pad & 1)
		team = 1;
	else	
		team = 0;
	if (ControllerToTeam(0) == 1)  // if pad 0 is away
		team ^= 1;		// swap
	return team;
}  /* End ControllerToCpuTeam() */

/*-------------------------------------------------------------
  EndPauseGraphic ~
-------------------------------------------------------------*/
void EndPauseGraphic(void)
{
	register INT i;
//	MenuText_t *mtext;

//	mtext = gPauseText;
	SetTeamNameSpriteOn(0, FALSE, 0, 0);
	SetTeamNameSpriteOn(1, FALSE, 0, 0);
	
//	ShowMenuBorder(False, NULL, 0);
	FreeDialogBox(gPauseBox);
	EndMenuText();
//	 DumpStringsUsed();
}

/*-------------------------------------------------------------
  ShowPauseGraphic ~ Show Pause Graphic
  Mode = 0 - Show nothing  1 - Show "Pause"
         2 - "Instant replay"
-------------------------------------------------------------*/
void ShowPauseGraphic(INT mode)
{
	register INT i, timeOuts, team, cpu;
	RECT rec;

	if (mode < 1)
	{
		EndPauseGraphic();
		if (gGameLoopFlags2.OffenseAudibleMenu)
			ShowAudibleMenu(0, TRUE);
		
//		if (gGameLoopFlags2.DefenseAudibleMenu)
//			ShowAudibleMenu(1, TRUE);
		return;
	
	}
	else if (mode == 1)  // Start Pause
	{
//		if (gGameLoopFlags & GLOOP_AUDIBLE_FLAG)
//			ShowAudibleMenu(False);
		
		HideAudibleMenus();
		gMenuInfo.menuText = gPauseText;
		gMenuInfo.max = MAX_PAUSE_TEXT;

		if (OKForInstantReplay() && !gInstantReplayMode)
			gPauseText[PAUSE_REPLAY].enabled = TRUE;
		else
			gPauseText[PAUSE_REPLAY].enabled = FALSE;

		if ((!BallSnapped && !(gGameLoopFlags & GLOOP_SCOREBOARD_FLAG))
		    		|| (gGameLoopState == GLOOP_IN_PCALL_STATE))
			gPauseText[PAUSE_CAMERA].enabled = TRUE;
		else
			gPauseText[PAUSE_CAMERA].enabled = FALSE;
					
	    gMenuInfo.selection = PAUSE_EXIT;
		team = ControllerToTeam(gPausePad);
		gPauseText[PAUSE_SET_AUDIBLES].enabled = False;
		gPauseText[PAUSE_SUBSTITUTE].enabled = FALSE;
		if (team >= 0) 	// User Controlled
		{
			if (gGameLoopState == GLOOP_IN_PCALL_STATE)
			{
				gPauseText[PAUSE_SET_AUDIBLES].enabled = True;
				gPauseText[PAUSE_SUBSTITUTE].enabled = True;
			}
			cpu = FALSE;
		}
		else  // CPU controlled
		{
			cpu = TRUE;
//			if (gPausePad & 1)
//				team = 1;
//			else	
//				team = 0;
//			if (ControllerToTeam(0) == 1)  // if pad 0 is away
//				team ^= 1;		// swap
			team = ControllerToCpuTeam(gPausePad);
		}
		timeOuts = TimeOutDisplayValue(team);
		gMenuInfo.team = team;
		TeamNo = team;	// for Nigel
		PadNo = gPausePad;	// for Nigel
//		sprintf(gPauseText[PAUSE_TEAM_NAME].text, "%s",
//			SpecificTeamData[GameTeamData[team].TeamNumber].TeamCity);
		
		if (timeOuts < 0)  // CPU vs CPU;
			timeOuts = 0;
		sprintf(gPauseText[PAUSE_TIME_OUT].text, "TIME OUT %d  ", timeOuts);
		if (gPausePad < 0)
			gPausePad = 0;
		if (cpu || GameType == PRACTICE_GAME)	
			gPauseText[PAUSE_TIME_OUT].enabled = FALSE;
		else	
			gPauseText[PAUSE_TIME_OUT].enabled = LegalForTimeOut(team);
//		if (PracticeMode == 0) // normal
		if (GameType != PRACTICE_GAME) // normal
		{
//				sprintf(gPauseText[PAUSE_GAME_OPTIONS].text, "%s",
//	                  	"GAME OPTIONS");
				sprintf(gPauseText[PAUSE_QUIT_GAME].text, "%s",
	                  	"QUIT GAME");
		}
		else // Practice mode
		{
//				sprintf(gPauseText[PAUSE_GAME_OPTIONS].text, "%s",
//	                  	"GAME OPTIONS");
				sprintf(gPauseText[PAUSE_QUIT_GAME].text, "%s",
	                  	"QUIT PRACTICE");
		}

		StartMenuText(gPauseText, PAUSE_REPLAY);

//		setRECT(&rec, PAUSE_X, PAUSE_Y, PAUSE_WIDTH, PAUSE_HEIGHT);
//		ShowMenuBorder(True, &rec, 0);
		gPauseBox = ShowArcadeMenuBox(PAUSE_X, PAUSE_Y, 
							PAUSE_WIDTH, PAUSE_HEIGHT, -1);
		
		SetTeamNameSpriteOn(team, TRUE, -1, PAUSE_Y+20);
//		MovePolySpriteTo(PAUSE_X+25-255, PAUSE_Y+20-115,0, TeamNameSprite[team]);
//		MovePolySpriteTo(-GetTeamNameWidth(team)/2, PAUSE_Y+20-115,0, TeamNameSprite[team]);
		
		MoveMenuSelect(0);
	}
}

/*-------------------------------------------------------------
  EndPauseMode ~ 
-------------------------------------------------------------*/
void EndPauseMode(void)
{
	UnPauseAllClocks();
	PauseSound(FALSE);
	gGameLoopFlags2.Paused = FALSE;
	if (gGameLoopState == GLOOP_INPLAY_STATE && !gInstantReplayMode)
		InitPlayOnScreenNames();	
}  /* End EndPauseMode() */

/*-------------------------------------------------------------
  DoGameLoopPausePads ~
-------------------------------------------------------------*/
void DoGameLoopPausePads(void)
{
	INT cmd, debugShell;
//	static char debounce = False;
//	static ULONG debounceVB = 0;
	USHORT pad;
	char *text;

//	gOffensePad = JpadData[GameTeamData[OffensiveSlotNum].ControllerNum[0]];
//	gDefensePad = JpadData[GameTeamData[DefensiveSlotNum].ControllerNum[0]];

	pad = JpadData[gPausePad];
	if (gPauseText[PAUSE_TIME_OUT].enabled)
		gPauseText[PAUSE_TIME_OUT].enabled = LegalForTimeOut(gMenuInfo.team);

	debugShell = FALSE;
	if (CheckEggPassword() 
		   	&& (gGameLoopState == GLOOP_INPLAY_STATE) )
//		   		|| gGameLoopState == GLOOP_IN_PCALL_STATE) )
	{		   		
		debugShell = TRUE;
	}
	if (CheckTesterPassword() && gMenuInfo.selection == PAUSE_QUIT_GAME)
		debugShell = TRUE;
		
	if (debugShell)
	{
		ShowPauseGraphic(0);
//		if ( gGameLoopFlags & GLOOP_DID_REPLAY_FLAG )
//			EndInstantReplay();
		UnPauseAllClocks();
//		ResetBit(gGameLoopFlags, GLOOP_PAUSED_FLAG); // Pause flag off
		ResetArcadeStrings();
		DumpArcadeForPause();
		InitFontsVRAM(gStadTexture[9].texture);
		Display_Debug_Shell(FALSE);
		ResetArcadeStrings();
		ReloadArcadeForPause();
//		EndPauseMode();
//		PauseSound(FALSE);
	}

	cmd = DoMenuPad(gPausePad);
	if (cmd != -1)  // Selection
	{
//		cmd = MoveMenuSelect(0);
		switch(cmd)
		{
			case PAUSE_TIME_OUT:
				CallTimeOut(gMenuInfo.team);
//				text = gPauseText[PAUSE_TIME_OUT].text;
//				sprintf(text, "TIME OUT %d",
//						TimeOutDisplayValue(gMenuInfo.team) );
//						
//				if (gGameLoopState == GLOOP_INPLAY_STATE
//						|| gGameLoopState == GLOOP_LOADING_PCALL_STATE)	
//					strlwr(text);
						
//				strlwr(gPauseText[PAUSE_TIME_OUT].text);  // lower case
//				ChangeString(gPauseText[PAUSE_TIME_OUT].stringID,
//							text, FONT0 | PROPORTIONAL);
//				gMenuInfo.selection = PAUSE_EXIT;
				ShowPauseGraphic(False);
				EndPauseMode();
				gNoPauseCount = 20;
				break;
			case PAUSE_REPLAY:
				if (OKForInstantReplay())
				{
					ShowPauseGraphic(False);
					StartInstantReplay();
					gGameLoopFlags2.Paused = FALSE;
				}
				break;
			case PAUSE_SUBSTITUTE:
				DumpArcadeForPause();
				Display_Substitute(gPausePad);	//
				ClearAllPolySprites();
				InitDrops(True);
				ClearAllPolySprites();
				gPermTexLoaded = False;
//				FreeAllDialogBoxes();
				ReloadArcadeForPause();
				break;
			case PAUSE_GAME_STATS:
				DumpArcadeForPause();
				Display_Game_Stats(gPausePad);
				ClearAllPolySprites();
				InitDrops(True);
				ClearAllPolySprites();
				gPermTexLoaded = False;
//				FreeAllDialogBoxes();
				ReloadArcadeForPause();
				break;
			case PAUSE_PLAYER_STATS:
				DumpArcadeForPause();
				Display_Player_Stats(gPausePad);
				ClearAllPolySprites();
				InitDrops(True);
				ClearAllPolySprites();
				gPermTexLoaded = False;
//				FreeAllDialogBoxes();
				ReloadArcadeForPause();
				break;               
			case PAUSE_SET_AUDIBLES:
				DumpArcadeForPause();
				SetAudiblesMenu(gPausePad);
				ClearAllPolySprites();
				InitDrops(True);
				ClearAllPolySprites();
				gPermTexLoaded = False;
//				FreeAllDialogBoxes();
				ReloadArcadeForPause();
				break;
			case PAUSE_CAMERA:
				gCameraMenuFlag = True;
				ShowPauseGraphic(False);
//				ResetBit(gGameLoopFlags, GLOOP_PAUSED_FLAG); // Pause flag off
				break;
			case PAUSE_PLAYER_OPTIONS:
				DumpArcadeForPause();
//				Display_Player_Options_Shell(gPausePad);
				ClearAllPolySprites();
				InitDrops(True);
				ClearAllPolySprites();
				SetStadiumByOptions();
				gPermTexLoaded = False;
//				FreeAllDialogBoxes();
				ReloadArcadeForPause();
				ConfigureJoyPads();
				break;
			case PAUSE_GAME_OPTIONS:
				DumpArcadeForPause();
				Display_Game_Options_Shell(gPausePad);
				ClearAllPolySprites();
				InitDrops(True);
				ClearAllPolySprites();
				SetStadiumByOptions();
				gPermTexLoaded = False;
//				FreeAllDialogBoxes();
				ReloadArcadeForPause();
				ConfigureJoyPads();
//				LoadStadiumTims(1);
//				InitStadiumTextures();
				break;
			case PAUSE_QUIT_GAME:
				ShowPauseGraphic(False);
				StartQuitMenu();
//				SetBit(gGameLoopFlags, GLOOP_QUIT_GAME_FLAG);
				break;
			case PAUSE_EXIT:
				ShowPauseGraphic(False);
				if ( gGameLoopFlags & GLOOP_DID_REPLAY_FLAG )
					EndInstantReplay();
//				UnPauseAllClocks();
//				PauseSound(FALSE);
//				gGameLoopFlags2.Paused = FALSE;
				EndPauseMode();
				break;
		}
		while (JpadData[gPausePad] & JPADx)
			ReadPads();
//		debounce = False;
	}
}


/*-------------------------------------------------------------
  StartConversionMenu ~
-------------------------------------------------------------*/
void StartConversionMenu(void)
{
//	RECT rec;

	gMenuInfo.selection = CONVERSION_MENU_KICK;
	gMenuInfo.team = LastTeamToScoreSlot;
	gPausePad = GameTeamData[gMenuInfo.team].ControllerNum[0];
	if (gPausePad < 0 )
		gPausePad = 0;
	if (gMenuInfo.team < 0)
		gMenuInfo.team = 0;
	sprintf(gConversionText[CONVERSION_MENU_TEAM].text, "%s",
		SpecificTeamData[GameTeamData[gMenuInfo.team].TeamNumber].TeamCity);

	StartMenuText(gConversionText, CONVERSION_MENU_KICK);
//	setRECT(&rec, CONVERSION_MENU_X, CONVERSION_MENU_Y,
//					CONVERSION_MENU_WIDTH, CONVERSION_MENU_HEIGHT);
//	ShowMenuBorder(True, &rec, 0);
	gConversionMenuBox = ShowArcadeMenuBox(CONVERSION_MENU_X, CONVERSION_MENU_Y,
					CONVERSION_MENU_WIDTH, CONVERSION_MENU_HEIGHT, -1);
	MoveMenuSelect(0);
	SetBit(gGameLoopFlags, GLOOP_CONVERSION_MENU_FLAG);
}

/*-------------------------------------------------------------
  EndConversionMenu ~
-------------------------------------------------------------*/
void EndConversionMenu(void)
{
	ResetBit(gGameLoopFlags, GLOOP_CONVERSION_MENU_FLAG);
	if (gConversionMenuBox != -1)
	{
		EndMenuText();
//		ShowMenuBorder(FALSE, NULL, 0);
		FreeDialogBox(gConversionMenuBox);
		gConversionMenuBox = -1;
		gNoPauseCount = 10;
	}
}

/*-------------------------------------------------------------
  UpdateConversionMenu ~
-------------------------------------------------------------*/
void UpdateConversionMenu(void)
{
//	USHORT pad;
	INT cmd;
	static char val[] =
	    { 0, EXTRA_POINT_KICK,
			EXTRA_POINT_2PT_LEFT,
	        EXTRA_POINT_2PT_MIDDLE,
			EXTRA_POINT_2PT_RIGHT };

//	pad = JpadData[gPausePad];
	cmd = DoMenuPad(gPausePad);
	if (cmd != -1)  // Selection
	{
//		cmd = MoveMenuSelect(0);
		ExtraPointStatus = val[cmd];
		EndConversionMenu();
	}
}


/*-------------------------------------------------------------
  StartReplayMenu ~
-------------------------------------------------------------*/
void StartReplayMenu(void)
{
//	GsIMAGE tim;
//	char *ptr;
	register PolySpritePtr sprite;
	register INT i;
//	INT x,y;
//	INT u,v;
	USHORT id, clutID;
	RECT rec;
//	vram_t *tpage, *clut;
	SubTexture_t *buttonTex[NUM_REPLAY_MENU_SPRITES] = 
	    			{ 	&gButtonUpDnTex, &gButtonLRTex,
						&gButtonFront1Tex,&gButtonFront2Tex,
						&gButtonTriangleTex,&gButtonSquareTex,
						&gButtonCircleTex, 
						&gButtonFront1Tex, &gButtonUpDnTex,
						&gButtonFront1Tex, &gButtonLRTex
					};
//	static BYTE buttonYadd[7] = {35, 18,18,18 ,18,18,18};


	gMenuInfo.max = REPLAY_MENU_MAX;

	gMenuInfo.selection = REPLAY_MENU_CONTINUE;
	if (gMenuInfo.team < 0)
		gMenuInfo.team = 0;
//	sprintf(gReplayMenuText[REPLAY_MENU_TEAM].text, "%s",
//			SpecificTeamData[GameTeamData[gMenuInfo.team].TeamNumber].TeamCity);
//	tpage = gTex10.texture;
//	u = 128;
//	v = 128;


//	x = REPLAY_MENU_X + 10 - 256;
//	y = REPLAY_MENU_Y + 32 - 115;
	for (i = 0; i < NUM_REPLAY_MENU_SPRITES; i++)
	{
//		if (i == 4 || i == 0)
//			y = REPLAY_MENU_Y + 32 - 115;
		gReplayMenuSprite[i] = CreatePolySprite(26,18);
		sprite = gReplayMenuSprite[i];
		MakePolySprite2d(sprite);
		SetPolySpriteSubTexture(buttonTex[i], sprite);
		MovePolySpriteTo(
			gReplayButtonPos[i].x, gReplayButtonPos[i].y, 0, sprite);
//		y += buttonYadd[i];
	}
	ResizePolySprite(26,30, gReplayMenuSprite[0]);
	ResizePolySprite(55,18, gReplayMenuSprite[1]);
	ResizePolySprite(55,18, gReplayMenuSprite[2]);
	ResizePolySprite(55,18, gReplayMenuSprite[3]);
	
	ResizePolySprite(26,30, gReplayMenuSprite[8]);
	ResizePolySprite(55,18, gReplayMenuSprite[7]);
	ResizePolySprite(55,18, gReplayMenuSprite[9]);
	ResizePolySprite(55,18, gReplayMenuSprite[10]);

	StartMenuText(gReplayMenuText, REPLAY_MENU_CONTINUE);
//	setRECT(&rec, REPLAY_MENU_X, REPLAY_MENU_Y,
//					REPLAY_MENU_WIDTH, REPLAY_MENU_HEIGHT);
//	ShowMenuBorder(True, &rec, 0);
	gReplayMenuBox = ShowArcadeMenuBox(REPLAY_MENU_X, REPLAY_MENU_Y,
					REPLAY_MENU_WIDTH, REPLAY_MENU_HEIGHT, -1);
	MoveMenuSelect(0);
}

/*-------------------------------------------------------------
  EndReplayMenu ~
-------------------------------------------------------------*/
void EndReplayMenu(void)
{
	register INT i;

	EndMenuText();
//	ShowMenuBorder(FALSE, NULL, 0);
	FreeDialogBox(gReplayMenuBox);
	for (i = 0; i < NUM_REPLAY_MENU_SPRITES; i++)
	{
		DeletePolySprite(gReplayMenuSprite[i]);
		gReplayMenuSprite[i] = NULL;
	}
}

/*-------------------------------------------------------------
  UpdateReplayMenu ~
-------------------------------------------------------------*/
void UpdateReplayMenu(void)
{
//	USHORT pad;
	INT cmd;

//	pad = JpadData[gPausePad];
	cmd = DoMenuPad(gPausePad);
	if (cmd != -1)  // Selection
	{
		cmd = MoveMenuSelect(0);
		switch (cmd)
		{
			case REPLAY_MENU_CONTINUE:
				gGameLoopFlags2.Paused = FALSE;
				EndReplayMenu();
				break;
			case REPLAY_MENU_EXIT:
				gGameLoopFlags2.Paused = FALSE;
				EndReplayMenu();
				EndInstantReplay();
				break;
		}
	}
}

/*-------------------------------------------------------------
  StartCameraMenu ~
-------------------------------------------------------------*/
void StartCameraMenu(void)
{
	register char *ptr;
	register INT i, u,v;
//	RECT rec;
	register PolySpritePtr sprite;

	switch (gGameCameraStyle)
	{
		case ISOMETRIC_CAMERA_STYLE:
			gMenuInfo.selection = CAMERA_MENU_ISOMETRIC_HIGH;
			break;
		case SIDELINE_CAMERA_STYLE:
			gMenuInfo.selection = CAMERA_MENU_SIDELINE_HIGH;
			break;
		default:
			gMenuInfo.selection = CAMERA_MENU_NORMAL;
			break;
	}
	
	if (gPausePad < 0 )
		gPausePad = 0;
	gMenuInfo.team = ControllerToTeam(gPausePad);
	if (gMenuInfo.team < 0)
		gMenuInfo.team = 0;
//	sprintf(gCameraMenuText[CAMERA_MENU_TEAM].text, "%s",
//		SpecificTeamData[GameTeamData[gMenuInfo.team].TeamNumber].TeamCity);
//	tpage = gTex10.texture;
//	u = 128;
//	v = 128;

	for (i = 0; i < NUM_CAMERA_MENU_SPRITES; i++)
	{
		gCameraMenuSprite[i] = CreatePolySprite(26,18);
		sprite = gCameraMenuSprite[i];
		MakePolySprite2d(sprite);
		SetPolySpriteSubTexture(gCameraButtonTex[i], sprite);
		MovePolySpriteTo(
			gCameraButtonPos[i].x, gCameraButtonPos[i].y, 0, sprite);
	}
	ResizePolySprite(26,30, gCameraMenuSprite[3]);
	ResizePolySprite(55,18, gCameraMenuSprite[0]);
	ResizePolySprite(55,18, gCameraMenuSprite[1]);
	ResizePolySprite(55,18, gCameraMenuSprite[2]);
	ResizePolySprite(55,18, gCameraMenuSprite[4]);
	ResizePolySprite(55,18, gCameraMenuSprite[5]);
	
	StartMenuText(gCameraMenuText, CAMERA_MENU_NORMAL);
//	setRECT(&rec, CAMERA_MENU_X, CAMERA_MENU_Y,
//					CAMERA_MENU_WIDTH, CAMERA_MENU_HEIGHT);
//	ShowMenuBorder(True, &rec, 0);
	gCameraMenuBox = ShowArcadeMenuBox(CAMERA_MENU_X, CAMERA_MENU_Y,
					CAMERA_MENU_WIDTH, CAMERA_MENU_HEIGHT, -1);
	MoveMenuSelect(0);
	gCameraMenuFlag = TRUE;
}

/*-------------------------------------------------------------
  EndCameraMenu ~
-------------------------------------------------------------*/
void EndCameraMenu(void)
{
	register INT i;

	EndMenuText();
//	ShowMenuBorder(FALSE, NULL, 0);
	FreeDialogBox(gCameraMenuBox);
	for (i = 0; i < NUM_CAMERA_MENU_SPRITES; i++)
	{
		DeletePolySprite(gCameraMenuSprite[i]);
		gCameraMenuSprite[i] = NULL;
	}
}

/*-------------------------------------------------------------
  DoCameraMenu ~
-------------------------------------------------------------*/
void DoCameraMenu(void)
{
//	USHORT pad;
	INT cmd;
	INT prevStyle;
//	static char active = False;

	if (gCameraMenuState == CAMERA_MENU_OFF_STATE)
	{
		StartCameraMenu();
		gCameraMenuState = CAMERA_MENU_SELECTING_STATE;
	}
	else if (gCameraMenuState == CAMERA_MENU_SELECTING_STATE)
	{
		cmd = DoMenuPad(gPausePad);
		if (JpadData[gPausePad] & JPADtriangle)
		{
			EndCameraMenu();
			gCameraMenuState = CAMERA_MENU_DONE_STATE;
			cmd = -1;
		}
		if (cmd != -1)  // Selection
		{
	//		cmd = MoveMenuSelect(0);
			MoveMenuSelect(0);
			prevStyle = gGameCameraStyle;
			switch(cmd)
			{
				case CAMERA_MENU_NORMAL:
					gGameCameraStyle = NORMAL_CAMERA_STYLE;
					break;
				case CAMERA_MENU_ISOMETRIC_HIGH:
					gGameCameraStyle = ISOMETRIC_CAMERA_STYLE;
					break;
//				case CAMERA_MENU_ISOMETRIC_LOW:
//					gGameCameraStyle = ISOMETRIC_LOW_CAMERA_STYLE;
//					break;
				case CAMERA_MENU_SIDELINE_HIGH:
					gGameCameraStyle = SIDELINE_CAMERA_STYLE;
					break;
//				case CAMERA_MENU_SIDELINE_LOW:
//					gGameCameraStyle = SIDELINE_LOW_CAMERA_STYLE;
//					break;
//				case CAMERA_MENU_EXIT:
//					gCameraMenuFlag = FALSE;
//					break;
			}
			EndCameraMenu();
			if (gCameraMenuFlag && (prevStyle != gGameCameraStyle))
			{
				 Cmarker();
				StartCameraMenu();
				ShowLoadingMessage(TRUE);
				gCameraMenuState = CAMERA_MENU_START_LOADING_STATE;
			}
			else
			{
				 Cmarker();
				gCameraMenuState = CAMERA_MENU_DONE_STATE;
//				gCameraMenuState = CAMERA_MENU_OFF_STATE;
//				gCameraMenuFlag = FALSE;
//				ResetBit(gGameLoopFlags, GLOOP_PAUSED_FLAG); // Pause flag off
			}
		}
	}
	else if (gCameraMenuState == CAMERA_MENU_START_LOADING_STATE)
	{
		gCameraMenuState = CAMERA_MENU_LOADING_STATE;
	}
	else if (gCameraMenuState == CAMERA_MENU_LOADING_STATE)
	{
		 Cmarker();
		ShowLoadingMessage(FALSE);   // It won't dissapear until next frame 
		DumpArcadeForPause();
		ResetArcadeStrings();
		LoadRefereeAnim();
		InitGameCameraStyle(TRUE);
		ReloadArcadeForPause();
		InitGameCameraStyle(TRUE);
		ShowPauseGraphic(False);
		gCameraMenuState = CAMERA_MENU_DONE_STATE;
//		gCameraMenuFlag = TRUE;
//		SetBit(gGameLoopFlags, GLOOP_PAUSED_FLAG); // Pause flag off
//		StartCameraMenu();
//		gCameraMenuState = CAMERA_MENU_SELECTING_STATE;
		
	}
	else if (gCameraMenuState == CAMERA_MENU_DONE_STATE)
	{
		if (!(JpadData[gPausePad] & JPADx))
		{
			gCameraMenuState = CAMERA_MENU_OFF_STATE;
			gCameraMenuFlag = FALSE;
//			ResetBit(gGameLoopFlags, GLOOP_PAUSED_FLAG); // Pause flag off
			gGameLoopFlags2.Paused = FALSE;
			UnPauseAllClocks();
			PauseSound(FALSE);
		}
	}
}

/*-------------------------------------------------------------
  ShowReplayBanner ~
-------------------------------------------------------------*/
void ShowReplayBanner(INT show)
{
	static PolySpritePtr sprite = NULL;
	SubTexture_t subtex;

	if (show)
	{
		if (sprite == NULL)
		{
			InitSubTexture(&subtex, gStadTexture[9].texture,
						gStadTexture[9].clut, 32,32, 16,16, 0, 0);
			sprite = CreatePolySprite(38,28);
			MakePolySprite2d(sprite);
			SetPolySpriteSubTexture(&subtex, sprite);
			MovePolySpriteTo(420-255,20-120, 0, sprite);
		}
		if (GetVBlankCount() & 0x20 && !gGameLoopFlags2.DoingAutoReplay)
			SetPolySpriteOnOff(True, sprite);
		else
			SetPolySpriteOnOff(False, sprite);
	}
	else
	{
		DeletePolySprite(sprite);
		sprite = NULL;
	}
}

/*-------------------------------------------------------------
  ShowDemoBanner ~ 
-------------------------------------------------------------*/
void ShowDemoBanner(INT init)
{
	static PolySpritePtr sprite[4] = {NULL, NULL, NULL, NULL};
	register INT i, x, y, on;
	SubTexture_t subtex;
	INT u[4] = { 1*16, 1*16,  1*16,  2*16 };  // DEMO
	INT v[4] = { 4*16, 5*16, 13*16, 11*16 };

	if (init)
	{
		x = 230;
		y = 20;
		for (i = 0; i < 4; i++)
		{
			InitSubTexture(&subtex, gStadTexture[9].texture,
					gStadTexture[9].clut, u[i], v[i], 16,16, 0, 0);
			sprite[i] = CreatePolySprite(16,16);
			MakePolySprite2d(sprite[i]);
			SetPolySpriteSubTexture(&subtex, sprite[i]);
			MovePolySpriteTo(x-255, y-120, 0, sprite[i]);
			x += 16;
		}
	}
	if (GetVBlankCount() & 0x10)
		on = TRUE;
	else
		on = FALSE;
	for (i = 0; i < 4; i++)	
	{
		SetPolySpriteOnOff(on, sprite[i]);
	}
	
}  /* End ShowDemoBanner() */

/*-------------------------------------------------------------
  ShowPlayInfoText ~
-------------------------------------------------------------*/
void ShowPlayInfoText(INT show)
{
	static INT active = 0;
	INT str;
//	 = -1, str2 = -1;
	static INT InfoStr[3];
	static PolySpritePtr sprite = NULL;
	register INT i;
	char *text;
	char *textPtr[3] = {PlayInfoText0, PlayInfoText1, PlayInfoText2};
	SubTexture_t subtex;
	INT len, height, showBar, y;
	TeamColorType *teamColorPtr;

	if (show)
	{
		if (!active)
		{
//			 strcpy(PlayInfoText0, "Testing");    // debug
			showBar = False;
			for (i = 0; i < 3; i++)
			{
				text = textPtr[i];
				if (InfoStr[i] == -1 && *text != '\0')
				{
//						 DebugPrintf(0, "    %s\n", text);	// debug
					showBar = TRUE;
					active = TRUE;
					y = 188 + i * 12;
//					strupr(PlayInfoText1);
					strlwr(text);
//					len = strlen(PlayInfoText1);
//					str = CreateString(text, fontdpc4,
//								255 , y, FONT0 | PROPORTIONAL);
					str = CreateArcadeString(text, 255 , y, 1);
					CenterString(str, text, 255);
					ChangeString(str, text, FONT0 | PROPORTIONAL); 				
					ChangeStringCLUT(strings.string[str], gArcadeFontClut->CLUT_ID);
//					ChangeStringDepth(strings.string[str], 1);
					InfoStr[i] = str;
				}
				else if (*text == '\0')
				{
					InfoStr[i] = -1;
				}
			}
			if (sprite == NULL && showBar)
			{
				if (PlayInfoText0[0])
				{
					y = 188;
					if (PlayInfoText2[0])
						height = 38;
					else	
						height = 27;
				}
				else
			    {
					y = 200;
					if (PlayInfoText2[0])
						height = 27;
					else
						height = 16;
				}
//				InitSubTexture(&subtex, gStadTexture[9].texture,
//							gTransparentClut, 123,208, 1,16, 0, 0);
				InitSubTexture(&subtex, gStadTexture[9].texture,
							gStadTexture[9].clut, 123,208, 1,16, 0, 0);
				sprite = CreatePolySprite(535, height);
				MakePolySprite2d(sprite);
				SetPolySpriteSubTexture(&subtex, sprite);
				teamColorPtr = GetTeamColorPtr(0);
				SetPolySpriteShade(teamColorPtr->red/2, 
						teamColorPtr->green/2, teamColorPtr->blue/2, 1, 0, sprite);
				MovePolySpriteTo(0-255, y-120, 4, sprite);
			}
		}  // if active
	} // if show
	else 
	{
		if (sprite != NULL)
		{
			DeletePolySprite(sprite);
			sprite = NULL;
		}
		for (i = 0; i < 3; i++)
		{
			if (InfoStr[i] != -1)
			{
				PopString(InfoStr[i]);
			}
			InfoStr[i] = -1;
		}
		active = FALSE;
	}
}

/*-------------------------------------------------------------
  Update5SecDisplay ~
-------------------------------------------------------------*/
void Update5SecDisplay(void)
{
//	INT seconds;
	ULONG vb;
	static ULONG prevVB = 0;
//	char text[6];
	Time_t gameTime;

//	 return;
	vb = GetVBlankTimer(GAME_TIMER_NUM);
//	if ((vb != prevVB && g5SecString != -1))
	if (vb != prevVB && g5SecSprite)
	{
//	    gameTime = VBlankToTime(vb);
//	    seconds = gameTime.seconds;
//		if (seconds < 10)
		if (vb < (10 * CLOCKS_TICKS_PER_SECOND))
		{
//			sprintf(text, ":%02d", seconds);
			SetPolySpriteOnOff(TRUE, g5SecSprite);
		}
		else
		{
//			text[0] = '\0';
			SetPolySpriteOnOff(FALSE, g5SecSprite);
		}
//		ChangeString(g5SecString, text, FONT0);
		prevVB = vb;
	}
}

/*-------------------------------------------------------------
  Show5SecClock ~
-------------------------------------------------------------*/
void Show5SecClock(INT on)
{
	SubTexture_t subtex;
	
	if (on)
	{
//		if (g5SecString == -1 && !CoinActiveFlag)
//		{
//			g5SecString = CreateString("   ", fontdpc4,
//							400, 210, FONT0);
//			ChangeStringCLUT(strings.string[g5SecString], gArcadeFontClut->CLUT_ID);
//			ChangeStringDepth(strings.string[g5SecString], 1);
//			ChangeString(g5SecString, "\0", FONT0);
//			 Cmarker();
//		}
		if (g5SecSprite == NULL && !CoinActiveFlag)
		{
			INT u,v;
			
			g5SecSprite = CreatePolySprite(32,16);
			MakePolySprite2d(g5SecSprite);
			u = DIGITS_U + (3 * 16);
			v = DIGITS_V + (1 * 16);
			InitSubTexture(&subtex, gScoreboard.tex, gScoreboard.clut,
						u,v, 32,16, 0, 0);
			SetPolySpriteSubTexture(&subtex, g5SecSprite);
			MovePolySpriteTo(30-256 , 20-115, 1, g5SecSprite);
//			MovePolySpriteTo(440-256 , 20-115, 1, g5SecSprite);
			SetPolySpriteOnOff(FALSE, g5SecSprite);
		}
	}
	else
	{
//		if (g5SecString != -1)
//			FreeString(g5SecString);
//		g5SecString = -1;
		if (g5SecSprite != NULL)
		{
			DeletePolySprite(g5SecSprite);
			g5SecSprite = NULL;
		}
	}
}

/*-------------------------------------------------------------
  InitPlayClockSprite ~ 
-------------------------------------------------------------*/
void InitPlayClockSprite(void)
{
	SubTexture_t subtex;
	register INT u,v;
			
	gPlayClockSprite = CreatePolySprite(32,16);
	MakePolySprite2d(gPlayClockSprite);
	u = DIGITS_U + (6 * 16);
	v = DIGITS_V + (4 * 16);
	InitSubTexture(&subtex, gScoreboard.tex, gScoreboard.clut,
				u,v, 32,16, 0, 0);
	SetPolySpriteSubTexture(&subtex, gPlayClockSprite);
	MovePolySpriteTo(440-256 ,180-115, 1, gPlayClockSprite);
	SetPolySpriteOnOff(FALSE, gPlayClockSprite);
}  /* End InitPlayClockSprite() */

/*-------------------------------------------------------------
  UpdatePlayClockDisplay ~
-------------------------------------------------------------*/
void UpdatePlayClockDisplay(void)
{
	INT show = FALSE;
//	ULONG vb;

//	 return;
//	vb = GetVBlankTimer(GAME_TIMER_NUM);

	if (gGameCameraStyle != NORMAL_CAMERA_STYLE
	    	&& gGameLoopState == GLOOP_INPLAY_STATE
	    	&& !(gGameLoopFlags & GLOOP_SCOREBOARD_FLAG)
	    	&& !BallSnapped
	    	&& !CoinActiveFlag )
	{	    	
		show = TRUE;
	}
	
	if (gPlayClockSprite)
	{
		SetPolySpriteOnOff(show, gPlayClockSprite);
	}
}

/*-------------------------------------------------------------
  InitArcGraphic ~
-------------------------------------------------------------*/
void InitArcGraphic(void)
{
	register INT i;
//	INT u, v;
	vram_t *tpage, *clut;
	static USHORT clutBuff[16];
	register USHORT color;

//	 return;

//	tpage = gAnimPage[2];
	tpage = gStadTexture[9].texture;
	clutBuff[0] = 0;
	color = GenPSXColor(0x30, 0x30, 0xff, TRUE);  // normal
	for (i = 1; i < 16; i++)
		clutBuff[i] = color;
	gKickClut1 = register_CLUT( (ULONG*)&clutBuff[0], VRAM_CLUT16);
	
//	color = GenPSXColor(0x80, 0x40, 0x40, FALSE);
//	color = GenPSXColor(0x10, 0x10, 0x10, FALSE);	// cursor
	color = GenPSXColor(0xFF, 0xFF , 0x15, FALSE);	// cursor
	for (i = 1; i < 16; i++)
		clutBuff[i] = color;
	gKickClut2 = register_CLUT( (ULONG*)&clutBuff[0], VRAM_CLUT16);
	
//	color = GenPSXColor(150, 160, 25, TRUE);	// empty area
	color = GenPSXColor(0x40, 0x10, 0x10, FALSE);	// empty area
	for (i = 1; i < 16; i++)
		clutBuff[i] = color;
	gKickClut3 = register_CLUT( (ULONG*)&clutBuff[0], VRAM_CLUT16);
//	u = 128;
//	v = 0;
	InitSubTexture(&gKickTex, tpage, gKickClut1, 128, 0, 32, 32, 0, 1);
	for (i = 0; i < MAX_POINTS_IN_BALL_ARC; i++)
	{
		gKickSprite[i] = CreatePolySprite(40 , 40);
		SetPolySpriteSubTexture(&gKickTex, gKickSprite[i]);
		SetPolySpriteShade(0x80, 0x80, 0x80, 1, 0x80, gKickSprite[i]);
		SetPolySpriteOnOff(0, gKickSprite[i]);
	}
}

/*-------------------------------------------------------------
  ShowArcGraphic ~
-------------------------------------------------------------*/
void ShowArcGraphic(void)
{
	register PolySpritePtr sprite;
	register INT i, points, cursor, cursorMax;
	SVECTOR vec2;

//	 return;

//	if (EventFlags & KICK_INTERFACE_ACTIVE_BFLAG)
	if ((InterfaceFlags & DISPLAY_BALL_ARC_BFLAG) 
		    && !gInstantReplayMode)
//			&& !gGameLoopFlags2.EndingGame )
	{
    	points = PointsInBallArc;
		cursor = GetTrueBallArcCounter();  // this var is the "fast" cursor
		cursorMax = GetTrueMaxPointsInBallCursor();
    }
    else
    	points = 0;
	for (i = 0; i < MAX_POINTS_IN_BALL_ARC; i++)      
	{
		sprite = gKickSprite[i];
		if (i < points)
		{
			TranslateAIVector(BallArc[i][0], BallArc[i][1],
								BallArc[i][2], &vec2);
			MovePolySpriteTo(vec2.vx, vec2.vy, vec2.vz, sprite);
			SetPolySpriteOnOff(1, sprite);
//			if (i == BallArcCounter)  // this var is the "fast" cursor
//			if (i == cursor)  // this var is the "fast" cursor
			if (i <= cursor)  // this var is the "fast" cursor
				SetPolySpriteClut(gKickClut2->CLUT_ID, sprite);
			else if (i < cursorMax)
			    SetPolySpriteClut(gKickClut3->CLUT_ID, sprite);
			else	
				SetPolySpriteClut(gKickClut1->CLUT_ID, sprite);
		}                                        
		else
			SetPolySpriteOnOff(0, sprite);
	}
}

/*-------------------------------------------------------------
  ClearArcGraphic ~ 
-------------------------------------------------------------*/
//void ClearArcGraphic(void)
//{
	
//}

/*-------------------------------------------------------------
  VideoBorder ~ 
-------------------------------------------------------------*/
void ShowVideoBorder(INT on)
{
	register INT i;
	static USHORT clutBuff[16]; // Clut data
	static BOOL active = False;
	char *ptr;
	USHORT color;
	vram_t *tpage;

	if (on)		
	{
		if (!active)		
		{
			active = True;
			tpage = gStadTexture[1].texture;   // point at already loaded texture
			color = GenPSXColor(0xF, 0xF, 0xF, FALSE);
			for (i = 1; i < 16; i++)
				clutBuff[i] = color;
			gVideoBorder.clut = register_CLUT( (ULONG*)clutBuff, VRAM_CLUT16);
			InitSubTexture(&gVideoBorder.tex, tpage, gVideoBorder.clut, 
						128, 128, 1, 1, 0, 0);
//			 InitSubTexture(&gVideoBorder.tex, tpage, gPauseClut, 128, 128, 32, 32, 0, 0);
			gVideoBorder.sprite[0] = 
				CreatePolySprite(VIDEO_BORDER_WIDTH, VIDEO_BORDER_INSET);
			gVideoBorder.sprite[1] = 
				CreatePolySprite(VIDEO_BORDER_WIDTH, VIDEO_BORDER_INSET);
			gVideoBorder.sprite[2] = 
				CreatePolySprite(VIDEO_BORDER_INSET, VIDEO_BORDER_HEIGHT);
			gVideoBorder.sprite[3] = 
				CreatePolySprite(VIDEO_BORDER_INSET, VIDEO_BORDER_HEIGHT);
			for (i = 0; i < 4; i++)
			{
				SetPolySpriteSubTexture(&gVideoBorder.tex, gVideoBorder.sprite[i]);
				MakePolySprite2d(gVideoBorder.sprite[i]);
				SetPolySpriteOnOff(1, gVideoBorder.sprite[i]);
			 	MovePolySpriteTo(10*i, 10*i, 1, gVideoBorder.sprite[i]);//db
			}
			MovePolySpriteTo(-257, -120-12, 9, gVideoBorder.sprite[0]); //top
			MovePolySpriteTo(-257, 
						VIDEO_BORDER_HEIGHT-VIDEO_BORDER_INSET-120+12, 
						9, gVideoBorder.sprite[1]);  // bottom
			MovePolySpriteTo(-257, -120, 9,	 gVideoBorder.sprite[2]);
			MovePolySpriteTo(VIDEO_BORDER_WIDTH-VIDEO_BORDER_INSET-254, 
									-120, 9, gVideoBorder.sprite[3]);
			DrawSync(0);
		}  // if !active
	}	
	else  // Not on
	{ 
	    if (active)
		{
			active = False;
			free_clut(gVideoBorder.clut);
			for (i = 0; i < 4; i++)
			{
				DeletePolySprite(gVideoBorder.sprite[i]);
				gVideoBorder.sprite[i] = NULL;
			}
		}
	}
}

/*-------------------------------------------------------------
  InitScoreboardScreenSectors ~ 
-------------------------------------------------------------*/
void InitScoreboardScreenSectors(void)
{
	register INT i;
	char fname[40];
	
	for (i = 0; i < 30; i++)
	{
		sprintf(fname, "/stadium/sbpic/sbpic%02d.mfl", i);
		gScoreboardScreenSector[i] = GetFileSector(fname);
	}
	gScoreboardScreenSectorUse = gScoreboardScreenSector[0];
}  /* End InitScoreboardScreenSectors() */

/*-------------------------------------------------------------
  RandomizeScoreboardScreen ~ 
-------------------------------------------------------------*/
void RandomizeScoreboardScreen(void)
{
	gScoreboardScreenSectorUse = gScoreboardScreenSector[ GetRandom(30) ];
}  /* End RandomizeScoreboardScreen() */

///*-------------------------------------------------------------
//  LoadScoreboardScreenPicture ~ 
//-------------------------------------------------------------*/
//void LoadScoreboardScreenPicture(void)
//{
//	
//}  /* End LoadScoreboardVideoPicture() */


/*-------------------------------------------------------------
-------------------------------------------------------------*/
void SetScoreboardScreenState(INT state)
{
	char *buff, *clutBuff, *ptr;
	INT alloc = FALSE, i;
	SubTexture_t subtex;
	USHORT *colorPtr, color;
	
	
	if (state)
	{
		if (gAnimBuff)
			buff = gAnimBuff;
		else
		{
			buff = (char*)AllocMem(88*64);
			alloc = TRUE;
		}
		clutBuff = (char*)AllocMem(512);
	
	
		InitSubTexture(&subtex, gStadTexture[11].texture,
						gStadTexture[11].clut, 0,0, 88,64, 1, 0);
		switch(state)
		{
			case SCOREBOARD_SCREEN_NONE:
				break;
			case SCOREBOARD_SCREEN_BLACK:
				color = GenPSXColor(0x8, 0x8, 0x8, FALSE);
				colorPtr = (USHORT*)clutBuff;
				for (i = 0; i < 256; i++)
				{
					*colorPtr = color;
					colorPtr++;
				}
				ReloadCLUT(clutBuff, gStadTexture[11].clut);
				 Cmarker();
				break;
			case SCOREBOARD_SCREEN_PICTURE:
				if (gScoreboardScreenMfl)
				{
					ptr = (char *)GetMultiFilePtr((MultiFile_t*)gScoreboardScreenMfl, "sbpic.cmp");
					DecompressFrameBytes(buff, ptr);
					LoadSubTexturePixels((ULONG*)buff, &subtex);
					ptr = (char *)GetMultiFilePtr((MultiFile_t*)gScoreboardScreenMfl, "sbpic.clt");
					ReloadCLUT(ptr, gStadTexture[11].clut);
				}
				break;
		}
		DrawSync(0);
		 DebugPrintf(0, "Scoreboard Screen: %X  %X\n", buff, clutBuff);
		FreeMem(clutBuff);
		gScoreboardScreenState = state;
		if (alloc)
		{
			FreeMem(buff);
			buff = NULL;
		}
	}
}

/*-------------------------------------------------------------
  UpdateWindVane ~ 
-------------------------------------------------------------*/
void UpdateWindVane(void)
{
	register INT dir, dirFrame, cup, num, show;
	char *ptr;
	
//	if (gWindVane.on)
//	if (!CoinActiveFlag && (gGameLoopFlags & GLOOP_INPLAY_FLAG)
	if (!CoinActiveFlag && (gGameLoopState == GLOOP_INPLAY_STATE)
	    || (CoinActiveFlag && CoinTossState >= COIN_TOSS_PICK_SIDE) )
    {
		show = True;	    	
    }
    else
    	show = False;
	
	if (gGameLoopFlags & GLOOP_SCOREBOARD_FLAG || BallSnapped)    
		show = False;
	if (!WindSpeed)
		show = False;

//	 show = TRUE;	//debug

	SetPolySpriteOnOff(show, gWindVane.sprite);
//	SetPolySpriteOnOff(show, gWindVane.spriteBg);
//	SetPolySpriteOnOff(show, gWindVane.spriteBg2);
//	 SetPolySpriteOnOff(FALSE, gWindVane.spriteBg);
//	 SetPolySpriteOnOff(FALSE, gWindVane.spriteBg2);
	if (show)
	{
//		SetPolySpriteOnOff(True, gWindVane.sprite);
//		SetPolySpriteOnOff(True, gWindVane.spriteBg);
		if (!gWindVane.boxOn)
		{
			PopupDialogBox(WIND_VANE_X - 5, WIND_VANE_Y, 
						100, 64, 4, 0x20, 0x20, 0x20);
			gWindVane.boxOn = TRUE;			
		}
		
//		dir = (WindDirection + gCamera.dir);
		dir = 16 + 8 + (WindDirection - gCamera.dir);
		dir &= 15;
		dirFrame = dir / 2;
//		dirFrame++;
//		dirFrame &= 7;
		if (dirFrame != gWindVane.dirFrame)
		{
			num = gWindVane.dir0 + dirFrame;
			ptr = (char*)GetMultiFileByNum(gWindVane.file, num);
			DecompressFrameBytes(gAnimBuff, ptr);    
			LoadSubTexturePixels((ULONG*)gAnimBuff, &gWindVane.dirTex);
		}
		gWindVane.dirFrame = dirFrame;
		 
//		 if (JpadData[0] & JPADselect)  // debug
//		 {
//		 	DebugPrintf(0, "Vane: %d + %d = %d  %d\n",
//		 			WindDirection, gCamera.dir, dir, dirFrame); 
//		 }
		 
			
		cup = gWindVane.cupFrame;
		cup += WindSpeed * 2;
		cup &= 0x1F;
		if (cup >> 2 != gWindVane.cupFrame >> 2)
		{
			num = gWindVane.cup0 + (cup >> 2);
			ptr = (char*)GetMultiFileByNum(gWindVane.file, num);
			DecompressFrameBytes(gAnimBuff, ptr);    
			LoadSubTexturePixels((ULONG*)gAnimBuff, &gWindVane.cupTex);
		}
		gWindVane.cupFrame = cup;
	}
	else
	{
//		SetPolySpriteOnOff(False, gWindVane.sprite);
//		SetPolySpriteOnOff(False, gWindVane.spriteBg);
		if (gWindVane.boxOn)
		{
//			FreeDialogBox();
			FreeAllDialogBoxes();
			gWindVane.boxOn = FALSE;			
		}
		
	}
}

/*-------------------------------------------------------------
  InitWindVane ~ 
-------------------------------------------------------------*/
void InitWindVane()
{
    vram_t *clut;
    SubTexture_t spriteTex;
    
//	if (True)	
//	{
		gWindVane.boxOn = FALSE;			
    	 DebugPrintf(0, "Wind dir:%d  cam:%d Speed:%d\n", WindDirection, gCamera.dir, WindSpeed);
		gWindVane.on = True;
		gWindVane.file = (MultiFile_t*)GetMultiFilePtr( gAnimationsFile[0],"wind.mfl");
		clut = register_CLUT((ULONG*)GetMultiFilePtr(gWindVane.file, "wind.clt"), VRAM_CLUT16);
		InitSubTexture(&spriteTex, gStadTexture[11].texture,
						 clut, 128, 128, 64, 64, 0, 0);
		InitSubTexture(&gWindVane.dirTex, gStadTexture[11].texture,
						 clut, 128, 128, 64, 32, 0, 0);
		InitSubTexture(&gWindVane.cupTex, gStadTexture[11].texture,
						 clut, 128, 128 + 32, 64, 32, 0, 0);
		gWindVane.sprite = CreatePolySprite(90,64);				 
		SetPolySpriteSubTexture(&spriteTex, gWindVane.sprite);
		MakePolySprite2d(gWindVane.sprite);
		MovePolySpriteTo(WIND_VANE_X-255, WIND_VANE_Y-120, 1, gWindVane.sprite);
		gWindVane.dir0 = GetNumberInMultiFile(gWindVane.file, "topa.cmp");
		gWindVane.cup0 = GetNumberInMultiFile(gWindVane.file, "bot00.cmp");
		gWindVane.dirFrame = -1;	
		gWindVane.cupFrame = -1;	
		
//		gWindVane.spriteBg = CreatePolySprite(98,70);				 
//		InitSubTexture(&spriteTex, gStadTexture[9].texture,
//						gTransparentClut, 106,218, 1,1, 0, 0);
//		MakePolySprite2d(gWindVane.spriteBg);
//		SetPolySpriteSubTexture(&spriteTex, gWindVane.spriteBg);
//		SetPolySpriteShade(0x10, 0x10, 0x10, 1, 0, gWindVane.spriteBg);
//		MovePolySpriteTo(WIND_VANE_X-255-4, WIND_VANE_Y-120-2, 2, gWindVane.spriteBg);
		
//		CopySpriteData(gWindVane.spriteBg, gWindVane.spriteBg2);
//		gWindVane.spriteBg2 = CreatePolySprite(90,64);				 
//		MakePolySprite2d(gWindVane.spriteBg2);
//		SetPolySpriteSubTexture(&spriteTex, gWindVane.spriteBg2);
//		ResizePolySprite(90, 64, gWindVane.spriteBg2);
//		SetPolySpriteShade(0xF0, 0x10, 0x10, 1, 0, gWindVane.spriteBg2);
//		MovePolySpriteTo(WIND_VANE_X-255-2, WIND_VANE_X-120-1, 2, gWindVane.spriteBg2);
		
		UpdateWindVane();
//	}
//	else 
//	{
//		gWindVane.on = False;
//	}
}

/*-------------------------------------------------------------
  InitOnScreenNames ~ 
-------------------------------------------------------------*/
void InitOnScreenNames(void)
{
	register INT i;
	
	for (i = 0; i < MAX_ON_SCREEN_NAMES; i++)
	{
		gOnScreenNames[i].nameStr = -1;
		gOnScreenNames[i].player = 0;
		gOnScreenNames[i].flags = 0;
		PlayerNameShow[i] = -1;	// remove this when AI does it		
	}
}  /* End InitOnScreenNames() */


/*-------------------------------------------------------------
  CheckCloseOnScreenNames ~ 
-------------------------------------------------------------*/
BOOL CheckCloseOnScreenNames(INT num)
{
	register INT i, x, y;
	BOOL close = FALSE;
	
	x = gOnScreenNames[num].sx;
	y = gOnScreenNames[num].sy;
	for (i = num-1;  i >= 0 && !close;  i--)
	{
		if (gOnScreenNames[i].flags
		    && abs(x - gOnScreenNames[i].sx) < 47
			&& abs(y - gOnScreenNames[i].sy) < 10 )
		{
			close = TRUE;
		}
	}
	return close;
}  /* End CheckCloseOnScreenNames() */

/*-------------------------------------------------------------
  CheckNewOnScreenNames ~ 
-------------------------------------------------------------*/
INT CheckNewOnScreenNames(void)
{
	INT i, new;
	
	new = FALSE;
	for (i = 0; i < MAX_ON_SCREEN_NAMES && !new; i++)
	{
		if (gOnScreenNames[i].player != PlayerNameShow[i])
			new = TRUE;
	}
	return new;
}  /* End CheckNewOnScreenNames() */

/*-------------------------------------------------------------
  UpdatePlayOnScreenNames ~ 
-------------------------------------------------------------*/
void UpdateNewOnScreenNames(void)
{
	if (!gInstantReplayMode)
	{
		if (gOnScreenNamesOn 
		    	&& gGameLoopState == GLOOP_INPLAY_STATE
		    	&& !CoinActiveFlag
//				&& !(gGameLoopFlags & GLOOP_AUDIBLE_FLAG)
		    	&& !gGameLoopFlags2.OffenseAudibleMenu
		    	&& !gGameLoopFlags2.DefenseAudibleMenu
		    	&& !gGameLoopFlags2.Paused
		    	&& !gNoPauseCount)
		{
			if (CheckNewOnScreenNames())
			{
				ClearOnScreenNames();
				InitPlayOnScreenNames();
			}
		}
	}
}  /* End UpdatePlayOnScreenNames() */

/*-------------------------------------------------------------
  UpdateOnScreenNames ~ 
-------------------------------------------------------------*/
void UpdateOnScreenNames(void)
{
	SVECTOR vec1, vec2;
	register INT i, str, otz, dspBuff;
	long flag, p;
	
//	dspBuff = GsGetActiveBuff();
	for (i = 0; i < MAX_ON_SCREEN_NAMES; i++)
	{
		if (gOnScreenNames[i].flags)
		{
			str = gOnScreenNames[i].nameStr;
			if (str != -1)
			{
			    if (gOnScreenNames[i].player == ON_SCREEN_NAME_BALL)
			    {
			    	//copyVector(&gBallxyz, &vec1);
			    	vec2.vx = 255;
			    	vec2.vy = 200;	
			    	otz = 4;
			    }
			    else
			    {
				    GetPlayerSpriteLocation(gOnScreenNames[i].player, &vec1);
				    vec1.vy += 10;
				    otz = GetScreenPosFrom3d(&vec1, &vec2);
//					otz = RotTransPers(&vec1, (long*)&vec2, &p, &flag);
//					otz = otz >> OTZSHIFT;
//					otz -= 100;
//					limitRange(otz, 4, OTSIZE);    /*##*/
					otz = 5;
				}
				vec2.vx -= (gOnScreenNames[i].len * 5);
//				vec2.vy += 4;
				gOnScreenNames[i].sx = vec2.vx;
				gOnScreenNames[i].sy = vec2.vy;
				if (CheckCloseOnScreenNames(i))
				{
					gOnScreenNames[i].sx = vec2.vx = 2000;
					gOnScreenNames[i].sy = vec2.vy = 2000;
				}
				ChangeStringDepth(strings.string[str], otz);
				ChangeStringABSXY(strings.string[str], vec2.vx, vec2.vy);
			}
		}
	}
}  /* End UpdateOnScreenNames() */

/*-------------------------------------------------------------
  SetOnScreenName ~ 
-------------------------------------------------------------*/
void SetOnScreenName(INT num, INT player, ULONG flags)
{
	INT str;
	char *name;
	char text[100];
	INT clutid;
	
	if (flags)
	{
		gOnScreenNamesOn = TRUE;
		str = gOnScreenNames[num].nameStr;
		if (str != -1)
		{
			PopString(str);
		}
		
		if (player == ON_SCREEN_NAME_BALL)
		{
			strcpy(text, "BALL");
		}
		else if (player != -1)
		{
			name = GetPlayerName(player);
			if (gInstantReplayMode)
			{
				sprintf(text, "%s #%d", name, GetJerseyNum(player));
			}
			else if (name)
			{
				while (*(name++) != ' ');	// advance to Last Name
				strncpy(text, name, 40);
			}
		}
		if (*text && *text != '\0' && player != -1)
		{
//			strupr(text);
			strlwr(text);
//			str = CreateString(text, fontdpc4,	1100, 210, FONT0 | PROPORTIONAL);
			str = CreateArcadeString(text, 1100, 210, 1);
			if (num < 4)
				clutid = gArcadeFontClut->CLUT_ID;
			else	
				clutid = gMenuInfo.selectClut->CLUT_ID;
			ChangeStringCLUT(strings.string[str], clutid);
//			ChangeStringDepth(strings.string[str], 1);
//			ChangeString(str, "\0", FONT0);
			gOnScreenNames[num].flags = flags;
			gOnScreenNames[num].nameStr = str;
			gOnScreenNames[num].len = strlen(text);
		}
		else // no text
		{
			gOnScreenNames[num].flags = 0;
			gOnScreenNames[num].nameStr = -1;
		}
	}
	else	// !flags
	{
		str = gOnScreenNames[num].nameStr;
		if (str != -1)
		{
			PopString(str);
		}
		gOnScreenNames[num].nameStr = -1;
		gOnScreenNames[num].flags = flags;
	}
	gOnScreenNames[num].player = player;
//	UpdateOnScreenNames();
}  /* End SetOnScreenName() */

/*-------------------------------------------------------------
  ClearOnScreenNames ~ 
-------------------------------------------------------------*/
void ClearOnScreenNames(void)
{
	INT i;
	
	for (i = 0; i < MAX_ON_SCREEN_NAMES; i++)
	{
		SetOnScreenName(i,-1,0);
	}
	gOnScreenNamesOn = FALSE;
}  /* End ClearOnScreenNames() */

/*-------------------------------------------------------------
  InitArcadeOnScreenNames ~ 
-------------------------------------------------------------*/
void InitPlayOnScreenNames(void)
{
	register INT i, j, dup, pnum;
	 
//	 return;	// debug
	
	if (!gGameLoopFlags2.OffenseAudibleMenu && !gGameLoopFlags2.DefenseAudibleMenu)
	{
		for (i = 0; i < MAX_ON_SCREEN_NAMES; i++)
		{
			dup = FALSE;
			pnum = PlayerNameShow[i];
			if (pnum >= 0)
			{
				if (i > 0)
				{
					for (j = i - 1; j >= 0; j--)
					{
						if (pnum == PlayerNameShow[j])
							dup = TRUE;
					}
				}
				if (!dup)
					SetOnScreenName(i, pnum, 1);
				else
					SetOnScreenName(i, pnum, 0);
			}
		}
	}
	gOnScreenNamesOn = TRUE;
}  /* End InitArcadeOnScreenNames() */

#define PENALTY_MENU_WIDTH  300
#define PENALTY_MENU_HEIGHT 130
#define PENALTY_MENU_X (255 - (PENALTY_MENU_WIDTH/2))
#define PENALTY_MENU_Y 55


/*-------------------------------------------------------------
  FakePenaltyMenu ~ 
-------------------------------------------------------------*/
void FakePenaltyMenu(void)
{
	if (ActivePenalty && !PenaltyResolved)
	{
		 Cmarker();
		PenaltyHasBeenResolved();
	}
	
}  /* End FakePenaltyMenu() */

#if 1
/*-------------------------------------------------------------
  DoPenaltyMenu ~ 
-------------------------------------------------------------*/
void DoPenaltyMenu(int on)
{
	static int active = 0;
	static int box = -1, selectBox = -1;
	static int str[NUM_PENALTY_TEXT_BUFFERS];
	static ULONG timer;
	int selectY[2] = {PENALTY_MENU_Y + 30,  PENALTY_MENU_Y + 78 };
	int pad, i , x, y;
	RECT rec;
	 ULONG db;  //debug
	 	
//	if (on)
	if (ActivePenalty && !PenaltyResolved)
	{
		gNoPauseCount = 2;
		if (!gGameLoopFlags2.PenaltyMenu)  // Start Menu
		{
			 Cmarker();
			timer = GetVBlankCount() + 3 * VBlanksPerSec;
			gGameLoopFlags2.PenaltyMenu = TRUE;
			SetTeamNameSpriteOn(PenaltyChooser, TRUE, -1, PENALTY_MENU_Y);

			box = ShowArcadeMenuBox(PENALTY_MENU_X, PENALTY_MENU_Y, 
					PENALTY_MENU_WIDTH, PENALTY_MENU_HEIGHT, -1);
			
			selectBox = ShowArcadeMenuBox(PENALTY_MENU_X, PENALTY_MENU_Y, 
					PENALTY_MENU_WIDTH, 36, -2);
			ChangeDialogDepth(selectBox, 2);
        	
			x = PENALTY_MENU_X;
			y = PENALTY_MENU_Y + 30;
			for (i = 0; i < NUM_PENALTY_TEXT_BUFFERS; i++)
			{	
				str[i] = CreateArcadeString(&PenaltyTextBuffer[i][0], x, y, 0);
				y += 12;
				if (i == 2)
					y += 10;
			}
		}
		else		// Do Menu
		{
			pad = GameTeamData[PenaltyChooser].ControllerNum[0];
			if (pad < 0) // CPU
			{
				if (GetVBlankCount() > timer )
				{
					PenaltyHasBeenResolved();
				}
			}
			else //Not CPU
			{
				if (JpadData[pad] & JPADLup)
				{
					ActivePenalty = ACCEPT_PENALTY;
				}
				else if (JpadData[pad] & JPADLdown)
				{
					ActivePenalty = DECLINE_PENALTY;
				}
				else if (JpadData[pad] & JPADx)
				{
					PenaltyHasBeenResolved();
					Cmarker();
				}
				y = selectY[ActivePenalty-1];
				MoveDialog(selectBox, PENALTY_MENU_X, y);
			}
		}
	}
	else  // Erase the menu
	{
	    if (gGameLoopFlags2.PenaltyMenu)
	    {
			gGameLoopFlags2.PenaltyMenu = FALSE;
//			ShowMenuBorder(FALSE, NULL, 0);
			FreeDialogBox(box);
			FreeDialogBox(selectBox);
			SetTeamNameSpriteOn(0, FALSE, 0,0);
			SetTeamNameSpriteOn(1, FALSE, 0,0);
			for (i = 0; i < NUM_PENALTY_TEXT_BUFFERS; i++)
			{	
				PopString(str[i]);
				str[i] = -1;
			}
			 Cmarker();
		}
	}
}  /* End DoPenaltyMenu() */
#endif //0