
//********** Arcade Menu Stuff ***********
#define ARCADE_MENU_NONE  (-1)

#define END_CMD 0
#define START_CMD 1
#define UPDATE_CMD 2

#define ON_SCREEN_NAME_BALL  44

enum
{
	SCOREBOARD_SCREEN_NONE,
	SCOREBOARD_SCREEN_BLACK,
	SCOREBOARD_SCREEN_PICTURE,
};

//--- Menu Border Type ---
typedef struct
{
	vram_t *clut;
	PolySpritePtr sprite[12];
} MenuBorder_t;
extern MenuBorder_t gMenuBorder[2];

//--- Menu Text Type ---
typedef struct
{
	char *text;
	short enabled, x,y;
	INT stringID;
} MenuText_t;

//---- Menu Info Type ----
typedef struct
{
//	INT stringID[MAX_PAUSE_TEXT];
	MenuText_t *menuText;
	vram_t *normClut, *selectClut, *disableClut;
	short min, max;
	short selection, team;
} MenuInfo_t;
extern MenuInfo_t  gMenuInfo;

extern SubTexture_t 	gTex10;  

extern char *DpcName[2];
extern char *DpcNameClut[2];
extern PolySpritePtr TeamNameSprite[2];

extern vram_t 	*gArcadeFontClut;

extern INT gPausePad; 
PolySpritePtr gPauseSprite;
extern USHORT gSkyClutData[16];
//extern SubTexture_t FieldLineTex[4];

extern ULONG gScoreboardScreenSector[];
extern ULONG gScoreboardScreenSectorUse;
extern char *gScoreboardScreenMfl;
extern char *gScoreboardScreenPix;
extern char *gScoreboardScreenClt;
extern INT gScoreboardScreenState;

enum
{
	SKY_NO_CHANGE = 0,
	SKY_AUTO,
	SKY_ALL,
	SKY_GRASS,
	SKY_BLACK
};

extern BYTE gSkyMode;


/* arcade.c */
INT CreateArcadeString ( char *text , INT x , INT y , INT depth );
INT IsCpuVsCpu ( void );
//TeamColorType *GetTeamColorPtr ( INT defense );
void ShowLoadingScreen ( void );
void ResetArcadeStrings ( void );
void SetClutTransparent ( USHORT *data , INT size , INT color0 );
void No2MinuteSeason ( void );
void SetHomeStadiumOptions ( void );
void SetStadiumByOptions ( void );
void SetGameBackground ( INT mode );
void InitSky ( void );
void InitDrops ( INT new );
void UpdateDrops ( void );
void EnableDrops ( INT on , INT instant );
INT PickWeather ( void );
void InitPlayLines ( void );
void DeletePlayLines ( void );
void InitFieldLines ( void );
void InitScoreboard ( void );
void UpdateScoreboardDigitTexture ( INT num );
void SetScoreboard2Digits ( INT value , INT start );
void UpdateScoreboard ( void );
void UpdateAllScoreboard ( void );
void InitButtonTextures ( void );
void InitPause ( void );
void AllocCrowd ( void );
ULONG GetLogoSector ( INT team , INT place );
void LoadLogos ( void );
void TextureCenterLogo ( void );
void InitLogoTextures ( void );
void InitLogoSprites ( void );
void FreeLogos ( INT perm );
INT GetTeamNameWidth ( INT away );
void SetTeamNameSpriteOn ( INT num , INT on , INT x , INT y );
void InitExtraStadiumTextures ( char *base );
void FreeExtraStadiumTextures ( void );
void FreeCrowd ( void );
void InitSideCluts ( void );
void PositionSideSprites ( void );
void SetPolePeople ( void );
void ShowReplayBanner ( INT show );
void ShowDemoBanner ( INT init );
void ShowPlayInfoText ( INT show );
void Update5SecDisplay ( void );
void Show5SecClock ( INT on );
void InitPlayClockSprite ( void );
void UpdatePlayClockDisplay ( void );
void InitArcGraphic ( void );
void ShowArcGraphic ( void );
//void ClearArcGraphic ( void );
void ShowVideoBorder ( INT on );
void InitScoreboardScreenSectors ( void );
void RandomizeScoreboardScreen ( void );
////void LoadScoreboardScreenPicture ( void );
void SetScoreboardScreenState ( INT state );
void UpdateWindVane ( void );
void InitWindVane ( void );
void InitOnScreenNames ( void );
BOOL CheckCloseOnScreenNames ( INT num );
INT CheckNewOnScreenNames ( void );
void UpdateNewOnScreenNames ( void );
void UpdateOnScreenNames ( void );
void SetOnScreenName ( INT num , INT player , ULONG flags );
void ClearOnScreenNames ( void );
void InitPlayOnScreenNames ( void );

//-------
INT ControllerToCpuTeam(INT pad);
void ShowAudibleMenu(INT side, INT on);
void ShowPauseGraphic(INT mode);
