#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbgequ.h"
#include "fbequ.h"
#include "fbram.h"
#include "fbstats.h"
#include "fbforms.h"
#include "fbplays.h"
#include "tmcolor.h"
#include "shell.h"



//**************************************************************************
// Data structures & defines for menu system

#include "menu.h"
#include "fbmenu.h"

//**************************************************************************

#define	AUDIBLES_Y	20
#define	AUDIBLES_X	250

extern INT InitControl(INT pad);
extern BYTE *DpcName[2],*DpcNameClut[2];
//tom!! extern TeamColorType gTeamBackColor[];
extern BYTE *strlwr(BYTE *s);

INT SetAudiblesMenu(INT Pad);
INT ProgramAudibles(WORD team01);
void ListAudibleFormation(WORD formnum,WORD team01);
INT CheckExisting(WORD team01);
INT InitSetAudibles(void);
INT TermSetAudibles(void);
INT MainSetAudibles(void);

// tom!! added this from shell.c
TeamColorType gTeamBackColor[] =
{
	{75,17,17}, {24,36,63}, {5,15,85}, {85,42,23}, {57,68,68},    // 0-4
	{57,68,68}, {57,68,68}, {41,57,85}, {70,23,100}, {3,62,47}, // 5-9
	{0,27,100}, {0,18,100}, {25,69,59}, {0,27,100}, {21,81,33},                  // 10-14
	{75,17,17}, {57,68,68}, {0,12,100}, {57,68,68}, {57,68,68},   // 15-19
	{30,80,15}, {14,41,85}, {32,50,66}, {40,23,100}, {85,50,35},    // 20-24
	{0,13,100}, {14,69,83}, {92,25,25}, {0,27,100}, {92,25,25},                 // 25-29
	{75,17,17}, {0,18,100},          // 30-31  ?
};



//**************************************************************************

MenuItem AudiblesItemList[] = {END_MENU
};

MenuObj	AudiblesMenu = {
	(MenuItem *)AudiblesItemList,
	InitSetAudibles,
	TermSetAudibles,
	MainSetAudibles,
	0, 0, 512, 240,
};


static INT Pad;

INT AudibleDialog[3];

static WORD key,formcount,playnum,playsinform, frmnum;

//**************************************************************************


INT InitSetAudibles(void)
{
	BYTE *ptr;

  /*Set graphics mode*/

	initVRamHandling();

  /*initialize the background for the shell*/

	LoadTeamPic(GameTeamData[WhichTeam].TeamNumber);

  /*Init the multifile pointers*/

	Shell_MFile = (unsigned long *)LoadCDFile("/shells/pled/audibles.mfl");
	DebugPrintf(0,"audibles.mfl loaded into %x\n", Shell_MFile);

	InitFonts();
	Register_Font_Cluts();
	LoadFont("fontdpc2.tim", 3);

  /*load the shell graphics template files*/

	InitTemplates();
	multifile = Shell_MFile;

	LoadTemplate("audibles.llx");
	LoadTemplate("nickname.llx");

	ChangePolyTex(1, 0, DpcName[WhichTeam]);
	ChangePoly4CLUT(1, 0, (unsigned long *)DpcNameClut[WhichTeam]);

	/* Set global joypad delay */

	JpadRepeatFreq = 10;

	key = 0;
	frmnum = formcount = 0;

	return(0);
}

//**************************************************************************
//**************************************************************************


INT TermSetAudibles(void)
{
	Std_Menu_CleanUp();
	FreeAllDialogBoxes();
	return(0);
}


//**************************************************************************
//**************************************************************************


INT MainSetAudibles(void)
{
	INT retcode = 0;

	FreeAllDialogBoxes();
	AudibleDialog[0] = PopupDialogBox(245, 17, 198, 203, 2, gTeamBackColor[GameTeamData[WhichTeam].TeamNumber].red, gTeamBackColor[GameTeamData[WhichTeam].TeamNumber].green,	gTeamBackColor[GameTeamData[WhichTeam].TeamNumber].blue);
	AudibleDialog[1] = PopupDialogBox(43, 81, 164, 16, 2, 0x46, 0x46, 0x46);
	AudibleDialog[2] = PopupDialogBox(30, 107, 200, 114, 2, 0x40, 0x00, 0x40);

	ChangeDialogDepth(AudibleDialog[0], 70);
	ChangeDialogDepth(AudibleDialog[1], 70);
	ChangeDialogDepth(AudibleDialog[2], 70);
	ChangeDialogLayers(AudibleDialog[0], 1);
	ChangeDialogLayers(AudibleDialog[1], 1);
	ChangeDialogLayers(AudibleDialog[2], 1);

	retcode = ProgramAudibles(WhichTeam);

	return(retcode);
}


//**************************************************************************
//  list all plays in formation indicating 3 currently selected
//	Audible plays and the Key play (if selected, the Key play
//	will become one of the audible plays
//	NOTE: allows all 3 audibles to be 1 play, might need additional
//	error checking if all 3 audibles must be unique
//**************************************************************************

void ListAudibleFormation(WORD formnum,WORD team01)
{
	WORD i,j,playnum;
	WORD *formptr;

	BYTE color;

	PrintStringXYCenter(strlwr(FormationNames[formnum]), 120, 80, PEN_YELLOW);

	PrintStringXY(LT_ARROW, 50, 80, PEN_RED);
	PrintStringXY(RT_ARROW, 180, 80, PEN_RED);

	formptr = GetPlaysPerForm(formnum);	// pointer to table, -1 at end

	i=0;

	while( (playnum = *(formptr+i)) >= ZERO)	// print all plays in form
	{
		if(i==key)
		{
			Flash++;

			if(Flash & 8)
				color = PEN_YELLOW;	//currently selected play for possible change
			else
				color = PEN_DKYELLOW;
		}
		else
		{
			if(playnum == ShotGunPoochKickNUM) color = PEN_GREY;
			else color= PEN_WHITE;
		}

		for(j=0; j<3; j++)	// is it an audible play?
		{
			if(playnum == TeamOffensiveAudible[team01][formnum][j])
			{
				MovePolyToXY(&template[0].poly[j+4], AUDIBLES_X-256, (AUDIBLES_Y-120)+(i*13));
				PrintStringXY(PlayNames[playnum], 80, (j*30)+110, PEN_YELLOW);
			}
		}


		PrintStringXY(PlayNames[playnum], AUDIBLES_X+30, (i*13)+AUDIBLES_Y, color);

		i++;
	}

	PrintStringXY("Exit", 80, (3*30)+110, PEN_YELLOW);
}


//**************************************************************************
//**************************************************************************


INT ProgramAudibles(WORD team01)
{
	WORD *formptr;

	INT retcode = 0;

	/****  WARNING  --  GameTeamData[X].  MUST have been set up -
		use team 0-1  NOT 0-29				*****/

	frmnum = GameTeamData[team01].STD.Formations[0][formcount];

	playsinform = 0;
	formptr = GetPlaysPerForm(frmnum);	// pointer to table, -1 at end
	playnum = *(formptr+key);
	while(*(formptr++) >= ZERO)
		playsinform++;

	switch(JpadTrig[Pad])
	{
		case JPADsquare:
			if(playnum != ShotGunPoochKickNUM && CheckExisting(team01))
			{
				PlayEffect(PRESS_SOUND);
				TeamOffensiveAudible[team01][frmnum][0] = playnum;
			}
			break;
		case JPADtriangle:
			if(playnum != ShotGunPoochKickNUM && CheckExisting(team01))
			{
				PlayEffect(PRESS_SOUND);
				TeamOffensiveAudible[team01][frmnum][1] = playnum;
			}
			break;
		case JPADcircle:
			if(playnum != ShotGunPoochKickNUM && CheckExisting(team01))
			{
				PlayEffect(PRESS_SOUND);
				TeamOffensiveAudible[team01][frmnum][2] = playnum;
			}
			break;
		case JPADLleft:
			key = 0;
			if(++formcount > 4)
				formcount = 0;
			PlayEffect(CURSOR_SFX);
			break;
		case JPADLright:
			key = 0;
			if(--formcount < 0)
				formcount = 4;
			PlayEffect(CURSOR_SFX);
			break;
		case JPADLup:
			key--;
			if(key < 0)
				key = playsinform-1;
			PlayEffect(CURSOR_SFX);
			break;
		case JPADLdown:
			key++;
			if(key >= playsinform)
				key = 0;
			PlayEffect(CURSOR_SFX);
			break;

		case JPADx: retcode++;
					PlayEffect(PRESS_SOUND);
					break;
		}

	ListAudibleFormation(frmnum,team01);

	return(retcode);
}

//**************************************************************************
//**************************************************************************

INT CheckExisting(WORD team01)
{
	INT i;

	for(i=0; i<3; i++)
		if(TeamOffensiveAudible[team01][frmnum][i] == playnum) return(FALSE);

	return(TRUE);
}

//**************************************************************************
//**************************************************************************

INT SetAudiblesMenu(INT pad)
{
	INT retcode;

	if((WhichTeam = ControllerToTeam(pad))<0) return(-1);
	Pad = pad;

	retcode = Display_Menu(AUDIBLES_MENU);

	return(retcode);
}
