
#define CAMERA_ON_FLAG 	1
#define CAMERA_OFFSET_TARGET_FLAG 	(1<<1)
#define CAMERA_DAMPEN_FLAG		(1<<2)
#define CAMERA_INSTANT_FLAG 	(1<<3)
#define CAMERA_AT_TARGET_FLAG 	(1<<4)
#define CAMERA_FLIPZ_FLAG 		(1<<5)

typedef struct
{
	ULONG flags;
	SVECTOR offset;
	SVECTOR maxOffset, minOffset;
	SVECTOR offsetMovement;
	SVECTOR offsetTarget;
	SVECTOR ref, refMax, refMin, refPrev;
	SVECTOR viewMax, viewMin;
	SVECTOR refMinSpeed;
	int refDiv, refSpeed;
	int zoom, zoomPrev, zoomSpeed, zoomTarget;
	int dir;
	int radius, angle;
	long radiusXY;
	long verticleAngle;
} Camera_t;

extern Camera_t gCamera;

//********** Camera routines **********
void SetCameraOffset ( int x , int y , int z );
void MoveCameraOffset ( int x , int y , int z );
void SetCameraMovement ( int x , int y , int z );
void SetCameraMax ( int x , int y , int z );
void SetCameraMin ( int x , int y , int z );
void DoCamera ( void );
void InitCamera ( void );
void DoCameraJoypad ( void );
void SetCameraOffsetVector(SVECTOR *vec);
void SetCameraAngle(int angle);
void SetCameraRadius(int radius);
int GetCameraAngle(void);
int GetCameraRadius(void);


