/*************************************************************************
 * CARD.H
 *
 *	Written by: Mike Heilemann
 *************************************************************************/

#define	NO_CARD		  -1
#define	FILE_ERROR		1
#define	WRITE_ERROR		2
#define	OPEN_ERROR		3
#define	CKSUM_ERROR		4

#define	MAX_RETRYS		5

typedef	struct	{
	int	fileEntry;
	char	fileName[15][64];
} file_t;

typedef struct {
	char name[21];
	char blocks;
} memfile_t;

typedef struct {
	char	magic[2];
	char	type;
	char	blocks;
	char	name[64];
	char	pad[28];
	char	clut[32];
	char	icon[3][128];
} card_t;

extern unsigned long ev0,ev1,ev2,ev3;
extern unsigned long ev10,ev11,ev12,ev13;
extern char		card[2];		// maybe make this 2...
extern memfile_t MemFile[16];
extern card_t card_info;
extern char *CARD_ACCESS_MSG;
extern char *CARD_SPACE_ERROR;
extern char *CARD_MISSING_ERROR;



int CheckFile(char port, char bank, char *file);
void InitCard(void);
short CheckCard(char port, char bank);
short CheckFormat(char port, char bank);
short FormatCard(char port, char bank);
int OpenFile(char *buffer, long length, char port, char bank, char *file_name, char *description);
char ReadFile(unsigned short *buffer, char port, char bank, char *file);
int WriteFile(long fp, unsigned short *buffer, long length);
char ReadHeader(char *buffer, char port, char bank, char *file);
char GetFiles(char port, char bank);
long DeleteFile(char port, char bank, char *file_name);
short _card_event(void);
void _clear_event(void);
UWORD GetPadPortBank(int pad);
//short _card_event_x(void);
//void _clear_event_x(void);
