#***********************************
# Makefile for PSX 
#   Uses Borland Make
#
#  By Christopher Deel
#***********************************

.swap

PROG = Football
ExeFile = SLUS_000.71
StartAddr = $80010000

Prog = $(PROG)
BuildCD =   - buildcd -l -gFootball.ccs -m cd.cti -s3:1

CompileOpts = -comments-c++ -c 
#CCLinkOpts = -Xo$(StartAddr) -Xm -Xn500 -Xb
CCLinkOpts = -Xo$(StartAddr) -Xm -Xn500 

#-----------------
# Implicit rules
#
.c.obj:
#       ccpsx $(CompileOpts)  -g $*.c 
#       ccpsx $(CompileOpts)  -O1 $*.c 
	ccpsx $(CompileOpts)  -O2 $*.c 
#	ccpsx $(CompileOpts)  -O3 $*.c 

.s.obj:
   ccpsx -c $*.s

.asm.obj:
	asmpsx /l /oc+ $*.asm,$*.obj

#.c.s:
#   ccpsx -S -v -g $*.c -o $*.s

.cpe.exe:
	cpe2x /ca $*.cpe        


STDINCS =VERSION.H PrjHdrs.H GFXIFACE.H DEBUG.h

AI_Incs = FBAIDATA.H FBBUTTON.H FBCPUPC.H FBEQU.H FBFORMS.H FBFRMDAT.H \
	FBGEQU.H FBMODES.H FBMODESG.H FBPINIT.H FBPLAYS.H FBPSDATA.H  \
	FBRAM.H FBRAMDAT.H FBSCRIPT.H FBSTATES.H FBAIGRAP.H \
	FBAI2GRP.H FBPGDATA.H

OBJS1 = Psprite.obj PSXPAD.Obj \
	 sound.obj MISC.Obj MultiFil.obj Debug.obj \
	 Deel.obj CDhandlr.obj PlyrAnim.obj memory.obj\
	 decomp.obj GameLoop.obj Camera.obj arcade.obj profile.obj \
	 coinlog.obj coingraf.obj credits.obj
	 
OBJS2 = MMVRAM.Obj Picture.Obj GFXIFACE.Obj field.obj\
	FONTS.Obj Card.obj Season.obj Movie.obj sjis.obj \
	tmstats.obj dialog.obj Nigel.obj Tom.obj

ShellObjs =  lowshell.obj shell.obj dpcshl.obj \
	tselshl.obj debugshl.obj \
	mmenushl.obj \
	pledshl.obj menu.obj options.obj tmview.obj \
	plview.obj schedule.obj audibles.obj seasshl.obj
	
AIObjs = FBFORMS.obj FBRAM.obj FBMOVE.obj FBPLAYS.obj fbtmdata.obj \
	 fbstring.obj fbaidata.obj fbblock.obj fbdefai.obj fbaiinit.obj \
	 fbball.obj fbaimain.obj fbcpupc.obj fbstats.obj fbaudio.obj \
	 fbirp.obj fbinit.obj simgame.obj
	 
TestObjs = 

#--- OBJ files from PSX\LIB ---
#LibObjs = c:\psx\lib\malloc.obj c:\psx\lib\2mbyte.obj
#LibObjs = c:\psx\lib\malloc.obj 
LibObjs =  

AllObjs = $(OBJS1) $(OBJS2) $(AIObjs) $(ShellObjs) $(TestObjs)\
	 $(LibObjs) $(PROG).obj
	 
Libs = -llibtap.lib -llibcard.lib

# ---- compile and run the program ----
run: $(PROG).cpe 
#       echo ready to RUN
#       pause
#       R

#---- Main target ---- 
$(PROG).cpe: $(AllObjs) $(PROG).cf
	ccpsx @$(PROG).cf $(CCLinkOpts) -o $(PROG).cpe,$(PROG).sym,$(PROG).map $(Libs)
	copy debug.h debug.h2 > nul
	copy version.h version.h2 >nul
	dir *.cpe
	dir *.cpe >> cpesize.txt

#---- Binary Data ----
FakeCD.bin: FakeCD.fil chris.fil mikeh.fil common.fil
	copy chris.fil+mikeh.fil+common.fil FakeCD.fil
	bldMulti FakeCD.fil FakeCD.bin

#Decomp.obj: Decomp.c makefile.mak
#       ccpsx -c -O2 decomp.c
	
#----- Build Compiler Link File ------
$(PROG).cf: makefile.mak
	echo Link File $@
	copy &&! 
	$(AllObjs) 
!       $@

#------PSX EXE file----
$(PROG).exe: $(PROG).cpe
	dir *.c /on > cdir.mfl
	dir *.h /on >> cdir.mfl
	copy cdir.mfl cdfiles\colors
	cpe2x /ca $(PROG).cpe
#	 copy $(PROG).exe cdfiles\psx.exe
	copy $(PROG).exe cdfiles\$(ExeFile)
	del cdfiles\football.exe
	del cdfiles\psx.exe

#----- Build CD Emulation File -----
cd.map: cd.cti $(PROG).exe
	- buildcd -l -m cd.cti -s3:1
	batcmd sound success

#--- Build CD ----
BLD:  $(PROG).cpe $(PROG).exe
	resetps 1
	batcmd wait 5
	batcmd printtime
	- buildcd -l -m cd.cti -s3:1
	batcmd printtime
	batcmd sound success

#--- Update CD ----
UPDATE:
	- resetps 1
	- updatecd -l cd.map


EXE: $(PROG).exe 
	dir *.exe
	dir cdfiles\sl*.*
		
$(PROG).zip: $(PROG).cpe
	- pkzip $(PROG) *.mak *.c *.h *.s *.bat *.lnk *.txt *.dat
	- pkzip bak *.bak
	- del *.bak   

	
ZIP: $(PROG).zip
CLEAN: $(PROG).zip

FORMAT:
	cddisk -n 3

#--- Load the Data ---
LOAD:
	pqbload fakecd.bin 80200000
#       pqbload fakecd.bin 80200000

RUNCD:
	batcmd printtime
	resetps 1
	run /w10 c:\psx\cd_utils\selemu
	run /w10 c:\psx\patch\snpatch
#	run /w10 c:\psx\cd_utils\cdexec
	run /w10 c:\psx\patch\run0071
	dir cdfiles\*.exe
	- mess1
	- tee testmess > output.txt
#       - dbugpsx 
	- mess1 
	

MAP:
	grep \. $(PROG).map > addr.map
#       sort < $(PROG).map >> tmp2.t$$p
	sortfl $(PROG).map  /Otmp2.t$$p
	addrsize  -a   tmp2.t$$p addr.map
	del *.t$$p
	dir *.map

##----- Special Compile ----------------	
sound.obj: sound.c sound.h 
	ccpsx $(CompileOpts) -G0 -O2 $*.c 
	
## --- Special Optimize ------------------------------------------
# These files will not compile at full optimization ?

dpcshl.obj: dpcshl.c $(AI_Incs)
	ccpsx $(CompileOpts)  -O2 $*.c 

tselshl.obj: tselshl.c $(AI_Incs)
	ccpsx $(CompileOpts)  -O2 $*.c 

pledshl.obj: pledshl.c   $(AI_Incs)
	ccpsx $(CompileOpts)  -O2 $*.c 
	
mikeh.obj: mikeh.c
	ccpsx $(CompileOpts)  -O2 $*.c 

lowshell.obj: lowshell.c lowshell.h
	ccpsx $(CompileOpts)  -O2 $*.c 

dialog.obj: dialog.c dialog.h
	ccpsx $(CompileOpts)  -O2 $*.c 
	
MMVRAM.Obj:  MMVRAM.C   $(STDINCS) mmvram.h
	ccpsx $(CompileOpts)  -O2 $*.c 

FBstats.obj: fbstats.c $(AI_Incs)
	ccpsx $(CompileOpts)  -O2 $*.c				

Movie.obj: Movie.c Movie.h
	ccpsx $(CompileOpts)  -O2 $*.c				
		
#-------- DMPSX Needed -------------------------------------------      
DEEL.Obj:  DEEL.C     $(STDINCS) fbequ.h fbramdat.h
	ccpsx $(CompileOpts)  -O2 $*.c 
	dmpsx $*.obj

psprite.obj:    psprite.c psprite.h plyranim.h version.h gfxiface.h
	ccpsx $(CompileOpts)  -O2 $*.c 
	dmpsx $*.obj
	
	
#--------------------------------------------------------------------
# Build dependencies

$(PROG).Obj: $(PROG).C $(STDINCS) $(ShellObjs) $(AIObjs) deel.c \
			debug.c gameloop.c

DEBUG.Obj     :  DEBUG.C    $(STDINCS) fbequ.h fbramdat.h
FONTS.Obj     :  FONTS.C    $(STDINCS)
PSXPAD.Obj    :  PSXPAD.C   $(STDINCS)
GFXIFACE.Obj  :  GFXIFACE.C $(STDINCS)
MISC.Obj      :  MISC.C     $(STDINCS)
Gameloop.obj:   gameloop.c gameloop.h version.h $(AI_Incs) plyranim.h formcam.h camera.h
PlyrAnim.obj:   PlyrAnim.h $(STDINCS) $(AI_Incs) psprite.h camera.h
Picture.obj:    Picture.c picture.h gfxiface.h mmvram.h
Field.obj:      field.c $(STDINCS) camera.obj
cdhandlr.obj:   cdhandlr.h version.h debug.h
arcade.obj:     arcade.c plyranim.h arcade.h $(AI_Incs)
profile.obj: 	profile.c profile.h
camera.obj: 	camera.c camera.h $(AI_Incs)
coinlog.obj:	coinlog.c coinlog.h $(AI_Incs)
coingraf.obj:	coingraf.c coingraf.h coinlog.h camera.h $(AI_Incs)

FBREPLAY.obj:   $(AI_Incs)
FBBLOCK.obj:    $(AI_Incs)
FBPLAYS.obj:    $(AI_Incs)
FBTMDATA.obj:   $(AI_Incs)
FBSTRING.obj:   $(AI_Incs)
FBBALL.obj:     $(AI_Incs)
FBTESTAI.obj:   $(AI_Incs)
FBFORMS.obj:    $(AI_Incs)
FBAIINIT.obj:   $(AI_Incs)
FBRAM.obj:      $(AI_Incs)
FBMOVE.obj:     $(AI_Incs)
FBDEFAI.obj:    $(AI_Incs)
FBPDATA.obj:    $(AI_Incs)
FBAIMAIN.obj:   $(AI_Incs)
FBAIDATA.obj:   $(AI_Incs)
FBAudio.obj:	$(AI_Incs)
FBirp.obj:		$(AI_Incs) FBIRP.H
