#ifdef __MSDOS__
#include <stdio.h>

#else  // PSX

#include <sys/types.h>

#include <libetc.h>			   /* For Controller routines */
#include <libgte.h>			   /* For LIBGS */
#include <libgpu.h>			   /* For LIBGS */
#include <libgs.h>			   /* Graphics Library */
#include <libsn.h>

#include "prjtypes.h"
#include "prjhdrs.h"    /* Project header files */
#include "debug.h"

#endif


#define LINE_SIZE 32
#define NUM_LINES 87

char *gCreditTextPtr;
int *gStrId;

char *CreditsTextFile = "credits.dat";

/*-------------------------------------------------------------
  GetCreditLinePtr ~
-------------------------------------------------------------*/
char * GetCreditLinePtr(int line)
{
	char *ptr;

	ptr = gCreditTextPtr + (line * LINE_SIZE);
	return ptr;
}  /* End GetCreditLinePtr() */



#ifndef __MSDOS__  //not

/*-------------------------------------------------------------
  MoveCreditStrings() ~
-------------------------------------------------------------*/
void MoveCreditStrings(int top)
{
	int str, i;

	for (i = 0; i < NUM_LINES; i++)
	{
		str = gStrId[i];
		ChangeStringABSXY(strings.string[str], 25, top + (i*16));
	}
}  /* End MoveCreditStrings() */

/*-------------------------------------------------------------
  DoCreditsFrame ~
-------------------------------------------------------------*/
int DoCreditsFrame(void)
{
	UpdateBackground();
	DisplayAllStrings();
	return(1);
}  /* End DoCreditsFrame() */

/*-------------------------------------------------------------
  DoCredits ~
-------------------------------------------------------------*/
void DoCredits(void)
{
	int top, i, str, working;
	char *ptr, *mfl;

	top = 240;

	VSync(0);
	initVRamHandling();
	ResetStrings();
	FreeAllDialogBoxes();
	SetBackgroundColor(0, 0, 0);

//	PlaySong(6);
//	 DumpAllocLoc();
  /*Load Fonts*/
	Register_Font_Cluts();
	InitFonts();
	DrawSync(0);
//	LoadFont("fontdpc3.tim", 3);
	LoadFont("fontdpc6.tim", 3);
//	 DumpAllocLoc();

	gStrId = (int*)AllocMem(NUM_LINES * 4);
	mfl = LoadCDFile("/colors/credits.mfl");
	ptr = (char*)GetMultiFilePtr(mfl, "credits.tim");
//	VSync(0);
	initTexture(0, (ULONG*)ptr);
	DrawSync(0);
//	 DumpAllocLoc();

	gCreditTextPtr = (char*)GetMultiFilePtr(mfl, CreditsTextFile);
	for (i = 0; i < NUM_LINES; i++)
	{
		ptr = GetCreditLinePtr(i);
//		 DebugPrintf(0, "%s\n", ptr);
		str = CreateString(ptr, fontdpc6, -100, -100, FONT0 | PROPORTIONAL);
		gStrId[i] = str;
		ChangeStringDepth(strings.string[str], 6);
//		SetStringClut();
	}
	working = True;
	while (working)
	{
		MoveCreditStrings(top);
		DoFrameLoop(1, DoCreditsFrame);
		if (IsAnyPadButton(0xFFFF))
//		if (IsAnyPadButton(JPADx | JPADtriangle))
			working = FALSE;
		if (top < -1500)
			top = 250;
		top--;
	}
	Cmarker();
	i = 300;
	while (IsAnyPadButton(0xFFFF) && i-- > 0)
	{
		ReadPads();
		VSync(0);
	}

	PlayEffect(PRESS_SOUND);

	LoadingMessage();

	ResetStrings();
	FreeMem(gStrId);
	FreeMem(mfl);
}  /* End DoCredits() */

#endif // not __MSDOS__


#ifdef __MSDOS__

/************* PC Generate routines ************/
char *SrcText[] =
{
/****************************************************************
 CREDITS LIST FOR PSX VERSION OF JIMMY JOHNSON NFL 97
 *****************************************************************/

"PRODUCERS",
"Bernie Whang",
"Bobby King",
"Bill McDonald - Asst",
" ",
"EXECUTIVE",
"  PRODUCER",
"Mike Knauer",
" ",
"LEAD PROGRAMMING",
"Mike Knauer - A.I.",
"Chris Deel - Arcade",
"Mike Heilemann ",
"  Sound/Movies",
"    Low level",
"Nigel Spencer - Shell",
" ",
"ADDITIONAL",
"   PROGRAMMING",
"Andy Green",
" ",
"ARTWORK",
"Alvyn Ramirez",
"Dan Santiago",
"Scott Sava",
"Steve Quinn",
" ",
"ADDITIONAL",
"     ARTWORK",
"Bernie Whang",
" ",
"TEXTURE MAPPING",
"Bill McDonald",
" ",
"DESIGN",
"Bernie Whang",
"Bobby King",
"Scott Sava",
"Mike Knauer",
" ",
"PLAY DESIGN",
"Bobby King",
" ",
"MUSIC/SFX",
"Barry Blum",
"Anna Karney",
" ",
"VOICE TALENT",
"Dennis McIntyre",
" ",
"VIDEO SUPERVISOR",
"Clifford Lau",
" ",
"TESTING",
"Bill McDonald - Lead",
"Sergio Fernandez",
"Carlos Fernandez",
"Adrian Fernandez",
"Phil Fisher-Ogden",
"Aaron Freedman",
"Bobby King",
"Bernie Whang",
" ",
"SPECIAL THANKS",
"Jimmy Johnson",
"Tom Reuterdahl",
"Mark Burke",
"Kelly Sumner",
"Linda Blanchard",
"Nick Antczak",
"   thanks for",
"     the memory",
" ",
"John Brandwood",
"Dag Richards",
"Dave Terry",
"Mimi Doggett",
"Neil Plakcy",
"Broadcast Video",
"Rosa Ricardo",
"Wendi Storm",
"Todd Mowatt",
"Juan Sanchez",
"Gordon Hart",
"Justin Monast",
"Cheri Johnson",
"Kenneth Navarro",
" ",
" ",
};

/*-------------------------------------------------------------
  GenerateCreditData ~
-------------------------------------------------------------*/
void GenerateCreditData(void)
{
	FILE *fp;
	int i, j, bytes;
	char *ptr;

	bytes = NUM_LINES * LINE_SIZE;
	gCreditTextPtr = malloc(bytes);
	for (i= 0; i < NUM_LINES; i++)
	{
		ptr = GetCreditLinePtr(i);
		for (j = 0; j < LINE_SIZE; j++)
		{
			*ptr = 0;
			ptr++;
		}
		ptr = GetCreditLinePtr(i);
		strcpy(ptr, SrcText[i]);
	}

	fp = fopen(CreditsTextFile, "wb");
	ptr = gCreditTextPtr;
	for (i = 0; i < bytes; i++)
	{
		fputc(*ptr, fp);
		ptr++;
	}
	fclose(fp);
}  /* End GenerateCreditData() */


/*-------------------------------------------------------------
  main ~
-------------------------------------------------------------*/
void main(void)
{
	GenerateCreditData();
}  /* End main() */

/****************** End PC Stuff *********************/
#endif  // __MSDOS__
