/***********************************************************************
*ctrlshl.c                                                             *
*Shell-play selection function                                         *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
*Started on 3/14/1995                                                  *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbequ.h"
#include "fbram.h"
#include "shell.h"
#include "ctrlshl.h"

/*used in display for picture flipping*/
extern pict_t	*picture[N_BG];

/*menu varaibles*/
static int WhichMenuItem[2];

static int CtrlCombinations[2][2] = {0,0,
                                     0,0};

static struct MenuItemsStruct ControlStrings[2][2][6] = { 
                                      0, 116, 20,
                                      0, 190, 15,
                                      0, 75,  84,
                                      0, 45,  102,
                                      0, 125, 100,
                                      0, 185, 90,

                                      0, 116 + 272, 20, 
                                      0, 190 + 272, 15, 
                                      0, 75  + 272, 84,  
                                      0, 45  + 272, 102, 
                                      0, 125 + 272, 100, 
                                      0, 185 + 272, 90, 
                                      
                                      0, 106, 130,
                                      0, 165, 120,
                                      0, 70 , 205,
                                      0, 122, 213,
                                      0, 180, 195,
                                     -1, 0,0, 
                                      
                                      0, 106 + 272, 130,
                                      0, 165 + 272, 120,
                                      0, 70  + 272, 205, 
                                      0, 122 + 272, 213,
                                      0, 180 + 272, 195,
                                     -1, 0, 0       
                                      };

/*ControllerSetups[offense/defense][particular combinations][all six strings]*/
static char *ControllerSetups[2][MAX_COMBINATIONS][6] = {

										/*offensive plays*/

                                        "Throw Away    ",
                                        "    Spin      ",
                                        " Pause        ",
                                        " Speed Burst  ",
                                        "Catch Ball    ",
                                        " Dive Jump    ",

                                        "Throw Away    ",
                                        " Dive Jump    ",
                                        " Pause        ",
                                        "    Spin      ",
                                        " Speed Burst  ",
                                        " Catch Ball   ",

                                        "    Spin      ",
                                        "  Throw Away  ",
                                        " Pause        ",
                                        " Catch Ball   ",
                                        " Speed Burst  ",
                                        " Dive Jump    ",

										
										/*defensive plays*/

                                        "Speed Burst   ",
                                        "Player Toggle ",
                                        "  Pause       ",
                                        "  Defend/Pass ",
                                        "Drive/Hard Hit",
                                        "              ",

                                        "Speed Burst   ",
                                        "Drive/Hard Hit",
                                        "  Pause       ",
                                        "Player Toggle ",
                                        "  Defend/Pass ",
                                        "              ",

                                        "Player Toggle ",
                                        "  Defend/Pass ",
                                        "  Pause       ",
                                        "Speed Burst   ",
                                        "Drive/Hard Hit",
                                        "              "
                                        };
static int XShift;

/******************************************************
Displays the controler config screen
*******************************************************/
int Display_Controller_Cfg_Shell(int NumPads)
{
  /*internal variables*/
  int i;
  int PlayersDone = FALSE;  /*both players done?*/
  int PlayerDone[2];        /*player 1 or 2 done?*/
  int MaxPlayers;
  int WhichPad; /*misc stuff*/
  int LastButtonPressed[2];	/*keeps track of the last button pressed*/
  int  FBall;
  char FBallFileName[MAXPATH];
  int RetCode;				/*return code flag*/

/*test variables*/
  int OffDef, WhichSide, StrDepth;

  /*Initialize variables*/
  PlayersDone   = FALSE;
  MaxPlayers = NumPads;
  FBall		 = 1;
  for(i=0; i<2; i++)
  {
    PlayerDone[i]    = FALSE;
    PadPressed[i]    = 0;
    WhichMenuItem[i] = 0; 
  }
  
  /*Set graphics mode*/
  //SetScreenMode(VMODE512);
  //ClearScreen();
  initVRamHandling();

  /*Load Fonts*/
  InitFonts();
  Register_Font_Cluts();
//LoadFont("fontpsx5.tim", 3);
//LoadFont("fontdpc2.tim", 3);
  LoadFont("fontdpc9.tim", 3);

  /*Paint the screen*/
  Paint_CTRL_Screen(NumPads);

  /*main event loop*/
  while(PlayersDone == FALSE)
  {

    /*Force redisplay of the screen*/
    DoFrameLoop(1, Shell_Frame_CTRL);

    /*Poll the pad*/
    PollPads(PadPressed, MaxPlayers);

	/*Update the ball*/
	sprintf(FBallFileName,"fball%d.xxx",FBall);
	ChangePolyCmpTexture(0, 0, FBallFileName);
	ChangePolyCmpTexture(0, 1, FBallFileName);
	if(++FBall > 16)	FBall =	1;

    /*0 for the left controller, 1 for the right controller*/
    for(WhichPad=0; WhichPad < MaxPlayers; WhichPad++)
    {
      /*handle the pad button pressed*/
      switch(PadPressed[WhichPad])
      {
        case PAD_UP:
          if(LastButtonPressed[WhichPad] != PadPressed[WhichPad])
          {	
		    if(--WhichMenuItem[WhichPad] < 0)	WhichMenuItem[WhichPad]	= 1;
            MovePolyToXY(&template[0].poly[WhichPad], (-256) + (10 + (WhichPad * 249)) + XShift, (-120) + (44 + (WhichMenuItem[WhichPad] * 118)));
		    PlayEffect(CURSOR_SFX);
		  }
          break;
        case PAD_DOWN:
          if(LastButtonPressed[WhichPad] != PadPressed[WhichPad])
          {	
		    if(++WhichMenuItem[WhichPad] > 1)	WhichMenuItem[WhichPad]	= 0;
            MovePolyToXY(&template[0].poly[WhichPad], (-256) + (10 + (WhichPad * 249)) + XShift, (-120) + (44 + (WhichMenuItem[WhichPad] * 118)));
		    PlayEffect(CURSOR_SFX);
		  }
          break;
        case PAD_LEFT:
          if(LastButtonPressed[WhichPad] != PadPressed[WhichPad])
          {
			if(--CtrlCombinations[WhichMenuItem[WhichPad]][WhichPad] < 0 ) CtrlCombinations[WhichMenuItem[WhichPad]][WhichPad] = MAX_COMBINATIONS - 1;
		    PlayEffect(CURSOR_SFX);
			DebugPrintf(0,"%d %d\n%d %d\n\n", CtrlCombinations[0][0], CtrlCombinations[0][1], CtrlCombinations[1][0], CtrlCombinations[1][1]);
            DisplayControlerStrings(NumPads);
		  }
          break;
        case PAD_RIGHT:
          if(LastButtonPressed[WhichPad] != PadPressed[WhichPad])
          {	
			if(++CtrlCombinations[WhichMenuItem[WhichPad]][WhichPad] >= MAX_COMBINATIONS) CtrlCombinations[WhichMenuItem[WhichPad]][WhichPad] = 0;
		    PlayEffect(CURSOR_SFX);
			DebugPrintf(0,"%d %d\n%d %d\n\n", CtrlCombinations[0][0], CtrlCombinations[0][1], CtrlCombinations[1][0], CtrlCombinations[1][1]);
            DisplayControlerStrings(NumPads);
		  }
          break;
    
        case SQUARE:
          break;

        case STOP:
        case CIRCLE:
          break;
        case TRIANGLE:
          break;

        case START:
        case CROSS:
          if(LastButtonPressed[WhichPad] != PadPressed[WhichPad])
          {	
		    PlayEffect(CURSOR_SFX);
		    PlayersDone = TRUE;
		    RetCode = GO_NEXT;
		  }
          break;
    
        case BOTTOMLEFT:
          break;
        case BOTTOMRIGHT:
          break;
    
        case TOPRIGHT:
          break;
        case TOPLEFT:
          break;
    
      }/*switch*/

      /*check if both players are done*/
      if(MaxPlayers == 1)
      {
        if(PlayerDone[0] == TRUE)
          PlayersDone = TRUE;
      }/*if*/
      else if(MaxPlayers > 1)
      {
        if(PlayerDone[0] == TRUE && PlayerDone[1] == TRUE)
          PlayersDone = TRUE;
      }/*if*/

      /*register the last button pressed*/
      LastButtonPressed[WhichPad] = PadPressed[WhichPad];

    }/*for*/

  }/*while*/

  /*Loop until all buttons on pad 0 are released*/
  do
  {
    PollPads(PadPressed, MaxPlayers);
  }while(PadPressed[0] != NOBUTTON || PadPressed[1] != NOBUTTON);

  /*cleanup*/
  CleanUp_CTRL();

  /*return return code*/
  DebugPrintf(0,"Returning %d\n", RetCode);
  return RetCode;
  
}

/********************************************************
Paints the main screen
*********************************************************/
int Paint_CTRL_Screen(int NumPads)
{
  int OffDef, WhichSide, StrDepth;
  char *ptr;

  /*initialize the background for the shell*/
  ptr = (char *)GetMultiFilePtr(Shell_MFile, "ctrlbak.tim"); 
  initTexture(0, ptr);   

  /*load the shell graphics template files*/
  InitTemplates();
  multifile = Shell_MFile;
  LoadTemplate("pads.llx");     /*0-controls*/

  /*Handle NumPads == 1 vs NumPads == 2*/
  if(NumPads == 1)
  {
    template[0].action[1] ^= DISPLAY;
	XShift = 100;
    MovePolyToXY(&template[0].poly[0], (-256) + (10) + XShift, (-120) + (44 + (WhichMenuItem[0] * 118)));
  }
  else
  {
	XShift = 0;
  }

  /*print the blank strings*/
  for(OffDef = 0;OffDef < 2;OffDef++)
    for(WhichSide = 0;WhichSide < NumPads;WhichSide++)
      for(StrDepth = 0;StrDepth < 6;StrDepth++)
	  {
	    if(ControlStrings[OffDef][WhichSide][StrDepth].StrPtr != -1)
		  ControlStrings[OffDef][WhichSide][StrDepth].StrPtr = CreateString("    TEST      ", fontdpc9, ControlStrings[OffDef][WhichSide][StrDepth].MenuXPos + XShift, ControlStrings[OffDef][WhichSide][StrDepth].MenuYPos, FONT0 | PROPORTIONAL); 
	  }

  /*Change the string to the right ones from the array*/
  DisplayControlerStrings(NumPads);

  return 0;

}

/*********************************************************
Change Strings
**********************************************************/
void DisplayControlerStrings(int NumPads)
{
  int OffDef, WhichSide, StrDepth;

  for(OffDef = 0;OffDef < 2;OffDef++)
    for(WhichSide = 0;WhichSide < NumPads;WhichSide++)
      for(StrDepth = 0;StrDepth < 6;StrDepth++)
	  {
	    if(ControlStrings[OffDef][WhichSide][StrDepth].StrPtr != -1)
		{
          ChangeString(ControlStrings[OffDef][WhichSide][StrDepth].StrPtr, 
                       ControllerSetups[OffDef][CtrlCombinations[OffDef][WhichSide]][StrDepth], FONT0 | PROPORTIONAL);
		}
	  }
}

/*********************************************************
Cleans up everything
**********************************************************/
int CleanUp_CTRL()
{
  FreeTemplate(0);

  FreeFonts();

  FreeBackgrounds();

  return 0;
}

/*************************************************************************
 * FIELD FRAME - Callback function to setup the frame stuff...
 *************************************************************************/
int Shell_Frame_CTRL(void)
{
  PollPC();
  UpdateBackground();

  DisplayAllStrings();
  DisplayShellPolys();
  return(1);
}

/**************************END OF FILE CTRLSHL.C****************************/


