/***********************************************************
	General purpose debugging routines
	for the PlayStation

	Copyright 1994 Gametek
	All rights reserved.
	By Christopher G. Deel
***********************************************************/

#include <stdio.h>
#include <stdarg.h>

#include <sys/types.h>
#include <r3000.h>
#include <asm.h>
#include <kernel.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>

#include "prjhdrs.h"	/* Project header files */

#define DOBEEP 0	// whether or not errors with getch() should beep or not
#define HEAP_WALK_BUFFER 0x80400000

#if PC_DEBUG
//char ErrMsgBuff[255];
	char *ErrMsgBuff = 0x80210000;
#endif

#define MEG_2_TEST 0x801Ffff0
#define MEG_2_VAL 0x0CDee1

u_long debugVar1 = 0, debugVar2 = 0, debugVar3 = 0, debugVar4 = 0;

//#if PC_DEBUG
#if 0
	#define MAX_TIME_MARKERS 20
	ULONG  gTimeMarkVB[MAX_TIME_MARKERS];
	int gTimeMarkLine[MAX_TIME_MARKERS];
	int gCurrentTimeMark = 0;
#endif

ULONG ExceptionEvent;
UBYTE DebugSuperbowlFlag = False;

extern short NumStrings;



/*-------------------------------------------------------------
  PollDebugger ~ 
-------------------------------------------------------------*/
void PollDebugger(void)
{
	PollPC();
}  /* End PollHostSub() */


/*-------------------------------------------------------------
  ExceptionHandler ~
-------------------------------------------------------------*/
void ExceptionHandler(void)
{
//	struct TCBH *h = (struct TCBH *)SysToT[1].head;
//	struct TCB *p = h->entry;
//	unsigned long cr = p->reg[R_CAUSE];
//	unsigned long pc = p->reg[R_EPC];

//	PollPC();
//	printf("EXCEPTION %X at %X  cr=%X\n", (cr>>2) & 0x0F, pc, cr);
//	printf("EXCEPTION \n");
}


/*~~-------------------------
---------------------------*/
void InitDebug(void)
{
	ULONG *ptr, i;

/*	InitDebugStrings();    /*##*/
/*	Sio_0 = open("tty00:",O_WRONLY);    /*##*/
/*	Sio_0 = open("tty00:",O_RDWR);    /*##*/
/*	write(Sio_0, "Init Debug\r\n", 11);    /*##*/

//	ExceptionEvent = OpenEvent(HwCPU, EvSpTRAP, EvMdINTR, ExceptionHandler);
//	EnableEvent(ExceptionEvent);

#if PC_DEBUG
	DebugPrintf(0, "Init Debug Created: %s\n", gCompileDate);
//	DebugPrintf(0, "SP=%x GP=%x SR=%x\n", GetSp(), GetGp(), GetSr());
	 printf(0, "SP=%x GP=%x SR=%x\n", GetSp(), GetGp(), GetSr());
	 ptr = malloc(10);
	 printf("ptr = %X\n", ptr);
	 free(ptr);
//	ptr = (ULONG *) MEG_2_TEST;
//	*ptr = MEG_2_VAL;
	
//	InitDeelTest();
	
#endif
	 printf("SP=%x GP=%x SR=%x\n", GetSp(), GetGp(), GetSr());
	 ptr = malloc(10);
	 printf("ptr = %X\n", ptr);
	 free(ptr);

}


#if PC_DEBUG
/*-------------------------------------------------------------
  DebugColorBg ~ 
-------------------------------------------------------------*/
void DebugColorBg(int red, int green, int blue)
{
	RECT Rect;
	int i;

	VSync(0);
	Rect.x = 0;
	Rect.y = 0;
	Rect.w = 512;
	Rect.h = 480;
	SetBackgroundColor(red, green, blue);
	ClearImage(&Rect, red, green, blue);    
	SetDispMask(1);     /* enable to display (0:inhibit, 1:enable) */
	for (i = 0; i < 30; i++)
		VSync(0);
}  /* End DebugColorBg() */
#endif 

/*-------------------------------------------------------------
  CheckValidAddress ~ 
-------------------------------------------------------------*/
int CheckValidAddress(char *addr, int align)
{
	register int ret = TRUE;
	char mask[5] = {0,0,1,3,3};
	
	if ((ULONG)addr & (ULONG)mask[align])
	{
		ret = FALSE;
	}
	if (!( (ULONG)addr & 0x80000000))
	{
		ret = FALSE;
	}
	return ret;
}  /* End CheckValidAddress() */


#if PC_DEBUG

/*-------------------------------------------------------------
  Check2MegOverflow ~
-------------------------------------------------------------*/
void Check2MegOverflow(void)
{
	ULONG *ptr;
	static int count = 0;

	ptr = (ULONG *) MEG_2_TEST;
	if (*ptr != MEG_2_VAL)
	{
		if (count++ < 5)
			DebugPrintf(0, "Over 2 Meg!\n");
	}
}


#endif PC_DEBUG

/*-------------------------------------------------------------
  DumpAllocLoc ~ Display location where next malloc would be
-------------------------------------------------------------*/
ULONG DumpAllocLoc(void)
{
#if PC_DEBUG
	ULONG memleft;

	DebugPrintf(0, "SP=%X  ", GetSp());
	memleft = ShowMemLeft();
	return memleft;

//	ptr = (char *)malloc(8 * 1024);
//	free(ptr);
//	memleft = (ULONG)0x200000 - ((ULONG)ptr & 0x7FFFffff);
//	memleft /= 0x400;
//	DebugPrintf(0, "Alloc=%X SP=%X  %dk free\n", ptr, GetSp(), memleft);
//	return ptr;
#endif PC_DEBUG
}

/*~~-------------------------
---------------------------*/
void CmarkerSub(char *msg, char *file, int line)
{
	char buf[20];
	ULONG vb;

//	vb = GetVBlankCount();
//	sprintf(buf, "%s %d   %s #%d\n", msg, vb, file, line);
	sprintf(buf, "%s %s #%d\n", msg, file, line);
	ShowDebugMsg(buf);
}


/*~~-------------------------
---------------------------*/
void DumpMemory(Ubyte *data, int lines, int size)
{
#if PC_DEBUG
//#if 0
	register int n;
	register Ubyte *ptr;
	register char c;

//	printf("\n");
	ptr = data;
	while (lines--)
	{
		printf("%08X: ", ptr);
		if (size <= 1)
			for (n=0; n < 16; n++)
			{
				printf("%02X ",	*ptr);
				ptr++;
			}
		else
			for (n=0; n < 8; n++)
			{
				printf("%04X ",	*(Ushort*)ptr);
				ptr +=2;
			}
		ptr = data;
		printf("  ");
		for (n=0; n < 16; n++)
		{
			c = *ptr;
			if (c < ' ' || c > 'z')
				c = '.';
			printf("%c", c);
			ptr++;
		}
		data += 16;
		printf("\n");
		VSync(0);
	}
#endif PC_DEBUG
}

/*-------------------------------------------------------------
  DumpPolyFT4 ~
-------------------------------------------------------------*/
void DumpPolyFT4(POLY_FT4 *poly)
{
#if PC_DEBUG
//	DebugPrintf(0, "Poly FT4 at: %x ", poly);
//	DebugPrintf(0, "Scrn: %d,%d  %d,%d  ", poly->x0, poly->y0,
//												poly->x3, poly->y3);
//	DebugPrintf(0, "Tex: %d,%d  %d,%d  ", poly->u0, poly->v0,
//												poly->u3, poly->v3);
//	DebugPrintf(0, "Tag: %x ", poly->tag);
#endif PC_DEBUG
}

/*-------------------------------------------------------------
  PrintSpriteInfo ~ 
-------------------------------------------------------------*/
void PrintSpriteInfo(PolySpritePtr sprite)
{
//	DebugPrintf(0, "Sprite: %X  flg:%X \n", sprite, sprite->flags);
//	DumpPolyFT4(&sprite->poly[0]);
}  /* End PrintSpriteInfo() */

/*-------------------------------------------------------------
  DumpVramAlloc ~ 
-------------------------------------------------------------*/
void DumpVramAlloc(void)
{
#if PC_DEBUG	
//#if 0	
	int i, cnt;
	int num_textures  = NUM_TEXTURE_PAGES;


	if (gVidMode == VMODE640)
	{
		num_textures  = BIG_NUM_TEXTURE_PAGES; /* 640 X 480 */
	} 
	else if (gVidMode == VMODE512)
	{
		num_textures  = MED_NUM_TEXTURE_PAGES; /* 512 X 240 */
	}
		
	Dprintf("VRAM: 0 1 2 3 4 5 6 7-8 9 A B C D E F G H I J K L\n");
	Dprintf("      ");
	for (i = 0; i < num_textures; i++)
	{
		Dprintf("%d ", texture[i].used);
	}
	Dprintf("\n");
	cnt = 0;
	for (i = 0; i < BIG_NUM_CLUT256_PAGES; i++)
	{
		if (clut256[i].used)
			cnt++;
	}
	Dprintf("Used %d Clut 256s  ", cnt);
	cnt = 0;
	for (i = 0; i < BIG_NUM_CLUT16_PAGES; i++)
	{
		if (clut16[i].used)
			cnt++;
	}
	Dprintf("%d Clut 16s\n", cnt);
#endif
}

#if 0
/*-------------------------------------------------------------
  DumpStringsUsed ~ 
-------------------------------------------------------------*/
void DumpStringsUsed(void)
{
  #if PC_DEBUG
	DebugPrintf(0, "%d of %d Strings used.\n", NumStrings, NUM_STRINGS);
  #endif //PC_DEBUG
}  /* End DumpStringsUsed() */
#endif

#if DEBUG_MALLOC
/*-------------------------------------------------------------
  AllocMemDebug ~
-------------------------------------------------------------*/
void * AllocMemDebug(long bytes, char *file, int line)
{
	register void *ptr;

	ptr = (void *)malloc(bytes);

	if ( (((ULONG)ptr + (ULONG)bytes) > 0x80200000) &&
	    						((ULONG)ptr < 0x80200100) )
	{
		 DebugPrintf(0, "Alloc Overflow: %X %X %X  -%dk\n", ptr, bytes,
	 				(ULONG)ptr + (ULONG)bytes,
	 				(((ULONG)ptr + (ULONG)bytes) - 0x80200000)/1024 );
	}
	DebugPrintf(0, "AllocMem: %X %X %X %s %d\n", ptr, bytes,
	 				(ULONG)ptr + (ULONG)bytes, file, line);
	return ptr;
}

/*-------------------------------------------------------------
  FreeMemDebug ~
-------------------------------------------------------------*/
void FreeMemDebug(void *ptr, char *file, int line)
{
	free(ptr);
	 DebugPrintf(0, "FreeMem: %X %s %d\n", ptr, file, line);
//	Check2MegOverflow();
	if ((ULONG)ptr > 0x80300000 || (ULONG)ptr < 0x8000FFFF)
		DebugPrintf(0, "Invalid Free: %x\n", ptr);
}

#endif  //DEBUG_MALLOC

/*-------------------------------------------------------------
  CalcFrameRate ~ Call this routine for every frame
  	mode 0 = count this frame
  	1 = reset,	2 = calc frame rate
-------------------------------------------------------------*/
ULONG CalcFrameRate(short mode)
{
}

/*~~----------------------------------------
    Put debug message into memory area
------------------------------------------*/
void ShowDebugMsg(char *msg)
{
/*	strcpy(gDebugMsg,msg);    /*##*/
#if PC_DEBUG
	printf(msg);
#endif
}

/*~~-------------------------
---------------------------*/
char InputDebugChar(void)
{
	register char prevCmd = 0, cmd = 'A';
	int working = True;
	int prevPad = 0xFF;

	while(JpadData[0])  /* Wait for all buttons released */
	{
		ReadPads();
		PollPC();
	}
	while (working)
	{
		ReadPads();
		PollPC();
		if (JpadData[0] != prevPad)
		{
			if (JpadData[0]	& JPADLup)
			    cmd++;
			if (JpadData[0]	& JPADLdown)
			    cmd--;
			if (JpadData[0]	& (JPADcircle | JPADx))
			{
			    working = False;
			    prevCmd = 0;
			}
			prevPad = JpadData[0];
		}
		if (cmd < 'A')
			cmd = 'Z';
		if (cmd > 'Z')
		    cmd = 'A';
		if (prevCmd != cmd)
		{
			DebugPrintf(0, "(%c) ", cmd);
		}
		prevCmd = cmd;
	}
	return cmd;
}

/*~~-------------------------
---------------------------*/
void DoDebugMonitor(void)
{
	int working = True;
	char cmd;

	DebugPrintf(0, "Debug Monitor -- A=Chris B=Nigel C=Tom\n");
	cmd = InputDebugChar();
	switch (cmd)
	{
		case 'A':
			DoDeelDebug();
			break;
		case 'B':
			DoNigelDebug();
			break;
		case 'C':
			DoTomDebug();
			break;
	}
	initVRamHandling();
	DebugPrintf(0, " Monitor Done\n");
}

/*~~----------------------------
    Check for Debug command
    (Start Button)
------------------------------*/
void CheckDebugCmd(void)
{
#if PC_DEBUG
	static int t = 2;

	if (t--)
		return;
	t = 3;
	PollPC();			/* Communicate with PSX Debugger */
	if (JpadData[0] & JPADLfront1)
		TomTest();
	if (JpadData[0] & JPADRfront1)
		NigelTest();
	if (JpadData[0] & JPADh)
		DoDebugMonitor();
#endif
}



/*-------------------------------------------------------------
  Dprintf ~ 
-------------------------------------------------------------*/
void Dprintf(char *format, ...)
{
#if PC_DEBUG
	va_list ap;

	va_start(ap, format);
	vsprintf2(ErrMsgBuff, format, ap);
	va_end(ap);
	ShowDebugMsg(ErrMsgBuff);
#endif
	
}  /* End Dprintf() */


/*~~-------------------------
**  Debug Printing
*/
void DebugPrintf(BOOL pause,char *format, ...)
{
#if PC_DEBUG
	va_list ap;

	va_start(ap, format);
	vsprintf2(ErrMsgBuff, format, ap);
	va_end(ap);
	ShowDebugMsg(ErrMsgBuff);
	if (pause)
		getch();
#endif
}

/*-------------------------------------------------------------
  CheckTesterPassword ~
-------------------------------------------------------------*/
//int CheckTesterPassword(void)
//{
//	int val;

//	static ULONG password[] =
//	{
//		 JPADtriangle,
//		 JPADsquare,
//		 JPADcircle,
//		 JPADsquare,
//		 JPADtriangle,
//		0
//	};

//	val = CheckPadHistory(0, password);
//#if PC_DEBUG
//	if (val)
//		DebugPrintf(0, "TesterPass\n");
//#endif PC_DEBUG
//	return val;
//}

#if 0
/*-------------------------------------------------------------
  GetFakeCDFile ~ 
-------------------------------------------------------------*/
char * GetFakeCDFile(char *fname)
{
	char *ptr = NULL;
	
	printf("WARNING: Fake CD %s\n", fname);
#if PC_DEBUG	
	ptr = (char*)GetMultiFilePtr((ULONG)FAKE_CD, fname);
#endif	
	return ptr;
}  /* End GetFakeCDFile() */
#endif //0

#if PC_DEBUG
// ************* Time Mark Routines ***************
#endif // PC_DEBUG

