#ifndef _DEBUG_H
#define _DEBUG_H 1
/******************************************************************
	PSX Debug Header 
	
******************************************************************/

#ifndef  _PRJTYPES_H
#include "prjtypes.h"
#endif

//#define DEBUG_MALLOC 1		/* Comment this line out normally */
#define DEBUG_MALLOC_FILE 1		/* Comment this line out normally */


extern unsigned long debugVar1, debugVar2, debugVar3, debugVar4;
extern UBYTE DebugSuperbowlFlag;


#define Cmarker() CmarkerSub("M", __FILE__, __LINE__)
#define Cerror()  CmarkerSub("Error", __FILE__, __LINE__)

#define FAKE_CD 0x80200000
//#define NO_JIMMY 1


#if PC_DEBUG 
#define MarkTime()  TimeMarkerSub(__LINE__)
#define InitTimeMarks() TimeMarkerSub(0)
#define PollPC() pollhost()
#define BreakPoint   asm("break 0")
#define DumpHeapMark() Cmarker(); DumpHeap()


#else
#define PollPC() /* nothing */
#define MarkTime()  /* nothing */
#define InitTimeMarks()  /* nothing */
#define DumpTimeMarks()	 /* nothing */
#define Check2MegOverflow()	/* */
#define BreakPoint  /* nothing */
#define DumpHeapMark()  /* nothing */
#endif

//#define ANSI_CLS 	"\x1b[2J"
//#define ANSI_HOME	"\x1b[0;0H"

#if DEBUG_MALLOC
//void * AllocMemDebug(long bytes, char *file, int line);
//void FreeMemDebug(void *ptr, char *file, int line);
//#define AllocMem(bytes)  AllocMemDebug(bytes, __FILE__, __LINE__)
//#define FreeMem(ptr)   FreeMemDebug(ptr, __FILE__, __LINE__)
#endif

#if DEBUG_MALLOC_FILE
#define AllocMem(bytes) mallocfl(bytes, __FILE__, __LINE__)
#define calloc(xx,yy)  callocfl(xx,yy,__FILE__,__LINE__)
#define realloc(xx,yy) reallocfl(xx,yy,__FILE__,__LINE__)

#endif


/* debug.c */
void InitDebug ( void );
void CheckDebugCmd ( void );
int WaitDebugCmd ( void );
void ShowDebugMsg ( char *msg );
void PrintDebugVars ( void );
void CmarkerSub ( char *msg , char *file , int line );

void DebugPrintf(BOOL pause,char *format, ...);
void Dprintf(char *format, ...);
void TimeMarkerSub(int line);

ULONG DumpAllocLoc(void);
char * GetFakeCDFile(char *fname);

#endif   /* _DEBUG_H */
