/**********************************************************************
	debugshl.c 														   
	debug options screen												   
																   
	Programmed by Nicolas Antczak										   
	Started on 3/14/1995												   
	Copyright (C) 1995 GameTek, inc									   

	Modifications														   
		Christopher Deel  3-29-96
************************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbequ.h"
#include "fbram.h"
#include "fbplays.h"
#include "shell.h"
#include "debugshl.h"


//#define EASY_TESTER_PASS 1
#define CROWD_SCALE_VALUE	128

/*global variables used as a debug flags*/
//int TesterVar[10] = {0,0,0,0,0,0,0,0,0,0};

/*multifile pointers*/
//unsigned long *Shell_MFile;

/*debug values array*/
static int DebugIndex = 0;
static int PasswordIn = 0;
static int AllEnabled = 0;
static int OnlyOne = 0;

extern vram_t	*gArcadeFontClut;

enum 
{
	NO_PASSWORD,	
	TESTER_PASSWORD,	
	EGG_SHELL_PASSWORD,	
};


enum
{
	DB_HOME_SCORE,
	DB_AWAY_SCORE,
	DB_HOME_TIMEOUTS,
	DB_AWAY_TIMEOUTS,
	DB_START_BALLX,
	DB_DOWN,
	DB_QTR,
	DB_COMMAND,
	DB_HOME_HANDS,
	DB_AWAY_HANDS,
	DB_HOME_SPEED,
	DB_AWAY_SPEED,
	DB_HOME_EDIT,
	DB_AWAY_EDIT,
	DB_GAME_TIME,
	DB_HOME_DOWNS_FOR_1ST,
	DB_AWAY_DOWNS_FOR_1ST,
	DB_HOME_YARDS_FOR_1ST,
	DB_AWAY_YARDS_FOR_1ST,
	DB_PLAYER_NUMS,
	DB_CROWD_VOLUME_A,
	DB_CROWD_VOLUME_B,
	DB_CROWD_VOLUME_C,
	DB_BASE_TACKLE_PCT,
	DB_WIND_X,
	DB_WIND_Y,
};

/*------------------------------------------------------------------------
To add additional menu items simply add one more component to DebugList
array and increase DEBUGMAX macro define. Also set the value of the new
item in InitDebugData() and save its value in ValidateDebugData()

The DebugList elements are defined in debugshl.h
-------------------------------------------------------------------------*/

#define DEBUGMAX 24
struct DebugStruct DebugShellVar[] = 
	{
		"Home Score", /*0*/  /*name*/
		0,			 /*value*/
		0,			 /*min*/
		300,	 /*max*/
		0,			 /*used internally, make it 0*/

		"Away Score",	0, 0, 300, 0, 	//1
		"Home TimeOuts",	0, 0, 100, 0,		//2
		"Away TimeOuts",	0, 0, 100, 0,		//3
		"StartBallX Yard",	0, 0, 100, 0,	//4
		"The Down",    	0, 0, 4, 0,		//5
		"Qtr.",			1, 1, 5, 0,		//6
		"Command",    /*7*/
		0, 0, 100, 0,
		"Home Skill",    /*8*/
		0, 0, 100, 0,
		"Away Skill",    /*9*/
		0, 0, 100, 0,
		"Team Speed0",    /*10*/
		0, 0, 8, 0,
		"Team Speed1",    /*11*/
		0, 0, 8, 0,
		"Home EditStatus",    /*12*/
		0, 0, 5, 0,
		"Away EditStatus",    /*13*/
		0, 0, 5, 0,
		"Game Time",	//14
		0, 0, 11000, 0,
		"Home: Downs for 1st",	//15
		0, 0, 20, 0,
		"Away: Downs for 1st",	//16
		0, 0, 20, 0,
		"Home: Yards for 1st",	//17
		0, 0, 100, 0,
		"Away: Yards for 1st",	//18
		0, 0, 100, 0,
		"Player Numbers",	//19
		0, 0, 2, 0,
		"Crowd Volume A",		//20
		0, 0, 127, 0,
		"Crowd Volume B",		//21
		0, 0, 127, 0,
		"Crowd Volume C",		//22
		0, 0, 127, 0,
		"Base Tackle Pct",		//23 BaseTacklePct
		0, 0, 200, 0,
//		"WindDeltaX",		//24
//		0, -50, 50, 0,
//		"WindDeltaY",		//25
//		0, -50, 50, 0,
	};

#if EASY_TESTER_PASS
static ULONG TesterPassword[] =    // Easy tester password
	{
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		JPADsquare,
		JPADtriangle,
		JPADsquare,
		0
	};
#else	
static ULONG TesterPassword[] =
	{
		JPADselect,
		JPADtriangle,
		JPADLleft,
		JPADcircle,
		JPADLleft,
		JPADsquare,
		JPADLleft,
		0
	};
#endif


static ULONG EggShellPassword1[] =
	{
		JPADselect,
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		JPADsquare,
		JPADtriangle,
		0
	};

static ULONG EggShellPassword2[] =
	{
		JPADselect,
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		JPADsquare,
		JPADcircle,
		0
	};

static ULONG EggShellPassword3[] =
	{
		JPADselect,
		JPADsquare,
		JPADcircle,
		JPADtriangle,
		JPADsquare,
		JPADtriangle,
		0
	};
static ULONG EggShellPassword4[] =
	{
		JPADselect,
		JPADsquare,
		JPADcircle,
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		0
	};
static ULONG EggShellPassword5[] = 
	{
		JPADselect,
		JPADcircle,
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		JPADsquare,
		0
	};
static ULONG EggShellPassword6[] =
	{
		JPADselect,
		JPADcircle,
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		JPADtriangle,
		0
	};
static ULONG EggShellPassword7[] =
	{
		JPADselect,
		JPADcircle,
		JPADsquare,
		JPADtriangle,
		JPADsquare,
		JPADcircle,
		0
	};
static ULONG EggShellPassword8[] =
	{
		JPADselect,
		JPADcircle,
		JPADsquare,
		JPADtriangle,
		JPADsquare,
		JPADtriangle,
		0
	};
	
static struct	
{
	ULONG *pass;
	int var;
} PasswordList[] =
	{
		{EggShellPassword1, DB_HOME_DOWNS_FOR_1ST},
		{EggShellPassword2, DB_AWAY_DOWNS_FOR_1ST},
		{EggShellPassword3, DB_HOME_YARDS_FOR_1ST},
		{EggShellPassword4, DB_AWAY_YARDS_FOR_1ST},
		{EggShellPassword5, DB_HOME_HANDS},
		{EggShellPassword6, DB_AWAY_HANDS},
		{EggShellPassword7, DB_HOME_SPEED},
		{EggShellPassword8, DB_AWAY_SPEED},
		{NULL, 1},
	};

/*-------------------------------------------------------------
  CheckTesterPassword ~
-------------------------------------------------------------*/
int CheckTesterPassword(void)
{
	int val, i, working;

	val = 0;
	if (CheckPadHistory(0, TesterPassword))
	{
		val = 1;
		OnlyOne = 0;
	}
	
	return val;
}
	
/*-------------------------------------------------------------
  CheckEggPassword ~
-------------------------------------------------------------*/
int CheckEggPassword(void)
{
	int val, i, working;

	i = 0;
	working = TRUE;
	val = 0;

	while(working)
	{
		if (PasswordList[i].pass == NULL)
			working = FALSE;
		else if (CheckPadHistory(0, PasswordList[i].pass))
		{
			OnlyOne = PasswordList[i].var + 1;
			val = 1;
			working = FALSE;
		}
		i++;
	}

	return val;
}

	
/*-------------------------------------------------------------
  CreateDbShlString ~ 
-------------------------------------------------------------*/
int CreateDbShlString(char *text, int xpos, int ypos)
{
	int str;
	str = CreateString(text, fontdpc4, xpos, ypos, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[str], gArcadeFontClut->CLUT_ID);
	return str;
}  /* End CreateDbShlString() */

	
/*-------------------------------------------------------------
  DoDebugShellCommand ~ 
-------------------------------------------------------------*/
void DoDebugShellCommand(int cmd)
{
	DebugPrintf(0, "Command: %d\n", cmd);
	if (cmd != 0)
	{
		if (cmd < 10)
			DoSoundTestCommand(cmd);
		else if (cmd < 20)
			DoAITestCommand(cmd);
		else
			DoArcadeDebugCommand(cmd);
	}
}  /* End DoDebugShellCommand() */

/*-----------------------------------------------------**
Inits debug vars to the program vars
------------------------------------------------------***/
void InitDebugData()
{
	int i;

	ResetStrings();
//	for(i=0;i<2;i++)
//	{
//		if(GameTeamData[i].OffDefFlag == ON_OFFENSE)
//		{
//			DebugShellVar[0].Value = GameTeamData[i].PlayNum;	 //Off. Play
//			DebugShellVar[0].Min = 0;
//			DebugShellVar[0].Max = MAXPLAYS;

//			DebugShellVar[2].Value = GameTeamData[i].TotalScore;	 //Off. Score
//			DebugShellVar[2].Min = 0;
//			DebugShellVar[2].Max = 100;
//		}
//		else
//		{
//			DebugShellVar[1].Value = GameTeamData[i].PlayNum;	 //Def. Play
//			DebugShellVar[1].Min = 0;
//			DebugShellVar[1].Max = MAXPLAYS;

//			DebugShellVar[3].Value = GameTeamData[i].TotalScore;	 //Def. Score
//			DebugShellVar[3].Min = 0;
//			DebugShellVar[3].Max = 100;
//		}
//	}

	
	DebugShellVar[DB_HOME_SCORE].Value = GameTeamData[0].TotalScore;
	DebugShellVar[DB_AWAY_SCORE].Value = GameTeamData[1].TotalScore;
	DebugShellVar[DB_HOME_TIMEOUTS].Value = GameTeamData[0].TimeOuts;
	DebugShellVar[DB_AWAY_TIMEOUTS].Value = GameTeamData[1].TimeOuts;
	
	DebugShellVar[4].Value = (StartBallX - DEF_GOAL_LINE) / YARDS ;  //StartBallX CGD
	DebugShellVar[5].Value = TheDown;	  //The Down
	DebugShellVar[6].Value = TheQuarter;	 //Qtr
	DebugShellVar[7].Value = 0;				// Debug Command
	DebugShellVar[8].Value = TeamHands[0];	 //team hands
	DebugShellVar[9].Value = TeamHands[1];	 //team hands
	DebugShellVar[10].Value = TeamSpeed[0];	  //team speed
	DebugShellVar[11].Value = TeamSpeed[1];	  //team speed
	DebugShellVar[12].Value = Team0EditStatus;
	DebugShellVar[13].Value = Team1EditStatus;
	DebugShellVar[14].Value = GetVBlankTimer(GAME_TIMER_NUM) / CLOCKS_TICKS_PER_SECOND;
	
	DebugShellVar[15].Value = GameTeamData[0].DownsForFirst;
	DebugShellVar[16].Value = GameTeamData[1].DownsForFirst;
	DebugShellVar[17].Value = GameTeamData[0].YardsForFirst / YARDS;
	DebugShellVar[18].Value = GameTeamData[1].YardsForFirst / YARDS;
	
//	DebugShellVar[19].Value;
	DebugShellVar[20].Value = DesiredCrowdVolume[0] / CROWD_SCALE_VALUE;
	DebugShellVar[21].Value = DesiredCrowdVolume[1] / CROWD_SCALE_VALUE;
	DebugShellVar[22].Value = DesiredCrowdVolume[2] / CROWD_SCALE_VALUE;
	DebugShellVar[23].Value = BaseTacklePercent;
//	DebugShellVar[24].Value = WindDeltaX;
//	DebugShellVar[25].Value = WindDeltaY;
}

/*------------------------------------------------------*
	Saves debug vars to the program vars
-------------------------------------------------------**/
void ValidateDebugData()
{
	int i;

//	for(i=0; i<2; i++)
//	{
//		if(GameTeamData[i].OffDefFlag == ON_OFFENSE)
//		{
//			GameTeamData[i].PlayNum = DebugShellVar[0].Value;		 //Off. Play
//			GameTeamData[i].TotalScore = DebugShellVar[2].Value;	 //Off. Score
//		}
//		else
//		{
//			GameTeamData[i].PlayNum = DebugShellVar[1].Value;		 //Def. Play
//			GameTeamData[i].TotalScore = DebugShellVar[3].Value;	 //Def. Score
//		}
//	}

	GameTeamData[0].TotalScore = DebugShellVar[DB_HOME_SCORE].Value;
	GameTeamData[1].TotalScore = DebugShellVar[DB_AWAY_SCORE].Value;
	GameTeamData[0].TimeOuts = DebugShellVar[DB_HOME_TIMEOUTS].Value;
	GameTeamData[1].TimeOuts = DebugShellVar[DB_AWAY_TIMEOUTS].Value;
	
	StartBallX	= (DebugShellVar[4].Value * YARDS) + DEF_GOAL_LINE;  //StartBallX  CGD
	TheDown 	= DebugShellVar[5].Value;	  //The Down
	TheQuarter = DebugShellVar[6].Value;	 //Qtr
	TheTrueQuarter = TheQuarter;
										//7 command
	TeamHands[0] = DebugShellVar[8].Value;			 //team hands
	TeamHands[1] = DebugShellVar[9].Value;			 //team hands
	TeamSpeed[0] = DebugShellVar[10].Value;			  //team speed
	TeamSpeed[1] = DebugShellVar[11].Value;			  //team speed
	Team0EditStatus = DebugShellVar[12].Value;
	Team1EditStatus = DebugShellVar[13].Value;
	SetVBlankTimer(GAME_TIMER_NUM, DebugShellVar[14].Value * CLOCKS_TICKS_PER_SECOND);
	
	GameTeamData[0].DownsForFirst = DebugShellVar[15].Value;
	GameTeamData[1].DownsForFirst = DebugShellVar[16].Value;
	GameTeamData[0].YardsForFirst = DebugShellVar[17].Value * YARDS;
	GameTeamData[1].YardsForFirst = DebugShellVar[18].Value * YARDS;

//	DebugShellVar[19].Value;
	DesiredCrowdVolume[0] = DebugShellVar[20].Value * CROWD_SCALE_VALUE	;
	DesiredCrowdVolume[1] = DebugShellVar[21].Value * CROWD_SCALE_VALUE	;
	DesiredCrowdVolume[2] = DebugShellVar[22].Value * CROWD_SCALE_VALUE	;
	BaseTacklePercent = DebugShellVar[23].Value;
//	WindDeltaX = DebugShellVar[24].Value;
//	WindDeltaY = DebugShellVar[25].Value;

	PracticeStartBallX = StartBallX;
	OverrideEditedSetting(0, Team0EditStatus);
	OverrideEditedSetting(1, Team1EditStatus);

	DoDebugShellCommand(DebugShellVar[7].Value);
	
	OnlyOne = 0;
}
		
/*-----------------------------------------------------------
-----------------------------------------------------------*/
void Display_Debug_Shell(int LoadFontsFlag)
{
	int i, move;
	USHORT pad;
	USHORT prevPad = 1;
	int repeat, working;
	
	
	SetBackgroundColor(0x30, 0x80, 0xA0); 
	InitDebugData();

  /*Load Fonts*/
	if(LoadFontsFlag == TRUE)
	{
		Register_Font_Cluts();
		InitFonts();
		LoadFont("fontdpc9.tim", 3);
	}

	Paint_DBUG_Screen();

	while(JpadData[0])
		ReadPads();
		
	prevPad = JpadData[0];	
	repeat = 0;
  	working = TRUE;
	while(working)
	{
		pad = JpadData[0];  // CGD
		move = 0;
		if (prevPad == 0 || repeat > 4)
		{
			repeat = 0;
			if (pad == JPADLup)
			{
//				DebugIndex--;
				move = -1;
			}
			if (pad == JPADLdown)
			{
//				DebugIndex++;
				move = 1;
			}
			if (pad & JPADLleft)
				DebugShellVar[DebugIndex].Value--;
			if (pad & JPADLright)
				DebugShellVar[DebugIndex].Value++;
			if (pad & JPADsquare)
				DebugShellVar[DebugIndex].Value -= 10;
			if (pad & JPADtriangle)
				DebugShellVar[DebugIndex].Value += 10;
			if (pad & JPADx)
			{
				working = FALSE;
			}
		}
		else if (pad == prevPad)
		{
			VSync(0);
			repeat++;
		}
		else
		{
			repeat = 0;
		}

		DebugIndex += move;
		
		if (OnlyOne)
			DebugIndex = OnlyOne - 1;
			
		if (DebugIndex < 0 ) 
		    DebugIndex = DEBUGMAX - 1;
		if (DebugIndex >= DEBUGMAX ) 
		    DebugIndex = 0;
		if(DebugShellVar[DebugIndex].Value < DebugShellVar[DebugIndex].Min)
			DebugShellVar[DebugIndex].Value = DebugShellVar[DebugIndex].Max;
		if(DebugShellVar[DebugIndex].Value > DebugShellVar[DebugIndex].Max)
			DebugShellVar[DebugIndex].Value = DebugShellVar[DebugIndex].Min;
		RefreshDebugScreen();
		DoFrameLoop(1, Shell_Frame_DBUG);
		prevPad = pad;
		
	}/*while*/

  /*cleanup*/
	ValidateDebugData();
	CleanUp_DBUG(LoadFontsFlag);
	SetBackgroundColor(0x0, 0x0, 0x0); 
}

/*-------------------------------------------------------
    Refreshes the strings on the screen
-------------------------------------------------------*/
void RefreshDebugScreen()
{
	char DisplayStr[255];			  /*Generic display string buffer*/
	int i;
	char Cursor;

	for(i = 0; i < DEBUGMAX; i++)
	{
		if(i==DebugIndex)
			Cursor = 'X';
		else
			Cursor = ' ';

		if (OnlyOne && i != OnlyOne-1)
			sprintf(DisplayStr, "  ");
		else
		{
			sprintf(DisplayStr, "%c %s  %d", Cursor, DebugShellVar[i].Name ,
									DebugShellVar[i].Value);
		}									
		ChangeString(DebugShellVar[i].StringPtr, DisplayStr, FONT0 | PROPORTIONAL);
	}
}

/*------------------------------------------------------*
	Paints the main screen
-------------------------------------------------------**/
int Paint_DBUG_Screen()
{
	char *ptr;
	char DisplayStr[255];			  /*Generic display string buffer*/
	register int i, str;
	char Cursor=' ';
	register int xpos, ypos;
	
  /*initialize the background for the shell*/

  /*paint the actual menu according to the list*/
	xpos = 21;
	ypos = 18;  // CGD
	for(i = 0; i < DEBUGMAX; i++)
	{
		if (i == 20)
		{
			xpos = 250;
			ypos = 18;
		}
		if (OnlyOne)
		{
			xpos = 24;
			ypos = 40;
		}
		sprintf(DisplayStr, "%c %s  %d     ", Cursor, DebugShellVar[i].Name ,DebugShellVar[i].Value);
//		DebugShellVar[i].StringPtr = CreateString(DisplayStr, fontdpc4, DebugShellVar[i].MenuXPos, DebugShellVar[i].MenuYPos, FONT0 | PROPORTIONAL);
//		DebugShellVar[i].StringPtr = CreateString(DisplayStr, fontdpc4, 
//						xpos, ypos, FONT0  | PROPORTIONAL);
		DebugShellVar[i].StringPtr = CreateDbShlString(DisplayStr, xpos, ypos);
		
		ypos += 10;
	}

//	xpos = 250;
//	ypos = 20;
  /*paint 'static' info, the one that does not change*/

  	if (!OnlyOne)
  	{
//		sprintf(DisplayStr, "Home Play %d", GameTeamData[0].PlayNum);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
//		sprintf(DisplayStr, "Away Play %d", GameTeamData[0].PlayNum);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
//		sprintf(DisplayStr, "Ball Position %X,%X", BallXPosition, BallYPosition);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
//		sprintf(DisplayStr, "Ball Delta %d,%d", BallDeltaX, BallDeltaY);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
//		sprintf(DisplayStr, "Ball Target %X,%X", BallTargetX, BallTargetY);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
		sprintf(DisplayStr, "Intercept  %d %%", InterceptPercent );
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
		
		sprintf(DisplayStr, "Def. Rand. %d", DefRandomNum );
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
		
		sprintf(DisplayStr, "OffCatch   %d %%", OffCatchPercent );
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
		
		sprintf(DisplayStr, "OffCatch0  %d %%", OffCatchPercent0 );
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
	
		sprintf(DisplayStr, "Off Rand.  %d", OffRandomNum );
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
	
		sprintf(DisplayStr, "Catch Status %d", CatchStatus );
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
	
//		sprintf(DisplayStr, "Anim Set %d", TDAnimLoadedNum);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
//		sprintf(DisplayStr, "TrueCrowdVol %d,%d,%d", TrueCrowdVolume[0],TrueCrowdVolume[1],TrueCrowdVolume[2]);
//		CreateDbShlString(DisplayStr, xpos, ypos);
//		ypos += 10;
	
		sprintf(DisplayStr, "ErrorNumber %d", ErrorNumber);
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
	
		sprintf(DisplayStr, "Ver. %s", gCompileDate);
		CreateDbShlString(DisplayStr, xpos, ypos);
		ypos += 10;
	}
	
	RefreshDebugScreen();

	return 0;
}


/*------------------------------------------------------**
	Cleans up everything
-------------------------------------------------------***/
int CleanUp_DBUG(int LoadFontsFlag)
{
	int i;

	if(LoadFontsFlag == TRUE)
	{
		FreeFonts();
	}

  /*free the strings*/
//	for(i = 0; i < DEBUGMAX; i++)
//	{
//		FreeString(DebugShellVar[i].StringPtr);
//	}
	ResetStrings();
	return 0;
}

/*-----------------------------------------------------------------
	FRAME - Callback function to setup the frame stuff...
-----------------------------------------------------------------*/
int Shell_Frame_DBUG(void)
{
//	UpdateBackground();

	DisplayAllStrings();
	DisplayShellPolys();
	return(1);
}

