/****************************************
	Chris Deel's Debugging Code

***************************************/

#include <stdio.h>
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include <kernel.h>

#include "prjhdrs.h"	/* Project header files */
#include "MultiFil.h"
#include "plyranim.h"
#include "camera.h"
#include "deel.h"
#include "teamstad.h"
#include "overlays.h"
#include "dpcshl.h"

#include "fbequ.h"
#include "fbram.h"
#include "fbirp.h"

#include "fbstats.h"
#include "shell.h"
#include "gameloop.h"

//POLY_FT4 gTestPoly[2];
vram_t *gTestVram;

//#define FORCE_HOME_TEAM  7

#if PC_DEBUG
//#define TEST_PLAYERS 1      // ENABLE TEST PLAYERS CODE
#endif // PC_DEBUG

#define TEST_ANIM  PG_RUNNING_NUM
//#define TEST_ANIM  PG_BACKPEDAL_WBALL_NUM


extern char *gRefereeFilePtr;
extern char *gStadTmdPtr;

extern SVECTOR gBallxyz;

/*~~----------------------------------------------
	DeelTestCode ;;;
------------------------------------------------*/
void DeelTestCode(void)  
{
	int i;
	ULONG base, sector;
	SectorFile_t *dir;
	char *buff;

	base = GetFileSector("/tmp/test.sfl");
//	dir = LoadSectorFileDirectory(NULL, base, NULL);
	dir = LoadSectorFileDirectory("/tmp/test.sfl", 0, NULL);
	VSync(0);
	sector = GetSectorFileSector(dir, "test1.txt");
	VSync(0);
	printf("\nSector %X\n", sector);
	buff = LoadFileSectors(sector);
	DumpMemory(buff, 10, 1);
}                       

/*-------------------------------------------------------------
  DumpColorValues ~ 
-------------------------------------------------------------*/
void DumpColorValues(USHORT color)
{
	int red, green, blue;
	
	red = color & 0x1F;
	green = (color >> 5) & 0x1F;
	blue = (color >> 10) & 0x1F;
	
	printf("(%04X  %d %d %d)  ", color, red, green, blue);
}  /* End DumpColorValues() */


/*-------------------------------------------------------------
  InitDeelTest ~ 
-------------------------------------------------------------*/
void InitDeelTest(void)
{
//	DebugPrintf(0, "memorycardmimic %d\n", sizeof(struct memorycardmimic));
//	DebugPrintf(0, "MCteamstats %d\n", sizeof(struct MCteamstats));
	DebugPrintf(0, "Replay Mem: %d frame:%d\n",
		MAX_IRP_FRAMES * sizeof(struct frameIRPData),
		sizeof(struct frameIRPData) );
}  /* End InitDeelTest() */

/*-------------------------------------------------------------
  TestSimGame ~ 
-------------------------------------------------------------*/
TestSimGame()
{
	int i;
	ULONG vb1, vb2;
	
	GameTeamData[0].TeamNumber = 1;
	GameTeamData[1].TeamNumber = 2;
	GameOptions[GAME_OPTNS_QTR_LENGTH] = 3;  // 15 min
	SetHomeStadiumOptions();
	GameType = EXHIBITION_GAME;
	SetupDemoPlayerData();
	DebugPrintf(0, "Sim Season PSX \x14\n");
	vb1 = GetVBlankCount();
	SimEntireSeasonPSX();
	vb2 = GetVBlankCount();
	DebugPrintf(0, "\x14 Done: %d - %d = %d  %d sec\n",
		vb2, vb1, vb2 - vb1, (vb2-vb1)/VBlanksPerSec );
}                       

extern SVECTOR gScoreboardPos[22+1][2];

/*-------------------------------------------------------------
  AdjustScoreboardCamera ~ 
-------------------------------------------------------------*/
void AdjustScoreboardCamera(void)
{
	SVECTOR vec;
	int y, z1, z2, i;

	while (!(JpadData[0] & JPADcircle))
	{
		ReadPads();
		y = gScoreboardPos[gStadiumNum][0].vy; 
		z1 = gScoreboardPos[gStadiumNum][0].vz;
		z2 = gScoreboardPos[gStadiumNum][1].vz;
		setVector(&vec, 0,0,0);
		GetPadxyz(0, 0, 40, &vec);
		y -= vec.vy;
		z1 += vec.vx;
		z2 += vec.vz;
		gScoreboardPos[gStadiumNum][0].vy = y; 
		gScoreboardPos[gStadiumNum][1].vy = y; 
		gScoreboardPos[gStadiumNum][0].vz = z1;
		gScoreboardPos[gStadiumNum][1].vz = z2;
		Dprintf("%d,%d  %d,%d\n", y,z1,  y,z2);
		for (i = 0; i < 20; i++)
			VSync(0);
	}
}  /* End AdjustScoreboardCamera() */


/*-------------------------------------------------------------
  DrawDebugSprites ~ 
-------------------------------------------------------------*/
void DoDebugSprites(void)
{
#if 0
	int i;
	SVECTOR vec;
    SubTexture_t subtexDb; // debug
	PolySpritePtr sprite[4]; // debug
	
	
	Cmarker();  //debug
//	PopupDialogBox(50, 25, 200, 100, 4, 0x50, 0x00, 0x00);
//	InitSubTexture(&subtexDb, gStadTexture[9].texture, gStadTexture[9].clut,
//					 108, 212, 1, 1, 0,0);
//	InitSubTexture(&subtexDb, gStadTexture[8].texture, gStadTexture[9].clut,
//					 0, 0, 256, 256, 0,0);

//	for (i = 0; i < 1; i++)
//	{				 
//		sprite[i] = CreatePolySprite(256, 256);  //debug
//		MakePolySprite2d(sprite[i]);
//		SetPolySpriteSubTexture(&subtexDb, sprite[i]);
//		SetPolySpriteShade(0xFF, 0x20, 0xFF, 1, 0, sprite[i]);
//	}
//	MovePolySpriteTo(-200, -100, 1, sprite[0]);
	
//	TranslateAIVector(OFF_END_LINE, LOW_GOALPOST_Y, GOALPOST_Z, &vec);
//	MovePolySpriteTo(vec.vx, vec.vy, vec.vz, sprite[0]); // debug
//	TranslateAIVector(OFF_END_LINE, HIGH_GOALPOST_Y, GOALPOST_Z, &vec);
//	MovePolySpriteTo(vec.vx, vec.vy, vec.vz, sprite[1]); // debug
//	TranslateAIVector(OFF_END_LINE, LOW_GOALPOST_Y - GP_BAR_WIDTH, GOALPOST_Z, &vec);
//	MovePolySpriteTo(vec.vx, vec.vy, vec.vz, sprite[2]); // debug
//	TranslateAIVector(OFF_END_LINE, HIGH_GOALPOST_Y + GP_BAR_WIDTH, GOALPOST_Z, &vec);
//	MovePolySpriteTo(vec.vx, vec.vy, vec.vz, sprite[3]); // debug
#endif //0
}  /* End DrawDebugSprites() */





/*-------------------------------------------------------------
  DumpGamePlay ~
-------------------------------------------------------------*/
void DumpGamePlay(void)
{
#if PC_DEBUG
//#if 0	
	Time_t gameTime, playTime;
	char str[10];
	int Yards, togo;

	gameTime = VBlankToTime(GetVBlankTimer(GAME_TIMER_NUM));
	Yards = (StartBallX - DEF_GOAL_LINE) / YARD;
	togo = (FirstDownX - StartBallX) / YARD;
	sprintf(str, "%02d:%02d", gameTime.minutes, gameTime.seconds);
	DebugPrintf(0, "TEAM: %s, Q%d  Score:%d-%d  Down:%d and %d on %d  play:%d-%d\n",
			str, TheQuarter, GameTeamData[0].TotalScore,
			GameTeamData[1].TotalScore, TheDown, togo, Yards,
			GameTeamData[0].PlayNum, GameTeamData[1].PlayNum );
#endif // PC_DEBUG
}

#if PC_DEBUG
/*-------------------------------------------------------------
  DebugSelectButton ~
-------------------------------------------------------------*/
void DebugSelectButton(void)
{
	DumpAllocLoc();
	DumpCamera();
	DebugPrintf(0, "BallPos %d,%d,%d ", gBallxyz.vx, gBallxyz.vy, gBallxyz.vz);
	DebugPrintf(0, "BallDir %d\n", BallDirection);
	if (JpadData[0] & JPADLfront1)
	{
		DumpHeap();
		while(JpadData[0])
			ReadPads();
	}
	VSync(0);
}
#endif // PC_DEBUG

#if PC_DEBUG
/*-------------------------------------------------------------
  SetPads1on1Debug ~
-------------------------------------------------------------*/
void SetPads1on1Debug(void)
{
	int team, i;

	 Cmarker();
	for (team = 0; team < 2; team++)
	{
		for (i = 0; i < 4; i++)
		{
			GameTeamData[team].ControllerNum[i] = -1;
		}
	}
//	GameTeamData[0].TeamNumber = 12;	//Miami
	GameTeamData[0].TeamNumber = 9;	
//	GameTeamData[1].TeamNumber = 25;	// cowboys
	GameTeamData[1].TeamNumber = 20;
	GameTeamData[0].ControllerNum[0] = 0;
	GameTeamData[1].ControllerNum[0] = 1;
//	CaptainPad[0] = 0;
//	CaptainPad[1] = 1;
	GameOptions[GAME_OPTNS_FIELD_TYPE] = TURF_FIELD;
	GameOptions[GAME_OPTNS_WEATHER] = 0;
	GameOptions[GAME_OPTNS_DIFFICULTY] = 1;
	GameOptions[GAME_OPTNS_DELAY_OF_GAME] = OPTION_OFF;
	Team0EditStatus = 2;
	Team1EditStatus = 2;
	SetHomeStadiumOptions();
	SetupDemoPlayerData();
}
#endif  // PC_DEBUG

#if PC_DEBUG
/*-------------------------------------------------------------
  SetCpuVsCpuDeel ~ 
-------------------------------------------------------------*/
void SetCpuVsCpuDeel(void)
{
	SetPads1on1Debug();
	GameTeamData[0].ControllerNum[0] = -1;
	GameTeamData[1].ControllerNum[0] = -1;
//	CaptainPad[0] = -1;
//	CaptainPad[1] = -1;
//	GameOptions[GAME_OPTNS_QTR_LENGTH] = 2;  // 15 min
//	GameOptions[GAME_OPTNS_QTR_LENGTH] = 0;  // 2 min
	GameOptions[GAME_OPTNS_QTR_LENGTH] = 1;  // 5 min
//	GameOptions[GAME_OPTNS_QTR_LENGTH] = 3;  // Very short
	
	GameOptions[GAME_OPTNS_SCRIMMAGE_MARKER] = OPTION_ON;
	GameOptions[GAME_OPTNS_1STDOWN_MARKER] = OPTION_ON;
	GameOptions[GAME_OPTNS_REC_ICONS] = OPTION_ON;
	GameOptions[GAME_OPTNS_REC_ICONS_AWAY] = OPTION_ON;
}
#endif  // PC_DEBUG

#if PC_DEBUG
/*-------------------------------------------------------------
  DeelTestGames ~ 
-------------------------------------------------------------*/
void DeelTestGames(void)
{
	int working, when;
	
	SetCpuVsCpuDeel();
	
//	DebugSuperbowlFlag = TRUE;	// test SuperBowl
	
	working = True;
//	gGameCameraStyle = ISOMETRIC_LOW_CAMERA_STYLE;
//	gGameCameraStyle = SIDELINE_CAMERA_STYLE;
	while(working)
	{
		LoadOverlay(FBAI_OVERLAY);
	    if (DebugSuperbowlFlag )
	    	GameType = CHAMPIONSHIP_GAME;
		GameTeamData[0].TeamNumber = GetRandom(30);  // Home 
		Randomize();
		GameTeamData[1].TeamNumber = GetRandom(30);
		
		#ifdef FORCE_HOME_TEAM 		
		  GameTeamData[0].TeamNumber = FORCE_HOME_TEAM;  // Home
		#endif 
//		GameTeamData[0].TeamNumber = 19;
//		GameTeamData[1].TeamNumber = 17;
		
		when = GetRandom(6);
		when = min(when, 2);
		GameType = SEASON_GAME;
		PickWeather();
		GameType = EXHIBITION_GAME;
		SetHomeStadiumOptions();
		SetupDemoPlayerData();
		RunFootballGame();
//		ShowCredits(8 * 60);
		if (IsAnyPadButton(JPADselect))
			working = False;
	}
}
#endif  // PC_DEBUG



/*-------------------------------------------------------------
  CheckQuickDebugGames ~ 
-------------------------------------------------------------*/
void CheckQuickDebugGames(void)
{
	#if PC_DEBUG
	if (IsAnyPadButton(JPADtriangle) )
	{
		SetScreenMode(VMODE512);
		DebugColorBg(0x0, 0x40, 0xFF); 		
		SetPads1on1Debug();
		LoadOverlay(FBAI_OVERLAY);
		RunFootballGame();
	}
	if (IsAnyPadButton(JPADsquare) )
	{
		SetScreenMode(VMODE512);
		DebugColorBg(0x0, 0x40, 0xFF); 		
 		DeelTestGames();
	}
	if (IsAnyPadButton(JPADcircle) )
	{
		SetScreenMode(VMODE512);
		DebugColorBg(0x0, 0x40, 0xFF); 		
		TestPracticeMode();
	}
	#endif //PC_DEBUG
}  /* End DoQuickDebugGames() */

/*-------------------------------------------------------------
  PrintGamePointers ~ 
-------------------------------------------------------------*/
void PrintGamePointers(void)
{
	 DebugPrintf(0, "Anim %x %x  ", gAnimationsFile[0], gAnimationsFile[1]);
	 DebugPrintf(0, "Referee Anims:%X  ", gRefereeFilePtr);
	 DebugPrintf(0, "TIMs:%X  ", gStadTimPtr);
	 DebugPrintf(0, "Model:%X\n", gStadTmdPtr);
}  /* End PrintGamePointers() */

/*-------------------------------------------------------------
  TestPracticeMode ~ 
-------------------------------------------------------------*/
void TestPracticeMode(void)
{
#if 1
	GameTeamData[0].TeamNumber = 12;	//Miami
	GameTeamData[1].TeamNumber = GetRandom(30);
	GameTeamData[0].ControllerNum[0] = 0;
	GameTeamData[1].ControllerNum[0] = -1;
//	CaptainPad[0] = 0;
//	CaptainPad[1] = -1;
	GameOptions[GAME_OPTNS_FIELD_TYPE] = TURF_FIELD;
	GameOptions[GAME_OPTNS_WEATHER] = 0;
	GameOptions[GAME_OPTNS_DIFFICULTY] = 1;
    
    PracticeMode = 1;	//debug
    PracticeStartBallX = (80 * YARD);  //debug
	SetHomeStadiumOptions();
//	RunFootballGame();
#endif //0
}

/*~~-------------------------
---------------------------*/
static int DeelTestFrame(void)
{

}


#if PC_DEBUG
//#if 0
/*-------------------------------------------------------------
  TestTimers ~ 
-------------------------------------------------------------*/
void TestTimers(void)
{
	ULONG vb;
	int i;
	Time_t tm;

	SetVBlankTimer(0, 2*60*60*60);	
//	SetVBlankTimer(0, 1000);	
	SetVBlankTimer(2, 20*60*60);	
	StartVBlankTimer(0);
	StartVBlankTimer(2);
	
	while (1)
	{
		for (i = 0; i < 1; i++)
		{
			vb = GetVBlankTimer(0);
//			DebugPrintf(0, "%d  ", vb);
			tm = VBlankToTime(vb);
			Dprintf("%d   %d:%d:%d.%d\n", vb, tm.hours, tm.minutes, 
						tm.seconds, tm.hundreths);
		}
//		DebugPrintf(0, "\n");
		DelayVB(20);
	}
}

#endif  // PC_DEBUG


/********** Sprite Tests ;;***************/
#if TEST_PLAYERS
#define MAX_PLAYERS 22

typedef struct
{
	PolySpritePtr	sprite;
	short dir;
	short velocity;
	short frame;
	SVECTOR move;
} PlayerMove_t;

static PlayerMove_t gPlayerMove[NUM_PLAYER_SLOTS];

struct
{
	short x,y;
} MoveArray[16] =
	{
		0, 2,	/* Dir 0 */
		1, 2,	/* Dir 1 */
		2, 2,	/* Dir 2 */
		2, 1,	/* Dir 3 */
		2, 0,	/* Dir 4 */
		2, -1,	/* Dir 5 */
		2, -2,	/* Dir 6 */
		1, -2,	/* Dir 7 */
		0, -2,	/* Dir 8 */
		-1, -2,	/* Dir 9 */
		-2, -2,	/* Dir 10 */
		-2, -1,	/* Dir 11 */
		-2, 0,	/* Dir 12 */
		-2, 1,	/* Dir 13 */
		-2, 2,	/* Dir 14 */
		-1, 2	/* Dir 15 */
	};

#endif // TEST_PLAYERS
	
#define DEPTH 1000
//#define dbDefaultX 3500    
//#define dbDefaultZ -2200    
#define dbDefaultX -3500  
#define dbDefaultZ 6800  

//static int gProjection = DEPTH;
//static int hike = 0;

//PolySpritePtr gSprite;

//static ULONG *gFrame[10];
//static int texX, texY;

//static LineHandle_t dbLines[5];

/*-------------------------------------------------------------
  DebugStadiumPads ~ 
-------------------------------------------------------------*/
int DebugStadiumPads(int padnum)
{
#if 1
	register USHORT pad, ret;
	SVECTOR vec;
	static SVECTOR fieldVect = {0,0,0}, rotVect = {0,0,0};
//	static int startCnt = 5*60*20;
//	static int projection = 1000;

	pad = JpadData[padnum];

	ret = False;
	if ((pad & JPADRfront1) && (pad & JPADRfront2))
	{
		ret = True;
		setVector(&vec, 0,0,0);
//		GetPadxyz(1, 0, 8, &vec);
		GetPadxyz(0, 0, 40, &vec);
//		sprite->trans.vy += vec.vz/2;
		fieldVect.vx += vec.vx;
		fieldVect.vy += vec.vy;
		fieldVect.vz += vec.vz;
		TranslateFieldTo(&fieldVect);	

//		gCamera.zoom += vec.vz;
		gCamera.zoom  = 1000;

		setVector(&vec, 0,0,0);
		GetPadxyz(0, 1, 40, &vec);
		rotVect.vy += vec.vx;
		RotateFieldTo(&rotVect);
//		MoveCameraOffset(vec.vx,0, -vec.vx);
		SetCameraMovement(0,0,0);
		gCamera.refDiv = 0;
		if (pad & JPADselect)
		{
			setVector(&fieldVect, 0,0,0);
		}
	}
//	JpadData[padnum] = 0;
	return ret;
#endif	
}



/************** Test Players ************************/

#if TEST_PLAYERS
/*~~-------------------------
---------------------------*/
void TestSpritePads(PolySpritePtr sprite)
{
	USHORT pad, dir = 100;
	SVECTOR vec;
	static SVECTOR fieldVect = {0,0,0};
	static int startCnt = 5*60*20;
	static int projection = 1000;

	if (JpadDataBoth)
		startCnt = 5*60*20;
	if (startCnt-- < 2) 
	{
		startCnt = 5*60*20;
		hike = True;
	}
	
	setVector(&vec, 0,0,0);
	pad = JpadData[1];

//	GetPadxyz(1, 0, 8, &vec);
	GetPadxyz(0, 0, 20, &vec);
//	sprite->trans.vy += vec.vz/2;
	fieldVect.vx += vec.vx;
	fieldVect.vy += vec.vy;
	fieldVect.vz += vec.vz;
	TranslateFieldTo(&fieldVect);	

//	gCamera.zoom += vec.vz;
	gCamera.zoom  = 1000;

	if (pad & JPADcircle)	hike = True;
	if (pad & JPADsquare)	hike = False;

	pad = pad & (JPADLup | JPADLdown | JPADLleft | JPADLright);
	if (pad == JPADLup)							dir = 0;    /*##*/
	else if (pad == (JPADLup | JPADLright))		dir = 2;    /*##*/
	else if (pad == JPADLright)					dir = 4;    /*##*/
	else if (pad == (JPADLright | JPADLdown))	dir = 6;    /*##*/
	else if (pad == JPADLdown)					dir = 8;    /*##*/
	else if (pad == (JPADLdown | JPADLleft))	dir = 10;    /*##*/
	else if (pad == JPADLleft)					dir = 12;    /*##*/
	else if (pad == (JPADLleft | JPADLup))		dir = 14;    /*##*/
	if (pad)
	{
		gPlayerMove[0].dir = dir;
		gPlayerMove[0].velocity = 40;
	}
	else if (!hike)
	{
		gPlayerMove[0].velocity = 0;
		gPlayerMove[0].frame = 0;
	}
		
	GetPadxyz(0, 1, 25, &gCamera.offsetTarget);
}

/*-------------------------------------------------------------
  MovePlayers ~ 
-------------------------------------------------------------*/
static void MovePlayers(void)
{
	int i, max, dir, x, y, z;
	int xbounds = 2000, zbounds = 4000; 
	PolySpritePtr sprite;
	static int f2 = 2, frm = 0;
	RECT rect;
//	int camera = 1;
	SVECTOR move;

	if (!hike)
		max = 1;
	else
	{
		max = NUM_PLAYERS_ON_FIELD;
		i = rand();
		i %= max;
		dir = (rand() % 3) - 1;
		dir += gPlayerMove[i].dir;
		if (dir < 0)
			dir = 15;
		gPlayerMove[i].dir = dir % 16; 
//		gPlayerMove[i].velocity = (rand() % 10);
		gPlayerMove[i].velocity = 22 + (rand() % 2);
	
	}
	move.vy = 0;
	for(i = 0; i < max; i++)
	{
		move.vz = MoveArray[gPlayerMove[i].dir].y * gPlayerMove[i].velocity;    /*##*/
		move.vx = MoveArray[gPlayerMove[i].dir].x * gPlayerMove[i].velocity;    /*##*/
		sprite = gPlayerSprite[i].sprite;
/*		MovePolySprite(&gPlayerMove[i].move, sprite);    /*##*/
		MovePolySprite(&move, sprite);    /*##*/
		x = sprite->trans.vx;
		y = sprite->trans.vy;
		z = sprite->trans.vz;
		MovePlayerSpriteTo( x, y, z, i);
		if ( i > 0 || hike)
		{
			if (sprite->trans.vx > dbDefaultX +xbounds)
			{
				sprite->trans.vx = dbDefaultX + xbounds - 11;    /*##*/
				gPlayerMove[i].dir += 1;
			}
			if (sprite->trans.vx < dbDefaultX - xbounds)
			{
				sprite->trans.vx = dbDefaultX - xbounds + 11;    /*##*/
				gPlayerMove[i].dir += 1;
			}

			if (sprite->trans.vz > dbDefaultZ + zbounds)
			{
				sprite->trans.vz = dbDefaultZ + zbounds;    /*##*/
				gPlayerMove[i].dir += 1;
			}
			if (sprite->trans.vz < dbDefaultZ - zbounds)
			{
				sprite->trans.vz = dbDefaultZ - zbounds;    /*##*/
				gPlayerMove[i].dir += 1;
			}
		}
		gPlayerMove[i].dir %= 16;
	}
	sprite = gPlayerSprite[1].sprite;
//	view.vrx = sprite->trans.vx;
//	view.vry = -90;
//	view.vrz = sprite->trans.vz;
	SetCameraReference(sprite->trans.vx, -200, sprite->trans.vz);
	SetBallFrame(1);
//	if (view.vrx > dbDefaultX + xbounds - 250)
//		view.vrx = dbDefaultX + xbounds - 250;
//	if (view.vrx < dbDefaultX - xbounds + 250)
//		view.vrx = dbDefaultX - xbounds + 250;
	DoCamera();
	MoveBallSpriteTo(view.vrx, -200, view.vrz);
}

	


/*-------------------------------------------------------------
-------------------------------------------------------------*/
static char TestPlayersFrame(void)
{
	char working = True;
	static ULONG prevVB = 0, startVB = 0;
	ULONG vb;
		
	POLY_FT4 *spoly;
	static int dly = 0, cnt = 0;
	int i, dir, anim;

#if 0 // Demo	
	vb = GetVBlankCount();
	if (startVB == 0)
		startVB = vb;
	else if (vb - startVB > 60 * 60)
	{
		working = False;
		startVB = 0;
	}
#endif

//	if (cnt++ > 30)
//	{
//		DumpCamera();
//		cnt = 0;
//	}
	ReadPads();
	PollPC();
	TestSpritePads(gSprite);    /*##*/
	if (JpadData[0] & JPADstart)
		working = False;

	if (dly-- <= 0)
	{
		dly = 0;
		for (i = 0; i < NUM_PLAYER_SLOTS; i++)
		{
			anim = TEST_ANIM;
			dir = gPlayerMove[i].dir;
//			 dir = 0;  // debug
			gPlayerMove[i].frame++;
			if (i >= REF_SLOT_NUM)
			{
				anim = REF_RUNNING_NUM;
				gPlayerMove[i].frame = 1;
			}
			gPlayerMove[i].frame %= NumFramesPerPlayerGraphic[anim];
//			gPlayerMove[i].frame = 0;
			SetPlayerFrame(i, anim, dir, gPlayerMove[i].frame);    /*##*/
		}
/*		SetPlayerFrame(0, 0, gPlayerMove[i].dir, frm);    /*##*/
	}
//	UpdateBackground();    /*##*/
	DrawField();    /*##*/
//	while ( (GetVBlankCount() - prevVB) < 3)
//		;
	prevVB = GetVBlankCount();
	UpdateScoreboard();
	DrawSync(0);    /*##*/
	UpdatePlayerTextures();    /*##*/
	DrawSync(0);
	DrawPolySprites();    /*##*/
//	Draw3DLines();

	DbDumpFrameRate();
	MovePlayers();		/*##*/
	return working;
}

/*~~-------------------------
---------------------------*/
void TestPlayers(void)
{
	PolySpritePtr sprite;
	pict_t *pict;
	Ushort tpage, clut;
	int i, u,v, width, height, working, n;
	char *ptr;
	GsIMAGE tim;
	POLY_FT4 *poly;
	int xbounds = 2000, zbounds = 4000; 
	
	DebugPrintf(0, "\nTest Players\n");
	
	FreeFonts();
	SetVBlankTimer(GAME_TIMER_NUM, 15*60*60);
	StartVBlankTimer(GAME_TIMER_NUM);
	Randomize();
	initVRamHandling(); 
	SetPads1on1Debug();
	GameOptions[GAME_OPTNS_FIELD_TYPE] = TURF_FIELD;
	SetStadiumByOptions();
	BallFlags = SPIN_BALL_BFLAG;
//	SetGeomOffset(160,120);
	FreeBackgrounds();
	InitPolySprites();
	InitField();    /*##*/
	DrawSync(0);
//	InitTestLines();

	InitPlayerAnim(1);
	DrawSync(0);
//	ShowVideoBorder(True);
	DrawSync(0);
	 DumpAllocLoc();
	InitGameData();
	 DoAI();
	SetVBlankTimer(GAME_TIMER_NUM, 15*60*60);
	InitSidePeople(1);
	StartVBlankTimer(GAME_TIMER_NUM);
	for (i = 0; i < NUM_PLAYER_SLOTS; i++)
	{
		gPlayerMove[i].dir = i % 16;
		gPlayerMove[i].dir = 0;
		gPlayerMove[i].velocity = 0;
		gPlayerMove[i].frame = i % 12;
		MovePlayerSpriteTo(dbDefaultX + (i * 70), 0, 
					dbDefaultZ + (i * 70),	i);
		height = 5*12 + rand() % 24;
		width = rand() % 10;
//		ResizePlayer(i, width, height);
		if (i < 16)
			MovePlayerMarkerTo(dbDefaultX + (i * 70), -200,
							 dbDefaultZ + (i * 70), 1, i);
	}
	MovePlayerSpriteTo(dbDefaultX - 70, 0, 
					dbDefaultZ - 70 ,	0);
	gSprite = gPlayerSprite[0].sprite;
	ClearPlayerMarkers();

//	view.vrx = gSprite->trans.vx;	/* Ref point */
//	view.vry = -200;
//	view.vrz = gSprite->trans.vz;
		
	InitCamera();
	SetCameraOffset(0,-750, -2500);
	SetCameraMax(25000, 25000, 25000);
	SetCameraMin(-25000, -25000, -25000);
	SetCameraRefMax(dbDefaultX + xbounds - 250, 31000, 31000);
	SetCameraRefMin(dbDefaultX - xbounds + 250, -31000, -31000);
	SetCameraReference(sprite->trans.vx, -200, sprite->trans.vz);
	SetCameraMovement(100, 100, 100); 
	gCamera.refDiv = 5;
	DoCamera();

	Cmarker();
	SetBackgroundColor(0x20, 0x40, 0x80);
/*	TestSpritePads(gSprite);    /*##*/
//	ClearScreen();
	CalcFrameRate(1);
//	UpdatePlayerTextures();
	Cmarker();
	 DumpVramAlloc();
	DoFrameLoop(0, (FCNPTR)	TestPlayersFrame);
	Cmarker();
//	FreePlayerAnim();
	FreeArcadeTemp();
	FreeArcadePerm();
	Cmarker();
}
#else
void TestPlayers(void)
{
}

#endif //TEST_PLAYERS

/*-------------------------------------------------------------
  TestGame ~ 
-------------------------------------------------------------*/
void TestGame(void)
{

}

/*-------------------------------------------------------------
-------------------------------------------------------------*/
void TestAngle(void)
{
//	int i, x,y, angle, angle2, deg;
	
//	printf("\n");
//	for (i = 0; i < 36; i++)
//	{
//		deg = i * 10;
//		angle = DegreesToPsxAngle(deg);
//		x = (csin(angle) * 10) / 4096;
//		y = (ccos(angle) * 10) / 4096;
//		angle2 = ratan2(x, y);
//		if (angle2 < 0) 
//			angle2 += 4096;
		
//		printf("%dd. %d %d,%d  %d\n",deg, angle, x,y, angle2);
//	}
}


/*-------------------------------------------------------------
  DoArcadeDebugCmd ~ 
-------------------------------------------------------------*/
void DoArcadeDebugCommand(int cmd)
{
	char *ptr;
	switch(cmd)
	{
		case 30:
			DebugSuperbowlFlag = True;
			break;
		case 31:
			DebugPrintf(0, "Edited: %d %d\n", 
				GameTeamData[0].UseEditedPlays[0],
				GameTeamData[1].UseEditedPlays[0]);
			break;
		case 32:
			AdjustScoreboardCamera();
			break;
		case 33:
			ptr = LoadCDFile("/t.t");
			FreeMem(ptr);
			break;
	}
}  /* End DoArcadeDebugCmd() */

/*~~-------------------------
---------------------------*/
void DoDeelDebug(void)
{
#if PC_DEBUG
	int working = True;
	char cmd;

	DebugPrintf(0, " Deel Debug ----\n");
	while (working)
	{
		cmd = InputDebugChar();
		switch (cmd)
		{
			case 'A':
				DeelTestCode();
				break;
			case 'B':
				TestTimers();
				break;
			case 'C':
			
				break;
			case 'T':
				DeelTestCode();
				break;
			case 'X':
			case 'Q':
			case 'Z':
			case 27:
				working = False;
				break;
		}
	}
#endif  //  PC_DEBUG	
}

