/*************************************************************************
 * DIALOG.H - Contains all structures, and externs for dialog.c
 *
 * Written by Mike Heilemann
 *************************************************************************/

// DIALOG BOX DEFINES & EXTERNS
#define MAX_DIALOGS 6
#define MAX_DIALOG_STRINGS 5
#define MAX_TRANS_LAYERS 2

typedef struct {
	POLY_F4 			poly[MAX_TRANS_LAYERS*5];
	unsigned short depth;
	unsigned short layers;
	char r,
		  g,
		  b;
	char shadow;
	short string[MAX_DIALOG_STRINGS];
	short used;
} dialog_t;

extern dialog_t dialog[MAX_DIALOGS];
extern int 		 num_dialogs;


int PopupDialogBox(int x, int y, int w, int h, int shadow, int r, int g, int b);
void DisplayDialogBox(void);
void ChangeDialogDepth(int num, unsigned short depth);
void FreeDialogBox(int box_handle);
void FreeAllDialogBoxes(void);
void MoveDialog(int num, int x, int y);
void ResizeDialog(int num, int w, int h);
void ChangeDialogColor(int num, int r, int g, int b);
int AddDialogTextCentered(int num, int x, int y, char *text, char color, char *spacing_table, char flags);
int AddDialogText(int num, int x, int y, char *text, char color, char *spacing_table, char flags);
int DialogBoxMessage(int x, int y, char *text);
