/***********************************************************************
*dpcshl.c                                                              *
*Shell- play selection function                                        *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
*Started on 3/14/1995                                                  *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
* MRH - 60% Rewrite                                                    *
************************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbequ.h"
#include "fbram.h"
#include "fbplays.h"
#include "shell.h"
#include "dpcshl.h"
#include "fbforms.h"
#include "tmcolor.h"
#include "menu.h"

#include "pledshl.h"
#include "arrows.h"
#include "editplay.h"
#include "editdat.h"

#include "editdat.c"	// Data file

/*defines used in the play call shell tom!! copied from shell.h */
#define SCROLL_PLAYS 3    /*scroll plays 3 or 1 at a time*/
#define TIMEWAIT     40   /*how long to wait when user stops scrolling before hitting CD*/
#define WAITTIME 		120
#define HOMETEAM     -1
#define AWAYTEAM      1
#define CPUTEAM       0


PLAYEDIT pEDIT_ThePLAY;
PLAYEDIT pEDIT_PLAYS[(48)];
//MultiFile_t *Arrows_MFile;		// tom

void BuildPlayBitmap(Sint16 template, Sint16 polynum, int playnum);
void CPUDraw(Uint16 player, Sint16 template_index, Sint16 polynum, Sint16 w, Sint16 h, Sint16 posx, Sint16 posy, char *string, Uint16 flip, char colflag);
void LoadARROW(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr);
void LoadPLAYER(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr);

extern char *strlwr(char *s);

/* external vars used by the shell */
extern struct play ThePlays[];
extern char in_arcade;
extern  char *TemplateBuff;

// EXTERNS for TEAM NAME graphics
extern char *DpcName[2];
extern char	*DpcNameClut[2];

/* pointers to the file sectors used in the shell */
static ULONG Shell_File_Sectors[2][3][2]; /* [whichteam][playtype][offense/defense] */
static ULONG DPC_File_Sector; /* Points to the main DPC file */
static ULONG Arrows_File_Sector; /* Points to the arrows file */
static ULONG Fields_File_Sector[20]; /* Points to the field file */

unsigned long *Arrows_MFile;
unsigned long *Fields_MFile[2];
Sint32 FieldNum[2];

/*used by the pad*/

int DumbFuck[9];				// 8 pads plus one to cover for a flaw in Nick's code
int *PadPressed = &DumbFuck[1]; // Because Nick never allowed for the -1 condition in pad no. in his code
int CaptainPad[2] = {-1, -1}; 	//which two pads are captain pads // OK Nick I give up .. which two ?

/*Ghost Player variables*/

int GhostEndTime[2];	  /*when did the ghost player start*/
int GhostSelected[2];  /*did the computer controled side selected play*/
int GhostPlay[2];      /**/
int GhostPlayGroup[2]; /*Which play on the screen ghost select- 0, 3, 6, 9, etc*/
int GhostFormation[2]; /*which formation button ghost select*/
int GhostMirrored[2];  /*has ghost player already send flip keystroke if one is needed?*/
void InitGhostPlayer();

/*external variables*/
//extern int PlayCallDone[2];
//extern int CurrFormation[2], CurrPlay[2];
//extern int Mirrored;
//

//////////////////////////////////////////////
// stuff tom added from shell.h
INT PadControl[8];		// (is it used anywhere???????)
ULONG *Team_MFile[2]; // points to the Formations mfiles		//tom added this

//////////////////////////////////////////////

/* Used by the AI */
int PlayCallDone[2];                      /* team 0 or 1 done? */
int PlayCallAllDone = FALSE;              /* both teams done? */

/* Shell global Variables */
static int DefPlayStr[3], OffPlayStr[3];  /* points to play name strings */
static int DefFormStr[7], OffFormStr[7];  /* points to the formation names */
static int FlipStr;                       /* points to the 'FLIPED' string */
static int OffTeamNameStr,DefTeamNameStr; /* points to the team name strings */
static int OffTeamNameSize,DefTeamNameSize; /* points to the team name strings */
static int MaxFormations[2];              /* 5 in no edited formations, 6 if edited */
static int TimerStr;                      /* points to DPC timer string */
static int GameTimeStr;					  /* points to game timer string */
static ULONG GameTime;					  /* game time */
static Time_t tm;						  	  /* time structure */
static char DisplayStr[255];			  /* Generic display string buffer */
static int PreviousPlayType = -1;	  /* must keep track of the plays,-1 if no previous play */

static int MaxPlayers, WhichPad;      /* Maximum Players, 1 or 2. Which Pad, 0 or 1 */
//static char TeamMFFileName[MAXPATH];  /* filename buffer */
static int LastButtonPressed[2];		  /* keeps track of the last button pressed for each pad */

static int LastOffDefStatus[2]={-1,-1};   /*keeps track of last offensive/defensive status*/
//static int LastOffDefStatus[2]={0,1};   /*keeps track of last offensive/defensive status*/

static int DPC_Init = FALSE;

int Mirrored;                      /* status of the formations - mirrored or not */
int CurrFormation[2], CurrPlay[2]; /* slider position, CurrFormation changes by 1, CurrPlay by 3 */
/* Previous slider position, CurrFormation changes by 1, CurrPlay by 3 */
int PrevFormation[2] = {0,0};
int PrevPlay[2] = {0,0};

Sint32	PlayBook = FALSE;
Sint32	ColorCycle = 0;
char pcspacing[2];


struct FormGridStruct FormGrid[2][7]; /*formations grid [which team][which formation]*/

char *RunPassNames[2][5] = {          /*run-pass button names*/
								   "RUN INSIDE",
								   "RUN OUT",
								   "PASS SHORT",
								   "PASS MED",
								   "PASS LONG",

								   "BLITZ",
								   "GENERAL",
								   "STOP RUN",
								   "STOP PASS",
								   "STOP LONG"
								   };

//char *KickOffFormationName[2] = {"KICK OFF", "KICK RET"};
char *OffKickOffFormationName = {"KICK RET"};
char *DefKickOffFormationName = {"KICK OFF"};

char *ExtraPtFormationName = {"SPECIAL"};
char *NullFormationName = {""};

short MakeTransRGB(short slot);

//Sint32 PlayBookCheck(Sint32 pad, Sint32 team);
void ToggleOffDef(void);
Sint32 GetFieldNum(Sint32 team);
void CyclePlaysColor(void);

unsigned long	Plays_Clut[8] = {

	0X6b200000,0X3ce051c0,0X10002440,0X4e736b20,
	0X653c031d,0X019e07c7,0X08ef0801,0X1edf1599,

//	0X031d8000,0X6b20031d,0X07c76b20,0X019e07c7,
//	0X653c019e,0X1edf653c,0X08ef1599,0X7fff0800,
};


/*-------------------------------------------------------------
  InitGamePlayCall ~
-------------------------------------------------------------*/
void InitGamePlayCall(void)
{
	PreviousPlayType = -1;	  ///* must keep track of the plays,-1 if no previous play */
	LastOffDefStatus[0] = -1;   //*keeps track of last offensive/defensive status*/
	LastOffDefStatus[1] = -1;   //*keeps track of last offensive/defensive status*/
	PrevFormation[0] =
			PrevFormation[1] =
			PrevPlay[0] =
			PrevPlay[1] = 0;
}  /* End InitGamePlayCall() */


/*----------------------------------------------------------------
	if Run/Pass Method, CurrPlay may be 15 in one form, 9 in another
	if we're on 15 and move up to 9, we need to adjust current play


	Also if switch between Run/Pass to formation during game


-------------------------------------------------------------------*/

void AdjustCurrPlayToMatchFormGrid(int team)
{
int temp;

	temp = FormGrid[team][CurrFormation[team]].PlaysMax;
	if(CurrPlay[team] >= temp)
	{
		 DebugPrintf(0, "Adjusting CurrPlay %d\n", temp);
		if( (CurrPlay[team] = temp -3) < ZERO)
		{
			 Cerror();
			CurrPlay[team] = ZERO;	// big error
		}
	}

}


/*****************************************************************
Does the DPC loop events
Returns:FALSE if DPC not done
		TRUE if DPC done
******************************************************************/
int DPC_Frame()
{
	ULONG PCallTimer;

	/*update game clock*/

//	if(!PlayBook)
//	{
		GameTime = GetVBlankTimer(GAME_TIMER_NUM);
		tm = VBlankToTime(GameTime);
		sprintf(DisplayStr, "%02d:%02d", tm.minutes, tm.seconds);
		ChangeString(GameTimeStr, DisplayStr, FONT0);
//	}

	/*Poll the pad*/
	PollPads(PadPressed, MaxPlayers);

	CyclePlaysColor();

	/*0 for the home team, 1 for the away team*/
	for(WhichPad = 0; WhichPad < MaxPlayers; WhichPad++)
	{
	  /*call ghost player if side is CPU controled*/
		if(CaptainPad[WhichPad] == -1) /*if the side serviced is computer controled*/
		{
			if(GhostPlayer(WhichPad) == TRUE) /*if ghost player fakes selection of play*/
			{
				if(PlayCallDone[WhichPad] == FALSE)
				{
					PlayCallDone[WhichPad] = TRUE;	  /*set the PlayCallDone flag*/
					VanishPlays(WhichPad);            /*hide the plays*/
//					if(GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE || PlayType == KICKOFF_PLAY) /*freeze clocks if offense*/
					if( (GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE
						  && PlayType != KICKOFF_PLAY) /*freeze clocks if offense*/

					  ||  (GameTeamData[WhichPad].OffDefFlag == ON_DEFENSE
						  && PlayType == KICKOFF_PLAY) /*freeze clocks if offense*/
					  )

					{
						FreezeAllClocks();
					}
				}
			}
		}

		switch(PadPressed[CaptainPad[WhichPad]])
		{
			case PAD_UP:
			case PAD_DOWN:
				  /*allow up/down movements only not PlayType == KICKOFF_PLAY
					  and not PlayType == EX_PT1_PLAY*/
					if(PlayType != KICKOFF_PLAY && PlayType != EX_PT1_PLAY)
					{
						if(PlayCallDone[WhichPad] == FALSE)
						{
							PlayEffect(CURSOR_SFX);
							DisplayNewFormation(PadPressed[CaptainPad[WhichPad]], WhichPad);
						}
					}
					break;

			case PAD_LEFT:
			case PAD_RIGHT:
		  /*allow left/right movements only not PlayType == KICKOFF_PLAY
		  and not PlayType == EX_PT1_PLAY*/
				if(PlayType != KICKOFF_PLAY && PlayType != EX_PT1_PLAY)
				{
					if(PlayCallDone[WhichPad] == FALSE)
					{
						PlayEffect(CURSOR_SFX);
						DisplayNewPlay(PadPressed[CaptainPad[WhichPad]], WhichPad);
					}
				}
				break;
		}

	  /*handle the pad button pressed*/


//		if(!PlayBook)
//		{
			switch(PadPressed[CaptainPad[WhichPad]])
			{

		  /*display the new formation if up/down*/
	//			case PAD_UP:
	//			case PAD_DOWN:
			  /*allow up/down movements only not PlayType == KICKOFF_PLAY
			  and not PlayType == EX_PT1_PLAY*/
	//				if(!(PlayType == KICKOFF_PLAY) && !(PlayType == EX_PT1_PLAY))
	//				{
	//					if(!(PlayCallDone[WhichPad] == TRUE))
	//					{
	//						PlayEffect(CURSOR_SFX);
	//						DisplayNewFormation(PadPressed[WhichPad], WhichPad);
	//					}
	//				}
	//				break;

		  /*display the new three plays if left/right*/
	//			case PAD_LEFT:
	//			case PAD_RIGHT:
			  /*allow left/right movements only not PlayType == KICKOFF_PLAY
			  and not PlayType == EX_PT1_PLAY*/
	//				if(!(PlayType == KICKOFF_PLAY) && !(PlayType == EX_PT1_PLAY))
	//				{
	//					if(!(PlayCallDone[WhichPad] == TRUE))
	//					{
	//						PlayEffect(CURSOR_SFX);
	//						DisplayNewPlay(PadPressed[WhichPad], WhichPad);
	//					}
	//				}
	//				break;

		  /*select the play*/
				case SQUARE:
				case CIRCLE:
				case TRIANGLE:
					if((LastButtonPressed[WhichPad] != PadPressed[CaptainPad[WhichPad]]) &&
						PlayCallDone[WhichPad] == FALSE)
					{
						PlayEffect(SELECT_SFX);
						SelectPlay(WhichPad, PadPressed[CaptainPad[WhichPad]]);
					}
					break;

				// X BUTTON TO TIME DOWN PLAY & GAME CLOCKS
				case CROSS:	// Only offensive team can do it...
					if ((GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE && PlayType != KICKOFF_PLAY)
						  || (GameTeamData[WhichPad].OffDefFlag == ON_DEFENSE && PlayType == KICKOFF_PLAY))
					{
						AutoCountDownSecond(8);

//						JpadVAL[CaptainPad[WhichPad]] &= !JPADRdown;	// make it a typeomatic key
						JpadData[CaptainPad[WhichPad]] &= !JPADRdown;	//
					}
					break;

		  /*mirror the play*/
				case JPADRfront1:
				case JPADLfront1:
					if((LastButtonPressed[WhichPad] != PadPressed[CaptainPad[WhichPad]]) &&
						!(PlayCallDone[WhichPad]==TRUE))
					{
						if(GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE)
						{
				  /*only offense mirror button works*/
							if(((PlayType != KICKOFF_PLAY) && (PlayType != EX_PT1_PLAY)) &&
							   (CurrFormation[WhichPad] != 5))
							{
								PlayEffect(SELECT_SFX);
								MirrorPlay(WhichPad);
							}
						}
					}
					break;
			}/*switch*/


		  // MRH - Display the timer (Removed funky function & put relevant stuff inline)
			PCallTimer = GetVBlankTimer(DPC_TIMER_NUM);
			tm = VBlankToTime(PCallTimer);
			sprintf(DisplayStr, "  :%02d", tm.seconds);
			ChangeString(TimerStr, DisplayStr, FONT2);


		  /*check if both players are done*/
			if(MaxPlayers == 1)
			{
				if(PlayCallDone[0] == TRUE && TimeDownPlaycall())
					PlayCallAllDone = TRUE;
			}/*if*/
			else if(MaxPlayers > 1)
			{
				if(PlayCallDone[0] == TRUE && PlayCallDone[1] == TRUE && TimeDownPlaycall())
					PlayCallAllDone = TRUE;
			}/*if*/

//		}	// If PlayBook
//		else
//		{
//			switch(PadPressed[CaptainPad[WhichPad]])
//			{
//				case SQUARE:
//				case CIRCLE:
//				case TRIANGLE:
//								if(LastButtonPressed[WhichPad] != PadPressed[CaptainPad[WhichPad]])
//								{
//									PlayEffect(SELECT_SFX);
//									PlayCallAllDone = TRUE;
//								}
//								break;
//
//			}
//		}

	  /*register the last button pressed*/
		LastButtonPressed[WhichPad] = PadPressed[CaptainPad[WhichPad]];
	}/*for*/

//	if(PlayCallAllDone && !PlayBook)
	if(PlayCallAllDone)
	{	// let me out of this jungle - MJK  11/7/96
		PrevFormation[0] = CurrFormation[0]; // loop or in-line - you decide
		PrevFormation[1] = CurrFormation[1];
		PrevPlay[0] = CurrPlay[0];
		PrevPlay[1] = CurrPlay[1];
		PreviousPlayType = PlayType;

	}

	return PlayCallAllDone;
}


void ClearFormationNames(void)	// ever here of SUBROUTINES, Nick?!?
{
int j;

	for(j=0; j<7; j++)
	{
		FormGrid[0][j].FormationName =
			FormGrid[1][j].FormationName = NullFormationName;
	}
}


/*****************************************************************

				Inits the formation grid

	FormGridStruct FormGrid[2][7] contains the list of all plays to
	be displayed. It is refered FormGrid[Home 0/Away 1][Y slider position]
	FormGrid[][].Plays[Which Play]. In this function we build this data
	structure.

******************************************************************/

void Init_Formation_Grid()
{
register int OffDefFlag;	// local var saves code Nick, (11/7/96 MJK)

	WORD *formptr;

register int i, j;
	int k, l,offteamslot;
	int PlayNum;
	int TransferPtr;
	int InterfaceType[2];
	struct play *PlayPtr;
	int OffCompare[5]={
					RUN_INSIDE,
					RUN_OUTSIDE,
					PASS_SHORT,
					PASS_MEDIUM,
					PASS_DEEP
					};

	int DefCompare[5]={
					BLITZ,
					ALL_PURPOSE,
					STOP_RUN,
					STOP_PASS_SHORT,
					STOP_PASS_DEEP
					};

  /*save GameOptions[] into array for easy indexing*/
	InterfaceType[0] = GameOptions[GAME_OPTNS_PLAY_CALL_METHOD];
	InterfaceType[1] = GameOptions[GAME_OPTNS_PLAY_CALL_METHOD_AWAY];

  /*init all the playmax values to 0 and Plays to -1*/
	for(i=0; i<2; i++)
	{
		for(j=0; j<7; j++)
		{
			FormGrid[i][j].PlaysMax = 0;
			for(k=0; k < 30; k++)
			{
				FormGrid[i][j].Plays[k] = -1;
			}
		}
	}

	for(i=0; i<2; i++) /*set the grid for run/pass*/
	{
		OffDefFlag = GameTeamData[i].OffDefFlag; // local var saves code Nick, (11/7/96 MJK)

		if(InterfaceType[i] != 0)
		{
	  /*fill and rearrange the plays from GameTeamData[].STD.Formations to
		FormGrid[][].Plays[]*/
			for(j=0; j<7; j++)
			{
		/*set the 'formation' data. I call a row of plays 'formation' */
				if(j < 5)/*set the 'formation' name to appropriate run/pass name*/
				{
					FormGrid[i][j].FormationNumber = -2;
					FormGrid[i][j].FormationName = RunPassNames[OffDefFlag][j];
				}
				else /*set the formation name to a regular formation name*/
				{
					FormGrid[i][j].FormationNumber =
							 GameTeamData[i].STD.Formations[OffDefFlag][j];
					FormGrid[i][j].FormationName =
							 FormationNames[FormGrid[i][j].FormationNumber];
				}
				FormGrid[i][j].FormationType   = RUNPASS_MODE;

		/*fill the plays array with plays*/
				if(j < 5)  /*copy and rearange pass/run plays*/
				{
					formptr = GetPlaysPerForm(GameTeamData[i].STD.Formations[OffDefFlag][j]);
					while((PlayNum = *(formptr++)) >= 0)
					{
			/*get the play number and the actual play structure pointer*/
						PlayPtr = &ThePlays[PlayNum];

			/*put the play number in the right slot within the grid*/
						if(OffDefFlag == ON_OFFENSE)
						{
							for(l = 0; l < 5; l++)
							{
								if(PlayPtr->PlayTypeDesignator == OffCompare[l])
								{
									if(FormGrid[i][l].PlaysMax <= 29)
									{
										FormGrid[i][l].Plays[FormGrid[i][l].PlaysMax++] = PlayNum;
									}
									else
										DebugPrintf(0, "Exceded 30 plays limit for 'formation' %d\n", l);
								}
							}/*for*/
						}
						else
						{
							for(l = 0; l < 5; l++)
							{
								if(PlayPtr->PlayTypeDesignator & DefCompare[l])
								{
									if(FormGrid[i][l].PlaysMax <= 29)
									{
										FormGrid[i][l].Plays[FormGrid[i][l].PlaysMax++] = PlayNum;
									}
									else
										DebugPrintf(0, "Exceded 30 plays limit for 'formation' %d\n", l);
								}
							}
						}

					}/*for*/
				}
				else /*do a straight copy of special teams and edited*/
				{
			  /*fill the plays array with plays*/

					k=0;

					formptr = GetPlaysPerForm(FormGrid[i][j].FormationNumber);

					while((PlayNum = *(formptr+k)) >= 0)
					{
						FormGrid[i][j].Plays[k] = PlayNum;
						FormGrid[i][j].PlaysMax++;
						k++;
					}/*for*/
				}
			}/*for*/

	  /*make sure that the number of plays is evenly divisible by 3*/
			for(j=0; j<5; j++)
			{
				TransferPtr = 0;
				while((FormGrid[i][j].PlaysMax % 3) !=0 )
				{
					FormGrid[i][j].Plays[FormGrid[i][j].PlaysMax++] = FormGrid[i][j].Plays[TransferPtr++];
				}
			}
		}
		else /*set the grid for formations*/
		{
	  /*do a straight copy from GameTeamData[].STD.Formations to
		FormGrid[][].Plays[]*/
			for(j=0; j<7; j++)
			{
		/*Save the formation name and number*/
				FormGrid[i][j].FormationNumber = GameTeamData[i].STD.Formations[OffDefFlag][j];
				FormGrid[i][j].FormationName   = FormationNames[FormGrid[i][j].FormationNumber];
				FormGrid[i][j].FormationType   = FORMATION_MODE;

		/*copy the play numbers to the play array*/

				k = 0;

				formptr = GetPlaysPerForm(FormGrid[i][j].FormationNumber);

				while((PlayNum = *(formptr+k)) >= 0)
				{
					FormGrid[i][j].Plays[k] = PlayNum;
					FormGrid[i][j].PlaysMax++;
					k++;
				}/*for*/
			}/*for*/
		}/*if*/
	}/*for*/

	offteamslot = OFFENSIVE_SLOT_NUM_MACRO;	//macro in fbequ.h

	FormGrid[offteamslot][5].PlaysMax = 9;	// off. has 9 special teams plays
	FormGrid[offteamslot^1][5].PlaysMax = 6; // def. has 6 special teams plays

  /*change the PlaysMax for special plays
	for(i=0; i<2; i++)
	{
		if(GameTeamData[i].OffDefFlag == ON_OFFENSE)
			FormGrid[i][5].PlaysMax = 9;
		else
			FormGrid[i][5].PlaysMax = 6;
	}
		*/
  /*if kickoff play type, null out the formation names and name
	the first one 'kickoff'*/
	if(PlayType == KICKOFF_PLAY)
	{
		ClearFormationNames();
		FormGrid[offteamslot][0].FormationName = OffKickOffFormationName;
		FormGrid[offteamslot^1][0].FormationName = DefKickOffFormationName;



/*----------	Nick must of thought he got paid by the byte
		for(j=0; j<7; j++)
		{
			FormGrid[0][j].FormationName =
				FormGrid[1][j].FormationName = NullFormationName;
		}

		for(i=0; i<2; i++)
		{
			if(GameTeamData[i].OffDefFlag == ON_OFFENSE)
			{
				FormGrid[0][0].FormationName = KickOffFormationName[0];
				FormGrid[1][0].FormationName = KickOffFormationName[1];
			}
			else
			{
				FormGrid[0][0].FormationName = KickOffFormationName[1];
				FormGrid[1][0].FormationName = KickOffFormationName[0];
			}
		}      -----------------------*/
	}
	else if(PlayType == EX_PT1_PLAY)
  /*if extra point type, null out the formation names and name
	the first one 'SPECIAL'*/
	{
		ClearFormationNames();
/*		for(j=0; j<7; j++)
		{
			FormGrid[0][j].FormationName =
				FormGrid[1][j].FormationName = NullFormationName;
		}  */

		FormGrid[0][0].FormationName =
			FormGrid[1][0].FormationName = ExtraPtFormationName;
	}
}

/*****************************************************************

					Init Da Play Call Screen

	Inits the DPC variables and paint the screen
	ForceInit is false is we want to preserve the flip and PlayCallDone
	status of one of theside. This would take place if one side chooses
	the play and other choses instant replay.

******************************************************************/

void Init_DPC_Data(int ForceInit)
{
int i;
int OffDefFlag;	// local var saves code Nick, (11/7/96 MJK)
int maxforms;

	CaptainPad[0] = GameTeamData[0].ControllerNum[0];
	CaptainPad[1] = GameTeamData[1].ControllerNum[0];

  /*init the formations grid - put plays in Formation or RUN/PASS order*/
	Init_Formation_Grid();

  /*Init variables*/
	Mirrored  =  PlayCallAllDone   = FALSE;
	MaxPlayers    = 2;

	for(i=0; i<2; i++)
	{

		OffDefFlag = GameTeamData[i].OffDefFlag;	// use local
	/*set PlayCallDone Flag*/
		if(ForceInit == TRUE)
		{	/*  is side done selecting play flag??  */

			PlayCallDone[i] = GameTeamData[i].PlayFlipped = FALSE;
		}

	/*** following new code 11/8/96 - mjk   -------------*/
		PadPressed[i] =  0;


	/*init hor/ver to 0 only if no play/formation selected yet*/
	/*  above not right - if "new" PC, use last PC variables	*/
		if(GameTeamData[i].PlayNum == -1 || GameTeamData[i].FormationNumber == -1)
		{
			CurrFormation[i] = PrevFormation[i];	// was = 0
			CurrPlay[i]      = PrevPlay[i];         // was = 0
//			CurrPlay[i]      = (PrevPlay[i] / 3) * 3; // must be mult of 3 for ghost
			 DebugPrintf(0, "CurrPlay[%d] = %d\n", i, CurrPlay[i]);
		}

	/*Position the sliders as needed*/

	/*if the status of the team changed, go to formation 0, play 0*/
		if(LastOffDefStatus[i] == -1)
		{
	  /*if the flag is not inited, init it*/
			LastOffDefStatus[i] = OffDefFlag;
		}
		else
		{  /*  else see if the status has changed  */
			if(LastOffDefStatus[i] != OffDefFlag)
	  /*if the status has changed, reset CurrPlay[i], CurrFormation[i]*/
			{
				LastOffDefStatus[i] = OffDefFlag;
				CurrPlay[i] = CurrFormation[i] = 0;
			}
		}

	/*if previous play was a KICKOFF_PLAY or EX_PT1_PLAY, put cursor at 0*/
		if(PreviousPlayType == KICKOFF_PLAY || PreviousPlayType == EX_PT1_PLAY)
//		if(PreviousPlayType >= EX_PT1_PLAY)	// Okay for any EX pt or KO - mjk 11/7/96
		{
			CurrFormation[i] = CurrPlay[i] = 0;
		}

	/*init hor=5 ver=0 if kickoff*/
		if(PlayType == KICKOFF_PLAY)
		{
			CurrFormation[i] = 5;
			CurrPlay[i]      = 0;
		}
		else if(PlayType == EX_PT1_PLAY)
		{
	  /*init hor=5 ver=0 if extra play. we can make in anything we want*/
			CurrFormation[i] = 5;	// SPECIAL TEAMS
			if(OffDefFlag == ON_DEFENSE)
			{
				CurrPlay[i] = 3;
			}
			else
			{
				CurrPlay[i] = 0;
			}
		}
		else if(TheDown == 4)	/*  if fourth down, go to punt/return  */
		{

			CurrFormation[i] = 5;	// SPECIAL TEAMS - off. & def.
			CurrPlay[i] = 0;		//assume

			if(StartBallX < OFF_GOAL_LINE-32*YARD)
			{ //  punt
				if(OffDefFlag == ON_OFFENSE)
				{
					CurrPlay[i] = 3;	// set up for punt
				}	// def--> cp =0 (punt return)
			}
			else	//Field goal
			{
				if(OffDefFlag == ON_DEFENSE)
				{
					CurrPlay[i] = 3;	//11 man rush
				}	// off--> cp =0 (FG)
			}
		}

	/*Check for edited formations*/
		if (PlayType == EX_PT2_PLAY)
		{
			maxforms = 4;	// MRH - Don't show special on 2 point conversion
		}
		else if(GameTeamData[i].UseEditedPlays[OffDefFlag] == 0)
		{
			maxforms = 5;
		}
		else	// if edited (or Easter egg_ plays)
		{
			maxforms = 6;
		}
		if(CurrFormation[i] > maxforms)	// just to be sure (ex 2pt ??)
			CurrFormation[i]= maxforms;

		MaxFormations[i] = maxforms;
		LastOffDefStatus[i] = OffDefFlag; // save whether off or def

		AdjustCurrPlayToMatchFormGrid(i);	// if switched from Run/Pass to From based

	/*** end new code 11/8/96 - mjk   -------------*/

	}/*for*/

// MRH - Practice mode set defense to done
	if (PracticeMode)		// AI sets up defensive play in practice
		PlayCallDone[DefensiveSlotNum] = TRUE;


	InitFonts();		  /*Load Fonts*/

	Register_Font_Cluts();	  /*register font colors*/

  /*load fonts from the multifile*/
	LoadFontPtr((char *)GetMultiFilePtr(Shell_MFile, "fontdpc3.tim"), 3);
	LoadFontPtr((char *)GetMultiFilePtr(Shell_MFile, "fontdpc6.tim"), 5);
	LoadFontPtr((char *)GetMultiFilePtr(Shell_MFile, "fontdpc7.tim"), 3);
//	LoadFont("fontdpc9.tim", 3);
//	LoadFont("fontdpc6.tim", 5);

  /*Init the ghost player  (really, Nick?!?)  */
	InitGhostPlayer();

	Paint_DPC_Screen();

  /*init the timer in seconds*/
	if(GameTeamData[0].PlayNum == -1 && GameTeamData[1].PlayNum == -1)
		StartPlayClock();

  /*Specif that the stuff was initilzed for C.Deel's part*/
	DPC_Init = TRUE;


}

/*****************************************************************

		Get and store DPC multifile sectors.
	Background load uses not filenames, but file sectors.
	Call is one before calling int Init_DPC_MFiles(int WaitForLoad)

******************************************************************/
int Init_DPC_Sectors()
{
	char TeamMFFileName[MAXPATH];
	int i;

	for(i = 0; i < 2; i++)
	{
	/*get kickoff plays sectors*/
		sprintf(TeamMFFileName, "/shells/dpc/defkick.mfl");
		Shell_File_Sectors[i][KICK_OFF_PLAY][DEFENSIVE_PLAYS] = GetFileSector(TeamMFFileName);
		DebugPrintf(0,"Team %d Setor for %s = %d\n", i, TeamMFFileName, Shell_File_Sectors[i][KICK_OFF_PLAY][DEFENSIVE_PLAYS]);
		sprintf(TeamMFFileName, "/shells/dpc/offkick.mfl");
		Shell_File_Sectors[i][KICK_OFF_PLAY][OFFENSIVE_PLAYS] = GetFileSector(TeamMFFileName);

	/*get extra point plays sectors*/
		sprintf(TeamMFFileName, "/shells/dpc/extradef.mfl");
		Shell_File_Sectors[i][EXTRA_POINT_PLAY][DEFENSIVE_PLAYS] = GetFileSector(TeamMFFileName);
		sprintf(TeamMFFileName, "/shells/dpc/extraoff.mfl");
		Shell_File_Sectors[i][EXTRA_POINT_PLAY][OFFENSIVE_PLAYS] = GetFileSector(TeamMFFileName);

	/*get normal plays sectors*/
		sprintf(TeamMFFileName, "/shells/dpc/deftm/slot%d/deftm%d.mfl", GameTeamData[i].TeamNumber/30, GameTeamData[i].TeamNumber);
		Shell_File_Sectors[i][NORMAL_GAME_PLAY][DEFENSIVE_PLAYS] = GetFileSector(TeamMFFileName);
		sprintf(TeamMFFileName, "/shells/dpc/offtm/slot%d/offtm%d.mfl", GameTeamData[i].TeamNumber/30, GameTeamData[i].TeamNumber);
		Shell_File_Sectors[i][NORMAL_GAME_PLAY][OFFENSIVE_PLAYS] = GetFileSector(TeamMFFileName);
	}/*for*/

  /*get the main DPC file*/
	DPC_File_Sector = GetFileSector("/shells/dpc/dpc.mfl");

	/* Get the arrows for edited plays - Nigel */
	Arrows_File_Sector = GetFileSector("/shells/dpc/arrows.mfl");

	/* Get the fields sectors for edited plays - Nigel */

	for(i=0; i<20; i++)
	{
		sprintf(TeamMFFileName, "/shells/fields/fieldc%d.mfl", i+1);
		Fields_File_Sector[i] = GetFileSector(TeamMFFileName);
	}
}


/*****************************************************************

					Init DPC multifiles

	Call this function to background load the multifiles

	Init_DPC_MFiles(TRUE)  start load and wait for the load to finish
	Init_DPC_MFiles(FALSE) start load and leave without
					   waiting for the load to finish
******************************************************************/
int Init_DPC_MFiles(int WaitForLoad)
{
int i, j, CDRetVal;
char   TeamMFFileName[MAXPATH];
ULONG  TeamFileSectors[2], DPCFileSector;
ULONG  TeamFileSize[2], DPCFileSize;
int plays,forms;

  /*init the background load */
	ClearLoadList();

	InitTemplates();

  /*Init the multifile pointers*/
  /*Load Formation multifiles*/

// MRH
	for(i=0; i<2; i++)
	{
		if(GameTeamData[i].OffDefFlag == ON_DEFENSE)
			plays = DEFENSIVE_PLAYS;
		else
			plays = OFFENSIVE_PLAYS;

		if(PlayType == KICKOFF_PLAY)	 /*load kickoff plays*/
			forms = KICK_OFF_PLAY;
		else if(PlayType == EX_PT1_PLAY) /*load extra point plays*/
			forms = EXTRA_POINT_PLAY;
		else
			forms = NORMAL_GAME_PLAY;

		Team_MFile[i] = (unsigned long *)AllocAddLoadList(Shell_File_Sectors[i][forms][plays]);

	}

  /*Load main multifile*/
	Shell_MFile = (unsigned long *)AllocAddLoadList(DPC_File_Sector);

	Arrows_MFile = (unsigned long *)AllocAddLoadList(Arrows_File_Sector);

	for(i=0; i<2; i++)
	{
		FieldNum[i] = GetFieldNum(i);
		if(FieldNum[i] !=-1)
		{
			Fields_MFile[i] = (unsigned long *)AllocAddLoadList(Fields_File_Sector[FieldNum[i]]);
		}
	}

  /*loop until done*/
	StartLoadList();

  /*Wait for load to finish if asked*/
	if(WaitForLoad == TRUE)
	{
		while((CDRetVal = CheckLoadList()) != 1)
		{
			if(CDRetVal == -1)
				DebugPrintf(0,"CDRetCode = %d ERROR \n", CDRetVal);
		}
	}
}

/*********************************************************

			Cleans up everything

**********************************************************/
int CleanUp_DPC()
{
	int i;

	if(DPC_Init == TRUE)
	{
		//FreeTemplate(5);
		//FreeTemplate(4);
		//FreeTemplate(3);
		FreeTemplate(2);
		FreeTemplate(1);
		FreeTemplate(0);
		ResetStrings();
		//FreeFonts();
	};

	for(i=0; i<2; i++)
	{
		if(Team_MFile[i]) FreeMem(Team_MFile[i]);
		Team_MFile[i] = NULL;
	}

	if(Shell_MFile) FreeMem(Shell_MFile);
		Shell_MFile = NULL;

	if(Arrows_MFile) FreeMem(Arrows_MFile);
		Arrows_MFile = NULL;

	for(i=0; i<2; i++)
	{
		if(FieldNum[i]!=-1 && Fields_MFile[i]) FreeMem(Fields_MFile[i]);
			Fields_MFile[i] = NULL;
	}

	/*save PreviousPlayType */
//	PreviousPlayType = PlayType;

//	DebugPrintf(0,"DPC screen cleanup complete\n");

//	DebugPrintf(0,"***Final Play Select***\n");
//	DebugPrintf(0,"TEAM: %s selected a play %d-%s. \n", GameTeamData[0].STD.TeamCity, GameTeamData[0].PlayNum, PlayNames[GameTeamData[0].PlayNum]);
//	DebugPrintf(0,"TEAM: %s selected a play %d-%s. \n", GameTeamData[1].STD.TeamCity, GameTeamData[1].PlayNum, PlayNames[GameTeamData[1].PlayNum]);
	DebugPrintf(0,"TEAM: %s selected a play %d-%s. \n", GameTeamData[0].STD.TeamCity, GameTeamData[0].PlayNum, GetPlayName(GameTeamData[0].PlayNum));
	DebugPrintf(0,"TEAM: %s selected a play %d-%s. \n", GameTeamData[1].STD.TeamCity, GameTeamData[1].PlayNum, GetPlayName(GameTeamData[1].PlayNum));

	/*Specif that the stuff was cleaned*/
	DPC_Init = FALSE;

	return 0;
}


/*************************************************************************
 * FIELD FRAME - Callback function to setup the frame stuff...
 *************************************************************************/
int Shell_Frame_DPC(void)
{
//	PollPC();

	DisplayAllStrings();
	DisplayShellPolys();
	return(1);
}


/********************************************************
Mirror Plays if the top left/right buttons are pressed
*********************************************************/
int MirrorPlay(int WhichPad)
{
	int i;

  /*flip the mirror flag*/

/*	if(Mirrored == TRUE)	what in the @#$%^& is this, nick?!?
		Mirrored = FALSE;
	else if(Mirrored == FALSE)
		Mirrored = TRUE;	*/

	Mirrored = !Mirrored;	// Nick, please take a course in Boolean algebra

	multifile = Shell_MFile;

  /*mirror offensive plays*/
	for(i=0;i<3;i++)
	{
		FlipPolyX(&template[DEFPLAYS_TEMPLATE].poly[i]);
		FlipPolyX(&template[OFFPLAYS_TEMPLATE].poly[i]);
	}
  /*load the bitmap for offense*/
	if(Mirrored == TRUE)
		ChangePolyCmpTexture(BUTTONS_TEMPLATE, FLIP_PLAY, "mirrdn.cmp");
	else
		ChangePolyCmpTexture(BUTTONS_TEMPLATE, FLIP_PLAY, "mirrup.cmp");

	return 0;
}

/********************************************************
Select the play
*********************************************************/
int SelectPlay(int WhichPad, int PadPressed)
{
WORD *formptr;

int PlayNum, t;
char PlayName[30];
int PlayIndex;

  /*set the player done flag*/
	PlayCallDone[WhichPad] = TRUE;

  /*set index flag, which play selected from the current trio*/
	switch(PadPressed)
	{
		case SQUARE:
			PlayIndex = CurrPlay[WhichPad];
			break;
		case TRIANGLE:
			PlayIndex = CurrPlay[WhichPad] + 1;
			break;
		default:        // error check and psuedo correction
			PlayIndex = CurrPlay[WhichPad] + 2;
			break;
	}/*case*/

  /*retrieve the name and numer of the play*/
	if(PlayType == KICKOFF_PLAY)
	{
		if(GameTeamData[WhichPad].OffDefFlag == ON_DEFENSE)
		{
	  /*go directly to formation 25*/
			t = DEF_KICKOFF_PLAYCALL_FORM_NUM;
			FreezeAllClocks();
		}
		else
		{
	  /*go directly to formation 15*/
			t = OFF_KICKOFF_PLAYCALL_FORM_NUM;
		}

		formptr = GetPlaysPerForm(t);
		PlayNum = *(formptr + PlayIndex);
	}
	else if(PlayType == EX_PT1_PLAY)
	{
		if(GameTeamData[WhichPad].OffDefFlag == ON_DEFENSE)
		{
	  /*go directly to formation 23*/
			t = DEF_SPECIAL_TEAMS_FORM_NUM;
		}
		else
		{
	  /*go directly to formation 9*/
			t = OFF_SPECIAL_TEAMS_FORM_NUM;
			FreezeAllClocks();
		}
		formptr = GetPlaysPerForm(t);
		PlayNum = *(formptr + PlayIndex);
	}
	else
	{
		PlayNum = FormGrid[WhichPad][CurrFormation[WhichPad]].Plays[PlayIndex];
		if(GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE)
		{
			FreezeAllClocks();
			DebugPrintf(0,"Clocks Frozen by side %d\n", WhichPad);
		}
	}
	strcpy(PlayName, GetPlayName(PlayNum));
	DebugPrintf(0,"TEAM: %s selected a play %d-%s. \n", GameTeamData[WhichPad].STD.TeamCity, PlayNum, PlayName);

  /*put the selected play number into the structure*/
	GameTeamData[WhichPad].PlayNum = PlayNum;
	GameTeamData[0].PlayFlipped = Mirrored; /*both sides have same mirrored status*/
	GameTeamData[1].PlayFlipped = Mirrored;

  /*hide the plays for the team which chose the play*/
	VanishPlays(WhichPad);

	return 0;
}


/*******************************************************
Display the new formation
********************************************************/
int DisplayNewFormation(int PadPressed, int team)
{
	int i,temp;
	int FormNum;

  /*unselect button*/
	multifile = Shell_MFile;

  /*bump pad pointer up or down depending what dir is pressed*/
	if(PadPressed == PAD_UP)
	{
		if(--CurrFormation[team] < 0)
		{
//			team = PlayBookCheck(PadPressed, team);
			CurrFormation[team] = MaxFormations[team];
		}/*if*/
	}/*if*/
	else if(PadPressed == PAD_DOWN)
	{
		if(++CurrFormation[team] > MaxFormations[team])
		{
//			team = PlayBookCheck(PadPressed, team);
			CurrFormation[team] = 0;
		}/*if*/
	}/*if*/

  /*adjust CurrPlay[] since it may be bigger than FormGrid[][].PlaysMax*/

/*-----------------------------------------------------
	 hey Nick, what if CurrPlay[team] = 0 and
		 FormGrid[team][CurrFormation[team]].PlaysMax= -1 or 0
		 it's called an endless loop

	while(CurrPlay[team] >= FormGrid[team][CurrFormation[team]].PlaysMax)
	{
	//DebugPrintf(0,"Adjusted CurrPlay[team] = %d CurrFormation[team] = %d\n", CurrPlay[team], CurrFormation[team]);
		if(CurrPlay[team] >= 3)
			CurrPlay[team] = CurrPlay[team] - 3;
	}			*/


/*  hey Nick, here's a REAL comment as to the IDEA behind the code, not
	one of your usual "comments" like:

			DisplayPlayGraphics(team); //display the bitmaps

	REAL comments
	if Run/Pass Method, CurrPlay may be 15 in one form, 9 in another
	if we're on 15 and move up to 9, we need to adjust current play
----------------*/

	AdjustCurrPlayToMatchFormGrid(team);

/*
	temp = FormGrid[team][CurrFormation[team]].PlaysMax;
	if(CurrPlay[team] >= temp)
	{
		if( (CurrPlay[team] = temp -3) < ZERO)
		{
			CurrPlay[team] = ZERO;	// big error
		}
	}
*/

  /*might have to turn the flip on/off for new CurrentFormation[]*/
	HandleFlip_ON_OFF(team);

  /*update current formation in GameTeamData array*/
	GameTeamData[team].FormationNumber =
			 GameTeamData[team].STD.Formations[GameTeamData[team].OffDefFlag][CurrFormation[team]];

  /*display the bitmaps*/
	DisplayPlayGraphics(team);

  /*select the new formation button*/
	DisplayFormationButtons(team);

	return 0;
}

/*********************************************************
Display the new play
**********************************************************/
int DisplayNewPlay(int PadPressed, int team)
{
	int i;

  /*bump the plays by +-SCROLL_PLAYS */
	if(PadPressed == PAD_LEFT)
	{
		CurrPlay[team] = CurrPlay[team] - SCROLL_PLAYS;
		if(CurrPlay[team] < 0)
		{
			CurrPlay[team] = FormGrid[team][CurrFormation[team]].PlaysMax - 3;
		}/*if*/
	}/*if*/
	else if(PadPressed == PAD_RIGHT)
	{
		CurrPlay[team] = CurrPlay[team] + SCROLL_PLAYS;
		if(CurrPlay[team] > FormGrid[team][CurrFormation[team]].PlaysMax - 3)
		{
			CurrPlay[team] = 0;
		}/*if*/
	}/*if*/

  /*display the play bitmaps*/
	DisplayPlayGraphics(team);

  /*select new formation button*/
	DisplayFormationButtons(team);

	return 0;
}

/*****************************************************************
displays the appropriate formation button for the given side
******************************************************************/
int DisplayFormationButtons(int team)
{
int BarWidth;
int cf,
	 wid;

	cf = CurrFormation[team];

  /*special case - kickoff or extra play - */
	if (PlayType == KICKOFF_PLAY || PlayType == EX_PT1_PLAY)
	{
		if(template[BUTTONS_TEMPLATE].action[BAR0] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[BAR0] ^= DISPLAY;
		if(template[BUTTONS_TEMPLATE].action[BAR1] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[BAR1] ^= DISPLAY;
	}
	else
	if (CaptainPad[team] == -1 && (GameOptions[GAME_OPTNS_DIFFICULTY] != 0) && !(CaptainPad[0] == -1 && CaptainPad[1] == -1))
	{
		for (wid = 0; wid < 2; wid++)
		{
			if (CaptainPad[wid] == -1)
			{
				if (GameTeamData[wid].OffDefFlag == ON_DEFENSE)
				{
					if (template[BUTTONS_TEMPLATE].action[BAR0] && DISPLAY)
						template[BUTTONS_TEMPLATE].action[BAR0] ^= DISPLAY;
				}
				else
				{
					if (template[BUTTONS_TEMPLATE].action[BAR1] && DISPLAY)
						template[BUTTONS_TEMPLATE].action[BAR1] ^= DISPLAY;
				}
			}
		}
	}
	else
	{
	/*calculate the width of the bar*/
//		BarWidth = 80 - ((FormGrid[team][cf].PlaysMax - 3) * (80 / FormGrid[team][cf].PlaysMax));
// MRH
		BarWidth = 96 / (FormGrid[team][cf].PlaysMax / 3);

	/*move cursor horizontaly and resize it*/
		if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
		{	// defense on top of screen with formations on right
// MRH
			wid = (-256) + 408 + CurrPlay[team] * (96 / FormGrid[team][cf].PlaysMax);
			if (wid+BarWidth > 241)	// Kluge to make defense special correct
			{
				BarWidth += 241 - (wid + BarWidth);
			}
			MovePolyToXY(&template[BUTTONS_TEMPLATE].poly[BAR0],
				  wid, (-120) + 38 + (cf * pcspacing[team]) + (pcspacing[team] == 10 ? 2 : 0));
			ChangeABSPolyWH(&template[BUTTONS_TEMPLATE].poly[BAR0], BarWidth, 11);
		}
		else		// offense on bottom of screen with formations on left
		{
// MRH
			wid = 18 + CurrPlay[team] * (96 / FormGrid[team][cf].PlaysMax);
			if (wid+BarWidth > 107)	// Kluge to make defense special correct
			{
				BarWidth += 107 - (wid + BarWidth);
			}
			wid -= 256;
			MovePolyToXY(&template[BUTTONS_TEMPLATE].poly[BAR1],
				wid, (-120) + 144 + (cf * pcspacing[team]) + (pcspacing[team] == 10 ? 2 : 0));
			ChangeABSPolyWH(&template[BUTTONS_TEMPLATE].poly[BAR1], BarWidth, 11);
		}
	}
}

/*********************************************************
Display edited play bitmaps
For now just display "edited.cmp"
**********************************************************/
int DisplayEditedPlayBitmaps(int team)
{
int i,j;
int  PlayNum;
char PlayName[30];

  /*do the rest of the graphics*/
	for(i=0;i<3;i++)
	{
		PlayNum = FormGrid[team][CurrFormation[team]].Plays[CurrPlay[team] + i];
		strcpy(PlayName, GetPlayName(PlayNum));
		strlwr(PlayName);

		if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
		{
			ChangePolyCmpTextureNOCLT(DEFPLAYS_TEMPLATE, i, "edited.cmp");
			CenterString(DefPlayStr[i], PlayName, 77 + (i * 130));
			ChangeString(DefPlayStr[i], PlayName, FONT0 | PROPORTIONAL);
		}
		else
		{
			BuildPlayBitmap(OFFPLAYS_TEMPLATE, i, (CurrPlay[team]+i)+(team*24));

			CenterString(OffPlayStr[i], PlayName, 175 + (i * 130));
			ChangeString(OffPlayStr[i], PlayName, FONT0 | PROPORTIONAL);
		}
	}
}

/*********************************************************
Display normal play bitmaps
**********************************************************/
int DisplayPlayBitmaps(int team)
{
WORD *formptr;
int i,t;
char PlayFileName[MAXPATH];
int  PlayNum, PlayIndex;
char PlayName[30];

  /*display the graphics*/
	for(i=0;i<3;i++)
	{

		/*which play in the row of plays in a formtion? (0-11)*/
		PlayIndex = CurrPlay[team] + i;

	/*which play from the list of all plays in the game?*/
		if(PlayType == KICKOFF_PLAY)
		{
			if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
			{
		/*go directly to formation 25*/
				t = DEF_KICKOFF_PLAYCALL_FORM_NUM;
			}
			else
			{
		/*go directly to formation 11*/
				t = OFF_KICKOFF_PLAYCALL_FORM_NUM;
			}
			formptr = GetPlaysPerForm(t);
			PlayNum = *(formptr + PlayIndex);
		}
		else if(PlayType == EX_PT1_PLAY) /*load extra point plays*/
		{
			if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
			{
		/*go directly to formation 23*/
				t = DEF_SPECIAL_TEAMS_FORM_NUM;
			}
			else
			{
		/*go directly to formation 9*/
				t = OFF_SPECIAL_TEAMS_FORM_NUM;
			}
			formptr = GetPlaysPerForm(t);
			PlayNum = *(formptr + PlayIndex);
		}
		else
		{
			PlayNum = FormGrid[team][CurrFormation[team]].Plays[PlayIndex];
		}

		strcpy(PlayName, GetPlayName(PlayNum));
		strlwr(PlayName);

	/*load graphics and print the name of the play*/
		if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
		{
	  /*go by playnum*/
			multifile = Team_MFile[team];
			sprintf(PlayFileName, "pl%d.cmp", PlayNum);

			if (template[DEFPLAYS_TEMPLATE].poly[i].u0 == 1)
			{
				template[DEFPLAYS_TEMPLATE].poly[i].u0 = 0;
				template[DEFPLAYS_TEMPLATE].poly[i].u1++;
				template[DEFPLAYS_TEMPLATE].poly[i].u2 = 0;
				template[DEFPLAYS_TEMPLATE].poly[i].u3++;
			}

			if(GetMultiFilePtr(multifile, PlayFileName) == NULL)/*safety net*/
			{
				ChangePolyCmpTextureNOCLT(DEFPLAYS_TEMPLATE, i, "notfound.cmp");
			}
			else
			{
				ChangePolyCmpTextureNOCLT(DEFPLAYS_TEMPLATE, i, PlayFileName);
			}
			CenterString(DefPlayStr[i], PlayName, 77 + (i * 130));
			ChangeString(DefPlayStr[i], PlayName, FONT0 | PROPORTIONAL);
			multifile = Shell_MFile;
		}/*if*/
		else
		{
	  /*go by playnum*/
			multifile = Team_MFile[team];
			sprintf(PlayFileName, "pl%d.cmp", PlayNum);

			if (template[OFFPLAYS_TEMPLATE].poly[i].u0 == 1)
			{
				template[OFFPLAYS_TEMPLATE].poly[i].u0 = 0;
				template[OFFPLAYS_TEMPLATE].poly[i].u1++;
				template[OFFPLAYS_TEMPLATE].poly[i].u2 = 0;
				template[OFFPLAYS_TEMPLATE].poly[i].u3++;
			}

			if(GetMultiFilePtr(multifile, PlayFileName) == NULL)/*safety net*/
			{
				ChangePolyCmpTextureNOCLT(OFFPLAYS_TEMPLATE, i, "notfound.cmp");
			}
			else
			{
				ChangePolyCmpTextureNOCLT(OFFPLAYS_TEMPLATE, i, PlayFileName);
			}
			CenterString(OffPlayStr[i], PlayName, 175 + (i * 130));
			ChangeString(OffPlayStr[i], PlayName, FONT0 | PROPORTIONAL);
			multifile = Shell_MFile;
		}/*if*/
	}/*for*/
}

/************************************************************
		Handles flip button being on/off as we move along the plays
*************************************************************/
void HandleFlip_ON_OFF(int team)
{
  /*if kickoff or extra play, hide the buttons*/
	if((PlayType == KICKOFF_PLAY) || (PlayType == EX_PT1_PLAY))
	{
		HideFlip();
		return;
	}

  /*if we are offense pointing to the SPECIAL PLAYS, hide mirror button,*/
	if(GameTeamData[team].OffDefFlag == ON_OFFENSE)
	{
		if(CurrFormation[team] == 5)
		{
	  /*if mirrored, unmirror*/
			if(Mirrored == TRUE)
				MirrorPlay(team);

	  /*hide*/
			if(!PlayBook) HideFlip();
		}
		else
		{
			if(!PlayBook) ShowFlip();
		}
	}
}

/*********************************************************
Causes all the plays to disappear
**********************************************************/
void HideFlip()
{
  /*load the bitmap for offense*/
	if(template[BUTTONS_TEMPLATE].action[FLIP_PLAY] && DISPLAY)
		template[BUTTONS_TEMPLATE].action[FLIP_PLAY] ^= DISPLAY;

	ChangeString(FlipStr, "    ", FONT0);
}

/*********************************************************
Causes all the plays to disappear
**********************************************************/
void ShowFlip()
{
  /*if not displayed, display, else leave alone*/
	if(!(template[BUTTONS_TEMPLATE].action[FLIP_PLAY] && DISPLAY))
		template[BUTTONS_TEMPLATE].action[FLIP_PLAY] ^= DISPLAY;

	ChangeString(FlipStr, "FLIP", FONT0);
}

/*********************************************************
Causes all the plays to disappear
**********************************************************/
void VanishPlays(int team)
{
	int i;
	char BlankTeamName[255];

	if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
	{
	/*hide the plays*/
		for(i=0; i<9; i++)
			if(template[DEFPLAYS_TEMPLATE].action[i] && DISPLAY)
				template[DEFPLAYS_TEMPLATE].action[i] ^= DISPLAY;

	/*hide buttons*/
		if(PlayType == KICKOFF_PLAY || PlayType == EX_PT1_PLAY)
		{
			ChangeString(DefFormStr[0], BLANK_FORM_STRING, FONT0);
		}
		else
		{
			for(i=0; i <= MaxFormations[team]; i++)
			{
				ChangeString(DefFormStr[i], BLANK_FORM_STRING, FONT0);
			}
		}

// MRH
		if(template[BUTTONS_TEMPLATE].action[TEAM0] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[TEAM0] ^= DISPLAY;
		if(template[BUTTONS_TEMPLATE].action[FORMBACK0] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[FORMBACK0] ^= DISPLAY;
		if(template[BUTTONS_TEMPLATE].action[BAR0] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[BAR0] ^= DISPLAY;

	/*hide the play names*/
		for(i=0; i < 3; i++)
			ChangeString(DefPlayStr[i], BLANK_PLAY_STRING, FONT0);

	/*hide team name*/
		for(i = 0; i < DefTeamNameSize; i++)
			BlankTeamName[i] = ' ';
		BlankTeamName[i] = '\0';
		ChangeString(DefTeamNameStr, BlankTeamName, FONT0);
	}
	else
	{
	/*hide the plays*/
		for(i=0; i<9; i++)
			if(template[OFFPLAYS_TEMPLATE].action[i] && DISPLAY)
				template[OFFPLAYS_TEMPLATE].action[i] ^= DISPLAY;

	/*hide buttons*/
		if(PlayType == KICKOFF_PLAY || PlayType == EX_PT1_PLAY)
		{
// MRH
			ChangeString(OffFormStr[0], BLANK_FORM_STRING, FONT0);
		}
		else
		{
			for(i=0; i <= MaxFormations[team]; i++)
			{
				ChangeString(OffFormStr[i], BLANK_FORM_STRING, FONT0);
			}
		}

// MRH
		if(template[BUTTONS_TEMPLATE].action[TEAM1] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[TEAM1] ^= DISPLAY;
		if(template[BUTTONS_TEMPLATE].action[FORMBACK1] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[FORMBACK1] ^= DISPLAY;
		if(template[BUTTONS_TEMPLATE].action[BAR1] && DISPLAY)
			template[BUTTONS_TEMPLATE].action[BAR1] ^= DISPLAY;

	/*if not kickoff or extra point, hide mirror button*/
		HideFlip();

	/*hide the play names*/
		for(i=0; i < 3; i++)
			ChangeString(OffPlayStr[i], BLANK_PLAY_STRING, FONT0);

	/*hide team name*/
		for(i = 0; i < OffTeamNameSize; i++) BlankTeamName[i] = ' ';
		BlankTeamName[i] = '\0';
		ChangeString(OffTeamNameStr, BlankTeamName, FONT0);
	}
}

/*********************************************************
Scans the FormationsGrid to determine h-v position within
the grid
**********************************************************/
int FindGridFormationSlot(int team, int PlayNum, int *FormationPos, int *PlayGroup, int *SpecificPlay)
{
	WORD *formptr;

	int i,j;

	DebugPrintf(0, "Team %d Looking for play %d\n", team, PlayNum);

  /*-1 means 'dont move', applicable only at kickoff and extra point*/
	*FormationPos = -1;
	*PlayGroup    = -1;

	if(PlayType == KICKOFF_PLAY)
  /*kickoff play*/
	{
		for(i=0;i<3;i++)
			if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
			{
				formptr = GetPlaysPerForm(DEF_KICKOFF_PLAYCALL_FORM_NUM);

				if(PlayNum == *(formptr+i))
				{
					*SpecificPlay = i;
					return TRUE;
				}
			}
			else
			{
				formptr = GetPlaysPerForm(OFF_KICKOFF_PLAYCALL_FORM_NUM);

				if(PlayNum == *(formptr+i))
				{
					*SpecificPlay = i;
					return TRUE;
				}
			}
	}
	else if(PlayType == EX_PT1_PLAY)
  /*extra point*/
	{
		for(i=0;i<3;i++)
			if(GameTeamData[team].OffDefFlag == ON_DEFENSE)
			{
				formptr = GetPlaysPerForm(DEF_SPECIAL_TEAMS_FORM_NUM);

				if(PlayNum == *(formptr + 3 + i))
				{
					*SpecificPlay = i;
					return TRUE;
				}
			}
			else
			{
				formptr = GetPlaysPerForm(OFF_SPECIAL_TEAMS_FORM_NUM);

				if(PlayNum == *(formptr + i))
				{
					*SpecificPlay = i;
					return TRUE;
				}
			}
	}
	else
	{
	/*else normal play*/
		for(i = 0; i < 7; i++)
		{
			for(j = 0; j < FormGrid[team][i].PlaysMax; j++)
			{
				if(FormGrid[team][i].Plays[j] == PlayNum)
				{
		  /*save y position, formation */
					*FormationPos = i;

		  /*save x position*/
					*PlayGroup = j;

		  /*make sure that PlayGroup is evenly divisible by 3*/
					while((*PlayGroup % 3) != 0)
						*PlayGroup = *PlayGroup - 1;

		  /*now find the specific play, 1st 2nd or 3rd within the group*/
					*SpecificPlay = j - *PlayGroup;

					DebugPrintf(0, "Play for team %d found. Formation %d, group %d, specific %d\n",
							 team, *FormationPos, *PlayGroup, *SpecificPlay);

		  /*return true*/
					return TRUE;
				}
			}
		}

	/*if we got this far, we failed to find the number, return false*/
		DebugPrintf(0, "Play for team %d NOT FOUND.\n", team);
		return FALSE;
	}
}

/********************************************************

				Paints the main Play Call  screen

*********************************************************/
int Paint_DPC_Screen()
{
int i, j, k, t;
char *ptr;
short buff[16];
int  str;
char ScoreStr[5];
char *NumSuf[] = {"st","nd","rd","th"};	// only  4 downs or quarters
int Yards = 0, YardFIndex, ScrimageLine;
char FieldFileName[MAXPATH];
char PlayDir;	// single char, are we before the middle of the field or after
ULONG PCallTimer;

  /*load the shell graphics template files*/
	InitTemplates();
	in_arcade = TRUE;
	multifile = Shell_MFile;

	LoadTemplate("defplays.llx");	   /*0-defensive-top-plays*/

  /*all plays use the same clut as the first one*/

	ChangePoly4CLUT(DEFPLAYS_TEMPLATE, 0, Plays_Clut);

	for(i = 1;i <= 2; i++)
		ReassignTemplateCLUT(DEFPLAYS_TEMPLATE, i, DEFPLAYS_TEMPLATE, 0);

  /*all fields use the same clut as the first one*/

	for(i = 4;i <= 5; i++)
		ReassignTemplateCLUT(DEFPLAYS_TEMPLATE, i, DEFPLAYS_TEMPLATE, 3);

  /*all action buttons use the same clut as the first one*/
	for(i = 7;i <= 8; i++)
		ReassignTemplateCLUT(DEFPLAYS_TEMPLATE, i, DEFPLAYS_TEMPLATE, 6);

	LoadTemplate("offplays.llx");	   /*1-offensive-bottom-plays*/

  /*all plays use the same clut as the first defensive one*/

	ChangePoly4CLUT(OFFPLAYS_TEMPLATE, 0, Plays_Clut);

	for(i = 0;i <= 2; i++)
		ReassignTemplateCLUT(OFFPLAYS_TEMPLATE, i, DEFPLAYS_TEMPLATE, 0);

  /*all fields use the same clut as the first defensive one*/
	for(i = 3;i <= 5; i++)
		ReassignTemplateCLUT(OFFPLAYS_TEMPLATE, i, DEFPLAYS_TEMPLATE, 3);

  /*all action buttons use the same clut as the first defensive one*/
	for(i = 6;i <= 8; i++)
		ReassignTemplateCLUT(OFFPLAYS_TEMPLATE, i, DEFPLAYS_TEMPLATE, 6);

	LoadTemplate("buttns.llx");      /*2-buttons*/

	// Make FIELD poly's Transparent
	for (i = 0; i < 9; i++)
	{
		SetTransPoly(&template[OFFPLAYS_TEMPLATE].poly[i]);
		SetTransPoly(&template[DEFPLAYS_TEMPLATE].poly[i]);
	}


	// Set action buttons to foreground priority

	for(i=6; i<9;i++)
	{
		template[DEFPLAYS_TEMPLATE].depth[i] =
		template[OFFPLAYS_TEMPLATE].depth[i] = 12;
	}

// Play announcer sound

	if(!PlayBook) AnnounceDownAndYards();

// MRH
	j = MakeTransRGB(DefensiveSlotNum);
	for (i = 0; i < 16; i++)
		buff[i] = j;
	ChangePoly4CLUT(BUTTONS_TEMPLATE, BAR0, (unsigned long *)buff);
	SetTransPoly(&template[BUTTONS_TEMPLATE].poly[BAR0]);

	j = MakeTransRGB(OffensiveSlotNum);
	for (i = 0; i < 16; i++)
		buff[i] = j;
	ChangePoly4CLUT(BUTTONS_TEMPLATE, BAR1, (unsigned long *)buff);
	SetTransPoly(&template[BUTTONS_TEMPLATE].poly[BAR1]);

	SetTransPoly(&template[BUTTONS_TEMPLATE].poly[FORMBACK0]);
	SetTransPoly(&template[BUTTONS_TEMPLATE].poly[FORMBACK1]);
	ReassignTemplateCLUT(BUTTONS_TEMPLATE, FORMBACK1, BUTTONS_TEMPLATE, FORMBACK0);

  /*write blank strings for the offensive and defensive plays*/
	for(k=0; k<3; k++)
	{
		DefPlayStr[k] = CreateString(BLANK_PLAY_STRING, fontdpc7, 24 + (k * 130) + 5, 35, FONT0 | PROPORTIONAL);
		OffPlayStr[k] = CreateString(BLANK_PLAY_STRING, fontdpc7, 104 + (k * 130) + 5, 141, FONT0 | PROPORTIONAL);
		ChangeStringCLUT(strings.string[DefPlayStr[k]], FontClutIDs[FONT_COLOR]->CLUT_ID);
		ChangeStringCLUT(strings.string[OffPlayStr[k]], FontClutIDs[FONT_COLOR]->CLUT_ID);
	}/*for*/

  /*load little arrows */
  //LoadTemplate("arrowsd0.llx");	   /*3*/
  //for(i = 0;i <= 13; i++) ReassignTemplateCLUT(3, i, DEFPLAYS_TEMPLATE, 0);

  //LoadTemplate("arrowsd1.llx");    /*4*/
  //for(i = 0;i <= 6; i++) ReassignTemplateCLUT(4, i, DEFPLAYS_TEMPLATE, 0);

  //LoadTemplate("arrowsd2.llx");	   /*5*/
  //for(i = 0;i <= 8; i++) ReassignTemplateCLUT(5, i, DEFPLAYS_TEMPLATE, 0);

  /*loop twice for both teams to do the rest of the stuff...*/
	for(j = 0; j < 2; j++)
	{

// MRH
		if(MaxFormations[j] == 4)
			pcspacing[j] = 13;
		if(MaxFormations[j] == 5)
			pcspacing[j] = 10;
		if(MaxFormations[j] == 6)
			pcspacing[j] = 9;

	/*paint the first three plays for the first formation of each team*/

	DisplayPlayGraphics(j);

	/*print the formation names*/
		for(k = 0; k <= MaxFormations[j]; k++)
		{
// MRH
			if(PlayType == KICKOFF_PLAY || PlayType == EX_PT1_PLAY)
			{
				if(GameTeamData[j].OffDefFlag == ON_DEFENSE)
				{
					DefFormStr[k] = CreateString(BLANK_FORM_STRING, fontdpc3,  416, 59, FONT0 | PROPORTIONAL);
					CenterString(DefFormStr[k], strlwr(FormGrid[j][k].FormationName), 451);
					ChangeString(DefFormStr[k], strlwr(FormGrid[j][k].FormationName), FONT0 | PROPORTIONAL);
					ChangeStringCLUT(strings.string[DefFormStr[k]], FontClutIDs[FONT_COLOR]->CLUT_ID);
				}
				else
				{
					OffFormStr[k] = CreateString(BLANK_FORM_STRING, fontdpc3, 28, 165, FONT0 | PROPORTIONAL | SMALL);
					CenterString(OffFormStr[k], strlwr(FormGrid[j][k].FormationName), 61);
					ChangeString(OffFormStr[k], strlwr(FormGrid[j][k].FormationName), FONT0 | PROPORTIONAL);
					ChangeStringCLUT(strings.string[OffFormStr[k]], FontClutIDs[FONT_COLOR]->CLUT_ID);
				}
			}
			else
			{
				if(GameTeamData[j].OffDefFlag == ON_DEFENSE)
				{
					DefFormStr[k] = CreateString(BLANK_FORM_STRING, fontdpc3,  416, 35 + (k * pcspacing[j]) + (pcspacing[j] == 10 ? 2 : 0), FONT0 | PROPORTIONAL);
					CenterString(DefFormStr[k], strlwr(FormGrid[j][k].FormationName), 451);
					ChangeString(DefFormStr[k], strlwr(FormGrid[j][k].FormationName), FONT0 | PROPORTIONAL);
					ChangeStringCLUT(strings.string[DefFormStr[k]], FontClutIDs[FONT_COLOR]->CLUT_ID);
				}/*if*/
				else
				{
					OffFormStr[k] = CreateString(BLANK_FORM_STRING, fontdpc3, 28, 141 + (k * pcspacing[j]) + (pcspacing[j] == 10 ? 2 : 0), FONT0 | PROPORTIONAL | SMALL);
					CenterString(OffFormStr[k], strlwr(FormGrid[j][k].FormationName), 61);
					ChangeString(OffFormStr[k], strlwr(FormGrid[j][k].FormationName), FONT0 | PROPORTIONAL);
					ChangeStringCLUT(strings.string[OffFormStr[k]], FontClutIDs[FONT_COLOR]->CLUT_ID);
				}/*if*/
			}
		}/*for*/

	/*draw new button*/
		DisplayFormationButtons(j);

	/*print Team Names*/
		if(GameTeamData[j].OffDefFlag == ON_DEFENSE)
		{
			//insert team graphic here
// MRH
			if(!PlayBook)
			{
				ChangePolyTex(BUTTONS_TEMPLATE, TEAM0, DpcName[j]);
				ChangePoly4CLUT(BUTTONS_TEMPLATE, TEAM0, (unsigned long *)DpcNameClut[j]);
				sprintf(ScoreStr, "%d", GameTeamData[j].TotalScore);
				DefTeamNameSize = strlen(ScoreStr);
				DefTeamNameStr = CreateString(ScoreStr, fontdpc3,  163, 24,  FONT0 | PROPORTIONAL);
				ChangeStringCLUT(strings.string[DefTeamNameStr], FontClutIDs[PEN_WHITE]->CLUT_ID);
			}
		}
		else
		{
// MRH
			if(!PlayBook)
			{
				ChangePolyTex(BUTTONS_TEMPLATE, TEAM1, DpcName[j]);
				ChangePoly4CLUT(BUTTONS_TEMPLATE, TEAM1, (unsigned long *)DpcNameClut[j]);
				sprintf(ScoreStr, "%d", GameTeamData[j].TotalScore);
				OffTeamNameSize = strlen(ScoreStr);
				OffTeamNameStr = CreateString(ScoreStr, fontdpc3, 163, 130, FONT0 | PROPORTIONAL);
				ChangeStringCLUT(strings.string[OffTeamNameStr], FontClutIDs[PEN_WHITE]->CLUT_ID);
			}
		}

	/*if side is CPU AND difficulty is not easy AND,
	  both sides are not CPU controlled display huddle formation*/
		if(CaptainPad[j] == -1 && (GameOptions[GAME_OPTNS_DIFFICULTY] != 0) && !(CaptainPad[0] == -1 && CaptainPad[1] == -1))
		{
			for(k = 0;k < 3;k++)
			{
				if(GameTeamData[j].OffDefFlag == ON_DEFENSE)
				{
		  /*change the bitmap, text and hide the slider*/
					ChangePolyCmpTextureNOCLT(DEFPLAYS_TEMPLATE, k, "defhud.cmp");
					CenterString(DefPlayStr[k], "huddle", 77 + (k * 130));
					ChangeString(DefPlayStr[k], "huddle", FONT0 | PROPORTIONAL);
				}
				else
				{
					ChangePolyCmpTextureNOCLT(OFFPLAYS_TEMPLATE, k, "offhud.cmp");
					CenterString(OffPlayStr[k], "huddle", 175 + (k * 130));
					ChangeString(OffPlayStr[k], "huddle", FONT0 | PROPORTIONAL);
				}
			}
		}
	}/*for*/

  /*paint misc. strings*/

	if(!PlayBook)
	{

		FlipStr = CreateString("FLIP", fontdpc3, 70, 210,  FONT0 | PROPORTIONAL);
		ChangeStringCLUT(strings.string[FlipStr], FontClutIDs[FONT_COLOR]->CLUT_ID);

	  /*print which down*/
		if(TheDown == ZERO)
		{
			strcpy(DisplayStr," ");
		}
		else
		{
		/*calculate the yards*/

			if(StartBallX > MID_FIELDX)
			{
				Yards = (OFF_GOAL_LINE - StartBallX) / YARD;
				PlayDir = '*';								// Up arrow char
			}
			else
			{
				Yards = (StartBallX - DEF_GOAL_LINE) / YARD;
				PlayDir = '$';								// Down arrow char
			}

		/*if EXACTLY on 50 yardline, arrow char becomes ' '*/
			if(Yards == 50) PlayDir = ' ';

		/*print the string*/
			if(FirstDownX==OFF_GOAL_LINE)
			{
				sprintf(DisplayStr,"%d%s and Goal on %d %c", TheDown, NumSuf[TheDown - 1], Yards, PlayDir);
			}
			else
			{
				sprintf(DisplayStr,"%d%s and %d on %d %c", TheDown, NumSuf[TheDown - 1], (FirstDownX - StartBallX) / YARD, Yards, PlayDir);
			}
		}
		str = CreateString(strlwr(DisplayStr), fontdpc3, 247, 130,  FONT0 | PROPORTIONAL);
		ChangeStringCLUT(strings.string[str], FontClutIDs[FONT_COLOR]->CLUT_ID);

	  /*print which quarter*/
		if(TheQuarter >= 5)
		{
			strcpy(DisplayStr, "OVERTIME");
		}
		else
		{
			sprintf(DisplayStr,"%d%s QTR", TheQuarter, NumSuf[TheQuarter - 1]);
		}
		str = CreateString(strlwr(DisplayStr), fontdpc3, 297, 24,  FONT0 | PROPORTIONAL);
		ChangeStringCLUT(strings.string[str], FontClutIDs[FONT_COLOR]->CLUT_ID);

	  /*print game clock*/
		GameTime = GetVBlankTimer(GAME_TIMER_NUM);
		tm = VBlankToTime(GameTime);
		sprintf(DisplayStr, "%02d:%02d", tm.minutes, tm.seconds);
		GameTimeStr = CreateString(DisplayStr, fontdpc6, 407, 20, FONT2);
		ChangeStringCLUT(strings.string[GameTimeStr], FontClutIDs[DIGITAL_TEXT_COLOR]->CLUT_ID);

	  /*print dummy timer string*/
		PCallTimer = GetVBlankTimer(DPC_TIMER_NUM);
		tm = VBlankToTime(PCallTimer);
		sprintf(DisplayStr, "  :%02d", tm.seconds);
		TimerStr = CreateString(DisplayStr, fontdpc6, 407, 126, FONT2);
		ChangeStringCLUT(strings.string[TimerStr], FontClutIDs[DIGITAL_TEXT_COLOR]->CLUT_ID);

	  /*hide the flip if needed, must check for both sides since on side
		might be on offense and on special*/
		for(j=0;j<2;j++)
			HandleFlip_ON_OFF(j);

	}	// End of if !PlayBook


	for(j = 0; j < 2; j++)
	{
		if(FieldNum[i] != -1)
		{
			multifile = Fields_MFile[j];

			for(i = 3; i <= 5; i++)
			{
				sprintf(FieldFileName, "fieldc%d.cmp", FieldNum[j]+1);

				ChangePolyCmpTextureNOCLT(DEFPLAYS_TEMPLATE+j, i, FieldFileName);
			}
		}

		// Check if either side should vanish it's plays
		if (GameTeamData[j].PlayNum != -1)
			PlayCallDone[j] = TRUE;

		if(PlayCallDone[j] == TRUE)
			VanishPlays(j);
	}

	return 0;
}


/****************************************************************************/

void DisplayPlayGraphics(int team)
{
	// 11/7/ 96 - mjk UseEditedPlays>1 means Easter egg plays
	if(CurrFormation[team] == 6 &&
	GameTeamData[team].UseEditedPlays[GameTeamData[team].OffDefFlag] == 1)
		DisplayEditedPlayBitmaps(team);
	else
		DisplayPlayBitmaps(team);  //Easter egg plays should "BitMap Not found"

/***
	if(CurrFormation[team] != 6 || !GameTeamData[team].UseEditedPlays[GameTeamData[team].OffDefFlag])
		DisplayPlayBitmaps(team);
	else
		DisplayEditedPlayBitmaps(team);
***/
}

/****************************************************************************/
void SetEditedFlag(int tm)
{
//	GameTeamData[tm].UseEditedPlays[0] = TRUE;

 // this is better as it's not a BOOL, could be 2-6 if Easter egg play
	GameTeamData[tm].UseEditedPlays[0] = 1;
}

/*************************************************************************
 * MAKE TRANS RGB - Converts RGB values to be used with LoadCLUT.
 *************************************************************************/

short MakeTransRGB(short slot)
{
	return(0x8000 + ((gTeamColor[GameTeamData[slot].TeamNumber].blue >> 3) << 10) + ((gTeamColor[GameTeamData[slot].TeamNumber].green >> 3) << 5) + (gTeamColor[GameTeamData[slot].TeamNumber].red >> 3));
}

/****************************************************************************/

//void DoPlayBook(void);

extern void  DoPlayCall(void);

/*
int Shell_Frame_Playbook(void);

void DoPlayBook(void)
{
Sint16 retcode = 0, i, teamnum;
void  *sptr, *dptr;
int t0offdef= GameTeamData[0].OffDefFlag;
int t1offdef= GameTeamData[1].OffDefFlag;


	PlayBook = TRUE;

	ResetStrings();

	initVRamHandling();

	LoadBackgroundCD(0,"/shells/bkg/playbook.tim");	// Load & free from memory

	GameTeamData[0].OffDefFlag = ON_DEFENSE;
	GameTeamData[1].OffDefFlag = ON_OFFENSE;

	StartBallX = MID_FIELDX;

	for(i=0; i<2; i++)
	{
		CaptainPad[i] = i;
//		GameTeamData[i].TeamNumber = 0;

		GameTeamData[i].PlayFlipped = FALSE;

//		GameTeamData[i].NumHumanControllers = 1;
//		GameTeamData[i].ControllerNum[0] = 0;

		teamnum = GameTeamData[i].TeamNumber;
		dptr = &GameTeamData[i].STD;
		sptr = &SpecificTeamData[teamnum];
		CopyBytes(sptr, dptr, sizeof(struct specificteamdata));
	}

//	InitGameData();

	PlayType = NORMAL_PLAY;

	Init_DPC_Sectors();
	Init_DPC_MFiles(TRUE);
	Init_DPC_Data(TRUE);

//	template[BUTTONS_TEMPLATE].action[BAR1] &= DISPLAY^0xFFFF;
//	template[BUTTONS_TEMPLATE].action[TEAM0] &= DISPLAY^0xFFFF;
//	template[BUTTONS_TEMPLATE].action[TEAM1] &= DISPLAY^0xFFFF;

//	for(i=6; i<9; i++)
//	{
//		template[DEFPLAYS_TEMPLATE].action[i] &= DISPLAY^0xFFFF;
//		template[OFFPLAYS_TEMPLATE].action[i] &= DISPLAY^0xFFFF;
//	}

	while(!retcode)
	{
		retcode = DPC_Frame();
		DoFrameLoop(1, Shell_Frame_Playbook);
	}

//	DoPlayCall();

	GameTeamData[0].OffDefFlag = t0offdef;
	GameTeamData[1].OffDefFlag = t1offdef;

	CleanUp_DPC();

	PlayBook = FALSE;

}

*/

/****************************************************************************/

/*

Sint32 PlayBookCheck(Sint32 pad, Sint32 team)
{
	Sint32 temp;

	if(PlayBook)
	{
		switch(pad)
		{
			case PAD_UP: CurrFormation[team]++; break;
			case PAD_DOWN: CurrFormation[team]--; break;
		}

		PadPressed[CaptainPad[team]] = -1;	// Clear as Nick's code won't

		template[BUTTONS_TEMPLATE].action[BAR0+team] &= DISPLAY^0xFFFF;
		team ^= 1;
		template[BUTTONS_TEMPLATE].action[BAR0+team] |= DISPLAY;

		temp = CaptainPad[0];
		CaptainPad[0] = CaptainPad[1];
		CaptainPad[1] = temp;
	}

	return(team);
}
*/

/****************************************************************************/

/*
int Shell_Frame_Playbook(void)
{
	UpdateBackground();
	Shell_Frame_DPC();
	return(1);

}
*/

/****************************************************************************/


Sint32 GetFieldNum(Sint32 team)
{
	Sint32 Yards = 0, YardFIndex = 0, ScrimageLine;


	if(PlayType == NORMAL_PLAY || PlayType == EX_PT1_PLAY || PlayType == EX_PT2_PLAY) /*leave field alone if kickoff or extra play*/
	{
	  /*Calculate yard index 1-20. Calculate counting from 0 to 100, not 0 to 50 to 0*/

	  /*calculate skirmage line (0-100)*/

		ScrimageLine = ((StartBallX - DEF_GOAL_LINE) / YARD) + 2;
		if(ScrimageLine < 0) //Bernie's paranoid...
			ScrimageLine = 2;
		else if(ScrimageLine > 102)
			ScrimageLine = 102;

		if(ScrimageLine >= 100 && ScrimageLine <= 102)
		{
			YardFIndex = 20;
		}
		else if(ScrimageLine >= 0 && ScrimageLine <= 7)
		{
			YardFIndex = 1+ GameTeamData[team].OffDefFlag;
		}
		else
		{
			YardFIndex = ( ScrimageLine / 5) + 1;
		}

		if(YardFIndex < 1)		/*1 to 20 are allowed file index numbers*/
			YardFIndex = 1;
		else if(YardFIndex > 20)	/*1 to 20 are allowed file index numbers*/
			YardFIndex = 20;
	}
	else if(PlayType == KICKOFF_PLAY)
	{
			YardFIndex = 7;
	}

	return(YardFIndex-1);
}


/****************************************************************************/
/* CyclePlaysColor                                                          */
/*                                                                          */
/* Cycles palette positions 1-5 for color cycling of play arrows            */
/* INPUT:   None                                                            */
/* OUTPUT:  None                                                            */
/****************************************************************************/

void CyclePlaysColor(void)
{
	WORD i,j;
	WORD *palptr;

	ColorCycle++;
	ColorCycle&=1;

	if(!ColorCycle)
	{
		DrawSync(0);

		palptr = (WORD *) Plays_Clut;

		j = palptr[1];

		for(i=1; i<5; i++)
		{
			palptr[i] = palptr[i+1];
		}

		palptr[5] = j;

		ChangePoly4CLUT(OFFPLAYS_TEMPLATE, 0, Plays_Clut);
	}
}


/****************************************************************************/

/*************************************************************************
 *Takes PadControl and fills the AI structure
 *************************************************************************/
void FillAIStructure()
{
  int i,j;

  /*fill all for CPU*/
  for(i = 0; i < 4; i++)
    for(j = 0; j < 2; j++)
      GameTeamData[j].ControllerNum[i] = -1;

  /*now scan PadControl[] array for HOMETEAM and AWAYTEAM*/
  /*HOMETEAM*/
  i = 0;
  for(j = 0; j < 8; j++)
  {
	if(PadControl[j] == HOMETEAM)
    {
	  GameTeamData[0].ControllerNum[i++] = j;
    }
  }

  /*AWAYTEAM*/
  i = 0;
  for(j = 0; j < 8; j++)
  {
	if(PadControl[j] == AWAYTEAM)
    {
	  GameTeamData[1].ControllerNum[i++] = j;
    }
  }

  /*print debug info*/
  for(i = 0; i < 4; i++)
	 DebugPrintf(0,"%d ",GameTeamData[0].ControllerNum[i]);
  DebugPrintf(0,"\n");
  for(i = 0; i < 4; i++)
    DebugPrintf(0,"%d ",GameTeamData[1].ControllerNum[i]);
  DebugPrintf(0,"\n");

}

/*************************************************************
**************************************************************/

INT PollPads(INT *PadPressed,INT MaxPlayers)
{
	 INT i;

 	 for(i = 0;	i < 8; i++)
	 {
		PadPressed[i] = JpadTrig[i];
//		PadPressed[i] = JpadData[i];
	 }

  return 0;

}



/*************************************************************************
 * Inits the ghost player variables
 *************************************************************************/
void InitGhostPlayer()
{
  int i;

  for(i=0;i<2;i++)
  {
	 GhostEndTime[i] = GetVBlankCount() + WAITTIME; /*get the current time*/
	 GhostSelected[i] = FALSE;
	 GhostPlayGroup[i] = 0;
	 GhostPlay[i] = 0;
	 GhostFormation[i] = 0;
    GhostMirrored[i] = FALSE;
  }

// MRH - Practice mode set defense to done
	if (PracticeMode)
		GhostSelected[1] = TRUE;
}


/*************************************************************************
Ghost Player function. 'Pretends' that the computer is playing by puting
the fake button strokes into PadPressed[]. Returns TRUE if computer
'pretends' to press one of the select buttons, FALSE is no button is
yet 'pressed'.
**************************************************************************/
int GhostPlayer(int WhichPad)
{
  int rc = FALSE, OtherPad;
  ULONG TimeNow;

  /*if there is a keystroke in the buffer, make it NOBUTON*/
  PadPressed[CaptainPad[WhichPad]] = NOBUTTON;

  /*Get the timer and see if done*/
  TimeNow = GetVBlankCount();

  OtherPad = WhichPad ^1;

  /*handle selection of the play*/
  /*if I am on offense, select play NOW*/
  if(GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE)
  {

    if(GhostSelected[WhichPad] != TRUE)
	{
	  GhostEndTime[WhichPad] = GetVBlankCount() + WAITTIME; /*get the current time*/
	  GameTeamData[WhichPad].PlayNum = CPUPlayCallOffense();

	  if(PlayType != KICKOFF_PLAY) /*freeze clocks if offense*/
	  {
		FreezeAllClocks();
	  }


      /*Debug Code - force the flip flag to true*/
      //GameTeamData[WhichPad].PlayFlipped = TRUE;

      DebugPrintf(0, "COMPUTER Team %d Chosen OFFENSIVE %d\n", WhichPad, GameTeamData[1].PlayNum);
      GhostSelected[WhichPad] = TRUE;
      FindGridFormationSlot(WhichPad, GameTeamData[WhichPad].PlayNum,
            &GhostFormation[WhichPad], &GhostPlayGroup[WhichPad], &GhostPlay[WhichPad]);
    }
  }
  else
  {
    /*else WAIT for HUMAN or COMPUTER offense to choose*/
	 if(PlayCallDone[OtherPad] == TRUE || GhostSelected[OtherPad] || PlayType == KICKOFF_PLAY)
    {
      if(GhostSelected[WhichPad] != TRUE)
      {
        GhostEndTime[WhichPad] = GetVBlankCount() + WAITTIME; /*get the current time*/
        GameTeamData[WhichPad].PlayNum = CPUPlayCallDefense();
        DebugPrintf(0, "COMPUTER Team %d Chosen DEFENSIVE %d\n", WhichPad, GameTeamData[0].PlayNum);
        GhostSelected[WhichPad] = TRUE;
        FindGridFormationSlot(WhichPad, GameTeamData[WhichPad].PlayNum,
              &GhostFormation[WhichPad], &GhostPlayGroup[WhichPad], &GhostPlay[WhichPad]);

		if(PlayType == KICKOFF_PLAY) /*freeze clocks if offense*/
		{
			FreezeAllClocks();
		}

	  }
    }
  }

  /*if the ghost already selected the play, do the final stage*/
  if(GhostSelected[WhichPad] == TRUE)
  {
    /*if kickoff or extra, and easy or CPU controlled dont scroll the slider*/
    if(((CaptainPad[0] == -1 && CaptainPad[1] == -1) || (GameOptions[GAME_OPTNS_DIFFICULTY] == 0)) &&
       ((PlayType == KICKOFF_PLAY) || (PlayType == EX_PT1_PLAY)))
    {
      /*flash the button*/
      if(PlayCallDone[WhichPad] != TRUE)
        if(GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE)
          template[OFFPLAYS_TEMPLATE].action[6 + GhostPlay[WhichPad]] ^= DISPLAY;
        else
          template[DEFPLAYS_TEMPLATE].action[6 + GhostPlay[WhichPad]] ^= DISPLAY;

      /*return true if ghost selected the play and five or more seconds passed*/
      if(GhostEndTime[WhichPad] < TimeNow)
    	return TRUE;
	 }
    else if(((CaptainPad[0] == -1 && CaptainPad[1] == -1) || (GameOptions[GAME_OPTNS_DIFFICULTY] == 0)) &&
           (PlayType == NORMAL_PLAY))
    /*if normal, and easy or CPU controlled, scroll the slider*/
    {

      //DebugPrintf(0, "CurrFormation[] %d CurrPlay[] %d \n", CurrFormation[WhichPad], CurrPlay[WhichPad]);
      //DebugPrintf(0, "GhostFormation[] %d GhostPlayGroup[] %d \n", GhostFormation[WhichPad], GhostPlayGroup[WhichPad]);

      /*First we handle possible flip of the play*/
      if(GameTeamData[WhichPad].OffDefFlag  == ON_OFFENSE &&
         GameTeamData[WhichPad].PlayFlipped == TRUE  &&
         GhostMirrored[WhichPad] == FALSE)
      {
        PadPressed[CaptainPad[WhichPad]] = JPADRfront1;
        DebugPrintf(0,"Sending Flip\n");
        GhostMirrored[WhichPad] = TRUE;
        return FALSE;
      }

      /*if we are already poitioned at the right formation/play, wait 3 sec and return */
      if((CurrFormation[WhichPad] == GhostFormation[WhichPad]) && CurrPlay[WhichPad] == GhostPlayGroup[WhichPad])
      {
        /*flash the button*/
        if(PlayCallDone[WhichPad] != TRUE)
          if(GameTeamData[WhichPad].OffDefFlag == ON_OFFENSE)
            template[OFFPLAYS_TEMPLATE].action[6 + GhostPlay[WhichPad]] ^= DISPLAY;
          else
            template[DEFPLAYS_TEMPLATE].action[6 + GhostPlay[WhichPad]] ^= DISPLAY;

        /*if time up, leave*/
        if(GhostEndTime[WhichPad] < TimeNow)
    	  return TRUE;
      }
      else
      {
        /*reset the timer to the current time*/
		  GhostEndTime[WhichPad] = GetVBlankCount() + WAITTIME; /*get the current time*/

        /*else scroll to the right play*/
        /*first adjust formation position*/
        if(CurrFormation[WhichPad] < GhostFormation[WhichPad])
        {
          PadPressed[CaptainPad[WhichPad]] = PAD_DOWN;
          return FALSE;
        }
        else if(CurrFormation[WhichPad] > GhostFormation[WhichPad])
        {
          PadPressed[CaptainPad[WhichPad]] = PAD_UP;
          return FALSE;
        }
        else if(CurrPlay[WhichPad] < GhostPlayGroup[WhichPad])
        /*next play position*/
        {
          PadPressed[CaptainPad[WhichPad]] = PAD_RIGHT;
			 return FALSE;
        }
        else if(CurrPlay[WhichPad] > GhostPlayGroup[WhichPad])
        {
          PadPressed[CaptainPad[WhichPad]] = PAD_LEFT;
          return FALSE;
        }
      }
    }
    else
    /*else do nothing with the screen, wait 5 seconds and return true*/
    {
      /*return true if ghost selected the play and five or more seconds passed*/
      if(GhostEndTime[WhichPad] < TimeNow)
    	return TRUE;
      else
        return FALSE;
    }
  }
  else
  {
    /*else return false*/
    return FALSE;
  }

}



#if 0
	the following load of crap was found rotting in InitDPC data

		PadPressed[i] =   0;

	/*init hor/ver to 0 only if no play/formation selected yet*/
	/*  above not right - if "new" PC, use last PC variables	*/
		if(GameTeamData[i].PlayNum == -1 || GameTeamData[i].FormationNumber == -1)
		{
//			CurrFormation[i] = 0;
//			CurrPlay[i]      = 0;
			CurrFormation[i] = PrevFormation[i];
			CurrPlay[i]      = (PrevPlay[i] / 3) * 3; // must be mult of 3 for ghost
			DebugPrintf(0, "CurrPlay[%d] = %d", i, CurrPlay[i]);
		}

	/*Position the sliders as needed*/

	/*if the status of the team changed, go to formation 0, play 0*/
		if(LastOffDefStatus[i] == -1)
		{
	  /*if the flag is not inited, init it*/
			LastOffDefStatus[i] = OffDefFlag;
		}
		else
		{  /*  else see if the status has changed  */
			if(LastOffDefStatus[i] != OffDefFlag)
	  /*if the status has changed, reset CurrPlay[i], CurrFormation[i]*/
			{
				LastOffDefStatus[i] = OffDefFlag;
				CurrPlay[i] = CurrFormation[i] = 0;
			}
		}

	/*if previous play was a KICKOFF_PLAY or EX_PT1_PLAY, put cursor at 0*/
//		if(PreviousPlayType == KICKOFF_PLAY || PreviousPlayType == EX_PT1_PLAY)
		if(PreviousPlayType >= EX_PT1_PLAY)	// Okay for any EX pt or KO - mjk 11/7/96
		{
			CurrFormation[i] = CurrPlay[i] = 0;
		}

	/*init hor=5 ver=0 if kickoff*/
		if(PlayType == KICKOFF_PLAY)
		{
			CurrFormation[i] = 5;
			CurrPlay[i]      = 0;
		}
		else if(PlayType == EX_PT1_PLAY)
		{
	  /*init hor=5 ver=0 if extra play. we can make in anything we want*/
			CurrFormation[i] = 5;	// SPECIAL TEAMS
			if(OffDefFlag == ON_DEFENSE)
			{
				CurrPlay[i] = 3;
			}
			else
			{
				CurrPlay[i] = 0;
			}
		}

	/*if fourth down, go to punt*/
		if(TheDown == 4)
		{
			CurrFormation[i] = 5;	// Special teams
			if(OffDefFlag == ON_OFFENSE)
			{
				CurrPlay[i] = 3;	// assume punt
			}
			else
				CurrPlay[i] = 0;	// assume punt return

		}





	/*** following new code 11/8/96 - mjk   -------------*/
		PadPressed[i] =  //  0;




			cplay = cform = 0;	// assume slider will be here

			// will be 0,0 if status changed or prev. play was KO or EXpt,
		if(LastOffDefStatus[i] == OffDefFlag // same status as before
		   && PreviousPlayType < EX_PT1_PLAY)	// Okay for any EX pt or KO - mjk 11/7/96
		{
			if(PlayType == KICKOFF_PLAY)	/*init hor=5 ver=0 if kickoff*/
			{
				cform = 5;	// both off & def
			//	cplay = 0;
			}
			else if(PlayType == EX_PT1_PLAY)
			{	  /*init hor=5 ver=0 if extra play .*/
				cform = 5;	// SPECIAL TEAMS

				if(OffDefFlag == ON_DEFENSE)
				{
					cplay = 3;
				}   // offense uses cplay=0
			}
			else if(TheDown == 4)	/*  if fourth down, go to punt/return  */
			{
				cform = 5;	// SPECIAL TEAMS - off. & def.

				if(StartBallX < OFF_GOAL_LINE-32*YARD)
				{ //  punt
					if(OffDefFlag == ON_OFFENSE)
					{
						cplay = 3;	// set up for punt
					}	// def--> cp =0 (punt return)
				}
				else	//Field goal
				{
					if(OffDefFlag == ON_DEFENSE)
					{
						cplay = 3;	//11 man rush
					}	// off--> cp =0 (FG)
				}
			}
			else if(GameTeamData[i].PlayNum == -1 || GameTeamData[i].FormationNumber == -1)
			{	// if "new" PlayCall, use last PC variables
				cform = PrevFormation[i];
				cplay = PrevPlay[i];
			}


		}

	/*Check for edited formations*/
		if (PlayType == EX_PT2_PLAY)
		{
			maxforms = 4;	// MRH - Don't show special on 2 point conversion
		}
		else if(GameTeamData[i].UseEditedPlays[OffDefFlag] == 0)
		{
			maxforms = 5;
		}
		else	// if edited (or Easter egg_ plays)
		{
			maxforms = 6;
		}
		if(cform > maxforms)	// just to be sure (ex 2pt ??)
			cform = maxforms;

		/***  move locals to global	(sounds like a Nick comment)	*/
		CurrFormation[i] = cform;
		CurrPlay[i] = cplay;
		MaxFormations[i] = maxforms;
		LastOffDefStatus[i] = OffDefFlag; // save whether off or def

		AdjustCurrPlayToMatchFormGrid(i);	// if switched from Run/Pass to From based

	/*** end new code 11/8/96 - mjk   -------------*/

#endif
/*****************************END OF FILE DPCSHL.C****************************/



//Uint16 Formation_LINES[] = {
//	5, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 3,
//
//	4, 4, 4, 4, 4, 2,
//
//	0,0,0,0,
//
//	1, 1
//};
//

Uint16 SORTFormation_LINES[2][2][7];

Uint16 SORTdFormation[2][7][30];
Uint16 SORToFormation[2][7][30];


/* SORT TEAM FORMATIONS BY PLAYTYPES */

/*

void SORToFormations(Uint16 formation, Uint16 team)
{
	Uint16 numoff = (Formation_LINES[formation] * 3);
	Uint16 plays;

	Uint16 *formptr = (Uint16 *)GetPlaysPerForm(formation);

	if(numoff)
	{
		for(plays = 0; plays < numoff; plays++)
		{
			Uint16 play = *(formptr + plays);
			Uint16 playtype = ThePlays[play].PlayTypeDesignator - 1;

			SORToFormation[team][playtype]
				[SORTFormation_LINES[0][team][playtype]++] = play;
		}
	}
}


void SORToGOPTIONS(Uint16 team, Uint16 page)
{
	Sint16 plays = SORTFormation_LINES[0][team][page];
	Uint16 count;

	while(plays > 0) {plays -= 3;}

	plays = -plays;

	for(count = 0; count < plays; count++)
	{
		SORToFormation[team][page][SORTFormation_LINES[0][team][page]++] =
			SORToFormation[team][page][count];
	}

	SORTFormation_LINES[0][team][page] /= 3;
}


void SORTdFormations(Uint16 formation, Uint16 team)
{
	Uint16 numoff = (Formation_LINES[formation] * 3);
	Uint16 plays;

	Uint16 *formptr = (Uint16 *)GetPlaysPerForm(formation);

	if(numoff)
	{
		for(plays = 0; plays < numoff; plays++)
		{
			Uint16 play = *(formptr + plays);
			Uint16 playbits = ThePlays[play].PlayTypeDesignator >> 8;

			Uint16 playtype;

			for(playtype = 0; playtype < 7; playtype++)
			{
				if(playbits & 0x01) SORTdFormation[team][playtype]
						[SORTFormation_LINES[1][team][playtype]++] = play;

				playbits >>= 1;
			}
		}
	}
}

void SORTdGOPTIONS(Uint16 team, Uint16 page)
{
	Sint16 plays = SORTFormation_LINES[1][team][page];
	Uint16 count;

	while(plays > 0) {plays -= 3;}

	plays = -plays;

	for(count = 0; count < plays; count++)
	{
		SORTdFormation[team][page][SORTFormation_LINES[1][team][page]++] =
			SORTdFormation[team][page][count];
	}

	SORTFormation_LINES[1][team][page] /= 3;
}
*/


/* CREATE TEAM EDITED PLAYS */

Sint32 pbase[2]={T0Edit0NUM,T1Edit0NUM};


void CREATEoEditPlays(Uint16 team)
{
	Uint32 formation;
	Uint32 nplay,count, fplays;
	Uint32 plays;
	Uint32 numoff = 0;
	Uint16 *formptr;
	Uint8 *from, *to;



	// Simply initialize edit play numbers

	formation =  TEAM0_EDIT_FORM_NUM + team;

	formptr = (Uint16 *)GetPlaysPerForm(formation);

	for(plays = 0; plays < 24; plays++)
			*(formptr + plays) = pbase[team]+plays;

	DebugPrintf(0,"%d = team\n",team);

	while(pEDIT_PLAYS[numoff+(team*24)].Formation >= 0 && numoff < (24)){ numoff++; }

	if(numoff)
	{
		fplays = 0;


		while (numoff%3)
		{
			PopPLAY(numoff-1+(team*24));
			numoff++;
			PushPLAY(numoff-1+(team*24));
		}

		for(plays = 0; plays < numoff; plays++)
		{
			formptr = (Uint16 *)GetPlaysPerForm(formation);

			if(plays < numoff)
				nplay = *(formptr + fplays);
			else
				nplay = *(formptr + (numoff-1));

			from	= (Uint8 *)&pEDIT_PLAYS[plays+(team*24)].ThePlay;
			to	= (Uint8 *)&ThePlays[nplay];

			SORToFormation[team][6]
				[SORTFormation_LINES[0][team][6]++] = nplay;

			strcpy(PlayNames[nplay], pEDIT_PLAYS[plays+(team*24)].Name);

			memcpy(to, from, sizeof(struct play));

			fplays++;
		}
	}

	// And finally terminate the list

	formptr = (Uint16 *)GetPlaysPerForm(formation);

	*(formptr + fplays) = -1;
}


//***************************************************************************
// Create bitmap play image in RAM for edited plays
//***************************************************************************


/*
void CreateEditedBitmap(void)
{
	int count;


	while(pEDIT_PLAYS[i].Formation <= 0)
	{

		for(count = 6; count >= 1; count--)
		{
			if(count != pEDIT_ThePLAY.BallCarrier &&
					count != pEDIT_ThePLAY.Third)
			{
				MapPLAYER(count);

				if(pEDIT_ThePLAY.Bitmap[count] != ANone)
							MapARROW(count);
			}
		}

		if(pEDIT_ThePLAY.Third >= 0)
		{
			MapPLAYER(pEDIT_ThePLAY.Third);

			MapARROW(pEDIT_ThePLAY.Third);
		}

		MapPLAYER(0);

		if(pEDIT_ThePLAY.BallCarrier >= 1)
		{
			MapPLAYER(pEDIT_ThePLAY.BallCarrier);

			MapARROW(pEDIT_ThePLAY.BallCarrier);
		}

		if(pEDIT_ThePLAY.Bitmap[0] != ANone)
			MapARROW(0);

		}
	}
}
*/


//***************************************************************************

char *bmap;
RECT rect;

void BuildPlayBitmap(Sint16 template, Sint16 polynum, int playnum)
{
	int count;
	PLAYEDIT *playptr;

	playptr = &pEDIT_PLAYS[playnum];


	if(TemplateBuff) bmap = (char *) TemplateBuff;
	else bmap = (char *)AllocMem(64 * 128);	// TEST ONLY

	memset(bmap, 0, 64*128);

	for(count = 6; count >= 1; count--)
	{
		if(count != playptr->BallCarrier &&
			count != playptr->Third)
		{
			LoadPLAYER(count, template, polynum, playptr);
			if(playptr->Bitmap[count] != ANone)
				LoadARROW(count, template, polynum, playptr);
		}
	}

	if(playptr->Third >= 0)
	{
		LoadPLAYER(playptr->Third, template, polynum, playptr);

		LoadARROW(playptr->Third, template, polynum, playptr);
	}

	LoadPLAYER(0, template, polynum, playptr);

	if(playptr->BallCarrier >= 1)
	{
		LoadPLAYER(playptr->BallCarrier, template, polynum, playptr);

		LoadARROW(playptr->BallCarrier, template, polynum, playptr);
	}

	if(playptr->Bitmap[0] != ANone)
		LoadARROW(0, template, polynum, playptr);

	LoadImage(&rect, (unsigned long *)bmap);

	DrawSync(0);

	if(!TemplateBuff) FreeMem(bmap);
}


//***************************************************************************


void LoadARROW(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr)
{
	char string[14];
	Sint16 bitmap = playptr->Bitmap[player];

	strcpy(string,ArrowNames[bitmap & 0x7fff]);
	strcat(string, ".CMP");

	ColorConvert[1]= (playptr->Color[player] << 1)+1;
	ColorConvert[2]= (playptr->Color[player] << 1)+2;

	CPUDraw(player, template_index, polynum,
				ARROWS_width[bitmap & 0x7fff] >> 1, ARROWS_height[bitmap & 0x7fff],
				playptr->ARROWposX[player] >> 1, playptr->ARROWposY[player],
				string, bitmap & 0x8000, TRUE);
}


//***************************************************************************


void LoadPLAYER(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr)
{
	char string[14];
	char *buffer;
	Uint16 posx;
	Uint16 posy;


//	if(player == 6) playptr->FORMposY[player]--;

	if(playptr->Formation == FORMS_ISlot)
		sprintf(string, Sprite_FormNames[SpriteIS_FormBits[player]]);
	else
		sprintf(string, Sprite_FormNames[Sprite_FormBits[player]]);

	strcat(string, ".CMP");

	ColorConvert[1]= 1;
	ColorConvert[2]= 2;

	CPUDraw(player, template_index, polynum,
				PLAYERS_width[player] >> 1, 8,
				playptr->FORMposX[player] >> 1, playptr->FORMposY[player],
				string, FALSE, TRUE);
}


//***************************************************************************


void CPUDraw(Uint16 player, Sint16 template_index, Sint16 polynum, Sint16 w, Sint16 h, Sint16 posx, Sint16 posy, char *string, Uint16 flip, char colflag)
{
	Uint32 *clut;
	char *buffer1, *buffer2, *ptr1, *ptr2;
	char *wptr1, *wptr2;
	Sint16 i, j;
	Sint16 offset, buffwidth;

//	return;

	buffer1 = (char *)AllocMem(64 * 128);

	DecompressFrameBytes((unsigned long *)buffer1, GetMultiFilePtr(Arrows_MFile, string));

	rect.w = ((template[template_index].poly[polynum].u1 - template[template_index].poly[polynum].u0)+1) >> 2;
	rect.h = template[template_index].poly[polynum].v2 - template[template_index].poly[polynum].v0;

	rect.x = (template[template_index].poly[polynum].u0 >> 2) + template[template_index].vram->x;
	rect.y = template[template_index].poly[polynum].v0 + template[template_index].vram->y;


	buffwidth = ((template[template_index].poly[polynum].u1 - template[template_index].poly[polynum].u0)+1) >> 1;


	if(flip)
	{
		buffer2 = (char *)AllocMem(64 * 128);

		ptr1 = buffer1;


		for(j = 0; j < h; j++)
		{

			ptr2 = buffer2 + (((j+1) * w)-1);

			for(i = 0; i < w; i++)
			{

				if(ptr2 < buffer2+(64*128))
				{
					*ptr2 = (*ptr1 >> 4) | (*ptr1 << 4);
				}

				ptr1++;
				ptr2--;
			}
		}

		FreeMem(buffer1);

		buffer1 = buffer2;
	}


	if(colflag)
	{
		ptr1 = buffer1;

		for(j = 0; j < h*w; j++)
		{
			if(ptr1 < buffer1+(64*128))
				*ptr1 = ColorConvert[*ptr1 & 0x0F] | ColorConvert[*ptr1 >> 4] << 4;
			ptr1++;
		}
	}

	wptr1 = buffer1;

	for(j = 0; j < h; j++)
	{
		wptr2 = (bmap + posx + ((posy+j) * buffwidth));

		if(wptr2 > bmap)
		{

			for(i = 0; i < w; i++)
			{
				if(*wptr1)
				{
					if(*wptr1 & 0xF0)
					{
						*wptr2 &= 0x0F;
						*wptr2 |= *wptr1 & 0xF0;
					}

					if(*wptr1 & 0x0F)
					{
						*wptr2 &= 0xF0;
						*wptr2 |= *wptr1 & 0x0F;
					}
				}

				wptr1++;
				wptr2++;

			}

		}
	}

	FreeMem(buffer1);
}


//****************************************************************
