/***********************************************************************
*dpcshl.h                                                              *
*Shell-play selection function                                         *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
*Started on 3/14/1995                                                  *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/

/*general purpose defines*/
#define TIMEOUT_AT 20  /*how long to wait before shuting down shell in sec.*/
#define BLANK_PLAY_STRING "                "
#define BLANK_FORM_STRING "           "
//#define FONT_COLOR 0
#define FONT_COLOR 0

/*defines used to reference sector array*/
#define	DEFENSIVE_PLAYS  0
#define OFFENSIVE_PLAYS	 1

#define	KICK_OFF_PLAY    0
#define	EXTRA_POINT_PLAY 1
#define	NORMAL_GAME_PLAY 2

/*which template is which*/
#define	DEFPLAYS_TEMPLATE 0
#define	OFFPLAYS_TEMPLATE 1
#define	BUTTONS_TEMPLATE  2


// BUTTONS polygons
#define	TEAM0 0
#define	TEAM1 1
#define	FORMBACK0 2
#define	FORMBACK1 3
#define	BAR0 4
#define	BAR1 5
#define	FLIP_PLAY 6

/*resizes for the string*/
#define	VER_TEXT_RESIZE   -5
#define	HOR_TEXT_RESIZE   -6

/*font color codes*/
#define	FORMATIONS_TEXT_COLOR 0
#define	PLAYS_TEXT_COLOR 0
#define	SCORE_TEXT_COLOR 0
#define	DEFENSE_TEAM_NAME_TEXT_COLOR 0
#define	OFFENSE_TEAM_NAME_TEXT_COLOR 0
#define	DIGITAL_TEXT_COLOR 2

/*structures*/
#define FORMATION_MODE 0
#define RUNPASS_MODE 1


extern int CaptainPad[2];

struct FormGridStruct{
                       int  FormationNumber;/*if formation mode, the actual formation number, else -2*/
                       char *FormationName;/*name to be displayed on the button*/
                       int  FormationType; /*formation or pass/run*/
                       int  PlaysMax;      /*how many plays in this formation*/
                       int  Plays[30];     /*actual plays*/
                     };

/*function prototypes*/
void Display_Play_Call_Shell();
void Init_DPC_Data(int ForceInit);
int Init_DPC_Sectors();
int  DPC_Frame();

int MirrorPlay(int WhichPad);
int SelectPlay(int WhichPad, int PadPressed);
int DisplayNewFormation(int PadPressed, int WhichPad);
int DisplayNewPlay(int PadPressed, int WhichPad);
int DisplayEditedPlayBitmaps(int WhichPad);
int DisplayPlayBitmaps(int WhichPad);
int InterrogateCard(void);
int CheckTimer(int WhichPad);
int Paint_DPC_Screen(void);
int CleanUp_DPC(void);
int Shell_Frame_DPC(void);
void Init_Formation_Grid(void);
int DisplayFormationButtons(int WhichPad);
void VanishPlays(int WhichPad);
void FlipMirror();
void ShowFlip();
void HideFlip();
void HandleFlip_ON_OFF(int WhichPad);
int FindGridFormationSlot(int WhichPad, int PlayNum, int *FormationPos, int *PlayGroup, int *SpecificPlay);
void SetEditedFlag(int tm);
void DisplayPlayGraphics(int team);

/****************************END OF FILE DPCSHL.H**************************/
