/**********************************************************************

			FBAI2GRP.H	(FootBall AI to GRaPhic animation tables)

	AUTHOR: M. Knauer				Start Date: 1/16/96
	Modification History/Dates:
		April 1997 for new motion-captured anim


	Copyright 1996,1997  GameTek, Inc.



	This file contains PLAYER  AI GRAPHIC Data.

	It is an INCLUDED file.  (but it actually contains real data)

	****  INCLUDED in FBAIData.c   -----------------------

	It contains AI (logical) animations tables which allow a logical
	animation to be made up of different physical animations.
	E.G.  the 4 frame logical "funky dance" animation could be
	made up of:

		PG_STAND,2		// physical(actual) standing frame #2
		PG_RUNNING,4    // physical running frame #4
		PG_KICK,3       // physical kicking frame #3
		PG_BLOCK,0      // physical blocking frame #0


	See file "fbaigrap.h" for more info.
	Num. of physical frames in "fbpgdata.h"

**************************************************************/


// use macros so "C" is hidden from whoever edits this list

#define AIGraphics(xyz) struct actualgraphics xyz[] = {
#define AIGraphicsOffsets(xyz) struct  Point3D xyz##Offsets[] = {
#define EndAIGraphics	0xff,0xff};


AIGraphicsOffsets(NO)	//dummy holder actually NOOffsets
EndAIGraphics



AIGraphics(AI_RUNNING)	// 10--> 8 frames
#if 1
	PG_RUNNING_NUM,0,	// first removed 0,5  - Steve wants 4,9
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,4,	// removed for 15 HTZ anims
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,9,	// removed for 15 HTZ anims
#else
	PG_RUNNING_NUM,0,	// Clifford wants to try this
	PG_RUNNING_NUM,0,
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,4,
	PG_RUNNING_NUM,4,
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,9,
	PG_RUNNING_NUM,9,
#endif
EndAIGraphics


AIGraphics(AI_WALKING)
#if 1
	PG_RUNNING_NUM,0,
	PG_RUNNING_NUM,0,
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,4,
	PG_RUNNING_NUM,4,
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,9,
	PG_RUNNING_NUM,9,
#else
	PG_WALKING_NUM,0,	// NO Walking anim - graphics use running
	PG_WALKING_NUM,1,
	PG_WALKING_NUM,2,
	PG_WALKING_NUM,3,
	PG_WALKING_NUM,4,
	PG_WALKING_NUM,5,
	PG_WALKING_NUM,6,
	PG_WALKING_NUM,7,
	PG_WALKING_NUM,8,
	PG_WALKING_NUM,9,
#endif
EndAIGraphics

AIGraphics(AI_RUNNINGWITHBALL)
	PG_RUNNINGWITHBALL_NUM,0,
	PG_RUNNINGWITHBALL_NUM,1,
	PG_RUNNINGWITHBALL_NUM,2,
	PG_RUNNINGWITHBALL_NUM,3,
	PG_RUNNINGWITHBALL_NUM,4,		// removed for 15 HTZ anims
	PG_RUNNINGWITHBALL_NUM,5,
	PG_RUNNINGWITHBALL_NUM,6,
	PG_RUNNINGWITHBALL_NUM,7,
	PG_RUNNINGWITHBALL_NUM,8,
	PG_RUNNINGWITHBALL_NUM,9,			// removed for 15 HTZ anims

EndAIGraphics


AIGraphics(AI_RUNNINGCATCH)	// before ball gets there
#if 1					// 4/21/97 - running catch obsolete -
	PG_RUNNING_NUM,0,
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,4,
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,9,

#else
	PG_RUNNINGCATCH_NUM,0,
	PG_RUNNINGCATCH_NUM,1,
	PG_RUNNINGCATCH_NUM,2,
	PG_RUNNINGCATCH_NUM,3,
	PG_RUNNINGCATCH_NUM,4,
	PG_RUNNINGCATCH_NUM,5,
	PG_RUNNINGCATCH_NUM,6,
	PG_RUNNINGCATCH_NUM,7,
	PG_RUNNINGCATCH_NUM,8,
	PG_RUNNINGCATCH_NUM,9,
#endif
EndAIGraphics


AIGraphics(AI_RUNNINGCAUGHT)	// immediately after he catches ball
	PG_RUNNINGCATCH_NUM,0,
	PG_RUNNINGCATCH_NUM,1,
	PG_RUNNINGCATCH_NUM,2,
	PG_RUNNINGCATCH_NUM,3,
	PG_RUNNINGCATCH_NUM,4,
EndAIGraphics



AIGraphics(AI_3PTSTANCE)
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,2,
EndAIGraphics


AIGraphics(AI_4PTSTANCE)
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,3,
	PG_4PTSTANCE_NUM,3,
	PG_4PTSTANCE_NUM,4,
	PG_4PTSTANCE_NUM,4,
EndAIGraphics

AIGraphics(AI_2PTSTANCE)
	PG_4PTSTANCE_NUM,0,
EndAIGraphics


AIGraphics(AI_GOTOHOLDER)
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,2,
	PG_FGHOLDER_NUM,0,		// ball not in hands
EndAIGraphics

AIGraphics(AI_FGHOLDER)
	PG_FGHOLDER_NUM,0,  // ball not in hands
	PG_FGHOLDER_NUM,1,  // hands out - ball in hands
	PG_FGHOLDER_NUM,2,	// hands down - ball in hands - freeze here until kick
	PG_FGHOLDER_NUM,3,	// ball not in hands
//	PG_FGHOLDER_NUM,4,
EndAIGraphics

//AIGraphics(AI_FGHOLDER_AFTER_KICK)
//	PG_FGHOLDER_NUM,3,		// not holding ball
//EndAIGraphics


AIGraphics(AI_DOWN_PUNT)
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics



AIGraphics(AI_PASSING)
	PG_PASSING_NUM,0,
	PG_PASSING_NUM,1,
	PG_PASSING_NUM,2,
	PG_PASSING_NUM,3,

	PG_PASSING_NUM,4,
	PG_PASSING_NUM,5,	// release frame
	PG_PASSING_NUM,6,
	PG_PASSING_NUM,6,
	PG_PASSING_NUM,6,
	PG_PASSING_NUM,6,
EndAIGraphics


AIGraphics(AI_GP_SPIKE)	// spike over goalpost
	PG_HANDSUP_NUM,0,
	PG_HANDSUP_NUM,0,
	PG_HANDSUP_NUM,1,
	PG_HANDSUP_NUM,1,

	PG_PASSING_NUM,3,
	PG_PASSING_NUM,3,
	PG_PASSING_NUM,3,
	PG_PASSING_NUM,3,

//	PG_PASSING_NUM,4,
	PG_PASSING_NUM,4,
	PG_PASSING_NUM,4,
	PG_PASSING_NUM,5,	// release frame

	PG_PASSING_NUM,6,
	PG_PASSING_NUM,6,
	PG_PASSING_NUM,5,	// release frame
EndAIGraphics


AIGraphicsOffsets(AI_GP_SPIKE)	//x,y,z
		0,0,0,				// MUST match num frame in AI SPIKE
		0,0,0,
		0,0,0,
		0,0,(8*INCHES),

		0,0,(14*INCHES),
		0,0,(17*INCHES),
		0,0,(17*INCHES),
		0,0,(12*INCHES),

//		0,0,(12*INCHES),
		0,0,(8*INCHES),
		0,0,(4*INCHES),
		0,0,(4*INCHES),

		0,0,-(4*INCHES),
		0,0,-(4*INCHES),
		0,0,-(12*INCHES),

EndAIGraphics


AIGraphics(AI_PUMPFAKE)
//	PG_PASSING_NUM,0,
	PG_PASSING_NUM,1,
	PG_PASSING_NUM,2,
	PG_PASSING_NUM,3,

	PG_PASSING_NUM,4,
//	PG_PASSING_NUM,4,
	PG_PASSING_NUM,3,
	PG_PASSING_NUM,2,
	PG_PASSING_NUM,1,
EndAIGraphics


AIGraphics(AI_BACKPEDAL_WBALL)
	PG_BACKPEDAL_WBALL_NUM,0,
	PG_BACKPEDAL_WBALL_NUM,1,
	PG_BACKPEDAL_WBALL_NUM,2,
	PG_BACKPEDAL_WBALL_NUM,3,
	PG_BACKPEDAL_WBALL_NUM,4,
	PG_BACKPEDAL_WBALL_NUM,5,
EndAIGraphics


AIGraphics(AI_BACKPEDAL)
	PG_BACKPEDAL_NUM,0,
	PG_BACKPEDAL_NUM,1,
	PG_BACKPEDAL_NUM,2,
	PG_BACKPEDAL_NUM,3,
	PG_BACKPEDAL_NUM,4,
	PG_BACKPEDAL_NUM,5,
//	PG_BACKPEDAL_NUM,6,
//	PG_BACKPEDAL_NUM,7,
EndAIGraphics



AIGraphics(AI_HANDSUP)	// jump up - used only for spike over GP
	PG_HANDSUP_NUM,0,	// (see AI_JUMPUP - new 10/22/96)
	PG_HANDSUP_NUM,0,
//	PG_HANDSUP_NUM,0,   	// removed for 15 HTZ anims
	PG_HANDSUP_NUM,1,	// code forces land on this frame
	PG_HANDSUP_NUM,2,
EndAIGraphics



AIGraphics(AI_HURDLEWITHBALL)
	PG_BURST_NUM,0,
	PG_BURST_NUM,1,
	PG_RUNNINGWITHBALL_NUM,4,
	PG_BURST_NUM,2,
	PG_BURST_NUM,2,
	PG_BURST_NUM,3,
	PG_BURST_NUM,3,
	PG_BURST_NUM,1,
	PG_BURST_NUM,4,
	PG_RUNNINGWITHBALL_NUM,3,
EndAIGraphics



// 20 hertz anim update
AIGraphics(AI_BLOCKING)	// hold all frames if 20 hertz
#if 1
	PG_BLOCKING_NUM,0,
	PG_BLOCKING_NUM,1,
	PG_BLOCKING_NUM,2,
	PG_BLOCKING_NUM,3,
	PG_BLOCKING_NUM,4,
	PG_BLOCKING_NUM,5,
	PG_BLOCKING_NUM,5,
	PG_BLOCKING_NUM,5,
#else
	PG_BLOCKING_NUM,0,
	PG_BLOCKING_NUM,0,
	PG_BLOCKING_NUM,1,
	PG_BLOCKING_NUM,1,
	PG_BLOCKING_NUM,2,
	PG_BLOCKING_NUM,2,
	PG_BLOCKING_NUM,3,
	PG_BLOCKING_NUM,3,
#endif
EndAIGraphics

AIGraphics(AI_BLOCKING_WAIT)
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,

	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,

	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,

//	PG_SHUFFLE_NUM,0, 	// standing
//	PG_SHUFFLE_NUM,0, 	// standing
//	PG_SHUFFLE_NUM,0, 	// standing
//	PG_SHUFFLE_NUM,0, 	// standing

	PG_BLOCKING_NUM,0,
	PG_BLOCKING_NUM,0,
	PG_BLOCKING_NUM,0,
	PG_BLOCKING_NUM,0,

	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,

	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,

//	PG_SHUFFLE_NUM,0, 	// standing
//	PG_SHUFFLE_NUM,0, 	// standing
//	PG_SHUFFLE_NUM,0, 	// standing
	PG_BLOCKING_NUM,1,
	PG_BLOCKING_NUM,1,
	PG_BLOCKING_NUM,1,

EndAIGraphics


AIGraphics(AI_KICKING)
	PG_KICKING_NUM,0,
	PG_KICKING_NUM,1,
	PG_KICKING_NUM,2,
	PG_KICKING_NUM,3,
	PG_KICKING_NUM,4,

	PG_KICKING_NUM,5,
	PG_KICKING_NUM,6,
	PG_KICKING_NUM,7,
	PG_KICKING_NUM,8,
	PG_KICKING_NUM,8,
	PG_KICKING_NUM,8,
EndAIGraphics



#if 0	// obsolete 4/21/97
AIGraphicsOffsets(AI_KICKING)	//x,y,z
		0,0,0,					// MUST match num frame in AI KICKING
		0,0,0,
		0,0,0,
		0,0,0,
		0,0,(12*INCHES),

		0,0,(8*INCHES),
		0,0,(4*INCHES),
		0,0,-(4*INCHES),
		0,0,-(8*INCHES),
		0,0,-(12*INCHES),
EndAIGraphics
#endif

AIGraphics(AI_PUNTING)
	PG_PUNTING_NUM,0,
	PG_PUNTING_NUM,1,
	PG_PUNTING_NUM,2,
	PG_PUNTING_NUM,3,
	PG_PUNTING_NUM,4,

	PG_PUNTING_NUM,5,
	PG_PUNTING_NUM,6,
	PG_PUNTING_NUM,7,
	PG_PUNTING_NUM,8,
	PG_PUNTING_NUM,9,

	PG_PUNTING_NUM,9,
EndAIGraphics


AIGraphicsOffsets(AI_PUNTING)	//x,y,z
		0,0,0,					// MUST match num frame in AI KICKING
		0,0,0,
		0,0,0,
		0,0,0,
		0,0,0,

		0,0,0,
		0,0,0,
		
		0,0,0,
		0,0,0,
		0,0,0,
		0,0,0,
		
//		0,0,(12*INCHES),	//old
//		0,0,(9*INCHES),
//		0,0,-(9*INCHES),

//		0,0,-(12*INCHES),

EndAIGraphics



AIGraphics(AI_QBPITCH) 	// as of 6/26/96 , 1 frame in 5 dirs
	PG_QBPITCH_NUM,0,	// Ball in QB hands
EndAIGraphics


AIGraphics(AI_DIVE)		// and tackler
	PG_DIVE_NUM,0,
	PG_DIVE_NUM,0,
	PG_DIVE_NUM,1,
	PG_DIVE_NUM,1,
	PG_DIVE_NUM,2,

	PG_DIVE_NUM,2,
	PG_DIVE_NUM,2,
	PG_DIVE_NUM,3,
	PG_DIVE_NUM,3,
					//	PG_DIVE_NUM,3,	// removed for 15 HTZ anim
	PG_DIVE_NUM,4,

	PG_DIVE_NUM,4,
	PG_DIVE_NUM,5,
	PG_DIVE_NUM,5,
/*  below are extra frames only if rain or snow	*/
	PG_DIVE_NUM,5,
	PG_DIVE_NUM,5,
	PG_DIVE_NUM,5,
	PG_DIVE_NUM,5,

	PG_DIVE_NUM,5,	// snow
	PG_DIVE_NUM,5,
	PG_DIVE_NUM,5,

EndAIGraphics

#define DIVE_FRAME_HEIGHT (4*INCHES)	// new for 15 HTZ anims
//#define DIVE_FRAME_HEIGHT (3*INCHES)

AIGraphicsOffsets(AI_DIVE)	//x,y,z
		0,0,DIVE_FRAME_HEIGHT,		// MUST match num frames in AI DIVE
		0,0,DIVE_FRAME_HEIGHT,	// height is incremental
		0,0,DIVE_FRAME_HEIGHT,
		0,0,DIVE_FRAME_HEIGHT/2,
		0,0,DIVE_FRAME_HEIGHT/2,

		0,0,-DIVE_FRAME_HEIGHT/2,	// jumped too high (10/29/96)
		0,0,-DIVE_FRAME_HEIGHT/2,
		0,0,-DIVE_FRAME_HEIGHT,
		0,0,-DIVE_FRAME_HEIGHT,
		0,0,-DIVE_FRAME_HEIGHT,

//		0,0,0,
		0,0,0,
		0,0,0,
		0,0,0,
/*  below are extra frames only if rain or snow	*/
		0,0,0,
		0,0,0,	// 2 extra frames for s
		0,0,0,
		0,0,0,

		0,0,0,
		0,0,0,
		0,0,0,
EndAIGraphics


// 9/12/96  - added extra frames for seq. 0,1,2
AIGraphics(AI_TACKLED_FFS)		//FFS- always there
	PG_FALLONBELLY_NUM,0,
	PG_FALLONBELLY_NUM,0,
	PG_FALLONBELLY_NUM,0,
	PG_FALLONBELLY_NUM,1,
	PG_FALLONBELLY_NUM,1,
	PG_FALLONBELLY_NUM,1,
	PG_FALLONBELLY_NUM,2,
	PG_FALLONBELLY_NUM,2,
	PG_FALLONBELLY_NUM,2,
	PG_FALLONBELLY_NUM,3,
	PG_FALLONBELLY_NUM,4,
	PG_FALLONBELLY_NUM,4,
	PG_FALLONBELLY_NUM,3,
//	PG_FALLONBELLY_NUM,5,
EndAIGraphics

AIGraphics(AI_TACKLED_FFF)		// ABD dirs only
	PG_FALLONBELLY2_NUM,0,  // FFF or FFR - use same PG_num
	PG_FALLONBELLY2_NUM,0,
	PG_FALLONBELLY2_NUM,0,
	PG_FALLONBELLY2_NUM,1,
	PG_FALLONBELLY2_NUM,1,
	PG_FALLONBELLY2_NUM,1,
	PG_FALLONBELLY2_NUM,2,
	PG_FALLONBELLY2_NUM,2,
	PG_FALLONBELLY2_NUM,2,
	PG_FALLONBELLY2_NUM,3,
	PG_FALLONBELLY2_NUM,4,
	PG_FALLONBELLY2_NUM,4,
	PG_FALLONBELLY2_NUM,3,
EndAIGraphics

AIGraphics(AI_TACKLED_FFR)		// ABD dirs only
	PG_FALLONBELLY2_NUM,0,  // FFF or FFR -  use same PG_num
	PG_FALLONBELLY2_NUM,0,
	PG_FALLONBELLY2_NUM,0,
	PG_FALLONBELLY2_NUM,1,
	PG_FALLONBELLY2_NUM,1,
	PG_FALLONBELLY2_NUM,1,
	PG_FALLONBELLY2_NUM,2,
	PG_FALLONBELLY2_NUM,2,
	PG_FALLONBELLY2_NUM,2,
	PG_FALLONBELLY2_NUM,3,
	PG_FALLONBELLY2_NUM,4,
	PG_FALLONBELLY2_NUM,4,
	PG_FALLONBELLY2_NUM,3,
EndAIGraphics

AIGraphics(AI_TACKLED_FBB)	//FALLONBACK) 	// ABD dirs only
#if 1
	PG_FALLONBACK_NUM,0,	// FBB or FBF or FBR - use same PG_num
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,0,    // hold beginning for a while
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
//	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
//	PG_FALLONBACK_NUM,3,
	PG_FALLONBACK_NUM,3,
	PG_FALLONBACK_NUM,4,

#else	//old as of 4/24/97
	PG_FALLONBACK_NUM,0,	// FBB or FBF or FBR - use same PG_num
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,3,
	PG_FALLONBACK_NUM,4,
	PG_FALLONBACK_NUM,4,
	PG_FALLONBACK_NUM,3,
#endif
EndAIGraphics

AIGraphics(AI_TACKLED_FBF)	//FALLONBACK) 	// ABD dirs only
	PG_FALLONBACK_NUM,0,	// FBB or FBF or FBR - use same PG_num
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,3,
	PG_FALLONBACK_NUM,4,
	PG_FALLONBACK_NUM,4,
	PG_FALLONBACK_NUM,3,
EndAIGraphics

AIGraphics(AI_TACKLED_FBR)	//FALLONBACK) 	// ABD dirs only
	PG_FALLONBACK_NUM,0,	// FBB or FBF or FBR - use same PG_num
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,0,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,1,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,2,
	PG_FALLONBACK_NUM,3,
	PG_FALLONBACK_NUM,4,
	PG_FALLONBACK_NUM,4,
	PG_FALLONBACK_NUM,3,
EndAIGraphics


AIGraphics(AI_BC_DIVE)		// Ball Carrier Diving
	PG_DIVEBALL_NUM,0,
	PG_DIVEBALL_NUM,1,
	PG_FALLONBELLY_NUM,2,
	PG_FALLONBELLY_NUM,3,
	PG_FALLONBELLY_NUM,4,
	PG_FALLONBELLY_NUM,3,
EndAIGraphics


AIGraphics(AI_GETUPFROMBACK)
	PG_ROLL_NUM,0,		// roll tripled 8/6/96
	PG_ROLL_NUM,0,
	PG_ROLL_NUM,0,
	PG_ROLL_NUM,0,		// roll quadrupled 9/17/96
	PG_4PTSTANCE_NUM,3,	//get up doubled 8/6/96
	PG_4PTSTANCE_NUM,3,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,2, // how long will these changes last???
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,1,	// my guess - les than 24 hours
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics

AIGraphics(AI_GETUPFROMBELLY)
	PG_4PTSTANCE_NUM,3, //get up doubled 8/6/96
	PG_4PTSTANCE_NUM,3,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,2,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,1,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics

AIGraphics(AI_STAND)
	PG_SHUFFLE_NUM,0,
EndAIGraphics

// new 9/22/96 - longer delay
AIGraphics(AI_SHUFFLE)
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,

	PG_SHUFFLE_NUM,2,	// new stuff 9/22 - hold longer
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,

	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,

	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,

	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,2,
//	PG_SHUFFLE_NUM,2,
//	PG_SHUFFLE_NUM,2,

//	PG_SHUFFLE_NUM,2,
	PG_SHUFFLE_NUM,1,
	PG_SHUFFLE_NUM,1,
//	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,

	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,

	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,
	PG_SHUFFLE_NUM,0,

EndAIGraphics


AIGraphics(AI_SHUFFLEWITHBALL)
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
//	PG_SHUFFLEWITHBALL_NUM,0,		// removed for 15 HTZ anims
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,0,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,1,
	PG_SHUFFLEWITHBALL_NUM,0,
EndAIGraphics


AIGraphics(AI_TDCELEBRATE0)		// fake spike ball
	PG_SPIKEBALL_NUM,0,
	PG_SPIKEBALL_NUM,1,
	PG_SPIKEBALL_NUM,2,
	PG_SPIKEBALL_NUM,3,
	PG_SPIKEBALL_NUM,4,
	PG_SPIKEBALL_NUM,5,
	PG_SPIKEBALL_NUM,6,
	PG_SPIKEBALL_NUM,7,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,10,

	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,10,

	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,10,

EndAIGraphics

AIGraphics(AI_TDCELEBRATE1)		// cabbage patch
	PG_SPIKEBALL_NUM,0,
	PG_SPIKEBALL_NUM,1,
	PG_SPIKEBALL_NUM,2,
	PG_SPIKEBALL_NUM,3,
	PG_SPIKEBALL_NUM,4,
	PG_SPIKEBALL_NUM,5,
	PG_SPIKEBALL_NUM,6,
	PG_SPIKEBALL_NUM,7,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,11,

	PG_SPIKEBALL_NUM,0,
	PG_SPIKEBALL_NUM,1,
	PG_SPIKEBALL_NUM,2,
	PG_SPIKEBALL_NUM,3,
	PG_SPIKEBALL_NUM,4,
	PG_SPIKEBALL_NUM,5,
	PG_SPIKEBALL_NUM,6,
	PG_SPIKEBALL_NUM,7,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,11,

	PG_SPIKEBALL_NUM,0,
	PG_SPIKEBALL_NUM,1,
	PG_SPIKEBALL_NUM,2,
	PG_SPIKEBALL_NUM,3,
	PG_SPIKEBALL_NUM,4,
	PG_SPIKEBALL_NUM,5,
	PG_SPIKEBALL_NUM,6,
	PG_SPIKEBALL_NUM,7,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,11,

EndAIGraphics

AIGraphics(AI_TDCELEBRATE2)		// arms up strut
	PG_SPIKEBALL_NUM,0,
	PG_SPIKEBALL_NUM,1,
	PG_SPIKEBALL_NUM,2,
	PG_SPIKEBALL_NUM,3,
	PG_SPIKEBALL_NUM,4,
	PG_SPIKEBALL_NUM,5,
	PG_SPIKEBALL_NUM,6,
	PG_SPIKEBALL_NUM,7,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,11,

	PG_SPIKEBALL_NUM,10,
	PG_SPIKEBALL_NUM,9,
	PG_SPIKEBALL_NUM,8,
	PG_SPIKEBALL_NUM,7,
	PG_SPIKEBALL_NUM,6,
	PG_SPIKEBALL_NUM,5,
	PG_SPIKEBALL_NUM,4,
	PG_SPIKEBALL_NUM,3,
	PG_SPIKEBALL_NUM,2,
	PG_SPIKEBALL_NUM,1,
//	PG_SPIKEBALL_NUM,0,

EndAIGraphics


AIGraphics(AI_SIDESTEP)	// only E dir
	PG_SIDESTEP_NUM,0,
	PG_SIDESTEP_NUM,1,
	PG_SIDESTEP_NUM,2,
	PG_SIDESTEP_NUM,3,
	PG_SIDESTEP_NUM,4,
	PG_SIDESTEP_NUM,5,
EndAIGraphics

AIGraphics(AI_BURST)
	PG_BURST_NUM,0,
	PG_BURST_NUM,1,
	PG_BURST_NUM,2,
	PG_BURST_NUM,3,
	PG_BURST_NUM,4,
	PG_BURST_NUM,5,
EndAIGraphics


AIGraphics(AI_QBSLIDE)	//
	PG_QBSLIDE_NUM,0,
	PG_QBSLIDE_NUM,0,
	PG_QBSLIDE_NUM,0,
	PG_QBSLIDE_NUM,0,
//	PG_QBSLIDE_NUM,0,	// removed for 15 HTZ anim rate
//	PG_QBSLIDE_NUM,1,   // removed for 15 HTZ anim rate
	PG_QBSLIDE_NUM,1,
	PG_QBSLIDE_NUM,1,
	PG_QBSLIDE_NUM,1,
	PG_QBSLIDE_NUM,1,
	PG_QBSLIDE_NUM,1,
	PG_QBSLIDE_NUM,1,
	PG_QBSLIDE_NUM,1,
EndAIGraphics


AIGraphics(AI_RUNNING_HEADTURN)		// receiver while pass going up
	PG_RUNNING_NUM,0,
	PG_RUNNING_NUM,1,
	PG_RUNNING_NUM,2,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,4,	// removed for 15 HTZ anim rate
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,9,	// removed for 15 HTZ anim rate
	PG_RUNNINGHEADTURN_NUM,0,	// replaces 1,2,3 not 5,6,7
	PG_RUNNINGHEADTURN_NUM,1,
	PG_RUNNINGHEADTURN_NUM,2,
	PG_RUNNING_NUM,3,
	PG_RUNNING_NUM,4,   // removed for 15 HTZ anim rate
	PG_RUNNING_NUM,5,
	PG_RUNNING_NUM,6,
	PG_RUNNING_NUM,7,
	PG_RUNNING_NUM,8,
	PG_RUNNING_NUM,9,   // removed for 15 HTZ anim rate
EndAIGraphics

AIGraphics(AI_JUMPCATCH)	// only ABC dir
	PG_JUMPCATCH_NUM,0,
	PG_JUMPCATCH_NUM,0,
	PG_JUMPCATCH_NUM,0,

	PG_JUMPCATCH_NUM,1,
	PG_JUMPCATCH_NUM,1,
	PG_JUMPCATCH_NUM,1,
	PG_JUMPCATCH_NUM,1,

	PG_JUMPCATCH_NUM,2,
	PG_JUMPCATCH_NUM,2,
	PG_JUMPCATCH_NUM,2,
EndAIGraphics

AIGraphicsOffsets(AI_JUMPCATCH)
		0,0,0,		// MUST match num frames in cooresponding anim
		0,0,(6*INCHES),
		0,0,(6*INCHES),

		0,0,(5*INCHES),
		0,0,(4*INCHES),
		0,0,-(4*INCHES),
		0,0,-(5*INCHES),

		0,0,-(6*INCHES),
		0,0,-(6*INCHES),
		0,0,0,		// MUST match num frames in cooresponding anim
EndAIGraphics


						// newer 4/21/97 - 5 frames in jump
AIGraphics(AI_JUMPUP)	// jump up AND down-  new 10/22/96
	PG_HANDSUP_NUM,0,
	PG_HANDSUP_NUM,0,
	PG_HANDSUP_NUM,1,	// human starts here

	PG_HANDSUP_NUM,2,
	PG_HANDSUP_NUM,2,   //  ----- WARNING - if # of Frames change
	PG_HANDSUP_NUM,3,	//  ... Tables in FBMove.c MUST also change!!!!!
	PG_HANDSUP_NUM,4,

	PG_HANDSUP_NUM,4,

	PG_HANDSUP_NUM,4,
	PG_HANDSUP_NUM,3,
	PG_HANDSUP_NUM,2,
	PG_HANDSUP_NUM,2,

	PG_HANDSUP_NUM,1,	// code forces land on this frame
EndAIGraphics



#if 1	// testing only for Alpha version (no new QBPlayCAll)
AIGraphics(AI_QBPLAYCALL_L1)	// looks to or left
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics

AIGraphics(AI_QBPLAYCALL_L2)	// looks to left a little longer
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics

AIGraphics(AI_QBPLAYCALL_R1)	// looks to right
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics

AIGraphics(AI_QBPLAYCALL_R2)	// looks to right a little longer
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
	PG_4PTSTANCE_NUM,0,
EndAIGraphics

#else
AIGraphics(AI_QBPLAYCALL_L1)	// looks to or left
	PG_QBPLAYCALL_NUM,1,	// physical frame #1 looks forward
	PG_QBPLAYCALL_NUM,0,    // physical frame #0 looks to side
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
//	PG_QBPLAYCALL_NUM,1,
	PG_QBPLAYCALL_NUM,1,
EndAIGraphics

AIGraphics(AI_QBPLAYCALL_L2)	// looks to left a little longer
	PG_QBPLAYCALL_NUM,1,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,0,
	PG_QBPLAYCALL_NUM,1,
EndAIGraphics

AIGraphics(AI_QBPLAYCALL_R1)	// looks to right
	PG_QBPLAYCALL_NUM,1,	// physical frame #1 looks forward
	PG_QBPLAYCALL_NUM,2,    // physical frame #2 looks to right side
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,1,
EndAIGraphics

AIGraphics(AI_QBPLAYCALL_R2)	// looks to right a little longer
	PG_QBPLAYCALL_NUM,1,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,2,
	PG_QBPLAYCALL_NUM,1,
EndAIGraphics
#endif
AIGraphics(AI_RECEIVERSTANCE)	// before snap
	PG_RECEIVERSTANCE_NUM,0,
EndAIGraphics


AIGraphics(AI_DEFENSE_PRESNAP1)	// only E dir
// points to left
	PG_DEFENSE_PRESNAP1_NUM,0,
	PG_DEFENSE_PRESNAP1_NUM,0,
//	PG_DEFENSE_PRESNAP1_NUM,0,
//	PG_DEFENSE_PRESNAP1_NUM,0,
//	PG_DEFENSE_PRESNAP1_NUM,1,
//	PG_DEFENSE_PRESNAP1_NUM,1,
//	PG_DEFENSE_PRESNAP1_NUM,1,
	PG_DEFENSE_PRESNAP1_NUM,1,
	PG_DEFENSE_PRESNAP1_NUM,1,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,2,
	PG_DEFENSE_PRESNAP1_NUM,1,
	PG_DEFENSE_PRESNAP1_NUM,1,
//	PG_DEFENSE_PRESNAP1_NUM,1,
//	PG_DEFENSE_PRESNAP1_NUM,0,
	PG_DEFENSE_PRESNAP1_NUM,0,
	PG_DEFENSE_PRESNAP1_NUM,0,
EndAIGraphics

AIGraphics(AI_DEFENSE_PRESNAP2)	// only E dir
	PG_DEFENSE_PRESNAP2_NUM,0,
	PG_DEFENSE_PRESNAP2_NUM,0,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,2,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,1,
	PG_DEFENSE_PRESNAP2_NUM,0,
	PG_DEFENSE_PRESNAP2_NUM,0,
EndAIGraphics


AIGraphics(AI_DEFENSE_POSTTACKLE)	// only E dir
// Pointing at down player  (OR at crowd?)
	PG_DEFENSE_POSTTACKLE_NUM,0,
	PG_DEFENSE_POSTTACKLE_NUM,1,
	PG_DEFENSE_POSTTACKLE_NUM,1,
	PG_DEFENSE_POSTTACKLE_NUM,2,
	PG_DEFENSE_POSTTACKLE_NUM,2,
	PG_DEFENSE_POSTTACKLE_NUM,3,
	PG_DEFENSE_POSTTACKLE_NUM,3,
	PG_DEFENSE_POSTTACKLE_NUM,4,
	PG_DEFENSE_POSTTACKLE_NUM,4,
	PG_DEFENSE_POSTTACKLE_NUM,5,
	PG_DEFENSE_POSTTACKLE_NUM,5,
	PG_DEFENSE_POSTTACKLE_NUM,5,
	PG_DEFENSE_POSTTACKLE_NUM,5,
	PG_DEFENSE_POSTTACKLE_NUM,4,
	PG_DEFENSE_POSTTACKLE_NUM,4,
	PG_DEFENSE_POSTTACKLE_NUM,3,
	PG_DEFENSE_POSTTACKLE_NUM,3,
	PG_DEFENSE_POSTTACKLE_NUM,2,
	PG_DEFENSE_POSTTACKLE_NUM,2,
	PG_DEFENSE_POSTTACKLE_NUM,1,
	PG_DEFENSE_POSTTACKLE_NUM,1,
	PG_DEFENSE_POSTTACKLE_NUM,0,
	PG_DEFENSE_POSTTACKLE_NUM,0,
/*	bug # 2285 - only one cycle */
EndAIGraphics


AIGraphics(AI_HANDOFF)	// only dir A  (can flip) NO NO
	PG_HANDOFF_NUM,0,	// as of 6/26/96 , 1 frame in 5 dirs
EndAIGraphics           // no ball in hands


AIGraphics(AI_STANDINGCATCH)	// only dir CDE
	PG_STANDINGCATCH_NUM,0,
//	PG_STANDINGCATCH_NUM,1,
	PG_STANDINGCATCH_NUM,1,
	PG_STANDINGCATCH_NUM,1,
//	PG_STANDINGCATCH_NUM,2,
	PG_STANDINGCATCH_NUM,2,
	PG_STANDINGCATCH_NUM,2,
EndAIGraphics

AIGraphics(AI_COINTOSS)	// only dir CDE
	PG_COINTOSS_NUM,0,
	PG_COINTOSS_NUM,1,
	PG_COINTOSS_NUM,1,
	PG_COINTOSS_NUM,2,
	PG_COINTOSS_NUM,2,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,3,
	PG_COINTOSS_NUM,2,
	PG_COINTOSS_NUM,2,
	PG_COINTOSS_NUM,1,
	PG_COINTOSS_NUM,1,
	PG_COINTOSS_NUM,0,
EndAIGraphics


/*------------------    REF    ANIMS  ---------------------*/

#define REF_TURN1_FRAMES \
	REF_TURNING_NUM,0,\
	REF_TURNING_NUM,0,\
/*	REF_TURNING_NUM,1,*/\
/*	REF_TURNING_NUM,1,*/\
/*	REF_TURNING_NUM,2,*/\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,

#define REF_TURN2_FRAMES \
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
	REF_STANDING_NUM,0,\
//	REF_GOHOME_NUM,0,\
//	REF_GOHOME_NUM,0,\
///	REF_GOHOME_NUM,1,\
//	REF_GOHOME_NUM,1,

AIGraphics(AI_REF_RUN)
	REF_RUNNING_NUM,0,
	REF_RUNNING_NUM,1,
	REF_RUNNING_NUM,2,
	REF_RUNNING_NUM,3,
	REF_RUNNING_NUM,4,
	REF_RUNNING_NUM,5,
	REF_RUNNING_NUM,6,
	REF_RUNNING_NUM,7,
EndAIGraphics

AIGraphics(AI_REF_STAND)
	REF_STANDING_NUM,0,
EndAIGraphics


AIGraphics(AI_REF_TOUCHDOWN)
	REF_TURN1_FRAMES	// a macro
	REF_TOUCHDOWN_NUM,0,
	REF_TOUCHDOWN_NUM,1,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,2,
	REF_TOUCHDOWN_NUM,1,

	REF_TURN2_FRAMES	// a macro
EndAIGraphics

AIGraphics(AI_REF_SAFETY)
	REF_TURN1_FRAMES	// a macro
	REF_TOUCHDOWN_NUM,0,
	REF_TOUCHDOWN_NUM,1,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_SAFETY_NUM,0,
	REF_TOUCHDOWN_NUM,0,
	REF_TOUCHDOWN_NUM,0,

	REF_TURN2_FRAMES	// a macro
EndAIGraphics

AIGraphics(AI_REF_WAVEARMS)		// "no good" or incomplete
	REF_TURN1_FRAMES	// a macro
	REF_PENALTY_REFUSED_NUM,0,
	REF_PENALTY_REFUSED_NUM,1,
	REF_PENALTY_REFUSED_NUM,1,
	REF_PENALTY_REFUSED_NUM,2,
	REF_PENALTY_REFUSED_NUM,3,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,3,
	REF_PENALTY_REFUSED_NUM,2,
	REF_PENALTY_REFUSED_NUM,1,
	REF_PENALTY_REFUSED_NUM,0,

	REF_PENALTY_REFUSED_NUM,0,
	REF_PENALTY_REFUSED_NUM,1,
	REF_PENALTY_REFUSED_NUM,1,
	REF_PENALTY_REFUSED_NUM,2,
	REF_PENALTY_REFUSED_NUM,3,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,4,
	REF_PENALTY_REFUSED_NUM,3,
	REF_PENALTY_REFUSED_NUM,2,
	REF_PENALTY_REFUSED_NUM,1,
	REF_PENALTY_REFUSED_NUM,0,


	REF_TURN2_FRAMES	// a macro
EndAIGraphics

AIGraphics(AI_REF_OFFSIDES)
	REF_TURN1_FRAMES	// a macro
	REF_OFFSIDE_NUM,0,
	REF_OFFSIDE_NUM,1,
	REF_OFFSIDE_NUM,1,
	REF_OFFSIDE_NUM,1,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,

/* following added 10/5/96 bug #2801 - phrase was too long -
	ref ran off before it was done		*/
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,
	REF_OFFSIDE_NUM,2,

	REF_TURN2_FRAMES	// a macro
EndAIGraphics

AIGraphics(AI_REF_DELAY)
	REF_TURN1_FRAMES	// a macro
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,1,
	REF_FALSE_START_NUM,1,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_DELAY_NUM,0,
	REF_FALSE_START_NUM,0,

	REF_FALSE_START_NUM,0,
/* following added 10/5/96 bug #2801 - phrase was too long -
	ref ran off before it was done		*/
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,
	REF_FALSE_START_NUM,0,

	REF_TURN2_FRAMES	// a macro
EndAIGraphics

AIGraphics(AI_REF_FIRSTDOWN)	// no turn cause he faces away from camera
	REF_1STDOWN_NUM,0,
	REF_1STDOWN_NUM,1,
	REF_1STDOWN_NUM,2,
	REF_1STDOWN_NUM,2,
	REF_1STDOWN_NUM,2,
	REF_1STDOWN_NUM,2,
	REF_1STDOWN_NUM,3,
	
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,
	REF_1STDOWN_NUM,4,

	REF_1STDOWN_NUM,3,
	REF_1STDOWN_NUM,3,
EndAIGraphics


/******************	End of file: FBai2grp.H  ***************************/

