/**************************************************************

					FBAIGRAP.H

	AUTHOR: M. Knauer				Start Date: 1/16/96
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains AI  PLAYER  GRAPHIC Data.

	The AI graphics index a table of actual graphics.
	This allows certain AI graphics to be composed different actual
	graphics.

	It is an INCLUDED file.


	NOTE: the max num of frames per AI animination is figured at run
	time by scanning the AItoGraphics table and filling an MaxFrames array.


	It uses the concept of redefinable macros to be included in two
	places:

	1) in an enum table
	2) in an pointer table



	This way all the data about player graphics is here and we can
	use it different places through macro redefinition, and if we
	need to change it, we just change it one place(i.e. here) and it's
	changed everywhere.


**************************************************************/

//	1st num is frame per anim, second will be a pointer to an offset table
/*0*/	aipgmac(AI_RUNNING,NO)
		aipgmac(AI_WALKING,NO)
		aipgmac(AI_PASSING,NO)
		aipgmac(AI_2PTSTANCE,NO)	/*  offense	*/
		aipgmac(AI_3PTSTANCE,NO)	/*  offense	*/

/* 5*/	aipgmac(AI_4PTSTANCE,NO)  	/*  defense	*/
		aipgmac(AI_GETUPFROMBELLY,NO)
		aipgmac(AI_BACKPEDAL,NO)
		aipgmac(AI_BACKPEDAL_WBALL,NO)
		aipgmac(AI_QBPITCH,NO)		//, right

/*10*/	aipgmac(AI_BLOCKING,NO)
		aipgmac(AI_BLOCKING_WAIT,NO)
		aipgmac(AI_DIVE,AI_DIVE)
		aipgmac(AI_HANDSUP,NO)
//	aipgmac(AI_KICKING,AI_KICKING)
		aipgmac(AI_KICKING,NO)

/*15*/	aipgmac(AI_PUNTING,AI_PUNTING)
		aipgmac(AI_FGHOLDER,NO)
		aipgmac(AI_GOTOHOLDER,NO)
		aipgmac(AI_SHUFFLE,NO)		//, (and STAND)
		aipgmac(AI_RUNNINGWITHBALL,NO)

/*20*/	aipgmac(AI_SHUFFLEWITHBALL,NO)	//,(and STAND)
		aipgmac(AI_RUNNINGCATCH,NO)
		aipgmac(AI_RUNNINGCAUGHT,NO)	// immediately after he catches ball
		aipgmac(AI_STAND,NO)
		aipgmac(AI_RUNNING_HEADTURN,NO)

/*25*/	aipgmac(AI_REF_RUN,NO)
		aipgmac(AI_REF_STAND,NO)
		aipgmac(AI_REF_TOUCHDOWN,NO)
		aipgmac(AI_REF_SAFETY,NO)
		aipgmac(AI_REF_OFFSIDES,NO)

/*30*/	aipgmac(AI_REF_FIRSTDOWN,NO)
		aipgmac(AI_REF_DELAY,NO)
		aipgmac(AI_REF_WAVEARMS,NO)
		aipgmac(AI_TDCELEBRATE0,NO)
		aipgmac(AI_TDCELEBRATE1,NO)

/*35*/	aipgmac(AI_TDCELEBRATE2,NO)
// new 3/17/96
// there are 6 tackle anims, but only 3 are loaded at one time
		aipgmac(AI_TACKLED_FFS,NO)		//#1 - ALWAYS loaded
		aipgmac(AI_TACKLED_FFF,NO)		//#2 - FFF or FFR always loaded
		aipgmac(AI_TACKLED_FFR,NO)		//
		aipgmac(AI_TACKLED_FBB,NO)		//#3 -  ABD dirs only

/*40*/	aipgmac(AI_TACKLED_FBF,NO)		//  ABD dirs only
		aipgmac(AI_TACKLED_FBR,NO)		//  ABD dirs only
		aipgmac(AI_GETUPFROMBACK,NO)
		aipgmac(AI_SIDESTEP,NO)
		aipgmac(AI_BURST,NO)

/*40*/	aipgmac(AI_QBSLIDE,NO)
		aipgmac(AI_JUMPCATCH,AI_JUMPCATCH)
		aipgmac(AI_QBPLAYCALL_L1,NO)
		aipgmac(AI_QBPLAYCALL_L2,NO)
		aipgmac(AI_QBPLAYCALL_R1,NO)

/*45*/	aipgmac(AI_QBPLAYCALL_R2,NO)
		aipgmac(AI_RECEIVERSTANCE,NO)
		aipgmac(AI_DEFENSE_PRESNAP1,NO)	// only E dir
		aipgmac(AI_DEFENSE_PRESNAP2,NO)	// only E dir
		aipgmac(AI_DEFENSE_POSTTACKLE,NO)	// only E dir

/*50*/	aipgmac(AI_HANDOFF,NO)
		aipgmac(AI_STANDINGCATCH,NO)	// only dir CDE
		aipgmac(AI_COINTOSS,NO)
		aipgmac(AI_DOWN_PUNT,NO)	// uses 4 pt. stance
		aipgmac(AI_PUMPFAKE,NO)

/*55*/	aipgmac(AI_GP_SPIKE,AI_GP_SPIKE)	// spike over goalpost
		aipgmac(AI_JUMPUP,NO)
		aipgmac(AI_HURDLEWITHBALL,NO)


/******************	End of file: FBAIGRAP.H  ***************************/

