/**************************************************************


					FBAIInit.C

	INITIAL AUTHOR: M. Knauer       Start Date: 6/21/95
	Offensive/Defensive Coordinator: B. King

	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains Play Initialization routines and Data.


**************************************************************/

	#include  "fbequ.h"
	#include  "fbRAM.h"     /* external VARs needed by this file  */
	#include  "FBPlays.h"   /* Script enums     */
	#include  "FBforms.h"   /* form enums     */

#ifdef __MSDOS__
	#include  <stdio.h>
	#include  <stdlib.h>		/* for rand	*/
	#include  <conio.h>

#else
//#define	min(aaa,bbb)  (aaa<bbb ? aaa : bbb)
//#define	max(aaa,bbb)  (aaa>bbb ? aaa : bbb)
#endif


#define PLAY_INIT_DEF(xyz) \
	void  (xyz)(void);  \
	void  (xyz)(void)   /* actual function name of the State  */


#define	ALWAYS_THROW	0x80



struct CoverAssignments {
	BYTE  OffenseSoltNum;   /* 0 -10  */
	BYTE  DefenseSoltNum;   /* 11-21  */
};



struct CoverAssignments ManToManInit[] = {
 {  1,17 },   /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,21 },     /*  SS covers TE  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



/****   function prototypes	*****/

//void InitMan(struct CoverAssignments *Assign);
void InitMan(void);
//void SetReceivers(BYTE rec0, BYTE rec1, BYTE rec2, BYTE rec3, BYTE rec4);
void SetReceivers(BYTE rec0,BYTE rec1,BYTE rec2,BYTE rec3,BYTE rec4,BYTE primary);
void SetFakeReceivers(BYTE rec0, BYTE rec1, BYTE rec2, BYTE rec3, BYTE rec4);
void SetGuyToBlock(WORD offslotnum,WORD defslotnum);


void SetIRPReceivers(void)
{	// save recievers at init for IRP later
	OneTimeIRP.Receivers[0] = 	Receivers[0];
	OneTimeIRP.Receivers[1] = 	Receivers[1];
	OneTimeIRP.Receivers[2] = 	Receivers[2];
}

void SetReceivers(BYTE rec0,BYTE rec1,BYTE rec2,BYTE rec3,BYTE rec4,BYTE primary)
{
EFFVAR r2, randnum;

	SetBit(OPFlags(0),CAN_PASS_BFLAG);		// QB can pass
	SetBit(OPFlags1(0),QB_CAN_BPEDAL_BFLAG);		 // and back pedal

	ShowReceiverIcons = TRUE;

	Receivers[0] = (WORD)rec0;	// usually LR
	Receivers[1] = (WORD)rec2;	// usually RR
	Receivers[2] = (WORD)rec1;  	//  toggled guy
	Receivers[3] = (WORD)rec3;
	Receivers[4] = (WORD)rec4;
/**
	Receivers[0] = PosReceivers[0] = (WORD)rec0;	// usually LR
	Receivers[1] = PosReceivers[1] = (WORD)rec2;	// usually RR
	Receivers[2] = PosReceivers[2] = (WORD)rec1;  	//  toggled guy
	Receivers[3] = 	PosReceivers[3] = (WORD)rec3;
	Receivers[4] = 	PosReceivers[4] = (WORD)rec4;
**/
	PrimaryReceiver = (WORD)primary;	//PrimaryReceiver is aa global

	randnum = rand();
	if(PrimaryReceiver == Receivers[2])	// primary is toggled
	{
		r2 = randnum&1;		// 50%
		CPURecIndex[0] = 2;
		CPURecIndex[1] = r2;
		CPURecIndex[2] = r2^1;
	}
	else	// main wide receivers
	{
		 r2= CPURecIndex[0] = (PrimaryReceiver == Receivers[0] ? 0 : 1);

		if(randnum%3)	// 75% of time
		{	// other main wide out is secondary
			CPURecIndex[1] = r2^1;
			CPURecIndex[2] = 2;
		}
		else	// toggled gut is secondary
		{
			CPURecIndex[1] = 2;
			CPURecIndex[2] = r2^1;
		}
	}


	SetIRPReceivers();					// also should be done at ball snap
}

void SetFakeReceivers(BYTE rec0,BYTE rec1,BYTE rec2,BYTE rec3,BYTE rec4)
{
	/*  used for running plays so that cursors can be set up	*/
//	OPFlags(0)  |= CAN_PASS_BFLAG;		 QB CAN NOT pass

	ShowReceiverIcons = TRUE;

	Receivers[0] = (WORD)rec0;	// usually LR
	Receivers[1] = (WORD)rec2;	// usually RR
	Receivers[2] = (WORD)rec1;  	//  toggled guy
	Receivers[3] = (WORD)rec3;
	Receivers[4] = (WORD)rec4;

	SetIRPReceivers();

}


/*************************************************************************

					 I N I T     Z O N E S

	This sets up the defense zones for the zone pass defense.

	Zones based on Player Position - not defensive slot num!!!

*************************************************************************/

#define TOTAL_Y_SIDE_LINE (NORTH_SIDE_LINE+SOUTH_SIDE_LINE)

void  InitZones(struct BKzonearea *ZAPtr)
{
EFFVAR i = 0;
EFFVAR who,temp;
//UWORD t;
EFFVAR t;

	gZonePtr = ZAPtr;

	temp = gPNum;   /* just to be safe  */

	while((who = ZAPtr[i].PlayerPos) != NOBODY)
	{
		for(gPNum = 11; gPNum < 22; gPNum++)
		{   /* remember all "CP.." macros contain ref to gPNum  */
			if(who == CPMyFormPosition)
			{

				if((t = ZAPtr[i].outsidezone.High.X) == CZD)  /* cover zone deep ??*/
				{ /* X's same if cover deep zone  */
					CPOutsideZone.High.X =  CPInsideZone.High.X = MAX_DEF_COVERX;
					CPOutsideZone.Low.X =  CPInsideZone.Low.X = StartBallX + ZAPtr[i].outsidezone.Low.X;
				}
				else
				{
					CPOutsideZone.High.X = StartBallX + t;
					CPInsideZone.High.X = StartBallX + ZAPtr[i].insidezone.High.X;
					CPOutsideZone.Low.X = StartBallX + ZAPtr[i].outsidezone.Low.X;
					CPInsideZone.Low.X = StartBallX + ZAPtr[i].insidezone.Low.X;
				}

				if((UWORD)CPOutsideZone.High.X > MAX_DEF_COVERX)
					(UWORD)CPOutsideZone.High.X = MAX_DEF_COVERX;
				if((UWORD)CPOutsideZone.Low.X > OFF_GOAL_LINE)
					(UWORD)CPOutsideZone.Low.X =  OFF_GOAL_LINE;

				if((UWORD)CPInsideZone.High.X > MAX_DEF_COVERX)
					CPInsideZone.High.X = MAX_DEF_COVERX;
				if((UWORD)CPInsideZone.Low.X > OFF_GOAL_LINE)
					CPInsideZone.Low.X =  OFF_GOAL_LINE;




				if(ZAPtr[i].outsidezone.Low.Y == CZN) /* cover zone north ??*/
				{
					CPOutsideZone.Low.Y =  MAX_COVER_NORTH;
					CPInsideZone.Low.Y = NORTH_SIDE_LINE+5*YARDS;
					CPOutsideZone.High.Y = StartBallY + ZAPtr[i].outsidezone.High.Y;
					CPInsideZone.High.Y = StartBallY + ZAPtr[i].insidezone.High.Y;
				}
				else if(ZAPtr[i].outsidezone.High.Y == CZS) /* cover zone south ??*/
				{
					CPOutsideZone.High.Y =  MAX_COVER_SOUTH;
					CPInsideZone.High.Y = SOUTH_SIDE_LINE-5*YARDS;
					CPOutsideZone.Low.Y = StartBallY + ZAPtr[i].outsidezone.Low.Y;
					CPInsideZone.Low.Y = StartBallY + ZAPtr[i].insidezone.Low.Y;
				}
				else
				{
					CPOutsideZone.High.Y = StartBallY + ZAPtr[i].outsidezone.High.Y;
					CPInsideZone.High.Y = StartBallY + ZAPtr[i].insidezone.High.Y;
					CPOutsideZone.Low.Y = StartBallY + ZAPtr[i].outsidezone.Low.Y;
					CPInsideZone.Low.Y = StartBallY + ZAPtr[i].insidezone.Low.Y;
				}


				if(GameTeamData[DEFENSIVE_SLOT_NUM_MACRO].PlayFlipped)
				{   /* change only the Ys  (lows --> highs, highs-->lows    */
					t = CPOutsideZone.High.Y;
					CPOutsideZone.High.Y = TOTAL_Y_SIDE_LINE - CPOutsideZone.Low.Y;
					CPOutsideZone.Low.Y = TOTAL_Y_SIDE_LINE - t;

					t = CPInsideZone.High.Y;
					CPInsideZone.High.Y = TOTAL_Y_SIDE_LINE - CPInsideZone.Low.Y;
					CPInsideZone.Low.Y = TOTAL_Y_SIDE_LINE - t;
				}

				CPCenterZone.X = CPInsideZone.Low.X/2+CPInsideZone.High.X/2;
				CPCenterZone.Y = CPInsideZone.Low.Y/2+CPInsideZone.High.Y/2;

				CPCenterZone.X = min(CPCenterZone.X,StartBallX+(30+rand()%8)*YARDS);

				TRACE(gPNum);
				TRACE(CPCenterZone.X);
				TRACE(CPCenterZone.Y);
//                getch();
				break;
			}
		}
		i++;
	}
	gPNum = temp;


}




void InitManSpecific(struct CoverAssignments *coverptr)
{
EFFVAR i,j;

	i=ZERO;
	while( (j = (coverptr+i)->OffenseSoltNum) != (BYTE)(-1))
	{
		OPGuyToCover((coverptr+i)->DefenseSoltNum) = j;
		i++;
	}

}


/*********************************************************************

					ZONE  DATA  STRUCTURES


*********************************************************************/

#define	WATCHQB -5*YARDS



struct BKzonearea  ZoneGoalLineDeepZone[] = {

	IRLB     ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,
	
	ILLB     ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-8*YARDS,

	DL6       ,WATCHQB,11*YARDS, 20*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,

	DL5     ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 12*YARDS,-13*YARDS,

	RC      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,8*YARDS, CZD,CZS,

	SS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,


	NOBODY,
};


struct BKzonearea  ZoneGoalLineShortZone[] = {

	ILLB     ,0*YARDS,-7*YARDS, 13*YARDS,0*YARDS,
				0*YARDS,-7*YARDS, 8*YARDS,0*YARDS,

	IRLB     ,0*YARDS,0*YARDS, 13*YARDS,7*YARDS,
				0*YARDS,0*YARDS, 8*YARDS,7*YARDS,

	LC       ,WATCHQB,CZN, 13*YARDS,-15*YARDS,
				0*YARDS,CZN, 8*YARDS,-15*YARDS,

	DL6     ,WATCHQB,7*YARDS, 13*YARDS,14*YARDS,
				0*YARDS,7*YARDS, 8*YARDS,14*YARDS,

	DL5     ,WATCHQB,-14*YARDS, 13*YARDS,-7*YARDS,
				0*YARDS,-14*YARDS, 8*YARDS,-7*YARDS,

	RC      ,WATCHQB,14*YARDS, 13*YARDS,CZS,
			 0*YARDS,14*YARDS, 8*YARDS,CZS,

	SS      ,15*YARDS,-15*YARDS, CZD,15*YARDS,
			 15*YARDS,-15*YARDS, CZD,15*YARDS,


	NOBODY,
};



struct BKzonearea  Zone433DeepCornerZone[] = {

	MLB     ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-8*YARDS,

	RC       ,WATCHQB,11*YARDS, 20*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,

	OLLB     ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 12*YARDS,-13*YARDS,

	ORLB     ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,

	FS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,8*YARDS, CZD,CZS,

	NOBODY,
};


struct BKzonearea  Zone433DeepSafetyZone[] = {

	MLB     ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-8*YARDS,

	RC      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,8*YARDS, CZD,CZS,

	OLLB     ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 12*YARDS,-13*YARDS,

	ORLB     ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,

	FS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS       ,WATCHQB,11*YARDS, 20*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,
	
	NOBODY,
};


struct BKzonearea  Zone43FakeSSBlitzZone[] = {

	MLB     ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-8*YARDS,

	RC      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,8*YARDS, CZD,CZS,

	OLLB     ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 12*YARDS,-13*YARDS,

	ORLB     ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,

	FS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS       ,WATCHQB,11*YARDS, 20*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,

	NOBODY,
};


struct BKzonearea  Zone43ZoneLeftZone[] = {

	MLB     ,0*YARDS,0*YARDS, 15*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,

	LC      ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 14*YARDS,-13*YARDS,

	RC      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,11*YARDS, CZD,CZS,

	OLLB    ,0*YARDS,-11*YARDS, 15*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	ORLB    ,WATCHQB,11*YARDS, 15*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,

	FS      ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-11*YARDS,

	SS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,
	
	NOBODY,
};



struct BKzonearea  Zone43WideZone[] = {    

	MLB     ,0*YARDS,-14*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-12*YARDS, 13*YARDS,-3*YARDS,

	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-11*YARDS,

	RC      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,11*YARDS, CZD,CZS,

	OLLB     ,WATCHQB,CZN, 20*YARDS,-14*YARDS,
			 4*YARDS,CZN, 13*YARDS,-12*YARDS,

	ORLB      ,WATCHQB,14*YARDS, 20*YARDS,CZS,
			 4*YARDS,12*YARDS, 13*YARDS,CZS,

	FS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS       ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 13*YARDS,12*YARDS,
	
	NOBODY,
};


struct BKzonearea  Zone43CombatZone[] = {   

	MLB     ,0*YARDS,-8*YARDS, 15*YARDS,8*YARDS,
			 4*YARDS,-5*YARDS, 12*YARDS,5*YARDS,

	LC      ,18*YARDS,CZN, CZD,0*YARDS,
			 21*YARDS,CZN, CZD,0*YARDS,

	RC      ,18*YARDS,0*YARDS, CZD,CZS,
			 21*YARDS,0*YARDS, CZD,CZS,

	OLLB    ,0*YARDS,CZN, 15*YARDS,-8*YARDS,
			 4*YARDS,CZN, 12*YARDS,-11*YARDS,

	ORLB    ,0*YARDS,8*YARDS, 15*YARDS,CZS,
			 4*YARDS,11*YARDS, 12*YARDS,CZS,

	FS      ,18*YARDS,-18*YARDS, CZD,10*YARDS,
			 21*YARDS,-18*YARDS, CZD,10*YARDS,

	SS      ,18*YARDS,-10*YARDS, CZD,18*YARDS,
			 21*YARDS,-10*YARDS, CZD,18*YARDS,

	NOBODY,
};



struct BKzonearea  Zone43TwoDeepZone[] = {

	MLB     ,0*YARDS,-4*YARDS, 15*YARDS,4*YARDS,
			 4*YARDS,-3*YARDS, 14*YARDS,3*YARDS,

	LC      ,WATCHQB,CZN, 20*YARDS,-12*YARDS,
			 4*YARDS,CZN, 14*YARDS,-14*YARDS,

	RC       ,WATCHQB,12*YARDS, 20*YARDS,CZS,
			 4*YARDS,14*YARDS, 14*YARDS,CZS,

	OLLB    ,0*YARDS,-12*YARDS, 15*YARDS,-4*YARDS,
			 4*YARDS,-11*YARDS, 12*YARDS,-3*YARDS,

	ORLB    ,0*YARDS,4*YARDS, 15*YARDS,12*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,11*YARDS,

	FS      ,15*YARDS,CZN, CZD,5*YARDS,
			 20*YARDS,CZN, CZD,-3*YARDS,

	SS      ,15*YARDS,-5*YARDS, CZD,CZS,
			 20*YARDS,3*YARDS, CZD,CZS,
	
	NOBODY,
};




struct BKzonearea  Zone34ThreeDeepCloudZone[] = {

		
	IRLB             ,0,-4*YARDS, 7*YARDS,9*YARDS,
							2*YARDS,-1*YARDS, 5*YARDS,7*YARDS,

	RC               ,WATCHQB,9*YARDS, 20*YARDS,CZS,
							5*YARDS,11*YARDS, 18*YARDS,CZS,
	
	ILLB             ,WATCHQB,CZN, 7*YARDS,-4*YARDS,
							2*YARDS,CZN, 5*YARDS,-8*YARDS,

	SS               ,20*YARDS,0*YARDS, CZD,CZS,            
							20*YARDS,9*YARDS, CZD,CZS,

	OLLB             ,7*YARDS,CZN, 20*YARDS,-4*YARDS,   
							11*YARDS,CZN, 16*YARDS,-8*YARDS,

	ORLB             ,7*YARDS,-4*YARDS, 20*YARDS,9*YARDS,  
							11*YARDS,-1*YARDS, 16*YARDS,7*YARDS,

	FS               ,20*YARDS,-15*YARDS, CZD,15*YARDS,
							20*YARDS,-9*YARDS, CZD,9*YARDS,

	LC               ,20*YARDS,CZN, CZD,0*YARDS,            
							20*YARDS,CZN, CZD,-9*YARDS,
	
	NOBODY,
};






struct BKzonearea  Zone34StuntBlitzZone[] = {


	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-8*YARDS,

	ILLB     ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	RC       ,WATCHQB,11*YARDS, 20*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,

	OLLB     ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 12*YARDS,-13*YARDS,

	ORLB     ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,

	FS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,8*YARDS, CZD,CZS,
	
	NOBODY,
};





struct BKzonearea  Zone34FakeSafetyBlitzZone[] = {  



	IRLB             ,0,-4*YARDS, 7*YARDS,9*YARDS,     
							2*YARDS,-1*YARDS, 5*YARDS,7*YARDS,

	LC               ,20*YARDS,CZN, CZD,0*YARDS,            
							20*YARDS,CZN, CZD,-9*YARDS,

	ILLB             ,WATCHQB,CZN, 7*YARDS,-4*YARDS,    
							2*YARDS,CZN, 5*YARDS,-8*YARDS,

	RC               ,20*YARDS,0*YARDS, CZD,CZS,            
							20*YARDS,9*YARDS, CZD,CZS,

	OLLB             ,7*YARDS,CZN, 20*YARDS,-4*YARDS,   
							11*YARDS,CZN, 16*YARDS,-8*YARDS,

	ORLB             ,0,9*YARDS, 20*YARDS,CZS,
							5*YARDS,11*YARDS, 18*YARDS,CZS,
	
	FS              ,7*YARDS,-4*YARDS, 20*YARDS,9*YARDS,  
							11*YARDS,-1*YARDS, 16*YARDS,7*YARDS,


	SS               ,20*YARDS,-15*YARDS, CZD,15*YARDS,
							20*YARDS,-9*YARDS, CZD,9*YARDS,


	NOBODY,
};





struct BKzonearea  Zone34ThreeDeepSkyZone[] = {

	IRLB             ,2*YARDS,-4*YARDS, 7*YARDS,9*YARDS,
							2*YARDS,-1*YARDS, 5*YARDS,7*YARDS,

	LC               ,20*YARDS,CZN, CZD,0*YARDS,
							20*YARDS,CZN, CZD,-9*YARDS,

	ILLB             ,WATCHQB,CZN, 7*YARDS,-4*YARDS,
							2*YARDS,CZN, 5*YARDS,-8*YARDS,

	RC               ,20*YARDS,0*YARDS, CZD,CZS,
							20*YARDS,9*YARDS, CZD,CZS,

	OLLB             ,7*YARDS,CZN, 20*YARDS,-4*YARDS,
							11*YARDS,CZN, 16*YARDS,-8*YARDS,

	ORLB             ,7*YARDS,-4*YARDS, 20*YARDS,9*YARDS,
							11*YARDS,-1*YARDS, 16*YARDS,7*YARDS,

	FS               ,20*YARDS,-15*YARDS, CZD,15*YARDS,
							20*YARDS,-9*YARDS, CZD,9*YARDS,

	SS               ,WATCHQB,9*YARDS, 20*YARDS,CZS,
							5*YARDS,11*YARDS, 18*YARDS,CZS,

	NOBODY,
};





struct BKzonearea  Zone34CBBlitzZone[] = {    

	IRLB             ,7*YARDS,-4*YARDS, 20*YARDS,9*YARDS,  
							11*YARDS,-1*YARDS, 16*YARDS,7*YARDS,

	LC               ,15*YARDS,CZN, CZD,0*YARDS,
							20*YARDS,CZN, CZD,-8*YARDS,

	ILLB             ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
							4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	OLLB            ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
							4*YARDS,CZN, 12*YARDS,-13*YARDS,

	ORLB            ,WATCHQB,11*YARDS, 20*YARDS,CZS,
							4*YARDS,13*YARDS, 12*YARDS,CZS,

	FS              ,15*YARDS,-12*YARDS, CZD,12*YARDS,
							20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS              ,15*YARDS,0*YARDS, CZD,CZS,
							20*YARDS,8*YARDS, CZD,CZS,

	NOBODY,
};





struct BKzonearea  Zone34CenterFieldZone[] = {    

	IRLB       ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 13*YARDS,12*YARDS,

	LC       ,15*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-11*YARDS,

	RC      ,15*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,11*YARDS, CZD,CZS,

	ILLB     ,0*YARDS,-14*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-12*YARDS, 13*YARDS,-3*YARDS,

	OLLB     ,WATCHQB,CZN, 20*YARDS,-14*YARDS,
			 4*YARDS,CZN, 13*YARDS,-12*YARDS,

	ORLB      ,WATCHQB,14*YARDS, 20*YARDS,CZS,
			 4*YARDS,12*YARDS, 13*YARDS,CZS,

	FS      ,15*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS      ,5*YARDS,-10*YARDS, 20*YARDS,10*YARDS,
							5*YARDS,-2*YARDS, 20*YARDS,2*YARDS,
	
	NOBODY,
};



struct BKzonearea  Zone34ShadowZone[] = {    

	IRLB    ,0*YARDS,4*YARDS, 15*YARDS,12*YARDS,
			 4*YARDS,1*YARDS, 12*YARDS,11*YARDS,

	LC      ,WATCHQB,CZN, 20*YARDS,-12*YARDS,
			 4*YARDS,CZN, 14*YARDS,-14*YARDS,

	RC       ,WATCHQB,12*YARDS, 20*YARDS,CZS,
			 4*YARDS,14*YARDS, 14*YARDS,CZS,

	ILLB    ,0*YARDS,-12*YARDS, 15*YARDS,-4*YARDS,
			 4*YARDS,-11*YARDS, 12*YARDS,-1*YARDS,

	OLLB    ,0*YARDS,CZN, 3*YARDS,0*YARDS,
			 1*YARDS,CZN, 3*YARDS,-3*YARDS,

	ORLB    ,0*YARDS,0*YARDS, 3*YARDS,CZS,
			 1*YARDS,3*YARDS, 3*YARDS,CZS,

	FS      ,15*YARDS,CZN, CZD,5*YARDS,
			 20*YARDS,CZN, CZD,-3*YARDS,

	SS      ,15*YARDS,-5*YARDS, CZD,CZS,
			 20*YARDS,3*YARDS, CZD,CZS,

	NOBODY,
};



struct BKzonearea  ZoneNickelPreventZone[] = {    

	ORLB    ,0*YARDS,-5*YARDS, 15*YARDS,CZS,
			 5*YARDS,0*YARDS, 12*YARDS,CZS,

	LC      ,15*YARDS,CZN, CZD,-10*YARDS,
			 18*YARDS,CZN, CZD,-7*YARDS,

	OLLB    ,0*YARDS,CZN, 15*YARDS,5*YARDS,
			 5*YARDS,CZN, 12*YARDS,0*YARDS,

	RC      ,15*YARDS,10*YARDS, CZD,CZS,
			 18*YARDS,7*YARDS, CZD,CZS,

	NB      ,15*YARDS,CZN, CZD,0*YARDS,
			 18*YARDS,-15*YARDS, CZD,5*YARDS,

	FS      ,15*YARDS,-15*YARDS, CZD,15*YARDS,
			 15*YARDS,-15*YARDS, CZD,15*YARDS,

	SS      ,15*YARDS,0*YARDS, CZD,CZS,
			 18*YARDS,-5*YARDS, CZD,15*YARDS,
	NOBODY,
};




struct BKzonearea  ZoneNickelPreventBlitzZone[] = {    

	ORLB    ,0*YARDS,8*YARDS, 15*YARDS,CZS,
			 4*YARDS,11*YARDS, 12*YARDS,CZS,

	NB      ,18*YARDS,CZN, CZD,0*YARDS,
			 21*YARDS,CZN, CZD,0*YARDS,

	RC      ,18*YARDS,0*YARDS, CZD,CZS,
			 21*YARDS,0*YARDS, CZD,CZS,

	LC      ,0*YARDS,CZN, 15*YARDS,-8*YARDS,
			 4*YARDS,CZN, 12*YARDS,-11*YARDS,

	FS      ,18*YARDS,-18*YARDS, CZD,10*YARDS,
			 21*YARDS,-18*YARDS, CZD,10*YARDS,

	SS      ,18*YARDS,-10*YARDS, CZD,18*YARDS,
			 21*YARDS,-10*YARDS, CZD,18*YARDS,

	NOBODY,
};




struct BKzonearea  ZoneNickelMiddleZone[] = {    

	ORLB    ,0*YARDS,-3*YARDS, 15*YARDS,10*YARDS,
			 5*YARDS,0*YARDS, 12*YARDS,8*YARDS,

	LC      ,WATCHQB,CZN, 15*YARDS,-10*YARDS,
			 0*YARDS,CZN, 12*YARDS,-15*YARDS,

	OLLB    ,0*YARDS,-10*YARDS, 15*YARDS,3*YARDS,
			 5*YARDS,-8*YARDS, 12*YARDS,0*YARDS,

	RC      ,WATCHQB,10*YARDS, 15*YARDS,CZS,
			 0*YARDS,15*YARDS, 12*YARDS,CZS,

	NB      ,10*YARDS,-20*YARDS, CZD,0*YARDS,
			 12*YARDS,-15*YARDS, CZD,-5*YARDS,

	SS      ,10*YARDS,0*YARDS, CZD,20*YARDS,
			 12*YARDS,5*YARDS, CZD,15*YARDS,

	FS      ,25*YARDS,-20*YARDS, CZD,20*YARDS,
			 25*YARDS,-15*YARDS, CZD,15*YARDS,


	NOBODY,
};



struct BKzonearea  ZoneNickelBlitzZone[] = {

	ORLB    ,0*YARDS,8*YARDS, 15*YARDS,CZS,
			 4*YARDS,11*YARDS, 12*YARDS,CZS,

	LC      ,18*YARDS,CZN, CZD,0*YARDS,
			 21*YARDS,CZN, CZD,0*YARDS,

	RC      ,18*YARDS,0*YARDS, CZD,CZS,
			 21*YARDS,0*YARDS, CZD,CZS,

	NB      ,0*YARDS,CZN, 15*YARDS,-8*YARDS,
			 4*YARDS,CZN, 12*YARDS,-11*YARDS,

	FS      ,18*YARDS,-18*YARDS, CZD,10*YARDS,
			 21*YARDS,-18*YARDS, CZD,10*YARDS,

	SS      ,18*YARDS,-10*YARDS, CZD,18*YARDS,
			 21*YARDS,-10*YARDS, CZD,18*YARDS,

	NOBODY,
};




struct BKzonearea  ZoneDimePreventZone[] = {

	MLB    ,0*YARDS,-10*YARDS, 15*YARDS,10*YARDS,
			 5*YARDS,-8*YARDS, 12*YARDS,8*YARDS,

	LC      ,10*YARDS,CZN, 25*YARDS,-10*YARDS,
			 10*YARDS,CZN, 25*YARDS,-12*YARDS,

	DB      ,16*YARDS,-15*YARDS, CZD,20*YARDS,
			 15*YARDS,-13*YARDS, CZD,20*YARDS,

	RC      ,10*YARDS,10*YARDS, 25*YARDS,CZS,
			 10*YARDS,12*YARDS, 25*YARDS,CZS,

	NB      ,11*YARDS,CZN, CZD,0*YARDS,
			 18*YARDS,-15*YARDS, CZD,5*YARDS,

	FS      ,16*YARDS,-20*YARDS, CZD,15*YARDS,
			 15*YARDS,-20*YARDS, CZD,13*YARDS,

	SS      ,11*YARDS,0*YARDS, CZD,CZS,
			 18*YARDS,5*YARDS, CZD,15*YARDS,
	NOBODY,
};




struct BKzonearea  ZoneDimeFourDeepZone[] = {

	MLB    ,5*YARDS,-7*YARDS, 18*YARDS,7*YARDS,
			 7*YARDS,-5*YARDS, 15*YARDS,5*YARDS,

	LC      ,5*YARDS,CZN, 20*YARDS,-7*YARDS,
			 8*YARDS,CZN, 17*YARDS,-9*YARDS,

	RC      ,5*YARDS,7*YARDS, 20*YARDS,CZS,
			 8*YARDS,9*YARDS, 17*YARDS,CZS,

	NB      ,11*YARDS,CZN, CZD,0*YARDS,
			 21*YARDS,CZN, CZD,0*YARDS,

	DB      ,16*YARDS,-7*YARDS, CZD,20*YARDS,
			 21*YARDS,-9*YARDS, CZD,16*YARDS,

	FS      ,16*YARDS,CZN, CZD,9*YARDS,
			 21*YARDS,-16*YARDS, CZD,7*YARDS,

	SS      ,11*YARDS,0*YARDS, CZD,CZS,
			 21*YARDS,0*YARDS, CZD,CZS,
	NOBODY,
};




struct BKzonearea  ZoneDimePreventRightZone[] = {

	MLB    ,0*YARDS,-5*YARDS, 15*YARDS,CZS,
			 5*YARDS,0*YARDS, 12*YARDS,CZS,

	LC      ,11*YARDS,CZN, CZD,-5*YARDS,
			 18*YARDS,CZN, CZD,-7*YARDS,

	RC      ,0*YARDS,CZN, 15*YARDS,5*YARDS,
			 5*YARDS,CZN, 12*YARDS,0*YARDS,

	SS      ,11*YARDS,5*YARDS, CZD,CZS,
			 18*YARDS,7*YARDS, CZD,CZS,

	NB      ,16*YARDS,CZN, CZD,10*YARDS,
			 18*YARDS,-15*YARDS, CZD,5*YARDS,

	FS      ,16*YARDS,-15*YARDS, CZD,15*YARDS,
			 15*YARDS,-15*YARDS, CZD,15*YARDS,

	DB      ,11*YARDS,10*YARDS, CZD,CZS,
			 18*YARDS,-5*YARDS, CZD,15*YARDS,
	NOBODY,
};




struct BKzonearea  ZoneDimePreventLeftZone[] = {

	ORLB    ,WATCHQB,7*YARDS, 15*YARDS,CZS,
			 5*YARDS,9*YARDS, 12*YARDS,CZS,

	NB      ,11*YARDS,CZN, CZD,-5*YARDS,
			 18*YARDS,CZN, CZD,-7*YARDS,

	LC      ,WATCHQB,CZN, 15*YARDS,-7*YARDS,
			 5*YARDS,CZN, 12*YARDS,-9*YARDS,

	OLLB    ,0*YARDS,-7*YARDS, 15*YARDS,7*YARDS,
			 5*YARDS,-5*YARDS, 12*YARDS,5*YARDS,

	RC      ,11*YARDS,5*YARDS, CZD,CZS,
			 18*YARDS,7*YARDS, CZD,CZS,

	FS      ,16*YARDS,CZN, CZD,10*YARDS,
			 18*YARDS,-15*YARDS, CZD,5*YARDS,

	DB      ,16*YARDS,-15*YARDS, CZD,15*YARDS,
			 15*YARDS,-15*YARDS, CZD,15*YARDS,

	SS      ,16*YARDS,10*YARDS, CZD,CZS,
			 18*YARDS,-5*YARDS, CZD,15*YARDS,
	NOBODY,
};


struct BKzonearea  ZoneDimeFakeSafetyBlitzZone[] = {

	OLLB      ,2*YARDS,CZN, 20*YARDS,-9*YARDS,
			 5*YARDS,CZN, 17*YARDS,-11*YARDS,

	ORLB      ,2*YARDS,9*YARDS, 20*YARDS,CZS,
			 5*YARDS,11*YARDS, 17*YARDS,CZS,

	LC      ,11*YARDS,CZN, CZD,0*YARDS,
			 21*YARDS,CZN, CZD,0*YARDS,

	SS      ,16*YARDS,-7*YARDS, CZD,20*YARDS,
			 21*YARDS,-7*YARDS, CZD,16*YARDS,

	NB      ,16*YARDS,-20*YARDS, CZD,7*YARDS,
			 21*YARDS,-16*YARDS, CZD,7*YARDS,

	FS      ,2*YARDS,-11*YARDS, 20*YARDS,2*YARDS,
			 5*YARDS,-9*YARDS, 17*YARDS, -1*YARDS,

	DB      ,2*YARDS,-2*YARDS, 20*YARDS,11*YARDS,
			 5*YARDS,1*YARDS, 17*YARDS, 9*YARDS,

	RC      ,11*YARDS,0*YARDS, CZD,CZS,
			 21*YARDS,0*YARDS, CZD,CZS,
	NOBODY,
};



struct BKzonearea  ZoneDimeBlitzZone[] = {

	DB       ,0*YARDS,-11*YARDS, 20*YARDS,0*YARDS,
			 4*YARDS,-8*YARDS, 12*YARDS,-3*YARDS,

	NB       ,11*YARDS,CZN, CZD,0*YARDS,
			 20*YARDS,CZN, CZD,-8*YARDS,

	RC       ,WATCHQB,11*YARDS, 20*YARDS,CZS,
			 4*YARDS,13*YARDS, 12*YARDS,CZS,

	LC       ,WATCHQB,CZN, 20*YARDS,-11*YARDS,
			 4*YARDS,CZN, 12*YARDS,-13*YARDS,

	ORLB     ,0*YARDS,0*YARDS, 20*YARDS,11*YARDS,
			 4*YARDS,3*YARDS, 12*YARDS,8*YARDS,

	FS      ,16*YARDS,-12*YARDS, CZD,12*YARDS,
			 20*YARDS,-18*YARDS, CZD,18*YARDS,

	SS      ,11*YARDS,0*YARDS, CZD,CZS,
			 20*YARDS,8*YARDS, CZD,CZS,

	NOBODY,
};







/*********************************************************************

						Play Init Routines

	Play Inits are accesed by a number(handle) in the play D.S. which
	is used as an index to look up the actual [location of] the
	Play Init routine

*********************************************************************/
				/*  pass play init example (OLD) */
// void  ProSetLongBombInit(void);
// void  ProSetLongBombInit(void)
// {
//	SetReceivers(2,3,1,5,4);
// }


				/*  pass play init example (NEW) */
// PLAYINIT(SetReceivers231451)
// {
//    SetReceivers(2,3,1,4,5,1);
// }


#define PLAYINIT(fname) void fname(void); void fname(void)


//**********************       CORE OF PASSING

PLAYINIT(SetReceivers231451)
{
   SetReceivers(2,3,1,4,5,1);
}


PLAYINIT(SetReceivers231452)
{
   SetReceivers(2,3,1,4,5,2);
}


PLAYINIT(SetReceivers231453)
{
   SetReceivers(2,3,1,4,5,3);
}

PLAYINIT(SetReceivers241351)
{
   SetReceivers(2,4,1,3,5,1);
}

PLAYINIT(SetReceivers241352)
{
   SetReceivers(2,4,1,3,5,2);
}


PLAYINIT(SetReceivers241354)
{
   SetReceivers(2,4,1,3,5,4);
}


PLAYINIT(SetReceivers251341)
{
   SetReceivers(2,5,1,3,4,1);
}

PLAYINIT(SetReceivers251345)
{
   SetReceivers(2,5,1,3,4,5);
}

PLAYINIT(SetReceivers251342)
{
   SetReceivers(2,5,1,3,4,2);
}


// ************************       CORE RUNS

PLAYINIT(SetFakeReceivers25134)
{
	SetFakeReceivers(2,5,1,3,4);
}


PLAYINIT(SetFakeReceivers24135)
{
	SetFakeReceivers(2,4,1,3,5);
}


PLAYINIT(SetFakeReceivers23145)
{
	SetFakeReceivers(2,3,1,4,5);
}


// ************************      ISLOT PASSES

PLAYINIT(SetReceivers213453)
{
   SetReceivers(2,1,3,4,5,3);
}


PLAYINIT(SetReceivers213451)
{
   SetReceivers(2,1,3,4,5,1);
}


PLAYINIT(SetReceivers243152)
{
   SetReceivers(2,4,3,1,5,2);
}


PLAYINIT(SetReceivers243153)
{
	SetReceivers(2,4,3,1,5,3);
}


PLAYINIT(SetReceivers253143)
{
   SetReceivers(2,5,3,1,4,3);
}



// **********************       ISLOT RUNS


PLAYINIT(SetFakeReceivers25314)
{
	SetFakeReceivers(2,5,3,1,4);
}


PLAYINIT(SetFakeReceivers21345)
{
	SetFakeReceivers(2,1,3,4,5);
}


PLAYINIT(SetFakeReceivers24315)
{
	SetFakeReceivers(2,4,3,1,5);
}

//************************  Tackle Eligible

/*****  tackle is in slot #3
PLAYINIT(SetReceivers271457)
{
	SetReceivers(2,7,1,4,5,7);
}

PLAYINIT(SetFakeReceivers27145)
{
	SetFakeReceivers(2,7,1,4,5);
}

**********************/


// ************************     HB OPTIONS

void  GoalLineOptionPassInit(void);
void  GoalLineOptionPassInit(void)
{
   SetReceivers(2,4,1,3,5,1);

   OPFlags(0)  &= ~CAN_PASS_BFLAG;	// QB can't pass
   OPFlags(5)  |= CAN_PASS_BFLAG;	// RB can
}


void  IFormHBOptionInit(void);
void  IFormHBOptionInit(void)
{
   SetReceivers(2,3,1,5,4,2);
   OPFlags(0)  &= ~CAN_PASS_BFLAG;	// QB can't pass
   OPFlags(5)  |= CAN_PASS_BFLAG;	// RB can
}


void  ProSetHalfBackOptionInit(void);
void  ProSetHalfBackOptionInit(void)
{
   SetReceivers(2,3,1,4,5,2);
   OPFlags(0)  &= ~CAN_PASS_BFLAG;	// QB can't pass
   OPFlags(5)  |= CAN_PASS_BFLAG;	// RB can
}









void  DefenseNoPlayInit(void);
void  DefenseNoPlayInit(void)   /* dummy routine  */
{

}


void OffenseKickoffInit(void);
void OffenseKickoffInit(void)
{	// no receiver init needed

//	SetGuyToBlock(WORD offslotnum,WORD defslotnum)
	SetGuyToBlock(1,18);
	SetGuyToBlock(2,14);
	SetGuyToBlock(3,12);
	SetGuyToBlock(4,15);
	SetGuyToBlock(5,19);
}



void PlayerHasBall(void);     		/*  a BALL ACTION		   */
void BallGPTest(void);

void SpeedTestInit(void) // WARNING - overridden at Wait4Snap by SetCPRatings
{
EFFVAR i;

	for(i=0; i<11; i++)
	{
		OPMaxSpeed(i) = (7+i)<<SPEED_SHIFT;
//		OPMaxSpeed(i) = (3+i)<<SPEED_SHIFT;
//		OPMaxSpeed(i) = (8)<<SPEED_SHIFT;
		OPAcceleration(i) = 84;
	}
	BallCarrier = 0;
	SetBit1(EventFlags,OK_FOR_HUMAN_OFF_CONTROL_BFLAG);

	SetBallAction(PlayerHasBall);

}


void AccelTestInit(void)
{
EFFVAR i;

	for(i=0; i<11; i++)
	{
		OPMaxSpeed(i) = 8<<SPEED_SHIFT;
		OPAcceleration(i) = 25 +10*i;
	}
	OPAcceleration(10) = 0x1000;
	BallCarrier = 0;
	SetBit1(EventFlags,OK_FOR_HUMAN_OFF_CONTROL_BFLAG);

	SetBallAction(BallGPTest);


}

/*********************************************************************/






PLAY_INIT_DEF(DefenseManToManInit)
{
	InitMan();
}


PLAY_INIT_DEF(DefenseGoalLineDeepInit)
{
	InitZones(ZoneGoalLineDeepZone);
}

PLAY_INIT_DEF(DefenseGoalLineShortZoneInit)
{
	InitZones(ZoneGoalLineShortZone);
}

PLAY_INIT_DEF(Defense433DeepCornerInit)
{
	InitZones(Zone433DeepCornerZone);
}

PLAY_INIT_DEF(Defense433DeepSafetyInit)
{
	InitZones(Zone433DeepSafetyZone);
}

PLAY_INIT_DEF(Defense43FakeSSBlitzInit)
{
	InitZones(Zone43FakeSSBlitzZone);
}

PLAY_INIT_DEF(Defense43ZoneLeftInit)
{
	InitZones(Zone43ZoneLeftZone);
}

PLAY_INIT_DEF(Defense43WideZoneInit)
{
	InitZones(Zone43WideZone);
}

PLAY_INIT_DEF(Defense43CombatZoneInit)
{
	InitZones(Zone43CombatZone);
}

PLAY_INIT_DEF(Defense43TwoDeepZoneInit)
{
	InitZones(Zone43TwoDeepZone);
}

PLAY_INIT_DEF(Defense34DeepCloudInit)
{
	InitZones(Zone34ThreeDeepCloudZone);  // is this right- mjk 6/22

}

PLAY_INIT_DEF(Defense34StuntBlitzInit)
{
	InitZones(Zone34StuntBlitzZone);
}

PLAY_INIT_DEF(Defense34FakeSatetyBlitzInit)
{
	InitZones(Zone34FakeSafetyBlitzZone);
}

PLAY_INIT_DEF(Defense34DeepSkyInit)
{
	InitZones(Zone34ThreeDeepSkyZone);  //Zone34DeepSkyZone); ???
}

PLAY_INIT_DEF(Defense34CBBlitzInit)
{
	InitZones(Zone34CBBlitzZone);
}

PLAY_INIT_DEF(Defense34CenterFieldZoneInit)
{
	InitZones(Zone34CenterFieldZone);
}

PLAY_INIT_DEF(Defense34ShadowZoneInit)
{
	InitZones(Zone34ShadowZone);
}

PLAY_INIT_DEF(DefenseNickelPreventInit)
{
	InitZones(ZoneNickelPreventZone);
}

PLAY_INIT_DEF(DefenseNickelPreventBlitzInit)
{
	InitZones(ZoneNickelPreventBlitzZone);
}

PLAY_INIT_DEF(DefenseManToManDoubleLeftInit)
{
	InitMan();

}

PLAY_INIT_DEF(DefenseNickelMiddleZoneInit)
{
	InitZones(ZoneNickelMiddleZone);
}

PLAY_INIT_DEF(DefenseNickelBlitzZoneInit)
{
	InitZones(ZoneNickelBlitzZone);
}











struct CoverAssignments DefenseKeyOnBacksTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,18 },     /*  ORLB covers TE  */
 {  4,13 },     /* OLLB covers FB */
 {  5,16 },     /*  NB covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




PLAY_INIT_DEF(DefenseKeyOnBacksInit)
{
	InitManSpecific(DefenseKeyOnBacksTable);
}















struct CoverAssignments DefenseManToManKeyOnHBTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,21 },     /*  SS covers TE  */
 {  5,20 },     /* FS covers FB */
 {  4,13 },     /* LE covers FB */
 {  5,18 },     /*  ORLB covers TE  */
 {  5,19 },     /* OLLB covers FB */
// {  5,11 },     /*  NB covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




PLAY_INIT_DEF(DefenseManToManKeyOnHBInit)	//play #206 (?)
{
//	InitMan(ManToManInit);
//	InitMan();
	InitManSpecific(DefenseManToManKeyOnHBTable);
	//adjustment
}










struct CoverAssignments DefenseManToManDoubleRightTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  1,21 },     /*  SS covers TE  */
// {  2,20 },     /* FS covers FB */
 {  3,18 },     /*  ORLB covers TE  */
 {  4,19 },     /* OLLB covers FB */
 {  5,11 },     /*  NB covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




PLAY_INIT_DEF(DefenseManToManDoubleRightInit)	//play #206 (?)
{
//	InitMan(ManToManInit);
//	InitMan();
	InitManSpecific(DefenseManToManDoubleRightTable);
	//adjustment
}





struct CoverAssignments DefenseManToManQBSpyInitTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
// {  0,21 },     /*  SS covers TE  */
// {  2,20 },     /* FS covers FB */
 {  3,19 },     /*  ORLB covers TE  */
// {  4,18 },     /* OLLB covers FB */
 {  5,11 },     /*  NB covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




PLAY_INIT_DEF(DefenseManToManQBSpyInit)
{
//	InitMan(ManToManInit);
//	InitMan();
	InitManSpecific(DefenseManToManQBSpyInitTable);
	//adjustment
}


PLAY_INIT_DEF(DefenseDimePreventInit)
{
	InitZones(ZoneDimePreventZone);
}

PLAY_INIT_DEF(DefenseDimeFourDeepInit)
{
	InitZones(ZoneDimeFourDeepZone);
}

PLAY_INIT_DEF(DefenseDimePreventRightInit)
{
	InitZones(ZoneDimePreventRightZone);
}





struct CoverAssignments DefenseManToManDoubleWidesInitTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  1,21 },     /*  SS covers TE  */
 {  4,20 },     /* FS covers FB */
 {  2,18 },     /*  NB covers TE  */
 {  3,16 },     /*  NB covers TE  */
 {  5,11 },     /* MLB covers FB */
// {  0,11 },     /*  MLB covers QB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




PLAY_INIT_DEF(DefenseManToManDoubleWidesInit)
{
	InitManSpecific(DefenseManToManDoubleWidesInitTable);
}




struct CoverAssignments DefenseManToManPuntDoubleInitTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  1,21 },     /*  SS covers TE  */
 {  2,11 },     /* FS covers FB */
// {  2,18 },     /*  NB covers TE  */
// {  3,16 },     /*  NB covers TE  */
// {  5,11 },     /* MLB covers FB */
// {  0,11 },     /*  MLB covers QB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




PLAY_INIT_DEF(DefenseManToManPuntDoubleInit)
{
	InitManSpecific(DefenseManToManPuntDoubleInitTable);
}





PLAY_INIT_DEF(DefenseDimePreventLeftInit)
{
	InitZones(ZoneDimePreventLeftZone);
}

PLAY_INIT_DEF(DefenseDimeFakeSafetyBlitzInit)
{
	InitZones(ZoneDimeFakeSafetyBlitzZone);
}

PLAY_INIT_DEF(DefenseDimeBlitzZoneInit)
{
	InitZones(ZoneDimeBlitzZone);
}

PLAY_INIT_DEF(DefensePuntInit)
{
//	InitMan(ManToManInit);
	InitMan();
	//adjustment
}




struct CoverAssignments DefenseManToManFGInitTable[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  1,19 },     /*  ORLB covers TE  */
// {  3,21 },     /*  ORLB covers TE  */
 {  2,20 },     /* OLLB covers FB */
 {  5,11 },     /*  NB covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


PLAY_INIT_DEF(DefenseFGInit)
{
//	InitMan(ManToManInit);
	InitManSpecific(DefenseManToManFGInitTable);
	//adjustment
}




//void *PlayInitRoutines[] = {
struct State PlayInitRoutines[] = {
#define pimac(xyz)  xyz,

		#include	"FBpinit.h"		// as pointers

#undef pimac
};



/*
struct defshiftDS {
	BYTE slotnum;
	BYTE targetx;	// targets relative to StartBallX/Y
	BYTE targety;	//  YARDS multiplied in during init process
};

*/

struct defshiftDS 	DefGoallinevsGoalline[] = {
	12,4*YARDS,-6*YARDS,
	17,4*YARDS,8*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsGoallineInit[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,21 },     /*  IRLB covers TE  */
 {  4,20 },     /* ILLB covers FB */
 {  5,11 },     /*  SS covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNormalvsGoalline[] = {
//	11,3.5*YARDS,0*YARDS,
	12,2*YARDS,-7*YARDS,
	17,2*YARDS,8*YARDS,
	18,2*YARDS,-5.5*YARDS,
	19,2.5*YARDS,5.5*YARDS,
	20,9*YARDS,-1.5*YARDS,
	21,8*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsGoallineInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsGoalline[] = {
	11,8.5*YARDS,-5.5*YARDS,
	12,6*YARDS,-7*YARDS,
//	14,1*YARDS,-.75*YARDS,
//	15,1*YARDS,.75*YARDS,
	17,6*YARDS,8*YARDS,
//	18,2.5*YARDS,-2.5*YARDS,
//	19,2.5*YARDS,2.5*YARDS,
	20,11*YARDS,-1.5*YARDS,
	21,9*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverNickelvsGoallineInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsGoalline[] = {
	11,4*YARDS,0*YARDS,
	12,8*YARDS,-7*YARDS,
	17,8*YARDS,8*YARDS,
	18,9*YARDS,-5.5*YARDS,
	19,11*YARDS,3*YARDS,
	20,11*YARDS,-3*YARDS,
	21,9*YARDS,5.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsGoallineInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  2,18 },     /*  covers LWR */
 {  1,19 },     /*  covers RWR  */
 {  4,11 },     /*  covers FB */
 {  5,14 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};







struct defshiftDS 	DefGoallinevsWishBone[] = {
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsWishBoneInit[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,21 },     /*  IRLB covers TE  */
 {  4,20 },     /* ILLB covers FB */
 {  5,19 },     /*  SS covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsWishBone[] = {
//	11,3*YARDS,0*YARDS,		okay for 4-3, looks bad if 3-4 (mjk 1/3/97
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,1.5*YARDS,-5*YARDS,
	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsWishBoneInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsWishBone[] = {
	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
//	18,1.5*YARDS,-5*YARDS,
//	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsWishBoneInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsWishBone[] = {
	11,4*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,7.5*YARDS,-6*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsWishBoneInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};







struct defshiftDS 	DefGoallinevsPowerI[] = {
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsPowerIInit[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,21 },     /*  IRLB covers TE  */
 {  4,20 },     /* ILLB covers FB */
 {  5,19 },     /*  SS covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsPowerI[] = {
//	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,1.5*YARDS,-5*YARDS,
	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsPowerIInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsPowerI[] = {
	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,1.5*YARDS,-5*YARDS,
	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsPowerIInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsPowerI[] = {
	11,4*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,7.5*YARDS,-6*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsPowerIInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};







struct defshiftDS    DefGoallinevsNearFar[] = {
	11,5.5*YARDS,2.5*YARDS,
	17,3*YARDS,9*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverGoallinevsNearFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers HB */
 {  5,20 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS		DefNormalvsNearFar[] = {
//	12,3*YARDS,-9*YARDS,   //	this is their normal formation NO NO
//	17,3*YARDS,9*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverNormalvsNearFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers HB */
 {  5,11 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS		DefNickelvsNearFar[] = {
	17,3*YARDS,9*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsNearFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers HB */
 {  5,18 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefDimevsNearFar[] = {
	11,4*YARDS,0*YARDS,
	17,3*YARDS,9*YARDS,
	18,7.5*YARDS,-7*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverDimevsNearFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers HB */
 {  5,18 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefGoallinevsISlot[] = {
	11,5*YARDS,0*YARDS,
	17,4*YARDS,8*YARDS,
	18,3*YARDS,-7*YARDS,
	12,6*YARDS,-12*YARDS,
	20,7*YARDS,-3*YARDS,
//	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsISlotInit[] = {
 {  1,20 },     /*  covers Left slot */
 {  2,12 },     /*  covers LWR */
 {  3,17 },     /*  covers RTE  */
 {  4,21 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsISlot[] = {
	12,3*YARDS,-11*YARDS,
	17,3*YARDS,9*YARDS,
	18,3*YARDS,-7*YARDS,
	19,1*YARDS,6.5*YARDS,
	20,8.5*YARDS,-1*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsISlotInit[] = {
 {  1,18 },     /*  covers left slot */
 {  2,12 },     /*  covers LWR */
 {  5,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  3,17 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsISlot[] = {
	11,5*YARDS,-7*YARDS,
	17,7*YARDS,9*YARDS,
	12,7*YARDS,-11*YARDS,
	19,1*YARDS,6.5*YARDS,
	20,8.5*YARDS,-1*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsISlotInit[] = {
 {  1,11 },     /*  covers left slot */
 {  2,12 },     /*  covers LWR */
 {  5,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  3,17 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsISlot[] = {
	11,4*YARDS,0*YARDS,
	12,7*YARDS,-11*YARDS,
	17,7*YARDS,8*YARDS,
	18,3*YARDS,-7*YARDS,
	19,12*YARDS,3*YARDS,
	20,12*YARDS,-3*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsISlotInit[] = {
 {  1,18 },     /*  covers left slot */
 {  2,12 },     /*  covers LWR */
 {  5,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  3,17 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsSingleBack[] = {
	12,5*YARDS,-9*YARDS,
	18,1*YARDS,-5*YARDS,
	21,3.5*YARDS,5*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverGoallinevsSingleBackInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers LTE */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNormalvsSingleBack[] = {
//	12,7*YARDS,-9*YARDS,
	12,4*YARDS,-9*YARDS,
	21,6.5*YARDS,5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsSingleBackInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers LTE */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNickelvsSingleBack[] = {
	12,7*YARDS,-9*YARDS,
	21,6.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsSingleBackInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers LTE */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsSingleBack[] = {
	11,5*YARDS,0*YARDS,
	12,7.5*YARDS,-9*YARDS,
	18,6.5*YARDS,-5.5*YARDS,
	19,11*YARDS,3*YARDS,
	20,11*YARDS,-3*YARDS,
	21,6.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsSingleBackInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers LTE */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefGoallinevsSingleBackSlot[] = {
//	11,5*YARDS,0*YARDS,
//	18,2*YARDS,-5*YARDS,
//	19,1*YARDS,6.5*YARDS,
	20,2.5*YARDS,-4*YARDS,
//	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsSingleBackSlotInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers Left Slot */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsSingleBackSlot[] = {
//	11,3*YARDS,0*YARDS,
	18,5.5*YARDS,-5.5*YARDS,
//	19,1*YARDS,6.5*YARDS,
//  20,9*YARDS,-1.5*YARDS,
//	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsSingleBackSlotInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers Left Slot */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNickelvsSingleBackSlot[] = {
//	11,8*YARDS,-5.5*YARDS,
	18,3.5*YARDS,-5.5*YARDS,
//	19,1*YARDS,6.5*YARDS,
//	20,9*YARDS,-1.5*YARDS,
//	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsSingleBackSlotInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,11 },     /*  covers LWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers Left Slot */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefDimevsSingleBackSlot[] = {
	11,4*YARDS,0*YARDS,
//	12,7*YARDS,-12*YARDS,
//	17,7*YARDS,12*YARDS,
	18,6*YARDS,-6*YARDS,
	19,10*YARDS,3*YARDS,
	20,10*YARDS,-3*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};



struct CoverAssignments CoverDimevsSingleBackSlotInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers Left Slot */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsIForm[] = {
//	17,7*YARDS,10*YARDS,
	21,3.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsIFormInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  5,20 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsIForm[] = {
//	17,6.5*YARDS,10*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsIFormInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNickelvsIForm[] = {
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsIFormInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsIForm[] = {
	-1,-1,-1
};


struct CoverAssignments CoverDimevsIFormInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsProset[] = {
//	17,6.5*YARDS,10*YARDS,
	21,3.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsProsetInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  5,20 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsProset[] = {
//	17,6.5*YARDS,10*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsProsetInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNickelvsProset[] = {
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsProsetInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsProset[] = {
	-1,-1,-1
};


struct CoverAssignments CoverDimevsProsetInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsWestCoast[] = {
	20,3.5*YARDS,-3*YARDS,
//	18,2*YARDS,-5*YARDS,
//	19,3.5*YARDS,7*YARDS,
	21,5*YARDS,7*YARDS,
	11,4.5*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsWestCoastInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,11 },     /*  covers RTE  */
 {  4,21 },     /*  covers FB */
 {  5,20 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsWestCoast[] = {
//	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
//	20,7*YARDS,-3*YARDS,
//	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsWestCoastInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsWestCoast[] = {
//	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
//	20,7*YARDS,-3*YARDS,
//	21,6*YARDS,3*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverNickelvsWestCoastInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsWestCoast[] = {
//	18,2.5*YARDS,-4*YARDS,
//	19,7*YARDS,6*YARDS,
//	20,9*YARDS,-3*YARDS,
	21,7*YARDS,7*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverDimevsWestCoastInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
// {  5,18 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsShotGun[] = {
	11,5*YARDS,0*YARDS,
	18,4*YARDS,-7*YARDS,
	19,1*YARDS,6.5*YARDS,
	20,7*YARDS,-4*YARDS,
	21,4.5*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsShotGunInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers Left Slot */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsShotGun[] = {
	18,7*YARDS,-7*YARDS,
	21,7*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsShotGunInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsShotGun[] = {
	11,7*YARDS,-7*YARDS,
	21,7*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsShotGunInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  4,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsShotGun[] = {
//	11,5*YARDS,0*YARDS,
	18,9*YARDS,-7*YARDS,
	19,13*YARDS,3*YARDS,
	20,13*YARDS,-3*YARDS,
	21,9*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsShotGunInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefGoallinevsTrips[] = {
	11,5*YARDS,6*YARDS,
	17,5*YARDS,12*YARDS,
	21,5*YARDS,10*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsTripsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  5,20 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsTrips[] = {
	19,5*YARDS,6*YARDS,
//	17,8*YARDS,12*YARDS,
	17,4*YARDS,12*YARDS,
	21,9*YARDS,10*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsTripsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsTrips[] = {
	11,9*YARDS,6*YARDS,
	17,8*YARDS,12*YARDS,
	21,11*YARDS,10*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsTripsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsTrips[] = {
	19,5*YARDS,6*YARDS,
	17,8*YARDS,12*YARDS,
	21,9*YARDS,10*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsTripsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsRunAndShoot[] = {
	20,5*YARDS,-7*YARDS,
	21,5*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsRunAndShootInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsRunAndShoot[] = {
	18,5*YARDS,-7*YARDS,
	21,5*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsRunAndShootInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsRunAndShoot[] = {
	11,5*YARDS,-7*YARDS,
	21,5*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsRunAndShootInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers FB */
 {  5,18 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsRunAndShoot[] = {
	18,5*YARDS,-7*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,5*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsRunAndShootInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};





#if 0	  // ********************start placeholder man to man inits

struct defshiftDS 	DefGoallinevsSpecialTeams[] = {
	11,5*YARDS,0*YARDS,
	12,3*YARDS,-7*YARDS,
	17,3*YARDS,9*YARDS,
	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
	20,7*YARDS,-3*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsSpecialTeamsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsSpecialTeams[] = {
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsSpecialTeamsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsSpecialTeams[] = {
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsSpecialTeamsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsSpecialTeams[] = {
	-1,-1,-1
};


struct CoverAssignments CoverDimevsSpecialTeamsInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefGoallinevsOffEdit[] = {
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsOffEditInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsOffEdit[] = {
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsOffEditInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsOffEdit[] = {
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsOffEditInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsOffEdit[] = {
	-1,-1,-1
};


struct CoverAssignments CoverDimevsOffEditInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};

#endif   //****************************** end placeholder man to man inits




struct defshiftDS 	DefGoallinevsGoalLineNoWR[] = {
	12,4*YARDS,-7*YARDS,
	17,2.5*YARDS,7*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsGoalLineNoWRInit[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,21 },     /*  IRLB covers TE  */
 {  4,20 },     /* ILLB covers FB */
 {  5,19 },     /*  SS covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsGoalLineNoWR[] = {
//	11,3.5*YARDS,0*YARDS,
	12,4*YARDS,-7*YARDS,
	17,2.5*YARDS,7*YARDS,
	18,1.5*YARDS,-6*YARDS,
	19,1.5*YARDS,6*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsGoalLineNoWRInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNickelvsGoalLineNoWR[] = {
	11,3.5*YARDS,0*YARDS,
	12,4*YARDS,-7*YARDS,
	17,2.5*YARDS,7*YARDS,
//	18,1.5*YARDS,-6*YARDS,
//	19,1.5*YARDS,6*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsGoalLineNoWRInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefDimevsGoalLineNoWR[] = {
	11,4*YARDS,0*YARDS,
	12,5*YARDS,-7*YARDS,
	17,2.5*YARDS,7*YARDS,
	18,7.5*YARDS,-6*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsGoalLineNoWRInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefGoallinevsGoalLineTackle[] = {
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,8*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsGoalLineTackleInit[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  4,21 },     /*  IRLB covers TE  */
 {  3,20 },     /* ILLB covers Tackle */
 {  5,19 },     /*  SS covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsGoalLineTackle[] = {
//	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,8*YARDS,
	18,1.5*YARDS,-5*YARDS,
	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsGoalLineTackleInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,18 },     /*  covers Tackle  */
 {  4,21 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsGoalLineTackle[] = {
	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,8*YARDS,
//	18,1.5*YARDS,-5*YARDS,
//	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsGoalLineTackleInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,18 },     /*  covers Tackle  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsGoalLineTackle[] = {
	11,4*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,5*YARDS,8*YARDS,
	18,7.5*YARDS,-6*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsGoalLineTackleInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,18 },     /*  covers Tackle  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};





struct defshiftDS 	DefGoallinevsPowerIWeak[] = {
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsPowerIWeakInit[] = {
 {  1,17 },     /* RCB covers RWR */
 {  2,12 },     /* LCB covers LWR */
 {  3,20 },     /*  IRLB covers TE  */
 {  4,21 },     /* ILLB covers FB */
 {  5,19 },     /*  SS covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsPowerIWeak[] = {
	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,1.5*YARDS,-5*YARDS,
	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsPowerIWeakInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,20 },     /*  covers RTE  */
 {  4,21 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsPowerIWeak[] = {
	11,3*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,1.5*YARDS,-5*YARDS,
	19,1.5*YARDS,5*YARDS,
	20,7*YARDS,-1.5*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsPowerIWeakInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,20 },     /*  covers RTE  */
 {  4,21 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsPowerIWeak[] = {
	11,4*YARDS,0*YARDS,
	12,2.5*YARDS,-9*YARDS,
	17,4*YARDS,6*YARDS,
	18,7.5*YARDS,-6*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,7.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsPowerIWeakInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,20 },     /*  covers RTE  */
 {  4,21 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};





struct defshiftDS    DefGoallinevsFar[] = {
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverGoallinevsFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  4,20 },     /*  covers RTE  */
 {  5,21 },     /*  covers HB */
 {  3,11 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS		DefNormalvsFar[] = {
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverNormalvsFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers HB */
 {  5,11 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS		DefNickelvsFar[] = {
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  2,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,19 },     /*  covers HB */
 {  5,18 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefDimevsFar[] = {
	11,4*YARDS,0*YARDS,
	18,7.5*YARDS,-7*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,4.5*YARDS,6*YARDS,
	-1,-1,-1
};

struct CoverAssignments CoverDimevsFarInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,11 },     /*  covers HB */
 {  5,18 },     /*  covers FB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};




struct defshiftDS 	DefGoallinevsShotGunTE[] = {
	11,5*YARDS,0*YARDS,
	18,4*YARDS,-7*YARDS,
//	19,1*YARDS,6.5*YARDS,
	20,7*YARDS,-4*YARDS,
//	21,4.5*YARDS,7.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsShotGunTEInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,20 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsShotGunTE[] = {
	18,5.5*YARDS,-7*YARDS,
	19,3*YARDS,6*YARDS,
	21,4.5*YARDS,5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsShotGunTEInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsShotGunTE[] = {
	11,5.5*YARDS,-7*YARDS,
	21,4.5*YARDS,6.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsShotGunTEInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  4,11 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsShotGunTE[] = {
	18,5.5*YARDS,-7*YARDS,
	19,9*YARDS,3*YARDS,
	20,9*YARDS,-3*YARDS,
	21,4.5*YARDS,6.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsShotGunTEInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,19 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefGoallinevsQBKneel[] = {
	11,5*YARDS,0*YARDS,
	12,3*YARDS,-7*YARDS,
	17,3*YARDS,9*YARDS,
	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
	20,7*YARDS,-3*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsQBKneelInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsQBKneel[] = {
	11,5*YARDS,0*YARDS,
	12,3*YARDS,-7*YARDS,
	17,3*YARDS,9*YARDS,
	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
	20,7*YARDS,-3*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsQBKneelInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsQBKneel[] = {
	11,5*YARDS,0*YARDS,
	12,3*YARDS,-7*YARDS,
	17,3*YARDS,9*YARDS,
	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
	20,7*YARDS,-3*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsQBKneelInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefDimevsQBKneel[] = {
	11,5*YARDS,0*YARDS,
	12,3*YARDS,-7*YARDS,
	17,3*YARDS,9*YARDS,
	18,2*YARDS,-5*YARDS,
	19,4*YARDS,7*YARDS,
	20,7*YARDS,-3*YARDS,
	21,6*YARDS,3*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsQBKneelInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefGoallinevsPunt[] = {
//	11,35*YARDS,0*YARDS,	now does a script
	-1,-1,-1
};


struct CoverAssignments CoverGoallinevsPuntInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNormalvsPunt[] = {
//	20,35*YARDS,0*YARDS, now a script
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsPuntInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefNickelvsPunt[] = {
//	20,35*YARDS,0*YARDS, now a script
	-1,-1,-1
};



struct CoverAssignments CoverNickelvsPuntInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefDimevsPunt[] = {
//	20,35*YARDS,0*YARDS, now a script
	-1,-1,-1
};


struct CoverAssignments CoverDimevsPuntInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};


struct defshiftDS 	DefGoallinevsFieldGoal[] = {
	12,3*YARDS,-6.5*YARDS,
	17,3*YARDS,6.5*YARDS,
	-1,-1,-1
};



struct CoverAssignments CoverGoallinevsFieldGoalInit[] = {
// {  1,16 },     /*bonus coverage*/
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};

struct defshiftDS 	DefNormalvsFieldGoal[] = {
	12,1*YARDS,-6.5*YARDS,
	17,1*YARDS,6.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNormalvsFieldGoalInit[] = {
// {  1,16 },
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefNickelvsFieldGoal[] = {
	12,3*YARDS,-6.5*YARDS,
	17,3*YARDS,6.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverNickelvsFieldGoalInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



struct defshiftDS 	DefDimevsFieldGoal[] = {
	12,3*YARDS,-6.5*YARDS,
	17,3*YARDS,6.5*YARDS,
	-1,-1,-1
};


struct CoverAssignments CoverDimevsFieldGoalInit[] = {
 {  1,17 },     /*  covers RWR */
 {  2,12 },     /*  covers LWR */
 {  3,21 },     /*  covers RTE  */
 {  4,18 },     /*  covers FB */
 {  5,11 },     /*  covers HB  */
 {NOBODY,NOBODY}  /* ALWAYS last in this D.S. */
};



/********************** Kickoff vs. Kickoff Inits ************************/


struct defshiftDS 	DefNormalvsRight[] = {
//	0,	-12*YARDS,0*YARDS,

	1,	-12*YARDS,7*YARDS,
	2,	-12*YARDS,-1*YARDS,
	3,	-12*YARDS,-7*YARDS,
	4,	-12*YARDS,-13*YARDS,
	5,	-12*YARDS,-19*YARDS,

	6,	-25*YARDS,-15*YARDS,
	7,	-25*YARDS,-5*YARDS,
	8,	-25*YARDS,5*YARDS,
	9,	-40*YARDS,0*YARDS,
	10,	-40*YARDS,-10*YARDS,
	-1,-1,-1
};


struct defshiftDS 	DefSpreadvsRight[] = {
//	0,	-12*YARDS,0*YARDS,

	1,	-12*YARDS,7*YARDS,
	2,	-12*YARDS,-1*YARDS,
	3,	-12*YARDS,-7*YARDS,
	4,	-12*YARDS,-13*YARDS,
	5,	-12*YARDS,-19*YARDS,

	6,	-40*YARDS,-10*YARDS,
//	7,	-30*YARDS,-5*YARDS,
	8,	-40*YARDS,0*YARDS,
	9,	-25*YARDS,5*YARDS,
	10,	-25*YARDS,-15*YARDS,
	-1,-1,-1
};


struct defshiftDS 	DefHandsvsRight[] = {
//	0,	-12*YARDS,0*YARDS,

	1,	-12*YARDS,6*YARDS,
	2,	-12*YARDS,0*YARDS,
	3,	-12*YARDS,-5*YARDS,
	4,	-12*YARDS,-15*YARDS,
	5,	-12*YARDS,-20*YARDS,

	6,	-12*YARDS,-10*YARDS,
	7,	-20*YARDS,-15*YARDS,
	8,	-20*YARDS,-5*YARDS,
	9,	-35*YARDS,0*YARDS,
	10,	-35*YARDS,-10*YARDS,
	-1,-1,-1
};

struct defshiftDS 	DefNormalvsLeft[] = {
//	0,	-12*YARDS,0*YARDS,

	1,	-12*YARDS,19*YARDS,
	2,	-12*YARDS,13*YARDS,
	3,	-12*YARDS,7*YARDS,
	4,	-12*YARDS,1*YARDS,
	5,	-12*YARDS,-7*YARDS,

	6,	-25*YARDS,-5*YARDS,
	7,	-25*YARDS,5*YARDS,
	8,	-25*YARDS,15*YARDS,
	9,	-40*YARDS,10*YARDS,
	10,	-40*YARDS,0*YARDS,
	-1,-1,-1
};


struct defshiftDS 	DefSpreadvsLeft[] = {
//	0,	-12*YARDS,0*YARDS,

	1,	-12*YARDS,19*YARDS,
	2,	-12*YARDS,13*YARDS,
	3,	-12*YARDS,7*YARDS,
	4,	-12*YARDS,1*YARDS,
	5,	-12*YARDS,-7*YARDS,

	6,	-40*YARDS,0*YARDS,
//	7,	-30*YARDS,-5*YARDS,
	8,	-40*YARDS,10*YARDS,
	9,	-25*YARDS,15*YARDS,
	10,	-25*YARDS,-5*YARDS,
	-1,-1,-1
};


struct defshiftDS 	DefHandsvsLeft[] = {
//	0,	-12*YARDS,0*YARDS,

	1,	-12*YARDS,20*YARDS,
	2,	-12*YARDS,15*YARDS,
	3,	-12*YARDS,10*YARDS,
	4,	-12*YARDS,0*YARDS,
	5,	-12*YARDS,-6*YARDS,

	6,	-12*YARDS,5*YARDS,
	7,	-20*YARDS,5*YARDS,
	8,	-20*YARDS,15*YARDS,
	9,	-35*YARDS,10*YARDS,
	10,	-35*YARDS,0*YARDS,
	-1,-1,-1
};






struct defshiftDS *KOLeftShiftLookup[3] ={
	DefSpreadvsLeft,
	DefNormalvsLeft,
	DefHandsvsLeft
};

struct defshiftDS *KORightShiftLookup[3] ={
	DefSpreadvsRight,
	DefNormalvsRight,
	DefHandsvsRight
};

/**********************************************************************

		DEFENSIVE  SHIFTING   ASSIGNMENTS

	Defensive Shifting (before hke)is formation dependant - depending on the
	def. formation,	there is different shift for each offensive formation.

	NOTE: - WARNING -
	The order of the defshiftDS arrays is based on MOST
	"positional" offensive formations (WHICH ARE NOT IN SEQUENTIAL
	ORDER AS OF 2/1/96!!!)

	(To solve the non-sequentialness we use an intermediate array
	"SequentialOffFormIndex[MAX_FORMATIONS]" which should be sequential).

**********************************************************************/


struct defshiftDS *DefGoallineShiftLookup[] ={
	DefGoallinevsGoalline,
	DefGoallinevsWishBone,
	DefGoallinevsPowerI,
	DefGoallinevsNearFar,

	DefGoallinevsISlot,
	DefGoallinevsSingleBack,
	DefGoallinevsSingleBackSlot,
	DefGoallinevsIForm,

	DefGoallinevsProset,
	DefGoallinevsWestCoast,
	DefGoallinevsShotGun,
	DefGoallinevsTrips,

	DefGoallinevsRunAndShoot,
//	DefGoallinevsRunAndShoot,
//	DefGoallinevsRunAndShoot,

	DefGoallinevsGoalLineNoWR,
	DefGoallinevsGoalLineTackle,
	DefGoallinevsPowerIWeak,
	DefGoallinevsFar,

	DefGoallinevsShotGunTE,
	DefGoallinevsQBKneel,
	DefGoallinevsPunt,
	DefGoallinevsFieldGoal
};


struct defshiftDS *DefNormalShiftLookup[] ={
	DefNormalvsGoalline,
	DefNormalvsWishBone,
	DefNormalvsPowerI,
	DefNormalvsNearFar,

	DefNormalvsISlot,
	DefNormalvsSingleBack,
	DefNormalvsSingleBackSlot,
	DefNormalvsIForm,

	DefNormalvsProset,
	DefNormalvsWestCoast,
	DefNormalvsShotGun,
	DefNormalvsTrips,

	DefNormalvsRunAndShoot,
//	DefNormalvsRunAndShoot,
//	DefNormalvsRunAndShoot,

	DefNormalvsGoalLineNoWR,
	DefNormalvsGoalLineTackle,
	DefNormalvsPowerIWeak,
	DefNormalvsFar,

	DefNormalvsShotGunTE,
	DefNormalvsQBKneel,
	DefNormalvsPunt,
	DefNormalvsFieldGoal
};

struct defshiftDS *DefNickelShiftLookup[] ={
	DefNickelvsGoalline,
	DefNickelvsWishBone,
	DefNickelvsPowerI,
	DefNickelvsNearFar,

	DefNickelvsISlot,
	DefNickelvsSingleBack,
	DefNickelvsSingleBackSlot,
	DefNickelvsIForm,

	DefNickelvsProset,
	DefNickelvsWestCoast,
	DefNickelvsShotGun,
	DefNickelvsTrips,

	DefNickelvsRunAndShoot,
//	DefNickelvsRunAndShoot,
//	DefNickelvsRunAndShoot,

	DefNickelvsGoalLineNoWR,
	DefNickelvsGoalLineTackle,
	DefNickelvsPowerIWeak,
	DefNickelvsFar,

	DefNickelvsShotGunTE,
	DefNickelvsQBKneel,
	DefNickelvsPunt,
	DefNickelvsFieldGoal
};




struct defshiftDS *DefDimeShiftLookup[] ={
	DefDimevsGoalline,
	DefDimevsWishBone,
	DefDimevsPowerI,
	DefDimevsNearFar,

	DefDimevsISlot,
	DefDimevsSingleBack,
	DefDimevsSingleBackSlot,
	DefDimevsIForm,

	DefDimevsProset,
	DefDimevsWestCoast,
	DefDimevsShotGun,
	DefDimevsTrips,

	DefDimevsRunAndShoot,
//	DefDimevsRunAndShoot,
//	DefDimevsRunAndShoot,
	DefDimevsGoalLineNoWR,
	DefDimevsGoalLineTackle,
	DefDimevsPowerIWeak,
	DefDimevsFar,

	DefDimevsShotGunTE,
	DefDimevsQBKneel,
	DefDimevsPunt,
	DefDimevsFieldGoal
};


/**********************************************************************

		MAN   TO   MAN   COVERAGE   ASSIGNMENTS

	Man Coverage is formation dependant - depending on the def. formation,
	there is deferent coverage for each offensive formation.

	NOTE: - WARNING -
	The order of the CoverAssignment arrays is based on MOST
	"positional" offensive formations (WHICH ARE NOT IN SEQUENTIAL
	ORDER AS OF 2/1/96!!!)

	(To solve the non-sequentialness we use an intermediate array
	"SequentialOffFormIndex[MAX_FORMATIONS]" which should be sequential).

**********************************************************************/

struct CoverAssignments *DefGoallineCoverLookup[] ={
	CoverGoallinevsGoallineInit,
	CoverGoallinevsWishBoneInit,
	CoverGoallinevsPowerIInit,
	CoverGoallinevsNearFarInit,

	CoverGoallinevsISlotInit,
	CoverGoallinevsSingleBackInit,
	CoverGoallinevsSingleBackSlotInit,
	CoverGoallinevsIFormInit,

	CoverGoallinevsProsetInit,
	CoverGoallinevsWestCoastInit,
	CoverGoallinevsShotGunInit,
	CoverGoallinevsTripsInit,

	CoverGoallinevsRunAndShootInit,
//	CoverGoallinevsRunAndShootInit,
//	CoverGoallinevsRunAndShootInit,

	CoverGoallinevsGoalLineNoWRInit,
	CoverGoallinevsGoalLineTackleInit,
	CoverGoallinevsPowerIWeakInit,
	CoverGoallinevsFarInit,

	CoverGoallinevsShotGunTEInit,
	CoverGoallinevsQBKneelInit,
	CoverGoallinevsPuntInit,
	CoverGoallinevsFieldGoalInit
};


struct CoverAssignments *DefNormalCoverLookup[] ={
	CoverNormalvsGoallineInit,
	CoverNormalvsWishBoneInit,
	CoverNormalvsPowerIInit,
	CoverNormalvsNearFarInit,

	CoverNormalvsISlotInit,
	CoverNormalvsSingleBackInit,
	CoverNormalvsSingleBackSlotInit,
	CoverNormalvsIFormInit,

	CoverNormalvsProsetInit,
	CoverNormalvsWestCoastInit,
	CoverNormalvsShotGunInit,
	CoverNormalvsTripsInit,

	CoverNormalvsRunAndShootInit,
//	CoverNormalvsRunAndShootInit,
//	CoverNormalvsRunAndShootInit,

	CoverNormalvsGoalLineNoWRInit,
	CoverNormalvsGoalLineTackleInit,
	CoverNormalvsPowerIWeakInit,
	CoverNormalvsFarInit,

	CoverNormalvsShotGunTEInit,
	CoverNormalvsQBKneelInit,
	CoverNormalvsPuntInit,
	CoverNormalvsFieldGoalInit
};


struct CoverAssignments *DefNickelCoverLookup[] ={
	CoverNickelvsGoallineInit,
	CoverNickelvsWishBoneInit,
	CoverNickelvsPowerIInit,
	CoverNickelvsNearFarInit,

	CoverNickelvsISlotInit,
	CoverNickelvsSingleBackInit,
	CoverNickelvsSingleBackSlotInit,
	CoverNickelvsIFormInit,

	CoverNickelvsProsetInit,
	CoverNickelvsWestCoastInit,
	CoverNickelvsShotGunInit,
	CoverNickelvsTripsInit,

	CoverNickelvsRunAndShootInit,
//	CoverNickelvsRunAndShootInit,
//	CoverNickelvsRunAndShootInit,

	CoverNickelvsGoalLineNoWRInit,
	CoverNickelvsGoalLineTackleInit,
	CoverNickelvsPowerIWeakInit,
	CoverNickelvsFarInit,

	CoverNickelvsShotGunTEInit,
	CoverNickelvsQBKneelInit,
	CoverNickelvsPuntInit,
	CoverNickelvsFieldGoalInit
};


struct CoverAssignments *DefDimeCoverLookup[] ={
	CoverDimevsGoallineInit,
	CoverDimevsWishBoneInit,
	CoverDimevsPowerIInit,
	CoverDimevsNearFarInit,

	CoverDimevsISlotInit,
	CoverDimevsSingleBackInit,
	CoverDimevsSingleBackSlotInit,
	CoverDimevsIFormInit,

	CoverDimevsProsetInit,
	CoverDimevsWestCoastInit,
	CoverDimevsShotGunInit,
	CoverDimevsTripsInit,

	CoverDimevsRunAndShootInit,
//	CoverDimevsRunAndShootInit,
//	CoverDimevsRunAndShootInit,

	CoverDimevsGoalLineNoWRInit,
	CoverDimevsGoalLineTackleInit,
	CoverDimevsPowerIWeakInit,
	CoverDimevsFarInit,

	CoverDimevsShotGunTEInit,
	CoverDimevsQBKneelInit,
	CoverDimevsPuntInit,
	CoverDimevsFieldGoalInit
};




/****************************************************************

				 I N I T    M A N   T O   M A N

****************************************************************/

#if	1


void InitMan(void)
{
struct CoverAssignments *coverptr;
EFFVAR defform,offform;
EFFVAR i,j;


	defform = GameTeamData[DEFENSIVE_SLOT_NUM_MACRO].FormationNumber;
	offform = GameTeamData[OFFENSIVE_SLOT_NUM_MACRO].FormationNumber;

	if( (offform =  SequentialOffFormIndex[offform]) == -1)
		return;		// don't do following if "illegal formation

//	if(offform >= START_DEF_FORM_NUM)
//		return;

	if(defform == DEF_GOALINE_FORM_NUM)
		coverptr = DefGoallineCoverLookup[offform];
	else if (defform == DEF_NICKEL_FORM_NUM)
		coverptr = DefNickelCoverLookup[offform];
	else if (defform == DEF_DIME_FORM_NUM || defform == DEF_DIME_4MANLINE_FORM_NUM)
		coverptr = DefDimeCoverLookup[offform];
	else
		coverptr = DefNormalCoverLookup[offform];


	i=ZERO;
	while( (j = (coverptr+i)->OffenseSoltNum) != (BYTE)(-1))
	{
		OPGuyToCover((coverptr+i)->DefenseSoltNum) = j;
		i++;
	}

/** not here - at snap so user can't audible into it
	if(GameTeamData[OffensiveSlotNum].PlayNum == ISlotFleaFlickerNUM)
	{	// stop this play
		OPGuyToCover(20) = Receivers[2];	// FS covers triangleguy
	}
***/

}

#else

void InitMan(struct CoverAssignments *Assign)
{
EFFVAR j;
EFFVAR i = 0;

	while((j =  Assign[i].OffenseSoltNum) != NOBODY)
	{
		OPGuyToCover(Assign[i].DefenseSoltNum) = j;
		i++;
	}
	if(GameTeamData[OFFENSIVE_SLOT_NUM_MACRO].FormationNumber == I_SLOT_FORM_NUM)
	{
		OPGuyToCover(21) = 1; // SS covers RR
		OPGuyToCover(17) = 3; // RC covers RTE
	}
}

#endif




#define	MAX_CPU_AUDIBLES	3


struct audiblechoice
{
	UBYTE audiblepercent;
	UBYTE audibleplay[MAX_CPU_AUDIBLES];
};



struct audiblechoice CPUAudibleChoices[13][5] = {


// goalline vs goalline
{{	2,
	GoalLineGoalLineFloodNUM,
	GoalLineTackleEligibleNUM,
	GoalLineOptionPassNUM
},

// goalline vs 43
{	1,
	GoalLineHBPowerNUM,
	GoalLineTackleEligibleNUM,
	GoalLineHBTrapNUM
},

// goalline vs 34
{	1,
	GoalLineHBPowerNUM,
	GoalLineTackleEligibleNUM,
	GoalLineHBLeapNUM
},

// goalline vs Nickel
{	3,
	GoalLineHBPowerNUM,
	GoalLineHBTrapNUM,
	GoalLineHBLeapNUM
},

// goalline vs Dime
{	3,
	GoalLineHBPowerNUM,
	GoalLineHBTrapNUM,
	GoalLineHBLeapNUM,
},},

// Wishbone vs goalline
{{	2,
	WishBone10YardCurlNUM,	//SHORT
	WishBoneHBScreenNUM,
	WishBoneTEBombNUM,			   //LONG
},

// Wishbone vs 43
{	1,
	WishBone10YardCurlNUM,	//SHORT
	WishBonePowerHBDiveNUM,			   //RUN
	WishBoneTEBombNUM,			   //LONG
},

// Wishbone vs 34
{	1,
	WishBone10YardCurlNUM,	//SHORT
	WishBonePowerHBDiveNUM,			   //RUN
	WishBoneTEBombNUM,			   //LONG
},

// Wishbone vs Nickel
{	3,
	WishBoneStudentBodySweepNUM,
	WishBonePowerHBDiveNUM,
	WishBoneQuickPitchNUM,
},

// Wishbone vs Dime
{	3,
	WishBoneStudentBodySweepNUM,
	WishBonePowerHBDiveNUM,
	WishBoneQuickPitchNUM,
},},

// PowerI vs goalline
{{	2,
	PowerIHBScreenNUM,
	PowerIRollOutNUM,
	PowerITEBombNUM,
},

// PowerI vs 43
{	1,
	PowerIHBScreenNUM,
	PowerIPowerHBDiveNUM,
	PowerITEBombNUM,
},

// PowerI vs 34
{	1,
	PowerIHBScreenNUM,
	PowerIPowerHBDiveNUM,
	PowerITEBombNUM,
},

// PowerI vs Nickel
{	3,
	PowerIPowerHBDiveNUM,
	PowerIFBMisdirectionNUM,
	PowerIPitchSweepNUM,
},

// PowerI vs Dime
{	3,
	PowerIPowerHBDiveNUM,
	PowerIFBMisdirectionNUM,
	PowerIPitchSweepNUM,
},},


// NearFar vs goalline
{{	2,
	NearFarTEBombNUM,
	NearFar10YardCurlNUM,
	NearFarFBScreenNUM,
},

// NearFar vs 43
{	1,
	NearFar10YardCurlNUM,
	NearFarHBOffTackleNUM,
	NearFarTEBombNUM,
},

// NearFar vs 34
{	1,
	NearFar10YardCurlNUM,
	NearFarHBOffTackleNUM,
	NearFarTEBombNUM,
},

// NearFar vs Nickel
{	2,
	NearFarHBOffTackleNUM,
	NearFarFBQuickPitchNUM,
	NearFarPowerHBRunNUM,
},

// NearFar vs Dime
{	2,
	NearFarHBOffTackleNUM,
	NearFarFBQuickPitchNUM,
	NearFarPowerHBRunNUM,
},},

// ISlot vs goalline
{{	2,
	ISlotBombNUM,
	ISlotTEFlyNUM,
	ISlotTEScreenNUM,
},

// ISlot vs 43
{	1,
	ISlotBombNUM,
	ISlotCrackBackNUM,
	ISlotTEScreenNUM,
},

// ISlot vs 34
{	1,
	ISlotBombNUM,
	ISlotCrackBackNUM,
	ISlotTEScreenNUM,
},

// ISlot vs Nickel
{	2,
	ISlotHBRunMiddleNUM,
	ISlotCrackBackNUM,
	ISlotFBPowerNUM,
},

// ISlot vs Dime
{	2,
	ISlotHBRunMiddleNUM,
	ISlotCrackBackNUM,
	ISlotFBPowerNUM,
},},


// SingleBack vs goalline
{{	2,
	SingleBackShortPostNUM,
	SingleBackPACrossNUM,
	SingleBack10YardCurlsNUM,
},

// SingleBack vs 43
{	1,
	SingleBackShortPostNUM,
	SingleBackPowerLeadNUM,
	SingleBackHBTossNUM,
},

// SingleBack vs 34
{	1,
	SingleBackShortPostNUM,
	SingleBackPowerLeadNUM,
	SingleBackHBTossNUM,
},

// SingleBack vs Nickel
{	2,
	SingleBackCounterPitchNUM,
	SingleBackPowerLeadNUM,
	SingleBackHBTossNUM,
},

// SingleBack vs Dime
{	2,
	SingleBackCounterPitchNUM,
	SingleBackPowerLeadNUM,
	SingleBackHBTossNUM,
},},


// HBack vs goalline
{{	2,
	HBackPACrossesNUM,
	HBackQuickOutsNUM,
	HBackBombNUM,
},

// HBack vs 43
{	1,
	HBackPACrossesNUM,
	HBackQuickOutsNUM,
	HBackHBCenterTrapNUM,
},

// HBack vs 34
{	1,
	HBackPACrossesNUM,
	HBackQuickOutsNUM,
	HBackHBCenterTrapNUM,
},

// HBack vs Nickel
{	2,
	HBackReverseNUM,
	HBackCrackBackSweepNUM,
	HBackHBCenterTrapNUM,
},

// HBack vs Dime
{	2,
	HBackReverseNUM,
	HBackCrackBackSweepNUM,
	HBackHBCenterTrapNUM,
},},


// IForm vs goalline
{{	2,
	IFormOutAndUpsNUM,
	IFormHBScreenNUM,
	IFormPAHBFlyNUM,
},

// IForm vs 43
{	1,
	IFormFBPunchNUM,
	IFormStrongPitchNUM,
	IFormPAHBFlyNUM,
},

// IForm vs 34
{	1,
	IFormOutAndUpsNUM,
	IFormFBPunchNUM,
	IFormStrongPitchNUM,
},

// IForm vs Nickel
{	2,
	IFormCounterPullLeftNUM,
	IFormFBPunchNUM,
	IFormStrongPitchNUM,
},

// IForm vs Dime
{	2,
	IFormCounterPullLeftNUM,
	IFormFBPunchNUM,
	IFormStrongPitchNUM,
},},


// Proset vs goalline
{{	2,
	ProSetInsideSlantNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,
},

// Proset vs 43
{	1,
	ProSetInsideSlantNUM,
	ProSetTEPostNUM,
	ProSetStrongPitchNUM,
},

// Proset vs 34
{	1,
	ProSetStrongPitchNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,
},

// Proset vs Nickel
{	1,
	ProSetStrongPitchNUM,
	ProSetQuickPitchWeakNUM,
	ProSetPowerBlastNUM,
},

// Proset vs Dime
{	1,
	ProSetStrongPitchNUM,
	ProSetQuickPitchWeakNUM,
	ProSetPowerBlastNUM,
},},


// West Coast vs goalline
{{	3,
	WestCoastPASlantNUM,
	WestCoastBombNUM,
	WestCoastNoBackPassNUM,
},

// West Coast vs 43
{	1,
	WestCoastPASlantNUM,
	WestCoastOffTackleNUM,
	WestCoastNoBackPassNUM,
},

// West Coast vs 34
{	1,
	WestCoastOffTackleNUM,
	WestCoastBombNUM,
	WestCoastNoBackPassNUM,
},

// West Coast vs Nickel
{	2,
	WestCoastQBDrawNUM,
	WestCoastOffTackleNUM,
	WestCoastSprintHandOffNUM,
},

// West Coast vs Dime
{	2,
	WestCoastQBDrawNUM,
	WestCoastOffTackleNUM,
	WestCoastSprintHandOffNUM,
},},


// Shotgun vs goalline
{{	3,
	ShotGunSwingPassNUM,
	ShotGunShortCrossNUM,
	ShotGunHailMaryNUM,
},

// Shotgun vs 43
{	1,
	ShotGunSwingPassNUM,
	ShotGunShortCrossNUM,
	ShotGunRunGunWideNUM,
},

// Shotgun vs 34
{	1,
	ShotGunSwingPassNUM,
	ShotGunShortCrossNUM,
	ShotGunRunGunWideNUM,
},

// Shotgun vs Nickel
{	2,
	ShotGunRunGunWideNUM,
	ShotGunHBSnapNUM,
	ShotGunShovelPassNUM,
},

// Shotgun vs Dime
{	2,
	ShotGunRunGunWideNUM,
	ShotGunHBSnapNUM,
	ShotGunShovelPassNUM,
},},


// Trips vs goalline
{{	3,
	TripsClearOutNUM,
	TripsSlantCrossNUM,
	TripsPickPassNUM,
},

// Trips vs 43
{	1,
	TripsClearOutNUM,
	TripsCenterTrapNUM,
	TripsPickPassNUM,
},

// Trips vs 34
{	1,
	TripsCenterTrapNUM,
	TripsSlantCrossNUM,
	TripsPickPassNUM,
},

// Trips vs Nickel
{	2,
	TripsPitchAwayNUM,
	TripsCenterTrapNUM,
	TripsReverseNUM,
},

// Trips vs Dime
{	2,
	TripsPitchAwayNUM,
	TripsCenterTrapNUM,
	TripsReverseNUM,
},},


// RunShoot vs goalline
{{	3,
	RunAndShootMotionFlatNUM,
	RunAndShootHBCurlNUM,
	RunAndShootPostIsoNUM,
},

// RunShoot vs 43
{	1,
	RunAndShootMotionFlatNUM,
	RunAndShootOffGuardNUM,
	RunAndShootPostIsoNUM,
},

// RunShoot vs 34
{	1,
	RunAndShootMotionFlatNUM,
	RunAndShootOffGuardNUM,
	RunAndShootPostIsoNUM,
},

// RunShoot vs Nickel
{	2,
	RunAndShootPitchBackNUM,
	RunAndShootReverseNUM,
	RunAndShootOffGuardNUM,
},

// RunShoot vs Dime
{	2,
	RunAndShootPitchBackNUM,
	RunAndShootReverseNUM,
	RunAndShootOffGuardNUM,
},}


};



/********************* End of File - FbAiInit.c  ********************/
