/*********************************************************************


					FBAUDIO.C

	INITIAL AUTHOR: M. Knauer       Start Date: 9/19/96

	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains AI related audio & SFX.


	AND  Instant Replay Stuff
	AND  Audibles
	AND toggling
	AND 				 C O N T R O L L E R     S T U F F

***********************************************************************/

	#include  "fbequ.h"
	#include  "fbRAM.h"		/* external VARs needed by this file	*/
	#include  "sound1.h"



/***********  prototypes  *******************/

void AISetCrowdLevel(void);	//
void HandleCrowdSound(void);
void SetNewCrowdVolume(WORD crowdchannel, WORD desiredvolume,WORD tickstodesired);
void SetNewCrowdVolumeDelta(WORD crowdchannel, WORD desiredvolume,UWORD delta);
void StopCrowdVolumeRamping(WORD crowdchannel);
void AIInitSFXLoop2(WORD newloopsfx,WORD desiredvol, WORD ticks);


WORD GetTrueYardline(void);	// returns 1-50


BOOL SwapControllers(WORD newplayerslotnum, WORD oldplayerslotnum);
void ChangeControlledPlayer(WORD jpad_num,WORD incval,WORD toggletype);

void  DefBeforeSnapAction(void);	//a player ACTION where toggled off of


WORD Grunts[16] = {

	GRUNT0_SFX,GRUNT1_SFX,GRUNT2_SFX,GRUNT3_SFX,
	GRUNT4_SFX,GRUNT5_SFX,GRUNT6_SFX,GRUNT7_SFX,
	GRUNT0_SFX,GRUNT1_SFX,GRUNT2_SFX,GRUNT3_SFX,
	GRUNT4_SFX,GRUNT5_SFX,GRUNT6_SFX,GET_HIM_SFX

};



/**************************************************************************

						 A U D I O    S  T U F F

**************************************************************************/


WORD AIPlayEffectCheck(WORD sfxnum)	// won't play if already playing this SFX
{
//	if(GameOptions[GAME_OPTNS_SFX_VOL] != ZERO)	// default 0 is ON
		return(PlayEffectCheck(sfxnum));	// returns channel number of SFX
//	else
//		return(-1);
};

WORD AIPlayEffect(WORD sfxnum)	// play EVEN if already playing this SFX
{
//	if(GameOptions[GAME_OPTNS_SFX_VOL] != ZERO)	// default 0 is ON
		return(PlayEffect(sfxnum));	// returns channel number of SFX
//	else
//		return(-1);
};


WORD AIPlayQBSFX(WORD sfxnum)	// won't play if already playing this SFX
{
//	if(GameOptions[GAME_OPTNS_SFX_VOL] != ZERO)	// default 0 is ON
		return(PlayEffectPitchCheck(sfxnum,QBAudioPitch[OffensiveSlotNum]));	// returns channel number of SFX
//	else
//		return(-1);
};


void AudioCrowdReaction(WORD sfxnum, WORD basevolume)
{

	SetVoiceVolume(AIPlayEffect(sfxnum),basevolume,basevolume);
}



void HomeOrAwayAudioCrowdReaction(WORD homesfx, WORD awaysfx)
{
	if(HOME_TEAM_HAS_BALL)
		AudioCrowdReaction(homesfx, CROWD_REACT_VOL_HIGH);
	else
		AudioCrowdReaction(awaysfx, CROWD_REACT_VOL_HIGH);
}

#ifndef	TRUE_SOUND

//#ifndef  PC_ALWAYS_MODE
/********************************************************************

				DUMMY    SOUND   ROUTINES

		following are medium level platform specific sound calls
		which should call hardware related functions

********************************************************************/

void InitAudio(void)	// hardware specific
{
}

//void SetCrowdLevel(BYTE v0,BYTE v1,BYTE v2,BYTE v3,BYTE LChannelPercent);	//

// set all 4 looping volumes (3 crowd + extra)
void SetCrowdLevel(WORD v0,WORD v1,WORD v2,WORD v3,WORD LChannelPercent)
//void SetCrowdLevel(BYTE loudness0_89,BYTE LChannelPercent)
{ // range on L channel = 25-75
	v0 = v1= v2= LChannelPercent;		// i hate warnings
	LChannelPercent = v0;
	v1= v2 = v3;
	v2=v1;
	v3 = v1;
	v3 = v2;
}
void InitPhrase(short *PhrasePtr, short num)
{
	num = *PhrasePtr;
	num = num;
}

WORD PlayEffectPitchCheck(WORD sfxnum, WORD pitch)	// returns channel number of SFX
{	// for different QB voices
	pitch = sfxnum;	// no WARNINGs please
	return(pitch);
}

void SetVoiceVolume(WORD voicenum, WORD volumeL, WORD volumeR)
{	//stero volume control
	volumeL = volumeR; 	// i hate complier warnings
	volumeR = volumeL;
	voicenum = voicenum;

};

short PlayEffect(short num)     	//for whistles
{	// play no matter what
	return(num);
}

short PlayEffectCheck(short num)	// 95% of SFX use this
{	// don't play if aleady playing
	return(num);
}

void InitSFXLoop(WORD newloopsfx)	//proto
{	// last crowd channel
	newloopsfx = newloopsfx;
}

short CheckEffect(short voice_channel)
{	// see if done
	voice_channel = FALSE;
	return(voice_channel);
}

#endif
/*----------------   End dummy Low level audio calls --------------*/



/*  as of 4/23/97 InitPhrase handles Background loading - will not start
the audio until PhraseFlag = TRUE				*/
void LoadAnnouncerPhrase(void)
{
	if(WordsInAnnouncerPhrase > ZERO)	/*  say announcer stuff	*/
	{
		if(!PracticeMode)
		{
			InitPhrase(AIAnnouncerPhrase, WordsInAnnouncerPhrase);	// low level audio call
		}
		WordsInAnnouncerPhrase = ZERO;	// clear so we don't say again
	}
}

void SayAnnouncerPhrase(void)
{
	PhraseFlag = TRUE;
}

/*
void InitAnnouncerPhrase(WORD firstword)
{
	AIAnnouncerPhrase[0] = firstword;
	WordsInAnnouncerPhrase = 1;
}
*/


void AddToAnnouncerPhrase(WORD word)
{
	AIAnnouncerPhrase[WordsInAnnouncerPhrase++] = word;
}

void BuildAnnouncerPhrase(WORD word)
{
	AIAnnouncerPhrase[WordsInAnnouncerPhrase++] = word;
}

void BuildAnnouncerPhraseInit(WORD firstword)
{
	AIAnnouncerPhrase[0] = firstword;
	WordsInAnnouncerPhrase = 1;
}

void SayRefPhrase(void)		// called from ref script
{
#ifdef SATURNMODE
	PlayEffectCheck(AIRefPhrase[0]);
#else
	if(WordsInRefPhrase > ZERO)	/*  say ref stuff	*/
	{
	 /****
		if(WordsInRefPhrase == 1)
		{ // could not hear if announcer talking so make it a sfx not phrase
			PlayEffectCheck(AIRefPhrase[0]);
		}
		else
		{
			InitPhrase(AIRefPhrase, WordsInRefPhrase);	// low level audio call
		}
		*****/
		PlayEffectCheck(AIRefPhrase[0]);
		WordsInRefPhrase = ZERO;	// clear so we don't say again
	}
#endif
}

void InitRefPhrase(WORD firstword)
{
	AIRefPhrase[0] = firstword;
	WordsInRefPhrase = 1;
}

void AddToRefPhrase(WORD word)
{
	AIRefPhrase[WordsInRefPhrase++] = word;
}

/*----------------------------------------------------------------------


				 A N N O U N C E R     S T U F F


----------------------------------------------------------------------*/

void InsertBlankAudio(WORD num)
{
EFFVAR i;

	for(i=0; i<num; i++)
	{
		AddToAnnouncerPhrase(SILENCE_SFX);
	}

}
//WORD FirstConvert[5] = {0,FIRST_SFX,SECOND_SFX,THIRD_SFX,FOURTH_SFX};
WORD FirstConvert[5] = {
	0,
	FIRST_DOWN_SFX,
	SECOND_DOWN_SFX,
	THIRD_DOWN_SFX,
	FOURTH_DOWN_SFX
};


void AnnounceDownAndYards(void)
{
EFFVAR togo;
EFFVAR randnum;
EFFVAR phrasenum;

	if(TheDown > ZERO && TheDown < 5  && FirstDownX > 0)	// error check
	{
		randnum = rand();
		togo = (FirstDownX-StartBallX)>>YARD_SHIFT;

		phrasenum = FirstConvert[TheDown];	// get starting value

		if(FirstDownX == OFF_GOAL_LINE)	// goal to go
		{
			phrasenum--;	// index before is "goal-to-go"

		}
		else if(TheDown == 1)
		{ // 1st down don't say as much as it's usually 10 to go

			if(togo > 15)
				phrasenum += 7;
			else if(togo == 15)
				phrasenum += 6;
			else if(togo == 5)
				phrasenum += 5;
			else if(togo == 10)	// 1/2 time say "and ten"
			{
				phrasenum = phrasenum +1 + (randnum&3);
			}
			//else {just say "1st down"}
		}
		else if(TheDown == 2 && (randnum & 0x0001))
		{
			  // sometimes only say "2nd down"
		}
		else // 3rd or 4th - give lots of info
		{
			if(togo > 15)
				phrasenum += 16;
			else
				phrasenum += togo;
		}

		BuildAnnouncerPhraseInit(phrasenum);	// always say "1st/2nd/.." etc.
		LoadAnnouncerPhrase();
		SayAnnouncerPhrase();
	}

}

#define	NYJ 	14	//Jets
#define	NYG     28	//Giants
#define AUDIO_TEAM_CITY	0
#define AUDIO_TEAM_NAME	1

//WORD AudioTeamNames[2][2] = {HOME_CITY,HOME_TEAM,	// audio equates
//							AWAY_CITY,AWAY_TEAM};
/*

WORD GetRandomAudioTeamCityOrName(void)
{	// RETURNS an INDEX to AudioTeamNames[team][index]
	if( (GameTeamData[0].TeamNumber == NYJ && GameTeamData[1].TeamNumber == NYG)
	  || (GameTeamData[0].TeamNumber == NYG && GameTeamData[1].TeamNumber == NYJ)
	  || (rand()&1)
	  )
	{	// say nicknames if both new york teams playing
//		type = AUDIO_TEAM_NAME;
//		teams[0] = HOME_TEAM;
//		teams[1] = AWAY_TEAM;
		return(1);	// use team names
	}
	else
	{
		return(0);	// use city names

	}

}
*/
void AnnounceScore(void)
{
/*  say either "Green Bay 10, Minnesota 7" or "Packers 10, Vikings 7"
	winning team first (if tie say home team first)			*/

#ifndef SATURNMODE       // no score on Saturn

EFFVAR ahead;	//,index;

	ahead = (GameTeamData[0].TotalScore < GameTeamData[1].TotalScore) ? 1:0;
/*
	index = GetRandomAudioTeamCityOrName();	// index is city or nickname

	InitAnnouncerPhrase(AudioTeamNames[ahead][index]);
	AddToAnnouncerPhrase(-GameTeamData[ahead].TotalScore);	//audio nums are negative
	AddToAnnouncerPhrase(AudioTeamNames[ahead^1][index]);
	AddToAnnouncerPhrase(-GameTeamData[ahead^1].TotalScore);	//audio nums are negative
	SayAnnouncerPhrase();
*/
/*
	if(rand()&1)	// new 10/8/96   "Raiders 10,Chiefs 7"
	{
		InitAnnouncerPhrase(AudioTeamNames[ahead][1]);
		AddToAnnouncerPhrase(-GameTeamData[ahead].TotalScore);	//audio nums are negative
		AddToAnnouncerPhrase(AudioTeamNames[ahead^1][1]);
		AddToAnnouncerPhrase(-GameTeamData[ahead^1].TotalScore);	//audio nums are negative
	}
	else	//  or "Oakland Raiders 10, K.C. Chiefs 7"
	{
		InitAnnouncerPhrase(AudioTeamNames[ahead][0]);
		AddToAnnouncerPhrase(AudioTeamNames[ahead][1]);
		AddToAnnouncerPhrase(-GameTeamData[ahead].TotalScore);	//audio nums are negative
		AddToAnnouncerPhrase(AudioTeamNames[ahead^1][0]);
		AddToAnnouncerPhrase(AudioTeamNames[ahead^1][1]);
		AddToAnnouncerPhrase(-GameTeamData[ahead^1].TotalScore);	//audio nums are negative
	}
	SayAnnouncerPhrase();
*/


	BuildAnnouncerPhraseInit(NICKNAME_SFX+GameTeamData[ahead].TeamNumber);
//	InsertBlankAudio(3);	//4
	AddToAnnouncerPhrase(NUMBERS1_SFX + GameTeamData[ahead].TotalScore);
//	InsertBlankAudio(2);	//3
	AddToAnnouncerPhrase(NICKNAME_SFX+GameTeamData[ahead^1].TeamNumber);
//	InsertBlankAudio(3); 	//4
	AddToAnnouncerPhrase(NUMBERS1_SFX + GameTeamData[ahead^1].TotalScore);

/**** old
	InitAnnouncerPhrase(AudioTeamNames[ahead][1]);
	InsertBlankAudio(3);	//4
	AddToAnnouncerPhrase(-GameTeamData[ahead].TotalScore);	//audio nums are negative
	InsertBlankAudio(2);	//3
	AddToAnnouncerPhrase(AudioTeamNames[ahead^1][1]);
	InsertBlankAudio(3); 	//4
	AddToAnnouncerPhrase(-GameTeamData[ahead^1].TotalScore);	//audio nums are negative
***/
	LoadAnnouncerPhrase();
	SayAnnouncerPhrase();


#endif
}




void AnnouncerSayTimeOut(WORD teamslotnum)
{

	if(WordsInAnnouncerPhrase == ZERO)
	{ 	// buffer empty - say it now

//		BuildAnnouncerPhraseInit(TIMEOUT_SFX);
		InsertBlankAudio(4);

//		AddToAnnouncerPhrase(AudioTeamNames[teamslotnum][AUDIO_TEAM_NAME]);   //Dolphins
		AddToAnnouncerPhrase(NICKNAME_SFX+GameTeamData[teamslotnum].TeamNumber);

//		LoadAnnouncerPhrase();	// load it ...
//		SayAnnouncerPhrase();	// ... and say it now

/*  following didn't sound right - CITY+NICKNAME doesn't fit right */

	}
	else
	{ 	// already something in announcer buffer - just add to it - will say later
//		AddToAnnouncerPhrase(TIMEOUT_SFX);
//		AddToAnnouncerPhrase(AudioTeamNames[teamslotnum][AUDIO_TEAM_NAME]);   //Dolphins
//		AddToAnnouncerPhrase(AudioTeamNames[teamslotnum][index]);
	}

}



void AnnounceYardsGained(void)	/*  and build audio phrases	*/
{
EFFVAR offset;

//NOTE: audio phrase said later( approx. 2 sec. after play over
// yards is actual yards (i.e. 1,2,3 NOT normal yards - (3*YARDS)


//	if(PlayType != KICKOFF_PLAY)
	if(PlayType < EX_PT1_PLAY)	// no expt or KO -SEga bug#200,201
	{
		if(YardsGainedThisPlay >= ZERO)
		{
			if(YardsGainedThisPlay > 20)
			{
				offset = 21;
			}
			else
			{
				offset = YardsGainedThisPlay;
			}

			BuildAnnouncerPhraseInit(GAIN_SFX+offset*3);

			if(EventFlags.TD_HAPPENED_BFLAG)
			{
				AddToAnnouncerPhrase(TOUCHDOWN_SFX);
			}
		}
		else	//loss
		{
			if(YardsGainedThisPlay > -13)
			{
				offset = 12;
			}
			else
			{
				offset = -YardsGainedThisPlay-1;
			}

			if(SackYards != INVALID_DISTANCE)
			{
				BuildAnnouncerPhraseInit(SACKED_FOR_SFX+offset);
			}
			else
			{
				BuildAnnouncerPhraseInit(LOSS_ON_SFX+offset);
			}


		}
		LoadAnnouncerPhrase();	// but don't say it yet
	}
}


/*------------------------------------------------------------*/

#define MAX_NUM_SL_SFX	16
#ifdef SATURNMODE
WORD GenericSideLineAudio[MAX_NUM_SL_SFX+1] = {
	CHAT1_SFX,CHAT2_SFX,CHAT3_SFX,CHAT4_SFX,
	CHAT1_SFX,CHAT2_SFX,CHAT3_SFX,CHAT4_SFX,
	CHAT5_SFX,CHAT6_SFX,CHAT7_SFX,CHAT8_SFX,
//	YOU_SUCK_SFX,COME_ON_SFX,GET_HIM1_SFX,BOO_SFX,
	CHAT6_SFX,COME_ON_SFX,GET_HIM1_SFX,BOO_SFX,
	BLOCK_IT_SFX						// special case
};
#else
WORD GenericSideLineAudio[MAX_NUM_SL_SFX+1] = {
	CHAT1_SFX,CHAT2_SFX,CHAT3_SFX,CHAT4_SFX,
	CHAT1_SFX,CHAT2_SFX,CHAT3_SFX,CHAT4_SFX,
	CHAT5_SFX,CHAT6_SFX,CHAT7_SFX,CHAT8_SFX,
	YOU_SUCK_SFX,COME_ON_SFX,GET_HIM1_SFX,BOO_SFX,
	BLOCK_IT_SFX						// special case
};
#endif


void HandleSideLineAudio(void)
{	// just some random yells to add to the ambiance
EFFVAR index;
EFFVAR rannum;	// okay to use random num more than once (and saves calls)

//	if(GameOptions[GAME_OPTNS_SFX_VOL] == ZERO)	// 0 is no sound
//		return;

	SideLineAudioTimer -= TICKS_PER_AI_FRAME;
	if( SideLineAudioTimer < ZERO)
	{
		rannum = rand();
		index = (rannum & (MAX_NUM_SL_SFX-1));

		if( (PlayFlags & (POS_PUNT_NOPOOCH_PLAY_BFLAG | POS_FG_PLAY_BFLAG)) // punt or FG
			&& (OffensiveSlotNum == AWAY_TEAM_SLOT)		// .. by AWAY team
			&& (PlayStateNum < PS_PlayHappeningNUM)		// .. before hike
			&&  (rannum & 0x0010)						// 1/2 the time
		  )
			index = MAX_NUM_SL_SFX; 	//"block it"

		AIPlayEffectCheck(GenericSideLineAudio[index]);
		SideLineAudioTimer = SECOND + (rannum&127); // 1-3 sec
							//0.5 - 2.5 seconds was too much

	}

}



void InitAtLOSAudio(void)
{

	if(PlayFlags & POS_PUNT_NOPOOCH_PLAY_BFLAG) // punt
	{
		if(rand()&1)
		{
//			InitAnnouncerPhrase(AudioTeamNames[OffensiveSlotNum][AUDIO_TEAM_NAME]);
			BuildAnnouncerPhraseInit(NICKNAME_SFX+GameTeamData[OffensiveSlotNum].TeamNumber);
			AddToAnnouncerPhrase(PUNT_FORMATION);	// "JETS ... in punt formation"
		}
		else
		{
//			InitAnnouncerPhrase(NUMBER_SFX);
//			AddToAnnouncerPhrase(-GetJerseyNum(PosPuntReturner));	// "Number 21..."
//			AddToAnnouncerPhrase(BACK_TO_RECEIVE);	// "... back to receive"

		}

		LoadAnnouncerPhrase();
		SayAnnouncerPhrase();	// if options say okay

	}
	else if( (PlayFlags & POS_FG_PLAY_BFLAG) // FG
			&& (!(PlayType == EX_PT1_PLAY || PlayType == EX_PT2_PLAY))
		)
	{
//		InitAnnouncerPhrase(AudioTeamNames[OffensiveSlotNum][AUDIO_TEAM_NAME]);
/**
		BuildAnnouncerPhraseInit(NICKNAME_SFX+GameTeamData[OffensiveSlotNum].TeamNumber);
		AddToAnnouncerPhrase(FIELD_GOAL);	// "Jets... to attempt a FG"

		LoadAnnouncerPhrase();
		SayAnnouncerPhrase();	// if options say okay
**/
	}

}


#define MIN_GRUNT_VOL	20	//was 50


void PlayBlockingSounds(void)
{ 	// modified 8/13/96 - only play one sound at end of AI loop
EFFVAR channel,rvol,lvol;

	if(MaxBlockAudioDistance < LARGE_DISTANCE)
	{	// a sound was triggered this frame
		channel = AIPlayEffectCheck(Grunts[(rand()&15)]);

		if(channel > -1)	// valid audio channel???
		{

		//	lvol = MAX_VOLUME - (dist>>7);	// subtract Yards time 2
		// above was too loud according to barry
#ifdef SATURNMODE	// not as loud on Saturn
			lvol = 100 - (MaxBlockAudioDistance>>7);	// subtract 2 Yards
#else
			lvol = 60 - (MaxBlockAudioDistance>>9);	// subtract 1/2 Yard
#endif
			if( lvol < MIN_GRUNT_VOL)
				lvol = MIN_GRUNT_VOL;

			rvol = lvol;
			if(KeyAudioY < BallYPosition-5*YARDS)
				rvol >>= 1;
			else if(KeyAudioY > BallYPosition+5*YARDS)
				lvol >>= 1;

			SetVoiceVolume(channel, lvol,rvol);
		}
	}
}



void HandleMinorCrowdRamping(void);
/*-----------------------------------------------------------------------


							CROWD    SOUNDS

	Crowd uses 3 voices played on 6 channels (each voices is "detuned")

	Low crowd sound is standard white noise
	Med crowd sound is swell during KO, when ball passed
	High crowd sound is cheering


	There are 2 ways to ramp up/down volume
	1) Time based - use SetNewCrowdVolume()	will reached desired volume
		in X amount of time.
	2) Delta volume based - use SetNewCrowdVolumeDelta()
		keeps changing curvolume by delat until desired volume is reached

---------------------------------------------------------------------*/

void HandleCrowdSound(void)		// called once per AI loop
{
//BOOL needsoundupdate = FALSE;
BOOL needsoundupdate = TRUE;	// always true if MID ramping
EFFVAR i;

	HandleMinorCrowdRamping();	// MID ramps all the time

	for(i=0; i<	NUM_MAJOR_CROWD_SFXS; i++)
	{
		if(CurCrowdVolume[i] != DesiredCrowdVolume[i])
		{
			needsoundupdate = TRUE;

			if(CurCrowdVolume[i] > DesiredCrowdVolume[i])
			{	// ramp down
				CurCrowdVolume[i] -= CrowdVolumeDelta[i];
				if(CurCrowdVolume[i] <= DesiredCrowdVolume[i])
					CurCrowdVolume[i] = DesiredCrowdVolume[i];
			}
			else
			{	// ramp up
				CurCrowdVolume[i] += CrowdVolumeDelta[i];
				if(CurCrowdVolume[i] >= DesiredCrowdVolume[i])
					CurCrowdVolume[i] = DesiredCrowdVolume[i];
			}
		}
	}

	if(LeftChannelPercent != DesiredLeftChannelPercent)
	{
		needsoundupdate = TRUE;
		if(LeftChannelPercent > DesiredLeftChannelPercent)
		{	// ramp down
			LeftChannelPercent -= 1;
			if(LeftChannelPercent <= DesiredLeftChannelPercent)
				LeftChannelPercent = DesiredLeftChannelPercent;
		}
		else
		{	// ramp up
			LeftChannelPercent += 1;
			if(LeftChannelPercent >= DesiredLeftChannelPercent)
				LeftChannelPercent = DesiredLeftChannelPercent;
		}

	}

	if(needsoundupdate)
		AISetCrowdLevel();

}


void AIInitSFXLoop2(WORD newloopsfx,WORD desiredvol, WORD ticks)
{

	if( newloopsfx != CurLoopSFXNum
	 && CurLoopSFXNum != -1
	 && DesiredCrowdVolume[LOOP_SFX] != ZERO
	 )
	{
		DesiredCrowdVolume[LOOP_SFX] = ZERO;	// kill other one

	}
	else
	{
		CurLoopSFXNum = newloopsfx;

		InitSFXLoop(newloopsfx);
		SetNewCrowdVolume(LOOP_SFX, desiredvol,ticks);	// sets delta and desired vol
//		CurCrowdVolume[LOOP_SFX] = 0;



//		AISetCrowdLevel();
	}
}


void SetNewCrowdVolume(WORD crowdchannel, WORD desiredvolume,WORD tickstodesired)
{
LONG diff,delta;	// WORD overflow on multiplication

	/* error check & correct	*/
	desiredvolume = SetMinMax(desiredvolume,0,AI_MAX_CROWD_VOLUME);
/*	if(desiredvolume > AI_MAX_CROWD_VOLUME)
		desiredvolume = AI_MAX_CROWD_VOLUME;
	else if(desiredvolume < ZERO)
		desiredvolume = ZERO;	*/


	diff = CurCrowdVolume[crowdchannel] - desiredvolume;
	if(diff < 0)
		diff = -diff;


	/* error check & correct divide by zero & negatives	*/
	if(tickstodesired < 1)
		tickstodesired = 1;

	// multiply 1st then divide is more accurate
	delta = (diff * TICKS_PER_AI_FRAME) / tickstodesired ;

	if(diff != ZERO && delta == ZERO)
		delta = 1;	//resolution is now 1/256,  do we need this??

	CrowdVolumeDelta[crowdchannel] = (WORD)delta;

	DesiredCrowdVolume[crowdchannel] = desiredvolume;


}
/***
void SetNewCrowdVolumeDelta(WORD crowdchannel, WORD desiredvolume,UWORD delta)
{	// NOTE: delta always positive - will be subtracted if necessary
	// also NOTE: delta is a scale value to allow for fractions

	DesiredCrowdVolume[crowdchannel] = desiredvolume;
	CrowdVolumeDelta[crowdchannel] = delta;

}
***/
void TestAudioSound(void){AIPlayEffectCheck(YOU_SUCK_SFX);}


void StopCrowdVolumeRamping(WORD crowdchannel)	// at whatever it is
{
	DesiredCrowdVolume[crowdchannel] = CurCrowdVolume[crowdchannel];
}

//#define combovolume(channel) ((CurCrowdVolume[channel]+CurCrowdVolume[MINOR_##channel])>>CVOL_SHIFT)

void AISetCrowdLevel(void)
{
//UWORD temp =  combovolume(MID_CROWD_SFX);
EFFVAR i;

//	if(GameOptions[GAME_OPTNS_CROWD_VOL] != ZERO)	// default 0 is ON
//	{
// be sure to reduce scaled AI (fractional) volumes to actual H/W volumes
		for(i=0; i <NUM_MAJOR_CROWD_SFXS; i++)
		{ 	// figure major + minor scaled
			TrueCrowdVolume[i] =	SetMinMax(
				((CurCrowdVolume[i]+CurCrowdVolume[i+NUM_MAJOR_CROWD_SFXS])>>CVOL_SHIFT),
				0,MAX_VOLUME);
		}

		SetCrowdLevel(TrueCrowdVolume[0], 		// low
						TrueCrowdVolume[1],     // mid
						TrueCrowdVolume[2],     // high
						TrueCrowdVolume[3],     // extra loop
						LeftChannelPercent);
/*
		NUM_MAJOR_CROWD_SFXS
		SetCrowdLevel(combovolume(LOW_CROWD_SFX),
//					combovolume(MID_CROWD_SFX),
					temp,
					combovolume(HIGH_CROWD_SFX),
					combovolume(LOOP_SFX),
					LeftChannelPercent);

		CurCrowdVolume[LOW_CROWD_SFX]>>CVOL_SHIFT,
					CurCrowdVolume[MID_CROWD_SFX]>>CVOL_SHIFT,
					CurCrowdVolume[HIGH_CROWD_SFX]>>CVOL_SHIFT,
					CurCrowdVolume[LOOP_CROWD_SFX]>>CVOL_SHIFT,
					LeftChannelPercent);*/
//	}
};


//#define RandomMinorRampTime (2*SECONDS + (rand()&127))
#define RandomMinorRampTime (1*SECONDS + (rand()&511)) // bug #2972 (10/5/96)

void HandleMinorCrowdRamping(void)
{
EFFVAR i = MINOR_MID_CROWD_SFX;	// only on MID crowd for now

	if(CurCrowdVolume[i] > DesiredCrowdVolume[i])
	{	// here if ramping down
		CurCrowdVolume[i] -= CrowdVolumeDelta[i];
		if(CurCrowdVolume[i] <= DesiredCrowdVolume[i])
		{	//reached bottom - do new to reach top in 3-5 seconds
			CurCrowdVolume[i] = DesiredCrowdVolume[i];
			SetNewCrowdVolume(i,MINOR_CML_RANGE,RandomMinorRampTime);
//			SetNewCrowdVolume(i,MINOR_CML_RANGE,1*SECONDS);
//			CrowdVolumeDelta[i] = 25; // test only
//			CurCrowdVolume[i] = 1500;
		}
	}
	else
	{	// here if ramping up
		CurCrowdVolume[i] += CrowdVolumeDelta[i];
		if(CurCrowdVolume[i] >= DesiredCrowdVolume[i])
		{	//reached top - do new to reach bottom in 3-5 seconds
			CurCrowdVolume[i] = DesiredCrowdVolume[i];
			SetNewCrowdVolume(i,SCALED_VOL_PERCENT(0),RandomMinorRampTime);
//			SetNewCrowdVolume(i,SCALED_VOL_PERCENT(0),1*SECONDS);
//			CrowdVolumeDelta[i] = 25; // test only
//			CurCrowdVolume[i] = 50;

		}
	}
}




#include "fbbuttons.h"
/**********************************************************************

					 C O N T R O L L E R     S T U F F

**********************************************************************/

/********************************************************************

					 S W A P     C O N T R O L L E R S

	Called either by Human on Defense forcing toggle
	OR by STATES where potential human control could happen (e.g.
	QB handing off, QB Passing);

********************************************************************/

BOOL SwapControllers(WORD newplayer, WORD curplayer)
{
EFFVAR tempcontlr;
BOOL rv= FALSE;

/*  don't switch if current isn't controlled OR new is already controlled */
	tempcontlr = OPControllerNum(curplayer);

	if( (tempcontlr >= ZERO)	// check for legal controller numbers
		&& (tempcontlr < MAX_CONTROLLERS)
		&& (OPControllerNum(newplayer) == NO_CONTROLLER) )

	{	/* if current wasn't controlled then no need to do below	*/
		/* switch "player oriented" data	*/
		OPControllerNum(curplayer) = OPControllerNum(newplayer);

		OPControllerNum(newplayer) = tempcontlr;
		ResetBit(OPFlags(curplayer),IS_HCONTROLLED_BFLAG);
		OPStateInit(curplayer) = ZERO;	// re-init script (if necessary)

		/*  update physical controller data	*/
		ControlWhichPlayer[tempcontlr] = newplayer;
		rv = TRUE;
	}
	return(rv);
}




/*#ifdef SATURNMODE
#define JPADs		JPADRc
#define	JPADc		JPADcircle
#define	JPADt		JPADtriangle
#else*/
#define JPs		JPADsquare
#define	JPc		JPADcircle
#define	JPt		JPADtriangle
#define	JPx		JPADx


//#endif
								 //  0   1   2   3   4   5   6   7   8   9
UWORD ConfigBURST[MAX_JP_CONFIGS]= {JPs,JPc,JPx,JPx,JPt,JPt,JPx,JPc,JPx,JPs};
UWORD ConfigJUMP[MAX_JP_CONFIGS] = {JPt,JPt,JPt,JPt,JPx,JPc,JPs,JPx,JPc,JPc};
UWORD ConfigDIVE[MAX_JP_CONFIGS] = {JPc,JPs,JPs,JPc,JPc,JPs,JPt,JPs,JPs,JPx};
UWORD ConfigMISC[MAX_JP_CONFIGS] = {JPx,JPx,JPc,JPs,JPs,JPx,JPc,JPt,JPt,JPt};

// MISC button = Toggle/pitch/spin/turntocatch
void ConfigureJoyPads(void)	// called at InitAI()
{
EFFVAR t,configop;

	for(t=0; t<2; t++)
	{
		configop = SetMinMax(GameOptions[GAME_OPTNS_JPAD_CONFIG+t],0,MAX_JP_CONFIGS-1);

///		configop = 7; 	// test only

		BurstButtonMask[t] = ConfigBURST[configop];
		DiveButtonMask[t] = ConfigDIVE[configop];
		JumpButtonMask[t] = ConfigJUMP[configop];
		MiscButtonMask[t] = ConfigMISC[configop];

	}

}



/**************************************************************************


		J O Y P A D   /   C O N T R O L L E R    S T U F F

	Def guys are inited to where they were previously (last play) but any
	toggle after that sets to index 0 (use DefToggleArray)
	and then go from there

**************************************************************************/
//BOOL QBChangeToggledRec(WORD jpad_num);

#define	DEF_TOGGLE_BUTTON1	JPADRfront1
#define	DEF_TOGGLE_BUTTON2	JPADLfront1

#define NORMAL_TOGGLE		0
#define UNBLOCKED_TOGGLE	1

/* following array is the order defensive guys should toggle before snap -
	they are inited to where they were previously (last play) but any
	toggle after that sets to index 0 and then go from there
*/
WORD DefToggleArray[11] = {11,18,19,20,21,12,17,13,16,14,15};





void CheckForToggling(void)
{
EFFVAR controller, ctrlnum;
EFFVAR team;

  if( (PlayStateNum <= PS_PlayHappeningNUM)	//only allow when play [mainly] happening
   && (PlayStateNum >= PS_CheckAtLOSNUM) )
	for (team = 0; team < 2; team++)
	{
		for (controller = 0; controller < MAX_USERS_PER_TEAM; controller++)	// check all controllers
		{
			if( (ctrlnum = GameTeamData[team].ControllerNum[controller]) != -1)	// Is controller in use?
			{

				if ( !(PreviousJoyReading[ctrlnum] & MiscButtonMask[team])	// Was the triangle button not down
						&& (AIJoyPadData[ctrlnum] & MiscButtonMask[team])	// Is the triangle button down
					)
				{
					ChangeControlledPlayer(ctrlnum,1,NORMAL_TOGGLE);
				}
#if 1
				else if ( !(PreviousJoyReading[ctrlnum] & DEF_TOGGLE_BUTTON1)	// Was the R trigger 1 button not down
						&&(AIJoyPadData[ctrlnum] & DEF_TOGGLE_BUTTON1)	// Is the R trigger 1 button down
						)
				{
						ChangeControlledPlayer(ctrlnum,1,UNBLOCKED_TOGGLE);
				}
				else if ( !(PreviousJoyReading[ctrlnum] & DEF_TOGGLE_BUTTON2)	// Was the R trigger 2button not down
						 &&(AIJoyPadData[ctrlnum] & DEF_TOGGLE_BUTTON2)	// Is the button down?
						)
				{
					ChangeControlledPlayer(ctrlnum,-1,UNBLOCKED_TOGGLE);
				}
#endif

			}
		}
	}
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

void ChangeControlledPlayer(WORD jpad_num,WORD incval,WORD toggletype)
{
EFFVAR i,pnum,closest;


	if ( (pnum = ControlWhichPlayer[jpad_num]) > 10)	// On defense
	{		// On defense
		if (!BallSnapped)	// Before snap... switch to next defensive player
		{

			if( ! (PlayType == KICKOFF_PLAY && pnum == 11) )
			{	// everyone except kicker
				if( (i=DefToggleIndex[jpad_num]) < 0) // safer than "== -1"
					i =  -incval;	// will init i to ZERO in loop

				do {
					i += incval;
					if (i > 10)
						i = 0;
					else if (i<0)
						i = 10;
				} while(!SwapControllers(DefToggleArray[i], pnum));

				DefToggleIndex[jpad_num] = i;	// save if any more toggling


		  /* now set guy just toggled off of to face the offense	*/
				OPAction(pnum) = DefBeforeSnapAction;
			}
		}
		else	// After snap, Try closest guy to ball until we get one...
		{
			if(GameTeamData[DefensiveSlotNum].TeamFlags
				& TOGGLE_TO_CLOSEST_VALID_BFLAG)
			{
				if(pnum != BallCarrier)	// don't toggle away if BC
				{
					if(toggletype == UNBLOCKED_TOGGLE)
					{
						for(i=0; i<11; i++)
						{
							closest = DefenseToggleArray[i].slotnum;
//							closest = DefenseKeyDistance[i].slotnum;
							if( !(OPFlags(closest) & IM_BLOCKED_BFLAG))
								if(SwapControllers(closest, pnum))
									break;
						}
					}
					else
					{
						for(i=0; i<11; i++)
						{
//							if(SwapControllers(DefenseKeyDistance[i].slotnum, pnum))
							if(SwapControllers(DefenseToggleArray[i].slotnum, pnum))
								break;
						}
					}
				}
			}
#if PC_ERROR_MODE

			if(i>10)
				printf("\nERROR - guy%d to guy%d",DefenseKeyDistance[0].slotnum, pnum);
#endif
		}
	}
	else		/*  ------- Offensive Toggling  -------------------*/
	{
		if (!BallSnapped)			// Before snap...
		{
		 /*     bug #2466 - no off seq. toggle on KO 8//3/96
			bernie changed mind - back in 8/10/98	*/
			if(PlayType == KICKOFF_PLAY)
			{   // sequential toggle
				i = pnum;
				do {
					i += incval;
					if (i > 10)
						i = 0;
					else if (i<0)
						i = 10;
				} while(!SwapControllers(i, pnum));

			}
			else	// Human Receivers can toggle among receivers
			{
				if(pnum > ZERO		// do only if not the QB
					&& GameTeamData[OffensiveSlotNum].NumHumanControllers
							< MAX_USERS_PER_TEAM	// and not max users
				  )
				{
					i = pnum;

					do {	// rotate 1,2,3,4,5,1,2 or backwards
						i += incval;
						if (i > MAX_RECEIVER_SLOTS-1) //
							i = 1;
						else if (i<1)
							i = MAX_RECEIVER_SLOTS-1;
					} while(!SwapControllers(i, pnum));
				}


			}
		}
		else if(GameTeamData[OffensiveSlotNum].TeamFlags
								 & TOGGLE_TO_CLOSEST_VALID_BFLAG)
		{ 	// after Snap - def has ball, punt, or fumble
			if(pnum == BallCarrier    	// don't toggle away if BC
			   || pnum == TheReceiver)	// ... or TheReceiver
			{
			}
			else
			{
				for(i=0; i<11; i++)
				{
					if(SwapControllers(OffenseKeyDistance[i].slotnum, pnum))
						break;
				}
			}
		}
//			if(   (BallCarrier >10)	// defense got turnover
//			   || (BallFlags & (BALL_IS_FUMBLED_BFLAG | BALL_PUNTED_BFLAG))
//			  )
//			{	// bug - no BC if punted or fumbled
//				j = FindClosestOffPlayer(BallCarrier);
//				SwapControllers(j, pnum);

//			}
//		}
	}
}

/************************************************************************/

/******   no need for QB to toggle if 5 receivers

BOOL QBChangeToggledRec(WORD ctrlnum)
{
EFFVAR i,j;
BOOL rv = FALSE;

	if ( !(PreviousJoyReading[ctrlnum] & QB_REC_TOGGLE_BUTTON)	// Was the triangle button not down
			&& (AIJoyPadData[ctrlnum] & QB_REC_TOGGLE_BUTTON)	// Is the triangle button down
			&& (!BallSnapped)			// Before snap...
			&& (PlayType != KICKOFF_PLAY)
			&& (!(EventFlags.AUDIBLE_ACTIVE_BFLAG)) 	//no toggle if audible active
	   )
	{

		if (ControlWhichPlayer[ctrlnum] == ZERO)	// QB?
		{
			j = -1;   // see if we need to bring along human rec.
			for (i = 0; i < 8; i++)
			{
				if (ControlWhichPlayer[i] == PosReceivers[ToggledReceiver])
					j = i;
			}
			if (++ToggledReceiver > 4)
				ToggledReceiver = 2;

			if (j >= ZERO)	// != -1)
				SwapControllers(PosReceivers[ToggledReceiver], ControlWhichPlayer[j]);
			Receivers[2] = PosReceivers[ToggledReceiver];
			rv = TRUE;
		}
	}
	return(rv);
}
***/

/***********************  End of File - FBAudio.c  ********************/