/*******************************************************************


					FBBUTTON.H

	AUTHOR: M. Knauer                         Start Date: 3/8/95
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains all Button/Key equates for Football AI.

	It is an INCLUDED file.


	This file equate Buttons/keys based on the different
	hardware platforms.  The 3 platforms currently are:

		1) PC - for overhead graphic testing only
		2) PSX
		3) Saturn


*******************************************************************/

/******         Specific Football  JoyPad   Equates     *******************/



#ifdef __MSDOS__		/*---------------  PC (similar to PSX) ----------*/

#include        "psxpad.h"      /* Joypad equates       */

/*-------- QB buttons   ---------*/
#define REC1_BUTTON         JPADcircle		// slot 1 = RR
#define REC2_BUTTON         JPADsquare		// slot 2 = LR
#define REC3_BUTTON         JPADRfront1		// slot 3 = TE
#define	REC4_BUTTON			JPADLfront1		// slot 4 = FB
#define	REC5_BUTTON			JPADtriangle     // slot 5 = HB

#define	THROWAWAY_LEFT		JPADLfront2
#define	THROWAWAY_RIGHT		JPADRfront2


#define	HIKE_BUTTON			 JPADx
#define QB_REC_TOGGLE_BUTTON JPADtriangle
#define QB_PUMP_FAKE_BUTTON	 JPADx

/*---   following now variables depending on Controller config 10/12/96
#define	PITCH_BUTTON		JPADtriangle	//		JPADx
#define	DIVE_BUTTON			JPADcircle

#define REC_CATCH_BUTTON	JPADx	//JUMP_BUTTON
#define	JUMP_BUTTON			JPADtriangle
#define DEF_TOGGLE_BUTTON	JPADx

#define BURST_BUTTON	JPADsquare
#define SPIN_BUTTON		JPADx
--------------------------------*/


#define	JPADfrontL		(JPADLfront1 | JPADLfront2)
#define	JPADfrontR		(JPADRfront1 | JPADRfront2)
#define	JPADfrontT		(JPADLfront1 | JPADRfront1)
#define	JPADfrontB		(JPADLfront2 | JPADRfront2)

#define	DEBUG_BUTTONS1	JPADfrontL
#define	DEBUG_BUTTONS2	JPADfrontR

#define	JPADL_SHIFT	12		// dir pad buttons in 12,13,14,15


// kicks on PC going left to right (uses DPad)

#define	KICK_X_UP_BUTTON	JPADLright
#define	KICK_X_DOWN_BUTTON	JPADLleft
#define	KICK_Y_UP_BUTTON	JPADLdown
#define	KICK_Y_DOWN_BUTTON	JPADLup


#define	KICK_Z_UP_BUTTON	JPADRright
#define	KICK_Z_DOWN_BUTTON	JPADRleft
#define	KICK_BUTTON			JPADRdown		// same as hike


#define	ANY_DPAD		JPADL_MASK


#else 	//a console machine

#if __psx__		/* --------------- PLAYSTATION  ----------*/

#include        "psxpad.h"      /* Joypad equates       */


#define REC1_BUTTON         JPADcircle		// slot 1 = RR
#define REC2_BUTTON         JPADsquare		// slot 2 = LR
#define REC3_BUTTON         JPADRfront1		// slot 3 = TE
#define	REC4_BUTTON			JPADLfront1		// slot 4 = FB
#define	REC5_BUTTON			JPADtriangle     // slot 5 = HB

#define	THROWAWAY_LEFT		JPADLfront2
#define	THROWAWAY_RIGHT		JPADRfront2

#define	HIKE_BUTTON			JPADx
#define QB_REC_TOGGLE_BUTTON 	JPADtriangle
#define QB_PUMP_FAKE_BUTTON		JPADx


/*---   following now variables depending on Controller config 10/12/96

#define	DIVE_BUTTON			JPADcircle

//#define	JUMP_BUTTON			JPADx
//#define DEF_TOGGLE_BUTTON	JPADtriangle
//#define	PITCH_BUTTON		JPADtriangle

#define REC_CATCH_BUTTON	JPADx	//JUMP_BUTTON
#define	PITCH_BUTTON		JPADx
#define	JUMP_BUTTON			JPADtriangle
#define DEF_TOGGLE_BUTTON	JPADx


#define BURST_BUTTON	JPADsquare
#define SPIN_BUTTON		JPADx
------------------------------------------*/


#define	JPADfrontL		(JPADLfront1 | JPADLfront2)
#define	JPADfrontR		(JPADRfront1 | JPADRfront2)
#define	JPADfrontT		(JPADLfront1 | JPADRfront1)
#define	JPADfrontB		(JPADLfront2 | JPADRfront2)

#define	DEBUG_BUTTONS1	JPADfrontL
#define	DEBUG_BUTTONS2	JPADfrontR

#define	JPADL_SHIFT	12		// dir pad buttons in 12,13,14,15


// looking from behind on PSX
#define	KICK_X_UP_BUTTON		JPADLup
#define	KICK_X_DOWN_BUTTON	JPADLdown
#define	KICK_Y_UP_BUTTON		JPADLright
#define	KICK_Y_DOWN_BUTTON	JPADLleft

#define	KICK_Z_UP_BUTTON		JPADRright
#define	KICK_Z_DOWN_BUTTON	JPADRleft
#define	KICK_BUTTON				JPADRdown		// same as hike



#define	ANY_DPAD		JPADL_MASK



#else		/*  ----------------  must be Saturn  -----------------*/

#include	"satpad.h"


#define	REC1_BUTTON			JPADRx		// usually LR
#define	REC2_BUTTON			JPADRz		// usually RR
#define	REC3_BUTTON			JPADRy		// toggled guy
#define	REC4_BUTTON			JPADLfront
#define	REC5_BUTTON			JPADRfront
#define	THROWAWAY_LEFT		JPADLfront2
#define	THROWAWAY_RIGHT		JPADRfront2

#define QB_REC_TOGGLE_BUTTON JPADRy
#define QB_PUMP_FAKE_BUTTON	 JPADRb

#define	HIKE_BUTTON			JPADRb

/*---   following now variables depending on Controller config 10/12/96

#define	DIVE_BUTTON			JPADRc
#define REC_CATCH_BUTTON	JPADRb	//JUMP_BUTTON
#define	PITCH_BUTTON		JPADRb
#define	JUMP_BUTTON			JPADRy
//#define	JUMP_BUTTON			JPADRb	changed 8/23/96

#define	DEF_TOGGLE_BUTTON	JPADRb
//#define	DEF_TOGGLE_BUTTON	JPADRy  changed 8/23/96

#define BURST_BUTTON	JPADRa
#define SPIN_BUTTON		JPADRb
------------------------------------------*/

#define	JPADfrontL		(JPADLfront1 | JPADLfront2)
#define	JPADfrontR		(JPADRfront1 | JPADRfront2)
#define	JPADfrontT		(JPADLfront1 | JPADRfront1)
#define	JPADfrontB		(JPADLfront2 | JPADRfront2)

#define	DEBUG_BUTTONS1	JPADfrontL
#define	DEBUG_BUTTONS2	JPADfrontR

#define	JPADL_SHIFT	12		// dir pad buttons in 12,13,14,15


// normally looking from behind on Saturn
#define	KICK_X_UP_BUTTON		JPADLup
#define	KICK_X_DOWN_BUTTON	JPADLdown
#define	KICK_Y_UP_BUTTON		JPADLright
#define	KICK_Y_DOWN_BUTTON	JPADLleft

#define	KICK_Z_UP_BUTTON		JPADRright
#define	KICK_Z_DOWN_BUTTON	JPADRleft
#define	KICK_BUTTON				JPADRdown		// same as hike



#define	ANY_DPAD				JPADL_MASK

#endif		/*  ----------------  must be Saturn  -----------------*/

#endif		// else console

/*****     Global   Button  Equates  ***********************/

#define REC_BUTTON_MASK (REC1_BUTTON | REC2_BUTTON | REC3_BUTTON | REC4_BUTTON | REC5_BUTTON |THROWAWAY_LEFT|THROWAWAY_RIGHT)

#define	ANY_KICK_BUTTON (KICK_X_UP_BUTTON | KICK_X_DOWN_BUTTON | KICK_Y_UP_BUTTON  \
		 | KICK_Y_DOWN_BUTTON	| KICK_Z_UP_BUTTON | KICK_Z_DOWN_BUTTON )






/***********************  End of File:  FBButton.h  *******************/
