/*************************************************************************
 *
 * 			FBCPUPC.C - Contains all the CPU play calling functions.
 *
 *	Started on: 11-28-95
 *	Written by: Mike Heilemann
 *
 *************************************************************************/
	#include  "fbequ.h"
	#include  "fbRAM.h"			/* external VARs needed by this file	*/
	#include  "fbcpupc.h"
	#include  "fbforms.h"
	#include  "misc.h"
	#include  "sound1.h"

//	#include  "fbpdata.h"

#if __MSDOS__
	#include  "stdio.h"
	#include  "conio.h"
//void VerifyROMData(WORD teamslot);

#endif

extern struct play ThePlays[];
extern ULONG  QuarterTimes[4];		// based on a User Option


WORD NormalCPUPlayCallOffense(WORD thedown, WORD yardstogo, WORD team_type);
WORD NormalCPUPlayCallDefense(WORD thedown, WORD yardstogo, WORD team_type);
signed int ShiftTeamType(void);
int AutoCountDownSecond(signed int countdown);
WORD SecondsLeftInGame(void);

/**   include data table  (use 2nd parameter in form macro)  ******/

#define formmacro(positionformnum,PCformnum,string,OfforDef,offseq)	PCformnum,
#define	ALL_FORMS_VALID

BYTE PositionFormToPCFormTable[] = {

	#include	"fbfrmdat.h"
};
#undef	ALL_FORMS_VALID

#undef formmacro


#define MAX_TEAM_TYPES	4


//				  DOWN, DIST
char OffTableToUse[4][4] = {5, 2, 0, 1, 2, 0, 1, 1, 5, 4, 4, 3, 5, 4, 4, 3};
char DefTableToUse[4][4] = {1, 0, 0, 0, 0, 0, 0, 2, 1, 2, 2, 3, 1, 2, 2, 3};

short	team_type;


BOOL LastPlayOfQuarter(WORD secondsleft)
{	/* used ONLY by Offense CPU team for play calling in Q2 or Q4
		- updated 11/11/96 mjk		*/

	if(GameFlags & GAME_TIMER_ON_BFLAG)
	{	// clock running
		if(secondsleft <= 22)	// less than X seconds
			return(TRUE);
	}
	else	// clock stopped
	{
		if(secondsleft <= 15)  // less than X seconds (was 10)
			return(TRUE);

	}

	return(FALSE);
/*   old
	return(
			((GameFlags & GAME_TIMER_ON_BFLAG)	&& GameTime <= 22)
		|| ( (!(GameFlags & GAME_TIMER_ON_BFLAG)) && (GameTime <= 10))
		  );		***/
}

WORD last_play[3][3] = {
	SpecialTeamsFieldGoalNUM, 	//tied - close to goal
	ShotGunHailMaryNUM,			//tied -
	-1, 					    //tied - far from goal (special case)

	SpecialTeamsFieldGoalNUM,   // 1-3 behind
	ShotGunHailMaryNUM,
	ShotGunHailMaryNUM,

	-2,						// way behind  (special case)
	ShotGunHailMaryNUM,
	ShotGunHailMaryNUM
};


/******
WORD LastPlayOfGameTable[2][4][3] = {
// downs  1-3
	SpecialTeamsQBKneelNUM,		// ahead
	SpecialTeamsQBKneelNUM,
	SpecialTeamsQBKneelNUM,


	SpecialTeamsFieldGoalNUM, 	//tied - close to goal
	ShotGunHailMaryNUM,			//tied -
	SpecialTeamsQBKneelNUM;	    //tied - far from goal (special case)

	SpecialTeamsFieldGoalNUM,   // 1-3 behind
	ShotGunHailMaryNUM,
	ShotGunHailMaryNUM,

	-2,						// way behind  (special case)
	ShotGunHailMaryNUM,
	ShotGunHailMaryNUM,

// 4th down
	SpecialTeamsFieldGoalNUM,	// ahead & close to goal
	SpecialTeamsPuntNUM,
	SpecialTeamsPuntNUM,


	SpecialTeamsFieldGoalNUM, 	//tied - close to goal
	ShotGunHailMaryNUM,			//tied -
	SpecialTeamsPuntNUM,	    //tied - far from goal (special case)

	SpecialTeamsFieldGoalNUM,   // 1-3 behind
	ShotGunHailMaryNUM,
	ShotGunHailMaryNUM,

	-2,						// 4-16 pts behind  (special case)
	ShotGunHailMaryNUM,
	ShotGunHailMaryNUM
};

*****/


/*************************************************************************
 * CPU PLAY CALL OFFENSE - Calls an offensive play based upon down,
 *		distance to first down, time, and point spread, as well as some
 *		other special cases.
 *************************************************************************/
short CPUPlayCallOffense(void)
{
EFFVAR	i,newplay,
		yards_to_go,
		yard_line,
		table = 0,
//		offteam,
		score_difference,
//		minutes_left,
		chance;
long  gametime;

BOOL flipped = FALSE;

	yards_to_go = FirstDownX - StartBallX;
	yards_to_go = yards_to_go / YARD + (yards_to_go % YARD ? 1 : 0);	// Convert to yards, round up
	yard_line = (OFF_GOAL_LINE - StartBallX) / YARD;
	score_difference = GameTeamData[OffensiveSlotNum].TotalScore - GameTeamData[DefensiveSlotNum].TotalScore;
	team_type = -1;

	gametime = SecondsLeftInQuarter();

	// round down for 0 based table...
//	minutes_left = (WORD)(((30 * GameTeamData[OffensiveSlotNum].TimeOuts) + GameTime) / SECS_PER_MIN);

//	offteam = GameTeamData[OffensiveSlotNum].TeamNumber;

	// Be sure to turn off flipping for both teams
	GameTeamData[OffensiveSlotNum].PlayFlipped =
		GameTeamData[DefensiveSlotNum].PlayFlipped = 0;

	// DO SPECIAL CASES HERE.

	// is it a Kick Off
	if (PlayType == KICKOFF_PLAY)
	{
		chance = randper;
		switch(GetDuressLevel(DefensiveSlotNum,FALSE))
		{
			case 1: if (chance <= 25)
							return(KickoffReturnHandsNUM);
					  break;

			case 2: if (chance <= 40)
							return(KickoffReturnHandsNUM);
					  break;

			case 3:
			case 4: if (gametime < 60)
							return(KickoffReturnHandsNUM);

					  break;

			case 5: return(KickoffReturnHandsNUM);
		}

		if (chance <= 80)
			return(KickoffReturnRegularNUM);
		else
			return(KickoffReturnSpreadNUM);
	}

	// Extra point?
	if (PlayType == EX_PT1_PLAY)
	{
		// Figure out if we want/have to go for 2
		i = score_difference + 19;
		if (i < 0 || i > 38)					// Off Table, Always go for Field Goal
			return(SpecialTeamsFieldGoalNUM);		// Field Goal???

		chance = randper;
		if (chance <= ExtraPoint[i][TheQuarter-1])// Quarters are 1 based
		{
			return(SpecialTeamsFieldGoalNUM);		// Field Goal
		}
		else													//	Go for it
		{
			chance = randper;
			if (chance <= 90)
				return(NormalCPUPlayCallOffense(3, 10 * YARD, 2)); // 3rd & 10 Normal team type
			else
			if (chance <= 95)
				return(SpecialTeamsFakeFGRunNUM);	// FAKE FG Run
			else
				return(SpecialTeamsFakeFGPassNUM);	// FAKE FG Run
		}
	}

	// Last play of Half?
	if (TheQuarter == 2)
	{
		if (LastPlayOfQuarter(gametime))
		{
		// If clock is running & we have some, call a time out...
//			if ((GameFlags & GAME_TIMER_ON_BFLAG) && LegalForTimeOut(OffensiveSlotNum))
//				CallTimeOut(OffensiveSlotNum); // Call time out if last play & clock running if we have one...

			// Set up team type
// no-no 10/9/96	team_type = SpecificTeamData[offteam].Stats[0] % 5;

			team_type = GameTeamData[OffensiveSlotNum].STD.TeamType;

			i = ShiftTeamType();
			if (i == -4)			// if -4 do QB Kneel Down
				return(SpecialTeamsQBKneelNUM);

// Don't shift if Passing or Running Team and 1 shift would make them super
//			if ((i != -1 && team_type != 1) && (i != 1 && team_type != 3))
			if (!((i == -1 && team_type == 1) || (i == 1 && team_type == 3)))
				team_type += i;

			team_type = SetMinMax(team_type,0,MAX_TEAM_TYPES);

			if (yard_line < 3)
				return(NormalCPUPlayCallOffense(3, 2, team_type)); // 3rd & short
			if (yard_line < 36)
				return(SpecialTeamsFieldGoalNUM);  	// Field Goal
			if (yard_line < 56)
				return(ShotGunHailMaryNUM);			// Hail Mary
		}
	}
	// Last play of Game?
	if (TheQuarter == 4)
	{
		if (LastPlayOfQuarter(gametime))
		{
			if (score_difference > 0)		// Offense is winning.
			{
				if(TheDown == 4)
				{
					if (yard_line < 35)
						return(SpecialTeamsFieldGoalNUM);		// Field Goal
					else
						return(SpecialTeamsPuntNUM);	// Punt
				}
				else
				{
					return(SpecialTeamsQBKneelNUM);
				}
			}

			if (score_difference > -17)	// If they still care.
			{
				if (score_difference == 0)	// Tie Game
					i = 0;
				else
				if (score_difference > -4)	// Down by 1-3
					i = 1;
				else
					i = 2;

				if	(yard_line <= 35)	// Within 35 yards of goal
					chance = 0;
				else
				if	(yard_line <= 55)	// Within 55 yards of goal
					chance = 1;
				else
					chance = 2;

				newplay = last_play[i][chance];
				if(newplay == -1)	// special case if tie
				{
					if(TheDown == 4)
						newplay = SpecialTeamsPuntNUM;
					else
						newplay = SpecialTeamsQBKneelNUM;
				}
				else if (newplay < -1)
				{		// Force 3rd & long super pass
					newplay = NormalCPUPlayCallOffense(3, 12, 4);
				}
				return(newplay);
			}
		}
	}

	if (TheQuarter == 5 && yard_line < 23)
		return(SpecialTeamsFieldGoalNUM);	// Field Goal to end game


	// KICK OR GO FOR IT... If this falls through go on as normal.
	if (TheDown == 4)
	{
		// Point spread
		if (score_difference <= 0) // If Offense ahead don't bother.
		{
			// Check Time left only 4th Quarter matters
//			if (TheQuarter == 2 || TheQuarter == 4) // Might be under duress
			if (TheQuarter == 4) // Might be under duress
			{
				table = GetDuressLevel(OffensiveSlotNum,TRUE);
				if (table == 5)			// NEED TD - ALWAYS GO FOR IT
				{
					table = 2;
					yards_to_go = 1;	  	// hard code it to one that
					yard_line = 65;	  	// always has go for it
				}
			}
		}

		if (yard_line <= 35)		// Convert yard line to use as index
			yard_line = 3;			// Close to goal
		else
		if (yard_line <= 45)
			yard_line = 2;
		else
		if (yard_line <= 65)
			yard_line = 1;
		else
			yard_line = 0;			// Far from goal

		if (yards_to_go <= 1)	// Convert Yards to go to use as index
			yards_to_go = 3;		// Close to 1st
		else
		if (yards_to_go <= 3)
			yards_to_go = 2;
		else
		if (yards_to_go <= 9)
			yards_to_go = 1;
		else
			yards_to_go = 0;		// Far from 1st

		chance = randper;			// get random 1-100

		for (i = 0; chance > kick_percent[table][yard_line][yards_to_go][i]; i++)
			chance -= kick_percent[table][yard_line][yards_to_go][i];

		switch(i)	// We know what to do, so do it.
		{
			case 0:	return(SpecialTeamsPuntNUM);				// Punt

			case 1:	chance = randper;								// Fake Punt
					if (chance < 10 * (yards_to_go / YARD + (yards_to_go % YARD ? 1 : 0)))
						return(SpecialTeamsFakePuntPassNUM);// FAKE Punt Pass
					else
						return(SpecialTeamsFakePuntRunNUM);	// FAKE Punt Run

			case 2:	return(SpecialTeamsFieldGoalNUM);		// Field Goal

			case 3:	chance = randper;								// Fake Field Goal
					if (chance < 10 * (yards_to_go / YARD + (yards_to_go % YARD ? 1 : 0)))
						return(SpecialTeamsFakeFGPassNUM);	// FAKE FG Pass
					else
						return(SpecialTeamsFakeFGRunNUM);	// FAKE FG Run

			case 4:	// Go for it
						break;
		}
	}

	// Determine when to FLIP PLAY
	chance = randper;
	if (StartBallY > (MID_FIELDY + SOUTH_HASH_MARK) / 2 && chance <= 40)
	{
		flipped = TRUE;
	}
	else
	if (StartBallY > MID_FIELDY && chance <= 25)
	{
		flipped = TRUE;
	}
	else
	if (StartBallY > (NORTH_HASH_MARK + MID_FIELDY) / 2 && chance <= 10)
	{
		flipped = TRUE;
	}
	else
	if (StartBallY <= (NORTH_HASH_MARK + MID_FIELDY) / 2 && chance <= 5)
	{
		flipped = TRUE;
	}

	if(flipped)
	{
		GameTeamData[OffensiveSlotNum].PlayFlipped =
			GameTeamData[DefensiveSlotNum].PlayFlipped = 1;
	}

	yards_to_go = FirstDownX - StartBallX;						// Calculate yards to first down
	yard_line = (OFF_GOAL_LINE - StartBallX) / YARD;

	team_type = GameTeamData[OffensiveSlotNum].STD.TeamType;


	// TEAM TYPE STUFF...
	i = ShiftTeamType();
	if (i == -4)			// if -4 do QB Kneel Down
		return(SpecialTeamsQBKneelNUM);

// Don't shift if Passing or Running Team and 1 shift would make them super
	if (!((i == -1 && team_type == 1) || (i == 1 && team_type == 3)))
		team_type += i;

	team_type = SetMinMax(team_type,0,MAX_TEAM_TYPES);

//	printf("\nNORM:%d  TYPE:%d  SHIFT:%d\n\n", GameTeamData[OffensiveSlotNum].STD.TeamType, team_type, i);

	return(NormalCPUPlayCallOffense(TheDown, yards_to_go, team_type));
}




/*************************************************************************
 * CPU PLAY CALL DEFENSE - Calls an defensive play based upon down,
 *		distance to first down, time, and point spread, as well as some
 *		other special cases.
 *
 *		Need to implement play calling based upon previous plays called by
 *		offense.
 *************************************************************************/
short CPUPlayCallDefense(void)
{
EFFVAR	i,
			yards_to_go,
			yard_line,
			table = 0,
			play,
			score_difference,
			chance,
			count,
			oldcount;
WORD player[12] = {0,0,0,0,0,0,0,0,0,0,0,0};	// number of players 0-5 + run (0) | pass 1 * 6
long  GameTime;

	yards_to_go = FirstDownX - StartBallX;
	yards_to_go = yards_to_go / YARD + (yards_to_go % YARD ? 1 : 0);
	yard_line = (OFF_GOAL_LINE - StartBallX);
	yard_line /= YARD;
	score_difference = GameTeamData[OffensiveSlotNum].TotalScore - GameTeamData[DefensiveSlotNum].TotalScore;

/*
//	GameTime = GetVBlankTimer(GAME_TIMER_NUM);
//	GameTime += 30 * VBlanksPerSec * GameTeamData[OffensiveSlotNum].TimeOuts;
//	GameTime /= VBlanksPerSec;	// Put it in seconds
//	minutes_left = (WORD)(GameTime / 60);	// round down for 0 based table...
*/
	GameTime = SecondsLeftInQuarter();
	// figure extra time if they have timeouts
//	GameTime += (30 * GameTeamData[OffensiveSlotNum].TimeOuts);
//	minutes_left = (WORD)(GameTime / SECS_PER_MIN);	// round down for 0 based table...


	// KICKOFF
	if (PlayType == KICKOFF_PLAY)
	{
		if(GameFlags & FREE_KICK_BFLAG)	// no onside on Safety KO
		{
			KickOffType = NORMAL_KO_TYPE;
			return(KickoffRegularNUM);
		}

		chance = randper;

		count = GetDuressLevel(DefensiveSlotNum,FALSE);
		if(GameTeamData[0].TotalScore == GameTeamData[1].TotalScore)
			count = 0;	// no onside if tie score
					// (duress table meant for 4th down play calling-not KO
		switch(count)
		{
			case 0: if (chance <= 2 && TheQuarter > 1 && TheQuarter < 4)
					  {	// only "trick" onsides in Q2-Q3 mjk 11/11/96 - don't change this
						  KickOffType = ONSIDE_KO_TYPE;
						  return(KickoffRegularNUM);
					  }
					  break;	// mjk 11/11/96

			case 1: if (chance <= 25 && TheQuarter == 4)
					  {
						  KickOffType = ONSIDE_KO_TYPE;
						  return(KickoffStackRightNUM);
					  }

					  break;

			case 2: if (chance <= 40 && TheQuarter == 4)
						  KickOffType = ONSIDE_KO_TYPE;
					  else
						  KickOffType = NORMAL_KO_TYPE;

					  if (randper <= 50 && TheQuarter == 4)
						  return(KickoffStackRightNUM);

					  break;

			case 3:
			case 4: if (TheQuarter == 4)
					  {
						  if (GameTime < 60)
						  {
							  KickOffType = ONSIDE_KO_TYPE;
							  return(KickoffStackRightNUM);
						  }
						  else
						  {
							  if (chance <= 80)
								 return(KickoffStackRightNUM);
						  }
						}

					  break;

			case 5: KickOffType = ONSIDE_KO_TYPE;
					  return(KickoffStackRightNUM);

			default: break;
		}

		if (randper <= 80
			&& GameTime <= 30
			&& GetDuressLevel(DefensiveSlotNum,FALSE) == 0
			&& (TheQuarter == 2 || TheQuarter == 4))
				KickOffType = SQUIB_KO_TYPE;
		else
			KickOffType = NORMAL_KO_TYPE;

		return(KickoffRegularNUM);
	}

	// FIGURE OUT TABLE OFFENSE USED IF 4TH DOWN
	// Point spread
	if (score_difference <= 0) // If Offense ahead don't bother.
	{
		// Check Time left (Only in 2nd & 4th Quarters matter)
//		if (TheQuarter == 2 || TheQuarter == 4) // Might be under duress
		if (TheQuarter == 4) // Might be under duress
		{
			// Check time left in quarter
//			if (minutes_left < 8)		// We are in crunch time...
//			{
				table = GetDuressLevel(OffensiveSlotNum,TRUE);
				if (table == 5)			// NEED TD - ALWAYS GO FOR IT
				{
					table = 2;
					yards_to_go = 1;	  	// hard code it to one that
					yard_line = 65;	  	// always has go for it
				}
//			}
		}
	}

	if (yard_line <= 35)		// Convert yard line to use as index
		yard_line = 3;			// Close to goal
	else
	if (yard_line <= 45)
		yard_line = 2;
	else
	if (yard_line <= 65)
		yard_line = 1;
	else
		yard_line = 0;			// Far from goal

	if (yards_to_go <= 1)	// Convert Yards to go to use as index
		yards_to_go = 3;		// Close to 1st
	else
	if (yards_to_go <= 3)
		yards_to_go = 2;
	else
	if (yards_to_go <= 9)
		yards_to_go = 1;
	else
		yards_to_go = 0;		// Far from 1st

	// Take a look at what offense is really doing...
	play = GameTeamData[OffensiveSlotNum].PlayNum;

	// Lined up for a punt?
	if (play == SpecialTeamsPuntNUM || play == SpecialTeamsFakePuntRunNUM || play == SpecialTeamsFakePuntPassNUM)
	{
		chance = kick_percent[table][yard_line][yards_to_go][0] + kick_percent[table][yard_line][yards_to_go][1];
		if (chance == 0)							// Normally no one would ever kick here
			return(DefSpecialPuntReturnNUM);	// it's a kick

		if ((rand() % chance) <	kick_percent[table][yard_line][yards_to_go][0])
			return(DefSpecialPuntReturnNUM);	// it's a kick
		else
			return(DefSpecialPuntBlockNUM);
	}

	// Lined up for a Field Goal?
	if (play == SpecialTeamsFieldGoalNUM || play == SpecialTeamsFakeFGRunNUM || play == SpecialTeamsFakeFGPassNUM)
	{
		chance = kick_percent[table][yard_line][yards_to_go][2] + kick_percent[table][yard_line][yards_to_go][3];
		if (chance == 0)							// Normally no one would ever kick here
			return(DefSpecialWatchFakeNUM);

		if ((rand() % chance) <	kick_percent[table][yard_line][yards_to_go][2])
			return(DefSpecialFGBlockNUM);	// it's a kick
		else
			return(DefSpecialWatchFakeNUM);
	}


	yards_to_go = FirstDownX - StartBallX;						// Calculate yards to first down
	yard_line = (OFF_GOAL_LINE - StartBallX) / YARD;

	// Stop Offense from running same play over and over...
	if (yards_to_go >= 3)
	{
		// Count them in loop
		for (i = 0; i < MAX_OFF_PLAYDATA; i++)
			if (GameTeamData[OffensiveSlotNum].PrevOffPlayData[i] != -1)
				player[GameTeamData[OffensiveSlotNum].PrevOffPlayData[i]]++;

		// Find highest 2 in loop
		count = 0;
		oldcount = 0;
		for (i = 0; i < 12; i++)
		{
			if (player[i] >= player[count])
			{
				oldcount = count;
				count = i;
			}
		}

		// Look at percentage & call correct play, else look till end
		if (player[count] > 2)
			if (rand()%8+1 < player[count] * 2)	 // You have double the chance so 3 = 75%, 4+ = 100%
				return(specialdef[count]);		// Return play from table

		if (player[oldcount] > 2)
			if (rand()%8+1 < player[oldcount] * 2)
				return(specialdef[oldcount]);	// Return play from table
	}


// TEAM TYPE STUFF...
	i = ShiftTeamType();
	if (i == -4)			// if -4 doing QB Kneel Down
		return(DefGoalLineOutsideCrunchNUM);

	return(NormalCPUPlayCallDefense(TheDown, yards_to_go, i));
}


/*************************************************************************
 *
 * NORMAL CPU PLAY CALL OFFENSE
 *
 *	"Normal" CPU play calling uses team type (Running, passing, balanced,
 *	etc.), down and distance (to first down).
 *
 *	There are 6 specific tables to use which are indexed by "thedown"(4
 *  possible) and "yardstogo"( also 4 possible).  Each table has 128 entries
 *	which are the possible plays (playnums) to be chosen for that
 *	situation (playnums may be repeated in the table).  Depending on the
 *	team type, only 64 or 96 (see "spread" and "startindex" tables below)
 *  possible plays will be chosen from the 128.
 *	I.E. - the "mini-tables" overlap - Teamtype #0 will
 *	choose from play indexes 0-63, Teamtype #1 choses 0-95, etc.
 *
 *
 *	Once the [possible] play is selected using the table and the index,
 *	we must check to make sure that play is valid for that team, i.e.
 *	the team uses the formation of the play. If not, then the index
 *	is modified up or down depending on team type and the process is
 *	repeated.  NOTE: sooner or later this process will find a play
 *	in one of the "standard" formations which all teams use.
 *
 *	Also, the parameters passed don't always have to be TheDown or
 *	YardsTo1stDown. e.g. for a team behind late in game it might
 *	always be 3rd and 10.
 *
 *	We need to pass in TeamType also so we can have super pass & super run
 *	plays when ever we need them.
 *
 *************************************************************************/

WORD NormalCPUPlayCallOffense(WORD thedown, WORD yardstogo, WORD team_type)
{
int	playnum,
		index,
		i,
		tablenum,
		offteamnum,
		dist,
		formnum;


#if 1
WORD startindex[5]	 = {0, 0,16,32,64};	// based on team type
WORD spread[5]		 = {64,96,96,96,64};
#else
WORD startindex[5]	 = {0,16,32,48,64};	// based on team type
WORD spread[5]		 = {64,64,64,64,64};
#endif

	offteamnum = GameTeamData[OffensiveSlotNum].TeamNumber;

	thedown = SetMinMax(thedown,1,4);
/***
	if (thedown < 1)	 		// error check for valid down numbers
		thedown = 1;
	else if (thedown > 4)
		thedown = 4;  ****/

	/*  convert yards to actual table index  */
	if (yardstogo > 21 * HALFYARD)		// if > 10.5 yards
		dist = 3;
	else if (yardstogo > 13 * HALFYARD)	// if 10 - 6.5 yards
		dist = 2;
	else if (yardstogo > 5 * HALFYARD)	// if 6.5 - 2.5 yards
		dist = 1;
	else
		dist = 0;

// Get initial index
	index = startindex[team_type] + (rand() % spread[team_type]);

	tablenum = OffTableToUse[thedown - 1][dist]; // 16 possible tables map to 6

	do
	{
		playnum = CPUOffense[tablenum][index];	// CPU Offense Play Call Table

	  // make sure play we chose uses a valid formation of the current team
		for (i = 0; i < 5; i++)				// Look at all formations
		{
			/* convert positional formation to PlayCall formation */
			formnum = ThePlays[playnum].FormationNumber;
			formnum = PositionFormToPCFormTable[formnum];

			if (SpecificTeamData[offteamnum].Formations[0][i] == formnum )
			{
				return(playnum);
			}
		}

	// If invalid formation - choose another play
		if (team_type < 2)	// If a running team go down list, if Passing go up
			index--;				// Running Team
		else
			index++;				// Normal or Passing Team

	} while(1);
}


/*************************************************************************
 *
 * NORMAL CPU PLAY CALL DEFENSE
 *
 *	"Normal" CPU play calling uses team type (Running, passing, balanced,
 *	etc.), down and distance (to first down).
 *
 *	There are 6 specific tables to use.  Each table has 128 entries
 *	which are the possible plays (playnums) to be chosen for that
 *	situation (playnums may be repeated in the table).  Depending on the
 *	team type, only 64(?) possible plays will be chosen from the 128.
 *	I.E. - the "mini-tables(the 64)" overlap - Teamtype #0 will
 *	choose from play indexes 0-63, Teamtype #1 choses 16-79, etc.
 *
 *
 *	Once the [possible] play is selected using the table and the index,
 *	we must check to make sure that play is valid for that team, i.e.
 *	the team uses the formation of the play. If not, then the index
 *	is modified up or down depending on team type and the process is
 *	repeated.  NOTE: sooner or later this process will find a play
 *	in one of the "standard" formations which all teams use.
 *
 *	Also, the parameters passed don't always have to be TheDown or
 *	YardsTo1stDown. e.g. for a team behind late in game it might
 *	always be 3rd and 10.
 *
 *	We need to pass in TeamType also so we can have super pass & super run
 *	plays when ever we need them.
 *
 *************************************************************************/
WORD NormalCPUPlayCallDefense(WORD thedown, WORD yardstogo, WORD shift)
{
int	i,
		playnum,
		index,
		tablenum,
		dist,
		formnum,
		invalid_form = 1;


	thedown = SetMinMax(thedown,1,4);
/*	if (thedown < 1)					 		// error check for valid down numbers
		thedown = 1;
	else if (thedown > 4)
		thedown = 4; */

	if (yardstogo > 21 * HALFYARD)		// if > 10.5 yards
		dist = 3;
	else if (yardstogo > 13 * HALFYARD)	// if 10 - 6.5 yards
		dist = 2;
	else if (yardstogo > 5 * HALFYARD)	// if 6.5 - 2.5 yards
		dist = 1;
	else
		dist = 0;

	// Get index
	index = rand() % 64;		// Use a random number 0-63 for index

	if (shift > 1)		// If Offense shifted to Pass or Super Pass, use the 3rd Long Defense table
	{
		thedown = 3;
		dist = 3;
	}
	else
//	if (shift < -1)	// If Offense shifted to Run or Super Run, use the 3rd Short Defense table
	if (shift < -2)	// If Offense shifted or Super Run ONLY (11/12/96
						//, use the 3rd Short Defense table
	{
		thedown = 3;
		dist = 0;
	}

	tablenum = DefTableToUse[thedown - 1][dist]; // 16 possible tables map to 6

	while(invalid_form)
	{
		invalid_form = 0;
		playnum = CPUDefense[tablenum][index]+DEF_PLAY_OFFSET;	// CPU Defense Play Call Table
		formnum = ThePlays[playnum].FormationNumber;

		i = GameTeamData[DefensiveSlotNum].TeamNumber;
		if ((i == 5 || i == 10 || i == 18) && formnum == 15)	// 3-4
		{
			index--;
			invalid_form = 1;
		}
		else					// 4-3
		if ((i != 5 && i != 10 && i != 18) && formnum == 16)
		{
			index++;
			invalid_form = 1;
		}
//		printf("FORM:%d INVALID:%d\n", formnum, invalid_form);
	}

	return(playnum);	// All defensive formations are valid for every team.
}



/*************************************************************************
 * GET DURESS LEVEL - Returns the level of duress the team is under.
 *	Returns 0-5 based upon the point spread, and time left in game.
 *		0 - No duress
 *		1 - Some Duress
 *		2 - Duress, but NOT desperate
 *		3 - Duress, Need a score, FG or TD
 *		4 - Duress,	Need 2 scores a FG & TD
 *		5 - Duress, Desperatly need TD
 *************************************************************************/
WORD GetDuressLevel(WORD slot,WORD usetimeouts)
{
	WORD	score_difference,
			minutes_left;
	ULONG	game_time;

	score_difference = GameTeamData[slot^1].TotalScore - GameTeamData[slot].TotalScore;

//	game_time = GetVBlankTimer(GAME_TIMER_NUM) + (1800 * GameTeamData[slot].TimeOuts);
//	game_time /= VBlanksPerSec;	// Put it in seconds
//	game_time = SecondsLeftInQuarter();

	game_time =  SecondsLeftInGame();	// use entire game - 10/17/96

	// Add 15 seconds for each time out to game time...
	if(usetimeouts)
		game_time += (15 * GameTeamData[slot].TimeOuts);

	minutes_left = (WORD)(game_time / SECS_PER_MIN);	// round down for 0 based table

	if (score_difference > -1 && score_difference < 22 && minutes_left < 8)		// Offense is tied or losing
		return (duress[score_difference][minutes_left]);
	else
		return (0);								// Offense is winning
}


/*************************************************************************
 * SHIFT TEAM TYPE - Uses tables to shift the team type depending on point
 *		spread, time left in half/game, and field position.
 *
 *		NOTE: GameTime is Divided by 60 (convert it to minutes) so we can
 *				fit everything in a long, if not done it will wrap around and
 *				cause problems.
 *************************************************************************/
#if 0

WORD ScDifftable[] = {-23,-16,-8,-3,0,1,4,9,17,24,10000};
WORD GTLefttable[] = {
	 -100,
	 0,
	 1 * SECS_PER_MIN / 2,	// if > 30 Seconds
	 1 * SECS_PER_MIN,
	 3 * SECS_PER_MIN,
	 5 * SECS_PER_MIN,
	 7 * SECS_PER_MIN,
	10 * SECS_PER_MIN,
	15 * SECS_PER_MIN,
	20 * SECS_PER_MIN,	// Convert Game Time to Index

};

signed int ShiftTeamType(void)	// this is a little cleaner
{
EFFVAR	i,yard_line,GameTime,gtindex;
EFFVAR	score_difference,scorediffindex;

	// Field Position
	yard_line = (OFF_GOAL_LINE - StartBallX) / YARD;

	// Point Spread
	score_difference = GameTeamData[OffensiveSlotNum].TotalScore -
							GameTeamData[DefensiveSlotNum].TotalScore;

	// Time left in Half/Game
	GameTime = SecondsLeftInQuarter();

	// Subtract 25 seconds per down, add 25 for each defensive time out
	i = ((5 - TheDown) - GameTeamData[DefensiveSlotNum].TimeOuts) * 25;

	if (i > 0)				// If more time outs then downs, it cancels
		GameTime -= i;		// Subtract it from time left in this quarter


 // add in time for other Quarter
	if (TheQuarter == 1 || TheQuarter == 3)
		GameTime += QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]] / CLOCKS_TICKS_PER_SECOND;

	// GameTime is SECONDS
	for(gtindex=9; gtindex>=0;gtindex--)
	{
		if(GameTime > GTLefttable[gtindex])
			break;
	}

	for(scorediffindex=0; scorediffindex<11;scorediffindex++)
	{
		if(score_difference < ScDifftable[scorediffindex])
			break;
	}

	if (yard_line > 90)	// If 90+ yards to go, be conservative...
		yard_line = 0;
	else						// Go for it...
		yard_line = 1;

	if (TheQuarter > 2)	// use more duress table
		yard_line += 2;		// add 2 for 3rd & 4th quarter

	return(TeamShift[yard_line][scorediffindex][gtindex]);
}

#else
signed int ShiftTeamType(void)
{
	WORD	i,
			yard_line,
			score_difference;
	long	GameTime;

	// Field Position
	yard_line = (OFF_GOAL_LINE - StartBallX) / YARD;

	// Point Spread
	score_difference = GameTeamData[OffensiveSlotNum].TotalScore - GameTeamData[DefensiveSlotNum].TotalScore;

	// Time left in Half/Game
//	GameTime = GetVBlankTimer(GAME_TIMER_NUM); // Convert to minutes * VBlanksPerSec
	GameTime = SecondsLeftInQuarter();

	// Subtract 25 seconds per down, add 25 for each defensive time out
	i = ((5 - TheDown) - GameTeamData[DefensiveSlotNum].TimeOuts) * 25;

	if (i > 0)				// If more time outs then downs, it cancels
		GameTime -= i;		// Subtract it from time left in this quarter


 // add in time for other Quarter
	if (TheQuarter == 1 || TheQuarter == 3)
		GameTime += QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]] / CLOCKS_TICKS_PER_SECOND;

	// GameTime is SECONDS

	if (GameTime > 20 * SECS_PER_MIN)	// Convert Game Time to Index
		GameTime = 9;
	else
	if (GameTime > 15 * SECS_PER_MIN)
		GameTime = 8;
	else
	if (GameTime > 10 * SECS_PER_MIN)
		GameTime = 7;
	else
	if (GameTime > 7 * SECS_PER_MIN)
		GameTime = 6;
	else
	if (GameTime > 5 * SECS_PER_MIN)
		GameTime = 5;
	else
	if (GameTime > 3 * SECS_PER_MIN)
		GameTime = 4;
	else
	if (GameTime > 1 * SECS_PER_MIN)
		GameTime = 3;
	else
	if (GameTime > 1 * SECS_PER_MIN / 2)	// if > 30 Seconds
		GameTime = 2;
	else
	if (GameTime > 0)
		GameTime = 1;
	else
		GameTime = 0;

	if (score_difference < -23)	// Convert Point Spread to Index
		score_difference = 0;
	else
	if (score_difference < -16)
		score_difference = 1;
	else
	if (score_difference < -8)
		score_difference = 2;
	else
	if (score_difference < -3)
		score_difference = 3;
	else
	if (score_difference < 0)
		score_difference = 4;
	else
	if (score_difference == 0)
		score_difference = 5;
	else
	if (score_difference < 4)
		score_difference = 6;
	else
	if (score_difference < 9)
		score_difference = 7;
	else
	if (score_difference < 17)
		score_difference = 8;
	else
	if (score_difference < 24)
		score_difference = 9;
	else
		score_difference = 10;


	if (yard_line > 90)	// If 90+ yards to go, be conservative...
		yard_line = 0;
	else						// Go for it...
		yard_line = 1;

	if (TheQuarter > 2)	// use more duress table
		return(TeamShift[yard_line+2][score_difference][(WORD)GameTime]);	// add 2 for 3rd & 4th quarter
	else
		return(TeamShift[yard_line][score_difference][(WORD)GameTime]);
}
#endif

/*************************************************************************
 * CPU CALL TIMEOUT - Checks to see if it is valid for the CPU controlled
 *		team to call a timeout.  Then determines if they should call a time
 *		out based on point spread, and time remaining.  Many special cases
 *		exist which must be accounted for.
 *
 *		If 1st half, on offense, game time < 1 minute, & LOS < 60 yards call
 *		a time out as long as you save one for last play of half.
 *
 *		If 2nd Half
 *************************************************************************/
void CPUCallTimeout(WORD team)
{
WORD score_difference,disttogoal;
long GameTime;

WORD thedown = NextDown;	//This called BEFORE down is inc'ed

	if(!(Q_CPUTeamMacro(team)))
	{
		return;		// don't do if human
	}

	disttogoal = (OFF_GOAL_LINE - StartBallX)/YARD;	// distance to goal

	// positive if other team ahead
	score_difference = GameTeamData[team^1].TotalScore - GameTeamData[team].TotalScore;

	GameTime = SecondsLeftInQuarter();

	if (LegalAndProperForTimeOut(team))
	{
		if (TheQuarter == 2)
		{
			if (team == OffensiveSlotNum) // If team on offense...
			{
				if (GameTime < 60 &&  disttogoal < 60)
				{// save 1 for final 10 seconds of half (last play of half)
					if (GameTeamData[OffensiveSlotNum].TimeOuts > 1)
						CallTimeOut(team);
					else if (GameTime < 20)
						CallTimeOut(team);
				}
			}
			else if (score_difference < 20)
			{ 	// losing by < 20 and we are on defense
				if (GameTime < 120 && disttogoal > 65) // Check this stuff
					if (thedown > 2)				// On 3rd or 4th down
						CallTimeOut(team);
			}
		}
		else if (TheQuarter == 4)
		{

			if (score_difference > 0)
			{       // I'm  behind
				if( score_difference < 17	// still close enough???
					&& GameTime < 80)	//60)
				{
					CallTimeOut(team);
				}
				// if score = 0-3 & team don't have ball
				else if (  score_difference < 4
						&& team == DefensiveSlotNum
						&& GameTime < 135	//120
						&& disttogoal < 25  // other team is close
						&& thedown > 2
						)
				{
					CallTimeOut(team);
				}
			}

/***** this would NOT call TO is behind by 3 and other team close
			// if score = 0-3 & team don't have ball
			if (	score_difference > -1
				&& score_difference < 4
				&& team == DefensiveSlotNum)
			{
				if (GameTime < 120 && GameTime > 30)
				{
					if (disttogoal < 25 && thedown > 2)
					{
						CallTimeOut(team);
						return;
					}
				}
			}
			else if (  score_difference > 0
					&& score_difference < 17
					&& GameTime < 60)
			{
				CallTimeOut(team);
			}
*****************/
			else if (score_difference == 0)
			{
				if (team == OffensiveSlotNum
//					 && disttogoal < 70
					 && disttogoal <= 55	// 11/6/96 - jive with play calling
					 && GameTime < 60
					 && thedown < 4
//					 && GameTeamData[OffensiveSlotNum].TimeOuts > 1
					)
				{
					CallTimeOut(team);
				}
				else if (team == DefensiveSlotNum
					 && disttogoal > 65
					 && GameTime < 120
					 && thedown > 2)
				{
					CallTimeOut(team);
				}
			}
		}
	}
}



short TimeDownCounter = 0;
signed int countdown;
char countdown_in_progress = 0;
/*************************************************************************
 * TIME DOWN PLAYCALL - Speeds up time countdown so CPU looks smarter/
 *		more realistic.
 *************************************************************************/
int TimeDownPlaycall(void)
{
//	ULONG	time,
//			GameTime;
	signed int done = 1;


	if (!countdown_in_progress)
	{
		if (GameTeamData[OffensiveSlotNum].ControllerNum[0] == -1
			&& GameFlags & GAME_TIMER_ON_BFLAG)
		{	// CPU team with clock running
			switch(ShiftTeamType())
			{
				case -4:
				case -3: countdown = 8;
							break;
				case -2:
				case -1: countdown = 10;
							break;
				case  0: countdown = 14 + randnum(3);
							break;
				case  1: countdown = 20;
							break;
				case  2:
						countdown = 25;
							break;
				case  3: countdown = 29;	//hurry up!!
							break;
			}
		}
		else
		if (GameTeamData[OffensiveSlotNum].ControllerNum[0] == -1)
		{	// cpu team with clock stopped
			countdown = 12 + randnum(7);	// wide spread ok if clock stopped
		}
		else
		{	//human team
			countdown = 36;		//30;	no random here
//			countdown = 34 + GetRandom(3);		//30;
		}
		countdown_in_progress = 1;
	}

	done = AutoCountDownSecond(countdown);

	return(done);
}


/*************************************************************************
 * AUTO COUNT DOWN SECOND -
 *************************************************************************/
int AutoCountDownSecond(signed int countdown)
{
	ULONG	time,
			GameTime;
	signed int done = 1;


	TimeDownCounter ^= 1;
	if (TimeDownCounter)
		return(0);

	time = GetVBlankTimer(DPC_TIMER_NUM);
	GameTime = GetVBlankTimer(GAME_TIMER_NUM);

	// Make absolutly sure it doesn't go down to far...
	if (time > 40 * CLOCKS_TICKS_PER_SECOND || time < 7 * CLOCKS_TICKS_PER_SECOND)
	{
		countdown_in_progress = 0;
		return(done);
//		printf("TIME:%d\n", time / CLOCKS_TICKS_PER_SECOND);
//		getch();
	}

//	countdown -= time / CLOCKS_TICKS_PER_SECOND + 1;
	countdown -= (signed int)(time / CLOCKS_TICKS_PER_SECOND + 1);

	if (countdown < 0)
	{
		PlayEffect(CURSOR_SFX);
		SetVBlankTimer(DPC_TIMER_NUM, time - CLOCKS_TICKS_PER_SECOND);

		if ((GameFlags & GAME_TIMER_ON_BFLAG) && ((signed)GameTime - CLOCKS_TICKS_PER_SECOND > 0))
		{
			if ((signed)GameTime - CLOCKS_TICKS_PER_SECOND < 8 * CLOCKS_TICKS_PER_SECOND && (TheQuarter == 2 || TheQuarter > 3) && GameTeamData[OffensiveSlotNum].ControllerNum[0] == -1)
			{
				countdown_in_progress = 0;
				return(1);	// Not much time left in quarter...
			}
			else
			{
				SetVBlankTimer(GAME_TIMER_NUM, GameTime - CLOCKS_TICKS_PER_SECOND);
				TimeOfPoss[OffensiveSlotNum] += CLOCKS_TICKS_PER_SECOND;
				DriveTime += CLOCKS_TICKS_PER_SECOND;
			}
		}
		done = 0;
	}

	countdown_in_progress = done ^ 1;
	return(done);
}

/**************************  End of File: FBCPUPC.c   ********************/
