/***********************************************************************


   fbcpupc.h

	PROGRAMMER AUTHOR: Mike Heilemann       Start Date: 11/29/95
	PLAY DESIGNER/COACH: Bobby "The" King

	Modify Date: All the time


	Copyright 1995  GameTek, Inc.


	This file is an INCLUDE file detailing play selection tables.


***********************************************************************/
#include "fbplays.h"

WORD GetDuressLevel(WORD slot,WORD usetimeouts);
//WORD GetDuressLevel(WORD slot);
//BYTE GetDuressLevel(char slot);

//			BALL CARRIER	0							  1								2								3								4								 5
WORD specialdef[12] = {
	 DefNickelQBSpyNUM,     // Run - Qb
	 DefDimeDoubleWidesNUM,
	 DefDimeDoubleWidesNUM,
	 Def43OutsideInBlitzNUM,
	 Def43OutsideInBlitzNUM,
	 Def34StraightUpManNUM,		// new 11/12/96 - last day?!?
//	 DefNickelKeyOnHBNUM,

	 DefNickelQBSpyNUM, 	// Pass
	 DefNickelDoubleRightNUM,
	 DefNickelBumpAndRunNUM,
	 Def34ShadowZoneNUM,
	 DefNickelNickelManNUM,	// WR3 or FB
//	 DefGoalLineCheatLeftNUM, who put this here???
	 DefNickelKeyOnHBNUM  };


BYTE duress[23][8] = {{1, 1, 0, 0, 0, 0, 0, 0},		//	Tie
							 {3, 3, 3, 1, 0, 0, 0, 0},		//	Down by 1
							 {3, 3, 3, 1, 0, 0, 0, 0},		//	Down by 2
							 {3, 3, 3, 1, 0, 0, 0, 0},		//	Down by 3
							 {5, 5, 2, 2, 1, 1, 0, 0},		//	Down by 4
							 {5, 5, 2, 2, 1, 1, 0, 0},		//	Down by 5
							 {5, 5, 2, 2, 1, 1, 0, 0},		//	Down by 6
							 {5, 5, 2, 2, 1, 1, 0, 0},		//	Down by 7
							 {5, 5, 2, 2, 1, 1, 0, 0},		//	Down by 8
							 {4, 4, 4, 4, 1, 1, 1, 0},		//	Down by 9
							 {4, 4, 4, 4, 1, 1, 1, 0},		//	Down by 10
							 {4, 4, 4, 4, 2, 2, 1, 0},		//	Down by 11
							 {5, 5, 5, 2, 2, 2, 1, 1},		//	Down by 12
							 {5, 5, 5, 2, 2, 2, 1, 1},		//	Down by 13
							 {5, 5, 5, 2, 2, 2, 1, 1},		//	Down by 14
							 {5, 5, 5, 2, 2, 2, 1, 1},		//	Down by 15
							 {0, 0, 5, 2, 2, 2, 1, 1},		//	Down by 16
							 {0, 0, 5, 2, 2, 2, 1, 1},		//	Down by 17
							 {0, 0, 5, 2, 2, 2, 1, 1},		//	Down by 18
							 {0, 0, 5, 2, 2, 2, 1, 1},		//	Down by 19
							 {0, 0, 5, 2, 2, 2, 1, 1},		//	Down by 20
							 {0, 0, 5, 2, 2, 2, 1, 1}};	//	Down by 21



// punt %, fake_punt %, field_goal %, fake_field_goal %, go_for_it %
BYTE kick_percent[5][4][4][5] =     {{{{100,   0,   0,   0,   0},
													{100,   0,   0,   0,   0},
													{ 99,   1,   0,   0,   0},
													{ 99,   1,   0,   0,   0}},

												  {{ 99,   1,   0,   0,   0},
													{ 99,   1,   0,   0,   0},
													{ 99,   1,   0,   0,   0},
													{ 90,   5,   0,   0,   5}},

												  {{ 50,  10,  10,  10,  20},
													{  5,  10,   0,   0,  85},
													{  0,   5,   0,   0,  95},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0, 100,   0,   0},
													{  0,   0, 100,   0,   0},
													{  0,   0,  90,   5,   5},
													{  0,   0,  50,   0,  50}}},

// TABLE 1 - Slight Duress
												 {{{100,   0,   0,   0,   0},
													{100,   0,   0,   0,   0},
													{100,   0,   0,   0,   0},
													{ 80,   1,   0,   0,  20}},

												  {{ 95,   5,   0,   0,   0},
													{ 85,   5,   0,   0,  10},
													{ 55,   5,   0,   0,  40},
													{ 30,   5,   0,   0,  65}},

												  {{ 50,  10,  10,  10,  20},
													{  5,  10,   0,   0,  85},
													{  0,   5,   0,   0,  95},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0, 100,   0,   0},
													{  0,   0, 100,   0,   0},
													{  0,   0,  90,   5,   5},
													{  0,   0,  50,   5,  45}}},

// TABLE 2 - Duress but not Desperate
												 {{{ 90,  10,   0,   0,   0},
													{ 70,   5,   0,   0,  25},
													{ 20,   5,   0,   0,  75},
													{ 10,   0,   0,   0,  90}},

												  {{ 70,   5,   0,   0,  25},
													{ 60,   5,   0,   0,  35},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0,  50,  20,  30},
													{  0,   0,  10,  10,  80},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}}},

// TABLE 3 - Desperate
												 {{{  1,   0,   0,   0,  99},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0, 100,   0,   0},
													{  0,   0, 100,   0,   0},
													{  0,   0, 100,   0,   0},
													{  0,   0, 100,   0,   0}}},

// TABLE 4 - Need 2 Scores TD & FG
												 {{{  1,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100},
													{  0,   0,   0,   0, 100}},

												  {{  0,   0, 100,   0,   0},
													{  0,   0, 100,   0,   0},
													{  0,   0,  40,   0,  60},
													{  0,   0,   0,   0, 100}}}};


//						Quarter 1st	 2nd	3rd  4th
BYTE ExtraPoint[39][4] =  {{ 75,  50,  25,   5},	// Down by 19	 0
									{100, 100,  50,   5},	// Down by 18	 1
									{100, 100, 100, 100},	// Down by 17	 2
									{ 75,  50,  25,   5},	// Down by 16	 3
									{100, 100, 100, 100},	// Down by 15	 4
									{100, 100, 100, 100},	// Down by 14	 5
									{100, 100, 100, 100},	// Down by 13	 6
									{ 50,  25,  25,   5},	// Down by 12	 7
									{100, 100, 100, 100},	// Down by 11	 8
									{100, 100, 100, 100},	// Down by 10	 9
									{ 20,  10,   0,   0},	// Down by 9	10
									{100, 100, 100, 100},	// Down by 8	11
									{100, 100, 100, 100},	// Down by 7	12
									{100, 100, 100, 100},	// Down by 6	13
									{ 25,  25,  10,   0},	// Down by 5	14
									{100, 100, 100, 100},	// Down by 4	15
									{ 90,  90,  90,  90},	// Down by 3	16
									{ 25,   0,   0,   0},	// Down by 2	17
									{100, 100, 100, 100},	// Down by 1	18
									{100, 100, 100, 100},	// Tied			19
									{ 90,  75,  50,   0},	// Up by 1		20
									{100, 100, 100, 100},	// Up by 2		21
									{100, 100, 100, 100},	// Up by 3		22
									{100,  75,  25,  25},	// Up by 4		23
									{ 10,   5,   0,   0},	// Up by 5		24
									{100, 100, 100, 100},	// Up by 6		25
									{100, 100, 100, 100},	// Up by 7		26
									{ 50,  50,  25,  10},	// Up by 8		27
									{100, 100, 100, 100},	// Up by 9		28
									{100, 100, 100, 100},	// Up by 10		29
									{ 95,  95,  95,  95},	// Up by 11		30
									{ 20,  15,  10,   5},	// Up by 12		31
									{100, 100, 100, 100},	// Up by 13		32
									{100, 100, 100, 100},	// Up by 14		33
									{ 90,  80,  70,  60},	// Up by 15		34
									{100, 100, 100, 100},	// Up by 16		35
									{100, 100, 100, 100},	// Up by 17		36
									{100, 100, 100, 100},	// Up by 18		37
									{ 10,  10,   5,   5}};	// Up by 19		38


//					  Time			  0  30	 1	  3	5	 7	 10  15	20	 30	   Score
BYTE TeamShift[4][11][10] = {{{-3, -3, -2, -1, -1, -1, -1, -1, -1, -1},	// -24+
										{-3, -3, -2, -1, -1, -1, -1, -1, -1, -1},	// -17+
										{-3, -3, -2, -1, -1, -1, -1, -1, -1, -1},	// -9+
										{-3, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// -4+
										{-3, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// -1+
										{-3, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// 0
										{-3, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// +3-
										{-3, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// +8-
										{-3, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// +16-
										{-3, -2, -2, -2, -1, -1, -1, -1, -1, -1},	// +23-
										{-3, -2, -2, -2, -2, -2, -1, -1, -1, -1}},// +24+

// 1st Half, Zone 2
									  {{ 3,  2,  2,  2,  2,  2,  1,  1,  1,  1},	// -24+
										{ 2,  2,  2,  2,  2,  1,  1,  1,  1,  1},	// -17+
										{ 2,  2,  2,  1,  1,  1,  0,  0,  0,  0},	// -9+
										{ 1,  1,  1,  1,  1,  0,  0,  0,  0,  0},	// -4+
										{ 1,  1,  1,  1,  0,  0,  0,  0,  0,  0},	// -1+
										{ 1,  1,  1,  1,  0,  0,  0,  0,  0,  0},	// 0
										{ 1,  1,  1,  1,  0,  0,  0,  0,  0,  0},	// +3-
										{ 1,  1,  1,  1,  0,  0,  0,  0,  0,  0},	// +8-
										{ 1,  1,  1,  1,  0,  0,  0,  0,  0,  0},	// +16-
										{ 1,  1,  1,  1,  0,  0,  0,  0,  0,  0},	// +23-
										{-1, -1, -1, -1, -1, -1, -1, -1, -1, -1}},// +24+

// 2nd Half, Zone 1
									  {{ 3,  3,  3,  2,  2,  1,  1,  0, -1, -1},	// -24+
										{ 3,  3,  3,  2,  2,  1,  1,  0, -1, -1},	// -17+
										{ 3,  3,  3,  2,  2,  1,  1, -1, -1, -1},	// -9+
										{ 3,  3,  3,  2,  2,  1,  1, -1, -1, -1},	// -4+
										{ 3,  2,  2,  1,  1, -1, -1, -1, -1, -1},	// -1+
										{ 2,  1,  1,  0,  0, -1, -1, -1, -1, -1},	// 0
										{-4, -3, -2, -1, -1, -1, -1, -1, -1, -1},	// +3-
										{-4, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// +8-
										{-4, -3, -2, -2, -1, -1, -1, -1, -1, -1},	// +16-
										{-4, -2, -2, -2, -1, -1, -1, -1, -1, -1},	// +23-
										{-4, -2, -2, -2, -2, -2, -1, -1, -1, -1}},// +24+

// 2nd Half, Zone 2
									  {{ 0,  0,  0,  0,  2,  2,  1,  1,  1,  1},	// -24+
										{ 0,  0,  0,  2,  2,  2,  1,  1,  1,  1},	// -17+
										{ 3,  3,  3,  2,  2,  1,  0,  0,  0,  0},	// -9+
										{ 3,  3,  2,  2,  1,  0,  0,  0,  0,  0},	// -4+
										{ 2,  2,  1,  1,  0,  0,  0,  0,  0,  0},	// -1+
										{ 2,  2,  1,  1,  0,  0,  0,  0,  0,  0},	// 0
										{-4, -3, -2, -1,  0,  0,  0,  0,  0,  0},	// +3-
										{-4, -3, -2, -2, -1,  0,  0,  0,  0,  0},	// +8-
										{-4, -3, -2, -2, -1, -1,  0,  0,  0,  0},	// +16-
										{-4, -2, -2, -2, -1, -1, -1,  0,  0,  0},	// +23-
										{-4, -2, -2, -2, -2, -2, -1, -1, -1, -1}}};// +24+


//WORD CPUOffense[6][128] = {
UBYTE CPUOffense[6][128] = {	// 11/7/96 - I need the space
/***   WARNING - can use BYTES only on offensive non-kicking play	*/
/***** TABLE 1  (1st Down and Norm, 2nd Down and Med) ******/
{
	GoalLineHBPowerNUM,			//   DD  rrr 6
	ProSetFBPunchNUM,				//   CC  rrr 1 6
	PowerIFBOffTackleNUM,		//   AA  rrr 1 3 6
	NearFarHBOffTackleNUM,		//   AA  rrr 1 3 6
	SingleBackSweepNUM,			//   AA  rrr 1 2 3
	WestCoastMotionPitchNUM,	//   AA  rrr 1 2 3
	HBackCrackBackSweepNUM,		//   BB  rrr 1 2 3
	TripsCenterTrapNUM,			//   BB  rrr 1 2 3
	TripsCenterTrapNUM,			//   BB  rrr 1 2 3
	IFormCounterPullLeftNUM,	//   CC  rrr 1 3
	ProSetPowerBlastNUM,			//   CC  rrr 1 3 6
	HBackCrackBackSweepNUM,		//   BB  rrr 1 2 3
	TripsCenterTrapNUM,      	//   BB  rrr 1 2 3
	HBackCrackBackSweepNUM,    //   BB  rrr 1 2 3
	TripsCenterTrapNUM,      	//   BB  rrr 1 2 3
	ISlotHBRunMiddleNUM,       //  BB  rrr 1 2 3 6
	ISlotHBRunMiddleNUM,       //  BB  rrr 1 2 3 6
	WishBoneQuickPitchNUM,     //  AA  rrr 1 2
	PowerIFBOffTackleNUM,      //  AA  rrr 1 3 6
	NearFarHBOffTackleNUM,     //  AA  rrr 1 3 6
	SingleBackSweepNUM,			//  AA  rrr 1 2 3
	SingleBackSweepNUM,			//  AA  rrr 1 2 3
	WestCoastMotionPitchNUM,   //  AA  rrr 1 2 3
	IFormCounterPullLeftNUM,   //  CC  rrr 1 3
	NearFarFBSweepNUM,        	//  AA  rrr 1
	SingleBackPowerLeadNUM,    //  AA  rrr 1 2 3
	WestCoastOffTackleNUM,     //  AA  rrr 1 2 3
	ISlotHBRunMiddleNUM,       //  BB  rrr 1 2 3 6
	ISlotHBRunMiddleNUM,       //  BB  rrr 1 2 3 6
	RunAndShootCenterTrapNUM,  //  BB  rrr 1 2 3 6
//	ShotGunSwingPassNUM,
//	TripsHBFlatNUM,
//	NearFarQBWaggleNUM,
//	RunAndShootMotionFlatNUM,
//	NearFarFBScreenNUM,
//	HBackHBFlatNUM,

	HBackHBCenterTrapNUM,
	RunAndShootOffGuardNUM,
	TripsCenterTrapNUM,
	ISlotHBRunMiddleNUM,
	HBackHBCenterTrapNUM,
	WestCoastOffTackleNUM,
	HBackHBCenterTrapNUM,
	RunAndShootOffGuardNUM,
	TripsCenterTrapNUM,
	ISlotHBRunMiddleNUM,
	HBackHBCenterTrapNUM,
	HBackHBCenterTrapNUM,
	WestCoastOffTackleNUM,
	ProSetFBPunchNUM,
	ProSetQuickPitchWeakNUM,
//	ProSetPowerBlastNUM,
	ISlotHBRunMiddleNUM,
	IFormFBPunchNUM,
	IFormPowerBlastNUM,
	IFormQuickPitchWeakNUM,
	HBackHBCenterTrapNUM,
	SingleBackPowerLeadNUM,

//half

	HBackHBCenterTrapNUM,
	RunAndShootOffGuardNUM,
	TripsCenterTrapNUM,
	ISlotHBRunMiddleNUM,
	HBackHBCenterTrapNUM,
	WestCoastOffTackleNUM,
	ProSetFBPunchNUM,
//	ProSetQuickPitchWeakNUM,
	ProSetPowerBlastNUM,
	ISlotHBRunMiddleNUM,

	RunAndShootOffGuardNUM,
	RunAndShootHBFlatNUM,
	TripsOffGuardNUM,
	TripsClearFlatNUM,
	WestCoastHBFlareNUM,
	WestCoastSprintHandOffNUM,
	WestCoastSlantClearNUM,
	IFormBounceOutsideNUM,
	IFormPAChairNUM,
	HBackHBackFlatNUM,
	HBackPickPassNUM,
	WestCoastCBBurnerNUM,
	HBackHBackRunNUM,
	SingleBackHBTossNUM,
	SingleBackQBWaggleNUM,
	SingleBackCornerPostNUM,
	ISlotSlantCrossNUM,
	ISlotPickPassNUM,
	ISlotFBDiveNUM,
	NearFarFBCounterSlantNUM,
	NearFarCornerPostNUM,
	NearFarQBWaggleNUM,
	ProSetInsideSlantNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,

	ISlotPACrossesNUM,        //  BB  ppp 1 2
	HBackPACrossesNUM,        //  BB  ppp 1 2
	TripsPACrossNUM,          //   BB  ppp 1 2 3 5
	RunAndShootShortShootNUM,   //  BB  ppp 1 2 5 6
	SingleBackTECornerNUM,      //  AA  ppp 1 4
	WestCoastPassBackRightNUM,    //  AA  ppp 1 2 3 5
	HBackQuickOutsNUM,        //  BB  ppp 1 2 5
	TripsHBFlatNUM,         //  BB  ppp 1 2 4 5
	RunAndShootMediumShootNUM,    //  BB  ppp 1 2 4 5
	WestCoastShortPostNUM,      //  AA  ppp 1 2 3 5
	TripsPickPassNUM,         //  BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,      //  BB  ppp 1 2 3 4 5
	SingleBackPACrossNUM,     //  AA  ppp 1 3
	WestCoastPASlantNUM,        //  AA  ppp 1 2 3 5
//	IFormPARollOutNUM,        //  CC  ppp 1 2 6
	ProSetQuickSlantNUM,        //  CC  ppp 1 5
	ProSetQuickSlantNUM,        //  CC  ppp 1 5
//	ShotGunShortCrossNUM,     //  DD  ppp 1 2 4 5
//	ShotGunSwingPassNUM,        //  DD  ppp 1 2 4 5
	ShotGunShortCrossNUM,     //  DD  ppp 1 2 4 5
	ISlotPACrossesNUM,        //  BB  ppp 1 2
	HBackPACrossesNUM,        //  BB  ppp 1 2
	TripsPACrossNUM,          //   BB  ppp 1 2 3 5
	RunAndShootShortShootNUM,   //  BB  ppp 1 2 5 6
	SingleBackTECornerNUM,      //  AA  ppp 1 4
	WestCoastPassBackRightNUM,    //  AA  ppp 1 2 3 5
	HBackQuickOutsNUM,        //  BB  ppp 1 2 5
	TripsHBFlatNUM,         //  BB  ppp 1 2 4 5
	RunAndShootMediumShootNUM,    //  BB  ppp 1 2 4 5
	WestCoastShortPostNUM,      //  AA  ppp 1 2 3 5
	TripsPickPassNUM,         //  BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,      //  BB  ppp 1 2 3 4 5
	TripsPickPassNUM,         //  BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,      //  BB  ppp 1 2 3 4 5
	SingleBackPACrossNUM,     //  AA  ppp 1 3
	WestCoastPASlantNUM,        //  AA  ppp 1 2 3 5
	IFormPARollOutNUM,        //  CC  ppp 1 2 6
	ProSetQuickSlantNUM,        //  CC  ppp 1 5
	RunAndShootHBCurlNUM,     //  BB  ppp 1 2 3 4 5
	IFormQuickSlantNUM,   //      CC  ppp 1 5
	ProSetPARollOutNUM,       //  CC  ppp 1 2 6
	ShotGunSwingPassNUM,        //  DD  ppp 1 2 4 5
	ProSetPARollOutNUM,       //  CC  ppp 1 2 6
	ShotGunSwingPassNUM,        //  DD  ppp 1 2 4 5
	ShotGunShortCrossNUM,     //  DD  ppp 1 2 4 5
	ShotGunShortCrossNUM,     //  DD  ppp 1 2 4 5

},

{/***** TABLE 2  (1st Down and long, 2nd Down and long, and 2nd and Norm) ******/
	PowerIWrapAroundDrawNUM,      //    AA  rrr 2 5
	HBackHBCenterTrapNUM,       //    BB  rrr 2 3
	TripsReverseNUM,        //        BB  rrr 2
	HBackCrackBackSweepNUM,       //    BB  rrr 1 2 3
	RunAndShootReverseNUM,        //    BB  rrr 2 3
	HBackCrackBackSweepNUM,       //    BB  rrr 1 2 3
	RunAndShootReverseNUM,        //    BB  rrr 2 3
	ISlotCenterTrapNUM,       //      BB  rrr 2 3
	ISlotCenterTrapNUM,       //      BB  rrr 2 3
//	ShotGunDelayedDrawNUM,        //    DD  rrr 1 2 5
	IFormQuickPitchWeakNUM,       //    CC  rrr 2
	ProSetQuickPitchWeakNUM,      //    CC  rrr 2
	ShotGunRunGunWideNUM,       //    DD  rrr 2 3
	PowerIWrapAroundDrawNUM,      //    AA  rrr 2 5
	PowerIWrapAroundDrawNUM,      //    AA  rrr 2 5
	NearFarPowerHBRunNUM,       //    AA  rrr 2 3 6
	SingleBackPowerLeadNUM,       //    AA  rrr 1 2 3
	WestCoastMotionPitchNUM,      //    AA  rrr 1 2 3
	WishBonePowerHBDiveNUM,       //    AA  rrr 2 3 6
	PowerIFBQuickPitchNUM,        //    AA  rrr 1 2
	NearFarFBQuickPitchNUM,       //    AA  rrr 1 2
	SingleBackWrapAroundDrawNUM,      //  AA  rrr 2
	WishBoneQuickPitchNUM,        //    AA  rrr 1 2
	NearFarWrapAroundDrawNUM,     //    AA  rrr 2 5
	NearFarWrapAroundDrawNUM,     //    AA  rrr 2 5
	SingleBackSweepNUM,       //      AA  rrr 1 2 3




	HBackHBCenterTrapNUM,
	RunAndShootOffGuardNUM,
	TripsCenterTrapNUM,
	ISlotHBRunMiddleNUM,
	HBackHBCenterTrapNUM,
	WestCoastOffTackleNUM,
	HBackHBCenterTrapNUM,
	RunAndShootOffGuardNUM,
	TripsCenterTrapNUM,
	ISlotHBRunMiddleNUM,
	HBackHBCenterTrapNUM,
	HBackHBCenterTrapNUM,
	WestCoastOffTackleNUM,
	ProSetFBPunchNUM,
	ProSetQuickPitchWeakNUM,
//	ProSetPowerBlastNUM,
	ISlotHBRunMiddleNUM,
	IFormFBPunchNUM,
	IFormPowerBlastNUM,
	IFormQuickPitchWeakNUM,
	HBackHBCenterTrapNUM,
	SingleBackPowerLeadNUM,


	RunAndShootHBCurlNUM,       //    BB  ppp 1 2 3 4 5
	IFormPARollOutNUM,        //      CC  ppp 1 2 6
	ProSetHBScreenNUM,        //      CC  ppp 2 3
	WishBoneHBScreenNUM,        //      AA  ppp 2
	PowerIRollOutNUM,       //        AA  ppp 2 5 6
	NearFarFBScreenNUM,       //      AA  ppp 2
	SingleBackRollOutFloodNUM,      //    AA  ppp 2 3 5
	WestCoastPassBackRightNUM,      //    AA  ppp 1 2 3 5
	ShotGunSwingPassNUM,        //      DD  ppp 1 2 4 5
	WishBoneRollOutNUM,       //      AA  ppp 2 5 6
	PowerIHBScreenNUM,        //      AA  ppp 2
	NearFarRollOutScrambleNUM,      //    AA  ppp 2 5 6
	SingleBackScreenNUM,        //      AA  ppp 2 5
	WestCoastRollOutFloodNUM,     //    AA  ppp 2 5 6
	ShotGunWRScreenNUM,       //      DD  ppp 2 5
	IFormHBScreenNUM,       //        CC  ppp 2 3
	ProSetPARollOutNUM,       //      CC  ppp 1 2 6


// half
	ShotGunRunGunWideNUM,       //    DD  rrr 2 3
	ShotGunShortCrossNUM,       //    DD  ppp 1 2 4 5
	WishBoneRollOutNUM,       //      AA  ppp 2 5 6
	PowerIHBScreenNUM,        //      AA  ppp 2
	NearFarRollOutScrambleNUM,      //    AA  ppp 2 5 6
	SingleBackScreenNUM,        //      AA  ppp 2 5
		WestCoastRollOutFloodNUM,     //    AA  ppp 2 5 6
	ShotGunWRScreenNUM,       //      DD  ppp 2 5
	IFormHBScreenNUM,       //        CC  ppp 2 3
	ProSetPARollOutNUM,       //      CC  ppp 1 2 6
	ShotGunShortClearoutNUM,      //    DD  ppp 2 4 5
	TripsClearOutNUM,       //        BB  ppp 1 2 5
	ISlotTEScreenNUM,       //        BB  ppp 2
	HBackHBFlatNUM,         //      BB  ppp 2 3 5
	TripsFlankerCurlNUM,        //      BB  ppp 2 5
	RunAndShootShortShootNUM,     //    BB  ppp 1 2 5 6
	WestCoastNoBackPassNUM,       //    AA  ppp 2 3 4 5
	WestCoastShortPostNUM,        //    AA  ppp 1 2 3 5
	WestCoastShortPostNUM,        //    AA  ppp 1 2 3 5
	ISlotPACrossesNUM,        //      BB  ppp 1 2
	HBackPACrossesNUM,        //      BB  ppp 1 2
	TripsPACrossNUM,        //         BB  ppp 1 2 3 5
	RunAndShootMediumShootNUM,      //    BB  ppp 1 2 4 5
	SingleBackPABootLegNUM,       //    AA  ppp 2 3
	ShotGunDeepCrossNUM,        //      DD  ppp 2 4 5
	WestCoastPASlantNUM,        //      AA  ppp 1 2 3 5
	HBackTEScreenNUM,       //        BB  ppp 2
	TripsHBFlatNUM,         //      BB  ppp 1 2 4 5
	RunAndShootMotionFlatNUM,     //    BB  ppp 1 2 3 4 5
	HBackQuickOutsNUM,        //      BB  ppp 1 2 5
	TripsPickPassNUM,       //        BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,        //    BB  ppp 1 2 3 4 5
	TripsSlantCrossNUM,       //      BB  ppp 1 2 4 5
	RunAndShootHBCurlNUM,       //    BB  ppp 1 2 3 4 5
	IFormPARollOutNUM,        //      CC  ppp 1 2 6
	ProSetHBScreenNUM,        //      CC  ppp 2 3
	WishBoneHBScreenNUM,        //      AA  ppp 2
	PowerIRollOutNUM,       //        AA  ppp 2 5 6
	NearFarFBScreenNUM,       //      AA  ppp 2
	SingleBackRollOutFloodNUM,      //    AA  ppp 2 3 5
	WestCoastPassBackRightNUM,      //    AA  ppp 1 2 3 5
	ShotGunSwingPassNUM,        //      DD  ppp 1 2 4 5
	WishBoneRollOutNUM,       //      AA  ppp 2 5 6
	PowerIHBScreenNUM,        //      AA  ppp 2
	NearFarRollOutScrambleNUM,      //    AA  ppp 2 5 6
	SingleBackScreenNUM,        //      AA  ppp 2 5
	WestCoastRollOutFloodNUM,     //    AA  ppp 2 5 6
	ShotGunWRScreenNUM,       //      DD  ppp 2 5
	HBackHBFlatNUM,         //      BB  ppp 2 3 5
	TripsFlankerCurlNUM,        //      BB  ppp 2 5
	RunAndShootShortShootNUM,     //    BB  ppp 1 2 5 6
	RunAndShootShortShootNUM,     //    BB  ppp 1 2 5 6
	WestCoastNoBackPassNUM,       //    AA  ppp 2 3 4 5
	WestCoastShortPostNUM,        //    AA  ppp 1 2 3 5
	ISlotPACrossesNUM,        //      BB  ppp 1 2
	HBackPACrossesNUM,        //      BB  ppp 1 2
	TripsFlankerCurlNUM,        //      BB  ppp 2 5
	RunAndShootShortShootNUM,     //    BB  ppp 1 2 5 6
	RunAndShootShortShootNUM,     //    BB  ppp 1 2 5 6
	WestCoastNoBackPassNUM,       //    AA  ppp 2 3 4 5
	ProSetPARollOutNUM,       //      CC  ppp 1 2 6
	TripsClearOutNUM,       //        BB  ppp 1 2 5
	ISlotTEScreenNUM,       //        BB  ppp 2
	IFormHBScreenNUM,       //        CC  ppp 2 3
	ShotGunShortCrossNUM,       //    DD  ppp 1 2 4 5

},

{/***** TABLE 3  (1st Down and Med, 2nd Down and Short) ******/
	HBackQBDrawNUM,          // BB  rrr 3
	HBackQBDrawNUM,          // BB  rrr 3
	HBackQBDrawNUM,          // BB  rrr 3
	WishBoneFBOffTackleNUM,      // AA  rrr 1 3 6
	PowerIFBMisdirectionNUM,     // AA  rrr 1 3 6
	NearFarHBOffTackleNUM,       // AA  rrr 1 3 6
	SingleBackPowerLeadNUM,      // AA  rrr 1 2 3
	WestCoastMotionPitchNUM,     // AA  rrr 1 2 3
	WestCoastMotionPitchNUM,     // AA  rrr 1 2 3
	WestCoastMotionPitchNUM,     // AA  rrr 1 2 3
	ISlotHBRunMiddleNUM,         // BB  rrr 1 2 3 6
	RunAndShootCenterTrapNUM,    // BB  rrr 1 2 3 6
	IFormPowerBlastNUM,        // CC  rrr 1 3 6
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ShotGunRunGunWideNUM,      // DD  rrr 2 3
	NearFarPowerHBRunNUM,      // AA  rrr 2 3 6
	SingleBackCounterPitchNUM,     // AA  rrr 1 3
	WestCoastReverseNUM,         // AA  rrr 2 3
	ISlotFBPowerNUM,           // BB  rrr 3
	HBackHBCenterTrapNUM,      // BB  rrr 2 3
	HBackHBCenterTrapNUM,      // BB  rrr 2 3
	TripsCenterTrapNUM,        // BB  rrr 1 2 3
	IFormCounterPullLeftNUM,     // CC  rrr 1 3
	ProSetPowerBlastNUM,         // CC  rrr 1 3 6
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	GoalLineFBDiveNUM,         // DD  rrr 6 3
	WishBoneMisdirectionNUM,     // AA  rrr 1 3 6
	PowerIFBOffTackleNUM,      // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	SingleBackLeadPushNUM,       // AA  rrr 2 3 6
	SingleBackLeadPushNUM,       // AA  rrr 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3
	HBackReverseNUM,           // BB  rrr 2 3
//	ISlotQBDrawNUM,          // BB  rrr 3
	IFormStrongPitchNUM,         // CC  rrr 1 3
	IFormStrongPitchNUM,         // CC  rrr 1 3
	ProSetStrongPitchNUM,      // CC  rrr 1 3
	WishBonePowerHBDiveNUM,      // AA  rrr 2 3 6
	PowerIPowerHBDiveNUM,      // AA  rrr 2 3 6
	SingleBackSweepNUM,        // AA  rrr 1 2 3
	ISlotPAReverseNUM,         // BB  rrr 2 3
	HBackCrackBackSweepNUM,      // BB  rrr 1 2 3
	RunAndShootReverseNUM,       // BB  rrr 2 3
	ISlotCenterTrapNUM,        // BB  rrr 2 3
//	HBackQBDrawNUM,          // BB  rrr 3
	WishBoneFBOffTackleNUM,      // AA  rrr 1 3 6
	WishBoneFBOffTackleNUM,      // AA  rrr 1 3 6
	PowerIFBMisdirectionNUM,     // AA  rrr 1 3 6
	NearFarHBOffTackleNUM,       // AA  rrr 1 3 6
	SingleBackPowerLeadNUM,      // AA  rrr 1 2 3
	WestCoastMotionPitchNUM,     // AA  rrr 1 2 3
	WestCoastMotionPitchNUM,     // AA  rrr 1 2 3
	WestCoastMotionPitchNUM,     // AA  rrr 1 2 3
	ISlotHBRunMiddleNUM,         // BB  rrr 1 2 3 6
	RunAndShootCenterTrapNUM,    // BB  rrr 1 2 3 6
	IFormPowerBlastNUM,        // CC  rrr 1 3 6
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ProSetCounterPullLeftNUM,    // CC  rrr 1 3
	ShotGunRunGunWideNUM,      // DD  rrr 2 3
	NearFarPowerHBRunNUM,      // AA  rrr 2 3 6
	ISlotHBRunMiddleNUM,         // BB  rrr 1 2 3 6
	IFormFBPunchNUM,           // CC  rrr 1 6
	ProSetPowerBlastNUM,         // CC  rrr 1 3 6
	WishBoneStudentBodySweepNUM,   // AA  rrr 1 6
	SingleBackCounterPitchNUM,     // AA  rrr 1 3
	WishBonePASeemNUM,         // AA  ppp 1 3
	PowerITEBombNUM,           // AA  ppp 3 4


//half

	NearFarPASeemNUM,          // AA  ppp 1 3
	SingleBackPABootLegNUM,      // AA  ppp 2 3
	WestCoastPassBackRightNUM,     // AA  ppp 1 2 3 5
	IFormTEPostNUM,
	IFormPAChairNUM,
	ProSetInsideSlantNUM,
	ProSetInsideSlantNUM,
	HBackBombNUM,            // BB  ppp 3
	TripsPACrossNUM,           //  BB  ppp 1 2 3 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	ProSetLongBombNUM,         // CC  ppp 3 4
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	WishBoneTEBombNUM,         // AA  ppp 3 4
	PowerIPASeemNUM,           // AA  ppp 1 3
	NearFarTEBombNUM,          // AA  ppp 3 4
	SingleBackPACrossNUM,      // AA  ppp 1 3
	WestCoastPASlantNUM,         // AA  ppp 1 2 3 5
	ISlotBombNUM,            // BB  ppp 3 4
//	HBackFleaFlickerNUM,         // BB  ppp 3
//	ISlotFleaFlickerNUM,         // BB  ppp 3
//	TripsFleaFlickerNUM,         // BB  ppp 3
//	RunAndShootFleaFlickerNUM,     // BB  ppp 3 5
	IFormLongBombNUM,          // CC  ppp 3 4
	ProSetOutAndUpsNUM,        // CC  ppp 3 4
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 5
	WestCoastBombNUM,          // AA  ppp 3 4
	ISlotTEFlyNUM,             // BB  ppp 3 4
	HBackHBFlatNUM,          // BB  ppp 2 3 5
	HBackHBFlatNUM,          // BB  ppp 2 3 5
	HBackHBFlatNUM,          // BB  ppp 2 3 5
	RunAndShootBombNUM,        // BB  ppp 3 4
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastCBBurnerNUM,     // AA  ppp 3
	WestCoastShortPostNUM,       // AA  ppp 1 2 3 5
	IFormOutAndUpsNUM,         // CC  ppp 3 4
	ProSetPAHBFlyNUM,          // CC  ppp 3 4 5
	RunAndShootMotionFlatNUM,    // BB  ppp 1 2 3 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
	IFormHBScreenNUM,          // CC  ppp 2 3
	ProSetHBScreenNUM,         // CC  ppp 2 3
	WishBonePASeemNUM,         // AA  ppp 1 3
	PowerITEBombNUM,           // AA  ppp 3 4
	NearFarPASeemNUM,          // AA  ppp 1 3
	SingleBackPABootLegNUM,      // AA  ppp 2 3
	WestCoastPassBackRightNUM,     // AA  ppp 1 2 3 5
//	ISlotFleaFlickerNUM,         // BB  ppp 3
	HBackBombNUM,            // BB  ppp 3
	TripsPACrossNUM,           //  BB  ppp 1 2 3 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	ProSetLongBombNUM,         // CC  ppp 3 4
	ProSetLongBombNUM,         // CC  ppp 3 4
	ProSetLongBombNUM,         // CC  ppp 3 4
	ProSetLongBombNUM,         // CC  ppp 3 4
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	WishBoneTEBombNUM,         // AA  ppp 3 4
	PowerIPASeemNUM,           // AA  ppp 1 3
	NearFarTEBombNUM,          // AA  ppp 3 4
	SingleBackPACrossNUM,      // AA  ppp 1 3
	WestCoastPASlantNUM,         // AA  ppp 1 2 3 5
	ISlotBombNUM,            // BB  ppp 3 4
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	
},
{/***** TABLE 4  (3rd Down and Long) ******/
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	WishBoneWrapAroundDrawNUM,     // AA  rrr 2 5
	PowerIFBOffTackleNUM,      // AA  rrr 1 3 6
	NearFarWrapAroundDrawNUM,    // AA  rrr 2 5
	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4
	WestCoastReverseNUM,         // AA  rrr 2 3 4
	WestCoastReverseNUM,         // AA  rrr 2 3 4
	ISlotPAReverseNUM,         // BB  rrr 2 3
	TripsReverseNUM,           // BB  rrr 2 4
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	IFormQuickPitchWeakNUM,      // CC  rrr 2 4
	ProSetQuickPitchWeakNUM,     // CC  rrr 2 4
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	ProSetQuickPitchWeakNUM,     // CC  rrr 2 4
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	WishBoneWrapAroundDrawNUM,     // AA  rrr 2 5
	PowerIFBOffTackleNUM,      // AA  rrr 1 3 6
	WishBoneWrapAroundDrawNUM,     // AA  rrr 2 5
	PowerIFBOffTackleNUM,      // AA  rrr 1 3 6
	NearFarWrapAroundDrawNUM,    // AA  rrr 2 5
	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4
	WestCoastReverseNUM,         // AA  rrr 2 3 4
	WestCoastReverseNUM,         // AA  rrr 2 3 4
	ISlotPAReverseNUM,         // BB  rrr 2 3
	TripsReverseNUM,           // BB  rrr 2 4
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	IFormQuickPitchWeakNUM,      // CC  rrr 2 4
	ProSetQuickPitchWeakNUM,     // CC  rrr 2 4
	ProSetQuickPitchWeakNUM,     // CC  rrr 2 4
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	ShotGunHailMaryNUM,        // DD  ppp 4
	IFormOutAndUpsNUM,         // CC  ppp 3 4
	ProSetOutAndUpsNUM,        // CC  ppp 3 4
	ShotGunDeepCrossNUM,         // DD  ppp 2 4 5
	ISlotBombNUM,            // BB  ppp 3 4
	TripsPickPassNUM,          // BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5
	IFormLongBombNUM,          // CC  ppp 3 4
	ProSetPAHBFlyNUM,          // CC  ppp 3 4 5
	TripsOutAndUnderNUM,         // BB  ppp 4 5
	RunAndShootBombNUM,        // BB  ppp 3 4



	RunAndShootPostIsoNUM,
	TripsClearFlatNUM,
	TripsPostIsoNUM,
	WestCoastHBFlareNUM,
	WestCoastSlantClearNUM,
	IFormTEPostNUM,
	IFormPAChairNUM,
	HBackHBackFlatNUM,
	HBackPickPassNUM,
	SingleBackHBTossNUM,
	SingleBackQBWaggleNUM,
	SingleBackCornerPostNUM,
	ISlotSlantCrossNUM,
	ISlotPickPassNUM,
	NearFarCornerPostNUM,
	NearFarQBWaggleNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,

//half


	RunAndShootMotionFlatNUM,    // BB  ppp 1 2 3 4 5
	RunAndShootMotionFlatNUM,    // BB  ppp 1 2 3 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
	WishBoneTEBombNUM,         // AA  ppp 3 4
	PowerITEBombNUM,           // AA  ppp 3 4
	NearFarTEBombNUM,          // AA  ppp 3 4
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	ShotGunSwingPassNUM,         // DD  ppp 1 2 4 5
	ISlotTEFlyNUM,             // BB  ppp 3 4
	HBackPostCornerNUM,        // BB  ppp 4
	TripsHBFlatNUM,          // BB  ppp 1 2 4 5
	RunAndShootMediumShootNUM,     // BB  ppp 1 2 4 5
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	ProSetLongBombNUM,         // CC  ppp 3 4
	SingleBackTECornerNUM,       // AA  ppp 1 4
	WestCoastBombNUM,          // AA  ppp 3 4
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	ISlotCornerFadeNUM,        // BB  ppp 4 5 6
	TripsSlantCrossNUM,        // BB  ppp 1 2 4 5
	RunAndShootLongShootNUM,     // BB  ppp 4
	ShotGunHailMaryNUM,        // DD  ppp 4
	IFormOutAndUpsNUM,         // CC  ppp 3 4
	ProSetOutAndUpsNUM,        // CC  ppp 3 4
	ShotGunDeepCrossNUM,         // DD  ppp 2 4 5
	ISlotBombNUM,            // BB  ppp 3 4
	TripsPickPassNUM,          // BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5
	IFormLongBombNUM,          // CC  ppp 3 4
	HBackFleaFlickerNUM,         // BB  ppp 3
	ISlotFleaFlickerNUM,         // BB  ppp 3
	TripsFleaFlickerNUM,         // BB  ppp 3
	RunAndShootFleaFlickerNUM,     // BB  ppp 3 5
	ProSetPAHBFlyNUM,          // CC  ppp 3 4 5
//	TripsOutAndUnderNUM,         // BB  ppp 4 5
//	TripsOutAndUnderNUM,         // BB  ppp 4 5
	TripsOutAndUnderNUM,         // BB  ppp 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
//	WishBoneTEBombNUM,         // AA  ppp 3 4
//	PowerITEBombNUM,           // AA  ppp 3 4
	NearFarTEBombNUM,          // AA  ppp 3 4
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	ShotGunSwingPassNUM,         // DD  ppp 1 2 4 5
	ISlotTEFlyNUM,             // BB  ppp 3 4
	HBackPostCornerNUM,        // BB  ppp 4
	TripsHBFlatNUM,          // BB  ppp 1 2 4 5
	RunAndShootMediumShootNUM,     // BB  ppp 1 2 4 5
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	ProSetLongBombNUM,         // CC  ppp 3 4
	SingleBackTECornerNUM,       // AA  ppp 1 4
	WestCoastBombNUM,          // AA  ppp 3 4
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	ISlotCornerFadeNUM,        // BB  ppp 4 5 6
	TripsSlantCrossNUM,        // BB  ppp 1 2 4 5
	RunAndShootLongShootNUM,     // BB  ppp 4
	ShotGunHailMaryNUM,        // DD  ppp 4
	IFormOutAndUpsNUM,         // CC  ppp 3 4
	ProSetOutAndUpsNUM,        // CC  ppp 3 4
	ShotGunDeepCrossNUM,         // DD  ppp 2 4 5
	ISlotBombNUM,            // BB  ppp 3 4
	TripsPickPassNUM,          // BB  ppp 1 2 4 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5
	IFormLongBombNUM,          // CC  ppp 3 4
	ProSetPAHBFlyNUM,          // CC  ppp 3 4 5
	TripsOutAndUnderNUM,         // BB  ppp 4 5
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5

},
{/***** TABLE 5  (3rd Down and Norm, 3rd Down and Med) ******/
	GoalLineHBPowerNUM,        // DD  rrr 5 6
	GoalLineHBPowerNUM,        // DD  rrr 5 6
	GoalLineHBPowerNUM,        // DD  rrr 5 6
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
//	ShotGunDelayedDrawNUM,       // DD  rrr 1 2 5
	WishBoneWrapAroundDrawNUM,     // AA  rrr 2 4 5
	PowerIWrapAroundDrawNUM,     // AA  rrr 2 5
	NearFarWrapAroundDrawNUM,    // AA  rrr 2 4 5
	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4 5
	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4 5
	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4 5
	WestCoastReverseNUM,         // AA  rrr 2 3 4 5
	TripsQBDrawNUM,          // BB  rrr 5
	RunAndShootQBDrawNUM,      // BB  rrr 5
//	IFormQuickPitchWeakNUM,      // CC  rrr 2 4 5
//	ProSetStrongPitchNUM,      // CC  rrr 1 3 5
//	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
//	GoalLineHBPowerNUM,        // DD  rrr 5 6
//	WishBoneWrapAroundDrawNUM,     // AA  rrr 2 4 5
	SingleBackHBTossNUM,
	SingleBackQBWaggleNUM,
	SingleBackQBWaggleNUM,
	SingleBackCornerPostNUM,
	HBackHBackFlatNUM,
	HBackPickPassNUM,
	HBackHBackRunNUM,
//	PowerIWrapAroundDrawNUM,     // AA  rrr 2 5
//	NearFarWrapAroundDrawNUM,    // AA  rrr 2 4 5
//	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4 5
//	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4 5
//	SingleBackWrapAroundDrawNUM,   // AA  rrr 2 4 5
//	WestCoastReverseNUM,         // AA  rrr 2 3 4 5
//	TripsQBDrawNUM,          // BB  rrr 5
//	RunAndShootQBDrawNUM,      // BB  rrr 5
//	IFormQuickPitchWeakNUM,      // CC  rrr 2 4 5
//	ProSetStrongPitchNUM,      // CC  rrr 1 3 5
	IFormTEPostNUM,
	IFormPAChairNUM,
	TripsClearFlatNUM,
	TripsPostIsoNUM,
	ProSetInsideSlantNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,
	RunAndShootHBFlatNUM,
	RunAndShootPostIsoNUM,
	ShotGunShovelPassNUM,      // DD  rrr 2 3 4 5
	TripsSlantCrossNUM,        // BB  ppp 1 2 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
	TripsSlantCrossNUM,        // BB  ppp 1 2 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastShortPostNUM,       // AA  ppp 1 2 3 5
//	WishBoneRollOutNUM,        // AA  ppp 2 5 6
	PowerIRollOutNUM,          // AA  ppp 2 5 6
	NearFar10YardCurlNUM,      // AA  ppp 5
	SingleBackShortPostNUM,      // AA  ppp 1 5
		WestCoastRollOutFloodNUM,    // AA  ppp 2 5 6
	WestCoastCBBurnerNUM,
	ISlotCornerFadeNUM,        // BB  ppp 4 5 6
	HBackHBFlatNUM,          // BB  ppp 2 3 5
	TripsClearOutNUM,          // BB  ppp 1 2 5
	RunAndShootShortShootNUM,    // BB  ppp 1 2 5 6
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	ProSetQuickSlantNUM,         // CC  ppp 1 5
	ProSetQuickSlantNUM,         // CC  ppp 1 5
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5
	TripsPACrossNUM,           //  BB  ppp 1 2 3 5
	RunAndShootMotionFlatNUM,    // BB  ppp 1 2 3 4 5
//	GoalLineNakedBootlegNUM,     // DD  ppp 6 5
	WishBone10YardCurlNUM,       // AA  ppp 5
		PowerI10YardCurlNUM,         // AA  ppp 5
	NearFarRollOutScrambleNUM,     // AA  ppp 2 5 6
	SingleBack10YardCurlsNUM,    // AA  ppp 5
	WestCoast10YardCurlNUM,      // AA  ppp 1 5
	HBackQuickOutsNUM,         // BB  ppp 1 2 5
	TripsHBFlatNUM,          // BB  ppp 1 2 4 5
	RunAndShootMediumShootNUM,     // BB  ppp 1 2 4 5
		IFormQuickSlantNUM,        // CC  ppp 1 5
	ProSetPAHBFlyNUM,          // CC  ppp 3 4 5
	ShotGunDeepCrossNUM,         // DD  ppp 2 4 5
	ShotGunWRScreenNUM,        // DD  ppp 2 5

//half

	SingleBackScreenNUM,         // AA  ppp 2 5
	WestCoastPassBackRightNUM,     // AA  ppp 1 2 3 5
	TripsFlankerCurlNUM,         // BB  ppp 2 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 4 5
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 4 5
	WestCoastPASlantNUM,         // AA  ppp 1 2 3 5
	TripsOutAndUnderNUM,         // BB  ppp 4 5
	RunAndShootFleaFlickerNUM,     // BB  ppp 3 5
	ShotGunSwingPassNUM,         // DD  ppp 1 2 4 5
	GoalLinePAFadeNUM,         // DD  ppp 6 5
	TripsPickPassNUM,          // BB  ppp 1 2 4 5
	TripsSlantCrossNUM,        // BB  ppp 1 2 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
//	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastCBBurnerNUM,
	WestCoastShortPostNUM,       // AA  ppp 1 2 3 5
	WishBoneRollOutNUM,        // AA  ppp 2 5 6
	PowerIRollOutNUM,          // AA  ppp 2 5 6
	NearFar10YardCurlNUM,      // AA  ppp 5
	SingleBackShortPostNUM,      // AA  ppp 1 5
		WestCoastRollOutFloodNUM,    // AA  ppp 2 5 6
	ISlotCornerFadeNUM,        // BB  ppp 4 5 6
	HBackHBFlatNUM,          // BB  ppp 2 3 5
	TripsClearOutNUM,          // BB  ppp 1 2 5
	RunAndShootShortShootNUM,    // BB  ppp 1 2 5 6
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	IFormPAHBFlyNUM,           // CC  ppp 3 4 5
	ProSetQuickSlantNUM,         // CC  ppp 1 5
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5
	TripsPACrossNUM,           //  BB  ppp 1 2 3 5
	RunAndShootMotionFlatNUM,    // BB  ppp 1 2 3 4 5
//	GoalLineNakedBootlegNUM,     // DD  ppp 6 5
	WishBone10YardCurlNUM,       // AA  ppp 5
		PowerI10YardCurlNUM,         // AA  ppp 5
	NearFarRollOutScrambleNUM,     // AA  ppp 2 5 6
	SingleBack10YardCurlsNUM,    // AA  ppp 5
	WestCoast10YardCurlNUM,      // AA  ppp 1 5
	HBackQuickOutsNUM,         // BB  ppp 1 2 5
	TripsHBFlatNUM,          // BB  ppp 1 2 4 5
	RunAndShootMediumShootNUM,     // BB  ppp 1 2 4 5
		IFormQuickSlantNUM,        // CC  ppp 1 5
	ProSetPAHBFlyNUM,          // CC  ppp 3 4 5
	ShotGunDeepCrossNUM,         // DD  ppp 2 4 5
	ShotGunWRScreenNUM,        // DD  ppp 2 5
	SingleBackScreenNUM,         // AA  ppp 2 5
	WestCoastPassBackRightNUM,     // AA  ppp 1 2 3 5
	TripsFlankerCurlNUM,         // BB  ppp 2 5
	RunAndShootPACrossNUM,       // BB  ppp 1 2 3 4 5
	ShotGunShortCrossNUM,      // DD  ppp 1 2 3 4 5
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 4 5
	SingleBackRollOutFloodNUM,     // AA  ppp 2 3 4 5
	WestCoastPASlantNUM,         // AA  ppp 1 2 3 5
	TripsOutAndUnderNUM,         // BB  ppp 4 5
	RunAndShootFleaFlickerNUM,     // BB  ppp 3 5
	GoalLinePAFadeNUM,         // DD  ppp 6 5
	TripsPickPassNUM,          // BB  ppp 1 2 4 5
	TripsSlantCrossNUM,        // BB  ppp 1 2 4 5
	RunAndShootHBCurlNUM,      // BB  ppp 1 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastNoBackPassNUM,      // AA  ppp 2 3 4 5
	WestCoastShortPostNUM,       // AA  ppp 1 2 3 5
	ShotGunSwingPassNUM,         // DD  ppp 1 2 4 5


},
{/***** TABLE 6  (1st Down and Short, 3rd Down and Short) ******/
	GoalLineQBSneakNUM,        // DD  rrr 6
	WishBoneFBOffTackleNUM,      // AA  rrr 1 3 6
	PowerIFBMisdirectionNUM,     // AA  rrr 1 3 6
	NearFarHBOffTackleNUM,       // AA  rrr 1 3 6
	SingleBackLeadPushNUM,       // AA  rrr 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	GoalLineFBDiveNUM,         // DD  rrr 6 3
	RunAndShootCenterTrapNUM,    // BB  rrr 1 2 3 6
	IFormPowerBlastNUM,        // CC  rrr 1 3 6
	ProSetFBPunchNUM,          // CC  rrr 1 6
	GoalLineHBLeapNUM,         // DD  rrr 6
	WishBoneMisdirectionNUM,     // AA  rrr 1 3 6
	PowerIFBOffTackleNUM,      // AA  rrr 1 3 4 6
	NearFarPitchSweepNUM,      // AA  rrr 1 6
	GoalLineHBTrapNUM,         // DD  rrr 6
	GoalLineHBTrapNUM,         // DD  rrr 6
	ISlotHBRunMiddleNUM,         // BB  rrr 1 2 3 6
	IFormFBPunchNUM,           // CC  rrr 1 6
	ProSetPowerBlastNUM,         // CC  rrr 1 3 6
	WishBoneStudentBodySweepNUM,   // AA  rrr 1 6
	PowerIPitchSweepNUM,         // AA  rrr 1 6
	NearFarPowerHBRunNUM,      // AA  rrr 2 3 6
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	WishBonePowerHBDiveNUM,      // AA  rrr 2 3 6
	PowerIPowerHBDiveNUM,      // AA  rrr 2 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	GoalLineHBPowerNUM,        // DD  rrr 5 6
	GoalLineQBSneakNUM,        // DD  rrr 6
	GoalLineHBDiveNUM,
	GoalLineWishbonePANUM,
	GoalLineFullHouseSweepNUM,
	SingleBackLeadPushNUM,       // AA  rrr 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	GoalLineFBDiveNUM,         // DD  rrr 6 3
	RunAndShootCenterTrapNUM,    // BB  rrr 1 2 3 6
	IFormPowerBlastNUM,        // CC  rrr 1 3 6
	ProSetFBPunchNUM,          // CC  rrr 1 6
	GoalLineHBLeapNUM,         // DD  rrr 6
	GoalLineHBDiveNUM,
	GoalLineWishbonePANUM,
	GoalLineFullHouseSweepNUM,
	GoalLineHBTrapNUM,         // DD  rrr 6
	GoalLineHBTrapNUM,         // DD  rrr 6
	ISlotHBRunMiddleNUM,         // BB  rrr 1 2 3 6
	IFormFBPunchNUM,           // CC  rrr 1 6
	ProSetPowerBlastNUM,         // CC  rrr 1 3 6
	WishBoneStudentBodySweepNUM,   // AA  rrr 1 6
	PowerIPitchSweepNUM,         // AA  rrr 1 6
	NearFarPowerHBRunNUM,      // AA  rrr 2 3 6
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	WishBonePowerHBDiveNUM,      // AA  rrr 2 3 6
	PowerIPowerHBDiveNUM,      // AA  rrr 2 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	GoalLineHBPowerNUM,        // DD  rrr 5 6

//half

	GoalLineQBSneakNUM,        // DD  rrr 6
	WishBoneFBOffTackleNUM,      // AA  rrr 1 3 6
	PowerIFBMisdirectionNUM,     // AA  rrr 1 3 6
	NearFarHBOffTackleNUM,       // AA  rrr 1 3 6
	SingleBackLeadPushNUM,       // AA  rrr 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	WestCoastOffTackleNUM,       // AA  rrr 1 2 3 6
	GoalLineFBDiveNUM,         // DD  rrr 6 3
	RunAndShootCenterTrapNUM,    // BB  rrr 1 2 3 6
	IFormPowerBlastNUM,        // CC  rrr 1 3 6
	ProSetFBPunchNUM,          // CC  rrr 1 6
	GoalLineHBLeapNUM,         // DD  rrr 6
	WishBoneMisdirectionNUM,     // AA  rrr 1 3 6
	PowerIFBOffTackleNUM,      // AA  rrr 1 3 4 6
	NearFarPitchSweepNUM,      // AA  rrr 1 6
	GoalLineHBTrapNUM,         // DD  rrr 6
	GoalLineHBTrapNUM,         // DD  rrr 6
	ISlotHBRunMiddleNUM,         // BB  rrr 1 2 3 6
	IFormFBPunchNUM,           // CC  rrr 1 6
	ProSetPowerBlastNUM,         // CC  rrr 1 3 6
	WishBoneStudentBodySweepNUM,   // AA  rrr 1 6
	PowerIPitchSweepNUM,         // AA  rrr 1 6
	NearFarPowerHBRunNUM,      // AA  rrr 2 3 6
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	RunAndShootReverseNUM,       // BB  rrr 2 3 4
	WishBonePowerHBDiveNUM,      // AA  rrr 2 3 6
	PowerIPowerHBDiveNUM,      // AA  rrr 2 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	NearFarHBMisdirectionNUM,    // AA  rrr 1 3 6
	GoalLineNakedBootlegNUM,     // DD  ppp 6 5
	GoalLineGoalLineFloodNUM,    // DD  ppp 6
	GoalLinePAFadeNUM,         // DD  ppp 6 5
	GoalLinePAFadeNUM,         // DD  ppp 6 5
	GoalLinePAFadeNUM,         // DD  ppp 6 5
	WishBoneRollOutNUM,        // AA  ppp 2 5 6
	PowerIRollOutNUM,          // AA  ppp 2 5 6
	NearFarRollOutScrambleNUM,     // AA  ppp 2 5 6
	SingleBackPACrossNUM,      // AA  ppp 1 3 6
		WestCoastRollOutFloodNUM,    // AA  ppp 2 5 6
	ISlotCornerFadeNUM,        // BB  ppp 4 5 6
	HBackPACrossesNUM,         // BB  ppp 1 2
		RunAndShootShortShootNUM,    // BB  ppp 1 2 5 6
	IFormPARollOutNUM,         // CC  ppp 1 2 6
	ProSetPARollOutNUM,        // CC  ppp 1 2 6
	GoalLineNakedBootlegNUM,     // DD  ppp 6 5
	GoalLineGoalLineFloodNUM,    // DD  ppp 6
	WishBoneRollOutNUM,        // AA  ppp 2 5 6
	WishBoneRollOutNUM,        // AA  ppp 2 5 6
	WishBoneRollOutNUM,        // AA  ppp 2 5 6
	PowerIRollOutNUM,          // AA  ppp 2 5 6
	NearFarRollOutScrambleNUM,     // AA  ppp 2 5 6
	SingleBackPACrossNUM,      // AA  ppp 1 3 6
		WestCoastRollOutFloodNUM,    // AA  ppp 2 5 6
	ISlotCornerFadeNUM,        // BB  ppp 4 5 6
	HBackPACrossesNUM,         // BB  ppp 1 2
		RunAndShootShortShootNUM,    // BB  ppp 1 2 5 6
	IFormPARollOutNUM,         // CC  ppp 1 2 6
	ProSetPARollOutNUM,        // CC  ppp 1 2 6
	IFormPARollOutNUM,         // CC  ppp 1 2 6
	ProSetPARollOutNUM,        // CC  ppp 1 2 6
	ShotGunShortClearoutNUM,     // DD  ppp 2 4 5



}
};

#define DEF_PLAY_OFFSET 	FIRST_DEF_PLAY_NUM
//#define DEF_PLAY_OFFSET 	0

UBYTE CPUDefense[4][64] = {
/***** TABLE 1  (1st Down and Med,Norm,Long 2nd Down and Short,Med,Norm) ******/
{
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def43OutsideInBlitzNUM  - DEF_PLAY_OFFSET,
	Def34InsideBlitzNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def433DeepCornerNUM  - DEF_PLAY_OFFSET,
	Def34StuntBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def43StuntBlitzNUM  - DEF_PLAY_OFFSET,
	Def34DeepCloudNUM  - DEF_PLAY_OFFSET,
	Def43SSBlitzNUM  - DEF_PLAY_OFFSET,
	Def34FakeSafetyBlitzNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	DefNickelMiddleZoneNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def43FakeSSBlitzNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34SafetyBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def43ZoneLeftNUM  - DEF_PLAY_OFFSET,
	Def34CBBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	DefNickelMiddleZoneNUM  - DEF_PLAY_OFFSET,
	Def43WideZoneNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34CenterFieldZoneNUM  - DEF_PLAY_OFFSET,
	Def43CombatZoneNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34SuicideBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def43TwoDeepZoneNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34ShadowZoneNUM  - DEF_PLAY_OFFSET,
	Def43LeftBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34OutsideBlitzNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,

},

{/***** TABLE 2  (1st and 3rd Down and Long) ******/
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideCrunchNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatLeftNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatRightNUM  - DEF_PLAY_OFFSET,
	DefGoalLineSafetyGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineFakeGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineJamMiddleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideContainNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideCrunchNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatLeftNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatRightNUM  - DEF_PLAY_OFFSET,
	DefGoalLineSafetyGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineFakeGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineJamMiddleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideContainNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideCrunchNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatLeftNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatRightNUM  - DEF_PLAY_OFFSET,
	DefGoalLineSafetyGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineFakeGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineJamMiddleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideContainNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideCrunchNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatLeftNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineCheatRightNUM  - DEF_PLAY_OFFSET,
	DefGoalLineSafetyGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineFakeGambleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineJamMiddleNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineDeepNUM  - DEF_PLAY_OFFSET,
	DefGoalLineGoalLineManNUM  - DEF_PLAY_OFFSET,
	DefGoalLineOutsideContainNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	
},
{/***** TABLE 3  (2nd and Long, 3rd Down and Med and Norm) ******/
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelKeyOnHBNUM  - DEF_PLAY_OFFSET,
	DefNickelMiddleZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelDoubleRightNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	DefNickelCornerCushionNUM  - DEF_PLAY_OFFSET,
	DefNickelQBSpyNUM  - DEF_PLAY_OFFSET,
	DefNickelFakeNickelBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelBlitzNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def43ZoneLeftNUM  - DEF_PLAY_OFFSET,
	Def34CBBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def43WideZoneNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34CenterFieldZoneNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelKeyOnHBNUM  - DEF_PLAY_OFFSET,
	DefNickelMiddleZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelDoubleRightNUM  - DEF_PLAY_OFFSET,
	DefNickelBigDogEatNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	DefNickelCornerCushionNUM  - DEF_PLAY_OFFSET,
	DefNickelQBSpyNUM  - DEF_PLAY_OFFSET,
	DefNickelFakeNickelBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelKeyOnHBNUM  - DEF_PLAY_OFFSET,
	DefNickelMiddleZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelDoubleRightNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	DefNickelCornerCushionNUM  - DEF_PLAY_OFFSET,
	DefNickelQBSpyNUM  - DEF_PLAY_OFFSET,
	DefNickelFakeNickelBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelBlitzNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def43ZoneLeftNUM  - DEF_PLAY_OFFSET,
	Def34CBBlitzNUM  - DEF_PLAY_OFFSET,
	Def43ManToManNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	Def34StraightUpManNUM  - DEF_PLAY_OFFSET,
	Def43WideZoneNUM  - DEF_PLAY_OFFSET,
	Def433DeepSafetyNUM  - DEF_PLAY_OFFSET,
	Def34CenterFieldZoneNUM  - DEF_PLAY_OFFSET,
	Def34DeepSkyNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelKeyOnHBNUM  - DEF_PLAY_OFFSET,
	DefNickelMiddleZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelDoubleRightNUM  - DEF_PLAY_OFFSET,
	DefNickelBigDogEatNUM  - DEF_PLAY_OFFSET,
	DefNickelBumpAndRunNUM  - DEF_PLAY_OFFSET,
	DefNickelCornerCushionNUM  - DEF_PLAY_OFFSET,
	DefNickelQBSpyNUM  - DEF_PLAY_OFFSET,
	DefNickelFakeNickelBlitzNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelBlitzNUM  - DEF_PLAY_OFFSET,
	
},
{/***** TABLE 4  (3rd Down and Long) ******/
	DefNickelNickelPreventNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimePreventNUM  - DEF_PLAY_OFFSET,
	DefDimeDimeManNUM  - DEF_PLAY_OFFSET,
	DefDimeFourDeepNUM  - DEF_PLAY_OFFSET,
	DefDimePreventRightNUM  - DEF_PLAY_OFFSET,
	DefDimeInsideBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzManNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleCBBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimePreventLeftNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeFakeSafetyBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelPreventNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimePreventNUM  - DEF_PLAY_OFFSET,
	DefDimeDimeManNUM  - DEF_PLAY_OFFSET,
	DefDimeFourDeepNUM  - DEF_PLAY_OFFSET,
	DefDimePreventRightNUM  - DEF_PLAY_OFFSET,
	DefDimeInsideBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzManNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleCBBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimePreventLeftNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeFakeSafetyBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelPreventNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimePreventNUM  - DEF_PLAY_OFFSET,
	DefDimeDimeManNUM  - DEF_PLAY_OFFSET,
	DefDimeFourDeepNUM  - DEF_PLAY_OFFSET,
	DefDimePreventRightNUM  - DEF_PLAY_OFFSET,
	DefDimeInsideBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzManNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleCBBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimePreventLeftNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeFakeSafetyBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzZoneNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelPreventNUM  - DEF_PLAY_OFFSET,
	DefNickelNickelManNUM  - DEF_PLAY_OFFSET,
	DefNickelPreventBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimePreventNUM  - DEF_PLAY_OFFSET,
	DefDimeDimeManNUM  - DEF_PLAY_OFFSET,
	DefDimeFourDeepNUM  - DEF_PLAY_OFFSET,
	DefDimePreventRightNUM  - DEF_PLAY_OFFSET,
	DefDimeInsideBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzManNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleCBBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimePreventLeftNUM  - DEF_PLAY_OFFSET,
	DefDimeDoubleWidesNUM  - DEF_PLAY_OFFSET,
	DefDimeFakeSafetyBlitzNUM  - DEF_PLAY_OFFSET,
	DefDimeBlitzZoneNUM  - DEF_PLAY_OFFSET,
	}
};

/***********************  End of File - FBCPUPC.h  *****************/