/**************************************************************

					FB_FORMS.C

	ORIGINAL AUTHOR: M. Knauer			Start Date: 3/11/95
	Modify Date:
	This stuff provided by: B. King

	Copyright 1995  GameTek, Inc.



	This file contains data structures of the formations.

	Positions relative to StartBallX/Y where to line up.


	MAJOR MOD:  6/17/96

	Addiiton of New offensive plays now required varible # of plays
	per formation, so they are now referenced thru a Ptr table.
		see "WORD *GetPlaysPerForm(WORD formnum)"

**************************************************************/

	#include        "fbequ.h"
	#include        "fbforms.h"		// equates moved here 5/9/96
	#include        "fbplays.h"   



/*******************************************************************


		F O R M A T I O N     D A T A    S T R U C T U R E S


********************************************************************/


const WORD	OffHuddleFacing[11] = {
EAST_DIR,
NORTH_DIR,
SOUTH_DIR,
NE_DIR,
SE_DIR,
EAST_DIR,	//HB - directly behind QB
NORTH_DIR,
SOUTH_DIR,
NW_DIR,
SW_DIR,
WEST_DIR
};



struct formation OFF_HUDDLE_FORM =       /*Pre play huddle formation*/
{
	QB,     -12.5*YARDS, 0*YARDS,
	RR,     -13*YARDS, 2*YARDS,
	LR,     -13*YARDS, -2*YARD,
	RTE,    -14*YARDS, 5*QTR_YARD,
	FB,     -14*YARDS, -5*QTR_YARD,
	HB,     -14.5*YARDS, 0*YARD,

	RT,     -12*YARDS, 2*YARD,
	LT,     -12*YARDS, -2*YARD,
	RG,     -11*YARDS, 5*QTR_YARD,
	LG,     -11*YARDS, -5*QTR_YARD,
	CENTER, -10*YARDS, 0*YARD
};


#if 0
struct formation OFF_TIGHT_HUDDLE_FORM =       /*Pre play huddle formation*/
{
	QB,     -13.75*YARDS, 0*YARDS,
	RR,     -12.25*YARDS, 2.0*YARDS,
	LTE,    -12.25*YARDS, -2.0*YARD,
	RTE,    -13*YARDS, -1.5*YARD,
	FB,     -14*YARDS, -.75*YARDS,
	HB,     -14*YARDS, .75*YARDS,

	RT,     -13*YARDS, 1.5*YARD,
	LT,     -11.5*YARDS, -1.5*YARD,
	RG,     -11.5*YARDS, 1.5*YARD,
	LG,     -10.75*YARDS, -.75*YARD,
	CENTER, -10.75*YARDS, .75*YARD
};
#endif


struct formation GOAL_LINE_FORM =       /*Normal I formation (6 plays of Goal Line formation)*/
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, 8*YARDS,
	LTE,    NORMAL_TE_START_X, -3.75*YARD,
	RTE,    NORMAL_TE_START_X,  3.75*YARD,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	RT,     OFF_LINE_START_X, 2.5*YARD,
	LT,     OFF_LINE_START_X,-2.5*YARD,
	RG,     OFF_LINE_START_X, 1.25*YARD,
	LG,     OFF_LINE_START_X,-1.25*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};

struct formation GOAL_LINE_NO_WR_FORM =    /*I formation with no WR (3 plays of Goal Line formation)*/
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	TE3,    NORMAL_SLOT_START_X, 8*YARDS,
	LTE,    NORMAL_TE_START_X, -3.75*YARD,
	RTE,    NORMAL_TE_START_X,  3.75*YARD,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	RT,     OFF_LINE_START_X, 2.5*YARD,
	LT,     OFF_LINE_START_X,-2.5*YARD,
	RG,     OFF_LINE_START_X, 1.25*YARD,
	LG,     OFF_LINE_START_X,-1.25*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};



struct formation GOAL_LINE_T_FORM =	 /*T formation (3 plays of Goal Line formation)*/
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_TE_START_X, 8*YARD,
	LTE,    NORMAL_SLOT_START_X, -5.0*YARD,
	LT,     OFF_LINE_START_X,-3*YARD,		// tackle eligible
	FB,     NORMAL_FB_START_X, 0*YARDS,
	HB,     NORMAL_HB_START_X, 0*YARDS,

	RT,     OFF_LINE_START_X, 3*YARD,
	RTE,    NORMAL_TE_START_X, 4.5*YARDS,
//	LT,     OFF_LINE_START_X,-3*YARD,
	RG,     OFF_LINE_START_X, 1.5*YARD,
	LG,     OFF_LINE_START_X,-1.5*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};



struct formation WISH_BONE_FORM =       /*  3 RBS  */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RTE,    NORMAL_TE_START_X, 4.5*YARDS,
	LR,    NORMAL_TE_START_X, -8*YARD,
	RB3,    NORMAL_HB_START_X,  1.5*YARD,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, -1.5*YARDS,

	RT,     OFF_LINE_START_X, 3*YARD,
	LT,     OFF_LINE_START_X,-3*YARD,
	RG,     OFF_LINE_START_X, 1.5*YARD,
	LG,     OFF_LINE_START_X,-1.5*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};




struct formation POWER_I_FORM =       /*    3 RBS   */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RTE,    NORMAL_TE_START_X, 4.5*YARDS,
	LR,     NORMAL_TE_START_X, -8*YARD,
	RB3,    NORMAL_FB_START_X,  1.5*YARD,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	RT,     OFF_LINE_START_X, 3*YARD,
	LT,     OFF_LINE_START_X,-3*YARD,
	RG,     OFF_LINE_START_X, 1.5*YARD,
	LG,     OFF_LINE_START_X,-1.5*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};



struct formation POWER_I_WEAK_FORM =       /*    3 RBS   */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RTE,    NORMAL_TE_START_X, 4.5*YARDS,
	LR,     NORMAL_TE_START_X, -8*YARD,
	RB3,    NORMAL_FB_START_X, -1.5*YARD,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	RT,     OFF_LINE_START_X, 3*YARD,
	LT,     OFF_LINE_START_X,-3*YARD,
	RG,     OFF_LINE_START_X, 1.5*YARD,
	LG,     OFF_LINE_START_X,-1.5*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};



struct formation NEAR_FAR_FORM =                /* Near side Veer form */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	FB,     NORMAL_FB_START_X, 1.5*YARDS,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation FAR_FORM =                /*  Far Side of the Veer form */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	FB,     NORMAL_FB_START_X, -1.5*YARDS,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation I_SLOT_FORM =          /* All 12 Plays of ISlot formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_SLOT_START_Y,
	LR,     NORMAL_WR_START_X,-12*YARDS,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation SINGLE_BACK_FORM =             /* All 12 Plays of Singleback formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_SLOT_START_X, NORMAL_SLOT_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	LTE,    NORMAL_TE_START_X, -NORMAL_TE_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation H_BACK_FORM =                 /* All 12 Plays of H_BACK formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	RB3,    NORMAL_SLOT_START_X, -4*YARDS,							// H-BACK
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};




struct formation I_FORM_FORM =                 /* All 12 Plays of I Form formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	FB,     NORMAL_FB_START_X, NORMAL_FB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};



struct formation PROSET_FORM =                 /* All 12 Plays of ProSet formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	FB,     NORMAL_RRB_START_X, NORMAL_RRB_START_Y,
	HB,     NORMAL_LRB_START_X, NORMAL_LRB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation WEST_COAST_FORM =              /* All 12 Plays of WestCoast formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_SLOT_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	WR3, NORMAL_SLOT_START_X, -NORMAL_SLOT_START_Y,
	HB,     NORMAL_LRB_START_X, NORMAL_LRB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation SHOTGUN_FORM =                 /* 6 Plays of Shotgun formation (No TE) */
{
	QB,     -6*YARD, 0*YARDS,
	RR,     NORMAL_WR_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	WR3, NORMAL_SLOT_START_X, -NORMAL_SLOT_START_Y,
	WR4, NORMAL_SLOT_START_X,  NORMAL_SLOT_START_Y,
	HB,     NORMAL_RRB_START_X-1, NORMAL_RRB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation SHOTGUN_TE_FORM =               /* 6 Plays of Shotgun formation (With TE) */
{
	QB,     -6*YARD, 0*YARDS,
	RR,     NORMAL_WR_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	RTE,    NORMAL_TE_START_X, NORMAL_TE_START_Y,
	WR3, NORMAL_SLOT_START_X,  NORMAL_SLOT_START_Y,
	HB,     NORMAL_RRB_START_X-1, NORMAL_RRB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};


struct formation TRIPS_FORM =            /* All 12 Plays of the TRIPS Formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_WR_START_X, NORMAL_WR_START_Y+3*YARDS,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	WR3, NORMAL_SLOT_START_X, -NORMAL_SLOT_START_Y+3*YARDS,
	WR4, NORMAL_SLOT_START_X, -NORMAL_SLOT_START_Y-1*YARDS,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};


struct formation RUN_SHOOT_FORM =            /* All 12 Plays of Run and Shoot Formation */
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RR,     NORMAL_WR_START_X, NORMAL_WR_START_Y,
	LR,     NORMAL_WR_START_X,-NORMAL_WR_START_Y,
	WR3, NORMAL_SLOT_START_X, -NORMAL_SLOT_START_Y,
	WR4, NORMAL_SLOT_START_X,  NORMAL_SLOT_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,

	NORMAL_OFF_LINE_FORMATION
};

struct formation QB_KNEEL_FORM =       /*Special Formation withing special teams)*/
{
	QB,     NORMAL_QB_START_X, 0*YARDS,
	RTE,    NORMAL_TE_START_X, 4.5*YARDS,
	LTE,    NORMAL_TE_START_X, -4.5*YARDS,
	TE3,    NORMAL_RRB_START_X, NORMAL_RRB_START_Y,
	FB,     NORMAL_LRB_START_X, NORMAL_LRB_START_Y,
	HB,     NORMAL_HB_START_X, NORMAL_HB_START_Y,
	RT,     OFF_LINE_START_X, 3*YARD,
	LT,     OFF_LINE_START_X,-3*YARD,
	RG,     OFF_LINE_START_X, 1.5*YARD,
	LG,     OFF_LINE_START_X,-1.5*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};

struct formation PUNT_FORM = {

	PUNTER, -24*HALF_YARD, 0*HALF_YARD,	//
	DB6,            OFF_LINE_START_X, NORMAL_WR_START_Y,
	DB7,            OFF_LINE_START_X,-NORMAL_WR_START_Y,
	IRLB,            -2*YARDS, 12*HALF_YARD,
	FB,             -12*HALF_YARD,  2*HALF_YARD,
	LTE,            -2*YARDS,-12*HALF_YARD,

	NORMAL_OFF_LINE_FORMATION
};

struct formation FIELD_GOAL_FORM = {

	QB2,	-14*HALF_YARD,  1*QTR_YARD,
	FB,		OFF_LINE_START_X-4*QTRYARD, 20*QTRYARD,
	LTE,	OFF_LINE_START_X-4*QTRYARD,-20*QTRYARD,
	RTE,    OFF_LINE_START_X-2*QTRYARD,	15*QTRYARD,
//	KICKER, -20*HALF_YARD, -4.75*HALF_YARD,
//	KICKER, -20*HALF_YARD, -5.25*HALF_YARD,
	KICKER, -18*HALF_YARD, -5.25*HALF_YARD,		//bug #1964 7/23/96
	TE3,	OFF_LINE_START_X-2*QTRYARD,	-15*QTRYARD,
	RT,     OFF_LINE_START_X-0*QTRYARD, 10*QTRYARD,
	LT,     OFF_LINE_START_X-0*QTRYARD,	-10*QTRYARD,
	RG,     OFF_LINE_START_X+1*QTRYARD,	5*QTRYARD,
	LG,     OFF_LINE_START_X+1*QTRYARD,	-5*QTRYARD,
	CENTER,-1*HALF_YARD, 0*HALF_YARD
};


/**************** DEFENSE ******************/



const WORD	DefHuddleFacing[11] = {
EAST_DIR,
SSW_DIR,
WEST_DIR,
WEST_DIR,
WEST_DIR,
WEST_DIR,
NNW_DIR,
SW_DIR,
NW_DIR,
WEST_DIR,
WEST_DIR
};


#define DHUDOFF	HALF_YARD
struct formation DEF_HUDDLE_FORM =       /*Pre play huddle formation*/
{
	MLB,      .25*YARDS+DHUDOFF, 0*YARDS,	// was huddling in neutral zone
	LC,       1.75*YARDS+DHUDOFF, -4*YARDS,	// .. if human control right away
	DLE,      1.25*YARDS+DHUDOFF, -1.75*YARD,	// .. MLB was offside
	DLT,      1.25*YARDS+DHUDOFF, -.5*YARD,
	DRT,      1.25*YARDS+DHUDOFF, .5*YARDS,
	DRE,      1.25*YARDS+DHUDOFF, 1.75*YARDS,
	RC,       1.75*YARDS+DHUDOFF, 4*YARD,
	OLLB,     2*YARDS+DHUDOFF, -2.5*YARD,
	ORLB,     2*YARDS+DHUDOFF, 2.5*YARD,
	FS,       2.5*YARDS+DHUDOFF, -1*YARD,
	SS,       2.5*YARDS+DHUDOFF, 1*YARD
};


struct formation DEF_4_3_FORM =       /* defensive 4-3 formation */
{
//	ILLB,      NORMAL_MLB_START_X, NORMAL_MLB_START_Y,
//  zone inits want IRLB first !!!!!
	MLB,      NORMAL_MLB_START_X, NORMAL_MLB_START_Y,
	LC,        (3*YARDS), NORMAL_LCB_START_Y,
	DLE,       NORMAL_43LE_START_X, NORMAL_43LE_START_Y,
	DLT,       NORMAL_43LT_START_X, NORMAL_43LT_START_Y,
	DRT,       NORMAL_43RT_START_X, NORMAL_43RT_START_Y,
	DRE,       NORMAL_43RE_START_X, NORMAL_43RE_START_Y,
	RC,        (3*YARDS), NORMAL_RCB_START_Y,
	OLLB,      NORMAL_LOLB_START_X+1.25*YARDS, NORMAL_LOLB_START_Y,
	ORLB,      NORMAL_ROLB_START_X+1.75*YARDS, NORMAL_ROLB_START_Y,
	FS,        NORMAL_FS_START_X, NORMAL_FS_START_Y,
	SS,        NORMAL_SS_START_X, NORMAL_SS_START_Y
};


struct formation DEF_3_4_FORM =       /* defensive 3-4 formation */
{
	IRLB,      NORMAL_RILB_START_X, NORMAL_RILB_START_Y,
	LC,        (3*YARDS), NORMAL_LCB_START_Y,
	DLE,       NORMAL_34LE_START_X, NORMAL_34LE_START_Y,
	ILLB,      NORMAL_LILB_START_X, NORMAL_LILB_START_Y,
	DRT,       NORMAL_34NG_START_X, NORMAL_34NG_START_Y,
	DRE,       NORMAL_34RE_START_X, NORMAL_34RE_START_Y,
	RC,        (3*YARDS), NORMAL_RCB_START_Y,
	OLLB,      NORMAL_LOLB_START_X+1.25*YARDS, NORMAL_LOLB_START_Y,
	ORLB,      NORMAL_ROLB_START_X+1.75*YARDS, NORMAL_ROLB_START_Y,
	FS,        NORMAL_FS_START_X, NORMAL_FS_START_Y,
	SS,        NORMAL_SS_START_X, NORMAL_SS_START_Y
};


struct formation DEF_NICKEL_FORM =       /* defensive nickel formation */
{
	NB,        NORMAL_NB_START_X, NORMAL_NB_START_Y,
	LC,        (6*YARDS), NORMAL_LCB_START_Y,
	DLE,       NORMAL_43LE_START_X, NORMAL_43LE_START_Y,
	DLT,       NORMAL_43LT_START_X, NORMAL_43LT_START_Y,
	DRT,       NORMAL_43RT_START_X, NORMAL_43RT_START_Y,
	DRE,       NORMAL_43RE_START_X, NORMAL_43RE_START_Y,
	RC,        (6*YARDS), NORMAL_RCB_START_Y,
//	OLLB,      NORMAL_LOLB_START_X, NORMAL_LOLB_START_Y),  //Saturn Version
//	ORLB,      NORMAL_ROLB_START_X, NORMAL_ROLB_START_Y),  //Saturn Version
	OLLB,      NORMAL_LOLB_START_X+(.5*YARDS), NORMAL_LILB_START_Y-(1.5*YARDS),
	ORLB,      NORMAL_ROLB_START_X+(.5*YARDS), NORMAL_RILB_START_Y+(1.5*YARDS),
	FS,        NORMAL_FS_START_X, NORMAL_34NG_START_Y,
	SS,        NORMAL_SS_START_X, NORMAL_SS_START_Y
};


struct formation DEF_DIME_4MANLINE_FORM =       /* defensive dime formation with 4 rushers */
{
	MLB,      NORMAL_MLB_START_X, NORMAL_MLB_START_Y,
	LC,        NORMAL_LCB_START_X, NORMAL_LCB_START_Y,
	DLE,       NORMAL_43LE_START_X, NORMAL_43LE_START_Y,
	DLT,       NORMAL_43LT_START_X, NORMAL_43LT_START_Y,
	DRT,       NORMAL_43RT_START_X, NORMAL_43RT_START_Y,
	DRE,       NORMAL_43RE_START_X, NORMAL_43RE_START_Y,
	RC,        NORMAL_RCB_START_X, NORMAL_RCB_START_Y,
	NB,        NORMAL_NB_START_X, (-7*YARDS),
	DB,        NORMAL_DB_START_X, NORMAL_DB_START_Y,
	FS,        NORMAL_FS_START_X, (-3*YARDS),
	SS,        NORMAL_SS_START_X, (7*YARDS)
};


struct formation DEF_DIME_FORM =       /* defensive dime formation with 3 rushers */
{
	ORLB,      NORMAL_RILB_START_X, NORMAL_ROLB_START_Y,
	LC,        NORMAL_LCB_START_X, NORMAL_LCB_START_Y,
	DLE,       NORMAL_34LE_START_X, NORMAL_34LE_START_Y,
	OLLB,      NORMAL_LILB_START_X, NORMAL_LOLB_START_Y,
	DRT,       NORMAL_34NG_START_X, NORMAL_34NG_START_Y,
	DRE,       NORMAL_34RE_START_X, NORMAL_34RE_START_Y,
	RC,        NORMAL_RCB_START_X, NORMAL_RCB_START_Y,
	NB,        NORMAL_NB_START_X, (-7*YARDS),
	DB,        NORMAL_DB_START_X, NORMAL_DB_START_Y,
	FS,        NORMAL_FS_START_X, (-3.5*YARDS),
	SS,        NORMAL_SS_START_X, (7*YARDS)

};


struct formation DEF_GOALINE_FORM =       /* defensive goal line */
{
	SS,        NORMAL_MLB_START_X, NORMAL_MLB_START_Y,
	LC,        (2*YARDS), NORMAL_LCB_START_Y,
	DLE,       NORMAL_43LE_START_X, (-3*YARDS),
	DLT,       NORMAL_43LT_START_X, (-1*YARDS),
	DRT,       NORMAL_34NG_START_X, (1*YARDS),
	DRE,       NORMAL_43RE_START_X, (3*YARDS),
	RC,        (2*YARDS), NORMAL_RCB_START_Y,
	DL5,       NORMAL_43LE_START_X, (-5*YARDS),
	DL6,       NORMAL_43RE_START_X, (5*YARDS),
	ILLB,      NORMAL_LILB_START_X, NORMAL_LILB_START_Y,
	IRLB,      NORMAL_RILB_START_X, NORMAL_RILB_START_Y
};


struct formation DEF_FG_FORM =       /* defensive field goal */
{
	SS,        NORMAL_LILB_START_X, NORMAL_34NG_START_Y,
	LC,        NORMAL_43LE_START_X, (-8*YARDS),
	DLE,       NORMAL_43LE_START_X, (-3*YARDS),
	DLT,       NORMAL_34NG_START_X, (-1*YARDS),
	DRT,       NORMAL_34NG_START_X, (1*YARDS),
	DRE,       NORMAL_43RE_START_X, (3*YARDS),
	RC,        NORMAL_43RE_START_X, (8*YARDS),
	OLLB,      NORMAL_43LE_START_X, (-5*YARDS),
	ORLB,      NORMAL_43RE_START_X, (5*YARDS),
	ILLB,      NORMAL_LILB_START_X-1.5*YARDS, (-2*YARDS),
	IRLB,      NORMAL_RILB_START_X-1.5*YARDS, (2*YARDS)
};


struct formation DEF_PUNT_FORM =       /* defensive punt return */
{
//	PUNT_RETURNER,        (35*YARDS), (0*YARDS),
	ILLB,      NORMAL_LILB_START_X, NORMAL_LILB_START_Y,
	LC,        NORMAL_LCB_START_X-2*YARDS, NORMAL_LCB_START_Y,
	DL5,       NORMAL_34LE_START_X, (-1.5*YARDS),
//	FS,        (17.5*YARDS), (-3*YARDS),
	FS,        (17.5*YARDS), (3*YARDS),	// kept bumping into PR
	DL6,       NORMAL_34NG_START_X, (0*YARDS),
	DRE,       NORMAL_34RE_START_X, (1.5*YARDS),
	RC,        NORMAL_RCB_START_X-2*YARDS, NORMAL_RCB_START_Y,
	LB5,       NORMAL_34LE_START_X+.5*YARDS, (-4*YARDS),
	LB6,       NORMAL_34RE_START_X+.5*YARDS, (4*YARDS),
	PUNT_RETURNER,        (35*YARDS), (0*YARDS),
	IRLB,      NORMAL_RILB_START_X, NORMAL_RILB_START_Y
};


struct formation DEF_PUNT_DOUBLE_COVER_FORM =       /* defensive punt double covering outside coverage men */
{
//	PUNT_RETURNER,        (35*YARDS), (0*YARDS),
	FS,        NORMAL_LCB_START_X-2*YARDS, NORMAL_LCB_START_Y+1*YARDS,
	LC,        NORMAL_LCB_START_X-2*YARDS, NORMAL_LCB_START_Y-1*YARDS,
	DL5,       NORMAL_34LE_START_X, (-2.5*YARDS),
	DLT,       NORMAL_34NG_START_X, (-.75*YARDS),
	DRT,       NORMAL_34NG_START_X, (.75*YARDS),
	DL6,       NORMAL_34RE_START_X, (2.5*YARDS),
	RC,        NORMAL_RCB_START_X-2*YARDS, NORMAL_RCB_START_Y+1*YARDS,
	LB5,       NORMAL_34LE_START_X, (-5*YARDS),
	LB6,       NORMAL_34RE_START_X, (5*YARDS),
	PUNT_RETURNER,        (35*YARDS), (0*YARDS),
	SS,        NORMAL_RCB_START_X-2*YARDS, NORMAL_RCB_START_Y-1*YARDS
};



struct formation DEF_PUNT_BLOCK_FORM =       /* defensive punt rush with one man back */
{
//	PUNT_RETURNER,        (35*YARDS), (0*YARDS),
	FS,        NORMAL_LCB_START_X-2*YARDS, NORMAL_LCB_START_Y+6*YARDS,
	LC,        NORMAL_LCB_START_X-2*YARDS, (-10*YARDS),
	DL5,       NORMAL_34LE_START_X, (-2.5*YARDS),
	DLT,       NORMAL_34NG_START_X, (-1*YARDS),
	DRT,       NORMAL_34NG_START_X, (1*YARDS),
	DL6,       NORMAL_34RE_START_X, (2.5*YARDS),
	RC,        NORMAL_RCB_START_X-2*YARDS, (10*YARDS),
	LB5,       NORMAL_34LE_START_X+.25*YARDS, (-4*YARDS),
	LB6,       NORMAL_34RE_START_X+.25*YARDS, (4*YARDS),
	PUNT_RETURNER,        (35*YARDS), (0*YARDS),
	SS,        NORMAL_RCB_START_X-2*YARDS, NORMAL_RCB_START_Y-6*YARDS
};


struct formation DEF_ALL_OUT_BLOCK_FORM =       /* defensive rush with all 11 men */
{
	ILLB,      NORMAL_34RE_START_X+(.25*YARDS), (2.5*YARDS),
	LC,        NORMAL_LCB_START_X-2*YARDS, (NORMAL_LCB_START_Y+3*YARDS),
	DLE,       NORMAL_34LE_START_X+(.25*YARDS), (-2.5*YARDS),
	DLT,       NORMAL_34NG_START_X, (-1.25*YARDS),
	DRT,       NORMAL_34NG_START_X, (0*YARDS),
	DRE,       NORMAL_34RE_START_X, (1.25*YARDS),
	RC,        NORMAL_RCB_START_X-2*YARDS, NORMAL_RCB_START_Y-3*YARDS,
	OLLB,      NORMAL_34LE_START_X+2*YARDS, (-1*YARDS),
	ORLB,      NORMAL_34RE_START_X+2*YARDS, (1*YARDS),
	FS,        NORMAL_LCB_START_X, (1.5*YARDS),
	SS,        NORMAL_RCB_START_X, (-1.5*YARDS)
};



struct formation DEF_DUMMY_FORM = /* defensive form to test offensive ai */
{
	DB7,       83*YARDS,-10*YARDS,	// no greater than 83 yards
	LC,        81*YARDS, -2*YARDS,	// as it's a bug if on 99 yard line
	DLE,       81*YARDS, -4*YARDS,
	DLT,       81*YARDS, -6*YARDS,
	DRT,       81*YARDS, -8*YARDS,
	DRE,       81*YARDS,  0*YARDS,
	RC,        81*YARDS,  2*YARDS,
	OLLB,      81*YARDS,  4*YARDS,
	ORLB,      81*YARDS,  6*YARDS,
	FS,        81*YARDS,  8*YARDS,
	SS,        81*YARDS, 10*YARDS,
};



struct formation DEF_ONE_MAN_FORM =       /* defensive form to test blocking */
{
	DB7,       53*YARDS,-10*YARDS,
	LC,        51*YARDS, -2*YARDS,
	DLE,       51*YARDS, -4*YARDS,
	DLT,       51*YARDS, -6*YARDS,
	DRT,       51*YARDS, -8*YARDS,
	DRE,       NORMAL_34RE_START_X,  0*YARDS,
	RC,        51*YARDS,  2*YARDS,
	OLLB,      51*YARDS,  4*YARDS,
	ORLB,      51*YARDS,  6*YARDS,
	FS,        51*YARDS,  8*YARDS,
	SS,        51*YARDS, 10*YARDS,
};


struct formation OFF_ONE_MAN_FORM =       /* offensive form to test blocking */
{
	QB,     -15*YARDS, 0*YARDS,
	RR,     -15*YARDS, 9*YARDS,
	LTE,    -15*YARDS, -4.5*YARD,
	RTE,    -15*YARDS,  4.5*YARD,
	FB,     -17*YARDS, NORMAL_FB_START_Y,
	HB,     -13*YARDS, NORMAL_HB_START_Y,
	RT,     -15*YARDS, 3*YARD,
	LT,     -15*YARDS,-3*YARD,
	RG,     -15*YARDS, 1.5*YARD,
	LG,     -15*YARDS,-1.5*YARD,
	CENTER, NORMAL_C_START_X, 0*YARD
};


struct formation KICKOFF_KICKING_FORM =       /* regular ko formation (defensive) */
{
	KICKER,  8*YARDS, 2*YARDS,			 // should be Kicker
	IRLB,    6*YARDS, 3.5*YARDS,
	ILLB,    6*YARDS, -3.5*YARDS,
	LB5,     6*YARDS,  7*YARDS,
	LB6,     6*YARDS, -7*YARDS,
	DB7,     6*YARDS, 11*YARDS,
	FS,      6*YARDS, -11*YARDS,
	SS,      6*YARDS, 15*YARDS,
	WR5,     6*YARDS, -15*YARDS,
	DB7,     6*YARDS, 18*YARDS,
	DB8,     6*YARDS, -18*YARDS
};


	// new 9/24/96 - StartBallY is on hash
struct formation KICKOFF_RIGHT_KICKING_FORM = /* ko formation (defensive) */
{ //RIGHT from kicking teams POV
	KICKER,  8*YARDS, 2*YARDS,			 // should be Kicker
	IRLB,    6*YARDS, -3*YARDS,
	ILLB,    6*YARDS, -5.5*YARDS,
	LB5,     6*YARDS,  7*YARDS,
	LB6,     6*YARDS, -8*YARDS,
	DB7,     6*YARDS, -23*YARDS,
	FS,      6*YARDS, -13*YARDS,
	SS,      6*YARDS, -10.5*YARDS,
	WR5,     6*YARDS, -15.5*YARDS,
	DB7,     6*YARDS, -18*YARDS,
	DB8,     6*YARDS, -20.5*YARDS
};
struct formation KICKOFF_LEFT_KICKING_FORM =       /* regular ko formation (defensive) */
{   //LEFT from kicking teams POV
	KICKER,  8*YARDS, 2*YARDS,			 // should be Kicker
	IRLB,    6*YARDS,  3*YARDS,
	ILLB,    6*YARDS, -7*YARDS,
	LB5,    6*YARDS,  8*YARDS,
	LB6,    6*YARDS, 5.5*YARDS,
	DB7,     6*YARDS, 13*YARDS,
	FS,      6*YARDS, 23*YARDS,
	SS,      6*YARDS, 15.5*YARDS,
	WR5,     6*YARDS, 10.5*YARDS,
	DB7,     6*YARDS, 20.5*YARDS,
	DB8,     6*YARDS, 18*YARDS
};



struct formation KICKOFF_RETURN_FORM =       /* regular ko return formation (offensive) */
{
	KR,      -65*YARDS, 0*YARDS,				// should be KR
	LG,      -15*YARDS, 15*YARDS,
	OL6,     -15*YARDS, 7*YARD,
	OL7,     -15*YARDS,  0*YARD,
	DL5,     -15*YARDS, -7*YARDS,
	DL6,     -15*YARDS, -15*YARDS,

	LB5,     -42*YARDS, -11*YARDS,
	FB,      -42*YARDS, 0*YARDS,
	LB6,     -42*YARDS, 11*YARDS,
	LTE,     -52*YARDS, 7*YARDS,
	TE3,     -52*YARDS, -7*YARDS
};

// following modified 4/14/96 mjk - to more closely resemble other KO forms
struct formation KICKOFF_RETURN_SPREAD_FORM =       /* ko return formation (offensive) */
{
	KR,      -65*YARDS, 10*YARDS,				// should be KR
	LG,      -15*YARDS, 15*YARDS,
	OL6,     -15*YARDS, 7*YARD,
	OL7,     -15*YARDS,  0*YARD,
	DL5,     -15*YARDS, -7*YARDS,
	DL6,     -15*YARDS, -15*YARDS,

	FB,      -42*YARDS, -5*YARDS,
	KR3,     -65*YARDS, -10*YARDS,	// second returner
	TE3,     -42*YARDS, 5*YARDS,
	LB5,     -30*YARDS, 12*YARDS,
	LB6,     -30*YARDS, -12*YARDS
};

struct formation KICKOFF_RETURN_HANDS_FORM =       /* ko return formation (offensive) */
{
	WR3,     -65*YARDS, 0*YARDS,				// should be KR
	RC,      -12*YARDS, 15*YARDS,
	RR,      -12*YARDS, 7*YARD,
	LTE,     -12*YARDS,  2*YARD,
	LR,      -12*YARDS, -7*YARDS,
	WR4,     -12*YARDS, -15*YARDS,

	RTE,      -12*YARDS, -2*YARDS,
	FB,      -25*YARDS, -10*YARDS,
	LB5,     -25*YARDS, 10*YARDS,
	FS,      -47*YARDS, 7*YARDS,
	DB,      -47*YARDS, -7*YARDS
};



#define	ORF_SX	(-10*YARDS)
struct formation OFF_RACE_FORM =   /* offensive form to test speed */
{
	QB,     ORF_SX,-10*YARDS,
	QB,     ORF_SX,-8*YARDS,
	QB,     ORF_SX,-6*YARDS,
	QB,     ORF_SX,-4*YARDS,
	QB,     ORF_SX,-2*YARDS,
	QB,     ORF_SX, 0*YARDS,
	QB,     ORF_SX, 2*YARDS,
	QB,     ORF_SX, 4*YARDS,
	QB,     ORF_SX, 6*YARDS,
	QB,     ORF_SX, 8*YARDS,
	QB,     ORF_SX,10*YARDS,

};


/*  following are dummy formations so our pointer table is complete */
struct formation DEF_SPECIAL_TEAMS_FORM;
struct formation OFF_SPECIAL_TEAMS_FORM;
struct formation OFF_EASTER_FORM;
struct formation DEF_EASTER_FORM;
struct formation TEAM0_EDIT_FORM;
struct formation TEAM1_EDIT_FORM;

//struct formation NULL_FORM;



#define PLAYS_IN_FORM(formation)	WORD formation##Table[] = {
#define END_PLAYS_IN_FORM			-1};


//WORD FormationPlays[][12] ={

PLAYS_IN_FORM(GOAL_LINE_FORM)/* 0 "GOAL LINE"*/

	GoalLineOptionPassNUM,
	GoalLineQBSneakNUM,
	GoalLineFBDiveNUM,

	GoalLineNakedBootlegNUM,
	GoalLineHBLeapNUM,
	GoalLineGoalLineFloodNUM,

	GoalLineTackleEligibleNUM,
	GoalLineEndSweepNUM,
	GoalLineCrossBlockNUM,

	GoalLinePAFadeNUM,
	GoalLineHBPowerNUM,
	GoalLineHBTrapNUM,

#if NEWPLAYS1
	GoalLineHBDiveNUM,
	GoalLineWishbonePANUM,
	GoalLineFullHouseSweepNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(WISH_BONE_FORM)/* 1 "WISH BONE"*/
	WishBoneFBOffTackleNUM,
	WishBoneRollOutNUM,
	WishBoneTripleOptionNUM,

	WishBonePowerHBDiveNUM,
	WishBoneHBScreenNUM,
	WishBoneStudentBodySweepNUM,

	WishBone10YardCurlNUM,
	WishBoneMisdirectionNUM,
	WishBonePASeemNUM,

	WishBoneQuickPitchNUM,
	WishBoneTEBombNUM,
	WishBoneWrapAroundDrawNUM,

#if	0	// NEWPLAYS1  only 12 plays in WB	 - Easter Egg anyway
	WishBoneEx1,
	WishBoneEx2,
	WishBoneEx3,
#endif

END_PLAYS_IN_FORM


PLAYS_IN_FORM(POWER_I_FORM)/* 2 "POWER I"*/
	PowerIFBOffTackleNUM,
	PowerIRollOutNUM,
	PowerIPitchSweepNUM,


	PowerIPowerHBDiveNUM,
	PowerIHBScreenNUM,
	PowerIDoubleOptionNUM,

	PowerI10YardCurlNUM,
	PowerIFBMisdirectionNUM,
	PowerIPASeemNUM,

	PowerIFBQuickPitchNUM,
	PowerITEBombNUM,
	PowerIWrapAroundDrawNUM,

#if 0	//NEWPLAYS1 only 12 plays in Power I - Easter Egg anyway
	PowerIEx1,
	PowerIEx2,
	PowerIEx3,
#endif

END_PLAYS_IN_FORM


PLAYS_IN_FORM(NEAR_FAR_FORM)/* 3 "NEAR FAR"*/
	NearFarHBOffTackleNUM,
	NearFarRollOutScrambleNUM,
	NearFarPitchSweepNUM,

	NearFarPowerHBRunNUM,
	NearFarFBScreenNUM,
	NearFarFBSweepNUM,

	NearFar10YardCurlNUM,
	NearFarHBMisdirectionNUM,
	NearFarPASeemNUM,

	NearFarFBQuickPitchNUM,
	NearFarTEBombNUM,
	NearFarWrapAroundDrawNUM,

#if NEWPLAYS1
	NearFarFBCounterSlantNUM,
	NearFarCornerPostNUM,
	NearFarQBWaggleNUM,
#endif

END_PLAYS_IN_FORM


PLAYS_IN_FORM(I_SLOT_FORM)/* 4 "I SLOT"*/
	ISlotFleaFlickerNUM,
	ISlotPACrossesNUM,
	ISlotHBRunMiddleNUM,

	ISlotBombNUM,
	ISlotFBPowerNUM,
	ISlotPAReverseNUM,

	ISlotCornerFadeNUM,
	ISlotQBDrawNUM,
	ISlotTEFlyNUM,

	ISlotTEScreenNUM,
	ISlotCrackBackNUM,
	ISlotCenterTrapNUM,

#if NEWPLAYS1
	ISlotSlantCrossNUM,
	ISlotPickPassNUM,
	ISlotFBDiveNUM,
#endif

END_PLAYS_IN_FORM


PLAYS_IN_FORM(SINGLE_BACK_FORM)/* 5 "ONE BACK"*/
	SingleBackLeadPushNUM,
	SingleBackShortPostNUM,
	SingleBackPACrossNUM,

	SingleBack10YardCurlsNUM,
	SingleBackSweepNUM,
	SingleBackRollOutFloodNUM,

	SingleBackWrapAroundDrawNUM,
	SingleBackScreenNUM,
	SingleBackPABootLegNUM,

	SingleBackTECornerNUM,
	SingleBackCounterPitchNUM,
	SingleBackPowerLeadNUM,

#if NEWPLAYS1
	SingleBackHBTossNUM,
	SingleBackQBWaggleNUM,
	SingleBackCornerPostNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(H_BACK_FORM)/* 6 "H BACK"*/
	HBackQBDrawNUM,
	HBackPostCornerNUM,
	HBackReverseNUM,

	HBackCrackBackSweepNUM,
	HBackHBCenterTrapNUM,
	HBackHBFlatNUM,

	HBackFleaFlickerNUM,
	HBackPACrossesNUM,
	HBackQuickOutsNUM,

	HBackBombNUM,
	HBackStrongPitchNUM,
	HBackTEScreenNUM,

#if NEWPLAYS1
	HBackHBackFlatNUM,
	HBackPickPassNUM,
	HBackHBackRunNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(I_FORM_FORM)/* 7 "I FORM"*/
	IFormCounterPullLeftNUM,
	IFormLongBombNUM,
	IFormHBOptionNUM,

	IFormFBPunchNUM,
	IFormStrongPitchNUM,
	IFormPARollOutNUM,

	IFormQuickSlantNUM,
	IFormQuickPitchWeakNUM,
	IFormOutAndUpsNUM,

	IFormHBScreenNUM,
	IFormPowerBlastNUM,
	IFormPAHBFlyNUM,

#if NEWPLAYS1
	IFormBounceOutsideNUM,
	IFormTEPostNUM,
	IFormPAChairNUM,
#endif

END_PLAYS_IN_FORM


PLAYS_IN_FORM(PROSET_FORM)/* 8 ProSet    */
	ProSetCounterPullLeftNUM,
	ProSetLongBombNUM,
	ProSetHalfBackOptionNUM,

	ProSetFBPunchNUM,
	ProSetStrongPitchNUM,
	ProSetPARollOutNUM,

	ProSetQuickSlantNUM,
	ProSetQuickPitchWeakNUM,
	ProSetOutAndUpsNUM,

	ProSetHBScreenNUM,
	ProSetPowerBlastNUM,
	ProSetPAHBFlyNUM,

#if NEWPLAYS1
	ProSetInsideSlantNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(WEST_COAST_FORM)/* 9 WEST COAST */
	WestCoastRollOutFloodNUM,
	WestCoastMotionPitchNUM,
	WestCoast10YardCurlNUM,

	WestCoastPassBackRightNUM,
	WestCoastReverseNUM,
	WestCoastPASlantNUM,

	WestCoastBombNUM,
	WestCoastNoBackPassNUM,
	WestCoastQBDrawNUM,

	WestCoastCBBurnerNUM,
	WestCoastShortPostNUM,
	WestCoastOffTackleNUM,

#if NEWPLAYS1
	WestCoastHBFlareNUM,
	WestCoastSprintHandOffNUM,
	WestCoastSlantClearNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(SHOTGUN_FORM)/* 10 "SHOTGUN"*/
	ShotGunRolloutOptionNUM,
	ShotGunSwingPassNUM,
	ShotGunRunGunWideNUM,

	ShotGunShortCrossNUM,
	ShotGunHBSnapNUM,
	ShotGunHailMaryNUM,

	ShotGunShovelPassNUM,
	ShotGunPoochKickNUM,
	ShotGunDeepCrossNUM,

	ShotGunWRScreenNUM,
	ShotGunDelayedDrawNUM,
	ShotGunShortClearoutNUM,

#if NEWPLAYS1
	ShotGunDelayTossNUM,
	ShotGunTEShortPostNUM,
	ShotGunClearFlatNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(TRIPS_FORM)/* 11 "TRIPS"*/
	TripsHBFlatNUM,
	TripsQBDrawNUM,
	TripsClearOutNUM,

	TripsSlantCrossNUM,
	TripsPitchAwayNUM,
	TripsPickPassNUM,

	TripsPACrossNUM,
	TripsCenterTrapNUM,
	TripsFleaFlickerNUM,

	TripsOutAndUnderNUM,
	TripsReverseNUM,
	TripsFlankerCurlNUM,

#if NEWPLAYS1
	TripsOffGuardNUM,
	TripsClearFlatNUM,
	TripsPostIsoNUM,
#endif

END_PLAYS_IN_FORM


PLAYS_IN_FORM(RUN_SHOOT_FORM)/* 12 "RUN AND SHOOT"*/
	RunAndShootShortShootNUM,
	RunAndShootQBDrawNUM,
	RunAndShootMediumShootNUM,

	RunAndShootPACrossNUM,
	RunAndShootFleaFlickerNUM,
	RunAndShootCenterTrapNUM,

	RunAndShootLongShootNUM,
	RunAndShootBombNUM,
	RunAndShootPitchBackNUM,

	RunAndShootMotionFlatNUM,
	RunAndShootReverseNUM,
	RunAndShootHBCurlNUM,

#if NEWPLAYS1
	RunAndShootOffGuardNUM,
	RunAndShootHBFlatNUM,
	RunAndShootPostIsoNUM,
#endif

END_PLAYS_IN_FORM



PLAYS_IN_FORM(OFF_SPECIAL_TEAMS_FORM)/* 13 "OFF SPECIAL TEAMS"*/
	SpecialTeamsFakeFGRunNUM,
	SpecialTeamsFieldGoalNUM,
	SpecialTeamsFakeFGPassNUM,

	SpecialTeamsFakePuntRunNUM,
	SpecialTeamsPuntNUM,
	SpecialTeamsFakePuntPassNUM,

	SpecialTeamsQBDownBallNUM,
	SpecialTeamsQBKneelNUM,
	SpecialTeamsFakeQBDownBallNUM,
END_PLAYS_IN_FORM



/****************Defenses*****************/
PLAYS_IN_FORM(DEF_GOALINE_FORM)/* 23 "GOALINE DEFENSE"*/
	DefGoalLineOutsideCrunchNUM,
	DefGoalLineGoalLineDeepNUM,
	DefGoalLineHousePartyNUM,

	DefGoalLineCheatLeftNUM,
	DefGoalLineShortZoneNUM,
	DefGoalLineCheatRightNUM,

	DefGoalLineSafetyGambleNUM,
	DefGoalLineFakeGambleNUM,
	DefGoalLineJamMiddleNUM,

	DefGoalLineGoalLineManNUM,
	DefGoalLineShadowBackfieldNUM,
	DefGoalLineOutsideContainNUM,
END_PLAYS_IN_FORM


PLAYS_IN_FORM(DEF_4_3_FORM)/* 24 "4-3"*/
	Def43OutsideInBlitzNUM,
	Def433DeepCornerNUM,
	Def43StuntBlitzNUM,

	Def43SSBlitzNUM,
	Def433DeepSafetyNUM,
	Def43FakeSSBlitzNUM,

	Def43ManToManNUM,
	Def43ZoneLeftNUM,
	Def43WideZoneNUM,

	Def43CombatZoneNUM,
	Def43TwoDeepZoneNUM,
	Def43LeftBlitzNUM,
END_PLAYS_IN_FORM


PLAYS_IN_FORM(DEF_3_4_FORM)/* 25 "3-4"*/
	Def34InsideBlitzNUM,
	Def34DeepCloudNUM,
	Def34StuntBlitzNUM,

	Def34FakeSafetyBlitzNUM,
	Def34DeepSkyNUM,
	Def34SafetyBlitzNUM,

	Def34StraightUpManNUM,
	Def34CBBlitzNUM,
	Def34CenterFieldZoneNUM,

	Def34SuicideBlitzNUM,
	Def34ShadowZoneNUM,
	Def34OutsideBlitzNUM,

END_PLAYS_IN_FORM


PLAYS_IN_FORM(DEF_NICKEL_FORM)/* 26 "NICKEL"*/
	DefNickelNickelPreventNUM,
	DefNickelNickelManNUM,
	DefNickelPreventBlitzNUM,

	DefNickelKeyOnHBNUM,
	DefNickelMiddleZoneNUM,
	DefNickelDoubleRightNUM,

	DefNickelBigDogEatNUM,
	DefNickelBumpAndRunNUM,
	DefNickelCornerCushionNUM,

	DefNickelQBSpyNUM,
	DefNickelFakeNickelBlitzNUM,
	DefNickelNickelBlitzNUM,
END_PLAYS_IN_FORM


PLAYS_IN_FORM(DEF_DIME_FORM)/* 27 "DIME"*/
	DefDimePreventNUM,
	DefDimeDimeManNUM,
	DefDimeFourDeepNUM,

	DefDimePreventRightNUM,
	DefDimeInsideBlitzNUM,
	DefDimeDoubleWidesNUM,

	DefDimeBlitzManNUM,
	DefDimeDoubleCBBlitzNUM,
	DefDimePreventLeftNUM,

	DefDimeFakeSafetyBlitzNUM,
	DefDimeBlitzZoneNUM,
	DefDimeTwoSafetyBlitzNUM,
END_PLAYS_IN_FORM


PLAYS_IN_FORM(DEF_SPECIAL_TEAMS_FORM)/* 28 "SPECIAL"*/
	DefSpecialDoubleOutsideNUM,
	DefSpecialPuntReturnNUM,
	DefSpecialPuntBlockNUM,

	DefSpecial11ManRushNUM,
	DefSpecialFGBlockNUM,
	DefSpecialWatchFakeNUM,

END_PLAYS_IN_FORM





PLAYS_IN_FORM(OFF_EASTER_FORM)/* 14 "OFF EDIT"*/
 OffEaster0NUM,
 OffEaster1NUM,
 OffEaster2NUM,
 OffEaster3NUM,

 OffEaster4NUM,
 OffEaster5NUM,
 OffEaster6NUM,
 OffEaster7NUM,

 OffEaster8NUM,
 OffEaster9NUM,
 OffEaster10NUM,
 OffEaster11NUM,

END_PLAYS_IN_FORM

PLAYS_IN_FORM(DEF_EASTER_FORM)/* 29 "def Edit"*/
 DefEaster0NUM,
 DefEaster1NUM,
 DefEaster2NUM,
 DefEaster3NUM,

 DefEaster4NUM,
 DefEaster5NUM,
 DefEaster6NUM,
 DefEaster7NUM,

 DefEaster8NUM,
 DefEaster9NUM,
 DefEaster10NUM,
 DefEaster11NUM,
END_PLAYS_IN_FORM


PLAYS_IN_FORM(TEAM0_EDIT_FORM)	// max 24 plays for edited
				// will be adjusted (with -1) for actually number of plays
	T0Edit0NUM,
	T0Edit1NUM,
	T0Edit2NUM,
	T0Edit3NUM,

	T0Edit4NUM,
	T0Edit5NUM,
	T0Edit6NUM,
	T0Edit7NUM,

	T0Edit8NUM,
	T0Edit9NUM,
	T0Edit10NUM,
	T0Edit11NUM,

	T0Edit12NUM,
	T0Edit13NUM,
	T0Edit14NUM,
	T0Edit15NUM,

	T0Edit16NUM,
	T0Edit17NUM,
	T0Edit18NUM,
	T0Edit19NUM,

	T0Edit20NUM,
	T0Edit21NUM,
	T0Edit22NUM,
	T0Edit23NUM,
END_PLAYS_IN_FORM

PLAYS_IN_FORM(TEAM1_EDIT_FORM)
	T1Edit0NUM,
	T1Edit1NUM,
	T1Edit2NUM,
	T1Edit3NUM,

	T1Edit4NUM,
	T1Edit5NUM,
	T1Edit6NUM,
	T1Edit7NUM,

	T1Edit8NUM,
	T1Edit9NUM,
	T1Edit10NUM,
	T1Edit11NUM,

	T1Edit12NUM,
	T1Edit13NUM,
	T1Edit14NUM,
	T1Edit15NUM,

	T1Edit16NUM,
	T1Edit17NUM,
	T1Edit18NUM,
	T1Edit19NUM,

	T1Edit20NUM,
	T1Edit21NUM,
	T1Edit22NUM,
	T1Edit23NUM,
END_PLAYS_IN_FORM



PLAYS_IN_FORM(GOAL_LINE_NO_WR_FORM)/* 15 "GOAL LINE NO WR"*/
	KickoffReturnSpreadNUM,	// offense (receiving)
	KickoffReturnRegularNUM,
	KickoffReturnHandsNUM,
END_PLAYS_IN_FORM


PLAYS_IN_FORM(GOAL_LINE_T_FORM)/* 30 "PUNT"*/
	KickoffStackLeftNUM,			// defense (kickers)
	KickoffRegularNUM,
	KickoffStackRightNUM,

END_PLAYS_IN_FORM



PLAYS_IN_FORM(KICKOFF_KICKING_FORM)
END_PLAYS_IN_FORM

#define PLAYS_IN_FORM(formation)	WORD formation##Table[] = {

PLAYS_IN_FORM(NoPlaysInForm)	// dummy holder
END_PLAYS_IN_FORM








//#define formmacro(xxx,yyy,zzz)	&xxx,
#define formmacro(positionform,PCformnum,string,OfforDef,offseq)	&positionform##Table,
//#define	ALL_FORMS_VALID		NOT valid for this used of macro table
void *PlaysPerFormationTables[] = {

	#include	"fbfrmdat.h"
	&GOAL_LINE_NO_WR_FORMTable,
	&GOAL_LINE_T_FORMTable,

};

#undef	ALL_FORMS_VALID
#undef formmacro







/**   pointer table to the above reference formation structures
	make redefineable MACRO equal the address of (&) the formation */

//#define formmacro(xxx,yyy,zzz)	&xxx,
#define formmacro(positionform,PCformnum,string,OfforDef,offseq)	&positionform,
#define	ALL_FORMS_VALID

void *AllFormations[] = {

	#include	"fbfrmdat.h"
};

#undef	ALL_FORMS_VALID
#undef formmacro





WORD *GetPlaysPerForm(WORD formnum)	// pointer to table, -1 at end
{
	if(formnum > GOAL_LINE_T_FORM_NUM)
		return((WORD *)&NoPlaysInFormTable);	// A POINTER TO -1
	else
		return(PlaysPerFormationTables[formnum]);

}

/***   code to use new pointer based PlaysPerFormation (from FBtestai.c)

	formptr = GetPlaysPerForm(FormNum);	// pointer to table, -1 at end

	i=0;
	while( (playnum = *(formptr+i)) >= ZERO)
	{
		gotoxy(StartX, StartY+2+i);
		printf("%3d %s",playnum,PlayNames[playnum]);
		i++;
	}


*/


/*********************  End of File - FB_FORMS.C  ****************/

