/**************************************************************


					FBFORMS.H

	AUTHOR: Bobby King			Start Date: 11/7/95
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains formataion equates for Football AI.

	It is an INCLUDED file.

**************************************************************/


/**********************************************************************

			F O R M A T I O N S

	Formations are refered to in two ways:

	"General Formations" - used in Play Calling Screen - this includes
	ProSet, Special teams, etc.

	"Positional Formations" - used to position the players at the start
	of the play - this [Formation Number] is included in the play data
	structure. E.G. "special teams" is NOT a positional formation, but
	punt formation and field goal formation are positional formations.

	On Offensive, teams have a choice of 5 of the 13 normal formations -
	all teams have 2 default formations, then 1 from column A and 1 from
	column B, and 1 from column C.

	A provision has been made for "editable formations" (General only)
	on both offense and defense.

-----------------------------------------------------------------------*/


/*****-------------   Prototypes   ------------------***/

WORD *GetPlaysPerForm(WORD formnum);	// pointer to table, -1 at end






/*  Use redefineable macro to get the data (formation number) that
	we want here ( make general name a number by concatenating "_NUM" */

#define formmacro(positionformnum,PCformnum,string,OfforDef,offseq)	positionformnum##_NUM,
#define	ALL_FORMS_VALID


enum FormationNumbers {

	#include	"fbfrmdat.h"
	MAX_FORMATIONS
};

#undef	ALL_FORMS_VALID
#undef formmacro



#define	NEAR_FORM_NUM			NEAR_FAR_FORM_NUM
#define VEER_FORM				NEAR_FAR_FORM_NUM

//#define START_OFF_FORM_NUM		GOALLINE_FORM_NUM
//#define START_DEF_FORM_NUM		DEF_GOALINE_FORM_NUM
//#define LAST_DEF_PLAY_CALL_FORM		DEF_EDIT_FORM_NUM
//#define LAST_OFF_PLAY_CALL_FORM		OFF_EDIT_FORM_NUM

/* following FORM_NUMations are ONLY used for playcalling and "hide" the
	kickoff plays in other "positional" FORM_NUMations			*/
//#define	OFF_KICKOFF_PLAYCALL_FORM_NUM 	GOAL_LINE_NO_WR_FORM_NUM   /* 11 	*/
//#define	DEF_KICKOFF_PLAYCALL_FORM_NUM	DEF_PUNT_FORM_NUM
#define	OFF_KICKOFF_PLAYCALL_FORM_NUM 	GOAL_LINE_NO_WR_FORM_NUM
#define	DEF_KICKOFF_PLAYCALL_FORM_NUM	(GOAL_LINE_NO_WR_FORM_NUM + 1)



/***** macro for team initialization	*******************/

#define	NORMAL_DEF_FORMATIONS 	\
	DEF_GOALINE_FORM_NUM,		\
	DEF_4_3_FORM_NUM,           \
	DEF_3_4_FORM_NUM,           \
	DEF_NICKEL_FORM_NUM,            \
	DEF_DIME_FORM_NUM,              \
	DEF_SPECIAL_TEAMS_FORM_NUM, \
	DEF_EASTER_FORM_NUM




/*--------------   EQUATES FOR INIT Positioning  ---------------------*/

#if 	1

#define	OOS	(-HALFYARD)
#define	DOS	(HALFYARD)

#define	DEFLINE_STARTX	(1*YARDS+DOS)

#define OFF_LINE_START_X                (-1*YARDS+OOS)
#define NORMAL_QB_START_X               (-1.75*YARDS+OOS)
#define NORMAL_C_START_X                (-.5*YARDS+OOS)
#define NORMAL_WR_START_X               (-1*YARDS+OOS)
#define NORMAL_WR_START_Y               (10*YARDS)
#define NORMAL_WR_SLOT_START_X          (-2.5*YARDS)
#define NORMAL_WR_SLOT_START_Y          (7*YARDS)
#define NORMAL_HB_START_X               (-7*YARDS)
#define NORMAL_HB_START_Y               (0*YARDS)
#define NORMAL_FB_START_X               (-5*YARDS)
#define NORMAL_FB_START_Y               (0*YARDS)
#define NORMAL_RRB_START_X              (-5*YARDS)
#define NORMAL_RRB_START_Y              (2*YARDS)
#define NORMAL_LRB_START_X              (-5*YARDS)
#define NORMAL_LRB_START_Y              (-2*YARDS)
#define NORMAL_TE_START_X               (-1*YARDS+OOS)
#define NORMAL_TE_START_Y               (4.5*YARDS)
#define NORMAL_SLOT_START_X             (-3*YARDS)
#define NORMAL_SLOT_START_Y             (-7.5*YARDS)
#define NORMAL_RBR_START_X              (-5*YARDS)
#define NORMAL_RBR_START_Y              ( 2*YARDS)
#define NORMAL_RBL_START_X              (-5*YARDS)
#define NORMAL_RBL_START_Y              (-2*YARDS)



#define NORMAL_OFF_LINE_FORMATION       \
		RT,             OFF_LINE_START_X, (3*YARDS),            /*      RT      */      \
		LT,             OFF_LINE_START_X, (-3*YARDS),           /*      LT      */  \
		RG,             OFF_LINE_START_X, (1.5*YARDS),            /*      RG      */  \
		LG,             OFF_LINE_START_X, (-1.5*YARDS),           /*      LG      */  \
		CENTER,         NORMAL_C_START_X , (0*YARDS)            /* Center       */

/******** DEFENSE *********/
//        Assumes Offenses Left-Right Perspective

#define NORMAL_34LE_START_X       DEFLINE_STARTX
#define NORMAL_34LE_START_Y       (-3.25*YARDS)
#define NORMAL_34RE_START_X       DEFLINE_STARTX
#define NORMAL_34RE_START_Y       (3.25*YARDS)
#define NORMAL_34NG_START_X       DEFLINE_STARTX
#define NORMAL_34NG_START_Y       (0*YARDS)
#define NORMAL_43LT_START_X       DEFLINE_STARTX
#define NORMAL_43LT_START_Y       (-1.25*YARDS)
#define NORMAL_43RT_START_X       DEFLINE_STARTX
#define NORMAL_43RT_START_Y       (1.25*YARDS)
#define NORMAL_43LE_START_X       DEFLINE_STARTX
#define NORMAL_43LE_START_Y       (-3.75*YARDS)
#define NORMAL_43RE_START_X       DEFLINE_STARTX
#define NORMAL_43RE_START_Y       (3.75*YARDS)

#define NORMAL_MLB_START_X        (5*YARDS)
#define NORMAL_MLB_START_Y        (0*YARDS)
#define NORMAL_LOLB_START_X       (2.5*YARDS)
#define NORMAL_LOLB_START_Y       (-4.5*YARDS)
#define NORMAL_ROLB_START_X       (2.5*YARDS)
#define NORMAL_ROLB_START_Y       (4.5*YARDS)
#define NORMAL_LILB_START_X       (4*YARDS)
#define NORMAL_LILB_START_Y       (-1.25*YARDS)
#define NORMAL_RILB_START_X       (4*YARDS)
#define NORMAL_RILB_START_Y       (1.25*YARDS)

#define NORMAL_LCB_START_X        (7*YARDS)
#define NORMAL_LCB_START_Y        (-NORMAL_WR_START_Y)
#define NORMAL_RCB_START_X        (7*YARDS)
#define NORMAL_RCB_START_Y        (NORMAL_WR_START_Y)
#define NORMAL_SS_START_X         (11*YARDS)
#define NORMAL_SS_START_Y         (NORMAL_TE_START_Y)
#define NORMAL_FS_START_X         (14*YARDS)
#define NORMAL_FS_START_Y         (-3*YARDS)
#define NORMAL_NB_START_X         (11*YARDS)
#define NORMAL_NB_START_Y         (-NORMAL_TE_START_Y)
#define NORMAL_DB_START_X         (14*YARDS)
#define NORMAL_DB_START_Y         (3.5*YARDS)


#else	// original off/def line numbers --------------------------

#define OFF_LINE_START_X                (-1*YARDS)
#define NORMAL_QB_START_X               (-1.75*YARDS)
#define NORMAL_C_START_X                (-.5*YARDS)
#define NORMAL_WR_START_X               (-1*YARDS)
#define NORMAL_WR_START_Y               (10*YARDS)
#define NORMAL_WR_SLOT_START_X          (-2.5*YARDS)
#define NORMAL_WR_SLOT_START_Y          (7*YARDS)
#define NORMAL_HB_START_X               (-7*YARDS)
#define NORMAL_HB_START_Y               (0*YARDS)
#define NORMAL_FB_START_X               (-5*YARDS)
#define NORMAL_FB_START_Y               (0*YARDS)
#define NORMAL_RRB_START_X              (-5*YARDS)
#define NORMAL_RRB_START_Y              (2*YARDS)
#define NORMAL_LRB_START_X              (-5*YARDS)
#define NORMAL_LRB_START_Y              (-2*YARDS)
#define NORMAL_TE_START_X               (-1*YARDS)
#define NORMAL_TE_START_Y               (4.5*YARDS)
#define NORMAL_SLOT_START_X             (-2.5*YARDS)
#define NORMAL_SLOT_START_Y             (-7.5*YARDS)
#define NORMAL_RBR_START_X              (-5*YARDS)
#define NORMAL_RBR_START_Y              ( 2*YARDS)
#define NORMAL_RBL_START_X              (-5*YARDS)
#define NORMAL_RBL_START_Y              (-2*YARDS)



#define NORMAL_OFF_LINE_FORMATION       \
		RT,             OFF_LINE_START_X, (3*YARDS),            /*      RT      */      \
		LT,             OFF_LINE_START_X, (-3*YARDS),           /*      LT      */  \
		RG,             OFF_LINE_START_X, (1.5*YARDS),            /*      RG      */  \
		LG,             OFF_LINE_START_X, (-1.5*YARDS),           /*      LG      */  \
		CENTER,         NORMAL_C_START_X , (0*YARDS)            /* Center       */

/******** DEFENSE *********/
//        Assumes Offenses Left-Right Perspective

#define NORMAL_34LE_START_X       (1*YARDS)
#define NORMAL_34LE_START_Y       (-2*YARDS)
#define NORMAL_34RE_START_X       (1*YARDS)
#define NORMAL_34RE_START_Y       (2*YARDS)
#define NORMAL_34NG_START_X       (1*YARDS)
#define NORMAL_34NG_START_Y       (0*YARDS)
#define NORMAL_43LT_START_X       (1*YARDS)
#define NORMAL_43LT_START_Y       (-1.25*YARDS)
#define NORMAL_43RT_START_X       (1*YARDS)
#define NORMAL_43RT_START_Y       (1.25*YARDS)
#define NORMAL_43LE_START_X       (1*YARDS)
#define NORMAL_43LE_START_Y       (-3.75*YARDS)
#define NORMAL_43RE_START_X       (1*YARDS)
#define NORMAL_43RE_START_Y       (3.75*YARDS)

#define NORMAL_MLB_START_X        (5*YARDS)
#define NORMAL_MLB_START_Y        (0*YARDS)
#define NORMAL_LOLB_START_X       (2.5*YARDS)
#define NORMAL_LOLB_START_Y       (-4.5*YARDS)
#define NORMAL_ROLB_START_X       (2.5*YARDS)
#define NORMAL_ROLB_START_Y       (4.5*YARDS)
#define NORMAL_LILB_START_X       (4*YARDS)
#define NORMAL_LILB_START_Y       (-2*YARDS)
#define NORMAL_RILB_START_X       (4*YARDS)
#define NORMAL_RILB_START_Y       (2*YARDS)

#define NORMAL_LCB_START_X        (7*YARDS)
#define NORMAL_LCB_START_Y        (-NORMAL_WR_START_Y)
#define NORMAL_RCB_START_X        (7*YARDS)
#define NORMAL_RCB_START_Y        (NORMAL_WR_START_Y)
#define NORMAL_SS_START_X         (11*YARDS)
#define NORMAL_SS_START_Y         (NORMAL_TE_START_Y)
#define NORMAL_FS_START_X         (14*YARDS)
#define NORMAL_FS_START_Y         (-3*YARDS)
#define NORMAL_NB_START_X         (11*YARDS)
#define NORMAL_NB_START_Y         (-NORMAL_TE_START_Y)
#define NORMAL_DB_START_X         (14*YARDS)
#define NORMAL_DB_START_Y         (3.5*YARDS)

#endif	//=======================================================









/*****************		End of file:  FBFORM_NUMs.h  **********************/
