#ifndef _FB_EQU_H
#define _FB_EQU_H
/**************************************************************


					FB_GEQU.H

	AUTHOR: M. Knauer				Start Date: 3/22/95
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains all GLOBAL equates for Football.

	It is an INCLUDED file.

	Also see FBEQU.h  which is mainly AI stuff.

**************************************************************/



/*  Prototypes needed for AI clock stuff  */

void StopGameClock(void);		// strictly AI
void StartGameClock(void);
void PauseAllClocks(void);      // "Pause" = human control
void UnPauseAllClocks(void);
void FreezeAllClocks(void);		// "Freeze" = game(CPU) control
void UnFreezeAllClocks(void);
void InitPlayClock(void);	// called at beginning of play call-sets to 25 sec AND starts it
void StartPlayClock(void);	// actually starts play call clock
BOOL GameClockRunning(void);	// a Question


UWORD SecondsLeftInQuarter(void);
UWORD SecondsOnPlayClock(void);



/*  Prototypes for AI-Play Call interface	*/

// called once both teams have selected their play (by Play Calling module)
void StartPlayAI(void);

BOOL OkayToStartPlayCall(void);
	// called by PlayCall Screen to see if time to init
	// returns TRUE (non-zero) if okay for play call screen to start

BOOL OkayToLoadPlayCall(void);
	// called by PlayCall Screen to see if time to init
	// returns TRUE (non-zero) if okay for play call screen to start loading

/*	used by PCall Module to see if have to abort (if delay or EOQ) */
BOOL AbortPlayCalling(void);

BOOL NeedToInitPlayCall(void);	// re-init if TimeOut during PC
void PlayCallHasBeenInited(void); // call after PCall inited



void OverrideEditedSetting(WORD team01,WORD newsetting);



BOOL PlayHappening(void); // returns TRUE if Play is happening
WORD QuarterHasEnded(void);	// return 0 if Quarter not ended else Quarter num

/*  below is encapsulation for PSX calling
		 - tells AI to start again after pause between quarters	*/
void OkayToStartNewQuarter(void);

void ResetPlayCallInit(void);	// called by AI engine
void PlayCallIsInited(void);		// called by Play Call
BOOL HasPlayCallBeenInited(void);		// called by Play Call



/*****  prototypes for Instant RePlay  *******/

void InitInstantReplay(void);
void CleanUpInstantReplay(void);
BOOL OKForInstantReplay(void);



/*****  prototypes for TimeOuts (from Pause Screen)  *******/

WORD ControllerToTeam(WORD controllernum);	// returns teamslot (-1,0,1) based on controller num
BOOL LegalForTimeOut(WORD teamslotnum);		// checks for teamslot == -1
BOOL LegalAndProperForTimeOut(WORD teamslotnum);  // screens out clock running
WORD TimeOutDisplayValue(WORD teamslotnum);	// display nothing if -1, else num
void CallTimeOut(WORD teamslotnum);	// will stop clock





/******   General  Equates  ***********************************/


#define	NUM_PLAYERS_ON_FIELD			22

#define CLOCKS_TICKS_PER_SECOND		45		// for accelerated clock
#define	INITIAL_PLAY_CLOCK_TICKS	(40*CLOCKS_TICKS_PER_SECOND)
#define	PAT_PLAY_CLOCK_TICKS		(25*CLOCKS_TICKS_PER_SECOND)

#define MAX_POINTS_IN_BALL_ARC 		128

#define	MAX_DEFFORMS_FOR_AUDIBLES	5
#define	MAX_OFFFORMS_FOR_AUDIBLES	13
#define	MAX_PLAYS_PER_AUDIBLEFORM	3



#define MAX_CREATED_PLAYERS	40
#define CREATED_PLAYER_START_INDEX	0x4000


extern UWORD BallArc[MAX_POINTS_IN_BALL_ARC][3];


extern BYTE PositionFormToPCFormTable[];	// in FBCPUPC.c

// default audibles in FBPlays.c	(off = 13x3, def = 5x3)
extern UBYTE OffensiveAudibles[MAX_OFFFORMS_FOR_AUDIBLES][MAX_PLAYS_PER_AUDIBLEFORM];
extern UWORD DefensiveAudibles[MAX_DEFFORMS_FOR_AUDIBLES][MAX_PLAYS_PER_AUDIBLEFORM];


BOOL DefAudibleIsActive(void);	// encapsulation for graphic/AI engines
BOOL OffAudibleIsActive(void); 	// encapsulation for graphic/AI engines


/***  "NumFramesPerPlayerGraphic[]" (in FBAIDATA.C), among other things,
	 indexed by the	following enums

*/

#define pgmac(abc,xyz)  xyz,

enum PlayerGraphicStates {	/* PG_ stands for "PlayerGraphic"	*/

	#include "FBPGData.h"
	MAX_PG_GRAPHICS
};
#undef pgmac


#define	PG_STAND_NUM	PG_SHUFFLE_NUM
#define	PG_TACKLE_NUM	PG_FALLONBELLY_NUM
#define	FIRST_REF_ANIM	REF_RUNNING_NUM



#define aipgmac(abc,xyz)  abc##_NUM,

enum PlayerAIGraphicStates {	/* PG_ stands for "PlayerGraphic"	*/

	#include "FBAIGrap.h"
	MAX_AI_GRAPHICS				// last enum  used as length

};
#undef aipgmac


extern void *AIToGraphicTable[];




#define OPTION_ON	0
#define OPTION_OFF	1

/* some options are "double duty" - used by home/away - index [XX+teamslot] */
/* all volumes are 0-5*/

#define gameoptions_stuff	\
	gameoptmacro(GAME_OPTNS_STADIUM,0)	\
	gameoptmacro(GAME_OPTNS_FIELD_TYPE,0)	\
	gameoptmacro(GAME_OPTNS_WEATHER,0)	\
	gameoptmacro(GAME_OPTNS_WIND,0)	\
	gameoptmacro(GAME_OPTNS_WIND_DIR,0)	\
	gameoptmacro(GAME_OPTNS_SCRIMMAGE_MARKER,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_1STDOWN_MARKER,OPTION_ON)	\
\
	gameoptmacro(GAME_OPTNS_QTR_LENGTH,1)\
	gameoptmacro(GAME_OPTNS_DIFFICULTY,1)	\
	gameoptmacro(GAME_OPTNS_GAME_SPEED,1)	\
	gameoptmacro(GAME_OPTNS_FUMBLES,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_HUMAN_EFFECT,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_SHOW_NAMES,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_SCORE_INDICATOR,OPTION_ON)	\
\
	gameoptmacro(GAME_OPTNS_PLAY_CALL_METHOD,0)	\
	gameoptmacro(GAME_OPTNS_PLAY_CALL_METHOD_AWAY,0)	\
	gameoptmacro(GAME_OPTNS_REC_ICONS,0)	\
	gameoptmacro(GAME_OPTNS_REC_ICONS_AWAY,0)	\
	gameoptmacro(GAME_OPTNS_PASS_ARC,0)	\
	gameoptmacro(GAME_OPTNS_PASS_ARC_AWAY,0)	\
	gameoptmacro(GAME_OPTNS_AUTO_HANDOFF,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_AUTO_HANDOFF_AWAY,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_AUTO_QB,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_AUTO_QB_AWAY,OPTION_ON)	\
\
	gameoptmacro(GAME_OPTNS_DELAY_OF_GAME,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_INTLGROUNDING,OPTION_ON)   \
	gameoptmacro(GAME_OPTNS_OFFSIDES,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_PASS_INTERFERENCE,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_FALSE_START,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_PFOULS,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_HOLDING,OPTION_ON)	\
\
	gameoptmacro(GAME_OPTNS_ROUGH_PASSER,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_ROUGH_KICKER,OPTION_ON)	\
\
	gameoptmacro(GAME_OPTNS_ANNOUNCER_VOL,5)\
	gameoptmacro(GAME_OPTNS_REFEREE_VOL,5)	\
	gameoptmacro(GAME_OPTNS_CROWD_VOL,5)	\
	gameoptmacro(GAME_OPTNS_SFX_VOL,5)	\
	gameoptmacro(GAME_OPTNS_MUSIC_VOL,5) \
\
	gameoptmacro(GAME_OPTNS_CREDITS,0)	\
	gameoptmacro(GAME_OPTNS_VIEW_TEAM,1) \
	gameoptmacro(GAME_OPTNS_LOAD_EDITED_PLAYS,1)\
	gameoptmacro(GAME_OPTNS_CONTROLS,0)   \
	gameoptmacro(GAME_OPTNS_CREATE_TEAM,1)   \
	gameoptmacro(GAME_OPTNS_SEASON_LEN,0) \
	gameoptmacro(GAME_OPTNS_VIEW_MOVIES,OPTION_ON)\
\
	gameoptmacro(GAME_OPTNS_JPAD_CONFIG,0)	\
	gameoptmacro(GAME_OPTNS_JPAD_CONFIG_AWAY,0)	\
	gameoptmacro(GAME_OPTNS_FATIGUE,OPTION_ON)	\
	gameoptmacro(GAME_OPTNS_AUTO_SUB,OPTION_ON)	\

#define MAX_JP_CONFIGS	10


/*player options return arrays and the defines - moved to FBGEQU.H */
/*use those defines to reach the appropriate slots in the PlayerOptions
for example:GameOptions[WEATHER] to get to the weather*/

#define	gameoptmacro(enum,initvalue) enum,

enum gameoptions {

	gameoptions_stuff		// a huge define

	MAX_NUM_GAME_OPTNS		// ALWAYS  last

};
#undef gameoptmacro


#define  NoFumbleMACRO	(GameOptions[GAME_OPTNS_FUMBLES] == OPTION_OFF)


/*
#define GAME_OPTNS_PLAY_CALL_METHOD    0
#define GAME_OPTNS_OFFENSIVE_INTERFACE 1
#define GAME_OPTNS_QTR_LENGTH          2
#define GAME_OPTNS_DIFFICULTY          3
#define GAME_OPTNS_FIELD_TYPE          4
#define GAME_OPTNS_WEATHER             5
#define GAME_OPTNS_FUMBLES             6
#define GAME_OPTNS_PASS_INTERFACE      7
#define GAME_OPTNS_SXF                 8
#define GAME_OPTNS_MUSIC               9
#define GAME_OPTNS_CONTROLS            10
#define	MAX_NUM_GAME_OPTNS				11
#define	MAX_NUM_GAME_OPTNS2				2		// team2 gets 2 choices
#define	NEW_MAX_NUM_GAME_OPTNS			12

#define GAME_OPTNS_OFFSIDES			11	// new one

  new ones yet to be implemented
#define GAME_OPTNS_STADIUM
#define GAME_OPTNS_AUTO_SUB
#define GAME_OPTNS_FATIGUE
#define GAME_OPTNS_HUMAN_EFFECT
#define GAME_OPTNS_SCRIM_MARKER
#define GAME_OPTNS_1ST_DOWN_MARKER
#define GAME_OPTNS_DELAY_OF_GAME
#define GAME_OPTNS_PERSONAL_FOULS
#define GAME_OPTNS_CLIPPING
#define GAME_OPTNS_ROUGH_PASSER
#define GAME_OPTNS_ROUGH_KICKER
#define GAME_OPTNS_OFFSIDES
#define GAME_OPTNS_INTERFERENCE
#define GAME_OPTNS_HOLDING
#define GAME_OPTNS_PASS_INDICATOR
#define GAME_OPTNS_SPEED
#define GAME_OPTNS_CROWD_VOL


*/

/*Valid values are:	8/5/96
GAME_OPTNS_PLAY_CALL_METHOD    0-formation 1-pass/run (2-formation 3-pass/run)
GAME_OPTNS_OFFENSIVE_INTERFACE 0-beg. 1-int. 2-adv.   (3-beg. 4-int. 5-adv.)
GAME_OPTNS_QTR_LENGTH          0-2min, 1-5 min 2-10 min 3-15 min
GAME_OPTNS_DIFFICULTY          0-easy 1-normal 2-hard
GAME_OPTNS_FIELD_TYPE          0-grass 1-2tone 2-turf 3-dometurf
GAME_OPTNS_WEATHER             0-normal 1-rain 2-snow
GAME_OPTNS_FUMBLES             0-on 1-off
GAME_OPTNS_PASS_INTERFACE      0-on 1-off
GAME_OPTNS_SXF                 0-on 1-off
GAME_OPTNS_MUSIC               0-on 1-off
GAME_OPTNS_CONTROLS            0-default 1-change
*/


#define	MAX_WEATHER_OPTIONS	3

/*******************************************************************

   Following are Play type designators which tell what the play does
	used by Play Calling stuff if Run/Pass play calling interface
	(these are found in the Play Structure

struct  play    {	as of 12/19/95 !!!!! (might have changed)
	WORD	PlayTypeDesignator;
	WORD    PlayInitRoutineNumber;
	WORD    FormationNumber;
	struct  script  Script[11];
};

	NOTE: (warning)  offensive plays use whole numbers
					defensive plays use bits!!!

------------------------------------------------------------------*/

#define	RUN_INSIDE      1
#define	RUN_OUTSIDE     2
#define	PASS_SHORT		3
#define	PASS_MEDIUM		4
#define	PASS_DEEP       5
#define	PASS_OPTION     PASS_MEDIUM
#define	PASS_ACTION     PASS_MEDIUM
#define	PASS_FLEA       PASS_DEEP

#define	RUN_OPTION      RUN_OUTSIDE
#define	SPECIAL_TEAMS   6
#define	TEST			7

#define	BLITZ            0x0100
#define ALL_PURPOSE      0x0200
#define STOP_RUN         0x0400
#define STOP_PASS_SHORT  0x0800
#define STOP_PASS_DEEP   0x1000

#define	SPECIAL_TEAMS_DEF 0x2000
#define KICKOFF          0x4000

#define	RUN_MIDDLE	RUN_INSIDE
#define STOP_PASS	STOP_PASS_SHORT
#define STOP_BOMB	STOP_PASS_DEEP



/* following used to tell if a play (based on it's formation) is
	offensive or defensive		*/

#define OFF_FORM	0
#define DEF_FORM	1
#define NO_FORM		2	// used for edited plays


enum playcallstatus {	// used to communicate between AI & graphic engine
	ZERO_HOLDER,
	PLAYCALL_GAME_OVER,
	PLAYCALL_HALF_OVER,
	PLAYCALL_QUARTER_OVER,
	PLAYCALL_EXPT_QUESTION,
	PLAYCALL_COP,			//COP = Change of Possession
	ABORT_PLAYCALL_SCREEN,	// here or less means NO play call screen
	BOTH_PLAYS_CALLED,
	OKAY_TO_LOAD_PLAYCALL_DATA,
	OKAY_TO_START_PLAYCALL,

};
#define	PLAYCALL_STALLED	PLAYCALL_COP	//anything less then this


enum extrapointstatus {
	EXTRA_POINT_KICK,
	EXTRA_POINT_2PT_MIDDLE,
	EXTRA_POINT_2PT_LEFT,
	EXTRA_POINT_2PT_RIGHT,
};


/*** following MUST be called by graphic (driver) engine	*/
void PowerOnAIInitialization(void);
void InitGameData(void);
void InitGameDataPart2(void);
void AllocAIMemory(void);
void DoAI(void);		// loop function
void HandleAISound(void);	/* crowd and sideline (sound loop function)-*/
void FreeAIMemory(void);



WORD AIIsStalled(void);	// return 0 if not stalled else PlaycallStatus
void UnstallAI(void);


void AnimationsLoaded(void);
void AnimationsNotLoaded(void);
void CameraOnScoreBoard(void);
WORD OkToDisplayAITextInfo(void);

void EditedPlaysAreNowLoaded(WORD team01);

WORD GetTrueBallArcCounter(void);	// kicking arc cursor
WORD GetTrueMaxPointsInBallCursor(void);


BYTE *GetPlayName(WORD playnum); // screens special case of Extra points or field goals

void LoadPlayerDataForGame(void);	// revised 4/11/97 for new season data base
void LoadPlayerData(void);	// revised 4/11/97 for new season data base


void LoadLeaguePlayerData(void);	//sets up  LeaguePlayersPtr
void FreeLeaguePlayerData(void);	// encapusaltion


/**********  Player Info  stuff	****************************/

WORD GetJerseyNum(WORD plyrslotnum);
BYTE *GetPlayerName(WORD plyrslotnum);
WORD GetPlayerWeight(WORD plyrslotnum);
WORD GetPlayerHeight(WORD plyrslotnum);	// inches

BOOL PlayerLeftHanded(WORD plyrslotnum);
BOOL PlayerWearingGloves(WORD plyrslotnum);
WORD GetPlayerSkinColor(WORD plyrslotnum);	// 0-3

/*  following takes into account diff. position with no Agil rating
		 and weather conditions	*/
WORD GetPlayerAgility(WORD plyrslotnum);
WORD GetPlayerRunBlockRating(WORD plyrslotnum);
WORD GetPlayerPassBlockRating(WORD plyrslotnum);
WORD GetPlayerTackleRating(WORD plyrslotnum);
WORD GetPlayerRushRating(WORD plyrslotnum);
WORD GetPlayerArmStrength(WORD plyrslotnum);
WORD GetPlayerFootStrength(WORD plyrslotnum);



/**********  SATURN Announcer phrases	****************************/

enum saturnredbookphrases {

WELCOME_TO_PHRASE = 1,  //track 00 reserved - 1 welcome phrase per team

END_Q1_PHRASE = WELCOME_TO_PHRASE+30,
END_Q2_PHRASE,
END_Q3_PHRASE,

FIRST_GOAL_PHRASE,
FIRST_DOWN_PHRASE,
SECOND_GOAL_PHRASE = FIRST_DOWN_PHRASE+4,
SECOND_DOWN_PHRASE,
THIRD_GOAL_PHRASE = SECOND_DOWN_PHRASE+14,
THIRD_DOWN_PHRASE,
FOURTH_GOAL_PHRASE = THIRD_DOWN_PHRASE+14,
FOURTH_DOWN_PHRASE,

INCOMPLETE1_PHRASE = FOURTH_DOWN_PHRASE+14,
INCOMPLETE2_PHRASE,
COMPLETE_PHRASE,
GAIN_PHRASE,
LONG_GAIN_PHRASE,
LOSS_PHRASE,
SHORT_GAIN_PHRASE,
NO_GAIN_PHRASE,
SACK_PHRASE,

//PUNT_BLOCKED_PHRASE,
//FB_BLOCKED_PHRASE,
//PUNT_OOB_PHRASE,
//KICKOFF_OOB_PHRASE,
KICK_GOOD_PHRASE,
KICK_NO_GOOD_PHRASE,

TIMEOUT_PHRASE,
TOUCHDOWN_PHRASE,

INTERCEPTION_PHRASE,
LAST_PHRASE		// just to see how many
};






enum TeamAbbreviations{

KC,  	// 0
SD,
SEA,
DEN,
OAK,

PIT,	// 5
CIN,
HOU,
BAL,
JAX,

BUF,	// 10
IND,
MIA,
NE,
NYJ,

SF,		// 15
ATL,
STL,
CAR,
NO,

GB,		// 20
DET,
CHI,
MIN,
TB,

DAL,	// 25
PHI,
WAS,
NYG,
ARI,

FREE_AGENTS,	//30 (free agents are "dummy" team for season only
AFC97,
NFC97,
AFC96,
NFC96,


CHI63,	//35
CLE64,
GB66,
NYJ68,
KC69,

DAL71,	//40
MIA72,
PIT74,
OAK76,
PIT78,

WAS82,	//45
OAK83,
CHI85,
NYG86,
SF89,

BUF90,	//50
WAS91,
DAL92,
SF94,
GB96,


JIMMYS_TEAM, 	//55

MAX_NUM_TEAMS	//56	// always LAST
};


#define	NUM_TEAMS_IN_LEAGUE	30


#define NUM_PENALTY_TEXT_BUFFERS 6
#define ACCEPTED_BUFFER_START	0
#define DECLINED_BUFFER_START	3


enum activepenaltytypes {	// values for ActivePenalty
	PENALTY_NOT_ACTIVE,
	ACCEPT_PENALTY,
	DECLINE_PENALTY
};

extern BYTE PenaltyTextBuffer[NUM_PENALTY_TEXT_BUFFERS][50];
void PenaltyHasBeenResolved(void);	// encapsulation for graphic engine


/************************** End of File - FB_GEQU.H    *****************/

#endif