/**************************************************************


					FBPDATA.C

	INITIAL AUTHOR: M. Knauer       Start Date: 10/2/95

	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file data for all the players including names and abilities.

	NOTE: there are 40 players on each team, however these players
	are layed out so they can be on anyteam.

**************************************************************/

	#include  "fbequ.h"


#define NEWPLAYERID	0x12a4

//#define PLAYERDATA	struct inputplayerdata  = {NEWPLAYERID,
#define PLAYERDATA	{NEWPLAYERID,

#define PHYSSIZE(x,y)	(x-56)<<4+y // height (in inches), width (0-15)

/****

#define	FIRST_NAME_LENGTH	10
#define	LAST_NAME_LENGTH	12

struct specificplayerdata {
	UBYTE FirstName[FIRST_NAME_LENGTH];
	UBYTE LastName[LAST_NAME_LENGTH];
	UBYTE SkinColor;
	UBYTE JerseyNum;
	UBYTE PhysSize;	// low nibble is width, high nibble is height offset
	UBYTE Misc[3];		// WORD boundaries, please
	struct playerabilities Ratings;
};
struct playerabilities{
	UBYTE	Strength;
	UBYTE	Speed;
	UBYTE	Acceleration;
	UBYTE	Reaction;
};


****/


struct inputplayerdata {
	UWORD playermarker;
	UBYTE *FirstName;
	UBYTE *LastName;
	UBYTE SkinColor;
	UBYTE JerseyNum;
	UBYTE Height;
	UBYTE Width;
	UBYTE Misc[2];		// WORD boundaries, please
	struct playerabilities Ratings;
};


enum skincolors {
	SKIN_WHITE,
	SKIN_TAN,
	SKIN_BROWN,
	SKIN_BLACK
};


struct inputplayerdata AllPlayerData[] = {

PLAYERDATA
"Joe"			// first name
,"Blow"			// last name
,SKIN_WHITE
,88				// jersey number
,72 			// height (in inches)
,5				// width (0-15)
,0              //unused
,0              //unused
,12				//strength(0-15)
,12				//speed(6-15)
,85				//acceleration (50-90)
,12				//reaction
},

PLAYERDATA
"Richard"			// first name
,"Head"			// last name
,SKIN_TAN
,87				// jersey number
,72 			// height (in inches)
,5				// width (0-15)
,0              //unused
,0              //unused
,12				//strength(0-15)
,12				//speed(6-15)
,85				//acceleration (50-90)
,12				//reaction
},

PLAYERDATA
"Joe B."			// first name
,"Blown"			// last name
,SKIN_BROWN
,88				// jersey number
,72 			// height (in inches)
,5				// width (0-15)
,0              //unused
,0              //unused
,12				//strength(0-15)
,12				//speed(6-15)
,85				//acceleration (50-90)
,12				//reaction
},

PLAYERDATA
"Dick"			// first name
,"Head"			// last name
,SKIN_BLACK
,87				// jersey number
,72 			// height (in inches)
,5				// width (0-15)
,0              //unused
,0              //unused
,12				//strength(0-15)
,12				//speed(6-15)
,85				//acceleration (50-90)
,12				//reaction
},

};	//end of AllPlayerData


#define MIN_HEIGHT	66	// 66 inches = 5'6"

/*******************************************************************

	RETURNS: ZERO if no errors
			else ERROR NUM

*******************************************************************/

#if 0

WORD CopyPlayer(WORD pnum,struct specificplayerdata *PDPtr)
{
struct inputplayerdata *inptr;
WORD i,j;

	inptr = &AllPlayerData[pnum%4];

	if(inptr->playermarker != NEWPLAYERID)
		return(1);

	for(i=0; i<FIRST_NAME_LENGTH; i ++)
		PDPtr->FirstName[i] = 0;
	i = 0;
	while( (j = *(inptr->FirstName+i)) != '\0' && i < FIRST_NAME_LENGTH+3)
		PDPtr->FirstName[i++] = j;

	if(i >=FIRST_NAME_LENGTH+1)
		return(2);		// illegal name length

	for(i=0; i<LAST_NAME_LENGTH; i ++)
		PDPtr->LastName[i] = 0;
	i = 0;
	while( (j = *(inptr->LastName+i)) != '\0' && i < LAST_NAME_LENGTH+3)
		PDPtr->LastName[i++] = j;

	if(i >=LAST_NAME_LENGTH+1)
		return(3);		// illegal name length


	if( (i=inptr->SkinColor) > 3)
		return(4);
	else
		PDPtr->SkinColor = i;

	i = inptr->Height;

	if(i < MIN_HEIGHT || i >= MIN_HEIGHT+16)
		return(5);
	i -= MIN_HEIGHT;

	j = inptr->Width;
	if(j >10)
		return(6);
	else
		PDPtr->PhysSize = (i<<4)+j;	// height in high nibble;

	PDPtr->Misc[0] = 0;
	PDPtr->Misc[1] = 0;
	PDPtr->Misc[2] = 0;


	i = inptr->Ratings.Strength;
	if(i==0 || i>15)
		return(7);
	else
		PDPtr->Ratings.Strength = i;

	i = inptr->Ratings.Speed;
	if(i<4 || i>15)
		return(8);
	else
		PDPtr->Ratings.Speed = i;


	i = inptr->Ratings.Acceleration;
	if(i < 30 || i > 150)
		return(9);
	else
		PDPtr->Ratings.Acceleration = i;

	i = inptr->Ratings.Reaction;
	if(i>100)
		return(10);
	else
		PDPtr->Ratings.Reaction = i;


	return(0);
}

#endif

/******************  End of file: FBPDATA.C    **********************/
