/**************************************************************


							FBEQU.H

	AUTHOR: M. Knauer						Start Date: 4/18/97
	Modify Date:


	Copyright 1997  GameTek, Inc.


	This file contains all equates for Football Penalties.

	It is an INCLUDED file.



	Define the major macro "PenaltyMacros"  which includes the
	re-definable macro penamacro (which is defined in this file
	as the penalty enums).

**************************************************************/

/*  NOTE:  penalties MUST be order from "best" to "worst" in case of
	multiple penalties on same team on same play - in which case chose
	the worst			*/

#define PenaltyMacros \
penmacro(NO_PENALTY,		 		 0,NORMAL_PENALTY,NO,				DELAY,DELAY_OF_GAME)	\
penmacro(DELAY_OF_GAME_PENALTY,		 5,NORMAL_PENALTY,DELAY OF GAME,	DELAY,DELAY_OF_GAME)	\
penmacro(FALSE_START_PENALTY,		 5,NORMAL_PENALTY,FALSE START,		OFFSIDES,FALSE_START)	\
penmacro(OFFSIDES_PENALTY,			 5,NORMAL_PENALTY,OFFSIDES,			OFFSIDES,OFFSIDES) 		\
penmacro(ENCROACHMENT_PENALTY,		 5,NORMAL_PENALTY,ENCROACHMENT,		OFFSIDES,ENCROACH)	\
penmacro(PASS_INTERFERENCE_PENALTY,	 0,AUTO_FIRST_DOWN,PASS INTERFERENCE,	WAVEARMS,INTERFERENCE)	\
penmacro(HOLDING_PENALTY,			10,SAFETY_IN_EZ,HOLDING,		WAVEARMS,OFFSIDES)		\
penmacro(DEF_HOLDING_PENALTY,		 5,AUTO_FIRST_DOWN,DEFENSIVE HOLDING,	WAVEARMS,OFFSIDES)		\
penmacro(PFOUL_PENALTY,				15,AUTO_FIRST_DOWN,PERSONAL FOUL,		WAVEARMS,PERSONAL)		\
penmacro(INT_GROUNDING_PENALTY,		 0,(SAFETY_IN_EZ+LOSS_OF_DOWN),INTENTIONAL GROUNDING,WAVEARMS,GROUNDING) \
penmacro(GROIN_KICK_PENALTY,		15,AUTO_FIRST_DOWN,ILLEGAL KICK TO THE GROIN,WAVEARMS,PERSONAL)


/* NOTE: Int. Grounding is actually -10 yards or where ball thrown from
	- whichever is less		*/

#define	NORMAL_PENALTY		0x00
#define	AUTO_FIRST_DOWN		0x01	//in PenaltyType[pennum]
#define LOSS_OF_DOWN		0x02	//in PenaltyType[pennum]
#define SAFETY_IN_EZ		0x04	//in PenaltyType[pennum] and AcceptPenaltyMode
#define PENALTY_NEED_COP    0x08	//in AcceptPenaltyMode


#define  penmacro(enum,yards,pentype,string,refanim,refsfx)	enum,
enum penaltyenums {
	PenaltyMacros		// penalty macros defined in fbequ.h
	MAX_PENALTIES
};
#undef penmacro



/****** prototypes		***********************************/

//void SetDefOffsides(WORD offsidestype);	// called if collision before snap OR past LOS at snap
void InitDefPenaltyParameters(UWORD pnum,UWORD penaltynum,UWORD where);
void InitOffPenaltyParameters(UWORD pnum,UWORD penaltynum,UWORD where);


/**************************	End of File: FBPenal.h   **************/
