/**************************************************************

					FBPGDATA.H

	AUTHOR: M. Knauer				Start Date: 9/27/95
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains PLAYER  GRAPHIC Data.

	It is an INCLUDED file.

	It uses the concept of redefinable macros to be included in two
	places:

	1) in an enum table
	2) in an array with the max num of frames per animination

	This way all the data about player graphics is here and we can
	use it different places through macro redefinition, and if we
	need to change it, we just change it one place(i.e. here) and it's
	changed everywhere.


**************************************************************/

//	1st num is frame per anim, second is the actual graphics num
//	pgmac(2,PG_GETREADY2_NUM) 	/* feet together (in huddle)			*/
//	pgmac(4,PG_QBREADY_NUM)		/* QB behind Center - ready to get ball	*/
//	pgmac(4,PG_3PTSTANCE_NUM)	/*  offense	*/

	//--- #0 ---
	pgmac(10,PG_RUNNING_NUM)
	pgmac(10,PG_WALKING_NUM)
//	pgmac(7,PG_PASSING_NUM)		//was 12, changed 2/12/96 //OLD
	pgmac(9,PG_PASSING_NUM)		//
	pgmac(2,PG_GETREADY1_NUM)	// feet apart ( one ahead of the other - W.R.)	*/

	pgmac(5,PG_4PTSTANCE_NUM)  	/*  defense	*/

	//--- #5 ---
//	pgmac(6,PG_BACKPEDAL_NUM)	//old
	pgmac(8,PG_BACKPEDAL_NUM)
//	pgmac(6,PG_BACKPEDAL_WBALL_NUM)	//old
	pgmac(7,PG_BACKPEDAL_WBALL_NUM)
	pgmac(1,PG_QBPITCH_NUM)		//, right
//	pgmac(4,PG_QBPITCH_RIGHT_NUM)		//, left
//	pgmac(5,PG_FALLONBELLY_NUM)
	pgmac(6,PG_FALLONBELLY_NUM)
	pgmac(5,PG_FALLONBELLY2_NUM)	
//	pgmac(5,PG_FALLONBELLY3_NUM)	
	//--- #10 ---
	pgmac(5,PG_FALLONBACK_NUM)

//	pgmac(4,PG_BLOCKING_NUM)	// blocker AND blockee
//	pgmac(7,PG_BLOCKING_NUM)	// blocker AND blockee
	pgmac(6,PG_BLOCKING_NUM)	// blocker AND blockee
	pgmac(6,PG_DIVE_NUM)
	pgmac(5,PG_GETUPFROMONBACK_NUM)
//	pgmac(3,PG_HANDSUP_NUM)	//Old
	pgmac(5,PG_HANDSUP_NUM)

	//--- #15 ---
//	pgmac(6,PG_KICKING_NUM)	//old
	pgmac(9,PG_KICKING_NUM)
//	pgmac(8,PG_PUNTING_NUM)	//old
	pgmac(10,PG_PUNTING_NUM)
//	pgmac(4,PG_FGHOLDER_NUM)	//old
	pgmac(5,PG_FGHOLDER_NUM)
	pgmac(12,PG_SPIKEBALL_NUM)	// any TD celebration by player who scored

	pgmac(3,PG_SHUFFLE_NUM)		//, (and STAND)
	pgmac(10,PG_RUNNINGWITHBALL_NUM)
	pgmac(2,PG_SHUFFLEWITHBALL_NUM)	//,(and STAND)
//	pgmac(10,PG_RUNNINGCATCH_NUM)	//Old
	pgmac(5,PG_RUNNINGCATCH_NUM)

	pgmac(1,PG_LEANRUN_NUM)
	pgmac(3,PG_RUNNINGHEADTURN_NUM)
	pgmac(3,PG_QBPLAYCALL_NUM)

	pgmac(2,PG_DIVEBALL_NUM)	//  
	pgmac(1,PG_ROLL_NUM)	//  
//	pgmac(0,PG_STAND_NUM)	//  
	pgmac(6,PG_SIDESTEP_NUM)	//  
	pgmac(6,PG_BURST_NUM)	//  
	pgmac(2,PG_QBSLIDE_NUM)	//  
	pgmac(3,PG_JUMPCATCH_NUM)	//  
	pgmac(1,PG_RECEIVERSTANCE_NUM)	//  
	pgmac(3,PG_DEFENSE_PRESNAP1_NUM)	//  
	pgmac(3,PG_DEFENSE_PRESNAP2_NUM)	//  
	pgmac(6,PG_DEFENSE_POSTTACKLE_NUM)	//  
	pgmac(1,PG_HANDOFF_NUM)	//  
	pgmac(3,PG_STANDINGCATCH_NUM)	//  
	pgmac(4,PG_COINTOSS_NUM)	//  

// ---- Referee Animations ----
	pgmac(8,REF_RUNNING_NUM)
	pgmac(6, REF_COINTOSS_NUM)      // 
	pgmac(1, REF_STANDING_NUM)      // 
	pgmac(3, REF_TURNING_NUM)       // 
	pgmac(2, REF_GOHOME_NUM)       // 
	pgmac(3, REF_TOUCHDOWN_NUM)     // 
	pgmac(1, REF_SAFETY_NUM)       // 
	pgmac(2, REF_PERSONAL_FOUL_NUM) // 
	pgmac(5, REF_CLIPPING_NUM)      // 
	pgmac(4, REF_ROUGHING_PASSER_NUM)       // 
	pgmac(3, REF_ROUGHING_KICKER_NUM)       // 
	pgmac(5, REF_PENALTY_REFUSED_NUM)       // 
	pgmac(3, REF_OFFSIDE_NUM)       // 
	pgmac(4, REF_INTERFERENCE_NUM)  // 
	pgmac(3, REF_INELLIGIBLE_RCVR_NUM)      // 
	pgmac(3, REF_ILLEGAL_HANDS_NUM) // 
	pgmac(5, REF_FALSE_START_NUM)   // 
	pgmac(1, REF_DELAY_NUM)       // 
	pgmac(9, REF_1STDOWN_NUM)       // 

/* as of 1/12/96 the following is true (in FBGEQU.H)	*/
//#define	PG_STAND_NUM	PG_SHUFFLE_NUM
//#define	PG_TACKLE_NUM	PG_FALLONBELLY_NUM

//#define	FIRST_REF_ANIM REF_RUNNING_NUM

/******************	End of file: FBPGDATA.H  ***************************/

