/***********************************************************************


						FBPlays.H

	PROGRAMMER AUTHOR: M. Knauer       Start Date: 4/6/95
	PLAY DESIGNER: Bobby "The" King

	Modify Date: All the time


	Copyright 1995  GameTek, Inc.


	This file is an  INCLUDE file detailing all plays and their scripts.

	NOTE: the plays just happen to be in order based on the formations,
	although all code is written NOT to make this asumption.

***********************************************************************/


/*  following used as parameters to STATES in player SCRIPTS	*/
#define DEF_LINE_NO_BLITZER	0
#define DEF_LINE_BLITZER	1




enum  ThePlaysNUMs  {

	GoalLineOptionPassNUM,
	GoalLineQBSneakNUM,
	GoalLineFBDiveNUM,

	GoalLineNakedBootlegNUM,
	GoalLineHBLeapNUM,
	GoalLineGoalLineFloodNUM,

	GoalLineTackleEligibleNUM,
	GoalLineEndSweepNUM,
	GoalLineCrossBlockNUM,

	GoalLinePAFadeNUM,
	GoalLineHBPowerNUM,
	GoalLineHBTrapNUM,

#if NEWPLAYS1
	GoalLineHBDiveNUM,
	GoalLineWishbonePANUM,
	GoalLineFullHouseSweepNUM,
#endif




/* 12 **************************************/

	WishBoneFBOffTackleNUM,
	WishBoneRollOutNUM,
	WishBoneTripleOptionNUM,

	WishBonePowerHBDiveNUM,
	WishBoneHBScreenNUM,
	WishBoneStudentBodySweepNUM,

	WishBone10YardCurlNUM,
	WishBoneMisdirectionNUM,
	WishBonePASeemNUM,

	WishBoneQuickPitchNUM,
	WishBoneTEBombNUM,
	WishBoneWrapAroundDrawNUM,

#if NEWPLAYS1
	WishBoneEx1,
	WishBoneEx2,
	WishBoneEx3,
#endif

/* 24 **************************************/

	PowerIFBOffTackleNUM,
	PowerIRollOutNUM,
	PowerIPitchSweepNUM,

	PowerIPowerHBDiveNUM,
	PowerIHBScreenNUM,
	PowerIDoubleOptionNUM,

   PowerI10YardCurlNUM,
	PowerIFBMisdirectionNUM,
	PowerIPASeemNUM,

	PowerIFBQuickPitchNUM,
	PowerITEBombNUM,
	PowerIWrapAroundDrawNUM,


#if NEWPLAYS1
	PowerIEx1,
	PowerIEx2,
	PowerIEx3,
#endif


/* 36 **************************************/

	NearFarHBOffTackleNUM,
	NearFarRollOutScrambleNUM,
	NearFarPitchSweepNUM,

	NearFarPowerHBRunNUM,
	NearFarFBScreenNUM,
	NearFarFBSweepNUM,

	NearFar10YardCurlNUM,
	NearFarHBMisdirectionNUM,
	NearFarPASeemNUM,

	NearFarFBQuickPitchNUM,
	NearFarTEBombNUM,
	NearFarWrapAroundDrawNUM,

#if NEWPLAYS1
	NearFarFBCounterSlantNUM,
	NearFarCornerPostNUM,
	NearFarQBWaggleNUM,
#endif

/* 48 **************************************/

	ISlotFleaFlickerNUM,
	ISlotPACrossesNUM,
	ISlotHBRunMiddleNUM,

	ISlotBombNUM,
	ISlotFBPowerNUM,
	ISlotPAReverseNUM,

	ISlotCornerFadeNUM,
	ISlotQBDrawNUM,
	ISlotTEFlyNUM,

	ISlotTEScreenNUM,
	ISlotCrackBackNUM,
	ISlotCenterTrapNUM,

#if NEWPLAYS1
	ISlotSlantCrossNUM,
	ISlotPickPassNUM,
	ISlotFBDiveNUM,
#endif


/* 60 **************************************/

	SingleBackLeadPushNUM,
	SingleBackShortPostNUM,
	SingleBackPACrossNUM,

	SingleBack10YardCurlsNUM,
	SingleBackSweepNUM,
	SingleBackRollOutFloodNUM,

	SingleBackWrapAroundDrawNUM,
	SingleBackScreenNUM,
	SingleBackPABootLegNUM,

	SingleBackTECornerNUM,
	SingleBackCounterPitchNUM,
	SingleBackPowerLeadNUM,

#if NEWPLAYS1
	SingleBackHBTossNUM,
	SingleBackQBWaggleNUM,
	SingleBackCornerPostNUM,
#endif


/* 72 **************************************/

	HBackQBDrawNUM,
	HBackPostCornerNUM,
	HBackReverseNUM,

	HBackCrackBackSweepNUM,
	HBackHBCenterTrapNUM,
	HBackHBFlatNUM,

	HBackFleaFlickerNUM,
	HBackPACrossesNUM,
	HBackQuickOutsNUM,

	HBackBombNUM,
	HBackStrongPitchNUM,
	HBackTEScreenNUM,

#if NEWPLAYS1
	HBackHBackFlatNUM,
	HBackPickPassNUM,
	HBackHBackRunNUM,
#endif


/* 84 **************************************/

	IFormCounterPullLeftNUM,
	IFormLongBombNUM,
	IFormHBOptionNUM,

	IFormFBPunchNUM,
	IFormStrongPitchNUM,
	IFormPARollOutNUM,

	IFormQuickSlantNUM,
	IFormQuickPitchWeakNUM,
	IFormOutAndUpsNUM,

	IFormHBScreenNUM,
	IFormPowerBlastNUM,
	IFormPAHBFlyNUM,

#if NEWPLAYS1
	IFormBounceOutsideNUM,
	IFormTEPostNUM,
	IFormPAChairNUM,
#endif


/* 96 **************************************/

	ProSetCounterPullLeftNUM,
	ProSetLongBombNUM,
	ProSetHalfBackOptionNUM,

	ProSetFBPunchNUM,
	ProSetStrongPitchNUM,
	ProSetPARollOutNUM,

	ProSetQuickSlantNUM,
	ProSetQuickPitchWeakNUM,
	ProSetOutAndUpsNUM,

	ProSetHBScreenNUM,
	ProSetPowerBlastNUM,
	ProSetPAHBFlyNUM,

#if NEWPLAYS1
	ProSetInsideSlantNUM,
	ProSetTEPostNUM,
	ProSetPAChairNUM,
#endif

/* 108 **************************************/

   WestCoastRollOutFloodNUM,
	WestCoastMotionPitchNUM,
	WestCoast10YardCurlNUM,

	WestCoastPassBackRightNUM,
	WestCoastReverseNUM,
	WestCoastPASlantNUM,

	WestCoastBombNUM,
	WestCoastNoBackPassNUM,
	WestCoastQBDrawNUM,

	WestCoastCBBurnerNUM,
	WestCoastShortPostNUM,
	WestCoastOffTackleNUM,

#if NEWPLAYS1
	WestCoastHBFlareNUM,
	WestCoastSprintHandOffNUM,
	WestCoastSlantClearNUM,
#endif


/* 120 **************************************/
	ShotGunRolloutOptionNUM,
	ShotGunSwingPassNUM,
	ShotGunRunGunWideNUM,

	ShotGunShortCrossNUM,
	ShotGunHBSnapNUM,
	ShotGunHailMaryNUM,

	ShotGunShovelPassNUM,
	ShotGunPoochKickNUM,
	ShotGunDeepCrossNUM,

	ShotGunWRScreenNUM,
	ShotGunDelayedDrawNUM,
	ShotGunShortClearoutNUM,

#if NEWPLAYS1
	ShotGunDelayTossNUM,
	ShotGunTEShortPostNUM,
	ShotGunClearFlatNUM,
#endif


/* 132 **************************************/

	TripsHBFlatNUM,
	TripsQBDrawNUM,
	TripsClearOutNUM,

	TripsSlantCrossNUM,
	TripsPitchAwayNUM,
	TripsPickPassNUM,

	TripsPACrossNUM,
	TripsCenterTrapNUM,
	TripsFleaFlickerNUM,

	TripsOutAndUnderNUM,
	TripsReverseNUM,
	TripsFlankerCurlNUM,

#if NEWPLAYS1
	TripsOffGuardNUM,
	TripsClearFlatNUM,
	TripsPostIsoNUM,
#endif


/* 144 **************************************/

   RunAndShootShortShootNUM,
	RunAndShootQBDrawNUM,
	RunAndShootMediumShootNUM,

	RunAndShootPACrossNUM,
	RunAndShootFleaFlickerNUM,
	RunAndShootCenterTrapNUM,

	RunAndShootLongShootNUM,
	RunAndShootBombNUM,
	RunAndShootPitchBackNUM,

	RunAndShootMotionFlatNUM,
	RunAndShootReverseNUM,
	RunAndShootHBCurlNUM,

#if NEWPLAYS1
	RunAndShootOffGuardNUM,
	RunAndShootHBFlatNUM,
	RunAndShootPostIsoNUM,
#endif


/* 156 **************************************/
	SpecialTeamsFakeFGRunNUM,
	SpecialTeamsFieldGoalNUM,
	SpecialTeamsFakeFGPassNUM,

	SpecialTeamsFakePuntRunNUM,
	SpecialTeamsPuntNUM,
	SpecialTeamsFakePuntPassNUM,

	SpecialTeamsQBDownBallNUM,
	SpecialTeamsQBKneelNUM,
	SpecialTeamsFakeQBDownBallNUM,



/*************  D E F E N S I V E      P L A Y S   *******************/


/*  **********************/

	DefGoalLineOutsideCrunchNUM,
	DefGoalLineGoalLineDeepNUM,
	DefGoalLineHousePartyNUM,

	DefGoalLineCheatLeftNUM,
	DefGoalLineShortZoneNUM,
	DefGoalLineCheatRightNUM,

	DefGoalLineSafetyGambleNUM,
	DefGoalLineFakeGambleNUM,
	DefGoalLineJamMiddleNUM,

	DefGoalLineGoalLineManNUM,
	DefGoalLineShadowBackfieldNUM,
	DefGoalLineOutsideContainNUM,

/*  **************************************/
	Def43OutsideInBlitzNUM,
	Def433DeepCornerNUM,
	Def43StuntBlitzNUM,

	Def43SSBlitzNUM,
	Def433DeepSafetyNUM,
	Def43FakeSSBlitzNUM,

	Def43ManToManNUM,
	Def43ZoneLeftNUM,
	Def43WideZoneNUM,

	Def43CombatZoneNUM,
	Def43TwoDeepZoneNUM,
	Def43LeftBlitzNUM,

/*  **************************************/
	Def34InsideBlitzNUM,
	Def34DeepCloudNUM,
	Def34StuntBlitzNUM,

	Def34FakeSafetyBlitzNUM,
	Def34DeepSkyNUM,
	Def34SafetyBlitzNUM,

	Def34StraightUpManNUM,
	Def34CBBlitzNUM,
	Def34CenterFieldZoneNUM,

	Def34SuicideBlitzNUM,
	Def34ShadowZoneNUM,
	Def34OutsideBlitzNUM,

/*  **************************************/
	DefNickelNickelPreventNUM,
	DefNickelNickelManNUM,
	DefNickelPreventBlitzNUM,

	DefNickelKeyOnHBNUM,
	DefNickelMiddleZoneNUM,
	DefNickelDoubleRightNUM,

	DefNickelBigDogEatNUM,
	DefNickelBumpAndRunNUM,
	DefNickelCornerCushionNUM,

	DefNickelQBSpyNUM,
	DefNickelFakeNickelBlitzNUM,
	DefNickelNickelBlitzNUM,

/*  **************************************/
	DefDimePreventNUM,
	DefDimeDimeManNUM,
	DefDimeFourDeepNUM,

	DefDimePreventRightNUM,
	DefDimeInsideBlitzNUM,
	DefDimeDoubleWidesNUM,

	DefDimeBlitzManNUM,
	DefDimeDoubleCBBlitzNUM,
	DefDimePreventLeftNUM,

	DefDimeFakeSafetyBlitzNUM,
	DefDimeBlitzZoneNUM,
	DefDimeTwoSafetyBlitzNUM,

/*  **************************************/
	DefSpecialDoubleOutsideNUM,
	DefSpecialPuntReturnNUM,
	DefSpecialPuntBlockNUM,

	DefSpecial11ManRushNUM,
	DefSpecialFGBlockNUM,
	DefSpecialWatchFakeNUM,


/*  Kickoff **************************************/


	KickoffReturnSpreadNUM,	// offense (receiving)
	KickoffReturnRegularNUM,
	KickoffReturnHandsNUM,

	KickoffStackLeftNUM,
	KickoffRegularNUM,			// defense (kickers)
	KickoffStackRightNUM,



/*  **************************************/
/*  24 Edited plays for Team 0 - HOme team
	 - reserve space for edited plays	*/

	T0Edit0NUM,		//DefDummyDummyNUM,
	T0Edit1NUM,		//DefBlockingNUM,
	T0Edit2NUM,		//DefHuddleTestNUM,
	T0Edit3NUM,

	T0Edit4NUM,
	T0Edit5NUM,
	T0Edit6NUM,
	T0Edit7NUM,

	T0Edit8NUM,
	T0Edit9NUM,
	T0Edit10NUM,
	T0Edit11NUM,

	T0Edit12NUM,		//DefDummyDummyNUM,
	T0Edit13NUM,		//DefBlockingNUM,
	T0Edit14NUM,		//DefHuddleTestNUM,
	T0Edit15NUM,

	T0Edit16NUM,
	T0Edit17NUM,
	T0Edit18NUM,
	T0Edit19NUM,

	T0Edit20NUM,
	T0Edit21NUM,
	T0Edit22NUM,
	T0Edit23NUM,


/*  **************************************/
/*  24 Edited plays for Team 1 - Away team
	 - reserve space for edited plays	*/

	T1Edit0NUM,		//DefDummyDummyNUM,
	T1Edit1NUM,		//DefBlockingNUM,
	T1Edit2NUM,		//DefHuddleTestNUM,
	T1Edit3NUM,

	T1Edit4NUM,
	T1Edit5NUM,
	T1Edit6NUM,
	T1Edit7NUM,

	T1Edit8NUM,
	T1Edit9NUM,
	T1Edit10NUM,
	T1Edit11NUM,

	T1Edit12NUM,		//DefDummyDummyNUM,
	T1Edit13NUM,		//DefBlockingNUM,
	T1Edit14NUM,		//DefHuddleTestNUM,
	T1Edit15NUM,

	T1Edit16NUM,
	T1Edit17NUM,
	T1Edit18NUM,
	T1Edit19NUM,

	T1Edit20NUM,
	T1Edit21NUM,
	T1Edit22NUM,
	T1Edit23NUM,


/***************************************/
/*  12 Offensive plays - Easter Eggs - used for debug plays */
	OffEaster0NUM,		//OfOffBlockingNUM,
	OffEaster1NUM,
	OffEaster2NUM, //	HuddleTestNUM,
	OffEaster3NUM,

	OffEaster4NUM,
	OffEaster5NUM,
	OffEaster6NUM,
	OffEaster7NUM,

	OffEaster8NUM,
	OffEaster9NUM,
	OffEaster10NUM,
	OffEaster11NUM,

/***************************************/
/*  12 Defensive plays - Easter Eggs - used for debug plays */
	DefEaster0NUM,		//DefDummyDummyNUM,
	DefEaster1NUM,		//DefBlockingNUM,
	DefEaster2NUM,		//DefHuddleTestNUM,
	DefEaster3NUM,

	DefEaster4NUM,
	DefEaster5NUM,
	DefEaster6NUM,
	DefEaster7NUM,

	DefEaster8NUM,
	DefEaster9NUM,
	DefEaster10NUM,
	DefEaster11NUM,


	MAXPLAYS                                /* always at end                */
};


#define MAX_OFF_PLAY_NUM   SpecialTeamsFakeQBDownBallNUM
#define	FIRST_KO_PLAY_NUM 	KickoffReturnRegularNUM
#define FIRST_DEF_PLAY_NUM  DefGoalLineOutsideCrunchNUM



/* a list of NUMBERS to be used as a reference to the actual address
	 of the script            */

enum SCRIPT_NUMS {
#define scmac(xyz)  xyz##NUM,

		#include	"FBScript.h"		// as actual function names

#undef	scmac
	MAX_SCRIPTS   /* always last  */
};

enum PlayInitRoutinesNumbers {
#define pimac(xyz)  xyz##NUM,

		#include	"FBpinit.h"		// as handles (intergers)

#undef pimac

};


/********************* End Of File - FBPlays.c   ********************/

