/**************************************************************


					FBPSDATA.H

	AUTHOR: Mike Knauer King			Start Date: 12/18/95

	Modify Dates:
		 4/18/97 --  new penalty resolving state

	Copyright 1995,1996,1997  GameTek, Inc.


	This file contains Play State data for Football AI.

	It uses our redefinable MACROs to group all Play STATE data
	here in this file and then change the MACRO depending on
	what data we need, such as enums, array data elements, or strings.


	It is an INCLUDED file.

**************************************************************/



/* 0*/ psmacro(PS_WaitForPlayStart)
/* 1*/ psmacro(PS_HuddleToLOS)
/* 2*/ psmacro(PS_CheckAtLOS) 	// all players made it to L.O.S.???
/* 3*/ psmacro(PS_Wait1)        // 1/4 sec if not Kickoff
/* 4*/ psmacro(PS_InitPlayShift)// start any shifts,				 "ready"
/* 5*/ psmacro(PS_Wait2)		// 1/2 sec
/* 6*/ psmacro(PS_SaySet)	  // when shifting over,can now go in motion "set"
/* 7*/ psmacro(PS_Wait3)	  // 1/2 sec
/* 8*/ psmacro(PS_Say1stHut)  //okay to hike now or any time after  "hut"

/* 9*/ psmacro(PS_PlayHappening)// it's happening
/*10*/ psmacro(PS_PlayOver)		// just ended (tackle, TD, etc.) - 1 tick
					// following is for EOP timing
/*11*/ psmacro(PS_Wait4a)		// 1/4 sec-@end init whistle/whistle phrase
/*12*/ psmacro(PS_Wait4b)		// 1/4 sec-@end init whistle
/*13*/ psmacro(PS_Wait4c)		// 1/4 sec-@end init whistle(50%)
/*14*/ psmacro(PS_Wait4d)		// 3/4 sec-@end trigger text display

/*15*/ psmacro(PS_Wait5)		// 1/2 sec
/*16*/ psmacro(PS_Wait5a)		// wait until penalty resolved
/*17*/ psmacro(PS_GetUpAfterPlay)// 1 tick - trigger CPU no huddle
/*18*/ psmacro(PS_Wait6)		 // 1 sec = a few seconds to return to huddle
/*19*/ psmacro(PS_Wait7)  // Waits for ref - BG load PCall or goto AIStalled
/*20*/ psmacro(PS_AfterEOP)      // 1 sec - @end no more IRP
/*21*/ psmacro(PS_ReturningToHuddle)    // 1 tick
/*22*/ psmacro(PS_InHuddle)		 // all players in huddle? check for PC done

/*23*/ psmacro(PS_AIStalled)	 // special non-sequential - state


/************************    End of File: FBPSDATA.H  *******************/