
/**************************************************************


					FBSTATS.C

	INITIAL AUTHOR: M. Knauer       Start Date: 6/3/95

	Modify Date:


	Copyright 1995,1996  GameTek, Inc.



	This file contains Stats stuff of the Football AI.



 ---  Disclaimer ------------------------------------------
 (i.e.-you better know the following if you are	working on the code)

	NOTE: All AI routines in the main AI loop refer to the
	"CURRENT PLAYER" (usually the loop counter of the AI loop 0-21 -
	often refered to by variable "gPNum")

	Any references to the players Data Stuctures are "hidden" in
	a macro starting wtih the initials CP. This allows us to
	more freely change the data structure (if needed) from the initial
	non-linked array based DS's (easier to debug) to a structure based
	data structure

	E.g.  CPXPos =  PlayerXPosition[gPNum]     (current as of 5/19/95)
		could be changed to
		 CPXPos =  Player[gPNum].XPosition
		or something like
		 initialize  	CP = Player[gPNum]
		 in macro		CPXPos =  CP->XPosition

**************************************************************/

	#include  "fbequ.h"
	#include  "fbRAM.h"			/* external VARs needed by this file	*/

	#include  "fbstats.h"
	#include  "fbplays.h"

	#include  "misc.h"

#ifdef __MSDOS__
//	#include  <stdio.h>			/* need for printf	*/
	#include  <conio.h>			/* need for getch	*/
	#include  <mem.h>			/* need for memset	*/
//	#include  <dos.h>			/* need for filefind	*/
	#include <dir.h>

	#define PRINT_UPDATE_STATS	1

extern WORD DisplayLevel;
#else

	#define PRINT_UPDATE_STATS	0	// no display on PSX

#endif

//void CopyBytes (BYTE *src , BYTE *dest , int count );

void FigureTeamQBRating(struct teamRAMstats *TRptr);	// all QBs on 1 team

extern  struct play ThePlays[];
extern  ULONG	QuarterTimes[5]; // time in Quarter based on a User Option

/*---------------------------------------------------------------------

				  S T A T S      I N F O

	(see FBStats.h)

	In keeping with our construct that all related data be in one place
	by using redefinable macros, here's all stats related stuff.
	Since stats are referenced in an array, the order below determines
	the index for ALL stats stuff - therefore if an emun is reordered,
	the string is also reordered automatically.

	In the StatsMacro, the first entry is used for enum,
	the second is the string.


	 -----------------------------------------------------------------*/

#if PC_ALWAYS_MODE		// not used by consoles
/***   All Strings associated with every stat	*****/
#define statsmacro(Enum,string,divsor,type)	#string,
BYTE *StatsNames[MAX_NUM_STATS_1TEAM] = {
	statsinfo				// see fbstats.h

};
#undef statsmacro
#endif

#define statsmacro(Enum,string,divsor,type)	divsor,
BYTE StatDivsorTable[MAX_NUM_STATS_1TEAM] = {
	statsinfo				// see fbstats.h

};
#undef statsmacro


#define statsmacro(Enum,string,divsor,type)	type,
BYTE StatTypeTable[MAX_NUM_STATS_1TEAM] = {
	statsinfo		// see fbstats.h

};
#undef statsmacro


/***   All Strings associated with every position (mostly abbreviations) **/
#define pposmacro(enum,stattype,pos_string,depth_string43,depth_string34)	#pos_string,

BYTE *PositionStrings[TOTAL_PLAYERS_ON_TEAM] = {
	PlayPosMacros
};
#undef pposmacro


#define pposmacro(enum,stattype,pos_string,depth_string43,depth_string34)	#depth_string43,
// USE WITH TEAMS USING 4-3 DEFENSE
BYTE *DepthChart43Strings[TOTAL_PLAYERS_ON_TEAM] = {
	PlayPosMacros
};
#undef pposmacro


#define pposmacro(enum,stattype,pos_string,depth_string43,depth_string34)	#depth_string34,
// USE WITH TEAMS USING 3-4 DEFENSE
BYTE *DepthChart34Strings[TOTAL_PLAYERS_ON_TEAM] = {
	PlayPosMacros
};
#undef pposmacro



/** table to convert a positon(0-46) to a stat set index	*/
#define pposmacro(enum,stattype,string,depth_string43,depth_string34)	stattype,

BYTE PositionToStatSetTable[TOTAL_PLAYERS_ON_TEAM] = {
	PlayPosMacros
};
#undef pposmacro



/********************************************************************

	Each position has a set of stats which are associated with it.
	These tables say which stats are valid.  Each table is searched
	and if the stat is found, the index of that stat in the xxStatsSet
	table is the index in the players actual Stats where the info is
	stored.

	e.g.-QB2(slot0) just threw a completed pass to FB2(slot5) for 10 yards.


	UpdateStats(0, GS_PASS_ATT,1)
	UpdateStats(0, GS_PASS_COMP,1)
	UpdateStats(0, GS_PASS_YARDS,10)
	UpdateStatsMax(0, GS_PASS_LONG,10)

	UpdateStats(5, GS_RECP_NUM,1)
	UpdateStats(5, GS_RECP_YARDS,10)
	UpdateStatsMax(5, GS_RECP_LONG,10)


	NOTE:  Each StatsSet is order based on the ROM stats for that
	position.  These ROM stats are a subset of the RAM stats and are
	always in the first "NumOfROMStatsPerSet[stat_set_num]" indexes.

	ROM stats = non-modifyable data from 1995 season
	RAM stats = kept track of during each game

********************************************************************/


WORD QBStatsSet[] = {		// these are valid stats for a QB,

GS_PASS_ATT,
GS_PASS_COMP,
GS_PASS_YARDS,
GS_PASS_LONG,
GS_PASS_TD,

GS_PASS_INT,
GS_PASS_RATE,

GS_RUSH_ATT,
GS_RUSH_YARDS,
GS_RUSH_TD,

GS_RUSH_LONG,		//RAM stats only
GS_CONV_NUM,        //RAM stats only

-1		// must be last
};


WORD RBStatsSet[] = { // these are valid stats for all Running backs

GS_RUSH_ATT,
GS_RUSH_YARDS,
GS_RUSH_LONG,
GS_RUSH_TD,

GS_RECP_NUM,
GS_RECP_YARDS,
GS_RECP_LONG,
GS_RECP_TD,

GS_CONV_NUM,

-1		// must be last
};



WORD RecStatsSet[] = {	// these are valid stats for Receivers
						// same stats as RBs, except in different order
GS_RECP_NUM,
GS_RECP_YARDS,
GS_RECP_LONG,
GS_RECP_TD,
GS_CONV_NUM,

GS_RUSH_ATT,		// here and below are strictly RAM stats
GS_RUSH_YARDS,
GS_RUSH_LONG,
GS_RUSH_TD,

-1		// must be last
};



WORD OLStatsSet[] = {		// these are valid stats Offensive Line

GS_SACK_ALLOWED,
-1		// must be last
};


WORD DefStatsSet[] = {		// these are valid stats for all defensive guys
GS_TACK_NUM,
GS_SACK_NUM,
GS_FUMFORCE,
GS_FUMRECOV,

GS_INT_NUM,
GS_INT_YARDS,
GS_INT_TD,

GS_FUM_TD,		   //RAM stats only
GS_INT_LONG,       //RAM stats only

-1		// must be last
};


WORD KickerStatsSet[] = {	// these are valid stats for Kicker OR punter
GS_PAT,
GS_PAT_ATT,
GS_FG,
GS_FG_ATT,
GS_FG_LONG,

GS_FG_BLK,			// here and below are strictly RAM stats

GS_PUNT,
GS_PUNT_YARDS,
GS_PUNT_LONG,
GS_PUNT_IN20,
GS_PUNT_TB,
GS_PUNT_BLK,
-1		// must be last
};

WORD PunterStatsSet[] = {	// these are valid stats for punter
							// same as kicker, but different order
GS_PUNT,
GS_PUNT_YARDS,
GS_PUNT_LONG,
GS_PUNT_IN20,
GS_PUNT_TB,
GS_PUNT_BLK,

GS_PAT,					// here and below are strictly RAM stats
GS_PAT_ATT,
GS_FG,
GS_FG_ATT,
GS_FG_LONG,
GS_FG_BLK,

-1		// must be last
};

WORD KRStatsSet[] = {	// these are valid stats for Kick OR punt Returner
GS_KRET_NUM,
GS_KRET_YARDS,
GS_KRET_TD,

GS_PRET_NUM,
GS_PRET_YARDS,
GS_PRET_TD,

GS_KRET_LONG,	// here and below are strictly RAM stats
GS_PRET_LONG,

-1		// must be last
};




#define  statssetmacro(enum, ptrtoRAMindexs, numROMStats) &ptrtoRAMindexs,

void * StatSetPtrTable[MAX_STATS_SETS] = {
	statssetinfo
};
#undef	statssetmacro


#define  statssetmacro(enum, ptrtoRAMindexs, numROMStats) numROMStats,

WORD NumOfROMStatsPerSet[MAX_STATS_SETS] = {
	statssetinfo
};
#undef	statssetmacro

WORD NumOfRAMStatsPerSet[MAX_STATS_SETS];	// initialized real time


struct teamRAMstats StatsData[2];	// RAM stuff

//struct teamRAMstats SeasonStatsData[NUM_TEAMS_IN_LEAGUE];	// RAM stuff

/*   Global Pointers for stats  and player data	*/
struct teamRAMstats *SeasonStatsPtr = NULL;
struct memorycardmimic *MemoryCardMimicPtr = NULL;


/************************************************************************

				^
				| Data
				|



				| Code
				|
			   \|/


	So every player doesn't have every stat (QB don't need # of PATs),
	stats are based on a players position which is mapped to a Stats
	Set which is a list of all stats appropriate for that player.
	The index of the stat in the StatSet is used as the index in the
	player stats DS where the data is stored

	Currently there are 45(?) possible stats, but each player only has
	12(?), which is the most any position has (QB has most). All other
	positions have fewer stats, so they don't use the full array.

************************************************************************/

WORD *GetStatsSetPtr(WORD pos)
{
	return(StatSetPtrTable[PositionToStatSetTable[pos]]);
}



void InitNumOfRAMStatsPerSet(void)
{
EFFVAR i, index;
WORD *statsetptr;

	for(i=0; i<MAX_STATS_SETS; i++)
	{
		index = 0;
		statsetptr = StatSetPtrTable[i];
		while(*statsetptr++ >= ZERO)		// -1 at end of stats list
		{
			index++;
		}
		NumOfRAMStatsPerSet[i] = index;

	}
}



/*  RETURNS:  index num if valid Stat for the position else negative	*/

WORD ValidStatForPos(WORD pos,WORD statnum)
{
WORD *statsetptr;
EFFVAR index = -1;

		// variable length of tables requires pointer
	statsetptr = GetStatsSetPtr(pos);

	while(*statsetptr >= ZERO)		// -1 at end of stats list
	{
		index++;

		if(*(statsetptr++) == statnum)	// found the stat we need?...
		{
			return(index);	// .. then this index is where we stick it
		}
	}
	return(-1);		// couldn't find it
}


void DebugScreen(void);

/*--------------------------------------------------------------

			U P D A T E    G A M E    S T A T  S


	If a "Stat" is valid for a "player", this will add the "value"
	to the total.

	In any case, the "value" will be added to team totals.

--------------------------------------------------------------*/
WORD UpdateStats(WORD pnum0_21, WORD statnum, WORD value)
{
EFFVAR mypnum,index,teamslotnum;

WORD rv = ILLEGAL_STAT;	// assume wrong

	if(pnum0_21 < 0)
	{
#if	PC_ERROR_MODE
		printf("\nInvalid slot num for stats- slot=%d, statnum=%d,value=%d",
					pnum0_21,statnum,value);
		getch();
		DebugScreen();

#endif
		return(rv);
	}

#if PRINT_UPDATE_STATS
	if(DisplayLevel)
		printf("\nPnum = %2d, %3d-%s",pnum0_21,value,GetStatsString(statnum));
#endif

	teamslotnum = (pnum0_21 < 11) ? OffensiveSlotNum : DefensiveSlotNum;

	mypnum = OPMyPNum(pnum0_21);	//convert slot# to player num 0-47(pos)#

	if( (index = ValidStatForPos(mypnum,statnum)) >= ZERO)
	{
		StatsData[teamslotnum].posstats[mypnum][index] += value;
		rv = StatsData[teamslotnum].posstats[mypnum][index];

	}
#if	PC_ERROR_MODE
	else	//flag the error
	{
		printf("\nInvalid Stats(%d)-%s - pos(%d)-%s",
				statnum,StatsNames[statnum],mypnum,PositionStrings[mypnum]);
	}
#endif

	// always add into overall team stats
	StatsData[teamslotnum].allplyrstats[statnum] += value;

	return(rv);
}



void UpdateStatsMax(WORD pnum0_21, WORD statnum, WORD value,WORD attempts)
{			// used for LONGEST pass, reception, run, etc.
EFFVAR mypnum,index,teamslotnum;

	if(pnum0_21 < 0)
	{
#if	PC_ERROR_MODE
		printf("\nInvalid slot num for stats- slot=%d, statnum=%d,value=%d",
					pnum0_21,statnum,value);
#endif
		return;
	}

#if PRINT_UPDATE_STATS
	if(DisplayLevel)
		printf("\tPnum = %2d, %3d-%s",pnum0_21,value,GetStatsString(statnum));
#endif

	teamslotnum = (pnum0_21 < 11) ? OffensiveSlotNum : DefensiveSlotNum;

	mypnum = OPMyPNum(pnum0_21);	//

	if( (index = ValidStatForPos(mypnum,statnum)) >= ZERO)
	{
		if( (value > StatsData[teamslotnum].posstats[mypnum][index])
		   || attempts == 1)	// handles negative yards on 1st attempt
		{
			StatsData[teamslotnum].posstats[mypnum][index] = value;

	#if PRINT_UPDATE_STATS
			if(DisplayLevel)
				printf(" - YES");
	#endif
		}
	}
#if	PC_ERROR_MODE
	else	//flag the error
	{
		printf("\nInvalid MAX Stats(%d)-%s - pos(%d)-%s",
				statnum,StatsNames[statnum],mypnum,PositionStrings[mypnum]);
	}
#endif

	// always check overall team stats
	if( value > StatsData[teamslotnum].allplyrstats[statnum])
	{ // problem with  negative yards on 1st attempt
		StatsData[teamslotnum].allplyrstats[statnum] = value;
	}
}

/*-------------------------------------------------------------------*/

void UpdateTeamStats(WORD teamslotnum, WORD statnum, WORD value)
{
	StatsData[teamslotnum].allplyrstats[statnum] += value;
}

void UpdateTeamStatsMax(WORD teamslotnum, WORD statnum, WORD value)
{
	if(value > StatsData[teamslotnum].allplyrstats[statnum])
		StatsData[teamslotnum].allplyrstats[statnum] = value;
}

/*-------------------------------------------------------------------*/

WORD GetPlayerGameStats(WORD teamslotnum, WORD pos0_46, WORD statnum)
{
EFFVAR index;		// used for RAM stats only!!


	if( (index = ValidStatForPos(pos0_46,statnum)) >= ZERO)
	{
		return(StatsData[teamslotnum].posstats[pos0_46][index]);

	}
	else	//flag the error
	{
#if	PC_ERROR_MODE
		printf("\nInvalid Gets Index %d - pos(%d)-%s",statnum,pos0_46,PositionStrings[pos0_46]);
//		printf("\nInvalid Gets Stats Index %d - pos = %d",statnum,pos0_46);
#endif
		return(ILLEGAL_STAT);
	}


}


WORD GetPlayerSeasonStats(WORD tnum0_29, WORD pos0_46, WORD statnum)
{
EFFVAR index;		// used for RAM stats only!!

	if(SeasonStatsPtr == NULL)
		return(ILLEGAL_STAT);		// error


	if( (index = ValidStatForPos(pos0_46,statnum)) >= ZERO)
	{
		return((SeasonStatsPtr+tnum0_29)->posstats[pos0_46][index]);

	}
	else	//flag the error
	{
		return(ILLEGAL_STAT);
	}


}



void ClearAllGameStats(void)	// for both teams - 1 game
{				// called at InitGame
EFFVAR i,j,t;

	for(t=0; t<2; t++)
	{
		for(j=0; j < TOTAL_PLAYERS_ON_TEAM; j++)		// player stats
			for(i=0; i < MAX_STATS_PER_1PLAYER; i++)
//				StatsData[t].posstats[j][i] = j;	//test
				StatsData[t].posstats[j][i] = ZERO;

		for(j=0; j < MAX_NUM_STATS_1TEAM; j++)		// cumulative team stats
		{
//			StatsData[t].allplyrstats[j] = 3;	// test only
//				StatsData[t].alloppplyrstats[j] = 4;	// opposition stats
			StatsData[t].allplyrstats[j] =
				StatsData[t].alloppplyrstats[j] = ZERO;	// opposition stats
		}
	}

}


#if PC_ALWAYS_MODE
BYTE *GetStatsString(UWORD statnum)
{
	if(statnum >= MAX_NUM_STATS_1TEAM)	// a little error checking never hurt
		return("ERROR");
	else
		return(StatsNames[statnum]);
}
#endif



/************************************************************************

				PLAYER    DATA   STRUCTURE   STUFF


	All ROM player data should be in GameTeamData and is referenced by the
	player's number (0-47). This is directly related to their position,

	 I.E.  QB (==0) is always referenced if refering to AI team roster
	 "TeamRoster[0][QB]"  or direct position.
	  HOWEVER this reference could be used as "TeamRoster[0][QB] = QB2"
	  if you substitute QBs


	CPPlayerNum is the actual PLAYER number 0-47.
	CPMyFormPosition is the actual position I play (0-47)
	In most cases they are the same unless there has been a substitution.

	I know it's a bit confusing, but substitutions was a last minute feature.

	GameTeamData[0 | 1].PlayerData[OPMyPosition(plyrslotnum)]);




	Usage (by shell) - ASSume team data already loaded in GameteamData[0]


specificplayerdata *pdptr;

	pdptr =  GetPlayerPosDataPtr(0,QB)	// if starting QB
OR	pdptr =  GetPlayerPosDataPtr(0,DB7)	// if last defensive back


	// to print 1995 season [ROM] stats

	printf("player name = %s",pdptr->pname);
	statsetptr = GetStatsSetPtr(QB);	// points to valid stats for QB (for stats strings)
	max = NumOfROMStatsPerSet[PositionToStatSetTable[QB]];
	for(i=0; i<	max; i++,statsetptr++)
		printf("\n%s - %d",GetStatsString(*statsetptr),pdptr->mypstats[i]);



************************************************************************/


/** 	SLOT  BASED   Pointer  (used by arcade AI)

	RETURNS: ptr to a players data structure (one of 2*player per team)
	 possible - based on players position (QB not x,y) and team
**/



specificplayerdata *GetPlayerDataPtr0_21(WORD plyrslotnum)
{
/*  need to figure which "teamnum" (0 or 1) is
					on offense (offense in player slots 0-10 */
	return(&GameTeamData[plyrslotnum<11?OffensiveSlotNum:
		   DefensiveSlotNum].PlayerData[OPMyPNum(plyrslotnum)]);

}




#ifdef SATURNMODE
specificplayerdata *GetPlayerDataPtr(WORD plyrslotnum)
{
/*  need to figure which "teamnum" (0 or 1) is
					on offense (offense in player slots 0-10 */
	return(&GameTeamData[plyrslotnum<11?OffensiveSlotNum:
		   DefensiveSlotNum].PlayerData[OPMyPNum(plyrslotnum)]);

}

#else
specificplayerdata *GetPlayerDataPtr(WORD plyrslotnum)
{
/*  need to figure which "teamnum" (0 or 1) is
					on offense (offense in player slots 0-10 */
	if(GameFlags & INSTANT_REPLAY_ACTIVE)
		return(OneTimeIRP.IRPPlayerDataPtr[plyrslotnum]);
	else
		return(GetPlayerDataPtr0_21(plyrslotnum));


//		&GameTeamData[plyrslotnum<11?OffensiveSlotNum:
//			   DefensiveSlotNum].PlayerData[OPMyPNum(plyrslotnum)]);

}
#endif


/** 	POSITION & TEAM Pointer  (used by shell)
	RETURNS: ptr to a players data structure (one of 2*player per team)
	 possible - based on players position (QB not x,y) and team
**/


specificplayerdata *GetPlayerPosDataPtr(WORD teamnum0_1,WORD posnum)
{
	return(&GameTeamData[teamnum0_1].PlayerData[posnum]);
}





/*********************************************************************

		PLAYER   DEMOGRAPHIC   INFO


*---------------------------------------------------------------------*/

WORD GetJerseyNum(WORD plyrslotnum)
{
	return(OPJerseyNum(plyrslotnum));	// OP... is a MACRO
}


BYTE *GetPlayerName(WORD plyrslotnum)
{
	return(GetPlayerDataPtr(plyrslotnum)->pname);

}

WORD GetPlayerWeight(WORD plyrslotnum)
{                // Weight is BYTe in DB, so add offset
	return(GetPlayerDataPtr(plyrslotnum)->weight+PD_WEIGHT_OFFSET);
}

WORD GetPlayerHeight(WORD plyrslotnum)	// inches
{
	return(GetPlayerDataPtr(plyrslotnum)->height+PD_HEIGHT_OFFSET);
}

WORD GetPlayerSkinColor(WORD plyrslotnum)	// 0-3
{
	return(GetPlayerDataPtr(plyrslotnum)->skincolor);
}

BOOL PlayerWearingGloves(WORD plyrslotnum)
{
	return(GetPlayerDataPtr(plyrslotnum)->gloves);

}

BOOL PlayerLeftHanded(WORD plyrslotnum)
{
	return(GetPlayerDataPtr(plyrslotnum)->leftqb);

}


/*********************************************************************

				PLAYER   RATINGS  INFO


*---------------------------------------------------------------------*/


//GAME_OPTNS_WEATHER 	            0-normal 1-rain 2-snow
WORD ExtraAgility[MAX_WEATHER_OPTIONS] = {0,-8,-15};


WORD GetPlayerAgility(WORD plyrslotnum)
{
EFFVAR pnum,agil;

	pnum = OPMyPNum(plyrslotnum);

	if(   (pnum > QB3 && pnum <= FB2)
	   || (pnum > PUNT_RETURNER-1 && pnum < KR3+1)
	  )
	{
		agil = GetPlayerDataPtr(plyrslotnum)->ratings[AGILITY_RATE];
	}
	else
		agil = 30;

	agil += ExtraAgility[GameOptions[GAME_OPTNS_WEATHER]];

	return(agil);
}


WORD GetPlayerRunBlockRating(WORD plyrslotnum)
{ 	//non- uniforn D.S. requires routine
EFFVAR pnum,rating;

	pnum = OPMyPNum(plyrslotnum);

	if(pnum >= RR && pnum <= OL7)	// offense except QB
		rating = GetPlayerDataPtr(plyrslotnum)->ratings[RUNBLOCK_RATE];
	else
		rating = 30;

	return(rating);
}

WORD GetPlayerPassBlockRating(WORD plyrslotnum)
{ 	//non- uniforn D.S. requires routine
EFFVAR pnum,rating;

	pnum = OPMyPNum(plyrslotnum);

	if(pnum >= RT && pnum <= OL7)	// offense line only
		rating = GetPlayerDataPtr(plyrslotnum)->ratings[PASSBLOCK_RATE];
	else
		rating = 30;

	return(rating);
}


WORD GetPlayerTackleRating(WORD plyrslotnum)
{ 	//non- uniforn D.S. requires routine
EFFVAR pnum,rating;
specificplayerdata *pdptr;

	// tackle rating range = 30-100
	pnum = OPMyPNum(plyrslotnum);
	pdptr = GetPlayerDataPtr(gPNum);	// debugging
	if(pnum >= FS)	// DBs have 1 fewer ratings
	{
		rating = pdptr->ratings[TACKLE_RATE-1];
	}
	else if(pnum >= DLE)	// normal defense
	{
		rating = pdptr->ratings[TACKLE_RATE];
	}
	else	// offense or kickers
	{
		rating = (pdptr->ratings[STRENGTH_RATE])/2;	// 40;
		if(rating < 30)	// not too low
			rating = 30;
	}
	return(rating);
}


WORD GetPlayerRushRating(WORD plyrslotnum)
{ 	//non- uniforn D.S. requires routine
EFFVAR pnum,rating;

	pnum = OPMyPNum(plyrslotnum);

	if(pnum >= DLE && pnum <= LB6)	// defense line & LBs
		rating = GetPlayerDataPtr(plyrslotnum)->ratings[RUSH_RATE];
	else
		rating = 30;

	return(rating);
}

WORD GetPlayerArmStrength(WORD plyrslotnum)
{ 	//non- uniforn D.S. requires routine
EFFVAR pnum,rating;

	pnum = OPMyPNum(plyrslotnum);

	if(pnum <= QB3)	// QBs only
		rating = GetPlayerDataPtr(plyrslotnum)->ratings[ARMSTRENGTH_RATE];
	else
		rating = 30;	// HB on option play or Punter on fake

	return(rating);
}

WORD GetPlayerFootStrength(WORD plyrslotnum)
{ 	//non- uniforn D.S. requires routine
EFFVAR pnum,rating;

	pnum = OPMyPNum(plyrslotnum);

	if(pnum == PUNTER || pnum == KICKER)
		rating = GetPlayerDataPtr(plyrslotnum)->ratings[LEGSTRENGTH_RATE];
	else
		rating = 30;	// QB on pooch kick

	return(rating);
}



/*------------------------------------------------------------------*/

#if	PC_DEBUG_MODE		// testing only !!!!

/*------------------------------------------------------------
   If  a player has any stats(non-zero), all stats for that player will be
   printed, along with all team stats				*/

void PrintTeamStats(WORD t)
{
WORD p,i,num,stat;		// RAM (game) STATS ONLY!!!!
WORD *statsetptr,*statsetptr1,*tptr1;
WORD statsetnum;
specificplayerdata *pdptr;

/**  print all valid stats for each player, each team	*/
//  for(t=0; t < 2; t++)
//  {
//	system("mode con: lines=50");	// let's look at all of them
	for(p=0; p < TOTAL_PLAYERS_ON_TEAM; p++)
	{
		num = 0;

		statsetptr1 = statsetptr = GetStatsSetPtr(p);
		while((i = *(statsetptr1++)) >= ZERO)	// -1 at end of stats list
		{	// see if there are any - don't print if none
			if( (stat = GetPlayerGameStats(t, p, i)) != ZERO)
				break;
		}

		if(stat)
		{
			pdptr =  GetPlayerPosDataPtr(t,p);

			printf("\nTeam %d, posnum %2d,%s, #%d - %s     STATS =\n",
						t,p,PositionStrings[p],pdptr->jerseynum,pdptr->pname);

	//		statsetptr = GetStatsSetPtr(p);
			statsetnum = PositionToStatSetTable[p];
	//		printf("\nSTATS =\n");

			while((i = *(statsetptr++)) >= ZERO)	// -1 at end of stats list
			{
				textcolor(8);	//ROM stats color
				if(num >= NumOfROMStatsPerSet[statsetnum])
					textcolor(9);	// additional RAM stats color

				stat = GetPlayerGameStats(t, p, i);

//				printf("%2d-%s=%d ",++num,GetStatsString(i),stat);
				cprintf("%2d-%s=%d ",++num,GetStatsString(i),stat);

			}
		}
//		if(getch() == 0x1b)		// ESCAPE exits
//			break;
	}
	textcolor(7);

// dump overall team stats

	tptr1 = (WORD *) &(StatsData[t].allplyrstats[0]);
	printf("  team stats follow -\n");
	for(i=0,p=0; i<MAX_NUM_STATS_1TEAM; i++,p++)
	{
		printf("%7.7s-%4d ",GetStatsString(i),*(tptr1++));
		if(p%6 == 5 || i == GS_WIN-1)
		{
			printf("\n");
			p=-1;
		}
	}


//  }
}


/*******
void PrintStatSize(void)	// testing only - called at program init
{

	OffensiveSlotNum = 0;
	DefensiveSlotNum = 1;

	ClearAllGameStats();

	printf("\nSize of all stats(1 team)= %d",sizeof(struct teamRAMstats ));

	OPMyPNum(0)	= QB2;	// init positions
	OPMyPNum(5)	= FB2;
	OPMyPNum(11)= DLE;


//  set up some real (and error)  stats

	UpdateStats(0, GS_PASS_ATT,1);
	UpdateStats(0, GS_PASS_COMP,1);
	UpdateStats(0, GS_PASS_YARDS,10);
	UpdateStatsMax(0, GS_PASS_LONG,10);

	UpdateStatsMax(5, GS_PASS_LONG,10);	// error?

	UpdateStats(0, GS_TACK_NUM,10);	// error?
	UpdateStats(11, GS_TACK_NUM,1);
	UpdateStats(11, GS_RECP_NUM,1);  // error?


	UpdateStats(5, GS_RECP_NUM,1);
	UpdateStats(5, GS_RECP_YARDS,10);
	UpdateStatsMax(5, GS_RECP_LONG,10);

	PrintTeamStats(0);
	PrintTeamStats(1);


}  **/
#endif

#if __MSDOS__

void PrintTeamRoster(WORD teamslot)
{
WORD i;
specificplayerdata *pdptr;

	// points to valid stats for QB (for stats strings)
	if(GameTeamData[teamslot].GameTeamFlags & PDATA_LOADED_BFLAG)
	{
		for (i = 0; i < TOTAL_PLAYERS_ON_TEAM; i++)
		{
			pdptr =  GetPlayerPosDataPtr(teamslot,i);
			printf("\n%2d %2s #%2d %s",i,PositionStrings[i],
				pdptr->jerseynum,pdptr->pname);
		}
	}
}



void DisplayPlayerROMData(lgplyrPTR pdptr)
{
WORD s,max,r,in,pos;
WORD *statsetptr;


//			pos = (pdptr->playernum)%TOTAL_PLAYERS_ON_TEAM;
			pos = pdptr->position;

//			pdptr =  GetPlayerPosDataPtr(teamslot,i);

		//  print 1995 season [ROM] stats

//			printf("\nplayer name = %s  pos = %s jnum=%d col=%s",
//				pdptr->pname,PositionStrings[i],pdptr->jerseynum,pdptr->collegename);
			printf("\nplayer name = %s  pos = %s jnum=%d col=%s",
				pdptr->pname,PositionStrings[pos],pdptr->jerseynum,
					(CollegePtr +(pdptr->collegeindex))->collegename );


			in = pdptr->height + PD_HEIGHT_OFFSET;
			printf("\nheight = %d'%d\"",in/12, in%12);
			printf("\tweight = %d",pdptr->weight + PD_WEIGHT_OFFSET);
			printf("\tDOB = %d-%d-%d",	pdptr->birthmonth,
										pdptr->birthday,
										pdptr->birthyear+PD_YEAR_OFFSET);

			in = pdptr->yearsinleague;
			printf("\tSeasons  = ");

			if(in)
				printf("%d",in);
			else
				printf("R",in);

			printf("\nratings = ");
			for(r=0; r < 8; r++)
				printf("%2d ",pdptr->ratings[r]);

			statsetptr = GetStatsSetPtr(pos);	// points to valid stats for QB (for stats strings)
			max = NumOfROMStatsPerSet[PositionToStatSetTable[pos]];

			for(s=0; s<	max; s++,statsetptr++)
			{
				if(StatDivsorTable[*statsetptr] == 10)
					printf("\n%s - %d.%d",GetStatsString(*statsetptr),pdptr->mypstats[s]/10,pdptr->mypstats[s]%10);
				else
					printf("\n%s - %d",GetStatsString(*statsetptr),pdptr->mypstats[s]);
			}

}


void VerifyROMData(WORD teamslot)
{
WORD i;
//WORD s,max,r,in;
//WORD *statsetptr;
specificplayerdata *pdptr;

	// points to valid stats for QB (for stats strings)
	if(GameTeamData[teamslot].GameTeamFlags & PDATA_LOADED_BFLAG)
	{
		for (i = 0; i < TOTAL_PLAYERS_ON_TEAM; i++)
		{

			pdptr =  GetPlayerPosDataPtr(teamslot,i);
			DisplayPlayerROMData(pdptr);
/*
		//  print 1995 season [ROM] stats

//			printf("\nplayer name = %s  pos = %s jnum=%d col=%s",
//				pdptr->pname,PositionStrings[i],pdptr->jerseynum,pdptr->collegename);
			printf("\nplayer name = %s  pos = %s jnum=%d col#=%d",
				pdptr->pname,PositionStrings[i],pdptr->jerseynum,pdptr->collegeindex);


			in = pdptr->height + PD_HEIGHT_OFFSET;
			printf("\nheight = %d'%d\"",in/12, in%12);
			printf("\tweight = %d",pdptr->weight + PD_WEIGHT_OFFSET);
			printf("\tDOB = %d-%d-%d",pdptr->birthmonth,pdptr->birthday,pdptr->birthyear+50);

			in = pdptr->yearsinleague;
			printf("\tSeasons  = ");

			if(in)
				printf("%d",in);
			else
				printf("R",in);

			printf("\nratings = ");
			for(r=0; r < 8; r++)
				printf("%2d ",pdptr->ratings[r]);

			statsetptr = GetStatsSetPtr(i);	// points to valid stats for QB (for stats strings)
			max = NumOfROMStatsPerSet[PositionToStatSetTable[i]];

			for(s=0; s<	max; s++,statsetptr++)
			{
				if(StatDivsorTable[*statsetptr] == 10)
					printf("\n%s - %d.%d",GetStatsString(*statsetptr),pdptr->mypstats[s]/10,pdptr->mypstats[s]%10);
				else
					printf("\n%s - %d",GetStatsString(*statsetptr),pdptr->mypstats[s]);
			}
***/
			if(getch() == 0x1b)		// ESCAPE exits
				break;

//			printf("\n%2d - %-20s %s", i, GameTeamData[0].PlayerData[i].pname, GameTeamData[0].PlayerData[i].collegename);
		}
	}
}
#endif

void Inc3rdor4thDownAttempts(void)	// if necessary
{
	if(TheDown == 3)
	{
		StatsData[OffensiveSlotNum].allplyrstats[GS_3RDDOWNS_ATT]++;
	}
	else if(TheDown == 4)
	{
		StatsData[OffensiveSlotNum].allplyrstats[GS_4THDOWNS_ATT]++;
	}
}

void Inc3rdor4thDownMade(void)	// if necessary
{
	if(TheDown == 3)
	{
		StatsData[OffensiveSlotNum].allplyrstats[GS_3RDDOWNS_MADE]++;
	}
	else if(TheDown == 4)
	{
		StatsData[OffensiveSlotNum].allplyrstats[GS_4THDOWNS_MADE]++;
	}
}

void UpdateEOPPlayerStats(void);
/*----------------------------------------------------------------

				Major STATS   Updater

	UpdateEOPStats() is called only if penalty declined (or there
	was no penalty DURING play).

	It first checks "overall" stuff like Extra Point plays and non-tackle
	plays (scoring,  kicking stuff, incompletes) then finally
	checks ball carrier	stuff.

	THIS SHOULD BE THE ONLY FUNCTION (besides it's subroutines) WHICH
	CALLS "UpdateStats()" !!!!!!

----------------------------------------------------------------	*/
void UpdateEOPStats(void)
{
WORD attempts;	// needed if negative yards on first stats (LONG)

	if(MoreEventFlags & OKAY_FOR_STATS_BFLAG)	// set in PlayHappeneing()
	{ // only do stats once per play (in case EOQ or 2Min Warn) after EOP
		ResetBit(MoreEventFlags,OKAY_FOR_STATS_BFLAG);

		if(ANY_EXPT_PLAY)
		{ // no real stats(yards, atts, etc) on Ex. Pt. - only conversion stuff

			if (PlayOverFlags & KICK_OVER_BFLAG)
			{ // actual kick hit ground or blocked

				UpdateStats(KickerSlot,GS_PAT_ATT,1);

				if(EventFlags.KICK_GOOD_BFLAG)
				{
					OfficiallyAddScore();	// points already stored in global
					UpdateStats(KickerSlot,GS_PAT,1);
				}
			}
			else if(ScoreStat == GS_CONV_NUM) // did offense score 2 points???
			{
				OfficiallyAddScore();	// gives credit to scorer for conv.
			}
		}
		else	// "normal" play
		{

			if(PuntYards != INVALID_DISTANCE)
			{	// there was a non-blocked punt this play
				attempts = UpdateStats(KickerSlot,GS_PUNT,1);
				UpdateStats(KickerSlot,GS_PUNT_YARDS,PuntYards);
				UpdateStatsMax(KickerSlot,GS_PUNT_LONG,PuntYards,attempts);

				if(KickStatsType != ZERO)
				{  // 	GS_PUNT_TB or IN20
					UpdateStats(KickerSlot,KickStatsType,1);
				}
			}
			else if(KickStatsType == GS_PUNT_BLK)	// or any block
			{
				if(PlayType == FIELD_GOAL_PLAY)
				{
					UpdateStats(KickerSlot, GS_FG_ATT,1);
					UpdateStats(KickerSlot, GS_FG_BLK,1);
				}
				else	// must be PUNT_PLAY
				{
					UpdateStats(KickerSlot, GS_PUNT,1);
					UpdateStats(KickerSlot, GS_PUNT_BLK,1);
				}

			}
			else  if (PlayOverFlags & KICK_OVER_BFLAG)
			{	// field goal only - actual kick hit ground (not blocked)
			// already checked for Ex. Pt play
				attempts = UpdateStats(KickerSlot,GS_FG_ATT,1);

				if(EventFlags.KICK_GOOD_BFLAG)
				{
					OfficiallyAddScore();

					UpdateStats(KickerSlot,GS_FG,1);
					UpdateStatsMax(KickerSlot,GS_FG_LONG,KickLength,attempts);
				}
			}
			else
			{	// only if not a kick
				Inc3rdor4thDownAttempts();	// if necessary
			}


			if(ScoreStat >= ZERO)	// actual score	(except kicks)  ???
			{
				OfficiallyAddScore();	// and handle individual score stats
			}

			UpdateEOPPlayerStats();
		}
	}
}



/*---------------------------------------------------------------------*/

void UpdateEOPPlayerStats(void)
{
WORD attempts;	// needed if negative yards on first stats (LONG)

/* all the Globals (playertype & yards) should have already	been set up */

	if(Tackler != NOBODY && PlayType != KICKOFF_PLAY)
	{	// why no tackles on KO???
		UpdateStats(Tackler,GS_TACK_NUM,1);
	}

	// fumbler independent of other stats!!!
	if(FumbleRecoverer != NOBODY)
	{
		UpdateStats(FumbleRecoverer,GS_FUMRECOV,1);	// recov. yards???

		if(Fumbler > 10 && FumbleRecoverer < 11)
		{	 // if fumbler on defense (punt or Int) ond off. got it
			UpdateTeamStats(DefensiveSlotNum,GS_FUM_LOST,1);
		}
		else if(Fumbler < 11 && FumbleRecoverer > 10)
		{ // if fumbler on offense AND def. got it
			UpdateTeamStats(OffensiveSlotNum,GS_FUM_LOST,1);
		}
	}


/**  only one of the following should have happened (even if fumble) */

	if(KickReturner != NOBODY)
	{
		if(ReturnYards != INVALID_DISTANCE)	// only if not downed in EZ
		{
			attempts = UpdateStats(KickReturner, GS_KRET_NUM,1);
			UpdateStats(KickReturner, GS_KRET_YARDS,ReturnYards);
			UpdateStatsMax(KickReturner, GS_KRET_LONG,ReturnYards,attempts);
		}
	}
	else if(Passer != NOBODY)
	{
		UpdateStats(Passer, GS_PASS_ATT,1);

		if(PassCatcher != NOBODY)	// offensive
		{
			attempts =  UpdateStats(Passer, GS_PASS_COMP,1);
			UpdateStats(Passer, GS_PASS_YARDS,PassYards);
			UpdateStatsMax(Passer, GS_PASS_LONG,PassYards,attempts);

			attempts = UpdateStats(PassCatcher, GS_RECP_NUM,1);
			UpdateStats(PassCatcher, GS_RECP_YARDS,PassYards);
			UpdateStatsMax(PassCatcher, GS_RECP_LONG,PassYards,attempts);
		}
		else if(PassInterceptor != NOBODY)	//interception
		{
			UpdateStats(Passer, GS_PASS_INT,1);

			attempts = UpdateStats(PassInterceptor, GS_INT_NUM,1);
			UpdateStats(PassInterceptor, GS_INT_YARDS,ReturnYards);
			UpdateStatsMax(PassInterceptor, GS_INT_LONG,ReturnYards,attempts);
		}
	}
	else if(SackYards != INVALID_DISTANCE) //else if(SackAllower != NOBODY)
	{	// it's a sack - QB tackled for loss on passing play
		// NOTE:  sacks are non-int in ROM stats (2.5) so we must add 10 (=1)

		UpdateTeamStats(OffensiveSlotNum,GS_SACK_YARDS,SackYards);

		if(Tackler > LAST_OFF_SLOT_NUM)	// OOB??
		{	// tackle made by defender
			UpdateStats(SackAllower, GS_SACK_ALLOWED,SACK_FACTOR);
			UpdateStats(Tackler, GS_SACK_NUM,SACK_FACTOR);	// will do team sack
		}
		else	// must be OOB - give team sack
		{
			UpdateTeamStats(DefensiveSlotNum,GS_SACK_NUM,SACK_FACTOR);
		}

	}
	else if(PuntReturner != NOBODY)	// punt returner
	{
		if(ReturnYards != INVALID_DISTANCE)
		{	// no update if fair catch
			attempts = UpdateStats(PuntReturner,GS_PRET_NUM,1);
			UpdateStats(PuntReturner,GS_PRET_YARDS,ReturnYards);
			UpdateStatsMax(PuntReturner,GS_PRET_LONG,ReturnYards,attempts);
		}
	}
	else if(Rusher != NOBODY)	// better be rushing
	{
		attempts = UpdateStats(Rusher, GS_RUSH_ATT,1);
		UpdateStats(Rusher, GS_RUSH_YARDS,RushingYards);
		UpdateStatsMax(Rusher, GS_RUSH_LONG,RushingYards,attempts);

	}
	else if(BlockedKickRecoverer != NOBODY)
	{
	}
	else if(KickEndsPlay)
	{
			// helps with possible stats errors
	}
	else	// I'm lost - get out the [memory] map
	{
#if PC_ALWAYS_MODE
		printf("Error on PlayerStats- FBC=%d",FinalBallCarrier);
		getch();
#endif
	}

}

void AddPoints(WORD teamslot, WORD points)	// called if safety on penalty
{
// NOTE: "LastToScoreSlot" is a global
	LastTeamToScoreSlot = teamslot;

	GameTeamData[LastTeamToScoreSlot].ScorePerQuarter[TheQuarter-1] += points;
	GameTeamData[LastTeamToScoreSlot].TotalScore += points;
}

void OfficiallyAddScore(void)	// AND update individual scoring stats
{
  /*     **** WARNING *** 	"UnofficiallyAddScore()" (which sets up
  actual points scored) MUST have already   been called this play	****/

#if PC_ALWAYS_MODE
	if(ScoringTeamThisPlay < ZERO)
	{
		printf("\nERROR on OfficiallyAddScore");
		getch();
	}
	else

#endif
	{
		AddPoints(ScoringTeamThisPlay,PointsThisPlay);

		if(ScoreStat >= ZERO)	// actual score	(except kicks)
		{
			UpdateStats(Scorer,ScoreStat,1);	// individual got 1 score
			if(ScoreStat == GS_RECP_TD)	//reception???
			{
				UpdateStats(Passer,GS_PASS_TD,1);	// QB got 1 TD pass
			}
		}
	}
}



/*********************************************************************

				 C L O C K    S T U F F

*********************************************************************/

/*********************************************************************

				 S E T     N E W    Q U A R T E R

	NOTE: as of 7/10/96 we use accelerated clock

*********************************************************************/

ULONG	QuarterTimes[5] = {		// based on a User Option
		(ULONG) 2*60*CLOCKS_TICKS_PER_SECOND,
		(ULONG) 5*60*CLOCKS_TICKS_PER_SECOND,
		(ULONG)10*60*CLOCKS_TICKS_PER_SECOND,
		(ULONG)15*60*CLOCKS_TICKS_PER_SECOND,
		(ULONG)	   15*CLOCKS_TICKS_PER_SECOND	//test only -15 sec quarter
};



//UWORD SecondsLeftInGame(void)
WORD SecondsLeftInGame(void)
{
WORD secs;

	if(TheQuarter >= 4)
	{	// 4th or O.T.
		secs = SecondsLeftInQuarter();
	}
	else
	{
	  secs =   SecondsLeftInQuarter() + ((4-TheQuarter) *
		   QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]/CLOCKS_TICKS_PER_SECOND);
	}

	return(secs);
}


UWORD SecondsLeftInQuarter(void)
{
//LONG secs =	gVBlankTimers[GAME_TIMER_NUM];
LONG secs =	GetVBlankTimer(GAME_TIMER_NUM);

	if(secs != ZERO)	   //leave on ZERO if expired
	{
		secs = (secs+CLOCKS_TICKS_PER_SECOND-1)/CLOCKS_TICKS_PER_SECOND;

	}
	return ((UWORD)secs);

}



void UpdateTeamsTimeOfPossession(void)
{	// both teams - to make it exact, base TOP on Away team
	// use TrueQuarter in case double OT in playoffs
UWORD secsingame;

	StatsData[1].allplyrstats[GS_TOP] =		//TOP in seconds
				 TimeOfPoss[1]/CLOCKS_TICKS_PER_SECOND;

/*
	StatsData[0].allplyrstats[GS_TOP] =

		( (TheTrueQuarter *
		   QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]/CLOCKS_TICKS_PER_SECOND)
			- SecondsLeftInQuarter())	// this is time so far
		-	StatsData[1].allplyrstats[GS_TOP]; // minus other teams TOP

*/
	secsingame = ( (TheTrueQuarter *
	   (QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]/CLOCKS_TICKS_PER_SECOND))
			- SecondsLeftInQuarter());	// this is time so far

	if(StatsData[1].allplyrstats[GS_TOP] > secsingame)	// error correction
	{	// damn testers who hold the ball all game
		StatsData[1].allplyrstats[GS_TOP] = secsingame;	// error correction

	}
	StatsData[0].allplyrstats[GS_TOP] = secsingame -
			StatsData[1].allplyrstats[GS_TOP]; // minus other teams TOP
}




void UpdateMiscStats(void)	// QB ratings, score per quarter @ EOGame
{
EFFVAR t;
void *sptr, *dptr;


	UpdateTeamsTimeOfPossession();

	for(t=0; t<2; t++)
	{
		StatsData[t].allplyrstats[GS_SCOREQ1] = GameTeamData[t].ScorePerQuarter[0];
		StatsData[t].allplyrstats[GS_SCOREQ2] = GameTeamData[t].ScorePerQuarter[1];
		StatsData[t].allplyrstats[GS_SCOREQ3] = GameTeamData[t].ScorePerQuarter[2];
		StatsData[t].allplyrstats[GS_SCOREQ4] = GameTeamData[t].ScorePerQuarter[3];
		StatsData[t].allplyrstats[GS_SCOREQ5] = GameTeamData[t].ScorePerQuarter[4];
		StatsData[t].allplyrstats[GS_TOTAL_SCORE] = GameTeamData[t].TotalScore;

		FigureTeamQBRating(&StatsData[t]);	// for all 3 QBs on team

		StatsData[t].allplyrstats[GS_NUM_RUN_PLAYS] =
				StatsData[t].allplyrstats[GS_RUSH_ATT];

		StatsData[t].allplyrstats[GS_NUM_PASS_PLAYS] =
				StatsData[t].allplyrstats[GS_PASS_ATT] +
				(StatsData[t].allplyrstats[GS_SACK_ALLOWED]/SACK_FACTOR);


	/**  copy my data to my opponents "opponents" data	*/
		sptr = &StatsData[t].allplyrstats;
		dptr = &StatsData[t^1].alloppplyrstats;

		CopyBytes(sptr, dptr, MAX_NUM_STATS_1TEAM * 2 ); // they're all WORDS
	}

}


BOOL HomeTeamAhead(void)	//used at EOG and for sound effects
{
	return(GameTeamData[HOME_TEAM_SLOT].TotalScore > GameTeamData[AWAY_TEAM_SLOT].TotalScore);
}

/* called at end of game to handle final stats, like who won
	and cleanup any other stats, including saving "opponents" stats	*/
void UpdateFinalGameStats(void)
{

	if(HomeTeamAhead())
	{	// home team wins
		StatsData[HOME_TEAM_SLOT].allplyrstats[GS_WIN] =
			StatsData[AWAY_TEAM_SLOT].allplyrstats[GS_LOSS] = 1;
	}
	else if(GameTeamData[HOME_TEAM_SLOT].TotalScore < GameTeamData[AWAY_TEAM_SLOT].TotalScore)
	{	// away team wins
		StatsData[AWAY_TEAM_SLOT].allplyrstats[GS_WIN] =
			StatsData[HOME_TEAM_SLOT].allplyrstats[GS_LOSS] = 1;
	}
	else
	{
		StatsData[HOME_TEAM_SLOT].allplyrstats[GS_TIE] =
			StatsData[AWAY_TEAM_SLOT].allplyrstats[GS_TIE] = 1;
	}

	UpdateMiscStats();	// QB ratings, score per quarter

}



void UpdateStatBasedOnType(WORD *wheretoput, WORD stattype,WORD value)
{
	if(stattype == LNG)
	{
		if( *wheretoput < value)	// longest catch, run, punt FG, etc.
		   *wheretoput = value;

	}
	else if(stattype == FORM)
	{	// skip formula based stuff
	}
	else
	{	// must be cumulative (CUME or CUMEL)
		*wheretoput += value;
	}
}





/*------------------------------------------------------------------

				Game  Stats  To  Season  Stats

	After a season game, the stats for that game need to update the
	season stats for the two teams.

	Also, any stats for SIMMed games also must update the season area.


	All data is "moved" to [global] SeasonStatsPtr.
	"Moved" means cumulated or tested for greatest value.

	example for moving current game stats to season area

error = GameStatsToSeasonStats(GameTeamData[0].TeamNumber,&StatsData[0]);
error = GameStatsToSeasonStats(GameTeamData[1].TeamNumber,&StatsData[1]);

	example for moving SIMMed game stats to season area

	// team 23 stats data for 1 game stored at SimmedStatsData
error = GameStatsToSeasonStats(23,&SimmedStatsData);


	Returns: ZERO if no error else error code

------------------------------------------------------------------*/

WORD GameStatsToSeasonStats(WORD teamnum, struct teamRAMstats *fromptr)
{
EFFVAR index,p,statnum,stat,stattype;
WORD *statsetptr;

	if(SeasonStatsPtr == NULL)
		return(1);		// error

	if(teamnum < ZERO || teamnum >= NUM_TEAMS_IN_LEAGUE)	// better to be code wise than memory corrupt
		return(2);		// error

	for(p=0; p < TOTAL_PLAYERS_ON_TEAM; p++)  // player stats
	{

		// go thru list for all valid stats for each player
		statsetptr = GetStatsSetPtr(p);

		index = 0;	// go thru all valid stats for each player
		while((statnum = *(statsetptr++)) >= ZERO)	// -1 at end of stats list
		{
			stattype = StatTypeTable[statnum];
			stat = fromptr->posstats[p][index];

			UpdateStatBasedOnType(&((SeasonStatsPtr+teamnum)->posstats[p][index]),
						 stattype,stat);
			index++;
		}
	}

	for(statnum=0; statnum< MAX_NUM_STATS_1TEAM; statnum++)
	{	// all the team stats - and Opponent stats

		stattype = StatTypeTable[statnum];
		stat = fromptr->allplyrstats[statnum];

		UpdateStatBasedOnType(&((SeasonStatsPtr+teamnum)->allplyrstats[statnum]),
						 stattype,stat);

		stat = fromptr->alloppplyrstats[statnum];
		UpdateStatBasedOnType(&((SeasonStatsPtr+teamnum)->alloppplyrstats[statnum]),
						 stattype,stat);

	}

	FigureTeamQBRating((struct teamRAMstats *) (SeasonStatsPtr+teamnum));

	return(0);	// i.e. no error
}




// following MUST be called AFTER "GameStatsToSeasonStats(WORD teamnum, struct teamRAMstats *fromptr)"

WORD UpdateSeasonGameScores(WORD seasongamenum, struct teamRAMstats *fromptrhometeam)
{   // returns ZERO if error

	if(MemoryCardMimicPtr == NULL)
		return(0);	// error code

	if(seasongamenum < 0 || seasongamenum >= NUM_ALL_SEASON_GAMES)
		return(0);	// error code

	MemoryCardMimicPtr->GameScores[seasongamenum][0] =		// home team
			fromptrhometeam->allplyrstats[GS_TOTAL_SCORE];

	MemoryCardMimicPtr->GameScores[seasongamenum][1] =	//opponent (away) team
			fromptrhometeam->alloppplyrstats[GS_TOTAL_SCORE];

	return(1);
}



WORD GetPlayerGameStatsViaPtr(struct teamRAMstats *TRptr, WORD pos0_46, WORD statnum)
{
EFFVAR index;		// used for RAM stats only!!


	if( (index = ValidStatForPos(pos0_46,statnum)) >= ZERO)
	{
		return(TRptr->posstats[pos0_46][index]);

	}
	else	//flag the error
	{
#if	PC_ERROR_MODE
		printf("\nInvalid Get PTR Index %d - pos(%d)-%s",statnum,pos0_46,PositionStrings[pos0_46]);
//		printf("\nInvalid Gets Stats Index %d - pos = %d",statnum,pos0_46);
#endif
		return(ILLEGAL_STAT);
	}
}




/*
void FigureQBRating1(struct teamRAMstats *TRptr)
{
WORD p,i;

float comps,yards,tds,ints,atts;
float step[5];

	for(p=0; p < NUM_QBs; p++)  // QBs are first three players
	{

		atts = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_ATT);
		if(atts <= ZERO) // screens illegal and divide by ZERO
			return;

		comps = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_COMP);
		yards = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_YARDS);
		tds = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_TD);
		ints = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_INT);


//		step[0] = ((comps/atts)-0.3)/0.2;
		step[0] = ((comps/atts)-0.3)*5;

		step[1] = ((yards/atts)-3)/4;
//		step[2] = (tds/atts)/0.05;
		step[2] = (tds/atts)*20;
//		step[3] = (0.095 -(ints/atts))/0.04;
		step[3] = (0.095 -(ints/atts))*25;

		step[4] = 0;

		for(i=0; i<4; i++)
		{
			if(step[i] < ZERO)
				step[i] = ZERO;
			else if(step[i] > 2.375)
				step[i] = 2.375;
			step[4] += step[i];
		}

		step[4] *=100;
		step[4] /=6;


		printf("\nQB ratings %d = %f,%f,%f,%f,%f",p,step[0],step[1],step[2],step[3],step[4]);

	}

}

*/
void FigureTeamQBRating(struct teamRAMstats *TRptr)
{				// use LONG (no floats) and scale by 1000
EFFVAR p,i;		// this is a pretty weird way to rate QBs

LONG comps,yards,tds,ints,atts;
LONG step[5];

	for(p=QB; p <= QB3; p++)  // QBs are first three players
	{
		step[4] = 0L;	// start with zero

		atts = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_ATT);
		if(atts > 0L) // screens illegal and divide by ZERO
		{
			comps = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_COMP);
			yards = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_YARDS);
			tds = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_TD);
			ints = GetPlayerGameStatsViaPtr(TRptr, p, GS_PASS_INT);

		/* show your work my old math teacher used to say	*/
	//		step[0] = ((comps/atts)-0.3)/0.2;
	//		step[0] = ((comps/atts)-0.3)*5;
			step[0] = ((comps*1000/atts)-300)*5;

	//		step[1] = ((yards/atts)-3)/4;
			step[1] = ((yards*1000/atts)-3000)/4;

	//		step[2] = (tds/atts)/0.05;
	//		step[2] = (tds/atts)*20;
			step[2] = (tds*1000/atts)*20;

	//		step[3] = (0.095 -(ints/atts))/0.04;
	//		step[3] = (0.095 -(ints/atts))*25;
			step[3] = (95 -(ints*1000/atts))*25;


			for(i=0; i<4; i++)
			{
				if(step[i] < ZERO)
					step[i] = ZERO;
				else if(step[i] > 2375)
					step[i] = 2375;
				step[4] += step[i];
			}

			step[4] *=100;	// sum of all 4 times 100 divided by 6
			step[4] /=6;	// how the NFL got this I do not know

#if	PC_ALWAYS_MODE
//			printf("\nQB ratings %d = %ld,%ld,%ld,%ld,%ld",p,step[0],step[1],step[2],step[3],step[4]);
//			printf("  TRUE = %d.%d",step[4]/1000,(step[4]%1000L));

	//		printf("\nQB ratings %d = %f,%f,%f,%f,%f",p,step[0],step[1],step[2],step[3],step[4]);
#endif
		}

		/* WARNING - following only works if QB stats mimic the 1st 10
			team stats - normally need to get index via a routine */
		TRptr->posstats[p][GS_PASS_RATE] = step[4]/100;	// stat is scaled by 10
	}

}



#if	PC_ALWAYS_MODE		//-------------------------------------PC MODE

//#include "season.h"
/*********************************************************************

					P C  TEST GAME DATA

	The PC Simulator will spit out files for all games.  These pre-played
	games are stored on the consoles CD.  Therefore season simulation
	is as easy as accessing the CD for the correct game - each season
	game will have 22(?) outcomes - 10 win for home, 10 wins for away,
	and 2 ties.

*********************************************************************/

//#define MAX_GAME_OUTCOMES	10

void SaveGameDataAsFile(WORD seasongamenum)
{

FILE *out;
BYTE *tptr;
EFFVAR i,j,t0,t1;
BYTE oc[2] = {0,0};
BYTE fname[40];
struct ffblk ffblk;
EFFVAR sgn,max;

	sgn = seasongamenum;
	if(seasongamenum < 0 || seasongamenum >= NUM_ALL_SEASON_GAMES)
	{
		printf("\nIllegal Season Game Number - %d - Aborting",seasongamenum);
		return;
	}

	if(GameTeamData[HOME_TEAM_SLOT].TotalScore > GameTeamData[AWAY_TEAM_SLOT].TotalScore)
	{	// home team wins
		oc[0] = 'H';
		max = 8;
	}
	else if(GameTeamData[HOME_TEAM_SLOT].TotalScore < GameTeamData[AWAY_TEAM_SLOT].TotalScore)
	{	// away team wins
		oc[0] = 'A';
		max = 5;
	}
	else
	{
		oc[0] = 'T';
		max = 2;
	}


	t0 = GameTeamData[0].TeamNumber;
	t1 = GameTeamData[1].TeamNumber;

//	sprintf(fname,"G%02d%02d%s.GAM",t0,t1,oc);	//pad <10 with zeros
//	printf("\nfname = %s\n",fname);


	for(i=0; i<max; i++)
	{
//		sprintf(fname,"games\\G%02d\\G%03d\\G%02d%02d%s%02d.GAM",
//						sgn/10,sgn,t0,t1,oc,i);	//pad <10 with zeros

		// new dir format 10/9/96
//		sprintf(fname,"games\\game%d\\G%02d%02d%s%02d.GAM",
//						sgn,t0,t1,oc,i);
		// even newer dir format 10/22/96
		sprintf(fname,"games\\game%d\\G%02d%02d%s%02d.GM%d",
						sgn,t0,t1,oc,i,GameOptions[GAME_OPTNS_QTR_LENGTH]);


		//if a match was found, findfirst returns 0
		if(findfirst(fname,&ffblk,0) == ZERO)
		{
//		   printf("\n%s already exists", ffblk.ff_name);
		}
		else	// no match we can use this fname
		{
		   printf("\n%s not found... creating....\n", fname);

			if ((out = fopen(fname, "w+b"))	// write binary(not TEXT!)
				   == NULL)
			{
				printf("Cannot open output file %s.\n",fname);
					return;
			}

			tptr = (BYTE *) &StatsData[0];

			for(j = 0 ; j < sizeof(TEAMRAMStats)*2; j++)	// do both teams
				fputc(*tptr++, out);

			fclose(out);
			break;
		}
	}
	if(i >= max)
		printf("\nNo game output - all %d slots for this outcome filled",max);
}



WORD tie_games[] = {2, 3, 10, 16, 35, 40, 48, 71, 79, 103, 106, 110, 128,
				  131, 136, 137, 146, 167, 168, 198, 199, 205, 206, 211,
				  234, 239, -1};



BOOL SaveGameDirFull(WORD seasongamenum)
{

EFFVAR i,j,t0,t1;
BYTE oc[2] = {0,0};
BYTE ocall[3] = {'H','A','T'};
BYTE fname[40];
struct ffblk ffblk;
EFFVAR sgn;
WORD max[3] = {8,5,2};

	sgn = seasongamenum;
	if(seasongamenum < 0 || seasongamenum >= NUM_ALL_SEASON_GAMES)
	{
		printf("\nIllegal Season Game Number - %d - Aborting",seasongamenum);
		return(TRUE);
	}

	max[2] = 0;	// assume no ties are needed for this game
	i = ZERO;
	while(tie_games[i] >= ZERO)
	{
		if( sgn==tie_games[i])
		{
			max[2] = 2;
			break;
		}
		i++;
	}

	t0 = GameTeamData[0].TeamNumber;
	t1 = GameTeamData[1].TeamNumber;

	for(j=0; j<3; j++)
	{
		oc[0] = ocall[j];
		for(i=0; i<max[j]; i++)
		{
			sprintf(fname,"games\\game%d\\G%02d%02d%s%02d.GM%d",
						sgn,t0,t1,oc,i,GameOptions[GAME_OPTNS_QTR_LENGTH]);


			//if a match was found, findfirst returns 0
			if(findfirst(fname,&ffblk,0) == ZERO)
			{
	//		   printf("\n%s already exists", ffblk.ff_name);
			}
			else	// no match we can use this fname
			{
			   return(FALSE);	// not all used
			}
		}
	}
	return(TRUE);	// everything filled up

}



BYTE *PlayTypeName[MAX_PLAY_TYPES] = {
	"R","P","Pt","FG","Q","EP1","EP2","KO"};



void * AllocMem(long bytes);
void FreeMem(void *addr);
//void TestSeasonStats2MCMimic(void);
void TestMCData(void);

void DumpTeamStats(WORD team01)
{
WORD *tptr1, p,s,cc;

//	system("mode con: lines=50");	// let's look at all of them
//	TestSeasonStats2MCMimic();


	FigureTeamQBRating(&StatsData[team01]);		// all 3 QBs on this team

	printf("\nSize of all stats(1 team)= %d  All 30 teams = %ld"
		,sizeof(struct teamRAMstats ),(LONG)(NUM_TEAMS_IN_LEAGUE*sizeof(struct teamRAMstats)));
	printf("\nplyr/team = %d, stats/plyr = %d totalbytes %d, teamstats = %d",
			TOTAL_PLAYERS_ON_TEAM,
				MAX_STATS_PER_1PLAYER,
				(TOTAL_PLAYERS_ON_TEAM) * (MAX_STATS_PER_1PLAYER)*2,
				(MAX_NUM_STATS_1TEAM)*2);

	printf("\nstruct MCteamstats = %d  x30 = %d",
			sizeof(struct MCteamstats),NUM_TEAMS_IN_LEAGUE*sizeof(struct MCteamstats));

	printf("\nstruct memorycardmimic = %d   3 Mem blocks = 23688\n",
			sizeof(struct memorycardmimic));

	tptr1 = (WORD *) &StatsData[team01].posstats;
	for(p=0; p <TOTAL_PLAYERS_ON_TEAM; p++)
	{
		printf("%2.2s-",PositionStrings[p]);
		for(s=0; s<MAX_STATS_PER_1PLAYER; s++)
			printf("%3d",*(tptr1++));
		if(p&1)
			printf("\n");

	}
	printf("  %s stats follow -\n",SpecificTeamData[GameTeamData[team01].TeamNumber].TeamNickName);
	tptr1 = (WORD *) &StatsData[team01].allplyrstats;

	for(s=0,cc=0; s<MAX_NUM_STATS_1TEAM; s++,cc++)
	{	printf("%4d",*(tptr1++));
		if(cc%16 == 15 || s == GS_WIN-1)
		{
			printf("\n");
			cc=-1;
		}
	}
	printf("\t%s stats follow-\n",SpecificTeamData[GameTeamData[team01^1].TeamNumber].TeamNickName);
	tptr1 = (WORD *) &StatsData[team01].alloppplyrstats;
	for(s=0,cc=0; s<MAX_NUM_STATS_1TEAM; s++,cc++)
	{
		printf("%4d",*(tptr1++));
		if(cc%16 == 15 || s == GS_WIN-1)
		{
			printf("\n");
			cc=-1;
		}
	}

	for(p=0; p<2; p++)
	{
		cc= 0;
		printf("\n#of plays- Team %d ",p);
		for(s=0; s<MAX_PLAY_TYPES; s++)
		{
			printf("%s-%d ",PlayTypeName[s],PlayTypeCount[p][s]);
			cc += PlayTypeCount[p][s];
		}
		printf("Total=%d",cc);
	}

	printf("\nBlocking Type Count 0 = ");
	for(p=0; p<MAX_BLOCK_FACTORS; p++)
		printf("%4d ",BlockTypeCount[p]);	// for debugging

	printf("\nBlocking Type Count 1 = ");
	for(p=0; p<MAX_BLOCK_FACTORS; p++)
		printf("%4d ",BlockTypeCountActual[p]);	// for debugging


/*
	for(i = 0 ; i <sizeof(TEAMRAMStats)/2; i++)	// printing WORDS
	{
		if(i%12 == ZERO)
		{
			j = i/12;
			if(j == 49)
				printf("  team stats follow -\n");
			if(j < 49)
				printf("%2d-",j);
		}
		printf("%2d ",*(tptr1++));
		if(i%24 == 23)
			printf("\n");
	}
*/
//	getch();
}



void TestStatsFileUpdate(void)
{
WORD *tempptr;
WORD error,i,t;
WORD q=253;

	printf("\nsize of teamRam stats is %d\n",sizeof(TEAMRAMStats));

	OffensiveSlotNum = 1;
	DefensiveSlotNum = OffensiveSlotNum^1;

	OPMyPNum(0)	= QB2;	// init positions
	OPMyPNum(5)	= FB2;

	UpdateStats(0, GS_PASS_ATT,q++);
	UpdateStats(0, GS_PASS_COMP,q++);
	UpdateStats(0, GS_PASS_YARDS,q++);
	UpdateStats(0, GS_PASS_LONG,q++);
	UpdateStats(0, GS_PASS_TD,q++);
	UpdateStats(0, GS_PASS_INT,q++);
	UpdateStats(0, GS_RUSH_ATT,q++);
	UpdateStats(0, GS_RUSH_YARDS,q++);
	UpdateStats(0, GS_RUSH_TD,q++);
	UpdateStats(0, GS_RUSH_LONG,q++);
	UpdateStats(0, GS_CONV_NUM,q++);

	UpdateStats(5, GS_RUSH_ATT,q++);
	UpdateStats(5, GS_RUSH_YARDS,q++);
	UpdateStats(5, GS_RUSH_TD,q++);
	UpdateStats(5, GS_RUSH_LONG,q++);
	UpdateStats(5, GS_CONV_NUM,q++);

	DumpTeamStats(0);


	/* set aside memory for saving season stats Data	*/
//	SeasonStatsPtr = (TEAMRAMStats *) AllocMem(10 * sizeof(TEAMRAMStats));
	SeasonStatsPtr = (TEAMRAMStats *) AllocMem(NUM_TEAMS_IN_LEAGUE * sizeof(TEAMRAMStats));


	if (SeasonStatsPtr !=  NULL)	// clear recently allocated area
		memset(SeasonStatsPtr,0, NUM_TEAMS_IN_LEAGUE * sizeof(TEAMRAMStats));

	error = GameStatsToSeasonStats(0,&StatsData[0]);

	error = GameStatsToSeasonStats(3,&StatsData[1]);	//team 3 in slot 1

	if(error)
	{
		printf("\nError of TestStatsFileUpdate, status = %d",error);
		getch();
	}
	else if ( SeasonStatsPtr !=  NULL)
	{
		tempptr = (WORD *) SeasonStatsPtr;
		for(t=0; t<5; t++)
//		for(t=0; t<1; t++)
		{
			printf("\n");
			for(i = 0 ; i < sizeof(TEAMRAMStats)/2; i++)	// printing WORDs so x/2
			{
				printf("%2d ",*(tempptr++));
				if(i%24 == 23)
					printf("\n");
			}
			printf("end of team %d",t);
			if(getch() ==  0x1b)	// ESCAPE
				break;
		}

	}

//	TeamSeasonStatsToMemoryCardMimic(0);
	TestMCData();


	if ( SeasonStatsPtr !=  NULL)
	{
		FreeMem(SeasonStatsPtr);
	}

//	SaveGameDataAsFile(2);
//	SaveGameDataAsFile(22);
//	SaveGameDataAsFile(222);

}

/*
void TestSimSeason(void)
{
WORD sg,i;

	for(sg=0; sg < 2; sg++)
	{

		GameTeamData[0].TeamNumber = schedule[sg].home;
		GameTeamData[1].TeamNumber = schedule[sg].away;

		GameTeamData[0].TotalScore = sg+1;
		GameTeamData[1].TotalScore = 0;

		for(i=0; i<3; i++)	// 3 games --> win for both and tie
		{
			ClearAllGameStats();	// for both teams - 1 game
			UpdateFinalGameStats();	// moves score to stats
			SaveGameDataAsFile(sg);
			GameTeamData[1].TotalScore += sg+1;
		}


	}
}
*/


extern struct memorycardmimic MemoryCardMimic;
struct memorycardmimic MemoryCardMimic2;


#endif	//PC_ALWAYS_MODE


/**********************************************************************


		 S E A S O N      D A T A     T O    C A R D    D A T A

	Converts WORD based [player] Season data to condensed data structure
	to store on Memory card

	Converts any "small" data from SeasonWORD to CardBYTE and doesn't
	store used data (i.e. each player had 12 stats, but Off. Lineman
	only used 1, so Card data only has one byte).

	As of 8/19/96, reduces 41K Season data to 23K so it can fit on 3 slots
	on PSX memory card.

**********************************************************************/

BYTE S16toU8(WORD in)	// convert WORD to BYTE checking for overflow
{
	if(in > 255)
		in = 255;
	return((BYTE)in);
}
//OR #define S16toU8(in)	(BYTE)(in >255 ? 255:in)

#define MC_DEBUG	0
#define MC_DEBUG1	0


/****  WARNING ----WARNING ----WARNING ----WARNING ----WARNING ----WARNING ----
	 although spelled the same, "stat_enum" are different
	depending on the structure or array index they reference
	i.e. let the compiler figure it out.
	Also - SeasonStatsPtr had better be valid
--------------------------------------------------------------*/
#if MC_DEBUG1		\

#define S2MCConvert16(ptr,stat_enum) \
	if( (stat = GetPlayerSeasonStats(tnum,pos,stat_enum)) != ILLEGAL_STAT)\
	{	ptr->stat_enum = stat;  } \
	else {	printf("Illegal S2MC Stats"); getch();}	\

#define S2MCConvert8(ptr,stat_enum) \
	if( (stat = GetPlayerSeasonStats(tnum,pos,stat_enum)) != ILLEGAL_STAT)\
	{	ptr->stat_enum = S16toU8(stat);  } \
	else {	printf("Illegal  S2MC Stats");getch(); }\

#else

#define S2MCConvert16(ptr,stat_enum) \
	if( (stat = GetPlayerSeasonStats(tnum,pos,stat_enum)) != ILLEGAL_STAT)\
	{	ptr->stat_enum = stat;  }

#define S2MCConvert8(ptr,stat_enum) \
	if( (stat = GetPlayerSeasonStats(tnum,pos,stat_enum)) != ILLEGAL_STAT)\
	{	ptr->stat_enum = S16toU8(stat);  }

#endif

void TeamSeasonStatsToMemoryCardMimic(WORD tnum)
{
struct memorycardmimic *MCMPtr;
struct MCRBstats	*MCRBStatsPtr;  // these are valid stats for all Running backs
struct MCRecstats 	*MCRecStatsPtr; // these are valid stats for Receivers
struct MCOLstats 	*MCOLStatsPtr;	// these are valid stats Offensive Line
struct MCDefstats 	*MCDefStatsPtr;	// these are valid stats for all defensive guys
struct MCKickerstats *MCKStatsPtr;	// these are valid stats for Kicker OR punter
struct MCPunterstats *MCPStatsPtr;	// these are valid stats for punter
struct MCKRstats 	*MCKRStatsPtr;// these are valid stats for Kick OR punt Returner

struct MCQBstats	*MCQBStatsPtr;
EFFVAR i;
EFFVAR stat,pos;
WORD *wptr1,*wptr2;

#if MC_DEBUG
BYTE *ptr;
EFFVAR j;
struct MCteamstats *MCTeamStatsPtr;
#endif //MC_DEBUG

//	tnum = 0;
//	pos = 0;

#if PC_ALWAYS_MODE
	MCMPtr = &MemoryCardMimic2;	// pc uses this area for test verification
#else
//	MCMPtr = &MemoryCardMimic;
	MCMPtr = MemoryCardMimicPtr;	// local = global

#endif
	if(MCMPtr == NULL)
		return;

#if MC_DEBUG
	MCTeamStatsPtr = MCMPtr->MCTeamStats;
	printf("\nMCMPtr =         %ld",MCMPtr);
	printf("\nMCTeamStatsPtr = %ld",MCTeamStatsPtr);
#endif //MC_DEBUG

	for(i=0, pos=START_POS_QBs; i <NUM_QBs; i++,pos++)
	{
		MCQBStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCQBStats[i]);
#if MC_DEBUG

		printf("\nMCMPtr =         %ld",MCMPtr);
		printf("\nMCTeamStatsPtr = %ld",MCTeamStatsPtr);
		printf("\nMCQBStatsPtr =   %ld",MCQBStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCQBStatsPtr,GS_PASS_ATT)
		S2MCConvert16(MCQBStatsPtr,GS_PASS_COMP)
		S2MCConvert16(MCQBStatsPtr,GS_PASS_YARDS)
		S2MCConvert16(MCQBStatsPtr,GS_RUSH_ATT)
		S2MCConvert16(MCQBStatsPtr,GS_RUSH_YARDS)

		S2MCConvert8(MCQBStatsPtr,GS_PASS_LONG)
		S2MCConvert8(MCQBStatsPtr,GS_PASS_TD)
		S2MCConvert8(MCQBStatsPtr,GS_PASS_INT)
		S2MCConvert8(MCQBStatsPtr,GS_RUSH_TD)
		S2MCConvert8(MCQBStatsPtr,GS_RUSH_LONG)
		S2MCConvert8(MCQBStatsPtr,GS_CONV_NUM)

#if MC_DEBUG
		ptr =  (BYTE *) MCQBStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_RBs; i <NUM_RBs; i++,pos++)
	{
		MCRBStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCRBStats[i]);

		S2MCConvert16(MCRBStatsPtr,GS_RUSH_ATT)
		S2MCConvert16(MCRBStatsPtr,GS_RUSH_YARDS)
		S2MCConvert16(MCRBStatsPtr,GS_RECP_YARDS)

		S2MCConvert8(MCRBStatsPtr,GS_RUSH_TD)
		S2MCConvert8(MCRBStatsPtr,GS_RUSH_LONG)

		S2MCConvert8(MCRBStatsPtr,GS_RECP_NUM)
		S2MCConvert8(MCRBStatsPtr,GS_RECP_LONG)
		S2MCConvert8(MCRBStatsPtr,GS_RECP_TD)
		S2MCConvert8(MCRBStatsPtr,GS_CONV_NUM)

#if MC_DEBUG
		ptr =  (BYTE *) MCRBStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG


	for(i=0, pos=START_POS_RECs; i <NUM_RECs; i++,pos++)
	{
		MCRecStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCRecStats[i]);
#if MC_DEBUG
		printf("\nMCRecStatsPtr =   %ld",MCRecStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCRecStatsPtr,GS_RECP_YARDS)
		S2MCConvert16(MCRecStatsPtr,GS_RUSH_YARDS)

		S2MCConvert8(MCRecStatsPtr,GS_RECP_NUM)
		S2MCConvert8(MCRecStatsPtr,GS_RECP_LONG)
		S2MCConvert8(MCRecStatsPtr,GS_RECP_TD)
		S2MCConvert8(MCRecStatsPtr,GS_CONV_NUM)
		S2MCConvert8(MCRecStatsPtr,GS_RUSH_ATT)
		S2MCConvert8(MCRecStatsPtr,GS_RUSH_TD)
		S2MCConvert8(MCRecStatsPtr,GS_RUSH_LONG)

#if MC_DEBUG
		ptr =  (BYTE *) MCRecStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_OLs; i <NUM_OLs; i++,pos++)
	{
		MCOLStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCOLStats[i]);
#if MC_DEBUG
		printf("\nMCOLStatsPtr =   %ld",MCOLStatsPtr);
#endif //MC_DEBUG

		S2MCConvert8(MCOLStatsPtr,GS_SACK_ALLOWED)

#if MC_DEBUG
		ptr =  (BYTE *) MCOLStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_DEFs; i <NUM_DEFs; i++,pos++)
	{
		MCDefStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCDefStats[i]);
#if MC_DEBUG
		printf("\nMDefStatsPtr =   %ld",MCDefStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCDefStatsPtr,GS_TACK_NUM)
		S2MCConvert16(MCDefStatsPtr,GS_INT_YARDS)

		S2MCConvert8(MCDefStatsPtr,GS_SACK_NUM)
		S2MCConvert8(MCDefStatsPtr,GS_FUMFORCE)
		S2MCConvert8(MCDefStatsPtr,GS_FUMRECOV)
		S2MCConvert8(MCDefStatsPtr,GS_INT_NUM)
		S2MCConvert8(MCDefStatsPtr,GS_INT_TD)
		S2MCConvert8(MCDefStatsPtr,GS_FUM_TD)
		S2MCConvert8(MCDefStatsPtr,GS_INT_LONG)

#if MC_DEBUG
		ptr =  (BYTE *) MCDefStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_Ks; i <NUM_Ks; i++,pos++)
	{
		MCKStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCKickerStats[i]);
#if MC_DEBUG
		printf("\nMCKStatsPtr =   %ld",MCKStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCKStatsPtr,GS_PUNT_YARDS)

		S2MCConvert8(MCKStatsPtr,GS_PAT)
		S2MCConvert8(MCKStatsPtr,GS_PAT_ATT)
		S2MCConvert8(MCKStatsPtr,GS_FG)
		S2MCConvert8(MCKStatsPtr,GS_FG_ATT)
		S2MCConvert8(MCKStatsPtr,GS_FG_LONG)
		S2MCConvert8(MCKStatsPtr,GS_FG_BLK)


		S2MCConvert8(MCKStatsPtr,GS_PUNT)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_LONG)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_IN20)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_TB)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_BLK)

#if MC_DEBUG
		ptr =  (BYTE *) MCKStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_Ps; i <NUM_Ps; i++,pos++)
	{
		MCPStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCPunterStats[i]);
#if MC_DEBUG
		printf("\nMPStatsPtr =   %ld",MCPStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCPStatsPtr,GS_PUNT_YARDS)

		S2MCConvert8(MCPStatsPtr,GS_PUNT)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_LONG)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_IN20)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_TB)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_BLK)

		S2MCConvert8(MCPStatsPtr,GS_PAT)
		S2MCConvert8(MCPStatsPtr,GS_PAT_ATT)
		S2MCConvert8(MCPStatsPtr,GS_FG)
		S2MCConvert8(MCPStatsPtr,GS_FG_ATT)
		S2MCConvert8(MCPStatsPtr,GS_FG_LONG)
		S2MCConvert8(MCPStatsPtr,GS_FG_BLK)


#if MC_DEBUG
		ptr =  (BYTE *) MCPStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_KRs; i <NUM_KRs; i++,pos++)
	{
		MCKRStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCKRStats[i]);
#if MC_DEBUG
		printf("\nMCKRStatsPtr =   %ld",MCKRStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCKRStatsPtr,GS_KRET_YARDS)
		S2MCConvert16(MCKRStatsPtr,GS_PRET_YARDS)

		S2MCConvert8(MCKRStatsPtr,GS_KRET_NUM)
		S2MCConvert8(MCKRStatsPtr,GS_KRET_TD)
		S2MCConvert8(MCKRStatsPtr,GS_PRET_NUM)
		S2MCConvert8(MCKRStatsPtr,GS_PRET_TD)
		S2MCConvert8(MCKRStatsPtr,GS_KRET_LONG)
		S2MCConvert8(MCKRStatsPtr,GS_PRET_LONG)

#if MC_DEBUG
		ptr =  (BYTE *) MCKRStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
	getch();
#endif //MC_DEBUG

//  now move team stats

	wptr1 = MCMPtr->MCTeamStats[tnum].allplyrstats;
	wptr2 = MCMPtr->MCTeamStats[tnum].alloppplyrstats;
//	struct MCteamstats MCTeamStats[30].allplyrstats[MAX_NUM_STATS_1TEAM];

	for(i=0; i< MAX_NUM_STATS_1TEAM; i++)
	{	// all the team stats - and Opponent stats

		*wptr1++ = (SeasonStatsPtr+tnum)->allplyrstats[i];

		*wptr2++ = (SeasonStatsPtr+tnum)->alloppplyrstats[i];
	}

}

#undef S2MCConvert8
#undef S2MCConvert16



/*---------------------------------------------------------------------*/
#if MC_DEBUG1		\

#define S2MCConvert8(ptr,stat_enum) \
	if( (index = ValidStatForPos( pos,stat_enum)) >= ZERO)	\
		(SeasonStatsPtr+tnum)->posstats[pos][index] = ptr->stat_enum; \
	else {	printf("Illegal  MC2S Stats");getch(); } \

#define S2MCConvert16(ptr,stat_enum) \
	if( (index = ValidStatForPos( pos,stat_enum)) >= ZERO)	\
		(SeasonStatsPtr+tnum)->posstats[pos][index] = ptr->stat_enum; \
	else {	printf("Illegal  MC2S Stats");getch(); }	\

#else
#define S2MCConvert8(ptr,stat_enum) \
	if( (index = ValidStatForPos( pos,stat_enum)) >= ZERO)	\
		(SeasonStatsPtr+tnum)->posstats[pos][index] = ptr->stat_enum;

#define S2MCConvert16(ptr,stat_enum) \
	if( (index = ValidStatForPos( pos,stat_enum)) >= ZERO)	\
		(SeasonStatsPtr+tnum)->posstats[pos][index] = ptr->stat_enum;

#endif


void TeamMemoryCardMimicToSeasonStats(WORD tnum)
{
struct memorycardmimic *MCMPtr;
struct MCRBstats	*MCRBStatsPtr;  // these are valid stats for all Running backs
struct MCRecstats 	*MCRecStatsPtr; // these are valid stats for Receivers
struct MCOLstats 	*MCOLStatsPtr;	// these are valid stats Offensive Line
struct MCDefstats 	*MCDefStatsPtr;	// these are valid stats for all defensive guys
struct MCKickerstats *MCKStatsPtr;	// these are valid stats for Kicker OR punter
struct MCPunterstats *MCPStatsPtr;	// these are valid stats for punter
struct MCKRstats 	*MCKRStatsPtr;// these are valid stats for Kick OR punt Returner

struct MCQBstats	*MCQBStatsPtr;
WORD *wptr1,*wptr2;
EFFVAR i;
EFFVAR index,pos;

#if MC_DEBUG
BYTE *ptr;
EFFVAR j;
struct MCteamstats *MCTeamStatsPtr;
#endif //MC_DEBUG

//	tnum = 0;
//	pos = 0;

//	MCMPtr = &MemoryCardMimic;
	MCMPtr = MemoryCardMimicPtr;	// local = global

	if(MCMPtr == NULL)
		return;


#if MC_DEBUG
	MCTeamStatsPtr = MCMPtr->MCTeamStats;
	printf("\nMCMPtr =         %ld",MCMPtr);
	printf("\nMCTeamStatsPtr = %ld",MCTeamStatsPtr);
#endif //MC_DEBUG

	for(i=0, pos=START_POS_QBs; i <NUM_QBs; i++,pos++)
	{
		MCQBStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCQBStats[i]);
#if MC_DEBUG
		printf("\nMCMPtr =         %ld",MCMPtr);
		printf("\nMCTeamStatsPtr = %ld",MCTeamStatsPtr);
		printf("\nMCQBStatsPtr =   %ld",MCQBStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCQBStatsPtr,GS_PASS_ATT)
		S2MCConvert16(MCQBStatsPtr,GS_PASS_COMP)
		S2MCConvert16(MCQBStatsPtr,GS_PASS_YARDS)
		S2MCConvert16(MCQBStatsPtr,GS_RUSH_ATT)
		S2MCConvert16(MCQBStatsPtr,GS_RUSH_YARDS)

		S2MCConvert8(MCQBStatsPtr,GS_PASS_LONG)
		S2MCConvert8(MCQBStatsPtr,GS_PASS_TD)
		S2MCConvert8(MCQBStatsPtr,GS_PASS_INT)
		S2MCConvert8(MCQBStatsPtr,GS_RUSH_TD)
		S2MCConvert8(MCQBStatsPtr,GS_RUSH_LONG)
		S2MCConvert8(MCQBStatsPtr,GS_CONV_NUM)
#if MC_DEBUG
		ptr =  (BYTE *) MCQBStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_RBs; i <NUM_RBs; i++,pos++)
	{
		MCRBStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCRBStats[i]);

		S2MCConvert16(MCRBStatsPtr,GS_RUSH_ATT)
		S2MCConvert16(MCRBStatsPtr,GS_RUSH_YARDS)
		S2MCConvert16(MCRBStatsPtr,GS_RECP_YARDS)

		S2MCConvert8(MCRBStatsPtr,GS_RUSH_TD)
		S2MCConvert8(MCRBStatsPtr,GS_RUSH_LONG)

		S2MCConvert8(MCRBStatsPtr,GS_RECP_NUM)
		S2MCConvert8(MCRBStatsPtr,GS_RECP_LONG)
		S2MCConvert8(MCRBStatsPtr,GS_RECP_TD)
		S2MCConvert8(MCRBStatsPtr,GS_CONV_NUM)
#if MC_DEBUG
		ptr =  (BYTE *) MCRBStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG


	for(i=0, pos=START_POS_RECs; i <NUM_RECs; i++,pos++)
	{
		MCRecStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCRecStats[i]);
#if MC_DEBUG
		printf("\nMCRecStatsPtr =   %ld",MCRecStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCRecStatsPtr,GS_RECP_YARDS)
		S2MCConvert16(MCRecStatsPtr,GS_RUSH_YARDS)

		S2MCConvert8(MCRecStatsPtr,GS_RECP_NUM)
		S2MCConvert8(MCRecStatsPtr,GS_RECP_LONG)
		S2MCConvert8(MCRecStatsPtr,GS_RECP_TD)
		S2MCConvert8(MCRecStatsPtr,GS_CONV_NUM)
		S2MCConvert8(MCRecStatsPtr,GS_RUSH_ATT)
		S2MCConvert8(MCRecStatsPtr,GS_RUSH_TD)
		S2MCConvert8(MCRecStatsPtr,GS_RUSH_LONG)

#if MC_DEBUG
		ptr =  (BYTE *) MCRecStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_OLs; i <NUM_OLs; i++,pos++)
	{
		MCOLStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCOLStats[i]);
#if MC_DEBUG
		printf("\nMCOLStatsPtr =   %ld",MCOLStatsPtr);
#endif //MC_DEBUG

		S2MCConvert8(MCOLStatsPtr,GS_SACK_ALLOWED)

#if MC_DEBUG

		ptr =  (BYTE *) MCOLStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_DEFs; i <NUM_DEFs; i++,pos++)
	{
		MCDefStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCDefStats[i]);
#if MC_DEBUG
		printf("\nMDefStatsPtr =   %ld",MCDefStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCDefStatsPtr,GS_TACK_NUM)
		S2MCConvert16(MCDefStatsPtr,GS_INT_YARDS)

		S2MCConvert8(MCDefStatsPtr,GS_SACK_NUM)
		S2MCConvert8(MCDefStatsPtr,GS_FUMFORCE)
		S2MCConvert8(MCDefStatsPtr,GS_FUMRECOV)
		S2MCConvert8(MCDefStatsPtr,GS_INT_NUM)
		S2MCConvert8(MCDefStatsPtr,GS_INT_TD)
		S2MCConvert8(MCDefStatsPtr,GS_FUM_TD)
		S2MCConvert8(MCDefStatsPtr,GS_INT_LONG)

#if MC_DEBUG

		ptr =  (BYTE *) MCDefStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_Ks; i <NUM_Ks; i++,pos++)
	{
		MCKStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCKickerStats[i]);
#if MC_DEBUG
		printf("\nMCKStatsPtr =   %ld",MCKStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCKStatsPtr,GS_PUNT_YARDS)

		S2MCConvert8(MCKStatsPtr,GS_PAT)
		S2MCConvert8(MCKStatsPtr,GS_PAT_ATT)
		S2MCConvert8(MCKStatsPtr,GS_FG)
		S2MCConvert8(MCKStatsPtr,GS_FG_ATT)
		S2MCConvert8(MCKStatsPtr,GS_FG_LONG)
		S2MCConvert8(MCKStatsPtr,GS_FG_BLK)


		S2MCConvert8(MCKStatsPtr,GS_PUNT)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_LONG)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_IN20)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_TB)
		S2MCConvert8(MCKStatsPtr,GS_PUNT_BLK)

#if MC_DEBUG

		ptr =  (BYTE *) MCKStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_Ps; i <NUM_Ps; i++,pos++)
	{
		MCPStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCPunterStats[i]);
#if MC_DEBUG
		printf("\nMPStatsPtr =   %ld",MCPStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCPStatsPtr,GS_PUNT_YARDS)

		S2MCConvert8(MCPStatsPtr,GS_PUNT)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_LONG)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_IN20)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_TB)
		S2MCConvert8(MCPStatsPtr,GS_PUNT_BLK)

		S2MCConvert8(MCPStatsPtr,GS_PAT)
		S2MCConvert8(MCPStatsPtr,GS_PAT_ATT)
		S2MCConvert8(MCPStatsPtr,GS_FG)
		S2MCConvert8(MCPStatsPtr,GS_FG_ATT)
		S2MCConvert8(MCPStatsPtr,GS_FG_LONG)
		S2MCConvert8(MCPStatsPtr,GS_FG_BLK)


#if MC_DEBUG
		ptr =  (BYTE *) MCPStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
#endif //MC_DEBUG

	for(i=0, pos=START_POS_KRs; i <NUM_KRs; i++,pos++)
	{
		MCKRStatsPtr = &(MCMPtr->MCTeamStats[tnum].MCKRStats[i]);
#if MC_DEBUG
		printf("\nMCKRStatsPtr =   %ld",MCKRStatsPtr);
#endif //MC_DEBUG

		S2MCConvert16(MCKRStatsPtr,GS_KRET_YARDS)
		S2MCConvert16(MCKRStatsPtr,GS_PRET_YARDS)

		S2MCConvert8(MCKRStatsPtr,GS_KRET_NUM)
		S2MCConvert8(MCKRStatsPtr,GS_KRET_TD)
		S2MCConvert8(MCKRStatsPtr,GS_PRET_NUM)
		S2MCConvert8(MCKRStatsPtr,GS_PRET_TD)
		S2MCConvert8(MCKRStatsPtr,GS_KRET_LONG)
		S2MCConvert8(MCKRStatsPtr,GS_PRET_LONG)

#if MC_DEBUG
		ptr =  (BYTE *) MCKRStatsPtr;
		printf("\n");
		for(j=0; j<20; j++)
			printf("%02x ",*(ptr+j));
#endif //MC_DEBUG

	}
#if MC_DEBUG
	printf("\n");
	getch();
#endif //MC_DEBUG

//  now move team stats

	wptr1 = MCMPtr->MCTeamStats[tnum].allplyrstats;
	wptr2 = MCMPtr->MCTeamStats[tnum].alloppplyrstats;
//	struct MCteamstats MCTeamStats[30].allplyrstats[MAX_NUM_STATS_1TEAM];

	for(i=0; i< MAX_NUM_STATS_1TEAM; i++)
	{	// all the team stats - and Opponent stats

		(SeasonStatsPtr+tnum)->allplyrstats[i] = *wptr1++;

		(SeasonStatsPtr+tnum)->alloppplyrstats[i] =	*wptr2++;
	}


	// figure QB rating for all 3 QBs on team
	FigureTeamQBRating((struct teamRAMstats *) (SeasonStatsPtr+tnum));


}

#undef S2MCConvert8
#undef S2MCConvert16


/*--------------------------------------------------------------------*/

WORD AllTeamSeasonStatsToMemoryCardMimic(void)	// returns 0 if okay
{	// moves season data to memory card mimic
EFFVAR t,errorcode = 0;

	if(SeasonStatsPtr == NULL)
	{
		errorcode = 1;
	}
	else
	{
		for(t=0; t< NUM_TEAMS_IN_LEAGUE; t++)
			TeamSeasonStatsToMemoryCardMimic(t);
	}
	return (errorcode);
};


void SetMemory(void *area, BYTE setto, UWORD n);


WORD AllTeamMemoryCardMimicToSeasonStats(void)	// returns 0 if okay
{  	// moves  memory card mimic data to season data  (not passwords)

EFFVAR t,errorcode = 0;

	if(SeasonStatsPtr == NULL)
	{
		errorcode = 1;
	}
	else
	{
		SetMemory(SeasonStatsPtr,0, NUM_TEAMS_IN_LEAGUE * sizeof(TEAMRAMStats));
//		SetMem(SeasonStatsPtr, 0x00, sizeof(struct teamRAMstats) * NUM_TEAMS_IN_LEAGUE);
		for(t=0; t < NUM_TEAMS_IN_LEAGUE; t++)
			TeamMemoryCardMimicToSeasonStats(t);
	}
	return (errorcode);
};





#if PC_ALWAYS_MODE



void TestMCData(void)
{
BYTE *bptr,*bptr1;
EFFVAR i;
EFFVAR miss = 0;

	// 1) fill MC1 with test data & MC2 with non test data
	bptr = ((void *)&MemoryCardMimic);
	bptr1 = (void *)&MemoryCardMimic2;
	for(i=0; i< sizeof(struct memorycardmimic); i++)
	{
		*bptr++ = (BYTE)i&0x7f;
//		*bptr1++ = 0x80;
	}

	SetMemory(&MemoryCardMimic2, 0x80, sizeof(struct memorycardmimic));

	// 2) send to Season data
	if(AllTeamMemoryCardMimicToSeasonStats())	// returns 0 if okay
	{
		printf("\nError on AllTeamMemoryCardMimicToSeasonStats");
	}
	// 3) back to [different] memcard
	else if(AllTeamSeasonStatsToMemoryCardMimic())	// returns 0 if okay
	{
		printf("\nError on AllTeamSeasonStatsToMemoryCardMimic");
	}
	else
	{		// verify data on the 2 mem cards

		bptr = (void *)&MemoryCardMimic;
		bptr1 = (void *)&MemoryCardMimic2;
		for(i=0; i< sizeof(struct memorycardmimic); i++)
			if(*bptr++ != *bptr1++)
			{
//				printf("%d ",i);
				miss++;
			}
		printf("\n#of misses = %d",miss);
		getch();
	}
}

#endif		// PC_ALWAYS_MODE


void SetMemory(void *area, BYTE setto, UWORD n)
{
EFFVAR i;
BYTE *bptr;

	bptr = area;
	for(i=0; i< n; i++)
	{
		*bptr++ = setto;
	}
}


struct sublist {
	BYTE startpos;
	BYTE endpos;
	BYTE numstarters;
	BYTE *posname;
};

#define NUM_DEPTH_POSITIONS 9

struct sublist DepthChart[NUM_DEPTH_POSITIONS] = {
	QB,QB3,1,"QUARTERBACKS",
	FB,FB2,2,"RUNNING BACKS",
	RR,TE3,3,"RECEIVERS",		// and Tight Ends
	LT,OL7,5,"OFFENSIVE LINE",
	DLE,DL6,4,"DEFENSIVE LINE",
	OLLB,LB6,3,"LINEBACKERS",
	FS,DB8,4,"DEFENSIVE BACKS",
	PUNT_RETURNER,KR3,1,"PUNT RETURNERS",
	PUNT_RETURNER,KR3,1,"KICK RETURNERS",
};



WORD ControllerToTeam(WORD controllernum)	// returns teamslot (-1,0,1) based on controller num
{
EFFVAR i,j;

	if(controllernum < 0 || controllernum >= MAX_CONTROLLERS) // error
		return(-1);

	for(j=0; j<2; j++)
		for(i=0; i<MAX_USERS_PER_TEAM; i++)
			if(GameTeamData[j].ControllerNum[i] == controllernum)
				return (j);

	return(-1);	// must be CPU team-controllernum not in Team's controller array
}


/***************************  End of File - FBStats.c  *******************/
