/*******************************************************************

		File: FBTestAI.c

	Copyright 1995  GameTek, Inc.


	Author: Chris Deel - original
			Mike Knauer - modified to graphic format



	This file allows user to input football play number to test.

	Will then give a graphic representation as to where the players
	will go.

	OR  a debug (text) version of what's happening

	Major Modification Dates:
	April 26, 1995
	May 8, 1995 - Now handled graphics display or text debugging
	May 31, 1995 - Now handles offense AND defensive plays




******************************************************************/

#include <mem.h>		// for memcopy
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>      /* for toupper  */
#include <dos.h>

#include <alloc.h>
#include <graphics.h>
#include <time.h>		// for "randomize"
#include <dir.h>

#include "prjtypes.h"

#include "season.h"	// for season sim

#include "fbequ.h"
#include "fbram.h"
#include "fbbutton.h"


//#include "fakepsx.h"
//#include "biosvid.h"    /* old file - no need to carry it around  */

#include  "fbplays.h"
#include  "fbforms.h"
#include  "misc.h"
#define ESCAPE 0x1b

#if	(NUM_QBs+NUM_RBs+NUM_RECs+NUM_OLs+NUM_DEFs+NUM_KRs+NUM_Ps+NUM_Ks) != TOTAL_PLAYERS_ON_TEAM
#error Number of Players do not add up
#endif


#define	MKkeys	1

//#define FORCE2PLAYERGAME	   TRUE
#define FORCE2PLAYERGAME	   FALSE


#define MAX_VB_TIMERS 5

ULONG gVBlankTimers[MAX_VB_TIMERS];


WORD BV1, BV2,BV3,BV4;

BOOL gSingleStep = False;
BOOL  ShowZones = TRUE;
USHORT PrevJpad[8];
USHORT JpadData[8];


void FreeMem(void *ptr);


void	StartPlayAI(void); 	// called once both teams have selected their play

void	SetBallSnapped(void);

void  DoShellInstructions(void);
void  DoGameInstructions(void);
void  DoFieldInstructions(void);

void ListPlays(void);
void ListFormation(WORD FormNum,WORD StartX,WORD StartY);
void ProgramAudibles(WORD team01);

void  ClearField(void);

void  DrawZonesBK(void);		/* uses global Zone Ptr	*/

int GetPcKey(int wait);   // wait 0 == no wait, 1 = wait for key


void SetSBLoc(void);		/* get new starting ball loc	*/
WORD  GetNum0_99(void);
WORD  GetNum0_999(void);
WORD  GetNum0_9999(void);
void  SetCurBallGrav(void);
void  SetTeamNum(WORD teamslot);
void  SetInitBallGrav(void);
void  SetTheDown(void);
void  SetTheQuarter(void);
void  PCSetQuarterTime(void);

void  SetCurBallDeltaZ(void);
void  SetConBallDeltaZ(void);

void	SetBallDeltaX(void);
void	SetWind(void);
void 	SetGenValue(void);

void TestInstantReplay(void);
void Printkeydef(void);

BOOL OkayToStartPlayCall(void);
//BOOL PlayCompleted(void);
void MKConvertPSXPads(WORD ch);
void InitPracticePlay(void);
void TestDuress();
void TurnOffKickInterface(void);		//make sure off restart during play

//void OkayToStartNewQuarter(void);	// encapsulation for PSX calling
void UnstallAI(void);
void CameraOnScoreBoard(void);


void DumpTeamStats(WORD team01);	// primitive dump
void PrintTeamStats(WORD team01);	// detailed dump



BOOL SimCPUGame(void);	// TRUE if normal finish, FALSE if ABORTED
void SaveGameDataAsFile(WORD seasongamenum);
void SimEntireSeason(void);
WORD SetMinMax(WORD value, WORD min, WORD max);
BOOL ParseCmdLine(int argc, char *argv[]);	//FALSE if info only
void SetCPUvsCPUGameParameters(void);

void FillRunPlaysArray(void);
WORD ForceRunPlay(void);
WORD ForceDefPlayNum(WORD pnum);
WORD ForceOffPlayNum(WORD pnum);
void SimGameClock(void);


//extern  struct play *ThePlays[];
extern  struct play ThePlays[];
//extern  const struct State  AllStates[];
extern  WORD  *All_Scripts[];


#define REGULAR_FR  (1000/15) /* milliseconds per "frame"  */
#define FAST_FR   1     /* milliseconds per "frame"  */


#define SMALLMODE 1

#if 0	//SMALLMODE
	#define ADJFACTOR 96
//	#define ADJFACTOR 128

//	#define SCREEN_X_OFFSET 40
//	#define SCREEN_Y_OFFSET 40
	#define	RIGHT_SIDE_SCREEN_OFFSET 0
	#define	LEFT_SIDE_SCREEN_OFFSET  0
	#define PIXSIZE   0

	#define SCREEN_Y_OFFSET 18
	BOOL bigguys = FALSE;

//#else

	//#define ADJFACTOR 64
//	WORD	ADJFACTOR= 64;

//#define SCREEN_X_OFFSET 0
//#define SCREEN_X_OFFSET -170
	#define	RIGHT_SIDE_SCREEN_OFFSET -170
	#define	LEFT_SIDE_SCREEN_OFFSET  0


	#define SCREEN_Y_OFFSET 18
	BOOL bigguys = TRUE;
	#define PIXSIZE   1

#endif

#define	LEFT_SIDE_SCREEN_OFFSET  0
//#define SCREEN_Y_OFFSET 18
#define	WHITE			15

#define SHOW_EOFRAME	0	/*  only for non-graphic debugger	*/

BOOL showoff = TRUE;
BOOL Bobbywantsplainguys = FALSE;

#define ADJX(xyz)   (((xyz)-DEF_END_LINE)/ADJFACTOR + SCREEN_X_OFFSET)

//#define ADJY(xyz) (((xyz)-NORTH_SIDELINE)/ADJFACTOR + SCREEN_Y_OFFSET)
//#define SCREEN_Y_OFFSET 18

#define SCREEN_Y_OFFSET 10
#define ADJY(xyz) (((xyz)-(NORTH_SIDELINE-2*YARDS))/ADJFACTOR + SCREEN_Y_OFFSET)


WORD SCREEN_X_OFFSET  = LEFT_SIDE_SCREEN_OFFSET;
#define LARGE_ADJ_FACTOR	64

WORD ADJFACTOR =  LARGE_ADJ_FACTOR;
WORD RIGHT_SIDE_SCREEN_OFFSET=-220;
WORD PIXSIZE = 1;
BOOL bigguys = TRUE;

WORD CPUSimLevel;
/*  debug variable - don't change here	change in main1 or sim*/
WORD DoKickOffs=1;
WORD CPUDebugHike = 1;
WORD DisplayLevel;


extern ULONG QuarterTimes[5];

unsigned char	CoinActiveFlag,
	CoinHeadsFlag,
	CoinFlippedFlag,
	CoinVisitorKickFlag,
	CoinVisitorEastFlag;



#include "sched97.dat"




void SetSmallField(void)		// so it fits on 1 screen
{
	ADJFACTOR =  96;
	RIGHT_SIDE_SCREEN_OFFSET=-5;
	PIXSIZE = 0;
	bigguys = FALSE;
}

void SetLargeField(void)		// only about 65 yards per screen
{
	ADJFACTOR =  LARGE_ADJ_FACTOR;
	RIGHT_SIDE_SCREEN_OFFSET=-220;
	PIXSIZE = 1;
	bigguys = TRUE;
}


/**********************************************************************/

#if 0   /*  this was way too slow */

void PutPixel(UWORD x, UWORD y, UWORD color);

void PutPixel(UWORD x, UWORD y, UWORD color)
{ /* x and y should be yards  */
	x = (x-DEF_GOAL_LINE)/128 + SCREEN_X_OFFSET;
	y = (y-NORTH_SIDELINE)/128 + SCREEN_Y_OFFSET;
	PutPixelBios(x, y, color);
}
#endif  /*   this was way too slow  */




/************************************************************************

			L O W    L E V E L     B I O S     S T U F F

*************************************************************************/

/*------------------------------
	Set Video Mode Using BIOS
------------------------------*/
void SetBiosVideoMode(int mode)
{
	union REGS regs;

	regs.h.ah = 0;
	regs.h.al = mode;
	int86(0x10,&regs,&regs);
}

/*------------------------
	get video mode
------------------------*/
int GetBiosVideoMode(void)
{
	union REGS regs;

	regs.h.ah = 0x0F;
	int86(0x10,&regs,&regs);
	return regs.h.al;
}
/*------------------------
	BOIS set point
------------------------*/
void PutPixelBios(int x, int y,int color)
{
	union REGS regs;

	if((x<0 || x >319 || y <0 || y > 199))
	{
	}
	else
	{
	regs.h.ah = 0x0C;    /* Write pixel command */
	regs.h.al = color;
	regs.x.cx = x;
	regs.x.dx = y;
	int86(0x10,&regs,&regs);
	}
}


/*-------------------------------------
	Set Cursor Position using BIOS
-------------------------------------*/
void PutCursorBios(int col,int row)
{
	union REGS regs;

	regs.h.ah = 02;
	regs.h.bh = 1;
	regs.h.dh = row;
	regs.h.dl = col;
	int86(0x10,&regs,&regs);
}

/*-------------------------------------------------------------
	PlotPlayers ~
-------------------------------------------------------------*/
void PlotPlayers(void)
{

#ifdef  DEBUGMODE
//	printf("\nnew frame\n");
//	clrscr();
#else
WORD start;

	int i,x,y,c,j,k;

	if(showoff)
		start = 0;
	else
		start = 11;

	for (i = start; i < 23; i++)
	{     /* below should be same as ADJX, ADJY macros  */
		x = ADJX(PlayerXPosition[i]);
		y = ADJY(PlayerYPosition[i]);
		c = BallCarrier == i ? 2: (i < 11? i+3 :72-11+i);
		if(Bobbywantsplainguys && i> 10)
			c = 12*16-4;

		if(i==22)
			c = 2;	// ref

		if(PlayStateNum > 0 && PlayStateNum < OKAY_TO_HIKE_PS)
			PutPixelBios(x, y, c);

		else if(bigguys)
		{
			for(j=x-1; j<=x+PIXSIZE; j++)
				for(k=y-1; k<=y+PIXSIZE; k++)
					PutPixelBios(j,k, c);

//      PutPixelBios(x+1, y+1, c);
//      PutPixelBios(x, y+1, c);
//      PutPixelBios(x+1, y, c);
		}
		else
		{
			PutPixelBios(x, y, c);
		}

	}

#if 0

/**** color test    ***/
{
	WORD a,b;

for (a = 0; a < 16; a++)
	for (b = 0; b < 16; b++)
	{     /* below should be same as ADJX, ADJY macros  */
		x = a*5+180;
		y = b*5+90;
		c = a*16+b;

		for(j=x-1; j<=x+PIXSIZE; j++)
			for(k=y-1; k<=y+PIXSIZE; k++)
				PutPixelBios(j,k, c);

	}
}
/*** end color test *****/

#endif

#endif
}

/****************************************************************/

#define LINECOLOR 10


void DrawHLine(WORD StartX, WORD EndX, WORD YPos)
{
WORD i;

	for (i = StartX; i <= EndX; i++)
	{
		PutPixelBios(i, YPos, LINECOLOR);
	}
}


void DrawVLine(WORD StartY, WORD EndY, WORD XPos)
{
WORD i;

	for (i = StartY; i <= EndY; i++)
	{
		PutPixelBios(XPos, i, LINECOLOR);
	}
}

void DrawVLineColor(WORD StartY, WORD EndY, WORD XPos, WORD colornum)
{
WORD i;                                 // first down X

	for (i = StartY; i <= EndY; i+=5)
	{
		PutPixelBios(XPos, i, colornum);
	}
}


void DrawHLineColor(WORD StartX, WORD EndX, WORD YPos,WORD color)
{
WORD i;

	for (i = StartX; i <= EndX; i++)
	{
		PutPixelBios(i, YPos, color);
	}
}


void  Wait(UWORD hundreds)
{

UWORD i;

	for(i=0; i < hundreds; i++);


}

void DrawBox(UWORD X1,UWORD X2,UWORD Y1,UWORD Y2,WORD Color);

#define BOXCOLOR  26  /* grey */
void DrawBox(UWORD X1,UWORD X2,UWORD Y1,UWORD Y2,WORD Color)
{
WORD i;

	for (i = X1; i <= X2; i+=2)
		PutPixelBios(i, Y1, Color);
	for (i = X1; i <= X2; i+=2)
		PutPixelBios(i, Y2, Color);

	for (i = Y1; i <= Y2; i+=2)
		PutPixelBios(X1, i, Color);
	for (i = Y1; i <= Y2; i+=2)
		PutPixelBios(X2, i, Color);
}

void DrawCross(WORD x, WORD y, WORD color)
{
	x = ADJX(x);
	y = ADJY(y);
	PutPixelBios(x, y, color);
	PutPixelBios(x+1, y, color);
	PutPixelBios(x-1, y, color);
	PutPixelBios(x, y-1, color);
	PutPixelBios(x, y+1, color);
}



/*-------------------------------------------------------------
	PlotBall Height
-------------------------------------------------------------*/
void PlotZ(WORD x, WORD z,WORD color)
{
#ifdef  DEBUGMODE
//	TRACE(z);
#else
WORD i,y;

	if(ADJFACTOR == LARGE_ADJ_FACTOR)
		i = SOUTH_SIDELINE;
	else
		i = SOUTH_SIDELINE+15*YARD;

	x = ADJX(x);	/*   X,Y pos	*/


	/*  guideline for catching 	*/
	y = ADJY(i - 2*YARDS);
	PutPixelBios(x, y, 143);		/*   Z = 2 yards   ugly green	*/

	y = ADJY(i - z);
	PutPixelBios(x, y, color);		/*   X,Z pos near bottom of screen	*/

#endif
}




void PlotBallHeight(void)		// and Target
{

#ifdef  DEBUGMODE

#else

WORD x,y;
WORD i;

	if(BallFlags & SHOW_BALL_BFLAG)
	{
		x = ADJX(BallXPosition);	/*   X,Y pos	*/
		y = ADJY(BallYPosition);
		PutPixelBios(x, y, 2);


		i = 15;
		if(BallZPosition > 10*FEET)	// wind affects
			i = 56;
		PlotZ(BallXPosition,BallZPosition,i);
	}

#define	TARGET_COLOR	15

	if(BTY1 != ZERO)
	{
		DrawCross(BTX1,BTY1,12);
	}
	if(BTY2 != ZERO)
	{
		DrawCross(BTX2,BTY2,12);
	}

	if(BallTargetY != ZERO)
	{
		DrawCross(BallTargetX,BallTargetY,TARGET_COLOR);
	}

	for(i=0; i<PassCounter; i++) /* visual display of how long button down	*/
		PutPixelBios(20+i*3, SCREEN_Y_OFFSET-1, TARGET_COLOR);


	if(EventFlags.TACKLE_STARTED_BFLAG)
		PutPixelBios(200, SCREEN_Y_OFFSET-1,TARGET_COLOR);

#endif
}


#ifdef  DEBUGMODE
#define NEWLINE printf("\n")
#define TRACE_DEC(xyz) printf(#xyz "=%4d ",xyz)
#else
#define NEWLINE
#define TRACE_DEC(xyz)
#endif


void DisplayBallArc(WORD color)
{
WORD i;
#ifdef  DEBUGMODE
WORD delta,z;
	NEWLINE;
	TRACE(InitialBallGravity);
	TRACE_DEC(CurrentBallDeltaZ);
	TRACE_DEC(ConstantBallDeltaZ);

	for(i=0; i < PointsInBallArc; i++)
	{
		z= BallArc[i][2];
		NEWLINE;
		TRACE_DEC(i);
		TRACE(z);
		if(i>0)
		{
			delta = z - BallArc[i-1][2];
			TRACE_DEC(delta);

		}
	}
#else
	for(i=0; i < PointsInBallArc; i++)
//	for(i=0; i < 2 * PointsInBallArc/4; i++)
	{

		if(i == GetTrueBallArcCounter())
			PlotZ(BallArc[i][0],BallArc[i][2],39); 	// red
		else if(i ==  GetTrueMaxPointsInBallCursor())
			PlotZ(BallArc[i][0],BallArc[i][2],7);
		else
			PlotZ(BallArc[i][0],BallArc[i][2],color);


	}
#endif

}



/*****************************************************************/

void ClearField(void)
{

#ifdef  DEBUGMODE


#else

WORD  i,j;      /* this is too slow */

	for(i = 0; i < 320; i++)
		for (j= 0; j < 200; j++)
			PutPixelBios(i, j, 0);

#endif
}
/*****************************************************************/
void DrawField(void)
{
UWORD i;

	DoFieldInstructions();


#ifdef  DEBUGMODE


#else

//	SCREEN_X_OFFSET = StartBallX < MID_FIELDX ? LEFT_SIDE_SCREEN_OFFSET:RIGHT_SIDE_SCREEN_OFFSET;

	DrawHLine(ADJX(DEF_END_LINE),ADJX(OFF_END_LINE),ADJY(NORTH_SIDELINE));
	DrawHLine(ADJX(DEF_END_LINE),ADJX(OFF_END_LINE),ADJY(SOUTH_SIDELINE));
	DrawHLine(ADJX(MID_FIELDX-HALFYARD),ADJX(MID_FIELDX+HALFYARD),ADJY(MID_FIELDY));


	for(i =  DEF_END_LINE; i <= OFF_END_LINE; i+= 10*YARD)
	{
		DrawVLine(ADJY(NORTH_SIDELINE),ADJY(SOUTH_SIDELINE),ADJX(i));

	}
	for(i =  DEF_GOAL_LINE+10*YARDS; i <= OFF_GOAL_LINE-10*YARDS; i+= 10*YARD)
	{
		DrawHLine(ADJX(i-QTRYARD),ADJX(i+QTRYARD),ADJY(NORTH_HASH_MARK));
		DrawHLine(ADJX(i-QTRYARD),ADJX(i+QTRYARD),ADJY(SOUTH_HASH_MARK));

	}
	for(i =  DEF_GOAL_LINE; i < OFF_GOAL_LINE; i+= YARD)	//hashmarks
	{
		DrawVLine(ADJY(NORTH_HASH_MARK-HALFYARD),ADJY(NORTH_HASH_MARK),ADJX(i));
		DrawVLine(ADJY(NORTH_SIDELINE),ADJY(NORTH_SIDELINE+HALFYARD),ADJX(i));
		DrawVLine(ADJY(SOUTH_HASH_MARK),ADJY(SOUTH_HASH_MARK+HALFYARD),ADJX(i));
		DrawVLine(ADJY(SOUTH_SIDELINE-HALFYARD),ADJY(SOUTH_SIDELINE),ADJX(i));
	}

	// goal posts
	DrawHLineColor(ADJX(OFF_END_LINE-HALFYARD),ADJX(OFF_END_LINE+HALFYARD),ADJY(LOW_GOALPOST_Y),39);
	DrawHLineColor(ADJX(OFF_END_LINE-HALFYARD),ADJX(OFF_END_LINE+HALFYARD),ADJY(LOW_GOALPOST_Y-GP_BAR_WIDTH),39);
	DrawHLineColor(ADJX(OFF_END_LINE-HALFYARD),ADJX(OFF_END_LINE+HALFYARD),ADJY(HIGH_GOALPOST_Y),39);
	DrawHLineColor(ADJX(OFF_END_LINE-HALFYARD),ADJX(OFF_END_LINE+HALFYARD),ADJY(HIGH_GOALPOST_Y+GP_BAR_WIDTH),39);
	PlotZ(OFF_END_LINE,10*FEET,39); 	// height of goal posts

	DrawZonesBK();

	if(FirstDownX >0)
		DrawVLineColor(ADJY(NORTH_SIDELINE),ADJY(SOUTH_SIDELINE),ADJX(FirstDownX),WHITE);


   if(InterfaceFlags & DISPLAY_BALL_ARC_BFLAG)
   {
		DisplayBallArc(143);	// = color
	}
#endif
}


short CPUPlayCallOffense(void);
short CPUPlayCallDefense(void);
WORD AIIsStalled(void);	// actually more of a Boolean
void DebugScreen(void);
void TestDefaultPlayerRatings(WORD teamslotnum);
void VerifyROMData(WORD team01);
void PrintTeamRoster(WORD teamslot);
void InternalVarDump(void);

/*******************************************************************/
//#define MAXPLAYS  10    now in fbplays.h

/*** returns a negative if user wants to exit   */

WORD  GetPlayNumber(void)
{
WORD  Num[3];
BOOL  done;
BOOL  redraw;
WORD  rv;
WORD  i,num;
BYTE  ch,ch1;
WORD offplaynum,defplaynum;
WORD offteam,defteam;



	if(CPUSimLevel  > 2)
	{

		GameTeamData[OffensiveSlotNum].ControllerNum[0]=-1;
		GameTeamData[DefensiveSlotNum].ControllerNum[0]=-1;
		GameTeamData[DefensiveSlotNum].NumHumanControllers = ZERO;
		GameTeamData[OffensiveSlotNum].NumHumanControllers = ZERO;
		ShowHuddle = TRUE;

		if (kbhit())
		{
			if(getch() == 0x1b)
				return(0);
		}
		else
		{
			GameTeamData[OffensiveSlotNum].PlayNum = CPUPlayCallOffense();
			GameTeamData[DefensiveSlotNum].PlayNum = CPUPlayCallDefense();
			return(1);
		}
	}

	if(PlayType == KICKOFF_PLAY)
	{   /* set defaults	*/
		GameTeamData[OffensiveSlotNum].PlayNum = FIRST_KO_PLAY_NUM;
		GameTeamData[DefensiveSlotNum].PlayNum = FIRST_KO_PLAY_NUM+3;
		KickOffType = NORMAL_KO_TYPE;
	}
	else if (PlayType == EX_PT1_PLAY)
	{   /* set defaults	*/
		GameTeamData[OffensiveSlotNum].PlayNum = SpecialTeamsFieldGoalNUM;
		GameTeamData[DefensiveSlotNum].PlayNum = DefSpecialFGBlockNUM;
	}


do
{
	done = FALSE;
	redraw = FALSE;
	rv = TRUE;

	DoGameInstructions();


	offplaynum = GameTeamData[OffensiveSlotNum].PlayNum;
	defplaynum = GameTeamData[DefensiveSlotNum].PlayNum;
	offteam = GameTeamData[OffensiveSlotNum].TeamNumber;
	defteam = GameTeamData[DefensiveSlotNum].TeamNumber;


	printf("\nTeam #%d %s %s Offensive Play #%d-%s",offteam,SpecificTeamData[offteam].TeamCity,\
		SpecificTeamData[offteam].TeamNickName,offplaynum,GetPlayName(offplaynum));

	printf("\nTeam #%d %s %s Defensive Play #%d-%s",defteam,SpecificTeamData[defteam].TeamCity,\
		SpecificTeamData[defteam].TeamNickName,defplaynum,GetPlayName(defplaynum));

	printf("\nInput either play number (Defensive plays start at #%d) or 'P':",FIRST_DEF_PLAY_NUM);

	for (i= 0; i<3; i++)
		Num[i] = 0;

	while(!done)
	{
		ch = tolower(getch());
		if(ch == 'p')
		{
			done = TRUE;
		}
		else if (ch == '\r')
		{
			num = Num[2]*100+Num[1]*10+Num[0];
			if (num >= MAXPLAYS)
			{
				printf("\n\nIllegal play number - max is %d, press any key and try again - ",MAXPLAYS-1);
				getch();
			}
			else
			{

				GameTeamData[FormationOffOrDef[ThePlays[num].FormationNumber] == OFF_FORM ?
						 OffensiveSlotNum:DefensiveSlotNum].PlayNum = num;

//				GameTeamData[ (num <= MAXOFFPLAYNUM  || (num >= OffEdit0NUM && num <= KickoffReturnRightNUM))?
//						 OffensiveSlotNum:DefensiveSlotNum].PlayNum = num;
			}
			done = TRUE;
			redraw = TRUE;
		}
		else
		{
			if (ch >= '0' && ch <= '9')
			{
				putchar(ch);
				Num[2] = Num[1];
				Num[1] = Num[0];
				Num[0] = ch- '0';
			}
			else if(ch == 's')
			{
				SetSBLoc();		/* get new starting ball loc	*/
				InitPracticePlay();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'k')	/* set up kickoff	*/
			{
				GameTeamData[OffensiveSlotNum].PlayNum = FIRST_KO_PLAY_NUM;
				GameTeamData[DefensiveSlotNum].PlayNum = FIRST_KO_PLAY_NUM+3;
				StartBallX = 70 * YARDS + DEF_GOAL_LINE;
				StartBallY = MID_FIELDY;
				PlayType = KICKOFF_PLAY;
				KickOffType = NORMAL_KO_TYPE;
				done = TRUE;
				redraw = TRUE;
			}
/***		else if(ch == 'h')      moved to shell
			{
				SetTeamNum(0);
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'a')
			{
				SetTeamNum(1);
				done = TRUE;
				redraw = TRUE;
			}					***/
			else if(ch == 'd')
			{
				SetTheDown();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'q')
			{
				SetTheQuarter();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 't')
			{
				PCSetQuarterTime();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'r')
			{
				TestInstantReplay();
				done = TRUE;
				redraw = TRUE;
			}
/**
			else if(ch == 'g')
			{
				SetCurBallGrav();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'i')
			{
				SetInitBallGrav();
				done = TRUE;
				redraw = TRUE;
			}

			else if(ch == 'z')
			{
				SetCurBallDeltaZ();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'c')
			{
				SetConBallDeltaZ();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'b')
			{
				SetBallDeltaX();
				done = TRUE;
				redraw = TRUE;
			}						*/
			else if(ch == 'v')
			{
				SetGenValue();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'l')
			{
				ListPlays();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'z')
			{
				printf("\nTeam?(0-1)");
				if((ch1 = getch()) == '0')
					ProgramAudibles(0);
				else if (ch1 == '1')
					ProgramAudibles(1);
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'w')
			{
				SetWind();
				done = TRUE;
				redraw = TRUE;
			}
			else if(ch == 'y')
			{
				DebugScreen();
				done = TRUE;
				redraw = TRUE;
			}


			else if(ch == 'x' || ch == 0x1b)  /* X, ESC exits */
			{
				done = TRUE;
				rv = FALSE;
			}
		}
	}
} while(!(!redraw || !done));

return(rv);
}

void CheckRatings(void);


/*---------------------------------------------------------------*/
BYTE *oc[3] = {"H","A","T"};


void PrintSimScores(void)
{
WORD sgn,sgnl=0,sgnh=12;
WORD count,length=1;

FILE *infile;
BYTE *tptr;
EFFVAR i,j,t0,t1;
BYTE fname[40];
struct ffblk ffblk;
BOOL done1,done= FALSE;

  while (!done)
  {

	clrscr();
	printf("\nPrint all Scores of Sim Games based on GameTime\n");

	printf("\nInput 'L' to set low game(cur = %d)",sgnl);
	printf("\nInput 'H' to set high game(cur = %d)",sgnh);
	printf("\nInput 'T' to set game time (cur = %d)",length);
	printf("\nInput 'S' to start");
	printf("\nInput 'X' to Quit: " );

	switch (toupper(getch()))
	{
		case ESCAPE:
		case 'X':
				done = TRUE;
				break;
		case 'L':
			printf("\nInput Low Season Game Num (0-250): ");
			sgnl = SetMinMax(GetNum0_999(),0,250);
			break;
		case 'H':
			printf("\nInput High Season Game Num (0-250): ");
			sgnh = SetMinMax(GetNum0_999(),0,250);
			break;

		case 'T':
			printf("\nInput Game Time (1,2,3 = 5,10,15 minute Quarters): ");
			length = SetMinMax(GetNum0_99(),0,3);
			break;

		case 'S':  	// scan the games

			for(sgn = sgnl; sgn <= sgnh; sgn++)
			{
				t0 = schedule[sgn].home;
				t1 = schedule[sgn].away;
				count=0;

				for(i=0; i<3; i++)
				{

					sprintf(fname,"games\\game%d\\G????%s*.GM%d",sgn,oc[i],length);
//					printf("\nfname = %s",fname);

					done1 = findfirst(fname,&ffblk,0);
				/*	if(done1)
					{
						printf("\n%s NOT found",fname);
						continue;
					} */

					while (!done1)
					{
						count++;

						sprintf(fname,"games\\game%d\\%s",sgn,ffblk.ff_name);

						if ((infile = fopen(fname, "r+b"))	// read binary(not TEXT!)
							   == NULL)
						{
							printf("\nERROR -Cannot open output file %s\n", ffblk.ff_name);
							{
								break;
							}
						}

						tptr = (BYTE *) &StatsData[0];

						for(j = 0 ; j < sizeof(TEAMRAMStats)*2; j++)	// do both teams
						{
							*tptr = fgetc(infile);
							tptr++;
						}
						fclose(infile);

						printf("\nSGN #%3d-File: %s: %s(%2d) vs. %s(%2d)",
							sgn,ffblk.ff_name,
							SpecificTeamData[t0].TeamNickName,
							StatsData[0].allplyrstats[GS_TOTAL_SCORE],
							SpecificTeamData[t1].TeamNickName,
							StatsData[1].allplyrstats[GS_TOTAL_SCORE]);

						done1 = findnext(&ffblk);
					 }
				}
				printf("\n     All %d Sims viewed for this Season Game - press NE key",count);
				if(getch() == ESCAPE)
					break;
			}	// done with for loop
			printf("\nAll Sims done ALL Season Games - press NE key");
			getch();
			break;

	}  // end switch

  }
}





void FixTieGames(void)
{
WORD sgn,count,length;

FILE *infile;
BYTE *tptr;
EFFVAR j,t0,t1;
BYTE fname[40];
struct ffblk ffblk;
BOOL done1;
UWORD time,rvtime,team;
WORD gsec[4] = {600,1500,3000,4500};
WORD gmask[4] = {127,127,255,511};

	clrscr();
	printf("\nFixing Ties SeasonGames\n");
	printf("\nInput Game Time (1,2,3 = 5,10,15 minute Quarters): ");
	length = SetMinMax(GetNum0_99(),0,3);
	printf("\nLooking for G????T*.GM%d",length);

	time = QuarterTimes[length]/2;	// extra time to add

	count=0;
	for(sgn = 0; sgn <= 250; sgn++)
//	for(sgn = 0; sgn <= 1; sgn++)
	{
		t0 = schedule[sgn].home;
		t1 = schedule[sgn].away;

		sprintf(fname,"games\\game%d\\G????T*.GM%d",sgn,length);


		done1 = findfirst(fname,&ffblk,0);
		while (!done1)
		{
			count++;

			sprintf(fname,"games\\game%d\\%s",sgn,ffblk.ff_name);

			if ((infile = fopen(fname, "r+b"))	// read binary(not TEXT!)
					   == NULL)
			{
				printf("\nERROR -Cannot open output file %s\n", ffblk.ff_name);
				{
					break;
				}
			}

			tptr = (BYTE *) &StatsData[0];

			for(j = 0 ; j < sizeof(TEAMRAMStats)*2; j++)	// do both teams
			{
				*tptr = fgetc(infile);
//				printf("%d ",*tptr);
				tptr++;
			}
			fclose(infile);
#if 0
			DumpTeamStats(0);
			getch();
			DumpTeamStats(1);
			getch();
#endif
/*			if(StatsData[HOME_TEAM_SLOT].allplyrstats[GS_TIE] == ZERO)
			{	// haven't fixed this one
				StatsData[HOME_TEAM_SLOT].allplyrstats[GS_TIE] =
					StatsData[AWAY_TEAM_SLOT].allplyrstats[GS_TIE] =
				StatsData[HOME_TEAM_SLOT].alloppplyrstats[GS_TIE] =
					StatsData[AWAY_TEAM_SLOT].alloppplyrstats[GS_TIE] = 1;

				StatsData[HOME_TEAM_SLOT].allplyrstats[GS_TOP] += time;
				StatsData[AWAY_TEAM_SLOT].allplyrstats[GS_TOP] += time;
				StatsData[HOME_TEAM_SLOT].alloppplyrstats[GS_TOP] += time;
				StatsData[AWAY_TEAM_SLOT].alloppplyrstats[GS_TOP] += time;

			}
***/

			team = rand()&1;
			time = gsec[length]/2;	// half the game time

			time += (rand() & gmask[length]);

			rvtime = gsec[length]-time;

			StatsData[team].allplyrstats[GS_TOP] = time;
			StatsData[team].alloppplyrstats[GS_TOP] = rvtime;

			StatsData[team^1].allplyrstats[GS_TOP] = rvtime;
			StatsData[team^1].alloppplyrstats[GS_TOP] = time;

//			printf("\nFixing file %s\n", ffblk.ff_name);
//			printf("\tTeam %d time = %d, Team %d time = %d",
//							team,time,team^1,rvtime);

			if ((infile = fopen(fname, "w+b"))	// read binary(not TEXT!)
					   == NULL)
			{
				printf("\nERROR -Cannot open output file %s\n", ffblk.ff_name);
				{
					break;
				}
			}

			tptr = (BYTE *) &StatsData[0];

			for(j = 0 ; j < sizeof(TEAMRAMStats)*2; j++)	// do both teams
			{
//				printf("%d ",*tptr);
				fputc(*tptr++, infile);
			}
			fclose(infile);
#if 0
			DumpTeamStats(0);
			getch();
			DumpTeamStats(1);
			getch();
#endif
			printf("\nSGN #%3d-File: %s: %s(%2d) vs. %s(%2d) - FIXED",
					sgn,ffblk.ff_name,
					SpecificTeamData[t0].TeamNickName,
					StatsData[0].allplyrstats[GS_TOTAL_SCORE],
					SpecificTeamData[t1].TeamNickName,
					StatsData[1].allplyrstats[GS_TOTAL_SCORE]);
			printf("\n\tTeam %d time = %d, Team %d time = %d",
							team,time,team^1,rvtime);

			done1 = findnext(&ffblk);

		}
		printf("\n     All Ties Fixed for Season Game #%d- press NE key",sgn);
		getch();
	}
	// done with for loop
	printf("\n%d Ties Fixed ALL Season Games of length type#%d- press NE key",count,length);
	getch();
}






/*---------------------------------------------------------------*/

void InputSimData(void)
{
WORD sgn=0;
WORD winner=0;
WORD gamenum=0;
WORD length=1;

FILE *infile;
BYTE *tptr;
EFFVAR j,t0,t1;
BYTE oc[2] = {0,0};
BYTE fname[40];
struct ffblk ffblk;
BOOL done= FALSE;

  while (!done)
  {

	clrscr();
	GameTeamData[0].TeamNumber = t0 = schedule[sgn].home;
	GameTeamData[1].TeamNumber = t1 = schedule[sgn].away;

	printf("Current Parameters: %s(%d) vs. %s(%d)\nSG# = %d, Winner= %d, gamenum=%d, gTime = %d",

		SpecificTeamData[t0].TeamNickName,StatsData[0].allplyrstats[GS_TOTAL_SCORE],
		SpecificTeamData[t1].TeamNickName,StatsData[1].allplyrstats[GS_TOTAL_SCORE],
		sgn,winner,gamenum,length);

	printf("\nInput 'S' to change season game");
	printf("\nInput 'W' to change winner");
	printf("\nInput 'G' to change game num");
	printf("\nInput 'T' to change game time");
	printf("\nInput 'L' to load the data");
	printf("\nInput 'X' to Quit: " );

	switch (toupper(getch()))
	{
		case ESCAPE:
		case 'X':
				done = TRUE;
				break;
		case 'S':
			printf("\nInput Season Game Num (0-250): ");
			sgn = SetMinMax(GetNum0_999(),0,250);
			break;
		case 'W':
			printf("\nInput Winner= 0-Home,1=Away,2=tie: ");
			winner = SetMinMax(GetNum0_99(),0,2);
			break;

		case 'G':
			printf("\nInput Gamenum (0-12): ");
			gamenum = SetMinMax(GetNum0_99(),0,12);
			break;
		case 'T':
			printf("\nInput Game Time (1,2,3 = 5,10,15 minute Quarters): ");
			length = SetMinMax(GetNum0_99(),0,3);
			break;

		case 'L':  	// load the game

			if(winner == 0)
			{	// home team wins
				oc[0] = 'H';
			}
			else if(winner == 1)
			{	// away team wins
				oc[0] = 'A';
			}
			else
			{
				oc[0] = 'T';
			}

			sprintf(fname,"games\\game%d\\G%02d%02d%s%02d.GM%d",
						sgn,t0,t1,oc,gamenum,length);

			//if a match was found, findfirst returns 0
			if(findfirst(fname,&ffblk,0) == ZERO)
			{
				printf("\n%s found... reading in data....\n", fname);

				if ((infile = fopen(fname, "r+b"))	// read binary(not TEXT!)
				   == NULL)
				{
					printf("ERROR -Cannot open output file %s.\n",fname);
					{
						break;
					}
				}

				tptr = (BYTE *) &StatsData[0];

				for(j = 0 ; j < sizeof(TEAMRAMStats)*2; j++)	// do both teams
				{
					*tptr = fgetc(infile);
					tptr++;
				}
				fclose(infile);

			}
			else	// no match we can use this fname
			{
				printf("\n%s NOT found... Try again....\n", fname);
			}
			printf("\nPress NE key to continue ");
			getch();
			break;

	}  // end switch

  }
}





void FixTieGames(void);
void PrintTotalRatings(void);
void ListSchedule(void);

/********************************************************************/


void DebugScreen(void)
{
WORD t =0;
BOOL done = FALSE;
BYTE ch;

	while(!done)
	{
		clrscr();
		printf("TEST - DEBUG - VIEW TEAM SCREEN FOR %s %s",
				SpecificTeamData[GameTeamData[t].TeamNumber].TeamCity,
				SpecificTeamData[GameTeamData[t].TeamNumber].TeamNickName);

		printf("\n\nOPTIONS:");
		printf("\n 0  Toggle Team ");
		printf("\n 1  Game Player & Team Stats - Hex dump");
		printf("\n 2  Game Team Stats - Detailed dump(only players w/stats)");
		printf("\n 3  View Player Ratings");
		printf("\n 4  View Player 1996 NFL (ROM) Stats");
		printf("\n 5  Team Roster (brief)");
		printf("\n 6  Internal Variable Dump");
//		printf("\n 7  Check Low Ratings by Position");
		printf("\n 7  Show all Ratings by Position");
		printf("\n 8  Input Sim data (Will corrupt current data)");
		printf("\n 9  View Sim Scores (Will corrupt current data)");
		printf("\n S  List 1997 NFL Schedule");
		printf("\n X or ESC - eXit");

		printf("\n\n Enter Selection: ");
		ch = toupper(getch());

		if(ch == '0')
		{
			t ^=1;
		}
		else if(ch == '1')
		{
			DumpTeamStats(t);
			printf("\nDone - Press NE key to continue");
			getch();
		}
		else if(ch == '2')
		{
			PrintTeamStats(t);
			printf("\nDone - Press NE key to continue");
			getch();

		}
		else if(ch == '3')
		{
			TestDefaultPlayerRatings(t);
		}
		else if(ch == '4')
		{
			VerifyROMData(t);
		}
		else if(ch == '5')
		{
			PrintTeamRoster(t);
			printf("\nDone - Press NE key to continue");
			getch();
		}
		else if(ch == '6')
		{
			InternalVarDump();
		}
		else if(ch == '7')
		{
			PrintTotalRatings();
		}
		else if(ch == '8')
		{
			InputSimData();
		}
		else if(ch == '9')
		{
			PrintSimScores();
		}
		else if(ch == 'S')
		{
			ListSchedule();
		}
		else if(ch == 'F')
		{
			FixTieGames();
		}
		else if(ch == 'X' || ch == 0x1b)  /* X, ESC exits */
		{
			done = TRUE;
		}

	}
}

/*******************************************************************/

#undef playmac

#define playmac(abc,name)  name,

BYTE *newnames1[] = {
playmac(GoalLineOptionPass1, "Option Pass")
};


#undef playmac


#define LPTOPY	2
#define LPX1	5
#define LPX2   28
#define LPX3   55
#define MAXFD 26

void ListPlays(void)
{
//WORD fa[MAXFD] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,23,24,25,26,27,28,29};
WORD fx[3] = {LPX1,LPX2,LPX3};
WORD i,j;

//	printf("\nnewname = %s\n",newnames1[0]);
//		printf("Press any key to continue, ESC to stop");
//		getch();

	for (i=0; i<MAXFD; i+=3)
	{
		clrscr();
		for(j=0;j<3;j++)
			if(i+j < MAXFD)
//				ListFormation(fa[i+j],fx[j],LPTOPY);
				ListFormation(i+j,fx[j],LPTOPY);
		gotoxy(1,LPTOPY+19);
		printf("Press any key to continue, ESC to stop");
		if(getch() == 0x1b)
			break;
	}

}


/*---------------------------------------------------------*/


void ListFormation(WORD FormNum,WORD StartX,WORD StartY)
{
WORD i,playnum;
WORD *formptr;

	gotoxy(StartX, StartY);
	printf("   %s",FormationNames[FormNum]);
	gotoxy(StartX, StartY+1);
	printf("------------------");

#if 1
	formptr = GetPlaysPerForm(FormNum);	// pointer to table, -1 at end

	i=0;
	while( (playnum = *(formptr+i)) >= ZERO)
	{
		gotoxy(StartX, StartY+2+i);
		printf("%3d %s",playnum,GetPlayName(playnum));
		i++;
	}

#else
	for(i=0; i<12; i++)
	{
		if((playnum = FormationPlays[FormNum][i]) != -1)
		{
			gotoxy(StartX, StartY+2+i);
			printf("%3d %s",playnum,GetPlayName(playnum));
		}
	}
#endif

}
void PrintFieldParameters(BOOL lastlf);

/*
void PrintPossibleFieldParameters(WORD curX, WORD firstdownX,WORD down);

void PrintFieldParameters(BOOL lastlf)
{
WORD  yard;
BYTE   *str;

	if(StartBallX > MID_FIELDX)
	{
		str = "Defensive";
		yard = 100 - (StartBallX-DEF_GOAL_LINE)/YARD;
	}
	else
	{
		str = "Offensive";
		yard = (StartBallX-DEF_GOAL_LINE)/YARD;

	}

	printf("\n  Ball on %s %d Yardline",str,yard);
	if(lastlf)
		printf("\t");
	printf("\tDown:%d  To Go:",TheDown);
	if(FirstDownX == OFF_GOAL_LINE)
		printf("GOAL");
	else if(FirstDownX  > 0)
		printf("%2d",(FirstDownX-StartBallX)>>8);
	else
		printf("-");

	if(lastlf)
		printf("\n");
}

*/



UWORD SecondsLeftInQuarter(void);

/*******************************************************************/

void  DoGameInstructions(void)
{
	clrscr();

	printf("GameTek Football Debugging Program\t(c) 1996,1997 GameTek, Inc.\n");
	printf("\nDuring play, use the following keys:");

	printf("\n  Numeric Joypad = Directional Joypad controls players");
	printf("\n  W,A,D,X = Buttons (X to hike; A,W,D to pass");
	printf("\n\t'R'-Restart play\t'M'-Restart on other side of field");
	printf("\n\t'['-Flip Offense\t']'-Flip Defense\t'U'-Start in Huddle");

	printf("\n\t'H'-Normal Speed\t'S'-Single Step\t\t'F'- Fast Speed");
	printf("\n\t'L'-Field Size\t\t'B'-\"Player\" Size\t'Z'-Show Zones");
	printf("\n\t'K'-Kill Defense\t'O'-Kill Offense Line\t'T'-Reset ball-10 YRD");
	printf("\n\t','-Control Off.\t'.'-Control Defense\t'N'-no show offense");
	printf("\n\t'Q'-Quit\t\t'ESC'-Quit\n");

	printf("\nRight now, use the following keys:");

	printf("\n\t'P'- Start Play\t\t'X' = Exit Program\t'L' - List Plays");
	printf("\n\t'K'- Kickoff\t\t'R' = Instant Replay (1,2=+ 8,9=-)");
//	printf("\n\t'H'or'A'- Select Home/Away Team\t'W'-Wind Speed=%d,%d",WindDeltaX,WindDeltaY);
	printf("\n\t'W'-Wind Speed=%d,%d",WindDeltaX,WindDeltaY);

#if 0
	printf("\n\t'G'-CurBallGrav =\t%d",BV1);
	printf("\t'I'-InitBallGrav=\t%d",BV2);
	printf("\n\t'Z'-CurBallDeltaZ=\t%x",BV3);
	printf("\t'C'-ConBallDeltaZ=\t%x",BV4);
	printf("\n\t'V'-General Value=\t%d",GenValue);
	printf("\t'B'-BallDeltaX(speed)=\t%x",BallDeltaX);
#endif
	printf("\n\t'V'-General Value=\t%d",GenValue);
	printf("\t'Y'-View Team Stats");
	printf("\n\t'S'-Set Line of Scrimmage\t'D'-Set the Down 'Q'-Set Quarter");

//	printf("\FDownX:%x  SBX%x\n",FirstDownX,StartBallX);
	PrintFieldParameters(FALSE);
	printf("   Qtr= %d  Time Left= %d:%02d%s",TheQuarter,
			SecondsLeftInQuarter()/60,SecondsLeftInQuarter()%60,
			((GameFlags & GAME_TIMER_ON_BFLAG)?"r":"s"));

}

/*******************************************************************/

void  DoFieldInstructions(void)
{
#ifdef  DEBUGMODE

	clrscr();
	printf("%sPlay #%d-%s",(GameTeamData[0].PlayFlipped ? "Flipped ":""),GameTeamData[0].PlayNum,GetPlayName(GameTeamData[0].PlayNum));
	if(TheDown >0)
		printf("\t\tDown: %d",TheDown);
	printf("\nvs. %sPlay #%d-%s\n",(GameTeamData[1].PlayFlipped ? "Flipped ":""),GameTeamData[1].PlayNum,GetPlayName(GameTeamData[1].PlayNum));
	printf("\n'S'-step,'R'-restart 'Q'-Quit");
	getch();

#else
		SetBiosVideoMode(0x13);
//    ClearField();
		gotoxy(0,0);

		printf("%3d ",GameTeamData[0].TotalScore);
		if(TheDown >0)
			printf("Down:%2d",TheDown);
		printf("\t%s#%d-%s",(GameTeamData[0].PlayFlipped ? "Flip":""),
			GameTeamData[0].PlayNum,GetPlayName(GameTeamData[0].PlayNum));

		printf("\n%3d ",GameTeamData[1].TotalScore);
		if(FirstDownX > 0)
			printf("ToGo:%2d",(FirstDownX-StartBallX)>>8);
		printf("\t%s#%d-%s",(GameTeamData[1].PlayFlipped ? "Flip":""),
			GameTeamData[1].PlayNum,GetPlayName(GameTeamData[1].PlayNum));

#endif

}


void InitPlayClock(void);	// called at beginning of play call
void StartPlayClock(void); 	// called at beginning of play call


void InsertFaceArray(void);

#if 1
BYTE FaceArray[3];


void InsertFaceArray(void)
{
//	if(FaceArray[0] == 255)
//	{
//		FaceArray[0] = gPNum;
//		FacePointer = 1;
//	}


//	if(FaceArray[0] == gPNum)
	if(PlayStateNum == PS_PlayHappeningNUM && gPNum == 0)
	{
		if(CPFacing == FaceArray[1])
		{
			if(FaceArray[0] == FaceArray[2])
			{	// a twitch is happening
				printf("t%d-",CPFacing);
				CPFacing = FaceArray[2];

			}
		}
		FaceArray[0] = FaceArray[1];
		FaceArray[1] = FaceArray[2];
		FaceArray[2] = CPFacing;
	}

	printf("%dd%d ",CPFacing,CPDirToGo);


}

#else
WORD FacePointer;
BYTE FaceArray[500];


void InsertFaceArray(void)
{
//	if(FaceArray[0] == 255)
//	{
//		FaceArray[0] = gPNum;
//		FacePointer = 1;
//	}


//	if(FaceArray[0] == gPNum)
	if(PlayStateNum == PS_PlayHappeningNUM && gPNum == 0)
	{
		FaceArray[FacePointer++] = CPFacing;
		printf("%d ",CPFacing);

	}
}
#endif

BYTE DrawFieldWait(void)
{
WORD savevid;
BYTE rv;

//  test players in huddle
//	getch();
	savevid =  GetBiosVideoMode();
//	SetLargeField();
	SetSmallField();
	SCREEN_X_OFFSET = StartBallX < MID_FIELDX ? LEFT_SIDE_SCREEN_OFFSET:RIGHT_SIDE_SCREEN_OFFSET;
	DrawField();
	PlotPlayers();
	rv =  getch();
	SetBiosVideoMode(savevid);
	return(rv);
}


/*-------------------------------------------------------------
						TestAI ~
-------------------------------------------------------------*/
void TestAI(void)
{
WORD ch,i;

BOOL needplaycall, inplay;
WORD savevid;
WORD   FrameRate;

struct  time tm;
ULONG  cticks,ticks;
WORD lastkey = 0;
WORD nohitcount = 0;
WORD defplay;


//	DrawFieldWait();	//  test players in huddle
	FieldDir = 4;		// PC goes L to R
//	GameOptions[GAME_OPTNS_AUTO_QB] = OPTION_OFF;


	while(GetPlayNumber())		// ZERO if time to exit
	{
		savevid =  GetBiosVideoMode();

		if(PlayType == KICKOFF_PLAY)
		{
			SetSmallField();

#if PC_ALWAYS_MODE  //KOType normally set up by CPUPC
			defplay = GameTeamData[DefensiveSlotNum].PlayNum;
			if(defplay == KickoffStackLeftNUM
				|| defplay == KickoffStackRightNUM)
			{
					KickOffType = ONSIDE_KO_TYPE;
			}
			else
			{
				KickOffType = NORMAL_KO_TYPE;
//				KickOffType = SQUIB_KO_TYPE;	//test only
			}
#endif
		}
		else
		{
			SetLargeField();
		}

		SCREEN_X_OFFSET = StartBallX < MID_FIELDX ? LEFT_SIDE_SCREEN_OFFSET:RIGHT_SIDE_SCREEN_OFFSET;

		needplaycall = FALSE;

//		StartPlayAI();
		InitPlayClock();	// called at beginning of play call
		StartPlayClock(); 	// called at beginning of play call

		while (!needplaycall)	// if reset during play
		{
//			InitAI();
			StartPlayAI();
			TurnOffKickInterface();		//make sure off restart during play
			PlayStateNum = 0;

			FaceArray[0] = 255;

			Printkeydef();

//			DoFieldInstructions();
			DrawField();

//			PlotPlayers();

			inplay = TRUE;

			gSingleStep = FALSE;
			FrameRate = REGULAR_FR;


			gettime(&tm);
			cticks = ticks =
				(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

//			frames = 0;
			nohitcount = 0;

			while (inplay)
			{
				ch = -1;
				if(gSingleStep)
				{
#if MKkeys
					ch = tolower(getch());
#else
					ch = tolower(GetPcKey(1));	// 1 means wait for key
#endif
				}
				else
				{
					if(FrameRate == REGULAR_FR)
					{
						do
						{
							gettime(&tm);
//							if (kbhit())
//								ch = tolower(getch());
							ticks =
						(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;
						}while(ticks < cticks + 5);	// 5 = 1/20 of sec
//						}while(ticks < cticks + 1);

						cticks = ticks;
				//  delay(FrameRate);

					}
			#if MKkeys
					if (kbhit())
					{
						ch = tolower(getch());	//  get 1st key in buffer
						while(kbhit())		/* and bleed the rest	*/
					//		ch = tolower(getch());
							getch();
						nohitcount = 0;
					}
					else
					{
						if(nohitcount++ >4)
							lastkey = 0;
					}
			#else
					ch = tolower(GetPcKey(0));		// 0 means don't wait
			#endif
				}

#if MKkeys
				MKConvertPSXPads(ch);
#endif
				if(ch == 'q' || ch == 0x1b)
				{
					needplaycall = TRUE;
					inplay = FALSE;
				}
				if(ch == 'r')
				{
					inplay = FALSE;
				}
				if(ch == '[')
				{
					inplay = FALSE;
					GameTeamData[OffensiveSlotNum].PlayFlipped = !GameTeamData[OffensiveSlotNum].PlayFlipped;
					GameTeamData[DefensiveSlotNum].PlayFlipped = !GameTeamData[DefensiveSlotNum].PlayFlipped;
				}
				if(ch == ']')
				{
					Bobbywantsplainguys = !Bobbywantsplainguys;
					inplay = FALSE;
		   //			GameTeamData[DefensiveSlotNum].PlayFlipped = !GameTeamData[OffensiveSlotNum].PlayFlipped;
				}

				if(ch == 'v')	// simulate EOQ
				{
//					TheQuarter = 2;
					SetVBlankTimer(GAME_TIMER_NUM,0L);

				}

				if(ch == 't')
				{
					PracticeStartBallX = DEF_GOAL_LINE+10*YARD;

					InitPracticePlay();

					SCREEN_X_OFFSET = StartBallX < MID_FIELDX ? LEFT_SIDE_SCREEN_OFFSET:RIGHT_SIDE_SCREEN_OFFSET;
					inplay = FALSE;
				}

				if(ch == ',' || ch == 't')	// control the offense
				{
#if FORCE2PLAYERGAME		//
					GameTeamData[OffensiveSlotNum].ControllerNum[0]=0;
					GameTeamData[DefensiveSlotNum].ControllerNum[0]=1;

					t = ControlWhichPlayer[0];
					if(t>10)	// swap em
					{
						ControlWhichPlayer[0] = ControlWhichPlayer[1];
						OPControllerNum(ControlWhichPlayer[1]) =0;
						ControlWhichPlayer[1]  = t;
						OPControllerNum(t) = 1;		/* old C0 player now by C1	*/

					}
#else
					for(gPNum = 0; gPNum <22; gPNum++)
					{
						CPControllerNum = NO_CONTROLLER;
						if(CPFlags & IS_HCONTROLLED_BFLAG)
						{
							ResetBit(CPFlags,IS_HCONTROLLED_BFLAG);
							CPStateInit = ZERO;
						}
					}
					ControlWhichPlayer[0] = 0;		/* controller 0 does QB 		*/
					OPControllerNum(0) = 0;		/* QB controlled by controller #0	*/
					GameTeamData[OffensiveSlotNum].ControllerNum[0]=0;
					GameTeamData[DefensiveSlotNum].ControllerNum[0]=-1;
//					GameTeamData[DefensiveSlotNum].ControllerNum[0]=1;
					GameTeamData[DefensiveSlotNum].NumHumanControllers = ZERO;
					GameTeamData[OffensiveSlotNum].NumHumanControllers = 1;
#endif
				}
				if(ch == '.')	// control the defense
				{

#if FORCE2PLAYERGAME		//
					GameTeamData[DefensiveSlotNum].ControllerNum[0]=0;
					GameTeamData[OffensiveSlotNum].ControllerNum[0]=1;

					t = ControlWhichPlayer[0];
					if(t<11)	// swap em
					{
						ControlWhichPlayer[0] = ControlWhichPlayer[1];
						OPControllerNum(ControlWhichPlayer[1]) =0;
						ControlWhichPlayer[1]  = t;
						OPControllerNum(t) = 1;		/* old C0 player now by C1	*/

					}
#else
					for(gPNum = 0; gPNum <22; gPNum++)
					{
						CPControllerNum = NO_CONTROLLER;
						if(CPFlags & IS_HCONTROLLED_BFLAG)
						{
							ResetBit(CPFlags,IS_HCONTROLLED_BFLAG);
							CPStateInit = ZERO;
						}
					}
					ControlWhichPlayer[0] = 11;		/* controller 0 does MLB 		*/
					OPControllerNum(11) = 0;		/* QB controlled by controller #0	*/
					GameTeamData[DefensiveSlotNum].ControllerNum[0]=0;
					GameTeamData[OffensiveSlotNum].ControllerNum[0]=-1;
//					GameTeamData[OffensiveSlotNum].ControllerNum[0]=1;
					GameTeamData[OffensiveSlotNum].NumHumanControllers = ZERO;
					GameTeamData[DefensiveSlotNum].NumHumanControllers = 1;
#endif
				}
/****
				if(ch == '2')      // test 2 min warning
				{
					TheQuarter = 2;
					SetVBlankTimer(GAME_TIMER_NUM,2*60*CLOCKS_TICKS_PER_SECOND +1);
					ResetBit(GameFlags,NEED_2MIN_WARNING_BFLAG);
					ResetBit(GameFlags,GAVE_2MIN_WARNING_BFLAG);
				}

				if(ch == '3')
				{
					StartGameClock();
				}

*/
				if(ch == 'h')
				{
//					SetBallSnapped();
					gSingleStep = FALSE;
					FrameRate = REGULAR_FR;
				}
				if(ch == 'm')
				{
			   //		inplay = FALSE;
					if(SCREEN_X_OFFSET == LEFT_SIDE_SCREEN_OFFSET)
						SCREEN_X_OFFSET = RIGHT_SIDE_SCREEN_OFFSET;
					else
						SCREEN_X_OFFSET = LEFT_SIDE_SCREEN_OFFSET;
					DrawField();
				}
				if(ch == 'g')
				{
					ch = 'g';		// set BPoint here
				}

				if(ch == 's')
				{
					SetBallSnapped();
					gSingleStep = TRUE;
				}
				if(ch == 'k')
				{
					for(i= START_DEF_SLOT_NUM; i < LAST_DEF_SLOT_NUM+1; i++)
//					for(i= 13; i < 17; i++)
						PlayerScriptPtr[i] = All_Scripts[DoNothingScriptNUM];

				}

				if(ch == 'o')
				{
					for(i= 6; i < LAST_OFF_SLOT_NUM+1; i++)
						PlayerScriptPtr[i] = All_Scripts[DoNothingScriptNUM];

				}
				if(ch == 'f')
				{
//					SetBallSnapped();
					gSingleStep = FALSE;
					FrameRate = FAST_FR;
				}
				if(ch == 'b' && lastkey != 'b')	// toggle player size
					bigguys = !bigguys;

				if(ch == 'l' && lastkey != 'l')	// toggle field size
				{
					if(ADJFACTOR == LARGE_ADJ_FACTOR)
						SetSmallField();
					else
						SetLargeField();

					SCREEN_X_OFFSET = StartBallX < MID_FIELDX ? LEFT_SIDE_SCREEN_OFFSET:RIGHT_SIDE_SCREEN_OFFSET;
//					inplay = FALSE;
					DrawField();

					UnstallAI();
					CameraOnScoreBoard();

//					OkayToStartNewQuarter();	// encapsulation for PSX calling

				}

				if(ch == 'n' && lastkey != 'n')
					showoff = !showoff;
				if(ch == 'z' && lastkey != 'z')
				{
					ShowZones = !ShowZones;
					inplay = FALSE;
				}
				if(ch == 'u' && lastkey != 'b')
				{
					ShowHuddle = !ShowHuddle;
					inplay = FALSE;
				}

				if(ch >= 'a' && ch <= 'z')
					lastkey = ch;


#if SHOW_EOFRAME
				DEBUG(\n);
				TRACE(JpadData[0]);
#endif
				if(CPUSimLevel)
				{
					if(AIIsStalled())
					{
						CameraOnScoreBoard();
						UnstallAI();
					}
				}

				DoAI();
//				if(TheQuarter == 2)
//					TheQuarter=TheQuarter;
				SimGameClock();

				PlotPlayers();
				PlotBallHeight();

				Printkeydef();

				#if 1
				if(OkayToStartPlayCall())

//				if(PlayCompleted())
				{
					needplaycall = TRUE;
					inplay = FALSE;
				}
			  #endif

			   #if 0
				if(BallSnapped)
				{
					frames++;
					moveto(3,3);
					printf("   ");
					moveto(3,3);
					printf("%d",frames);
				}
				#endif
			}
		}
		if(savevid !=  GetBiosVideoMode())
			SetBiosVideoMode(savevid);
	}



//SetBiosVideoMode(savevid);

}

void Printkeydef(void)
{
#ifdef  DEBUGMODE
WORD i;

//	for(i=0; i<11; i++)
//		printf("\ns= %2d, d= %d",DefenseKeyDistance[i].slotnum ,DefenseKeyDistance[i].distance);
#endif
}






void DrawZonesBK(void)
{
WORD i= 0;
WORD who,c;

/*  Zones based on Player Position - not defensive slot num!!!	*/
	if(ShowZones &&  gZonePtr != NULL)
	{
		while((who = gZonePtr[i].PlayerPos) != NOBODY)
		{
			for(gPNum = 11; gPNum < 22; gPNum++)
			{   /* remember all "CP.." macros contain ref to gPNum	*/
				if(who == CPMyFormPosition)
				{
					c = 72-11+gPNum;
					PutPixelBios(ADJX(CPCenterZone.X),ADJY(CPCenterZone.Y), c);

					DrawBox(ADJX(CPInsideZone.Low.X),ADJX(CPInsideZone.High.X),ADJY(CPInsideZone.Low.Y),ADJY(CPInsideZone.High.Y),c);
					DrawBox(ADJX(CPOutsideZone.Low.X),ADJX(CPOutsideZone.High.X),ADJY(CPOutsideZone.Low.Y),ADJY(CPOutsideZone.High.Y),c);
					break;
				}
			}
			i++;
		}
	}

}


/************

void testran(void)

{
WORD ta[1003];
WORD i;
LONG j;

	for(i=0; i<1003; i++)
		ta[i]=0;

	for(j=0L; j<100000L; j++)
		ta[Random1000]++;

	for(i=0; i<1003; i++)
	{
		printf("\n%5d  %2d",i,ta[i]);
		if(i%24 == 0)
			getch();
	}
	getch();

}

*************/

void PrintRatings(void)
{
FILE *s;
WORD i,t,stlen;
WORD speed, hands;

	s = fopen("TeamRate.TXT", "w+");

	for(t=0; t < 108; t++)
	{
		if(t%10 == ZERO)
			fprintf(s,"\n");

		stlen  = fprintf(s, "\n%3d %s %s",t,SpecificTeamData[t].TeamCity,
						SpecificTeamData[t].TeamNickName);

		for(i=0;i< 38-stlen; i++)
			fprintf(s," ");

		speed = t&7;
		hands = 100-((t/10)*10);
		if(t == 0 || t == 1)
		{                      // average teams
			speed = 4;
			hands = 50;
		}
		fprintf(s, "%3d     %3d",speed,hands);

	}

	fclose(s);
}


WORD Distance(WORD x, WORD y);
WORD Distance2Players(WORD p1, WORD p2);

void testdist(void)
{
UWORD	x1,y1;
WORD	answer;

	gPNum = 0;

	CPXPos = 140*YARDS;
	CPYPos = 130*YARDS;

	x1=	150*YARDS;
	y1=	130*YARDS;

	answer = Distance(x1,y1);
	x1 = answer;

	OPXPos(1) = 150*YARDS;
	OPYPos(1) = 130*YARDS;

	answer = Distance2Players(0,1);

	x1=answer;
}


/*********************************************************************

						M A I N    routine


*******************************************************************/

void TestIRP(void);


void AllocAIMemory(void);
void FreeAIMemory(void);

void TestCPUPCall(void);
void TestFGOutCome(void);

void TestDive(void);

void PrintStatSize(void);

void InitGameDataPart1(void);




void PCInitialTests(void)	// put test routines here
{
//	bktest();

//	InitGameData();
//	VerifyROMData(0);

/*{
UWORD i;

	for(i=DEF_GOAL_LINE-2*YARD; i <DEF_GOAL_LINE+2*YARD+1; i+=32)
	{
		printf("\ni=%x, true = %x",i,RoundToNearestWholeYard(i));
	}
	getch();
	for(i=OFF_GOAL_LINE-2*YARD; i <OFF_GOAL_LINE+2*YARD+1; i+=32)
	{
		printf("\ni=%x, true = %x",i,RoundToNearestWholeYard(i));
	}
	getch();

	for(i=DEF_GOAL_LINE-20; i <DEF_GOAL_LINE+20; i+=1)
	{
		printf("\ni=%x, true = %x",i,RoundToNearestWholeYard(i));
	}
	getch();
	for(i=OFF_GOAL_LINE-20; i <OFF_GOAL_LINE+20; i+=1)
	{
		printf("\ni=%x, true = %x",i,RoundToNearestWholeYard(i));
	}
	getch();
}
*/
/*
{
WORD i,j;
	for(i=0; i <MAX_NUM_SPEEDS; i++)
	{
		printf("\nSpeed = %d\n",i);
		for(j=0; j <MAX_DIRECTIONS; j++)
		{
			printf("%d-%d ",SpeedTable[i][j].X,SpeedTable[i][j].Y);
		}
		printf("\n");
		getch();
	}
	getch();
}
******/
//	printf("MAX_NUM_GAME_OPTNS = %d",MAX_NUM_GAME_OPTNS);
//	getch();


#if 0
{
WORD i;
	for(i=0; i <101; i+=10)	// test fumble %
		printf("\ni = %d, p1 = %d, p2 = %d", i,(150 - i) >> 1,(150 - i/2));
	getch();
}

{
WORD i;
	for(i=0; i<16; i++)
		printf("\n%2d dir=%2d %2d opp=%2d %2d",i,
			((DirVsDirTable[(EAST_DIR+8)&15][i])+8)&15,
			(16 - (DirVsDirTable[(EAST_DIR+8)&15][i])),
			((DirVsDirTable[(WEST_DIR+8)&15][i])+8)&15,
			(16 - (DirVsDirTable[(WEST_DIR+8)&15][i]))

			);
	getch();
}
#endif

//	PrintStatSize();	// and display RAM stats
//	getch();


#if 0	// look at struct/ file sizes
	printf("\nSize of 1 = %d,",sizeof(TEAMRAMStats));	// do both teams
	printf("\nSize of 30 = %d,",30*sizeof(TEAMRAMStats));	// do both teams

//	printf("\nSize of allpdata = %d",sizeof(struct allpdata));
//	printf("\nSize of irpunion = %d",sizeof(union irpunion));
	printf("\nSize of OneTimeIRP = %d",sizeof(OneTimeIRP));
//	printf("\nSize of CurrentIRPData = %d",sizeof(CurrentIRPData));
//	printf("\n1 sec if IRP = %d bytes",sizeof(CurrentIRPData)*AI_FRAME_RATE);
	printf("\n\nSize of 1 IRP frame = %d",sizeof(struct frameIRPData));
	printf("\nSize of 1TEAM STD = %d",sizeof(struct specificteamdata) );
	printf("\nSize of MAX TEAMS STD = %d",sizeof(struct specificteamdata) * MAX_NUM_TEAMS );
	printf("\nSize of specificplayerdata = %d",sizeof(specificplayerdata));
	printf("\nSize of gtd = %d",sizeof(struct gameteamdata  ));

	getch();
#endif


#if	0	//def __MSDOS__

  {
	WORD i;
	for(i=0; i <MAX_AI_GRAPHICS; i++)
		printf("\nFrames per AI Anim %2d = %2d",i,MaxAIFrames[i]);
	getch();

	for(i=0; i <MAX_FORMATIONS; i++)
		printf("\nOff. Seq. = %2d, %2d %s",i,SequentialOffFormIndex[i],FormationNames[i]);
	getch();

  }

//	PrintRatings();	// to a file
//	testran();
//	testdist();
#endif
//	TestDive();
//	getch();

#if 0
	TestFGOutCome();


	TestDuress();

	TestCPUPCall();
#endif

}



//void DisplayPlayerROMData(specificplayerdata *pdptr);

/********************************************************************/

void PCGraphicGame(void)
{

/*  need faster delay for correct movement delay =1 is 1/4 sec. -
	still too slow but better then nothing	*/
	system("mode con:rate=30 delay=1");

	ShowHuddle = FALSE;

	AllocAIMemory();	// Instant Replay Buffer


//	TestIRP();	// MUST be after AllocAI Memory
//	getch();

	InitGameData();

//	CoinVisitorKickFlag = (DrawFieldWait())&1;	// see who won coin toss
	CoinVisitorKickFlag = 1;
	InitGameDataPart1();

	InitGameDataPart2();

	TestAI();		// the actual meat of the program

	FreeAIMemory();


/* restore to default	*/
	system("mode con:rate=30 delay=3");

}



void ListTeams(void)
{
WORD i;

	for(i=0; i<MAX_NUM_TEAMS; i++)
	{
		printf("\n%2d - %s %s",i,
				SpecificTeamData[i].TeamCity,
				SpecificTeamData[i].TeamNickName);

		if( (i!= 0 && i%25 == ZERO)
		   || i == MAX_NUM_TEAMS-1)
		{
			if(getch() == ESCAPE)
				break;
		}

	}


	for(i=0; i<NumColleges; i++)
	{

		printf("\n%3d - %20s.",i,
				(CollegePtr+i)->collegename );

		if( (i!= 0 && i%25 == ZERO)
		   || i == NumColleges-1)
		{
			if(getch() == ESCAPE)
				break;
		}

	}
}

void ViewLeaguePlayer(void);

void  DoShellInstructions(void)
{
	clrscr();

	printf("GameTek Football Debugging Program\t(c) 1996,1997 GameTek, Inc.\n");
	printf("\n\n\t\t---------- Shell ----------");

	printf("\n\nCurrent Game - %s vs. %s\n\n",
			SpecificTeamData[GameTeamData[0].TeamNumber].TeamNickName,
			SpecificTeamData[GameTeamData[1].TeamNumber].TeamNickName);

	printf("\n\t'G'- Start Game");
	printf("\n\t'L'- List Plays");
	printf("\n\t'H'- Select Home Team");
	printf("\n\t'A'- Select Away Team");
	printf("\n\t'R'- Analyze Ratings");
	printf("\n\t'S'- List 1997 NFL Schedule");
	printf("\n\t'T'- List Teams");
	printf("\n\t'V'- View Player");
	printf("\n\t'Y'- Debug/Stats Screen");
	printf("\n\t'X' or ESC = Exit Program");

	printf("\n\nWhadda ya wantta do??? ");

}

/**************************************************************

				S H E L L   -   E X H I B I T I O N


**************************************************************/

void NormalGame(void)	// and shell
{

BOOL done = FALSE;
BYTE ch;

	PCInitialTests();

	LoadPlayerDataForGame();	// revised 4/11/97 for new season data base

	while (!done)
	{
		DoShellInstructions();

		ch = tolower(getch());

		if(ch == 'g' || ch == 'p')
		{	// play game

			FreeLeaguePlayerData();	// need room for IRP

			PCGraphicGame();

			LoadLeaguePlayerData();

		}
		else if(ch == 'h')
		{
			SetTeamNum(0);
		}
		else if(ch == 'a')
		{
			SetTeamNum(1);
		}
		else if(ch == 'l')
		{
			ListPlays();
		}
		else if(ch == 'y')
		{
			DebugScreen();
		}
		else if(ch == 's')
		{
			ListSchedule();
		}
		else if(ch == 'v')
		{
			ViewLeaguePlayer();
		}
		else if(ch == 't')
		{
			ListTeams();
		}
		else if(ch == 'r')
		{
			CheckRatings();
		}
		else if(ch == 'x' || ch == ESCAPE)
		{
			done = TRUE;
		}

	}
}


/****************************** M A I N  *****************************/

WORD SGLow=0;
WORD SGHigh=0;
WORD SimsPerGame=1;

void main(int argc, char *argv[])
{

	PowerOnAIInitialization();	// ParseCMD may override default options(QLength)

	LoadLeaguePlayerData();	// set up LeaguePlayersPtr

	CPUSimLevel = 0;	// no info - could be overriden by command line
	DisplayLevel = 0;

//	randomize();

	if(ParseCmdLine(argc, argv))
	{
		if(CPUSimLevel)
		{
			DisplayLevel = CPUSimLevel-1;	// careful - tricky bit stuff
			CPUDebugHike = DoKickOffs = 1;

			if(CPUSimLevel == 1)
				randomize();

			SimEntireSeason();	// or a portion thereof
		}
		else
		{
		 /* following are AI vars which are strictly PC based	*/
			DisplayLevel = DISPLAY_EOP_INFO;	// display info after play
			DoKickOffs = 0; 	// they just get in the way
			CPUDebugHike = 0;	// no hike so I can test

			NormalGame();	// regular football debug
		}
	}


	FreeLeaguePlayerData();
}




/**************************************************************

	RETURNS: a number from 0-99 OR -1 if no change

***************************************************************/
WORD  GetNum0_99(void)
{
WORD  rv,Num[2];
BOOL  done = FALSE;
BYTE  ch;


	Num[0] = Num[1] = 0;

	while(!done)
	{
		ch = getch();
		if( ch == '\r')
		{
			rv = Num[1]*10 + Num[0];
			done = TRUE;
		}
		else
		{
			if (ch >= '0' && ch <= '9')
			{
				putchar(ch);
				Num[1] = Num[0];
				Num[0] = ch-'0';
			}
			else if(tolower(ch) == 'x' || ch == 0x1b) /* X, ESC exits */
			{
				done = TRUE;
				rv = -1;
			}
		}
	}
	return(rv);
}

WORD  GetNum0_999(void)
{
WORD  rv,Num[3];
BOOL  done = FALSE;
BYTE  ch;


	Num[0] = Num[1] = Num[2] = 0;

	while(!done)
	{
		ch = getch();
		if( ch == '\r')
		{
			rv = Num[2]*100 + Num[1]*10 + Num[0];
			done = TRUE;
		}
		else
		{
			if (ch >= '0' && ch <= '9')
			{
				putchar(ch);
				Num[2] = Num[1];
				Num[1] = Num[0];
				Num[0] = ch-'0';
			}
			else if(tolower(ch) == 'x' || ch == 0x1b) /* X, ESC exits */
			{
				done = TRUE;
				rv = -1;
			}
		}
	}
	return(rv);
}

WORD  GetNum0_9999(void)
{
WORD  rv,Num[4];
BOOL  done = FALSE;
BYTE  ch;


	Num[0] = Num[1] = Num[2] = Num[3] = 0;

	while(!done)
	{
		ch = getch();
		if( ch == '\r')
		{
			rv = Num[3]*1000+ Num[2]*100 + Num[1]*10 + Num[0];
			done = TRUE;
		}
		else
		{
			if (ch >= '0' && ch <= '9')
			{
				putchar(ch);
				Num[3] = Num[2];
				Num[2] = Num[1];
				Num[1] = Num[0];
				Num[0] = ch-'0';
			}
			else if(tolower(ch) == 'x' || ch == 0x1b) /* X, ESC exits */
			{
				done = TRUE;
				rv = -1;
			}
		}
	}
	return(rv);
}

EFFVAR BuildPlayerDataForGame(WORD slotnum);	// revised 4/11/97 for new season data base
/******************************************************************/

void  SetTeamNum(WORD teamslot)
{
WORD  t;

	printf("\nInput Team Num (0 - %d) for %s team, X to exit- "
							,MAX_NUM_TEAMS-1,teamslot ==0?"Home":"Away");

	t = GetNum0_99();
	if(t < ZERO || t >= MAX_NUM_TEAMS)
	{
		return;
	}
	else
	{
		GameTeamData[teamslot].TeamNumber = t;
		BuildPlayerDataForGame(teamslot);	// revised 4/11/97 for new season data base
//		LoadPlayerDataForGame();	// revised 4/11/97 for new season data base

//		InitGameData();		// resets players abilities
	}
}



/******************************************************************/

void  SetSBLoc(void)
{
WORD  t;

	printf("\nInput Line of Scrimmage (1 - 99), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			PracticeStartBallX = t* YARDS + DEF_GOAL_LINE;

}



/******************************************************************/

void  SetCurBallGrav(void)
{
WORD  t;

	printf("\nInput Current Ball Gravity (1 - 99), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			BV1 = t;

}


/******************************************************************/

void  SetInitBallGrav(void)
{
WORD  t;

	printf("\nInput Initial Ball Gravity (1 - 99), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			BV2 = t;

}

void  SetTheDown(void)
{
WORD  t;

	printf("\nInput Down (0 - 4), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
	{
		if(t > 4)
			t = 4;
		TheDown = t;
	}
}

void  SetTheQuarter(void)
{
WORD  t;

	printf("\nInput Quarter (1 - 5), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
	{
		if(t > 5)
			t = 5;
		TheTrueQuarter = TheQuarter = t;
	}
}

void  PCSetQuarterTime(void)
{
WORD  t;

	printf("\nInput Seconds In Quarter (0 - ?), X to exit- ");

	if((t = GetNum0_999()) >= ZERO)
	{
		if(t > 15*60)
			t = 15*60;
		t *= CLOCKS_TICKS_PER_SECOND;
		SetVBlankTimer(GAME_TIMER_NUM,t);
	}
}


/******************************************************************/

void  SetCurBallDeltaZ(void)
{
WORD  t;

	printf("\nInput Cur. Ball Delta Z (in SIXTEENTH YARDS), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			BV3 = t * SIXTEENTH_YARD;

}

/******************************************************************/

void  SetConBallDeltaZ(void)
{
WORD  t;

	printf("\nInput Constant Ball Delta Z (in SIXTEENTH YARDS), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			BV4 = t * SIXTEENTH_YARD;

}

/******************************************************************/

void  SetBallDeltaX(void)
{
WORD  t;

	printf("\nInput Ball Delta X (in QTR YARDS-4to8), X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			BallDeltaX = t * QTR_YARD;

}


void  SetWind(void)
{
WORD  t;

	printf("\nInput Wind Delta X, X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			WindDeltaX = t;

	printf("\nInput Wind Delta Y, X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			WindDeltaY = t;

}


void SetGenValue(void)
{
WORD  t;

	printf("\nInput General Value, X to exit- ");

	if((t = GetNum0_99()) >= ZERO)
			GenValue = t;

}



void DisplayPlayerROMData(lgplyrPTR pdptr);


lgplyrPTR GetLeaguePlayerPtr(EFFVAR pnum)
{
lgplyrPTR tpdptr;


	if(LeaguePlayersPtr == NULL)
	{
		return(NULL);	// error
	}
	else
	{

		tpdptr = LeaguePlayersPtr + pnum;

	}
	return(tpdptr);
}


void ViewLeaguePlayer(void)
{
WORD  pnum;
BOOL done = FALSE;

	while(!done)
	{
		printf("\nInput Player Number (0-%d)- ",MAX_PLAYERS_IN_LEAGUE-1);

		if(LeaguePlayersPtr == NULL)
		{
			printf("\nLeaguePlayerPtr == NULL");
			done = TRUE;
		}
		else if((pnum = GetNum0_9999()) >= ZERO && pnum < MAX_PLAYERS_IN_LEAGUE)
		{
			DisplayPlayerROMData(GetLeaguePlayerPtr(pnum));
		}
		else
		{
			done = TRUE;
		}
	}
}



void CleanUpInstantReplay(void);
void InitInstantReplay(void);
void DoInstantReplay(WORD framestoinc);
BOOL OKForInstantReplay(void);


void TestInstantReplay(void)
{
WORD framestoinc = 1;
BOOL inplay;
WORD ch,savevid;

	if(OKForInstantReplay())
//	if(MaxIRPFrameCounter != ZERO)
	{
		savevid =  GetBiosVideoMode();


		SCREEN_X_OFFSET = StartBallX < MID_FIELDX ? LEFT_SIDE_SCREEN_OFFSET:RIGHT_SIDE_SCREEN_OFFSET;
//		DoFieldInstructions();
		InitInstantReplay();

		DoInstantReplay(0);

		DrawField();
		PlotPlayers();
		inplay = TRUE;


		while (inplay)
		{

			ch = 1;
//			if(kbhit())
#if MKkeys
				ch = tolower(getch());
#else
			ch = tolower(GetPcKey(1));		// 0 means don't wait
#endif
			if(ch == 'q' || ch == 0x1b)
			{
				inplay = FALSE;
			}
			if(ch == '1')
			{
				framestoinc	= 1;
			}
			if(ch == '2')
			{
				framestoinc	= 2;
			}
			if(ch == '8')
			{
				framestoinc	= -1;
			}
			if(ch == '9')
			{
				framestoinc	= -2;
			}
			if(ch == 'b')
				bigguys = TRUE;

			if(ch == 'l')
				bigguys = FALSE;
			if(ch == 'z')
					ShowZones = !ShowZones;


			DoInstantReplay(framestoinc);
			PlotPlayers();
			PlotBallHeight();

		}
		CleanUpInstantReplay();

		if(savevid !=  GetBiosVideoMode())
			SetBiosVideoMode(savevid);
	}

}






#define pd(x,yyy)		case x:	JpadData[0] = (yyy); break;

void MKConvertPSXPads(WORD key)
{
	PrevJpad[1] = JpadData[1];		// fake controller #2 (0,1)
	JpadData[1] = 0;

	PrevJpad[0] = JpadData[0];
	JpadData[0] = 0;
	if(key == -1)
		return;

	switch(key)
	{
		pd('a',JPADRleft)
		pd('w',JPADRup)
		pd('d',JPADRright)
		pd('x',JPADRdown)
		pd('4',JPADLleft)
		pd('8',JPADLup)
		pd('6',JPADLright)
		pd('2',JPADLdown)
		pd('-',JPADLfront1)		//L1
		pd('=',JPADRfront1)		//r1

		pd('7',JPADLup | JPADLleft)
		pd('9',JPADLup | JPADLright)
		pd('3',JPADLdown| JPADLright)
		pd('1',JPADLdown | JPADLleft)

		pd('\\',JPADLfront1 | JPADLfront2) // no huddle combo


	}
}



#if 0

#define pd(x,yyy)		case x:	JpadData[0] = 1<<yyy; break;
#define pd1(x,yyy,zz)	case x:	JpadData[0] = (1<<yyy) | (1<<zz); break;

void MKConvertPSXPads(WORD key)
{
	PrevJpad[1] = JpadData[1];		// fake controller #2 (0,1)
	JpadData[1] = 0;

	PrevJpad[0] = JpadData[0];
	JpadData[0] = 0;
	if(key == -1)
		return;

	switch(key)
	{
		pd('a',7)
		pd('w',4)
		pd('d',5)
		pd('x',6)
		pd('4',15)
		pd('8',12)
		pd('6',13)
		pd('2',14)
		pd('-',2)		//L1
		pd('=',3)		//r1

		pd1('7',15,12)
		pd1('9',12,13)
		pd1('3',13,14)
		pd1('1',14,15)

	}
}

#endif


/*-------------------------------------------------------------
  AllocMem ~ Allocate memory
-------------------------------------------------------------*/
void * AllocMem(long bytes)
{
register void *ptr;
//UWORD size = (bytes/MAX_IRP_FRAMES);

	ptr = (void *) malloc((UWORD)bytes);
//	ptr = (void *) malloc((UWORD)bytes);
//	ptr = malloc(bytes);
#if PC_ALWAYS_MODE
	if(ptr == NULL)
		printf("Unable to AllocMem: %d\n", bytes);
	else
		printf("\nAllocMem: IRP buffer = %lx (%ld)\n",ptr,(LONG)bytes);
//	getch();
#endif
	return ptr;
}

/*-------------------------------------------------------------
  FreeMem ~ Free memory
-------------------------------------------------------------*/
void FreeMem(void *ptr)
{
	free(ptr);
#if DEBUG_MALLOC
	 DebugPrintf(0, "FreeMem: %X\n", ptr);
#endif	 
}



void CopyBytes (UBYTE *src , UBYTE *dest , int count )
{

	memcpy(dest, src, count);

}


/********************************************************************

				DUMMY    SOUND   ROUTINES
	  moved to FBAIMain.c
********************************************************************/
#if 0
void SetCrowdLevel(BYTE v0,BYTE v1,BYTE v2,BYTE v3,BYTE LChannelPercent);	//

void SetCrowdLevel(BYTE v0,BYTE v1,BYTE v2,BYTE v3,BYTE LChannelPercent)
//void SetCrowdLevel(BYTE loudness0_89,BYTE LChannelPercent)
{ // range on L channel = 25-75
	v0 = v1= v2= LChannelPercent;		// i hate warnings
	LChannelPercent = v0;
	v1= v2 = v3;
	v2=v1;
	v3 = v1;
	v3 = v2;
}
/*
void InitSFXLoop(WORD newloopsfx)	//proto
{
	newloopsfx = newloopsfx;
}
*/
/*
short PlayEffect(short num)
{
	return(num);
}
*/
short PlayEffectCheck(short num)
{
	return(num);
}
/*
void StopEffect(short num)
{
	num = num;
}
*/
/*
short CheckEffect(short voice_channel)
{
	voice_channel = FALSE;
	return(voice_channel);
}
*/
/*
short SetVoiceVolume(WORD voicenum, WORD volumeL, WORD volumeR)
{
	volumeL = volumeR; 	// i hate complier warnings
	volumeR = volumeL;
	return voicenum;

};

void InitPhrase(short *PhrasePtr, short num)
{
	num = *PhrasePtr;
	num = num;
}
*/

#endif
void StartVBlankTimer ( int num )
{
	num = num;
}

void StopVBlankTimer ( int num )
{
	num = num;
}


void SetVBlankTimer ( int num , ULONG val )
{
	gVBlankTimers[num] = val;
}

ULONG GetVBlankTimer(int num)

{
	return(gVBlankTimers[num]);
}



/*******************************************************************


		Test CPU Play Calling

	This routine simulates how a CPU team calls plays under
	certain conditions.

	Data is written to a file "CPU_PC.TXT"

*******************************************************************/

WORD NormalCPUPlayCallOffense(WORD thedown, WORD yardstogo, WORD team_type);
//WORD NormalCPUPlayCallOffense(WORD thedown, WORD yardstogo);
extern BYTE PositionFormToPCFormTable[];


void TestCPUPCall(void)
{

WORD testteams[5] = {0,68,99,102,32};
WORD playhitcount[MAXPLAYS+1];
FILE *s;
WORD t,teamnum,i,pnum;
WORD down, togo,ttnum;
UWORD total;
BYTE *tt[5] = {
	"Super Running",
	"Running",
	"Balanced",
	"Passing",
	"Super Passing" };


	s = fopen("CPU_PC.TXT", "w+");

	OffensiveSlotNum = 0;

	printf("\n\nSimulating CPU play calling");


  for(t=0; t < 1; t++)
  {
	teamnum  = GameTeamData[OffensiveSlotNum].TeamNumber = testteams[t];
	ttnum =	   SpecificTeamData[teamnum].Stats[0] % 5;
	fprintf(s, "\nTeam Num = %3d - %s" , teamnum, SpecificTeamData[teamnum].TeamCity);
	fprintf(s, "\tTeam type = %s",tt[ttnum]);
	fprintf(s, "\nValid Formation Numbers = ");
	for(i=0; i < 5; i++)
	{
		pnum = SpecificTeamData[teamnum].Formations[0][i];
		fprintf(s, "\n\t%3d  %s",pnum, FormationNames[pnum]);
	}

	for(togo = 13; togo> ZERO; togo-=4)
	{
	  for(down=1; down <4; down++)
	  {
		fprintf(s, "\n\nTeam Num = %3d - %s" , teamnum, SpecificTeamData[teamnum].TeamCity);
		fprintf(s, "\tDown = %d, ToGo = %2d",down,togo);

		total = 0;
		for(i=0; i <= MAXPLAYS; i++)
			playhitcount[i] = ZERO;

		for(i=0; i <10000; i++)
		{
			pnum = NormalCPUPlayCallOffense(down, togo*YARDS,ttnum);
			if(pnum < ZERO || pnum >= MAXPLAYS)
				playhitcount[MAXPLAYS]++;		// error checking
			else
			{
				playhitcount[pnum]++;
				total++;
			}
		}

		pnum = 0;
		fprintf(s, "\n\tPnum Hits  Formation \t Play name");
		fprintf(s, "\n\t---------------------\t-------------");
		for(i=0; i <MAXPLAYS; i++)
		{
			if(playhitcount[i] != ZERO)
			{
				pnum++;		// total to choose from
				fprintf(s, "\n\t %3d %4d %2d,%2d-%s \t %s",i,
							playhitcount[i],
							ThePlays[i].FormationNumber,
							PositionFormToPCFormTable[ThePlays[i].FormationNumber],
							FormationNames[PositionFormToPCFormTable[ThePlays[i].FormationNumber]],
							PlayNames[i]	);
			}
		}

		fprintf(s, "\n\t%2d Plays to choose from %5d total Simulated Plays  ",pnum,total);
		printf(". ");

	  }		// end down loop
	}		// end togo loop

	fprintf(s, "\n\n");	// white space between teams

   }

   fclose(s);
}


/*---------------------------------------------------------------------*/

WORD FieldGoalHitorMiss(UWORD maxdistance);


void TestFGOutCome(void)
{
WORD i,j,kickstr,count;
WORD outcome[22][22];


	for(i=0; i<22; i++)
		for(j=0; j<22; j++)
			outcome[i][j] = 0;


	for(i=0,KickStartX = OFF_GOAL_LINE-15*YARDS; KickStartX > OFF_GOAL_LINE-60*YARDS; KickStartX -= 3*YARDS,i++)
	{
		for(j=0,kickstr = 0; kickstr <101; kickstr +=5,j++)
		{
			MaxKickDistance = 55*YARDS + (kickstr* YARDS/5);

			for(count = 0; count <1000; count++)
			{
				if(FieldGoalHitorMiss(MaxKickDistance) == MAKE_FG)

					outcome[i][j]++;
			}
		}
	}

	printf("\n     ");

	for(i=25; i <68; i+= 3)
		printf("%3d,",i);

	for(j=0; j<21; j++)
	{
		printf("\n%3d  ",j*5);
		for(i=0; i<15; i++)
		{
			printf("%3d,",outcome[i][j]);

		}
	}
	getch();
}

/**********************************************************************

				PSX   File handler  mimic


	Since PC only loads type of player data, blocksize is based on
	pdata_t size.

	note:
		fread(ptr, 1, 93000,file)  does NOT work
		fread(ptr, 64, 1340,file)  does  work	(reads all league players)


**********************************************************************/


#include <fcntl.h>
#include <io.h>
//#include <sys\stat.h>
#include <conio.h>

#if 1
void * LoadCDFile(BYTE *fname)
{
void *buffer;

LONG flen1;
FILE *stream;

LONG flen;	// = sizeof(struct pdata_t) * (LONG)MAX_PLAYERS_IN_LEAGUE;
WORD blocksize = sizeof(struct pdata_t);	// 64 bytes as of 4/10/97
WORD numplyrs;
WORD handle;

	/* figure size of file to load		*/
	if ((handle = open(fname, O_RDONLY | O_BINARY)) == -1)
	{
		printf("\nError Opening File- %s",fname);
		printf("\nPress any key to continue");
		getch();
		return (NULL);
	}


	flen  = filelength(handle);
	close(handle);

/****
	printf("The difference between the highest allocated block and\n");
	printf("the top of the heap is: %lu bytes\n", (unsigned long) coreleft());
	printf("The difference between the highest allocated block in the far\n");
	printf("heap and the top of the far heap is: %lu bytes\n", farcoreleft());
	getch();	****/

	if( (buffer = farmalloc(flen)) == NULL)
	{
		printf("\nCan't allocate %ld bytes for file %s",flen,fname);
		printf("\nPress any key to continue");
		getch();
		return (NULL);
	}

	if ((stream = fopen(fname, "rb"))	== NULL)
	{
		printf("\nCannot open file %s 2nd time",fname);
		FreeMem(buffer);
		return (NULL);
	}

	numplyrs =  (flen+blocksize-1)/blocksize;	// give 1 extra block

	flen1 = fread(buffer,blocksize , numplyrs, stream);

	if(flen1 != numplyrs)
	{
		printf("\nBad read on %s - only %d",fname,flen1);
//		getch();
//		return (NULL);
	}


	fclose(stream);

	return buffer;

}

#else


void * LoadCDFile(BYTE *fname)	// only reads 65K max bytes
{
void *buffer;
WORD handle, bytes;
LONG flen;

	if ((handle = open(fname, O_RDONLY | O_BINARY)) == -1)
	{
		printf("\nError Opening File- %s",fname);
		printf("\nPress any key to continue");
		getch();
		return (NULL);
	}


	flen  = filelength(handle);
	buffer = malloc(flen);


	if ((bytes = read(handle, buffer, flen)) == -1)
	{
		printf("\nRead Failed on %s - wanted %d, got%d bytes",fname,flen,bytes);
        getch();
		return (NULL);
	}
	else
	{
//		printf("\nRead: %d bytes read from %s", bytes,fname);
	}

	close(handle);

	return buffer;

}
#endif

void FreeFileData(void *mem)
{
	free(mem);
}


/*---------------------------------------------------------------------*/

UWORD SecondsOnPlayClock(void);
WORD SecondsLeftInGame(void);


void SimGameClock(void)
{

	if(!(GameFlags&FREEZE_ACTIVATED_BFLAG))	// going to LOS time
	{
		if(GameFlags & GAME_TIMER_ON_BFLAG)
		{
			gVBlankTimers[GAME_TIMER_NUM] -= TICKS_PER_AI_FRAME; // 3(?) ticks per frame
			if(gVBlankTimers[GAME_TIMER_NUM] > 0xffffff00L)	// unsigned
				gVBlankTimers[GAME_TIMER_NUM] = ZERO;   //leave on ZERO if expired
		}
		if(GameFlags & PLAY_TIMER_ON_BFLAG)
		{
			gVBlankTimers[PLAY_TIMER_NUM] -= TICKS_PER_AI_FRAME; // 3(?) ticks per frame
			if(gVBlankTimers[PLAY_TIMER_NUM] > 0xffffff00L)	// unsigned
				gVBlankTimers[PLAY_TIMER_NUM] = ZERO;   //leave on ZERO if expired
		}
	}
}

int PlayPostGameMovie(WORD team01);

int TimeDownPlaycall(void);
WORD ForceFleaPlay(void);
WORD ForceBombPlay(void);

extern WORD team_type;

BOOL SimCPUGame(void)
{
//WORD ch,i,t;
BOOL needplaycall, inplay;
BYTE ch;
WORD playcount = 0;
WORD secs;
struct  time tm;
ULONG  startticks,endticks;
WORD pa,ph;
BOOL playcallactive;
BOOL rv = TRUE;		// assume game ends okay

printf("\nRunning Game Simulation - t#%d-%s(HOME)(TT%d) vs. t#%d-%s(TT%d)",
			GameTeamData[0].TeamNumber,GameTeamData[0].STD.TeamNickName,GameTeamData[0].STD.TeamType,
			GameTeamData[1].TeamNumber,GameTeamData[1].STD.TeamNickName,GameTeamData[1].STD.TeamType);

	gettime(&tm);
	startticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

	FieldDir = 4;		// PC goes L to R

	while(! (GameFlags & LEAVE_GAME_BFLAG))
	{
		playcount++;

	 /****  Here's PC "PLAY CALL SCREEN"   *************************/
		InitPlayClock();	// called at beginning of play call
		StartPlayClock(); 	// called at beginning of play call

		playcallactive = TRUE;
//		GameTeamData[OffensiveSlotNum].PlayNum = ForceRunPlay(); // TEST only
//		GameTeamData[OffensiveSlotNum].PlayNum = ForceFleaPlay(); // TEST only
//		GameTeamData[OffensiveSlotNum].PlayNum = ForceBombPlay(); // TEST only
//		GameTeamData[OffensiveSlotNum].PlayNum =	SingleBackPACrossNUM;
//		GameTeamData[OffensiveSlotNum].PlayNum = ForceOffPlayNum(10);

		GameTeamData[OffensiveSlotNum].PlayNum = CPUPlayCallOffense();

//		GameTeamData[DefensiveSlotNum].PlayNum = ForceDefPlayNum(DefGoalLineHousePartyNUM);

		GameTeamData[DefensiveSlotNum].PlayNum = CPUPlayCallDefense();

		PlayCallStatus = 0;	// null state

		FreezeAllClocks();	// sim the actual game(TOP problems)

	 /****  Here's end of PC "PLAY CALL SCREEN"   *************************/

		ph = GameTeamData[0].PlayNum;
		pa = GameTeamData[1].PlayNum;

/*
	   //KOType normally set up by CPUPC
		if(GameTeamData[DefensiveSlotNum].PlayNum == KickoffStackLeftNUM
			|| GameTeamData[DefensiveSlotNum].PlayNum == KickoffStackRightNUM)
				KickOffType = ONSIDE_KO_TYPE;
		else
			KickOffType = NORMAL_KO_TYPE;
*/
		if(DisplayLevel & DISPLAY_EOP_INFO)	//display  mucho info in this mode
		{
			PrintFieldParameters(FALSE);	// down and togo and where at
//			secs = gVBlankTimers[GAME_TIMER_NUM]/CLOCKS_TICKS_PER_SECOND;
			secs = SecondsLeftInQuarter();

			printf("  Q=%d,t=%d:%02d%s (%d:%02d-%d:%02d)\nP#=%2d Score=H%d A%d (%d)%s-(%d)%s TT=%d %d:%02d",
				TheQuarter,secs/60,secs%60,
				((GameFlags & GAME_TIMER_ON_BFLAG)?"r":"s"),
				StatsData[0].allplyrstats[GS_TOP]/60,
				StatsData[0].allplyrstats[GS_TOP]%60,
				StatsData[1].allplyrstats[GS_TOP]/60,
				StatsData[1].allplyrstats[GS_TOP]%60,


				playcount,
				GameTeamData[0].TotalScore,GameTeamData[1].TotalScore,
				ph,GetPlayName(ph),pa,GetPlayName(pa)
				,team_type
				,SecondsLeftInGame()/60,SecondsLeftInGame()%60


//				SecondsOnPlayClock()
			  );
		}


		needplaycall = FALSE;

		while (!needplaycall)	// if reset during play
		{
			TurnOffKickInterface();		//make sure off restart during play
//			PlayStateNum = 0;

//			FaceArray[0] = 255;

			inplay = TRUE;

			while (inplay)
			{
//				ReadPads();
				if(playcallactive)
				{
					if(TimeDownPlaycall())	// wait for CPU
					{
						if(DisplayLevel)
							printf(" PC=%d",SecondsOnPlayClock());
						StartPlayAI();
						playcallactive = FALSE;
					}
				}

//				if(CPUSimLevel)
//				{
					if(AIIsStalled())
					{
						CameraOnScoreBoard();
						UnstallAI();
					}
//				}

				DoAI();

				SimGameClock();

				if(OkayToStartPlayCall() || (GameFlags & LEAVE_GAME_BFLAG))
				{
					needplaycall = TRUE;
					inplay = FALSE;
				}

				if (kbhit())
				{
					ch = tolower(getch());	//  get 1st key in buffer
					if(ch == 0x1b)	//ESCAPE???
					{
						needplaycall = TRUE;
						inplay = FALSE;
						SetBit(GameFlags, LEAVE_GAME_BFLAG);
						rv = FALSE;
						printf("\n\n   *************   GAME  ABORTED  -  NOT   SAVED  **********\n");
/*						printf("\nPState=%d, PStateFlags=%d, LBC=%d, TAC=%d,strut=%d,x=%x, y=%x, tx=%x, ty=%x, anim=%d seq#=%d REFSFXP =%d, CGUY = %d\n ",
							PlayStateNum,PlayStateFlags,LastBallCarrier,Tackler,DefStrutter,
//							OPXPos(PlayStateFlags),OPYPos(PlayStateFlags),
//							OPTargetX(PlayStateFlags),OPTargetY(PlayStateFlags),
//							PlayerAIGraphicState[PlayStateFlags],
//							PlayerAIGraphicSequence[PlayStateFlags],
							OPXPos(CameraGuy),OPYPos(CameraGuy),
							OPTargetX(CameraGuy),OPTargetY(CameraGuy),
							PlayerAIGraphicState[CameraGuy],
							PlayerAIGraphicSequence[CameraGuy],
							RefSFXPending,CameraGuy
							); */
						getch();
						DebugScreen();
					}
					else if (ch == 'p')
					{
						DebugScreen();
					}
				}
			}
		}
	}
	gettime(&tm);
	endticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

	secs = (endticks-startticks)/100;
	printf("\nFinal Score - (H)%s %d, (A)%s %d -NumPlays = %d - Sim time = %d sec",
				GameTeamData[0].STD.TeamNickName,GameTeamData[0].TotalScore,
				GameTeamData[1].STD.TeamNickName,GameTeamData[1].TotalScore,
				playcount,secs);

	startticks = TimeOfPoss[0]/CLOCKS_TICKS_PER_SECOND;
	endticks = TimeOfPoss[1]/CLOCKS_TICKS_PER_SECOND;
	printf("\nTOPoss(ticks) = %ld - %ld total=%ld true = %ld" ,TimeOfPoss[0],TimeOfPoss[1],
			TimeOfPoss[0]+TimeOfPoss[1],QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]*4);
	printf("\nTimeOfPoss = %ld - %ld  total = %ld true = %ld",startticks,endticks,
			startticks+endticks,
			(QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]*4)/CLOCKS_TICKS_PER_SECOND);

	return(rv);
}


void SaveGameDataAsFile(WORD seasongamenum);
BOOL SaveGameDirFull(WORD seasongamenum);
BOOL TrueSimGame(void);

//#define GAMES_TO_SIM	10
//#define SIMS_PER_GAME	10

void SimEntireSeason(void)
{
WORD sg,g;    //WARNING - directory structure must be setup (.bat
WORD secs;
struct  time tm;
ULONG  startticks,endticks;

	printf("\nSim Level =%d,Starting Game= %d, Ending Game = %d, # sims per game = %d",
				CPUSimLevel,SGLow,SGHigh,SimsPerGame);

	gettime(&tm);

	startticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;


//	GameOptions[GAME_OPTNS_FUMBLES] = OPTION_OFF;	//test only
//	GameOptions[GAME_OPTNS_QTR_LENGTH] = 3;	//15 min Qs
//	GameOptions[GAME_OPTNS_QTR_LENGTH] = 0;	//2 min Qs

	FillRunPlaysArray();	//test only

	SetCPUvsCPUGameParameters();

//	AllocAIMemory();	// no IRP for Sim games

	for(sg=SGLow; sg <= SGHigh; sg++)
	{

		GameTeamData[0].TeamNumber = schedule[sg].home;
		GameTeamData[1].TeamNumber = schedule[sg].away;

		for(g=0; g < SimsPerGame; g++)	// do this many games
		{

			if(SimsPerGame > 3)
			{
				if(SaveGameDirFull(sg))
				{
					printf("\nDir. full for Season Game #%d",sg);
					break;	// out of this game - do next game
				}
			}

			LoadPlayerDataForGame();	// revised 4/11/97 for new season data base

			FreeLeaguePlayerData();	// need room for IRP


			printf("\nSeason Game #%d - sim #%d",sg,g);
			InitGameData();
			CoinVisitorKickFlag = rand()&1;
			InitGameDataPart1();
			InitGameDataPart2();

//			if(TrueSimGame())
			if(SimCPUGame())
				SaveGameDataAsFile(sg);	// only save non-aborted games

			if(DisplayLevel & DISPLAY_EOG_STATS)
			{
				printf("\nMovie num for HOME = %d",PlayPostGameMovie(0));
				printf("\nMovie num for AWAY = %d",PlayPostGameMovie(1));
				getch();
				DebugScreen();
			}

			LoadLeaguePlayerData();

		}
	}

//	FreeAIMemory();

	gettime(&tm);
	endticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

	secs = (endticks-startticks)/100;

	printf("\n\nTotal %d games in %d min, %d sec.",
			(SGHigh-SGLow+1)*SimsPerGame,secs/60,secs%60);

}


BOOL ParseCmdLine(int argc, char *argv[])
{	// return true if wamt to sim a season
BOOL rv = TRUE;

	if(argc > 1)
	{
		if(*argv[1] < '0'  ||  *argv[1] > '9')
		{
			printf("\nUsage: GTFB <simlevel> <season game-low> <season game-high> <# sims/> <Qtime>");
			printf("\nsimlevel =  0 - no sim, graphic play tester  [default]");
			printf("\n            1 - quick sim (best for M.A.B. sim - will randomize)");
			printf("\n            2 - verbose sim ");
			printf("\n            3 - dumpstats at end of sim");
			printf("\n            4 - verbose and dumpstats");
			printf("\nQtime = 0-3 -> 2,5,10,15 minute Quarters");
			printf("\nValid Season game #0-%d  - will error check",NUM_GAMES_IN_SEASON-1);
			printf("\nNOTE: if needed, all parameters must be in specific order");
			printf("\nIf no parameters, then normal graphic based play tester");
			rv = FALSE;
		}
		else
		{
			CPUSimLevel = atoi(argv[1]);
			CPUSimLevel = SetMinMax(CPUSimLevel, 0, 4);
			if(argc > 2)
			{
				SGLow = atoi(argv[2]);
				SGLow = SetMinMax(SGLow, 0, NUM_GAMES_IN_SEASON-1);
				if(argc > 3)
				{
					SGHigh = atoi(argv[3]);
					SGHigh = SetMinMax(SGHigh, 0, NUM_GAMES_IN_SEASON-1);

					if(argc > 4)
					{
						SimsPerGame = atoi(argv[4]);
						SimsPerGame	= SetMinMax(SimsPerGame, 1, 50);

						if(argc > 5)
						{
							GameOptions[GAME_OPTNS_QTR_LENGTH] = SetMinMax(atoi(argv[5]), 0, 3);
						}
					}
				}
			}
			if(SGHigh < SGLow)
				SGHigh = SGLow;

		}
	}

	return(rv);
}





/*   list all plays in formation indicating 3 currently selected
	Audible plays and the Key play (if selected, the Key play
	will become one of the audible plays
	NOTE: allows all 3 audibles to be 1 play, might need additional
	error checking if all 3 audibles must be unique
*/
void ListAudibleFormation(WORD formnum,WORD team01,WORD key)
{
WORD i,j,playnum;
WORD *formptr;
WORD hit;

	printf("\n%s Audibles- %s",GameTeamData[team01].STD.TeamNickName,FormationNames[formnum]);
	printf("\n------------------");

	formptr = GetPlaysPerForm(formnum);	// pointer to table, -1 at end

	i=0;
	while( (playnum = *(formptr+i)) >= ZERO)	// print all plays in form
	{
		textcolor(8);
		if(i==key)
			textcolor(10);	//currently selected play for possible change

		hit = 0;
		printf("\n");
		for(j=0; j<3; j++)	// is it an audible play?
		{
			if(playnum == TeamOffensiveAudible[team01][formnum][j])
			{
				cprintf("%d",j);
				hit++;
			}
		}
		while(hit++ <4)
			cprintf(" ");

		cprintf("  %s",GetPlayName(playnum));

		textcolor(8);	//standard (non-key) color
		i++;
	}
}



void ProgramAudibles(WORD team01)
{
WORD key,formcount,formnum,playnum,playsinform;
BOOL done = FALSE;
BYTE ch;
WORD *formptr;

	/****  WARNING  --  GameTeamData[X].  MUST have been set up -
		use team 0-1  NOT 0-29				*****/

	key = 0;
	formcount = 0;

	while(!done)
	{
		clrscr();
		formnum = GameTeamData[team01].STD.Formations[0][formcount];

		ListAudibleFormation(formnum,team01,key);
		printf("\n\nUse UP or DOWN to move\nA,W,D to select\nX = next formation\nQ or ESC to quit");

		playsinform = 0;
		formptr = GetPlaysPerForm(formnum);	// pointer to table, -1 at end
		playnum = *(formptr+key);
		while(*(formptr++) >= ZERO)
			playsinform++;

		ch = getch();
		switch(tolower(ch))	// see what they want to do
		{
			case 'a':
				TeamOffensiveAudible[team01][formnum][0] = playnum;
				break;
			case 'w':
				TeamOffensiveAudible[team01][formnum][1] = playnum;
				break;
			case 'd':
				TeamOffensiveAudible[team01][formnum][2] = playnum;
				break;
			case 'x':
				key = 0;
				if(++formcount > 4)
					formcount = 0;
				break;
			case '8':
				key--;
				if(key < ZERO)
					key = playsinform-1;
				break;
			case '2':
				key++;
				if(key >= playsinform)
					key = ZERO;
				break;
			case 'q':
			case 0x1b:	//escape
				done = TRUE;	// no need to "save" - real time modification
				break;
		}
	}

}
#define ESCAPE 0x1b

extern BYTE *PositionStrings[TOTAL_PLAYERS_ON_TEAM];

BYTE *RatingString[8] = {
	"SPEED_RATE",
	"STRENGTH_RATE",
	"REACTION_RATE",
	"HANDS_RATE",
	"SCRAMBLE_RATE/Agility/Pass Block/Rush",
	"ARMSTRENGTH_RATE/ Blocking/Tackle",
	"ACCURACY_RATE",
	"INTELLIGENCE_RATE"
};

/*
#define AGILITY_RATE	SCRAMBLE_RATE	// non QB RB, Rec
#define	RUNBLOCK_RATE	ARMSTRENGTH_RATE
#define	PASSBLOCK_RATE	SCRAMBLE_RATE


#define	RUSH_RATE		SCRAMBLE_RATE
#define	TACKLE_RATE		ARMSTRENGTH_RATE

#define	LEGSTRENGTH_RATE		SCRAMBLE_RATE
#define	KICKACCURACY_RATE		ARMSTRENGTH_RATE
*/


void TestDefaultPlayerRatings(WORD teamslotnum)
{
struct pdata_t *pdata;
WORD i,j;

	for(j=0;j<8;j++)
	{
		printf("\n%s- %s\n", GameTeamData[teamslotnum].STD.TeamNickName,
				RatingString[j]);

		for(i=0; i<TOTAL_PLAYERS_ON_TEAM; i++)
		{
			pdata = &GameTeamData[teamslotnum].PlayerData[i];		//where it goes

			printf("%2s-%2d   ",PositionStrings[i],pdata->ratings[j]);

		}
		if(getch() == ESCAPE)	// ESCAPE exits
			break;
   }
}

BOOL LoadPlayerDataFor1Team(WORD slotnum);

BYTE *StatsSetString[MAX_STATS_SETS] = {
"QBs",
"RBs",
"Recs",
"OLine",
"Def",
"Kickers",
"Punters",
"Returners"};

//BYTE *hlstring[2]= {"Lowest","Highest"};

#if 1

void CheckRatings(void)
{

WORD pnum,currate;
WORD pos,rating;
LONG num,count;
WORD highguy,lowguy;
WORD low,high;
BOOL done = FALSE;

  if(LeaguePlayersPtr == NULL)
	return;		// error

  while(!done)
  {
	printf("\n\nAnalyze Rating for QB, RB, Rec,OL, Def,P,K,Ret");
	printf("\n\tInput position set number (0-%d)(ESC to exit): ",MAX_STATS_SETS-1);
	pos = GetNum0_99();
	if(pos < ZERO || pos > MAX_STATS_SETS-1)
	{
		done=TRUE;
		break;
	}
	printf("\n\tInput rating num (0-7):");
	rating =  GetNum0_99();
	if(rating < ZERO || rating > 7)
	{
		done=TRUE;
		break;
	}

	printf("\nAnalyzing %s for %s rating", StatsSetString[pos], RatingString[rating]);


	num = count = ZERO;
	high =1;
	low = 1000;
//	what = 1000;
//	if(high)
//		what = 1;

	for(pnum=0; pnum <MAX_PLAYERS_IN_LEAGUE-TOTAL_PLAYERS_ON_TEAM; pnum++)
	{

		if(PositionToStatSetTable[pnum%TOTAL_PLAYERS_ON_TEAM] == pos)
		{

			currate = (LeaguePlayersPtr+pnum)->ratings[rating];

			count += currate;
			num++;

			if(currate < low)
			{
				low = currate;
				lowguy = pnum;
			}
			if(currate > high)
			{
				high = currate;
				highguy = pnum;
			}

/*			if( (high == 0  &&  currate<= what)
			   ||(high == 1  && currate >= what))
			{
				what = currate;

				printf("\n%s so far (%4d) = %s - %s, %d",
					hlstring[high],
					pnum,
					SpecificTeamData[pnum/TOTAL_PLAYERS_ON_TEAM].TeamNickName,
					(LeaguePlayersPtr+pnum)->pname,what);
			}*/
		}
	}
	if(num)
	{
		printf("\nNum of Guys Searched= %ld, Average = %d",num, count/num);
		printf("\nHighest (%4d) = %s - %s, %d",
					highguy,
					SpecificTeamData[highguy/TOTAL_PLAYERS_ON_TEAM].TeamNickName,
					(LeaguePlayersPtr+highguy)->pname,high);
		printf("\nLowest  (%4d) = %s - %s, %d",
					lowguy,
					SpecificTeamData[lowguy/TOTAL_PLAYERS_ON_TEAM].TeamNickName,
					(LeaguePlayersPtr+lowguy)->pname,low);
	}

  }

}


#else  // old as of 4/11/97 - loaded each team file separately

void CheckRatings(WORD high)
{
WORD tempteam,t;
WORD p,what,currate;
WORD pos,rating;
BOOL done = FALSE;
LONG num,count;

  tempteam = GameTeamData[0].TeamNumber;

  while(!done)
  {
	printf("\n\nChecking for %s Rating for QB, RB, Rec,OL, Def,P,K,Ret",hlstring[high]);
	printf("\nInput postion set num (0-%d)(ESC to exit): ",MAX_STATS_SETS-1);
	pos = GetNum0_99();
	if(pos < ZERO || pos > MAX_STATS_SETS-1)
	{
		done=TRUE;
		break;
	}
	printf("\nInput rating num (0-7):");
	rating =  GetNum0_99();
	if(rating < ZERO || rating > 7)
	{
		done=TRUE;
		break;
	}

	printf("\nChecking all teams for %s %s rating for %s",hlstring[high],
			 RatingString[rating],StatsSetString[pos]);


	num = count = ZERO;
	what = 1000;
	if(high)
		what = 1;

	for(t=0; t<30; t++)
	{
		GameTeamData[0].TeamNumber = t;
		LoadPlayerDataFor1Team(0);
		for(p=0; p < TOTAL_PLAYERS_ON_TEAM; p++)
		{

			if(PositionToStatSetTable[p] == pos)
			{

				currate = GameTeamData[0].PlayerData[p].ratings[rating];

				count += currate;
				num++;

				if( (high == 0  &&  currate<= what)
				   ||(high == 1  && currate >= what))
				{
					what = currate;
					printf("\n%s so far = %s - %s, %d",
						hlstring[high],SpecificTeamData[t].TeamNickName,
								GameTeamData[0].PlayerData[p].pname,what);
				}
			}
		}
	}
	if(num)
		printf("\nNum of Guys Searched= %ld, Average = %d",num, count/num);

  }
  GameTeamData[0].TeamNumber = tempteam;
  LoadPlayerDataFor1Team(0);

}

#endif

#if 1

void PrintTotalRatings(void)
{
WORD teamrate,t,total,i;
WORD p, pnum,pos,rating,lcount;
BOOL done = FALSE;
//LONG num,count;

//  tempteam = GameTeamData[0].TeamNumber;

  while(!done)
  {
	printf("\n\nOutput Total Ratings for QB, RB, Rec,OL, Def,P,K,Ret");
	printf("\nInput postion set num (0-%d)(ESC to exit): ",MAX_STATS_SETS-1);
	pos = GetNum0_99();
	if(pos < ZERO || pos > MAX_STATS_SETS-1)
	{
		done=TRUE;
		break;
	}
	printf("\nChecking all teams for Total rating for %s",StatsSetString[pos]);

	lcount = 0;

	for(t=0; t<30; t++)
	{
//		GameTeamData[0].TeamNumber = t;
//		LoadPlayerDataFor1Team(0);
		teamrate = 0;
		for(p=0; p < TOTAL_PLAYERS_ON_TEAM; p++)
		{

			if(PositionToStatSetTable[p] == pos)
			{
				pnum = t*TOTAL_PLAYERS_ON_TEAM + p;

				printf("\n%20s",(LeaguePlayersPtr+pnum)->pname);
//				printf("\n%20s",GameTeamData[0].PlayerData[p].pname);
				total = ZERO;
				for(i=0; i<8; i++)
				{
					rating = (LeaguePlayersPtr+pnum)->ratings[i];
//					rating = GameTeamData[0].PlayerData[p].ratings[i];
					total += rating;
					printf("%3d",rating);

				}
				printf(" Total = %3d",total);
				if(++lcount > 24)
				{
					lcount = ZERO;
					if(getch() == ESCAPE)
						break;
				}
				teamrate += total;
			}
		}
		printf("  End of team(%d)",teamrate);

	}

  }
//  GameTeamData[0].TeamNumber = tempteam;
//  LoadPlayerDataFor1Team(0);

}

#else
void PrintTotalRatings(void)
{
WORD tempteam,t,total,i;
WORD p, pos,rating,lcount;
BOOL done = FALSE;
//LONG num,count;

  tempteam = GameTeamData[0].TeamNumber;

  while(!done)
  {
	printf("\n\nOutput Total Ratings for QB, RB, Rec,OL, Def,P,K,Ret");
	printf("\nInput postion set num (0-%d)(ESC to exit): ",MAX_STATS_SETS-1);
	pos = GetNum0_99();
	if(pos < ZERO || pos > MAX_STATS_SETS-1)
	{
		done=TRUE;
		break;
	}
	printf("\nChecking all teams for Total rating for %s",StatsSetString[pos]);

	lcount = 0;

	for(t=0; t<30; t++)
	{
		GameTeamData[0].TeamNumber = t;
		LoadPlayerDataFor1Team(0);
		for(p=0; p < TOTAL_PLAYERS_ON_TEAM; p++)
		{

			if(PositionToStatSetTable[p] == pos)
			{
				printf("\n%20s",GameTeamData[0].PlayerData[p].pname);
				total = ZERO;
				for(i=0; i<8; i++)
				{
					rating = GameTeamData[0].PlayerData[p].ratings[i];
					total += rating;
					printf("%3d",rating);

				}
				printf(" Total = %3d",total);
				if(++lcount > 24)
				{
					getch();
					lcount = ZERO;
				}
			}
		}
		printf("  End of team");

	}

  }
  GameTeamData[0].TeamNumber = tempteam;
  LoadPlayerDataFor1Team(0);

}

#endif




void DumpPlayerPointers(void)
{
WORD i;

	for(i=0; i<22; i++)
	{
		printf("\nNormal = %lx, IRP = %lx",
			GetPlayerDataPtr(i),OneTimeIRP.IRPPlayerDataPtr[i]);

	}
	getch();
}


void InternalVarDump(void)
{
WORD p=0;
BOOL done = FALSE;
WORD i,t;

	printf("\nSize of GTData = %d",sizeof(struct gameteamdata));
	printf("\nSize of PData = %d",sizeof(struct  pdata_t));
	DumpPlayerPointers();

	while(!done)
	{
		clrscr();
		printf("\n\t\tINTERNAL VARIABLE DUMP");
		printf("\nDefGL=%x, OffGL=%x, MidX=%x",DEF_GOAL_LINE,OFF_GOAL_LINE,MID_FIELDX);
		printf("\nN=%x, S=%x, MidY=%x",NORTH_SIDELINE,SOUTH_SIDELINE,MID_FIELDY);

		printf("\nPState=%d, PStateFlags=%d,",PlayStateNum,PlayStateFlags);
		printf("\nBC=%d,  LBC=%d, Tackler=%d, Passer = %d, PassCatcher = %d, strutter=%d",
			BallCarrier,LastBallCarrier,Tackler,Passer, PassCatcher,DefStrutter);
		printf("\nRefSFXPending = %d, CameraGUY= %d  KickReturner = %d",RefSFXPending,CameraGuy,KickReturner);
		printf("\nPlayType = %d",PlayType);
		printf("\nFUMBLE_HAPPENED_BFLAG	=  %d,",EventFlags.FUMBLE_HAPPENED_BFLAG);
		printf("\nCatchBallX = %x, BallX = %x, BallY = %x, BallZ = %x",
				CatchBallX,BallXPosition,BallYPosition,BallZPosition);
		printf("\nBallTargetX = %x, BallTargetY = %x",
				BallTargetX,BallTargetY);
		printf("\nBallDeltaX = %x, BallDeltaY = %x",
				BallDeltaX,BallDeltaY);
		printf("\n\nDown: %d  StartBallX = %x",TheDown,StartBallX);
		printf("\nQtr=%d Time left = %d",TheQuarter,SecondsLeftInQuarter());

		printf("\nTeam 0 Play #%d-%s",GameTeamData[0].PlayNum,GetPlayName(GameTeamData[0].PlayNum));
		printf("\nTeam 1 Play #%d-%s",GameTeamData[1].PlayNum,GetPlayName(GameTeamData[1].PlayNum));


				// Count them in loop
		for(t=0; t<2; t++)
		{
			printf("\nPrevOffPlayData for team %d: ",t);
			for (i = 0; i < MAX_OFF_PLAYDATA; i++)
				printf("%2d ",GameTeamData[t].PrevOffPlayData[i]);
		}


		printf("\n\nInfo On Current Player = #%d %s %s  slotnum = %d",
				   GetJerseyNum(p),PositionStrings[OPMyPNum(p)],GetPlayerName(p),p);

		printf("\nx=%x, y=%x, tx=%x, ty=%x, anim=%d seq#=%d",
			OPXPos(p),OPYPos(p),
			OPTargetX(p),OPTargetY(p),
			PlayerAIGraphicState[p],
			PlayerAIGraphicSequence[p]
			);
		printf("\nSTATE # = %d KeyDistance = %x",*PlayerScriptPtr[p],PlayerKeyDistance[p]);

		printf("\nInput Slot Num to change current player or ESC to exit: ");
		p = GetNum0_99();
		if(p < ZERO || p > 23)
		{
			done = TRUE;
		}
	}

}




#define MAX_RUNS	64

UBYTE RunPlays[MAX_RUNS];


void FillRunPlaysArray(void)
{
WORD i= 0, p=0;

	while(i<64 && p < 256)
	{

		if(p < 15 || p >= 45)	// skip dead formations
			if(ThePlays[p].PlayTypeDesignator == RUN_INSIDE
			 || ThePlays[p].PlayTypeDesignator == RUN_OUTSIDE)
				RunPlays[i++] = p;

		p++;        //play #177 is last (8/30/96)
	}

}

WORD ForceRunPlay(void)
{
	if(TheDown > ZERO && TheDown < 4)
		return(RunPlays[rand()&(MAX_RUNS-1)]);
	else
		return (CPUPlayCallOffense());

}

WORD ForceDefPlayNum(WORD pnum)
{
	if(TheDown > ZERO && TheDown < 4)
		return(pnum);
	else
		return (CPUPlayCallDefense());

}

WORD ForceOffPlayNum(WORD pnum)
{
	if(TheDown > ZERO && TheDown < 4)
		return(pnum);
	else
		return (CPUPlayCallOffense());

}


WORD BombPlays[8] = {141,55,63,99,106,121,155,187};
WORD ForceBombPlay(void)
{
	if(TheDown > ZERO && TheDown < 4)
		return(BombPlays[rand()&7]);
	else
		return (CPUPlayCallOffense());

}


WORD FleaPlays[4] = {60,96,173,184};
/*	ISlotFleaFlickerNUM,
	HBackFleaFlickerNUM,
	TripsFleaFlickerNUM,
	RunAndShootFleaFlickerNUM,	*/



WORD ForceFleaPlay(void)
{
	if(TheDown > ZERO && TheDown < 4)
		return(FleaPlays[rand()&3]);
	else
		return (CPUPlayCallOffense());

}



void PrintPlayInfoText(void)
{
	if(PlayInfoText0[0] != '\0')
	{
		printf("\n");
		printf(PlayInfoText0);
	}
	if(PlayInfoText1[0] != '\0')
	{
		printf("\n");
		printf(PlayInfoText1);
	}
	if(PlayInfoText2[0] != '\0')
	{
		printf("\n");
		printf(PlayInfoText2);
	}
}

void PCPrintAIText(void)
{
	if(DisplayLevel & DISPLAY_EOP_INFO)	//display  mucho info in this mode
	{	// display for simmed games
		if(OkToDisplayAITextInfo())
		{
			PrintPlayInfoText();
		}
	}
}


void SignalOverTimeCoinToss(void)
{   // if tie game,

// extra time to add to each team to sim. extra period
ULONG 	time = (QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]/CLOCKS_TICKS_PER_SECOND)/2;

	SetBit(GameFlags,LEAVE_GAME_BFLAG);		//flag cleared by graphic engine
	UpdateFinalGameStats();

	TheTrueQuarter = 5;	// after this true TOP is figured once more

	StatsData[HOME_TEAM_SLOT].allplyrstats[GS_TOP] += time;
	StatsData[AWAY_TEAM_SLOT].allplyrstats[GS_TOP] += time;
	StatsData[HOME_TEAM_SLOT].alloppplyrstats[GS_TOP] += time;
	StatsData[AWAY_TEAM_SLOT].alloppplyrstats[GS_TOP] += time;

	TimeOfPoss[0] = (ULONG)StatsData[0].allplyrstats[GS_TOP] * (ULONG)CLOCKS_TICKS_PER_SECOND;
	TimeOfPoss[1] = (ULONG)StatsData[1].allplyrstats[GS_TOP] * (ULONG)CLOCKS_TICKS_PER_SECOND;


};

#include "fbmovie.c"
/**

#define NUM_NAMES	8
#define NAME_WIDTH  40
#define NAME_HEIGHT 12

struct  sBox  NameBoxes[NUM_NAMES];
struct  sXY   NameXY[NUM_NAMES];

void NameCollision(void)
{
EFFVAR i,j,x,y;
BOOL drawn[NUM_NAMES];

	for(i=0; i < NUM_NAMES; i++)
	{	// figure centers
		NameXY[i].X = x;	//screenx;
		NameXY[i].Y = y-8;	//screeny-8; 	// center
	}

	for(i=0; i < NUM_NAMES; i++)
	{   // figure collision boxes
		NameBoxes[i].Low.X = NameXY[i].X - NAME_WIDTH/2;
		NameBoxes[i].High.X = NameXY[i].X + NAME_WIDTH/2;
		NameBoxes[i].Low.Y = NameXY[i].Y - NAME_HEIGHT/2;
		NameBoxes[i].High.Y = NameXY[i].Y + NAME_HEIGHT/2;
	}


	for(i=0; i < NUM_NAMES; i++)
	{
		drawn[i] = TRUE;		// assume we'll draw it
		for(j=0; j < i; j++)	// check all previous
		{
			x = NameXY[i].X;
			y = NameXY[i].Y;
			if(   x > NameBoxes[j].Low.X
			   && x < NameBoxes[j].High.X
			   && y > NameBoxes[j].Low.Y
			   && y < NameBoxes[j].High.Y
			   && drawn[j]	// only "collide" with previous drawn ones
			  )
			{
				// "collision" with previous one - don't draw
				drawn[i] = FALSE;
				break;
			}
		}

		if(drawn[i])
		{
			// draw name "i"
		}
	}

}
**/



#include "truesim.c"

void ListSchedule(void)
{
WORD g,w;
BOOL done = FALSE;

	w=1;
	g=0;

	printf("\n--------------------- Week %d ------------------",w);

	do{

		printf("\n\t#%3d  %2d/%2d/%2d %15s @ %s",
				g,
				schedule[g].month+1,
				schedule[g].day,
				schedule[g].month ? 97 : 98,
				SpecificTeamData[schedule[g].away].TeamNickName,
				SpecificTeamData[schedule[g].home].TeamNickName);
		if(g++ >= 250)
		{
			getch();
			done = TRUE;
		}
		else
		{
			if(schedule[g].week != w
			   && w <18)
			{
				if( getch() == ESCAPE)
				{
					done = TRUE;
				}
				else
				{
					w = schedule[g].week;
					if(w>= 18)
						printf("\nPlayoffs");
					else
						printf("\nWeek %d",w);
				}
			}
		}

	} while(!done);
}



/******************** EOF - FBTestAI.c  *****************************/
