/**************************************************************


					FBTMDATA.C

	AUTHOR: M. Knauer                               Start Date: 5/5/95
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains all Football Team Data.
	Stick this in your project file.

	Also see "FBRAM.H"  - an include file with all of these
	variables as EXTERN.



	As of 4/24/96 the Team Data Structure is as follows:

struct specificteamdata {       // see fbtmData.c

	BYTE    TeamNumber;     // 0 to num teams in entire game
	BYTE    TeamType;               // run, pass, or normal

	BYTE    *TeamCity;
	BYTE    *TeamNickName;

	BYTE    Formations[2][7];       //[0] = offenive forms, [1] = def. forms
	BYTE    Stats[8];                       // Static numbers for bars

}

**************************************************************/


	#include        "fbequ.h"
	#include        "fbforms.h"


//struct  specificteamdata SpecificTeamData[MAX_NUM_TEAMS] = {
struct  specificteamdata SpecificTeamData[] = {

{
/* team 0       */
	KC,KC,
	BALANCED_TEAM,0,

	"KANSAS CITY",  "CHIEFS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,                /*3     A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	60,85,65,90,90,80,80,70 /*Team Stats*/
	,78             //penalty factor
},

{
/* team 1       */
	SD,SD,
	BALANCED_TEAM,0,

	"SAN DIEGO",    "CHARGERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,           /*7 default        */
	H_BACK_FORM_NUM,         /*8    B       */
	I_FORM_FORM_NUM,         /*8    B       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	75,70,80,75,75,85,65,90 /*Team Stats*/
	,90     //penalty factor
},

{
/* team 2       */
	SEA,SEA,
	BALANCED_TEAM,0,

	"SEATTLE",      "SEAHAWKS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	I_SLOT_FORM_NUM,                        /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,


	55, 80, 80, 60, 80, 60, 65, 85 /*Team Stats*/
	,80             //penalty factor

},

{
/* team 3       */
	DEN,DEN,
	PASSING_TEAM,0,

	"DENVER",       "BRONCOS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,            /*3     A       */
	TRIPS_FORM_NUM,         /*8     B       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 95, 95, 80, 70, 90, 80, 85, 85 /*Team Stats*/
	,76             //penalty factor

},

{
/* team 4       */
	OAK,OAK,PASSING_TEAM,0,

	"OAKLAND",      "RAIDERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,           /*7 default      */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 75 ,  80 ,  85 ,  65 ,  95 ,  65 ,  85 ,  70 /*Team Stats*/
	,98             //penalty factor

},

{
/* team 5       */
	PIT,PIT,
	RUNNING_TEAM,0,

	"PITTSBURGH","STEELERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,       /*6    A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,


	60 ,  90 ,  75 ,  95 ,  75 ,  90 ,  90 ,  70 /*Team Stats*/
	,74             //penalty factor

},

{
/* team 6       */
	CIN,CIN,
	PASSING_TEAM,0,

	"CINCINNATI","BENGALS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,         /*8  B       */
	I_SLOT_FORM_NUM,         /*8    B       */
	PROSET_FORM_NUM,           /*7 default  */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 80 ,  75 ,  85 ,  70 ,  65 ,  60 ,  50 ,  75  /*Team Stats*/
	,68             //penalty factor

},

{
/* team 7       */
	HOU,HOU,
	BALANCED_TEAM,0,

//      "NASHVILLE","OILERS",
	"HOUSTON","OILERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	H_BACK_FORM_NUM,         /*8    B       */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,
	NORMAL_DEF_FORMATIONS,

	 75 ,  90 ,  65 ,  80 ,  85 ,  80 ,  80 ,  90     /*Team Stats*/
	,64             //penalty factor

},

{
/* team 8       */
	BAL,BAL,
	BALANCED_TEAM,0,

	"BALTIMORE","RAVENS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,         /*8    B       */
	SINGLE_BACK_FORM_NUM,           /*3     A       */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,
	NORMAL_DEF_FORMATIONS,

	80 ,  65 ,  85 ,  75 ,  60 ,  55 ,  55 ,  70     /*Team Stats*/
	,92             //penalty factor

},

{
/* team 9       */
	JAX,JAX,
	BALANCED_TEAM,0,

	"JACKSONVILLE","JAGUARS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,           /*7 default        */
	I_SLOT_FORM_NUM,                        /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	90 ,  75 ,  85 ,  90 ,  75 ,  70 ,  75 ,  60      /*Team Stats*/
	,94             //penalty factor

},

{
/* team 10      */
	BUF,BUF,
	BALANCED_TEAM,0,

	"BUFFALO",      "BILLS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,       /*6 A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	RUN_SHOOT_FORM_NUM,             /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 65 ,  80 ,  75 ,  80 ,  90 ,  85 ,  80 ,  75     /*Team Stats*/

	,48             //penalty factor
},

{
/* team 11      */
	IND,IND,
	BALANCED_TEAM,0,

	"INDIANAPOLIS", "COLTS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,         /*8       B       */
	PROSET_FORM_NUM,           /*7 default  */
	TRIPS_FORM_NUM,         /*8     B       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 80 ,  60 ,  80 ,  75 ,  70 ,  80 ,  80 ,  95     /*Team Stats*/
	,88             //penalty factor

},

{
/* team 12      */
	MIA,MIA,
	BALANCED_TEAM,0,

	"MIAMI", "DOLPHINS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,                   /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	85 ,  80 ,  70 ,  80 ,  65 ,  75 ,  75 ,  65     /*Team Stats*/
	,84     //penalty factor

},

{
/* team 13      */
	NE,NE,
	BALANCED_TEAM,0,

	"NEW ENGLAND",  "PATRIOTS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,              /*3     A       */
	H_BACK_FORM_NUM,         /*8    B       */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  85 ,  85 ,  85 ,  80 ,  70 ,  75 ,  70    /*Team Stats*/
	,50             //penalty factor

},

{
/* team 14      */
	NYJ,NYJ,
	BALANCED_TEAM,0,

	"NEW YORK",     "JETS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,                        /*5 default     */
	SINGLE_BACK_FORM_NUM,           /*7 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 70 ,  80 ,  80 ,  50 ,  70 ,  80 ,  60 ,  70     /*Team Stats*/
	,99             //penalty factor

},

{
/* team 15      */
	SF,SF,
	PASSING_TEAM,0,

	"SAN FRANCISCO",        "49ERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  75 ,  80 ,  85 ,  90 ,  85 ,  90 ,  80     /*Team Stats*/
	,58             //penalty factor

},

{
/* team 16      */
	ATL,ATL,
	PASSING_TEAM,0,

	"ATLANTA",      "FALCONS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,         /*8       B       */
	PROSET_FORM_NUM,           /*7 default  */
	RUN_SHOOT_FORM_NUM,         /*8 B       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,
	NORMAL_DEF_FORMATIONS,

	 65 ,  75 ,  80 ,  70 ,  50 ,  70 ,  40 ,  70     /*Team Stats*/
	,60             //penalty factor

},

{
/* team 17      */
	STL,STL,
	BALANCED_TEAM,0,

	"ST. LOUIS",    "RAMS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 60 ,  60 ,  75 ,  55 ,  80 ,  55 ,  60 ,  70     /*Team Stats*/
	,86             //penalty factor

},

{
/* team 18      */
	CAR,CAR,
	BALANCED_TEAM,0,

	"CAROLINA",     "PANTHERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,         /*8    B       */
	SINGLE_BACK_FORM_NUM,           /*3     A       */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 80 ,  75 ,  70 ,  75 ,  80 ,  99 ,  80 ,  95     /*Team Stats*/
	,52     //penalty factor

},

{
/* team 19      */
	NO,NO,
	BALANCED_TEAM,0,

	"NEW ORLEANS",  "SAINTS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,           /*7 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	70 ,  65 ,  60 ,  70 ,  65 ,  60 ,  85 , 70    /*Team Stats*/
	,54     //penalty factor

},

{
/* team 20      */
	GB,GB,
	PASSING_TEAM,0,

	"GREEN BAY",    "PACKERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  80 ,  90 ,  80 ,  95 ,  90 ,  95 ,  90     /*Team Stats*/
	,46             //penalty factor

},

{
/* team 21      */
	DET,DET,
	PASSING_TEAM,0,

	"DETROIT",      "LIONS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,           /*7 default     */
	I_FORM_FORM_NUM,           /*7 default  */
	TRIPS_FORM_NUM,         /*8     B       */
	SHOTGUN_FORM_NUM,         /*8   B       */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	80 ,  95 ,  90 ,  75 ,  70 ,  65 ,  60 ,  70     /*Team Stats*/
	,96             //penalty factor

},

{
/* team 22      */
	CHI,CHI,
	BALANCED_TEAM,0,

	"CHICAGO",      "BEARS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 65 ,  75 ,  70 ,  75 ,  75 ,  80 ,  70 ,  70    /*Team Stats*/
	,44             //penalty factor

},

{
/* team 23      */
	MIN,MIN,
	PASSING_TEAM,0,

	"MINNESOTA",    "VIKINGS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,           /*3     A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*8     B       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 80 ,  60 ,  90 ,  80 ,  80 ,  60 ,  70 ,  70    /*Team Stats*/
	,66             //penalty factor

},

{
/* team 24      */
	TB,TB,
	RUNNING_TEAM,0,

	"TAMPA BAY",    "BUCCANEERS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,                        /*5 default     */
	SINGLE_BACK_FORM_NUM,           /*7 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 25 ,  85 ,  40 ,  60 ,  70 ,  75 ,  70 ,  75     /*Team Stats*/
	,82             //penalty factor
},

{
/* team 25      */
	DAL,DAL,
	RUNNING_TEAM,0,

	"DALLAS",       "COWBOYS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,       /*6    A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  90 ,  85 ,  95 ,  85 ,  80 ,  90 ,  85     /*Team Stats*/
	,56             //penalty factor

},

{
/* team 26      */
	PHI,PHI,
	BALANCED_TEAM,0,

	"PHILADELPHIA", "EAGLES",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,         /*8    B       */
	PROSET_FORM_NUM,           /*7 default  */
	WEST_COAST_FORM_NUM,         /*8        B       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,
	NORMAL_DEF_FORMATIONS,

	 80 ,  90 ,  85 ,  80 ,  90 ,  75 ,  80 ,  75    /*Team Stats*/
	,72             //penalty factor

},

{
/* team 27      */
	WAS,WAS,
	RUNNING_TEAM,0,

	"WASHINGTON",   "REDSKINS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 70 ,  90 ,  75 ,  75 ,  70 ,  60 ,  70 ,  75     /*Team Stats*/
	,42             //penalty factor

},

{
/* team 28      */
	NYG,NYG,
	BALANCED_TEAM,0,

	"NEW YORK",     "GIANTS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,              /*3     A       */
	H_BACK_FORM_NUM,         /*8    B       */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 55 ,  75 ,  70 ,  65 ,  65 ,  55 ,  75 ,  75    /*Team Stats*/
	,62             //penalty factor

},

{
/* team 29      */
	ARI,ARI,
	BALANCED_TEAM,0,

	"ARIZONA",      "CARDINALS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,           /*7 default        */
	I_SLOT_FORM_NUM,                        /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 70 ,  65 ,  80 ,  70 ,  85 ,  75 ,  70 ,  85    /*Team Stats*/
	,70             //penalty factor

},


{       /* team 30      */
	FREE_AGENTS,FREE_AGENTS,
	BALANCED_TEAM,0,

	"GAMETEK",  "FREE AGENTS",

	GOAL_LINE_FORM_NUM,             /*0 default     */
	I_FORM_FORM_NUM,
	PROSET_FORM_NUM,
	TRIPS_FORM_NUM,
	SHOTGUN_FORM_NUM,

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  99 ,  99 ,  99 ,  99 ,  99 ,  99 ,  99    /*Team Stats*/
	,98             //penalty factor
},


{
/* team 31      */
	AFC97,AFC97,
	BALANCED_TEAM,0,

	"'97 AFC ALL PRO",  "'97 AFC ALL PROS",

	GOAL_LINE_FORM_NUM,             /*0 default     */
	I_FORM_FORM_NUM,
	PROSET_FORM_NUM,
	TRIPS_FORM_NUM,
	SHOTGUN_FORM_NUM,

	OFF_SPECIAL_TEAMS_FORM_NUM,
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 95 ,  95 ,  90 ,  95 ,  95 ,  95 ,  95 ,  95    /*Team Stats*/
	,30             //penalty factor

},



{       /* team 32      */
	NFC97,NFC97,BALANCED_TEAM,0,

	"'97 NFC ALL PRO",      "'97 NFC ALL PROS",

	GOAL_LINE_FORM_NUM,		/*0 default     */
	SINGLE_BACK_FORM_NUM,	/*5 default     */
	I_FORM_FORM_NUM,		/*5 default     */
	TRIPS_FORM_NUM,			/*5 default     */
	SHOTGUN_FORM_NUM,		/*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  95 ,  99 ,  95 ,  95 ,  95 ,  99 ,  95    /*Team Stats*/
	,30             //penalty factor

},



{
/* team 33      */
	AFC96,AFC96,
	BALANCED_TEAM,0,

	"'96 AFC ALL PRO",  "'96 AFC ALL PROS",

	GOAL_LINE_FORM_NUM,             /*0 default     */
	I_FORM_FORM_NUM,
	PROSET_FORM_NUM,
	TRIPS_FORM_NUM,
	SHOTGUN_FORM_NUM,

	OFF_SPECIAL_TEAMS_FORM_NUM,
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 95 ,  95 ,  90 ,  95 ,  95 ,  95 ,  95 ,  95    /*Team Stats*/
	,30             //penalty factor

},


{       /* team 34      */
	NFC96,NFC96,
	BALANCED_TEAM,0,

	"'96 NFC ALL PRO",      "'96 NFC ALL PROS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,                   /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  99 ,  99 ,  95 ,  95 ,  95 ,  99 ,  95    /*Team Stats*/
	,30             //penalty factor

},


{
/* team 35      */
	CHI63,CHI,
	BALANCED_TEAM,0,

	"CHICAGO",      "BEARS-63",

	GOAL_LINE_FORM_NUM,
	NEAR_FAR_FORM_NUM,
	TRIPS_FORM_NUM,
	PROSET_FORM_NUM,
	SHOTGUN_FORM_NUM,

	OFF_SPECIAL_TEAMS_FORM_NUM,
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 65 ,  75 ,  70 ,  75 ,  75 ,  80 ,  70 ,  70    /*Team Stats*/
	,44             //penalty factor

},


{
/* team 36       */
	CLE64,BAL,
	RUNNING_TEAM,0,

	"CLEVELAND","BROWNS-64",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,         /*8    B       */
	SINGLE_BACK_FORM_NUM,           /*3     A       */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,
	NORMAL_DEF_FORMATIONS,

	80 ,  65 ,  85 ,  75 ,  60 ,  55 ,  55 ,  70     /*Team Stats*/
	,92             //penalty factor

},


{
/* team 37      */
	GB66,GB,
	PASSING_TEAM,0,

	"GREEN BAY",    "PACKERS-66",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  80 ,  90 ,  80 ,  95 ,  90 ,  95 ,  90     /*Team Stats*/
	,46             //penalty factor

},


{
/* team 38      */
	NYJ68,NYJ,
	BALANCED_TEAM,0,

	"NEW YORK",     "JETS-68",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,                        /*5 default     */
	SINGLE_BACK_FORM_NUM,           /*7 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 70 ,  80 ,  80 ,  50 ,  70 ,  80 ,  60 ,  70     /*Team Stats*/
	,99             //penalty factor

},


{
/* team 39       */
	KC69,KC,
	BALANCED_TEAM,0,

	"KANSAS CITY",  "CHIEFS-69",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_SLOT_FORM_NUM,                /*3     A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	60,85,65,90,90,80,80,70 /*Team Stats*/
	,78             //penalty factor
},


{
/* team 40      */
	DAL71,DAL,
	RUNNING_TEAM,0,

	"DALLAS",       "COWBOYS-71",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,       /*6    A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  90 ,  85 ,  95 ,  85 ,  80 ,  90 ,  85     /*Team Stats*/
	,56             //penalty factor

},


{
/* team 41      */
	MIA72,MIA,
	BALANCED_TEAM,0,

	"MIAMI", "DOLPHINS-72",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,                   /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	85 ,  80 ,  70 ,  80 ,  65 ,  75 ,  75 ,  65     /*Team Stats*/
	,84     //penalty factor

},



{
/* team 42       */
	PIT74,PIT,
	RUNNING_TEAM,0,

	"PITTSBURGH","STEELERS-74",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,       /*6    A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,


	60 ,  90 ,  75 ,  95 ,  75 ,  90 ,  90 ,  70 /*Team Stats*/
	,74             //penalty factor

},



{
/* team 43       */
	OAK76,OAK,
	PASSING_TEAM,0,

	"OAKLAND",      "RAIDERS-76",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,           /*7 default      */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 75 ,  80 ,  85 ,  65 ,  95 ,  65 ,  85 ,  70 /*Team Stats*/
	,98             //penalty factor

},


{
/* team 44       */
	PIT78,PIT,
	RUNNING_TEAM,0,

	"PITTSBURGH","STEELERS-78",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,       /*6    A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,


	60 ,  90 ,  75 ,  95 ,  75 ,  90 ,  90 ,  70 /*Team Stats*/
	,74             //penalty factor

},


{
/* team 45      */
	WAS82,WAS,
	RUNNING_TEAM,0,

	"WASHINGTON",   "REDSKINS-82",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 70 ,  90 ,  75 ,  75 ,  70 ,  60 ,  70 ,  75     /*Team Stats*/
	,42             //penalty factor

},



{
/* team 46       */
	OAK83,OAK,
	PASSING_TEAM,0,

	"OAKLAND",      "RAIDERS-83",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,           /*7 default      */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 75 ,  80 ,  85 ,  65 ,  95 ,  65 ,  85 ,  70 /*Team Stats*/
	,98             //penalty factor

},

{
/* team 47      */
	CHI85,CHI,
	BALANCED_TEAM,0,

	"CHICAGO",      "BEARS-85",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 65 ,  75 ,  70 ,  75 ,  75 ,  80 ,  70 ,  70    /*Team Stats*/
	,44             //penalty factor

},


{
/* team 48      */
	NYG86,NYG,
	RUNNING_TEAM,0,

	"NEW YORK",     "GIANTS-86",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,              /*3     A       */
	H_BACK_FORM_NUM,         /*8    B       */
	I_FORM_FORM_NUM,                        /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 55 ,  75 ,  70 ,  65 ,  65 ,  55 ,  75 ,  75    /*Team Stats*/
	,62             //penalty factor

},


{
/* team 49      */
	SF89,SF,
	PASSING_TEAM,0,

	"SAN FRANCISCO",        "49ERS-89",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  75 ,  80 ,  85 ,  90 ,  85 ,  90 ,  80     /*Team Stats*/
	,58             //penalty factor

},


{
/* team 50      */
	BUF90,BUF,
	BALANCED_TEAM,0,

	"BUFFALO",      "BILLS-90",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,       /*6 A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	RUN_SHOOT_FORM_NUM,             /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 65 ,  80 ,  75 ,  80 ,  90 ,  85 ,  80 ,  75     /*Team Stats*/

	,48             //penalty factor
},



{
/* team 51      */
	WAS91,WAS,
	RUNNING_TEAM,0,

	"WASHINGTON",   "REDSKINS-91",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,                      /*5 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 70 ,  90 ,  75 ,  75 ,  70 ,  60 ,  70 ,  75     /*Team Stats*/
	,42             //penalty factor

},



{
/* team 52      */
	DAL92,DAL,
	RUNNING_TEAM,0,

	"DALLAS",       "COWBOYS-92",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	NEAR_FAR_FORM_NUM,       /*6    A       */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  90 ,  85 ,  95 ,  85 ,  80 ,  90 ,  85     /*Team Stats*/
	,56             //penalty factor

},


{
/* team 53      */
	SF94,SF,
	PASSING_TEAM,0,

	"SAN FRANCISCO",        "49ERS-94",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	PROSET_FORM_NUM,                        /*5 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 90 ,  75 ,  80 ,  85 ,  90 ,  85 ,  90 ,  80     /*Team Stats*/
	,58             //penalty factor

},


{
/* team 54      */
	GB96,GB,
	PASSING_TEAM,0,

	"GREEN BAY",    "PACKERS-96",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	WEST_COAST_FORM_NUM,       /*6  A       */
	PROSET_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,         /*3     A       */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  80 ,  90 ,  80 ,  95 ,  90 ,  95 ,  90     /*Team Stats*/
	,46             //penalty factor

},


{       /* team 55       */
	JIMMYS_TEAM,JIMMYS_TEAM,
	BALANCED_TEAM,0,

	"JIMMY",      "ALL STARS",

	GOAL_LINE_FORM_NUM,                     /*0 default     */
	SINGLE_BACK_FORM_NUM,                   /*5 default     */
	I_FORM_FORM_NUM,                        /*5 default     */
	TRIPS_FORM_NUM,                 /*5 default     */
	SHOTGUN_FORM_NUM,           /*7 default */

	OFF_SPECIAL_TEAMS_FORM_NUM,     /*9     ST      */
	OFF_EASTER_FORM_NUM,

	NORMAL_DEF_FORMATIONS,

	 99 ,  99 ,  99 ,  99 ,  99 ,  99 ,  99 ,  99    /*Team Stats*/
	,78             //penalty factor
},



};

/********************  end of  file - FBTMDATA.C  *********************/

