/***************************************************************
	Football main

	Copyright 1994 GameTek
	All rights reserved.

	By Christopher G. Deel
****************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>

#include "prjhdrs.h"	/* Project header files */

#include "overlays.h"
#include "movie.h"
#include "fbequ.h"
#include "fbram.h"

char *gCompileDate = __DATE__;

char *DemoBgs[] = {
//	  	"/tmp/psxlogo.tim",
//	  	"/tmp/sat.tim",
//		"/tmp/play.tim",
		"/tmp/title1.tim",
		"/tmp/gametek.tim",
		"/tmp/credits.tim",
//	  	"/tmp/constrct.tim",
//	  	"/tmp/constrct.tim",

		"*"
	};

/*-------------------------------------------------------------
  ShowAPicture ~
-------------------------------------------------------------*/
void ShowAPicture(char *file, int vblanks, int key)
{
	int i, waiting, prevBlank;
	char *ptr;

	LoadBackgroundCD(0, file);
	ReadPads();    /*##*/
	CheckDebugCmd();    /*##*/
	waiting = True;
	prevBlank = GetVBlankCount();
	for (i = 0; i < 4; i++)
	{
	  	InitFrame();
		UpdateBackground();
		ShowFrame();
	}
	while(waiting)
	{
		ReadPads();
		if ((GetVBlankCount() - prevBlank) > vblanks)
			waiting = False;
		CheckDebugCmd();
		if (IsAnyPadButton(0xFFFF) != 0 || JpadData[0])
			waiting = False;
	}
}

/*-------------------------
	Initialize PlayStation
---------------------------*/
int cdmode;

void InitPlayStation(void)
{
	ULONG vb;
	int w;

//	printf("Testing\n");
//	 DebugPrintf("SP=%X\n", GetSp());  // debug
//	SetMem(8);        /* 8 Megs of ram */
//	SetMem(2);
	ResetCallback();
//	SwitchScreenOff();
//	_96_remove();
//	_96_init();
	SetBackgroundColor(0,0,0);
	InitGraph();
	InitPads(0);		/* reset PAD */
//	SetScreenMode(VMODE320);
//	ClearScreen();
	SetScreenMode(VMODE512);
//	ClearScreen();
	initVRamHandling();
//	SetBackgroundColor(0x80, 0, 0);
	SetBackgroundColor(0,0,0);
	InitDebug();
	InitVBlankCount();
	InitCDHandler();

	LoadOverlay(MOVIE_OVERLAY);

	ShowAPicture("/stadium/warn.tim", 0, 0);
	InitCard();	// MRH - took out of DisplayMainGameShell as it caused music slowdown.
	InitFonts();
	SetBackgroundColor(0x00, 0x60, 0x80);
	vb = GetVBlankCount();
//	register_default_CLUTs();
// 	DoVersionScreen();
	 Cmarker();
	InitSound();
	 Cmarker();
	ReadPads();    /*##*/
	SetPadNeeded(-1,0);
	CheckDebugCmd();    /*##*/
//	while (GetVBlankCount() < (vb + 3*60) && !IsAnyPadButton(0xFFFF) )
//		ReadPads();
//	 SetBackgroundColor(0, 0x80, 0);
//	 ClearScreen();

#if PC_DEBUG
	PCinit();			/* Init PC file system for debug, returns 0 so OK */
#endif
	Randomize();
	Cmarker();
}


/*-------------------------------------------------------------
-------------------------------------------------------------*/
void ShowCredits(int tm)
{
	limitRange(tm, 0, 10 * 60);
	ShowAPicture("/tmp/credits.tim", tm, True);
}


/*------------------------------
------------------------------*/
void main(void)
{
	int i, waiting, prevBlank;
	char *ptr;

	DumpHeap();

	InitPlayStation();
	PowerOnAIInitialization();
	ReadPads();    /*##*/
	CheckDebugCmd();    /*##*/

	DumpAllocLoc();
	ReadPads();    /*##*/
	CheckDebugCmd();    /*##*/
	SetBackgroundColor(0,0,0);
	ResetSpinDown();

//	LoadOverlay(0);

#ifndef NO_INTRO

 #if PC_DEBUG
	if (IsAnyPadButton(0xFFFF))
		goto SkipMovies;
 #endif // PC_DEBUG

//		MovieClear = 0;
//		PlayMovie(KONAMI_MOV);

//		ShowScreen("/shells/bkg/sports.tim",0);

		MovieClear = 0;
		PlayMovie(GAMETEK_MOV);

		ClearMovie();
		ShowScreen("/shells/bkg/license.tim",0);

		MovieClear = 0;
		PlayMovie(FB_INTRO_MOV);

		ClearMovie();

SkipMovies:  // jump to here to skip movies

#if (PC_DEBUG)
	CheckQuickDebugGames();
#endif
#endif	// NO_INTRO


	GameOptions[GAME_OPTNS_FIELD_TYPE] = TURF_FIELD;
	CheckDebugCmd();    /*##*/

//#endif	// NO_INTRO

	 FreeBackgrounds();
//	ShowCredits(8 * 60);
	ReadPads();
	DisplayMainGameShell();  // This will Run Football Game
	StopPads();
	exit();
}

