#ifndef FORMCAM_H
#define FORMCAM_H 1
/******************************************************************
	Formation Camera Offsets
	
	By Christopher Deel and Bernie Whang

	June/20/96
	
	This file generates Data that uses memory.      
******************************************************************/     

typedef struct 
{
	unsigned char play;     // Play number
	unsigned char y;        // Height   1=low 200=high  10=norm
	unsigned char z;        // back     1=low 200=high  70=norm
	unsigned char tilt;     // Tilt up  1=low 200=high  10=norm
} PreSnapPlayCamera_t;

//#if GAMELOOP_C
/*-----------------------------------------------------
	Camera offsets before the snap 
	in order by offensive play number
	(see struct above)
-----------------------------------------------------*/ 
PreSnapPlayCamera_t gPreSnapCamera[] = 
{
// Goalline
	{0,  11, 69, 5},
	{6,  11, 69, 5},
//	{9,  11, 69, 5},
//	{12, 11, 69, 5},
// Wishbone
//	{15,  11, 69, 5},
// Power I
//	{30,  11, 69, 5},
//	{36,  11, 69, 5},
// Veer
//	{45,  11, 69, 5},
//	{51,  11, 69, 5},
//	{57,  11, 69, 5},
// I Slot
//	{60,  11, 69, 5},
// One Back/SingleBack
//	{75,  11, 69, 5},
// H Back
//	{90,  11, 69, 5},
// I Form
//	{105,  11, 69, 5},
// Pro Set
//	{120,  11, 69, 5},
// W Coast
//	{135,  11, 69, 5},
// Shotgun
//	{150,  11, 69, 5},
//	{156,  11, 69, 5},
// Trips
//	{165,  11, 69, 5},
// RunShoot
//	{180,  11, 69, 5},
// Special Teams
//	{195,  6, 96, 12},	// Field goal
//	{195,  6, 120, 16},	// Field goal
//	{198,  6, 120, 12},	// punt
	{201,  11, 69, 5},
//	{500,  11, 69, 5},

	0xFF, 100, 100, 100     // End marker
};


//#endif /* GAMELOOP_C */

#endif /* FORMCAM_H  */
