#ifndef _GAMELOOP_H
#define _GAMELOOP_H 1
/***************************************************************
	Copyright 1995 GameTek
	All rights reserved.

	By Christopher G. Deel 
****************************************************************/

//----- for demo code -------
#define PLAY_START_DELAY 5
#define PLAY_RUN_TIME 15

#define LOOK_AT_BALL (-1)

#define HOME_SLOT 0
#define AWAY_SLOT 1
#define VBLANKS_PER_LOOP 3

// -- Instant replay modes
enum {
	REPLAY_OFF = 0,
	REPLAY_PLAY,
	REPLAY_STEP,
	REPLAY_FF,
	REPLAY_REW,
};

extern int WriteMessageFlag;
extern char gInstantReplayMode;
extern short gCurrentPlayType;
extern ULONG gHoldPlayCallVB;
extern char gSkipCoinTossFlag;
extern char *TemplateBuff;
extern SVECTOR gBallxyz;
extern int gAttractMode;
extern BOOL AutoReplayFlag;  // signal from AI

extern int gNoPauseCount;
extern int gNoAudibleMenuCount;

extern int gGameLoopState;
enum
{
	GLOOP_NO_STATE,
	GLOOP_LOADING_ARCADE_STATE,
	GLOOP_INPLAY_STATE,
	GLOOP_LOADING_PCALL_STATE,	
	GLOOP_IN_PCALL_STATE,			
	GLOOP_INITIALISED_STATE,		
	GLOOP_LOADING_STADTIM_STATE,
	GLOOP_LOADING_SBPIC_STATE,
	GLOOP_IN_REPLAY_STATE,
	GLOOP_ENDING_GAME_STATE,
};

extern int gGameEndReason;
enum	//--- Reasons for ending a game ------
{
	GAME_OVER_END,
	QUIT_GAME_END,
	DEMO_MODE_END,
	DEMO_KEY_END,
};


// --- Game loop flags ---
extern ULONG gGameLoopFlags;
//#define GLOOP_INPLAY_FLAG		(1)
//#define GLOOP_PAUSED_FLAG			(1<<1)
//#define GLOOP_LOADING_ARCADE_FLAG	(1<<2)
//#define GLOOP_LOADING_PCALL_FLAG	(1<<3)
//#define GLOOP_IN_PCALL_FLAG			(1<<4)
#define GLOOP_INITIALISED_FLAG		(1<<5)
//#define GLOOP_LOADING_STADTIM_FLAG	(1<<6)
#define GLOOP_RELOAD_PCALL_FLAG 	(1<<7)
#define GLOOP_RELOAD_PERM_FLAG		(1<<8)
#define GLOOP_DID_REPLAY_FLAG		(1<<9)
#define GLOOP_RELOAD_ANIM_FLAG		(1<<10)
#define GLOOP_RELOAD_ENABLE_FLAG	(1<<11)
#define GLOOP_END_QUARTER_FLAG		(1<<12)
#define GLOOP_SCOREBOARD_FLAG		(1<<13)
#define GLOOP_AT_SCOREBOARD_FLAG	(1<<14)
#define GLOOP_WAS_SCOREBOARD_FLAG	(1<<15)
#define GLOOP_END_GAME_FLAG			(1<<16)
#define GLOOP_FIRST_PLAY_FLAG		(1<<17)
#define GLOOP_BALL_RUNNING_FLAG		(1<<18)
#define GLOOP_CONVERSION_MENU_FLAG	(1<<19)
#define GLOOP_QUIT_GAME_FLAG		(1<<20)
#define GLOOP_CHANGE_DIR_FLAG		(1<<21)
//#define GLOOP_AUDIBLE_FLAG			(1<<22)
#define GLOOP_FLIP_AI_FLAG			(1<<23)
#define GLOOP_QUIT_MENU_FLAG		(1<<24)
//#define GLOOP_NO_PAUSE_FLAG			(1<<25)

typedef struct 
{
	BOOL ScoreboardReplay;
	BOOL DoingAutoReplay;
	BOOL Paused;
	BOOL WasCoinToss;
	BOOL EndingGame;
	BOOL SavingCard;
	BOOL OffenseAudibleMenu; 
	BOOL DefenseAudibleMenu; 
	BOOL PenaltyMenu;
} GameLoopFlags2Type;

extern GameLoopFlags2Type gGameLoopFlags2;

extern char gCameraMenuFlag;
char gChangingCameraFlag;

//--- Replay Animations Used Flags ----
extern ULONG gReplayAnimFlags;
#define USED_PASSING_ANIM 	1
#define USED_KICKING_ANIM 	(1<<1)
#define USED_PUNTING_ANIM 	(1<<2)

enum 
{
	NORMAL_CAMERA_STYLE,
	ISOMETRIC_CAMERA_STYLE,
	ISOMETRIC_LOW_CAMERA_STYLE,
	SIDELINE_CAMERA_STYLE,
	SIDELINE_LOW_CAMERA_STYLE,
};
	
int gGameCameraStyle;

/* gameloop.c */
void InitGameLoop(void);
void TranslateAI ( void );
void DoGameLoop ( void );
void TranslateAIVector(int x, int y, int z, SVECTOR *vectOut);
void TranslateAINoFlip(int x, int y, int z, SVECTOR *vectOut);
void DoGameCamera(void);

void SetFormationCamera(void);
void StartInstantReplay(void);
int RunFootballGame(void);
int CheckAttractMode(int reset);
int DoAttractMode(void);

void SignalEndGame(int why);

#endif