/***********************************************
	GFXIFACE.H

 Updated by Christopher Deel
 Updated by Mike Heilemann

	Copyright 1994 GameTek
	All rights reserved
***********************************************/

#define VMODE320  0           /* 320 X 240 */
#define VMODE512  1           /* 512 X 240 */
#define VMODE640  2           /* 640 X 480 */

#define FRAME_X	320		   /* frame size (320x240) */
#define FRAME_Y	240

#define PACKETMAX (45000)	/* Maximum number packet number (Nigel - was 30000) */
#define OT_LENGTH  11 	/* Resolution of OT in bits */
#define OTSIZE (1 << OT_LENGTH)
#define OTZSHIFT (14 - OT_LENGTH);
#define OBJECTMAX  2   /* Max objects */
//#define PACKETMAX2 (PACKETMAX*24)

/*--- Display buffer Type ---*/
typedef struct
{
	DRAWENV		draw;
	DISPENV		disp;
	GsOT		gsot;
	u_long		ot[OTSIZE];
	PACKET		gsprim[PACKETMAX];	/*  */
} DspBuf_t;

typedef struct World
{
	GsCOORDINATE2  coord_system;/* Coordinate system */
	GsF_LIGHT      lights[3];		/* Structure of light sources */
	GsRVIEW2       view;			  /* Structure of view point */
	/* --- Added for GPU (CGD) ----*/
	SVECTOR	ang;
	VECTOR	trans;
	MATRIX	mat;
} World;

/* --- Standard Frame Flags ----*/
typedef struct {
	BOOL background;
} StdFrameFlags_t;

extern StdFrameFlags_t gStdFrameFlags;

extern char       gVidMode;
/*extern int        double_buffer_id;    /*##*/
//extern GsOT       Wot[2];				/* OT handlers */
//extern GsOT_TAG	zsorttable[2][1<<OT_LENGTH];	/* Entity of OT */
//extern u_long		out_packet[2][0X8000];  /* for double buffers  */

extern  DspBuf_t gDspBuf[2];
extern  char gCurrDB;
extern  DspBuf_t *gPtrCurrDB;
extern  GsOT *gPtrGsOt;			/* Pointer to Current Gs Ordering Table */
extern  ULONG *gPtrGpuOt;		/* Pointer to Current GPU Ordering Table */

extern Sint16 SyncFlag;


/*     Function prototypes */
/* GFXIFACE.C */
void SetBackgroundColor(UBYTE red, UBYTE green, UBYTE blue);
void SetScreenMode ( char mode );
void InitGraph ( void );
void SwitchScreenOff ( void );
void SwitchScreenOn ( void );
void InitFrame ( void );
void ShowFrame ( void );
void ClearScreen ( void );
int  StdFrameSub ( void );
void DoFrameLoop ( char num , FCNPTR func );
void AddPrimToOT ( int z , u_long *prim );

void StartFadeOut(int speed, int interleave, BOOL wait);
int UpdateFade(void);

