/***********************************************************************
*gtekshl.c                                                             *
*Shell-play selection function                                         *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
*Started on 3/14/1995                                                  *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbequ.h"
#include "fbram.h"
#include "shell.h"
#include "gtekshl.h"

/*used in display for picture flipping*/
extern pict_t	*picture[2];

/******************************************************
Display the Gametek splash screen currently not used
*******************************************************/
int Display_GTEK_Shell()
{
  /*internal variables*/
  int i;
  int PlayersDone = FALSE;  /*both players done?*/
  int PlayerDone[2];        /*player 1 or 2 done?*/
  int MaxPlayers, WhichPad; /*misc stuff*/
  int RetCode;				/*return code flag*/

  /*Init the multifile pointers*/
  Shell_MFile = (unsigned long *)LoadCDFile("/shells/gametek/gametek.mfl");
  DebugPrintf(0,"gametek.mfl loaded into %x\n", Shell_MFile);

  /*Initialize variables*/
  PlayersDone   = FALSE;
  MaxPlayers = 2;
  for(i=0; i<2; i++)
  {
    PlayerDone[i]    = FALSE;
    PadPressed[i]    = 0;
  }

  /*Set graphics mode*/
  SetScreenMode(VMODE512);
  ClearScreen();
//initVRamHandling();

  /*Paint the screen*/
  Paint_GTEK_Screen();

  /*main event loop*/
  while(PlayersDone == FALSE)
  {

    /*Force redisplay of the screen*/
    DoFrameLoop(1, Shell_Frame_GTEK);

    /*Poll the pad*/
    PollPads(PadPressed, MaxPlayers);

    /*0 for the left controller, 1 for the right controller*/
    for(WhichPad=0; WhichPad < MaxPlayers; WhichPad++)
    {
      /*handle the pad button pressed*/
      switch(PadPressed[WhichPad])
      {
        case PAD_UP:
          break;
        case PAD_DOWN:
          break;
        case PAD_LEFT:
          break;
        case PAD_RIGHT:
          break;

        case SQUARE:
          break;
        case CIRCLE:
		  PlayShellSound(PRESS_SOUND);
          PlayerDone[0] = TRUE;
          PlayerDone[1] = TRUE;
		  RetCode = GO_PREV;
          break;
        case TRIANGLE:
          break;
        case START:
        case CROSS:
		  PlayShellSound(PRESS_SOUND);
          PlayerDone[0] = TRUE;
          PlayerDone[1] = TRUE;
		  RetCode = GO_NEXT;
          break;

        case BOTTOMLEFT:
          break;
        case BOTTOMRIGHT:
          break;

        case TOPRIGHT:
          break;
        case TOPLEFT:
          break;

        case STOP:
          break;
      }/*switch*/

      /*check if both players are done*/
      if(MaxPlayers == 1)
      {
        if(PlayerDone[0] == TRUE)
          PlayersDone = TRUE;
      }/*if*/
      else if(MaxPlayers > 1)
      {
        if(PlayerDone[0] == TRUE && PlayerDone[1] == TRUE)
          PlayersDone = TRUE;
      }/*if*/
    }/*for*/

  }/*while*/

  /*cleanup*/
  CleanUp_GTEK();

  /*return return code*/
  DebugPrintf(0,"Returning %d\n", RetCode);
  return RetCode;

}

/********************************************************
Paints the main screen
*********************************************************/
int Paint_GTEK_Screen()
{
  char *ptr;

  /*initialize the background for the shell*/
  ptr = (char *)GetMultiFilePtr(Shell_MFile, "gametek.tim");
  initTexture(0, ptr);

  return 0;

}

/*********************************************************
Cleans up everything
**********************************************************/
int CleanUp_GTEK()
{
  FreeFileData((char *)Shell_MFile);

  FreeBackgrounds();

  return 0;
}

/*************************************************************************
 * FIELD FRAME - Callback function to setup the frame stuff...
 *************************************************************************/
int Shell_Frame_GTEK(void)
{
  PollPC();
  UpdateBackground();

  DisplayAllStrings();
  DisplayShellPolys();
  return(1);
}


/**************************END OF FILE GTEKSHL.C****************************/

