//
// GAMETEK 1996
//
// Menu defines for machine independant menu system
//
// Author : Nigel Spencer 08/01/96
//
//


// Standard color defs

#define COLOR0	0
#define COLOR1	1
#define COLOR2	2
#define COLOR3	3
#define COLOR4	4
#define COLOR5	5
#define COLOR6	6
#define COLOR7	7
#define COLOR8	8
#define COLOR9	9
#define COLOR10	10
#define COLOR11	11
#define COLOR12 12
#define COLOR13	13
#define COLOR14	14
#define COLOR15	15

// High Light color defs

#define HICOLOR0	(0<<4)
#define HICOLOR1	(1<<4)
#define HICOLOR2	(2<<4)
#define HICOLOR3	(3<<4)
#define HICOLOR4	(4<<4)
#define HICOLOR5	(5<<4)
#define HICOLOR6	(6<<4)
#define HICOLOR7	(7<<4)
#define HICOLOR8	(8<<4)
#define HICOLOR9	(9<<4)
#define HICOLOR10	(10<<4)
#define HICOLOR11	(11<<4)
#define HICOLOR12	(12<<4)
#define HICOLOR13	(13<<4)
#define HICOLOR14	(14<<4)
#define HICOLOR15	(15<<4)

// Inactive color defs

#define DIMCOLOR0	(0<<8)
#define DIMCOLOR1	(1<<8)
#define DIMCOLOR2	(2<<8)
#define DIMCOLOR3	(3<<8)
#define DIMCOLOR4	(4<<8)
#define DIMCOLOR5	(5<<8)
#define DIMCOLOR6	(6<<8)
#define DIMCOLOR7	(7<<8)
#define DIMCOLOR8	(8<<8)
#define DIMCOLOR9	(9<<8)
#define DIMCOLOR10	(10<<8)
#define DIMCOLOR11	(11<<8)
#define DIMCOLOR12	(12<<8)
#define DIMCOLOR13	(13<<8)
#define DIMCOLOR14	(14<<8)
#define DIMCOLOR15	(15<<8)


#define	DIM_YELLOW	DIMCOLOR3
#define	HI_YELLOW	HICOLOR2

#define PEN_WHITE		0
#define PEN_GREY		1
#define PEN_YELLOW		2
#define PEN_DKYELLOW	3
#define PEN_BLUE		4
#define PEN_DKBLUE		5
#define PEN_RED			6
#define PEN_DKRED		7
#define PEN_GREEN		8
#define PEN_DKGREEN		9
#define PEN_ORANGE		10
#define PEN_DKORANGE	11
#define PEN_PURPLE		12
#define PEN_DKPURPLE		12


#define	UP_ARROW		"*"
#define	DOWN_ARROW		"$"
#define	LT_ARROW		"("
#define	RT_ARROW		")"

// Font defs (not currently used)

#define	FONT_0	0<<8
#define	FONT_1	1<<8
#define	FONT_2	2<<8
#define	FONT_3	3<<8


#define	PITTSBURGH	5
#define	BUFFALO		10
#define	CAROLINA	18


#define	ACTIVE		0x80000000			// Used to turn item off (dimmed) or on
#define	MENU_ITEM	0x40000000			// Distinguish between menu items & item fields
#define	TEXT_ITEM	0x20000000			// Distinguish between menu items & item fields
#define HIGHLIGHT	0x10000000			// Used to highlight current item field as being current setting
#define	END_MENU	0x40001234			// Magic no. + MENU_ITEM bit to indicate end of menu (MENU_ITEM set for convenience)

#define MENU_FRAMERATE	1

#define SCREEN_HEIGHT	240
#define SCREEN_WIDTH	512
#define CENTER_SCREEN	(SCREEN_WIDTH/2)

enum MenuStates {

	GAME_OPTIONS_MENU = 0,
	PLAYER_OPTIONS_MENU,
	TEAM_VIEW_MENU,
	PLAYER_VIEW_MENU,
	SCHEDULE_MENU,
	AUDIBLES_MENU,
	NEWSEASON_MENU,
	CONTSEASON_MENU,
	SEASOPT_MENU,
	TMSTATS_MENU,
	TMSTAND_MENU,
	LGLEADERS_MENU,
	PLYRLDRS_MENU,
	LEADERS_MENU,
	CONTOPTSEAS_MENU,
	SUBSTITUTION_MENU,
	PLAYOFFS_MENU,
	TRADING_MENU,
	CONTROLLERS_MENU,
};


typedef struct MenuItem_S{

	LONG	item_flags;					// positioning & flags for Item heading
	UWORD	item_x;
	UWORD	item_y;
	UBYTE	*item_text;					// Item text string if any
	LONG	(*item_funct)(struct MenuItem_S *curitem, WORD itemnum);			// Item function if any

}MenuItem;


typedef struct {

		MenuItem *menu_items;			// pointer to array of Menu Items
		INT (*init_menu)(void);			// Menu function init call
		INT (*term_menu)(void);			// Menu function termination/cleanup call
		INT (*main_menu)(void);			// Menu function call to be called each loop of menu (display code etc)
		RECT rect_menu;
}MenuObj;


extern LONG	TeamNo;
extern LONG	PadNo;
extern LONG	WhichTeam;
extern BYTE *CurFont;
extern BYTE  HumanTeamNum;
//tom extern UBYTE GameMode;
extern WORD	CurMenu;
extern LONG	MenuFadeFlag;
extern RECT ClipString;		// Viewport rectangle
extern INT	RetCode, RetCode2, GoToFxn, GoToFxn2;

extern void LoadingMessage(void);
extern INT GetAllPads(INT repeatrate);
extern BYTE DoName(INT NameLen);
extern void FadeDown(LONG fadespeed);
extern LONG LoadNickname(LONG teamNum, LONG template_num, LONG template_item);
extern LONG LoadTeamPic(LONG teamno);
extern LONG LoadHalfPic(LONG teamno);
extern void SetupFont(BYTE *fontname);

extern LONG LoadJimmy(void);		// Jimmy animating logo routines
extern LONG FreeJimmy(void);
extern void DoMenuStrip(void);
extern void EndSeasonMessage(INT win);


