/*************************************************************************
 *	menus.h for the PSX.
 *
 *	Copyright 1997 GAMETEK
 *	All rights reserved.
 *
 * Written by Tom McWilliams
 * Started: 3-17-97
 *
 *	Notes: Crazy Menu Interpreter
 *
 *************************************************************************/

#define PEN_WHITE			0
#define PEN_GREY			1
#define PEN_YELLOW		2
#define PEN_DKYELLOW	3
#define PEN_BLUE			4
#define PEN_DKBLUE		5
#define PEN_RED				6
#define PEN_DKRED			7
#define PEN_GREEN			8
#define PEN_DKGREEN		9
#define PEN_ORANGE		10
#define PEN_DKORANGE	11
#define PEN_PURPLE		12
#define PEN_DKPURPLE	12


typedef WORD var_t;			// options variable type

typedef void* menu_t;
typedef void* submenu_t;

enum
{
	M_MUTEX		=0x0100,		// 					set selections as mutually exclusive
	M_HILITE	=0x0200,		//					hilite selections
	M_ACTIVE	=0x0300,		//					hilite selections if parent active
	M_x				=0x0401,		// x				set cursor x
	M_y				=0x0501,		// y				set cursor y
	M_xy			=0x0602,		// x,y			set cursor x,y
	M_dx			=0x0701,		// dx				change cursor x
	M_dy			=0x0801,		// dy				change cursor y
	M_dxy			=0x0902,		// dx,dy		change cursor x,y
	M_top			=0x0A01,		// y				clipping top
	M_bot			=0x0B01,		// y				clipping bottom
	M_color		=0x0C01,		// color		set normal color (color of item not selected and in an inactive menu)
	M_hicolor	=0x0D01,		// color		set hilite color (color of selection in an active menu)
	M_locolor	=0x0E01,		// color		set lolite color (color of selection in an inactive menu)
	M_scrolloff=0x0F00,		//					scrolling off
	M_scrollon=0x1000,		//					scroling on
	M_text		=0x1101,		// char*		print text
	M_textc		=0x1201,		// char*		print text centered at x
	M_link		=0x1301,		// menuptr	link to submenu by ptr
	M_linkvar	=0x1402,		// menuptr,var	link to submenu by ptr w/var
	M_hmenu		=0x1501,		// varptr		horizontally controlled menu. varptr=ptr to control var
	M_vmenu		=0x1601,		// varptr		vertically controlled menu. varptr=ptr to control var
	M_pdmenu	=0x1701,		// varptr		pull-down menu (takes control from above menus)
	M_ifactive=0x1800,		//					if active continue else skip to eol (don't put M_jpad afterward!)
	M_eol			=0x1900,		// 					end of current menu line
	M_end			=0x1A00,		//					end of current menu
	M_call		=0x1B01,		// addr			execute function
	M_exec		=0x1C01,		// addr			execute code then redraw menu
	M_exit		=0x1D01,		// retcode	exit menus and return retcode
	M_setpad	=0x1E01,		// pad#			set joypad to read for menu (index to MenuPad[] array)
// joypad trigger: if no trigger skip to M_eol.  Joy bits to check are in bits 0-15
	M_jpad=0x10000				// joybits
};


// end of menus.h //

