#***********************************
# Makefile for PSX 
#   Uses Borland Make
#
#  By Christopher Deel
#***********************************

PROG = BBall

#
# Implicit rules
#
.c.obj:
#   - bcc -mh -Ic:\psx\include -c -otmp.$ $*.c
   ccpsx -c -g $*.c 

.s.obj:
   aspsx $*.s

#.c.s:
#   ccpsx -S -v -g $*.c -o $*.s

STDINCS =VERSION.H PrjHdrs.H GFXIFACE.H MISC.H

OBJS1 =	$(PROG).Obj Deel.obj MikeH.obj DEBUG.Obj FONTS.Obj Psprite.obj \
 	MMVRAM.Obj Picture.Obj
OBJS2 =	PSXPAD.Obj GFXIFACE.Obj FONTTEST.Obj \
 	MISC.Obj
OBJS3 =	SCRIPTS.Obj FontData.obj MultiFil.obj

TestObjs = field.obj


# ---- compile and run the program ----
run: $(PROG).cpe 
#	pause
#	R

#---- Main target ---- 
$(PROG).cpe: FakeCD.bin $(OBJS1) $(OBJS2) $(OBJS3) $(TestObjs) $(PROG).cf
	ccpsx @$(PROG).cf -Xo$80010000 -Xm -o $(PROG).cpe,$(PROG).sym,$(PROG).map
	
#---- Binary Data ----
FakeCD.bin: FakeCD.fil chris.fil mikeh.fil common.fil
	copy chris.fil+mikeh.fil+common.fil FakeCD.fil
	bldMulti FakeCD.fil FakeCD.bin

ZIP: $(PROG).zip
CLEAN: $(PROG).zip

$(PROG).zip: $(PROG).cpe
	- pkzip $(PROG) *.mak *.c *.h *.s *.bat *.lnk *.txt *.dat
	- pkzip bak *.bak
	- del *.bak   
   
#----- Build Compiler Link File ------
$(PROG).cf: makefile.mak
	echo $(OBJS1) > $@
	echo $(OBJS2) >> $@
	echo $(OBJS3) >> $@
	echo $(TestObjs) >> $@
	
#
# Build dependencies
#

$(PROG).Obj    :  $(PROG).C   $(STDINCS) 
DEEL.Obj      :  DEEL.C     $(STDINCS) 
DEBUG.Obj     :  DEBUG.C    $(STDINCS)
FONTS.Obj     :  FONTS.C    $(STDINCS)
MMVRAM.Obj    :  MMVRAM.C   $(STDINCS)
PSXPAD.Obj    :  PSXPAD.C   $(STDINCS)
GFXIFACE.Obj  :  GFXIFACE.C $(STDINCS)
MISC.Obj      :  MISC.C     $(STDINCS)
FONTTEST.Obj  :  FONTTEST.C $(STDINCS)
LINES.Obj     :  LINES.C    $(STDINCS)



