#ifndef MISC_H
#define MISC_H 1
/************************************************************
				Misc. routines for the PSX

	Copyright 1995 GameTek
	All rights reserved

*************************************************************/

#if PAL
#define VBlanksPerSec 50
#else
#define VBlanksPerSec 60
#endif

#define MAX_VB_TIMERS 5
#define GAME_TIMER_NUM 0
#define DPC_TIMER_NUM  1             	// shell uses this
#define PLAY_TIMER_NUM	DPC_TIMER_NUM	// AI uses this (you decide which is better)
#define CAMERA_TIMER_NUM 2
#define CAMERA_TIMER2_NUM 3
#define COIN_TIMER_NUM 4
extern ULONG gVBlankTimers[MAX_VB_TIMERS];

#define randN(n) (rand()%(n))
#ifndef random
	#define random(num) (GetRandom(int num))
#endif

/*  AI needs these prototypes	*/
ULONG GetVBlankCount ( void );
void StartVBlankTimer ( int num );
void StopVBlankTimer ( int num );
void SetVBlankTimer ( int num , ULONG val );
ULONG GetVBlankTimer(int num);

void CopyBytes ( UBYTE *src , UBYTE *dest , int count );
void CopyShorts ( USHORT *src , USHORT *dest , int count );
void CopyLongs ( ULONG *src , ULONG *dest , int count );


#ifndef __MSDOS__
//#define isascii(c) (!c&0x80)
//#define isdigit(c) (((c>('0'-1))&&(c<('9'+1)))||c=='-')
//#define isspace(c) (c==' ')
#ifndef max
#define max(x,y) ( ( (x) > (y) ) ? (x) : (y) )
#define min(x,y) ( ( (x) < (y) ) ? (x) : (y) )
#endif

#define TrueFalseMacro(val) ((val) ? 1 : 0)

//--- Scratchpad Stack routines ---
#if __psx__
#define SetSpadStack(addr) {\
	__asm__ volatile ("move $8,%0"     ::"r"(addr):"$8","memory"); \
    __asm__ volatile ("sw $29,0($8)"   ::         :"$8","memory"); \
    __asm__ volatile ("addiu $8,$8,-4" ::         :"$8","memory"); \
    __asm__ volatile ("move $29,$8"    ::         :"$8","memory"); \
}
    
    #define ResetSpadStack() {\
        __asm__ volatile ("addiu $29,$29,4":::"$29","memory"); \
        __asm__ volatile ("lw $29,0($29)"  :::"$29","memory"); \
    }

    #define GetStackAddr(addr) {\
        __asm__ volatile ("move $8,%0"     ::"r"(addr):"$8","memory"); \
        __asm__ volatile ("sw $29,0($8)"   ::         :"$8","memory"); \
    }

#endif

typedef struct
{
	unsigned	hours:8;
	unsigned	minutes:8;
	unsigned	seconds:8;
	unsigned	hundreths:8;
} Time_t;


#if va_list
	void vsprintf ( char *buf , char *format , va_list ap );
#endif

/* misc.c */
#ifdef SVECTOR
	void SetShortVector(SVECTOR *vec, int x, int y, int z);
	void CopyShortVector(SVECTOR *source, SVECTOR *dest);
#endif

//void HandleVBlank ( void );
void InitVBlankCount ( void );
//ULONG GetVBlankCount ( void );
//void StartVBlankTimer ( int num );
//void StopVBlankTimer ( int num );
//void SetVBlankTimer ( int num , ULONG val );
//ULONG GetVBlankTimer(int num);
Time_t VBlankToTime ( ULONG vb );
void DelayVB ( long n );
void Randomize ( void );
int GetRandom(int num);
char getch ( void );
int strlenI ( char *s );
char *strupr ( char *s );
int Int2Str ( int num , char *str , int radix );
BOOL strincmp ( char *arg1 , char *arg2 , int n );
//void vsprintf2 ( char *buf , char *format , va_list ap );
char *sprintf2 ( char *buf , char *format , ...);
BOOL stricmp ( char *s1 , char *s2 );
BOOL isgraph ( char c );

USHORT GenPSXColor(int red, int green, int blue, int transparent);
int AbsInt(int val);

#if !DEBUG_MALLOC_FILE
void *AllocMem ( long bytes );
void FreeMem ( void *ptr );
#endif

#endif //not __MSDOS__


#endif MISC_H
