/***********************************************************************
*mmenushl.c                                                            *
*Shell-play selection function                                         *
*                                                                      *
                                          *
*                                                                      *
*Ripped apart by Nigel Spencer & rewritten                             *
*07-20-96                                                              *
*                                                                      *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbequ.h"
#include "fbram.h"
#include "shell.h"
#include "mmenushl.h"
//#include "menu.h"

//---------------

// 3d sprite structures & functions

#include "psprite.h"
#include "field.h"

extern PolySpritePtr gPSpritePtrs[];
extern PolySpriteType gPolySpriteData[];

void coordinit(void);

//---------------

/*menu variables*/
static INT Which_Game;

void InitMenuPositions(void);
void RotateMenu(long degrees);
void RotateVectorY(VECTOR *vec, long angle);
void TranslateToScreen(long menu_num);
long FixedToInt(long num);
void SortPriority(void);

#define	NUM_DEGREES		256
//#define VIEW_DISTANCE	(290)
#define VIEW_DISTANCE	(280)
#define	CAMZ			(-599 <<8 )
#define	CAMX			(0 <<8 )
#define	CAMY			(-40)
#define	YOFF			(-15)
#define	MAX_MENUOBJ		5
#define MENU_RADIUS		320
#define	ROT_SPEED		4

static LONG NumRot;
static LONG Cam_Z;


int fbx1, fby1;

int ExtraX[MAX_MENUOBJ] = {
							120,
							120,
							120,
							120,
							120,
};


int MenuPicXoff[MAX_MENUOBJ] = {
								 0x00000000,
								 0x00000000,
								 0x00000000,
								 0x00000000,
								 0x00000000,
};


VECTOR	MenuVectorsInit[MAX_MENUOBJ] = {
						{0 <<8, -CAMY <<8,0 <<8,0},	// adjusted y for play editor icon
						{0 <<8, -CAMY <<8,0 <<8,0},
						{0 <<8, -CAMY <<8,0 <<8,0},
						{0 <<8, -CAMY <<8,0 <<8,0},
						{0 <<8, -CAMY <<8,0 <<8,0},
};

VECTOR MenuVectors[MAX_MENUOBJ];


POLY_FT4 *MenuPoly[MAX_MENUOBJ*2] = {
							&template[0].poly[0],
							&template[1].poly[0],
							&template[2].poly[0],
							&template[3].poly[0],
							&template[4].poly[0],

							&template[0].poly[1],
							&template[1].poly[1],
							&template[2].poly[1],
							&template[3].poly[1],
							&template[4].poly[1],
};

BYTE *MenuDepth[MAX_MENUOBJ*2] = {
							&template[0].depth[0],
							&template[1].depth[0],
							&template[2].depth[0],
							&template[3].depth[0],
							&template[4].depth[0],

							&template[0].depth[1],
							&template[1].depth[1],
							&template[2].depth[1],
							&template[3].depth[1],
							&template[4].depth[1],
};


int rot;

int MenuAngle[MAX_MENUOBJ] = {	1,
								((NUM_DEGREES/MAX_MENUOBJ) * 1)+1,
								((NUM_DEGREES/MAX_MENUOBJ) * 2)+1,
								((NUM_DEGREES/MAX_MENUOBJ) * 3)+1,
								((NUM_DEGREES/MAX_MENUOBJ) * 4)+1,
};


int Target=0;

/******************************************************
Display main menu
*******************************************************/
int Display_Main_Menu_Shell()
{
  /*internal variables*/
	int i,j, lighting;
	int PlayersDone = FALSE;  /*both players done?*/
	int PlayerDone[2];        /*player 1 or 2 done?*/
	int MaxPlayers, WhichPad; /*misc stuff*/
	int RetCode;				/*return code flag*/
	int Spin=0;

/*Initialize variables*/

	DumpHeap();

	PlayersDone   = FALSE;
	MaxPlayers = 8;
	Which_Game = 2;
	Cam_Z = CAMZ;

/*Initialize display & VRAM */

	FreeAllDialogBoxes();
	initVRamHandling();

/*initialize the background for the shell*/

	LoadBackgroundCD(0,"/shells/mmenu/mainmenu.tim");	// Load & free from memory
//	DoMenuStrip();

/* Set global joypad delay */

	JpadRepeatFreq = 1;

/*Init the multifile pointers*/

	Shell_MFile = (unsigned long *)LoadCDFile("/shells/mmenu/mmenu.mfl");
	DebugPrintf(0,"mmenu.mfl loaded into %x\n", Shell_MFile);

/*Paint the screen*/

	Paint_MMENU_Screen();

	InitMenuPositions();

	for(i=0;i<8;i++)
		JpadTrig[i] =  0;				// Clear any button presses

	rot = MenuAngle[Target];			// Startup value

/*main event loop*/

	while(!PlayersDone)
	{
//		JimmyLogo(8);

		GetRandom(1);				// Simply turning the generator over for variety.

		if(Spin > 0)
		{
			for(j=0; j<Spin; j++)
			{
				rot++;

				if(rot > NUM_DEGREES) rot = 1;

				if(rot == MenuAngle[Target])
				{
					Spin = 0;
				}
			}
		}
		else
		if(Spin < 0)
		{
			for(j=0; j>Spin; j--)
			{
				rot--;

				if(rot < 1) rot = NUM_DEGREES;

				if(rot == MenuAngle[Target])
				{
					Spin = 0;
				}
			}
		}

		RotateMenu(rot+24);				// Offset to line pics up at front

		for (i=0; i<MAX_MENUOBJ; i++)
		{
//			if(MenuVectors[i].vz-Cam_Z < (VIEW_DISTANCE<<12))
//				template[i].action[0] &= DISPLAY^0xFFFF;
//			else
//				template[i].action[0] |= DISPLAY;
//

			lighting = (128-40)-(MenuVectors[i].vz>>11);

			setRGB0(MenuPoly[i], lighting, lighting, lighting);
			setRGB0(MenuPoly[i+5], lighting, lighting, lighting);


			TranslateToScreen(i);
		}

		if(rot == MenuAngle[Target])
		{

			for(WhichPad=0; WhichPad < MaxPlayers; WhichPad++)
			{
				switch(JpadTrig[WhichPad])
				{
					case JPADLleft:
							if(--Which_Game < 1)
							    Which_Game =	3;

							Spin = -ROT_SPEED;
							Target--;
							if(Target<0) Target=MAX_MENUOBJ-1;

							PlayEffect(CURSOR_SFX);
							break;

					case JPADLright:
							if(++Which_Game > 3) Which_Game = 1;

							Spin = ROT_SPEED;
							Target++;
							Target%=MAX_MENUOBJ;

							PlayEffect(CURSOR_SFX);
							break;

					case JPADtriangle:
							PlayEffect(PRESS_SOUND);
							PlayersDone = TRUE;
							RetCode = GO_PREV;
							break;

					case JPADstart:
					case JPADx:
							PlayEffect(PRESS_SOUND);
							PlayersDone = TRUE;
							RetCode = Target;
							break;
				}

			}

		}

		SortPriority();

		DoFrameLoop(1, Shell_Frame_MMENU);

	}

	CleanUp_MMENU();

	DumpHeap();

	return RetCode;
}

/********************************************************
Paints the main screen
*********************************************************/
int Paint_MMENU_Screen()
{
	int i;
	BYTE *ptr;

  /*load the shell graphics template files*/

	InitTemplates();
	multifile = Shell_MFile;

	LoadTemplate("mmenu1.llx");
	LoadTemplate("mmenu2.llx");
	LoadTemplate("mmenu3.llx");
	LoadTemplate("mmenu4.llx");
	LoadTemplate("mmenu5.llx");
	LoadTemplate("mmenu6.llx");
	LoadTemplate("mmenu7.llx");

//	LoadJimmy();

	for(i=0; i<10; i++)
		setShadeTex(MenuPoly[i], 0);

	return 0;
}

/*********************************************************
Cleans up everything
**********************************************************/
int CleanUp_MMENU()
{
	int i;

	FreeAllTemplates();

	FreeFileData((BYTE *)Shell_MFile);
	FreeBackgrounds();
	return 0;
}

/*************************************************************************
 * Re-paints the menu bitmaps
 *************************************************************************/
void RePaintScreenMMENU()
{
	do_controls();

	MovePolyToXY(&template[5].poly[0], (-256)+fbx1, (-120)+fby1);
	MovePolyToXY(&template[6].poly[0], (-256)+fbx1+120, (-120)+fby1);

//	MovePolyToXY(&template[0].poly[0], (-256) + MenuPos[Which_Game][0], (-120) + MenuPos[Which_Game][1]);
//	SetPolySpritePos( (-256) + MenuPos[Which_Game][0], (-120) + MenuPos[Which_Game][1],100, gPSpritePtrs[0]);

}

/*************************************************************************
 * FIELD FRAME - Callback function to setup the frame stuff...
 *************************************************************************/
int Shell_Frame_MMENU(void)

{
	DisplayDialogBox();
	UpdateBackground();
	DisplayShellPolys();

	return(1);
}


//*************************************************************************
//*************************************************************************

void RotateVectorY(VECTOR *vec, long angle)
{
	long newx, newz;


//	newz = (vec->vz * ccos(angle)) - (vec->vx * csin(angle));
//	newx = (vec->vz * csin(angle)) + (vec->vx * ccos(angle));

	newx = (csin(angle) * (MENU_RADIUS<<8));
	newz = (ccos(angle) * (MENU_RADIUS<<8));


	vec->vz = FixedToInt(newz);
	vec->vx = FixedToInt(newx);
}


//*************************************************************************
//*************************************************************************


void TranslateToScreen(long menunum)
{

//	if(!(MenuVectors[menunum].vz-Cam_Z))
//	{
//		MenuPoly[menunum]->x0 = MenuPoly[menunum]->x2 = (MenuVectors[menunum].vx * VIEW_DISTANCE) >> 8;
//		MenuPoly[menunum]->x1 = MenuPoly[menunum]->x3 = ((MenuVectors[menunum].vx + (120<<8)) * VIEW_DISTANCE) >> 8;
//		MenuPoly[menunum]->y0 = MenuPoly[menunum]->y1 = (MenuVectors[menunum].vy * VIEW_DISTANCE) >> 8;
//		MenuPoly[menunum]->y2 = MenuPoly[menunum]->y3 = ((MenuVectors[menunum].vy+ (256<<8)) * VIEW_DISTANCE) >> 8;
//
//		MenuPoly[menunum+MAX_MENUOBJ]->x0 = MenuPoly[menunum+MAX_MENUOBJ]->x2 = MenuPoly[menunum]->x1;
//		MenuPoly[menunum+MAX_MENUOBJ]->x1 = MenuPoly[menunum+MAX_MENUOBJ]->x3 = MenuPoly[menunum]->x0 + (((ExtraX[menunum]<<8) * VIEW_DISTANCE) >> 8);
//		MenuPoly[menunum+MAX_MENUOBJ]->y0 = MenuPoly[menunum+MAX_MENUOBJ]->y1 = MenuPoly[menunum]->y0;
//		MenuPoly[menunum+MAX_MENUOBJ]->y2 = MenuPoly[menunum+MAX_MENUOBJ]->y3 = MenuPoly[menunum]->y2;
//	}
//	else
//	{
		MenuPoly[menunum]->x0 = MenuPoly[menunum]->x2 = (((MenuVectors[menunum].vx + MenuPicXoff[menunum] - CAMX - (120<<8)) * VIEW_DISTANCE)) /  (MenuVectors[menunum].vz-Cam_Z);
		MenuPoly[menunum]->x1 = MenuPoly[menunum]->x3 = (((MenuVectors[menunum].vx + MenuPicXoff[menunum] - CAMX) * VIEW_DISTANCE)) / (MenuVectors[menunum].vz-Cam_Z);
		MenuPoly[menunum]->y0 = MenuPoly[menunum]->y1 = ((MenuVectors[menunum].vy * VIEW_DISTANCE)) /  (MenuVectors[menunum].vz-Cam_Z)+CAMY+YOFF;
		MenuPoly[menunum]->y2 = MenuPoly[menunum]->y3 = (((MenuVectors[menunum].vy+ (113<<8)) * VIEW_DISTANCE)) / (MenuVectors[menunum].vz-Cam_Z)+CAMY+YOFF;

		MenuPoly[menunum+MAX_MENUOBJ]->x0 = MenuPoly[menunum+MAX_MENUOBJ]->x2 = MenuPoly[menunum]->x1;
		MenuPoly[menunum+MAX_MENUOBJ]->x1 = MenuPoly[menunum+MAX_MENUOBJ]->x3 = (((MenuVectors[menunum].vx + (ExtraX[menunum]<<8) + MenuPicXoff[menunum] - CAMX) * VIEW_DISTANCE) / (MenuVectors[menunum].vz-Cam_Z));
		MenuPoly[menunum+MAX_MENUOBJ]->y0 = MenuPoly[menunum+MAX_MENUOBJ]->y1 = MenuPoly[menunum]->y0;
		MenuPoly[menunum+MAX_MENUOBJ]->y2 = MenuPoly[menunum+MAX_MENUOBJ]->y3 = MenuPoly[menunum]->y2;
//	}
}

//*************************************************************************
//*************************************************************************

void RotateMenu(long degrees)
{
	int i;
	int ang;

	for (i=0; i< MAX_MENUOBJ; i++)
	{
		ang = (degrees + MenuAngle[i])%NUM_DEGREES;

		RotateVectorY(&MenuVectors[i], (ang * 4096)/NUM_DEGREES);
	}
}

//*************************************************************************
//*************************************************************************

void InitMenuPositions(void)
{
	int i;

	NumRot = 0;

	memcpy(MenuVectors, MenuVectorsInit, sizeof(VECTOR) * MAX_MENUOBJ);

	for (i=0; i< MAX_MENUOBJ; i++)
	{
		RotateVectorY(&MenuVectors[i], (i * 4096)/MAX_MENUOBJ);
	}
}


//*************************************************************************
//*************************************************************************


long FixedToInt(long num)
{
	int remainder = num & 0xFFFFF000;

	num >>=12;

	if(remainder > 0x800) num++;

	return(num);
}

//*************************************************************************
//*************************************************************************

void SortPriority(void)
{

	int i;
	int objlist[MAX_MENUOBJ][2], tempz, tempi;
	BYTE flag = TRUE;


	for (i= 0; i<MAX_MENUOBJ; i++)
	{
		objlist[i][0]=MenuVectors[i].vz;
		objlist[i][1]=i;
	}

	while(flag)
	{
		flag = 0;

		for (i= MAX_MENUOBJ-2; i>=0; i--)
		{
			if(objlist[i][0] > objlist[i+1][0])
			{
				tempz = objlist[i+1][0];
				tempi = objlist[i+1][1];

				objlist[i+1][0] = objlist[i][0];
				objlist[i+1][1] = objlist[i][1];


				objlist[i][0] = tempz;
				objlist[i][1] = tempi;

				flag++;
			}
		}
	}

	tempz = 55;

	for(i=0; i<MAX_MENUOBJ; i++)
	{
		if(objlist[i][0]>-4000) tempz = 61;
		*MenuDepth[objlist[i][1]] = *MenuDepth[objlist[i][1]+MAX_MENUOBJ] = tempz+=1;
	}
}

//*************************************************************************
// End Of File
//*************************************************************************

