/************************************************
	Multi File Definitions
	
	By Christopher G. Deel
************************************************/
#ifndef _MULTIFIL_H
#define _MULTIFIL_H 1

#define MULTIFILE1_HEADER 0x544C554D
#define MULTIFILE2_HEADER 0x324c464d
#define SECTOR_FILE1_HEADER 0x314c4653

typedef struct {
	char name[12];
	unsigned long offset;
} MULTI_FILE;

typedef struct
{
	ULONG type;
	ULONG type2;
	ULONG files;
	ULONG bytes;
} MultiFileHeaderType;

typedef struct
{
	ULONG type;
	ULONG sector;
	ULONG files;
	ULONG bytes;
} SectorFileHeader_t;

  
typedef MULTI_FILE MultiFile_t;
typedef MULTI_FILE SectorFile_t;


/* multifil.c */
int GetMultiFileType ( MultiFile_t *base );
char *GetMultiFilePtr ( MultiFile_t *base , char *name );
int GetNumberInMultiFile ( MultiFile_t *base , char *name );
char *GetMultiFile2ByNum ( MultiFile_t *base , int num );
char *GetMultiFileByNum ( MultiFile_t *base , int num );

SectorFile_t *LoadSectorFileDirectory(char *name, ULONG sector, SectorFile_t *dest );
ULONG GetSectorFileSector ( SectorFile_t *dir , char *fname );
ULONG GetSectorFileByNum ( SectorFile_t *base , int num );
  
#endif
