/**********************************

**********************************/

#define	TIM_HEADER 0x00000010  /* Header Marker for TIM file */

typedef struct
{
	char      	blocks;
	char      	clutType;         /* VRAM_CLUT16 = 16...         */
	POLY_FT4 	poly[10];
	vram_t	 	*tpage[10];       /* 10 blocks max (640 * 480)    */
	vram_t    	*CLUT;            /* either 16 or 256 CLUT  (for whole picture) */
} pict_t;

#define GetPictTpage(pict) (pict->block[0]->tpage)
#define	N_BG 1		/* Number of backgrounds */
								 
extern pict_t picture[N_BG];
extern vram_t texture[NUM_TEXTURE_PAGES];    /* 320 # of textures is the largest */
extern vram_t clut256[BIG_NUM_CLUT256_PAGES];/* 640 # of cluts is the largest */
extern vram_t clut16[BIG_NUM_CLUT16_PAGES];  /* 640 # of cluts is the largest */


//pict_t *load_pict(GsIMAGE pic);
void load_pict(int num, GsIMAGE pic);
void InitBackground(void);
void FreeBackgrounds(void);
void UpdateBackground(void);
void move_background(int num, int rate, int dir);
