/***********************************************************************
*pleddata.h                                                            *
*Shell-play edit function data file                                    *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/

/*include definitions of the scripts*/
//#include "fbplays.h"

/*Location of all the players on all the play bitmaps*/
/*FormationPositions[position][x,y]*/

/*List of the arrow plays available to each position in each formation.*/
/*Indeterminate length arrays of numbers are declared as arrays of char*/
/*and initilized. Clumsy, but its the only way to do it in C*/
/*THE NUMBERS MUST BE IN HEX*/
static struct FormationInfoStruct FormationInfo[] = {
					/*0 - Goalline*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,53, /*Running Back*/
					64,61, /*Running Back*/
					100,40,/*Running Back*/
					29,39, /*L.W. Receiver*/
					119,42,/*R. Receiver*/
					/*passing plays*/
                    4,2,8,5,8,6,7,  					  /*max arrow plays for each positions*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x4\x5",                          /*QB*/           
					"\x0\x3\x4\x5\x6\x7\x8\x9\xA",        /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5",                 /*Running Back*/ 
					"\x0\x1\x2\x3\x6\x7\x8\x9\xA",        /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runnin plays*/
                    4,2,8,5,8,6,7,  					  /*max arrow plays for each positions*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x4\x5",                          /*QB*/           
					"\x0\x3\x4\x5\x6\x7\x8\x9\xA",        /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5",                 /*Running Back*/ 
					"\x0\x1\x2\x3\x6\x7\x8\x9\xA",        /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*1 - Wish Bone*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,53, /*Running Back*/
					52,62, /*Running Back*/
					77,62, /*Running Back*/
					11,39, /*L.W. Receiver*/
					101,39,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*running plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*2 - Power I*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,53, /*Running Back*/
					64,62, /*Running Back*/
					76,53, /*Running Back*/
					11,40, /*L.W. Receiver*/
					102,39,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*3 - VR Form*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,53, /*Running Back*/
					76,50, /*Running Back*/
					100,40,/*Running Back*/
					11,40, /*L.W. Receiver*/
					119,42,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*running plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*4 - I Slot*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,53, /*Running Back*/
					64,61, /*Running Back*/
					25,42, /*Running Back*/
					11,39, /*L.W. Receiver*/
					101,39,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*running plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*5 - Single Back*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,61, /*Running Back*/
					28,40, /*Running Back*/
					100,40,/*Running Back*/
					11,41, /*L.W. Receiver*/
					119,41,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*running plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*6 - H Back*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,61, /*Running Back*/
					32,45, /*Running Back*/
					100,40,/*Running Back*/
					11,39, /*L.W. Receiver*/
					119,41,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*7 - I Form*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,53, /*Running Back*/
					64,62, /*Running Back*/
					100,40,/*Running Back*/
					11,40, /*L.W. Receiver*/
					118,41,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*8 - ProSet */
					41,40, /*lineman*/
					64,47, /*QB*/
					52,53, /*Running Back*/
					76,53, /*Running Back*/
					100,40,/*Running Back*/
					11,39, /*L.W. Receiver*/
					119,41,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*9 - West Coast*/
					41,40, /*lineman*/
					64,47, /*QB*/
					52,53, /*Running Back*/
					100,40,/*Running Back*/
					110,44,/*Running Back*/
					11,40, /*L.W. Receiver*/
					123,43,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*10 - Shot Gun*/
					41,40, /*lineman*/
					64,58, /*QB*/
					24,42, /*Running Back*/
					76,53, /*Running Back*/
					105,42,/*Running Back*/
					7,39,  /*L.W. Receiver*/
					123,39,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*11 - Trips*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,62, /*Running Back*/
					100,42,/*Running Back*/
					111,42,/*Running Back*/
					11,40, /*L.W. Receiver*/
					120,40,/*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  

					/*12 - Run Shoot*/
					41,40, /*lineman*/
					64,47, /*QB*/
					64,61, /*Running Back*/
					24,42, /*Running Back*/
					105,42,/*Running Back*/
					7,40,  /*L.W. Receiver*/
					123,39, /*R. Receiver*/
					/*passing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7",           /*R. Receiver*/  
					/*runing plays*/
                    4,5,10,10,10,6,7,					  /*max arrow plays*/
					"\x0\x1\x2\x3\x4",                    /*lineman*/      
					"\x0\x1\x2\x3\x4\x5",                 /*QB*/           
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA",  /*Running Back*/ 
					"\x0\x1\x2\x3\x4\x5\x6",              /*L.W. Receiver*/
					"\x0\x1\x2\x3\x4\x5\x6\x7"            /*R. Receiver*/  

                                        };

/*lineman arrows*/

static struct ArrowStruct LineMen[] ={
                               "None", /*name*/
                               64,16,  /*XY size*/
                               4,13,   /*origin where to draw*/

                               "Run Block Left",  /*1*/
                               64,16,		       
                               4,13,		       
											       
                               "Run Block Right", /*2*/
                               64,16,		       
                               10,13,		       
											       
                               "Slant Block Right",/*3*/
                               64,16,		       
                               10,13,		       
                             				       
                               "Slant Block Left",/*4*/
                               64,16,
                               10,13,
                             				       
                               "Pass Block",      /*5*/
                               64,16,
                               10,13,
                             				       
                               "Pull Right",      /*6*/
                               64,16,
                               10,13,
                             				       
                               "Pull Left",       /*7*/
                               64,16,
                               10,13,
                             				       
                               "Pull Right Short",/*8*/
                               64,16,
                               10,13,
                             				       
                               "Pull Left Short", /*9*/
                               64,16,
                               10,13,
                             				       
                               "Screen Right",    /*A*/
                               64,16,
                               10,13,
                             				       
                               "Screen Center",   /*B*/
                               64,16,
                               10,13,
                             				       
                               "Screen Left",     /*C*/
                               64,16,
                               10,13,
                             				       
                               "Trap Right",      /*D*/
                               64,16,
                               10,13,
                             				       
                               "Trap Left",       /*E*/
                               64,16,
                               10,13
                              };

/*qb arrows*/
static struct ArrowStruct QBack[] = {
                               "None",	                /*0*/
                               80,50,
                               47,37,

                               "Down Ball",             /*1*/
                               16,46,
                               0,32,

                               "Kneel",                 /*2*/
                               56,39,
                               4,35,

                               "Fake Down Ball",        /*3*/
                               48,14,
                               4,2,
                             
                               "Bootleg Right",         /*4*/
                               32,6,
                               3,3,

                               "Bootleg Left",          /*5*/
                               40,47,
                               36,40,

                               "Sneak",                 /*6*/
                               40,47,
                               36,40,

                               "Drop Back Short",       /*7*/
                               40,47,
                               36,40,

                               "Drop Back Medium",      /*8*/
                               40,47,
                               36,40,

                               "Drop Back Deep",        /*9*/
                               40,47,
                               36,40,

                               "Hand Off Right",        /*A*/
                               40,47,
                               36,40,

                               "Hand Off Left",         /*B*/
                               40,47,
                               36,40,

                               "Hand Off Right Inside", /*C*/
                               40,47,
                               36,40,

                               "Hand Off Left Inside",  /*D*/
                               40,47,
                               36,40,

                               "Pitch Left",            /*E*/
                               40,47,
                               36,40,

                               "Pitch Right",           /*F*/
                               40,47,
                               36,40,

                               "Shotgun Pass Regular",  /*10*/
                               40,47,
                               36,40,

                               "Shotgun Pass Drop",     /*11*/
                               40,47,
                               36,40,

                               "Shotgun Roll Out Right",/*12*/
                               40,47,
                               36,40,

                               "Shotgun Roll Out Left",/*13*/
                               40,47,
                               36,40,

                               "Shotgun Hand Off",     /*14*/
                               40,47,
                               36,40,

                               "Shotgun Draw Hand Off",/*15*/
                               40,47,
                               36,40,

                               "Shovel Pass",          /*16*/
                               40,47,
                               36,40,

                               "Roll Out Right",       /*17*/
                               40,47,
                               36,40,

                               "Roll Out Left",        /*18*/
                               40,47,
                               36,40,

                               "Draw Middle",          /*19*/
                               40,47,
                               36,40,

                               "Draw Middle Right",    /*1A*/
                               40,47,
                               36,40,

                               "Play Action Right",    /*1B*/
                               40,47,
                               36,40,

                               "Play Action Left",     /*1C*/
                               40,47,
                               36,40
                              };

static struct ArrowStruct RunBack[] = {
                               "None",	        /*0*/
                               80,50,
                               0,50,

                               "Lead Block",    /*1*/ 
                               48,29,
                               43,26,

                               "Lead Block",    /*2*/
                               64,29,
                               59,26,
                               
                               "Lead Block",    /*3*/
                               48,42,
                               34,37,

                               "Lead Block",	/*4*/
                               40,14,
                               34,11,

                               "Lead Block",    /*5*/
                               32,15,
                               5,12,

                               "Lead Block",	/*6*/
                               48,38,
                               5,35,

                               "Lead Block",	/*7*/
                               16,38,
                               11,35,

                               "Lead Block",	/*8*/
                               80,48,
                               4,45,

                               "Run",	        /*9*/
                               24,43,
                               19,40,

                               "Run",	        /*A*/
                               56,43,
                               4,40,

                               "Run",	        /*B*/
                               24,43,
                               19,40,

                               "Run",	        /*C*/
                               24,43,
                               19,40,

                               "Run",	        /*D*/
                               24,43,
                               19,40,

                               "Run",	        /*E*/
                               24,43,
                               19,40,

                               "Run",	        /*F*/
                               24,43,
                               19,40,

                               "Run",	        /*10*/
                               24,43,
                               19,40,

                               "Lead Block",	/*11*/
                               24,43,
                               19,40,

                               "Lead Block",	/*12*/
                               24,43,
                               19,40,

                               "Lead Block",	/*13*/
                               24,43,
                               19,40,

                               "Lead Block",	/*14*/
                               24,43,
                               19,40,

                               "Lead Block",	/*15*/
                               24,43,
                               19,40,

                               "Lead Block",	/*16*/
                               24,43,
                               19,40,

                               "Lead Block",	/*17*/
                               24,43,
                               19,40,

                               "Lead Block",	/*18*/
                               24,43,
                               19,40,

                               "Run",	/*19*/
                               24,43,
                               19,40,

                               "Run",	/*1A*/
                               24,43,
                               19,40,

                               "Run",	/*1B*/
                               24,43,
                               19,40,

                               "Run",	/*1C*/
                               24,43,
                               19,40,

                               "Run",	/*1D*/
                               24,43,
                               19,40,

                               "Run",	/*1E*/
                               24,43,
                               19,40,

                               "Run",	/*1F*/
                               24,43,
                               19,40,

                               "Run",	/*20*/
                               24,43,
                               19,40,

                               "Draw Run",	/*21*/
                               24,43,
                               19,40,

                               "Shotgun Run Draw",	/*22*/
                               24,43,
                               19,40,

                               "Draw Run Step Right",	/*23*/
                               24,43,
                               19,40,

                               "Draw Run Step Left",	/*24*/
                               24,43,
                               19,40,

                               "Flea Flicker",	/*25*/
                               24,43,
                               19,40,

                               "Lead Block",	/*26*/
                               24,43,
                               19,40,

                               "Lead Block",	/*27*/
                               24,43,
                               19,40,

                               "Lead Block",	/*28*/
                               24,43,
                               19,40,

                               "Lead Block",	/*29*/
                               24,43,
                               19,40,

                               "Lead Block",	/*2A*/
                               24,43,
                               19,40,

                               "Lead Block",	/*2B*/
                               24,43,
                               19,40,

                               "Lead Block",	/*2C*/
                               24,43,
                               19,40,

                               "Lead Block",	/*2D*/
                               24,43,
                               19,40,

                               "Run",	/*2E*/
                               24,43,
                               19,40,

                               "Run",	/*2F*/
                               24,43,
                               19,40,

                               "Run",	/*30*/
                               24,43,
                               19,40,

                               "Run",	/*31*/
                               24,43,
                               19,40,

                               "Run",	/*32*/
                               24,43,
                               19,40,

                               "Run",	/*33*/
                               24,43,
                               19,40,

                               "Run",	/*34*/
                               24,43,
                               19,40,

                               "Run",	/*35*/
                               24,43,
                               19,40,

                               "Lead Block",	/*36*/
                               24,43,
                               19,40,

                               "Lead Block",	/*37*/
                               24,43,
                               19,40,

                               "Lead Block",	/*38*/
                               24,43,
                               19,40,

                               "Lead Block",	/*39*/
                               24,43,
                               19,40,

                               "Lead Block",	/*3A*/
                               24,43,
                               19,40,

                               "Lead Block",	/*3B*/
                               24,43,
                               19,40,

                               "Lead Block",	/*3C*/
                               24,43,
                               19,40,

                               "Lead Block",	/*3D*/
                               24,43,
                               19,40,

                               "Run",	/*3E*/
                               24,43,
                               19,40,

                               "Run",	/*3F*/
                               24,43,
                               19,40,

                               "Run",	/*40*/
                               24,43,
                               19,40,

                               "Run",	/*41*/
                               24,43,
                               19,40,

                               "Run",	/*42*/
                               24,43,
                               19,40,

                               "Run",	/*43*/
                               24,43,
                               19,40,

                               "Run",	/*44*/
                               24,43,
                               19,40,

                               "Run",	/*45*/
                               24,43,
                               19,40,

                               "Pass Block Right",	/*46*/
                               24,43,
                               19,40,

                               "Roll Out Pass Block Right",	/*47*/
                               24,43,
                               19,40,

                               "Pass Block Left",	/*48*/
                               24,43,
                               19,40,

                               "Pass Block Right From Left",	/*49*/
                               24,43,
                               19,40,

                               "Option Pass Right",	/*4A*/
                               24,43,
                               19,40,

                               "Option Pass Left",	/*4B*/
                               24,43,
                               19,40,

                               "Pass Back Right",	/*4C*/
                               24,43,
                               19,40,

                               "Pass Back Left",	/*4D*/
                               24,43,
                               19,40,

                               "Pass Circle Right",	/*4E*/
                               24,43,
                               19,40,

                               "Pass Circle Left",	/*4F*/
                               24,43,
                               19,40,

                               "Play Action Out Right",	/*50*/
                               24,43,
                               19,40,

                               "Play Action Out Left",	/*51*/
                               24,43,
                               19,40,

                               "Flat Right",	/*52*/
                               24,43,
                               19,40,

                               "Flat Left",	/*53*/
                               24,43,
                               19,40,

                               "Screen Right",	/*54*/
                               24,43,
                               19,40,

                               "Screen Left",	/*55*/
                               24,43,
                               19,40,

                               "Flat and Up Right",	/*56*/
                               24,43,
                               19,40,

                               "Flat and Up Left",	/*57*/
                               24,43,
                               19,40

                               };

static struct ArrowStruct LWReceiver[] = {
                               "None",		   /*0*/
                               80,50,
                               0,50,

                               "Rec Post Right 5 ",	   /*1*/
                               72,20,
                               3,17,

                               "Rec Post Right 10",	   /*2*/
                               24,26,
                               17,24,
                               
                               "Rec Post Right 15", /*3*/
                               16,31,
                               4,28,

                               "Rec Post Left 5 ",  /*4*/
                               48,28,
                               4,25,

                               "Rec Post Left 10",   /*5*/
                               48,26,
                               6,22,

                               "Rec Post Left 15",   /*6*/
                               16,36,		  
                               9,32,

                               "Rec Corner Right 5 ",   /*7*/
                               16,36,			   
                               9,32,			   
												   
                               "Rec Corner Right 10",   /*8*/
                               16,36,			   
                               9,32,			   
												   
                               "Rec Corner Right 15",   /*9*/
                               16,36,
                               9,32,

                               "Rec Corner Left 5 ",   /*A*/
                               16,36,		      
                               9,32,		      
											      
                               "Rec Corner Left 10",   /*B*/
                               16,36,		      
                               9,32,		      
											      
                               "Rec Corner Left 15",   /*C*/
                               16,36,
                               9,32,

                               "Rec Cross Right 5",   /*D*/
                               16,36,
                               9,32,

                               "Rec Cross Right 10",   /*E*/
                               16,36,
                               9,32,


                               "Pass Block Right",   /*F*/
                               16,36,
                               9,32,

                               "Pass Block Left",   /*10*/
                               16,36,
                               9,32,

                               "Cross Right 5",   /*11*/
                               16,36,
                               9,32,

                               "Cross Right 10",   /*12*/
                               16,36,
                               9,32,

                               "Cross Left 5",   /*13*/
                               16,36,
                               9,32,

                               "Cross Left 10",   /*14*/
                               16,36,
                               9,32,

                               "Streak",   /*15*/
                               16,36,
                               9,32,

                               "Slant Right",   /*16*/
                               16,36,
                               9,32,

                               "Slant Left",   /*17*/
                               16,36,
                               9,32,
								   
                               "Slant Cross Right 5 ",   /*18*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Cross Right 10",   /*19*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Cross Right 15",   /*1A*/
                               16,36,
                               9,32,

                               "Slant Cross Left 5 ",   /*1B*/
                               16,36,			   
                               9,32,			   
												   
                               "Slant Cross Left 10",   /*1C*/
                               16,36,			   
                               9,32,			   
												   
                               "Slant Cross Left 15",   /*1D*/
                               16,36,
                               9,32,

                               "Slant Corner Right 5 ",   /*1E*/
                               16,36,			     
                               9,32,			     
												     
                               "Slant Corner Right 10",   /*1F*/
                               16,36,			     
                               9,32,			     
												     
                               "Slant Corner Right 15",   /*20*/
                               16,36,
                               9,32,

                               "Slant Corner Left 5 ",   /*21*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Corner Left 10",   /*22*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Corner Left 15",   /*23*/
                               16,36,
                               9,32,

                               "Chair Right 5 ",   /*24*/
                               16,36,	      
                               9,32,	      
										      
                               "Chair Right 10",   /*25*/
                               16,36,	      
                               9,32,	      
										      
                               "Chair Right 15",   /*26*/
                               16,36,
                               9,32,

                               "Chair Left 5 ",   /*27*/
                               16,36,	     
                               9,32,	     
										     
                               "Chair Left 10",   /*28*/
                               16,36,	     
                               9,32,	     
										     
                               "Chair Left 15",   /*29*/
                               16,36,
                               9,32,

                               "Hook Right 5 ",   /*2A*/
                               16,36,	     
                               9,32,	     
										     
                               "Hook Right 10",   /*2B*/
                               16,36,	     
                               9,32,	     
										     
                               "Hook Right 15",   /*2C*/
                               16,36,
                               9,32,

                               "Hook Left 5 ",   /*2D*/
                               16,36,	    
                               9,32,	    
										    
                               "Hook Left 10",   /*2E*/
                               16,36,	    
                               9,32,	    
										    
                               "Hook Left 15",   /*2F*/
                               16,36,
                               9,32,

                               "Post Corner Right 5 ",   /*30*/
                               16,36,			    
                               9,32,			    
												    
                               "Post Corner Right 10",   /*31*/
                               16,36,			    
                               9,32,			    
												    
                               "Post Corner Right 15",   /*32*/
                               16,36,
                               9,32,

                               "Post Corner Left 5 ",   /*33*/
                               16,36,			   
                               9,32,			   
												   
                               "Post Corner Left 10",   /*34*/
                               16,36,			   
                               9,32,			   
												   
                               "Post Corner Left 15",   /*35*/
                               16,36,
                               9,32,

                               "Run Block Left",   /*36*/
                               16,36,
                               9,32,

                               "Run Block Right",   /*37*/
                               16,36,
                               9,32,

                               "Crack Back Right",   /*38*/
                               16,36,
                               9,32,

                               "Crack Back Left",   /*39*/
                               16,36,
                               9,32,

                               "Reverse Left",   /*3A*/
                               16,36,
                               9,32,

                               "Reverse Right",   /*3B*/
                               16,36,
                               9,32,

                               "Shovel Pass",   /*3C*/
                               16,36,
                               9,32,

                               "Screen Left",   /*3D*/
                               16,36,
                               9,32,

                               "Screen Right",   /*3E*/
                               16,36,
                               9,32
                               };


static struct ArrowStruct RReceiver[] = {
                               "None",		   /*0*/
                               80,50,
                               0,50,

                               "Rec Post Right 5 ",	   /*1*/
                               24,41,
                               15,35,

                               "Rec Post Right 10",	   /*2*/
                               24,30,
                               19,25,
                               
                               "Rec Post Right 15", /*3*/
                               16,34,
                               10,30,

                               "Rec Post Left 5 ",  /*4*/
                               56,26,
                               50,23,

                               "Rec Post Left 10",   /*5*/
                               24,23,
                               8,18,

                               "Rec Post Left 15",   /*6*/
                               32,30,		  
                               25,25,

                               "Rec Corner Right 5 ",   /*7*/
                               16,35,			   
                               7,31,			   
												   
                               "Rec Corner Right 10",   /*8*/
                               16,36,			   
                               9,32,			   
												   
                               "Rec Corner Right 15",   /*9*/
                               16,36,
                               9,32,

                               "Rec Corner Left 5 ",   /*A*/
                               16,36,		      
                               9,32,		      
											      
                               "Rec Corner Left 10",   /*B*/
                               16,36,		      
                               9,32,		      
											      
                               "Rec Corner Left 15",   /*C*/
                               16,36,
                               9,32,

                               "Rec Cross Right 5",   /*D*/
                               16,36,
                               9,32,

                               "Rec Cross Right 10",   /*E*/
                               16,36,
                               9,32,


                               "Pass Block Right",   /*F*/
                               16,36,
                               9,32,

                               "Pass Block Left",   /*10*/
                               16,36,
                               9,32,

                               "Cross Right 5",   /*11*/
                               16,36,
                               9,32,

                               "Cross Right 10",   /*12*/
                               16,36,
                               9,32,

                               "Cross Left 5",   /*13*/
                               16,36,
                               9,32,

                               "Cross Left 10",   /*14*/
                               16,36,
                               9,32,

                               "Streak",   /*15*/
                               16,36,
                               9,32,

                               "Slant Right",   /*16*/
                               16,36,
                               9,32,

                               "Slant Left",   /*17*/
                               16,36,
                               9,32,
								   
                               "Slant Cross Right 5 ",   /*18*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Cross Right 10",   /*19*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Cross Right 15",   /*1A*/
                               16,36,
                               9,32,

                               "Slant Cross Left 5 ",   /*1B*/
                               16,36,			   
                               9,32,			   
												   
                               "Slant Cross Left 10",   /*1C*/
                               16,36,			   
                               9,32,			   
												   
                               "Slant Cross Left 15",   /*1D*/
                               16,36,
                               9,32,

                               "Slant Corner Right 5 ",   /*1E*/
                               16,36,			     
                               9,32,			     
												     
                               "Slant Corner Right 10",   /*1F*/
                               16,36,			     
                               9,32,			     
												     
                               "Slant Corner Right 15",   /*20*/
                               16,36,
                               9,32,

                               "Slant Corner Left 5 ",   /*21*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Corner Left 10",   /*22*/
                               16,36,			    
                               9,32,			    
												    
                               "Slant Corner Left 15",   /*23*/
                               16,36,
                               9,32,

                               "Chair Right 5 ",   /*24*/
                               16,36,	      
                               9,32,	      
										      
                               "Chair Right 10",   /*25*/
                               16,36,	      
                               9,32,	      
										      
                               "Chair Right 15",   /*26*/
                               16,36,
                               9,32,

                               "Chair Left 5 ",   /*27*/
                               16,36,	     
                               9,32,	     
										     
                               "Chair Left 10",   /*28*/
                               16,36,	     
                               9,32,	     
										     
                               "Chair Left 15",   /*29*/
                               16,36,
                               9,32,

                               "Hook Right 5 ",   /*2A*/
                               16,36,	     
                               9,32,	     
										     
                               "Hook Right 10",   /*2B*/
                               16,36,	     
                               9,32,	     
										     
                               "Hook Right 15",   /*2C*/
                               16,36,
                               9,32,

                               "Hook Left 5 ",   /*2D*/
                               16,36,	    
                               9,32,	    
										    
                               "Hook Left 10",   /*2E*/
                               16,36,	    
                               9,32,	    
										    
                               "Hook Left 15",   /*2F*/
                               16,36,
                               9,32,

                               "Post Corner Right 5 ",   /*30*/
                               16,36,			    
                               9,32,			    
												    
                               "Post Corner Right 10",   /*31*/
                               16,36,			    
                               9,32,			    
												    
                               "Post Corner Right 15",   /*32*/
                               16,36,
                               9,32,

                               "Post Corner Left 5 ",   /*33*/
                               16,36,			   
                               9,32,			   
												   
                               "Post Corner Left 10",   /*34*/
                               16,36,			   
                               9,32,			   
												   
                               "Post Corner Left 15",   /*35*/
                               16,36,
                               9,32,

                               "Run Block Left",   /*36*/
                               16,36,
                               9,32,

                               "Run Block Right",   /*37*/
                               16,36,
                               9,32,

                               "Crack Back Right",   /*38*/
                               16,36,
                               9,32,

                               "Crack Back Left",   /*39*/
                               16,36,
                               9,32,

                               "Reverse Left",   /*3A*/
                               16,36,
                               9,32,

                               "Reverse Right",   /*3B*/
                               16,36,
                               9,32,

                               "Shovel Pass",   /*3C*/
                               16,36,
                               9,32,

                               "Screen Left",   /*3D*/
                               16,36,
                               9,32,

                               "Screen Right",   /*3E*/
                               16,36,
                               9,32
                               };

/************************END OF FILE PLEDDATA.H****************************/

