/***********************************************************************
*pledshl.c                                                             *
*Shell-play edit function                                              *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbequ.h"
#include "fbram.h"
#include "pledshl.h"
#include "psxpad.h"

#include "fbplays.h"

#include "arrows.h"
#include "fbgequ.h"
#include "fbforms.h"
#include "shell.h"
#include "editplay.h"
#include "menu.h"
#include "movie.h"
#include "fbmenu.h"
#include "editdat.h"


#define BACK_CEL	(Uint32 *)0x200000
#define BACK_MAP	(Uint32 *)0x200004

#define BACK_PAL	(Uint32 *)0x200008

#define	OFFSCREEN	600					// Used to move polys out of visible screen area
#define	YESNO_X		30					// Base position of YesNo menu
#define	YESNO_Y		120
#define	FILEPANEL_Y		50				// Base Y pos for file panels
#define	FNAME_Y		(FILEPANEL_Y-4)	// Base Y position for filenames
#define	FNAME_X		162					// Base X position for filenames
#define MENU_Y_SPACING	10				// Spacing between ascii strings
#define PLAYNAME_X	FNAME_X+178		// Base X pos of playnames in saved play files
#define	PLAYNAME_Y	FNAME_Y

#define	CROSS_X		68
#define	TRIANGLE_X	(CROSS_X+100)
#define	SQUARE_X	(CROSS_X+200)
#define	CIRCLE_X	(CROSS_X+300)
#define	BUTTONS_Y	210

#define	PROMPTSTR1_X	160
#define	PROMPTSTR1_Y	20

#define RandomNUM(num) (GetRandom((int)num))

#define	EDITPANEL1		0	// Template 2 items
#define	EDITPANEL2		1	// Template 2 items
#define	CROSS_POLY		2	// Template 2 items
#define	TRIANGLE_POLY	3	// Template 2 items
#define	SQUARE_POLY		4	// Template 2 items
#define	CIRCLE_POLY		5	// Template 2 items
#define	YESNOWIN		6	// Template 2 items

#define	ASCIIPANEL	0	// Template 3 items
#define	RFIELD		1

#define	LFIELD		0	// Template 5 items

#define	PEXOFF	-134	// X base offset for drawing playeditor sprites
#define	GRID_X	196
#define	GRID_Y	FILEPANEL_Y-4


#define	MAX_LINES	14

//*************************

typedef     Sint16      ANGLE ;

#define     DEGtoANG(d)         ((ANGLE)((65536.0 * (d)) / 360.0))


extern Uint16 PLAYERS_width[];
extern Uint16 PLAYERS_ISlot[];
extern Uint8 FORMS_arrowX[][7];
extern Uint8 FORMS_arrowY[][7];
extern Uint8 FORMS_RUNBCscripts[][6];
extern Uint8 FORMS_RUNNONscripts[][6];
extern Uint16 FORMS_PASSscripts[][6];
extern Sint8 ARROWS_offsets[][2];
extern Uint16 ARROWS_width[];
extern Uint16 ARROWS_height[];
extern SCRIPT pEDIT_Scripts[];
extern Uint16 pEDIT_QBScriptFIND[];
extern PBLOCK pEDIT_Blocks[];
extern OLSCRIPT pEDIT_OLScripts[];
extern PBLOCK pEDIT_OLBlocks[];
extern Uint8 *ArrowNames[];
extern char *Sprite_FormNames[];
extern int Sprite_FormBits[];
extern int SpriteIS_FormBits[];
extern char *Arrow_Cluts[];
extern char ColorConvert[];

/*used in display for picture flipping*/

extern  char *TemplateBuff;
extern	memfile_t MemFile[16];
extern  struct play ThePlays[];
extern	void String2SJIS (unsigned char *string, unsigned short *sjis);
extern	void SJISString2ASCII (unsigned short *string, unsigned char *ascii);
extern	char ReadPlayHeader(unsigned short *buffer, char port, char bank, char *file);
extern  void CREATEoEditPlays(Uint16 team);
extern  void ClearYesNo(void);
extern	void SetEditedFlag(int tm);

/* Prototypes for functions in this module */

void SetStringXY(int string_num, int x, int y);
void InitPlayEditor(void);
int ProcPlayEditor(void);
void HideEditor(void);
void ShowEditor(void);
void HideFileMenu(void);
void ShowFileMenu(void);
int BackUpWrite(char *fname, char *comment,	void *data, long size, char exists);
int BackUpRead(char *fname, void *buffer);
void ClearPlayNames(void);
void ClearAllPlays(void);
void Toupper(char *string);
void CircleMsg(char *msg);
void SquareMsg(char *msg);
int GetUniqueFnum(void);
void GetPlayEditFiles(void);

/*multifile pointers*/

//tom declared in shell.c now //unsigned long *Shell_MFile;
//MultiFile_t *Arrows_MFile;		// tom
extern unsigned long *Arrows_MFile;

static int PromptStr1, PromptStr2, PromptStr3;	/*pointers to the strings*/
static int TextStr, MenuStr[2],AsciiCharStr;
static int CrossStr,TriangleStr,SquareStr,CircleStr;
static int Questions[2];
static char ArrowNameText[MAXPATH]; /*arrow name text*/
static int CrossPtr, CirclePtr, SquarePtr, TrianglePtr, CtrlPtr;
static int PriorityLevel;
static int CursorTable[]={9,9,9,9,9,9,8};
static int Lines[32];


extern Sint16 CardSlot;
extern Sint16 NumStrings;

int YesnoPos[2]={ YESNO_X, YESNO_X+60};
int YNBox;	// Handle of Yes No dialog box
int AscBox;	// Handle of ascii panel dialog box

//void BuildPlayBitmap(Sint16 template, Sint16 polynum, int playnum);
//void CPUDraw(Uint16 player, Sint16 template_index, Sint16 polynum, Sint16 w, Sint16 h, Sint16 posx, Sint16 posy, char *string, Uint16 flip, char colflag);
//void LoadARROW(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr);
//void LoadPLAYER(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr);


int Paint_PLED_Screen(void);
int CleanUp_PLED(void);
int Shell_Frame_PLED(void);
int UpdateStrings(void);
int UpdateBitmaps(void);

void PrintCenterWText(int id, Sint16 y, char* string);
void PrintWIDEText(int id, char* string);
void InitCreate(void);
void InitName(Uint16 pos);
void ClearAsciiPanel(void);
int  InitFile(Uint8 flag);

memfile_t PE_MemFile[16];

char Files[15][64];			// Hold descriptive strings (parallel with MemFile array)
char LINES_TXT[50 + 24][16];
Uint8 LINES_FLAG[50 + 24];


char *Workbuffer;
Sint32  GridX = GRID_X;
Sint32  GridY = GRID_Y;


Sint8 Jpad2Dir[] = { -1, 0, 3, -1, 1, -1,-1,-1, 2, -1,-1,-1,-1,-1,-1,-1 };

typedef struct {
	Uint16 X;
	Uint16 Y;
	Uint16 Width;
	Uint16 Offset;
	char *Text;
	Uint16 Dir[4];
} NAMEGRID;

Uint32 GridStr[39];

NAMEGRID pEDIT_NAME[] = {		  // U * D * L * R
	 (0*20)+0,  0*16,   2,  88, "A",   35,  7,  6,  1,
	 (1*20)+0,  0*16,   2,  90, "B",   36,  8,  0,  2,
	 (2*20)+0,  0*16,   2,  92, "C",   36,  9,  1,  3,
	 (3*20)+0,  0*16,   2,  94, "D",   37, 10,  2,  4,
	 (4*20)+0,  0*16,   2,  96, "E",   37, 11,  3,  5,
	 (5*20)+0,  0*16,   2,  98, "F",   38, 12,  4,  6,
	 (6*20)+0,  0*16,   2, 100, "G",   38, 13,  5,  0,
	 (0*20)+0,  1*16,   2, 102, "H",    0, 14, 13,  8,
	 (1*20)+4,  1*16,   2, 104, "I",    1, 15,  7,  9,
	 (2*20)+0,  1*16,   2, 106, "J",    2, 16,  8, 10,
	 (3*20)+0,  1*16,   2, 108, "K",    3, 17,  9, 11,
	 (4*20)+0,  1*16,   2, 110, "L",    4, 18, 10, 12,
	 (5*20)+0,  1*16,   2, 112, "M",    5, 19, 11, 13,
	 (6*20)+0,  1*16,   2, 114, "N",    6, 20, 12,  7,
	 (0*20)+0,  2*16,   2, 116, "O",    7, 21, 20, 15,
	 (1*20)+0,  2*16,   2, 118, "P",    8, 22, 14, 16,
	 (2*20)+0,  2*16,   2, 120, "Q",	 9, 23, 15, 17,
	 (3*20)+0,  2*16,   2, 122, "R",   10, 24, 16, 18,
	 (4*20)+0,  2*16,   2, 124, "S",	11, 25, 17, 19,
	 (5*20)+0,  2*16,   2, 126, "T",	12, 26, 18, 20,
	 (6*20)+0,  2*16,   2, 128, "U",	13, 27, 19, 14,
	 (0*20)+0,  3*16,   2, 130, "V",	14, 28, 27, 22,
	 (1*20)+0,  3*16,   2, 132, "W",	15, 29, 21, 23,
	 (2*20)+0,  3*16,   2, 134, "X",	16, 30, 22, 24,
	 (3*20)+0,  3*16,   2, 136, "Y",	17, 31, 23, 25,
	 (4*20)-2,  3*16,   2, 138, "Z",	18, 32, 24, 26,
	 (5*20)+0,  3*16,   2, 140, "0",	19, 33, 25, 27,
	 (6*20)+4,  3*16,   2, 142, "1",	20, 34, 26, 21,
	 (0*20)+0,  4*16,   2, 144, "2",	21, 35, 34, 29,
	 (1*20)+0,  4*16,   2, 146, "3",   22, 36, 28, 30,
	 (2*20)+0,  4*16,   2, 148, "4",	23, 36, 29, 31,
	 (3*20)+0,  4*16,   2, 150, "5",	24, 37, 30, 32,
	 (4*20)+0,  4*16,   2, 152, "6",	25, 37, 31, 33,
	 (5*20)+0,  4*16,   2, 154, "7",	26, 38, 32, 34,
	 (6*20)+0,  4*16,   2, 156, "8",	27, 38, 33, 28,
	 (0*20)+0,  5*16,   2, 158, "9",   28,  0, 38, 36,
	 (1*20)+0,  5*16,   6, 160, "spc", 29,  1, 35, 37,
	 (3*20)+0,  5*16,   6, 166, "del", 31,  3, 36, 38,
	 (5*20)+0,  5*16,   6, 172, "end", 33,  5, 37, 35
};

char TheNAME_TXT[20];


char *FORMS_TXT[] = {
	"Goalline",
	"Goalline No WR",
	"Goalline Wishbone",
	"Shifted I",
	"Shifted I Weak",
	"I Slot",
	"Single Back",
	"H Back",
	"I Form",
	"Proset",
	"West Coast",
	"Shotgun",
	"Shotgun TE",
	"Trips",
	"Run and Shoot"
};

char *FORMS_PLAYERSLOT[][6] = {
	"QB"		,"RR"		,"LTE"	,"RTE" 	,"FB"		,"HB",
	"QB"		,"TE3"	,"LTE"	,"RTE" 	,"FB"		,"HB",
	"QB"		,"RTE"	,"LR"		,"LHB" 	,"FB"		,"RHB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"FB"		,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"FB"		,"HB",
	"QB"		,"LSLOT"	,"LR"		,"RTE" 	,"FB"		,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"LTE" 	,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"HBACK"	,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"FB"		,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"FB"		,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"RSLOT"	,"HB",
	"QB"		,"RR"		,"LR"		,"RSLOT"	,"LSLOT"	,"HB",
	"QB"		,"RR"		,"LR"		,"RTE" 	,"LSLOT"	,"HB",
	"QB"		,"RR"		,"LR"		,"RSLOT"	,"RSLOT"	,"HB",
	"QB"		,"RR"		,"LR"		,"RSLOT"	,"LSLOT"	,"HB"
};

Uint16 FORMS_toAI[] = {
	GOAL_LINE_FORM_NUM,
	GOAL_LINE_NO_WR_FORM_NUM,
	WISH_BONE_FORM_NUM,
	NEAR_FAR_FORM_NUM,
	FAR_FORM_NUM,
	I_SLOT_FORM_NUM,
	SINGLE_BACK_FORM_NUM,
	H_BACK_FORM_NUM,
	I_FORM_FORM_NUM,
	PROSET_FORM_NUM,
	WEST_COAST_FORM_NUM,
	SHOTGUN_FORM_NUM,
	SHOTGUN_TE_FORM_NUM,
	TRIPS_FORM_NUM,
	RUN_SHOOT_FORM_NUM
};


char PLAYERSLOTa_TXT[] = "( Choose ";
char PLAYERSLOTb_TXT[] = " Route )";
char ThePLAYERSLOT_TXT[22];


Uint16 PlayInitNUM_Run[] = {
	SetFakeReceivers23145NUM,
	SetFakeReceivers24135NUM,
	SetFakeReceivers25134NUM,

	SetFakeReceivers21345NUM
};

Uint16 PlayInitNUM[] = {
	0,0, SetReceivers231453NUM, SetReceivers241354NUM, SetReceivers251345NUM
};
Uint16 PlayInitNUM_ISlot[] = {
	SetReceivers213451NUM, 0,0, SetReceivers243152NUM, SetReceivers253143NUM
};

extern PLAYEDIT pEDIT_ThePLAY;
extern PLAYEDIT pEDIT_PLAYS[48];
//PLAYEDIT pEDIT_ThePLAY;
//PLAYEDIT pEDIT_PLAYS[(48)];
//PLAYEDIT *pEDIT_PLAYS;

Uint16 pEDIT_PLAYnum;
Uint16 pEDIT_PLAYpos;

Sint16 pEDIT_CreateEdit;
Sint16 pEDIT_Doing;
Uint16 pEDIT_RunPass;
Uint16 pEDIT_Return;
Uint16 pEDIT_Display;

Sint16 pEDIT_step;
Sint16 pEDIT_player;
Uint16 pEDIT_ISplayer;
Uint16 pEDIT_script;
Uint16 pEDIT_scriptOld;
Uint16 pEDIT_OLblock;

Uint16 pEDIT_FILES;
Sint16 pEDIT_FILEnum;
Sint16 pEDIT_FILEedit;

Uint16 pEDIT_FLASH;
Uint16 pEDIT_GRID;
Uint16 pEDIT_GRIDpos;
Sint16 pEDIT_LINE;
Uint16 pEDIT_LINEpos;
Uint16 pEDIT_LINEedit;
Uint16 pEDIT_LINEyes;

Sint32 OptFlag;
Sint32 EditPad;
Sint32 EditPadData;

Sint32 CardBank;
Sint32 CardPort;

/******************************************************
Displays the play editor screen
*******************************************************/

int Display_Play_Editor_Shell(int WhichPad)
{
	Sint16 x=0;
	Sint32 retcode = 0;

	DumpAllocLoc();

	FlushPads();

	EditPad = WhichPad;

	OptFlag = FALSE;

	Workbuffer = (char *)AllocMem( (sizeof(PLAYEDIT)*24) + (24 * 14) + 128); // Extra 128 bytes due to BUPRam being read in 128 byte blocks

	InitPlayEditor();

	for (x=0; x < (sizeof(PLAYEDIT)*24)+(24*14); x++) *(Workbuffer+x)=0;
	for (x=0; x < 24; x++) pEDIT_PLAYS[x].Formation = -1;

	MovieClear = 0;			// Don't clear at end of movie

	for(x=0; x<4 ;x++)
	{
	  	InitFrame();
		UpdateBackground();
		DisplayShellPolys();
		DisplayAllStrings();
		ShowFrame();
	}

	for(x=0; x<4 ;x++)
	{
	  	InitFrame();
		UpdateBackground();
		DisplayShellPolys();
		DisplayAllStrings();
		ShowFrame();
	}

	CardBank = GetPadPortBank(EditPad);
	CardPort = CardBank >> 8;
	CardBank &= 0xFF;

retry:
	EditPadData = 0;		// Clear button press to ensure the while loop is entered

	CardSlot = -1;

	if(CheckCard(CardPort, CardBank)) CardSlot = CardBank;

	while((CardSlot < 0) && !(EditPadData & JPADx) && !(EditPadData & JPADtriangle))
	{
		if(CheckCard(CardPort, CardBank)) CardSlot = CardBank;

		PrintCenterWText(PromptStr1, 44, MEMCARD_MSG);
		PrintCenterWText(PromptStr2, 44, "if you want to save edited plays");

		for(x=0; x<3; x++)
			DoFrameLoop(1, Shell_Frame_PLED);	// Do 3 frames to ensure joypad reads correctly

		EditPadData = JpadTrig[EditPad];
	}

	PrintCenterWText(PromptStr2, 44, BLANK_PROMPT);	// Clear text in 2nd prompt

// Clear all strings off screen

	for(x=0; x<NumStrings; x++)
			ChangeStringXY(strings.string[x], 513, 0);
//

	if(CardSlot >= 0)
	{
		retcode = ProcPlayEditor();

		if(retcode < 0) goto retry;
	}

	FreeMem(Workbuffer);

	LoadingMessage();

	CleanUp_PLED();
}

/* MOVE POINTER OR CHANGE SCRIPT */

Sint16 MoveChange(Sint16 what, Uint16 min, Uint16 max)
{

	if(EditPadData & JPADLleft)
	{
		what--;	if(what < min) what = max - 1;
		PlayEffect(CURSOR_SFX);
	}
	if(EditPadData & JPADLright)
	{
		what++;	if(what == max) what = min;
		PlayEffect(CURSOR_SFX);
	}

	return what;
}


/* DISPLAY AN ARROW */

void DisplayARROW(Uint16 player)
{
	Sint16 bitmap = pEDIT_ThePLAY.Bitmap[player];
	Uint32 *clut;
	char string[14];
	Sint16 posx, posy;
	Sint16 offset;
	Uint16 flip = bitmap & 0x8000;
	bitmap &= 0x7fff;


	clut = (Uint32 *)GetMultiFilePtr(Shell_MFile, Arrow_Cluts[pEDIT_ThePLAY.Color[player]]);

	ChangePoly4CLUT(ARROWS_TEMPLATE, player, clut);

	posx = FORMS_arrowX[pEDIT_ThePLAY.Formation][player];
	posy = FORMS_arrowY[pEDIT_ThePLAY.Formation][player];

	offset = ARROWS_offsets[bitmap][0];

	if(!flip)
	{
		 posx -= offset;

	}
	else
	{
		offset -= ARROWS_width[bitmap] - PLAYERS_width[player];
		posx += offset;
	}

	posy -= ARROWS_offsets[bitmap][1];

	pEDIT_ThePLAY.ARROWposX[player] = posx;
	pEDIT_ThePLAY.ARROWposY[player] = posy;

	strcpy(string,ArrowNames[bitmap]);

	strcat(string, ".CMP");

	template[ARROWS_TEMPLATE].depth[player] = PriorityLevel--;

	ChangePolyUV(&template[ARROWS_TEMPLATE].poly[player],
                   ARROWS_width[bitmap]-1,
                   ARROWS_height[bitmap]);

	ChangeABSPolyWH(&template[ARROWS_TEMPLATE].poly[player],(ARROWS_width[bitmap]-1)*2, (ARROWS_height[bitmap]-1)*2);

	ChangePolyCmpTextureNOCLT(ARROWS_TEMPLATE, player , string);

	MovePolyToXY(&template[ARROWS_TEMPLATE].poly[player],
                   (PEXOFF)+(posx*2),
                   -64+(posy * 2));

	template[ARROWS_TEMPLATE].action[player] |= DISPLAY; /*activate arrows*/

	if(flip) FlipPolyX(&template[ARROWS_TEMPLATE].poly[player]);


//	LoadARROW(player, SCREEN_TEMPLATE5, 1);
}


/* DISPLAY THE PLAYER SYMBOL */

void DisplayPLAYER(Uint16 player)
{
	char string[14];

	Uint16 posx = FORMS_arrowX[pEDIT_ThePLAY.Formation][player];
	Uint16 posy = FORMS_arrowY[pEDIT_ThePLAY.Formation][player];

	pEDIT_ThePLAY.FORMposX[player] = posx;
	pEDIT_ThePLAY.FORMposY[player] = posy;

	if(player == 6) pEDIT_ThePLAY.FORMposY[player]--;

	if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
		sprintf(string, Sprite_FormNames[SpriteIS_FormBits[player]]);
	else
		sprintf(string, Sprite_FormNames[Sprite_FormBits[player]]);

	strcat(string, ".CMP");

	template[SCREEN_TEMPLATE].depth[player] = PriorityLevel--;

	ChangePolyCmpTexture(SCREEN_TEMPLATE, player , string);

	MovePolyToXY(&template[SCREEN_TEMPLATE].poly[player],
                   PEXOFF+(posx * 2),
                   -66+(posy * 2));

//	LoadPLAYER(player, SCREEN_TEMPLATE5, 1);
}


/* DISPLAY THE PLAYER SLOT INFO */

void DisplayPLAYERSLOT(void)
{

	strcpy(ThePLAYERSLOT_TXT, PLAYERSLOTa_TXT);
	strcat(ThePLAYERSLOT_TXT,
		FORMS_PLAYERSLOT[pEDIT_ThePLAY.Formation][pEDIT_player]);
	strcat(ThePLAYERSLOT_TXT, PLAYERSLOTb_TXT);

	PrintCenterWText( PromptStr1, 44, ThePLAYERSLOT_TXT);

}



/* UPDATE TEXT LINES */

void UpdateLines(Uint16 posx, Uint16 *posy, Uint16 offset, Uint16 max)
{
	Uint16 count;

	Uint16 update = pEDIT_LINEpos & 0x8000;

	Uint16 line = 0;

	if(offset)
	{
		line = MAX_LINES;
	}

	pEDIT_LINEpos &= 0x7FFF;

	if(update && pEDIT_LINEpos && pEDIT_LINEpos == (max - (MAX_LINES-1))) pEDIT_LINEpos--;

	offset += pEDIT_LINEpos;

	pEDIT_FLASH++;	pEDIT_FLASH &= 0x0F;

	for(count = 0; count < max; count++)
	{
		if(count == MAX_LINES) break;

		if(update)
		{
			PrintWIDEText(Lines[ line + count] , LINES_TXT[offset + count]);
		}
		else
		{
			if(pEDIT_LINE-pEDIT_LINEpos == count)
			{
				if(pEDIT_FLASH & 0x08)
					ChangeStringCLUT(strings.string[Lines[line + count]], FontClutIDs[PEN_DKYELLOW]->CLUT_ID);
				else
					ChangeStringCLUT(strings.string[Lines[line + count]], FontClutIDs[PEN_YELLOW]->CLUT_ID);
			}
			else
				if((LINES_FLAG[line + count] & 0x7F) || offset >= 50)
					ChangeStringCLUT(strings.string[Lines[line + count]], FontClutIDs[PEN_WHITE]->CLUT_ID);
				else
					ChangeStringCLUT(strings.string[Lines[line + count]], FontClutIDs[PEN_GREY]->CLUT_ID);

			SetStringXY(Lines[line + count], posx, posy[count]);
		}
	}

	for(;count < MAX_LINES;count++)
		SetStringXY(Lines[line + count], OFFSCREEN, OFFSCREEN);
//		SetStringXY(Lines[offset + count], OFFSCREEN, OFFSCREEN);

}


/* MOVE POINTER */

void MoveLines(Uint16 offset, Uint16 max)
{
	Sint16 oldline = pEDIT_LINE;
	Sint16 line = pEDIT_LINE-(pEDIT_LINEpos & 0x7fff);
	Uint16 linepos = pEDIT_LINEpos;

	Sint16 linelook;

	if(EditPadData & JPADLup)
	{
		if(!line)
		{
			if(linepos) linepos--;
		}
		else line--;

		pEDIT_FLASH = 0;
		linepos|=0x8000;
	}

	if(EditPadData & JPADLdown)
	{
		if((linepos+line) < max-1)
		{
			if(line < MAX_LINES-1)
			{
				line++;
			}
			else linepos++;
		}

		pEDIT_FLASH = 0;
		linepos|=0x8000;
	}


	pEDIT_LINE = line+(linepos & 0x7fff);
	pEDIT_LINEpos = linepos;

	if(oldline != pEDIT_LINE) PlayEffect(CURSOR_SFX);
}



void MoveMenuLines(Uint16 offset, Uint16 max)
{
	Sint16 line = pEDIT_LINE;
	Sint16 oldline = pEDIT_LINE;
	Uint16 linepos = pEDIT_LINEpos;

	Sint16 linelook;

	pEDIT_FLASH++;
	pEDIT_FLASH&=0x0F;

	if(EditPadData & JPADLup)
	{
		line--;	if(line < 0) line = 0;

		if(max > MAX_LINES && linepos && line < linepos + 1)
		{
			linepos--;	linepos |= 0x8000;
		}

//		linelook = line;	line++;
//
//		while(!(LINES_FLAG[offset + linelook] & 0x7F))
//		{
//			linelook--;	if(linelook < 0) break;
//
//			if(max > 16 && linepos && line < linepos + 1)
//			{
//				linepos--;	linepos |= 0x8000;
//			}
//		}
//
//		if(linelook >= 0) line = linelook;

		pEDIT_LINE = line;
		pEDIT_LINEpos = linepos;
	}

	if(EditPadData & JPADLdown)
	{
		line++;	if(line == max) line = max - 1;

		if(max > MAX_LINES && line > linepos + 14 && line < (max - 1))
		{
			linepos++;	linepos |= 0x8000;
		}

//		linelook = line;	line--;
//
//		while(!(LINES_FLAG[offset + linelook] & 0x7F))
//		{
//			linelook++;	if(linelook == max) break;
//
//			if(max > 16 && line > linepos + 14 && line < (max - 1))
//			{
//				linepos++;	linepos |= 0x8000;
//			}
//		}
//
//		if(linelook < max) line = linelook;

		pEDIT_LINE = line;
		pEDIT_LINEpos = linepos;
	}

	if(oldline != line) PlayEffect(CURSOR_SFX);
}


/* TRANSFER PLAY BETWEEN EDIT AND STORE */

/* COPY EDIT PLAY TO STORE */

void PushPLAY(Uint16 play)
{
	Uint16 count;

	Uint8 *from	= (Uint8 *)&pEDIT_ThePLAY.ThePlay;
	Uint8 *to	= (Uint8 *)&pEDIT_PLAYS[play].ThePlay;

	pEDIT_PLAYS[play].Formation	= pEDIT_ThePLAY.Formation;
	pEDIT_PLAYS[play].BallCarrier	= pEDIT_ThePLAY.BallCarrier;
	pEDIT_PLAYS[play].Third			= pEDIT_ThePLAY.Third;

	strcpy(pEDIT_PLAYS[play].Name, pEDIT_ThePLAY.Name);

	for(count = 0; count < sizeof(struct play); count++) *to++ = *from++;

	for(count = 0; count < 7; count++)
	{
		pEDIT_PLAYS[play].Block[count]		= pEDIT_ThePLAY.Block[count];
		pEDIT_PLAYS[play].Script[count]		= pEDIT_ThePLAY.Script[count];

		pEDIT_PLAYS[play].Bitmap[count]		= pEDIT_ThePLAY.Bitmap[count];
		pEDIT_PLAYS[play].Color[count]		= pEDIT_ThePLAY.Color[count];

		pEDIT_PLAYS[play].ARROWposX[count]	= pEDIT_ThePLAY.ARROWposX[count];
		pEDIT_PLAYS[play].ARROWposY[count]	= pEDIT_ThePLAY.ARROWposY[count];
		pEDIT_PLAYS[play].FORMposX[count]	= pEDIT_ThePLAY.FORMposX[count];
		pEDIT_PLAYS[play].FORMposY[count]	= pEDIT_ThePLAY.FORMposY[count];
	}
}

/* COPY STORE PLAY TO EDIT */

void PopPLAY(Uint16 play)
{
	Uint16 count;

	Uint8 *from	= (Uint8 *)&pEDIT_PLAYS[play].ThePlay;
	Uint8 *to	= (Uint8 *)&pEDIT_ThePLAY.ThePlay;


	pEDIT_ThePLAY.Formation		= pEDIT_PLAYS[play].Formation;
	pEDIT_ThePLAY.BallCarrier	= pEDIT_PLAYS[play].BallCarrier;
	pEDIT_ThePLAY.Third			= pEDIT_PLAYS[play].Third;

	strcpy(pEDIT_ThePLAY.Name, pEDIT_PLAYS[play].Name);

	for(count = 0; count < sizeof(struct play); count++) *to++ = *from++;

	for(count = 0; count < 7; count++)
	{
		pEDIT_ThePLAY.Block[count]			= pEDIT_PLAYS[play].Block[count];
		pEDIT_ThePLAY.Script[count]		= pEDIT_PLAYS[play].Script[count];

		pEDIT_ThePLAY.Bitmap[count]		= pEDIT_PLAYS[play].Bitmap[count];
		pEDIT_ThePLAY.Color[count]			= pEDIT_PLAYS[play].Color[count];

		pEDIT_ThePLAY.ARROWposX[count]	= pEDIT_PLAYS[play].ARROWposX[count];
		pEDIT_ThePLAY.ARROWposY[count]	= pEDIT_PLAYS[play].ARROWposY[count];
		pEDIT_ThePLAY.FORMposX[count]		= pEDIT_PLAYS[play].FORMposX[count];
		pEDIT_ThePLAY.FORMposY[count]		= pEDIT_PLAYS[play].FORMposY[count];
	}
}


/* UPDATE THE FILE TEXT */

void UpdateFILEs(void)
{
	Uint16 count,i;

	for(count = 0; count < pEDIT_FILES; count++)
	{
		Uint16 view = 7;

		if(count == 16)
		{
//			PrintCenterWText(Lines[count - 1], 22, ")");
			break;
		}

		if(!(LINES_FLAG[count] & 0x7F)) view = 9;

		SetStringXY(Lines[count], FNAME_X, FNAME_Y+(count * MENU_Y_SPACING));
	}

	for(;count < MAX_LINES; count++)
		SetStringXY(Lines[count], OFFSCREEN, OFFSCREEN);
}

/* UPDATE PLAY FILE TEXT */

Uint16 UpdatePLAYFile(Uint8 flag, Uint16 offset)
{
	Uint16 count = 0, i;


	for(i=0; i < MAX_LINES; i++)
	{
		ChangeStringCLUT(strings.string[Lines[MAX_LINES + i]], FontClutIDs[PEN_WHITE]->CLUT_ID);
		SetStringXY(Lines[MAX_LINES + i], OFFSCREEN, OFFSCREEN);
	}

	while(pEDIT_PLAYS[count].Formation >= 0 && count < (24))
	{
		strcpy(LINES_TXT[50 + count], pEDIT_PLAYS[count].Name);

		LINES_FLAG[50 + count] = 0x81;

		if(!flag && count >= offset)
		{
			if((count - offset) >= MAX_LINES)
			{
//				if((count - offset) == 16) PrintCenterWText(0, 882, 22, ")");
//				if((count - offset) == MAX_LINES) PrintCenterWText(0, 882, 22, ")");
			}
			else {
				if(offset && !(count - offset));
//					PrintCenterWText(0, 552, 22, "(");
				else
					PrintWIDEText(Lines[MAX_LINES + (count - offset)],
						LINES_TXT[50 + count]);

					SetStringXY(Lines[MAX_LINES + count], PLAYNAME_X, PLAYNAME_Y+((count - offset)*MENU_Y_SPACING));
			}
		}

		count++;
	}

	i=count;

	if(pEDIT_LINEedit > count-1) pEDIT_LINEedit = 0;

//	for(;i < MAX_LINES;i++)
//		SetStringXY(Lines[MAX_LINES + i], OFFSCREEN, OFFSCREEN);

	return count;
}


/* INITIALIZE YES/NO WINDOW */

void InitYesNo(Uint16 pos, char *text, Uint16 grid)
{
	Uint16 count;

	pEDIT_Doing = QUESTION;

//	template[SCREEN_TEMPLATE2].action[YESNOWIN] |= DISPLAY;
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[YESNOWIN], 20-256, YESNO_Y-128);

	YNBox = PopupDialogBox(YESNO_X-6, YESNO_Y, 120, 40, 2, 0x50, 0x10, 0x10);

	PrintCenterWText(Questions[0], 6, "Yes");
	SetStringXY(Questions[0], YESNO_X, YESNO_Y+20);
	PrintCenterWText(Questions[1], 6, "No");
	SetStringXY(Questions[1], YESNO_X+60, YESNO_Y+20);

	PrintCenterWText(PromptStr3, 40, text);
	SetStringXY(PromptStr3, YESNO_X, YESNO_Y);

	SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);
	PrintCenterWText(TriangleStr, 4, BACK_MSG);
	SetStringXY(TriangleStr, TRIANGLE_X, BUTTONS_Y);

	pEDIT_FLASH = 0;
	pEDIT_GRID = grid;
	pEDIT_GRIDpos = pos;
}


/* UPDATE YES/NO TEXT */

void UpdateYesNo(void)
{
	Uint16 count;

	pEDIT_FLASH++;	pEDIT_FLASH &= 0x0F;

	for(count = 0; count < 2; count++)
	{
//		Uint16 view = 7;

		if(count == pEDIT_GRID)
		{
//			view = 8;

			if(pEDIT_FLASH & 0x08)
				ChangeStringCLUT(strings.string[Questions[count]], FontClutIDs[PEN_DKYELLOW]->CLUT_ID);
			else
				ChangeStringCLUT(strings.string[Questions[count]], FontClutIDs[PEN_YELLOW]->CLUT_ID);
		}
		else
			ChangeStringCLUT(strings.string[Questions[count]], FontClutIDs[PEN_WHITE]->CLUT_ID);

		SetStringXY(Questions[count], YesnoPos[count], YESNO_Y+20);
	}
}

/* MOVE YES/NO POINTER */

void MoveYesNo(void)
{
	if(EditPadData & JPADLleft)
	{
		PlayEffect(CURSOR_SFX);
		pEDIT_GRID--;	pEDIT_GRID &= 0x01;
	}

	if(EditPadData & JPADLright)
	{
		PlayEffect(CURSOR_SFX);
		pEDIT_GRID++;	pEDIT_GRID &= 0x01;
	}

	JpadRepeatFreq = 30;
}


/* QUESTION YES/NO */

void DoYesNo(void)
{
	MoveYesNo();

	UpdateYesNo();

	if(EditPadData & JPADx)
	{
		ClearYesNo();

		pEDIT_Doing = FILE;

		pEDIT_step += pEDIT_GRID + 1;

		if(!pEDIT_GRID) pEDIT_LINE = pEDIT_LINEyes;

		PlayEffect(PRESS_SOUND);

	}

/*	if(EditPadData & JPADtriangle)
	{
		ClearYesNo();

		if(pEDIT_CreateEdit == CREATE)
		{
			pEDIT_Doing = FILE;

			pEDIT_step = 0;

			pEDIT_PLAYnum = UpdatePLAYFile(1, 0);

			pEDIT_LINEpos |= 0x8000;

		}
		else {
			pEDIT_Doing = FILE;

			pEDIT_step += 2;

//			CircleMsg("Do yes");
//			SquareMsg("and no");
		}
	}
*/
}


/* INITIALIZE MAIN MENU */

void InitMain(void)
{
	pEDIT_Doing = MAIN;

	pEDIT_Display = 0;

	HideEditor();		// Ensure editor stuff is off screen

	PrintCenterWText(PromptStr1, 44, "Please Choose");

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1], 160, 50);	// resize panel
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1], 180-256, 105-128);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1] |= DISPLAY;	// and show panel

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+7], 160, 50);	// resize panel
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+7], 180-256, 105-128);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] |= DISPLAY;	// and show panel

	FreeAllDialogBoxes();
	PopupDialogBox(180, 95, 160, 50, 2, 0x40, 0x40, 0x40);

	PrintCenterWText(MenuStr[0], 256, "Create New Play");
	PrintCenterWText(MenuStr[1], 256, "Edit Old Play");

	SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);
	PrintCenterWText(TriangleStr, 4, "exit");
	SetStringXY(TriangleStr, TRIANGLE_X, BUTTONS_Y);

	SetStringXY(AsciiCharStr, 600, 200);	// Get it off screen

	pEDIT_FLASH = 0;
	pEDIT_LINE = 0;	pEDIT_LINEpos = 0x8000;
}


/* MAIN MENU */

int DoMain(void)
{
	Uint16 pos[] = {13,15};
	Sint32 i;


//	template[SCREEN_TEMPLATE2].action[EDITPANEL] |= DISPLAY;/*show panel*/

	PrintCenterWText( TextStr, 44, " ");

	MoveMenuLines(0, 2);

	ChangeStringCLUT(strings.string[CrossPtr], FontClutIDs[PEN_WHITE]->CLUT_ID);
	ChangeStringCLUT(strings.string[MenuStr[pEDIT_LINE^1]], FontClutIDs[PEN_WHITE]->CLUT_ID);

	if(pEDIT_FLASH & 0x08)
		ChangeStringCLUT(strings.string[MenuStr[pEDIT_LINE]], FontClutIDs[PEN_DKYELLOW]->CLUT_ID);
	else
		ChangeStringCLUT(strings.string[MenuStr[pEDIT_LINE]], FontClutIDs[PEN_YELLOW]->CLUT_ID);

//	UpdateLines(26, pos, 0, 2);

	if(EditPadData & JPADx)
	{

		PlayEffect(PRESS_SOUND);

//		if ((i=GetCardBank())>=0)
//		{
			pEDIT_CreateEdit = pEDIT_LINE;

			if(pEDIT_CreateEdit == CREATE)
				InitCreate();
			else
			{
				pEDIT_FILEnum = -1;	pEDIT_FILEedit = -1;

				PrintCenterWText(TriangleStr, 4, BACK_MSG);
				SetStringXY(TriangleStr, TRIANGLE_X, BUTTONS_Y);

				if(InitFile(0)) return(1);
			}
//		}
	}

	return(0);
}



/* INITIALIZE CREATE A PLAY */

void InitCreate(void)
{
	Uint16 count;
	Sint16 i;

	Uint8 *clear = (Uint8 *)&pEDIT_ThePLAY;

	for(count = 0; count < sizeof(PLAYEDIT); count++) *clear++ = 0;

	pEDIT_Doing = CREATE;

	pEDIT_Display = 0;

	HideEditor();

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1], 160, 50);	// resize panel
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1], 180-256, 105-128);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1] |= DISPLAY;				//show panel

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+7], 160, 50);	// resize panel
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+7], 180-256, 105-128);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] |= DISPLAY;				//show panel

	FreeAllDialogBoxes();
	PopupDialogBox(180, 95, 160, 50, 2, 0x40, 0x40, 0x40);

	PrintCenterWText(MenuStr[0], 256, "Offense RUN");
	PrintCenterWText(MenuStr[1], 256, "Offense PASS");

	PrintCenterWText(PromptStr1, 44, "Choose the Play type");

	PrintCenterWText( TextStr, 44, " ");

	SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);

	PrintCenterWText(TriangleStr, 4, BACK_MSG);
	SetStringXY(TriangleStr, TRIANGLE_X, BUTTONS_Y);

	SetStringXY(CircleStr, OFFSCREEN, BUTTONS_Y);		// Offscreen
	SetStringXY(SquareStr, OFFSCREEN, BUTTONS_Y);		// Offscreen

	pEDIT_step = -1;
	pEDIT_player = -1;

	pEDIT_FILEnum = -1;

	pEDIT_FLASH = 0;
	pEDIT_LINE = 0;	pEDIT_LINEpos = 0x8000;

	pEDIT_ThePLAY.Formation = 0;
	pEDIT_ThePLAY.BallCarrier = -1;
	pEDIT_ThePLAY.Third = -1;

	for(count = 0; count < 7; count++)
		pEDIT_ThePLAY.Bitmap[count] = ANone;
}

void ResetCreate(void)
{
	Uint16 count;

	PrintCenterWText(PromptStr1, 44, "( Choose Formation )");

	pEDIT_step = 0;
	pEDIT_player = -1;

	pEDIT_ThePLAY.BallCarrier = -1;
	pEDIT_ThePLAY.Third = -1;

	for(count = 0; count < 7; count++)
		pEDIT_ThePLAY.Bitmap[count] = ANone;

//	template[SCREEN_TEMPLATE2].action[EDITPANEL1] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2+7] &= DISPLAY^0xFFFF;	/*hide menu panel*/

	FreeAllDialogBoxes();

	ShowEditor();

	PlayEffect(PRESS_SOUND);
}


/* CREATE A PLAY */

void DoCreate(void)
{
	Sint16 i;


	for (i=7; i<11; i++)
	{
		template[SCREEN_TEMPLATE].action[i] &= DISPLAY^0xFFFF; /*hide cursors*/
	}

	for (i=0; i<7; i++)
	{
		template[ARROWS_TEMPLATE].action[i] &= DISPLAY^0xFFFF; /*hide arrows*/
	}


	if(pEDIT_step == -1)
	{
		/* SELECT PLAY TYPE */

		Uint16 pos[] = {13,15};

		MoveMenuLines(0, 2);

		ChangeStringCLUT(strings.string[CrossPtr], FontClutIDs[PEN_WHITE]->CLUT_ID);
		ChangeStringCLUT(strings.string[MenuStr[pEDIT_LINE^1]], FontClutIDs[PEN_WHITE]->CLUT_ID);

		if(pEDIT_FLASH & 0x08)
			ChangeStringCLUT(strings.string[MenuStr[pEDIT_LINE]], FontClutIDs[PEN_DKYELLOW]->CLUT_ID);
		else
			ChangeStringCLUT(strings.string[MenuStr[pEDIT_LINE]], FontClutIDs[PEN_YELLOW]->CLUT_ID);

//		UpdateLines(26, pos, 0, 2);

		if(EditPadData & JPADx)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step++;	EditPadData = 0;

			pEDIT_RunPass = pEDIT_LINE;

			pEDIT_ThePLAY.ThePlay.PlayTypeDesignator = (pEDIT_RunPass * 2) + 1;

			pEDIT_Display = 1;

			PrintCenterWText(MenuStr[0], 256, "             ");
			PrintCenterWText(MenuStr[1], 256, "             ");

			PrintCenterWText(PromptStr1, 44, "( Choose Formation )");

//			template[SCREEN_TEMPLATE2].action[EDITPANEL1] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//			template[SCREEN_TEMPLATE2].action[EDITPANEL2] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//			template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//			template[SCREEN_TEMPLATE2].action[EDITPANEL2+7] &= DISPLAY^0xFFFF;	/*hide menu panel*/

			FreeAllDialogBoxes();

			ShowEditor();
		}

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);
			InitMain();
		}
	}

	if(pEDIT_step == 0)
	{
		/* SELECT FORMATION */

		pEDIT_ThePLAY.Formation =
			MoveChange(pEDIT_ThePLAY.Formation, 0, 15);

		PrintCenterWText(TextStr, 44, FORMS_TXT[pEDIT_ThePLAY.Formation]);

		pEDIT_ThePLAY.ThePlay.FormationNumber =
			FORMS_toAI[pEDIT_ThePLAY.Formation];

		if(EditPadData & JPADx)
		{
			PlayEffect(PRESS_SOUND);
			pEDIT_step++;	EditPadData = 0;

			PrintCenterWText(TextStr, 44, "");

			if(pEDIT_RunPass == RUN)
			{
				pEDIT_player = 5;

				PrintCenterWText(PromptStr1, 44, "( Choose Ball Carrier )");
			}
			else {
				pEDIT_player = pEDIT_ISplayer = 0;	pEDIT_script = 0;

				DisplayPLAYERSLOT();
			}
		}

		if(EditPadData & JPADtriangle)
		{
//			CLRsection((Uint16 *)NBG0_MAP_ADR, (18),  (3), 44, 1);
//			CLRsection((Uint16 *)NBG0_MAP_ADR, (18), (24), 44, 1);
			PlayEffect(PRESS_SOUND);
			InitCreate();
		}
	}

	if(pEDIT_step > 0 && (EditPadData & JPADtriangle)) ResetCreate();

	if(pEDIT_RunPass == RUN)
	{
		if(pEDIT_step == 1)
		{
			/* SELECT THE BALL CARRIER */

			pEDIT_player = MoveChange(pEDIT_player, 0, 6);

			PrintCenterWText(TextStr, 44,
				FORMS_PLAYERSLOT[pEDIT_ThePLAY.Formation][pEDIT_player]);

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_step++;	EditPadData = 0;

				pEDIT_script = 0;

				pEDIT_ThePLAY.BallCarrier = pEDIT_player;

				DisplayPLAYERSLOT();
			}
		}

		if(pEDIT_step == 2)
		{
			/* SELECT BALL CARRIER SCRIPT */

			Uint16 block = FORMS_RUNBCscripts[pEDIT_ThePLAY.Formation]
				[pEDIT_player] - 1;
			Uint16 script;

			pEDIT_script = MoveChange(pEDIT_script,
				0, pEDIT_Blocks[block].number);

			script = pEDIT_Blocks[block].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_Scripts[script].scriptNUM;

			pEDIT_ThePLAY.Block[pEDIT_player] = block;
			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_Scripts[script].Bitmap;

			pEDIT_ThePLAY.Color[pEDIT_player] =
				pEDIT_Blocks[block].color;

			PrintCenterWText(TextStr, 44, pEDIT_Scripts[script].text);

			if(pEDIT_player)
			{
				Uint16 QBscript = 0;

				while(pEDIT_QBScriptFIND[QBscript] !=
					pEDIT_Scripts[script].QBscript){ QBscript++; };

				pEDIT_ThePLAY.ThePlay.Script[0].ScriptNumToDo =
					pEDIT_Scripts[QBscript].scriptNUM;

				pEDIT_ThePLAY.Bitmap[0] =
					pEDIT_Scripts[QBscript].Bitmap;

				pEDIT_ThePLAY.Color[0] = palBLUE;
			}

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_step++;	EditPadData = 0;

				pEDIT_player = 6;	pEDIT_script = 0;

				pEDIT_OLblock = pEDIT_Scripts[script].OLblock;

				PrintCenterWText(PromptStr1, 44, "( Choose Offensive Line Route )");
			}
		}

		if(pEDIT_step == 3)
		{
			/* SELECT OFFENSIVE LINE (RUN) SCRIPT */

			Uint16 script;

			pEDIT_script = MoveChange(pEDIT_script,
				0, pEDIT_OLBlocks[pEDIT_OLblock].number);

			script = pEDIT_OLBlocks[pEDIT_OLblock].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_OLScripts[script].RTscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 1].ScriptNumToDo =
				pEDIT_OLScripts[script].LTscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 2].ScriptNumToDo =
				pEDIT_OLScripts[script].RGscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 3].ScriptNumToDo =
				pEDIT_OLScripts[script].LGscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 4].ScriptNumToDo =
				pEDIT_OLScripts[script].CscriptNUM;

			pEDIT_ThePLAY.Block[pEDIT_player] = pEDIT_OLblock;
			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_OLScripts[script].Bitmap;

			pEDIT_ThePLAY.Color[pEDIT_player] =
				pEDIT_OLBlocks[pEDIT_OLblock].color;

			PrintCenterWText(TextStr, 44, pEDIT_OLScripts[script].text);

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_step++;	EditPadData = 0;

				pEDIT_player = 5;	pEDIT_script = 0;

				if(pEDIT_player == pEDIT_ThePLAY.BallCarrier) pEDIT_player--;

				DisplayPLAYERSLOT();
			}
		}

		if(pEDIT_step == 4)
		{
			/* SELECT NONE BALL CARRIER SCRIPT */

			Uint16 block;
			Uint16 script;

//			PrintCenterWText(TextStr, 44, pEDIT_Scripts[script].text);

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_player--;

				if(pEDIT_player == pEDIT_ThePLAY.BallCarrier)
				{
					pEDIT_player--;
				}

				if(pEDIT_player > 0)
				{
					pEDIT_script = 0;

					DisplayPLAYERSLOT();
				}
				else
				{
//					if(CardSlot < 0)
//					{
//						pEDIT_player++;
//
//						pEDIT_script = 0;
//						DisplayPLAYERSLOT();
//					}
//					else
//					{
						Uint16 PInum = PlayInitNUM_Run[RandomNUM(3)];

						if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
							PInum = PlayInitNUM_Run[3];

						pEDIT_ThePLAY.ThePlay.PlayInitRoutineNumber = PInum;

						pEDIT_player = -1;

						strcpy(TheNAME_TXT, "");

						PrintCenterWText(PromptStr1, 44, "Name the Play");

						PrintCenterWText(TextStr, 44, TheNAME_TXT);

						pEDIT_Return = pEDIT_Doing;

						pEDIT_Doing = NAMEPLAY;

						InitName(GRID_X);
//					}
				}
			}

			if(pEDIT_player !=-1)
			{

			block =	FORMS_RUNNONscripts[pEDIT_ThePLAY.Formation]
				[pEDIT_player] - 1;

			pEDIT_script = MoveChange(pEDIT_script,
				0, pEDIT_Blocks[block].number);

			script = pEDIT_Blocks[block].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_Scripts[script].scriptNUM;

			pEDIT_ThePLAY.Block[pEDIT_player] = block;
			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_Scripts[script].Bitmap;

			pEDIT_ThePLAY.Color[pEDIT_player] =
				pEDIT_Blocks[block].color;

			PrintCenterWText(TextStr, 44, pEDIT_Scripts[script].text);

			}
		}
	}
	else {

		if(pEDIT_step == 1)
		{
			/* SELECT (QB AND WIDE REC) PASSING PLAY SCRIPTS */

			Uint16 block;
			Uint16 script;

			if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
				pEDIT_player = PLAYERS_ISlot[pEDIT_ISplayer];
			else pEDIT_player = pEDIT_ISplayer;

			block = FORMS_PASSscripts[pEDIT_ThePLAY.Formation]
				[pEDIT_player] - 1;

			pEDIT_script = MoveChange(pEDIT_script,
				0, pEDIT_Blocks[block].number);

			script = pEDIT_Blocks[block].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_Scripts[script].scriptNUM;

			pEDIT_ThePLAY.Block[pEDIT_player] = block;
			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_Scripts[script].Bitmap;

			switch(pEDIT_ISplayer) {
				case 0:
					pEDIT_ThePLAY.Color[pEDIT_player] =
						pEDIT_Blocks[block].color;
					break;

				case 1:
					pEDIT_ThePLAY.Color[pEDIT_player] = palORANGE;
					break;

				case 2:
					pEDIT_ThePLAY.Color[pEDIT_player] = palPINK;
					break;
			}

			PrintCenterWText(TextStr, 44, pEDIT_Scripts[script].text);

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_ISplayer++;

				if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
					pEDIT_player = PLAYERS_ISlot[pEDIT_ISplayer];
				else pEDIT_player = pEDIT_ISplayer;

				if(pEDIT_ISplayer == 3)
				{
					pEDIT_step++;	EditPadData = 0;

					PrintCenterWText(PromptStr1, 44, "( Choose third receiver )");
				}
				else DisplayPLAYERSLOT();

				pEDIT_script = 0;
			}
		}

		if(pEDIT_step == 2)
		{
			/* SELECT THE THIRD RECEIVER */

			pEDIT_ISplayer = MoveChange(pEDIT_ISplayer, 3, 6);

			if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
				pEDIT_player = PLAYERS_ISlot[pEDIT_ISplayer];
			else pEDIT_player = pEDIT_ISplayer;

			PrintCenterWText(TextStr, 44,
				FORMS_PLAYERSLOT[pEDIT_ThePLAY.Formation][pEDIT_player]);

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_step++;	EditPadData = 0;

				pEDIT_script = 0;

				pEDIT_ThePLAY.Third = pEDIT_player;

				DisplayPLAYERSLOT();
			}
		}

		if(pEDIT_step == 3)
		{
			/* SELECT (GREEN REC, THIRD REC FIRST) PASSING PLAY SCRIPTS */

			Uint16 block = FORMS_PASSscripts[pEDIT_ThePLAY.Formation]
				[pEDIT_player] - 1;
			Uint16 script;

			pEDIT_script = MoveChange(pEDIT_script,
				0, pEDIT_Blocks[block].number);

			script = pEDIT_Blocks[block].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_Scripts[script].scriptNUM;

			pEDIT_ThePLAY.Block[pEDIT_player] = block;
			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_Scripts[script].Bitmap;

			if(pEDIT_player == pEDIT_ThePLAY.Third)
				pEDIT_ThePLAY.Color[pEDIT_player] = palGREEN;
			else pEDIT_ThePLAY.Color[pEDIT_player] = palYELLOW;

			PrintCenterWText(TextStr, 44, pEDIT_Scripts[script].text);

			if(EditPadData & JPADx)
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_ISplayer++;
				if(pEDIT_ISplayer == 6) pEDIT_ISplayer = 3;

				if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
					pEDIT_player = PLAYERS_ISlot[pEDIT_ISplayer];
				else pEDIT_player = pEDIT_ISplayer;

				if(pEDIT_player == pEDIT_ThePLAY.Third)
				{
					pEDIT_step++;

					EditPadData = 0;

					pEDIT_player = 6;

					PrintCenterWText(PromptStr1, 44, "( Choose Offensive Line Route )");
				}
				else DisplayPLAYERSLOT();

				pEDIT_script = 0;
			}
		}

		if(pEDIT_step == 4)
		{
			/* SELECT OFFENSIVE LINE (PASS) SCRIPT */

			Uint16 script;

			pEDIT_script = MoveChange(pEDIT_script,
				0, pEDIT_OLBlocks[8].number);

			script = pEDIT_OLBlocks[8].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_OLScripts[script].RTscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 1].ScriptNumToDo =
				pEDIT_OLScripts[script].LTscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 2].ScriptNumToDo =
				pEDIT_OLScripts[script].RGscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 3].ScriptNumToDo =
				pEDIT_OLScripts[script].LGscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 4].ScriptNumToDo =
				pEDIT_OLScripts[script].CscriptNUM;

			pEDIT_ThePLAY.Block[pEDIT_player] = 8;
			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_OLScripts[script].Bitmap;

			pEDIT_ThePLAY.Color[pEDIT_player] =
				pEDIT_OLBlocks[8].color;

			PrintCenterWText(TextStr, 44, pEDIT_OLScripts[script].text);

			if(EditPadData & JPADx)
			{

//				if(CardSlot < 0)
//				{
//					pEDIT_player = 6;
//					pEDIT_script = 0;
//					DisplayPLAYERSLOT();
//				}
//				else
//				{
				Uint16 *PInum = PlayInitNUM;

				PlayEffect(PRESS_SOUND);

				if(pEDIT_ThePLAY.Formation == FORMS_ISlot)
					PInum = PlayInitNUM_ISlot;

				pEDIT_ThePLAY.ThePlay.PlayInitRoutineNumber =
					PInum[pEDIT_ThePLAY.Third - 1];

				pEDIT_player = -1;

				strcpy(TheNAME_TXT, "");

				PrintCenterWText(PromptStr1, 44, "Name the Play");

				PrintCenterWText(TextStr, 44, TheNAME_TXT);

				pEDIT_Return = pEDIT_Doing;

				pEDIT_Doing = NAMEPLAY;

				InitName(GRID_X);
//				}
			}
		}
	}
}


/* INITIALIZE EDIT A PLAY */

void InitEdit(void)
{
	int i;

	pEDIT_CreateEdit = pEDIT_Doing = EDIT;

	pEDIT_Display = 1;

	PrintCenterWText(PromptStr1, 44, "( Choose player to Edit )");

	template[SCREEN_TEMPLATE5].action[LFIELD] |= DISPLAY;/*show field*/
	template[SCREEN_TEMPLATE3].action[RFIELD] |= DISPLAY;/*show field*/

	HideFileMenu();

//	template[SCREEN_TEMPLATE2].action[EDITPANEL1] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] &= DISPLAY^0xFFFF;	/*hide menu panel*/
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2+7] &= DISPLAY^0xFFFF;	/*hide menu panel*/

	FreeAllDialogBoxes();

	for (i=0; i<7; i++)
	{
		template[SCREEN_TEMPLATE].action[i] |= DISPLAY; /* show form */
	}

	for (i=7; i<11; i++)
	{
		template[SCREEN_TEMPLATE].action[i] &= DISPLAY^0xFFFF; /* hide cursors */
	}

	SquareMsg("SAVE");
//	CircleMsg("SAVE");

	pEDIT_step = 0;
	pEDIT_player = 0;

	if(pEDIT_ThePLAY.BallCarrier > 0) pEDIT_player++;
}


/* EDIT A PLAY */

void DoEdit(void)
{
	if(pEDIT_step == 0)
	{
		template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] &= DISPLAY^0XFFFF;
		SetStringXY(CircleStr, OFFSCREEN, BUTTONS_Y);

		/* SELECT PLAYER TO EDIT */

		pEDIT_player = MoveChange(pEDIT_player, 0, 7);

		if(pEDIT_player == 0 && pEDIT_ThePLAY.BallCarrier > 0)
			pEDIT_player = MoveChange(pEDIT_player, 0, 7);

		if(pEDIT_player != 6) PrintCenterWText(TextStr, 44,
			FORMS_PLAYERSLOT[pEDIT_ThePLAY.Formation][pEDIT_player]);
		else PrintCenterWText(TextStr, 44, "Offensive Line");

		if(EditPadData & JPADx)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step++;	EditPadData = 0;

			if(pEDIT_player != 6)
			{
				pEDIT_script = pEDIT_ThePLAY.Script[pEDIT_player] -
					pEDIT_Blocks[pEDIT_ThePLAY.Block[pEDIT_player]].add;

				pEDIT_scriptOld = pEDIT_script;

				DisplayPLAYERSLOT();
			}
			else {
				pEDIT_step++;

				pEDIT_OLblock = pEDIT_ThePLAY.Block[pEDIT_player];

				pEDIT_script = pEDIT_ThePLAY.Script[pEDIT_player] -
					pEDIT_OLBlocks[pEDIT_OLblock].add;

				pEDIT_scriptOld = pEDIT_script;

				PrintCenterWText(PromptStr1, 44, "( Choose Offensive Line Route )");
			}
		}

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_FILEnum = pEDIT_FILEedit & 0x7FFF;
			pEDIT_LINE = pEDIT_LINEedit;

			pEDIT_LINEpos = pEDIT_LINE - (MAX_LINES-1);
			if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;

			pEDIT_FILEedit = -1;

			PrintCenterWText(TextStr, 44, pEDIT_ThePLAY.Name);

			ClearPlayNames();
			pEDIT_PLAYnum = UpdatePLAYFile(0, 0);

			InitFile(1);
		}
	}

	if(pEDIT_step == 1 && pEDIT_Doing == EDIT)
	{
		/* SELECT PLAYER'S NEW SCRIPT */

		Uint16 block = pEDIT_ThePLAY.Block[pEDIT_player];
		Uint16 script;

		pEDIT_script = MoveChange(pEDIT_script,
			0, pEDIT_Blocks[block].number);

		script = pEDIT_Blocks[block].add + pEDIT_script;

		pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
			pEDIT_Scripts[script].scriptNUM;

		pEDIT_ThePLAY.Script[pEDIT_player] = script;

		pEDIT_ThePLAY.Bitmap[pEDIT_player] =
			pEDIT_Scripts[script].Bitmap;

		PrintCenterWText(TextStr, 44, pEDIT_Scripts[script].text);

		if(pEDIT_player && pEDIT_player == pEDIT_ThePLAY.BallCarrier)
		{
			Uint16 QBscript = 0;

			while(pEDIT_QBScriptFIND[QBscript] !=
				pEDIT_Scripts[script].QBscript){ QBscript++; };

			pEDIT_ThePLAY.ThePlay.Script[0].ScriptNumToDo =
				pEDIT_Scripts[QBscript].scriptNUM;

			pEDIT_ThePLAY.Bitmap[0] =
				pEDIT_Scripts[QBscript].Bitmap;
		}

		if(EditPadData & JPADx)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step = 0;	EditPadData = 0;

			PrintCenterWText(PromptStr1, 44, "( Choose player to Edit )");
		}

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step = 0;	EditPadData = 0;

			pEDIT_script = pEDIT_scriptOld;

			script = pEDIT_Blocks[block].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_Scripts[script].scriptNUM;

			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_Scripts[script].Bitmap;

			PrintCenterWText(PromptStr1, 44, "( Choose player to Edit )");
		}
	}

	if(pEDIT_step == 2)
	{
		/* SELECT OFFENSIVE LINE'S NEW SCRIPT */

		Uint16 script;

		pEDIT_script = MoveChange(pEDIT_script,
			0, pEDIT_OLBlocks[pEDIT_OLblock].number);

		script = pEDIT_OLBlocks[pEDIT_OLblock].add + pEDIT_script;

		pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
			pEDIT_OLScripts[script].RTscriptNUM;
		pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 1].ScriptNumToDo =
			pEDIT_OLScripts[script].LTscriptNUM;
		pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 2].ScriptNumToDo =
			pEDIT_OLScripts[script].RGscriptNUM;
		pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 3].ScriptNumToDo =
			pEDIT_OLScripts[script].LGscriptNUM;
		pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 4].ScriptNumToDo =
			pEDIT_OLScripts[script].CscriptNUM;

		pEDIT_ThePLAY.Script[pEDIT_player] = script;

		pEDIT_ThePLAY.Bitmap[pEDIT_player] =
			pEDIT_OLScripts[script].Bitmap;

		PrintCenterWText(TextStr, 44, pEDIT_OLScripts[script].text);

		if(EditPadData & JPADx)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step = 0;	EditPadData = 0;

			PrintCenterWText(PromptStr1, 44, "( Choose player to Edit )");
		}

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step = 0;	EditPadData = 0;

			pEDIT_script = pEDIT_scriptOld;

			script = pEDIT_OLBlocks[pEDIT_OLblock].add + pEDIT_script;

			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player].ScriptNumToDo =
				pEDIT_OLScripts[script].RTscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 1].ScriptNumToDo =
				pEDIT_OLScripts[script].LTscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 2].ScriptNumToDo =
				pEDIT_OLScripts[script].RGscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 3].ScriptNumToDo =
				pEDIT_OLScripts[script].LGscriptNUM;
			pEDIT_ThePLAY.ThePlay.Script[pEDIT_player + 4].ScriptNumToDo =
				pEDIT_OLScripts[script].CscriptNUM;

			pEDIT_ThePLAY.Script[pEDIT_player] = script;

			pEDIT_ThePLAY.Bitmap[pEDIT_player] =
				pEDIT_OLScripts[script].Bitmap;

			PrintCenterWText(PromptStr1, 44, "( Choose player to Edit )");
		}
	}

	if(EditPadData & JPADsquare)
	{
		PlayEffect(PRESS_SOUND);

		pEDIT_player = -1;

		strcpy(TheNAME_TXT, pEDIT_ThePLAY.Name);

		PrintCenterWText(PromptStr1, 44, "Name the Play");

		PrintCenterWText(TextStr, 44, TheNAME_TXT);

		pEDIT_Return = pEDIT_Doing;

		pEDIT_Doing = NAMEPLAY;

		InitName(196);
	}
}


/* INITIALIZE NAME A PLAY WINDOW */

void InitName(Uint16 pos)
{
	Uint16 count,i;

//	strcpy(TheNAME_TXT, "");

	AscBox = PopupDialogBox((pos-2), FILEPANEL_Y, 138, 96, 2, 0x10, 0x50, 0x10);

	for(i=0; i<39; i++)
	{
		SetStringXY(GridStr[i], (pos)+pEDIT_NAME[i].X, FILEPANEL_Y+pEDIT_NAME[i].Y);
	}

	GridX = pos;
	GridY = GRID_Y;

	pEDIT_FLASH = 0;
	pEDIT_GRID = 0;	if(strcmp(TheNAME_TXT, "")) pEDIT_GRID = 38;
	pEDIT_GRIDpos = pos;
}



void ClearAsciiPanel(void)
{
	Uint16 i;

	FreeDialogBox(AscBox);

	for(i=0; i<39; i++)
	{
		SetStringXY(GridStr[i], OFFSCREEN, 0);
	}

	SetStringXY(AsciiCharStr, 600, 200);	// remove 'cursor' string
}


/* UPDATE NAME GRID TEXT */

void UpdateNAMEGrid(void)
{
	Uint16 count;

	pEDIT_FLASH++;	pEDIT_FLASH &= 0x0F;

	PrintWIDEText(AsciiCharStr, pEDIT_NAME[pEDIT_GRID].Text);
	SetStringXY(AsciiCharStr, pEDIT_NAME[pEDIT_GRID].X+GridX,pEDIT_NAME[pEDIT_GRID].Y+GridY+4);

	if(pEDIT_FLASH & 0x08)
		ChangeStringCLUT(strings.string[AsciiCharStr], FontClutIDs[PEN_DKYELLOW]->CLUT_ID);
	else
		ChangeStringCLUT(strings.string[AsciiCharStr], FontClutIDs[PEN_YELLOW]->CLUT_ID);

}

/* MOVE NAME GRID POINTER */

void MoveNAMEGrid(void)
{
	Sint16 dir = EditPadData >> 12;

	dir = Jpad2Dir[dir];

	if(dir >= 0)
	{
		Uint16 grid = pEDIT_NAME[pEDIT_GRID].Dir[dir];

		PlayEffect(CURSOR_SFX);

		if(!(grid == 38 && strlen(TheNAME_TXT) == 0))
		{
			pEDIT_GRID = grid;

			pEDIT_FLASH = 0;
		}
	}
}


/* NAME A PLAY */

Sint8 DoName(int NameLen)
{
	Sint8 done = 0;

	MoveNAMEGrid();

	UpdateNAMEGrid();

	if(EditPadData & JPADx)
	{

		char *text = pEDIT_NAME[pEDIT_GRID].Text;

		PlayEffect(PRESS_SOUND);

		if(text == "spc") text = " ";

		if(strlen(text) == 1 && strlen(TheNAME_TXT) < NameLen)
		{
			strcat(TheNAME_TXT, text);
		}

		if(text == "del")
		{
			Sint16 count = 0;

			while(TheNAME_TXT[count] != 0){ count++; }

			count--;

			if(count >= 0) TheNAME_TXT[count] = 0;
		}

		if(text == "end")
		{
			done = 1;

			pEDIT_Doing = pEDIT_Return;

			ClearAsciiPanel();
		}
	}

	if(EditPadData & JPADtriangle)
	{
		done = -1;

		pEDIT_Doing = pEDIT_Return;

		ClearAsciiPanel();

		PlayEffect(PRESS_SOUND);
	}

	return done;
}


/* INITIALIZE FILE MANAGER WINDOW */

int InitFile(Uint8 flag)
{
	Sint16 count;
	Sint16 fsort[50];
	Sint16 i = 0, j = 0, x;


	HideEditor();
	ShowFileMenu();


	EditPadData = NULL;

	PrintCenterWText(TextStr, 44, "");


	pEDIT_Doing = FILE;

	if(pEDIT_CreateEdit == CREATE)
	{
		PrintCenterWText(PromptStr1, 44, "Choose Block to SAVE to");
	}
	else {
		pEDIT_Display = 0;

		if(!flag) PrintCenterWText(PromptStr1, 44, "Choose Block to LOAD from");
		else PrintCenterWText(PromptStr1, 44, "Choose the Play");
	}


	pEDIT_step = 0;


	if(pEDIT_CreateEdit == EDIT && flag)
	{
		CircleMsg("Delete");
		SquareMsg("Copy");
	}

//	x = DialogBoxMessage(256, 112, "LOADING...Please Wait");

/***************************/

	GetFiles(CardPort,CardBank);

	memcpy(PE_MemFile, MemFile, sizeof(memfile_t)*16);

	pEDIT_FILES = 0;

	while(PE_MemFile[pEDIT_FILES].name[0] !=NULL) pEDIT_FILES++;

	for(count=0; count < pEDIT_FILES; count++)
	{
		Uint8 lflag = 0;

		char fname[22], tmpstr[22] ,fnum[4];

		if(strncmp(pEDITFILE,PE_MemFile[count].name,11) == 0	// Compare  first 8 ascii characters to see if it's a JJ file
			&& strncmp(TRADE_EXHIBFILE,PE_MemFile[count].name,13) != 0
			&& strncmp(TRADE_SEASONFILE,PE_MemFile[count].name,13) != 0
			&& strncmp(OPTIONFILE,PE_MemFile[count].name,13) != 0
			&& strncmp(SEASONFILE,PE_MemFile[count].name,13) != 0)
		{
			ReadHeader(Files[count], CardPort, CardBank, PE_MemFile[count].name);

			if(Files[count][0] & 0x80)		// if hi bit set this is kanji code (16 bit)
			{
				Files[count][28] = 0;		//terminate after SJIS char 14

				SJISString2ASCII((unsigned short *)Files[count], fname);
				strcpy(Files[count], fname);
			}
			else							// regular ascii code (8 bit)
			{
				Files[count][14] = 0;

				strcpy(fname, Files[count]);
			}

			strcpy(LINES_TXT[count], fname);					// I'll do it here so it can be overwritten if we want


 			LINES_FLAG[count] = 0x81;	lflag = 1;	fsort[count] = count;
		}
		else
		{
			Uint32 nfiles = count;

			if(count+1 != pEDIT_FILES)
			{
				for(;nfiles<pEDIT_FILES-1; nfiles++)
				{
					strcpy(PE_MemFile[nfiles].name, PE_MemFile[nfiles+1].name);
					PE_MemFile[nfiles].blocks = PE_MemFile[nfiles].blocks;
				}
			}

			count--;
			pEDIT_FILES--;
		}

	}

//	CloseDialogBoxMessage(x);


	if(pEDIT_CreateEdit == CREATE)
	{
		if(pEDIT_FILEnum < 0) pEDIT_LINE = pEDIT_FILES;
		else pEDIT_LINE = pEDIT_FILEnum;

		pEDIT_FILEnum = 0;

		for(count = 0; count < pEDIT_FILES; count++)
		{
			if(pEDIT_FILEnum == fsort[count]) pEDIT_FILEnum++;
		}

		strcpy(LINES_TXT[count], "-new block-");

		LINES_FLAG[count] = 0x81;

		pEDIT_FILES++;
	}

	pEDIT_FLASH = 0;


	if(pEDIT_CreateEdit == CREATE)
	{
		if(pEDIT_LINE == pEDIT_FILES - 1)
  		{
//			for(count = 0; count < (24); count++)
//				pEDIT_PLAYS[count].Formation = -1;

			ClearAllPlays();

			pEDIT_PLAYnum = 0;
		}
		else
		{

//			BackUpRead(&PE_MemFile[pEDIT_LINE].name[0], &pEDIT_PLAYS);

			pEDIT_PLAYnum = UpdatePLAYFile(0, 0);
		}
	}
	else
	{
		Sint16 file;

		if(pEDIT_FILEnum < 0)
		{
			count = 0;
			while(fsort[count] < 0 && count < pEDIT_FILES){ count++; }

			if(count == pEDIT_FILES) count = -1;

			pEDIT_LINE = count;	pEDIT_FILEnum = -1;

			file = pEDIT_LINE;
		}
		else
		{
			if(!flag)
			{
				pEDIT_LINE = pEDIT_FILEnum;	pEDIT_FILEnum = -1;

				file = pEDIT_LINE;
			}
			else
			{
				pEDIT_step++;	file = pEDIT_FILEnum;

				UpdateFILEs();
			}
		}

		if(file < 0) pEDIT_PLAYnum = 0;
		else
		{

//			BackUpRead(&PE_MemFile[file].name[0], &pEDIT_PLAYS); //seems unecessary

			pEDIT_PLAYnum = UpdatePLAYFile(flag, 0);
		}
	}

	pEDIT_PLAYpos = 0;	pEDIT_LINEpos |= 0x8000;

//////////
	if(!flag && pEDIT_FILES)
	{
		ReadNamesOnly(&PE_MemFile[pEDIT_LINE].name[0], &pEDIT_PLAYS);
		ClearPlayNames();
		pEDIT_PLAYnum = UpdatePLAYFile(0, 0);
	}
/////////

	return(0);
}


/* FILE MANAGER */

	Uint16 pos[] = {FNAME_Y+(0*MENU_Y_SPACING),FNAME_Y+(1*MENU_Y_SPACING),
					FNAME_Y+(2*MENU_Y_SPACING),FNAME_Y+(3*MENU_Y_SPACING),
					FNAME_Y+(4*MENU_Y_SPACING),FNAME_Y+(5*MENU_Y_SPACING),
					FNAME_Y+(6*MENU_Y_SPACING),FNAME_Y+(7*MENU_Y_SPACING),
					FNAME_Y+(8*MENU_Y_SPACING),FNAME_Y+(9*MENU_Y_SPACING),
					FNAME_Y+(10*MENU_Y_SPACING),FNAME_Y+(11*MENU_Y_SPACING),
					FNAME_Y+(12*MENU_Y_SPACING),FNAME_Y+(13*MENU_Y_SPACING),
					FNAME_Y+(14*MENU_Y_SPACING),FNAME_Y+(15*MENU_Y_SPACING)
					};




int DoFile(void)
{

	Uint16 i,j;

	if(pEDIT_step == 0)
	{
		// SELECT FILE


		Sint16 line = pEDIT_LINE;

		if(line >= 0) MoveLines(0, pEDIT_FILES);

		UpdateLines(FNAME_X, pos, 0, pEDIT_FILES);

		if(line != pEDIT_LINE)
		{
			if(pEDIT_CreateEdit == CREATE && pEDIT_LINE == pEDIT_FILES - 1)
  			{
				// NEW FILE

				Uint16 count;

//				for(count = 0; count < (24); count++)
//					pEDIT_PLAYS[count].Formation = -1;

				ClearAllPlays();
				ClearPlayNames();
				UpdatePLAYFile(0, 0);
				pEDIT_PLAYnum = 0;
			}
			else
			{
				// OLD FILE

				if(EditPadData)
				{
					ReadNamesOnly(&PE_MemFile[pEDIT_LINE].name[0], &pEDIT_PLAYS);
					ClearPlayNames();
					pEDIT_PLAYnum = UpdatePLAYFile(0, 0);
				}
			}

			pEDIT_PLAYpos = 0;
		}

		if(pEDIT_CreateEdit == CREATE)
		{
			if((EditPadData & JPADLleft) && pEDIT_PLAYnum > MAX_LINES && pEDIT_PLAYpos)
			{
				pEDIT_PLAYpos = 0;	UpdatePLAYFile(0, 0);
				PlayEffect(CURSOR_SFX);
			}

			if((EditPadData & JPADLright) && pEDIT_PLAYnum > MAX_LINES && !pEDIT_PLAYpos)
			{
				pEDIT_PLAYpos = pEDIT_PLAYnum - MAX_LINES;
				UpdatePLAYFile(0, pEDIT_PLAYpos);
				PlayEffect(CURSOR_SFX);
			}
		}

		if(line >= 0 && (EditPadData & JPADx ||
			(pEDIT_CreateEdit == EDIT && (EditPadData & JPADLright))))
		{
			PlayEffect(PRESS_SOUND);

			if(OptFlag) return(TRUE);

			pEDIT_FLASH = 0;
			UpdateLines(FNAME_X, pos, 0, pEDIT_FILES);

			BackUpRead(&PE_MemFile[pEDIT_LINE].name[0], &pEDIT_PLAYS);	// Moved to here to avoid loading until needed


			PrintCenterWText(CrossStr, 4, "select");
			SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);

			if(pEDIT_CreateEdit == CREATE)
			{
				if(pEDIT_LINE == pEDIT_FILES - 1)
				{
					// NAME NEW FILE

					strcpy(TheNAME_TXT, "");

					PrintCenterWText(PromptStr1, 44, "Name the Block");

					PrintWIDEText(Lines[pEDIT_LINE  - pEDIT_LINEpos],
						TheNAME_TXT);

					pEDIT_Doing = NAMEFILE;

					InitName(22);
				}
				else {
					// CHECK FOR SAME PLAY IN OLD FILE

					Uint8 flag = 0;

					Uint16 count;

					for(count = 0; count < (24); count++)
					{
						if(pEDIT_PLAYS[count].Formation >= 0 &&
							strcmp(pEDIT_ThePLAY.Name, pEDIT_PLAYS[count].Name) == 0)
						{
							PrintCenterWText(PromptStr1, 44, "Duplicate Play");

							if(count > MAX_LINES)
 							{
								pEDIT_PLAYpos = pEDIT_PLAYnum - MAX_LINES;
								UpdatePLAYFile(0, pEDIT_PLAYpos);
							}

							pEDIT_PLAYnum = count;

							pEDIT_LINEyes = pEDIT_LINE;

							InitYesNo(3, "Overwrite?", 1);

							flag = 1;
							break;
						}
					}

					if(pEDIT_PLAYnum == 24)
					{
						pEDIT_step = 7;	EditPadData = 0;

						PrintCenterWText(PromptStr1, 44, "Overwrite which Play?");

						pEDIT_PLAYpos = 0;

						pEDIT_FILEnum = pEDIT_LINE;

						pEDIT_LINE = 0;	pEDIT_LINEpos = 0x8000;

						flag = 1;
					}

					if(!flag) pEDIT_step++;
				}
			}
			else {
				if(pEDIT_PLAYnum)
				{
					pEDIT_step++;	EditPadData = 0;

					PrintCenterWText(PromptStr1, 44, "Choose the Play");

					pEDIT_PLAYpos = 0;

					pEDIT_FILEnum = pEDIT_LINE;

					pEDIT_LINE = 0;	pEDIT_LINEpos = 0x8000;

					CircleMsg("Delete");
					SquareMsg("Copy");
				}
			}
		}

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);

			if(OptFlag) return(-1);

			if(pEDIT_CreateEdit == CREATE)
			{
				if(pEDIT_FILEedit < 0)
				{
					pEDIT_FILEnum = pEDIT_LINE;


					PrintCenterWText(PromptStr1, 44, "Name the Play");

					pEDIT_Doing = NAMEPLAY;

					HideFileMenu();
					ShowEditor();
					InitName(196);

					strcpy(TheNAME_TXT, pEDIT_ThePLAY.Name);
					PrintCenterWText(TextStr, 44, TheNAME_TXT);
				}
				else {
					pEDIT_CreateEdit = EDIT;

					pEDIT_Display = -1;

					pEDIT_FILEnum = pEDIT_FILEedit;
					pEDIT_LINE = pEDIT_LINEedit;

					pEDIT_LINEpos = pEDIT_LINE - 14;
					if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;

					pEDIT_FILEedit = -1;

					InitFile(1);	EditPadData = 0;
				}
			}
			else {
					InitMain();
			}
		}
	}

	if(pEDIT_step == 1)
	{
		if(pEDIT_CreateEdit == CREATE)
		{
			// WRITE FILE TO THE BACK-UP

			Uint8 flag = 0;

			pEDIT_step++;	EditPadData = 0;

//	unneeded		BackUpRead(&PE_MemFile[pEDIT_LINE].name[0], &pEDIT_PLAYS);	// Moved to here to avoid loading until needed

			PushPLAY(pEDIT_PLAYnum);

			pEDIT_PLAYnum = UpdatePLAYFile(1, 0);	pEDIT_PLAYpos = 0;

			if(pEDIT_LINE == pEDIT_FILES - 1)
			{
				// WRITE NEW FILE

				char fname[12];

				Uint16 count;

				for(count = 0; count < pEDIT_FILES; count++)
				{
					if(strcmp(TheNAME_TXT, Files[count]) == 0)
					{
						PrintCenterWText(PromptStr1, 44, "Duplicate Block");

						pEDIT_step -= 2;

						pEDIT_LINEyes = count;

						InitYesNo(3, "Overwrite?", 1);
						break;
					}
				}

				if(pEDIT_step)
				{
					for (i=0; i<24; i++)
					{
						if(pEDIT_PLAYS[i].Name[0] == 0) pEDIT_PLAYS[i].Formation = -1;
					}

					PopPLAY(0);

					j = GetUniqueFnum();
//					sprintf(fname, "BASLUS-00071%02d", j);
					sprintf(fname, PLAYSFILE, j);

					if(BackUpWrite(fname, TheNAME_TXT,
						&pEDIT_PLAYS, sizeof(PLAYEDIT) * 24, 1))
					{
						PrintCenterWText(PromptStr1, 44, "Block not Saved  -Memory Full-");

						pEDIT_LINEyes = pEDIT_LINE;

						InitYesNo(3, "Save Again?", 0);
					}
					else flag = 1;

					flag = 1;

				}
			}
			else {
				// WRITE OLD FILE ( but read it in first )

				BackUpWrite(PE_MemFile[pEDIT_LINE].name, Files[pEDIT_LINE],
					&pEDIT_PLAYS, sizeof(PLAYEDIT) * 24, 0);

				flag = 1;
			}

			if(flag)
			{
				PrintCenterWText(PromptStr1, 44, "The Block is Saved");

			 	UpdatePLAYFile(0, 0);

/////////////////////////////////////////////////
				pEDIT_LINEyes = pEDIT_LINE;
				InitYesNo(3, "Save Again?", 1);
/////////////////////////////////////////////////
			}
		}
		else {
			MoveLines(50, pEDIT_PLAYnum);

			UpdateLines(PLAYNAME_X, pos, 50, pEDIT_PLAYnum);

			BuildPlayBitmap(SCREEN_TEMPLATE5, 1, pEDIT_LINE);

			if(EditPadData & JPADx)
			{
//				BackUpRead(&PE_MemFile[pEDIT_FILEnum].name[0], &pEDIT_PLAYS);	// Moved to here to avoid loading until needed

				PlayEffect(PRESS_SOUND);

				PopPLAY(pEDIT_LINE);

				pEDIT_FILEedit = pEDIT_FILEnum;
				pEDIT_LINEedit = pEDIT_LINE;

				InitEdit();

			}
			else		////////
			if((EditPadData & JPADtriangle) || (EditPadData & JPADLleft))
			{
				PlayEffect(PRESS_SOUND);

				pEDIT_FLASH = 0;
				UpdateLines(PLAYNAME_X, pos, 50, pEDIT_PLAYnum);

				PrintCenterWText(CrossStr, 4, SELECT_MSG);
				SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);

				pEDIT_step--;	EditPadData = 0;

				PrintCenterWText(PromptStr1, 44, "Choose Block to LOAD from");

				pEDIT_LINE = pEDIT_FILEnum;	pEDIT_FILEnum = -1;

				pEDIT_LINEpos = pEDIT_LINE - 14;
				if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;

				pEDIT_LINEpos |= 0x8000;

				template[SCREEN_TEMPLATE2].action[SQUARE_POLY] &= DISPLAY^0xFFFF;	//hide inactive buttons
				template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] &= DISPLAY^0XFFFF;

				SetStringXY(CircleStr, OFFSCREEN, BUTTONS_Y);
				SetStringXY(SquareStr, OFFSCREEN, BUTTONS_Y);

			}
			else		////////
			if(EditPadData & JPADsquare)
			{
				PlayEffect(PRESS_SOUND);

//				BackUpRead(&PE_MemFile[pEDIT_FILEnum].name[0], &pEDIT_PLAYS);	// Moved to here to avoid loading until needed

				PopPLAY(pEDIT_LINE);

				pEDIT_Display = 1;	pEDIT_player = -1;

				PrintCenterWText(TextStr, 44, pEDIT_ThePLAY.Name);

				pEDIT_LINEpos = 0;

				pEDIT_FILEedit = pEDIT_FILEnum;
				pEDIT_LINEedit = pEDIT_LINE;

				pEDIT_CreateEdit = CREATE;

				pEDIT_FLASH = 0;
				UpdateLines(PLAYNAME_X, pos, 50, pEDIT_PLAYnum);

				InitFile(0);
			}
			else		////////
			if(EditPadData & JPADcircle)
			{
				PlayEffect(PRESS_SOUND);

//				BackUpRead(&PE_MemFile[pEDIT_FILEnum].name[0], &pEDIT_PLAYS);	// Moved to here to avoid loading until needed

				PopPLAY(pEDIT_LINE);

//				pEDIT_Display = 1;
				pEDIT_player = -1;

				pEDIT_step = 4;

//				PrintCenterWText(TextStr, 44, pEDIT_ThePLAY.Name);

				pEDIT_LINEyes = pEDIT_LINE;


				pEDIT_FLASH = 0;
				UpdateLines(PLAYNAME_X, pos, 50, pEDIT_PLAYnum);

//				template[SCREEN_TEMPLATE2].action[SQUARE_POLY] &= DISPLAY^0xFFFF;	//hide inactive buttons
//				template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] &= DISPLAY^0XFFFF;

				PrintCenterWText(CrossStr, 4, SELECT_MSG);
				SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);

				template[SCREEN_TEMPLATE2].action[SQUARE_POLY] &= DISPLAY^0xFFFF;	/*hide inactive buttons*/
				template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] &= DISPLAY^0XFFFF;

				SetStringXY(CircleStr, OFFSCREEN, BUTTONS_Y);
				SetStringXY(SquareStr, OFFSCREEN, BUTTONS_Y);

				InitYesNo(3, "Delete Play ?", 1);
			}
		}
	}

	if(pEDIT_step == 2 && pEDIT_Doing == FILE)
	{
		// DUPLICATE PLAY OR FILE

		PrintCenterWText(PromptStr1, 44, "Block not SAVED");

		pEDIT_LINEyes = pEDIT_LINE;

		InitYesNo(3, "Save Again?", 0);
	}


	if(pEDIT_step == 3)
	{
		pEDIT_FILEnum = pEDIT_LINE;

		InitFile(0);
	}

	if(pEDIT_step == 4 && pEDIT_Doing == FILE)
	{
		if(pEDIT_FILEedit < 0)
		{
			InitMain();
		}
		else {
			pEDIT_CreateEdit = EDIT;

			pEDIT_Display = -1;


			pEDIT_FILEnum = pEDIT_LINE;
//			pEDIT_FILEnum = pEDIT_FILEedit;
			pEDIT_LINE = pEDIT_LINEedit;

			pEDIT_LINEpos = pEDIT_LINE - 14;
			if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;

			pEDIT_FILEedit = -1;

			InitFile(1);
		}
	}

	if(pEDIT_step == 5)
	{
		Uint16 count;

		for(count = pEDIT_LINE; count < (pEDIT_PLAYnum - 1); count++)
		{
			PopPLAY(count + 1);
			PushPLAY(count);
		}

		pEDIT_PLAYS[count].Formation = -1;

		BackUpWrite(PE_MemFile[pEDIT_FILEnum].name, Files[pEDIT_FILEnum],
			&pEDIT_PLAYS, sizeof(PLAYEDIT) * 24, 0);

		pEDIT_Display = 0;
		pEDIT_step = 1;

		if(pEDIT_LINEpos && pEDIT_LINEpos == (pEDIT_PLAYnum - MAX_LINES))
			pEDIT_LINEpos--;

		pEDIT_PLAYnum = UpdatePLAYFile(0, pEDIT_LINEpos);

		if(count)
		{
			if(pEDIT_LINE == pEDIT_PLAYnum) pEDIT_LINE--;
		}
		else {
			pEDIT_step--;

			PrintCenterWText(PromptStr1, 44, "Choose Block to LOAD from");

			pEDIT_LINE = pEDIT_FILEnum;	pEDIT_FILEnum = -1;

			pEDIT_LINEpos = pEDIT_LINE - 14;
			if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;
		}
	}

	if(pEDIT_step == 6)
	{
		pEDIT_Display = 0;	pEDIT_step = 1;

		CircleMsg("Delete");
		SquareMsg("Copy");

	}

	if(pEDIT_step == 7)
	{
		MoveLines(50, pEDIT_PLAYnum);

		UpdateLines(PLAYNAME_X, pos, 50, pEDIT_PLAYnum);

		if(EditPadData & JPADx)
		{
			PlayEffect(PRESS_SOUND);

			pEDIT_step = 1;

			pEDIT_PLAYnum = pEDIT_LINE;

			pEDIT_LINE = pEDIT_FILEnum;	pEDIT_FILEnum = -1;

			pEDIT_LINEpos = pEDIT_LINE - 14;
			if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;

			pEDIT_LINEpos |= 0x8000;
		}

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);

			UpdatePLAYFile(0, 0);

			pEDIT_step = 0;

			PrintCenterWText(PromptStr1, 44, "Choose Block to SAVE to");

			pEDIT_LINE = pEDIT_FILEnum;	pEDIT_FILEnum = -1;

			pEDIT_LINEpos = pEDIT_LINE - 14;
			if((Sint16)pEDIT_LINEpos < 0) pEDIT_LINEpos = 0;

			pEDIT_LINEpos |= 0x8000;
		}
	}

	return(FALSE);
}




int ProcPlayEditor(void)
{
	Sint16 count;
	Uint16 sum = 0;

	char *cel = (char *)*BACK_CEL + 4;
	Sint16 posx,posy;
	Sint16 Select = 0;
	Uint16 Done = 0;
	Uint8	*dst;

	EditPadData = JpadTrig[EditPad];


	//pEDIT_Doing = TITLE;
	//pEDIT_Doing = MENU;
	//pEDIT_Doing = PLAYEDITOR;

	pEDIT_Doing = -1;

	InitMain();

	while(!Done) {

//		JimmyLogo(8);

		PriorityLevel = 60;		// Use to support 'drawing ordered' priority (as on Saturn version)

		EditPadData = JpadTrig[EditPad];
		JpadRepeatFreq = 16;

		if(!CheckCard(CardPort, CardBank)) return(-1);

		DrawSync(0);

		RandomNUM(1);			// Keep rand generator ticking over ...

		ReadProfileValue(1);

		switch(pEDIT_Doing) {
			Sint8 answer;

			case MAIN:
				DoMain();

				if(EditPadData & JPADtriangle)
				{
					Done = 1;
					PlayEffect(PRESS_SOUND);
				}
				break;

			case CREATE:
				DoCreate();
				ReadProfileValue(2);
				break;

			case EDIT:
				DoEdit();
//				BuildPlayBitmap(SCREEN_TEMPLATE5, 1, pEDIT_LINE);
				ReadProfileValue(2);
				break;

			case NAMEPLAY:
				if(answer = DoName(10))
				{
					if(answer > 0)
					{
						strcpy(pEDIT_ThePLAY.Name, TheNAME_TXT);

						pEDIT_LINEpos = 0;	pEDIT_FILEedit |= 0x8000;

						pEDIT_CreateEdit = CREATE;

						InitFile(1);
					}
					else {
						if(pEDIT_Doing == CREATE) ResetCreate();

						if(pEDIT_Doing == EDIT) InitEdit();
					}
				}
				else {
					if(EditPadData & JPADx)
					{
						PrintCenterWText(TextStr, 44, TheNAME_TXT);
						PlayEffect(PRESS_SOUND);
					}
				}
				break;

			case FILE:
				DoFile();
				break;

			case NAMEFILE:
				if(answer = DoName(10))
				{
					if(answer > 0)
					{
						pEDIT_Doing = FILE;	pEDIT_step++;
					}
					else {
						pEDIT_Doing = FILE;

						PrintCenterWText(PromptStr1, 44, "Choose Block to SAVE to");

						pEDIT_LINEpos |= 0x8000;
					}
				}
				else {
					if(EditPadData & JPADx)
					{
						PrintWIDEText(Lines[pEDIT_LINE - pEDIT_LINEpos],
							TheNAME_TXT);
						PlayEffect(PRESS_SOUND);
					}
				}
				break;

			case QUESTION:
				DoYesNo();
				break;
		}


		ReadProfileValue(3);

		if(pEDIT_Display)
		{

			for(count = 6; count >= 1; count--)
			{
				if(count != pEDIT_ThePLAY.BallCarrier &&
					count != pEDIT_ThePLAY.Third)
				{
					DisplayPLAYER(count);

					if(pEDIT_ThePLAY.Bitmap[count] != ANone)
						DisplayARROW(count);
				}
			}

			if(pEDIT_ThePLAY.Third >= 0)
			{
				DisplayPLAYER(pEDIT_ThePLAY.Third);

				DisplayARROW(pEDIT_ThePLAY.Third);
			}

			DisplayPLAYER(0);

			if(pEDIT_ThePLAY.BallCarrier >= 1)
			{
				DisplayPLAYER(pEDIT_ThePLAY.BallCarrier);

				DisplayARROW(pEDIT_ThePLAY.BallCarrier);
			}

			if(pEDIT_ThePLAY.Bitmap[0] != ANone)
				DisplayARROW(0);


			if(pEDIT_player >= 0)
			{
				posx = PEXOFF-8;
				posy = -70;

				posx += FORMS_arrowX[pEDIT_ThePLAY.Formation][pEDIT_player] * 2;
				posy += FORMS_arrowY[pEDIT_ThePLAY.Formation][pEDIT_player] * 2;

				template[SCREEN_TEMPLATE].action[8] &= DISPLAY^0xFFFF; //hide cursors
				template[SCREEN_TEMPLATE].action[9] &= DISPLAY^0xFFFF; //hide cursors

				template[SCREEN_TEMPLATE].action[CursorTable[pEDIT_player]] |= DISPLAY; /*activate cursor*/

				MovePolyToXY(&template[SCREEN_TEMPLATE].poly[CursorTable[pEDIT_player]],posx,posy);

			}

		}

		ReadProfileValue(4);

		DoFrameLoop(1, Shell_Frame_PLED);
	}

	return(0);
}


void PrintCenterWText(int stringid, Sint16 x, char* string)
{
//	if(stringid)
//	{
		CenterString(stringid, string, 256);
		ChangeString(stringid, string, FONT0 | PROPORTIONAL);
//	}

	return;
}

void PrintWIDEText(int stringid, char* string)
{
//	if(stringid)
//	{
		ChangeString(stringid, string, FONT0 | PROPORTIONAL);
//	}
	return;
}


void InitPlayEditor(void)
{
	Arrows_MFile = Shell_MFile = (unsigned long *)LoadCDFile("/shells/pled/played.mfl");
	DebugPrintf(0,"played.mfl loaded into %x\n", Shell_MFile);

	FreeAllDialogBoxes();

	/*Set graphics mode*/
	initVRamHandling();

	LoadBackgroundCD(0,"/shells/bkg/pledbak.tim");	// Load & free from memory

	/*Load Fonts*/
	InitFonts();
	Register_Font_Cluts();
	LoadFont("fontdpc4.tim", 3);

//	pEDIT_PLAYS = (PLAYEDIT *)AllocMem( (sizeof(PLAYEDIT)*24));

	Paint_PLED_Screen();

	return;
}


/********************************************************
Paints the main screen
*********************************************************/
int Paint_PLED_Screen()
{
	char *ptr;

	int i;

	/*load the shell graphics template files*/
	InitTemplates();
	multifile = Shell_MFile;
	LoadTemplate("screen.llx");     /*0-controls*/
	LoadTemplate("screen2.llx");    /*1-field*/
	LoadTemplate("screen3.llx");    /*2-field*/
	LoadTemplate("screen4.llx");    /*3-field*/
	LoadTemplate("screen5.llx");    /*3-field*/
	LoadTemplate("arrows.llx");     /*4-arrows*/


//	LoadJimmy();

	/*hide the controls not needed in the start*/

	for (i=0; i<11; i++)
	{
		template[SCREEN_TEMPLATE].action[i] ^= DISPLAY;		/*hide stuff*/
		if(i<7)	ScalePolyWH(&template[SCREEN_TEMPLATE].poly[i], 0x20000, 0x20000);
	}

//	for (i=0; i<2; i++)
//	{
//		template[SCREEN_TEMPLATE2].action[EDITPANEL1+i] ^= DISPLAY;
//		setSemiTrans(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+i], 1);
//	}

	template[SCREEN_TEMPLATE2].action[EDITPANEL1] &= DISPLAY^0xFFFF;		/*hide menu panel */
	template[SCREEN_TEMPLATE2].action[EDITPANEL2] &= DISPLAY^0xFFFF;		/*hide menu panel */

//	CopyPoly(SCREEN_TEMPLATE2, EDITPANEL1);
//	CopyPoly(SCREEN_TEMPLATE2, EDITPANEL2);

	template[SCREEN_TEMPLATE2].action[SQUARE_POLY] ^= DISPLAY;	/*hide inactive buttons*/
	template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] ^= DISPLAY;
	template[SCREEN_TEMPLATE2].action[YESNOWIN] ^= DISPLAY;

//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[CROSS_POLY],40-256,BUTTONS_Y-120);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[TRIANGLE_POLY],140-256,BUTTONS_Y-120);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[SQUARE_POLY],240-256,BUTTONS_Y-120);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[CIRCLE_POLY],340-256,BUTTONS_Y-120);

	template[SCREEN_TEMPLATE3].action[ASCIIPANEL] ^= DISPLAY;/*hide ascii panel */
	template[SCREEN_TEMPLATE3].action[RFIELD] ^= DISPLAY;	/*hide rfield*/
	template[SCREEN_TEMPLATE5].action[LFIELD] ^= DISPLAY;	/*hide lfield*/

	template[SCREEN_TEMPLATE5].action[1] ^= DISPLAY;	// hide small field trans layer
	template[SCREEN_TEMPLATE4].action[3] ^= DISPLAY;	// hide small field background

	template[SCREEN_TEMPLATE4].action[0] ^= DISPLAY;		/*hide play man. menu */
	template[SCREEN_TEMPLATE4].action[1] ^= DISPLAY;		/*hide menu inactive arrow*/
	template[SCREEN_TEMPLATE4].action[2] ^= DISPLAY;		/*hide menu inactive arrow*/

	/*Print the instruction strings*/

	CrossPtr    = CreateString(BLANK_BUTTON_PROMPT, fontdpc4,        20, 50, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[CrossPtr], FontClutIDs[PEN_WHITE]->CLUT_ID);
	ChangeStringDepth(strings.string[CrossPtr], 60);

	CirclePtr   = CreateString(BLANK_BUTTON_PROMPT, fontdpc4,    20, 90, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[CirclePtr], FontClutIDs[PEN_WHITE]->CLUT_ID);
	ChangeStringDepth(strings.string[CirclePtr], 60);

	SquarePtr   = CreateString(BLANK_BUTTON_PROMPT, fontdpc4, 20, 130, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[SquarePtr], FontClutIDs[PEN_WHITE]->CLUT_ID);
	ChangeStringDepth(strings.string[SquarePtr], 60);

	TrianglePtr = CreateString(BLANK_BUTTON_PROMPT, fontdpc4, 20, 170, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[TrianglePtr], FontClutIDs[PEN_WHITE]->CLUT_ID);
	ChangeStringDepth(strings.string[TrianglePtr], 60);

	CtrlPtr     = CreateString(BLANK_BUTTON_PROMPT, fontdpc4, 20, 210, FONT0 | PROPORTIONAL);
	ChangeStringDepth(strings.string[CtrlPtr], 60);

	/*print the blank strings*/
	/*prompt*/

	PromptStr1 = CreateString(BLANK_PROMPT, fontdpc4, PROMPTSTR1_X, PROMPTSTR1_Y, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[PromptStr1], FontClutIDs[PEN_WHITE]->CLUT_ID);

	PromptStr2 = CreateString(BLANK_PROMPT, fontdpc4, PROMPTSTR1_X, PROMPTSTR1_Y+12, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[PromptStr2], FontClutIDs[PEN_WHITE]->CLUT_ID);

	PromptStr3 = CreateString(BLANK_PROMPT, fontdpc4, PROMPTSTR1_X, PROMPTSTR1_Y+12, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[PromptStr2], FontClutIDs[PEN_WHITE]->CLUT_ID);

	// Setup playeditor strings to accomodate ported Saturn code

	CrossStr = CreateString(SELECT_MSG, fontdpc4, 40+28, BUTTONS_Y, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[CrossStr], FontClutIDs[PEN_WHITE]->CLUT_ID);

	TriangleStr = CreateString(BACK_MSG, fontdpc4, 140+28, BUTTONS_Y, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[TriangleStr], FontClutIDs[PEN_WHITE]->CLUT_ID);

	CircleStr = CreateString("      ", fontdpc4, 340+28, BUTTONS_Y, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[CircleStr], FontClutIDs[PEN_WHITE]->CLUT_ID);
//	ChangeStringDepth(strings.string[CircleStr], 60);

	SquareStr = CreateString("       ", fontdpc4, 240+28, BUTTONS_Y, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[SquareStr], FontClutIDs[PEN_WHITE]->CLUT_ID);
//	ChangeStringDepth(strings.string[SquareStr], 60);

	Questions[0] = CreateString("      ", fontdpc4, 0, 20*16, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[Questions[0]], FontClutIDs[PEN_WHITE]->CLUT_ID);

	Questions[1] = CreateString("      ", fontdpc4, 0, 21*16, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[Questions[1]], FontClutIDs[PEN_WHITE]->CLUT_ID);

	MenuStr[0] = CreateString("                      ", fontdpc4, 160, 104, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[MenuStr[0]], FontClutIDs[PEN_WHITE]->CLUT_ID);

	MenuStr[1] = CreateString("                      ", fontdpc4, 160, 120, FONT0 | PROPORTIONAL);
	ChangeStringCLUT(strings.string[MenuStr[1]], FontClutIDs[PEN_WHITE]->CLUT_ID);

	AsciiCharStr = CreateString("      ", fontdpc4, 600, 0, FONT0 | PROPORTIONAL);

	for(i=0; i<39; i++)
	{
		GridStr[i] = CreateString(pEDIT_NAME[i].Text, fontdpc4, OFFSCREEN, 0, FONT0 | PROPORTIONAL);
	}

	for (i = 0; i < 32; i++)
	{
		Lines[i] = CreateString("              ",
								 fontdpc4, 600, 20+(i*16),
								 FONT0 | PROPORTIONAL);
	}

	TextStr = CreateString("                      ", fontdpc4, 0, 196, FONT0 | PROPORTIONAL);

//	AsciiCharStr = CreateString("     ", fontdpc4, 600, 0, FONT0 | PROPORTIONAL);

	HideFileMenu();

	return 0;

}


/*************************************************************************
 * FIELD FRAME - Callback function to setup the frame stuff...
 *************************************************************************/

int Shell_Frame_PLED()
{
//  DisplayDialogBox();
  UpdateBackground();
  DisplayAllStrings();
  DisplayShellPolys();
  return(1);
}


/*********************************************************
Cleans up everything
**********************************************************/
int CleanUp_PLED()
{

//  FreeMem(pEDIT_PLAYS);

//  FreeAllDialogBoxes();

  FreeTemplate(0);
  FreeTemplate(1);
  FreeTemplate(2);
  FreeTemplate(3);
  FreeTemplate(4);

//  FreeTemplate(8);			// Jimmy anim

  FreeFileData((char *)Shell_MFile);

  FreeFonts();

  FreeBackgrounds();

  return 0;
}


/*********************************************************
Position a string at X,Y
**********************************************************/

void SetStringXY(int string_num, int x, int y)
{
	ChangeStringABSXY(strings.string[string_num], x, y);
}


//*********************************************************

void HideEditor(void)
{
	int i;


	for (i=0; i<10; i++)
	{
		template[SCREEN_TEMPLATE].action[i] &= DISPLAY^0xFFFF; //hide form
	}

	for (i=0; i<7; i++)
	{
		template[ARROWS_TEMPLATE].action[i] &= DISPLAY^0xFFFF; //hide arrows
	}

	for (i=0; i<2; i++)
	{
		SetStringXY(Questions[i], OFFSCREEN, OFFSCREEN);
	}

	template[SCREEN_TEMPLATE5].action[LFIELD] &= DISPLAY^0xFFFF;	//hide field
	template[SCREEN_TEMPLATE3].action[RFIELD] &= DISPLAY^0xFFFF;	//hide field

//	template[SCREEN_TEMPLATE2].action[YESNOWIN] &= DISPLAY^0xFFFF; //hide yesno menu if still onscreen

	pEDIT_Display = 0;	// Turn draw flag off

	HideFileMenu();
}


//*********************************************************


void ShowEditor(void)
{
	int i;

	pEDIT_Display = 1;

	template[SCREEN_TEMPLATE5].action[LFIELD] |= DISPLAY;		/*show field*/
	template[SCREEN_TEMPLATE3].action[RFIELD] |= DISPLAY;		/*show field*/

	for (i=0; i<7; i++)
	{
		template[SCREEN_TEMPLATE].action[i] |= DISPLAY; 	/*show form*/
	}
}


//*********************************************************


void HideFileMenu(void)
{
	int i;

	FreeAllDialogBoxes();

//	template[SCREEN_TEMPLATE2].action[EDITPANEL1] &= DISPLAY^0xFFFF;		/*hide menu panel */
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2] &= DISPLAY^0xFFFF;		/*hide menu panel */
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] &= DISPLAY^0xFFFF;		/*hide menu panel */
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2+7] &= DISPLAY^0xFFFF;		/*hide menu panel */

	template[SCREEN_TEMPLATE5].action[1] &= DISPLAY^0xFFFF;		/*hide small field trans layer */
	template[SCREEN_TEMPLATE4].action[3] &= DISPLAY^0xFFFF;		/*hide small field*/

	for (i=0; i<32; i++) SetStringXY(Lines[i], 600, 0);	//move all file menu strings offscreen until needed

//	template[SCREEN_TEMPLATE2].action[EDITPANEL] &= DISPLAY^0xFFFF;	// hide panel

}


//*********************************************************

void ShowFileMenu(void)
{
	int i;

	HideEditor();

	SetStringXY(AsciiCharStr, 600, 200);				// Get ascii cursor off screen

	FreeAllDialogBoxes();
	PopupDialogBox(154, FILEPANEL_Y-8, 172, 150, 2, 0x40, 0x40, 0x50);
	PopupDialogBox(334, FILEPANEL_Y-8, 172, 150, 2, 0x40, 0x40, 0x50);

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1], 180, 150);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1], 150-256, FILEPANEL_Y);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1] |= DISPLAY;	// show panel

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL2], 180, 150);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL2], 328-256, FILEPANEL_Y);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2] |= DISPLAY;	// show panel

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+7], 180, 150);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL1+7], 150-256, FILEPANEL_Y);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL1+7] |= DISPLAY;	// show panel

//	ChangeABSPolyWH(&template[SCREEN_TEMPLATE2].poly[EDITPANEL2+7], 180, 150);
//	MovePolyToXY(&template[SCREEN_TEMPLATE2].poly[EDITPANEL2+7], 328-256, FILEPANEL_Y);
//	template[SCREEN_TEMPLATE2].action[EDITPANEL2+7] |= DISPLAY;	// show panel

	template[SCREEN_TEMPLATE5].action[1] |= DISPLAY;	// show small field trans layer
	template[SCREEN_TEMPLATE4].action[3] |= DISPLAY;	// show small field background

	for (i=0; i<2; i++) PrintCenterWText(MenuStr[i], 256, "             ");

//	template[SCREEN_TEMPLATE2].action[YESNOWIN] &= DISPLAY^0xFFFF; //hide yesno menu if still onscreen

	for (i=0; i<2; i++)
	{
		SetStringXY(Questions[i], OFFSCREEN, OFFSCREEN);
	}

	for (i=7; i<10; i++)
	{
		template[SCREEN_TEMPLATE].action[i] &= DISPLAY^0xFFFF; /*hide cursors*/
	}

	template[SCREEN_TEMPLATE2].action[SQUARE_POLY] &= DISPLAY^0xFFFF;	/*hide inactive buttons*/
	template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] &= DISPLAY^0XFFFF;

	SetStringXY(CircleStr, OFFSCREEN, BUTTONS_Y);		// Offscreen
	SetStringXY(SquareStr, OFFSCREEN, BUTTONS_Y);		// Offscreen

	PrintCenterWText(CrossStr, 4, SELECT_MSG);
	SetStringXY(CrossStr, CROSS_X, BUTTONS_Y);
}


//*********************************************************
// Write all play names & play data to file
//*********************************************************


int BackUpWrite(char *fname, char *comment,	void *data, long size, char exists)
{
	char sjisstr[60];

	int i;
	int error;

	String2SJIS(comment, (unsigned short *)sjisstr);

	for (i=0; i<24; i++)
	{
		if(pEDIT_PLAYS[i].Formation != -1)
		{
			strcpy(Workbuffer+(i*14), pEDIT_PLAYS[i].Name);
		}
		else *(Workbuffer+(i*14)) = NULL;
	}

	memcpy(Workbuffer+(24*14), data, size);

//	OpenFile(data, size, 0, CardSlot, fname, comment);

	DebugPrintf(0,"File %s opened for write ..\n",fname);

	error = OpenFile(Workbuffer, size+(24*14), CardPort, CardBank, fname, sjisstr);

//	GetPlayEditFiles();

//	InitFile(1);
	pEDIT_PLAYnum = UpdatePLAYFile(0, 0);

	DebugPrintf(0,"File %s written ..\n",fname);

	return(error);	// dummy return until we get some sort of status result back ???
}


//***********************************************************
// Read file (strings, plays) and move plays into destination
//***********************************************************


int BackUpRead(char *fname, void *buffer)
{
	int i,j,x,tries = 3;
	int boxnum;
	unsigned char *ptr;

	if(pEDIT_CreateEdit == 1 || pEDIT_CreateEdit == -1 || pEDIT_LINE != pEDIT_FILES - 1)
	{
		boxnum = DialogBoxMessage(256, 52, "Reading Memory Card");
//		PopupDialogBox(200, 52, 320, 90, 2, 0x50, 0x10, 0x10);
//		DoFrameLoop(1, Shell_Frame_PLED);	//
//		DoFrameLoop(1, Shell_Frame_PLED);	// Do 2 frames
		do {
			j = ReadFile((unsigned short *)Workbuffer, CardPort, CardBank, fname);
		} while(j && --tries);
		FreeDialogBox(boxnum);
		PopString(NumStrings-1);
	}
	else j = -1;


	switch(j)
	{
		case  0:	memcpy(buffer, Workbuffer+(24*14), sizeof(PLAYEDIT)*24);
					break;

		case -1:	ClearAllPlays();
					break;
	}

	return(j);
}


//***********************************************************
//***********************************************************
//***********************************************************


int ReadNamesOnly(char *fname, void *buffer)
{
	int i;
	int error=-1, ercount = 3;

	memset(Workbuffer,0,24*14);		// Clear names buffer in case of file error or missing card

	while(error && ercount)
	{
		error = ReadPlayHeader((unsigned short *)Workbuffer, CardPort, CardBank, fname);

		if(error) ercount--;	// we'll try to read up to 3 times before exiting
	}

	for(i=0; i<24; i++)
	{
		if(*(Workbuffer+(i*14)))
		{
			strcpy(pEDIT_PLAYS[i].Name,Workbuffer+(i*14));
			pEDIT_PLAYS[i].Formation = 0;					// anything but -1 will work for display purposes
		}
		else pEDIT_PLAYS[i].Formation = -1;
	}
}

//*********************************************************
// Simply move all play strings offscreen (x=600)
//*********************************************************

void ClearPlayNames(void)
{
	int count;

	for(count = 0; count < 16; count++)
	{
		SetStringXY(Lines[16 + count], OFFSCREEN, 0);
		ChangeStringCLUT(strings.string[Lines[16 + count]], FontClutIDs[PEN_WHITE]->CLUT_ID);
//		PrintWIDEText(Lines[16 + count], " ");
		LINES_TXT[50+count][0] = 0;

	}
}


//*********************************************************
// Lower-2-Upper case conversion
//*********************************************************

void Toupper(char *string)
{
	int i=0;

	while (string[i])
	{
		if(string[i]>0x40 && string[i]<0x80) string[i]&=0xFF^0x20;
		i++;
	}
}


void CircleMsg(char *msg)
{
	PrintWIDEText(CircleStr, msg);
	SetStringXY(CircleStr, CIRCLE_X, BUTTONS_Y);
	template[SCREEN_TEMPLATE2].action[CIRCLE_POLY] |= DISPLAY;
}

void SquareMsg(char *msg)
{
	PrintWIDEText(SquareStr, msg);
	SetStringXY(SquareStr, SQUARE_X, BUTTONS_Y);
	template[SCREEN_TEMPLATE2].action[SQUARE_POLY] |= DISPLAY;
}


void ClearYesNo(void)
{
//	template[SCREEN_TEMPLATE2].action[YESNOWIN] ^= DISPLAY;
	SetStringXY(Questions[0], OFFSCREEN, YESNO_Y+20);
	SetStringXY(Questions[1], OFFSCREEN, YESNO_Y+20);
	PrintCenterWText(PromptStr3, 44, BLANK_PROMPT); // Erase prompt
	SetStringXY(PromptStr1, PROMPTSTR1_X, PROMPTSTR1_Y);	// Put prompt back center

	FreeDialogBox(YNBox);
}

//****************************************************************
//****************************************************************
//****************************************************************
/*

Uint16 Formation_LINES[] = {
	5, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 3,

	4, 4, 4, 4, 4, 2,

	0,0,0,0,

	1, 1
};


Uint16 SORTFormation_LINES[2][2][7];

Uint16 SORTdFormation[2][7][30];
Uint16 SORToFormation[2][7][30];
*/


/* SORT TEAM FORMATIONS BY PLAYTYPES */

/*

void SORToFormations(Uint16 formation, Uint16 team)
{
	Uint16 numoff = (Formation_LINES[formation] * 3);
	Uint16 plays;

	Uint16 *formptr = (Uint16 *)GetPlaysPerForm(formation);

	if(numoff)
	{
		for(plays = 0; plays < numoff; plays++)
		{
			Uint16 play = *(formptr + plays);
			Uint16 playtype = ThePlays[play].PlayTypeDesignator - 1;

			SORToFormation[team][playtype]
				[SORTFormation_LINES[0][team][playtype]++] = play;
		}
	}
}


void SORToGOPTIONS(Uint16 team, Uint16 page)
{
	Sint16 plays = SORTFormation_LINES[0][team][page];
	Uint16 count;

	while(plays > 0) {plays -= 3;}

	plays = -plays;

	for(count = 0; count < plays; count++)
	{
		SORToFormation[team][page][SORTFormation_LINES[0][team][page]++] =
			SORToFormation[team][page][count];
	}

	SORTFormation_LINES[0][team][page] /= 3;
}


void SORTdFormations(Uint16 formation, Uint16 team)
{
	Uint16 numoff = (Formation_LINES[formation] * 3);
	Uint16 plays;

	Uint16 *formptr = (Uint16 *)GetPlaysPerForm(formation);

	if(numoff)
	{
		for(plays = 0; plays < numoff; plays++)
		{
			Uint16 play = *(formptr + plays);
			Uint16 playbits = ThePlays[play].PlayTypeDesignator >> 8;

			Uint16 playtype;

			for(playtype = 0; playtype < 7; playtype++)
			{
				if(playbits & 0x01) SORTdFormation[team][playtype]
						[SORTFormation_LINES[1][team][playtype]++] = play;

				playbits >>= 1;
			}
		}
	}
}

void SORTdGOPTIONS(Uint16 team, Uint16 page)
{
	Sint16 plays = SORTFormation_LINES[1][team][page];
	Uint16 count;

	while(plays > 0) {plays -= 3;}

	plays = -plays;

	for(count = 0; count < plays; count++)
	{
		SORTdFormation[team][page][SORTFormation_LINES[1][team][page]++] =
			SORTdFormation[team][page][count];
	}

	SORTFormation_LINES[1][team][page] /= 3;
}
*/


/* CREATE TEAM EDITED PLAYS */

/*
Sint32 pbase[2]={T0Edit0NUM,T1Edit0NUM};


void CREATEoEditPlays(Uint16 team)
{
	Uint32 formation;
	Uint32 nplay,count, fplays;
	Uint32 plays;
	Uint32 numoff = 0;
	Uint16 *formptr;
	Uint8 *from, *to;



	// Simply initialize edit play numbers

	formation =  TEAM0_EDIT_FORM_NUM + team;

	formptr = (Uint16 *)GetPlaysPerForm(formation);

	for(plays = 0; plays < 24; plays++)
			*(formptr + plays) = pbase[team]+plays;

	DebugPrintf(0,"%d = team\n",team);

	while(pEDIT_PLAYS[numoff+(team*24)].Formation >= 0 && numoff < (24)){ numoff++; }

	if(numoff)
	{
		fplays = 0;


		while (numoff%3)
		{
			PopPLAY(numoff-1+(team*24));
			numoff++;
			PushPLAY(numoff-1+(team*24));
		}

		for(plays = 0; plays < numoff; plays++)
		{
			formptr = (Uint16 *)GetPlaysPerForm(formation);

			if(plays < numoff)
				nplay = *(formptr + fplays);
			else
				nplay = *(formptr + (numoff-1));

			from	= (Uint8 *)&pEDIT_PLAYS[plays+(team*24)].ThePlay;
			to	= (Uint8 *)&ThePlays[nplay];

			SORToFormation[team][6]
				[SORTFormation_LINES[0][team][6]++] = nplay;

			strcpy(PlayNames[nplay], pEDIT_PLAYS[plays+(team*24)].Name);

			memcpy(to, from, sizeof(struct play));

			fplays++;
		}
	}

	// And finally terminate the list

	formptr = (Uint16 *)GetPlaysPerForm(formation);

	*(formptr + fplays) = -1;
}

*/

//***************************************************************************
// Create bitmap play image in RAM for edited plays
//***************************************************************************


/*
void CreateEditedBitmap(void)
{
	int count;


	while(pEDIT_PLAYS[i].Formation <= 0)
	{

		for(count = 6; count >= 1; count--)
		{
			if(count != pEDIT_ThePLAY.BallCarrier &&
					count != pEDIT_ThePLAY.Third)
			{
				MapPLAYER(count);

				if(pEDIT_ThePLAY.Bitmap[count] != ANone)
							MapARROW(count);
			}
		}

		if(pEDIT_ThePLAY.Third >= 0)
		{
			MapPLAYER(pEDIT_ThePLAY.Third);

			MapARROW(pEDIT_ThePLAY.Third);
		}

		MapPLAYER(0);

		if(pEDIT_ThePLAY.BallCarrier >= 1)
		{
			MapPLAYER(pEDIT_ThePLAY.BallCarrier);

			MapARROW(pEDIT_ThePLAY.BallCarrier);
		}

		if(pEDIT_ThePLAY.Bitmap[0] != ANone)
			MapARROW(0);

		}
	}
}
*/


//***************************************************************************

/*
char *bmap;
RECT rect;

void BuildPlayBitmap(Sint16 template, Sint16 polynum, int playnum)
{
	int count;
	PLAYEDIT *playptr;

	playptr = &pEDIT_PLAYS[playnum];


	if(TemplateBuff) bmap = (char *) TemplateBuff;
	else bmap = (char *)AllocMem(64 * 128);	// TEST ONLY

	memset(bmap, 0, 64*128);

	for(count = 6; count >= 1; count--)
	{
		if(count != playptr->BallCarrier &&
			count != playptr->Third)
		{
			LoadPLAYER(count, template, polynum, playptr);
			if(playptr->Bitmap[count] != ANone)
				LoadARROW(count, template, polynum, playptr);
		}
	}

	if(playptr->Third >= 0)
	{
		LoadPLAYER(playptr->Third, template, polynum, playptr);

		LoadARROW(playptr->Third, template, polynum, playptr);
	}

	LoadPLAYER(0, template, polynum, playptr);

	if(playptr->BallCarrier >= 1)
	{
		LoadPLAYER(playptr->BallCarrier, template, polynum, playptr);

		LoadARROW(playptr->BallCarrier, template, polynum, playptr);
	}

	if(playptr->Bitmap[0] != ANone)
		LoadARROW(0, template, polynum, playptr);

	LoadImage(&rect, (unsigned long *)bmap);

	DrawSync(0);

	if(!TemplateBuff) FreeMem(bmap);
}


//***************************************************************************


void LoadARROW(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr)
{
	char string[14];
	Sint16 bitmap = playptr->Bitmap[player];

	strcpy(string,ArrowNames[bitmap & 0x7fff]);
	strcat(string, ".CMP");

	ColorConvert[1]= (playptr->Color[player] << 1)+1;
	ColorConvert[2]= (playptr->Color[player] << 1)+2;

	CPUDraw(player, template_index, polynum,
				ARROWS_width[bitmap & 0x7fff] >> 1, ARROWS_height[bitmap & 0x7fff],
				playptr->ARROWposX[player] >> 1, playptr->ARROWposY[player],
				string, bitmap & 0x8000, TRUE);
}


//***************************************************************************


void LoadPLAYER(Uint16 player, Sint16 template_index, Sint16 polynum, PLAYEDIT *playptr)
{
	char string[14];
	char *buffer;
	Uint16 posx;
	Uint16 posy;


//	if(player == 6) playptr->FORMposY[player]--;

	if(playptr->Formation == FORMS_ISlot)
		sprintf(string, Sprite_FormNames[SpriteIS_FormBits[player]]);
	else
		sprintf(string, Sprite_FormNames[Sprite_FormBits[player]]);

	strcat(string, ".CMP");

	ColorConvert[1]= 1;
	ColorConvert[2]= 2;

	CPUDraw(player, template_index, polynum,
				PLAYERS_width[player] >> 1, 8,
				playptr->FORMposX[player] >> 1, playptr->FORMposY[player],
				string, FALSE, TRUE);
}


//***************************************************************************


void CPUDraw(Uint16 player, Sint16 template_index, Sint16 polynum, Sint16 w, Sint16 h, Sint16 posx, Sint16 posy, char *string, Uint16 flip, char colflag)
{
	Uint32 *clut;
	char *buffer1, *buffer2, *ptr1, *ptr2;
	char *wptr1, *wptr2;
	Sint16 i, j;
	Sint16 offset, buffwidth;

//	return;

	buffer1 = (char *)AllocMem(64 * 128);

	DecompressFrameBytes((unsigned long *)buffer1, GetMultiFilePtr(Arrows_MFile, string));

	rect.w = ((template[template_index].poly[polynum].u1 - template[template_index].poly[polynum].u0)+1) >> 2;
	rect.h = template[template_index].poly[polynum].v2 - template[template_index].poly[polynum].v0;

	rect.x = (template[template_index].poly[polynum].u0 >> 2) + template[template_index].vram->x;
	rect.y = template[template_index].poly[polynum].v0 + template[template_index].vram->y;


	buffwidth = ((template[template_index].poly[polynum].u1 - template[template_index].poly[polynum].u0)+1) >> 1;


	if(flip)
	{
		buffer2 = (char *)AllocMem(64 * 128);

		ptr1 = buffer1;


		for(j = 0; j < h; j++)
		{

			ptr2 = buffer2 + (((j+1) * w)-1);

			for(i = 0; i < w; i++)
			{

				if(ptr2 < buffer2+(64*128))
				{
					*ptr2 = (*ptr1 >> 4) | (*ptr1 << 4);
				}

				ptr1++;
				ptr2--;
			}
		}

		FreeMem(buffer1);

		buffer1 = buffer2;
	}


	if(colflag)
	{
		ptr1 = buffer1;

		for(j = 0; j < h*w; j++)
		{
			if(ptr1 < buffer1+(64*128))
				*ptr1 = ColorConvert[*ptr1 & 0x0F] | ColorConvert[*ptr1 >> 4] << 4;
			ptr1++;
		}
	}

	wptr1 = buffer1;

	for(j = 0; j < h; j++)
	{
		wptr2 = (bmap + posx + ((posy+j) * buffwidth));

		if(wptr2 > bmap)
		{

			for(i = 0; i < w; i++)
			{
				if(*wptr1)
				{
					if(*wptr1 & 0xF0)
					{
						*wptr2 &= 0x0F;
						*wptr2 |= *wptr1 & 0xF0;
					}

					if(*wptr1 & 0x0F)
					{
						*wptr2 &= 0xF0;
						*wptr2 |= *wptr1 & 0x0F;
					}
				}

				wptr1++;
				wptr2++;

			}

		}
	}

	FreeMem(buffer1);
}

*/

//***************************************************************************
// Gets a unique no. for current filename (Checks against files on current memcard)
//
// Returns no. to be appended to base filename
//***************************************************************************

int GetUniqueFnum(void)
{
	int i,j;
	char flag = 1;
	char fname[16];

	i = -1;

	while(flag)
	{
		i++;

		flag = 0;

//		sprintf(fname, "BASLUS-00071%02d", i);
		sprintf(fname, PLAYSFILE, i);

		for (j = 0; j < pEDIT_FILES; j++)
		{
			if(!strcmp(PE_MemFile[j].name,fname))
			{
				flag++;
				continue;
			}
		}
	}

	return(i);
}

//***************************************************************************
// Load a file from the Player Options menu
//

int LoadPlayFile(int team)
{
	int fileret=-1,retcode = 0;

	InitPlayEditor();

	template[SCREEN_TEMPLATE4].action[3] ^= DISPLAY;	// hide small field background

	Workbuffer = (char *)AllocMem( (sizeof(PLAYEDIT)*24) + (24 * 14) + 128); // Extra 128 bytes due to BUPRam being read in 128 byte blocks

	pEDIT_FLASH = 0;
	pEDIT_LINE = 0;
	pEDIT_LINEpos = 0x8000;
	pEDIT_CreateEdit = -1;
	pEDIT_FILEnum = -1;
	pEDIT_FILEedit = -1;

	pEDIT_Doing = FILE;
	pEDIT_step = 0;

	InitFile(0);			// read plays for 1st file

	OptFlag = TRUE;

	while(!retcode && EditPadData!=JPADx)
	{
		EditPadData = JpadTrig[EditPad];

		if((retcode = DoFile())== TRUE)
				fileret = BackUpRead(&PE_MemFile[pEDIT_LINE].name[0], &pEDIT_PLAYS[team*24]);

		if(EditPadData & JPADtriangle)
		{
			PlayEffect(PRESS_SOUND);
			EditPadData = JPADx;
		}

		DoFrameLoop(1, Shell_Frame_PLED);
	}

	if(!fileret && pEDIT_PLAYnum)	// if successful file read & there are actually some plays in it
	{
		CREATEoEditPlays(team);		// Setup edited plays for home or away
		SetEditedFlag(team);		//
		InitEditedFormations();
	}

	FreeMem(Workbuffer);

	CleanUp_PLED();

//	InitPlayerOpt();
}

//***************************************************************************


void InitPasswordBox(void)
{
	int i;

	TextStr = CreateString("                      ", fontdpc2, 0, 180, FONT0 | PROPORTIONAL);
	AsciiCharStr = CreateString("      ", fontdpc2, 600, 0, FONT0 | PROPORTIONAL);

	for(i=0; i<39; i++)
	{
		GridStr[i] = CreateString(pEDIT_NAME[i].Text, fontdpc2, OFFSCREEN, 0, FONT0 | PROPORTIONAL);
	}

	InitName(190);

	PopupDialogBox(146, 176, 220, 24, 2, 0x60, 0x00, 0x00);
}


//***************************************************************************


void PrintPassword(void)
{
	PrintCenterWText(TextStr, 44, TheNAME_TXT);
	strcpy(MemoryCardMimicPtr->password,TheNAME_TXT);
}


//***************************************************************************


void ClearPassword(void)
{
	TheNAME_TXT[0]=0;
}

//***************************************************************************

void ClearAllPlays(void)
{
	int i;

	for (i=0; i<24; i++)
	{
		pEDIT_PLAYS[i].Formation = -1;
	}
}

/*****************************END OF FILE PLEDSHL.C****************************/

