/*******************************************************************

				File: PSXPAD.H

	Updated by Christopher Deel

	Copyright 1995 GameTek, Inc.
	All rights reserved

*********************************************************************/

#ifndef	_PSXPAD_H
#define	_PSXPAD_H

#define PADID_CON     0x41
#define PADID_MOUSE   0x12
#define PADID_ANA     0x23
#define PADID_MULTI   0x80



/* ---- Fast JPAD defines (CGD) ---- */
#define JPADLup     (1<<12)
#define JPADLdown   (1<<14)
#define JPADLleft   (1<<15)
#define JPADLright  (1<<13)
#define JPADRup     (1<< 4)
#define JPADRdown   (1<< 6)
#define JPADRleft   (1<< 7)
#define JPADRright  (1<< 5)
#define JPADi       (1<< 9)
#define JPADj       (1<<10)
#define JPADk       (1<< 8)
#define JPADl       (1<< 3)
#define JPADm       (1<< 1)
#define JPADn       (1<< 2)
#define JPADo       (1<< 0)
#define JPADh       (1<<11)


#define JPADstart 		JPADh
#define JPADselect 		JPADk
#define JPADtriangle 	JPADRup
#define JPADx 			JPADRdown
#define JPADsquare 		JPADRleft
#define JPADcircle 		JPADRright
#define JPADRfront1		JPADl
#define JPADRfront2		JPADm
#define JPADLfront1		JPADn
#define JPADLfront2		JPADo


#define	JPADL_MASK		(JPADLup | JPADLdown | JPADLright | JPADLleft)
#define	JPADR_MASK		(JPADRup | JPADRdown | JPADRright | JPADRleft)

#define PADBUFFLEN    34

extern UWORD AnyPadData, AnyPadTrig; 	// Data from all pads ORed together
extern UWORD LastPad;
extern UWORD JpadData[8];	// Data from Joy pads
extern UWORD JpadPrev[8];  // Previos Data from Joy pads
extern UWORD JpadTrig[8];  // One shot data from joy pads
extern UBYTE JpadID[8];	// IDs of joypads  0=No pad
extern int JpadNeeded[8];
extern int MultiTapID[2];
extern WORD JpadRepeatFreq;

extern UBYTE gPadBuffer[2][PADBUFFLEN];


/* PSXPAD.C */
void InitPads ( int n );
void StopPads ( void );
void ReadPads ( void );
int RPadLeftRight ( int p );
int RPadUpDown ( int p );
int LPadLeftRight ( int p );
int LPadUpDown ( int p );
int PadHK ( int p );
int PadLN ( int p );
int PadMO ( int p );
int PadIJ ( int p );
int IsAnyButton ( void );
void WaitForButton ( void );
BOOL IsNewButton(void);
int IsAnyPadButton(USHORT mask);
void GetJpadData(Uint16 which, Uint16 count);	// JJ '97 compatibility reasons only
void FlushPads(void);

#ifdef SVECTOR
void GetPadxyz(char pad, char right, int mult, SVECTOR *vect);
#endif



#endif		//ifndef	_PSXPAD_H

/************************* End of File: PSXPAD.H   **********************/
