/*************************************************************************
 * SEASON.H - Written by Mike Heilemann
 *
 *	Contains Structures for Season Simulation, Includeing:
 *		Weeks in a Season
 *		Playoff Winners
 *		Season Schedule
 *************************************************************************/

#define NUM_GAMES_IN_SEASON 251	// Number of games in a season
#define NUM_SEASONS 32	// Max Number of different seasons we have
#define PASS_LENGTH 12


#define FULL_SEASON 		0
#define HALF_SEASON	 	1
#define QUARTER_SEASON	2
#define PLAYOFF_SEASON	3
#define BAD_PASSWORD		2

#define BY_GAME			-1
#define PLAYOFF_LOSS		-2

extern Sint32 PreSimGame;	// Didn't do CPU vs CPU, use stats
extern Sint16 SeasonMode;			// 0 = Password
extern Sint32 ByGame;

extern void RankTeams(void);
extern void DoPlayoffTree(void);
extern void UpdateWins(void);
extern short GetOpponent(short week, short team);
extern short InitNewSeason(void);
extern short ContinueRamSeason(signed char port, signed char bank, char seas_num);
extern short DoSeasonWeek(signed char port, signed char bank, char seas_num);

enum MonthNames{
	JAN,
	FEB,
	MAR,
	APR,
	MAY,
	JUN,
	JUL,
	AUG,
	SEP,
	OCT,
	NOV,
	DEC
};



typedef struct {
	char	month,		// Month
			day,		// Day of the month
			week,		// Week number of game
			away,		// Away Team number
			home;		// Home Team number
} schedule_t;


/***************************  End of File: Season.h  *****************/