#include <stdio.h>
#include <sys/types.h>

#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libsn.h>
#include <libgs.h>
#include "prjhdrs.h"

#include "fbgequ.h"
#include "fbequ.h"
#include "fbram.h"
#include "fbstats.h"
#include "fbforms.h"
#include "fbplays.h"
#include "shell.h"
#include "season.h"

//////////////////////////////////////////////////////////////
// tom moved this from shell.h

#define MEMCARD_MSG  "Insert Memory Card into Slot 1"

//////////////////////////////////////////////////////////////

//**************************************************************************
// Data structures & defines for menu system

#include "menu.h"
#include "fbmenu.h"

//**************************************************************************

#define	NEWSEAS_Y	100
#define	NEWSEAS_X	150
#define	NEWSEASITEMS	2

#define BAD_PASSWORD 2

extern int InitControl(int pad);
extern char *DpcName[2],*DpcNameClut[2];
extern memfile_t MemFile[16];
extern Sint16 CardSlot;
extern char Files[15][64];
extern Sint16 SeasonMode;
extern UBYTE ShadowPassword[];
extern signed char WeekNum, playoff_loss;

/*************************************************************************/

int IntSeasonShell(void);
int InitContSeasonMenu(void);
int InitNewSeasonMenu(void);
//int TermNewSeasonMenu(void);
int MainSeasonMenu(void);
int TermSeasonMenu(void);

MenuItem NewSeasonItemList[] = {
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, NEWSEAS_X, NEWSEAS_Y+0   ,  "Start RAM Card Season",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, NEWSEAS_X, NEWSEAS_Y+15   , "Start Password Season",NULL,
		END_MENU
};


MenuObj	NewSeasonMenu = {
	(MenuItem *)NewSeasonItemList,
	InitNewSeasonMenu,
	TermSeasonMenu,
	MainSeasonMenu,
	0, 0, 512, 240,
};


MenuItem ContSeasonItemList[] = {
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, NEWSEAS_X-20, NEWSEAS_Y+0   ,  "Continue RAM Card Season",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, NEWSEAS_X-20, NEWSEAS_Y+15   , "Continue Password Season",NULL,
		END_MENU
};



MenuObj	ContSeasonMenu = {
	(MenuItem *)ContSeasonItemList,
	InitContSeasonMenu,
	TermSeasonMenu,
	MainSeasonMenu,
	0, 0, 512, 240,
};


static Sint16 NumFiles;
static char fname[64];



//**************************************************************************


int InitNewSeasonMenu(void)
{
	char *ptr;
	Sint32 i,j;

	initVRamHandling();

  /*initialize the background for the shell*/

	LoadBackgroundCD(0,"/shells/bkg/loadseas.tim");	// Load & free from memory

  /*Init the multifile pointers*/

	Shell_MFile = (unsigned long *)LoadCDFile("/shells/stats/season.mfl");
	DebugPrintf(0,"season.mfl loaded into %x\n", Shell_MFile);

  /*Set graphics mode*/

	SetupFont("fontdpc2.tim");

  /*load the shell graphics template files*/

	InitTemplates();
	multifile = Shell_MFile;

	LoadTemplate("season.llx");

	/* Set global joypad delay */

	JpadRepeatFreq = 20;

	MenuItemNum = 0;
	Flash = 0;

	MenuCursorY = NEWSEAS_Y;
	MenuCursorX = NEWSEAS_X;

	ScrollYLimit = 0;

	for(i=0; i<11; i++)
		for(j=0; j<2; j++)
			MemoryCardMimicPtr->GameScores[i][j] = -1;

	InitControl(-1);

	PopupDialogBox(NEWSEAS_X- 16, NEWSEAS_Y, 250, 13, 2, 0x00, 0x50, 0x50);

	return(0);
}



//**************************************************************************


int InitContSeasonMenu(void)
{
	char *ptr;

	MenuFadeFlag = FALSE;

	initVRamHandling();

  /*initialize the background for the shell*/

	LoadBackgroundCD(0,"/shells/bkg/loadseas.tim");	// Load & free from memory

  /*Init the multifile pointers*/

	Shell_MFile = (unsigned long *)LoadCDFile("/shells/stats/cseason.mfl");
	DebugPrintf(0,"cseason.mfl loaded into %x\n", Shell_MFile);


  /*Set graphics mode*/

	SetupFont("fontdpc2.tim");

  /*load the shell graphics template files*/

	InitTemplates();
	multifile = Shell_MFile;

	LoadTemplate("cseason.llx");

	/* Set global joypad delay */

	JpadRepeatFreq = 20;

	MenuItemNum = 0;
	Flash = 0;

	MenuCursorY = NEWSEAS_Y;
	MenuCursorX = NEWSEAS_X;

	ScrollYLimit = 0;

	InitControl(-1);

	PopupDialogBox(NEWSEAS_X-30, NEWSEAS_Y, 266, 13, 2, 0x50, 0x00, 0x50);

	return(0);
}


//**************************************************************************


int TermSeasonMenu(void)
{
	Std_Menu_CleanUp();
	MenuFadeFlag = TRUE;
	DumpHeap();
	return(0);
}


//**************************************************************************

int MainSeasonMenu(void)
{
	int retcode = 0;
	int i, color, done=0, size = 0;
	char s[40];


	MenuTxt_Yoffset = 0;	// Don't permit screen to scroll

	SetHighlight();

	switch (retcode = InputHandler(NEWSEAS_Y, NEWSEAS_Y+15))
	{
		case CROSS:		retcode = 1;
						break;
		case TRIANGLE:	retcode= -1;
						break;
		default:		retcode = 0;
	}


	if(retcode == 1)
	{
		switch(MenuItemNum)
		{
			case 0:
					// CONTINUE SEASON - Be sure file exists
					if (SeasonMode == -2)
					{
						if (!GetCardBank())	// If no card display message
						{
							TimedMessageXY(256, 62, 5, MEMCARD_MSG);
							return(0);
						}

						GetFiles(0, CardSlot);
						sprintf(s, "%s%d", SEASONFILE, 0);
						for (i = 0; i < 15; i++)
						{
							if (!strcmp(s, MemFile[i].name))
							{
								SeasonMode = 1;		// RAM card season
								return(retcode);
							}
						}
						TimedMessageXY(256, 62, 5, "Season File not found");
						retcode = 0;
					}
					else
					// NEW SEASON - Prompt for overwrite & card insertion
					if (SeasonMode == -1)
					{
						if (i = CheckSeasonFile())
						{
							retcode = 0;

							if(i == -1)
								TimedMessageXY(256, 62, 4, MEMCARD_MSG);
						}
						else
						{
							GetFiles(0, CardSlot);
							for (i = 0; i < 15; i++)
								if (MemFile[i].blocks)
									size += MemFile[i].blocks;
								else
									break;

							sprintf(s, "%s%d", SEASONFILE, 0);
							if (CheckFile(0, CardSlot, s))	// if season exists
								size -= 3;

							if (size > 12)
							{
								TimedMessage(5, CARD_SPACE_ERROR);
								return(0);
							}
							SeasonMode = 1;		// RAM card season
						}
					}
					break;

			case 1:
					if(SeasonMode == -1)
					{
						SeasonMode = 0;		// Set to password
					}
					else
					{
						ResetStrings();
						FreeAllDialogBoxes();
						DoMenuStrip();
						InitPasswordBox();
						ClearPassword();
						done = 0;

						while(!done)
						{
//							AnyPads = GetAllPads(8);
							GetAllPads(8);
							done = DoName(15);
							DoFrameLoop(1, Std_Menu_Frame);
							PrintPassword();
						}

						if(done > 0 && !ParsePassword(MemoryCardMimicPtr->password))
						{
							SeasonMode = 0;		// Password season
							ResetStrings();
							DrawMenu(CurMenu);
						}
						else
						{
							retcode = 0;
						}

						FreeDialogBox(0);
						FreeDialogBox(1);
						PopupDialogBox(NEWSEAS_X-30, NEWSEAS_Y, 266, 13, 2, 0x50, 0x00, 0x50);
						DoMenuStrip();
					}
					break;
		}
	}

//	MoveDialog(0, MenuCursorX-16, MenuCursorY);				// Move to X, Y
	MoveDialog(0, dialog[0].poly[4].x0+256, MenuCursorY);				// Move to X, Y

	return(retcode);
}


//**************************************************************************


int CheckSeasonFile(void)
{
	int i , j, error = 0;
	char s[40];


	NumFiles = 0;

	if(!GetCardBank()) return(-1);

	sprintf(s, "%s%d", SEASONFILE, 0);
	if (!PromptForOverwrite(0, CardSlot, 256, 62, s))
		error = 1;

	return(error);
}

/****************************************************************************/

int DisplayNewSeasonMenu(void)
{
	return(Display_Menu(NEWSEASON_MENU));
}

/****************************************************************************/

int DisplayContSeasonMenu(void)
{
	int retcode = 0;

	while(!retcode)
	{
		retcode = Display_Menu(CONTSEASON_MENU);

		if(retcode != -1)
		{
			ByGame = ContinueSeason();
			if(ByGame == 1 || ByGame == 2) retcode = 0;
		}
	}

	return(retcode);
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/


#define CONTOPT_X 200
#define CONTOPT_Y 100

MenuItem ContOptSeasonItemList[] = {
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, CONTOPT_X+10, CONTOPT_Y+0   ,  "Play Game",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, CONTOPT_X+10, CONTOPT_Y+15   , "View Team",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, CONTOPT_X+10, CONTOPT_Y+30   , "Standings",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, CONTOPT_X-8, CONTOPT_Y+45   , "NFL Schedule",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, CONTOPT_X-16, CONTOPT_Y+60   , "League Leaders",NULL,
		ACTIVE	| MENU_ITEM | HI_YELLOW | PEN_WHITE | DIM_YELLOW, CONTOPT_X+2, CONTOPT_Y+75   , "Exit Season",NULL,
		END_MENU
};

int MainContOptSeasonMenu(void);
int InitContOptSeasonMenu(void);


MenuObj	ContOptSeasonMenu = {
	(MenuItem *)ContOptSeasonItemList,
	InitContOptSeasonMenu,
	TermSeasonMenu,
	MainContOptSeasonMenu,
	0, 0, 512, 240,
};



//**************************************************************************

int InitContOptSeasonMenu(void)
{
	char *ptr;

	initVRamHandling();

  /*initialize the background for the shell*/

	LoadTeamPic(HumanTeamNum);

  /*Init the multifile pointers*/

	Shell_MFile = (unsigned long *)LoadCDFile("/shells/stats/rseason.mfl");
	DebugPrintf(0,"cseason.mfl loaded into %x\n", Shell_MFile);


  /*Set graphics mode*/

	SetupFont("fontdpc2.tim");

  /*load the shell graphics template files*/

	InitTemplates();
	multifile = Shell_MFile;

//	LoadTemplate("rotseas1.llx");
//	LoadTemplate("rotseas2.llx");
//	LoadTemplate("rotseas3.llx");

	LoadTemplate("cseason.llx");

	LoadTemplate("nickname.llx");
	LoadNickname(HumanTeamNum, 1, 0);

	/* Set global joypad delay */

	JpadRepeatFreq = 20;

	MenuItemNum = 0;
	Flash = 0;

	MenuCursorX = CONTOPT_X;
	MenuCursorY = CONTOPT_Y;

	ScrollYLimit = 0;

	PopupDialogBox(MenuCursorX+40, MenuCursorY+1,160,12, 2, 0x30, 0x00, 0x30);

	if(!SeasonMode)
		PopupDialogBox(146, 196, 220, 24, 2, 0x60, 0x00, 0x00);

	return(0);
}


//**************************************************************************


int MainContOptSeasonMenu(void)
{
	int retcode;


//	Display_Rotate_Menu(6);

	MenuTxt_Yoffset = 0;	// Don't permit screen to scroll

	SetHighlight();

	if(!SeasonMode)
		PrintStringXYCenter(MemoryCardMimicPtr->password,256,200,PEN_WHITE);


	switch (retcode = InputHandler(CONTOPT_Y, CONTOPT_Y+(15*5)))
	{
		case CROSS:
						switch(MenuItemNum)
						{
							case 0: retcode = 1; break;
							case 1: retcode = 2; break;
							case 2: retcode = 3; break;
							case 3: retcode = 4; break;
							case 4: retcode = 5; break;
							case 5: retcode = 6; break;
						}

						if (retcode == 5)	// League leaders, check for card.
						{
							if (!SeasonMode)	// 0 = Password
							{
								TimedMessage(4, "League Leaders Not available in Password Mode");
								retcode = 0;
							}
							if (!GetCardBank())
							{
								TimedMessage(4, CARD_MISSING_ERROR);
								retcode = 0;
							}
						}
						break;
		case TRIANGLE:	retcode= -1;
						break;
		default:		retcode = 0;
	}

//	if(!SeasonMode)
//		PrintStringXYCenter(MemoryCardMimicPtr->password,256,180,PEN_WHITE);

	if(retcode == 1 && (WeekNum == 22 || playoff_loss))
	{
		EndSeasonMessage(playoff_loss == 0);
		retcode = 0;
	}

	MoveDialog(0,175,MenuCursorY);

	return(retcode);
}

//**************************************************************************


int DisplayContOptSeason(void)
{
	return(Display_Menu(CONTOPTSEAS_MENU));
}



