
//
//	shell.h
//

#include "shellsys.h"

// global variables

extern int CursorX,CursorY;

extern ShellObj **ShellObject;

// shell graphics objects by number

enum { HOMENAME,AWAYNAME,HOMEHELM,AWAYHELM,MENUTRIANGLE,MENUSQUARE,MENUCROSS,MENUCIRCLE,SHELLOBJS };

// global shell file definitions

#include "multifil.h"

#define SEASONFILE	"BASLUS-00071S"
#define	SEASONSTR   "JJ-FB Week:"
#define TRADE_EXHIBFILE	"BASLUS-00071TE"
#define TRADE_EXHIBSTR	"JJ-FB ETeam"
#define TRADE_SEASONFILE	"BASLUS-00071TS"
#define TRADE_SEASONSTR	"JJ-FB STeam"
#define OPTIONFILE	"BASLUS-00071OP"
#define	OPTIONSTR   "JJ-FB Options"
#define pEDITFILE	"BASLUS-00071"
#define PLAYSFILE	"BASLUS-00071%02d"

extern MultiFile_t *ShellData;			// master shell file

extern MultiFile_t *Shell_MFile;		// points to the general purpose info mfile for this shell
extern MultiFile_t *Home_MFile;			// spinning helmet graphics
extern MultiFile_t *Away_MFile;

// prototypes

void DrawTriangle ();
void DrawSquare ();
void DrawCross ();
void DrawCircle ();
void DrawHomeName ();
void DrawAwayName ();
void DrawHomeNameAt ();
void DrawAwayNameAt ();
void SpinHomeHelmet ();
void SpinAwayHelmet ();
void SpinHomeHelmetAt ();
void SpinAwayHelmetAt ();
int AlignHelmets ();

// hostile variables shell should not be responsible for

// used by tmstats.c 
#define	TOTAL_WEEKS	18
#define	TOTAL_GAMES	240

// shl files use these.  They should be fixed at some point
#define GO_PREV           -1
#define GO_NEXT            1


#define NOBUTTON   			-1
#define PAD_UP          JPADLup
#define PAD_DOWN        JPADLdown
#define PAD_LEFT        JPADLleft
#define PAD_RIGHT       JPADLright
#define CROSS       		JPADx
#define TRIANGLE    		JPADtriangle
#define SQUARE      		JPADsquare
#define CIRCLE      		JPADcircle

extern UBYTE MyGameType;		// ?? (this should be an int)
extern int GameMode;				// ?? used by shell stuff, set in gameloop.c
#define PREGAME	    0x0			// states for GameMode
#define GAME				0x1
#define POSTGAME    0x2


extern ULONG *This_MFile;							// used by team stats etc..


// end of shell.h

