/*******************************************************************


				SimGame.c


	Module included for PSX to allow real time game simulation,
	actually not a simulation, but the real game played out without
	any graphic stuff.

	MJK  2/27/97

*******************************************************************/

#include "fbequ.h"
#include "fbgequ.h"
#include "fbram.h"
#include "misc.h"

ULONG gVBlankTimers[MAX_VB_TIMERS];


short CPUPlayCallOffense(void);
short CPUPlayCallDefense(void);
WORD AIIsStalled(void);	// actually more of a Boolean
void TurnOffKickInterface(void);		//make sure off restart during play

void UnstallAI(void);
void CameraOnScoreBoard(void);
int TimeDownPlaycall(void);
void InitGameDataPart1(void);
void SetCPUvsCPUGameParameters(void);



extern unsigned char	CoinActiveFlag,
	CoinHeadsFlag,
	CoinFlippedFlag,
	CoinVisitorKickFlag,
	CoinVisitorEastFlag;


/****
typedef struct {
	char	month,		// Month
			day,		// Day of the month
			week,		// Week number of game
			away,		// Away Team number
			home;		// Home Team number
} schedule_t;

extern schedule_t schedule[];

****/

/*-------------------------------------------------------------------*/

void SimGameClock(void)
{

	if(!(GameFlags&FREEZE_ACTIVATED_BFLAG))	// going to LOS time
	{
		if(GameFlags & GAME_TIMER_ON_BFLAG)
		{
			gVBlankTimers[GAME_TIMER_NUM] -= TICKS_PER_AI_FRAME; // 3(?) ticks per frame
			if(gVBlankTimers[GAME_TIMER_NUM] > 0xffffff00L)	// unsigned
				gVBlankTimers[GAME_TIMER_NUM] = ZERO;   //leave on ZERO if expired
		}
		if(GameFlags & PLAY_TIMER_ON_BFLAG)
		{
			gVBlankTimers[PLAY_TIMER_NUM] -= TICKS_PER_AI_FRAME; // 3(?) ticks per frame
			if(gVBlankTimers[PLAY_TIMER_NUM] > 0xffffff00L)	// unsigned
				gVBlankTimers[PLAY_TIMER_NUM] = ZERO;   //leave on ZERO if expired
		}
	}
}


/*-------------------------------------------------------------------*/


BOOL SimCPUGame(void)
{

BOOL needplaycall, inplay;
//BYTE ch;
WORD playcount = 0;
//WORD secs;
//struct  time tm;
//ULONG  startticks,endticks;
//WORD pa,ph;
BOOL playcallactive;
//BOOL rv = TRUE;		// assume game ends okay
int qtr = 0;	//CGD

	FieldDir = 4;		// PC goes L to R

//	DisplayLevel = 0;

//	while(! (GameFlags & LEAVE_GAME_BFLAG))
	while(! (GameFlags & GAME_OVER_BFLAG))
	{
		playcount++;

	 /****  Here's PC "PLAY CALL SCREEN"   *************************/
		InitPlayClock();	// called at beginning of play call
		StartPlayClock(); 	// called at beginning of play call

		playcallactive = TRUE;

		GameTeamData[OffensiveSlotNum].PlayNum = CPUPlayCallOffense();
		GameTeamData[DefensiveSlotNum].PlayNum = CPUPlayCallDefense();

		PlayCallStatus = 0;	// null state

		FreezeAllClocks();	// sim the actual game(TOP problems)

	 /****  Here's end of PC "PLAY CALL SCREEN"   *************************/

//		ph = GameTeamData[0].PlayNum;
//		pa = GameTeamData[1].PlayNum;

		needplaycall = FALSE;

		while (!needplaycall)	// if reset during play
		{
			TurnOffKickInterface();		//make sure off restart during play

			inplay = TRUE;

			if (TheQuarter != qtr) //CGD
			{
//				Dprintf("Q%d ", TheQuarter);
				DumpGamePlay();
				qtr = TheQuarter;
				if (qtr == 4)
				{
//					DumpGamePlay();
					if (GameTeamData[0].TotalScore == GameTeamData[1].TotalScore)
						SetBit(GameFlags, GAME_OVER_BFLAG);
				}
			}

			while (inplay)
			{

				if(playcallactive)
				{
					if(TimeDownPlaycall())	// wait for CPU
					{
//						if(DisplayLevel)
//							printf(" PC=%d",SecondsOnPlayClock());
						StartPlayAI();
						playcallactive = FALSE;
					}
				}

				if(AIIsStalled())
				{
					CameraOnScoreBoard();
					UnstallAI();
				}

				DoAI();
//				PollDebugger();
				SimGameClock();

				if(OkayToStartPlayCall() || (GameFlags & LEAVE_GAME_BFLAG))
				{
					needplaycall = TRUE;
					inplay = FALSE;
				}

			}
		}
	}

/*
	gettime(&tm);
	endticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

	secs = (endticks-startticks)/100;
	printf("\nFinal Score - (H)%s %d, (A)%s %d -NumPlays = %d - Sim time = %d sec",
				GameTeamData[0].STD.TeamNickName,GameTeamData[0].TotalScore,
				GameTeamData[1].STD.TeamNickName,GameTeamData[1].TotalScore,
				playcount,secs);

	startticks = TimeOfPoss[0]/CLOCKS_TICKS_PER_SECOND;
	endticks = TimeOfPoss[1]/CLOCKS_TICKS_PER_SECOND;
	printf("\nTOPoss(ticks) = %ld - %ld total=%ld true = %ld" ,TimeOfPoss[0],TimeOfPoss[1],
			TimeOfPoss[0]+TimeOfPoss[1],QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]*4);
	printf("\nTimeOfPoss = %ld - %ld  total = %ld true = %ld",startticks,endticks,
			startticks+endticks,
			(QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]*4)/CLOCKS_TICKS_PER_SECOND);
*/
	return(FALSE);

}



/*-------------------------------------------------------------------*/


void SimEntireSeasonPSX(void)
{
WORD sg,g;


	SetCPUvsCPUGameParameters();

	AllocAIMemory();

	for(sg=0; sg <= 1; sg++)
	{

//		GameTeamData[0].TeamNumber = schedule[sg].home;
//		GameTeamData[1].TeamNumber = schedule[sg].away;

//		GameTeamData[0].TeamNumber = 0;
//		GameTeamData[1].TeamNumber = 1;

//		for(g=0; g < 30; g++)	// do this many games
		for(g=0; g < 1; g++)	// do this many games
		{

			printf("\nSeason Game #%d - sim #%d\n",sg,g);

			InitGameData();
			CoinVisitorKickFlag = rand()&1;
			InitGameDataPart1();
			InitGameDataPart2();

			SimCPUGame();
		}

	}

	FreeAIMemory();

}

/*-------------------------  End of file  ------------------------*/

