/****************************************************************
	What teams play in what stadiums
	
	Note: Stad ver(1-22), team#, grass type, wind direction, rain/snow/wind 
	Note: rain+snow+wind+sunny (not labeled) should equal 100%
	Stadiums are numbered 1 - 22     
	Teams are numbered 0 - 55
*****************************************************************/

/*
 Wheather sections are:
	 Sept 1 - Oct 31, 
	 Nov 1 - Nov 30, 
	 Dec 1 - Playoffs
*/

#define SUPERBOWL_STADIUM 19

enum  // here are the directions a stadium can face
{
	NORTH_STADIUM,
	NORTH_WEST_STADIUM,
	WEST_STADIUM,
	SOUTH_WEST_STADIUM,
//      SOUTH_STADIUM
};

typedef struct
{
	char rain;
	char snow;
	char wind;
} WeatherPercent_t;


typedef struct
{
	char stadium;
	char textures;
	char turf;
	char faces;
	WeatherPercent_t weather[3];
} TeamStad_t;

#if TEAM_STADIUM_DATA

// 01 = One Sided Ver. 1 Chargers, Superbowl
// 02 = One Sided Ver. 2 Broncos, Ravens, Cardinals
// 03 = 2 Tier Bowl Ver. 1 Chiefs 
// 04 = 2 Tier Bowl Ver. 2 Panthers, Raiders
// 05 = 49ers 
// 06 = Bowl Ver. 1 Patriots, Buccaneers
// 07 = Bowl Ver. 2 Packers
// 08 = Bowl Ver. 3 Bears
// 09 = Bowl With Wings Jaguars, Bills, Aloha
// 10 = Circular 2 Tunnels Ver. 1 Bengals
// 11 = Circular 2 Tunnels Ver. 2 Dolphins
// 12 = Circular 2 Tunnels Ver. 3 Jets, Giants
// 13 = Circular End Stand Ver. 1 Steelers, Redskins
// 14 = Circular End Stand Ver. 2 Eagles
// 15 = Dome 1 Tunnel Ver. 1 Seahawks
// 16 = Dome 1 Tunnel Ver. 2 Oilers (if no move)
// 17 = Dome 1 Tunnel Ver. 4 Vikings
// 18 = Dome 1 Tunnel Ver. 3 Lions
// 19 = Dome 1 Tunnel Ver. 5 Cowboys
// 20 = Dome 4 Tunnels Ver. 1 Colts
// 21 = Dome 4 Tunnels Ver. 2 Falcons, Rams
// 22 = Dome 4 Tunnels Ver. 3 Saints

// Do not put 0's in front of numbers!!

TeamStad_t gTeamStadiumInfo[] =
{    // Team 0
	{  3, 0, GRASS_FIELD, NORTH_WEST_STADIUM, 10,00,25, 10,00,25, 10,20,25 },
	{  1, 1, GRASS_FIELD, NORTH_STADIUM,  5,00,25,  5,00,25,  5,00,25 },
	{ 15, 2, DOME_TURF_FIELD, NORTH_STADIUM, 00,00,00, 00,00,00, 00,00,00  },
	{  2, 3, GRASS_FIELD, NORTH_STADIUM, 25,00,10, 10,20,10,  5,25,10  },
	{  4, 4, GRASS_FIELD, WEST_STADIUM, 10,00,10, 10,00,10, 10,00,10  },
     // Team 5
	{ 13, 5, TURF_FIELD, NORTH_WEST_STADIUM,  15,00,20, 15, 5,20,  5,15,20  },
	{ 10, 6, TURF_FIELD, NORTH_WEST_STADIUM,  15,00,15, 15,00,15,  5,15,15  },
	{ 16, 7, DOME_TURF_FIELD, WEST_STADIUM,  00,00,00, 00,00,00, 00,00,00  },
	{  2, 8, GRASS_FIELD, NORTH_WEST_STADIUM, 20,00,15, 20, 5,15, 20,10,15  },
	{  9, 9, GRASS_FIELD, NORTH_STADIUM, 20,00, 5, 20,00, 5, 20,00, 5  },
     // Team 10
	{  9,10, TURF_FIELD, NORTH_WEST_STADIUM, 20,00,35, 20,15,35, 00,60, 5, },
	{ 20,11, DOME_TURF_FIELD, WEST_STADIUM, 00,00,00, 00,00,00, 00,00,00 },
	{ 11,12, GRASS_FIELD, NORTH_WEST_STADIUM, 25,00,15, 25,00,20,  5,00,15 },
	{  6,13, GRASS_FIELD, NORTH_STADIUM, 15,00,15, 20,10,15,  5,40,15  },
	{ 12,14, TURF_FIELD, NORTH_WEST_STADIUM, 10,00,15, 20,10,15,  5,25,15 },
     // team 15
	{  5,15, GRASS_FIELD, NORTH_STADIUM, 25,00,25, 35,00,40, 25,00,25  },
	{ 21,16, DOME_TURF_FIELD, WEST_STADIUM, 00,00,00, 00,00,00, 00,00,00  },
	{ 21,17, DOME_TURF_FIELD, NORTH_WEST_STADIUM, 00,00,00, 00,00,00, 00,00,00  },
	{  4,18, GRASS_FIELD, WEST_STADIUM, 20,00,15, 20, 5,15, 10,15,15  },
	{ 22,19, DOME_TURF_FIELD, NORTH_STADIUM, 00,00,00, 00,00,00, 00,00,00 },
     // Team 20
	{  7,20,  GRASS_FIELD, NORTH_STADIUM, 15,00,20, 15,15,20, 00,40,20  },
	{ 18,21,  DOME_TURF_FIELD, NORTH_WEST_STADIUM, 00,00,00, 00,00,00, 00,00,00  },
	{  8,22,  GRASS_FIELD, NORTH_STADIUM, 20,00,60, 20,10,60,  5,50,30  },
	{ 17,23,  DOME_TURF_FIELD, SOUTH_WEST_STADIUM, 00,00,00, 00,00,00, 00,00,00  },
	{  6,24,  GRASS_FIELD, NORTH_STADIUM, 25,00,15, 25,00,15, 25,00,35  },
     // Team 25
	{ 19,25,  DOME_TURF_FIELD, SOUTH_WEST_STADIUM, 10,00,00, 10, 5,00, 10, 5,00  },
	{ 14,26,  TURF_FIELD, WEST_STADIUM, 25,00,15, 25,10,15, 10,25,15  },
	{ 13,27,  GRASS_FIELD, NORTH_WEST_STADIUM, 15,00,15, 15, 5,15,  5,20,15  },
	{ 12,28,  TURF_FIELD, NORTH_WEST_STADIUM, 10,00,15, 20,10,15,  5,25,15  },
	{  2,29,  GRASS_FIELD, NORTH_STADIUM,  5,00,25,  5,00,25,  5,00,25  },
     // Team 30
	{  9,30,  GRASS_FIELD, NORTH_STADIUM, 25,00,15, 25,00,15, 25,00,35  },
	{  9,31,  GRASS_FIELD, NORTH_STADIUM, 25,00,15, 25,00,15, 25,00,35  },
	{  9,32,  GRASS_FIELD, NORTH_STADIUM, 25,00,15, 25,00,15, 25,00,35  },
	{  9,33,  GRASS_FIELD, NORTH_STADIUM, 25,00,15, 25,00,15, 25,00,35  },
	{  9,34,  GRASS_FIELD, NORTH_STADIUM, 25,00,15, 25,00,15, 25,00,35  },
     // Team 35    
	{  8,35,  GRASS_FIELD, NORTH_STADIUM, 20,00,60, 20,10,60,  5,50,30  },   
	{  2,36, GRASS_FIELD, NORTH_WEST_STADIUM, 20,00,15, 20, 5,15, 20,10,15  },  
	{  7,37,  GRASS_FIELD, NORTH_STADIUM, 15,00,20, 15,15,20, 00,40,20  },      
	{ 12,38, TURF_FIELD, NORTH_WEST_STADIUM, 10,00,15, 20,10,15,  5,25,15 },     
	{  3,39, GRASS_FIELD, NORTH_WEST_STADIUM, 10,00,25, 10,00,25, 10,20,25 },     
     // Team 40    
	{ 19,40,  DOME_TURF_FIELD, SOUTH_WEST_STADIUM, 10,00,00, 10, 5,00, 10, 5,00  },   
	{ 11,41, GRASS_FIELD, NORTH_WEST_STADIUM, 25,00,15, 25,00,20,  5,00,15 },  
	{ 13,42, TURF_FIELD, NORTH_WEST_STADIUM,  15,00,20, 15, 5,20,  5,15,20  }, 
	{  4,43, GRASS_FIELD, WEST_STADIUM, 10,00,10, 10,00,10, 10,00,10  },
	{ 13,44, TURF_FIELD, NORTH_WEST_STADIUM,  15,00,20, 15, 5,20,  5,15,20  }, 
     // Team 45    
	{ 13,45,  GRASS_FIELD, NORTH_WEST_STADIUM, 15,00,15, 15, 5,15,  5,20,15  },   
	{  4,46, GRASS_FIELD, WEST_STADIUM, 10,00,10, 10,00,10, 10,00,10  },
	{  8,47,  GRASS_FIELD, NORTH_STADIUM, 20,00,60, 20,10,60,  5,50,30  },     
	{ 12,48,  TURF_FIELD, NORTH_WEST_STADIUM, 10,00,15, 20,10,15,  5,25,15  },    
	{  5,49, GRASS_FIELD, NORTH_STADIUM, 25,00,25, 35,00,40, 25,00,25  },
     // Team 50    
	{  9,50, TURF_FIELD, NORTH_WEST_STADIUM, 20,00,35, 20,15,35, 00,60, 5, },  
	{ 13,51,  GRASS_FIELD, NORTH_WEST_STADIUM, 15,00,15, 15, 5,15,  5,20,15  },   
	{ 19,52,  DOME_TURF_FIELD, SOUTH_WEST_STADIUM, 10,00,00, 10, 5,00, 10, 5,00  }, 
	{  5,53, GRASS_FIELD, NORTH_STADIUM, 25,00,25, 35,00,40, 25,00,25  },
	{  7,54,  GRASS_FIELD, NORTH_STADIUM, 15,00,20, 15,15,20, 00,40,20  },  
     // Team 55    
	{  7,55,  GRASS_FIELD, NORTH_STADIUM, 15,00,20, 15,15,20, 00,40,20  },  

};

//char *gTeamStadiumNames[] =
//      {
//              "Texas Stadium",
//              "Astro Dome",
//      };

#else

extern  TeamStad_t gTeamStadiumInfo[];
extern char *gTeamStadiumNames[];

#endif //TEAM_STADIUM_DATA
