/********************************************************************

	File:  TrueSim.C

********************************************************************/


BOOL CheckForPlayOver(void);	// returns TRUE if the play just ended
void InitAI(BOOL startofplay);
void HandleChangeOfPossesssion(void);	// if necessary
void HandlePlayOverPlayType(void);
void SetNewDown(void);
void OfficiallyAddScore(void);
void UpdateFinalGameStats(void);

#define USE_SIMPLAY_C   1

void UpdateAllStats(void)
{
}


#if !USE_SIMPLAY_C
void SimThePlay(void)
{
	if(PlayFlags & POS_PUNT_PLAY_BFLAG)
	{
		KickReturner = 	BallCarrier = 20;
		KickerSlot = 0;

		CatchBallX =  StartBallX + ((39 + (rand()&7)) >>YARD_SHIFT);	// punt dist.
		ForwardProgress = OPXPos(BallCarrier) =
			CatchBallX - (rand()&7)*YARDS;


	}
	else if(PlayType == KICKOFF_PLAY)
	{
		KickReturner = 	BallCarrier = 0;
		KickerSlot = 11;
		CatchBallX = DEF_GOAL_LINE;
		ForwardProgress = OPXPos(BallCarrier) = DEF_GOAL_LINE + 21*YARDS;
	}
	else
	{
		Passer  = 0;
		BallCarrier = PassCatcher = (rand()&3) + 1;

		ForwardProgress = OPXPos(BallCarrier) =
//				StartBallX + ((rand()&7)*YARDS);
				StartBallX + ((rand()&3)*YARDS);
	}

	SetBit1(EventFlags,TACKLE_ENDED_BFLAG);
	Tackler = (rand()&7) +11;

}
#endif //!USE_SIMPLAY_C



/*--------------------------------------------------------------*/

BOOL TrueSimGame(void)
{

BYTE ch;
WORD playcount = 0;
WORD secs;
struct  time tm;
ULONG  startticks,endticks;
WORD pa,ph;
BOOL rv = FALSE;		// assume game ends okay

/**
	InitGameData();
	CoinVisitorKickFlag = rand()&1;
	InitGameDataPart1();
	InitGameDataPart2();
*/
	printf("\nRunning Game Simulation - t#%d-%s(HOME)(TT%d) vs. t#%d-%s(TT%d)",
			GameTeamData[0].TeamNumber,GameTeamData[0].STD.TeamNickName,GameTeamData[0].STD.TeamType,
			GameTeamData[1].TeamNumber,GameTeamData[1].STD.TeamNickName,GameTeamData[1].STD.TeamType);

	gettime(&tm);		// see how long it takes
	startticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

	FieldDir = 4;		// PC goes L to R

	while(! (GameFlags & LEAVE_GAME_BFLAG))
	{
		if(++playcount > 100)
			SetBit(GameFlags,LEAVE_GAME_BFLAG);

 /****  Here's Simmed "PLAY CALL SCREEN"   *************************/
		InitPlayClock();	// called at beginning of play call
		StartPlayClock(); 	// called at beginning of play call

		GameTeamData[OffensiveSlotNum].PlayNum = CPUPlayCallOffense();
		GameTeamData[DefensiveSlotNum].PlayNum = CPUPlayCallDefense();

		PlayCallStatus = 0;	// null state

		FreezeAllClocks();	// sim the actual game(TOP problems)

 /****  Here's end of PC "PLAY CALL SCREEN"   *************************/

		ph = GameTeamData[0].PlayNum;
		pa = GameTeamData[1].PlayNum;

//		if(TRUE)	//display  mucho info in this mode
		{
			PrintFieldParameters(FALSE);	// down and togo and where at

			printf("\nP#=%2d Score=H%d A%d (%d)%s-(%d)%s TT=%d %d:%02d",
				playcount,
				GameTeamData[0].TotalScore,GameTeamData[1].TotalScore,
				ph,GetPlayName(ph),pa,GetPlayName(pa)
				,team_type
				,SecondsLeftInGame()/60,SecondsLeftInGame()%60
			  );
		}

 /****  Actual Play   *************************/

		InitAI(TRUE);

		SimThePlay();

		CheckForPlayOver();		// we know it is
		HandlePlayOverPlayType();

		SetNewDown();
		OfficiallyAddScore();
		UpdateAllStats();

		HandleChangeOfPossesssion();	// if necessary

		SimGameClock();

/****  End Simmed play  ******************/

		PrintPlayInfoText();

	  /** check for abort or access to Debug screen  */
		if (kbhit())
		{
			ch = tolower(getch());	//  get 1st key in buffer
			if(ch == 0x1b)	//ESCAPE???
			{
				SetBit(GameFlags, LEAVE_GAME_BFLAG);
				rv = FALSE;
				printf("\n\n   *************   GAME  ABORTED  -  NOT   SAVED  **********\n");
				getch();
				DebugScreen();
			}
			else if (ch == 'p')
			{
				DebugScreen();
			}
		}
	}

	gettime(&tm);
	endticks =
		(((((ULONG)tm.ti_hour*60)+ (ULONG)tm.ti_min)*60 + (ULONG)tm.ti_sec)*100) + (ULONG)tm.ti_hund;

	secs = (endticks-startticks)/100;
	printf("\nFinal Score - (H)%s %d, (A)%s %d -NumPlays = %d - Sim time = %d sec",
				GameTeamData[0].STD.TeamNickName,GameTeamData[0].TotalScore,
				GameTeamData[1].STD.TeamNickName,GameTeamData[1].TotalScore,
				playcount,secs);

	startticks = TimeOfPoss[0]/CLOCKS_TICKS_PER_SECOND;
	endticks = TimeOfPoss[1]/CLOCKS_TICKS_PER_SECOND;
	printf("\nTOPoss(ticks) = %ld - %ld total=%ld true = %ld" ,TimeOfPoss[0],TimeOfPoss[1],
			TimeOfPoss[0]+TimeOfPoss[1],QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]*4);
	printf("\nTimeOfPoss = %ld - %ld  total = %ld true = %ld",startticks,endticks,
			startticks+endticks,
			(QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]*4)/CLOCKS_TICKS_PER_SECOND);

	UpdateFinalGameStats();

	printf("\nPress NE key to continue or 'D' for debug screen");
	if(tolower(getch()) == 'd')
	{
		DebugScreen();
	}

	return(rv);
}


/******	graveyard
		if(DisplayLevel & DISPLAY_EOP_INFO)	//display  mucho info in this mode
		{
			PrintFieldParameters(FALSE);	// down and togo and where at
			secs = SecondsLeftInQuarter();

			printf("  Q=%d,t=%d:%02d%s (%d:%02d-%d:%02d)\nP#=%2d Score=H%d A%d (%d)%s-(%d)%s TT=%d %d:%02d",
				TheQuarter,secs/60,secs%60,
				((GameFlags & GAME_TIMER_ON_BFLAG)?"r":"s"),
				StatsData[0].allplyrstats[GS_TOP]/60,
				StatsData[0].allplyrstats[GS_TOP]%60,
				StatsData[1].allplyrstats[GS_TOP]/60,
				StatsData[1].allplyrstats[GS_TOP]%60,


				playcount,
				GameTeamData[0].TotalScore,GameTeamData[1].TotalScore,
				ph,GetPlayName(ph),pa,GetPlayName(pa)
				,team_type
				,SecondsLeftInGame()/60,SecondsLeftInGame()%60
			  );
		}



		DefPassInterferenceGuy = BallCarrier =
		BlockedKickRecoverer = BlockedKickBlocker =
		ThrowAwayRec = IntendedReceiver = PassCatcher =
		KickReturner = KickerSlot = Passer = Tackler = //PassDefender =
			FumbleRecoverer =
			PenaltyGuy = PersonalFouler = BCHitter = NOBODY;	// for stats

	PuntYards = INVALID_DISTANCE;	// can't use 99 to -50 since they're valid
	PointsThisPlay = KickStatsType = KickLength = 0;


*/
/**********************************  End  of file  **********************/