/**************************************************************


					FBAIMAIN.C

	INITIAL AUTHOR: M. Knauer       Start Date: 10/3/95

	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains "Main" stuff of the Football AI.

	Main loops, initialization,
	Also PlayStates and Instant Replay.




	NOTE: All AI code is written such that it can be used in two places:

	1) In the PC tester (main loop in file FBTESTAI.C)
	2) in the actual Playstation game(main loop in file ???.C)

	The main module here is "DoAI()", which is called in either one
	of the forementioned main loops.



 ---  Disclaimer ------------------------------------------
 (i.e.-you better know the following if you are	working on the code)

	NOTE: All AI routines in the main AI loop refer to the
	"CURRENT PLAYER" (usually the loop counter of the AI loop 0-21 -
	often refered to by variable "gPNum")

	Any references to the players Data Stuctures are "hidden" in
	a macro starting wtih the initials CP. This allows us to
	more freely change the data structure (if needed) from the initial
	non-linked array based DS's (easier to debug) to a structure based
	data structure

	E.g.  CPXPos =  PlayerXPosition[gPNum]     (current as of 5/19/95)
		could be changed to
		 CPXPos =  Player[gPNum].XPosition
		or something like
		 initialize  	CP = Player[gPNum]
		 in macro		CPXPos =  CP->XPosition

**************************************************************/

	#include  "fbequ.h"
	#include  "fbRAM.h"			/* external VARs needed by this file	*/
	#include  "FBPlays.h"		/* Script enums							*/
	#include  "FBforms.h"		/* Script enums							*/
	#include  "FBStats.h"		/* Stats enums & protos					*/
	#include  "FBpenal.h"		/* Penalty enums & protos				*/
	#include  "misc.h"			/* Alloc, Free memory, timer stuff		*/
	#include  "sound1.h"

	#include  "fbbutton.h"	// has "psxpad.h" or other platform specific


struct frameIRPData *IRPptr = NULL;	// MUST be 1st var for SATURN!!!!


//typedef struct pdata_t specificplayerdata;


#if 1


#define	INITIAL_DEF_PLAY	DefEaster0NUM		 // for testing	Def Dummy 1
#define	INITIAL_OFF_PLAY	WestCoastBombNUM // for testing  W.C. Bomb

#else

#define	INITIAL_DEF_PLAY	247+39	 // for testing	twitch
#define	INITIAL_OFF_PLAY	253+39	//249 // for testing  twitch

#endif



/***************  following used as conditional compile	*****/

#define USE_POSITION_BASED_RATINGS	1	//base rating are based on position,not players
//#define BALLCARRIER_GETS_TIRED		TRUE



#ifdef __MSDOS__			//-------------------------------------
#include <stdio.h>
#include <conio.h>
#include <ctype.h>      /* for toupper  */
#endif

#if PC_ALWAYS_MODE
//	#define	DO_KICKOFFS				0	// no KickOff on PC tester
	#define	NOCONTROLLERSELECT		0
	#define OKAY_FOR_OFFSIDES		1

#define MAX_VB_TIMERS 5
//extern ULONG gVBlankTimers[MAX_VB_TIMERS];
extern WORD DisplayLevel,DoKickOffs,CPUDebugHike;
void DebugScreen(void);

#endif

// must be a console game like PlayStation -------------------

#ifdef PSXMODE
	#define	DO_KICKOFFS		   	1
	#define	NOCONTROLLERSELECT	0	// means controller variable as set up
	#define OKAY_FOR_OFFSIDES	1
#endif

#ifdef	SATURNMODE
	#define	DO_KICKOFFS			1
	#define	NOCONTROLLERSELECT	1
	#define OKAY_FOR_OFFSIDES	1
	#define	WHISTLE_MASK		0x1f	// smaller range on whistle volume
#else
/* MemoryCardMimic allocated on Saturn - however, everything and
	everybody (all machines) should	use MemoryCardMimicPtr			*/
//struct memorycardmimic MemoryCardMimic;	// 24K ????
	#define	WHISTLE_MASK		0x3f	// bigger range on whistle volume

#endif



//---------------------------------------------------------

#define EXPT_STARTX		(2*YARDS)	//pros start at 2 

/*------------------ MACROS  ------------------------*/

//#define STATEDEF(xyz) \	actually in FBEQU.h
//	void  (xyz)(void);  /* prototype  */  \
//	void  (xyz)(void)   /* actual function name of the State  */


//#define	SetBit(xxx,yyy)  xxx |= yyy
#define   SetAI(xyz)  CPAIState = (xyz)

#define PERCENT50   ((random0_99) < 50)
#define PERCENT25   ((random0_99) < 25)

//#define	NORMAL_2ND_STATE_TICKS	4



/*---------------  function prototypes  -----------*/

WORD  TryManyMoves(UWORD PossibleDirToMove);
WORD  TryMove(UWORD PossibleDirToMove,WORD speedtablevalue);
//void  MakeTargetInBounds(void);

void  GeneratePlayerSphereOfInfluence(UWORD PNum);


WORD  IncrementPlayerSpeed(void);
WORD DecrementPlayerSpeed(WORD DecelFactor,WORD minspeed);
void HandleCPCPUBursting(void);
void InitSpeedBurst(void);
//WORD  DecrementPlayerSpeed(WORD DecelFactor);
//WORD  FigureMaxSpeed(void);

void  FaceBallandShuffle(void);
void  Run(void);
void  Walk(void);
void  Shuffle(WORD shuffletype);
void  InitGraphics(WORD AIgraphicsnum);
void SetStandingCatchGraphics(void);
void ConvertAIToActualGraphics(WORD teamtype);		// whole team(11 guys)
void ConvertCurrentPlayerAIToActualGraphics(void);	// 1 player

BOOL  ReachedTarget(void);
void  SetNewBallCarrier(WORD NewBallCarrier);
BOOL HeShouldFumbleGeneric(WORD possiblefumbler);
void InitFumble(WORD fumbletype,WORD DirToGo,WORD NeedSFX);	// in FBMove.c


void SetTestPlay(void);
void SetNewQuarter(void);
void SetQuarterTime(void);
void ForceNewAIPlayInit(WORD newplaycallstatus);	// forces players in huddle, does COP, Play State = 0
void InitDriveStats(void);

void InitAI(BOOL startofplay);
void InitDefaultPlayerData(WORD teamslotnum);	// only at game init
void InitDebugPlayerRatings(WORD teamnum);
void InitTeamPlayAI(WORD TeamSlotNum);
void SaveOffensivePlayNum(void);

void InitZones(struct BKzonearea *ZAPtr);
void InitExtraRatings(void);
void InitAudio(void);		// platform specific
void InitWind(void);
void InitEditedFormations(WORD team01);	// called at game init
void UpdateShownPlayerNames(void);


void DoAI(void);

//void  GoToNextState(WORD  ParamIncValue);

void	Init2ndState(WORD tickstostayinstate);
void	Do2ndState(void);


//void MoveOffense(void);
//void MoveDefense(void);
void DoOffenseAI(void);
void DoDefenseAI(void);
void BubbleSortOnY(void);
void UpdateTeamsTimeOfPossession(void);

void MoveBall(void);
void MoveReferees(void);
void SetForwardProgress(void);	// check forward progress every frame

void FigureDefenseKeyDistance(WORD player);
void FigureOffenseKeyDistance(void);
UWORD DistanceToClosestDef(WORD offguy);

void DoState(void);
void DoAction(void);
void DoPlayState(void);
void GoToNextPlayState(void);		// a playstate subroutine
void SetPlayState(WORD PStateNum);	//could be used anywhere
void InitKickOffPlay(void);
void InitPlayersInHuddle(WORD TeamSlotNum);

void InitReferees(void);	// at beginning of PLAY
void SetNewRefAnim(WORD sfxnum,WORD refAIAnimtodo,BOOL dopenalty);
void SetRefStartX(UWORD xpos);


//void FinalPlayCleanup(void);
void HandleOffensiveAudible(void);
void HandleDefensiveAudible(void);

void BuildAnnouncerPhraseInit(WORD firstword);
void AddToAnnouncerPhrase(WORD word);
//void SayAnnouncerPhrase(void);	// uses AIAnnouncerPhrase &  WordsInAnnouncerPhrase

void AnnounceScore(void);
void InitAtLOSAudio(void);
void AnnouncerSayTimeOut(WORD teamslotnum);
void InitRefPhrase(WORD firstword);
void AddToRefPhrase(WORD word);
void SayRefPhrase(void);	// uses AIRefPhrase &  WordsInRefPhrase
void PlayBlockingSounds(void);

void AudioCrowdReaction(WORD sfxnum, WORD basevolume);
void HomeOrAwayAudioCrowdReaction(WORD homesfx, WORD awaysfx);
BOOL HomeTeamAhead(void);

BOOL BallOutOfBounds(void);
BOOL BallOutOfEntireField(void); // returns TRUE if Ball outof bounds or over Endlines
void UnofficiallyAddScore(WORD teamslot, WORD scoretype);	// teamtype = OFF or DEF

BOOL SetPossibleTD(WORD scorer); //return TRUE if TD  or FALSE if 2 pt conversion
void AdjustNewStartBall(UWORD newX);	// sets ball within hashmarks
void FigureYardsGained(WORD lastbc,UWORD endX);	// and adjust new ballX
void SaveOffensePlayData(void);

//void StopGameClock(void);
void GotFirstDownOrIncDown(void);	// assume ball X already adjusted
void SetInitStartBall(WORD startx);		// Y = middle of field
void SetNewFirstDown(WORD startnewdrive);
void Set1stDownParameters(void);
void SetSafetyOrTouchBack(WORD teamslot);


void IncrementTimers(void);
void StopPlayClock(void);
void CPUCallTimeout(WORD team);
void CheckForPausedTimeOut(void);	// in main loop

void HandleController(void);
void CheckForToggling(void);
void CheckForDebugKeys(void);


void InitBallFumble(WORD fumbletype,WORD DirToGo);

//void SetReactTime(WORD timeuntilreaction);
void SetFakeReceivers(BYTE rec0,BYTE rec1,BYTE rec2,BYTE rec3,BYTE rec4);
void SetIRPReceivers(void);
void SaveIRPBallTarget(void);
void InitIRPPrePlay(void);

void InitPlayerPlayConstants(void);	// used by Players or Ref

void SetReceiversToLeadBlockers(void);


BOOL GamerControlled(void);
BOOL MoveHumanControlledPlayer(WORD ControllerNum);
void HandleHumanHandoff(WORD ctrlnum);
void HandleHumanReceiver(WORD ctrlnum);
void HandleHumanPassing(WORD ctrlnum);
void QuickFigurePass(WORD pnum);

void ReleasePass(BOOL TruePass);	/*  called by QB ACTION	   */
void DoHandoff(void);

void InitDefensePreSnapShift(void);
//void InitLongHike(void);
BOOL PlayCompleted(void);
void StartDive(BOOL startthisframe);
void StartJump(void);	/* a STATE (or Human controlled) subroutine	*/

void InitDefaultAudiblePlays(void);

void ClearReceivers(void);
void SaveDefControlledGuys(void);
void SaveOffControlledGuys(void);
void SavePreviouslyControlledGuys(void);

BOOL SwapControllers(WORD newplayer, WORD oldplayer);

void RunInPlace(void);
void SetLookToPassGraphics(WORD dirtoface);
void InitPlayerPass(voidFCNPTR action);
void SetCPAction(voidFCNPTR action);
//void SpinMoveAction(void);
void InitSpinMove(void);


void SaveInstantReplayData(void);
//void DoInstantReplay(WORD framestoinc);
//void InitInstantReplay(void);
BOOL OkayForAudible(void);	// separate for PSX or PC/Saturn



void FigureWhoToBlock(void);	// in FBBlock.c
void SetTeamBlockFactor(void);

/****  Play Call/ AI interface routines	*****/
void StartPlayAI(void); 	// called once both teams have selected their play
BOOL OkayToStartPlayCall(void);	// used by Play Call stuff to see if okay to start
BOOL OkayToLoadPlayCall(void); // used by Play Call stuff to see if okay to load


void FillMaxAIGraphicSeqArray(void);


void AISetCrowdLevel(void);	//
void HandleCrowdSound(void);
void SetNewCrowdVolume(WORD crowdchannel, WORD desiredvolume,WORD tickstodesired);
void SetNewCrowdVolumeDelta(WORD crowdchannel, WORD desiredvolume,UWORD delta);
void StopCrowdVolumeRamping(WORD crowdchannel);
void AIInitSFXLoop2(WORD newloopsfx,WORD desiredvol, WORD ticks);



WORD AIPlayEffectCheck(WORD sfxnum);	// returns channel number of SFX
WORD AIPlayEffect(WORD sfxnum);	// play EVEN if already playing this SFX
WORD AIPlayQBSFX(WORD sfxnum);	// won't play if already playing this SFX
short CheckEffect(short voice);
void HandleAudibleAudio(void);
void HandleSideLineAudio(void);

void DontDisplayAITextInfo(void);

void PCPrintAIText(void);
void ClearPenaltyTextBuffers(void);

WORD GetTrueYardline(void);	// returns 1-50
UWORD WheresFirstDown(UWORD startingyard, WORD teamslot);

void Inc3rdor4thDownAttempts(void);	// if necessary - in fbstats.c
void Inc3rdor4thDownMade(void);	// if necessary - in fbstats.c
void SetNewDown(void);

/*************************   EXTERNAL   TABLES, VARIABLES  ********/

extern	UWORD	NumFramesPerPlayerGraphic[];
//extern  WORD  *All_Scripts[];

extern  const struct State  AllStates[];
extern  BYTE *ScoreNames[MAX_SCORE_TYPES];	// actually here
extern  struct formation *AllFormations[];
//extern  struct play *ThePlays[];
extern  struct play ThePlays[];

extern	struct State PlayInitRoutines[];
extern	struct  BlockerState GetPushed10[];
extern	struct  BlockerState NormalBlocker[];

extern  ULONG	QuarterTimes[5]; // time in Quarter based on a User Option



extern unsigned char	CoinActiveFlag,
	CoinHeadsFlag,
	CoinFlippedFlag,
	CoinVisitorKickFlag,
	CoinVisitorEastFlag;






//extern  WORD  TryManyMovesTable[MAX_DIR][4];  /* actual in this file*/

//void  	StartTackle(void);

//UWORD FindDirection(WORD DeltaX, WORD DeltaY);
WORD Distance(WORD x, WORD y);
WORD Distance2Points(WORD x, WORD y, WORD x2, WORD y2);


void InitPumpFake(void);		// in fbmove.c

//BOOL	TurnPlayer(WORD FinalDirection, WORD WayToTurn);
BOOL	TurnPlayerOptimal(WORD FinalDirection);

void	NoAction(void);		/*  a NULL action	*/
void	NoAI(void);			/*  a NULL action	*/

/**********  A.I.  STATES	*************************/

//void	FutureBCLookForBall(void);
//void	FutureBCLookForBallPitch(void);
void	StopAfterHandOff(void);		/* an AI State used by QB	*/


BOOL	ICanGetBall(void);
BOOL	HeCanGetBall(WORD pnum);	  /*  Can "He" (pnum) get ball ??? 	*/


/**********  PLAYER  ACTIONS	*************************/

void	HumanPassingAction(void);
void	NormalPassingAction(void);
void	GoTo3PtStanceInitAction(void);
//void	GoTo3PtStanceAction(void);
void	GoTo4PtStanceInitAction(void);
//void	GoTo4PtStanceAction(void);
void	DiveAction(void);
//void 	BeTacklerAction(void);
void	GetUpAction(void);
void	DelayedGetUpAction(void);
void 	FreezeActionOnGround(void);
void 	LayOnGroundGroundAction(void);
void	SpinMoveAction(void);			// does DoState
void	FreezeAWhileAction(void);
PLAYER_ACTION(BlockeeStunned);	// something in blocker state must unstun	*/
void	QBCallPlays(void);	// head turn at LOS
void	InitQBCallPlays(void);	// turns QB head side to side
//void 	QBPumpFakeAction(void);

/******* Ball Actions	*********************/

void BallPreSnap(void);
void PlayerHasBall(void);
void BallAfterTackle(void);    // leave ball where it's at, don't show
void BallBeingPassed(void);
void InitBallBeingPassed(void);
void InitBouncingBall();
//void BallLongHikeAction(void);

/*--- ball action subroutines	----*/
BOOL FigurePassHeight(void);
//void MoveBallInAir(void);
void FigureBallSphereOfInfluence(void);
void UpdatePlayerWithBall(void);

void InitKickInterfaceVars(void);
void HumanKickInterface(void);
void TurnOffKickInterface(void);		//make sure off if EOQ or Delay




WORD	InitDefControlledGuys[MAX_USERS_PER_TEAM] = {11,21,20,18,17,16};	// MLB,SS,FS,OLLB
//WORD	InitOffControlledGuys[MAX_USERS_PER_TEAM] = {0,0,1,2,3,4};	// these are rec. index (except 0 which is QB)
WORD	InitOffControlledGuys[MAX_USERS_PER_TEAM] = {0,1,2,5,3,4};	// these are rec. index (except 0 which is QB)



WORD	NormalCrowdVolume[MAX_CROWD_SFXS] = {
// NOTE: all only used at GameInit, 1st half used when return to huddle
	SCALED_VOL_PERCENT(20),	// low crowd volume - constant
	CML1_VOL,			// medium CV - most active crowd volume
	SCALED_VOL_PERCENT(0),		// high CV - used if lots of action
	SCALED_VOL_PERCENT(0),		// chant or boo

	SCALED_VOL_PERCENT(0),		// minor
	MINOR_CML_RANGE,		// minor MID - start at 5% and go forever
	SCALED_VOL_PERCENT(0),		// minor
	SCALED_VOL_PERCENT(0),		// minor

};

WORD	LeavingHuddleCrowdVolume[NUM_MAJOR_CROWD_SFXS] = {
//	SCALED_VOL_PERCENT(20),	// low crowd volume - constant during play
	SCALED_VOL_PERCENT(50),	// 11/21/96 - more noise
	CML2_VOL,			// medium CV - most active crowd volume
	SCALED_VOL_PERCENT(0),		// high CV - used if lots of action
	SCALED_VOL_PERCENT(0)		// chant or boo
};



//void InitSFXLoop(WORD newloopsfx);	//proto
//void CopyBytes (BYTE *src , BYTE *dest , int count );
//void LoadPlayerData(void);

#define DEFAULT_PRACTICE_START_X  DEF_GOAL_LINE+10*YARD;

//	0-grass 1-2tone 2-turf 3-dometurf
WORD FieldTypeTable[4] = {
	GRASS_FIELD,
	GRASS_FIELD,
	TURF_FIELD,
	TURF_FIELD
};


BYTE *NoGood2PtText = {"2 PT CONVERSION IS NO GOOD"};



BOOL InvalidPlay,SinglePenaltyPending;	// set if offsetting penalties
UWORD AcceptPenaltyX,AcceptPenaltyDown,AcceptPenaltyPlayType,AcceptPenalty1st;
UWORD TruePenaltyYards, AcceptPenaltyTeamWithBall,AcceptPenaltyMode;

/************************************************************************

				INIT    GAME    DATA

	Called 1 time at the beginning of a game

	Initializes all data at the start of a game


	Player Data (from AllPlayerData) is copied to the 80 players
	in the game.  The Player data file should then be closed i.e. it's
	memory should be freed.

	InitGameDataPart1 is called right at game init.

	InitGameDataPart2 is called right after the coin toss has been
	decided.


************************************************************************/

void InitGameData(void)
{
EFFVAR i,t,teamnum;
void  *sptr, *dptr;

/*   testing only - modifiable through debug menu
	if speed != zero, then override normal player based ratings  */
//	TeamSpeed[0] = TeamSpeed[1] = 4; 		// ratings test variable
//	TeamHands[0] = TeamHands[1] = 50; 		// ratings test variable

	TeamSpeed[0] = TeamSpeed[1] = TeamHands[0] = TeamHands[1] = ZERO;

/*   end testing only	*/
	OkToTackle = ShowHuddle = TRUE;				// debug variables
	Team0EditStatus = Team1EditStatus = ZERO; 	// ratings test variable

	PhraseFlag = FALSE;	// turn on when you want audio to start

#if PC_DEBUG_MODE
//	ShowHuddle = FALSE;		// debug variables
#endif

	CollisionDetectActive = TRUE;

	ClearAllGameStats();

/**
	if(GameTeamData[0].TeamNumber < 0)	// if team not inited by team select
	{
		GameTeamData[0].TeamNumber=13;	// bills
		GameTeamData[1].TeamNumber=1;	// S.D.
	}
***/

	if(PracticeMode)
	{
		GameTeamData[1].TeamNumber = GameTeamData[0].TeamNumber;
	 /* don't change options internal to game - handle elsewhere
		GameOptions[GAME_OPTNS_DELAY_OF_GAME] = OPTION_OFF;	// no delay of game
	 */
	}

	// default for coin flip sequence OR Practice mode
	GameTeamData[0].PlayNum = INITIAL_OFF_PLAY;
	GameTeamData[0].OffDefFlag = ON_OFFENSE;
	OffensiveSlotNum = 0;

	GameTeamData[1].PlayNum = INITIAL_DEF_PLAY;
	GameTeamData[1].OffDefFlag = ON_DEFENSE;
	DefensiveSlotNum = 1;

	PracticeStartBallX = DEFAULT_PRACTICE_START_X;	// do even if not PracticeMode
	StartBallY = MID_FIELDY;		// if practice

/**-----  END  TEST ONLY - FORCE 2 Player Game	-------------***/

	InitDefaultAudiblePlays();	// for both teams - is here a good place???


	FillMaxAIGraphicSeqArray();	// couldn't do it at compile time

/* InterfaceFlags and GameFlags Only cleared here, never again
	 EventFlags cleared at beginning of every play		*/

	SetMemory(&EventFlags, ZERO, sizeof(struct evflags));

//	InterfaceFlags = GameFlags = PlayFlags = EventFlags = MoreEventFlags = ZERO;
	InterfaceFlags = GameFlags = PlayFlags = MoreEventFlags = ZERO;	// 16 bit flags
	PlayOverFlags = ZERO;	//NEED_COP must be cleared from quitting prev. game
	CoinVisitorEastFlag = CoinVisitorKickFlag = ZERO;
		// no InstantRePlay yet
//	StartIRPFrameCounter = CurIRPFrameCounter = EndIRPFrameCounter = ZERO;

	StopGameClock();	// should be stopped, but make sure
	SetQuarterTime();
	StopPlayClock();	// should be stopped, but make sure
	InitPlayClock();	// sets clock to MAX but DOES NOT START it

	for(t=0; t <2; t++)
	{
		teamnum = GameTeamData[t].TeamNumber;

//		QBAudioPitch[t] = 56 + (rand()&0x0007);
//		QBAudioPitch[t] = 57 + randnum(7);	// range 57-63
//		QBAudioPitch[t] = 58 + randnum(5);	// range 58-62 bug#2645(10/4/96)
//		QBAudioPitch[t] = 58 + teamnum%5;	// range 58-62 bug#2645(10/4/96)
		QBAudioPitch[t] = 58 + (teamnum&3);	// range 58-61 (11/3/96)


		//following could be modified by Easter egg
		GameTeamData[t].DownsForFirst = 4;			// why always 4??
		GameTeamData[t].YardsForFirst = 10*YARDS;   // why always 10??

		dptr = &GameTeamData[t].STD;
		sptr = &SpecificTeamData[teamnum];
		CopyBytes(sptr, dptr, sizeof(struct specificteamdata));

		GameTeamData[t].NumHumanControllers = 0;	// assume CPU game

		for(i=0; i < MAX_USERS_PER_TEAM; i++) // assume all the rest are dead
		{
			GameTeamData[t].PrevDefControlledPlayers[i]= InitDefControlledGuys[i];
			GameTeamData[t].PrevOffControlledPlayers[i]= InitOffControlledGuys[i];
			if(GameTeamData[t].ControllerNum[i] != NO_CONTROLLER)
				GameTeamData[t].NumHumanControllers++;
		}

		for(i=0; i<MAX_PLAY_TYPES; i++)
		{
			PlayTypeCount[t][i] = ZERO;
		}

		GameTeamData[t].PlayFlipped = FALSE;

//		GameTeamData[j].TimeOuts = 3;	time outs inited in SetNewQuarter
		GameTeamData[t].TeamFlags = 	// also cleared every PLAY
			GameTeamData[t].GameTeamFlags =  // this in the only time this is cleared
			TimeOfPoss[t] = ZERO;

		// only humans get edited plays
		if(GameTeamData[t].NumHumanControllers==ZERO)
		{
			GameTeamData[t].UseEditedPlays[0]
					 = GameTeamData[t].UseEditedPlays[1] = ZERO;
		}
		else
		{
		}
		InitEditedFormations(t);	// MUST be called AFTER STData setup

#ifdef SATURNMODE
//		GameTeamData[t].UseEditedPlays[0]
//				 = GameTeamData[t].UseEditedPlays[1] = FALSE;
#endif

		for(i=0; i<5; i++)
			GameTeamData[t].ScorePerQuarter[i] = ZERO;

		GameTeamData[t].TotalScore = ZERO;	/* can't you add?	*/


		for(i=0; i<MAX_OFF_PLAYDATA; i++)
		{
			GameTeamData[t].PrevOffPlayData[i]= -1;	// BC of previous plays
			GameTeamData[t].PrevOffPlayNum[i]= -1;	// play num. of previous plays
		}

		GameTeamData[t].OffPlayNumCounter = 		// index into above array
			GameTeamData[t].OffPlayDataCounter = 0;

/*	following data setup will be overridden with ROM ratings later,
	 but if error then at least something is there
	9/28/96 - no-ONLY on Powerup  - Player data loaded pre-game by SHELL
		in case of Created team
		InitDefaultPlayerData(t);	// name, etc.
//		InitDefaultPlayerRatings(t);
*/
	}

#ifndef SATURNMODE
#if PC_ALWAYS_MODE
//	LoadPlayerData();   //from disc	WARNING =SPEED is 0-100 in DS, needs to be 0-16
#endif
	MemoryCardMimicPtr = &MemoryCardMimic;

#endif

	for(gPNum = 0; gPNum <22; gPNum++)
	{	// init all "slots" to a neutral STATE
		CPMyFormPosition = CPMyPNum = 0;	// everybody's a QB
		SetNewScript(DoNothingScriptNUM);
		InitPlayerPlayConstants();	// USES gPNum -

	}

	GameOptions[GAME_OPTNS_DIFFICULTY] =	// make sure valid for all game
			SetMinMax(GameOptions[GAME_OPTNS_DIFFICULTY],0,2);
//	ExtraCPURatings = 0;
	InitExtraRatings();	//... for CPU teams based on GameType or Options

 //TEST only - a PNum below which a player won't be tackled
	TackleGuyTest = -1;	// okay to tackle QB
	LastTeamToScoreSlot = ExtraPointStatus = -1;

	ErrorNumber =	TheQuarter = TheTrueQuarter = 0;
	OffenseDir = 0;	// direction offense going
	TeamBlockFactor = 0; 	// offensive team only

	TDAnimLoadedNum = 0; // will be changed by PSX anim loading

	for(i=0; i<MAX_BLOCK_FACTORS; i++)
		BlockTypeCount[i] = BlockTypeCountActual[i] = ZERO;	// for debugging

/**  following moved to Part2
	SetNewQuarter();		// will init KickOff

	// force  players into huddle
	ForceNewAIPlayInit(OKAY_TO_START_PLAYCALL);	// and LOAD_PLAY_CALL);
	InitIRPPrePlay();
****/

	FieldType = FieldTypeTable[GameOptions[GAME_OPTNS_FIELD_TYPE]];

	ClearReceivers();
	InitKickOffPlay();

	// force  players into huddle
	ForceNewAIPlayInit(ABORT_PLAYCALL_SCREEN);	//no PLAY_CALL yet

	SetPlayState(PS_WaitForPlayStartNUM);	//players do nothing until P.Call done

	InitWind();

#if PC_ALWAYS_MODE
	FieldDir = 4;		// PC goes L to R
	TackleGuyTest = -1;	// no QB tackle
//	WindDeltaX = 0;
//	WindDeltaY = 0; //-15;
#else

	FieldDir = 0;		// consoles go u/D


#if PC_ALWAYS_MODE
	InitAudio();	// hardware specific

#else

	InitAudio();	// hardware specific

//	InitEffectsBody();
//	StopSequence();		// kills music
//	CloseMusVab();
//	InitCrowd();		//


#endif

#endif
	for(i=0; i<MAX_CROWD_SFXS; i++)	// do major and minor volumes
	{
		CurCrowdVolume[i] = ZERO;	// should ramp up
		SetNewCrowdVolume(i,NormalCrowdVolume[i],5*SECONDS);

//		SetNewCrowdVolumeDelta(i, NormalCrowdVolume[i],1<<CVOL_SHIFT)

//		DesiredCrowdVolume[i] = NormalCrowdVolume[i];
//		CrowdVolumeDelta[i] = 1<<CVOL_SHIFT;
	}
	/* start minor MID crowd volume going - it will continue forever	*/
//	SetNewCrowdVolume(MINOR_MID_CROWD_SFX,SCALED_VOL_PERCENT(5),3*SECONDS + (rand()&127));

	LeftChannelPercent = DesiredLeftChannelPercent = 50;	//for crowd stereo effect
	CurLoopSFXNum = -1;	// nothing

	AISetCrowdLevel();	//

	ConvertAIToActualGraphics(0);
	ConvertAIToActualGraphics(1);

	// history  = 20 (10/02/96)
	// 			= 27 (10/16/96)	bug # 2967
	// 			= 38 (10/26/96)
	BaseTacklePercent = 38;	// semi-constant - changeable @ debug screen

}






void InitGameDataPart1(void)
{      /*  called right after coin toss BUT before field start
				rotating	**/

	/* slot #1 is visitor, #0 is home	*/
	if(PracticeMode)
		DefensiveSlotNum = 1;
	else
		DefensiveSlotNum = (CoinVisitorKickFlag) ? 1 : 0;

	OffenseDir = CoinVisitorEastFlag;
	OffensiveSlotNum = DefensiveSlotNum^1;

	if(OffensiveSlotNum == 0)	// offense == home??
		OffenseDir ^= 1;


	GameTeamData[OffensiveSlotNum].PlayNum = INITIAL_OFF_PLAY; // not really needed except by PC
	GameTeamData[OffensiveSlotNum].OffDefFlag = ON_OFFENSE;

	GameTeamData[DefensiveSlotNum].PlayNum = INITIAL_DEF_PLAY; // not really needed except by PC OR Practice Mode
	GameTeamData[DefensiveSlotNum].OffDefFlag = ON_DEFENSE;

}

void InitGameDataPart2(void)
{      /*  coin toss should be over with, camera on scoreboard	**/

	/* slot #1 is visitor, #0 is home	*/
/*
	if(PracticeMode)
		DefensiveSlotNum = 1;
	else
		DefensiveSlotNum = (CoinVisitorKickFlag) ? 1 : 0;

	OffenseDir = CoinVisitorEastFlag;
	OffensiveSlotNum = DefensiveSlotNum^1;

	if(OffensiveSlotNum == 0)	// offense == home??
		OffenseDir ^= 1;


	GameTeamData[OffensiveSlotNum].PlayNum = INITIAL_OFF_PLAY; // not really needed except by PC
	GameTeamData[OffensiveSlotNum].OffDefFlag = ON_OFFENSE;

	GameTeamData[DefensiveSlotNum].PlayNum = INITIAL_DEF_PLAY; // not really needed except by PC OR Practice Mode
	GameTeamData[DefensiveSlotNum].OffDefFlag = ON_DEFENSE;

*/
	SetNewQuarter();		// will init KickOff

	// force  players into huddle
	ForceNewAIPlayInit(OKAY_TO_START_PLAYCALL);	// and LOAD_PLAY_CALL);
	InitIRPPrePlay();

	InitDriveStats();

	// below if OT cointoss
	SetPlayState(PS_WaitForPlayStartNUM);	//players do nothing until P.Call done
}

/* below NOt true anymore - separate wind speed tables so we can tweak
   independant of player speeds				*/
// WindSpeed uses player speed table (what a cheat)-SpeedTables are non-linear!!!
//#define HIGH_WIND_SPEED_INDEX	2	//3= 25% (7/31/96 w/ 20HTZ)  4was too high
//#define LOW_WIND_SPEED_INDEX    0	//0 index is slowest (non-zero)

//WORD WindSpeedTable[3] = {0, LOW_WIND_SPEED_INDEX,HIGH_WIND_SPEED_INDEX};
extern struct s8XY WindSpeedTable[MAX_NUM_WIND_SPEEDS][MAX_DIRECTIONS];

void SetWindSpeed(void)
{
	WindSpeed = GameOptions[GAME_OPTNS_WIND];

	if(WindSpeed != ZERO)	// need equate for wind
	{
//		WindSpeed = 2;

		WindDeltaX = WindSpeedTable[WindSpeed-1][AIWindDirection].X;
		WindDeltaY = WindSpeedTable[WindSpeed-1][AIWindDirection].Y;
	}
	else
	{
		WindDeltaX = WindDeltaY = WindSpeed = 0;

	}

}

void InitWind(void)
{ 	/* WindDirection remains CONSTANT during a game,
		AIWindDirection changes depending on fielddir		*/

	ShowWindFlag = FALSE;	// set by AI, tells graphic engine to display wind vane

	//Wid Dir is DON'T CARE if no wind
//	AIWindDirection = WindDirection = SE_DIR;	//DON"T CARE if no wind
//	AIWindDirection = WindDirection = SOUTH_DIR;	//DON"T CARE if no wind

	AIWindDirection = WindDirection = (rand()&7)*2;	//0,2,4,6,8,10,12,14

	SetWindSpeed();

}


void ToggleAIWindDir(void)
{
	AIWindDirection = 	((AIWindDirection+8)&15);
}


extern BYTE BaseSpeed[TOTAL_PLAYERS_ON_TEAM];	// based on player position

void InitDebugPlayerRatings(WORD teamslotnum)
{
struct pdata_t *pdata;
EFFVAR i,j,speed,hands;

/*  TeamSpeed/Hands are debug variables	*/
#if 1
	if((speed = TeamSpeed[teamslotnum]) != ZERO)
	{
		speed = SetMinMax(speed,1,10);	// (range 0-10)
		for(i=0; i<TOTAL_PLAYERS_ON_TEAM; i++)
		{
			pdata = &GameTeamData[teamslotnum].PlayerData[i]; //where it goes

			//for 0-100 use the following
			pdata->ratings[SPEED_RATE] = 6 * min(BaseSpeed[i]+speed,15);;
		}
	}

	if( (hands = TeamHands[teamslotnum]) != ZERO)
	{
		hands = SetMinMax(hands,0,100);
		for(i=0; i<TOTAL_PLAYERS_ON_TEAM; i++)
		{
			pdata = &GameTeamData[teamslotnum].PlayerData[i]; //where it goes

			for(j=1; j < MAX_NUM_RATINGS_PER_PLAYER; j++)	// skip speed
				pdata->ratings[j] = hands;		//assume
		}

	}

#else
	if((speed = TeamSpeed[teamslotnum]) == ZERO)
		return;

	speed = SetMinMax(speed,1,10);	// (range 0-10)
	hands = SetMinMax(TeamHands[teamslotnum],0,100);

	for(i=0; i<TOTAL_PLAYERS_ON_TEAM; i++)
	{
		pdata = &GameTeamData[teamslotnum].PlayerData[i]; //where it goes

		for(j=0; j < MAX_NUM_RATINGS_PER_PLAYER; j++)
			pdata->ratings[j] = hands;		//assume


	#if	USE_POSITION_BASED_RATINGS
//		pdata->ratings[SPEED_RATE] = min(BaseSpeed[i]+speed,15);
	//for 0-100 use the following
		pdata->ratings[SPEED_RATE] = 6 * min(BaseSpeed[i]+speed,15);;
	#else	// consistant rating for all players
		pdata->ratings[SPEED_RATE] = 4+speed;
	#endif
	/*
		pdata->ratings[STRENGTH_RATE] = hands;
		pdata->ratings[STRENGTH_RATE] = hands;
		pdata->ratings[ARMSTRENGTH_RATE] = hands;	// scale = 0-100 (kicker, QB, rating)
		pdata->ratings[LEGSTRENGTH_RATE] = hands;	// scale = 0-100 (kicker, QB, rating)
		pdata->ratings[HANDS_RATE]	 = hands;	// scale = 0-100 (kicker, QB, rating)
		pdata->ratings[REACTION_RATE] = hands;
	*/
	}
#endif
}


WORD SetMinMax(WORD value, WORD min, WORD max)
{
	if(value < min)	// error check and correct
		value = min;
	else if(value > max)
		value = max;

	return(value);
}

UWORD USetMinMax(UWORD value, UWORD min, UWORD max)	// UNSIGNED !!!
{
		// use this one if dealing with YARDS!!!!

	if(value < min)	// error check and correct
		value = min;
	else if(value > max)
		value = max;

	return(value);
}


WORD ExtraRatingsTable[3] = {-10,0, 10};	// based on difficulty

void InitExtraRatings(void)	// done at game init only!!!
{
	// error check and correct
	GameOptions[GAME_OPTNS_DIFFICULTY] = SetMinMax(GameOptions[GAME_OPTNS_DIFFICULTY],0,2);


	ExtraCPURatings = ExtraRatingsTable[GameOptions[GAME_OPTNS_DIFFICULTY]];


	if(GameType == PLAYOFF_GAME)
		ExtraCPURatings += 10;
	else if (GameType == CHAMPIONSHIP_GAME)
		ExtraCPURatings += 15;
//	else if (GameType == SEASON_GAME)
//		ExtraCPURatings = 0;
//	else	// check options for exhibition or practice
//		ExtraCPURatings = ExtraRatingsTable[GameOptions[GAME_OPTNS_DIFFICULTY]];
}


UWORD SecondsOnPlayClock(void)
{
//LONG secs =	gVBlankTimers[PLAY_TIMER_NUM];
LONG secs =	GetVBlankTimer(PLAY_TIMER_NUM);

//	if(sec != ZERO)	   //leave on ZERO if expired
//	{
		secs = (secs+CLOCKS_TICKS_PER_SECOND-1)/CLOCKS_TICKS_PER_SECOND;

//	}
	return ((UWORD)secs);

}



void SetQuarterTime(void)	// called in InitGameData so time !ZERO
{
ULONG ticks;

	ticks =	QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]];

	SetVBlankTimer(GAME_TIMER_NUM,ticks);

	if(ticks <= 2*60*CLOCKS_TICKS_PER_SECOND)	// no 2min warning if short quarter
		SetBit(GameFlags, GAVE_2MIN_WARNING_BFLAG);


}

void StartNewQuarterKickOff(WORD numtimeouts)
{
	ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// abort any Change of Possession

	GameTeamData[0].TimeOuts = GameTeamData[1].TimeOuts = numtimeouts;

	ResetBit1(EventFlags,SAFETY_HAPPENED_BFLAG);	// to position ball for KO
	IllegalKickCount = ZERO;
	InitKickOffPlay();
}

#define	Get2ndHalfKO_BFLAG	0x0001	/* in GameTeamData[x].TeamFlags	*/
WORD Get2ndHalfKOTeam;

void SetNewQuarter(void)
{ 	// TheQuarter starts at 1 to 4 (5 in OT) - not at ZERO

	BCStopClock = FALSE;

	StopGameClock();	// should be stopped, but make sure

	ResetBit(GameFlags,QUARTER_OVER_BFLAG);
	ResetPlayCallInit();	// re-init entire play calling

	SetQuarterTime();

	if(++TheQuarter > 5)
		TheQuarter = 5;		// it's been a long game (Double OT in playoffs)
//	TheQuarter++;	// check >5 AFTER KO set up (NO KO in 6th Q) - YES - KO in 6th
	TheTrueQuarter++;	// could be >5 if OT in Playoffs (for TofP)

	if(PracticeMode)
	{
		SetTestPlay();	// put ball at 10 yard line
	}
	else if(TheQuarter == 1)	// game just starting
	{
		Get2ndHalfKOTeam = 	DefensiveSlotNum;
		StartNewQuarterKickOff(3);	// numtimeouts
	}
	else if(TheQuarter == 3)
	{
		ResetBit(GameFlags, (NEED_2MIN_WARNING_BFLAG | GAVE_2MIN_WARNING_BFLAG));

		OffensiveSlotNum = Get2ndHalfKOTeam;
		GameTeamData[OffensiveSlotNum].OffDefFlag = ON_OFFENSE;
		DefensiveSlotNum = Get2ndHalfKOTeam^1;
		GameTeamData[DefensiveSlotNum].OffDefFlag = ON_DEFENSE;

		StartNewQuarterKickOff(3);	// numtimeouts

	}
	else if(TheQuarter == 5)	// also OT in playoffs
	{	// - should have re-done coin flip
		StartNewQuarterKickOff(2);	// numtimeouts
	}
	else	// must be 2 or 4
	{
		OffenseDir ^= 1;		// offense go other way
		ToggleAIWindDir();
	}


	// force  players into huddle, Play State = 0
//	ForceNewAIPlayInit(OKAY_TO_START_PLAYCALL);	// and LOAD_PLAY_CALL);
  // NOTE: above now done external to routine
}


void ResetPlayNums(void)
{
#if PC_ALWAYS_MODE
	// nothing - leave them as they were
#else	// tell Play call that new plays need to be selected
		GameTeamData[0].PlayNum = GameTeamData[1].PlayNum = -1;
//		SetBit(GameFlags, NEED_INIT_OF_PLAYCALL_BFLAG);	// cleared by PlayCall

#endif
}

/***
BOOL NeedToInitPlayCall(void)
{
	return(GameFlags & NEED_INIT_OF_PLAYCALL_BFLAG);	// cleared by PlayCall
}

void PlayCallHasBeenInited(void)
{
	ResetBit(GameFlags,NEED_INIT_OF_PLAYCALL_BFLAG);	// cleared by PlayCall
}
*/
/*
void SetPlayCallStatus(WORD newstatus)
{
	PlayCallStatus = newstatus;
	if(newstatus >= 	OKAY_TO_LOAD_PLAYCALL_DATA)
	{	// tell playcall that both teams need to pick a play
		GameTeamData[0].PlayNum = GameTeamData[0].PlayNum = -1;
	}
}
*/


void HandleChangeOfPossesssion(void)
{
	if(PlayOverFlags & NEED_COP_BFLAG)	// do Change of Possession
	{
		ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// did Change of Possession


	// swap field if PSX or PC, but Saturn actually flips camera, so no swap
	//  NO - swap on Saturn too 4/26/96
		SetInitStartBall(OFF_GOAL_LINE - StartBallX + DEF_GOAL_LINE);	/* put on "other side of field */


	// swap Offense and defense
		GameTeamData[0].OffDefFlag ^= 1;
		GameTeamData[1].OffDefFlag ^= 1;
		OffensiveSlotNum ^=1;
		DefensiveSlotNum ^=1;
		OffenseDir ^= 1;	// offense going other direction
		ToggleAIWindDir();

		if(PlayType < EX_PT1_PLAY)
		{
			StartNewDrive = TRUE;
			NextDown = TheDown = 1;
			Set1stDownParameters();
//			SetNewDown();
		}
		else
		{  // extra pt. or KO
			NextDown = TheDown = ZERO;
			NumPlaysInDrive = DriveTime = ZERO;
		}

#if PC_DEBUG_MODE
		GameTeamData[OffensiveSlotNum].PlayNum = INITIAL_OFF_PLAY;	//PC testing only
		GameTeamData[DefensiveSlotNum].PlayNum = INITIAL_DEF_PLAY;  //PC testing only
#endif
	}

}

/*----------------------------------------------------------------

				Force  New  AI  Play  Init

	Following should only be called when screen black or view not on
	field as it forces (teleports) players to init in huddle.

----------------------------------------------------------------------*/
void ForceNewAIPlayInit(WORD newplaycallstatus)	// forces  players in huddle, Play State = 0
{

	HandleChangeOfPossesssion();	// if necessary

	InitPlayersInHuddle(TEAM0);	// sets SCRIPTS to DoNothing
	InitPlayersInHuddle(TEAM1);
	InitReferees();				//put ref on sideline

	 // I need a play call screen
//	PlayCallStatus = OKAY_TO_START_PLAYCALL;	// AND load
	PlayCallStatus = newplaycallstatus;	// now a variable due to AIStalled stuff
	ResetPlayNums();

//	SetPlayCallStatus(newplaycallstatus);

	InitPlayClock();	// sets clock to MAX but DOES NOT START it

	InitAI(FALSE);		// FALSE means start of Game, TRUE means start of play

//	SetPlayState(PS_WaitForPlayStartNUM);	//players do nothing until P.Call done
//  above now done externally

	BallPreSnap();
	SetBallAction(BallPreSnap);

}


/*------------------------------------------------------------------*/

void InitPracticePlay(void)
{
	PlayType = NORMAL_PLAY;

	StartBallX = PracticeStartBallX;
	NextDown = 1;
	StartNewDrive = TRUE;	// I think

	SetNewDown();
}

void SetTestPlay(void)
{	// used by PC testing OR Practice mode
	GameTeamData[OffensiveSlotNum].PlayNum = INITIAL_OFF_PLAY;
	GameTeamData[DefensiveSlotNum].PlayNum = INITIAL_DEF_PLAY;
//	InitNewNormalPlay(DEF_GOAL_LINE+10*YARD);
	InitPracticePlay();
}

void InitKickOffPlay1(void)		// subrroutine for condition compile
{
	PlayType = KICKOFF_PLAY;
	TheDown = ZERO;
	FirstDownX = -1;

	StopGameClock();	// just to be sure

	if(EventFlags.SAFETY_HAPPENED_BFLAG)
	{
		SetInitStartBall(OFF_GOAL_LINE-20*YARDS);	// Y = middle of field
		SetBit(GameFlags,FREE_KICK_BFLAG);
	}
	else
	{
		SetInitStartBall(OFF_GOAL_LINE-30*YARDS);	// Y = middle of field
		ResetBit(GameFlags,FREE_KICK_BFLAG);	// just to be sure
	}

	if(PlayOverFlags & NEED_COP_BFLAG)	// if Change of Possession
	{	/* put on "other side of field so COP can put it back */
		SetInitStartBall(OFF_GOAL_LINE - StartBallX + DEF_GOAL_LINE);
	}
}




void InitKickOffPlay(void)		// called at end of play
{

	KickOffType = NORMAL_KO_TYPE;	//CPU only - could be changed to onside

	if(PracticeMode)
	{
		SetTestPlay();

	}
	else
	{

#if PC_ALWAYS_MODE
		if(DoKickOffs)
			InitKickOffPlay1();		// subroutine for conditional compile
		else
			SetTestPlay();
#else	// consoles
		InitKickOffPlay1();		// subroutine for conditional compile
#endif
	}
}



void ClearPlayInfoTextBuffers(void)
{
	PlayInfoText1[0] = PlayInfoText2[0] = PlayInfoText0[0] = NULL;
}

void ClearPenaltyTextBuffers(void)
{
WORD i;

	for(i=0; i<NUM_PENALTY_TEXT_BUFFERS; i++)
	{
		PenaltyTextBuffer[i][0] = NULL;
	}
}



/*********************************************************************

					INIT   A.I.

	At the beginning of each PLAY(input = TRUE) OR at beginning of Game
	(input = FALSE).

	The "GameTeamData[x].PlayNum" is assumed to have been inited
	by the playcall screen if TRUE.

************************************************************************/

void ConfigureJoyPads(void);


void InitAI(BOOL StartOfPlay)	// everybody should still be in huddle
{

EFFVAR  i,offplay,playnum;


	NextOffTeam =		// assume offense ends up with ball @ Playover
		OffensiveSlotNum = OFFENSIVE_SLOT_NUM_MACRO;

	DefensiveSlotNum = OffensiveSlotNum^1;



/**   first to normal init for Start of Play or Start of Game	**/
#ifndef  TRUE_SOUND
//#if  PC_ALWAYS_MODE

	// below are global vars normally set by graphic engine
	AnimationsLoaded();	// all anims are there
	TDAnimLoadedNum = (rand()%3);

#endif

	GameOptions[GAME_OPTNS_DIFFICULTY] =	// make sure valid for all game
			SetMinMax(GameOptions[GAME_OPTNS_DIFFICULTY],0,2);


	YardsGainedThisPlay = ReplotBallArcCounter = BallFlags = ZERO;
	BallSnapped = FALSE;
	BallDirection = EAST_DIR;	// for correct graphic display

	AccumulatedTacklePercent = MissTackleCount = SFXCount = ZERO;		// test counters

// NOTE: GameFlags & InterfaceFlags only zeroed at game init
	SetMemory(&EventFlags, ZERO, sizeof(struct evflags));
	PlayFlags = PlayOverFlags = //EventFlags =
					MoreEventFlags = PlayStateFlags = ZERO;

	// normal (defaut) QB EOP stuff - could be changed by play init
	QBEndOfPlayScriptNum = WatchEOPScriptNUM;


	// clear Text Display buffer
	ClearPlayInfoTextBuffers();
	ClearPenaltyTextBuffers();

	WordsInRefPhrase = WordsInAnnouncerPhrase = ZERO;	// for audio phrases

	ClearReceivers();
//	SetIRPReceivers(); moved to separate routine

	gZonePtr = NULL;

	/*   set all variable "players" to NOBODY	*/
	CameraGuy = DefStrutter = FutureBC = TheReceiver = FinalBallCarrier =

//		DefPassInterferenceGuy =
		BallCarrier = PenaltyBallCarrier =
		BlockedKickRecoverer = BlockedKickBlocker =
		ThrowAwayRec = IntendedReceiver = PassCatcher = PassInterceptor =
		KickReturner = KickerSlot = PuntReturner =
		Passer = Tackler = PassDefender = Rusher =
		Fumbler = FumbleRecoverer = ScoreStat = Scorer =  SackAllower =
		OffPenaltyGuy = DefPenaltyGuy =
		PenaltyGuy = PersonalFouler = BCHitter = NOBODY;	// for stats


	OffPenaltyPending = DefPenaltyPending = 	// type of penalty
		PenaltyResolved =
		ActivePenalty = PENALTY_NOT_ACTIVE;		// 1 means accept, 2 means decline

	PenaltyChooser  = NOBODY;  	// team slot num if human chosing


	InvalidPlay = 	// set if offsetting penalties
		SinglePenaltyPending =		// set if only 1 penalty this play
			KickEndsPlay = FALSE;	// helps with possible stats errors

	SackYards = ReturnYards = PuntYards = INVALID_DISTANCE;	// can't use 99 to -50 since they're valid

	PointsThisPlay = KickStatsType = KickLength = 0;

	ScoringTeamThisPlay = NOBODY;
	ScoreType = NO_SCORE;

	ExtraTackleX =  TempExtraTackleX =	// used if BC falls forward
		ForwardProgress = CatchBallX = FumbleX = PossibleFumbleX =
					FumbleRecoveryX = ZERO; // for stats

	DefPassInterferenceCounter = OffPassInterferenceCounter = ZERO;

	PassType = NO_PASS;


/*  clear all controller stuff (players and controllers)
		will be set up in "InitTeamPlayAI()"		*/

	for(i=0; i <MAX_CONTROLLERS; i++)	/* no human control...yet 	*/
	{
		DefToggleIndex[i] = -1;
		ControlWhichPlayer[i] = NOBODY;	// ... will be set up in InitteamAI
		PreviousJoyReading[i] = 0xffff;	// psuedo force all keys pressed
	}

	for(i=0; i <NUM_PLAYER_SLOTS; i++)	/* no human control...yet 	*/
	{
		OPControllerNum(i) = NO_CONTROLLER;
		OPZPos(i) = ZERO;			// put everybody on ground
		PlayersYSortList[i] = i;
		OPYSortPos(i) = i;
	}

	ConfigureJoyPads();


	BCStuck.Low.X = BCStuck.High.X = BCStuck.Low.Y = BCStuck.High.Y =
		BCStuckTimer = ZERO;


	KickOOBX = BallTargetX = BallTargetY = ZERO;
//	SaveIRPBallTarget();	// must be AFTER initing BTargetX/Y

	PointsInBallArc = BTX1 = BTX2 = BTY1 = BTY2 = ZERO;	//init globals


	FumbleFrameCounter = AIPlayTimer = AIFrameCounter =	NumBallBounces
		= NumFumblesOnPlay = NumDeflections =
		PassCounter = TimeIntoPlay = ZERO;

//	EOPSFXPending = -1;		// End OfPlay SFX to play (after whistle)
//	AutoReplayFlag = FALSE;

//	ToggledReceiver = 2; 	// index of PosReceivers used in Receivers[2]
	PassState = 2;

	QBHandoffFreezeTime = QUARTER_SECOND+18;	//12;

//	InitReferees();

		// no InstantRePlay yet
//	StartIRPFrameCounter = CurIRPFrameCounter = EndIRPFrameCounter = ZERO;

	TurnOffKickInterface(); //just to be safe
	MaxPointsInBallCursor = BallArcCounter = -1000;	// don't display

	GameTeamData[0].TeamFlags = GameTeamData[1].TeamFlags = 0;

	AITickCount = ZERO;

	PutCameraOffRefMacro;	// just to make sure

	SetWindSpeed();

	PenaltyX = OriginalStartBallX = StartBallX; // Original used to figure penalty placement
	AcceptPenaltyMode = 0;

	if(StartOfPlay)
	{

		// defense MUST mimic offense flip due to shifting
		GameTeamData[DefensiveSlotNum].PlayFlipped =
					 GameTeamData[OffensiveSlotNum].PlayFlipped;


//		SetPlayState(PS_HuddleToLOSNUM);

		if(ANY_EXPT_PLAY)	// next play is Ex pts or KO
		{	// keep crowd sound the same

			// Why set COP now ????  Wait till play over ????

			NextPlayType = KICKOFF_PLAY;
			SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP
		}
		else
		{
			NextPlayType = NORMAL_PLAY;	// assumption, could change depending on what happens in play
			ResetBit(GameFlags,BIG_HOME_TD_BFLAG);

			for(i=0; i<NUM_MAJOR_CROWD_SFXS; i++)
			{ 	// return to normal crowd volumes slowly
	//			SetNewCrowdVolume(i,NormalCrowdVolume[i],SECOND);
	//			SetNewCrowdVolumeDelta(i, NormalCrowdVolume[i],1<<CVOL_SHIFT);
				SetNewCrowdVolume(i, LeavingHuddleCrowdVolume[i],3*SECONDS);
			}
			DesiredLeftChannelPercent = 50;
		}

		if( TheDown == 3
			&& DefensiveSlotNum == HOME_TEAM_SLOT
			&& (TheQuarter > 2 || FirstDownX -StartBallX <= 2*YARDS)
		  )
		{
			i = (rand()&1) ? CHANT : DEFENSE_LOOP_SFX;
			AIInitSFXLoop2(i,AI_MAX_CROWD_VOLUME, 2*SECONDS);
		}

		LastBallCarrier = QB_SLOT_NUM;	//CENTER_SLOT_NUM;

		offplay = GameTeamData[OffensiveSlotNum].PlayNum;

		if(offplay >= SpecialTeamsFakeFGRunNUM && offplay <= SpecialTeamsFakeFGPassNUM)
		{ // set flags for kick interface

			if( (KickJPadNum = GameTeamData[OffensiveSlotNum].ControllerNum[0]) != NO_CONTROLLER)
			{
				SetBit(PlayFlags,POS_HUMAN_KICK_BFLAG);
			}
			KickerSlot = 4;
			SetBit(PlayFlags,(POS_FG_PLAY_BFLAG	| POS_ANYKICK_PLAY_BFLAG));
	//		PlayType = FIELD_GOAL_PLAY  no-no this set when ball actually kicked


			if(offplay != SpecialTeamsFieldGoalNUM)
				SetBit(PlayFlags,FAKE_KICK_PLAY_BFLAG);	/* used to turn off Kick interface */
		}
		else if( (offplay >= SpecialTeamsFakePuntRunNUM && offplay <= SpecialTeamsFakePuntPassNUM)
				|| offplay == ShotGunPoochKickNUM)
		{
			if( (KickJPadNum = GameTeamData[OffensiveSlotNum].ControllerNum[0]) != NO_CONTROLLER)
			{
				SetBit(PlayFlags,POS_HUMAN_KICK_BFLAG);
			}
			SetBit(PlayFlags,(POS_PUNT_PLAY_BFLAG	| POS_ANYKICK_PLAY_BFLAG));
	//		PlayType = PUNT_PLAY;  no-no this set when ball actually kicked
			if(  (offplay == SpecialTeamsFakePuntRunNUM)
			   ||(offplay == SpecialTeamsFakePuntPassNUM) )
			{
				SetBit(PlayFlags,FAKE_KICK_PLAY_BFLAG);	/* used to turn off Kick interface */
			}
			if(offplay != ShotGunPoochKickNUM)
			{
				SetBit(PlayFlags,POS_PUNT_NOPOOCH_PLAY_BFLAG);	// used for audio hooks
				KickerSlot = 0;		// actually the punter

			}
		}
		else if(offplay == KickoffReturnRegularNUM
				|| offplay == KickoffReturnHandsNUM
				|| offplay == KickoffReturnSpreadNUM)
		{
			if( (KickJPadNum = GameTeamData[DefensiveSlotNum].ControllerNum[0]) != NO_CONTROLLER)
				SetBit(PlayFlags,POS_HUMAN_KICK_BFLAG);

			SetBit(PlayFlags,(POS_KO_PLAY_BFLAG	| POS_ANYKICK_PLAY_BFLAG));
			PlayType = KICKOFF_PLAY;	// we can do this here cause there's no fake kickoffs
			LastBallCarrier = NOBODY;

//			SetNewCrowdVolume(MID_CROWD_SFX,AI_MAX_CROWD_VOLUME,10*SECOND);

		}

		playnum = GameTeamData[DefensiveSlotNum].PlayNum;
		if(playnum == KickoffStackLeftNUM)
			StartBallY = NORTH_HASH_MARK;	// will cause ball to eleport
		else if(playnum == KickoffStackRightNUM)
			StartBallY = SOUTH_HASH_MARK;
		else if(playnum == KickoffRegularNUM)
			StartBallY = MID_FIELDY;


		// Set ball action BEFORE teams as some test plays(race) reset ballaction
		SetBallAction(BallPreSnap);		// will set ball flags to SHOWBALL, BallXPosition = StartBAllX

		InitTeamPlayAI(OffensiveSlotNum);	// must do off. first..
			//... since def. needs to know off's formation for def. play init

		SaveOffensivePlayNum();		// for possible adjustment by defense

		InitTeamPlayAI(DefensiveSlotNum);

		SetTeamBlockFactor();

		for(i=0; i<11; i++)
		{
			DefenseToggleArray[i].slotnum =
					DefenseKeyDistance[i].slotnum = i+11;
			OffenseKeyDistance[i].slotnum = i;
			OffenseKeyDistance[i].distance =
					DefenseKeyDistance[i].distance = 100*YARDS;	// set to max
		}

//		SetBallAction(BallPreSnap);		// will set ball flags to SHOWBALL, BallXPosition = StartBAllX

#if 0	//__MSDOS__
		for(i=0; i<22; i++)
		{
			printf("%2d-#%d %s",i,GetJerseyNum(i),GetPlayerName(i));
		}
#endif
	}

	BubbleSortOnY();	// all players


}




/*----------------------------------------------------------------*/

void InitPlayerPlayConstants(void)	// used by Players or Ref
{ 	// only init CP  (gPNum)

	CPNumSpinMoves = CPNumSpeedBursts = CPTackleCount =
		CPSpeed = CPBurstCounter = CPCPUBurstTimer
				= CPFlags = CPFlags1 = ZERO;

	CPAction = NoAction;
	SetAI(NoAI);

	CPBStatePtr = NormalBlocker;
	CPState2Count = -1;		// 2nd State is if they get "stuck"

	CPGuyToBlock = CPBlockingMe = CPGuyToCover = NOBODY;

	CPTimer = 0;
	CPOldZPos = CPZPos = ZERO;

	CPReactTime = MAX_REACT_TIME;	//	(30*SECONDS)as of 10/16/96

}



void InitReferees(void)			// at beginning of PLAY (in InitAI())
{
	gPNum = REF_SLOT_NUM;
	InitPlayerPlayConstants();	// ... of gPNum

	CPOldXPos = CPXPos = StartBallX;
	CPOldYPos = CPYPos = SOUTH_SIDELINE+2*YARDS;
	CPOldZPos = CPZPos = ZERO;

	CPDirToGo = CPFacing = NORTH_DIR;
	InitGraphics(AI_REF_STAND_NUM);
	SetNewScript(RefWatchPlayScriptNUM);
	RefSFXPending = -1;

	PutCameraOffRefMacro;	// used by graphics engine - just to be sure

	if(TheDown == ZERO)	// KO or EP
		RefMarkerX[0] = RefMarkerX[1] = ZERO;	// DON'T show marker refs

//	OneTimeIRP.StartPlayRefMarkerX[0] = RefMarkerX[0];	// save in case of IRP
//	OneTimeIRP.StartPlayRefMarkerX[1] = RefMarkerX[1];


}

void ResetIRPCounters(void)	// also called by graphic engine when PCall done
{
	StartIRPFrameCounter = CurIRPFrameCounter = EndIRPFrameCounter = ZERO;
}

void InitIRPPrePlay(void)
{	/* Init replay must be isolated from InitAI as it caused problems
	with going to scoreboard (couldn't do IRP @ SB as InitAI(FALSE) was
	call when players were force into huddle	*/

EFFVAR i;

		// no InstantRePlay yet
	ResetIRPCounters();

	SetIRPReceivers();
	SaveIRPBallTarget(); // must be AFTER initing BTargetX/Y (in this case-ZERO)

	OneTimeIRP.BeginningofPlayOffTeamSlotNum = OFFENSIVE_SLOT_NUM_MACRO;
	OneTimeIRP.BeginningofPlayOffenseDir = OffenseDir;	// for camera

	OneTimeIRP.StartPlayRefMarkerX[0] = RefMarkerX[0];	// save in case of IRP
	OneTimeIRP.StartPlayRefMarkerX[1] = RefMarkerX[1];
	OneTimeIRP.StartFirstDownX = FirstDownX ;
	OneTimeIRP.StartStartBallX = StartBallX;

	// need to know who's on field at play begin in case of COP
	for(i=0; i<22; i++)
		OneTimeIRP.IRPPlayerDataPtr[i] = GetPlayerDataPtr0_21(i);


}




/* control these slot numbers on Kickoff or non-receiver plays	*/
///WORD DefaultHumanAssignments[3]= {1,2,3};

/****************************************************************

			S E T     P L A Y E R      R A T I N G S

		For the 22 players on the field

****************************************************************/
WORD ExtraWeatherSpeed[MAX_WEATHER_OPTIONS] = {0,-2,-4};

//WORD SpeedIncOption[3] = {-5,0,6};	// new options 8/5/96
WORD SpeedIncOption[3] = {-5,0,7};	// new options 11/16/96

void SetCPRatings(WORD extraratings)	//sets gPNum's constant ratings
{
specificplayerdata *PData;
EFFVAR speed,speed1;


	/**  set up player ratings from constant ratings	*/
	PData = GetPlayerDataPtr(gPNum);	// will point to one of 2*47 current players

	CPStrength = SetMinMax(PData->ratings[STRENGTH_RATE] + extraratings,1,100);


	speed = SetMinMax(( (PData->ratings[SPEED_RATE] + extraratings)/5),
	  LOWEST_NORMAL_SPEED,HIGHEST_NORMAL_SPEED);	//rating 0-100 -> 0-20

	speed1 = SpeedIncOption[SetMinMax(GameOptions[GAME_OPTNS_GAME_SPEED],0,2)]
		   + ExtraWeatherSpeed[GameOptions[GAME_OPTNS_WEATHER]];


	speed1 = SetMinMax(speed1,-6,7);	// not too slow
	speed += speed1;	// not too slow
	speed = SetMinMax(speed,(LOWEST_NORMAL_SPEED-1),(HIGHEST_MAX_SPEED-1)); //bug #3211

	CPMaxSpeed = speed<<SPEED_SHIFT;	// store in high byte

  /* CPMinMaxSpeed is used by BC getting tired - bug # 1643   */
  /*  AND by SpeedBurst bug #3002		*/
//	CPMinMaxSpeed = CPMaxSpeed - (3<<SPEED_SHIFT);
//	CPMinMaxSpeed = CPMaxSpeed - (2<<SPEED_SHIFT);	// was 3, bug #1691
//	CPMinMaxSpeed = CPMaxSpeed - (3<<SPEED_SHIFT);	// back to 3 with 20 pos. speeds
	CPMinMaxSpeed = CPMaxSpeed - (4<<SPEED_SHIFT);	// 10/5/96 -bug #3002
	if( CPMinMaxSpeed  < (4<<SPEED_SHIFT))
		CPMinMaxSpeed = (4<<SPEED_SHIFT);	// slowest possible

//	CPAcceleration = 84;	//PData->ratings[ACCELERATION_RATE];
	CPAcceleration = 0x1000;	//instant accel- test only 8/20/96

	CPReaction = SetMinMax(PData->ratings[REACTION_RATE] + extraratings,10,100);

	CPHands = SetMinMax(PData->ratings[HANDS_RATE] + extraratings,10,100);          	// 0 -100
	CPArmStrength = SetMinMax(GetPlayerArmStrength(gPNum) + extraratings,10,100);	// 0 -100
	CPFootStrength=	SetMinMax(GetPlayerFootStrength(gPNum) + extraratings,10,100); // 0 -100

	CPAgility =  SetMinMax(GetPlayerAgility(gPNum) + extraratings,10,100);

	CPRunBlockRating =  SetMinMax(GetPlayerRunBlockRating(gPNum) + extraratings,1,100);
	CPPassBlockRating =  SetMinMax(GetPlayerPassBlockRating(gPNum) + extraratings,1,100);
	CPTackleRating =  SetMinMax(GetPlayerTackleRating(gPNum) + extraratings,10,100);
	CPRushRating =  SetMinMax(GetPlayerRushRating(gPNum) + extraratings,10,100);



	CPJerseyNum = PData->jerseynum;	// not really a rating...
}

#define	OPRunBlockRating(opnum)		(PlayerRunBlockRating[opnum])
#define	OPPassBlockRating(opnum)	(PlayerPassBlockRating[opnum])
#define	OPTackleRating(opnum)		(PlayerTackleRating[opnum])
#define	OPRushRating(opnum)			(PlayerRushRating[opnum])






/********************************************************************

			Cheats  (I mean Adjustments)

********************************************************************/

void SaveOffensivePlayNum(void)
{	// keep track of what plays offense calls so we can adjust (i.e. cheat) later

	GameTeamData[OffensiveSlotNum].PrevOffPlayNum[GameTeamData[OffensiveSlotNum].OffPlayNumCounter]
				= GameTeamData[OffensiveSlotNum].PlayNum;

	if(++GameTeamData[OffensiveSlotNum].OffPlayNumCounter >= MAX_OFF_PLAYDATA)
		GameTeamData[OffensiveSlotNum].OffPlayNumCounter = ZERO;
}


BYTE AdjustDefRatingsBasedOnOffPlaysTable[MAX_OFF_PLAYDATA+1] = {
//	0 1 2 3 4   5   6   7  8
	0,0,4,8,10, 12, 16, 24,28
};

EFFVAR AdjustDefRatingsBasedOnOffPlays(void)
{
EFFVAR i,curplay,extrarating;
EFFVAR curplayindex,prevplayindex;
EFFVAR playcount = 0;

	/*  was already inc'ed for next insertion, so go back one	*/
	curplayindex = 	GameTeamData[OffensiveSlotNum].OffPlayNumCounter-1;
	if(curplayindex < ZERO)
		curplayindex = MAX_OFF_PLAYDATA-1;

	prevplayindex = curplayindex-1;
	if(prevplayindex < ZERO)
		prevplayindex = MAX_OFF_PLAYDATA-1;


	curplay = GameTeamData[OffensiveSlotNum].PrevOffPlayNum[curplayindex];

	for(i=0; i<MAX_OFF_PLAYDATA; i++)
	{ // how many times has this play been called
		if(curplay == GameTeamData[OffensiveSlotNum].PrevOffPlayNum[i])
			playcount++;
	}

	extrarating = AdjustDefRatingsBasedOnOffPlaysTable[playcount];

	if(GameTeamData[OffensiveSlotNum].PrevOffPlayNum[curplayindex] ==
		GameTeamData[OffensiveSlotNum].PrevOffPlayNum[prevplayindex])
	{	// called same play twice in a row???

		extrarating += 4;

	}

	return (extrarating);
}







EFFVAR FigureRunPassDistibutionForHuman(void); 	//in FBBLock
BYTE CPUCheatRatings[9] = {0,0,0,0,0, 1,2,3,5};

/*----------------------------------------------------------------*/

#define	REC_START_ADJUST	(2*FEET)	//(3*QTR_YARD)

void InitTeamPlayAI(WORD TeamSlotNum)
{	// NOTE: offense goes first, then defense

EFFVAR  yoff,temp,i;
struct formation  *FormationPtr;
//struct  play    *PlayPtr;
EFFVAR playnum,index;
EFFVAR	dirtoface,loopstart;
EFFVAR	cntl,hudform;
EFFVAR extraratings = ZERO;
//BOOL error = FALSE;

	if(Q_CPUTeamMacro(TeamSlotNum))	// only CPU teams
	{
		extraratings += ExtraCPURatings;	// > 0 if playoff OR hard difficulty
		if(Q_HumanTeamMacro(TeamSlotNum^1))	// other team human???
		{
			if(GameTeamData[TeamSlotNum].TotalScore < GameTeamData[TeamSlotNum^1].TotalScore-7)
				extraratings += (2+(rand()&3));	// give more if CPU behind against human
		}
	}

	if(TeamSlotNum == HOME_TEAM_SLOT && TeamSlotNum == OffensiveSlotNum)
	{ // only HOME offense gets the bump 11/9/96
		extraratings += (2+(rand()&3));	// home team get extra points
//		extraratings += (0+(rand()&3));	// home team get extra points
	}

	if (GameTeamData[TeamSlotNum].OffDefFlag == ON_OFFENSE)
	{
		dirtoface = EAST_DIR;
		loopstart = 0;
		hudform = OFF_HUDDLE_FORM_NUM;
	}
	else   // this is defensive team
	{
	// if a human is calling too many plays of one kind, he is penalized
		if(GameOptions[GAME_OPTNS_DIFFICULTY] > ZERO) // normal or hard mode
		{
			index = FigureRunPassDistibutionForHuman();
#if PC_ALWAYS_MODE
			if(index > 4)
				printf("\nFigureRunPassDist = %d\n",index);
#endif
			i = AdjustDefRatingsBasedOnOffPlays();

			extraratings += max(i,CPUCheatRatings[index]);
		}

		dirtoface = WEST_DIR;
		loopstart = 11;
		hudform = DEF_HUDDLE_FORM_NUM;

		for(i=0; i<MAX_USERS_PER_TEAM; i++)	// set who to control based on prev. play
		{
//			DefToggleIndex[i] = -1; 	// -1 inited to previous
			if( (cntl = GameTeamData[TeamSlotNum].ControllerNum[i]) != NO_CONTROLLER)
			{
				if(PlayType == KICKOFF_PLAY)
					temp = InitDefControlledGuys[i]; // Captain must be kicker
				else
					temp = GameTeamData[TeamSlotNum].PrevDefControlledPlayers[i];

				OPControllerNum(temp) = cntl;
				ControlWhichPlayer[cntl] = temp;
			}
		}
	}

/* following allows for testers to change ratings realtime from debug menu
	WARNING - once changed, ratings will NOT revert to true player/team
	until start of next game				*/
	InitDebugPlayerRatings(TeamSlotNum);

	playnum = GameTeamData[TeamSlotNum].PlayNum;
//	PlayPtr = &ThePlays[GameTeamData[TeamSlotNum].PlayNum];
//	FormationPtr = AllFormations[PlayPtr->FormationNumber];
//	GameTeamData[TeamSlotNum].FormationNumber = PlayPtr->FormationNumber;

	FormationPtr = AllFormations[ThePlays[playnum].FormationNumber];
	GameTeamData[TeamSlotNum].FormationNumber = ThePlays[playnum].FormationNumber;


	if(!CPURatingCheat)	// default is cheat mode
	{
		extraratings = ZERO;
	}

	temp = gPNum;		/* save in case it's being used	*/

	for(i=0,gPNum=loopstart; i < 11; i++,gPNum++)
	{

		/* remember - gPNum is "hidden" in CPSpeed, etc.	*/

		InitPlayerPlayConstants();	// used by Players or Ref


	// must load position first so I can use it to "GetPlayerDataPTR"
/* covert "true" position in formation to who is actully in that position
	based on teamroster (or depth chart)			*/
		CPMyFormPosition = FormationPtr->FormationStart[i].WhoAmI;	// formation position
		CPMyPNum = TeamRoster[TeamSlotNum][CPMyFormPosition];	// actual player number on this team

		SetCPRatings(extraratings);	//CPMyPNum MUST be setup

		InitGraphics(AI_STAND_NUM);


  /*  set Target (from Huddle) and init X,Y (in case of no huddle) -
	if in huddle, init X,Y will be set up below n 2nd loop	*/
//		CPTargetX = CPXPos = min((StartBallX + (UWORD)FormationPtr->FormationStart[i].XStart),MAX_DEF_COVERX);
		CPTargetX = StartBallX + FormationPtr->FormationStart[i].XStart;
		if(CPTargetX < DEF_END_LINE + HALF_YARD)		// punter if on 1 yrd?
			CPTargetX = DEF_END_LINE + HALF_YARD;
		else if(CPTargetX > MAX_DEF_COVERX)		// punt returner if on 99 YRD?
			CPTargetX = MAX_DEF_COVERX;


		yoff = FormationPtr->FormationStart[i].YStart;
		if(CPMyFormPosition == RR || CPMyFormPosition == LR)
		{   // adjust receivers start pos - idea is to keep off same Y as DB
			if(PERCENT50)
				yoff += REC_START_ADJUST;
			else
				yoff -= REC_START_ADJUST;
		}

		if(GameTeamData[TeamSlotNum].PlayFlipped)
			yoff = -yoff;

		CPTargetY = StartBallY + yoff;

		if(!ShowHuddle)
		{
			CPOldXPos = CPXPos = CPTargetX;
			CPOldYPos = CPYPos = CPTargetY;
		}

		GeneratePlayerSphereOfInfluence(gPNum);

		CPDirToGo = CPFacing = dirtoface;

		SetNewScript(ThePlays[playnum].Script[i].ScriptNumToDo);

/*  WARNING - see notes under "NoBlockContact()" in fbblock.c as to
	how I_CAN_PUSH_BFLAG works							*/
		if(PlayType != KICKOFF_PLAY)
			SetBit(CPFlags,I_CAN_PUSH_BFLAG);

		CPDirToPush = NO_DIR;
		CPPushFactor = 2;		// a "speed" to push people at
//		CPControllerNum = NO_CONTROLLER;


	}


	if(ShowHuddle)
	{
#if PC_ALWAYS_MODE
//		InitPlayersInHuddle(TeamSlotNum);
#endif
		for(i=0,gPNum=loopstart; i < 11; i++,gPNum++)
		{
			if(hudform == OFF_HUDDLE_FORM_NUM)
			{
				SetNewScript(OffHuddleToLOSScriptNUM);
				CPFacing = OffHuddleFacing[i];
				InitGraphics(AI_2PTSTANCE_NUM);
			}
			else
			{
				SetNewScript(DefHuddleToLOSScriptNUM);
				CPFacing = DefHuddleFacing[i];
			}
		}
	}


	gPNum = temp;		/* restore	*/


/* do play init LAST after other player parameters set-up	*/
	PlayInitRoutines[ThePlays[playnum].PlayInitRoutineNumber].todo();






/*  receivers must be set up (from PlayInitRoutines) for below to work  */
	if (GameTeamData[TeamSlotNum].OffDefFlag == ON_OFFENSE)
	{

		for(i=0; i<MAX_USERS_PER_TEAM; i++)	// set who to control based on prev. play
		{
			if( (cntl = GameTeamData[TeamSlotNum].ControllerNum[i]) != NO_CONTROLLER)
			{
				temp = GameTeamData[TeamSlotNum].PrevOffControlledPlayers[i];

				OPControllerNum(temp) = cntl;
				ControlWhichPlayer[cntl] = temp;
			}
		}


		for(i=0; i<MAX_RECEIVERS; i++)
		{
			PlayerOptimalPassTime[i] = -1;	// no pass time yet
			CPUPassType[i] = NORMAL_PASS;	// could be changed later
		}
	}


}


void FixControllers(void)
{
WORD conpltr[22];
EFFVAR i,index;

	for(i=0; i<22; i++)
		conpltr[i] = ZERO;


	for(i=0; i<8; i++)
	{
		if( (index = ControlWhichPlayer[i]) >= ZERO)
		{
			if(++conpltr[index] > 1)
			{	// ERROR - 1 controller controlling more than 1 player
//				OPControllerNum(index) = NO_CONTROLLER;	// correction ?!?
				ControlWhichPlayer[i] = NOBODY;
			}
		}
	}

}


/*-------------------------------------------------------------*/

void InitPlayersInHuddle(WORD TeamSlotNum)
{
EFFVAR  yoff,i,hudform;
UEFFVAR keyx;
struct formation  *formationptr;
EFFVAR loopstart;


	keyx = StartBallX;	// assumption

	if (GameTeamData[TeamSlotNum].OffDefFlag == ON_OFFENSE)
	{
		loopstart = 0;
		hudform = OFF_HUDDLE_FORM_NUM;

	/* following allows guys in KO to reach their ending positions faster */
		if(PlayType == KICKOFF_PLAY)
			keyx = StartBallX - 27*YARDS;
		else if(StartBallX < DEF_GOAL_LINE+5*YARDS)
				keyx = DEF_GOAL_LINE+5*YARDS; // don't allow offense to huddle out of EZ

	}
	else
	{
		hudform = DEF_HUDDLE_FORM_NUM;
		loopstart = 11;
	}

	formationptr = AllFormations[hudform];

	keyx = min(keyx, OFF_END_LINE-3*YARDS);

	for(i=0,gPNum=loopstart; i < 11; i++,gPNum++)
	{
	/* remember - gPNum is "hidden" in CPSpeed, etc.	*/

  /*  set Huddle X,Y  (target is actual form X,Y)	*/
		CPOldXPos = CPXPos = keyx + formationptr->FormationStart[i].XStart;

		yoff = formationptr->FormationStart[i].YStart;
//		if(GameTeamData[TeamSlotNum].PlayFlipped)
//			yoff = -yoff;

		CPOldYPos =  CPYPos = StartBallY + yoff;

		GeneratePlayerSphereOfInfluence(gPNum);

		CPAction = NoAction;
		SetNewScript(DoNothingScriptNUM);

		if(hudform == OFF_HUDDLE_FORM_NUM)
		{
			CPFacing = OffHuddleFacing[i];
			InitGraphics(AI_2PTSTANCE_NUM);
		}
		else
		{
			CPFacing = DefHuddleFacing[i];
			InitGraphics(AI_STAND_NUM);
		}
	}

}


/******------------------------------------------------------------

	When a pass is caught or incomplete or play over or ...???
	then remove the graphical indicators by setting Receivers to -1
--------------------------------------------------------------------*/
void ClearReceivers(void)
{
EFFVAR i;

	for(i=0; i<MAX_RECEIVERS; i++)	// set who to control
	{
//		Receivers[i] = PosReceivers[i] = NOBODY;	// the 5 elligible receiviers
		Receivers[i] = NOBODY;	// the 5 elligible receiviers
	}
//	TheReceiver = PosReceivers[3] = PosReceivers[4] = NOBODY;	// the 5 possible receiviers
	TheReceiver = NOBODY;	// the 5 possible receiviers
	ShowReceiverIcons = FALSE;
}

/*******************************************************************/

STATEDEF(SetInitialScriptState)
{	/* called at end of huddletoLOS script to reset guys to what
		they're supposed to do for that play		*/
#if 0
struct  play    *PlayPtr;

//  "CurTeamSlot" set up before calling "DoOffenseAI" or "DoDefenseAI"
	PlayPtr = &ThePlays[GameTeamData[CurTeamSlot].PlayNum];

	SetNewScript(PlayPtr->Script[gPNum%11].ScriptNumToDo);
#else
	SetNewScript(ThePlays[GameTeamData[CurTeamSlot].PlayNum].Script[gPNum%11].ScriptNumToDo);
#endif
}




/*******************************************************************

				 P E N A L T I E S



*******************************************************************/

BYTE *HalfDistString = "HALF THE DISTANCE TO THE GOAL";
BYTE *FiveYardPenString =  "5 YARD PENALTY";
BYTE *TenYardPenString =  "10 YARD PENALTY";
BYTE *LossDownPenString =  "AND LOSS OF DOWN";



#define  penmacro(enum,yards,pentype,string,refanim,refsfx)	#string,
BYTE *PenaltyStrings[MAX_PENALTIES] = {
	PenaltyMacros
};
#undef penmacro


#define  penmacro(enum,yards,pentype,string,refanim,refsfx)	yards,
BYTE YardsPerPenalty[MAX_PENALTIES] = {
	PenaltyMacros
};
#undef penmacro

#define  penmacro(enum,yards,pentype,string,refanim,refsfx)	pentype,
BYTE PenaltyType[MAX_PENALTIES] = {
	PenaltyMacros
};
#undef penmacro

#define  penmacro(enum,yards,pentype,string,refanim,refsfx)	AI_REF_##refanim##_NUM,

WORD RefPenaltyAnim[MAX_PENALTIES] = {
	PenaltyMacros
};
#undef penmacro


#define  penmacro(enum,yards,pentype,string,refanim,refsfx)	refsfx##_SFX,
WORD RefPenaltySFX[MAX_PENALTIES] = {
	PenaltyMacros
};
#undef penmacro



void SetTeamPenaltyStats(WORD teamslotnum,WORD penyards)	//yards is *256
{

	StatsData[teamslotnum].allplyrstats[GS_PENALTY_NUM]++;
	StatsData[teamslotnum].allplyrstats[GS_PENALTY_YARDS] += (penyards>>YARD_SHIFT);
}


UWORD WheresOffPenalty(UWORD penaltyX,UWORD penyards)
{
UWORD newx;

	if(penaltyX - 2*penyards <= DEF_GOAL_LINE)
	{	// then half the distance
		newx = penaltyX - (penaltyX-DEF_GOAL_LINE)/2;
	}
	else
	{
		newx = penaltyX - penyards;
	}

	newx = SETTOWHOLEYARD(newx);

	TruePenaltyYards = penaltyX -newx;	// save for stats later

	return(newx);

}

UWORD WheresDefPenalty(UWORD penaltyX,UWORD penyards)
{
UWORD newx;

	if(penaltyX >= OFF_GOAL_LINE)
	{	// penalty in EZ, put on 1
		newx = OFF_GOAL_LINE - YARD;
	}
	else if(penaltyX + 2*penyards >= OFF_GOAL_LINE)
	{	// then half the distance
		newx = penaltyX + (OFF_GOAL_LINE - penaltyX)/2;
	}
	else
	{
		newx = penaltyX + penyards;
	}

	newx = SETTOWHOLEYARD(newx);

//	TruePenaltyYards = newx-penaltyX;	// save for stats later
	TruePenaltyYards = newx-OriginalStartBallX;	// save for stats later

	return(newx);

}


//returns TRUE if 1/2 distance to goal else FALSE
BOOL SetPenaltyYards(WORD teamtype,WORD penyards)
{
BOOL rv = FALSE;	// assume
EFFVAR tsnum;		// team slot num 0-1
UWORD newx;

	if(teamtype == ON_DEFENSE)
	{
		if(StartBallX + 2*penyards >= OFF_GOAL_LINE)
		{	// then half the distance
			newx =	StartBallX + (OFF_GOAL_LINE-StartBallX)/2;
			rv = TRUE;
		}
		else
			newx = StartBallX + penyards;

		newx = SETTOWHOLEYARD(newx);
		penyards = newx-StartBallX;

		StartBallX = newx;

		if(PlayType <= FIELD_GOAL_PLAY && StartBallX >= FirstDownX)
		{
			NeedTeam1stDownStats = TRUE;
			SetNewFirstDown(FALSE);
		}

		tsnum = DefensiveSlotNum;
	}
	else	// penalty on offense - move ball back
	{
		if(StartBallX - 2*penyards <= DEF_GOAL_LINE)
		{	// then half the distance
			newx = StartBallX - (StartBallX-DEF_GOAL_LINE)/2;
			rv = TRUE;
		}
		else
			newx = StartBallX - penyards;

		newx = SETTOWHOLEYARD(newx);
		penyards = StartBallX-newx;
		StartBallX = newx;

		tsnum = OffensiveSlotNum;

	}

	SetTeamPenaltyStats(tsnum,penyards);	//yards is *256

	AdjustNewStartBall(StartBallX);

	return(rv);
}


void InitFalseStart(void)
{
EFFVAR temp;

//	if( (!PracticeMode) || (PlayStateNum < PS_PlayHappeningNUM)) ???
	if( (!PracticeMode) && (PlayStateNum < PS_PlayHappeningNUM))
	{
		if(GameOptions[GAME_OPTNS_FALSE_START] == OPTION_ON)	\
		{
//			if( (rand()&127) == ZERO)
//			if( (rand()&31) == ZERO)	// higher chance 11/10/96
			if( (rand()&15) == ZERO)	// higher chance 11/10/96
			{
				temp = gPNum;
				gPNum = 6 + (rand()&3);	// tackles or guards
				SetNewScript(FalseStartScriptNUM);
				gPNum = temp;
			}
		}
	}
}



void CheckForPersonalFoul(void)	// a subroutine of PlayState Wait4
{
}
void CheckForPersonalFoul1(void)	// a subroutine of PlayState Wait4
{         // called once per play
BOOL halfdist;


/**
	if(MoreEventFlags & HIT_BC_THIS_FRAME)
	{
		PersonalFouler = BCHitter;
	}
***/
	if( //   (PersonalFouler >=ZERO)	// safer than != NOBODY)
		 (!(EventFlags.SAFETY_HAPPENED_BFLAG))
		&& (! (PlayOverFlags & NEED_COP_BFLAG))
		&& (!(GameFlags & EX_PT_PENDING_BFLAG))
		&& (GameOptions[GAME_OPTNS_PFOULS] == OPTION_ON)
		&& (TheDown < 4)	//includes kickoffs
		&& (!ANY_EXPT_PLAY)	// but not extra points
		&&  (PersonalFouler > 10)	// defense only
		&& (!QuarterHasEnded())
		&& (!(EventFlags.FUMBLE_HAPPENED_BFLAG))	// not if fumble

	  )
	{
#if PC_ALWAYS_MODE
			printf("TRUE PersonalFouler = %d\n\n",PersonalFouler);
#endif

		StopGameClock();

		halfdist = SetPenaltyYards(ON_DEFENSE,15*YARDS);

		sprintf(PlayInfoText0,PlayInfoText1);	// main stuff to top display
//		sprintf(PlayInfoText1,PlayInfoText2);	// make it look right

		sprintf(PlayInfoText1,"LATE HIT BY #%d - %s",
			   GetJerseyNum(PersonalFouler),GetPlayerName(PersonalFouler));
		sprintf(PlayInfoText2,"PERSONAL FOUL - %s",halfdist?"FIRST DOWN":"15 YARD PENALTY");

		if(PlayType == KICKOFF_PLAY)
		{
			NeedTeam1stDownStats = FALSE;
			SetNewFirstDown(TRUE);	// re-init drive stats
		}
		else
		{
			NeedTeam1stDownStats = TRUE;
//			if(TheDown != 1)	// already inc'ed???
//			{
//				UpdateTeamStats(OffensiveSlotNum,GS_1STDOWNS,1);
//			}
			SetNewFirstDown(FALSE);
		}

		if(RefSFXPending == -1)
		{	// only bring out ref if not already out (could be 1st down)
			InitRefPhrase(PERSONAL_SFX);
			SetNewRefAnim(PERSONAL_SFX,AI_REF_FIRSTDOWN_NUM,NO_PENALTY);
			SetRefStartX(StartBallX - 7* YARDS);	// prob. if 1/2 distance
		}
/*		else
		{
			AddToRefPhrase(PERSONAL_SFX);
		}
  didn't work as ref ran off too fast	*/

		for(gPNum = 0; gPNum <22; gPNum++)
		{	// everybody go to new StartX (huddle)
			SetNewScript(EndOfPlayScriptNUM);
		}
	}
	PersonalFouler = BCHitter = NOBODY;	// clear in case of EOP before next InitAI

}



void InitDefPenaltyParameters(UWORD pnum,UWORD penaltynum,UWORD where)
{
	SetBit(GameFlags,DEF_PENALTY_PENDING_BFLAG);	// Quarter can't end

	if(penaltynum > DefPenaltyPending) // only change if "worse" than current
	{
		DefPenaltyPending = penaltynum;				\
		DefPenaltyGuy = pnum;						\
		PenaltyX = where;
	}
}

void InitOffPenaltyParameters(UWORD pnum,UWORD penaltynum,UWORD where)
{
	if(penaltynum > OffPenaltyPending) // only change if "worse" than current
	{
		OffPenaltyPending = penaltynum;				\
		OffPenaltyGuy = pnum;						\
		PenaltyX = where;
	}
}



void CheckForDelayOfGameNew(void)	// with new penalty method	4/97
{
	if( (GameFlags & PLAY_TIMER_ON_BFLAG)
		&& (GetVBlankTimer(PLAY_TIMER_NUM) == ZERO)

	  )
	{
//		StopGameClock();	will stop in a few lines anyway
//		StopPlayClock();

		if( !PracticeMode	// no delay in Practice
		  && GameOptions[GAME_OPTNS_DELAY_OF_GAME] == OPTION_ON)
		{
			if(PlayType == KICKOFF_PLAY)
			{
				InitDefPenaltyParameters(11,DELAY_OF_GAME_PENALTY,StartBallX);
			}
			else
			{
				InitOffPenaltyParameters(0,DELAY_OF_GAME_PENALTY,StartBallX);

			}
		}
	}
}



/***************************************************************************

	Pre Snap Penalties:

		FALSE START	(or stop play if hike after F.S. init but before end)
		OFFSIDES
		DELAY OF GAME

***************************************************************************/

void CheckForPreSnapPenalty(void)
{

#if 0	// test only
	if(PlayType == NORMAL_PLAY
	  && PlayStateNum == PS_Wait2NUM)
	{
		SetVBlankTimer(PLAY_TIMER_NUM,ZERO);
	}
#endif

	CheckForDelayOfGameNew();

//	HandleFalseStartNew();

	if(
		(     PlayStateNum >= PS_HuddleToLOSNUM
		   && PlayStateNum < PS_PlayHappeningNUM
		   && (OffPenaltyPending || DefPenaltyPending)
		)
		|| (MoreEventFlags & FALSE_START_HAPPENED_BFLAG)
	  )
	{  // force to end of play STATE
		StopGameClock();
		StopPlayClock();

		if(MoreEventFlags & FALSE_START_HAPPENED_BFLAG)	// set in players Script
		{
			ResetBit(MoreEventFlags,FALSE_START_HAPPENED_BFLAG);
			InitOffPenaltyParameters(PenaltyGuy,FALSE_START_PENALTY,StartBallX);
		}

		ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// no COP if this is extra point
		ResetBit(MoreEventFlags,OKAY_FOR_STATS_BFLAG);	// no stats if pre-snap penalty

		SavePreviouslyControlledGuys();

//		SaveDefControlledGuys();
//		SaveOffControlledGuys();	// based on receiver index


		PlayStateNum = PS_PlayOverNUM;
	}

}


//#define NUM_PENALTY_TEXT_BUFFERS 6	moved to fbgequ.h
//#define ACCEPTED_BUFFER_START	0		here for reference
//#define DECLINED_BUFFER_START	3		(but they might be wrong

BYTE PenaltyTextBuffer[NUM_PENALTY_TEXT_BUFFERS][50];


void BuildFieldParametersText(UWORD curX, UWORD firstdownX,
			UWORD down,WORD playtype,WORD offteam,WORD penbuffnum);


BYTE *NumSuffix[] = {
"th",  	// 0 down possible if KO, ex. pt
"st",
"nd",
"rd",
"th"
};



#if PC_ALWAYS_MODE		//  only for  PC display/input ===============


BYTE *pentabs[NUM_PENALTY_TEXT_BUFFERS/2] = {
	"      ",                //
	"  ",
	"           ",
};

void DisplayPenaltyBuffers(void)
{
WORD i;

	for(i=0; i<NUM_PENALTY_TEXT_BUFFERS; i++)
	{
		if(PenaltyTextBuffer[i][0] != NULL)
		{
			printf("\n%s%s",
					pentabs[i%3],
					&PenaltyTextBuffer[i][0]);
			if(	(ActivePenalty == ACCEPT_PENALTY && i== ACCEPTED_BUFFER_START)
			  ||(ActivePenalty == DECLINE_PENALTY && i== DECLINED_BUFFER_START)
			  )
			{
				printf(" <---Selected");
			}

		}
	}
}

void DisplayPenaltyInfo(WORD chosingteam)
{

	printf("\n%s",PlayInfoText1);	// who's it on
	printf("\n  %s - ACCEPT OR DECLINE",
				GameTeamData[chosingteam].STD.TeamNickName);

	DisplayPenaltyBuffers();
}
#endif                 	//  only for  PC display/input ===============


#define GIVE_PENALTY 1


void CheckForPenaltyPart1(void)	// called In EOP PlaySTATE
{						// have ref run out

#if 1 //PC_ALWAYS_MODE	// test only - force penalties
	if(  ForcePenalties		// a debug variable
	   && (PlayType != KICKOFF_PLAY))
	{
//		InitOffPenaltyParameters(0,INT_GROUNDING_PENALTY,DEF_GOAL_LINE-1);
//		InitOffPenaltyParameters(0,INT_GROUNDING_PENALTY,OriginalStartBallX-5*YARDS);

		if(!(OffPenaltyPending || DefPenaltyPending))	// something not already called?
		{
			if(rand()&1)
			{
				InitOffPenaltyParameters(4,GROIN_KICK_PENALTY,OriginalStartBallX);
			}

			if(rand()&2)
			{
				InitDefPenaltyParameters(14,DEF_HOLDING_PENALTY,OriginalStartBallX);
			}
		}
	}
#endif

	if(OffPenaltyPending && DefPenaltyPending)
	{	// offsetting penalties

		StopGameClock();

		sprintf(PlayInfoText0,"%s on #%d - %s",PenaltyStrings[OffPenaltyPending],
				GetJerseyNum(OffPenaltyGuy),GetPlayerName(OffPenaltyGuy));
		sprintf(PlayInfoText1,"%s on #%d - %s",PenaltyStrings[DefPenaltyPending],
				GetJerseyNum(DefPenaltyGuy),GetPlayerName(DefPenaltyGuy));
		sprintf(PlayInfoText1,"UNNECESSARY SARCASM on #78 - PATRICK DOWNEY");
		sprintf(PlayInfoText2,"PENALTIES OFFSET - REPLAY THE DOWN");


//		SetNewRefAnim(OFFSETTING_SFX,AI_REF_WAVEARMS_NUM);
		SetNewRefAnim(-2,AI_REF_WAVEARMS_NUM,NO_PENALTY);

		InvalidPlay = TRUE;	// set if offsetting penalties
	}
	else if (OffPenaltyPending || DefPenaltyPending)
	{
		StopGameClock();
		SinglePenaltyPending = OffPenaltyPending ? OffPenaltyPending : DefPenaltyPending;
		SetNewRefAnim(RefPenaltySFX[SinglePenaltyPending],RefPenaltyAnim[SinglePenaltyPending],GIVE_PENALTY);

	}
}


void PenaltyHasBeenResolved(void)	// encapsulation for graphic engine
{
	PenaltyResolved = ActivePenalty;
}



void SetPenaltyDeclinedParameters(void)
{ 	// take the play outcome for a declined penalty

	sprintf(&PenaltyTextBuffer[DECLINED_BUFFER_START][0],
		"DECLINE PENALTY");

	if(ScoreType != NO_SCORE)	// somebody scored
	{
		sprintf(&PenaltyTextBuffer[DECLINED_BUFFER_START+1][0],
				"%s SCORE %s",
				GameTeamData[ScoringTeamThisPlay].STD.TeamNickName,
				ScoreNames[ScoreType]);
	}
	else
	{
		if(PlayOverFlags & NEED_COP_BFLAG)
		{
			if(NextOffTeam == DefensiveSlotNum)
			{
				BuildFieldParametersText(StartBallX,
					 WheresFirstDown(StartBallX,DefensiveSlotNum),
					 1,NextPlayType,NextOffTeam,DECLINED_BUFFER_START+1);
			}
			else
			{
#if PC_ALWAYS_MODE
				printf("\nError - COP Next off = %d, Defslot = %d",NextOffTeam,DefensiveSlotNum);
				getch();
#endif
			}
		}
		else
		{
			BuildFieldParametersText(
				StartBallX, NextFirstDownX,NextDown,
				NextPlayType,NextOffTeam,DECLINED_BUFFER_START+1);
		}
	}
}


void SetPossiblePenaltySafety(WORD teamslot,WORD pennum)
{
	sprintf(&PenaltyTextBuffer[ACCEPTED_BUFFER_START+1][0],
		"%s IN THE END ZONE",PenaltyStrings[pennum]);
		sprintf(&PenaltyTextBuffer[ACCEPTED_BUFFER_START+1][0],
			"SAFETY ON THE %s",
			GameTeamData[teamslot].STD.TeamNickName);

	AcceptPenaltyMode = SAFETY_IN_EZ;
}


/*-----------------------------------------------------------------



-----------------------------------------------------------------*/

void CheckForPenaltyPart2(void)	// in a PlayState soon after EOP
{
UWORD penyards;
//UWORD acceptpenaltyX,acceptpenaltydown,acceptpenaltyplaytype,new1st;

	PenaltyResolved = 0;
//	PenaltyChooser = NOBODY;	// assume CPU team

	if(OffPenaltyPending && DefPenaltyPending)
	{	// offsetting penalties
		StopGameClock();
/*
		sprintf(PlayInfoText0,"%s on #%d - %s",PenaltyStrings[OffPenaltyPending],
				GetJerseyNum(OffPenaltyGuy),GetPlayerName(OffPenaltyGuy));
		sprintf(PlayInfoText1,"%s on #%d - %s",PenaltyStrings[DefPenaltyPending],
				GetJerseyNum(DefPenaltyGuy),GetPlayerName(DefPenaltyGuy));
		sprintf(PlayInfoText1,"UNNECESSARY SARCASM on #78 - PATRICK DOWNEY");
		sprintf(PlayInfoText2,"PENALTIES OFFSET - REPLAY THE DOWN");

		InvalidPlay = TRUE;	// set if offsetting penalties

		#if PC_ALWAYS_MODE
		PCPrintAIText();	// print what happened
		#endif	*/
	}
	else if(OffPenaltyPending)
	{
		StopGameClock();

 //		if(Q_HumanTeamMacro(DefensiveSlotNum))
		{
			PenaltyChooser = DefensiveSlotNum;	// set only if human team
		}


		AcceptPenaltyTeamWithBall = OffensiveSlotNum;	// default

		ClearPenaltyTextBuffers();
		ClearPlayInfoTextBuffers();

		sprintf(PlayInfoText1,"%s on #%d - %s",
					PenaltyStrings[OffPenaltyPending],
					GetJerseyNum(OffPenaltyGuy),
					GetPlayerName(OffPenaltyGuy));


		if( (PenaltyType[OffPenaltyPending] & SAFETY_IN_EZ)
		   && PenaltyX <= DEF_GOAL_LINE)
		{
			// holding or int grounding in End Zone
			SetPossiblePenaltySafety(OffensiveSlotNum,OffPenaltyPending);
		}
		else
		{
			penyards = YardsPerPenalty[OffPenaltyPending]*YARDS;
			AcceptPenaltyDown = TheDown;	// assume - could change
			AcceptPenaltyPlayType = PlayType;
			AcceptPenaltyX = WheresOffPenalty(PenaltyX,penyards);
			AcceptPenalty1st = FirstDownX;


			if(PlayType == KICKOFF_PLAY)
			{
				PenaltyX = StartBallX - 5 *YARDS;	// test  only - spot where penaltyhappened
				AcceptPenaltyX = WheresOffPenalty(PenaltyX,penyards);
				AcceptPenalty1st = WheresFirstDown(AcceptPenaltyX,OffensiveSlotNum);
				NextFirstDownX = WheresFirstDown(StartBallX,OffensiveSlotNum);
				AcceptPenaltyDown = 1;
				AcceptPenaltyPlayType = NORMAL_PLAY;
			}
			else if(PenaltyType[OffPenaltyPending] & LOSS_OF_DOWN)
			{
				if(++AcceptPenaltyDown > GameTeamData[OffensiveSlotNum].DownsForFirst)
				{	// loss of down causes turnover on downs
					AcceptPenaltyTeamWithBall = DefensiveSlotNum;
					AcceptPenalty1st = WheresFirstDown(AcceptPenaltyX,DefensiveSlotNum);
					AcceptPenaltyDown = 1;
					AcceptPenaltyPlayType = NORMAL_PLAY;
					AcceptPenaltyMode = PENALTY_NEED_COP;
				}
			}

			BuildFieldParametersText(AcceptPenaltyX,AcceptPenalty1st,
				AcceptPenaltyDown,AcceptPenaltyPlayType,
				AcceptPenaltyTeamWithBall,ACCEPTED_BUFFER_START+1);

		}

		sprintf(&PenaltyTextBuffer[ACCEPTED_BUFFER_START][0],"ACCEPT PENALTY");

// declined - nothing happens - take the play
		SetPenaltyDeclinedParameters();

#if PC_ALWAYS_MODE
//		DisplayPenaltyInfo(DefensiveSlotNum);
#endif
		ActivePenalty = ACCEPT_PENALTY; 	//assume ACCEPT penalty

	}
	else if(DefPenaltyPending)		/* -------  PENALTY  ON  DEFENSE  ----*/
	{
		StopGameClock();

//		if(Q_HumanTeamMacro(OffensiveSlotNum))
		{
			PenaltyChooser = OffensiveSlotNum;	// set only if human team
		}
		ClearPenaltyTextBuffers();
		ClearPlayInfoTextBuffers();

		sprintf(PlayInfoText1,"%s on #%d - %s",PenaltyStrings[DefPenaltyPending],
				GetJerseyNum(DefPenaltyGuy),GetPlayerName(DefPenaltyGuy));

		sprintf(&PenaltyTextBuffer[ACCEPTED_BUFFER_START][0],
					"ACCEPT PENALTY");


		if( (PenaltyType[DefPenaltyPending] & SAFETY_IN_EZ)
		   && PenaltyX >= OFF_GOAL_LINE)
		{
			// clipping in End Zone
			SetPossiblePenaltySafety(DefensiveSlotNum,DefPenaltyPending);
			AcceptPenaltyTeamWithBall = DefensiveSlotNum;
		}
		else
		{
			penyards = YardsPerPenalty[DefPenaltyPending]*YARDS;

			AcceptPenaltyPlayType = PlayType;
			AcceptPenaltyDown = TheDown;	// assume - could change
			AcceptPenaltyX = WheresDefPenalty(PenaltyX,penyards);
			AcceptPenalty1st = FirstDownX;

			if(AcceptPenaltyX >= FirstDownX
			 || PenaltyType[DefPenaltyPending] == AUTO_FIRST_DOWN)
			{
				AcceptPenaltyDown = 1;
				AcceptPenalty1st = WheresFirstDown(AcceptPenaltyX,OffensiveSlotNum);
			}

			BuildFieldParametersText(AcceptPenaltyX,AcceptPenalty1st,
				AcceptPenaltyDown,AcceptPenaltyPlayType,OffensiveSlotNum,
				ACCEPTED_BUFFER_START+1);
	   }

		// declined - nothing happens - take the play
		SetPenaltyDeclinedParameters();

#if PC_ALWAYS_MODE
//		DisplayPenaltyInfo(OffensiveSlotNum);
#endif

		ActivePenalty = ACCEPT_PENALTY; 	//assume ACCEPT penalty
	}
}



#if PC_ALWAYS_MODE
void HandlePenaltyInput(void)
{
//WORD i,j;
UWORD paddata;

	if(ActivePenalty && !PenaltyResolved)
	{
		DisplayPenaltyInfo(PenaltyChooser);

		if(Q_CPUTeamMacro(PenaltyChooser))
		{	// CPU has chosen whatever ActivePenalty set to

			ActivePenalty = DECLINE_PENALTY;	//CPU declines everything for now
			ActivePenalty = ACCEPT_PENALTY;	//CPU declines everything for now
			PenaltyHasBeenResolved();
		}
		else	// human needs to chose
		{
#if 0
			while(!PenaltyResolved)
			{
				ReadPads();
				paddata = AIJoyPadData[GameTeamData[PenaltyChooser].ControllerNum[0]];

				if(paddata == JPADLup || paddata == JPADLdown)
				{
					ActivePenalty = (ActivePenalty ==
						ACCEPT_PENALTY ? DECLINE_PENALTY:ACCEPT_PENALTY);

					DisplayPenaltyInfo(PenaltyChooser);
				}
				else if(paddata == JPADx)
				{
					PenaltyHasBeenResolved();
				}
			}
#else
			while(!PenaltyResolved)
			{

				paddata = tolower(getch());

				if(paddata == '8' || paddata == '2')
				{
					ActivePenalty = (ActivePenalty ==
						ACCEPT_PENALTY ? DECLINE_PENALTY:ACCEPT_PENALTY);
					clrscr();
					DisplayPenaltyInfo(PenaltyChooser);
				}
				else if(paddata == 'x')
				{
					PenaltyHasBeenResolved();
				}
			}
		}
#endif
		printf("\nPenalty is %s",ActivePenalty ==1 ? "Accepted":"Declined");
//		for(i=0; i<100; i++)		// wait a bit
//			for(j=0; j<10000; j++);

	}
}

#endif

//VAR (WORD,ActivePenalty);		// 1 means accept, 2 means decline
//VAR (WORD,PenaltyChooser);		// team slot num if human chosing(-1 if CPU)
//VAR (BOOL,PenaltyResolved);		// graphic engine sets true


/***********************************************************************

				Display   Field  Parameters  (Down, to go , etc.)

	The main reason for all this "extra" code and passed parameters
	is to build phrases	to display "possible" info in the case
	of possible outcomes of	penalties.

	Figures out who has ball based on relationship between
	"curX" and "firstdownX".

***********************************************************************/

void BuildFieldParametersText(UWORD curX, UWORD firstdownX,
			UWORD down,WORD newplaytype,WORD nextoffteamslot,WORD penbuffernum)
{
WORD  yardline,togo,teamside;	//,possessionteam;

	if(curX > MID_FIELDX)
	{
		teamside = DefensiveSlotNum;
		yardline = 100 - (curX-DEF_GOAL_LINE)/YARD;
	}
	else
	{
		teamside = OffensiveSlotNum;
		yardline = (curX-DEF_GOAL_LINE)/YARD;

	}


//	DownTextBuffer[0] = 0;	// clear down buffer (might not be used)

//	if(newplaytype == KICKOFF_PLAY && !BallSnapped)
	if(newplaytype == KICKOFF_PLAY)
	{	//
		sprintf(&PenaltyTextBuffer[penbuffernum][0],
				"%s KICKING OFF FROM THE %d",
				GameTeamData[nextoffteamslot^1].STD.TeamNickName,yardline);

	}
	else if(newplaytype == EX_PT1_PLAY || newplaytype == EX_PT2_PLAY)	// Extra Point
	{
		sprintf(&PenaltyTextBuffer[penbuffernum][0],
			"%s CONVERSION ATTEMPT FROM THE %d",
			GameTeamData[nextoffteamslot].STD.TeamNickName,yardline);

	}
	else
	{
		if(curX < firstdownX)
		{
			togo =  firstdownX - curX;
//			possessionteam = OffensiveSlotNum;
		}
		else
		{	//this only happens in penalty situations
			togo =  curX - firstdownX;	// defense will have ball
//			possessionteam = DefensiveSlotNum;
		}

		togo /= YARD;	// scale measurement to actual yards

		if(teamside == nextoffteamslot)
//		if(teamside == possessionteam)
		{	// on own side of field
			sprintf(&PenaltyTextBuffer[penbuffernum][0],
				"%s BALL ON THEIR OWN %d",
				GameTeamData[nextoffteamslot].STD.TeamNickName,yardline);
		}
		else
		{
			sprintf(&PenaltyTextBuffer[penbuffernum][0],
				"%s BALL ON THE %s %d",
				GameTeamData[nextoffteamslot].STD.TeamNickName,
				GameTeamData[teamside].STD.TeamNickName,yardline);
		}


		if(firstdownX == OFF_GOAL_LINE || firstdownX == DEF_GOAL_LINE)
		{
			sprintf(&PenaltyTextBuffer[penbuffernum+1][0],
					"%d%s AND GOAL",
					down,NumSuffix[min(down,4)]);
		}
		else
		{
			sprintf(&PenaltyTextBuffer[penbuffernum+1][0],
					"%d%s AND %d",
					down,NumSuffix[min(down,4)],togo);
		}
	}
}



#if PC_ALWAYS_MODE
void PrintFieldParameters(BOOL lastlf)
{
	ClearPenaltyTextBuffers();
	BuildFieldParametersText(StartBallX,FirstDownX,TheDown,PlayType,
//			PlayType == KICKOFF_PLAY?DefensiveSlotNum:OffensiveSlotNum,0);
			OffensiveSlotNum,0);

	printf("\n  %s - %s",
			&PenaltyTextBuffer[0][0],
			&PenaltyTextBuffer[1][0]);
	if(lastlf)
		printf("\n");

}
#endif








/**************************************************************************/




void SavePreviouslyControlledGuys(void)
{
EFFVAR i,cntl;

	if(PlayType != KICKOFF_PLAY)
	{
		for(i=0; i < MAX_USERS_PER_TEAM; i++)
		{
			if( (cntl = GameTeamData[DefensiveSlotNum].ControllerNum[i]) != NO_CONTROLLER)
			{
				GameTeamData[DefensiveSlotNum].PrevDefControlledPlayers[i] =
							  ControlWhichPlayer[cntl];
			}
//		}

//		for(i=0; i < MAX_USERS_PER_TEAM; i++)
//		{
			if( (cntl = GameTeamData[OffensiveSlotNum].ControllerNum[i]) != NO_CONTROLLER)
			{
				GameTeamData[OffensiveSlotNum].PrevOffControlledPlayers[i] =
					  ControlWhichPlayer[cntl];
			}
		}
	}

}



void ResetPreSnapStuff(void)
{		// called if BallSnapped AND at PlayOver(to account for delay)

//	SetNewCrowdVolume(LOOP_SFX, ZERO,HALF_SECOND);	//kill chant or boo
	SetNewCrowdVolume(LOOP_SFX, ZERO,2*SECOND);	//kill chant or boo


	ResetBit(GameTeamData[OffensiveSlotNum].TeamFlags,OKAY_TO_SAY_HUT_BFLAG);
	ResetBit(MoreEventFlags,(OFF_AUDIBLE_ACTIVE_BFLAG | DEF_AUDIBLE_ACTIVE_BFLAG));

	DontDisplayAITextInfo();	// not yet if playover

}



BOOL ItsAFleaFlickerPlay(void)
{
WORD temp = GameTeamData[OffensiveSlotNum].PlayNum;

	return(   temp == ISlotFleaFlickerNUM
		   || temp == HBackFleaFlickerNUM
		   || temp == TripsFleaFlickerNUM
		   || temp == RunAndShootFleaFlickerNUM
		  );
}

/*******************************************************************

					SetBallSnapped(void)

	Called right when the ball is hiked
	RETURNS: TRUE if ball was actually hiked

	NOTE: Called on Kick Off when kicker starts toward ball,
		not when ball hits toe

*******************************************************************/

BOOL SetBallSnapped(void)
{
EFFVAR i,temp;
BOOL rv = FALSE;

	if(PlayStateNum == 	OKAY_TO_HIKE_PS   && !BallSnapped)	// error checking
	{
//		BallCarrier = 0;
		BallSnapped = TRUE;	// could change below if offside


		ResetPreSnapStuff();	// called if BallSnapped AND at PlayOver(to cover delay)

		if(PlayType != KICKOFF_PLAY)
		{      // def. now toggles to closest
			SetBit(GameTeamData[DefensiveSlotNum].TeamFlags,TOGGLE_TO_CLOSEST_VALID_BFLAG);
			AIPlayQBSFX(HUT_SFX);

//			AIPlayEffectCheck(HUT_SFX);		//final "hut"

		}
		FigureWhoToBlock();

		TimeIntoPlay  = ZERO;
		AIFrameCounter = ZERO;

		PlayStateFlags = ZERO;
		PlayStateNum = PS_PlayHappeningNUM;

/* when ball hiked, save currently controlled defensive players for
		init on next play	*/

		SavePreviouslyControlledGuys();
//		SaveDefControlledGuys();	// based on slot num
//		SaveOffControlledGuys();	// based on receiver index

//		for(i=1; i < 4; i++)
//		{	// allow non QB to control players even if pressing down before
//			if( (cntl = GameTeamData[OffensiveSlotNum].ControllerNum[i]) != NO_CONTROLLER)
//					PreviousJoyReading[cntl] = ZERO;
//		}

		StopPlayClock();


	 /* check for defense being offsides	*/
		for(i=11; i < 22; i++)
		{
//			if(OPXPos(i) < StartBallX)
/* 1/2 yard added as "neutral zone" as physical size
					 (side view in IRP) must be taken into account */
			if(OPXPos(i) < StartBallX + NEUTRAL_ZONE_LENGTH)
			{
				InitDefPenaltyParameters(i,OFFSIDES_PENALTY,StartBallX);

//				SetDefOffsides(DEF_OFFSIDES_TYPE);	// called if collision before snap OR past LOS at snap
/*  removed 4/21/97 for new penalty method
				BallSnapped = FALSE;	// bug # 1722 - shotgun hike on offside
*/				break;
			}
		}
/*  removed 4/21/97 for new penalty method
		if(MoreEventFlags & FALSE_START_PENDING_BFLAG)
			BallSnapped = FALSE;	// NOPe - not yet	*/


		OPAction(0) = NoAction;	// kill any QB head turning
		OPFacing(0) = EAST_DIR;	// if head turn then no backpedal

	/* here's a real kludge - don't have QB looking l/r at hike as it
		screws up IRP as the head turn anims aren't in IRP and we save the
		1st frame of IRP in a few more lines		*/

		temp = gPNum;	//save to be safe (for ConvertCurrentPlayerAIToActualGraphics below)
		gPNum = 0;
		if(OPGraphicState(0) == PG_QBPLAYCALL_NUM)	// use REAL graphics..
		{
			InitGraphics(AI_2PTSTANCE_NUM);	// change to 2 pt stance (in IRP anims)
			ConvertCurrentPlayerAIToActualGraphics();

		}
//		if( OPAIGraphicState(0) == AI_QBPLAYCALL2_NUM	// do AI graphics...
//		  || OPAIGraphicState(0) == AI_QBPLAYCALL1_NUM)	// ...just to be sure
//			OPAIGraphicSequence(0) = ZERO;

	/*-----  end kludge -------------*/

		gPNum = temp;
//		if(OPFlags(11) & IM_POINTING_BFLAG)	// only if pointing"gethim" #bug 1699
//			OPAction(11) = NoAction;	// kill any Def pointing - also kills jumping

		rv = BallSnapped;
		if(BallSnapped)
		{
			ClearPlayInfoTextBuffers();

//			SetNewCrowdVolume(MID_CROWD_SFX,CML3_VOL,5*SECONDS);	// level 3 volume
//			SetNewCrowdVolume(HIGH_CROWD_SFX,CHL1_VOL,SECONDS);	// quickly up

		/* 11/21/96 - mid up quick to max (25% minor also happening) and
				save high_crowd for later	*/
			SetNewCrowdVolume(MID_CROWD_SFX,SCALED_VOL_PERCENT(70),1*SECONDS); //11/21/96
//			SetNewCrowdVolume(HIGH_CROWD_SFX,CHL1_VOL,SECONDS);	// 11/21/96

			SetIRPReceivers();	// save again in case of triangle toggle- bug #1988
			SaveInstantReplayData(); //at snap positions  - bug #1961

			InitKickInterfaceVars();	// if necessary - added 7/28/96

			if(PlayType < EX_PT1_PLAY)
			{
				StartGameClock(); // on kick, clock starts when guy touches ball
				NumPlaysInDrive++;
			}
			// following not at InitAI (so Half won't end when huddle broken)
			ResetBit(GameFlags,DEF_PENALTY_PENDING_BFLAG);

//			ResetBit(MoreEventFlags,(OFF_AUDIBLE_ACTIVE_BFLAG
//					 | DEF_AUDIBLE_ACTIVE_BFLAG));	// clear def. audible if hike



  /*  Here's where the CPU cheats -  play specific cheats	*/

			if(ItsAFleaFlickerPlay()
//			 || GameTeamData[OffensiveSlotNum].PlayNum == IFormHBOptionNUM
			 )
			{	// stop these plays
				OPGuyToCover(20) = Receivers[2];	// FS covers triangleguy
			}
			else if( (GameTeamData[OffensiveSlotNum].PlayNum == IFormHBOptionNUM)
				   ||(GameTeamData[OffensiveSlotNum].PlayNum == ProSetHalfBackOptionNUM)
				   )
			{
				OPGuyToCover(21) = 1;	// SS covers RR
				OPGuyToCover(17) = Receivers[2];	// RC covers triangleguy
				if(rand()&1)
					OPGuyToCover(20) = 1;	// somtimes FS covers RR

			}
			else if(GameTeamData[OffensiveSlotNum].PlayNum == ShotGunTEShortPostNUM)
			{
				OPGuyToCover(11) = 5;	// MLB covers HB
			}

		}
	}
	return(rv);
}




void HandleEndOfQuarter(void)	// and End of Game
{   // ALWAYS called in main AI loop, so be careful of re-entry if flags set

	if( TheQuarter > 4
		&& GameTeamData[0].TotalScore != GameTeamData[1].TotalScore)
	{	// somebody just scored in OverTime
		SetBit(GameFlags,GAME_OVER_BFLAG | QUARTER_OVER_BFLAG);
	}
	else if(GameFlags & QUARTER_OVER_BFLAG)
	{	// already over, check to see if okay to start
		if(GameFlags & DEF_PENALTY_PENDING_BFLAG)
		{
			if(TheQuarter == 2 || TheQuarter >= 4)
			{	// error correction
				ResetBit(GameFlags,QUARTER_OVER_BFLAG);
			}
/*			else  // 1 or 3
			{   okay for Q to end

			}	*/
		}

		// moved to PS_Stalled PlayState
	}
	else
	{
		if(    (PlayStateNum != PS_PlayHappeningNUM)
			&& (GetVBlankTimer(GAME_TIMER_NUM) == 0L)
//			&& !(GameFlags & EX_PT_PENDING_BFLAG)
		  )
		{	 // then time ran out and play not happening

/*			if( (GameFlags & EX_PT_PENDING_BFLAG))	// no new Q if Ex pt pending
				// unless not tie and scored TD on last play of 4th Q, then no Ex pt.
//			   ||	no - they always do PAT if TD on last play of game
//				(  (TheQuarter == 4)
//				&& (GameTeamData[0].TotalScore != GameTeamData[1].TotalScore))

			  || ( (TheQuarter == 2 || TheQuarter == 4)
				   && (!GameFlags & DEF_PENALTY_PENDING_BFLAG)  )
			  ) */

			if( (GameFlags & EX_PT_PENDING_BFLAG)	// no new Q if Ex pt pending
				|| ( (TheQuarter == 2 || TheQuarter >= 4)
					 && (GameFlags & DEF_PENALTY_PENDING_BFLAG)  )
			  )
			{
			// can't end half on defensive penalty
			// or Q if next play is Ex Pt.
#if PC_ALWAYS_MODE		// save a few bytes for the consoles
				TheQuarter=TheQuarter;	//bp here
#endif
			}
			else
			{

				SetBit(GameFlags,QUARTER_OVER_BFLAG);

				StopGameClock();
				StopPlayClock();
				if(  (TheQuarter == 4
					  && GameTeamData[0].TotalScore != GameTeamData[1].TotalScore)
				   || (TheQuarter == 5 && GameType < PLAYOFF_GAME)  // tie in overtime
				  )
					SetBit(GameFlags,GAME_OVER_BFLAG);

				SetPlayState(PS_PlayOverNUM);	// do end of play
			}
		}

	}

}


void UnstallAI(void)
{
	ResetBit(GameFlags,AI_STALLED_BFLAG);
}


WORD QuarterHasEnded(void)	// return 0 if Quarter not ended else Quarter num
{

	if(GameFlags & QUARTER_OVER_BFLAG)
		return(TheQuarter);
	else
		return (ZERO);
}


void CheckFor2MinuteWarning(void)
{

	if(! (GameFlags & GAVE_2MIN_WARNING_BFLAG))
	{

		if(TheQuarter == 2 || TheQuarter == 4)	//2 or 4th ??
		{	// don't use !(TheQuarter&1) as Q 0 is possible during coin flip

//			if(GetVBlankTimer(GAME_TIMER_NUM) <= 2*60*CLOCKS_TICKS_PER_SECOND)
			if(SecondsLeftInQuarter() <= 2*SECS_PER_MIN)
			{
				if(! (GameFlags & NEED_2MIN_WARNING_BFLAG))
				{
					SetBit(GameFlags,NEED_2MIN_WARNING_BFLAG);

					if(PlayStateNum != PS_PlayHappeningNUM)
					{
						StopGameClock();
						StopPlayClock();
					}

					if( (PlayStateNum < PS_PlayHappeningNUM)
					  || (PlayStateNum >= PS_AfterEOPNUM)
					)
					{ // should never be AIStalled
//						StopGameClock();
//						StopPlayClock();

						InitRefPhrase(TWO_MINUTE_WARNING_SFX);
						SetNewRefAnim(TWO_MINUTE_WARNING_SFX,AI_REF_WAVEARMS_NUM,NO_PENALTY);
						SetRefStartX(StartBallX - 3*YARDS);

						ClearPlayInfoTextBuffers();
						sprintf(PlayInfoText1,"TWO MINUTE WARNING");

						SetPlayState(PS_PlayOverNUM);

					}
//					else if(PlayStateNum > PS_PlayHappeningNUM)
//					{
//						StopGameClock();
//						StopPlayClock();
		// NOTE: if 2 min after play over, it's trapped in PLAYSTATE(PS_Wait7)
//					}

				}

			}

		}

	}

}



WORD GetDuressLevel(WORD slot,WORD usetimeouts);

#define NO_HUDDLE_BUTTON_CONFIG	(JPADLfront1 | JPADLfront2)

void CheckForNoHuddle(void)
{
	if(
		  (PlayStateNum <= PS_PlayOverNUM)       	// valid only during ...
	   || (PlayStateNum >= PS_GetUpAfterPlayNUM)	// .. this time period

	   || (GameFlags & GAME_OVER_BFLAG)
	   || (GameFlags & EX_PT_PENDING_BFLAG)
	   || (QuarterHasEnded())
	   || (PlayOverFlags & NEED_COP_BFLAG)
	   || (EventFlags.SAFETY_HAPPENED_BFLAG) 	// covers safety on def.
	   || (GameFlags & NEED_2MIN_WARNING_BFLAG)
	   || (LastPlayType == KICKOFF_PLAY)
//	   || (EventFlags.TD_HAPPENED_BFLAG)
//	   || (TheDown < 2)
	  )
	{	// no huddle can not be called
	}
	else	// okay for no huddle
	{
		if(Q_HumanTeamMacro(OffensiveSlotNum))
		{   // does human team captain want to do a no huddle???
//			printf("%4x %d",AIJoyPadData[GameTeamData[OffensiveSlotNum].ControllerNum[0]],
//				   NO_HUDDLE_BUTTON_CONFIG		);
			if( (AIJoyPadData[GameTeamData[OffensiveSlotNum].ControllerNum[0]]
				& NO_HUDDLE_BUTTON_CONFIG) == NO_HUDDLE_BUTTON_CONFIG)
			{
				SetBit(MoreEventFlags,NEED_NO_HUDDLE_BFLAG);
			}
		}
		else if(Q_CPUTeamMacro(OffensiveSlotNum))	// CPU team on offense
		{
			if( GameClockRunning()	// a Question
				&& (GetDuressLevel(OffensiveSlotNum,TRUE) >= 2)
			  )
			{
				SetBit(MoreEventFlags,NEED_NO_HUDDLE_BFLAG);
			}
		}

	}
}





void IncTimeOfPossession(void);


void GetJoyPadData(WORD *paddata)	// little subroutine
{
EFFVAR i;

	for(i=0; i<MAX_CONTROLLERS; i++)
	   *(paddata+i) = JpadData[i];

}

//void ForceOT(void);
void HomeWin(void);

/*************************************************************************

					the   "MAIN  LOOP"


	"DoAI" is a module called in the main loop of the program.

	Major re-mod 7/25/96 = Back to 20 hertz move/amin/joypad rate (which
	is much more straight forward anyway).

	(see FBGrave.txt for old 30 Hertz module)

*************************************************************************/

void  DoAI(void)		/* called once every main loop	*/
{

	HandleEndOfQuarter();

	CheckFor2MinuteWarning();

//	HandleFalseStart();

//	CheckForPausedTimeOut();	// in main loop

//	IncTimeOfPossession();

//	ForceOT();


	DoPlayState();

	HandleAISound();

	UpdateTeamsTimeOfPossession();

	UpdateShownPlayerNames();

	// don't do STATES if PlayState = 0 (scripts may not have been inited!)
	if(PlayStateNum != PS_WaitForPlayStartNUM)
	{

		MaxBlockAudioDistance = LARGE_DISTANCE;
		ResetBit(MoreEventFlags,HIT_BC_THIS_FRAME);

		BubbleSortOnY();	// improves speed of collision detection

	// get physical joypad data into AIJPData
		GetJoyPadData(AIJoyPadData);

		CheckForNoHuddle();

		HandleController();	/* toggling, kicking, hiking, diving, etc.	*/
//		SaveInstantReplayData();moved to after AI2GRAPHIC convert below 3/24/96

		CurTeamSlot = OffensiveSlotNum;
		DoOffenseAI();

		CurTeamSlot = DefensiveSlotNum;
		DoDefenseAI();

		MoveBall();

		IncrementTimers();

		MoveReferees();

		SetForwardProgress();	// check forward progress every frame

	}
#if	PC_ALWAYS_MODE
	else
	{
		if(GameFlags & GAME_TIMER_ON_BFLAG)
		{// 1 tick okay here - just don't let it happen more than once per play
//			printf("\nError - Clock Runnin gin PS 0");
//			getch();
		}
	}
#endif

	// get physical joypad data into Previous AIJPData
	GetJoyPadData(PreviousJoyReading);

//	CheckForDelayOfGame();

	CheckForPausedTimeOut();	// in main loop

	CheckForPreSnapPenalty();

	ConvertAIToActualGraphics(0);
	ConvertAIToActualGraphics(1);

	SaveInstantReplayData();


}


/*-------------------------------------------------------------------

			 H A N D L E    C O N T R O L L E R S

	All controller(joypad) stuff EXCEPT player movement is handled
	here.  This includes toggling, kicking, hiking, eyc.

-------------------------------------------------------------------*/

void HandleController(void)
{
EFFVAR captpad;


#if  PC_ALWAYS_MODE
	captpad = 0;		// PC - always hike with Pad 0
//	captpad = -1;  // test only - allow def to jump before hike
#else
	captpad = GameTeamData[PlayType == KICKOFF_PLAY ?
				 DefensiveSlotNum:OffensiveSlotNum].ControllerNum[0];
#endif
	if( captpad >= ZERO)
	{
		if( (AIJoyPadData[captpad] & HIKE_BUTTON)
			&& !(PreviousJoyReading[captpad] & HIKE_BUTTON)	// in case of audible
			&& !(OffAudibleIsActive())
		  )
		{
			if(SetBallSnapped()) // kludge no QB control until this button up then down
				PreviousJoyReading[captpad] = 0xffff;

		}


		if (PlayType != KICKOFF_PLAY
		  && GameTeamData[OffensiveSlotNum].TeamFlags & OKAY_TO_SAY_HUT_BFLAG
		  && AIJoyPadData[captpad] & JPADcircle
		  && (!(OffAudibleIsActive()))	// no "hut" if audible active
		  && !(PreviousJoyReading[captpad] & JPADcircle)
		  )
		 {	// CPU will say hut until human takes over
			SetBit(GameTeamData[OffensiveSlotNum].TeamFlags,NO_MORE_CPU_SAY_HUT_BFLAG);
			AIPlayQBSFX(HUT_SFX);
			InitFalseStart();		// if necessary

//			AIPlayEffectCheck(HUT_SFX);	// human only
		 }


	}

	HandleOffensiveAudible();

	HandleDefensiveAudible();

	CheckForToggling();

//	if( (AIFrameCounter&3)==ZERO  && TimeIntoPlay > ZERO)
//		FixControllers();

	CheckForDebugKeys();

	HumanKickInterface();	// turn on in PlayState if kick play


// below moved to main loop as player STATES need the data
//	for(i=0; i<MAX_CONTROLLERS; i++)
//		PreviousJoyReading[i] = AIJoyPadData[i];

}






void IncrementTimers(void)
{
/*   Note: if a Simmed game, game,play timers are simmed external
	to this function					*/

	AIFrameCounter++;	// zeroed at BallSnapped

	AIPlayTimer += TICKS_PER_AI_FRAME;	// 60 Hz  software timer runs all the time

	if(BallSnapped)
		TimeIntoPlay += TICKS_PER_AI_FRAME;	// 60 Hz  software timer runs only after ball hiked

	IncTimeOfPossession();

}




void CheckForDebugKeys(void)
{

#if 0
EFFVAR i;


	// both top left button on Pad 1 kills defensive line
	if ((AIJoyPadData[1] & DEBUG_BUTTONS1) == DEBUG_BUTTONS1)
	{
		for(i= START_DEF_SLOT_NUM; i < LAST_DEF_SLOT_NUM+1; i++)
			if(PlayerMyFormPosition[i] >= DLE && PlayerFormMyPosition[i] <= DRE)
				PlayerScriptPtr[i] = All_Scripts[DoNothingScriptNUM];
	}

	// both top right button on Pad 1 kills offensive line
	if ( (AIJoyPadData[1] & DEBUG_BUTTONS1) == DEBUG_BUTTONS1)
		for(i= 6; i < LAST_OFF_SLOT_NUM+1; i++)
			PlayerScriptPtr[i] = All_Scripts[DoNothingScriptNUM];


	if ((AIJoyPadData[0] & DEBUG_BUTTONS2) == DEBUG_BUTTONS2)
		TackleGuyTest = -1;	// okay to  tackle QB

	if ((AIJoyPadData[0] & DEBUG_BUTTONS1) == DEBUG_BUTTONS1)
		TackleGuyTest = 0;	// don't tackle QB

	if ( (AIJoyPadData[1] &	JPADfrontB) == JPADfrontB)	// end the quarter
	{
		SetVBlankTimer(GAME_TIMER_NUM,0L);

	}
#endif

}


void SetForwardProgress(void)	// check forward progress every frame
{
UWORD bcx;
		   // make sure not advancing if OOB
	if(PlayHappening() && BallCarrier >= ZERO)	// safer than BallCarrier != NOBODY
	{
		bcx = OPXPos(BallCarrier);
		if(MoreEventFlags & HIT_BC_THIS_FRAME
		   || EventFlags.TACKLE_STARTED_BFLAG
		  )
		{	// if hit, don't reset FP until X many frames
			HitBCFrameCount = 15;	//6;
		}

		if(--HitBCFrameCount <= ZERO)
		{   // haven't been hit in a while
			ForwardProgress = bcx;	// reset forward progress
			HitBCFrameCount = ZERO;
		}
		else // BC is being hit OR was hit with X frames
		{
			if(BallCarrier < 11)	// bc on offense
			{
				if( bcx > ForwardProgress)
				{
					ForwardProgress = bcx;
				}	// else don't change if behind previous FP
				else if(bcx < ForwardProgress)
				{
					ForwardProgress = ForwardProgress;	//b.p. here
				}
			}
			else	// bc on def
			{
				if(bcx < ForwardProgress)
					ForwardProgress = bcx;	// else don't change
			}
		}

		if((BallFlags & SHOW_BALL_BFLAG))
		{	// why am I showing ball if BC has it????
			SetBit(ErrorNumber,0x0010);
	#if	PC_ERROR_MODE
	//		printf("\nError - BC and Showball");	//#bug 1386???
	#endif
		}

	}
	else
	{
		HitBCFrameCount = ZERO;
	}
}

/************************************************************************/

void DoOffenseAI(void)
{
EFFVAR i;

/* first figure key distance for offense	*/

	//  following used for icon scaling on receiver
	if( (PlayStateNum == PS_PlayHappeningNUM)
//		 && ( (AIFrameCounter&3) == ZERO)		// don't do every frame
	  )
	{

		FigureOffenseKeyDistance();	// mainly used for off. toggling

	/* figure dist. from receivers to closest def. guy (for icon scaling) */
		for(i=0; i< MAX_RECEIVERS; i++)
		{
			if(ShowReceiverIcons)
			{
				RecDistToClosestDef[i] = DistanceToClosestDef(i+1);
			}
			else
			{
				RecDistToClosestDef[i] = -1; //  don't show icon
			}
		}


/***		for(i=0; i< MAX_RECEIVERS; i++)
		{
			if( (rec = Receivers[i]) >= ZERO)
			{
				RecDistToClosestDef[i] = DistanceToClosestDef(rec);
			}
			else
				RecDistToClosestDef[i] = -1;	//  used for icon scaling
		}	***/
	}

	// need to reset flag in case human took control (set in FakeHandoff)
	ResetBit(PlayFlags,POS_HANDOFF_BFLAG);	// only 1 chance for LBs


	for(gPNum=0; gPNum < NUM_PLAYERS_ON_FIELD_PER_TEAM; gPNum++)
	{
//		CPOldXPos = CPXPos;
//		CPOldYPos = CPYPos;
//		CPOldZPos = CPZPos;

		DoAction();		/* NoAction will	DoState();	*/

		if(CPTackleCount > ZERO)	// can tackle only if ZERO
			CPTackleCount--;
	}

}


void DoDefenseAI(void)
{

/* first figure key distance for defense - used for def. toggling
	AND BCAvoid (et. al.)	*/
	FigureDefenseKeyDistance(NOBODY);	// NOBODY means use internal logic


	for(gPNum=11; gPNum < 22; gPNum++)
	{
//		CPOldXPos = CPXPos;
//		CPOldYPos = CPYPos;
//		CPOldZPos = CPZPos;

		DoAction();		/* NoAction will	DoState();	*/

		if(CPTackleCount > ZERO)	// can tackle only if ZERO
			CPTackleCount--;
	}

}


void MoveReferees(void)
{

	gPNum = REF_SLOT_NUM;
	DoState();		/* NoAction will	DoState();	*/

}

void DoAction(void)
{
	// always turn off burst - could be set by BCAvoid or human controll
	ResetBit(CPFlags1,BURST_ACTIVE_BFLAG);

	HandleCPCPUBursting();	// could turn above back on

	CPAction();    /* do the Current Players Action	*/
}


void DoState(void)
{
//WORD i,guy;

	if(!GamerControlled())
	{
		if(CPState2Count < ZERO)	// if not "stuck"
		{
			AllStates[*CPScriptPtr].todo();
		}
		else
		{
			Do2ndState();
		}
	/* make sure Ball moves with BC as AI looks at Ball Loc	*/
		if(gPNum == BallCarrier)
		{
			UpdatePlayerWithBall();
		}
		CPAIState();	/* do player's AI	*/
	}

	if(gPNum == BallCarrier)
	{
		// BC getting tired moved to Run() function

		UpdatePlayerWithBall();

		if(  (PlayType != KICKOFF_PLAY)
		   && (BallXPosition > StartBallX)
		   && (BallCarrier < 11) // BC must be on off. or else punts are messed up
		   && (!(EventFlags.BC_PASSED_LOS_BFLAG)) // only do once
		   )
		{
			SetBit1(EventFlags,BC_PASSED_LOS_BFLAG);
			ResetBit(CPFlags,CAN_PASS_BFLAG);   // can never pass again
			SetReceiversToLeadBlockers();	// except BallCarrier
			ClearReceivers();
			ResetBit(CPFlags1,QB_CAN_BPEDAL_BFLAG);	// passing or draw(bug # 1758)
			SetBit(GameTeamData[OffensiveSlotNum].TeamFlags,TOGGLE_TO_CLOSEST_VALID_BFLAG);

//			SetNewCrowdVolume(HIGH_CROWD_SFX,CHL2_VOL,4*SECONDS);	// start ramp slowly
			SetNewCrowdVolume(HIGH_CROWD_SFX,SCALED_VOL_PERCENT(70),2*SECONDS);	// 11/21/96

		}

#if PC_DEBUG_MODE
//		if(( AIJoyPadData[2] & (JPADR_MASK | JPADfrontT)) == (JPADR_MASK | JPADfrontT))
//		if(AIJoyPadData[0] & JPADcircle)
		{
//			InitFumble(BALL_HIT_GUY_FUMBLE,rand()&15,NEED_FUMBLE_SFX);
//			CPXPos += 10*YARDS;
		}
#endif
#if 0	//ndef SATURNMODE
		if(( AIJoyPadData[2] & (JPADR_MASK | JPADfrontT)) == (JPADR_MASK | JPADfrontT))
		{
			InitFumble(BALL_HIT_GUY_FUMBLE,rand()&15,NEED_FUMBLE_SFX);
		}

#endif
/*
		if(PlayHappening() && (CPSpeed > (5<<SPEED_SHIFT)) )
		{
		  if(!NoFumbleMACRO)
			if( (120 - OPHands(BallCarrier))/20 > Random1000)
//				if( (120 - OPHands(BallCarrier))/20 > Random1000/10)
				{	// worse hands fumbles 0.6%, best 0.1%
					InitFumble(BALL_HIT_GUY_FUMBLE,rand()&15,NEED_FUMBLE_SFX);
				}
			}
*/
	}


}



/*************************************************************************

			 K E Y    D E F E N S I V E   D I S T A N C E

	This routine, called before "MoveDefense", figures and sets up
	the "Key Defensive" distance, which is defined as the distance to
	the ball (Ballcarrier) or on special occasions, something else,
	such as if a ball is being passed.

	The basic idea is to only figure the "key" distance once per loop,
	and save it in the Players D.S. and also in a sorted list.

	The sorted list can be used by the "[human] toggle to player", or by
	the ballcarrier.  A bubble sort is used, as once it is initialized,
	the sorted players will rarely change.

	Also called in Determine pass outcome to determine players closest
	to TheReceiver.

	NOTE:  "FigureDefenseToggleArray()" uses the KeyDistance array
	as a base, and then modifies the players so that toggling is
	"smarter" i.e toggle to guy 5 yards in front of BC instead of
	4 yards behind him.


*************************************************************************/
void BubbleSortKeyDistance(struct slotdist *keyarray);
void FigureDefenseToggleArray(void);


void FigureDefenseKeyDistance(WORD player)
{
UEFFVAR x,y;
EFFVAR i,pnum;


	// assume run to ball (includes BallCarrier)
	x = BallXPosition;
	y = BallYPosition;

	if(BallInAirMACRO
	 && (!(BALL_BOUNCING_BFLAG & BallFlags)))	// bug # 1777
	{		// Pass, punt, kickoff
		if(BallTargetX | BallTargetY)	// kludgy, late night programming
		{
			x = BallTargetX;	// focus on Target if valid
			y = BallTargetY;
		}
/*		else   // if error
		{
			x = BallXPosition;
			y = BallYPosition;
		}
	}
	else 					// else ball
	{	// includes BallCarrier
		x = BallXPosition;
		y = BallYPosition;		*/
	}

	if(player >= ZERO)		// override normal stuff
	{
		x = OPXPos(player);
		y = OPYPos(player);
	}


	for(i=0; i<11; i++)	// figure distance from all def. players to key X,Y
	{
		pnum = DefenseKeyDistance[i].slotnum;
		OPKeyDistance(pnum) = DefenseKeyDistance[i].distance
					= Distance2Points(OPXPos(pnum),OPYPos(pnum),x,y);
//		CPKeyDistance = DefenseKeyDistance[i].distance = 25-2*i;	// set to max
	}

	/* now bubble sort the list	- closest to Ball is in slot 0		*/
	BubbleSortKeyDistance(DefenseKeyDistance);


	FigureDefenseToggleArray();

}


void FigureOffenseKeyDistance(void)
{
UEFFVAR x,y;
EFFVAR i,pnum;


	if(BallInAirMACRO
	 && (!(BALL_BOUNCING_BFLAG & BallFlags)))	// bug # 1777
	{		// Pass, punt, kickoff
		if(BallTargetX | BallTargetY)	// kludgy, late night programming
		{
			x = BallTargetX;	// focus on Target if valid
			y = BallTargetY;
		}
		else   // some error
		{
			x = BallXPosition;
			y = BallYPosition;
		}
	}
	else 					// else ball
	{	// includes BallCarrier
		x = BallXPosition;
		y = BallYPosition;
	}

	for(i=0; i<11; i++)	// figure distance from all def. players to key X,Y
	{
		pnum = OffenseKeyDistance[i].slotnum;
		OPKeyDistance(pnum) = OffenseKeyDistance[i].distance
					= Distance2Points(OPXPos(pnum),OPYPos(pnum),x,y);
	}

	/* now bubble sort the list	- closest to Ball is in slot 0		*/
	BubbleSortKeyDistance(OffenseKeyDistance);


}


//#define	TOGGLEYDIST	   5*YARDS
//#define	TOGGLEYDIST	   4*YARDS	// 11/1
#define	TOGGLEYDIST	   7*HALF_YARD	// 11/16

void FigureDefenseToggleArray(void)
{
EFFVAR bcx,bcy,pnum,i,offset;
void *sptr, *dptr;


	if(BallCarrier >= ZERO && BallCarrier < 11)
	{
		bcx = OPXPos(BallCarrier);
		bcy = OPYPos(BallCarrier);

		for(i=0; i<11; i++)
		{
			pnum = DefenseToggleArray[i].slotnum;

			offset = ZERO;	// assume in a "box" in front of BC

			if(OPXPos(pnum) < bcx - YARD)
			{	// Im behind BC
				offset += 10*YARD;
			}
/**
			if(OPXPos(pnum) > bcx + 10*YARD)
			{	// Im too far in front of  BC
				offset += 2*YARD;
			}***/

			if(  (OPYPos(pnum) < bcy - TOGGLEYDIST)
			   ||(OPYPos(pnum) > bcy + TOGGLEYDIST)
			  )
			{	// too far to left or right

				offset += 5*YARD;

			}

			if( OPFlags(pnum) & IM_LYING_ON_GROUND_BFLAG)
			{
				offset += 10*YARD;
			}

			DefenseToggleArray[i].distance = OPKeyDistance(pnum) + offset;
		}
		BubbleSortKeyDistance(DefenseToggleArray);
	}
	else
	{	// just use default (KeyDistance)
		sptr = &DefenseKeyDistance;
		dptr = &DefenseToggleArray;
		CopyBytes(sptr,dptr , sizeof(struct slotdist)*11);
	}
}





/******* sort either DefenseKeyDistance or OffenseKeyDistance   ****/

void BubbleSortKeyDistance(struct slotdist *keyarray)
{
register EFFVAR i,j;
EFFVAR done,temp;

	for(i=0; i<10; i++)
	{
		done = TRUE;		// make an assumption
		for(j=0; j<10-i; j++)
		{
			if(keyarray[j+1].distance < keyarray[j].distance)
			{	/* then swap the two entries	*/

				done = FALSE;	// assumption was wrong

				temp = keyarray[j].distance;
				keyarray[j].distance = keyarray[j+1].distance;
				keyarray[j+1].distance = temp;

				temp = keyarray[j].slotnum;
				keyarray[j].slotnum= keyarray[j+1].slotnum;
				keyarray[j+1].slotnum = temp;
			}
		}
		if(done)
			break;	// out of "i" loop

	}

}


/*************************************************************************
	To help with Collision detect, players are sorted on their Y position

	See comments under "TryMove()" in FBMOVE.C

*************************************************************************/
void BubbleSortOnY(void)
{
//register EFFVAR i,j;
//EFFVAR done,temp;
WORD i,j;
WORD done,temp;

	for(i=0; i<21; i++)		// do 1 less than num. players
	{
		done = TRUE;		// make an assumption
		for(j=0; j<21-i; j++)
		{
			if(OPYPos(PlayersYSortList[j+1]) < OPYPos(PlayersYSortList[j]) )
			{	/* then swap the two entries	*/

				done = FALSE;	// assumption was wrong

				temp = PlayersYSortList[j];	//swap 'em
				PlayersYSortList[j] = PlayersYSortList[j+1];
				PlayersYSortList[j+1] = temp;
			}
		}
		if(done)
			break;	// out of "i" loop

	}

	// keep track in player DS where they are in YSortlist
	for(i=0; i<22; i++)
	{
		OPYSortPos(PlayersYSortList[i]) = i;
	}

}




/*************************************************************************/


void PuntDowned(UWORD yardline) 	// either by offense down it or go OOB

{  	// NOTE: COP will swap yards and set new 1stdown
	// "yardline" could be where down OR where went OOB

	/*  3/25/97 - DON'T do any STATS stuff here		*/

//EFFVAR yards;
BYTE *how;

	SetBit(PlayOverFlags,NEED_COP_BFLAG);

	if( (yardline  = SETTOWHOLEYARD(yardline)) >= OFF_GOAL_LINE)
		yardline = OFF_GOAL_LINE;	// correct yardage in EZ


	PuntYards = ((WORD)(yardline - StartBallX)) >>YARD_SHIFT;	// punt dist.

//	UpdateStats(KickerSlot,GS_PUNT,1);
//	UpdateStats(KickerSlot,GS_PUNT_YARDS,yards);
//	UpdateStatsMax(KickerSlot,GS_PUNT_LONG,yards);
	sprintf(PlayInfoText1,"%d YARD PUNT BY #%d - %s",PuntYards,
			GetJerseyNum(KickerSlot),GetPlayerName(KickerSlot));

	if(yardline < DEF_GOAL_LINE+1) // it happens in this game-(darn testers!)
	{
		SetSafetyOrTouchBack(DefensiveSlotNum);
	}
	else if(yardline < OFF_GOAL_LINE)
	{
		SetInitStartBall(yardline);
		if(yardline > OFF_GOAL_LINE-20*YARDS)
		{
			KickStatsType = GS_PUNT_IN20;
//			UpdateStats(KickerSlot,GS_PUNT_IN20,1);
		}
		if(PlayOverFlags & BALL_OUT_OF_BOUNDS_BFLAG)	// set on init bounce only!
		{
			how = "OUT OF BOUNDS";
		}
		else
		{
			how = "DOWNED";
		}
		sprintf(PlayInfoText2,"%s ON THE %d YARDLINE",how,GetTrueYardline());

	}
	else
	{	// in EZ, touchback
		SetInitStartBall(OFF_GOAL_LINE-20*YARDS);
		KickStatsType = GS_PUNT_TB;
//		UpdateStats(KickerSlot,GS_PUNT_TB,1);
		sprintf(PlayInfoText2,"TOUCHBACK");

	}
}


//#define SETTOWHOLEYARD(xxx)	if(xxx <= MID_FIELDX) xxx += YARD-1; endX &= 0xff00
void AnnounceYardsGained(void);	/*  and build audio phrases	*/
void PutTackleInfoPIT2(void);


/*--------------------------------------------------------------------


			 E N D    O F    P L A Y     F U N C T I O N S


--------------------------------------------------------------------*/

void DisplayYardsGained(WORD yards)	/*  and build audio phrases	*/
{			//NOTE: audio phrase said later( approx. 2 sec. after play over
EFFVAR jersey;
BYTE *pname;

	// yards is actual yards (i.e. 1,2,3 NOT normal yards - (3*YARDS)
	YardsGainedThisPlay  = yards;	// save as global for audio building

	if(PlayFlags & SACK_ON_PLAY_BFLAG)	// kludgey due to Saturn files
	{	// can't call "	InitAnnouncerPhrase" from fbstats.c
#ifdef SATURNMODE
//		if(BallXPosition > DEF_GOAL_LINE)  // don't say if a safety
//			InitAnnouncerPhrase(SACK_PHRASE);
#endif
	}
	else if(PlayType != KICKOFF_PLAY)
	{
		if(LastBallCarrier >= ZERO)
		{
			jersey = GetJerseyNum(LastBallCarrier);
			pname = GetPlayerName(LastBallCarrier);

			if(YardsGainedThisPlay == ZERO)
			{
				sprintf(PlayInfoText1,"NO GAIN BY #%d - %s",jersey,pname);
//				InitAnnouncerPhrase(NO_GAIN_SFX);

			}
			else if(YardsGainedThisPlay > ZERO)
			{
				sprintf(PlayInfoText1,"GAIN OF %d BY #%d - %s",YardsGainedThisPlay,jersey,pname);
//				InitAnnouncerPhrase(GAIN_OF_SFX);
//				AddToAnnouncerPhrase(-YardsGainedThisPlay);  // number words are negative

			}
			else
			{
				sprintf(PlayInfoText1,"LOSS OF %d BY #%d - %s",-YardsGainedThisPlay,jersey,pname);
/*				if(rand() &1 || YardsGainedThisPlay == -1)
				{
					InitAnnouncerPhrase(LOSS_OF_SFX);
					AddToAnnouncerPhrase(YardsGainedThisPlay);	// number words are negative
				}
				else
				{
					InitAnnouncerPhrase(LOSS_OF_SFX);	//"Loss on theplay of.."
					AddToAnnouncerPhrase(YardsGainedThisPlay); // number words are negative
					AddToAnnouncerPhrase(YARDS_SFX);
				}
*/
			}
			PutTackleInfoPIT2();

			AnnounceYardsGained();	/*  and build audio phrases	*/

		}
		else
		{
#if	PC_ERROR_MODE
			printf("\n No Last BC in DisplayYards");
#endif
			if(YardsGainedThisPlay == ZERO)
				sprintf(PlayInfoText1,"NO GAIN");
			else if(YardsGainedThisPlay > ZERO)
				sprintf(PlayInfoText1,"GAIN OF %d",YardsGainedThisPlay);
			else
				sprintf(PlayInfoText1,"LOSS OF %d",-YardsGainedThisPlay);
		}
	}
}


void TextualKickerName(BOOL good)
{
BYTE *outcome = good ? "GOOD":"NO GOOD";

	if(KickerSlot >= ZERO)
	{
		sprintf(PlayInfoText2,"BY #%d - %s IS %s",
			GetJerseyNum(KickerSlot),GetPlayerName(KickerSlot),outcome);
	}
	else
	{
		sprintf(PlayInfoText2,"IS %s",outcome);
	}
}


void TwoPointConversionNoGood(void)
{
	sprintf(PlayInfoText1,NoGood2PtText);
	InitRefPhrase(NOGOOD_SFX);
	SetNewRefAnim(NOGOOD_SFX,AI_REF_WAVEARMS_NUM,NO_PENALTY);
}



void SetKickNoGood(UWORD kicklength)	// or 2 pt Extra point
{	// called if normally no good, if block, OOB or def. has it on ANY EX PT
//WORD stat;

	// kick was no good
#ifdef SATURNMODE
	if(GameTeamData[OffensiveSlotNum].PlayNum ==  SpecialTeamsFieldGoalNUM)
	{ // say only if the kick playwas used
		InitAnnouncerPhrase(KICK_NO_GOOD_PHRASE);
	}
#endif

	InitRefPhrase(NOGOOD_SFX);
	SetNewRefAnim(NOGOOD_SFX,AI_REF_WAVEARMS_NUM,NO_PENALTY);
//	EOPSFXPending = NOGOOD_SFX;

	if(PlayType == EX_PT2_PLAY)
	{
		sprintf(PlayInfoText1,NoGood2PtText);
	}
	else
	{
		if(PlayType == EX_PT1_PLAY)
		{
//			if(KickerSlot != NOBODY 	// def. got fumble on 2 pointer
//			  && GameTeamData[OffensiveSlotNum].PlayNum != ShotGunPoochKickNUM)

			sprintf(PlayInfoText1,"EXTRA POINT");
//			stat = GS_PAT_ATT;
		}
		else	// field goal
		{
			sprintf(PlayInfoText1,"%d YARD FIELD GOAL",kicklength);

	// mark ball @ spot where it was kicked from, NOT LOS (COP will swap)
	//if kicking from End Zone, put on 1 (darn testers)
			StartBallX = USetMinMax(KickStartX,DEF_GOAL_LINE+YARD,OFF_GOAL_LINE-20*YARDS);
/*********
			StartBallX = KickStartX;	// spot where it was kicked from, NOT LOS

			if(StartBallX >= OFF_GOAL_LINE-20*YARDS)	// pro only ???
				StartBallX = OFF_GOAL_LINE-20*YARDS;	//COP will swap
			else if(StartBallX < DEF_GOAL_LINE+YARD)	// yeah, it could happen
				StartBallX = DEF_GOAL_LINE+YARD;	//but only by a tester
		***************************/
//			stat = GS_FG_ATT;
			HomeOrAwayAudioCrowdReaction(SWELL1, YEAH);
		}
//		if(KickerSlot != NOBODY) // why check? - just to be safe
//			UpdateStats(KickerSlot,stat,1);

		TextualKickerName(FALSE);	// FALSE means no good

	}

}



#define STALL_ZONE  YARD
#define STUCK_TIME   (5*SECONDS)
BOOL StoppedForwardProgress(void)
{	// really a kludge to see if BC got stuck
BOOL rv = FALSE;
EFFVAR keydist,numguys;

	numguys = PracticeMode? 0 : 4;

	if( BallXPosition > BCStuck.Low.X
	   && BallXPosition < BCStuck.High.X
	   && BallYPosition > BCStuck.Low.Y
	   && BallYPosition < BCStuck.High.Y)
	{	// still in box
		BCStuckTimer += TICKS_PER_AI_FRAME;
		if(BCStuckTimer >  STUCK_TIME)
		{
			if(BallCarrier < 11)	// off. or nobody
				keydist = DefenseKeyDistance[numguys].distance;
			else
				keydist = OffenseKeyDistance[numguys].distance;

			if(keydist < 4*HALF_YARD)	// X guys within 2 Yards?
			{
	#if PC_ALWAYS_MODE
				printf("\nUnstuck kicked in");
//				getch();
	#endif
				SetBit(ErrorNumber,0x0001);
				rv = TRUE;
			}
			else
				BCStuckTimer =  STUCK_TIME/2;
		}
	}
	else	// outside of box - set new box
	{
		BCStuck.Low.X = BallXPosition - STALL_ZONE;
		BCStuck.High.X = BallXPosition + STALL_ZONE;
		BCStuck.Low.Y = BallYPosition - STALL_ZONE;
		BCStuck.High.Y = BallYPosition + STALL_ZONE;
		BCStuckTimer = 0;
	}
	return(rv);
}

void DefenseDidBadThingOnKickoff(UWORD ballx)
{ 		// illegal touch on kickoff(not 10 yards)
		// or free kick (any touch) or OOB on 2nd attempt

	AdjustNewStartBall(ballx);		// X and Y within hashmarks
	if(StartBallX <= DEF_GOAL_LINE)	// don't start in EZ
	{
			StartBallX = DEF_GOAL_LINE+20*YARDS;
	}

//	NeedTeam1stDownStats = FALSE;	should be default
	SetNewFirstDown(TRUE);		// 1st & 10 - start drive stats

	sprintf(PlayInfoText2,"%s TAKES OVER ON THE %d",
			GameTeamData[OffensiveSlotNum].STD.TeamCity, // e.g "S.Fran"
			GetTrueYardline());
}

BOOL IntentionalGroundingValid(void)
{
	if(GameOptions[GAME_OPTNS_INTLGROUNDING] == OPTION_ON)
	{   // if QB in pocket
		if( (ThrowAwayRec > 0)
			&& (BallArc[0][1] > StartBallY- 3*YARDS)
			&& (BallArc[0][1] < StartBallY+ 3*YARDS)
			&& (PlayType < EX_PT1_PLAY)	// ignore EX Point Play
			   // closest guy is not within X yards (based on ball target)
			&& (OffenseKeyDistance[0].distance > 7*YARDS)

		  )
			return(TRUE);

	}
	return(FALSE);

}






/** This is part of human movement routine - Pass Interference	****/
void CheckForReceiverContact(WORD guyhit)
{	// keeps track of number of times Receiver gets touched during play

UWORD where;

	if(	(   guyhit >= ZERO           // make sure guy & receiver not NOBDODY
		&& guyhit == TheReceiver	//TheReciever valid only when pass in air
		&& PlayHappening()
		&& GameOptions[GAME_OPTNS_PASS_INTERFERENCE] == OPTION_ON
		&& (!(BallFlags & PASS_DEFLECTED_BFLAG))	// no P.I. on deflection
		&& gPNum > LAST_OFF_SLOT_NUM	// i'm on def
		)
//		|| ((TheReceiver != NOBODY) && gPNum ==12)	// TEST only
	  )
	{
		if(++DefPassInterferenceCounter > 2)	//ignore incidental contact
		{
			// if in EndZone, put on 1 OR minimum of where started
			where = USetMinMax(SETTOWHOLEYARD(OPXPos(TheReceiver)),
								StartBallX,OFF_GOAL_LINE - YARD);

			InitDefPenaltyParameters(gPNum,PASS_INTERFERENCE_PENALTY,where);

//			SetBit(PlayFlags,DEF_PASS_INTERFERENCE_BFLAG);
//			DefPassInterferenceGuy = gPNum;
		}

/* no offense PI in this game as then we'd have to have penalty choices
		else if( gPNum == TheReceiver
			&& guyhit > LAST_OFF_SLOT_NUM)	// i'm the rec.
		{
			SetBit(PlayFlags,OFF_PASS_INTERFERENCE_BFLAG);
			OffPassInterferenceCounter++;
			//OffPassInterferenceGuy = gPNum;	always TheReceiver
		}  *******/

	}
}

void HandleNormalIncomplete(void)
{
register WORD rec;	// need local for PSX complier bug 4/11/97

	BuildAnnouncerPhraseInit(INCOMPLETE1_SFX); // announcer "incomplete" (said later)

	YardsGainedThisPlay = ZERO;
//	NextStartBallX = StartBallX;	// starts

	if((rec = IntendedReceiver) >=0)
	{
		sprintf(PlayInfoText1,"INCOMPLETE - INTENDED FOR #%d - %s",
				GetJerseyNum(rec),GetPlayerName(rec));

		 // announcer "intended for" (said later)
		AddToAnnouncerPhrase(INTENDED_FOR_SFX+GetJerseyNum(rec)-1);	// no #zero
/***
		AddToAnnouncerPhrase(INTENDED_SFX); // announcer "intended for" (said later)
		AddToAnnouncerPhrase(NUMBER_SFX);
		AddToAnnouncerPhrase(-GetJerseyNum(rec)); // true number are negative
***/
		if(PassDefender > -1)
		{
			sprintf(PlayInfoText2,"DEFENDED BY #%d - %s",
				GetJerseyNum(PassDefender),GetPlayerName(PassDefender));
		}
	}
	else	// spike ball or error
	{
		sprintf(PlayInfoText1,"INCOMPLETE");
	}

	if(ANY_EXPT_PLAY)
	{	// no stats on EX PT
		sprintf(PlayInfoText2,NoGood2PtText);	// in second text line
		InitRefPhrase(NOGOOD_SFX);
		SetNewRefAnim(NOGOOD_SFX,AI_REF_WAVEARMS_NUM,NO_PENALTY);
	}
	else
	{
	// only stat this play - 1 attempt for passer
//		UpdateStats(Passer, GS_PASS_ATT,1);
		SaveOffensePlayData();

		GotFirstDownOrIncDown();	// only the latter
	}

}

void HandleFGorExptOver(void)
{

	StopGameClock();

	SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP

	KickLength = (OFF_END_LINE - KickStartX) >> YARD_SHIFT;	// a global for stats later

	if(EventFlags.KICK_GOOD_BFLAG)
	{
		InitRefPhrase(GOOD_SFX);
		SetNewRefAnim(GOOD_SFX,AI_REF_TOUCHDOWN_NUM,NO_PENALTY);

		NextPlayType = KICKOFF_PLAY;  // if good FG or Ex pt - MUST be here - don't remove MJK 7/10/96

		if(ANY_EXPT_PLAY)
		{
			UnofficiallyAddScore(OffensiveSlotNum,EXPT_SCORE);
			sprintf(PlayInfoText1,"EXTRA POINT");

//			UpdateStats(KickerSlot,GS_PAT,1);
//			UpdateStats(KickerSlot,GS_PAT_ATT,1);
		}
		else	// it's a field goal
		{
			UnofficiallyAddScore(OffensiveSlotNum,FG_SCORE);
//			sprintf(PlayInfoText1,"%d YARD FIELD GOAL IS GOOD",kicklength);
			sprintf(PlayInfoText1,"%d YARD FIELD GOAL",KickLength);

//			UpdateStats(KickerSlot,GS_FG,1);
//			UpdateStats(KickerSlot,GS_FG_ATT,1);
//			UpdateStatsMax(KickerSlot,GS_FG_LONG,kicklength);
//
			HomeOrAwayAudioCrowdReaction(AHHH_SFX, SWELL1);

		}
		TextualKickerName(TRUE);	// who came up with this function name?
	}
	else	// kick no good
	{
		SetKickNoGood(KickLength);	// called if normally no good or if block OOB
	}

}


void HandleKickOutOfBounds(void)
{
EFFVAR ballx;

	StopGameClock();
	if(PlayType == KICKOFF_PLAY)
	{
		if(KickOOBX <= DEF_GOAL_LINE+FOOT)	// length of ball
		{  // in EZ is touchback
			SetInitStartBall(DEF_GOAL_LINE+20*YARDS);
//			NeedTeam1stDownStats = FALSE; should be default
			SetNewFirstDown(TRUE);	// TRUE means reset Drive Stats
			sprintf(PlayInfoText1,"TOUCHBACK");
		}
		else	//
		{
			if(   (KickOOBX > StartBallX - 20*YARDS)
			   && (IllegalKickCount == ZERO)
			   && (!(GameFlags & FREE_KICK_BFLAG))
			  )
			{
				SetPenaltyYards(ON_DEFENSE,5*YARDS);
				NextPlayType = KICKOFF_PLAY;	// re-kick
				sprintf(PlayInfoText1,"ONSIDE KICK OUT OF BOUNDS");
				sprintf(PlayInfoText2,"ON FIRST ATTEMPT - RE-KICK");
				SetBit(MoreEventFlags,ILLEGAL_KICK_BFLAG);
			}
			else
			{
				sprintf(PlayInfoText1,"PENALTY - KICKOFF OUT OF BOUNDS");
				// closer of 30 yards from where kicked from or OOB spot
				ballx = StartBallX-30*YARDS;
				if(KickOOBX > ballx)
					ballx = BallXPosition;

				DefenseDidBadThingOnKickoff(ballx);
			}
			AudioCrowdReaction(SWELL1, CROWD_REACT_VOL_MED);
		}

	}
	else if(PlayType == PUNT_PLAY)
	{  	// COP will swap yards and set new 1stdown
		PuntDowned(KickOOBX);
	}
	else if(PlayType == FIELD_GOAL_PLAY)
	{  	// COP will swap yards and set new 1stdown
//		PuntDowned(KickOOBX);	// works for FG too - bug #2129
		SetKickNoGood((OFF_END_LINE - KickStartX) >> YARD_SHIFT);	// called if normally no good or if block OOB
		SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP

	}
	else if(ANY_EXPT_PLAY)
	{
		SetKickNoGood(0);	// called if normally no good or if block OOB
		SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP
	}
	else
	{		// fumble out of bounds	???
		sprintf(PlayInfoText1,"FUMBLE OUT OF BOUNDS");
//		sprintf(PlayInfoText2,"THIS IS PROBABLY A BUG");
		GotFirstDownOrIncDown();	//
	}

}


void HandleDefGettingOnsideKick(EFFVAR bc)
{
	StopGameClock();	// always stop clock if TurnOver

	if(GameFlags & FREE_KICK_BFLAG) //after Safety KO?
	{
		sprintf(PlayInfoText1,"BALL DOWNED ON FREE KICK");
		DefenseDidBadThingOnKickoff(BallXPosition);

	}
	else if(MoreEventFlags & KO_WENT_10YARDS_BFLAG)	// had went far enough?
	{
		// yes - def. got their on-side kickoff
	   // but in Pro they can't advance it  bug #1464
//		SetBit(MoreEventFlags,DEF_ONSIDE_RECOVER_BFLAG);
	 //	FigureYardsGained(bc,BallXPosition);
		AdjustNewStartBall(BallXPosition);	// X and Y within hashmarks
		SetBit(PlayOverFlags,NEED_COP_BFLAG);
		sprintf(PlayInfoText1,"ONSIDE KICK RECOVERED BY #%d - %s",GetJerseyNum(bc),GetPlayerName(bc));

	}
	else	// KO didn't go 10 yards
	{
		sprintf(PlayInfoText1,"ILLEGAL TOUCH ON KICKOFF");
		if(IllegalKickCount == ZERO)
		{	// they get a second chance
			SetPenaltyYards(ON_DEFENSE,5*YARDS);
			NextPlayType = KICKOFF_PLAY;	// re-kick
			sprintf(PlayInfoText2,"ON FIRST ATTEMPT - RE-KICK");
			SetBit(MoreEventFlags,ILLEGAL_KICK_BFLAG);
		}
		else
		{
			DefenseDidBadThingOnKickoff(BallXPosition);
		}
		SetNewRefAnim(-2,AI_REF_DELAY_NUM,NO_PENALTY);
		SetRefStartX(StartBallX - 6*YARDS);
	}
}

/**********************************************************************

				 E N D     O F    P L A Y    S T U F F

	"CheckForPlayOver()", called during the in PlayHappening PlayState,
	checks for all of the possibilities for a play being over
	and then handles all consequences if it is.

	This is the largest function in all of the AI, so be careful!!!

	Major Modification 3/26/97
	Because of penalties, the following are NOT updated now, but,
	if figured, are stored in Temp vars which will be handled later
	once we know if [a possible] penalty was accepted or declined.
		Stats
		Scores
		Down
		StartBallX
		COP (?)

	Here's what IS handled now
		Did play end?
		Clock
		Building of text phrases
		Building of audio phrases (need to preload from disc)
		Ref Anim



	Talk about conditional statements !!!


	Mod. - 3/22/97 broken down for readability - components moved into
	separate functions.

**********************************************************************/

BOOL CheckForPlayOver(void)		// returns TRUE if the play just ended
{
EFFVAR rv = FALSE;
EFFVAR bc = NOBODY;
UEFFVAR ballx;

	if(BallXPosition  < StartBallX - 10 * YARDS)	// for onside kick
		SetBit(MoreEventFlags,KO_WENT_10YARDS_BFLAG);

	if(StoppedForwardProgress())
		SetBit1(EventFlags,TACKLE_ENDED_BFLAG);


	if(PlayOverFlags & INCOMPLETE_PASS_BFLAG)
	{
		StopGameClock();

/***  Pass Interfer now handled as it happens
		if(PassInterferenceValid())	// sets DEF_PEN_PENDING
		{
			HandlePassInterference();
		}
		else	****/
		if(IntentionalGroundingValid())
		{
			// penalty from spot ball was thrown
			InitOffPenaltyParameters(Passer,INT_GROUNDING_PENALTY,BallArc[0][0]);

//			HandleIntentionalGrounding();
		}
		else	// normal incomplete
		{
			HandleNormalIncomplete();
		}
		rv = TRUE;	// TRUE means play has ended
	}
	else if(PlayOverFlags & OFF_DOWNED_PUNT_BFLAG)	// or punt in EZ
	{
		StopGameClock();

		if(ANY_EXPT_PLAY)
		{   // pouch kick on conversion
			TwoPointConversionNoGood();	// in PIT1
		}
		else
		{
			PuntDowned(BallXPosition);
		}
		rv = KickEndsPlay = TRUE;
	}
	else if (PlayOverFlags & KICK_OVER_BFLAG)	// field goal or Ex pt over
	{
		HandleFGorExptOver();
		rv = KickEndsPlay = TRUE;

	}
	else if( (PlayOverFlags & BALL_OUT_OF_BOUNDS_BFLAG)	// set on init bounce only!
			&& (LastBallCarrier == NOBODY))
	{	// kick must have gone OOB
		HandleKickOutOfBounds();
		rv = KickEndsPlay = TRUE;
	}
	else //if(bc >= ZERO)	MUST be a "normal" play with a BallCarrier
	{
		if( (PlayOverFlags & BALL_OUT_OF_BOUNDS_BFLAG)	// set on init bounce only!
				&&  (LastBallCarrier != NOBODY) )
		{	// this handles fumbles that go Out Of Bounds

	//NOTE: LastBallCarrier will be NOBODY on kicks,FGs, punts - see above
			bc = LastBallCarrier;

			if(FumbleX == ZERO)    // error correction
			{
				ballx  = BallXPosition;
			}
			else if(bc < 11)
			{ // if fumble forward put at FumbleX, if backward, put where went OOB
				ballx  = (BallXPosition > FumbleX ?  FumbleX : BallXPosition);
			}
			else	// def. fumbled
			{ // if fumble forward put at FumbleX, if backward, put where went OOB
				ballx  = BallXPosition > FumbleX ?  BallXPosition : FumbleX;
			}

			if(ballx < DEF_END_LINE+FOOT)	// out of back of EZ?
				ballx = DEF_END_LINE-1;	// safety should kick in

		}
		else if(BallCarrier >= ZERO)
		{
			bc = BallCarrier;
			ballx = OPXPos(bc) + ExtraTackleX;	// where BC at + how far he fell down
			if(bc < 11)	// bc on offense
			{
				if(ballx < ForwardProgress)
					ballx = ForwardProgress;
			}
			else
			{
				if(ballx > ForwardProgress)
					ballx = ForwardProgress;
			}

		}
		else
		{	// no ballcarrier - 1 frame(hike) or ball in air-pass or pitch
			return(FALSE);

		}
	// there is a Ball Carrier (or psuedo BC on fumble OOB)

		if(bc < 11)		/*****  Ball Carrier is[was] on Offense	*****/
		{
		/*  here's a good place to check for Safety or TouchBack conditions	*/
			if(ballx  > DEF_GOAL_LINE)
				SetBit1(EventFlags,BC_OUT_OF_EZ_BFLAG);


			if(ballx >= OFF_GOAL_LINE)	// check for TD
			{	// ball crossed goalline
				StopGameClock();
				if(!ANY_EXPT_PLAY)
				{  // no yards if conversion
					FigureYardsGained(bc,OFF_GOAL_LINE);	// to the goalline
				}
		// MUST FigureYardsGained BEFORE SetTD (else StartBallX is messed up)

				if(SetPossibleTD(bc))	// possible means if penalty pending
				{
					sprintf(PlayInfoText2,"TOUCHDOWN");
				}
				else
				{
					sprintf(PlayInfoText1,"2 PT CONVERSION IS GOOD");
				}
				rv = TRUE;
			}
			else if(EventFlags.TACKLE_ENDED_BFLAG || BallOutOfBounds())
			{
				if(ANY_EXPT_PLAY)
				{   // no stats or safety on conversion
//					StopGameClock();	// should have not been running
					TwoPointConversionNoGood();	// in PIT1
				}
				else
				{
					if(ballx  <= DEF_GOAL_LINE)
					{	// ran out of bounds or tackled in end zone
						FigureYardsGained(bc,DEF_GOAL_LINE);
						SetSafetyOrTouchBack(DefensiveSlotNum);
					}
					else
					{
						FigureYardsGained(bc,ballx);	//will adjust to whole number
						if(BallOutOfBounds())
							StopGameClock();
						GotFirstDownOrIncDown();	// only the latter
					}
//					if(Tackler != NOBODY && PlayType != KICKOFF_PLAY)
//						UpdateStats(Tackler,GS_TACK_NUM,1);

					if(bc == KickReturner && bc != NOBODY)	// hooks everywhere!
						AudioCrowdReaction(AHHH_SFX, CROWD_REACT_VOL_MED);
				}
				rv = TRUE;
			}
			else if(ballx  <= DEF_END_LINE)
			{	// offense ran out of back of endzone
				if(ANY_EXPT_PLAY)
				{   // no stats or safety on conversion
//					StopGameClock();	// should have not been running
					TwoPointConversionNoGood();	// in PIT1
				}
				else
				{
					FigureYardsGained(bc,DEF_GOAL_LINE);
					SetSafetyOrTouchBack(DefensiveSlotNum);
				}
				rv = TRUE;
			}

		}
		else if (bc < 22)
		{	// defensive Ball Carrier - punt or turnover or On-side

		/*  here's a good place to check for Safety or TouchBack conditions	*/
			if(ballx  < OFF_GOAL_LINE)
				SetBit1(EventFlags,DEF_BC_OUT_OF_EZ_BFLAG);

			if(ANY_EXPT_PLAY)
			{
				SetKickNoGood(0);	// it might not be a kick - bug in KickerSlot
				rv = TRUE;
			}
			else
			{
				if( (PlayType == KICKOFF_PLAY) && (!(EventFlags.FUMBLE_HAPPENED_BFLAG)))
				{ // def just got onside kick
					HandleDefGettingOnsideKick(bc);
					rv = TRUE;

				}   //  drop through in  case of TD



				if(ballx <= DEF_GOAL_LINE) // check for def. TD
				{	// ball crossed goalline
					FigureYardsGained(bc,DEF_GOAL_LINE); // this fills PlayInfoText1

					SetPossibleTD(bc);
					sprintf(PlayInfoText2,"TOUCHDOWN");
					SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP
					rv = TRUE;
				}
				else if(EventFlags.TACKLE_ENDED_BFLAG || BallOutOfBounds())
				{
					StopGameClock();	// always stop clock if TurnOver
					if(ballx >= OFF_GOAL_LINE)
					{	// ran out of bounds or tackled in end zone
						FigureYardsGained(bc,OFF_GOAL_LINE); // loss to the goalline
						SetSafetyOrTouchBack(OffensiveSlotNum);
					}
					else
					{
						FigureYardsGained(bc,BallXPosition); // to the goalline
						SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP
					}
					rv = TRUE;
				}
				else if(BallXPosition  >= OFF_END_LINE)
				{	// defense ran out of back of endzone
					FigureYardsGained(bc,OFF_GOAL_LINE); // loss to the goalline
					SetSafetyOrTouchBack(OffensiveSlotNum);
					rv = TRUE;
				}
			}
		}
	}

	return(rv);
}

/** following called if receiver caught ball or BC past LOS  */
void SetReceiversToLeadBlockers(void)
{
EFFVAR i,guy;

	for(i=0; i< MAX_RECEIVERS; i++)	// ...become a lead blocker
	{
//		guy = PosReceivers[i];
		guy = Receivers[i];
		if( guy >= ZERO && guy != BallCarrier)
		{
			OPScriptPtr(guy) = All_Scripts[LeadBlockerScriptNUM];
			OPStateInit(guy) = FALSE;
		}
	}
}


/******************************************************************

		 E N D     O F    P L A Y    S U B R O U T I N E S

	Always place final ball X on a whole number  X yard line!!!

******************************************************************/

void SaveOffensePlayData(void)
{
EFFVAR i = -1;

	if(PlayType < EX_PT1_PLAY)	// no special plays- KO or Ex pts
	{
		if(YardsGainedThisPlay > ZERO)	// only save data for positvie yardage
		{
			if(BallCarrier >=0 && BallCarrier <=5)
			{
				i = BallCarrier;
				if(PlayFlags &  PASS_PLAY_BFLAG)
					i += 6;	// now 6-11
			}
		}

		GameTeamData[OffensiveSlotNum].PrevOffPlayData[GameTeamData[OffensiveSlotNum].OffPlayDataCounter] = i;

		if(++GameTeamData[OffensiveSlotNum].OffPlayDataCounter >= MAX_OFF_PLAYDATA)
			GameTeamData[OffensiveSlotNum].OffPlayDataCounter = ZERO;

	}
}


BYTE *KickStrings[3] = {
"PUNT",
"FIELD GOAL",
"P.A.T."
};


void DisplayWhoBlockedKick(void)
{
BYTE *ktype;

	if(BlockedKickBlocker >= ZERO)	// safer than != NOBODY
	{
		if(PlayFlags & POS_PUNT_PLAY_BFLAG)
			ktype = KickStrings[0];
		else if(PlayType > EX_PT1_PLAY)
			ktype = KickStrings[2];
		else
			ktype = KickStrings[1];

		sprintf(PlayInfoText0,"%s BLOCKED BY #%d - %s",ktype,
			GetJerseyNum(BlockedKickBlocker),GetPlayerName(BlockedKickBlocker));
	}
}


void PutTackleInfoPIT2(void)
{
	if(Tackler > -1)
	{
		if(AIFrameCounter&1)	// no need to call rand()
		{
			sprintf(PlayInfoText2,"TACKLED BY #%d - %s",
				GetJerseyNum(Tackler),GetPlayerName(Tackler));
		}
		else
		{
			sprintf(PlayInfoText2,"#%d - %s MAKES THE TACKLE",
				GetJerseyNum(Tackler),GetPlayerName(Tackler));
		}
	}
}




/********************************************************************

					UpdatePrelimOffPlayStats


	Called at the immediate EOP, this routine figures out:

	a) textual phrase to display
	b) audio phrase to say
	c) all stats info for later on

	NOTE: stats NOT added until AFTER it is determined that a penalty
	is not pending so DO NOT call UpdateStats() in this routine

********************************************************************/

void UpdatePrelimOffPlayStats(WORD lastbc, UWORD endX,BOOL endofplay)
{		//TDs figured elsewhere
	// "endofplay" FALSE if called on fumble recovery

EFFVAR yards,i;
EFFVAR OffPlayTypeDesignator;	// to see if a sack
BOOL optionplay = FALSE;


	yards =  ((WORD)(endX - StartBallX)) >>YARD_SHIFT;	// assume

	i = GameTeamData[OffensiveSlotNum].PlayNum;	// temp playnum
	if( i == ProSetHalfBackOptionNUM
	   || i == GoalLineOptionPassNUM
	   || i == IFormHBOptionNUM)
		optionplay = TRUE;


	OffPlayTypeDesignator = ThePlays[i].PlayTypeDesignator;


/*  Fumble recovery MUST be first check so as not to mess up pre-fumble stats */
	if(lastbc == FumbleRecoverer)
	{
		yards = ((WORD)(endX - FumbleRecoveryX)) >>YARD_SHIFT;
		FinalBallCarrier = FumbleRecoverer;

//		UpdateStats(lastbc,GS_FUMRECOV,1);	// recov. yards???

		if(endX <= DEF_GOAL_LINE || FumbleRecoveryX >= OFF_GOAL_LINE)
		{ 	// if in EZ - no yards
			yards = ZERO;
		}

		if(yards > ZERO)
			sprintf(PlayInfoText1,"%d YARD FUMBLE RECOVERY BY #%d - %s",yards,
				GetJerseyNum(lastbc),GetPlayerName(lastbc));
		else
			sprintf(PlayInfoText1,"FUMBLE RECOVERY BY #%d - %s",
				GetJerseyNum(lastbc),GetPlayerName(lastbc));

		PutTackleInfoPIT2();	// give credit to tackler

	}
//  else if(lastbc == KickReturner || PlayType == KICKOFF_PLAY)
	else if(lastbc == KickReturner) // why was (PlayType == KICKOFF_PLAY) there???
	{
		if(endX <= DEF_GOAL_LINE) 	// if in EZ - no yards
		{	// no stats for KR on downed kicked
			sprintf(PlayInfoText1,"NO RETURN ON THE KICKOFF");
			yards = ZERO;
			ReturnYards = INVALID_DISTANCE;	// can't use 99 to -50 since they're valid
		}
		else
		{
			FinalBallCarrier = KickReturner;
			ReturnYards = yards =  ((WORD)(endX - CatchBallX)) >>YARD_SHIFT;	// assumption wrong

//			UpdateStats(lastbc, GS_KRET_NUM,1);
//			UpdateStats(lastbc, GS_KRET_YARDS,yards);
//			UpdateStatsMax(lastbc, GS_KRET_LONG,yards);
			sprintf(PlayInfoText1,"%d YARD KICKOFF RETURN BY #%d - %s",yards,
					GetJerseyNum(lastbc),GetPlayerName(lastbc));

			PutTackleInfoPIT2();	// give credit to tackler
		}
	}
	else if(lastbc == PassCatcher)
	{
		FinalBallCarrier = PassCatcher;
//		UpdateStats(Passer, GS_PASS_ATT,1);
/**		UpdateStats(Passer, GS_PASS_COMP,1);
		UpdateStats(Passer, GS_PASS_YARDS,yards);
		UpdateStatsMax(Passer, GS_PASS_LONG,yards);

		UpdateStats(PassCatcher, GS_RECP_NUM,1);
		UpdateStats(PassCatcher, GS_RECP_YARDS,yards);
		UpdateStatsMax(PassCatcher, GS_RECP_LONG,yards);
***/
		PassYards = yards;
		DisplayYardsGained(yards);	/*  and build audio phrases	*/
		if(yards > ZERO)	// override existing text phrase with below
		{
			sprintf(PlayInfoText1,"PASS COMPLETE TO %s FOR %d YARD%s",
						GetPlayerName(lastbc),yards,yards==1?"":"S");
		}
		else if (yards == ZERO)
		{
			sprintf(PlayInfoText1,"PASS COMPLETE TO %s - NO GAIN",GetPlayerName(lastbc));
		}
		else
		{
			sprintf(PlayInfoText1,"PASS COMPLETE TO %s - LOSS OF %d",GetPlayerName(lastbc),-yards);
		}
	}
	else if(  OffPlayTypeDesignator >= PASS_SHORT
		   && OffPlayTypeDesignator <= PASS_DEEP
		   && OPMyFormPosition(lastbc) == QB
		   && yards < ZERO
		   && !optionplay
		   && endofplay		// no sack on fumble recovery
		   )
	{	// it's a sack - QB tackled for loss on passing play
		// NOTE:  sacks are non-int in ROM stats (2.5) so we must add 10 (=1)

		for(i=0; i<10; i++)	// for safer than while
		{      // closest to QB gets sack
			if(OffenseKeyDistance[i].slotnum >=6)	// found a lineman
				break;
		}

		// give to closest lineman to QB (even if it wasn't his guy)
		SackAllower = OffenseKeyDistance[i].slotnum;	// closest guy
		FinalBallCarrier = QB;
		SackYards = yards;

//		UpdateStats(OffenseKeyDistance[i].slotnum, GS_SACK_ALLOWED,SACK_FACTOR);
//		UpdateStats(LAST_OFF_SLOT_NUM, GS_SACK_ALLOWED,SACK_FACTOR);	// give to CENTER & team

//		UpdateTeamStats(OffensiveSlotNum,GS_SACK_YARDS,yards);
//		StatsData[OffensiveSlotNum].allplyrstats[GS_SACK_YARDS] += yards;

		SetBit(PlayFlags,PASS_PLAY_BFLAG | SACK_ON_PLAY_BFLAG);	// keep track of # of pass plays
		sprintf(PlayInfoText1,"SACK - LOSS OF %d",-yards);	//P.I.T.2 will have tackler
		if(Tackler > LAST_OFF_SLOT_NUM)	// OOB??
		{
//			UpdateStats(Tackler, GS_SACK_NUM,SACK_FACTOR);	// will do team sack
			PutTackleInfoPIT2();
			if(AIFrameCounter&1)
			{     // override what's there
				sprintf(PlayInfoText1,"%s SACKED FOR A%s %d YARD LOSS",
					GetPlayerName(lastbc),
					((yards == -8) || (yards == -18)) ? "N":"",	// Sony dinged us for not having this
					-yards);
			}
		}
//		else	// must be OOB - give team sack
//		{
//			UpdateTeamStats(DefensiveSlotNum,GS_SACK_NUM,SACK_FACTOR);
//			StatsData[DefensiveSlotNum].allplyrstats[GS_SACK_NUM] += SACK_FACTOR;
//		}
#ifdef SATURNMODE
		if(BallXPosition > DEF_GOAL_LINE)  // don't say if a safety
			InitAnnouncerPhrase(SACK_PHRASE);
#endif

	}
	else if(lastbc == BlockedKickRecoverer)
	{
		FinalBallCarrier = BlockedKickRecoverer;
		yards = ((WORD)(FumbleRecoveryX - endX)) >>YARD_SHIFT;

		DisplayWhoBlockedKick();	// in PIT0

		sprintf(PlayInfoText1,"RECOVERED BY #%d - %s",
			GetJerseyNum(lastbc),GetPlayerName(lastbc));
	}
	else	// better be rushing
	{
		RushingYards = yards;
		FinalBallCarrier = Rusher = lastbc;
//		UpdateStats(lastbc, GS_RUSH_ATT,1);
//		UpdateStats(lastbc, GS_RUSH_YARDS,yards);
//		UpdateStatsMax(lastbc, GS_RUSH_LONG,yards);

		DisplayYardsGained(yards);	/*  and build audio phrases	*/
	}
	YardsGainedThisPlay = yards;

}



void UpdatePrelimDefPlayStats(WORD lastbc, UWORD endx)
{		//TDs figured elsewhere

WORD retyards;

	if(lastbc < 11 || lastbc > 21)	// error
	{
#if PC_ALWAYS_MODE
		printf("\nError on UpdatePrelimDefPlayStats , LBC = %d",lastbc);
		getch();
#endif
		return;
	}

	FinalBallCarrier = lastbc;	// save as global

/*  Fumble recovery MUST be first check so as not to mess up pre-fumble stats */
	if(lastbc == FumbleRecoverer)
	{
		// !!! DON'T use global ReturnYards !!!

		retyards = ((WORD)(FumbleRecoveryX - endx)) >>YARD_SHIFT;
//		UpdateStats(lastbc,GS_FUMRECOV,1);	// recov. yards???

		if(endx >= OFF_GOAL_LINE || FumbleRecoveryX <= DEF_GOAL_LINE) //bug #2827
			retyards = ZERO;		// if in EZ - no yards

		if(retyards > ZERO)
			sprintf(PlayInfoText1,"%d YARD FUMBLE RECOVERY BY #%d - %s",retyards,
				GetJerseyNum(lastbc),GetPlayerName(lastbc));
		else
			sprintf(PlayInfoText1,"FUMBLE RECOVERY BY #%d - %s",
				GetJerseyNum(lastbc),GetPlayerName(lastbc));

		PutTackleInfoPIT2();	// give credit to tackler
	}
	else if(lastbc == PuntReturner)	// punt returner
	{
		PuntYards = ((WORD)(CatchBallX - StartBallX)) >>YARD_SHIFT;	// punt dist.

//		UpdateStats(KickerSlot,GS_PUNT,1);
//		UpdateStats(KickerSlot,GS_PUNT_YARDS,yards);
//		UpdateStatsMax(KickerSlot,GS_PUNT_LONG,yards);
		sprintf(PlayInfoText0,"%d YARD PUNT BY #%d - %s",PuntYards,
					GetJerseyNum(KickerSlot),GetPlayerName(KickerSlot));

		if(endx >= OFF_GOAL_LINE) 	// if in EZ - no yards
		{
			ReturnYards = INVALID_DISTANCE;	// can't use 99 to -50 since they're valid
			sprintf(PlayInfoText1,"NO RETURN");
		}
		else
		{
			ReturnYards = ((WORD)(CatchBallX - endx)) >>YARD_SHIFT;
//			UpdateStats(lastbc,GS_PRET_NUM,1);
//			UpdateStats(lastbc,GS_PRET_YARDS,yards);
//			UpdateStatsMax(lastbc,GS_PRET_LONG,yards);
		}

		if(ReturnYards > ZERO)
		{
			sprintf(PlayInfoText1,"%d YARD RETURN BY #%d - %s",ReturnYards,
						GetJerseyNum(lastbc),GetPlayerName(lastbc));
		}
	}
	else if(lastbc == PassInterceptor)	//interception
	{
		AutoReplayFlag = TRUE;	// show IRP on Scoreboard

		ReturnYards = ((WORD)(CatchBallX - endx)) >>YARD_SHIFT;
		if(endx >= OFF_GOAL_LINE) 	// if in EZ - no yards
			ReturnYards = ZERO;
		if(Passer == NOBODY)	// if intercepted a backward pass
			Passer = 0;
//		UpdateStats(Passer, GS_PASS_ATT,1);
//		UpdateStats(Passer, GS_PASS_INT,1);

//		UpdateStats(PassCatcher, GS_INT_NUM,1);
//		UpdateStats(PassCatcher, GS_INT_YARDS,yards);
//		UpdateStatsMax(PassCatcher, GS_INT_LONG,yards);

		if(ReturnYards > ZERO)
			sprintf(PlayInfoText1,"%d YARD INTERCEPTION RETURN BY #%d - %s",ReturnYards,
				GetJerseyNum(lastbc),GetPlayerName(lastbc));
		else
			sprintf(PlayInfoText1,"INTERCEPTION BY #%d - %s",
				GetJerseyNum(lastbc),GetPlayerName(lastbc));

		PutTackleInfoPIT2();	// give credit to tackler
//		Inc3rdor4thDownAttempts();	// if necessary


//		InitAnnouncerPhrase(INTERCEPTED_SFX+GetJerseyNum(lastbc)-1);

	}
	else if(lastbc == BlockedKickRecoverer)
	{
		ReturnYards = ((WORD)(FumbleRecoveryX - endx)) >>YARD_SHIFT;

		DisplayWhoBlockedKick();

		if(ReturnYards > ZERO)
		{
			sprintf(PlayInfoText1,"RETURNED %d YARD%s BY #%d - %s",
				ReturnYards,ReturnYards==1?"":"S",
				GetJerseyNum(lastbc),GetPlayerName(lastbc));
		}
		else
		{
			sprintf(PlayInfoText1,"RECOVERED BY #%d - %s",
				GetJerseyNum(lastbc),GetPlayerName(lastbc));
		}
	}
	else	// I'm lost - get out the [memory] map
	{
		ReturnYards = ZERO;
#if PC_DEBUG_MODE
		sprintf(PlayInfoText1,"Something Good Is About To Happen-#%d-%s",
					GetJerseyNum(lastbc),GetPlayerName(lastbc));
#endif
	}
//	YardsGainedThisPlay = yards;

}










void FigureYardsGained(WORD lastbc, UWORD endX)
{	// only for "normal" plays
//WORD i;

	endX  = SETTOWHOLEYARD(endX);

	if(lastbc > 10)	// ON_DEFENSE
	{
		UpdatePrelimDefPlayStats(lastbc,endX);

//		YardsGainedThisPlay = ((WORD)(CatchBallX-endX)) >>YARD_SHIFT;
	}
	else
	{
		UpdatePrelimOffPlayStats(lastbc,endX,TRUE);	// prelim in case of penalty

//		YardsGainedThisPlay = ((WORD)(endX - StartBallX)) >>YARD_SHIFT;
		SaveOffensePlayData();

	}

	AdjustNewStartBall(endX);	// X and Y within hashmarks

}





UWORD WheresFirstDown(UWORD startingyard, WORD teamslot)
{ // if it's first down (or could be 1st due to penalty), this figures it
UWORD possible1st;

	if(teamslot == OffensiveSlotNum)
	{
		possible1st = startingyard + GameTeamData[OffensiveSlotNum].YardsForFirst;
		if(possible1st > OFF_GOAL_LINE)
		{
			possible1st = OFF_GOAL_LINE;
		}
	}
	else	// figure as if def. has ball (for penalty calculation)
	{
		possible1st = startingyard - GameTeamData[DefensiveSlotNum].YardsForFirst;
		if(possible1st < DEF_GOAL_LINE)
		{
			possible1st = DEF_GOAL_LINE;
		}
	}


	return (possible1st);
}


void Set1stDownParameters(void)
{
///	NextDown = TheDown = 1;	// just to be sure  NO,NO screws up stats

	FirstDownX = NextFirstDownX = WheresFirstDown(StartBallX,OffensiveSlotNum);
/*
	FirstDownX = StartBallX + GameTeamData[OffensiveSlotNum].YardsForFirst;
	if(FirstDownX > OFF_GOAL_LINE)
		FirstDownX = OFF_GOAL_LINE;	*/

	RefMarkerX[0] = StartBallX;	// where the guys with the markers stand
	RefMarkerX[1] = FirstDownX;

	if(StartNewDrive)	// global
	{
		StartNewDrive = FALSE;

#if 0		//PC_ALWAYS_MODE
		  {
			EFFVAR secs = SecondsLeftInQuarter();

			printf("\nIniting Drive Stats - #P = %d, T = %ld GameTime = %d:%02d%s",
				NumPlaysInDrive,DriveTime/CLOCKS_TICKS_PER_SECOND,
				secs/60,secs%60,
				((GameFlags & GAME_TIMER_ON_BFLAG)?"r":"s"));

//			getch();
		  }
#endif
		InitDriveStats();
	}
/**
	else if(NeedTeam1stDownStats)
	{
		NeedTeam1stDownStats = FALSE;
		UpdateTeamStats(OffensiveSlotNum,GS_1STDOWNS,1);
	}
***/
}


void SetNewFirstDown(WORD startnewdrive)	// make this disappear
{											// used for old 96 penalties
	StartNewDrive  = startnewdrive;
	NextDown = 1;
	Set1stDownParameters();

/****************
	TheDown = 1;
	FirstDownX = StartBallX + GameTeamData[OffensiveSlotNum].YardsForFirst;
	if(FirstDownX > OFF_GOAL_LINE)
		FirstDownX = OFF_GOAL_LINE;

	RefMarkerX[0] = StartBallX;	// where the guys with the markers stand
	RefMarkerX[1] = FirstDownX;

	if(startnewdrive)
	{
#if 0	//PC_ALWAYS_MODE
	  {
		EFFVAR secs = SecondsLeftInQuarter();

		printf("\nIniting Drive Stats - #P = %d, T = %ld GameTime = %d:%02d%s",
				NumPlaysInDrive,DriveTime/CLOCKS_TICKS_PER_SECOND,
				secs/60,secs%60,
				((GameFlags & GAME_TIMER_ON_BFLAG)?"r":"s"));

//		getch();
	  }
#endif
		InitDriveStats();
	}
**************/
}


/*********************************************************************

					void SetNewDown(void)

	Called AFTER  EOP after it was determined if penalty was accepted

	Okay to update stats in this module
	("TheDown" is actually a very important stat)

*********************************************************************/

void SetNewDown(void)	//Called a few seconds AFTER  EOP
{

//	Inc3rdor4thDownAttempts();	// if necessary  ---what if punt????

	if(NextDown > GameTeamData[OffensiveSlotNum].DownsForFirst) // why always 4??
	{ 	// just to be sure
#if PC_ALWAYS_MODE
		if(!(PlayOverFlags & NEED_COP_BFLAG))
		{
			printf(" COP in SetNewDown without old COP");
			getch();
		}
#endif
		SetBit(PlayOverFlags,NEED_COP_BFLAG); // for final cleanup @ EOP
		StopGameClock();
	}
	else if(NextDown == 1)
	{

		if(NeedTeam1stDownStats)
		{
			NeedTeam1stDownStats = FALSE;
			UpdateTeamStats(OffensiveSlotNum,GS_1STDOWNS,1);
			Inc3rdor4thDownMade();	// if necessary (uses [unchanged] TheDown)
		}

		Set1stDownParameters();	// new 1stDownX, refs

	}

	TheDown = NextDown;	// MUST be at end of this routine (Inc3rdor4th.. uses TheDown)
}




void HandlePlayOverPlayType(void)
{
/*****  moved to right after CheckForPlayOver
		if(PlayType == KICKOFF_PLAY)	// after KO, init to normal play
		{
			StopGameClock();	//sega bug # 154??
	#if 	PC_DEBUG_MODE
			GameTeamData[OffensiveSlotNum].PlayNum = INITIAL_OFF_PLAY;
			GameTeamData[DefensiveSlotNum].PlayNum = INITIAL_DEF_PLAY;
	#endif
		}
*****/

		if(PlayType == EX_PT2_PLAY)
		{
			PlayTypeCount[OffensiveSlotNum][EX_PT2_PLAY]++;
/// ???		PlayType = NORMAL_PLAY;	//assume a Running play
		}
		if(PlayFlags & PASS_PLAY_BFLAG)
			PlayType = PASS_PLAY;

		if(PlayType < ZERO || PlayType >= MAX_PLAY_TYPES)
		{	// not really a play but it's useful here for debugging
			PlayTypeCount[OffensiveSlotNum][ASK_FOR_EXPT]++;
		}
		else
		{
			if(PlayType == NORMAL_PLAY)
				PlayType = NORMAL_PLAY;	// test only - BP -here
			PlayTypeCount[OffensiveSlotNum][PlayType]++;
		}


		LastPlayType = PlayType;

		PlayType = NextPlayType;
		if(PlayType == KICKOFF_PLAY)
		{
			InitKickOffPlay();
		}
}




void SetPlayOfficiallyOver(void)
{ // everything that happens when a play is officially over


	if(MoreEventFlags & OKAY_FOR_STATS_BFLAG)	// set in PlayHappeneing()
	{
		UpdateEOPStats();	// test only

		HandlePlayOverPlayType();

		SetNewDown();
	}
}


void SetInitStartBall(WORD startx)		// Y = middle of field
{ 	// leave ball where is is (BallX,Y) until later
//	BallXPosition = StartBallX = startx;
//	BallYPosition = StartBallY = MID_FIELDY;

//	if(PracticeMode)
//	{
//		StartBallX = PracticeStartBallX;
//		// leave StartY where it was
//	}
//	else
	{
		StartBallX = SETTOWHOLEYARD(startx);
		StartBallY = MID_FIELDY;
	}
}

void AdjustNewStartBall(UWORD newX)
{
	StartBallX = SETTOWHOLEYARD(newX);

	/* re-adjust Start Y with in hash marks	*/
	StartBallY = USetMinMax(BallYPosition,NORTH_HASH_MARK,SOUTH_HASH_MARK);
}


void InitDriveStats(void)
{
	NumPlaysInDrive = DriveTime = ZERO;
	StartDriveX = StartBallX;
}


void SetNewRefAnim(WORD sfxnum,WORD refAIAnim,BOOL dopenalty)
{	// sets REF script to run on field, say and do something, then run off

EFFVAR temp;

	if(PracticeMode)	// no ref needed in practice
		return;

	temp = gPNum;
	gPNum  = REF_SLOT_NUM;

	if(BallYPosition < NORTH_SIDELINE + ((FIELD_WIDTH/3)*2))
		CPOldYPos = CPYPos  = SOUTH_SIDELINE+1*YARD; // start at bottom
	else
		CPOldYPos = CPYPos  = SOUTH_SIDELINE+5*YARD; // hide way off screen

//	CPTargetY = MID_FIELDY;					// go to middle
	CPTargetY = StartBallY;

	if(dopenalty)
	{
		SetNewScript(RefPenaltyScriptNUM);
		SetRefStartX(PenaltyX);
	}
	else
	{
		SetNewScript(RefRunOnFieldScriptNUM);
		SetRefStartX(BallXPosition);
	}
	SetBit(CPFlags,REF_RUNNING_OUT_BFLAG);	// used for camera control

#ifdef SATURNMODE
	PutCameraOnRefMacro; //PSX does it as part of ref script (7/19/96)
#endif
	/*  when ref reaches his target he will do the following	*/
	RefSFXPending = sfxnum;			// say this (if positive)
  /*  note - 8/11/96 REF says phrases, 	RefSFXPending is now a flag to
   indicate whether or not he says something		*/

	RefAIAnimPending = refAIAnim;	// do this

	gPNum = temp;


}

void SetRefStartX(UWORD xpos)
{
	OPOldXPos(REF_SLOT_NUM) = OPXPos(REF_SLOT_NUM) =
		OPTargetX(REF_SLOT_NUM) = min(OFF_GOAL_LINE+5*YARDS,xpos);
}




/***********************************************************************

				 G O T    1 S T    D O W N  ????

	Only sets up shadow vars (NextDown,StartNewDrive) to be looked
	at later in case of pending penaly

	DOESN'T  do  any STATS

***********************************************************************/

void GotFirstDownOrIncDown(void)	// assume ball X already adjusted
{

//	Inc3rdor4thDownAttempts();	// if necessary
	NextFirstDownX = FirstDownX;

	if(ANY_EXPT_PLAY)
	{		// handles tackle on fake extra point
		StopGameClock();	// just to be sure
		NextDown = ZERO;	// means need a kickoff
	}
	else if (   (PlayType == KICKOFF_PLAY)	// KO just ended
			 || (MoreEventFlags & FORCE_NEW_1STDOWN_BFLAG)
			)	 // off. recovered def. fumble
	{
		StopGameClock();
		NextDown = 1;
		StartNewDrive = TRUE;

	}
	else if(StartBallX >= FirstDownX)
	{	// offense just made a first down (maybe if no penalty)
		NextDown = 1;
		NextFirstDownX = WheresFirstDown(StartBallX,OffensiveSlotNum);

		StartNewDrive = FALSE;	// should be default
		NeedTeam1stDownStats = TRUE;

//		UpdateTeamStats(OffensiveSlotNum,GS_1STDOWNS,1);
//		Inc3rdor4thDownMade();	// if necessary
	}
	else
	{
		NextDown = TheDown + 1;

		if(NextDown > GameTeamData[OffensiveSlotNum].DownsForFirst) // why always 4??
		{
			SetBit(PlayOverFlags,NEED_COP_BFLAG); // for final cleanup @ EOP
			StopGameClock();
		}
	}

	if(NextDown == 1)	// a 1st down was [possibly] made
	{
		InitRefPhrase(FIRST_DOWN_SFX);
		SetNewRefAnim(FIRST_DOWN_SFX,AI_REF_FIRSTDOWN_NUM,NO_PENALTY);	// bug 2367
	// reinit X as ball will have moved by time ref gets to middle of field
		SetRefStartX(BallXPosition - 2*YARDS);



	}
}


BOOL BallOutOfBounds(void)	// returns TRUE if Ball outof bounds
{

	return( (BallYPosition < NORTH_SIDE_LINE+1)
			|| (BallYPosition > SOUTH_SIDE_LINE-1) );
}

BOOL BallOutOfEntireField(void)	// returns TRUE if Ball outof bounds or over Endlines
{

	return( (BallYPosition < NORTH_SIDE_LINE+1)
			|| (BallYPosition > SOUTH_SIDE_LINE-1)
			|| (BallXPosition < DEF_END_LINE+FOOT)	// length of ball
			|| (BallXPosition > OFF_END_LINE-1)
		 );
}


WORD PointsTable[MAX_SCORE_TYPES] = {0,1,2,2,3,6};
BYTE *ScoreNames[MAX_SCORE_TYPES] = {
	"",
	"AN EXTRA POINT",
	"A 2 POINT CONVERSION",
	"A SAFETY",
	"A FIELD GOAL",
	"A TOUCHDOWN",
};

void UnofficiallyAddScore(WORD teamslotnum, WORD scoretype)
{	// not offical until possible penalty resolved

	// save stuff so CPU can evaluate situation
	PointsThisPlay = PointsTable[scoretype];
	ScoreType = scoretype;	// global for later
	ScoringTeamThisPlay = teamslotnum;
}

/*
void AddScore(WORD teamslotnum, WORD points)
{	// not offical until possible penalty resolved
	// save stuff so CPU can evaluate situation
	PointsThisPlay = points;
	ScoringTeamThisPlay = teamslotnum;
}
*/


BOOL SetPossibleTD(WORD scorer)	// Ball Carrier crossed Goal Line
{	// WARNING - use scorer, NOT BallCarrier (as it might be fumble OOB)
BOOL td = TRUE;		// will be FALSE if Ex PT
EFFVAR teamslot;

//	teamtype = scorer < 11 ? ON_OFFENSE : ON_DEFENSE;
	teamslot = scorer < 11 ? OffensiveSlotNum : DefensiveSlotNum;

	Scorer = scorer;	// global = local

	StopGameClock();	// always stop clock
	NextDown = 0;
//	TheDown = ZERO;
//	FirstDownX = -1;	// clear this for Ex pt.

	if(ANY_EXPT_PLAY)
	{
		if(teamslot == OffensiveSlotNum)	// nothing for def in PRO
		{

			UnofficiallyAddScore(OffensiveSlotNum,CONV_SCORE);	// conversion
//			UpdateStats(scorer,GS_CONV_NUM,1);
			ScoreStat = GS_CONV_NUM;

			InitRefPhrase(GOOD_SFX);
			SetNewRefAnim(GOOD_SFX,AI_REF_TOUCHDOWN_NUM,NO_PENALTY);
			NextPlayType = KICKOFF_PLAY;	// already done at playinit??
			td = FALSE;

//			CameraGuy = scorer;		// Sega bug #349 - not until celebration starts
			SetBit(OPFlags1(scorer),I_SCORED_CONV_BFLAG);	// so he will start dancing later

		}
	}
	else
	{

		if(Q_HumanTeamMacro(teamslot))
		{	// only human team scoring (doesn't go to SB if CPU scores)
				AutoReplayFlag = TRUE;	// show IRP on Scoreboard
		}

		if(HOME_TEAM_SLOT == teamslot)
		{	// home team scored
//-NO-NO 10/31/96	DesiredLeftChannelPercent = 80;	// team 0 on left side
//			SetNewCrowdVolume(MID_CROWD_SFX,SCALED_VOL_PERCENT(70),HALF_SECOND);
			SetNewCrowdVolume(MID_CROWD_SFX,SCALED_VOL_PERCENT(90),SECOND);
			AudioCrowdReaction(YEAH, CROWD_REACT_VOL_HIGH);

			if( (TheQuarter ==2 && GameTeamData[0].TotalScore < 6)	//1st TD??
			   || (TheQuarter == 5)
			   || (TheQuarter ==4 &&
					GameTeamData[0].TotalScore > GameTeamData[1].TotalScore &&
					GameTeamData[0].TotalScore < GameTeamData[1].TotalScore+7 )
			  )
			{
				SetBit(GameFlags,BIG_HOME_TD_BFLAG);
				SetNewCrowdVolume(HIGH_CROWD_SFX,CHL5_VOL,HALF_SECOND);
			}
			else
				SetNewCrowdVolume(HIGH_CROWD_SFX,CHL4_VOL,HALF_SECOND);

				// below added 10/31/96 to make some NOISE!!!
			SetNewCrowdVolume(LOW_CROWD_SFX,SCALED_VOL_PERCENT(75),2*SECOND);

		}
		else	// visitor scored
		{
//-NO-NO 10/31/96	DesiredLeftChannelPercent = 20; // team 1 on right side
//			AIInitSFXLoop2(BOO_LOOP_SFX,SCALED_VOL_PERCENT(50),SECOND);
			AIInitSFXLoop2(BOO_LOOP_SFX,SCALED_VOL_PERCENT(70),SECOND);
			AudioCrowdReaction(SWELL1, CROWD_REACT_VOL_HIGH);

		}

//		EOPSFXPending = TOUCHDOWN_SFX;
//		SetNewRefAnim(-2,AI_REF_TOUCHDOWN_NUM);
		InitRefPhrase(TOUCHDOWN_SFX);
		SetNewRefAnim(TOUCHDOWN_SFX,AI_REF_TOUCHDOWN_NUM,NO_PENALTY);	// -2 means WAIT but don't say anything

		UnofficiallyAddScore(teamslot,TD_SCORE);

		if(teamslot == OffensiveSlotNum)
//		if(teamtype == ON_OFFENSE)	// figure what type of TD
		{
//			Inc3rdor4thDownAttempts();	// if necessary
//			Inc3rdor4thDownMade();	// if necessary

			if(scorer == FumbleRecoverer)	// MUST be 1st in this "if else" conditional
			{                 				// ( in case receiver gets own fumble
				ScoreStat = GS_FUM_TD;
			}
			else if(scorer == KickReturner)
			{
				ScoreStat = GS_KRET_TD;
			}
			else if(scorer == PassCatcher)
			{
//				UpdateStats(Passer,GS_PASS_TD,1);	// QB got 1 TD
				ScoreStat = GS_RECP_TD;	//reception
			}
			else	// better be rushing TD
			{
				ScoreStat = GS_RUSH_TD;
			}
		}
		else	// def scored
		{
			if(scorer == FumbleRecoverer)	// MUST be 1st in this "if else" conditional
			{               	// ( in case interceptor gets own fumble
				ScoreStat = GS_FUM_TD;
			}
			else if(scorer == KickReturner)
			{
				ScoreStat = GS_PRET_TD;	// punt return
			}
			else if(scorer == PassCatcher)	//interception
			{
				ScoreStat = GS_INT_TD;
			}
			else // better be fumble cause I don't know what else it could be
			{
				ScoreStat = GS_FUM_TD;
#if PC_ALWAYS_MODE
				printf("\nIllegal Def. Score type, scorer - %d",scorer);
				getch();
#endif
			}
		}

/****
		if(scorer >= ZERO)
			UpdateStats(scorer,ScoreStat,1);	// they got 1 TD
#if 	PC_ERROR_MODE
		else
			printf("\nIllegal scorer - %d",scorer);
#endif
	 ***/

		NextPlayType = EX_PT1_PLAY;	//assume

		if(teamslot == OffensiveSlotNum)	// nothing for def in PRO
//		if(teamtype == ON_OFFENSE)
		{
			SetInitStartBall(OFF_GOAL_LINE-EXPT_STARTX); // Y = middle of field
		}
		else
		{
			SetInitStartBall(DEF_GOAL_LINE+EXPT_STARTX); // COP will swap
		}

//		CameraGuy = scorer;
		SetBit(OPFlags1(scorer),I_SCORED_A_TD_BFLAG);	// so he will start dancing later

		SetBit1(EventFlags,TD_HAPPENED_BFLAG);
#ifdef SATURNMODE
		InitAnnouncerPhrase(TOUCHDOWN_PHRASE);	// override "gain" phrase
#endif
//		SetBit(GameFlags,EX_PT_PENDING_BFLAG);
	}

//	if(teamtype == ON_DEFENSE)
//		SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP

	return (td);
}



/**********************************************************************

					 S A F E T I E S


**********************************************************************/

void SetSafetyParameters(WORD teamslot)
{
//	EOPSFXPending = SAFETY_SFX;
	InitRefPhrase(SAFETY_SFX);
	SetNewRefAnim(SAFETY_SFX,AI_REF_SAFETY_NUM,NO_PENALTY);
// reinit X as ball will have moved by time ref gets to middle of field

	UnofficiallyAddScore(teamslot,SAFETY_SCORE);	// this team (def. or off) gets two points
	if(Tackler > -1)
		sprintf(PlayInfoText2,"TACKLED BY #%d - %s FOR A SAFETY",
			GetJerseyNum(Tackler),GetPlayerName(Tackler));
	else
		sprintf(PlayInfoText2,"SAFETY");

	SetBit1(EventFlags,SAFETY_HAPPENED_BFLAG);	// to position ball for KO

	NextPlayType = KICKOFF_PLAY;
	if(teamslot == DefensiveSlotNum)		// if Def got safety..
	{
		SetBit(PlayOverFlags,NEED_COP_BFLAG);	// ...then off. kicks off
		SetRefStartX(DEF_GOAL_LINE - 5*YARDS);
	}
	else
	{
		SetRefStartX(OFF_GOAL_LINE - 2*YARDS);
	}
}

// teamtype is team who would get the 2 points
void SetSafetyOrTouchBack(WORD teamslot)
{
	StopGameClock();

	if(teamslot == DefensiveSlotNum)	// off. in or out of EZ
	{
		if(PlayType == KICKOFF_PLAY)
		{
			if(EventFlags.BC_OUT_OF_EZ_BFLAG)
			{
				SetSafetyParameters(teamslot);	// def gets two points
			}
			else
			{	// then touchback - offense gets ball on the 20
				SetInitStartBall(DEF_GOAL_LINE+20*YARDS);

				NextDown = 1;
				StartNewDrive = TRUE;

//				SetNewFirstDown(TRUE);
				sprintf(PlayInfoText2,"TOUCHBACK");
			}

		}
		else		// non- kickoff - it's a safety on offense
		{
//			FigureYardsGained(DEF_GOAL_LINE,ON_OFFENSE);	// off. lost some yards
			SetSafetyParameters(teamslot);	// def gets two points
		}
	}
	else //if(teamtype == ON_OFFENSE)	// def has ball, must be punt or T.O
	{
		if(EventFlags.DEF_BC_OUT_OF_EZ_BFLAG)
		{	// if def was ever in field of play and now in his EZ
			SetSafetyParameters(teamslot);	// off gets two points
		}
		else		// touchback on punt or init
		{
			SetInitStartBall(OFF_GOAL_LINE-20*YARDS);	//COP will switch
			SetBit(PlayOverFlags,NEED_COP_BFLAG);	// for final cleanup @ EOP
			sprintf(PlayInfoText2,"TOUCHBACK");
		}
	}
}



/************************************************************************


						 C L O C K S

		Starting, Stopping, Pausing, Etc.

	WARNING: "pause" is initiated by human pressing pause button
			"freeze" is initiated by CPU control (e.g. freezing clock
				after offense has slected it's play)

			" start" and "stop" game clock are invoked by AI.

	NOTE: as of 7/10/96 we use accelerated clock

************************************************************************/

//#define PLAY_TIMER_NUM	DPC_TIMER_NUM

void StartGameClock(void)
{
	if(!PracticeMode)	// fixes bug #2777
	{
		StartVBlankTimer(GAME_TIMER_NUM);
		SetBit(GameFlags,GAME_TIMER_ON_BFLAG);
	}
}

BOOL GameClockRunning(void)	// a Question
{

	return(GameFlags & GAME_TIMER_ON_BFLAG);

}

void StopGameClock(void)
{

	StopVBlankTimer(GAME_TIMER_NUM);
//	StopVBlankTimer(PLAY_TIMER_NUM);		// just for the heck of it
	ResetBit(GameFlags,GAME_TIMER_ON_BFLAG);

}


void StartPlayClock(void) 	// called at beginning of play call
{
//	if(PlayType != KICKOFF_PLAY)	// no delay of game on kick offs
	SetBit(GameFlags,PLAY_TIMER_ON_BFLAG);

	if(!(GameFlags & PAUSE_ACTIVATED_BFLAG))	// if PCallScreen reloaded during PAUSE
	{
		StartVBlankTimer(PLAY_TIMER_NUM);
//		SetBit(GameFlags,PLAY_TIMER_ON_BFLAG);
	}
}


void StopPlayClock(void)    // called when ballsnapped to stop it
{							// or if delay penalty
	StopVBlankTimer(PLAY_TIMER_NUM);
	ResetBit(GameFlags,PLAY_TIMER_ON_BFLAG);
}

void InitPlayClock(void)	// called at beginning of play call NO NO
{
// this should only INIT the clock, not start it
	if(ANY_EXPT_PLAY)
		SetVBlankTimer(PLAY_TIMER_NUM,PAT_PLAY_CLOCK_TICKS);	//25?
	else
		SetVBlankTimer(PLAY_TIMER_NUM,INITIAL_PLAY_CLOCK_TICKS); //40?
//	SetVBlankTimer(PLAY_TIMER_NUM,5*60);	// test only
//	if(PlayType != KICKOFF_PLAY)
//		StartPlayClock();		// to play clock on K.O
}


void PauseAllClocks(void)
{

	SetBit(GameFlags,PAUSE_ACTIVATED_BFLAG);

	StopVBlankTimer(GAME_TIMER_NUM);
	StopVBlankTimer(PLAY_TIMER_NUM);

}


void FreezeAllClocks(void)
{
	SetBit(GameFlags,FREEZE_ACTIVATED_BFLAG);

	StopVBlankTimer(GAME_TIMER_NUM);
	StopVBlankTimer(PLAY_TIMER_NUM);

}


void UnPauseAllClocks(void)
{
	ResetBit(GameFlags,PAUSE_ACTIVATED_BFLAG);

	if( !(GameFlags & FREEZE_ACTIVATED_BFLAG))	// if not FROZEN
	{
		if(GameFlags & PLAY_TIMER_ON_BFLAG)
			StartVBlankTimer(PLAY_TIMER_NUM);

		if(GameFlags & GAME_TIMER_ON_BFLAG)
			StartVBlankTimer(GAME_TIMER_NUM);
	}
}


void UnFreezeAllClocks(void)
{
	ResetBit(GameFlags,FREEZE_ACTIVATED_BFLAG);

	if( !(GameFlags & PAUSE_ACTIVATED_BFLAG))	// if not PAUSEd
	{
		if(GameFlags & PLAY_TIMER_ON_BFLAG)
			StartVBlankTimer(PLAY_TIMER_NUM);

		if(GameFlags & GAME_TIMER_ON_BFLAG)
			StartVBlankTimer(GAME_TIMER_NUM);
	}
}


void IncTimeOfPossession(void)	// called once per AI frame
{
	if(  GameFlags & GAME_TIMER_ON_BFLAG
		&& (!(GameFlags&PAUSE_ACTIVATED_BFLAG))
		&& (!(GameFlags&FREEZE_ACTIVATED_BFLAG))	// going to LOS time
	  )
	{
		if(GetVBlankTimer(GAME_TIMER_NUM) != 0L)	// timed out
		{
			TimeOfPoss[OffensiveSlotNum] += TICKS_PER_AI_FRAME;

			DriveTime  += TICKS_PER_AI_FRAME;

		}
	}
}
/*
void UpdateTeamsTimeOfPossession(void)
{	// both teams - to make it exact, base TOP on Away team


	StatsData[1].allplyrstats[GS_TOP] =		//TOP in seconds
				 TimeOfPoss[1]/CLOCKS_TICKS_PER_SECOND;

	StatsData[0].allplyrstats[GS_TOP] =

		( (TheQuarter *
		   QuarterTimes[GameOptions[GAME_OPTNS_QTR_LENGTH]]/CLOCKS_TICKS_PER_SECOND)
			- SecondsLeftInQuarter())	// this is time so far
		-	StatsData[1].allplyrstats[GS_TOP]; // minus other teams TOP
}
*/


/***  not needed with 5 receivers
void CPUToggle3rdReceiver(void)
{
	if (++ToggledReceiver > 4)
		ToggledReceiver = 2;
	Receivers[2] = PosReceivers[ToggledReceiver];
}
****/

/**********************************************************************

				 P L A Y      S T A T E    H A N D L E R

	Just like the Players, the PLAY is also made up of STATES
	Many of the player STATES, especially before the snap, do checks
	on the playstate to see when they should start to do something -
	e.g. man-in-motion starts at PS_SAYSET.

**********************************************************************/

/*
void GoToNextPlayState(void)		// a playstate subroutine
{
	  PlayStateFlags = ZERO;
	  PlayStateNum++;
}

 a subroutine called by all Play State Wait States
	RETURNS: TRUE if time out occured
BOOL PlayStateWait(WORD seconds)
{
	if(PlayStateFlags == ZERO)
	{
		PlayStateFlags = 1;
		AIPlayTimerWait = AIPlayTimer + seconds;	// init timer
	}
	else if(AIPlayTimer >= AIPlayTimerWait)	// wait a bit before initing Shift
	{
		GoToNextPlayState();
		return(TRUE);
	}

	return(FALSE);

}

*/


/* a subroutine called by all Play State Wait States
	RETURNS: TRUE if time out occured	*/
BOOL PlayStateWait(WORD seconds, WORD newplaystate)
{
	if(PlayStateFlags == ZERO)
	{
		PlayStateFlags = 1;
		AIPlayTimerWait = AIPlayTimer + seconds;	// init timer
	}
	else if(AIPlayTimer >= AIPlayTimerWait)
	{
//		GoToNextPlayState();
		SetPlayState(newplaystate);
		return(TRUE);
	}

	return(FALSE);

}



void SetPlayState(WORD PStateNum)	//could be used anywhere
{
	  PlayStateFlags = ZERO;
	  PlayStateNum = PStateNum;
}




void StartPlayAI(void)
{ 	// called once both teams have selected their play (by Play Calling module)

	PlayCallStatus = BOTH_PLAYS_CALLED;
//	SetPlayCallStatus(BOTH_PLAYS_CALLED);
}

BOOL OkayToStartPlayCall(void)
{ 	// called by PlayCall Screen to see if time to init
	// returns TRUE (non-zero) if okay for play call screen to start
	return(PlayCallStatus >= OKAY_TO_START_PLAYCALL);

}


BOOL OkayToLoadPlayCall(void)
{ 	// called by PlayCall Screen to see if time to init
	// returns TRUE (non-zero) if okay for play call screen to start
	return(PlayCallStatus >= OKAY_TO_LOAD_PLAYCALL_DATA);

}


BOOL AbortPlayCalling(void)
{
	return(PlayCallStatus <= ABORT_PLAYCALL_SCREEN);

}


WORD AIIsStalled(void)	// actually more of a Boolean
{
EFFVAR rv = ZERO;		// means not stalled

	if( (GameFlags & AI_STALLED_BFLAG)		//flag cleared by graphic engine
	   && (PlayCallStatus <= PLAYCALL_STALLED) )
			rv = PlayCallStatus;
	return(rv);
}


#if 0
BOOL PlayCompleted(void) // returns TRUE when Play completely over
{
	return (PlayStateNum >= PS_PlayOverNUM;
);
}
#endif

BOOL PlayHappening(void) // returns TRUE if Play is happening
{
	return(PlayStateNum == PS_PlayHappeningNUM);
}


void AnimationsLoaded(void)
{
	SetBit(InterfaceFlags,AMINS_LOADED_BFLAG);
}

void AnimationsNotLoaded(void)
{
	ResetBit(InterfaceFlags,AMINS_LOADED_BFLAG);
}


void CameraOnScoreBoard(void)
{	// encapsulation for graphic engine
	SetBit(InterfaceFlags,FIELD_NOT_VIEWABLE_BFLAG);
}

WORD OkToDisplayAITextInfo(void)
{	// encapsulation for graphic engine
	return( (PlayFlags & OK_TO_DISPLAY_AITEXT_BFLAG)
			&& (PlayInfoText1[0] != '\0'
				|| PlayInfoText0[0] != '\0'
				|| PlayInfoText2[0] != '\0')
		  );
}

void DontDisplayAITextInfo(void)
{	// encapsulation for graphic engine
	ResetBit(PlayFlags,OK_TO_DISPLAY_AITEXT_BFLAG);
}

void DisplayAITextInfo(void)
{	// encapsulation for graphic engine
	if(!PracticeMode)
		SetBit(PlayFlags,OK_TO_DISPLAY_AITEXT_BFLAG);
}

void ResetPlayCallInit(void)	// called by AI engine
{
	ResetBit(GameFlags,PLAY_CALL_INITED);
}

void PlayCallIsInited(void)		// called by Play Call
{
	ResetBit(GameFlags,PLAY_CALL_INITED);
}

BOOL HasPlayCallBeenInited(void)		// called by Play Call
{
	return(GameFlags & PLAY_CALL_INITED);
}

/*----------------------------------------------------------------------*/

void PreSnapTextDisplay(void)
{
EFFVAR atts, made;
BYTE *who;
ULONG secs;
EFFVAR pnum,yards;

	who = GameTeamData[OffensiveSlotNum].STD.TeamNickName;	// e.g "Jets"
	atts = StatsData[OffensiveSlotNum].allplyrstats[GS_3RDDOWNS_ATT];
	if(TheDown == 3  &&  atts > ZERO)
	{
		made = StatsData[OffensiveSlotNum].allplyrstats[GS_3RDDOWNS_MADE];

		sprintf(PlayInfoText1,"%s - THIRD DOWN EFFICIENCY - %d / %d",who,made,atts);
	}
	else if(TheDown == 4 && GameTeamData[OffensiveSlotNum].PlayNum < SpecialTeamsFakeFGRunNUM)
	{	// they're going for it
		atts = StatsData[OffensiveSlotNum].allplyrstats[GS_4THDOWNS_ATT];
		made = StatsData[OffensiveSlotNum].allplyrstats[GS_4THDOWNS_MADE];

		sprintf(PlayInfoText1,"%s - FOURTH DOWN EFFICIENCY - %d / %d",who,made,atts);
	}
	else if(PlayFlags & POS_PUNT_NOPOOCH_PLAY_BFLAG) // punt
	{
		if(KickerSlot != NOBODY)
		{
			pnum = OPMyPNum(KickerSlot);

			if( (atts = GetPlayerGameStats(OffensiveSlotNum,pnum,GS_PUNT)) > ZERO)
			{
				yards = GetPlayerGameStats(OffensiveSlotNum,pnum,GS_PUNT_YARDS);
				sprintf(PlayInfoText1,"#%d - %s",GetJerseyNum(KickerSlot),GetPlayerName(KickerSlot));

				if( (made = GetPlayerGameStats(OffensiveSlotNum,pnum,GS_PUNT_IN20)) > ZERO)
				{
					sprintf(PlayInfoText2,"PUNTS-%d  AVER.-%d.%d  LNG-%d  INSIDE 20-%d",
					atts,	yards/atts,
					((yards%atts)*10)/atts,
					GetPlayerGameStats(OffensiveSlotNum,pnum,GS_PUNT_LONG),
					made);
				}
				else
				{
					sprintf(PlayInfoText2,"PUNTS - %d   AVER. - %d.%d   LNG - %d",
					atts,	yards/atts,
					((yards%atts)*10)/atts,
					GetPlayerGameStats(OffensiveSlotNum,pnum,GS_PUNT_LONG));
				}
			}

		}
	}
	else if(ANY_EXPT_PLAY)
	{
		if(NumPlaysInDrive > ZERO)	// screen out punt/int/KO returns
		{
			secs = DriveTime/CLOCKS_TICKS_PER_SECOND;
			sprintf(PlayInfoText1,"%s - DRIVE SUMMARY",GameTeamData[OffensiveSlotNum].STD.TeamNickName);
			sprintf(PlayInfoText2,"PLAYS - %d      YARDS - %d     TIME - %ld:%02ld",
				NumPlaysInDrive,((OFF_GOAL_LINE-StartDriveX)>>YARD_SHIFT),
				secs/60,secs%60
				);

		}
	}
	else if(PlayFlags & POS_FG_PLAY_BFLAG)	// MUST be after EX_PT check
	{
		if(KickerSlot != NOBODY)
		{
			pnum = OPMyPNum(KickerSlot);

			if( (atts = GetPlayerGameStats(OffensiveSlotNum,pnum,GS_FG_ATT)) > ZERO)
			{
				sprintf(PlayInfoText1,"#%d - %s",GetJerseyNum(KickerSlot),GetPlayerName(KickerSlot));

				if( (made = GetPlayerGameStats(OffensiveSlotNum,pnum,GS_FG)) > ZERO)
				{
					sprintf(PlayInfoText2,"FIELD GOALS - %d / %d    LONG - %d",
					made,atts,
					GetPlayerGameStats(OffensiveSlotNum,pnum,GS_FG_LONG));
				}
				else
				{
					sprintf(PlayInfoText2,"FIELD GOALS - %d / %d",
					made,atts);
				}
			}

		}

	}

#ifdef SATURNMODE
//	else if (
//		sprintf(PlayInfoText1,"SEGA welcomes you to New Orleans");
#endif

	DisplayAITextInfo();	//just sets flag - graphic engine must display
	#if PC_ALWAYS_MODE
		PCPrintAIText();	// PC graphic engine displays
	#endif
//	SetBit(PlayFlags,OK_TO_DISPLAY_AITEXT_BFLAG);
}

#define DefDummyGL		DefEaster0NUM
#define DefDummy43		DefEaster1NUM
#define DefDummy34		DefEaster2NUM
#define DefDummyNickel	DefEaster3NUM
#define DefDummyDime	DefEaster4NUM



/*----------------------------------------------------------------------
   following array used to determine what defensive play to use
	against a PRACTICE offensive play based on [sequential positional]
	offensive formation (index1).
	index 2 is based on PracticMode type, where PMode 1= "dead" defense,
	and PMode 2 = actual defensive play
----------------------------------------------------------------------*/
WORD PracticeDummyPlays[21][2] = {

DefDummyGL,DefGoalLineShadowBackfieldNUM,	//GOAL_LINE_FORM_NUM,0)
DefDummy34,Def34StraightUpManNUM,	//WISH_BONE_FORM_NUM,1)
DefDummy43,Def43ManToManNUM,		//POWER_I_FORM_NUM,2)
DefDummy34,Def34StraightUpManNUM,	//NEAR_FAR_FORM_NUM,VEER,,3)
DefDummy34,Def34StraightUpManNUM,	//I_SLOT_FORM_NUM,I SLOT,,4)

DefDummy43,Def43ManToManNUM,		//SINGLE_BACK_FORM_NUM,ONE BACK,,5)
DefDummy43,Def43ManToManNUM,		//H_BACK_FORM_NUM,H BACK,,6)
DefDummy43,Def43ManToManNUM,		//I_FORM_FORM_NUM,I FORM,,7)
DefDummy43,Def43ManToManNUM,		//PROSET_FORM_NUM,PRO SET,,8)
DefDummyDime,DefDimeDimeManNUM,		//WEST_COAST_FORM_NUM,W COAST,,9)

DefDummyNickel,DefNickelNickelManNUM,	//SHOTGUN_FORM_NUM,SHOTGUN,,10)
DefDummyDime,DefDimeDimeManNUM,			//TRIPS_FORM_NUM,TRIPS,,11)
DefDummyDime,DefDimeDimeManNUM,			//RUN_SHOOT_FORM,,,12)
DefDummyGL,DefGoalLineShadowBackfieldNUM,	//GOAL_LINE_FORM_NUM,G.L. NO WR,,13)
DefDummyGL,DefGoalLineShadowBackfieldNUM,	//GOAL_LINE_FORM_NUM,GOAL LINE T,,14)

DefDummy43,Def43ManToManNUM,			//POWER_I_FORM_NUM, POWER I WEAK,,15)
DefDummy43,Def43ManToManNUM,			//NEAR_FAR_FORM_NUM,VEER 2,,16)
DefDummyNickel,DefNickelNickelManNUM,	//SHOTGUN_FORM_NUM, SHOT GUN TE,,17)
DefDummyGL,DefGoalLineShadowBackfieldNUM,	//QB_KNEEL_FORM,X,,18)
DefDummyGL,DefSpecialPuntBlockNUM,		//PUNT_FORM,,19)
DefDummyGL,DefSpecial11ManRushNUM		//FIELD_GOAL_FORM,20)
};


#define NUM_WHISTLE_SFX 4
WORD WhistleTable[NUM_WHISTLE_SFX] = {
	WHISTLE2_SFX,  	// longest 	"tweeeeeeeeeeeeeet"
	WHISTLE_SFX,    // 			"tweeeeeeeeeeet"
	WHISTLE1_SFX,   // 			"tweeet"
	WHISTLE3_SFX	// shortest	"tweet"   (high pitch)
};


void BlowWhistle(WORD num)	// will play 0,1,or 2 whistles
{			// num = 1 or 3 means ALWAYS do at least one
WORD rnum;

	rnum = rand()&WHISTLE_MASK;	// WHISTLE_MASK is platform specific
	if(num > 0 && num < NUM_WHISTLE_SFX)
	{ 	// should be 1 or 3	- always play one- use parameter as mask
		SetVoiceVolume(AIPlayEffect(WhistleTable[rnum&num]),64+rnum,64-rnum);
	}
	else if(rnum&0x08)	//randomly play one
	{	// different volume for L/R channels
//		SetVoiceVolume(AIPlayEffect(WhistleTable[rnum&(NUM_WHISTLE_SFX-1)]),64+rnum,64-rnum);
		SetVoiceVolume(AIPlayEffect(WhistleTable[rnum&1]),64+rnum,64-rnum);
	}

/*
	// 50% time play another one
	rnum = rand()&WHISTLE_MASK;	// WHISTLE_MASK is platform specific
	if( (rnum&0x08) == 0x08)	// 50% of time do another
	{
		SetVoiceVolume(AIPlayEffect(WhistleTable[rnum&(NUM_WHISTLE_SFX-1)]),64+rnum,64-rnum);
	}
*/
}


void SetPuntReturnGuy(void)
{	// used in PS_CheckAtLOS or at Punt if PoochKick
EFFVAR temp;

	temp = gPNum;
	// send somebody back on Punt
	PosPuntReturner = gPNum =
		 GameTeamData[DefensiveSlotNum].FormationNumber ==
					 DEF_GOALINE_FORM_NUM ? 11 : 20;

	SetNewScript(PuntReturnerScriptNUM);
	SetBit(CPFlags,IM_PUNT_RETURNER_BFLAG);
	No_Back_Pedal_Macro;

	gPNum = temp;
}


#define NOW	ZERO	// # of ticks

void GetPlayerUpAfterPlay(EFFVAR time)
{

	if( CPAction ==	FreezeActionOnGround
		|| CPAction == DiveAction
		|| (CPFlags & IM_LYING_ON_GROUND_BFLAG)
	  )
	{
		CPTimer = time;
		if(gPNum == LastBallCarrier)
		{
			CPTimer += QUARTER_SECOND;
		}
		CPAction = DelayedGetUpAction;
	}
}




void ImplementNoHuddle(void)
{
	if(MoreEventFlags & NEED_NO_HUDDLE_BFLAG)
	{
		ResetBit(MoreEventFlags,NEED_NO_HUDDLE_BFLAG);

		SetBit1(EventFlags,IRP_INITED_BFLAG);  // means don't save anymore
		PlayCallStatus = BOTH_PLAYS_CALLED;
		InitPlayClock();	// sets clock to MAX but DOES NOT START it
		SetPlayState(PS_WaitForPlayStartNUM);	//ALWAYS force it, don't GoToNextPS
	}
}


/************************************************************************



						PLAY	STATES

	Just like the Players, the PLAY is also made up of STATES
	Many of the player STATES, especially before the snap, do checks
	on the playstate to see when they should start to do something -
	e.g. man-in-motion starts at PS_SAYSET.


*************************************************************************/

#define PLAYSTATE(xxx)	void xxx(void)


PLAYSTATE(PS_WaitForPlayStart)	// players will NOT do normal scripts
{
EFFVAR offform, playnum;

	if(PlayCallStatus == BOTH_PLAYS_CALLED)	// both plays have been selected
	{
		if(PracticeMode)
		{	// StartX could have been changed during play calling??

			if( (playnum = GameTeamData[OffensiveSlotNum].PlayNum)
					==	SpecialTeamsFieldGoalNUM)
				PracticeStartBallX = OFF_GOAL_LINE-30*YARDS;
			else
				PracticeStartBallX = DEFAULT_PRACTICE_START_X;

			InitPracticePlay();

			/* chose an appropriate defensive play */
			offform = ThePlays[playnum].FormationNumber;

			if( (offform =  SequentialOffFormIndex[offform]) == -1)
				offform = 1;		// if error, fake it
			GameTeamData[DefensiveSlotNum].PlayNum =
						 PracticeDummyPlays[offform][PracticeMode-1];
		}



		InitAI(TRUE);		// set player parameters for off. & def. plays
		InitIRPPrePlay();

		if( GetVBlankTimer(PLAY_TIMER_NUM) < 10 * CLOCKS_TICKS_PER_SECOND)
		{	// only say if little time left
			AIPlayEffectCheck(BREAK_SFX);
		}
//		GoToNextPlayState();
		SetPlayState(PS_HuddleToLOSNUM);	//ALWAYS force it, don't GoToNextPS

	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_HuddleToLOS)
{
//	if(PlayType != KICKOFF_PLAY)
//		SetBit1(EventFlags,OK_FOR_HUMAN_DEF_CONTROL_BFLAG);

	/* need to wait here a bit so Saturn Graphic engine(camera) can
	"latch on" to this state to init camera movement - there was a problem
	if calling consecutive "DoAI"s - (no effect on PSX		*/
	if(PlayStateWait(10,PS_CheckAtLOSNUM))	// 1/6 of a second, then next P.State
	{
#ifdef SATURNMODE
	// no Background loading on Saturn so start clock now
		UnFreezeAllClocks();
#endif
		PreSnapTextDisplay();	// if needed

		//moved after wait - bug #2978
		if(PlayType != KICKOFF_PLAY)
			SetBit1(EventFlags,OK_FOR_HUMAN_DEF_CONTROL_BFLAG);
	}



}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_CheckAtLOS)
{ 	// all Offensive players made it to L.O.S.???

	gPNum=0;

	while(CPTargetX == CPXPos && CPTargetY == CPYPos && gPNum < 11)
		gPNum++;

	 //bug # 1665 -must start punt returner NOW not @ DEFshift
	if( (GameTeamData[OffensiveSlotNum].FormationNumber == PUNT_FORM_NUM)
		&& (gPNum > ZERO)		// when punter is ready
		&& !PlayStateFlags		// only do once
	  )
	{
		SetPuntReturnGuy();
		PlayStateFlags = TRUE;

	}

	if(gPNum == 11)
	{
//		InitKickInterfaceVars();	// if necessary
//		GoToNextPlayState();
		SetPlayState(PS_Wait1NUM);	//ALWAYS force it, don't GoToNextPS
		InitAtLOSAudio();
	}


}

void OffenseKOShift(void);

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait1)
{	/* short wait state after reaching LOS until "ready" */


	if(PlayType == KICKOFF_PLAY)
	{	/* on KO, Def human Control only AFTER ball in air
		 (done in Kickers STATE in file FBMove.c)		*/
		if(InterfaceFlags & AMINS_LOADED_BFLAG)
		{
			UnFreezeAllClocks();
			for(gPNum = 0; gPNum <11; gPNum++)
				InitGraphics(AI_2PTSTANCE_NUM);

			OffenseKOShift();	// if necessary

			SetPlayState(PS_Say1stHutNUM);
		}
	}
	else
	{
		PlayStateWait(QUARTER_SECOND,PS_InitPlayShiftNUM);	// re-entrant - go to next PS_ when timeout
//		SetBit(EventFlags,OK_FOR_HUMAN_DEF_CONTROL_BFLAG);
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_InitPlayShift)
{	// start any shifts, motion   QB -> "Ready...."

	// Stay in this playSTATE unitl animations are loaded

	if(InterfaceFlags & AMINS_LOADED_BFLAG)	// set by graphic engine
	{
		UnFreezeAllClocks();

//		SetBit(EventFlags,OK_FOR_HUMAN_DEF_CONTROL_BFLAG);
//		Reset(InterfaceFlags & AMINS_LOADED_BFLAG)

		for(gPNum = 1; gPNum <11; gPNum++)		// all linemen
		{	/* anybody in "box" near LOS goes into 3 point stance	*/
			 if((CPYPos	< StartBallY+6*YARD+1)	// inside TEs???
			  &&(CPYPos > StartBallY-6*YARD-1)  )
			{
				if(	CPXPos > StartBallX-5*YARD-1)
					CPAction = GoTo3PtStanceInitAction;
				else //if ( CPMyPosition == HB)	comment now includes fg kicker
				{
					InitGraphics(AI_2PTSTANCE_NUM);
					if ( CPMyFormPosition == KICKER)
						CPFacing = SE_DIR;
				}
	//    below FB stuff is taken into acount by the above "box"
	//			else if ( CPMyFormPosition == FB)
	//			{
	//			   if(GameTeamData[OffensiveSlotNum].FormationNumber
	//					 == GOAL_LINE_FORM_NUM)
	//					CPAction = GoTo3PtStanceInitAction;
	//			   else
	//					InitGraphics(AI_2PTSTANCE_NUM);
	//			}
			}
			else	// must be receivers
			{
				InitGraphics(AI_RECEIVERSTANCE_NUM);
				if(CPYPos < MID_FIELDY)
					CPFacing = SE_DIR;	// forces flip to look in to center of field
			}

		}

		gPNum = 0;		// QB, punter get ready
		if( !(CPFlags1 & IM_HOLDER_BFLAG))	// but not FG holder
		{
			if(CPXPos < StartBallX-3*YARDS)	// shotgun???
				InitGraphics(AI_2PTSTANCE_NUM);
			else
			{
				InitQBCallPlays();	// turns QB head side to side
			}

		}

		InitDefensePreSnapShift();

		AIPlayQBSFX(READY_SFX);
//		AIPlayEffectCheck(READY_SFX);		/* say "Ready"	*/

//		GoToNextPlayState();
		SetPlayState(PS_Wait2NUM);	//ALWAYS force it, don't GoToNextPS

	}


 }

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait2)	/* wait while "ready" is verbalized */
{
	PlayStateWait(HALF_SECOND,PS_SaySetNUM);	// was SECOND
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_SaySet)
{	// QB starts his thing
		AIPlayQBSFX(SET_SFX);
//		AIPlayEffectCheck(SET_SFX);
//		GoToNextPlayState();
		SetPlayState(PS_Wait3NUM);	//ALWAYS force it, don't GoToNextPS

}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait3)	/* wait while "set" is verbalized */
{
	PlayStateWait(HALF_SECOND,PS_Say1stHutNUM);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Say1stHut)		/*  in this or any state after this it's okay to hike */
{	// few seconds later, more QB stuff
EFFVAR i;
register EFFVAR x,lowy,highy;

	if(BallSnapped)
	{	//NEVER gets here - SetBallSnapped forces PlayHAppening
//		AIPlayEffectCheck(HIKE_SFX);
//		GoToNextPlayState();

	}
	else
	{
		x = StartBallX - HALF_YARD;
		lowy = StartBallY - 4*YARD;
		highy = StartBallY + 4*YARD;

		for(i=11; i < 22; i++)	// bug # 1596 - arrrggghhh!!!
		{	// defender in "unabated" path to QB
			if( (OPXPos(i) < x)
			  && (OPYPos(i) > lowy)
			  && (OPYPos(i) < highy)
			  )
			{
//				SetDefOffsides();	// will set PlaySTATE to end PlayOver
//				return;
			}
		}


		if(PlayStateFlags == ZERO)
		{
			PlayStateFlags = 1;
			SetBit(GameTeamData[OffensiveSlotNum].TeamFlags,OKAY_TO_SAY_HUT_BFLAG);
			AIPlayTimerWait = AIPlayTimer; 	//triggers below for 1st "HUT"

			/* init CPU when to hike	*/
#if	PC_ALWAYS_MODE
			if(CPUDebugHike)	// forced set by mjk - saves compile time
				CPUPlayTimerWait = AIPlayTimer + HALF_SECOND + (rand()&0x007f);
			else
				CPUPlayTimerWait = 0xffff;	//test only - CPU doesn't hike
#else
			CPUPlayTimerWait = AIPlayTimer + HALF_SECOND + (rand()&0x007f);
#endif
		}

		if( PlayType != KICKOFF_PLAY)
		{
			if(!(GameTeamData[OffensiveSlotNum].TeamFlags & NO_MORE_CPU_SAY_HUT_BFLAG))
			{
				if(OffAudibleIsActive())
				{
					HandleAudibleAudio();
				}
				else if (AIPlayTimer >= AIPlayTimerWait) /* wait a bit before other "HUTS" */
				{
					AIPlayQBSFX(HUT_SFX);
//					AIPlayEffectCheck(HUT_SFX);	// CPU only
				 /*  now set random time for next hut  (1/4 to 1 1/4 second)	*/
					AIPlayTimerWait = AIPlayTimer + HALF_SECOND + (rand()&0x003f);
				}
			}
			//else	- human hut done in handlecontrollers


		}

		/* see if time for CPU team to hike	*/
		if( Q_CPUTeamMacro(PlayType == KICKOFF_PLAY? DefensiveSlotNum:OffensiveSlotNum))
		{	// this is a CPU team
	/***  NO CPU QB toggling with 5 receivers
			if(PlayType != KICKOFF_PLAY && Receivers[2] != PrimaryReceiver)
			{
//				if( (rand()&0x7f) == ZERO)	 this was too long
				if( ((rand()&0x1f) == ZERO)
					|| (OPFlags1(Receivers[2]) & IM_A_BLOCKER_BFLAG)
				  )
				{
					CPUToggle3rdReceiver();
					// must check 3 times or else Punt play toggles forever
					if(OPFlags1(Receivers[2]) & IM_A_BLOCKER_BFLAG)
					{ // if new guy is a blocker...
						CPUToggle3rdReceiver();    // go to other guy
						if(OPFlags1(Receivers[2]) & IM_A_BLOCKER_BFLAG)
						{ // if this guy is a blocker...
							CPUToggle3rdReceiver();     // back to original
						}
					}
				}
			}	end NO CPU QB toggling with 5 receivers*******/

			if(AIPlayTimer >= CPUPlayTimerWait)
				SetBallSnapped();

		}
	}
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_PlayHappening)	/*   the Main Play State - check to see if over */
{	// it's happening

	if(CheckForPlayOver())		// this is a monster
	{

		if(PlayType == KICKOFF_PLAY)
		{
			StopGameClock();
		}

		ResetBit(GameFlags,EX_PT_PENDING_BFLAG | FREE_KICK_BFLAG);	//always clear when any play over

		if(EventFlags.TD_HAPPENED_BFLAG)
		{
			SetBit(GameFlags,EX_PT_PENDING_BFLAG);	//needed if time ran out
		}

		/* handshaking to keep track of onside OOB or Illegal touch	*/
		if(MoreEventFlags & ILLEGAL_KICK_BFLAG)
			IllegalKickCount++;
		else
			IllegalKickCount = ZERO;


		if(PlayOverFlags & NEED_COP_BFLAG)
		{
			NextOffTeam = DefensiveSlotNum;
		}

		if(BallCarrier >= ZERO)
		{  // leave ball where it's at, don't show, no BallCarrier = Zero
			PenaltyBallCarrier = BallCarrier;	// used for fouls later
			SetBallAction(BallAfterTackle);
		}
		ClearReceivers();	// fixes bug #1711?
		SetPlayState(PS_PlayOverNUM);

		UpdateMiscStats();  // QB ratings, score per quarter

//		HandlePlayOverPlayType(); here or after officially over???

//		AIPlayEffectCheck(WHISTLE_SFX);
	}
	else	// play is still happening
	{
		SetBit(MoreEventFlags,OKAY_FOR_STATS_BFLAG);


		if(EventFlags.FIRST_HIT_BFLAG )
		{
			PlayBlockingSounds();
		}
//		if( ( (rand()&7) == ZERO) && (EventFlags & FIRST_HIT_BFLAG) )
//		{
//			AIPlayEffectCheck(Grunts[rand()&15]);
//		}
	}
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// PO1 - Play over State ------------------------------------------

#define CLOSE_TO_GP	(16*YARDS)	//was 20 yards

PLAYSTATE(PS_PlayOver)	/*  a momentary Play STATE	*/
{
 /* just ended (tackle, TD, etc.)	OR forced here by DelayofGame, EOQ  */
/*  Every Play (even if aborted by Delay) MUST go through here	*/


	SetBit(PlayOverFlags,OKAY_TO_GO_OOB_BFLAG);	// everybody can go OOB

	CheckForPenaltyPart1();	// if necessary


	if(BallCarrier >= ZERO)
	  // leave ball where it's at, don't show, no BC
		SetBallAction(BallAfterTackle);
//	BallCarrier = NOBODY;

	PlayCallStatus = ABORT_PLAYCALL_SCREEN;	// abort PlayCall (if Delay or EOQ)
	ResetPlayCallInit();	// re-init entire play calling
	TurnOffKickInterface();		//make sure off if EOQ or Delay
	BCStopClock = FALSE;


	if(GameFlags & NEED_2MIN_WARNING_BFLAG)
	{ 	// in case it happened during play
		StopGameClock();
		StopPlayClock();
	}


	if(PracticeMode)	// pretend nothing happened -Normal stuff
	{
		ResetBit(PlayOverFlags,NEED_COP_BFLAG);
		ResetBit(GameFlags,EX_PT_PENDING_BFLAG);
		PlayType = NextPlayType = NORMAL_PLAY;
		InitPracticePlay();
	}

	// below in case delay or offsides
	ResetPreSnapStuff();	// called if BallSnapped AND at PlayOver(to cover delay)

	BlowWhistle(1);	//1 means do at least 1 long whistle
//	AIPlayEffectCheck(WHISTLE_SFX);

	for(gPNum = 0; gPNum <22; gPNum++)
	{
		if( (QuarterHasEnded() || (PlayOverFlags & NEED_COP_BFLAG)
				|| (EventFlags.SAFETY_HAPPENED_BFLAG) )  	// covers safety on def.
		   && (!(GameFlags & EX_PT_PENDING_BFLAG))	//timing could be improved here
		   && (!PracticeMode)
		 )
		{
			SetNewScript(QuarterEndedScriptNUM);	// go to sidelines
		}
		else if( ((CPFlags1 & I_SCORED_A_TD_BFLAG) || (CPFlags1 & I_SCORED_CONV_BFLAG))
//				 && (!(CPFlags & IM_LYING_ON_GROUND_BFLAG))
				 )
		{

//			ResetBit(CPFlags,I_SCORED_TD_BFLAG);
			ResetBit(CPFlags1,(I_SCORED_CONV_BFLAG | I_SCORED_A_TD_BFLAG));
			// be sure we see celebrate - no human override - Bug # 2311
			ResetBit1(EventFlags,OK_FOR_HUMAN_OFF_CONTROL_BFLAG);
			ResetBit(CPFlags,IS_HCONTROLLED_BFLAG);	// TD guy not human controlled

			if(!(CPFlags & IM_LYING_ON_GROUND_BFLAG))
			{	// only celebrate if not lying on ground
				CameraGuy = gPNum;	// should have already happened -NO,NO - MUST BE HERE

				if( gPNum < 6 && gPNum > 0	// only rec, RBs
				  && (GameFlags & BIG_HOME_TD_BFLAG)
				  && CPYPos > MID_FIELDY - CLOSE_TO_GP	// must be "close" to post
				  && CPYPos < MID_FIELDY + CLOSE_TO_GP	// or BallPreSnap screws it up
				  )									// after spike
				{		// only key offense and not QB
					SetNewScript(Celebrate1ScriptNUM);	// spike ball over goal post
				}
				else
				{
					SetNewScript(CelebrateScriptNUM);
				}
			}
			else	// scorer is on ground
			{
				SetNewScript(EndOfPlayScriptNUM);
			}

		}
		else	// just the normal stuff
		{
			SetNewScript(EndOfPlayScriptNUM);
		}

		// following out of above conditional - bug #3366
		ResetBit(CPFlags1,(I_SCORED_CONV_BFLAG | I_SCORED_A_TD_BFLAG));

		if(CPAction == BlockeeStunned	// something in blocker state must unstun	*/
		   || CPAction == QBCallPlays)	// head turn at LOS
		{
			CPAction = NoAction;
		}

		CPCPUBurstTimer = CPBurstCounter = ZERO;

//		ResetBit(CPFlags,IS_HCONTROLLED_BFLAG);	// no one is human controlled
//		ResetBit(CPFlags,IM_SPINNING_BFLAG);	// kill spinning- bug #2334
/*  don't take away human control yet!!! 11/26/96
		ResetBit(CPFlags,(IS_HCONTROLLED_BFLAG | IM_SPINNING_BFLAG));	*/
		ResetBit(CPFlags,IM_SPINNING_BFLAG);	// kill spinning- bug #2334


		SetAI(NoAI);	// kills any defense reaction timing, lead blocking

//		if(gPNum == DefStrutter)	this now in WatchEOP script/STATE
//		{
//			InitGraphics(AI_DEFENSE_POSTTACKLE_NUM);
//			SetCPAction(CycleAnimActionAndEnd);
//		}


	}

//	ResetBit(EventFlags,OK_FOR_HUMAN_OFF_CONTROL_BFLAG);
/** comment out below if testing	*/
//	ResetBit(EventFlags,OK_FOR_HUMAN_DEF_CONTROL_BFLAG);

	ClearReceivers();

	CPUCallTimeout(0);	// if necessary
	CPUCallTimeout(1);


	LoadAnnouncerPhrase();	// begin loading from disc (if necessary)

	SetPlayState(PS_Wait4aNUM);

//	GoToNextPlayState();

}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait4a)  	// timing for referee whistles
{
//WORD wphrase[8];
//WORD rnum,i;

	if(PlayStateWait(QTR_SECOND,PS_Wait4bNUM))	// will GoToNext State When done
	{
		BlowWhistle(0);	// 0 means not always

#if	0	//ndef SATURNMODE
		rnum = rand()&3;
		i=0;
		while(i < rnum)
		{
			wphrase[i++] = WHISTLE1_SFX;
		}
		InitPhrase(wphrase, rnum);
#endif
	}



}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait4b)  	// timing for referee whistles
{

	if(PlayStateWait(QTR_SECOND,PS_Wait4cNUM) )	// will GoToNext State When done
	{
//		BlowWhistle(NUM_WHISTLE_SFX-1);	// 3 means do at least one
		BlowWhistle(1);					// 3 means do at least one
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait4c)  	// give a few seconds to return to huddle
{                       // timing for referee whistles
						// personal foul active in this state

	if(PlayStateWait(QTR_SECOND,PS_Wait4dNUM) )	// will GoToNext State When done
	{
		if(rand()&1)
		{
			BlowWhistle(0);	// 0 means not always
		}
	}
}

//void CheckForPenalty(void);
//void HandlePenaltyInput(void);

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait4d)	// personal foul active in this state
{
	if(PlayStateWait(3*QTR_SECOND,PS_Wait5NUM) )	// will GoToNext State When done
	{
//		PersonalFouler = 12;	//test only
		CheckForPersonalFoul();	// MUST be before DisplayAITextInfo();

		DisplayAITextInfo();	// sets flag for display

		#if PC_ALWAYS_MODE
		PCPrintAIText();	// print what happened
		#endif

//		CheckForPenalty();

	}
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


PLAYSTATE(PS_Wait5)	 /* total wait- 2 Seconds after play over */
{
	if(SinglePenaltyPending)
	{
		if(RefSFXPending == -1)	// ref done with his thing
		{
			CheckForPenaltyPart2();
			SetPlayState(PS_Wait5aNUM);	//ALWAYS force it, don't GoToNextPS

		}
		// else wait until ref does his thing
	}
	else
	{

		PlayStateWait(HALF_SECOND,PS_Wait5aNUM);
#if 0
//	if(PlayStateWait(HALF_SECOND,PS_GetUpAfterPlayNUM) ) /* total wait- 2 Seconds after play over */
	{
		// 7/27/96  - EOPSFXPending may be obsolete
/**		if(EOPSFXPending != -1)	// End OfPlay SFX to play (after whistle)
		{
			AIPlayEffectCheck(EOPSFXPending);
			EOPSFXPending = -1;		// End OfPlay SFX to play (after whistle)
		}
**/

//		SayAnnouncerPhrase();	/*  say announcer stuff	(if necessary) "gain/loss..." */

//		SetPlayOfficiallyOver();
#endif

	}
}

void AddPoints(WORD teamslot, WORD points);	// called if safety on penalty

PLAYSTATE(PS_Wait5a)	// wait here until penalty resolved
{
WORD scoringteam;

	if(InvalidPlay)		// true if offsetting penalties (or ???)
	{   // don't update any stats

		StartBallX = OriginalStartBallX;
		ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// abort any Change of Possession

		SetPlayState(PS_GetUpAfterPlayNUM);	//ALWAYS force it, don't GoToNextPS
	}
	else if(ActivePenalty)
	{
#if PC_ALWAYS_MODE
		HandlePenaltyInput();	// resolves the penalty
#endif
		if(PenaltyResolved)	// set by graphic engine
		{
			if(ActivePenalty == ACCEPT_PENALTY)
			{	// penalty was accepted
				if(AcceptPenaltyMode == SAFETY_IN_EZ)
				{
					scoringteam = AcceptPenaltyTeamWithBall^1;
					AddPoints(scoringteam , 2);
					SetBit1(EventFlags,SAFETY_HAPPENED_BFLAG);	// to position ball for KO

					NextPlayType = KICKOFF_PLAY;
					if(scoringteam  == DefensiveSlotNum)
					{
						SetBit(PlayOverFlags,NEED_COP_BFLAG);	// ...then off. kicks off
					}
					HandlePlayOverPlayType();	// inits Kickoff

				}
				else
				{
					PlayType = AcceptPenaltyPlayType;
					TheDown = AcceptPenaltyDown;
					StartBallX = AcceptPenaltyX;
					FirstDownX = AcceptPenalty1st;
					if(AcceptPenaltyMode == PENALTY_NEED_COP)
						SetBit(PlayOverFlags,NEED_COP_BFLAG);	// if grounding on 4th
					else
						ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// abort any Change of Possession
				}
			}
			else if(ActivePenalty == DECLINE_PENALTY)	// penalty declined - take play
			{
				SetPlayOfficiallyOver();

			}
			else	// error
			{
#if PC_ALWAYS_MODE
				printf("Error on ActivePenalty - %d",ActivePenalty);
#endif

			}

			ActivePenalty = PENALTY_NOT_ACTIVE; // not active any more

			SetPlayState(PS_GetUpAfterPlayNUM);	//ALWAYS force it, don't GoToNextPS

		}
		// else stay in this state until Penalty resolved
	}
	else	// no penalty this play
	{
		SayAnnouncerPhrase();	/*  say announcer stuff	(if necessary) "gain/loss..." */

		SetPlayOfficiallyOver();

		SetPlayState(PS_GetUpAfterPlayNUM);	//ALWAYS force it, don't GoToNextPS

	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_GetUpAfterPlay)	/*  a "momentary" (one time) Play STATE	*/
{		// return to huddle

//   now in script NO NO -must be here cause it's an ACTION !!!!
	for(gPNum = 0; gPNum <22; gPNum++)
	{
		GetPlayerUpAfterPlay(NOW);

		ResetBit(CPFlags,IS_HCONTROLLED_BFLAG);	// no one is human controlled
		SetAI(NoAI);	// kills any defense reaction timing, lead blocking

	}


	// play around with when to take away human control - bug #2016
	ResetBit1(EventFlags,OK_FOR_HUMAN_OFF_CONTROL_BFLAG);
	ResetBit1(EventFlags,OK_FOR_HUMAN_DEF_CONTROL_BFLAG);


// "BallPreSnap" will set ball flags to SHOWBALL, BallXPosition = StartBAllX
//	SetBallAction(BallPreSnap);


	SetPlayState(PS_Wait6NUM);	//ALWAYS force it, don't GoToNextPS


	ImplementNoHuddle();	// if necessary

}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait6)	/* wait for players to get up */
{
	if(PlayStateWait(2*HALF_SECOND,PS_Wait7NUM))	// when timeout...
	{
//		ResetBit(GameFlags,ABORT_PLAYCALLING_BFLAG);	// okay for PCall


	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_Wait7)
{ 	/* Make sure ref says his thing, then check for special stuff */
EFFVAR i;

	if(RefSFXPending == -1 && CameraGuy < ZERO)	// wait for ref to say(or DO if -2) his thing
	{
		PlayStateFlags = REF_SLOT_NUM;	//for testing only during sim

		if(!(EventFlags.TD_HAPPENED_BFLAG && LastTeamToScoreSlot == HOME_TEAM_SLOT))
		{
			for(i=0; i<NUM_MAJOR_CROWD_SFXS; i++)
			{ 	// return to normal crowd volumes slowly (unless big TD)
		//		if( !(i == HIGH_CROWD_SFX && (GameFlags & BIG_HOME_TD_BFLAG)))
				SetNewCrowdVolume(i, NormalCrowdVolume[i],5*SECONDS);
			}
		}

		if(GameFlags & GAME_OVER_BFLAG)
		{
			if(HomeTeamAhead())
			{
				SetNewCrowdVolume(MID_CROWD_SFX,CML4_VOL,2*SECONDS);
				SetNewCrowdVolume(HIGH_CROWD_SFX,CHL4_VOL,4*SECONDS);
			}
			PlayCallStatus = PLAYCALL_GAME_OVER;
			SetPlayState(PS_AIStalledNUM);
		}
		else if(PracticeMode)	// pretend nothing happened -Normal stuff
		{
			PlayCallStatus = OKAY_TO_LOAD_PLAYCALL_DATA;		// okay to load play call screen
			ResetPlayNums();
//			SetPlayCallStatus(OKAY_TO_LOAD_PLAYCALL_DATA);
			InitPlayClock();	// sets clock to MAX but DOES NOT START it
//			GoToNextPlayState();
			SetPlayState(PS_AfterEOPNUM);	//ALWAYS force it, don't GoToNextPS

		}
		else if( (GameFlags & EX_PT_PENDING_BFLAG)  // HIGHEST Priority
		   && (LastTeamToScoreSlot >= ZERO)	// error check
		   && (GameTeamData[LastTeamToScoreSlot].ControllerNum[0] >= ZERO) )
		{	// only ask for human controlled teams
			PlayCallStatus = PLAYCALL_EXPT_QUESTION; // camera goes to scoreboard
			SetPlayState(PS_AIStalledNUM);
//			PlayCallStatus = OKAY_TO_LOAD_PLAYCALL_DATA;		// okay to load play call screen
//			InitPlayClock();	// sets clock to MAX but DOES NOT START it
//			GoToNextPlayState();
		}
		else if(QuarterHasEnded())
		{
//			if(GameFlags & GAME_OVER_BFLAG)
//				PlayCallStatus = PLAYCALL_GAME_OVER;
//			else
			if(TheQuarter == 2)	// || TheQuarter == 4)	// Q=4 if overtime
				PlayCallStatus = PLAYCALL_HALF_OVER;
			else
				PlayCallStatus = PLAYCALL_QUARTER_OVER;

			SetPlayState(PS_AIStalledNUM);

		}
		else if (PlayOverFlags & NEED_COP_BFLAG)
		{
			PlayCallStatus = PLAYCALL_COP;	// camera goes to scoreboard
			SetPlayState(PS_AIStalledNUM);
		}
#ifndef SATURNMODE
		else if (IllegalKickCount) 	// re-kick - camera problems
		{	// bug # 2045
			PlayCallStatus = PLAYCALL_COP;	// camera goes to scoreboard
			SetPlayState(PS_AIStalledNUM);  // PLAYCALL_COP is really dummy
		}
#endif
		else if (EventFlags.SAFETY_HAPPENED_BFLAG) 	// covers safety on def.
		{	// bug # 2045
			PlayCallStatus = PLAYCALL_COP;	// camera goes to scoreboard
			SetPlayState(PS_AIStalledNUM);  // PLAYCALL_COP is really dummy
		}
		else if(GameFlags & NEED_2MIN_WARNING_BFLAG)
		{	// traps if 2min warning happened after playover
//			SetNewRefAnim(-2,AI_REF_WAVEARMS_NUM,NO_PENALTY);	// will redo this STATE until ref done
			SetRefStartX(StartBallX - 3*YARDS);
			InitRefPhrase(TWO_MINUTE_WARNING_SFX);
			SetNewRefAnim(TWO_MINUTE_WARNING_SFX,AI_REF_WAVEARMS_NUM,NO_PENALTY);	// will redo this STATE until ref done
			sprintf(PlayInfoText1,"TWO MINUTE WARNING");

		}
		else	// Normal stuff
		{
#ifdef SATURNMODE
			DontDisplayAITextInfo();
#endif

			PlayCallStatus = OKAY_TO_LOAD_PLAYCALL_DATA;		// okay to load play call screen
			ResetPlayNums();
//			SetPlayCallStatus(OKAY_TO_LOAD_PLAYCALL_DATA);
			InitPlayClock();	// sets clock to MAX but DOES NOT START it
//			GoToNextPlayState();
			SetPlayState(PS_AfterEOPNUM);	//ALWAYS force it, don't GoToNextPS
		}
	}

}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_AfterEOP)
{
	if(PlayStateWait(2*HALF_SECOND,PS_ReturningToHuddleNUM))
	{// goes to next PlayState when timeout
		SetBit1(EventFlags,IRP_INITED_BFLAG);  // means don't save anymore
					// screws up camera when BallPreSnap
	}
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_ReturningToHuddle) /*  a "momentary" (one time) Play STATE	*/
{

#if 0		// this stuff is test only!
	gPNum=0;

	while(CPTargetX == CPXPos && CPTargetY == CPYPos && gPNum < 22)
		gPNum++;
	if(gPNum == 22)		// all offense in huddle
	{
// "BallPreSnap" will set ball flags to SHOWBALL, BallXPosition = StartBAllX
//		SetBallAction(BallPreSnap);
		PlayCallStatus = OKAY_TO_START_PLAYCALL;		// okay to start play call screen
//		GoToNextPlayState();
		SetPlayState(PS_NUM)	//ALWAYS force it, don't GoToNextPS
	}
#else
// "BallPreSnap" will set ball flags to SHOWBALL, BallXPosition = StartBAllX
	SetBallAction(BallPreSnap);

	DontDisplayAITextInfo();

	PlayCallStatus = OKAY_TO_START_PLAYCALL;		// okay to start play call screen
//	SetPlayCallStatus(OKAY_TO_START_PLAYCALL);
//	InitPlayClock();	// sets clock to MAX but DOES NOT START it


//	GoToNextPlayState();
	SetPlayState(PS_InHuddleNUM);	//ALWAYS force it, don't GoToNextPS

#endif
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_InHuddle)		// players will do normal scripts
{
	if(PlayCallStatus == BOTH_PLAYS_CALLED)	// wait here until PC done
	{
//		InitIRPPrePlay();	// no more IRP -
//		PlayStateFlags = 1;	// for debugging (ESC from sim) purposes

		gPNum=0;

		while(CPTargetX == CPXPos && CPTargetY == CPYPos && gPNum < 22)
			gPNum++;
		PlayStateFlags = gPNum;	// for debugging (ESC from sim) purposes

		if(gPNum >= 22)		// all players in huddle ????
		{
			SetPlayState(PS_WaitForPlayStartNUM);	//back to beginning
		}
	}

}


void SignalOverTimeCoinToss(void);


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

PLAYSTATE(PS_AIStalled)	// camera should be up on (or going to) scoreboard
{
EFFVAR pcstat;

	if(PlayStateFlags == ZERO)
	{
//		AutoReplayFlag = FALSE;
		DontDisplayAITextInfo();
		SetBit(GameFlags,AI_STALLED_BFLAG);		//flag cleared by graphic engine
		PlayStateFlags = 1;
		SetBit1(EventFlags,IRP_INITED_BFLAG);  // means don't save anymore
					// screws up camera when BallPreSnap

	}


	if(GameFlags & GAME_OVER_BFLAG)
	{
		if(InterfaceFlags & FIELD_NOT_VIEWABLE_BFLAG)	// set by "CameraOnSB()"
		{
//			ResetBit(InterfaceFlags,FIELD_NOT_VIEWABLE_BFLAG);

			if(!(InterfaceFlags & DID_SCOREBOARD_AI_STUFF))
			{	//only do this ONCE - had problems if IRP during SB

				SetBit(InterfaceFlags,DID_SCOREBOARD_AI_STUFF);
				AnnounceScore();
				UpdateFinalGameStats();
				AIPlayTimerWait = AIPlayTimer + 6*SECONDS;	// init timer to leave game

			}

			if(AIPlayTimer >= AIPlayTimerWait)	/* wait a bit before leaving game */
			{
				SetBit(GameFlags,LEAVE_GAME_BFLAG);		//flag cleared by graphic engine
			}
		}
		return;	//if game over,  don't do anything else- don't init new play, no more play calling
	}


	if(InterfaceFlags & FIELD_NOT_VIEWABLE_BFLAG)	// set by "CameraOnSB()"
	{
		ResetBit(InterfaceFlags,FIELD_NOT_VIEWABLE_BFLAG);

		if(!(InterfaceFlags & DID_SCOREBOARD_AI_STUFF))
		{	//only do this ONCE - had problems if IRP during SB

			SetBit(InterfaceFlags,DID_SCOREBOARD_AI_STUFF);

			AnnounceScore();

	//		pcstat = OKAY_TO_LOAD_PLAYCALL_DATA; // assume LOAD but don't START
			pcstat = PlayCallStatus; // leave what it was i.e. DON'T LOAD (CGD)

			if( GameFlags & EX_PT_PENDING_BFLAG)
			{	  // Ex. Pt. has priority over End OF Quarter
				pcstat = PlayCallStatus; // leave what it was i.e. DON'T LOAD
			}
			else if(GameFlags & QUARTER_OVER_BFLAG)
			{	// don't change Quarter if EXPT pending OR game over
				if(TheQuarter >= 4)	// end of 4th Q (or more if Playoff)&& game not over
				{	// will "InitGamePart2" which resets PS to 0
					SignalOverTimeCoinToss();
					ResetBit1(EventFlags,SAFETY_HAPPENED_BFLAG);
					InitKickOffPlay();
				}
				else
				{
					SetNewQuarter();
				}

			}

			// force players in huddle, will do COP if needed
			ForceNewAIPlayInit(pcstat);	// does InitAI(FALSE)
		}
	}
	else if( !(GameFlags & AI_STALLED_BFLAG))	//flag cleared by graphic engine
	{
		if(GameFlags & EX_PT_PENDING_BFLAG)
		{	// see what player wants to do
			// assumption is EXPT1 & ball in middle of field

			PlayType = EX_PT2_PLAY;		// assumption (saves code)
			StartBallY = MID_FIELDY;

			switch(ExtraPointStatus)
			{
				case EXTRA_POINT_2PT_LEFT:
					StartBallY = NORTH_HASH_MARK;
					break;

				case EXTRA_POINT_2PT_RIGHT:
					StartBallY = SOUTH_HASH_MARK;
					break;

				case EXTRA_POINT_2PT_MIDDLE:
					break;		// this was our assumption

				default:
					PlayType = EX_PT1_PLAY;
			}
//			ForceNewAIPlayInit();	// this does COP, sets PlayState = 0
		}

		ResetBit(InterfaceFlags,DID_SCOREBOARD_AI_STUFF);
		PlayCallStatus = OKAY_TO_START_PLAYCALL;  // will also load if not loaded
		ResetPlayNums();

		SetPlayState(PS_WaitForPlayStartNUM);	//players do nothing until P.Call done
//		AutoReplayFlag = FALSE;

	}


//	if(PlayStateWait(8*HALF_SECOND))	// when timeout...
//		ForceNewAIPlayInit();	// forces  players in huddle, Play State = 0

}



/*-------------------------------------------------------------*/
#define psmacro(xxx)  xxx,

voidFCNPTR	PlayStatesFunctions[] = {	/* enums in FBEQU.H	*/
										/* see FBPSDATA.H for actual info */
#include "FBPSDATA.h"

};

#undef psmacro



void HandleAISound(void)	// crowd and sideline
{
	HandleCrowdSound();

	HandleSideLineAudio();
}

/*---------------------------------------------------------------------*/

void DoPlayState(void)
{

	if(PlayStateNum < MAX_PLAY_STATES)	// error checking
	{
		PlayStatesFunctions[PlayStateNum]();
	}
}



/**********************************************************************


				Defensive Shift Before Play

	Following is used in case the def. formation doesn't "matchup" with
	the offensive formation.  It makes some of the defenders shift to
	compensate for where the offensive players are.

**************************************************************************/

extern struct defshiftDS *DefGoallineShiftLookup[]; 	/* in FBAIINIT.c */
extern struct defshiftDS *DefNormalShiftLookup[]; 	/* in FBAIINIT.c */
extern struct defshiftDS *DefDimeShiftLookup[]; 	/* in FBAIINIT.c */
extern struct defshiftDS *DefNickelShiftLookup[]; 	/* in FBAIINIT.c */
///extern struct defshiftDS *DefShiftLookup[]; 	/* in FBAIINIT.c */

BOOL DefShouldGoTo4PointStance(void);

BOOL DefShouldGoTo4PointStance(void)
{ // if with box where def. linemen should normally be
		return(	(CPXPos < StartBallX+3*HALF_YARD+1)
		  &&(CPXPos > StartBallX)	// human guy past LOS then toggled off
		  &&(CPYPos < StartBallY+6*YARD)
		  &&(CPYPos > StartBallY-6*YARD)  );
}

void InitDefensePreSnapShift(void)	/* a PlayState subroutine	*/
{
struct defshiftDS *shiftptr;
EFFVAR i;
EFFVAR offform,defform;



	for(gPNum = START_DEF_SLOT_NUM; gPNum < LAST_DEF_SLOT_NUM; gPNum++)
	{	/* anybody in "box" near LOS goes into 4 point stance	*/
		if(CPFlags & IM_PUNT_RETURNER_BFLAG || CPMyPNum == PR)
		{
//			i = i;	 //bp here
			continue;		// punt returner already doing his thing
		}

		CPDirToGo = WEST_DIR;

		if( DefShouldGoTo4PointStance()
		  && ( !(CPFlags & IS_HCONTROLLED_BFLAG))
		  )
		{
			CPAction = GoTo4PtStanceInitAction;
			// but don't start it until CPTimer dec's to ZERO
			CPTimer = rand()&31;	//0-31 ticks = 0-7 frames
		}
		else
			InitGraphics(AI_2PTSTANCE_NUM);
	}



/*
	following is used in case the def. formation doesn't "matchup" with
	the offensive formation.  It makes some of the defenders shift to
	 compensate for where the offensive players are.
*/
	defform = GameTeamData[DefensiveSlotNum].FormationNumber;
	offform = GameTeamData[OffensiveSlotNum].FormationNumber;

	if( (offform =  SequentialOffFormIndex[offform]) == -1)
		return;		// don't do following if "illegal formation"
//	if(offform > FIELD_GOAL_FORM_NUM)
//		return;		// no shift if testing
#if 1
	if(defform == DEF_GOALINE_FORM_NUM)
		shiftptr = DefGoallineShiftLookup[offform];
	else if (defform == DEF_NICKEL_FORM_NUM)
		shiftptr = DefNickelShiftLookup[offform];
	else if (defform == DEF_DIME_FORM_NUM || defform == DEF_DIME_4MANLINE_FORM_NUM)
		shiftptr = DefDimeShiftLookup[offform];
	else
		shiftptr = DefNormalShiftLookup[offform];

#endif
//	shiftptr = DefShiftLookup[GameTeamData[OFFENSIVE_SLOT_NUM_MACRO].FormationNumber];

	i=ZERO;
	while( (gPNum = (shiftptr+i)->slotnum) != (BYTE)(-1))
//	while( (shiftptr+i)->slotnum != -1)
	{

	/* no pre-snap shifts if human has moved a player - even if not controlling
		him anymore due to toggling - bug #1433			*/
		if( !( CPFlags1 & I_HAVE_BEEN_HCONTROLLED_BFLAG))
		{

			if( (CPTargetX = StartBallX + (shiftptr+i)->targetx) > OFF_END_LINE-YARD)
				CPTargetX = OFF_END_LINE-YARD;
			else if(CPTargetX < StartBallX + DEFLINE_STARTX)	// new formations changes necesitate this line of code
				CPTargetX = StartBallX + DEFLINE_STARTX; // not too close toLOS(neutral zone)

			if(GameTeamData[DefensiveSlotNum].PlayFlipped)
				CPTargetY = StartBallY - (shiftptr+i)->targety;
			else
				CPTargetY = StartBallY + (shiftptr+i)->targety;
			SetNewScript(DefFormationShiftScriptNUM);
		}
		i++;
	}


}


extern struct defshiftDS *KOLeftShiftLookup[];
extern struct defshiftDS *KORightShiftLookup[];

void OffenseKOShift(void)	// shift against [potential] onside kick
{
struct defshiftDS *shiftptr;
EFFVAR i;
EFFVAR offplay,defplay;

	defplay = GameTeamData[DefensiveSlotNum].PlayNum;
	offplay = SetMinMax(GameTeamData[OffensiveSlotNum].PlayNum -
				KickoffReturnSpreadNUM,0,2);

	if(defplay == KickoffStackLeftNUM)
		shiftptr = KOLeftShiftLookup[offplay];
	else if (defplay == KickoffStackRightNUM)
		shiftptr = KORightShiftLookup[offplay];
	else
		return;	// normal kickoff


	i=ZERO;
	while( (gPNum = (shiftptr+i)->slotnum) != (BYTE)(-1))
	{
	/* no pre-snap shifts if human has moved a player - even if not controlling
		him anymore due to toggling - bug #1433			*/
		if( !( CPFlags1 & I_HAVE_BEEN_HCONTROLLED_BFLAG))
		{
			CPTargetX = StartBallX + (shiftptr+i)->targetx;
			CPTargetY = StartBallY + (shiftptr+i)->targety;

			SetNewScript(OffKOFormationShiftScriptNUM);
		}
		i++;
	}
}


#if 0
/**  first STATE of DefFormationShiftScript  -
	target was set up in InitDefensePreSnapShift		*/

void CheckForDefBackPedalState(void)
{

EFFVAR	dirtotarget;

	if(!CPStateInit)
	{	/* check once to init back pedal - StateInit TRUE  in next subroutine */
		CPDirToGo = CPFacing = dirtotarget= FindCPDirectionToTargetMACRO;
		if(dirtotarget >= EAST_DIR-2 && dirtotarget <= EAST_DIR+2)
			Do_Back_Pedal_Macro;
		CPStateInit = TRUE;
	}

	CPFacing = FindCPDirectionToTargetMACRO;
	if(AIFrameCounter%4 == ZERO)
		CPDirToGo = CPFacing;

	CPXPos += SpeedTable[5][CPDirToGo].X;		// NO collisoin detect
	CPYPos += SpeedTable[5][CPDirToGo].Y;
	GeneratePlayerSphereOfInfluence(gPNum);
	Run();

	if(ReachedTarget())
	{
		CPXPos = CPTargetX;	  // make the current EXACTLY what the target is
		CPYPos = CPTargetY;
		GeneratePlayerSphereOfInfluence(gPNum);
		GoToNextState(1);
	}

}
#endif

/*
void KickOffShift(void)
{

	if(defform == DEF_GOALINE_FORM_NUM)
		shiftptr = DefGoallineShiftLookup[offform];
	else if (defform == DEF_NICKEL_FORM_NUM)
		shiftptr = DefNickelShiftLookup[offform];
	else if (defform == DEF_DIME_FORM_NUM || defform == DEF_DIME_4MANLINE_FORM_NUM)
		shiftptr = DefDimeShiftLookup[offform];
	else
		shiftptr = DefNormalShiftLookup[offform];

}
*/
/*---------------------------------------------------------------------*/


#if 0	//__MSDOS__		/*  for PC testing	*/
const WORD JoyToDirTable[16] = {
				// LDRU  (Left,Down,Right,Up)
	-1,			// 0000 = no movement
	NORTH_DIR,	// 0001
	EAST_DIR,	// 0010
	NE_DIR,		// 0011

	SOUTH_DIR,	// 0100
	-1,			// 0101	N & S ???
	SE_DIR,		// 0110
	-1,			// 0111

	WEST_DIR,	// 1000
	NW_DIR,		// 1001
	-1,			// 1010 W & E ???
	-1,			// 1011

	SW_DIR,		// 1100
	-1,			// 1101 here or below - you have a broken joypad
	-1,			// 1110
	-2			// 1111
};
#endif


#ifdef SATURNMODE
/*  for actual SATURN - assumes going "into" TV	*/
const WORD JoyToDirTable[16] = {
				/* RLDU  (Right,Left,Down,Up) */
	-1,			/* 0000 = no movement */
	EAST_DIR,	/* 0001 */
	WEST_DIR,	/* 0010 */
	-1,			/* 0011 Left & Right ??? */

	NORTH_DIR,	/* 0100 */
	NE_DIR,		/* 0101 */
	NW_DIR,		/* 0110 */
	-1,			/* 0111 */

	SOUTH_DIR,	/* 1000 */
	SE_DIR,		/* 1001 */
	SW_DIR,		/* 1010 */
	-1,			/* 1011 */

	-1,			/* 1100 Down & Up ??? */
	-1,			/* 1101 here or below - you have a broken joypad */
	-1,			/* 1110 */
	-2				/* 1111 */
};
#else	//#if  (__MSDOS__ | __psx__)
	/*  for actual PlayStation - assumes going "into" TV	*/
const WORD JoyToDirTable[16] = {
				// LDRU  (Left,Down,Right,Up)
	-1,			// 0000 = no movement
	EAST_DIR,	// 0001
	SOUTH_DIR,	// 0010
	SE_DIR,		// 0011

	WEST_DIR,	// 0100
	-1,			// 0101	Down & Up ???
	SW_DIR,		// 0110
	-1,			// 0111

	NORTH_DIR,	// 1000
	NE_DIR,		// 1001
	-1,			// 1010 Left & Right ???
	-1,			// 1011

	NW_DIR,		// 1100
	-1,			// 1101 here or below - you have a broken joypad
	-1,			// 1110
	-2			// 1111
};


#endif

WORD TryManyMovesPush(WORD dir);

/*********************************************************************

					 H U M A N    C O N T R O L


	If a player is human controlled this takes care of it.
	This routine is called after doing a Players ACTION but before
	doing his STATE - if player is human controlled then don't do
	his STATE or AI.


	Each Player D.S. has a variable to say which controller (out of
	MAX_CONTROLLER) is controlling the player.

	Also, there a a controller D.S.
	(WORD ControlWhichPlayer[MAX_CONTROLLERS]) which states what player
	is controlled by each of the controllers.  Much of these arrays
	are filled with "NOBODY".


	NOTE: Toggling of players is handled elsewhere as are time outs,
	pause, instant replay, etc. - this only takes
	care of actual player movement or player initiated ball movement.


	RETURNS: TRUE if player is currently controlled by a human.

*********************************************************************/
#define REV_FIELD_DIR	WEST_DIR

void CheckForHumanToTakeControl(WORD ctrlnum)
{  //	sets CPFlags-IS_HCONTROLLED_BFLAG if human takes control;
UEFFVAR	mask,prevread,paddata,t,prevt;

	paddata = AIJoyPadData[ctrlnum];	// use local var.  to save code

	if( gPNum > LAST_OFF_SLOT_NUM)	// player on defense?
	{
		if(EventFlags.OK_FOR_HUMAN_DEF_CONTROL_BFLAG)
		{  // okay to control def.

//			mask = JPADL_MASK | JPADx  | JPADcircle  | JPADsquare;
//			mask = JPADL_MASK | JUMP_BUTTON  | DIVE_BUTTON;	// no BURST, TOGGLE
			mask = JPADL_MASK | JumpButtonMask[CurTeamSlot] | DiveButtonMask[CurTeamSlot];

//			if(!(GameTeamData[DefensiveSlotNum].TeamFlags
//							 & TOGGLE_TO_CLOSEST_VALID_BFLAG))
//				mask |= JPADtriangle; // allow def. to spin if toggle off

			if(paddata & mask)	/* then human wants to control */
				SetBit(CPFlags,IS_HCONTROLLED_BFLAG);	// no "debounce"
		}
	}
	else if ((EventFlags.OK_FOR_HUMAN_OFF_CONTROL_BFLAG))
	{    /* on offense -  treat direction pad and buttons separate	*/
		prevread = PreviousJoyReading[ctrlnum];
		if( (t = (paddata & JPADL_MASK)) > ZERO	// must lift up then down
//				&& (!(prevread & JPADL_MASK))	// (in case of auto swap)
		  )
		{
			prevt = prevread & JPADL_MASK;
			if(CPFlags1 & MUST_LIFT_OFF_CONTROLLER_BFLAG)
			{ 	// (in case of auto swap - QB to rec in 1 player game
				if( (!(prevread & JPADL_MASK))	// (in case of auto swap)
					|| (prevt != t)	// bug # 1763
				  )
					SetBit(CPFlags,IS_HCONTROLLED_BFLAG);

			}
			else
				SetBit(CPFlags,IS_HCONTROLLED_BFLAG);
		}
		else	// check buttons for dive, spin, etc.
		{
			ResetBit(CPFlags1,MUST_LIFT_OFF_CONTROLLER_BFLAG);

			if(GameTeamData[OffensiveSlotNum].TeamFlags
							 & TOGGLE_TO_CLOSEST_VALID_BFLAG)

			{ // TRIANGLE won't take control if toggle valid
				mask = JumpButtonMask[CurTeamSlot] | DiveButtonMask[CurTeamSlot];
//				mask = JUMP_BUTTON  | DIVE_BUTTON;	// no BURST, SPIN
//				mask =  JPADx  | JPADcircle;	// no BURST
//				mask = JPADx  | JPADcircle  | JPADsquare;
			}
			else if(CPFlags & CAN_PASS_BFLAG)
			{
				mask = REC_BUTTON_MASK;		// just receivers
//				mask = MiscButtonMask[CurTeamSlot];
			}
			else
			{
				mask = JumpButtonMask[CurTeamSlot] | DiveButtonMask[CurTeamSlot];
//				mask = JUMP_BUTTON  | DIVE_BUTTON;	// no BURST, SPIN
//				mask =  JPADx  | JPADcircle;	// no BURST
//				mask = JPADR_MASK;		// any buttons
			}

			if(  (paddata & mask)	/* then human wants to control */
			  && (!(prevread & mask))
			  )
			{
				SetBit(CPFlags,IS_HCONTROLLED_BFLAG);
			}

		}
	}
}



/*------------------------------------------------------------------*/

BOOL GamerControlled(void)
{
EFFVAR	ctrlnum;
BOOL	rv = FALSE;
UEFFVAR	prevread,paddata;	// local variables save code

//	FieldDir = 4;		//test only

	ResetBit(CPFlags1,OKAY_FOR_RCATCH_ANIM_BFLAG);	// always do this, could be set below

	if((ctrlnum = CPControllerNum) != NO_CONTROLLER)
	{  /*  ... if yes, has human actually taken control yet ?	*/

		prevread = PreviousJoyReading[ctrlnum];
		paddata = AIJoyPadData[ctrlnum];


		if(PlayHappening())	// bug # 1757
		{
		//  SPIN and BURST do NOT force a human to control	bug#1664
//			if(  (gPNum == BallCarrier || gPNum == TheReceiver)	 // only BC can spin
			if(  (gPNum == BallCarrier)	 // only BC can spin
			 && (paddata & MiscButtonMask[CurTeamSlot])
			 && (!(prevread & MiscButtonMask[CurTeamSlot]))
			  )
			{
				if( !(CPFlags & (CAN_PASS_BFLAG | CAN_HANDOFF_BFLAG))) // ... except passing QB
				{
//					if(!(GameTeamData[CurTeamSlot].TeamFlags	// no SPIN if toggle valid
//						 & TOGGLE_TO_CLOSEST_VALID_BFLAG))
						InitSpinMove();
		//			return(TRUE);
				}
			}
			else if( (paddata & MiscButtonMask[CurTeamSlot])
					&& (gPNum == TheReceiver)
				   )
			{
				SetBit(CPFlags1,OKAY_FOR_RCATCH_ANIM_BFLAG);
			}


			if(	(!(CPFlags & CAN_PASS_BFLAG))	// ... except passing QB
				&& (paddata & BurstButtonMask[CurTeamSlot])
//				&& (!(prevread & BURST_BUTTON))	// removed 6/1/96 -
			  )
			{
				InitSpeedBurst();
			}

		}
 /*  is player possibly controlled (with a physical controller)?	*/

		if( !(CPFlags & IS_HCONTROLLED_BFLAG))
			CheckForHumanToTakeControl(ctrlnum);



		/* 2nd part - if controlled, move him	*/

		if(CPFlags & IS_HCONTROLLED_BFLAG)
		{
			rv = TRUE;	// set breakpoint here to check human movement
			SetBit(CPFlags1,I_HAVE_BEEN_HCONTROLLED_BFLAG);	//bug #1433


			if(  (CPFlags & CAN_PASS_BFLAG) && (gPNum == BallCarrier) )
			{
				HandleHumanPassing(ctrlnum);
			}
			else if( (CPFlags & CAN_HANDOFF_BFLAG) && (gPNum == BallCarrier) )
			{
				HandleHumanHandoff(ctrlnum);
			}
			else if( gPNum == TheReceiver)
			{
				HandleHumanReceiver(ctrlnum);
			}
			else if(!MoveHumanControlledPlayer(ctrlnum))	// didn't move
			{ // need to turn player if facing N @ speed0 and goes south

			// defense before snap faces toward offense (if no human input)
				if(gPNum > 10  && PlayStateNum < PS_PlayHappeningNUM)
				{
					CPDirToGo = WEST_DIR;	// will force turn below
					TurnPlayerOptimal(CPDirToGo);  // updates CPFacing
//					InitGraphics(AI_2PTSTANCE_NUM);	// bug #1790
					InitGraphics(AI_2PTSTANCE_NUM);	// bug #1790
				}
				else
				{
					if(!(CPFlags & IM_SPINNING_BFLAG) )	// this line fixes bug #1288
					{
						TurnPlayerOptimal(CPDirToGo);  // updates CPFacing
						if(PlayStateNum > PS_PlayHappeningNUM)
							Shuffle(NORMAL_SHUFFLE);
						else	//active during play
							Shuffle(BLOCKING_SHUFFLE);	// 11/6/96
					}

				}
//				Shuffle(NORMAL_SHUFFLE);
				CPSpeed = ZERO;	//override SHUFFLE_SPEED;
			}
		}
	}
	return(rv);
}


/*  protos		*/
//void InitPitch(void);
//void PitchBallSub(WORD turnvalue);	// a subroutine called by Pitching STATEs
void InitHumanPitch(void);


/***   If FutureBC close than handoff else if FBC behind QB than pitch	*/

BOOL CheckForHumanHandoff(void)	// already made sure he has ball
{
//WORD dir, diff;
BOOL rv = FALSE;	// returns TRUE if HO/pitch happened

	if(FutureBC < ZERO)
	{
	//		return(FALSE);

	}
	else if(HeCanGetBall(FutureBC))
	{  /*... then force QB to VARIABLE Script (usually stop unles Fleaflick */

		if(HeShouldFumbleGeneric(FutureBC) )
		{
			InitFumble(BALL_HIT_GUY_FUMBLE,BallDirection,NEED_FUMBLE_SFX);
		}
		else
		{
			DoHandoff();
		}

		rv = TRUE;
	}
	else if(
//			 (CPXPos > OPXPos(FutureBC))
			 (OPXPos(FutureBC)  < StartBallX)	//FBC behind LOS
		  && (CPXPos < StartBallX)		// QB behind LOS
		  && (DistanceToPlayer(FutureBC) < 8*YARDS)    // not too far
		  )
	{
		InitHumanPitch();
		rv = TRUE;
	}

	return(rv);

}
/*---------------------------------------------------------*/


/*  two chances to handoff - if not at start then move QB and check again	*/

void HandleHumanHandoff(WORD ctrlnum)
{

  if(CPXPos >= StartBallX)
  {
	ResetBit(CPFlags,CAN_HANDOFF_BFLAG);   // can never handoff again
	MoveHumanControlledPlayer(ctrlnum);
  }
  else
  {
	/* see if futureBC nearby....	*/
	if(  (FutureBC >= ZERO)            // PITCH button
	  && (AIJoyPadData[ctrlnum] & MiscButtonMask[CurTeamSlot])
	  && ( !(PreviousJoyReading[ctrlnum] & MiscButtonMask[CurTeamSlot]))
	  )
	{
		if (!CheckForHumanHandoff())
		{
			if(!MoveHumanControlledPlayer(ctrlnum))
					Shuffle(NORMAL_SHUFFLE);
			if(CheckForHumanHandoff())
				SetBit(PreviousJoyReading[ctrlnum],MiscButtonMask[CurTeamSlot]);	//bug #2457
		}
		else
		{   // pitch == SPIN , make sure FBC doesn't spin THIS SAME frame
			SetBit(PreviousJoyReading[ctrlnum],MiscButtonMask[CurTeamSlot]);	//bug #2457

		}
	}
	else
		if(!MoveHumanControlledPlayer(ctrlnum))
				Shuffle(NORMAL_SHUFFLE);
  }
}

/*---------------------------------------------------------*/

/*  two chances to handoff - if not at start then move QB and check again	*/

void HandleHumanReceiver(WORD ctrlnum)
{
                                    // REC_CATCH _BUTTON
	if(AIJoyPadData[ctrlnum] == MiscButtonMask[CurTeamSlot])
	{	// pressing ONLY catch button !!

		TurnPlayerOptimal(FindCPDirectionToBallMACRO);	// adjust facing
		SetStandingCatchGraphics();
	}
	else
		if(!MoveHumanControlledPlayer(ctrlnum))
				Shuffle(NORMAL_SHUFFLE);
}


/*---------------------------------------------------------*/

UWORD RecButtonArray[MAX_RECEIVERS] = {

REC1_BUTTON,
REC2_BUTTON,
REC3_BUTTON,
REC4_BUTTON,
REC5_BUTTON
};


void HandleHumanPassing(WORD ctrlnum)
{
EFFVAR	recbutton,i;

  if(CPXPos >= StartBallX)
  {
	ResetBit(CPFlags,CAN_PASS_BFLAG);   // can never pass again
	MoveHumanControlledPlayer(ctrlnum);
  }
  else
  {
	recbutton = (AIJoyPadData[ctrlnum] & REC_BUTTON_MASK);

	if ( (recbutton != ZERO)
		&&  (TheReceiver == NOBODY) )
	{	/* human has not passed yet and wants to now	*/
		ThrowAwayRec = NOBODY;	// assume - be safe
		TheReceiver = 1;		// assume - be safe

		if(recbutton & THROWAWAY_LEFT)
		{
			TheReceiver = ThrowAwayRec = 2;
		}
		else if(recbutton & THROWAWAY_RIGHT)
		{
			TheReceiver = ThrowAwayRec = 1;
		}
		else
		{
			for(i=0; i<MAX_RECEIVERS; i++)
			{
				if(recbutton &  RecButtonArray[i])
				{	// found him
					TheReceiver = i+1;
					break;
				}
			}
		}
/**
		 if(rec &  REC1_BUTTON)
		{
			TheReceiver = Receivers[0];	// slot number of the off. player
		}
		else if(rec &  REC2_BUTTON)
		{
			TheReceiver = Receivers[1];	// slot number of the off. player
		}
		else if (rec &  REC3_BUTTON)
		{
			TheReceiver = Receivers[2];	// slot number of the off. player
		}
		else if (rec &  REC4_BUTTON)
		{
			TheReceiver = Receivers[3];	// slot number of the off. player
		}
		else //if (rec &  REC5_BUTTON)
		{
			TheReceiver = Receivers[4];	// slot number of the off. player
		}
****/
		if(TheReceiver == gPNum) // can't pass to myself (bug #3181 -HB option,toggle)
		{
			TheReceiver = ThrowAwayRec = NOBODY;

			if(!MoveHumanControlledPlayer(ctrlnum))
			{ // if QB isn't moving have him face downfield
				SetLookToPassGraphics(-1);	// -1 means random
			}
		}
		else
		{
			IntendedReceiver = TheReceiver;

			InitPlayerPass(HumanPassingAction);
			SetNewScript(QBEndOfPlayScriptNum);	 // a VARIABLE!!!
		}
	}
	else if( (AIJoyPadData[ctrlnum] & QB_PUMP_FAKE_BUTTON)
			&& (!(PreviousJoyReading[ctrlnum] & QB_PUMP_FAKE_BUTTON))
		  )
	{
			InitPumpFake();		// in fbmove.c
	}
	else
	{
		if(!MoveHumanControlledPlayer(ctrlnum))
		{	/* if QB isn't moving have him face downfield	*/
			SetLookToPassGraphics(-1);	// -1 means random

		}
	}
  }
}


/*************************************************************************

				 H U M A N      P A S S I N G    A C T I O N

	An ACTION used for human controlled passers.

	Once a Receiver button is pressed (in "HandleHumanPassing"), it
	will instigate the following ACTION.

	Monitor the button to see how long it's held down for to determine
	what type of pass (bullet, lob) is thrown.

	Note: CPU QB uses certain subroutines while pre-initing some vars,
	such as PassCounter (which determines LOB or BULLET).

*************************************************************************/
void DefenseSayTheyPassing(void);	// only somtimes
void FaceDownFieldRandom(void);	// in fbmove.c
void TriggerDefJumpBlock(WORD dir);	// all def. players - if nesssary


void InitPlayerPass(voidFCNPTR action)
{
	CPAction = action;		/* ball actually released in this QB ACTION	*/
	PassState = 2;

	CPAIGraphicSequence = PASS_START_FRAME_NUM-1;	// (-1) cause DoAction Inc's it
	CPAIGraphicState = AI_PASSING_NUM;
	CPDirToGo = CPFacing = FindCPDirectionToPlayer(TheReceiver); /* QB faces receiver	*/
	DoAction();		// added 3/14/96 - do the passing ACTION THIS frame
}


void HumanPassingAction(void)
{

	// do ACTION first, then see if button still down
	NormalPassingAction();		// okay to call an ACTION as a subroutine

	if(CPControllerNum != NO_CONTROLLER)
	{
		if(AIJoyPadData[CPControllerNum] & REC_BUTTON_MASK)
		{
			PassCounter++;
		}
		else
		{
			PassState = 1;
		}
	}

//	CPUPassingAction();		// okay to call an ACTION as a subroutine

}


/*  handles the passing action - directly if CPU QB or as a subroutine
	of human passing	WARNING - uses PassCounter to determine type of pass
*/
void NormalPassingAction(void)		//a player ACTION
{

	CPAIGraphicState = AI_PASSING_NUM;

	BallDirection = CPFacing = FindCPDirectionToPlayer(TheReceiver);	/* QB faces receiver	*/

	if(++CPAIGraphicCounter >= PassState)	/* "greater than" test to be sure	*/
	{
		CPAIGraphicCounter = 0;

		CPAIGraphicSequence++;
		if(CPAIGraphicSequence == PASS_RELEASE_FRAME_NUM)	// 5
		{
			if(!ImBallCarrierMACRO)
			{	// must have fumbled in mid-pass (on last defense frame)
				InitGraphics(AI_STAND_NUM);
				CPAction = NoAction;
			}
			else if(DistanceToPlayer(TheReceiver) < 2*YARDS)
			{	 //if close - just give it to him- # bug #1435
				SetNewBallCarrier(TheReceiver);	// sets BS(PlayerHasBall)
				OPScriptPtr(TheReceiver) = All_Scripts[BallCarrierAvoidScriptNUM];
				OPStateInit(TheReceiver) = FALSE;
			}
			else
			{ // PassCounter must be set-up (routine in FBBall.c)
				ReleasePass(TRUE);	// TRUE means really throw it
				if(BallTargetX > StartBallX + 13*YARDS)
//					SetNewCrowdVolume(HIGH_CROWD_SFX,CHL2_VOL,4*SECONDS);	// start ramp slowly
					SetNewCrowdVolume(HIGH_CROWD_SFX,CHL2_VOL,3*SECONDS);	// 11/21/96
			}
		}
		else if (CPAIGraphicSequence >= MAX_FRAMES_MACRO(CPAIGraphicState))	//PASS_END_FRAME_NUM)
		{
			CPAction = NoAction;	/* next time back to STATE	*/
			if(SwapControllers(TheReceiver,gPNum))	//swap at end of passing
				SetBit(OPFlags1(TheReceiver),MUST_LIFT_OFF_CONTROLLER_BFLAG);

			SetBit(GameTeamData[OffensiveSlotNum].TeamFlags,TOGGLE_TO_CLOSEST_VALID_BFLAG);
			DefenseSayTheyPassing();	// only somtimes

		}   //mjkbug - above swapcon won't work if this action interrupted
	}

	if(CPAIGraphicSequence > 2)
	{	// force def. to jump  based on where Qb is facing
		TriggerDefJumpBlock(CPFacing);	// all def. players - if nesssary
	}


	if(CPAIGraphicSequence < PASS_RELEASE_FRAME_NUM)	// 9 (?)
	{
		if(ImBallCarrierMACRO)
		{
			QuickFigurePass(TheReceiver);	// will display arc as if thrown now
		}
		else
		{	// must have fumbled in mid-pass
			InitGraphics(AI_STAND_NUM);
			CPAction = NoAction;
		}
	}
}

WORD JumpBlockTable[2][3] = {	// % of time def. will jump EACH FRAME!!!
//	2, 4, 7,	// jumper is blocked (easy,normal,difficult)
//	5,13,17     // jumper not blocked
	1, 3, 5,	// jumper is blocked (easy,normal,difficult)
	3, 8,12     // jumper not blocked
};

void TriggerDefJumpBlock(WORD dir)	// all def. players - if nesssary
{	// subroutine of QB passing - Called at least 5 times in passing ACTION
	// dir is way Qb is facing or dir ball is going
EFFVAR temp,percent;
EFFVAR lowy,highy;

	temp = gPNum;	//save as I need gPNum to do possible jump ACTION

	if(dir >= SE_DIR)	// looking right
	{
		lowy = BallYPosition-1*YARD;
		highy = BallYPosition+5*YARD;

	}
	else if(dir <= NE_DIR)	// looking left
	{
		lowy = BallYPosition-5*YARD;
		highy = BallYPosition+1*YARD;
	}
	else	// facing forward
	{
		lowy = BallYPosition-3*YARD;
		highy = BallYPosition+3*YARD;
	}

	for(gPNum = 11; gPNum <22; gPNum++)
	{
		if(  (CPXPos > BallXPosition+YARD)
		   &&(CPXPos < BallXPosition+6*YARD)
		   &&(CPYPos > lowy)
		   &&(CPYPos < highy)
		   &&(CPFacing > SSW_DIR)	// must be [sort of] facing QB
		   &&(!(CPFlags & IS_HCONTROLLED_BFLAG))	// no humans
		  )
		{
			if(CPFlags & IM_BLOCKED_BFLAG)
				percent = 0;
			else
				percent = 1;

			percent = JumpBlockTable[percent][GameOptions[GAME_OPTNS_DIFFICULTY]];
			if(randper < percent)
				StartJump();	// only if not doing an ACTION

		}
	}
	gPNum = temp;	// restore
}

/*-----------------------------------------------------------------------

	Will turn QB to face downfield if he wants to pass
-----------------------------------------------------------------------*/

void	SetLookToPassGraphics(WORD dirtoface)
{

	if( (CPFacing >= DOWN_FIELD_DIR-2) && (CPFacing <= DOWN_FIELD_DIR+2) )
	{
		InitGraphics(AI_PASSING_NUM);

		/*  don't run animation at full frame rate	*/
		if(dirtoface >1)
			CPDirToGo = CPFacing = dirtoface;

		if(++CPAIGraphicCounter >= 8)		/* "greater than" test to be sure	*/
		{
			CPAIGraphicCounter = 0;

			CPAIGraphicSequence++;
			CPAIGraphicSequence &= 1;		// 0 or 1
			if(dirtoface < 2 && CPAIGraphicSequence == ZERO)
				FaceDownFieldRandom();	// select new dir (in fbmove.c)
//			else
//				CPDirToGo = CPFacing = dirtoface;

		}
	}
	else	/* turn QB to face downfield (doing whatever he was doing	*/
	{
		CYCLE_GRAPHICS_MACRO(CPAIGraphicState);
#if 0	//PC_DEBUG_MODE
		if(CPAIGraphicState == AI_PASSING_NUM)
			printf("\nPump fake");
#endif
		if(CPFacing > DOWN_FIELD_DIR  && CPFacing < DOWN_FIELD_DIR+8)
			CPFacing -= 2;
		else
			CPFacing += 2;
		CPFacing &= (16-1);
		CPDirToGo = CPFacing;	// in 2/4/96 fo bug #1312
	}
}


/*---------------------------------------------------------

			Move  Human  Controlled  Player

		RETURNS:  TRUE if H.C. Player was moving (either by actual
		movement or by inertia slowdown). Therefore, calling routine
		decides what to do if no movement

	NOTE:  Buttons (dive, spin, jump, etc.) override directions.

-----------------------------------------------------------------*/
BOOL DownKickOffValid(void);	// proto - in fbmove.c


BOOL MoveHumanControlledPlayer(WORD ControllerNum)
{
UEFFVAR move;
EFFVAR dir;
UEFFVAR	prevread,paddata;	// local variables save code

	prevread = PreviousJoyReading[ControllerNum];
	paddata = AIJoyPadData[ControllerNum];



	if( (paddata & DiveButtonMask[CurTeamSlot])
	   && (!(prevread & DiveButtonMask[CurTeamSlot]))
	   && (InterfaceFlags & AMINS_LOADED_BFLAG)
	   // only 1%(per frame) chance to dive if being blocked -bug#2253
	   && (  (! (CPFlags & IM_BLOCKED_BFLAG)) || ((rand()&127)==ZERO))

	  )
	{
		if(!DownKickOffValid())	// human in EZ on Kickoff?
		{
			StartDive(TRUE);	// TRUE = start dive this frame
		}
		return(TRUE);
	}

	if( (paddata & JumpButtonMask[CurTeamSlot])
	   && (!(prevread & JumpButtonMask[CurTeamSlot]))	// don't re-init jump
	   && (InterfaceFlags & AMINS_LOADED_BFLAG)
	  )
	{
		StartJump();
		return(TRUE);
	}
/**#if 0  moved to handle controllers as this doesn't FORCE human to take control
	if( (paddata & MiscButtonMask[CurTeamSlot])
	   && (gPNum == TheReceiver)
	  )
	{
		SetBit(CPFlags1,OKAY_FOR_RCATCH_ANIM_BFLAG);
	}


	if(  (gPNum == BallCarrier)		 // only BC can spin
		 && (paddata & SPIN_BUTTON)
		 && (!(prevread & SPIN_BUTTON))
	  )
	{
		if( !(CPFlags & (CAN_PASS_BFLAG | CAN_HANDOFF_BFLAG))) // ... except passing QB
		{
			InitSpinMove();
//			return(TRUE);
		}
	}

	if(	(!(CPFlags & CAN_PASS_BFLAG))	// ... except passing QB
		&& (paddata & BURST_BUTTON)
		&& (!(prevread & BURST_BUTTON))
	  )
	{
		InitSpeedBurst();
	}

#endif **/

		move = (paddata & ANY_DPAD);
		if(move)
		{	/* human wants to move in a direction	*/
			move >>=JPADL_SHIFT;	// set up index into table

			dir = CPDirToGo =  ((JoyToDirTable[move] - FieldDir)&15);
//			dir = CPDirToGo =  JoyToDirTable[move];

#if 0
			if(  (CPFlags & (CAN_PASS_BFLAG | BACK_PEDAL_BFLAG))
				 && (gPNum == BallCarrier) )
			{
				if(dir >= DOWN_FIELD_DIR-2 && dir <=  DOWN_FIELD_DIR+2)
				{	// still okay for QB to back pedal
//					TryManyMovesPush(dir);
				}
				else
					No_Back_Pedal_Macro;
			}
			TryManyMovesPush(dir);
#else
			if( (gPNum == BallCarrier)
				&& (CPFlags1 & QB_CAN_BPEDAL_BFLAG)	// passing or draw(bug # 1758)
				&& (CPFacing == DOWN_FIELD_DIR)
			  )
			{	// passing QB facing East
				if(dir > REV_FIELD_DIR+2 || dir < REV_FIELD_DIR-2)
				{	// still okay for QB to back pedal
					No_Back_Pedal_Macro;
				}
				else
					Do_Back_Pedal_Macro;
			}
			else
			{
				No_Back_Pedal_Macro;
			}

			CheckForReceiverContact(TryManyMovesPush(dir));
#endif
		}
		else
		{		/* no direction to go, check for inertia slowdown	*/
#if	PC_ALWAYS_MODE		// need this due to bad KB reads
			if(DecrementPlayerSpeed(19,0) < ZERO)	// safer(faster?) than == -1)
//			if(DecrementPlayerSpeed(3,0) < ZERO)	// safer(faster?) than == -1)
#else	//			if(DecrementPlayerSpeed(6,0) < ZERO) // 3 took too long 12/29/75
			if(DecrementPlayerSpeed(HUMAN_ACCEL_DEC,0) < ZERO) // 3 took too long 12/29/75
#endif
			{	// here if completely stopped
	// have him shuffle here -NO NO, could be QB looking to pass - must be handled externally
				return(FALSE);
			}
			else	// he's still moving a bit
			{		/* negative parameter means don't inc speed	*/
				CheckForReceiverContact(TryManyMovesPush(CPDirToGo-MAX_DIR));
			}
		}
//		TurnPlayerOptimal(CPDirToGo);		// updates CPFacing
		return(TRUE);
}



/*********************************************************************

					 T I M E     O U T S


*********************************************************************/

/****
WORD ControllerToTeam(WORD controllernum)	// returns teamslot (-1,0,1) based on controller num
{
EFFVAR i,j;

	if(controllernum < 0 || controllernum >= MAX_CONTROLLERS) // error
		return(-1);

	for(j=0; j<2; j++)
		for(i=0; i<MAX_USERS_PER_TEAM; i++)
			if(GameTeamData[j].ControllerNum[i] == controllernum)
				return (j);

	return(-1);	// must be CPU team-controllernum not in Team's controller array
}
*****/

BOOL LegalForTimeOut(WORD teamslotnum)
{
	if(  (teamslotnum < 0)	// error check
	  || (teamslotnum > 1)  // error check
	  || (PlayHappening())  // can't do it if playhappeneing
	  || (GetVBlankTimer(GAME_TIMER_NUM) == 0L)	// Qtr over
	  || PlayStateNum == PS_AIStalledNUM	//
	  )
		return (FALSE);	// could be from Pause in CPU vs CPU game.
	else
	{
		return (GameTeamData[teamslotnum].TimeOuts);
	}
}

BOOL LegalAndProperForTimeOut(WORD teamslotnum)	//human and CPU
{
	if(  (teamslotnum < 0)	// error check
	  || (teamslotnum > 1)  // error check
	  || (PlayHappening())  // can't do it if playhappeneing
	  || (!GameClockRunning())	// not proper if clock stopped
	  || (GetVBlankTimer(GAME_TIMER_NUM) == 0L)	// Qtr over

	  )
		return (FALSE);	// could be from Pause in CPU vs CPU game.
	else
	{
		return (GameTeamData[teamslotnum].TimeOuts);
	}
}

WORD TimeOutDisplayValue(WORD teamslotnum)	// display nothing if -1, else num
{
	if(  (teamslotnum < 0)	// error check
	  || (teamslotnum > 1)  // error check
	  )
		return (-1);	// could be from Pause in CPU vs CPU game.
	else
	{
		return (GameTeamData[teamslotnum].TimeOuts);
	}
}



void CallTimeOut(WORD teamslotnum)	// will stop clock
{	// called by PAUSE screen or CPU coaching AI
	// WARNING - TimeOut can be called at any time!!!!

	if(LegalForTimeOut(teamslotnum))
	{
		GameTeamData[teamslotnum].TimeOuts--;
		StopGameClock();
		InitPlayClock(); // reset playclock at beginning - don't start bug #102

		AnnouncerSayTimeOut(teamslotnum);	// if right after play, will appended to any pending phrase


//		if(PlayStateNum > PS_WaitForPlayStartNUM && PlayStateNum < PS_PlayHappeningNUM)
		if(PlayStateNum < PS_PlayHappeningNUM	// mod. 10/20/96 to reset all PCall
			|| PlayStateNum == PS_InHuddleNUM
		  )
		{	// can't do here - must do in main loop (if paused)
			SetBit(MoreEventFlags,NEED_FORCED_TIMEOUT_BFLAG);


			ClearPlayInfoTextBuffers();
			sprintf(PlayInfoText1,"%s call Time Out  -  %d Remaining",
				 GameTeamData[teamslotnum].STD.TeamNickName,GameTeamData[teamslotnum].TimeOuts);
/*
		// tell playcall that both teams need to pick a new play
			ResetPlayNums();
			SetPlayState(PS_PlayOverNUM);	// do end of play- bug # 2822
//			NextPlayType = PlayType;	//T.O. on Expt would
			ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// no COP if this is extra point

			SetNewRefAnim(-2,AI_REF_WAVEARMS_NUM);
			SetRefStartX(StartBallX - 3*YARDS);
*/
		}
		else
		{	// play just ended
			// overwrite Line 2 info
			sprintf(PlayInfoText2,"%s call Time Out  -  %d Remaining",
			 GameTeamData[teamslotnum].STD.TeamNickName,GameTeamData[teamslotnum].TimeOuts);

		}
#if PC_ALWAYS_MODE
		printf("\n%s call Time Out - %d",
			 GameTeamData[teamslotnum].STD.TeamNickName,GameTeamData[teamslotnum].TimeOuts);
#endif
	}
}


void CheckForPausedTimeOut(void)	// in main loop
{	// if called TO from PAUSE during PlayCall or Before Snap

	if(MoreEventFlags & NEED_FORCED_TIMEOUT_BFLAG
	   && PlayStateNum !=PS_AIStalledNUM)
	{
		ResetBit(MoreEventFlags,NEED_FORCED_TIMEOUT_BFLAG);

//		sprintf(PlayInfoText1,"%s call Time Out  -  %d Remaining",
//			 GameTeamData[teamslotnum].STD.TeamNickName,GameTeamData[teamslotnum].TimeOuts);
		PlayInfoText2[0] = NULL;	// clear 2nd line Text Display buffer

	// tell playcall that both teams need to pick a new play
		ResetPlayNums();
		SetPlayState(PS_PlayOverNUM);	// do end of play- bug # 2822
//		NextPlayType = PlayType;	//T.O. on Expt would
		ResetBit(PlayOverFlags,NEED_COP_BFLAG);	// no COP if this is extra point

		SetNewRefAnim(-2,AI_REF_WAVEARMS_NUM,NO_PENALTY);
		SetRefStartX(StartBallX - 3*YARDS);
	}
}


/*************************************************************************

				Logical  Graphics Converter

	AI (logical) animations tables allow a logical
	animation to be made up of different physical animations.
	E.G.  the 4 frame logical "funky dance" animation could be
	made up of:

		PG_STAND,2		// physical(actual) standing frame #2
		PG_RUNNING,4    // physical running frame #4
		PG_KICK,3       // physical kicking frame #3
		PG_BLOCK,0      // physical blocking frame #0

	See file "FBAI2Grp.h"
	Also handles offsets (mainly Z height) on some anims.


	Modified 4/1/96 - only does 1 team at a time

*************************************************************************/

extern struct Point3D NOOffsets[];

extern void *AIGraphicOffsetTable[];




void ConvertCurrentPlayerAIToActualGraphics(void)
{
struct actualgraphics *gptr;
struct Point3D *goffptr;

	if(CPAIGraphicState >= MAX_AI_GRAPHICS)	// error check
	{
#if	PC_ERROR_MODE	/*  error checking  at DOS level */
		printf("\nIllegal AIGraphicState-%d, guy = %d",CPAIGraphicState,gPNum);
#endif
		return;
	}

	gptr = AIToGraphicTable[CPAIGraphicState];
	goffptr = AIGraphicOffsetTable[CPAIGraphicState];

	CPGraphicState = (gptr+CPAIGraphicSequence)->GraphicNum;
	CPGraphicSequence = (gptr+CPAIGraphicSequence)->GraphicSeq;

#if 	PC_ERROR_MODE	/*  error checking  at DOS level */
	if( (CPGraphicState >= MAX_PG_GRAPHICS)
		  ||(CPGraphicSequence >= NumFramesPerPlayerGraphic[CPGraphicState])
		  )
		{
			printf("\npAnim ERROR #%d, pframe#%d, guy =%d, AIgs = %d,AIFnum=%d",
						CPGraphicState,CPGraphicSequence,gPNum,
						CPAIGraphicState,CPAIGraphicSequence);
			getch();
			DebugScreen();
			if( CPGraphicState >= MAX_PG_GRAPHICS)
				CPGraphicState = CPGraphicSequence = 0;	// correct the error
			else if( (CPGraphicSequence >= NumFramesPerPlayerGraphic[CPGraphicState])
			   || CPGraphicSequence < ZERO )
				 CPGraphicSequence = 0;	// correct the error

		}
#endif

	if(goffptr != NOOffsets)
	{
		CPXPos += (goffptr+CPAIGraphicSequence)->X;
		CPYPos += (goffptr+CPAIGraphicSequence)->Y;
		CPZPos += (goffptr+CPAIGraphicSequence)->Z;
	}

	if(CPZPos > 0xf000)	// it's a signed word - don't go underground
		CPZPos = ZERO;


}




void ConvertAIToActualGraphics(WORD teamtype)
{
//struct actualgraphics *gptr;
//struct Point3D *goffptr;
EFFVAR low, high;


	if(teamtype == 0)
	{
		low = 0;
		high = 11;
	}
	else
	{
		low = 11;
		high = 23;		// includes ref

	}

	for(gPNum=low; gPNum<high; gPNum++)		// includes ref
	{
		ConvertCurrentPlayerAIToActualGraphics();
	}

}


/*  must fill at run time as compiler can't figure it out during compile time */
void FillMaxAIGraphicSeqArray(void)
{
EFFVAR i,j;
struct actualgraphics *gptr;

	for(i=0; i< MAX_AI_GRAPHICS; i++)
	{
		gptr = AIToGraphicTable[i];
		j = 0;
		while( (UBYTE)(gptr+j)->GraphicNum != 0xff)	// kludgy BYTE logic
			j++;
		MaxAIFrames[i] = --j;	// max if 12 frames is 11 (0-11)

	}
}







/**************************************************************************

						 A U D I B L E S

**************************************************************************/
#ifdef SATURNMODE
 #define AUDIBLE_BUTTON  		 JPADRa
 #define AUDIBLE_SELECT_BUTTON1  JPADRa
 #define AUDIBLE_SELECT_BUTTON2  JPADRb
 #define AUDIBLE_SELECT_BUTTON3  JPADRc
 #define AUDIBLE_CANCEL_BUTTON   JPADRy
#else // psx or PC
 #define AUDIBLE_BUTTON  		JPADsquare
 #define AUDIBLE_SELECT_BUTTON1  JPADsquare
 #define AUDIBLE_SELECT_BUTTON2  JPADtriangle
 #define AUDIBLE_SELECT_BUTTON3  JPADcircle
 #define AUDIBLE_CANCEL_BUTTON  	JPADx
#endif

#define AUDIBLE_SELECT_BUTTONS_MASK  (AUDIBLE_SELECT_BUTTON1 | \
			   AUDIBLE_SELECT_BUTTON2 | AUDIBLE_SELECT_BUTTON3 | AUDIBLE_CANCEL_BUTTON)


WORD AudibleColorSFX[2] = {COLOR0_SFX,COLOR1_SFX};
WORD AudibleNumSFX[4] = {NUM0_SFX,NUM1_SFX,NUM2_SFX,NUM2_SFX};


void DisplayAudibleInfo(void);


void HandleOffensiveAudible(void) // padnum is legal and offensive team captain
{
EFFVAR offform,newplay,rnum,captpad;


	if( (captpad = GameTeamData[PlayType == KICKOFF_PLAY ?
				 DefensiveSlotNum:OffensiveSlotNum].ControllerNum[0])
			< ZERO)
	{
		return;		// offense is CPU
	}

	if(OffAudibleIsActive())	// already active???
	{
		if(  (AIJoyPadData[captpad] & AUDIBLE_SELECT_BUTTONS_MASK)
			&& !(PreviousJoyReading[captpad] & AUDIBLE_SELECT_BUTTONS_MASK))
		{	// pressed one of the buttons
			if(AIJoyPadData[captpad] & AUDIBLE_CANCEL_BUTTON)
			{
	#if	PC_DEBUG_MODE
				printf(" Off. Aud. Canceled");
	#endif

			}
			else
			{
				if(AIJoyPadData[captpad] & AUDIBLE_SELECT_BUTTON1)
					newplay = 0;
				else if(AIJoyPadData[captpad] & AUDIBLE_SELECT_BUTTON2)
					newplay = 1;
				else
					newplay = 2;

				offform = PositionFormToPCFormTable[GameTeamData[OffensiveSlotNum].FormationNumber];

				GameTeamData[OffensiveSlotNum].PlayNum =
//					newplay = OffensiveAudibles[offform][newplay];
					newplay = TeamOffensiveAudible[OffensiveSlotNum][offform][newplay];

				for(gPNum =0; gPNum < 11; gPNum++)
				{
					SetNewScript(ThePlays[newplay].Script[gPNum].ScriptNumToDo);
				}
				PlayInitRoutines[ThePlays[newplay].PlayInitRoutineNumber].todo();

	#if	PC_DEBUG_MODE
				printf(" Selected %d",newplay);
	#endif
				TurnOffKickInterface();	//was on if 1st play was pooch kick
					// don't turn on if originally pooch
				ResetBit(PlayFlags,POS_ANYKICK_PLAY_BFLAG);

			}
			ResetBit(MoreEventFlags,OFF_AUDIBLE_ACTIVE_BFLAG);
			// make so other buttons won't work this frame
			PreviousJoyReading[captpad]	|= AUDIBLE_SELECT_BUTTONS_MASK;

		}
	}

// changed 11/5/96 - could be problem if inited too soon - sega crash
//	else if(PlayStateNum >= PS_InitPlayShiftNUM && PlayStateNum < PS_PlayHappeningNUM)
	else if(PlayStateNum >= PS_SaySetNUM
		   && PlayStateNum < PS_PlayHappeningNUM
		   && OkayForAudible()	// make sure graphic engine ready
		   )
	{		// audible not active, see if okay to start

		if( (AIJoyPadData[captpad] & AUDIBLE_BUTTON)
		  && !(PreviousJoyReading[captpad] & AUDIBLE_BUTTON))
		{	// pressed button - see if legal for audible in this formation

			offform = PositionFormToPCFormTable[GameTeamData[OffensiveSlotNum].FormationNumber];
			if(offform < 13)
			{
				// allow forced "hut" and "audible calls
				ResetBit(GameTeamData[OffensiveSlotNum].TeamFlags,NO_MORE_CPU_SAY_HUT_BFLAG);
				InitQBCallPlays();	// turns QB head side to side

				rnum = rand();	// figure what words to say
				AudibleSFX1 = AudibleColorSFX[rnum&1];
				AudibleSFX2 = AudibleNumSFX[(rnum>>1)&3];

				AudibleVoice = -1;		// start words in a few moments
				AIPlayTimerWait = AIPlayTimer + HALF_SECOND;// + (rand()&0x003f);
//				AudibleVoice = AIPlayEffectCheck(AudibleSFX1);

				SetBit(MoreEventFlags,OFF_AUDIBLE_ACTIVE_BFLAG);

#if	PC_DEBUG_MODE
				DisplayAudibleInfo();
//				printf("A");
#endif
			}
			else
			{
				//error beep
			}
		}
	}

}




/***********************************************************************/

void HandleDefensiveAudible(void)
{

#if 1
EFFVAR defform,newplay,captpad;


	if( (captpad = GameTeamData[PlayType == KICKOFF_PLAY ?
				 OffensiveSlotNum:DefensiveSlotNum].ControllerNum[0])
		 < ZERO)
	{
		return;		// exit if CPU team (captpad == -1)
	}

	if(DefAudibleIsActive())	// already active???
	{	// here if active (must be legal)
		if(  (AIJoyPadData[captpad] & AUDIBLE_SELECT_BUTTONS_MASK)
			&& !(PreviousJoyReading[captpad] & AUDIBLE_SELECT_BUTTONS_MASK))
		{	// pressed one of the buttons
			if(AIJoyPadData[captpad] & AUDIBLE_CANCEL_BUTTON)
			{
	#if	PC_DEBUG_MODE
				printf(" Def. Aud. Canceled");
	#endif

			}
			else
			{
				if(AIJoyPadData[captpad] & AUDIBLE_SELECT_BUTTON1)
					newplay = 0;
				else if(AIJoyPadData[captpad] & AUDIBLE_SELECT_BUTTON2)
					newplay = 1;
				else
					newplay = 2;

				// convert to actual form (if Dime 4 man line) with
				defform = PositionFormToPCFormTable[GameTeamData[DefensiveSlotNum].FormationNumber]
							- DEF_GOALINE_FORM_NUM;

				GameTeamData[DefensiveSlotNum].PlayNum =
					newplay = TeamDefensiveAudible[DefensiveSlotNum][defform][newplay];

				for(gPNum =11; gPNum < 22; gPNum++)
				{
					SetNewScript(ThePlays[newplay].Script[gPNum-11].ScriptNumToDo);
				}
				PlayInitRoutines[ThePlays[newplay].PlayInitRoutineNumber].todo();

	#if	PC_DEBUG_MODE
				printf(" Selected %d",newplay);
	#endif
			}
			ResetBit(MoreEventFlags,DEF_AUDIBLE_ACTIVE_BFLAG);
			// make so other buttons won't work this frame
			PreviousJoyReading[captpad]	|= AUDIBLE_SELECT_BUTTONS_MASK;

		}
	}
	  // else NOT active - see of okay to activate
	else if(PlayStateNum >= PS_SaySetNUM
		   && PlayStateNum < PS_PlayHappeningNUM
		   && OkayForAudible()	// make sure graphic engine ready
		   )
	{		// audible not active, see if okay to start

		if( (AIJoyPadData[captpad] & AUDIBLE_BUTTON)
		  && !(PreviousJoyReading[captpad] & AUDIBLE_BUTTON))
		{	// pressed button - see if legal for audible in this formation

			defform = PositionFormToPCFormTable[GameTeamData[DefensiveSlotNum].FormationNumber];
			if(   defform >= DEF_GOALINE_FORM_NUM
			   && defform <= DEF_DIME_FORM_NUM)
			{
				SetBit(MoreEventFlags,DEF_AUDIBLE_ACTIVE_BFLAG);

#if	PC_DEBUG_MODE
				DisplayAudibleInfo();
#endif
			}
			else
			{
				//error beep
			}
		}
	}
#endif

}


/***********************************************************************/


void HandleAudibleAudio(void)	// QB says "red 43" etc.
{

	if(AudibleVoice >= ZERO)	// playing first word (color)
	{
		if(!CheckEffect(AudibleVoice))
		{	// then done playing color - start number
			AIPlayQBSFX(AudibleSFX2);	//uses QB "pitch"

//			AIPlayEffectCheck(AudibleSFX2);	//start "number"
			AudibleVoice = -1;
		 /*  now set random time for next color */
//			AIPlayTimerWait = AIPlayTimer + HALF_SECOND + (rand()&0x003f);
//			AIPlayTimerWait = AIPlayTimer + HALF_SECOND + (rand()&0x007f);	//bug # 2187
			AIPlayTimerWait = AIPlayTimer + SECOND + (rand()&0x00ff);	//bug # 2281 (1-5 secs)

		}
	}
	else if(AIPlayTimer >= AIPlayTimerWait)	// time to start color?
	{
		AudibleVoice = AIPlayQBSFX(AudibleSFX1);	// say "Blue/red"
//		AudibleVoice = AIPlayEffectCheck(AudibleSFX1);	// say "Blue/red"
	}

}



BOOL DefAudibleIsActive(void)	// encapsulation for graphic/AI engines
{
	if(MoreEventFlags & DEF_AUDIBLE_ACTIVE_BFLAG)
		return(TRUE);
	else
		return(FALSE);
//	return(MoreEventFlags & DEF_AUDIBLE_ACTIVE_BFLAG);
}

BOOL OffAudibleIsActive(void) 	// encapsulation for graphic/AI engines
{
	if(MoreEventFlags & OFF_AUDIBLE_ACTIVE_BFLAG)
		return(TRUE);
	else
		return(FALSE);
//	return(MoreEventFlags & OFF_AUDIBLE_ACTIVE_BFLAG);
}


#if	PC_DEBUG_MODE

void DisplayAudibleInfo(void)
{
EFFVAR form;

	if(OffAudibleIsActive())	// already active???
	{
		form = PositionFormToPCFormTable[GameTeamData[OffensiveSlotNum].FormationNumber];

		printf("\nOff Audible Active");

// warning -  TeamOffensiveAudible is BYTES(8 bits) - will be problem if using defensive plays
		printf("\nS-%s",PlayNames[TeamOffensiveAudible[OffensiveSlotNum][form][0]]);
		printf("\nT-%s",PlayNames[TeamOffensiveAudible[OffensiveSlotNum][form][1]]);
		printf("\nC-%s",PlayNames[TeamOffensiveAudible[OffensiveSlotNum][form][2]]);
		printf("\nX-Cancel");

	}

	if(DefAudibleIsActive())	// already active???
	{
		form = PositionFormToPCFormTable[GameTeamData[DefensiveSlotNum].FormationNumber]
				- DEF_GOALINE_FORM_NUM;

		printf("\nDef Audible Active");

		printf("\nS-%s",PlayNames[TeamDefensiveAudible[DefensiveSlotNum][form][0]]);
		printf("\nT-%s",PlayNames[TeamDefensiveAudible[DefensiveSlotNum][form][1]]);
		printf("\nC-%s",PlayNames[TeamDefensiveAudible[DefensiveSlotNum][form][2]]);
		printf("\nX-Cancel");

	}

}
#endif



void InitDefaultAudiblePlays(void)
{	// load default ROM audibles
EFFVAR i,j;

	for(i=0; i<MAX_OFFFORMS_FOR_AUDIBLES; i++)
	{
		for(j=0; j<MAX_PLAYS_PER_AUDIBLEFORM; j++)
		{
			TeamOffensiveAudible[0][i][j] = TeamOffensiveAudible[1][i][j] =
				OffensiveAudibles[i][j]; // each form has 3 audibles
		}
	}

	for(i=0; i<MAX_DEFFORMS_FOR_AUDIBLES; i++)
	{
		for(j=0; j<MAX_PLAYS_PER_AUDIBLEFORM; j++)
		{
			TeamDefensiveAudible[0][i][j] = TeamDefensiveAudible[1][i][j] =
				DefensiveAudibles[i][j]; // each form has 3 audibles
		}
	}

}



WORD GetTrueYardline(void)	// returns 1-50
{
EFFVAR yardline;

	if(StartBallX > MID_FIELDX)
	{
		yardline = 100 - (StartBallX-DEF_GOAL_LINE)/YARD;
	}
	else
	{
		yardline = (StartBallX-DEF_GOAL_LINE)/YARD;

	}
	return(yardline);
}



/**************************************************************************

	  Types of Easter Egg/ Edited Formations

	stored in 	GameTeamData[0/1].STD.Formations[off/def][6];

  VALUE	 OFF			DEF			comment

	0   illegal     illegal     index 0 means never use this
	1   TeamXEdited illegal		used the edited plays (but not on defense)
	2   Easter eggs Easter eggs	debug plays/ off = OffEaster0NUM, def = DefEaster0NUM,
	3   Wishbone    illegal		"hidden" formation
	4   Fake edited illegal     uses default plays at TeamXEdited

****/

#define MAX_EXTRA_FORMS 6
WORD EditedFormations[2][2][MAX_EXTRA_FORMS] = {
	-1,TEAM0_EDIT_FORM_NUM,	OFF_EASTER_FORM_NUM,WISH_BONE_FORM_NUM,TEAM0_EDIT_FORM_NUM,POWER_I_FORM_NUM,
	-1,-1,					DEF_EASTER_FORM_NUM,-1, -1,-1,

	-1,TEAM1_EDIT_FORM_NUM,	OFF_EASTER_FORM_NUM,WISH_BONE_FORM_NUM,TEAM1_EDIT_FORM_NUM,POWER_I_FORM_NUM,
	-1,-1,					DEF_EASTER_FORM_NUM,-1, -1,-1
};

void InitEditedFormations(WORD team01)	// called at game init (or if status modified)
{	/* sets "GameTeamData[team01].STD.Formations[off/def][6]" based on
			"GameTeamData[team01].UseEditedPlays[off/def]"		*/
EFFVAR i, newform,epstatus;

	for(i=0; i<2; i++)	// do  off & def
	{
		epstatus = GameTeamData[team01].UseEditedPlays[i];
		newform = EditedFormations[team01][i][epstatus];
		if(newform < ZERO)	// if illegal (or not used), don't change
		{
			GameTeamData[team01].UseEditedPlays[i] = 0;
		#if	PC_ERROR_MODE
			if(epstatus != ZERO)
			{
				printf("\nIllegal edited init team = %d, editedstatus =%d",team01,epstatus);
//				getch();
			}
		#endif
		}
		else
		{
			GameTeamData[team01].STD.Formations[i][6] = newform;
		}
	}


}

void OverrideEditedSetting(WORD team01,WORD newsetting)
{

	if(newsetting < MAX_EXTRA_FORMS && newsetting > -1)	// legal value
	{
		if(GameTeamData[team01].UseEditedPlays[0] != 1)	// already edited??
		{
			GameTeamData[team01].UseEditedPlays[0] =
				GameTeamData[team01].UseEditedPlays[1] = newsetting;

			InitEditedFormations(team01);	//
		}
	}
}


void EditedPlaysAreNowLoaded(WORD team01)
{ 	// offensive edited plays only!

	GameTeamData[team01].UseEditedPlays[0] = 1;

}





void DoAITestCommand(WORD commandnum)	// called from debug screen
{

//	commandnum = commandnum;

	if(commandnum == 21)
	{
		ForcePenalties = FALSE;	// debug variable
	}
	else if(commandnum == 22)
	{
		ForcePenalties = TRUE;	// debug variable

	}
/*****
	else if(commandnum == 23)
	{
		HomeWin();
	}
	else if(commandnum == 22)
	{
		AIPlayEffectCheck(YOU_SUCK_SFX);
	}
******/
}


BYTE *ExtraPointPlayNames[4] = {
 "Fake PAT Run", "Extra Point", "Fake PAT Pass",
 "PAT Block"
};


BYTE *GetPlayName(WORD playnum)
{   // screens special case of Extra points or field goals
	if(ANY_EXPT_PLAY)
	{
		if(playnum >= SpecialTeamsFakeFGRunNUM
		  && playnum <= SpecialTeamsFakeFGPassNUM)
		{
			return(ExtraPointPlayNames[playnum-SpecialTeamsFakeFGRunNUM]);
		}

		else if(playnum == DefSpecialFGBlockNUM)
			return(ExtraPointPlayNames[3]);
	}

	return(PlayNames[playnum]);

}


BOOL ShowOffensiveBCName(void)	// if necessary
{
	if(BallCarrier < 11 && BallCarrier >= ZERO)
	{
		PlayerNameShow[0] = BallCarrier;
		return(TRUE);
	}
	return(FALSE);	// didn't show it
}

void UpdateShownPlayerNames(void)
{
#ifndef SATURNMODE		// save code on Saturn (not a feature)
EFFVAR i,cntl;

	for(i=0; i < 8; i++)	// clear everybody
		PlayerNameShow[i] =  NOBODY;

	if(GameOptions[GAME_OPTNS_SHOW_NAMES] == OPTION_OFF)
		return;	// no names

	/*----  Defense   ------*/

	for(i=0; i < 4; i++)	// defense - humans only
	{
		if( (cntl = GameTeamData[DefensiveSlotNum].ControllerNum[i]) != NO_CONTROLLER)
		{
			PlayerNameShow[i+4] =  ControlWhichPlayer[cntl];
		}
		else if(i==0 && BallCarrier > 10)	// def BC on CPU team
			PlayerNameShow[4] =  BallCarrier;
	}


	/*----  Offense   ------*/

	if(!ShowOffensiveBCName())	// default - show BC
	{
		PlayerNameShow[0] = 0;	// IF NO bc, show QB or punter

	}

	if(PlayFlags & POS_FG_PLAY_BFLAG)	// or Ex pt
	{
		if(!ShowOffensiveBCName())
		{
			PlayerNameShow[1] = 4;	// kicker=1, holder = 0
		}
	}
	else if(Receivers[0] != NOBODY)
	{
		for(i=1; i < 4; i++)
		{
			PlayerNameShow[i] =	Receivers[i-1];	//rec
		}
	}
	else
	{
		for(i=0; i < 4; i++)	// show all humans
		{
			if( (cntl = GameTeamData[OffensiveSlotNum].ControllerNum[i]) != NO_CONTROLLER)
			{
				PlayerNameShow[i] =  ControlWhichPlayer[cntl];
			}
/*			else if(i==0)	// CPU team
			{
				ShowOffensiveBCName();	// if necessary - uses PNS[0]
			}*/
		}
	}
#endif
}

#ifndef PSXMODE
BOOL OkayForAudible(void)
{
	return(TRUE);
}
#endif

/******************************
void ForceOT(void)
{
	if(AIJoyPadData[0] == (REC1_BUTTON|REC2_BUTTON|REC3_BUTTON))
	{
		TheQuarter= TheTrueQuarter = 4;
		GameTeamData[0].TotalScore = GameTeamData[1].TotalScore = 4;
		SetVBlankTimer(GAME_TIMER_NUM,5*45);

		SetBit(GameFlags, GAVE_2MIN_WARNING_BFLAG);
		StartGameClock();
	}
}
************************/


/*********************
void HomeWin(void)
{
	if(AIJoyPadData[0] == (REC1_BUTTON|REC2_BUTTON|REC3_BUTTON))
	{
		TheQuarter= TheTrueQuarter = 4;

//		GameTeamData[0].TotalScore = GameTeamData[1].TotalScore = 0;

		if(Q_HumanTeamMacro(0))
			GameTeamData[0].TotalScore = 55;
		else
			GameTeamData[1].TotalScore = 55;

		SetVBlankTimer(GAME_TIMER_NUM,5*45);	// 5 sec

		SetBit(GameFlags, GAVE_2MIN_WARNING_BFLAG);
		StartGameClock();
	}
}

***************/

/*************************  end of  file - FBAIMAIN.C  *********************/
