/**************************************************************


					FBPlays.C

	PROGRAMMER AUTHOR: M. Knauerkraut       Start Date: 3/8/95
	PLAY DESIGNER: Bobby "The" King

	Modify Date: All the time


	Copyright 1995  GameTek, Inc.



	This file contains all plays and their scripts.

**************************************************************/



	#include  "fbequ.h"

	#include  "fbplays.h"
	#include  "fbforms.h"


#define	HUDDLE_WAIT	10 //3*QUARTER_SECOND	// actual time to wait before breaking huddle

#define DO_NOTHING  \
{   Wait4SnapNUM, \
		DoNothingNUM  };


#define GoUpField(x) RunToRelNUM,EAST_DIR,(x)*YARDS,DONT_CARE



#define RunUpToLOSMACRO  RunToRelSBNUM,EAST_DIR,0*YARDS,DONT_CARE



#define EDITEDPLACEHOLDER	\
PLAY(ProSetLongBomb) {		\
	PASS_DEEP,				\
	SetReceivers231451NUM, 	\
	PROSET_FORM_NUM,        \
/*  QB  */  QBDropBackDeepNUM, \
/* RR  */  MotionLeft_RecStreakShortNUM, \
/*  LR  */  RecStreakNUM,  \
/*  RTE */  RecChairLeft5NUM, \
/*  FB  */  RBPassBlockRightNUM, \
/*  HB  */  RBPassCircleLeftNUM, \
/*  RT  */  OLPassBlockNUM,      \
/*  LT  */  OLPassBlockNUM,      \
/*  RG  */  OLPassBlockNUM,      \
/*  LG  */  OLPassBlockNUM,      \
/*  CENT*/  OLPassBlockNUM       \
END_PLAY_DS



/*****************************************************************

		FOOTBALL   A.I.   NAMING CONVENTIONS

	A "PLAY" is made up of 11 "SCRIPT"s (each player has a SCRIPT)
	A "SCRIPT" is made up of various "STATE"s e.g. RunTo, Wait,
		LookForReceiver,

	The levels of Player A.I. are:
	1) Lowest level - do this first- "ACTION"s -
		a move that once started must be completed
		e.g. falling down, getting up, turning

	2) 2nd level - to be done if no ACTIONs pending  - "STATE"

	3) 3rd level - usually done at end of STATE - "SMARTS"
		this will allow a player to change SCRIPTS


	NOTE: Human controlled players don't do level 2 or 3.


*****************************************************************/



/**********************************************************************



				 S T A T E S   O F   S C R I P T

	These are the STATEs that make up the different scripts.
	The scripts are an array of WORDS referenced by a pseudo
	instruction pointer for each Player on the field (PScriptPtr).

	The first entry is a State Number which is then used as an
	index into the AllStates array. This is an array of pointers
	to the actual functions - all functions take and return no
	parameters - all parameters are referenced by the functions
	themselves using the pseudo instruction pointer.  These
	functions will increase the PScriptPtr to the next State
	when the current State is complete.

--------------------------------------------------------------*/


#define fsp(xyz)  extern void (xyz)(void);

		#include	"FBStates.h"		// as externals

#undef	fsp



/*--------------  state  function  pointers   ---------------*/

struct State  AllStates[] ={

#define fsp(xyz)  xyz,

		#include	"FBStates.h"		// as actual function names

#undef	fsp


};

/*------------  state function "Numbers"   ----------------*/

enum STATE_NUMS {

#define fsp(xyz)  xyz##NUM,

		#include	"FBStates.h"		// as handles (intergers)
	MAX_STATES
#undef fsp



};





/******************  DEFINES  ***************************/

#define SPEEDCHANGE		0


#define	PASSTIMER80			80+SPEEDCHANGE
#define	PASSTIMER79			79+SPEEDCHANGE
#define	PASSTIMER78			78+SPEEDCHANGE
#define	PASSTIMER77			77+SPEEDCHANGE
#define	PASSTIMER76			76+SPEEDCHANGE
#define	PASSTIMER75			75+SPEEDCHANGE
#define	PASSTIMER74			74+SPEEDCHANGE
#define	PASSTIMER73			73+SPEEDCHANGE
#define	PASSTIMER72			72+SPEEDCHANGE
#define	PASSTIMER71			71+SPEEDCHANGE
#define	PASSTIMER70			70+SPEEDCHANGE
#define	PASSTIMER69			69+SPEEDCHANGE
#define	PASSTIMER68			68+SPEEDCHANGE
#define	PASSTIMER67			67+SPEEDCHANGE
#define	PASSTIMER66			66+SPEEDCHANGE
#define	PASSTIMER65			65+SPEEDCHANGE
#define	PASSTIMER64			64+SPEEDCHANGE
#define	PASSTIMER63			63+SPEEDCHANGE
#define	PASSTIMER62			62+SPEEDCHANGE
#define	PASSTIMER61			61+SPEEDCHANGE
#define	PASSTIMER60			60+SPEEDCHANGE
#define	PASSTIMER59			59+SPEEDCHANGE
#define	PASSTIMER58			58+SPEEDCHANGE
#define	PASSTIMER57			57+SPEEDCHANGE
#define	PASSTIMER56			56+SPEEDCHANGE
#define	PASSTIMER55			55+SPEEDCHANGE
#define	PASSTIMER54			54+SPEEDCHANGE
#define	PASSTIMER53			53+SPEEDCHANGE
#define	PASSTIMER52			52+SPEEDCHANGE
#define	PASSTIMER51			51+SPEEDCHANGE
#define	PASSTIMER50			50+SPEEDCHANGE
#define	PASSTIMER49			49+SPEEDCHANGE
#define	PASSTIMER48			48+SPEEDCHANGE
#define	PASSTIMER47			47+SPEEDCHANGE
#define	PASSTIMER46			46+SPEEDCHANGE
#define	PASSTIMER45			45+SPEEDCHANGE
#define	PASSTIMER44			44+SPEEDCHANGE
#define	PASSTIMER43		 	43+SPEEDCHANGE
#define	PASSTIMER42			42+SPEEDCHANGE
#define	PASSTIMER41			41+SPEEDCHANGE
#define	PASSTIMER40			40+SPEEDCHANGE
#define	PASSTIMER39			39+SPEEDCHANGE
#define	PASSTIMER38			38+SPEEDCHANGE
#define	PASSTIMER37			37+SPEEDCHANGE
#define	PASSTIMER36			36+SPEEDCHANGE
#define	PASSTIMER35			35+SPEEDCHANGE
#define	PASSTIMER34			34+SPEEDCHANGE
#define	PASSTIMER33			33+SPEEDCHANGE
#define	PASSTIMER32			32+SPEEDCHANGE
#define	PASSTIMER31			31+SPEEDCHANGE
#define	PASSTIMER30			30+SPEEDCHANGE
#define	PASSTIMER29			29+SPEEDCHANGE
#define	PASSTIMER28			28+SPEEDCHANGE
#define	PASSTIMER27			27+SPEEDCHANGE
#define	PASSTIMER26			26+SPEEDCHANGE
#define	PASSTIMER25			25+SPEEDCHANGE
#define	PASSTIMER24			24+SPEEDCHANGE
#define	PASSTIMER23			23+SPEEDCHANGE
#define	PASSTIMER22			22+SPEEDCHANGE
#define	PASSTIMER21			21+SPEEDCHANGE
#define	PASSTIMER20			20+SPEEDCHANGE
#define	PASSTIMER19			19+SPEEDCHANGE
#define	PASSTIMER18			18+SPEEDCHANGE
#define	PASSTIMER17			17+SPEEDCHANGE
#define	PASSTIMER16			16+SPEEDCHANGE
#define	PASSTIMER15			15+SPEEDCHANGE
#define	PASSTIMER14			14+SPEEDCHANGE
#define	PASSTIMER13			13+SPEEDCHANGE
#define	PASSTIMER12			12+SPEEDCHANGE
#define	PASSTIMER11			11+SPEEDCHANGE
#define	PASSTIMER10			10+SPEEDCHANGE
#define	PASSTIMER9			9+SPEEDCHANGE
#define	PASSTIMER8			8+SPEEDCHANGE
#define	PASSTIMER7			7+SPEEDCHANGE
#define	PASSTIMER6			6+SPEEDCHANGE
#define	PASSTIMER5			5+SPEEDCHANGE
#define	PASSTIMER4			4+SPEEDCHANGE
#define	PASSTIMER3			3+SPEEDCHANGE
#define	PASSTIMER2			2+SPEEDCHANGE
#define	PASSTIMER1			1+SPEEDCHANGE










#define SCRIPT(xyz) WORD (xyz)[] =




/****************  THE   SCRIPTS   **************************/

/****************  Offense ***************/
/*****Special Teams and Miscellaneous*****/


SCRIPT (DoNothingScript)
{
	DoNothingNUM
};



SCRIPT (KOKicker)
{
	Wait4SnapNUM,

	RunToRelNUM,
	WEST_DIR,-3.25*YARDS,DONT_CARE,

	RunToRelSBNUM,
//	WNW_DIR,2*YARDS,4*YARDS,
	WNW_DIR,2*HALFYARD,4*YARDS,		// modified 1/18/96 for new kicker graphics

	DefKickerKickOffNUM,
//	PShuffleWaitNUM,  8*QUARTERSEC,
//	PShuffleWaitNUM,  6*QUARTERSEC,	// bug # 2351 - no wait
	ChaseBallNUM
};




SCRIPT(PunterScript)
{
	QBSGSnapNUM,
	PunterGetSGSnapNUM,	// punter must immediately go to punt ACTION
//	QBGetSGSnapNUM,
//	PuntStateNUM,
	ChaseBallNUM
//	QBWatchEOPNUM
};

SCRIPT(PunterScriptFakeRun)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};


SCRIPT(FieldGoalScript)
{
	Wait4SnapNUM,
//	PShuffleWaitNUM, 1*QUARTERSEC,	removed 6/25/96 mjk
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1.25*YARDS,
	RunToRelNUM,
	ESE_DIR,1*YARDS,DONT_CARE,
	OffKickerKickBallNUM,
	QBWatchEOPNUM
};

SCRIPT(FieldGoalHold)
{
//	WaitForReadyNUM,
	SetHolderGraphicsStateNUM,
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	KickHoldNUM,
	QBWatchEOPNUM
};




SCRIPT(QBFakeFGPass)
{
	SetHolderGraphicsStateNUM,
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};




SCRIPT(PuntingTeamEnd)
{
	Wait4SnapNUM,
	RunToRelRandomXNUM,
	EAST_DIR,30*YARDS,DONT_CARE,
	ChaseBallNUM
};

SCRIPT(SpecialTeamRunRight)
{
	QBSGSnapNUM,
	RunToRelNUM,
	NE_DIR,QTR_YARD,-QTR_YARD, 	// must time so this ends before hike past
	QBGetSGSnapNUM,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3*YARDS,
	RunUpToLOSMACRO,
	BCAvoidNUM
};


SCRIPT(SpecialTeamRunLeft)
{
//	QBSGSnapNUM,
//	QBGetSGSnapNUM,
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,1*YARDS,1*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelNUM,
	NNW_DIR,DONT_CARE,-1*YARDS,
//	RunToRelNUM,
//	NNW_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	ENE_DIR,2*YARDS,DONT_CARE,
	RunUpToLOSMACRO,
	BCAvoidNUM
};


#define KOTACKLER_WAIT 3*QUARTERSEC
SCRIPT(KickoffTackler)
{
	Wait4SnapNUM,
	PShuffleWaitNUM,  KOTACKLER_WAIT,
	TestState1NUM,	// does SetAI(ChaseBallIfClose);
	RunToRelNUM,
	WEST_DIR,-40*YARDS,DONT_CARE,
	ChaseBallNUM
};


SCRIPT(KickoffMiddleTackler)
{
   Wait4SnapNUM,
	PShuffleWaitNUM,  KOTACKLER_WAIT,
	TestState1NUM,		// does SetAI(ChaseBallIfClose);
	RunToRelNUM,
	WEST_DIR,-15*YARDS,DONT_CARE,
//	PShuffleWaitNUM, 1*QUARTERSEC,
	ChaseBallNUM
};


SCRIPT(KickoffReturner)
{
	Wait4SnapNUM,
//	InitKickReturnerNUM,	   // Run to where ball is going to land
	PShuffleWaitNUM, 12*QUARTERSEC,		  //ditto
	KickReturnerGetKickStateNUM,KR_ALL,	/* used by receiver to chase ball being passed	*/
	BCAvoidNUM
};



SCRIPT(KickoffReturnerRight)
{
 Wait4SnapNUM,
//	InitKickReturnerNUM,	   // Run to where ball is going to land
	PShuffleWaitNUM, 10*QUARTERSEC,
	KickReturnerGetKickStateNUM,KR_RIGHT,	/* used by receiver to chase ball being kicker	*/
	RunToRelNUM,
	SE_DIR, 7*YARDS, 7*YARDS,
	BCAvoidNUM
};



SCRIPT(KickoffReturnerLeft)
{
 Wait4SnapNUM,
//	InitKickReturnerNUM,	   // Run to where ball is going to land
	PShuffleWaitNUM, 10*QUARTERSEC,
	KickReturnerGetKickStateNUM,KR_LEFT,	/* used by receiver to chase ball being kicker	*/
	RunToRelNUM,
	NE_DIR, 7*YARDS, 7*YARDS,
	BCAvoidNUM
};



SCRIPT(KOWedgeMiddle)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 5*QUARTERSEC,
	RunBackwardsStateNUM,
	WEST_DIR,-2*YARDS,DONT_CARE,
	PShuffleWaitNUM, 7*QUARTERSEC,
	BeBlockerNUM
};



SCRIPT(KOUpMan)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 12*QUARTERSEC,
	CheckForOnsideStateNUM,
//	PShuffleWaitNUM, 4*QUARTERSEC,
//	RunBackwardsStateNUM,
//	WEST_DIR,-4*YARDS,DONT_CARE,
	RunToRelNUM, 					// change 12/21/95 mjk
	WEST_DIR,-18*YARDS,DONT_CARE,   // have them run back far & fast
	BeBlockerNUM
};




SCRIPT(KOWedgeBackLeft)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 7*QUARTERSEC,
//	RunToRelNUM,
//	NW_DIR,-4.75*YARDS,-.75*YARDS,
	RunToRelNUM,
	NE_DIR, .25*YARDS,-5*YARDS,
	BeBlockerNUM
};


SCRIPT(KOWedgeBackRight)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 7*QUARTERSEC,
//	RunToRelNUM,
//	SW_DIR,-4.75*YARDS,1*YARDS,
//	PShuffleWaitNUM, 11*QUARTERSEC,
	RunToRelNUM,
	SE_DIR,.25*YARDS,5*YARDS,
	BeBlockerNUM
};



SCRIPT(KOWedgeLeft)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 6*QUARTERSEC,
	RunToRelNUM,
	NW_DIR,-5.75*YARDS,-.75*YARDS,
	PShuffleWaitNUM, 4*QUARTERSEC,
//	RunToRelNUM,
//	NE_DIR, .5*YARDS,-5*YARDS,
	BeBlockerNUM
};


SCRIPT(KOWedgeRight)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 6*QUARTERSEC,
	RunToRelNUM,
	SW_DIR,-5.75*YARDS,1*YARDS,
	PShuffleWaitNUM, 4*QUARTERSEC,
//	 RunToRelNUM,
//	 SE_DIR,.5*YARDS,5*YARDS,
	BeBlockerNUM
};








/**************************      QB     *****************************/


SCRIPT(QBDownBall)
{
	QBSnapNUM,
	ThrowDownNUM,
	QBWatchEOPNUM
};


SCRIPT(QBKneel)
{
	QBSnapNUM,
	KneelDownNUM,
	QBWatchEOPNUM		// safety only - shouldn't get here
};


SCRIPT(QBFakeDownBall)
{
	QBSnapNUM,
	FakeThrowDownNUM,
	RunToRelNUM,
	WEST_DIR,-5*YARDS,DONT_CARE,
	LookForReceiverNUM,
	QBWatchEOPNUM
};




SCRIPT (QBPABootLegRight)
{
	QBSnapNUM,
	RunToRelNUM,
	WEST_DIR,-2*YARDS,DONT_CARE,
	FakeHandoffNUM, SOUTH_DIR,		// parameter is direction facing
	RunToRelNUM,
	SSW_DIR,-2*YARDS,4*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1.5*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1.5*YARDS,
	RunToRelNUM,
	SE_DIR,DONT_CARE,2*YARDS,
	RunToRelSBNUM,
	EAST_DIR,-3*YARDS,DONT_CARE,
	BCAvoidNUM           // would like percent chance

};




SCRIPT(QBBootLegRight)
{
	QBSnapNUM,
	RunToRelNUM,
	WSW_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	SW_DIR,-1*YARDS,1*YARDS,
	RunToRelNUM,
	SSW_DIR,-2*YARDS,4*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1.5*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1.5*YARDS,
	RunToRelNUM,
	SE_DIR,DONT_CARE,2*YARDS,
	RunToRelSBNUM,
	EAST_DIR,-3*YARDS,DONT_CARE,

//	LookForReceiverNUM,	bug #2192
//	QBWatchEOPNUM

	BCAvoidNUM           // would like percent chance
};



SCRIPT(QBWaggleRight)
{
	QBSnapNUM,
	RunToRelNUM,
	WSW_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	SW_DIR,-1*YARDS,.5*YARDS,
	RunToRelNUM,
	SSW_DIR,-.5*YARDS,.5*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM

//	BCAvoidNUM            would like percent chance
};

SCRIPT(QBWaggleLeft)
{
	QBSnapNUM,
	RunToRelNUM,
	WNW_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	NW_DIR,-1*YARDS,-.5*YARDS,
	RunToRelNUM,
	NNW_DIR,-.5*YARDS,-.5*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM

//	BCAvoidNUM            would like percent chance
};




SCRIPT(QBBootLegLeft)
{
	QBSnapNUM,
	RunToRelNUM,
	WNW_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	NW_DIR,-2*YARDS,-2*YARDS,
	RunToRelNUM,
	NNW_DIR,-2*YARDS,-4*YARDS,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,0*YARDS,DONT_CARE,
	BCAvoidNUM
};





SCRIPT (QBSneak)
{
	QBSnapNUM,
	RunToRelSBNUM,
	ENE_DIR,2.5*YARDS,-1*YARDS,
	BCAvoidNUM
};

SCRIPT (QBDropBackShort)
{
	QBSnapNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-.5*YARDS,DONT_CARE,
	LookForReceiverNUM,
	QBWatchEOPNUM
};

SCRIPT (QBDropBackMedium)
{
	QBSnapNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	LookForReceiverNUM,
	QBWatchEOPNUM
};

SCRIPT (QBDropBackDeep)
{
	QBSnapNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-5*YARDS,DONT_CARE,
	LookForReceiverNUM,
	QBWatchEOPNUM
};


SCRIPT (QBDropBackVeryDeep)
{
	QBSnapNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-10*YARDS,DONT_CARE,
	LookForReceiverNUM,
	QBWatchEOPNUM
};



SCRIPT (QBHandOffRight) /*????????*/
{
	QBSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
//	TurnRightSWNUM,
	#if 1
		RunToRelNUM,
		SW_DIR,-QTR_YARD,QTR_YARD,
		QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	#else
		RunToRelNUM,
		SW_DIR,-9*QTR_YARD+20,9*QTR_YARD-20,
		HandOffBallNUM,
	#endif

/* following shouldn't happen (AI should force it) but just to be safe)*/
	QBWatchEOPNUM
};


SCRIPT (QBHandOffLeft)
{
	QBSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
//	TurnLeftNWNUM,
	#if 1
		RunToRelNUM,
		NW_DIR,-QTR_YARD,-QTR_YARD,
		QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	#else
		RunToRelNUM,
		SW_DIR,-9*QTR_YARD+20,9*QTR_YARD-20,
		HandOffBallNUM,
	#endif

/* following shouldn't happen (AI should force it) but just to be safe)*/
	QBWatchEOPNUM
};


SCRIPT (QBHandOffRightInsideFB) /*For runs up the middle*/
{
	QBSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
//  	RunBackwardsStateNUM,
// 	WEST_DIR,-.5*YARDS,DONT_CARE,
//	TurnRightSWNUM,
	RunToRelNUM,
	WEST_DIR,-3*QTR_YARD,DONT_CARE,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};


SCRIPT (QBHandOffLeftInsideFB)	 /*For runs up the middle */
{
	QBSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
//  	RunBackwardsStateNUM,
//	   WEST_DIR,-.5*YARDS,DONT_CARE,
//   TurnLeftNWNUM,
	RunToRelNUM,
	WEST_DIR,-3*QTR_YARD,DONT_CARE,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};





SCRIPT (QBHandOffRightInsideHB) /*For runs up the middle to HB*/
{
	QBSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
//  	RunBackwardsStateNUM,
// 	WEST_DIR,-.5*YARDS,DONT_CARE,
//	TurnRightSWNUM,
	RunToRelNUM,
	WEST_DIR,-1.5*YARD,DONT_CARE,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};


SCRIPT (QBHandOffLeftInsideHB)	 /*For runs up the middle */
{
	QBSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
//  	RunBackwardsStateNUM,
//	   WEST_DIR,-.5*YARDS,DONT_CARE,
//   TurnLeftNWNUM,
	RunToRelNUM,
	WEST_DIR,-1.5*YARD,DONT_CARE,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};



SCRIPT (QBPitchRight)
{
	QBSnapNUM,
//	TurnRightSWNUM,
//	RunToRelNUM,
//	SW_DIR,-.25*YARDS,.25*YARDS,
	PitchBallRightStateNUM,
	QBWatchEOPNUM
};


SCRIPT (QBQuickPitchRight)
{
	QBSnapNUM,
	PitchBallRightStateNUM,
	QBWatchEOPNUM
};


SCRIPT (QBPitchLeft)
{
	QBSnapNUM,
//	TurnLeftNWNUM,
//	RunToRelNUM,
//	NW_DIR,-.25*YARDS,-.25*YARDS,
   PitchBallLeftStateNUM,
	QBWatchEOPNUM
};

SCRIPT (QBQuickPitchLeft)
{
	QBSnapNUM,
//	TurnLeftNWNUM,
//	RunToRelNUM,
//	NW_DIR,-.25*YARDS,-.25*YARDS,
   PitchBallLeftStateNUM,
	QBWatchEOPNUM
};



/*****QB SHOTGUN (-6,0)*****/


SCRIPT(QBShotGunPassRegular)
{
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	LookForReceiverNUM,
	QBWatchEOPNUM
};



SCRIPT(QBShotGunPassDrop)
{
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-2*YARDS,DONT_CARE,
//	RunToRelNUM,
//	WEST_DIR,-2*YARDS,DONT_CARE,
	LookForReceiverNUM,
	QBWatchEOPNUM
};


SCRIPT(QBShotGunRollOutRight)
{
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};


SCRIPT(QBShotGunRollOutLeft)
{
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	RunToRelNUM,
	NNW_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};



SCRIPT(QBShotGunDoNothing)
{
	Wait4SnapNUM,
	PShuffleWaitNUM, 8*QUARTERSEC,
	QBWatchEOPNUM
};



SCRIPT(HBSnapRun)
{
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	RunToRelNUM,
	ESE_DIR,DONT_CARE,.25*YARDS,
	RunToRelNUM,
	EAST_DIR,2*YARDS,DONT_CARE,
	BCAvoidNUM,
};




SCRIPT(QBShotGunHandOff)
{
//	QBSGSnapNUM,
	QBSGSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
	QBGetSGSnapNUM,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};


SCRIPT(QBShotGunDrawHandOff)
{
//	QBSGSnapNUM,
//	QBGetSGSnapNUM,
	InitQBDrawPlayStateNUM,
	QBSGSnapThenHandOffNUM, /* sets AI to stop QB when ball handed off  */
	QBGetSGSnapNUM,
	QBLookToPassStateNUM, 1*QUARTERSEC,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};


SCRIPT(QBShovelPass)
{
	QBSGSnapNUM,
	QBGetSGSnapNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-.75*YARDS,DONT_CARE,
//	RunToRelNUM,
//	EAST_DIR,1*YARDS,DONT_CARE,
	PitchBallLeftStateNUM,
	QBWatchEOPNUM
};





SCRIPT(QBFakeFGPitch)
{
	SetHolderGraphicsStateNUM,
	QBSGSnapNUM,
	QBGetSGSnapNUM,
//	RunBackwardsStateNUM,
//	WEST_DIR,-2.25*YARDS,DONT_CARE,
//  RunToRelNUM,
//	EAST_DIR,1*YARDS,DONT_CARE,
	PitchBallLeftStateNUM,
	QBWatchEOPNUM
};



SCRIPT(QBRollOutRight)
{
	QBSnapNUM,
//	RunToRelNUM,
//	WNW_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WSW_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	SW_DIR,-1*YARDS,.5*YARDS,
	RunToRelNUM,
	SSW_DIR,-2*YARDS,2*YARDS,
//	RunToRelNUM,
//	SOUTH_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};


SCRIPT(QBRollOutLeft)
{
	QBSnapNUM,
	RunToRelNUM,
	WSW_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WNW_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	NW_DIR,-2*YARDS,-1*YARDS,
	RunToRelNUM,
	NNW_DIR,-2*YARDS,-3*YARDS,
//	RunToRelNUM,
//	NORTH_DIR,DONT_CARE,-3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};

SCRIPT (QBDrawMiddle)
{
	InitQBDrawPlayStateNUM,
	QBSnapThenHandOffNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	RunToRelSBNUM,
		NE_DIR,-7*YARDS,-.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT (QBDrawMiddleRight)
{
	InitQBDrawPlayStateNUM,
	QBSnapThenHandOffNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	RunToRelSBNUM,
		SE_DIR,-7*YARDS,-1*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT (QBDrawHandOffFive)
{
	InitQBDrawPlayStateNUM,
	QBSnapThenHandOffNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
   TurnLeftNWNUM,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};


SCRIPT (QBReverseHandOff)
{
	QBSnapThenHandOffNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-3.5*YARDS,DONT_CARE,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
	QBWatchEOPNUM
};


SCRIPT (QBDrawHandOffSeven)
{
	InitQBDrawPlayStateNUM,
   QBSnapThenHandOffNUM,
	RunBackwardsStateNUM,
	WEST_DIR,-6.5*YARDS,DONT_CARE,
	QBRunToFutureBCNUM,       // runtoFutureBC  - QBHandOff,
   QBWatchEOPNUM
};


SCRIPT (QBFleaFlicker)
{
   QBInitFleaFlickerNUM,
   QBSnapThenHandOffNUM,
//   QBInitFleaFlickerNUM,
   RunToRelNUM,
   WEST_DIR,-2.25*YARD,DONT_CARE,
   QBRunToFutureBCNUM       // runtoFutureBC  - QBHandOff,
//	QBWatchEOPNUM
};


SCRIPT (QBFleaFlickerPart2Script)
{
   QBFleaFlickerAfterHandOffNUM,
   RunBackwardsStateNUM,		// this works! (11/2/96) but RELATIVE
   WEST_DIR,-5*YARDS,DONT_CARE,	// not to STARTING BALL
//   RunToRelSBNUM,
//   WEST_DIR,-9*YARDS,DONT_CARE,
   QBFleaFlickerWaitForPitchNUM,
   LookForReceiverNUM,
   QBWatchEOPNUM
};


SCRIPT (QBPlayActionLeftHB)
{
	QBSnapNUM,
	RunToRelNUM,
	WEST_DIR,-2*YARD,DONT_CARE,

	FakeHandoffNUM, NORTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WEST_DIR,-1*YARD,DONT_CARE,
	RunBackwardsStateNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,


	LookForReceiverNUM,
	QBWatchEOPNUM
};



SCRIPT (QBPlayActionLeftFB)
{
	QBSnapNUM,

	RunToRelNUM,
	WEST_DIR,-1*YARD,DONT_CARE,

	FakeHandoffNUM, NORTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WEST_DIR,-1*YARD,DONT_CARE,
	RunBackwardsStateNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,


	LookForReceiverNUM,
	QBWatchEOPNUM
};



SCRIPT(QBPALeftRollOutRight)
{
	QBSnapNUM,
	RunToRelNUM,
	WEST_DIR,-1.5*YARD,DONT_CARE,
	FakeHandoffNUM, NORTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WNW_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WSW_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	SW_DIR,-2*YARDS,1*YARDS,
	RunToRelNUM,
	SSW_DIR,-2*YARDS,3*YARDS,
//	RunToRelNUM,
//	SOUTH_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};


SCRIPT(QBPALeftRollOutRightShort)
{
	QBSnapNUM,
	RunToRelNUM,
	WEST_DIR,-1.5*YARD,DONT_CARE,
	FakeHandoffNUM, NORTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WNW_DIR,-1*YARDS,DONT_CARE,
//	RunToRelNUM,
//	WEST_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WSW_DIR,-2*YARDS,DONT_CARE,
//	RunToRelNUM,
//	SW_DIR,-2*YARDS,1*YARDS,
//	RunToRelNUM,
//	SSW_DIR,-2*YARDS,3*YARDS,
//	RunToRelNUM,
//	SOUTH_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};





SCRIPT(QBPARightRollOutRight)
{
	QBSnapNUM,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	FakeHandoffNUM, SOUTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WNW_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	WSW_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	SW_DIR,-2*YARDS,1*YARDS,
	RunToRelNUM,
	SSW_DIR,-2*YARDS,3*YARDS,
//	RunToRelNUM,
//	SOUTH_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};







SCRIPT (QBPlayActionRightHB)
{
	QBSnapNUM,
//	QBRunToFutureFakeBCNUM,

//	RunToRelNUM,
//	WNW_DIR,-7*YARDS,DONT_CARE,

	RunToRelNUM,
	WEST_DIR,-2*YARDS,DONT_CARE,
//	TurnLeftNWNUM,
	FakeHandoffNUM, SOUTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WEST_DIR,-1*YARD,DONT_CARE,
	RunBackwardsStateNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,

	LookForReceiverNUM,
	QBWatchEOPNUM
};

SCRIPT (QBPlayActionBackHB)
{
	QBSnapNUM,
//	QBRunToFutureFakeBCNUM,

//	RunToRelNUM,
//	WNW_DIR,-7*YARDS,DONT_CARE,

	RunToRelNUM,
	WEST_DIR,-2*YARDS,DONT_CARE,
//	TurnLeftNWNUM,
	FakeHandoffNUM, WEST_DIR,		// parameter is direction facing

	RunToRelNUM,
	WEST_DIR,-1*YARD,DONT_CARE,
	RunBackwardsStateNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,

	LookForReceiverNUM,
	QBWatchEOPNUM
};


SCRIPT (QBPlayActionRightFB)
{
	QBSnapNUM,
//	QBRunToFutureFakeBCNUM,

//	RunToRelNUM,
//	WNW_DIR,-7*YARDS,DONT_CARE,

	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
//	TurnLeftNWNUM,
	FakeHandoffNUM, SOUTH_DIR,		// parameter is direction facing

	RunToRelNUM,
	WEST_DIR,-1*YARD,DONT_CARE,
	RunBackwardsStateNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,

	LookForReceiverNUM,
	QBWatchEOPNUM
};




/*****RB I-FORM Blocking (-7,0) or (-5,0) with 1.5 yard line splits*****/

SCRIPT(RBILeadBlock1)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-.75*YARDS,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlockPALeft)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-.75*YARDS,
	RunToRelSBNUM,
	EAST_DIR,-1*YARDS,DONT_CARE,
	WhoToPassBlockNUM,
	OLPassBlockDropBackNUM,
	BeBlockerNUM
};

SCRIPT(RBILeadBlockPARight)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,.75*YARD,
	RunToRelSBNUM,
	EAST_DIR,-1*YARDS,DONT_CARE,
	WhoToPassBlockNUM,
	OLPassBlockDropBackNUM,
	BeBlockerNUM
};



SCRIPT(RBILeadBlock2)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,.75*YARD,
	RunToRelNUM,
	EAST_DIR,-1*YARDS,DONT_CARE,
	WhoToPassBlockNUM,
	OLPassBlockDropBackNUM,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlock3)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1.25*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlock4)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1.25*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlock5)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1.75*YARD,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-1*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlock6)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1.75*YARD,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlock7)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-2.75*YARD,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1.75*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBILeadBlock8)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,3*YARD,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1*YARD,
	RunToRelNUM,
	SE_DIR,DONT_CARE,.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBIRun1)
{
	SetFutureBCHandoffStateNUM,
   Wait4SnapNUM,
//	RBTakeHandOffNUM,

	RunToRelSBNUM,NE_DIR,-7*YARDS,-.75*YARDS,
//		TakeHandOffNUM,

	RunToRelSBNUM,EAST_DIR,0,DONT_CARE,

	BCAvoidNUM
};

SCRIPT(RBIRun2)
{
//	RBTakeHandOffNUM,
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,

	RunToRelSBNUM,SE_DIR,-7*YARDS,3*QTR_YARD,
//    TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBIStepLeftRun3)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-1.75*YARDS,

//	RunToRelSBNUM,
//	NE_DIR,-7*YARDS,-1.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(RBIRun3)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	RunToRelSBNUM,
		NNE_DIR,-7*YARDS,-1.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBIRun4)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1*YARDS,
//	PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelSBNUM,
	SE_DIR,-7*YARDS,2.5*YARDS,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBIStepRightRun4)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1*YARDS,
//	PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelSBNUM,
	SE_DIR,-7*YARDS,2.5*YARDS,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBIRun5)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	RunToRelSBNUM,
		NNE_DIR,-7*YARDS,-3.25*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBIRun6)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	RunToRelSBNUM,
		SSE_DIR,-7*YARDS,3.25*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBIRun7)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
//	RunToRelSBNUM,
//	NNE_DIR,-7*YARDS,-5.5*YARDS,
//	TakePitchNUM,
	RunToRelSBNUM,
	NNE_DIR,-7*YARDS,-4.5*YARDS,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBIRun8)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-7*YARDS,1*YARDS,
	RunToRelNUM,
	SSE_DIR,-7*YARDS,2.25*YARDS,
	RunToRelNUM,
	SE_DIR,-7*YARDS,2.25*YARDS,
//	TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};





/*****RB Regular Blocking and Running (-7,0) or (-5,0) with 2.0 yard line splits*****/

SCRIPT(RBLeadBlock1)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-.5*YARDS,
	RunToRelNUM,
	EAST_DIR,7*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock2)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,.75*YARD,
	RunToRelNUM,
	EAST_DIR,7*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock3)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1.75*YARD,
	RunToRelNUM,
	EAST_DIR,7*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock4)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1.75*YARD,
	RunToRelNUM,
	EAST_DIR,7*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock5)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-2*YARD,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1*YARD,
	RunToRelNUM,
	EAST_DIR,7*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock6)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,2*YARD,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1*YARD,
	RunToRelNUM,
	EAST_DIR,1*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock7)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-3*YARD,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-2.5*YARD,
//	RunToRelNUM,
//	EAST_DIR,1*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBLeadBlock8)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3*YARD,
	RunToRelNUM,
	SE_DIR,DONT_CARE,2.5*YARD,
	RunToRelNUM,
	EAST_DIR,7*YARDS,DONT_CARE,
	LeadBlockerNUM
};

SCRIPT(RBRun1)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  #if 0
		RunToRelSBNUM,
		NE_DIR,-7*YARDS,-.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRun2)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
		RunToRelSBNUM,
		SE_DIR,-7*YARDS,.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRun28)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
		RunToRelSBNUM,
		SE_DIR,-7*YARDS,.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,-2*YARDS,DONT_CARE,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2.5*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	SE_DIR,1*YARDS,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(RBRun3)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
		RunToRelSBNUM,
		NE_DIR,-7*YARDS,-1.75*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRun4)
{
//	RBTakeHandOffNUM,
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,

	RunToRelSBNUM,SE_DIR,-7*YARDS,1.75*YARDS,
//    TakeHandOffNUM,
	RunToRelSBNUM,EAST_DIR,0,DONT_CARE,

	BCAvoidNUM
};

SCRIPT(RBRun5)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NNE_DIR,-7*YARDS,-3*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBMisDirRun5)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	RunToRelNUM,
	SSE_DIR,.25*YARDS,.25*YARDS,
	RunToRelSBNUM,
	NNE_DIR,-7*YARDS,-2*YARDS,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(RBRun6)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 1*QUARTERSEC,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		SSE_DIR,-7*YARDS,3*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBMisDirRun6)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelNUM,
	WEST_DIR,-1*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1*YARDS,
	RunToRelSBNUM,
	SE_DIR,-5*YARDS,3.0*YARDS,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBRun7)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
		RunToRelSBNUM,
		NNW_DIR,-1*YARDS,-1*YARDS,
		RunToRelSBNUM,
		NNE_DIR,-7*YARDS,-5.5*YARDS,
//		TakePitchNUM,
	RunToRelNUM,
	EAST_DIR,1*YARDS,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRun8)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,

	RunToRelSBNUM,SSE_DIR,-7*YARDS,5.5*YARDS,

//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBDrawRun)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0

//		PShuffleWaitNUM, 2*QUARTERSEC,
	ShuffleWaitTilIGetBallNUM,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBDrawRunStepLeft)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
	RunToRelNUM,
	NNE_DIR,-8*YARDS,-1*YARDS,
	RunToRelNUM,
	EAST_DIR,.25*YARDS,DONT_CARE,

//		PShuffleWaitNUM, 2*QUARTERSEC,
	ShuffleWaitTilIGetBallNUM,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};




SCRIPT(RBShotGunDrawRun)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
	RunToRelNUM,
	NNW_DIR,-8*YARDS,-1*YARDS,
	TurnRightSWNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(RBDrawRunStepRight)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
	RunToRelNUM,
	SSE_DIR,DONT_CARE,.5*YARDS,
//	RunToRelNUM,
//	EAST_DIR,.25*YARDS,DONT_CARE,

//		PShuffleWaitNUM, 4*QUARTERSEC,
	ShuffleWaitTilIGetBallNUM,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


#if 1
SCRIPT(RBFleaFlicker)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	PShuffleWaitNUM, 2*QUARTERSEC,
	RunToRelNUM,
	SE_DIR,3*QTRYARD,3*QTRYARD,	// move to side

	RunToRelNUM,
	EAST_DIR,2*HALFYARD,DONT_CARE,

	ShuffleWaitTilIGetBallNUM,

	RunToRelSBNUM,
	EAST_DIR,-7*HALFYARD,DONT_CARE,

	SetQBAsFBCStateNUM,
	PitchBallLeftStateNUM,
	QBWatchEOPNUM
};

#else
SCRIPT(RBFleaFlicker)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	PShuffleWaitNUM, 2*QUARTERSEC,
	RunToRelNUM,
	SE_DIR,1*YARDS,1*YARDS,
	RunToRelSBNUM,
	EAST_DIR,-3*YARDS,DONT_CARE,
	SetQBAsFBCStateNUM,
	PitchBallLeftStateNUM,
	QBWatchEOPNUM
	/*PitchToQB*/
};
#endif

/*****RB LEFT Blocking and Running(-5,-2.75)*****/

SCRIPT(RBLFleaFlicker)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	/*PitchToQB*/
	LeadBlockerNUM
};




SCRIPT(RBLLeadBlock1)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	ESE_DIR,-5*YARDS,-.75*YARDS,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock2)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SE_DIR,-5*YARDS,.75*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock3)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	ENE_DIR,-5*YARDS,-2.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock4)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SSE_DIR,-5*YARDS,2.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock5)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	NE_DIR,-5*YARDS,-3.75*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock6)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARDS,1*YARD,
	RunToRelSBNUM,
	SE_DIR,-5*YARDS,3.75*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock7)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	NNE_DIR,-5*YARDS,-5.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLLeadBlock8)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARDS,3*YARD,
	RunToRelSBNUM,
	SE_DIR,-5*YARDS,5.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBLRun1)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		ESE_DIR,-5*YARDS,-1*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBLRun2)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelNUM,
		SOUTH_DIR,DONT_CARE,.1*YARD,
		RunToRelNUM,
		SSE_DIR,DONT_CARE,.5*YARD,
		RunToRelSBNUM,
		SE_DIR,-5*YARDS,1*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBLRun3)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		ENE_DIR,-5*YARDS,-2.5*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBLRun4)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		SSE_DIR,-5*YARDS,2.5*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBHRun4)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,

	RunToRelSBNUM,
	SSW_DIR,DONT_CARE,-1*YARD,

	RunToRelSBNUM,
	SSE_DIR,DONT_CARE,2*YARD,

	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,

	BCAvoidNUM
};



SCRIPT(RBLRun5)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM,
	1*QUARTERSEC,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NE_DIR,-5*YARDS,-3.75*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBLRun6)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		SOUTH_DIR,-5*YARDS,1*YARD,
		RunToRelSBNUM,                                 
		SE_DIR,-5*YARDS,3.75*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBLCounterRun7)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	RunToRelSBNUM,
	SOUTH_DIR,ZERO,DONT_CARE,

	RunToRelSBNUM,NNE_DIR,-5*YARDS,-5.5*YARDS,

//	TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(RBCounterRun7)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,1.5*YARDS,

	RunToRelSBNUM,
	NNE_DIR,-5*YARDS,-5.5*YARDS,

//	TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(RBLRun7)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
//  if  0
		RunToRelSBNUM,
		NNE_DIR,-5*YARDS,-5.5*YARD,
//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};



SCRIPT(MotionRight_RBLRun8)
{
	SetFutureBCPitchStateNUM,

   WaitToGoInMotionNUM,  3*SECONDS,

   GoInMotionNUM,
   SOUTH_DIR,DONT_CARE,1*YARDS,

	Wait4SnapShuffleNUM,
//	RBTakePitchNUM,
//  if  0
		RunToRelSBNUM,
		SOUTH_DIR,-5*YARDS,3*YARD,
		RunToRelSBNUM,
		SE_DIR,-5*YARDS,5.5*YARD,
//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};




SCRIPT(RBLRun8)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
//  if  0
		RunToRelSBNUM,
		SOUTH_DIR,-5*YARDS,3*YARD,
		RunToRelSBNUM,
		SE_DIR,-5*YARDS,5.5*YARD,
//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

/*****RB RIGHT Blocking and Running (-5,2.75)*****/

SCRIPT(RBRLeadBlock1)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	NE_DIR,-5*YARDS,-1*YARDS,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock2)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	ENE_DIR,-5*YARDS,1*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock3)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	NNE_DIR,-5*YARDS,-2.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock4)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	EAST_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	ESE_DIR,-1.5*YARDS,DONT_CARE,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock5)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	NORTH_DIR,-5*YARDS,-1*YARD,
	RunToRelSBNUM,
	NE_DIR,-5*YARDS,-3.75*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock6)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SE_DIR,-5*YARDS,3.75*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock7)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	NORTH_DIR,-5*YARDS,-3*YARD,
	RunToRelSBNUM,
	NE_DIR,-5*YARDS,-5.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};

SCRIPT(RBRLeadBlock8)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SSE_DIR,-5*YARDS,5.5*YARD,
	RunUpToLOSMACRO,
	LeadBlockerNUM
};



SCRIPT(RBRRun1)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NE_DIR,-5*YARDS,-1*YARDS,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun2)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
	//  if  0
		PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelSBNUM,
		NNE_DIR,-5*YARDS,2*YARD,
	RunToRelSBNUM,
		ENE_DIR,-3*YARDS,2*YARD,
//		TakeHandOffNUM,
	   RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun3)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelNUM,
		NNW_DIR,-.5*YARDS,-1*YARD,
		RunToRelNUM,
		NORTH_DIR,DONT_CARE,-.5*YARD,
		RunToRelSBNUM,
		NNE_DIR,-5*YARDS,-2.5*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun4)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		ESE_DIR,-5*YARDS,2.5*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun5)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NORTH_DIR,-5*YARDS,-1*YARD,
		RunToRelSBNUM,
		NE_DIR,DONT_CARE,-3.75*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun6)
{
	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 1*QUARTERSEC,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		SE_DIR,-5*YARDS,3.75*YARD,
//		TakeHandOffNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun7)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NORTH_DIR,-5*YARDS,-3*YARD,
		RunToRelSBNUM,
		NE_DIR,-5*YARDS,-5.5*YARD,
//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};

SCRIPT(RBRRun8)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
//  if  0
		RunToRelSBNUM,
		SSE_DIR,-5*YARDS,5.5*YARD,
//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


SCRIPT(RBRRun8Delay)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
	PShuffleWaitNUM, 2*QUARTERSEC,
//	RBTakePitchNUM,
//  if  0
		RunToRelSBNUM,
		SSE_DIR,-5*YARDS,5.5*YARD,
//		TakePitchNUM,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM
};


/*****RB Pass Patterns (Generic for all RBs)*****/

SCRIPT(RBPassBlockRight)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,	// bug #1859 - must be AFTER Wait4Snap
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1.5*YARDS,
	BeBlockerNUM
};


SCRIPT(RBRollOutPassBlockRight)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARD,3.5*YARDS,
	RunToRelSBNUM,
	SSE_DIR,-4*YARD,5.5*YARDS,
//	PShuffleWaitNUM, 1*QUARTERSEC,
	BeBlockerNUM
};


SCRIPT(RBPassBlockRightFromLeft)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelSBNUM,
	SE_DIR,-7*YARD,-1.5*YARDS,
	RunToRelSBNUM,
	SSE_DIR,-7*YARD,0*YARDS,
	RunToRelSBNUM,
	SOUTH_DIR,-7*YARD,1*YARDS,
	RunToRelSBNUM,
	SSE_DIR,-7*YARD,2*YARDS,
	BeBlockerNUM
};


SCRIPT(RBPassBlockLeft)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-1.5*YARDS,
	BeBlockerNUM
};

SCRIPT(RBOptionPassRight)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};

SCRIPT(RBOptionPassLeft)
{
	SetFutureBCPitchStateNUM,
	Wait4SnapNUM,
//	RBTakePitchNUM,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	NNW_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NW_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NNW_DIR,DONT_CARE,-3*YARDS,
	LookForReceiverNUM,
	QBWatchEOPNUM
};

SCRIPT(RBPassBackRight)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER15,
	Wait4SnapNUM,
	RunToRelSBNUM,
	SSW_DIR,-5*YARDS,6*YARDS,
	RunToRelNUM,
	SSE_DIR,-5*YARDS,3*YARDS,
	RunToRelNUM,
	SE_DIR,-5*YARDS,3*YARDS,
	PShuffleWaitNUM, 4*QUARTERSEC,
	GoUpField(20),
	SaveQBMediumNUM
};

SCRIPT(RBPassBackLeft)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER15,
	Wait4SnapNUM,
	RunToRelSBNUM,
	NORTH_DIR,-5*YARDS,-6*YARDS,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-3*YARDS,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-3*YARDS,
	PShuffleWaitNUM, 4*QUARTERSEC,
	GoUpField(20),
	SaveQBMediumNUM
};

SCRIPT(RBPassCircleRight)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARDS,2*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3.5*YARDS,
	RunUpToLOSMACRO,
	RunToRelSBNUM,
	NNE_DIR,DONT_CARE,0,
	RunToRelNUM,
	WEST_DIR,-.5*YARDS,DONT_CARE,
	PShuffleWaitNUM, 4*QUARTERSEC,
	SaveQBShortNUM
};

SCRIPT(RBPassCircleLeft)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-3*YARDS,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-3.5*YARDS,
	RunUpToLOSMACRO,
	RunToRelSBNUM,
	SSE_DIR,DONT_CARE,0,
	RunToRelNUM,
	WEST_DIR,-.5*YARDS,DONT_CARE,
	PShuffleWaitNUM, 4*QUARTERSEC,
	SaveQBShortNUM
};



SCRIPT(MotionRight_RBPassCircleRight)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	 WaitToGoInMotionNUM,  3*SECONDS,
	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,4*YARDS,
	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARDS,2*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3.5*YARDS,
	RunUpToLOSMACRO,
	RunToRelSBNUM,
	NNE_DIR,DONT_CARE,0,
	RunToRelNUM,
	WEST_DIR,-.5*YARDS,DONT_CARE,
	PShuffleWaitNUM, 4*QUARTERSEC,
	SaveQBShortNUM
};



SCRIPT(MotionUpRight_RBPassCircleRight)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	 WaitForReadyNUM,
	GoInMotionBeforeMotionNUM,
	 EAST_DIR,-2.5*YARDS,DONT_CARE,
	 WaitToGoInMotionNUM,  2*SECONDS,
	GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,5*YARDS,
	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARDS,2*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,1.5*YARDS,
	RunUpToLOSMACRO,
	RunToRelSBNUM,
	NNE_DIR,DONT_CARE,0,
	RunToRelNUM,
	WEST_DIR,-.5*YARDS,DONT_CARE,
	PShuffleWaitNUM, 4*QUARTERSEC,
	SaveQBShortNUM
};




SCRIPT(RBPlayActionOutRight)
{
	InitRecParametersNUM,MEDIUM_BULLET_PASS,PASSTIMER34,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,1*YARDS,1*YARDS,
	RunUpToLOSMACRO,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,15*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	SaveQBMediumNUM
};

SCRIPT(RBPlayActionOutLeft)
{
	InitRecParametersNUM,MEDIUM_BULLET_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,1*YARDS,-1*YARDS,
//	RunUpToLOSMACRO,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-15*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	SaveQBMediumNUM
};




SCRIPT(MotionRightLeft_RBFlatLeft)
{

	 InitRecParametersNUM,BULLET_PASS,PASSTIMER25,

	 WaitForReadyNUM,
	GoInMotionBeforeMotionNUM,
	 SOUTH_DIR,DONT_CARE,-.5*YARDS,
	 WaitToGoInMotionNUM,  3*SECONDS,
	GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-2*YARDS,
	Wait4SnapShuffleNUM,


	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	NNE_DIR,DONT_CARE,-7*YARDS,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-2*YARDS,
	RunToRelSBNUM,
	ENE_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-8*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	SaveQBShortNUM
};



SCRIPT(MotionRight_RBFlatRight)
{
	 InitRecParametersNUM,BULLET_PASS,PASSTIMER25,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,6*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	SSE_DIR,DONT_CARE,7*YARDS,
	RunToRelNUM,
	SE_DIR,DONT_CARE,2*YARDS,
	RunToRelSBNUM,
	ESE_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	SaveQBShortNUM
};

SCRIPT(RBFlatRight)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelSBNUM,
	SSE_DIR,DONT_CARE,7*YARDS,
	RunToRelNUM,
	SE_DIR,DONT_CARE,2*YARDS,
	RunToRelSBNUM,
	ESE_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	SaveQBShortNUM
};

SCRIPT(RBFlatLeft)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelSBNUM,
	NNE_DIR,DONT_CARE,-7*YARDS,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-2*YARDS,
	RunToRelSBNUM,
	ENE_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-8*YARDS,
	PShuffleWaitNUM, 1*QUARTERSEC,
	SaveQBShortNUM
};


SCRIPT(RBScreenRight)
{
	InitRecParametersNUM,MEDIUM_BULLET_PASS,PASSTIMER28,
	Wait4SnapNUM,
	RunToRelNUM,
	SW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,4*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,4*YARDS,
//	RunToRelNUM,
//	SSE_DIR,DONT_CARE,4*YARDS,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBShortNUM
};


SCRIPT(HBScreenRight)
{
	InitRecParametersNUM,MEDIUM_BULLET_PASS,PASSTIMER28,
	Wait4SnapNUM,
	RunToRelNUM,
	SW_DIR,DONT_CARE,.5*YARDS,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,1*YARDS,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,4*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,5*YARDS,
//	RunToRelNUM,
//	SSE_DIR,DONT_CARE,4*YARDS,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBShortNUM
};



SCRIPT(RBScreenLeft)
{
	InitRecParametersNUM,MEDIUM_BULLET_PASS,PASSTIMER28,
	Wait4SnapNUM,
	RunToRelNUM,
	NNW_DIR,DONT_CARE,-2*YARDS,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-2*YARDS,
	RunToRelNUM,
	NNE_DIR,DONT_CARE,-4*YARDS,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBShortNUM
};



SCRIPT(RBFlatAndUpRight)
{
	InitRecParametersNUM,MEDIUM_LOB_PASS,PASSTIMER58,
	Wait4SnapNUM,
	RunToRelSBNUM,
	SSE_DIR,DONT_CARE,6*YARDS,
	RunToRelNUM,
	SE_DIR,DONT_CARE,2*YARDS,
	RunToRelSBNUM,
	ESE_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,4*YARDS,
	RunToRelNUM,
	EAST_DIR,40*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RBFlatAndUpLeft)
{
	InitRecParametersNUM,MEDIUM_LOB_PASS,PASSTIMER58,
	Wait4SnapNUM,
	RunToRelSBNUM,
	NNE_DIR,DONT_CARE,-6*YARDS,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-2*YARDS,
	RunToRelSBNUM,
	ENE_DIR,2*YARDS,DONT_CARE,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-4*YARDS,
	RunToRelNUM,
	EAST_DIR,40*YARDS,DONT_CARE,
	SaveQBDeepNUM
};





SCRIPT(RBPAPassBlockLeft)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1.5*YARD,
	RunToRelNUM,
	EAST_DIR,.5*YARDS,DONT_CARE,
	BeBlockerNUM
};



SCRIPT(RBPAPassBlockRight)
{
	InitIWillBeABlockerNUM,
	Wait4SnapNUM,
	InitLeadBlockerStateNUM,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1.5*YARD,
	RunToRelNUM,
	EAST_DIR,.5*YARDS,DONT_CARE,
	BeBlockerNUM
};




/***** Receiver Patterns *****/

SCRIPT(RecPostRight5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER12,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ESE_DIR,70*YARDS,DONT_CARE,
	SaveQBMediumNUM
};

SCRIPT(RecPostRight10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	ESE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};


SCRIPT(MotionUpLeft_RecPostRight15)
{
	 InitRecParametersNUM,LOB_PASS,PASSTIMER32,

	 WaitForReadyNUM,

	GoInMotionBeforeMotionNUM,
	 EAST_DIR,-2.5*YARDS,DONT_CARE,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-6*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ESE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};


SCRIPT(MotionRight_RecPostRight15)
{
	 InitRecParametersNUM,LOB_PASS,PASSTIMER46,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,-6*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ESE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};


SCRIPT(MotionRight_RecPostLeft10)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER31,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,5.5*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ENE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};



SCRIPT(RecPostRight15)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER46,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ESE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecPostLeft5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER12,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,40*YARDS,DONT_CARE,
	SaveQBMediumNUM
};

SCRIPT(RecPostLeft10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER34,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ENE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecPostLeft15)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER48,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	ENE_DIR,70*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecCornerRight5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER14,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};





SCRIPT(RecCornerRight10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER30,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(MotionLeft_RecCornerRight10)
{

	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER30,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};


SCRIPT(MotionRight_RecCornerRight10)
{

	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER30,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(RecCornerRight15)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecCornerLeft5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER14,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecCornerLeft10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(MotionLeft_RecCornerLeft10)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(MotionRight_RecCornerLeft10)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(RecCornerLeft15)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(RecCrossRight5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER18,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBShortNUM
};



SCRIPT(MotionUpLeft_RecCrossRight10)
{
	 InitRecParametersNUM,BULLET_PASS,PASSTIMER28,

	 WaitForReadyNUM,

	 GoInMotionBeforeMotionNUM,
	 EAST_DIR,-3*YARDS,DONT_CARE,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};


SCRIPT(RecCrossRight10)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER26,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecCrossRight15)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,13*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};


SCRIPT(RBCrossRight10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER29,
	Wait4SnapNUM,
   RunToRelNUM,
	NE_DIR,1*YARDS,1*YARDS,
   RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(MotionLeft_RecCrossLeft5)
{
	 InitRecParametersNUM,BULLET_PASS,PASSTIMER22,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-5.75*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBShortNUM
};


SCRIPT(RecCrossLeft5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER22,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBShortNUM
};

/* old - use as reference
SCRIPT(MotionRight_RecCrossLeft5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};*/

SCRIPT(MotionRight_RecCrossLeft5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER28,

	WaitToGoInMotionNUM,  3*SECONDS,

	GoInMotionNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};


SCRIPT(MotionUpRight_RecCrossLeft10)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER27,

   WaitForReadyNUM,

   GoInMotionBeforeMotionNUM,
   EAST_DIR,-3*YARDS,DONT_CARE,

	WaitToGoInMotionNUM,  3*SECONDS,

	GoInMotionNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(MotionRight_RecCrossRight5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER27,

	WaitToGoInMotionNUM,  3*SECONDS,

	GoInMotionNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBShortNUM
};


SCRIPT(MotionUpRight_RecCrossRight5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER26,

   WaitForReadyNUM,

   GoInMotionBeforeMotionNUM,
   EAST_DIR,-3*YARDS,DONT_CARE,

	WaitToGoInMotionNUM,  3*SECONDS,

	GoInMotionNUM,
	SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBShortNUM
};



SCRIPT(RecCrossLeft10)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER27,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecCrossLeft15)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,13*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};




SCRIPT(MotionRight_RecStreak)
{
	 InitRecParametersNUM,MEDIUM_LOB_PASS,PASSTIMER38,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	GoUpField(70),
	SaveQBDeepNUM
};



SCRIPT(MotionLeft_RecStreakShort)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER28,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,7.5*YARDS,

	Wait4SnapShuffleNUM,
	GoUpField(70),
	SaveQBDeepNUM
};



SCRIPT(MotionRightShort_RecStreak)
{
	 InitRecParametersNUM,LOB_PASS,PASSTIMER38,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,-6*YARDS,

	Wait4SnapShuffleNUM,
	GoUpField(70),
	SaveQBDeepNUM
};




SCRIPT(MotionLeft_RecStreak)
{
	 InitRecParametersNUM,LOB_PASS,PASSTIMER44,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-8*YARDS,

	Wait4SnapShuffleNUM,
	GoUpField(70),
	SaveQBDeepNUM
};




SCRIPT(RecStreak)
{
   InitRecParametersNUM,LOB_PASS,PASSTIMER44,
	Wait4SnapNUM,
	GoUpField(70),
	SaveQBDeepNUM
};


SCRIPT(RecSlantRight)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER9,
	Wait4SnapNUM,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecSlantLeft)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER9,
	Wait4SnapNUM,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecSlantCrossRight5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER15,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCrossRight10)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCrossRight15)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER30,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,13*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCrossLeft5)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER15,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(RecSlantCrossLeft10)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCrossLeft15)
{
	InitRecParametersNUM,BULLET_PASS,PASSTIMER30,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,13*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(MotionRightLeft_SlantCorner)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER30,

//	 WaitToGoInMotionNUM,  5*SECONDS,

//	 GoInMotionNUM,
//	 SOUTH_DIR,DONT_CARE,-3*YARDS,
	 WaitForReadyNUM,
	GoInMotionBeforeMotionNUM,
	 SOUTH_DIR,DONT_CARE,-2*YARDS,
	 WaitToGoInMotionNUM,  3*SECONDS,
	GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-13*YARDS,
	Wait4SnapShuffleNUM,


	Wait4SnapShuffleNUM,
	RunToRelNUM,
	SE_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};



SCRIPT(RecSlantCornerRight5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER22,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCornerRight10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER28,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCornerRight15)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER37,
	Wait4SnapNUM,
	RunToRelNUM,
	SE_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCornerLeft5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER22,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};


SCRIPT(RecSlantCornerLeft10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER28,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,10*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecSlantCornerLeft15)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelNUM,
	NE_DIR,15*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBMediumNUM
};

SCRIPT(RecChairRight5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,50*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecChairRight10)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER40,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,50*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecChairRight15)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER45,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,50*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecChairLeft5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,50*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecChairLeft10)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER40,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,50*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecChairLeft15)
{
	InitRecParametersNUM,LOB_PASS,PASSTIMER45,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelNUM,
	NORTH_DIR,DONT_CARE,-3*YARDS,
	RunToRelSBNUM,
	EAST_DIR,50*YARDS,DONT_CARE,
	SaveQBDeepNUM
};

SCRIPT(RecHookRight5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER17,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	SW_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};

SCRIPT(RecHookRight10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER26,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	SW_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};

SCRIPT(RecHookRight15)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER29,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelNUM,
	SE_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	SW_DIR,DONT_CARE,1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};

SCRIPT(RecHookLeft5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER17,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	NW_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};




SCRIPT(MotionRight_RecHookLeft10)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER40,

	 WaitToGoInMotionNUM,  5*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,7*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	NW_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};



SCRIPT(RecHookLeft10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER26,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	NW_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};

SCRIPT(RecHookLeft15)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER29,
	Wait4SnapNUM,
	RunToRelSBNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	NW_DIR,DONT_CARE,-1*YARDS,
	RunToRelNUM,
	WEST_DIR,-3*YARDS,DONT_CARE,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBMediumNUM
};

SCRIPT(RecPostCornerRight5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER26,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	SE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecPostCornerRight10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	SE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecPostCornerRight15)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER35,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelNUM,
	SE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NE_DIR,DONT_CARE,-22*YARDS,
	SaveQBDeepNUM
};



SCRIPT(MotionRight_RecPostCornerLeft5)
{
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER26,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,8*YARDS,

	Wait4SnapShuffleNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBDeepNUM
};



SCRIPT(RecPostCornerLeft5)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER26,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,5*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecPostCornerLeft10)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER34,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,10*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecPostCornerLeft15)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER36,
	Wait4SnapNUM,
	RunToRelNUM,
	EAST_DIR,15*YARDS,DONT_CARE,
	RunToRelNUM,
	NE_DIR,3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,22*YARDS,
	SaveQBDeepNUM
};

SCRIPT(RecRunBlockLeft)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_LEFT,
	 Wait4SnapNUM,
	 RunToRelNUM,
	 EAST_DIR,5*YARDS,DONT_CARE,
	 RunToRelNUM,
	 SE_DIR, 1*YARDS,1*YARDS,
	 BeBlockerNUM
};

SCRIPT(RecRunBlockRight)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_LEFT,
	 Wait4SnapNUM,
	 RunToRelNUM,
	 EAST_DIR,5*YARDS,DONT_CARE,
	 RunToRelNUM,
	 NE_DIR, 1*YARDS,-1*YARDS,
	 BeBlockerNUM
};


SCRIPT(RecCrackBackRight)
{
	InitIWillBeABlockerNUM,
//	 InitRunBlockNUM,PUSH_RIGHT,
	 Wait4SnapNUM,
	 RunToRelNUM,
	 SSE_DIR,2*YARDS,2*YARDS,
	 RunToRelNUM,
	 SE_DIR, 1*YARDS,1*YARDS,
	 BeBlockerNUM
};


SCRIPT(RecCrackBackLeft)
{
	InitIWillBeABlockerNUM,
//	 InitRunBlockNUM,PUSH_LEFT,
	 Wait4SnapNUM,
	 RunToRelNUM,
	 NNE_DIR,2*YARDS,-2*YARDS,
	 RunToRelNUM,
	 NE_DIR, 1*YARDS,-1*YARDS,
	 BeBlockerNUM
};



SCRIPT(RecReverseLeft)
{
	SetFutureBCReverseStateNUM,
//	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	RunToRelNUM,
	WNW_DIR,-5*YARDS,DONT_CARE,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NORTH_DIR,-5*YARDS,-1*YARD,
//		TakeHandOffNUM,
		RunToRelSBNUM,
		NE_DIR,DONT_CARE,-5*YARD,
		RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM

};


SCRIPT(MotionRight_RecReverseLeft)
{
	SetFutureBCReverseStateNUM,
//	SetFutureBCHandoffStateNUM,
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,

	WaitToGoInMotionNUM,  5*SECONDS,

	GoInMotionNUM,
	SOUTH_DIR,DONT_CARE,7*YARDS,

	Wait4SnapShuffleNUM,
	PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelNUM,
	WNW_DIR,-5*YARDS,DONT_CARE,
//	RBTakeHandOffNUM,
//  if  0
		RunToRelSBNUM,
		NORTH_DIR,-5*YARDS,-1*YARD,
//		TakeHandOffNUM,
		RunToRelSBNUM,
		NE_DIR,DONT_CARE,-5*YARD,
		RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM

};




SCRIPT(RecReverseRight)
{
//	RBTakeHandOffNUM,
	SetFutureBCReverseStateNUM,
//	SetFutureBCHandoffStateNUM,
	Wait4SnapNUM,
	RunToRelNUM,
	WSW_DIR,-3*YARDS,DONT_CARE,
	RunToRelNUM,
	SW_DIR,-2*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,-5*YARDS,1*YARD,
//  TakeHandOffNUM,
	RunToRelSBNUM,
	SE_DIR,DONT_CARE,5*YARD,
	RunToRelSBNUM,
	EAST_DIR,0,DONT_CARE,
	BCAvoidNUM

};

SCRIPT(RecComeBackLeft)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER5,
	Wait4SnapNUM,
	RunToRelNUM,
	NW_DIR,-1*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,10*YARDS,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBShortNUM
};


SCRIPT(RecScreenLeft)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER15,
	Wait4SnapNUM,
	RunToRelNUM,
	NW_DIR,-3*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-8*YARDS,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBShortNUM
};


SCRIPT(TEScreenLeft)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER15,
	Wait4SnapNUM,
	RunToRelNUM,
	NW_DIR,-1.5*YARDS,DONT_CARE,
	RunToRelSBNUM,
	NORTH_DIR,DONT_CARE,-6*YARDS,
	RunToRelSBNUM,
	NNW_DIR,DONT_CARE,-12*YARDS,
//	RunToRelSBNUM,
//	NW_DIR,DONT_CARE,-12*YARDS,
	PShuffleWaitNUM, 8*QUARTERSEC,
	SaveQBShortNUM
};


SCRIPT(RecShovelPass)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER12,
//	SetFutureBCPitchStateNUM,
   Wait4SnapNUM,
//	RBTakePitchNUM,
	PShuffleWaitNUM, 1*QUARTERSEC,
	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,
	RunToRelNUM,
	SOUTH_DIR,DONT_CARE,5*YARDS,
	RunToRelNUM,
	SSE_DIR,DONT_CARE,3*YARDS,
//	RunToRelSBNUM,
//	SE_DIR,DONT_CARE,1*YARDS,
	BCAvoidNUM
};


SCRIPT(RecScreenRight)
{
	InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,
	Wait4SnapNUM,
	RunToRelNUM,
	SSE_DIR,.25*YARDS,DONT_CARE,
	RunToRelSBNUM,
	SOUTH_DIR,DONT_CARE,22*YARDS,
	SaveQBShortNUM
};


SCRIPT(MotionRight_RecCrackBackRight)
{
	InitIWillBeABlockerNUM,
	 InitRecParametersNUM,NORMAL_PASS,PASSTIMER25,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,5*YARDS,

	 Wait4SnapShuffleNUM,
	 RunToRelNUM,
	 SSE_DIR,5*YARDS,5*YARDS,
	 InitRunBlockNUM,PUSH_RIGHT,
	 RunToRelNUM,
	 SE_DIR, 1*YARDS,1*YARDS,
	 BeBlockerNUM
};


/* Offensive Lineman Scripts */

SCRIPT(OLRunBlockLeft)
{
	 InitRunBlockNUM,PUSH_LEFT,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 BeBlockerNUM
};



SCRIPT(MotionRight_OLRunBlockLeft)
{
	InitIWillBeABlockerNUM,
	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,5*YARDS,

	Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 EAST_DIR,2*YARDS,DONT_CARE,
	 InitRunBlockNUM,PUSH_LEFT,
	 LeadBlockerNUM
};



SCRIPT(MotionRightLeft_OLRunBlockLeft)
{
	InitIWillBeABlockerNUM,
	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,-3*YARDS,

	Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 EAST_DIR,2*YARDS,DONT_CARE,
	 InitRunBlockNUM,PUSH_LEFT,
	 LeadBlockerNUM
};


SCRIPT(MotionRight_OLRunBlockRight)
{
	InitIWillBeABlockerNUM,
	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,5*YARDS,

	Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 EAST_DIR,2*YARDS,DONT_CARE,
	 InitRunBlockNUM,PUSH_RIGHT,
	 LeadBlockerNUM
};


SCRIPT(MotionLeft_OLRunBlockLeft)
{
	InitIWillBeABlockerNUM,
	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-5*YARDS,

	Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 EAST_DIR,2*YARDS,DONT_CARE,
	 InitRunBlockNUM,PUSH_LEFT,
	 LeadBlockerNUM
};



SCRIPT(MotionUpLeft_OLRunBlockLeft)
{
	InitIWillBeABlockerNUM,
	 WaitForReadyNUM,

	GoInMotionBeforeMotionNUM,
	 EAST_DIR,-3*YARDS,DONT_CARE,

	 WaitToGoInMotionNUM,  3*SECONDS,

	GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-5*YARDS,

	Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 EAST_DIR,2*YARDS,DONT_CARE,
	 InitRunBlockNUM,PUSH_LEFT,
	 LeadBlockerNUM
};



SCRIPT(MotionLeft_OLRunBlockRight)
{
	InitIWillBeABlockerNUM,
	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 NORTH_DIR,DONT_CARE,-5*YARDS,

	Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 EAST_DIR,2*YARDS,DONT_CARE,
	 InitRunBlockNUM,PUSH_RIGHT,
	 LeadBlockerNUM
};



SCRIPT(OLRunBlockRight)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_RIGHT,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 BeBlockerNUM
};


SCRIPT(OLSlantBlockRight)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_RIGHT|SLANT_BLOCK_BFLAG,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 BeBlockerNUM
};
//	DO_NOTHING

SCRIPT(OLSlantBlockLeft)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_LEFT|SLANT_BLOCK_BFLAG,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 BeBlockerNUM
};
//	DO_NOTHING



SCRIPT(OLTrapLeft)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_LEFT|TRAP_BLOCK_BFLAG,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 NNW_DIR,-.5*YARDS,-1.5*YARDS,
	 BeBlockerNUM
};


SCRIPT(OLTrapRight)
{
	InitIWillBeABlockerNUM,
	 InitRunBlockNUM,PUSH_RIGHT|TRAP_BLOCK_BFLAG,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunToRelNUM,
	 SSW_DIR,-.5*YARDS,1.5*YARDS,
//	 RunToRelNUM,
//	 SE_DIR, .5*YARDS,2*YARDS,
	 BeBlockerNUM
};


SCRIPT(OLPassBlock)
{
	InitIWillBeABlockerNUM,
	WhoToPassBlockNUM,
	Wait4SnapNUM,
    OLPassBlockDropBackNUM,
//	 SetToBlockStanceNUM,
//	 RunBackwardsStateNUM,
//	 WEST_DIR,-1*YARDS,DONT_CARE,
	BeBlockerNUM
};


SCRIPT(MotionRight_OLPassBlock)
{
	InitIWillBeABlockerNUM,
	 WhoToPassBlockNUM,

	 WaitToGoInMotionNUM,  3*SECONDS,

	 GoInMotionNUM,
	 SOUTH_DIR,DONT_CARE,4*YARDS,

	 Wait4SnapShuffleNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 WEST_DIR,-1*YARDS,DONT_CARE,
	 BeBlockerNUM
};





SCRIPT(OLPullRight)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 SW_DIR,-.25*YARDS,DONT_CARE,
	 RunToRelSBNUM,
	 SOUTH_DIR,DONT_CARE,4*YARDS,
	 RunToRelNUM,
	 SE_DIR,DONT_CARE,1*YARDS,
	 LeadBlockerNUM
};


SCRIPT(OLPullLeft)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 NW_DIR,-.25*YARDS,DONT_CARE,
	 RunToRelSBNUM,
	 NORTH_DIR,DONT_CARE,-4*YARDS,
	 RunToRelNUM,
	 NE_DIR,DONT_CARE,-1*YARDS,
	 LeadBlockerNUM
};




SCRIPT(OLPullRightShort)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 SW_DIR,-.25*YARDS,DONT_CARE,
	 RunToRelSBNUM,
	 SOUTH_DIR,DONT_CARE,2*YARDS,
	 LeadBlockerNUM
};


SCRIPT(OLPullLeftShort)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 NW_DIR,-.25*YARDS,DONT_CARE,
	 RunToRelSBNUM,
	 NORTH_DIR,DONT_CARE,-2*YARDS,
	 LeadBlockerNUM
};




/*   PullLeftShort:      ; used if guy has somebody to block
	 Wait4Snap
//	 SetToBlockStance
	 RunBackwardsState
	 NW_DIR,-1*HALFYARD,DONT_CARE
	 RunToRelSBNUM
	 NORTH_DIR,DONT_CARE,-4*YARDS
	 BeBlocker
*/

SCRIPT(OLScreenCenter)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 WSW_DIR,-1.25*YARDS,DONT_CARE,
	 Wait4CatchShuffleNUM,
	 LeadBlockerNUM
};


SCRIPT(OLScreenRight)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 WSW_DIR,-1.25*YARDS,DONT_CARE,
	 RunToRelNUM,
	 SOUTH_DIR,DONT_CARE,10*YARDS,
	 Wait4CatchShuffleNUM,
	 LeadBlockerNUM
};

SCRIPT(OLScreenLeft)
{
	InitIWillBeABlockerNUM,
	 Wait4SnapNUM,
//	 SetToBlockStanceNUM,
	 RunBackwardsStateNUM,
	 WNW_DIR,-1.25*YARDS,DONT_CARE,
	 RunToRelNUM,
	 NORTH_DIR,DONT_CARE,-10*YARDS,
	 Wait4CatchShuffleNUM,
	 LeadBlockerNUM
};




SCRIPT(BlockForPuntScript)
{
	InitIWillBeABlockerNUM,
	 WhoToPassBlockNUM,
	 Wait4SnapNUM,
	 BePuntBlockerNUM,
	 ChaseBallNUM
};



SCRIPT(RTEBlockForPuntScript)
{
	InitIWillBeABlockerNUM,
	 WhoToPassBlockNUM,
	 Wait4SnapNUM,
	 BePuntBlockerNUM,
	 RunToRelRandomXNUM,
	 ESE_DIR,15*YARDS,DONT_CARE,
	 ChaseBallNUM
};




SCRIPT(LTEBlockForPuntScript)
{
	InitIWillBeABlockerNUM,
	 WhoToPassBlockNUM,
	 Wait4SnapNUM,
	 BePuntBlockerNUM,
	 RunToRelRandomXNUM,
	 ENE_DIR,15*YARDS,DONT_CARE,
	 ChaseBallNUM

};


SCRIPT(RTBlockForPuntScript)
{
	InitIWillBeABlockerNUM,
	 WhoToPassBlockNUM,
	 Wait4SnapNUM,
	 BePuntBlockerNUM,
	 RunToRelRandomXNUM,
	 ESE_DIR,5*YARDS,DONT_CARE,
	 ChaseBallNUM
};




SCRIPT(LTBlockForPuntScript)
{
	InitIWillBeABlockerNUM,
	 WhoToPassBlockNUM,
	 Wait4SnapNUM,
	 BePuntBlockerNUM,
	 RunToRelRandomXNUM,
	 ENE_DIR,5*YARDS,DONT_CARE,
	 ChaseBallNUM

};











/*****  Defensive Play Patterns *******/

SCRIPT(BlitzDefense)
{
	Wait4SnapNUM,
	DefSnapWAITNUM,
	DefLineNUM,DEF_LINE_BLITZER,
	ChaseBallNUM
};


SCRIPT(BlitzInDefense)
{
	Wait4SnapNUM,
	DefSnapWAITNUM,
	RunToRelSBNUM,
	NNW_DIR,DONT_CARE,1.5*YARDS,
	RunToRelSBNUM,
	SSW_DIR,DONT_CARE,-1.5*YARDS,
	DefLineNUM,DEF_LINE_BLITZER,
	ChaseBallNUM
};



SCRIPT(BlitzOutsideLeftDefense)
{
	Wait4SnapNUM,
	RunToRelSBNUM,
	NNW_DIR,DONT_CARE,-8*YARDS,
	DefLineNUM,DEF_LINE_BLITZER,
	ChaseBallNUM
};

SCRIPT(BlitzOutsideRightDefense)
{
	Wait4SnapNUM,
	RunToRelSBNUM,
	SSW_DIR,DONT_CARE,8*YARDS,
	DefLineNUM,DEF_LINE_BLITZER,
	ChaseBallNUM
};

SCRIPT(ShowBlitzDefense)     /* run up to line before snap (starts like fake blitz */
{
	WaitToGoInMotionNUM,  1*SECONDS,
   SetDefRunUpTargetNUM,       /* used by safeties */
	RuntoTargetPreSnapStateNUM,
	BlitzerWait4SnapNUM,
	DefLineNUM,DEF_LINE_BLITZER,
	ChaseBallNUM
};

SCRIPT(FakeBZDefense)       /* zone defense BUT looks like blitz */
{
	WaitToGoInMotionNUM,  1*SECONDS,
   SetDefRunUpTargetNUM,     /* used by safeties */
	RuntoTargetPreSnapStateNUM,
	BlitzerWait4SnapNUM,
	ZoneDefenseInitNUM,
	ZoneDefenseNUM,
	ChaseBallNUM
};

SCRIPT(FakeBManDefense)       /* man LB defense BUT looks like blitz */
{
	SetDefRunUpTargetNUM,     /* used by safeties */
	RuntoTargetPreSnapStateNUM,
	BlitzerWait4SnapNUM,
	LBReadNUM,
	ChaseBallNUM
};



SCRIPT(LNDefense)
{
	Wait4SnapNUM,
	DefLineNUM,DEF_LINE_NO_BLITZER,
	ChaseBallNUM
};




SCRIPT(LNLeftDefense)
{
	Wait4SnapNUM,

	RunToRelNUM,
	NNW_DIR,DONT_CARE,-2*YARDS,


//	DefLineNUM,DEF_LINE_NO_BLITZER,

//	RunToRelNUM,
//	NNW_DIR,-2*YARDS,DONT_CARE,

	ChaseBallNUM
};



SCRIPT(LNRightDefense)
{
	Wait4SnapNUM,

	RunToRelNUM,
	SSW_DIR,DONT_CARE,2*YARDS,


	DefLineNUM,DEF_LINE_NO_BLITZER,
	ChaseBallNUM
};



SCRIPT(CBDefense)
{
	Wait4SnapNUM,
	CBCheckForPuntNUM,
	CBReadNUM,
	ChaseBallNUM
};


SCRIPT(CBBumpDefense)
{
	RunToRelSBNUM,
	WEST_DIR,1*YARDS,DONT_CARE,
	Wait4SnapNUM,
	CBCheckForPuntNUM,
	CBReadNUM,
	ChaseBallNUM
};


SCRIPT(CBCushionDefense)
{
	RunToRelSBNUM,
	EAST_DIR,12*YARDS,DONT_CARE,
	Wait4SnapNUM,
	CBCheckForPuntNUM,
	CBReadNUM,
	ChaseBallNUM
};


SCRIPT(NoDefense)
{
	DoNothingUpdateGraphicsNUM
};


SCRIPT(LBDefense)
{
	Wait4SnapNUM,
	LBReadNUM,
	ChaseBallNUM
};

SCRIPT(LBQBDefense)
{
	Wait4SnapNUM,
	LBCoverQBNUM,
	ChaseBallNUM
};

SCRIPT(FSDefense)         /* Free Safety Man to Man */
{
	Wait4SnapNUM,
	FSReadNUM,
	ChaseBallNUM
};

SCRIPT(ZDefense)          /* zone defense */
{
	Wait4SnapNUM,
	ZoneDefenseInitNUM,
	ZoneDefenseNUM,
	ChaseBallNUM
};

SCRIPT(PuntReturnerScript)
{
	SetMaxSpeedStateNUM,MAX_NUM_SPEEDS-1,	// set to highest speed
	RunToRelSBNUM,
	EAST_DIR,40*YARDS,0,	// mainly for guys in non PR formation

	TurnPlayerStateNUM,WEST_DIR,
	Wait4SnapNUM,
	PRWait4PuntNUM,
//	ChaseBallNUM,		this didn't work
	RunToBallTargetStateNUM,	// this is better than ChaseBall
	DefBCAvoidNUM		// probably won't get here but best to be safe
};



/**********************************************************************

		I N D I R E C T    S C R I P T S

	The following scripts are not directly in any plays, but are
	forced to be certain players scripts either by a players "Smarts"
	or if a major event happens (e.g. fumble, interception)

**********************************************************************/



SCRIPT (WatchEOPScript)
{
	QBWatchEOPNUM
};


SCRIPT (HumanControl)
{
	DoNothingNUM
};

SCRIPT(ChaseBallScript)
{
	ChaseBallNUM
};

SCRIPT(RunToBallTargetScript)
{
	RunToBallTargetStateNUM
};

SCRIPT(DefRunToPuntTargetScript)
{
	DefRunToPuntTargetStateNUM,
	QBWatchEOPNUM
};

SCRIPT(BallCarrierAvoidScript)
{
	BCAvoidNUM
};

SCRIPT(DefBallCarrierAvoidScript)
{
	DefBCAvoidNUM
};

SCRIPT(DefBeBlockerScript)
{
	DefBeBlockerNUM
};

SCRIPT(BeBlockerScript)
{
	BeBlockerNUM
};

SCRIPT(OffHuddleToLOSScript)
{
	FreezePlayerWaitNUM,HUDDLE_WAIT,
	HuddleRunToLOSStateNUM,
	OffAtLOSNUM,
	SetInitialScriptStateNUM
};


SCRIPT(DefHuddleToLOSScript)
{
	FreezePlayerWaitNUM,HUDDLE_WAIT,
	HuddleRunToLOSStateNUM,
	DefAtLOSNUM,
	SetInitialScriptStateNUM
};

SCRIPT(DefFormationShiftScript)
{
	CheckForDefBackPedalStateNUM,
//	HuddleRunToLOSStateNUM,
	DefAtLOSNUM,
	SetInitialScriptStateNUM
};

SCRIPT(OffKOFormationShiftScript)
{
	HuddleRunToLOSStateNUM,	// or to sidelines
	OffAtLOSNUM,
	SetInitialScriptStateNUM
};

SCRIPT(EndOfPlayScript)
{
	DecelerateStateNUM,
	EverybodyWatchEOPNUM,
	ReturnToHuddleNUM
};

SCRIPT(LeadBlockerScript)
{
	LeadBlockerNUM
};


SCRIPT(CelebrateScript)
{
	DecelerateStateNUM,
	CelebrateStateNUM,
	ReturnToHuddleNUM
};

SCRIPT(Celebrate1Script)
{
//	DecelerateStateNUM,
	Celebrate1StateNUM,
	ReturnToHuddleNUM
};



SCRIPT(QuarterEndedScript)
{
	DecelerateStateNUM,
	EverybodyWatchEOPNUM,
	RunToSideLinesStateNUM,
	ReachedSideLinesStateNUM
};


SCRIPT(RaceScript)
{
	Wait4SnapNUM,
	GoUpField(110),
	DoNothingNUM
};

SCRIPT(TwitchScript)
{
	Wait4SnapNUM,
	TwitchStateNUM,
//	GoUpField(110),
	DoNothingNUM
};

SCRIPT(Twitch2Script)
{
	Wait4SnapNUM,
	Twitch2StateNUM,
//	GoUpField(110),
	DoNothingNUM
};


SCRIPT(FalseStartScript)
{
	FalseStartStateNUM,
	GoUpField(2),		//	PShuffleWaitNUM,  2*SECONDS,
	FalseStartStatePart2NUM,
	QBWatchEOPNUM

};

SCRIPT(DefAfterFGKickedScript)	// init when FG is kicked
{
	DefAfterFGKickedStateNUM	// init when FG is kicked
};


SCRIPT(CoverManInMotionScript)
{
	CoverManInMotionStateNUM,
	SetInitialScriptStateNUM
};


SCRIPT(RefWatchPlayScript)
{
	RefDoNothingStateNUM
};

SCRIPT(RefRunOnFieldScript)	// for TD, 1st down, (everything but penalties)
{
	RefRunToTargetStateNUM,	// run on field
	RefDoHisThingStateNUM,	// do anim an/or SFX
	RefRunToTargetStateNUM,	// run off field
	RefDoNothingStateNUM
};

SCRIPT(RefPenaltyScript)	// penalties
{
	RefRunToTargetStateNUM,	// run on field
	RefDoHisThingStateNUM,	// do anim an/or SFX
	RefPenaltyOutcomeStateNUM,	// do anim an/or SFX
	RefRunToTargetStateNUM,	// run off field
	RefDoNothingStateNUM
};


/**************************  THE   SCRIPTS   ***********************/

void *All_Scripts[] = {

#define scmac(xyz)  xyz,

		#include	"FBScript.h"		// as actual function names

#undef	scmac

};



/************************************************************


						THE  PLAYS

			----- 	WARNING -- DANGER-----

	The Plays are in an array , so they must be in the same
	order as the equate list.

************************************************************/


//#define PLAY(xyz)  struct play (xyz) =	old pointer based
//#define	END_PLAY_DS	};
//#define INITPLAY(xyz) extern void(xyz)(void); (xyz),


#define PLAY(xyz)
#define	END_PLAY_DS	},

struct play	ThePlays[] = {

//------------------ Off. GOALLINE PLAYS -----------------------

PLAY(GoalLineOptionPass)
{
	PASS_OPTION,
	GoalLineOptionPassInitNUM,
	GOAL_LINE_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecSlantCrossRight5NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBRollOutPassBlockRightNUM,
/*  HB  */  RBOptionPassRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(GoalLineQBSneak)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	GOAL_LINE_FORM_NUM,

/*  QB  */  QBSneakNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrossLeft5NUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBILeadBlock8NUM,
/*  HB  */  RBILeadBlock7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(GoalLineFBDive)
{						
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	GOAL_LINE_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBIRun2NUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS

PLAY(GoalLineNakedBootleg)
{
	RUN_OUTSIDE,
	SetReceivers241354NUM,
	GOAL_LINE_FORM_NUM,

/*  QB  */  QBBootLegRightNUM,
/*  RR  */  RecCrossLeft10NUM,
/*  LR  */  RecPostRight5NUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBPassCircleLeftNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(GoalLineHBLeap)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	GOAL_LINE_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/*  RR  */  RecPostLeft5NUM,
/*  LR  */  OLRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBILeadBlock2NUM,
/*  HB  */  RBIRun1NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLSlantBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS

PLAY(GoalLineGoalLineFlood)
{
	PASS_MEDIUM,
	SetReceivers241351NUM,
	GOAL_LINE_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecHookLeft10NUM,
/*  LR  */  RecCornerLeft5NUM,
/*  RTE */  RecCrossLeft10NUM,
/*  FB  */  RBPassCircleRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(GoalLineTackleEligible)
{
	PASS_MEDIUM,
//	SetReceivers271457NUM,
	SetReceivers231453NUM,	// tackle is #3 - primary rec.
	GOAL_LINE_T_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecCornerLeft10NUM,
//		/*  lr  */  RecCrossLeft5NUM,
/*  LT  */  RecCrossLeft5NUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBPlayActionOutRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  RTE */  OLPassBlockNUM,

/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(GoalLineEndSweep)
{
	RUN_OPTION,
//	SetFakeReceivers27145NUM,
	SetFakeReceivers23145NUM,
	GOAL_LINE_T_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecReverseRightNUM,
//             /*  lr  */  RecRunBlockLeftNUM,
/*  LT  */  OLSlantBlockLeftNUM,
/*  FB  */  RBRLeadBlock8NUM,
/*  HB  */  RBLeadBlock8NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLSlantBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

PLAY(GoalLineCrossBlock)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
//	SetFakeReceivers27145NUM,
	GOAL_LINE_T_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  OLRunBlockRightNUM,
/*  LR  */  OLSlantBlockRightNUM,
//          /*  lr  */  RecRunBlockLeftNUM,
/*  LT  */  OLSlantBlockLeftNUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBIRun5NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS

PLAY(GoalLinePAFade)
{
	PASS_ACTION,
	SetReceivers231451NUM,
	GOAL_LINE_NO_WR_FORM_NUM,		// FIXED 11/4/96 to reflect graphics

/*  QB  */ // QBPlayActionRightFBNUM,
/*  QB  */  QBPlayActionLeftFBNUM,
/*  RR  */  MotionLeft_RecCornerLeft10NUM,
//							/*  rr  */  RecCornerLeft10NUM,
/*  LR  */  RecCrossLeft5NUM,
/*  RTE */  RecCrossLeft10NUM,
/*  FB  */ // RBILeadBlockPARightNUM,
/*  HB  */ // RBILeadBlockPARightNUM,
/*  FB  */  RBILeadBlockPALeftNUM,		// new 11/4
/*  HB  */  RBILeadBlock3NUM,              // new 11/4

/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(GoalLineHBPower)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	GOAL_LINE_NO_WR_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/*  RR  */  MotionLeft_OLRunBlockLeftNUM,
//					/*  rr  */  RecRunBlockLeftNUM,
/*  LR  */  OLRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBILeadBlock3NUM,
/*  HB  */  RBIStepLeftRun3NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(GoalLineHBTrap)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	GOAL_LINE_NO_WR_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RR  */  MotionLeft_RecCornerRight10NUM,
//							/*  rr  */  RecCornerRight10NUM,
/*  LR  */  OLRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBILeadBlock1NUM,
/*  HB  */  RBIRun2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLTrapRightNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS

//---extra
#if NEWPLAYS1


PLAY(GoalLineHBDive)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBLeadBlock2NUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBLRun2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(GoalLineWishbonePA)
{
	PASS_ACTION,
	SetReceivers251342NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBPlayActionLeftHBNUM,      	//QBPlayActionRightNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecSlantCornerRight10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBPlayActionOutRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(GoalLineFullHouseSweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  LR  */  RecPostRight10NUM,
/*  RB3 */  RBLeadBlock8NUM,
/*  FB  */  RBILeadBlock3NUM,
/*  HB  */  RBLRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS
#endif

//------------------ Off. WishBone PLAYS -----------------------


PLAY(WishBoneFBOffTackle)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBRun4NUM,
/*  HB  */  RBLeadBlock7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(WishBoneQBRollOut)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBRollOutLeftNUM,
/*  RTE */  RecPostLeft10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RecCrossLeft5NUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBLeadBlock7NUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WishBoneTripleOption)
{
	RUN_OPTION,
	SetFakeReceivers23145NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RTE */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  OLRunBlockLeftNUM,
/*  FB  */  RBRLeadBlock8NUM,
/*  HB  */  RBIRun8NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS


PLAY(WishBoneHBDive)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBLeadBlock2NUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBRun2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(WishBoneHBScreen)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RTE */  RecPostRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLScreenRightNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLScreenRightNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(WishBoneStudentBodySweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  LR  */  RecPostRight10NUM,
/*  RB3 */  RBLeadBlock8NUM,
/*  FB  */  RBLLeadBlock8NUM,
/*  HB  */  RBLRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(WishBone10YardCurl)
{
	PASS_MEDIUM,
	SetReceivers251342NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RTE */  RecPostLeft10NUM,
/*  LR  */  RecHookRight10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBPassCircleLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(WishBoneMisdirection)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBMisDirRun5NUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBLLeadBlock2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(WishBonePASeem)
{
	PASS_ACTION,
	SetReceivers251342NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,      	//QBPlayActionRightNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecSlantCornerRight10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBPlayActionOutRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WishBoneQuickPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  OLRunBlockLeftNUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBLRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(WishBoneTEBomb)
{
	PASS_DEEP,
	SetReceivers241351NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RTE */  RecStreakNUM,
/*  LR  */  RecPostCornerRight10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPlayActionOutRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(WishBoneWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBDrawRunStepRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

//- extra
#if NEWPLAYS1

PLAY(WishBoneWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBDrawRunStepRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

PLAY(WishBoneWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBDrawRunStepRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

PLAY(WishBoneWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	WISH_BONE_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBDrawRunStepRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

	#endif

//------------------ Off. Power I Plays -----------------------


PLAY(PowerIFBOffTackle)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	POWER_I_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBRLeadBlock4NUM,
/*  FB  */  RBIStepRightRun4NUM,
/*  HB  */  RBLeadBlock5NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(PowerIRollOut)
{
	PASS_MEDIUM,
	SetReceivers251341NUM,
	POWER_I_FORM_NUM,

/*  QB  */  QBRollOutRightNUM,
/*  RTE */  RecCrossRight10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(PowerIPitchSweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	POWER_I_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBRLeadBlock8NUM,
/*  FB  */  RBLeadBlock4NUM,
/*  HB  */  RBIRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(PowerIHBDive)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	POWER_I_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBLeadBlock2NUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBRun2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(PowerIHBScreen)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	POWER_I_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RTE */  RecCrossLeft5NUM,
/*  LR  */  RecPostRight10NUM,
/*  RB3 */  RBPassBlockRightNUM,
/*  FB  */  RBFlatLeftNUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLScreenRightNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLScreenRightNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(PowerIDoubleOption)
{
	RUN_OPTION,
	SetFakeReceivers25134NUM,
	POWER_I_FORM_NUM,

/*  QB  */  QBHandOffLeftNUM,
/*  RTE */  MotionLeft_RecCornerRight10NUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RB3 */  OLRunBlockRightNUM,
/*  FB  */  RBRRun7NUM,
/*  HB  */  RBLeadBlock7NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLPullLeftNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS


PLAY(PowerI10YardCurl)
{
	PASS_MEDIUM,
	SetReceivers231451NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RTE */  RecHookLeft10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RB3 */  RBPassCircleLeftNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(PowerIFBMisdirection)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RB3 */  RBMisDirRun6NUM,
/*  FB  */  RBLeadBlock1NUM,
/*  HB  */  RBLeadBlock1NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(PowerIPASeem)
{
	PASS_ACTION,
	SetReceivers231451NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RTE */  RecPostLeft10NUM,
/*  LR  */  RecPostRight15NUM,
/*  RB3 */  RBPlayActionOutRightNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBILeadBlockPALeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(PowerIFBQuickPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RB3 */  RBLRun7NUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBLeadBlock4NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(PowerITEBomb)
{
	PASS_DEEP,
	SetReceivers241351NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RTE */  RecStreakNUM,
/*  LR  */  RecPostCornerRight10NUM,
/*  RB3 */  RBPassBlockLeftNUM,
/*  FB  */  RBPassCircleRightNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(PowerIWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBLeadBlock1NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBDrawRunStepLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS

//--extra
#if NEWPLAYS1

PLAY(PowerIWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBLeadBlock1NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBDrawRunStepLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS

PLAY(PowerIWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBLeadBlock1NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBDrawRunStepLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS

PLAY(PowerIWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	POWER_I_WEAK_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RB3 */  RBLeadBlock1NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBDrawRunStepLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS

	#endif

//------------------ Off. Near-Far Plays -----------------------


PLAY(NearFarHBOffTackle)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRLeadBlock6NUM,
/*  HB  */  RBRun6NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLPullRightShortNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS


PLAY(NearFarRollOutScramble)
{
	PASS_MEDIUM,
	SetReceivers241351NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBRollOutRightNUM,
/*  RR  */  RecCrossRight10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecSlantCornerLeft5NUM,
/*  FB  */  RBFlatRightNUM ,
/*  HB  */  RBRollOutPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(NearFarPitchSweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  FB  */  RBRLeadBlock8NUM,
/*  HB  */  RBIRun8NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS


PLAY(NearFarPowerHBRun)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RR  */  MotionLeft_OLRunBlockLeftNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLSlantBlockRightNUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBIRun2NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLTrapRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS


PLAY(NearFarFBScreen)
{
	PASS_SHORT,
	SetReceivers241354NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  MotionLeft_RecCornerLeft10NUM,
/*  LR  */  RecPostRight5NUM,
/*  RTE */  RecCrossLeft5NUM,
/*  FB  */  RBScreenRightNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLScreenRightNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLScreenRightNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(NearFarFBSweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBHandOffLeftNUM,
/*  RR  */  MotionLeft_RecCornerRight10NUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRRun7NUM,
/*  HB  */  RBLeadBlock7NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLPullLeftNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS


PLAY(NearFar10YardCurl)
{
	PASS_MEDIUM,
	SetReceivers241351NUM,
	FAR_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecHookLeft10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBPassCircleLeftNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(NearFarHBMisdirection)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	FAR_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBRun8NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLSlantBlockLeftNUM,
/*  RG  */  OLPullLeftNUM,
/*  LG  */  OLSlantBlockRightNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS




PLAY(NearFarPASeem)
{
	PASS_ACTION,
	SetReceivers241351NUM,
	FAR_FORM_NUM,

/*  QB  */  QBPlayActionLeftFBNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecPostRight15NUM,
/*  RTE */  RecCrossLeft10NUM,
/*  FB  */  RBPlayActionOutRightNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(NearFarFBQuickPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	FAR_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBLRun7NUM,
/*  HB  */  MotionRight_RecStreakNUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS


PLAY(NearFarTEBomb)
{
	PASS_DEEP,
	SetReceivers231453NUM,
	FAR_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecHookRight15NUM,
/*  LR  */  RecPostCornerRight10NUM,
/*  RTE */  RecStreakNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  MotionRight_RBPassCircleRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(NearFarWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	FAR_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RTE */  RecCornerRight10NUM,
/*  FB  */  RBDrawRunStepRightNUM,
/*  HB  */  MotionRight_RecCornerRight10NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLSlantBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

//---------------------------------------extra
#if NEWPLAYS1

PLAY(NearFarFBCounterSlant)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideFBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRRun3NUM,
/*  HB  */  RBLeadBlock8NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLSlantBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS

PLAY(NearFarCornerPost)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCrossLeft5NUM,
/*  LR  */  RecCrossLeft15NUM,
/*  RTE */  RecSlantCornerRight10NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPassBackRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(NearFarQBWaggle)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	NEAR_FORM_NUM,

/*  QB  */  QBWaggleRightNUM,
/*  RR  */  RecCrossRight10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecCrossRight15NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBRollOutPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

#endif

//------------------ Off. I Slot   Plays -----------------------


PLAY(ISlotFleaFlicker)
{
	PASS_FLEA,
	SetReceivers213451NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBFleaFlickerNUM,
/* LSLOT*/  RecPostRight15NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBFlatAndUpLeftNUM,
/*  HB  */  RBFleaFlickerNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(ISlotPACrosses)
{
	PASS_ACTION,
	SetReceivers213451NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBPlayActionRightHBNUM,
/* LSLOT*/  RecCrossRight15NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCrossLeft5NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPlayActionOutRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(ISlotHBRunMiddle)
{
	RUN_MIDDLE,
	SetFakeReceivers21345NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/* LSLOT*/  RecRunBlockLeftNUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBRun2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(ISlotBomb)
{
	PASS_DEEP,
	SetReceivers213451NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/* LSLOT*/  MotionRight_RecStreakNUM,
//						/* lslot*/  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecHookLeft15NUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(ISlotFBPower)
{
	RUN_INSIDE,
	SetFakeReceivers21345NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/* LSLOT*/  MotionRight_OLRunBlockRightNUM,
//						/* lslot*/  OLSlantBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRun6NUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(ISlotPAReverse)
{
	RUN_OUTSIDE,
	SetFakeReceivers21345NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBReverseHandOffNUM,
/* LSLOT*/  MotionRight_RecReverseLeftNUM,
//						/* lslot*/  RecReverseRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLSlantBlockLeftNUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBLeadBlock2NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(ISlotCornerFade)
{
	PASS_MEDIUM,
	SetReceivers243152NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/* LSLOT*/  RecPostRight5NUM,
/*  LR  */  RecCornerLeft15NUM,
/*  RTE */  RecSlantCrossLeft5NUM,
/*  FB  */  MotionRight_RecCrossRight5NUM,
//							/*  fb  */  RecCrossRight10NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ISlotQBDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24315NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDrawMiddleNUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCornerRight5NUM,
/*  FB  */  MotionRight_RecCrossRight5NUM,
//					/*  fb  */  RBFlatRightNUM,
/*  HB  */  RBScreenLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS

PLAY(ISlotTEFly)
{
	PASS_DEEP,
	SetReceivers243153NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/* LSLOT*/  RecHookLeft10NUM,
/*  LR  */  RecPostCornerRight5NUM,
/*  RTE */  RecStreakNUM,
/*  FB  */  MotionRight_RecCrossLeft5NUM,
//						/*  fb  */  RBPassCircleRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ISlotTEScreen)
{
	PASS_SHORT,
	SetReceivers253143NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDropBackVeryDeepNUM,
/* LSLOT*/  RecSlantCrossRight10NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  TEScreenLeftNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBFlatAndUpRightNUM,
/*  RT  */  OLScreenLeftNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLScreenLeftNUM
END_PLAY_DS


PLAY(ISlotCrackBack)
{
	RUN_OUTSIDE,
	SetFakeReceivers25314NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/* LSLOT*/  RecCrackBackRightNUM,
/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBLeadBlock7NUM,
/*  HB  */  RBRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(ISlotCenterTrap)
{
	RUN_INSIDE,
	SetFakeReceivers25314NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBLeadBlock1NUM,
/*  HB  */  RBIStepRightRun4NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLTrapRightNUM
END_PLAY_DS


//----------------------------extra
#if NEWPLAYS1

PLAY(ISlotSlantCross)
{
	PASS_MEDIUM,
//	SetReceivers243152NUM,
	SetReceivers213453NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/* LSLOT*/  RecChairRight5NUM,
/*  LR  */  RecSlantCrossRight10NUM,
/*  RTE */  RecCornerRight10NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(ISlotPickPass)
{
	PASS_SHORT,
	SetReceivers213451NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  LR  */  RecCrossRight5NUM,
/*  RTE */  RecPostLeft10NUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(ISlotFBDive)
{
	RUN_INSIDE,
	SetFakeReceivers21345NUM,
	I_SLOT_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRun2NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS
	#endif


//------------------ Off. Single Back Plays -----------------------

PLAY(SingleBackLeadPush)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideFBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  MotionRightLeft_OLRunBlockLeftNUM,
//				/*  lr  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LTE */  OLRunBlockLeftNUM,
/*  HB  */  RBRun3NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(SingleBackShortPost)
{
	PASS_SHORT,
	SetReceivers241351NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBDropBackShortNUM,
/*  RR  */  RecPostLeft5NUM,
/*  LR  */  MotionRightLeft_SlantCornerNUM,
//					/*  lr  */  RecSlantCornerRight5NUM,
/*  RTE */  OLPassBlockNUM,
/*  LTE */  RecCrossRight10NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(SingleBackPACross)
{
	PASS_ACTION,
	SetReceivers241354NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBPlayActionLeftFBNUM,
/*  RR  */  RecCrossRight5NUM,
/*  LR  */  MotionRightLeft_RBFlatLeftNUM,
//							/*  lr  */  RBFlatLeftNUM,
/*  RTE */  OLPassBlockNUM,
/*  LTE */  RecCrossRight10NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(SingleBack10YardCurls)
{
	PASS_MEDIUM,
	SetReceivers241354NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecHookLeft10NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecPostLeft10NUM,
/*  LTE */  RecHookRight10NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(SingleBackSweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecRunBlockRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  LTE */  OLRunBlockRightNUM,
/*  HB  */  RBRun7NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLPullLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS




PLAY(SingleBackRollOutFlood)
{
	PASS_MEDIUM,
	SetReceivers241351NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBRollOutRightNUM,
/*  RR  */  RecHookLeft15NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecCornerRight15NUM,
/*  LTE */  RecSlantCrossRight5NUM,
/*  HB  */  RBRollOutPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(SingleBackWrapAroundDraw)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBDrawHandOffSevenNUM,
/*  RR  */  RecCrossRight10NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCornerRight10NUM,
/*  LTE */  OLRunBlockLeftNUM,
/*  HB  */  RBDrawRunStepRightNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(SingleBackScreen)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecPostLeft15NUM,
/*  LR  */  RecPostRight5NUM,
/*  RTE */  RecCornerRight5NUM,
/*  LTE */  OLPassBlockNUM,
/*  HB  */  HBScreenRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLScreenRightNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(SingleBackPABootLeg)
{
	PASS_ACTION,
	SetReceivers251342NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBPABootLegRightNUM,
/*  RR  */  RecSlantCrossLeft5NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLPassBlockNUM,
/*  LTE */  RecCrossRight10NUM,
/*  HB  */  RBILeadBlockPARightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(SingleBackTECorner)
{
	PASS_DEEP,
	SetReceivers231453NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCrossLeft10NUM,
/*  LR  */  MotionRight_OLPassBlockNUM,
//						/*  lr  */  RecCrossRight5NUM,
/*  RTE */  RecCornerRight15NUM,
/*  LTE */  OLPassBlockNUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(SingleBackCounterPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  MotionRight_RecCrackBackRightNUM,
//								/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  OLSlantBlockLeftNUM,
/*  LTE */  OLRunBlockRightNUM,
/*  HB  */  RBRun7NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS




PLAY(SingleBackPowerLead)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  MotionRight_OLRunBlockRightNUM,
//					/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  OLTrapLeftNUM,
/*  LTE */  OLRunBlockLeftNUM,
/*  HB  */  RBIRun4NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS

//--------------------------------extra
#if NEWPLAYS1

PLAY(SingleBackHBToss)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
//					/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  LTE */  OLRunBlockLeftNUM,
/*  HB  */  RBRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

PLAY(SingleBackQBWaggle)
{
	PASS_MEDIUM,
	SetReceivers231451NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBWaggleRightNUM,
/*  RR  */  RecCrossRight15NUM,
/*  LR  */  RecCrossRight10NUM,
//					/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  RecHookRight15NUM,
/*  LTE */  RecCrossRight5NUM,
/*  HB  */  RBRollOutPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(SingleBackCornerPost)
{
	PASS_MEDIUM,	// bug # 2185	RUN_INSIDE,
	SetReceivers231453NUM,
	SINGLE_BACK_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecCrossRight5NUM,
/*  LR  */  RecStreakNUM,
//					/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  RecSlantCornerRight10NUM,
/*  LTE */  RecCrossRight15NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

	#endif

//------------------ Off. H Back I Plays -----------------------


PLAY(HBackQBDraw)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDrawMiddleRightNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLSlantBlockRightNUM,
/* LSLOT*/  MotionRight_RecStreakNUM,
//					/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLSlantBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLSlantBlockLeftNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS




PLAY(HBackPostCorner)
{
	PASS_DEEP,
	SetReceivers241354NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCrossLeft5NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLPassBlockNUM,
/* LSLOT*/  MotionRight_RecPostCornerLeft5NUM,
//						/* LSLOT*/  RecPostCornerRight5NUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(HBackReverse)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBReverseHandOffNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/* LSLOT*/  MotionRight_RecReverseLeftNUM,
//						/* LSLOT*/  RecReverseLeftNUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(HBackCrackBackSweep)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrackBackRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/* LSLOT*/  RecCrackBackRightNUM,
/*  HB  */  RBRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLPullLeftNUM,
/*  LG  */  OLSlantBlockRightNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS




PLAY(HBackHBCenterTrap)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLSlantBlockRightNUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  HB  */  RBIRun4NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLTrapRightNUM
END_PLAY_DS




PLAY(HBackHBFlat)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCrossLeft15NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecCornerRight15NUM,
/* LSLOT*/  RecCrossLeft5NUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(HBackFleaFlicker)
{
	PASS_FLEA,
	SetReceivers241352NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBFleaFlickerNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,    //should be streak
/*  RTE */  RecCrossRight10NUM,
/* LSLOT*/  RecPostRight15NUM,     
/*  HB  */  RBFleaFlickerNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(HBackPACrosses)
{
	PASS_ACTION,
	SetReceivers241354NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBPlayActionRightFBNUM,
/*  RR  */  RecCrossLeft15NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecSlantCrossLeft5NUM,
/* LSLOT*/  RecCrossRight10NUM,     
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(HBackQuickOuts)
{
	PASS_SHORT,
	SetReceivers241354NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecSlantLeftNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCrossRight5NUM,
/* LSLOT*/  RecCrossLeft5NUM,
/*  HB  */  RBPassBackRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(HBackBomb)
{
	PASS_DEEP,
	SetReceivers231451NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCrossLeft10NUM,
/* LSLOT*/  OLPassBlockNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(HBackStrongPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLRunBlockLeftNUM,
/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS




PLAY(HBackTEScreen)
{
	PASS_SHORT,
	SetReceivers231453NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecScreenLeftNUM,
/* LSLOT*/  RecSlantRightNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLScreenLeftNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLScreenLeftNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



//-------------------------extra
#if NEWPLAYS1

PLAY(HBackFlat)
{
	PASS_SHORT,
	SetReceivers241354NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCrossLeft10NUM,
/* LSLOT*/  RBFlatRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(HBackPickPass)
{
	PASS_SHORT,
	SetReceivers241354NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecCrossRight10NUM,
/*  RTE */  OLPassBlockNUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(HBackHBackRun)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	H_BACK_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLSlantBlockRightNUM,
/* LSLOT*/  RBHRun4NUM,
/*  HB  */  RBILeadBlock4NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS

#endif

//------------------ Off. I Form  Plays -----------------------


PLAY(IFormCounterPullLeft)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/* RR  */   MotionLeft_RecStreakShortNUM,
//			/*  rr  */  RecStreakNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLSlantBlockLeftNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBCounterRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLPullLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS



PLAY(IFormLongBomb)
{
	PASS_DEEP,
	SetReceivers231451NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  MotionLeft_RecStreakShortNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecChairLeft5NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPassCircleLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(IFormHBOption)
{
	PASS_OPTION,
	IFormHBOptionInitNUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/* RR  */  MotionLeft_RecStreakShortNUM,
//						/*  rR  */  RecStreakNUM,
/*  LR  */  RecSlantRightNUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBOptionPassRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(IFormFBPunch)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRun1NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(IFormStrongPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  FB  */  RBLeadBlock8NUM,
/*  HB  */  RBRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLPullRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS




PLAY(IFormPARollOut)
{
	PASS_ACTION,
	SetReceivers241354NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBPARightRollOutRightNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecPostRight15NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBPlayActionOutRightNUM,
/*  HB  */  RBRollOutPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(IFormQuickSlant)
{
	PASS_SHORT,
	SetReceivers251342NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBDropBackShortNUM,
/*  RR  */  RecCrossRight5NUM,
/*  LR  */  RecSlantRightNUM,
/*  RTE */  RecCornerRight10NUM,
/*  FB  */  RBPassBlockLeftNUM,
//						/*  fb  */  RBPassCircleRightNUM,
/*  HB  */  RBPassCircleRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(IFormQuickPitchWeak)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBPassBlockRightNUM,
//						/*  fb  */  RecCrossRight5NUM,
/*  HB  */  RBIRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(IFormOutAndUps)
{
	PASS_DEEP,
	SetReceivers251341NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecChairRight10NUM,
/*  LR  */  RecChairLeft10NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBPassBlockLeftNUM,
//						/*  fb  */  RecCrossLeft10NUM,
/*  HB  */  RBPlayActionOutLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(IFormHBScreen)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  MotionRightShort_RecStreakNUM,
//					/*  lr  */  RecStreakNUM,
/*  RTE */  RecCrossLeft10NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  HBScreenRightNUM,
/*  RT  */  OLScreenRightNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLScreenRightNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLScreenRightNUM
END_PLAY_DS





PLAY(IFormPowerBlast)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	I_FORM_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  MotionRightShort_RecStreakNUM,
//						/*  lr  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBLeadBlock4NUM,
/*  HB  */  RBIRun4NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS





PLAY(IFormPAHBFly)
{
	PASS_ACTION,
	SetReceivers251345NUM,
	I_FORM_FORM_NUM,


/*  QB  */  QBPlayActionLeftFBNUM,
/*  RR  */  RecCrossLeft10NUM,
/*  LR  */  MotionRight_RecPostRight15NUM,
//							/*  lr  */  RecPostRight15NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBPassBlockLeftNUM,
/*  HB  */  RBFlatAndUpLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


//---------------------------extra
#if NEWPLAYS1

PLAY(IFormBounceOutside)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	I_FORM_FORM_NUM,


/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  FB  */  RBLeadBlock2NUM,
/*  HB  */  RBRun28NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS

PLAY(IFormTEPost)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	I_FORM_FORM_NUM,


/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecHookRight15NUM,
/*  LR  */  RecSlantCornerLeft5NUM,
/*  RTE */  RecPostLeft10NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPassCircleRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(IFormPAChair)
{
	PASS_ACTION,
	SetReceivers231451NUM,
	I_FORM_FORM_NUM,


/*  QB  */  QBPlayActionLeftFBNUM,
/*  RR  */  RecChairRight10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBILeadBlockPALeftNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS
#endif

//------------------ Off. Pro Set Plays -----------------------


PLAY(ProSetCounterPullLeft)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/* RR  */   MotionLeft_RecStreakShortNUM,
//			/*  rr  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLSlantBlockLeftNUM,
/*  FB  */  RBLeadBlock4NUM,
/*  HB  */  RBLCounterRun7NUM,
/*  RT  */  OLPullLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLPullLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS



PLAY(ProSetLongBomb)
{
	PASS_DEEP,
	SetReceivers231451NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/* RR  */  MotionLeft_RecStreakShortNUM,
//					/*  rR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecChairLeft5NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPassCircleLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ProSetHalfBackOption)
{
	PASS_OPTION,
	ProSetHalfBackOptionInitNUM,
	PROSET_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/* RR  */  MotionLeft_RecStreakShortNUM,
//						/*  rR  */  RecStreakNUM,
/*  LR  */  RecSlantRightNUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBOptionPassRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ProSetFBPunch)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  RBRRun4NUM,
/*  HB  */  RBLLeadBlock3NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS




PLAY(ProSetStrongPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  FB  */  RBRLeadBlock8NUM,
/*  HB  */  RBLRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLPullRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLSlantBlockRightNUM
END_PLAY_DS




PLAY(ProSetPARollOut)
{
	PASS_ACTION,
	SetReceivers231453NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBPALeftRollOutRightShortNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecPostRight15NUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBRollOutPassBlockRightNUM,
/*  HB  */  RBPlayActionOutRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(ProSetQuickSlant)
{
	PASS_SHORT,
	SetReceivers241351NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDropBackShortNUM,
/*  RR  */  RecCrossRight5NUM,
/*  LR  */  RecSlantRightNUM,
/*  RTE */  RecCornerRight10NUM,
/*  FB  */  MotionUpRight_RBPassCircleRightNUM,
//						/*  fb  */  RBPassCircleRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(ProSetQuickPitchWeak)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecCornerRight15NUM,
/*  LR  */  RecRunBlockLeftNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  FB  */  MotionUpRight_RecCrossRight5NUM,
//						/*  fb  */  RecCrossRight5NUM,
/*  HB  */  RBLRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(ProSetOutAndUps)
{
	PASS_DEEP,
	SetReceivers241352NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecChairRight10NUM,
/*  LR  */  RecChairLeft10NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  MotionUpRight_RecCrossLeft10NUM,
//						/*  fb  */  RecCrossLeft10NUM,
/*  HB  */  RBFlatLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ProSetHBScreen)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  MotionRightShort_RecStreakNUM,
//					/*  lr  */  RecStreakNUM,
/*  RTE */  RecCrossLeft10NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLScreenRightNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLScreenRightNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLScreenRightNUM
END_PLAY_DS




PLAY(ProSetPowerBlast)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  MotionRightShort_RecStreakNUM,
//						/*  lr  */  RecStreakNUM,
/*  RTE */  OLSlantBlockRightNUM,
/*  FB  */  RBRLeadBlock6NUM,
/*  HB  */  RBLRun6NUM,
/*  RT  */  OLSlantBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS





PLAY(ProSetPAHBFly)
{
	PASS_ACTION,
	SetReceivers251345NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecCrossLeft10NUM,
/*  LR  */  MotionRight_RecPostRight15NUM,
//							/*  lr  */  RecPostRight15NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBFlatAndUpLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


//------------------extra
#if NEWPLAYS1

PLAY(ProSetInsideSlant)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecCrossRight5NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLSlantBlockRightNUM,
/*  FB  */  RBRLeadBlock2NUM,
/*  HB  */  RBLRun2NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(ProSetTEPost)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecHookRight15NUM,
/*  LR  */  RecSlantCornerLeft5NUM,
/*  RTE */  RecPostLeft10NUM,
/*  FB  */  RBPassCircleRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(ProSetPAHBChair)
{
	PASS_ACTION,
	SetReceivers231451NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBPlayActionLeftFBNUM,
/*  RR  */  RecChairRight15NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBPlayActionOutLeftNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS
	#endif


//------------------ Off. West Coast Plays -----------------------


PLAY(WestCoastRollOutFlood)
{
	PASS_MEDIUM,
	SetReceivers231451NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBRollOutRightNUM,
/*  RR  */  RecHookLeft10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecPostCornerLeft5NUM,
/* RSLOT*/  RecStreakNUM,     
/*  HB  *///  MotionRight_OLRunBlockRightNUM,
			MotionRight_OLPassBlockNUM,
//			/*  hb  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WestCoastMotionPitch)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBQuickPitchRightNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/* RSLOT*/  RecRunBlockRightNUM,
/*  HB  */  MotionRight_RBLRun8NUM,
//						/*  hb  */  RBLRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS




PLAY(WestCoast10YardCurl)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecHookRight10NUM,
/* RSLOT*/  RecSlantCrossLeft10NUM,
/*  HB  */  MotionRight_RBFlatRightNUM,
//						/*  hb  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(WestCoastPassBackRight)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecChairRight10NUM,
/*  RTE */  RecPostLeft10NUM,
/* RSLOT*/  RecSlantCrossLeft10NUM,
/*  HB  */  RBPassBackRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(WestCoastReverse)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecCrossRight10NUM,
/* RSLOT*/  RecReverseLeftNUM,     
/*  HB  */  RBLLeadBlock2NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(WestCoastPASlant)
{
	PASS_ACTION,
	SetReceivers251342NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBPlayActionBackHBNUM,
/*  RR  */  RecCrossLeft5NUM,
/*  LR  */  RecSlantRightNUM,
/*  RTE */  OLPassBlockNUM,
/* RSLOT*/  RecHookRight10NUM,
/*  HB  */  RBPassBackRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WestCoastBomb)
{
	PASS_DEEP,
	SetReceivers251342NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecCornerRight10NUM,  //RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLPassBlockNUM,
/* RSLOT*/  RecStreakNUM,         //RecCornerRight10NUM,
/*  HB  */  MotionUpLeft_RecCrossRight10NUM,
//				/*  hb  */  RecCrossRight10NUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(WestCoastNoBackPass)
{
	PASS_MEDIUM,
	SetReceivers251345NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCrossRight15NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLPassBlockNUM,
/* RSLOT*/  RecCrossLeft10NUM,     
/*  HB  */  MotionUpLeft_RecPostRight15NUM, // MotionUpLeft_RecPostRight15
//					/*  hb  */  RBFlatAndUpLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WestCoastQBDraw)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDrawMiddleRightNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCornerRight10NUM,
/* RSLOT*/  RecCrossRight10NUM,     
/*  HB  */  MotionUpLeft_OLRunBlockLeftNUM,
//				/*  hb  */  RecRunBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(WestCoastCBBurner)
{
	PASS_MEDIUM,
	SetReceivers241352NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBWaggleLeftNUM,
/*  RR  */  RecSlantCornerRight5NUM,
/*  LR  */  RecSlantCornerRight5NUM,
/*  RTE */  RecCrossLeft10NUM,
/* RSLOT*/  RecHookLeft5NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WestCoastShortPost)
{
	PASS_SHORT,
	SetReceivers241354NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackShortNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrossRight5NUM,
/*  RTE */  RecSlantLeftNUM,
/* RSLOT*/  RecPostLeft5NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(WestCoastOffTackle)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBHandOffRightNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLRunBlockRightNUM,
/* RSLOT*/  RecCornerRight5NUM,
/*  HB  */  RBLRun6NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLPullRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS

//---------------------extra
#if NEWPLAYS1
PLAY(WestCoastHBFlare)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecCrossRight10NUM,
/*  RTE */  RecHookLeft10NUM,
/* RSLOT*/  RecPostLeft10NUM,
/*  HB  */  RBPassBackLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(WestCoastSprintHandOff)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBHandOffLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockRightNUM,
/* RSLOT*/  RecStreakNUM,
/*  HB  */  RBLRun3NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(WestCoastSlantClear)
{
	PASS_MEDIUM,
	SetReceivers251341NUM,
	WEST_COAST_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecSlantLeftNUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  RecStreakNUM,
/* RSLOT*/  RecCornerRight5NUM,
/*  HB  */  RBPassCircleLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

#endif
//------------------ Off. Shotgun I Plays -----------------------

PLAY(ShotGunRolloutOption)
{
	PASS_MEDIUM,
	SetReceivers251345NUM,
	SHOTGUN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/*  RR  */  RecCrossLeft10NUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  MotionLeft_RecCrossLeft5NUM,
//					/* RSLOT*/  RecCrossLeft5NUM,
/* LSLOT*/  RecPostRight15NUM,
/*  HB  */  RBPlayActionOutRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunSwingPass)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	SHOTGUN_FORM_NUM,

/*  QB  */  QBShotGunPassRegularNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecCrossLeft15NUM,
/* RSLOT*/  MotionLeft_OLRunBlockLeftNUM,
//						/* RSLOT*/  RBPassBlockLeftNUM,
/* LSLOT*/  RecPostRight10NUM,     
/*  HB  */  RBPassBackRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunRunGunWide)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	SHOTGUN_FORM_NUM,

/*  QB  */  QBShotGunHandOffNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrackBackRightNUM,
/* RSLOT*/  MotionLeft_OLRunBlockLeftNUM,
//							/* RSLOT*/  OLPullLeftNUM,
/* LSLOT*/  RecRunBlockLeftNUM,
/*  HB  */  RBRRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLSlantBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(ShotGunShortCross)
{
	PASS_SHORT,
	SetReceivers231452NUM,
	SHOTGUN_FORM_NUM,

/*  QB  */  QBShotGunPassRegularNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecSlantCrossRight5NUM,
/* RSLOT*/  RecCrossRight5NUM,
/* LSLOT*/  RecSlantCornerRight5NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunHBSnap)
{
	RUN_MIDDLE,
	SetFakeReceivers23145NUM,
	SHOTGUN_FORM_NUM,

/*  QB  */  QBShotGunDoNothingNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecRunBlockRightNUM,
/* LSLOT*/  RecCrossLeft10NUM,
/*  HB  */  HBSnapRunNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



		 


PLAY(ShotGunHailMary)
{
	PASS_DEEP,
	SetReceivers231453NUM,
	SHOTGUN_FORM_NUM,

/*  QB  */  QBShotGunPassDropNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
//                      /* RSLOT*/  MotionLeft_RecStreakNUM,
/* RSLOT*/  RecPostLeft15NUM,
/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(ShotGunShovelPass)
{
	RUN_OUTSIDE,
	SetReceivers241354NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunPassRegularNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/* LSLOT*/  RecShovelPassNUM,     
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunPoochKick)
{
	SPECIAL_TEAMS,	///	SPECIAL_TEAMS,	- Pooch wasn't seen in run/pass PC method
	SetReceivers241351NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  PunterScriptNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/* LSLOT*/  OLPassBlockNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunDeepCross)
{
	PASS_DEEP,
	SetReceivers241352NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunPassDropNUM,
/*  RR  */  RecHookLeft15NUM,
/*  LR  */  RecCrossRight15NUM,
/*  RTE */  RecCrossRight5NUM,
/* LSLOT*/  RecSlantRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunWRScreen)
{
	PASS_SHORT,
	SetReceivers231451NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunPassDropNUM,
/*  RR  */  RecScreenLeftNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCornerRight10NUM,
/* LSLOT*/  RecPostRight10NUM,     
/*  HB  */  RBPassBackRightNUM,
/*  RT  */  OLScreenRightNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLScreenRightNUM,
/*  LG  */  OLScreenCenterNUM,
/*  CENT*/  OLScreenCenterNUM
END_PLAY_DS


PLAY(ShotGunDelayedDraw)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunDrawHandOffNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCornerRight10NUM,
/* LSLOT*/  RecCrossLeft10NUM,     
/*  HB  */  RBShotGunDrawRunNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(ShotGunShortClearout)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunPassRegularNUM,
/*  RR  */  RecCrossRight15NUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecCrossLeft5NUM,
/* LSLOT*/  RecPostRight5NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


//---------------------------extar SG
#if NEWPLAYS1
PLAY(ShotGunShortDelayToss)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShovelPassNUM,
/*  RR  */  RecRunBlockRightNUM,
/*  LR  */  RecCornerLeft10NUM,
/*  RTE */  OLRunBlockLeftNUM,
/* LSLOT*/  RecCornerLeft10NUM,
/*  HB  */  RBRRun8DelayNUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(ShotGunTEShortPost)
{
	PASS_MEDIUM,
	SetReceivers251342NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunPassRegularNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrossRight5NUM,
/*  RTE */  RecPostLeft5NUM,
/* LSLOT*/  RecPostRight15NUM,
/*  HB  */  RBFlatLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(ShotGunShortClearFlat)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	SHOTGUN_TE_FORM_NUM,

/*  QB  */  QBShotGunPassRegularNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  RecPostLeft10NUM,
/* LSLOT*/  RecCrossRight15NUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS
	#endif

//------------------ Off. Trips Plays -----------------------


PLAY(TripsHBFlat)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrossLeft15NUM,
/* RSLOT*/  RecPostLeft10NUM,
/* LSLOT*/  RecSlantLeftNUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(TripsQBDraw)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDrawMiddleRightNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  RecCrossRight10NUM,
/* LSLOT*/  RecCrossRight5NUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(TripsClearOut)
{
	PASS_SHORT,
	SetReceivers251341NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackShortNUM,
/*  RR  */  RecComeBackLeftNUM,
/*  LR  */  RecPostRight10NUM,
/* RSLOT*/  RecCornerRight10NUM,
/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBFlatLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(TripsSlantCross)
{
	PASS_SHORT,
	SetReceivers231453NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCrossLeft15NUM,
/*  LR  */  RecPostRight10NUM,
/* RSLOT*/  RecSlantLeftNUM,
/* LSLOT*/  RecCrossRight5NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(TripsPitchAway)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBPitchLeftNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  RecStreakNUM,
/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBRun7NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(TripsPickPass)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecPostRight10NUM,
/* RSLOT*/  RecCrossLeft5NUM,
/* LSLOT*/  RecCornerRight5NUM,
/*  HB  */  RBScreenRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(TripsPACross)
{
	PASS_ACTION,
	SetReceivers241354NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBPlayActionRightHBNUM,
/*  RR  */  RecHookLeft15NUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecPostLeft10NUM,
/* LSLOT*/  RecCrossLeft10NUM,
/*  HB  */  RBILeadBlockPARightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(TripsCenterTrap)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecCrossRight10NUM,
/* LSLOT*/  RecSlantRightNUM,
/*  HB  */  RBRun2NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLTrapRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS



PLAY(TripsFleaFlicker)
{
	PASS_FLEA,
	SetReceivers241354NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBFleaFlickerNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft15NUM,
/* RSLOT*/  RecCrossLeft10NUM,
/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBFleaFlickerNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS





PLAY(TripsOutAndUnder)
{
	PASS_MEDIUM,
	SetReceivers231452NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecSlantCornerLeft5NUM,
/* RSLOT*/  RecCrossRight10NUM,
/* LSLOT*/  RecPostLeft10NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(TripsReverse)
{
	RUN_OUTSIDE,
	SetFakeReceivers23145NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RR  */  RecRunBlockLeftNUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecCrackBackLeftNUM,
/* LSLOT*/  RecReverseLeftNUM,
/*  HB  */  RBLeadBlock8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(TripsFlankerCurl)
{
	PASS_MEDIUM,
	SetReceivers231453NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecPostLeft15NUM,
/*  LR  */  RecSlantCornerRight10NUM,
/* RSLOT*/  RecHookRight10NUM,
/* LSLOT*/  RecCornerRight10NUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



//-------------------extra trips
#if NEWPLAYS1


PLAY(TripsOffGuard)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBHandOffLeftInsideHBNUM,
/*  RR  */  RecCornerRight5NUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  RecStreakNUM,
/* LSLOT*/  OLRunBlockRightNUM,
/*  HB  */  RBRun3NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(TripsClearFlat)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCrossRight10NUM,
/* RSLOT*/  RecStreakNUM,
/* LSLOT*/  RecPostLeft10NUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(TripsPostIso)
{
	PASS_MEDIUM,
	SetReceivers251342NUM,
	TRIPS_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecPostRight10NUM,
/* RSLOT*/  RecCrossLeft5NUM,
/* LSLOT*/  OLPassBlockNUM,
/*  HB  */  RBFlatAndUpLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS
#endif

//------------------ Off. Run & Shoot Plays -----------------------



PLAY(RunAndShootShortShoot)
{
	PASS_SHORT,
	SetReceivers231452NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackShortNUM,
/*  RR  */  RecPostLeft10NUM,
/*  LR  */  RecCrossRight10NUM,
/* RSLOT*/  RecSlantCrossLeft5NUM,
/* LSLOT*/  RecCrossLeft5NUM,
/*  HB  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(RunAndShootQBDraw)
{
	RUN_INSIDE,
	SetFakeReceivers23145NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDrawMiddleRightNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  RecCrossRight5NUM,
/* LSLOT*/  RecCornerLeft10NUM,
/*  HB  */  RBScreenLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(RunAndShootMediumShoot)
{
	PASS_MEDIUM,
	SetReceivers231451NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  RecChairLeft5NUM,
/* LSLOT*/  RecCrossRight10NUM,
/*  HB  */  RBPassCircleLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(RunAndShootPACross)
{
	PASS_ACTION,
	SetReceivers241354NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBPlayActionRightHBNUM,
/*  RR  */  RecCrossRight10NUM,
/*  LR  */  RecCrossRight10NUM,
/* RSLOT*/  RecChairRight5NUM,
/* LSLOT*/  RecCornerLeft5NUM,
/*  HB  */  RBILeadBlockPARightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(RunAndShootFleaFlicker)
{
	PASS_FLEA,
	SetReceivers241351NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBFleaFlickerNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft15NUM,
/* RSLOT*/  RecCrossLeft5NUM,
/* LSLOT*/  RecPostRight10NUM,     
/*  HB  */  RBFleaFlickerNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




PLAY(RunAndShootCenterTrap)
{
	RUN_INSIDE,
	SetFakeReceivers24135NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBHandOffRightInsideHBNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecSlantRightNUM,
/* LSLOT*/  RecCrossLeft5NUM,
/*  HB  */  RBRun2NUM,
/*  RT  */  OLSlantBlockRightNUM,
/*  LT  */  OLSlantBlockRightNUM,
/*  RG  */  OLSlantBlockRightNUM,
/*  LG  */  OLTrapRightNUM,
/*  CENT*/  OLSlantBlockLeftNUM
END_PLAY_DS



PLAY(RunAndShootLongShoot)
{
	PASS_DEEP,
	SetReceivers241354NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecCrossLeft10NUM,
/*  LR  */  RecPostRight10NUM,
/* RSLOT*/  RecCrossRight15NUM,
/* LSLOT*/  RecPostCornerRight10NUM,     
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(RunAndShootBomb)
{
	PASS_DEEP,
	SetReceivers241352NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecCrossRight10NUM,
/* LSLOT*/  RecSlantRightNUM,
/*  HB  */  RBPassBlockRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(RunAndShootPitchBack)
{
	RUN_OUTSIDE,
	SetFakeReceivers24135NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBPitchRightNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  OLRunBlockRightNUM,
/* LSLOT*/  RecStreakNUM,
/*  HB  */  RBRun8NUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(RunAndShootMotionFlat)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecPostLeft15NUM,
/*  LR  */  RecCrossLeft15NUM,
/* RSLOT*/  RecCrossLeft10NUM,
/* LSLOT*/  RecStreakNUM,     
/*  HB  */  MotionRight_RBFlatRightNUM,
//							/*  hb  */  RBFlatRightNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(RunAndShootReverse)
{
	RUN_OUTSIDE,
	SetFakeReceivers25134NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDrawHandOffFiveNUM,
/*  RR  */  RecCrackBackLeftNUM,
/*  LR  */  RecCornerLeft10NUM,
/* RSLOT*/  RecCrackBackLeftNUM,
/* LSLOT*/  RecReverseRightNUM,
/*  HB  */  MotionRight_RecCrackBackRightNUM,
//							/*  hb  */  RecRunBlockRightNUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS



PLAY(RunAndShootHBCurl)
{
	PASS_MEDIUM,
	SetReceivers251345NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackDeepNUM,
/*  RR  */  RecPostCornerLeft10NUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecCornerRight5NUM,
/* LSLOT*/  RecPostRight10NUM,
/*  HB  */  MotionRight_RecHookLeft10NUM,
//							/*  hb  */  RecHookLeft10NUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

//----------------------extra
#if NEWPLAYS1

PLAY(RunAndShootOffGuard)
{
	RUN_INSIDE,
	SetFakeReceivers25134NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBHandOffRightInsideFBNUM,
/*  RR  */  RecCornerRight5NUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  OLRunBlockRightNUM,
/* LSLOT*/  MotionRight_OLRunBlockRightNUM,
/*  HB  */  RBIRun4NUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(RunAndShootHBFlat)
{
	PASS_SHORT,
	SetReceivers251345NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCornerRight15NUM,
/*  LR  */  RecStreakNUM,
/* RSLOT*/  RecCrossLeft10NUM,
/* LSLOT*/  MotionRight_RecPostLeft10NUM,
/*  HB  */  RBFlatLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(RunAndShootHBCurl)
{
	PASS_MEDIUM,
	SetReceivers251342NUM,
	RUN_SHOOT_FORM_NUM,

/*  QB  */  QBDropBackMediumNUM,
/*  RR  */  RecCornerRight5NUM,
/*  LR  */  RecPostRight10NUM,
/* RSLOT*/  RecCrossLeft5NUM,
/* LSLOT*/  MotionRight_OLPassBlockNUM,
/*  HB  */  RBFlatAndUpLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


#endif


//------------------ Off. Special Teams Plays -----------------------




PLAY(SpecialTeamsFakeFGRun)
{
	SPECIAL_TEAMS,
	SetFakeReceivers25134NUM,
	FIELD_GOAL_FORM_NUM,

/*  QB2 */  QBFakeFGPitchNUM,
/*  FB  */  OLRunBlockRightNUM,
/*  LTE */  OLSlantBlockRightNUM,
/*  RTE */  OLRunBlockRightNUM,
/*  K   */  SpecialTeamRunLeftNUM,
/*  TE3 */  OLSlantBlockRightNUM,
/*  RT  */  OLRunBlockRightNUM,
/*  LT  */  OLRunBlockRightNUM,
/*  RG  */  OLRunBlockRightNUM,
/*  LG  */  OLRunBlockRightNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(SpecialTeamsFieldGoal)
{
	SPECIAL_TEAMS,
	SetReceivers251341NUM,
	FIELD_GOAL_FORM_NUM,

/*  QB2 */  FieldGoalHoldNUM,
/*  FB  */  OLPassBlockNUM,
/*  LTE */  OLPassBlockNUM,
/*  RTE */  OLPassBlockNUM,
/*  K   */  FieldGoalScriptNUM,
/*  TE3 */  OLPassBlockNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS



PLAY(SpecialTeamsFakeFGPass)
{
	SPECIAL_TEAMS,
	SetReceivers251341NUM,
	FIELD_GOAL_FORM_NUM,

/*  QB2 */  QBFakeFGPassNUM,
/*  FB  */  RecCrossRight5NUM,
/*  LTE */  RecCrossRight15NUM,
/*  RTE */  OLPassBlockNUM,
/*  K   */  RBPassBlockLeftNUM,
/*  TE3 */  RecSlantCrossRight10NUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(SpecialTeamsFakePuntRun)
{
	SPECIAL_TEAMS,
	SetFakeReceivers24135NUM,
	PUNT_FORM_NUM,

/*  P   */  PunterScriptFakeRunNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecStreakNUM,
/*  RTE */  OLRunBlockLeftNUM,
/*  FB  */  SpecialTeamRunRightNUM,
/*  LTE */  OLRunBlockLeftNUM,
/*  RT  */  OLRunBlockLeftNUM,
/*  LT  */  OLRunBlockLeftNUM,
/*  RG  */  OLRunBlockLeftNUM,
/*  LG  */  OLRunBlockLeftNUM,
/*  CENT*/  OLRunBlockLeftNUM
END_PLAY_DS


PLAY(SpecialTeamsPunt)
{
	SPECIAL_TEAMS,
	SetReceivers241351NUM,
	PUNT_FORM_NUM,

/*  P   */  PunterScriptNUM,
/*  RR  */  PuntingTeamEndNUM,
/*  LR  */  PuntingTeamEndNUM,
/*  RTE */  RTEBlockForPuntScriptNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  LTE */  LTEBlockForPuntScriptNUM,
/*  RT  */  RTBlockForPuntScriptNUM,
/*  LT  */  LTBlockForPuntScriptNUM,
/*  RG  */  BlockForPuntScriptNUM,
/*  LG  */  BlockForPuntScriptNUM,
/*  CENT*/  BlockForPuntScriptNUM
END_PLAY_DS


PLAY(SpecialTeamsFakePuntPass)
{
	SPECIAL_TEAMS,
	SetReceivers241351NUM,
	PUNT_FORM_NUM,

/*  P   */  QBShotGunPassRegularNUM,
/*  RR  */  RecStreakNUM,
/*  LR  */  RecHookRight15NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RecCrossRight10NUM,
/*  LTE */  RecCrossRight5NUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS

PLAY(SpecialTeamsQBDownBall)
{
	SPECIAL_TEAMS,
	SetReceivers251342NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBDownBallNUM,
/*  RR  */  RecCornerRight10NUM,
/*  LR  */  RecPostRight15NUM,
/*  RTE */  RecCrossRight5NUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBPassBlockLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


PLAY(SpecialTeamsQBKneel)
{
	SPECIAL_TEAMS,
	SetFakeReceivers25134NUM,
	QB_KNEEL_FORM_NUM,

/*  QB  */  QBKneelNUM,
/*  RR  */  OLPassBlockNUM,
/*  LR  */  OLPassBlockNUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  OLPassBlockNUM,
/*  HB  */  OLPassBlockNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS




PLAY(SpecialTeamsFakeQBDownBall)
{
	SPECIAL_TEAMS,
	SetReceivers251341NUM,
	PROSET_FORM_NUM,

/*  QB  */  QBFakeDownBallNUM,
/*  RR  */  RecHookRight10NUM,
/*  LR  */  RecPostRight10NUM,
/*  RTE */  OLPassBlockNUM,
/*  FB  */  RBPassBlockRightNUM,
/*  HB  */  RBFlatLeftNUM,
/*  RT  */  OLPassBlockNUM,
/*  LT  */  OLPassBlockNUM,
/*  RG  */  OLPassBlockNUM,
/*  LG  */  OLPassBlockNUM,
/*  CENT*/  OLPassBlockNUM
END_PLAY_DS


/****************************************************************


	*************    DEFENSE    ***********************

****************************************************************/

//------------------ Defense Goalline Plays -----------------------

PLAY(DefGoalLineOutsideCrunch)
{
	BLITZ+STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNDefenseNUM,
/* ROLB */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS



PLAY(DefGoalLineGoalLineDeep)
{
	ALL_PURPOSE,
	DefenseGoalLineDeepInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/* LILB */  ZDefenseNUM,
/* RILB */  ZDefenseNUM
END_PLAY_DS




PLAY(DefGoalLineHouseParty)
{
	STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  LNDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  LNDefenseNUM,
/* LOLB */  LNDefenseNUM,
/* ROLB */  LNDefenseNUM,
/* LILB */  LNDefenseNUM,
/* RILB */  LNDefenseNUM
END_PLAY_DS


PLAY(DefGoalLineCheatLeft)
{
	STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNLeftDefenseNUM,
/*  LT  */  LNLeftDefenseNUM,
/*  RT  */  LNLeftDefenseNUM,
/*  RE  */  LNLeftDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNLeftDefenseNUM,
/* ROLB */  LNLeftDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS



PLAY(DefGoalLineShortZone)
{
	STOP_PASS_SHORT,
	DefenseGoalLineShortZoneInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/* LILB */  ZDefenseNUM,
/* RILB */  ZDefenseNUM
END_PLAY_DS




PLAY(DefGoalLineCheatRight)
{
	STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNRightDefenseNUM,
/*  LT  */  LNRightDefenseNUM,
/*  RT  */  LNRightDefenseNUM,
/*  RE  */  LNRightDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNRightDefenseNUM,
/* ROLB */  LNRightDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS



PLAY(DefGoalLineSafetyGamble)
{
	BLITZ+STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  ShowBlitzDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNDefenseNUM,
/* ROLB */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS


PLAY(DefGoalLineFakeGamble)
{
	BLITZ+STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FakeBManDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNDefenseNUM,
/* ROLB */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS


PLAY(DefGoalLineJamMiddle)
{
	BLITZ+STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNDefenseNUM,
/* ROLB */  LNDefenseNUM,
/* LILB */  BlitzDefenseNUM,
/* RILB */  BlitzDefenseNUM
END_PLAY_DS



PLAY(DefGoalLineGoalLineMan)
{
	BLITZ+ALL_PURPOSE,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LNDefenseNUM,
/* ROLB */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS



PLAY(DefGoalLineShadowBackfield)
{
	STOP_RUN,
	DefenseKeyOnBacksInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LBDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LBDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS


PLAY(DefGoalLineOutsideContain)
{
	STOP_RUN,
	DefenseManToManInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  BlitzOutsideLeftDefenseNUM,
/* ROLB */  BlitzOutsideRightDefenseNUM,
/* LILB */  LBDefenseNUM,
/* RILB */  LBDefenseNUM
END_PLAY_DS



//------------------ Defense 4-3 Plays -----------------------


PLAY(Def43OutsideInBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  BlitzInDefenseNUM,
/* ROLB */  BlitzInDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS

						
PLAY(Def433DeepCorner)
{
	ALL_PURPOSE,
	Defense433DeepCornerInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def43StuntBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  BlitzDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  BlitzOutsideLeftDefenseNUM,
/*  RT  */  BlitzOutsideRightDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


PLAY(Def43SSBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  ShowBlitzDefenseNUM
END_PLAY_DS

						
PLAY(Def433DeepSafety)
{
	ALL_PURPOSE,
	Defense433DeepSafetyInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def43FakeSSBlitz)
{
	ALL_PURPOSE,
	Defense43FakeSSBlitzInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  FakeBZDefenseNUM
END_PLAY_DS




PLAY(Def43ManToMan)
{
	STOP_PASS_SHORT,
	DefenseManToManInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


									
PLAY(Def43ZoneLeft)
{
	STOP_PASS_SHORT,
	Defense43ZoneLeftInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS





PLAY(Def43WideZone)
{
	STOP_PASS_SHORT,
	Defense43WideZoneInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS





PLAY(Def43CombatZone)
{
	ALL_PURPOSE,
	Defense43CombatZoneInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS



									
PLAY(Def43TwoDeepZone)
{
	STOP_PASS_SHORT,
	Defense43TwoDeepZoneInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def43LeftBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  ShowBlitzDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


//------------------ Defense 3-4 Plays -----------------------


PLAY(Def34InsideBlitz)
{
	BLITZ+STOP_RUN,
	DefenseManToManInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  BlitzDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  BlitzDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


PLAY(Def34DeepCloud)
{
	ALL_PURPOSE,
	Defense34DeepCloudInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def34StuntBlitz)
{
	BLITZ+ALL_PURPOSE,
	Defense34StuntBlitzInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  BlitzOutsideRightDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  ZDefenseNUM,
/*  RT  */  BlitzOutsideLeftDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS



PLAY(Def34FakeSafetyBlitz)
{
	STOP_PASS_SHORT,
	Defense34FakeSatetyBlitzInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  FakeBZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS





PLAY(Def34DeepSky)
{
	ALL_PURPOSE,
	Defense34DeepSkyInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def34SafetyBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  ShowBlitzDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


PLAY(Def34StraightUpMan)
{
	STOP_PASS_SHORT,
	DefenseManToManInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS



PLAY(Def34CBBlitz)
{
	BLITZ,
	Defense34CBBlitzInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  BlitzOutsideRightDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def34CenterFieldZone)
{
	STOP_PASS_SHORT,
	Defense34CenterFieldZoneInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(Def34SuicideBlitz)
{
	BLITZ+STOP_RUN,
	DefenseManToManInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  BlitzDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  BlitzDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  BlitzOutsideLeftDefenseNUM,
/* ROLB */  BlitzOutsideRightDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


									
PLAY(Def34ShadowZone)
{
	STOP_PASS_SHORT,
	Defense34ShadowZoneInitNUM,
	DEF_3_4_FORM_NUM,

/*  MLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS


PLAY(Def34OutsideBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_3_4_FORM_NUM,

/* RILB */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/* LILB */  LBDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  BlitzOutsideLeftDefenseNUM,
/* ROLB */  BlitzOutsideRightDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


//------------------ Defense Nickel Plays -----------------------

PLAY(DefNickelNickelPrevent)
{
	STOP_PASS_DEEP,
	DefenseNickelPreventInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(DefNickelNickelMan)
{
	ALL_PURPOSE,
	DefenseManToManInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS



PLAY(DefNickelPreventBlitz)
{
	BLITZ+STOP_PASS_DEEP,
	DefenseNickelPreventBlitzInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  BlitzDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS



PLAY(DefNickelKeyOnHB)
{
	STOP_PASS_DEEP,
	DefenseManToManKeyOnHBInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LBDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  LBDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS




PLAY(DefNickelMiddleZone)
{
	ALL_PURPOSE,
	DefenseNickelMiddleZoneInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  ZDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(DefNickelDoubleRight)
{
	STOP_PASS_DEEP,
	DefenseManToManDoubleRightInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


PLAY(DefNickelBigDogEat)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  BlitzDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  BlitzDefenseNUM
END_PLAY_DS


PLAY(DefNickelBumpAndRun)
{
	STOP_PASS_SHORT,
	DefenseManToManInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  LBDefenseNUM,
/*  LC  */  CBBumpDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBBumpDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


PLAY(DefNickelCornerCushion)
{
	STOP_PASS_DEEP,
	DefenseManToManInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  LBDefenseNUM,
/*  LC  */  CBCushionDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBCushionDefenseNUM,
/* LOLB */  LBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS



PLAY(DefNickelQBSpy)
{
	STOP_RUN+ALL_PURPOSE,
	DefenseManToManQBSpyInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  LBQBDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBQBDefenseNUM
END_PLAY_DS



PLAY(DefNickelFakeNickelBlitz)
{
	BLITZ,
	DefenseNickelBlitzZoneInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  FakeBZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/* LOLB */  BlitzDefenseNUM,
/* ROLB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS



PLAY(DefNickelNickelBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  NB  */  ShowBlitzDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/* LOLB */  BlitzDefenseNUM,
/* ROLB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM          
END_PLAY_DS


//------------------ Defense Dime Plays -----------------------


PLAY(DefDimePrevent)
{
	STOP_PASS_DEEP,
	DefenseDimePreventInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/* IRLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/*  NB  */  ZDefenseNUM,
/*  DiB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS


																				 
PLAY(DefDimeDimeMan)
{
	STOP_PASS_SHORT,
	DefenseManToManInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/*  IRLB*/  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  NB  */  LBDefenseNUM,
/*  DiB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS


																				 

PLAY(DefDimeFourDeep)
{
	STOP_PASS_DEEP,
	DefenseDimeFourDeepInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/* IRLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/*  NB  */  ZDefenseNUM,
/*  DiB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(DefDimePreventRight)
{
	STOP_PASS_DEEP,
	DefenseDimePreventRightInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/* IRLB */  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/*  NB  */  ZDefenseNUM,
/*  DiB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS



PLAY(DefDimeInsideBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/*  IRLB*/  BlitzDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  NB  */  LBDefenseNUM,
/*  DiB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS



PLAY(DefDimeDoubleWides)
{
	STOP_PASS_DEEP,
	DefenseManToManDoubleWidesInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/*  MLB*/   LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  NB  */  CBDefenseNUM,
/*  DiB */  LBDefenseNUM,
/*  FS  */  LBDefenseNUM,
/*  SS  */  CBDefenseNUM
END_PLAY_DS



PLAY(DefDimeBlitzMan)
{
	BLITZ+ALL_PURPOSE,
	DefenseManToManInitNUM,
	DEF_DIME_FORM_NUM,

/*  ORLB*/  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  OLLB*/  BlitzOutsideLeftDefenseNUM,
/*  RT  */  BlitzOutsideRightDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  NB  */  LBDefenseNUM,
/*  DiB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS



																				 
PLAY(DefDimeDoubleCBBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_DIME_FORM_NUM,

/*  ORLB*/  LBDefenseNUM,
/*  LC  */  BlitzDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  OLLB*/  LBDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  BlitzDefenseNUM,
/*  NB  */  LBDefenseNUM,
/*  DiB */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS

PLAY(DefDimePreventLeft)
{
	STOP_PASS_DEEP,
	DefenseDimePreventLeftInitNUM,
	DEF_DIME_FORM_NUM,

/*  ORLB*/  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  OLLB*/  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/*  NB  */  ZDefenseNUM,
/*  DiB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(DefDimeFakeSafetyBlitz)
{
	STOP_PASS_SHORT,
	DefenseDimeFakeSafetyBlitzInitNUM,
	DEF_DIME_FORM_NUM,

/*  ORLB*/  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  OLLB*/  ZDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/*  NB  */  ZDefenseNUM,
/*  DiB */  FakeBZDefenseNUM,
/*  FS  */  FakeBZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS



PLAY(DefDimeBlitzZone)
{
	BLITZ+ALL_PURPOSE,
	DefenseDimeBlitzZoneInitNUM,
	DEF_DIME_FORM_NUM,

/*  ORLB*/  ZDefenseNUM,
/*  LC  */  ZDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  OLLB*/  BlitzDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  ZDefenseNUM,
/*  NB  */  ZDefenseNUM,
/*  DiB */  ZDefenseNUM,
/*  FS  */  ZDefenseNUM,
/*  SS  */  ZDefenseNUM
END_PLAY_DS




PLAY(DefDimeTwoSafetyBlitz)
{
	BLITZ,
	DefenseManToManInitNUM,
	DEF_DIME_FORM_NUM,

/*  ORLB*/  LBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  OLLB*/  LBDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  NB  */  LBDefenseNUM,
/*  DiB */  ShowBlitzDefenseNUM,
/*  FS  */  ShowBlitzDefenseNUM,
/*  SS  */  LBDefenseNUM
END_PLAY_DS



//------------------ Defense Special Teams Plays -----------------------
				/*  def special teams (6 plays)	*/

PLAY(DefSpecialDoubleOutside)
{
	SPECIAL_TEAMS_DEF,
	DefenseManToManPuntDoubleInitNUM,
	DEF_PUNT_DOUBLE_COVER_FORM_NUM,

/*  FS  */  CBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  OLLB*/  BlitzDefenseNUM,
/*  ORLB*/  BlitzDefenseNUM,
/*  PR  */  PuntReturnerScriptNUM,
/*  SS  */  CBDefenseNUM	//FSDefenseNUM
END_PLAY_DS



PLAY(DefSpecialPuntReturn)
{
	SPECIAL_TEAMS_DEF,
	DefensePuntInitNUM,
	DEF_PUNT_FORM_NUM,

/*  PR  */  CBDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LBDefenseNUM,
/*  FS  */  FSDefenseNUM,
/*  RT  */  LBDefenseNUM,
/*  RE  */  LBDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  OLLB*/  LBDefenseNUM,
/*  ORLB*/  LBDefenseNUM,
/*  ILLB*/  PuntReturnerScriptNUM,
/*  IRLB*/  BlitzDefenseNUM
END_PLAY_DS



PLAY(DefSpecialPuntBlock)
{
	SPECIAL_TEAMS_DEF,
	DefensePuntInitNUM,
	DEF_PUNT_FORM_NUM,

/*  PR  */  BlitzDefenseNUM,
/*  LC  */  BlitzDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LBDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  BlitzDefenseNUM,
/*  OLLB*/  BlitzDefenseNUM,
/*  ORLB*/  BlitzDefenseNUM,
/*  FS  */  PuntReturnerScriptNUM,
/*  SS  */  BlitzDefenseNUM
END_PLAY_DS


PLAY(DefSpecial11ManRush)
{
	SPECIAL_TEAMS_DEF,
	DefenseFGInitNUM,
//	DEF_ALL_OUT_BLOCK_FORM_NUM,
	DEF_FG_FORM_NUM,

/*  DB7 */  LNDefenseNUM,
/*  LC  */  LNDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  LNDefenseNUM,
/*  OLLB*/  LNDefenseNUM,
/*  ORLB*/  LNDefenseNUM,
/*  FS  */  LNDefenseNUM,
/*  SS  */  LNDefenseNUM
END_PLAY_DS

PLAY(DefSpecialFGBlock)
{
	SPECIAL_TEAMS_DEF,
	DefenseFGInitNUM,
	DEF_FG_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  LBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LBDefenseNUM,
/*  RC  */  LBDefenseNUM,
/*  OLLB*/  LNDefenseNUM,
/*  ORLB*/  LNDefenseNUM,
/*  ILLB*/  LNDefenseNUM,
/*  IRLB*/  LBDefenseNUM
END_PLAY_DS



PLAY(DefSpecialWatchFake)
{
	SPECIAL_TEAMS_DEF,
	DefenseFGInitNUM,
	DEF_FG_FORM_NUM,

/*  SS  */  FSDefenseNUM,
/*  LC  */  CBDefenseNUM,
/*  LE  */  LNDefenseNUM,
/*  LT  */  LNDefenseNUM,
/*  RT  */  LNDefenseNUM,
/*  RE  */  LNDefenseNUM,
/*  RC  */  CBDefenseNUM,
/*  OLLB*/  LBDefenseNUM,
/*  ORLB*/  LBDefenseNUM,
/*  ILLB*/  LBDefenseNUM,
/*  IRLB*/  LBDefenseNUM
END_PLAY_DS



//------------------  KickOff - Kick return Plays -----------------------


PLAY(KickoffReturnSpread)
{
	KICKOFF,
	OffenseKickoffInitNUM,
	KICKOFF_RETURN_SPREAD_FORM_NUM,

/*  KR  */  KickoffReturnerRightNUM,
/*  LC  */  KOUpManNUM,
/*  LE  */  KOUpManNUM,
/*  LT  */  KOUpManNUM,
/*  RT  */  KOUpManNUM,
/*  RE  */  KOUpManNUM,

/*  NB  */  KOWedgeRightNUM,
/*  SS  */  KickoffReturnerLeftNUM,
/*  RC  */  KOWedgeLeftNUM,
/*  FS  */  KOWedgeLeftNUM,
/*  DiB */  KOWedgeRightNUM,
END_PLAY_DS


PLAY(KickoffReturnRegular)
{
	KICKOFF,
	OffenseKickoffInitNUM,
	KICKOFF_RETURN_FORM_NUM,

/*  KR  */  KickoffReturnerNUM,
/*  LC  */  KOUpManNUM,
/*  LE  */  KOUpManNUM,
/*  LT  */  KOUpManNUM,
/*  RT  */  KOUpManNUM,
/*  RE  */  KOUpManNUM,
/*  RC  */  KOWedgeRightNUM,
/*  NB  */  KOWedgeMiddleNUM,
/*  DiB */  KOWedgeLeftNUM,
/*  FS  */  KOWedgeBackLeftNUM,
/*  SS  */  KOWedgeBackRightNUM,
END_PLAY_DS




PLAY(KickoffReturnGoodHands)
{
	KICKOFF,
	OffenseKickoffInitNUM,
	KICKOFF_RETURN_HANDS_FORM_NUM,

/*  KR  */  KickoffReturnerNUM,
/*  LC  */  KOUpManNUM,
/*  LE  */  KOUpManNUM,
/*  LT  */  KOUpManNUM,
/*  RT  */  KOUpManNUM,
/*  RE  */  KOUpManNUM,
/*  RC  */  KOUpManNUM,
/*  NB  */  KOWedgeLeftNUM,
/*  DiB */  KOWedgeRightNUM,
/*  FS  */  KOWedgeRightNUM,
/*  SS  */  KOWedgeLeftNUM,
END_PLAY_DS






PLAY(KickoffStackLeft)
{
	KICKOFF,
	DefenseNoPlayInitNUM,
	KICKOFF_LEFT_KICKING_FORM_NUM,

/*Kicker*/  KOKickerNUM,
/*  LC  */  KickoffTacklerNUM,
/*  LE  */  KickoffTacklerNUM,
/*  LT  */  KickoffTacklerNUM,
/*  RT  */  KickoffTacklerNUM,
/*  RE  */  KickoffTacklerNUM,
/*  RC  */  KickoffTacklerNUM,
/*  NB  */  KickoffTacklerNUM,
/*  DiB */  KickoffTacklerNUM,
/*  FS  */  KickoffTacklerNUM,
/*  SS  */  KickoffTacklerNUM,
END_PLAY_DS



PLAY(KickoffRegular)
{
	KICKOFF,
	DefenseNoPlayInitNUM,
	KICKOFF_KICKING_FORM_NUM,

/*Kicker*/  KOKickerNUM,
/*  LC  */  KickoffMiddleTacklerNUM,
/*  LE  */  KickoffMiddleTacklerNUM,
/*  LT  */  KickoffTacklerNUM,
/*  RT  */  KickoffTacklerNUM,
/*  RE  */  KickoffTacklerNUM,
/*  RC  */  KickoffTacklerNUM,
/*  NB  */  KickoffTacklerNUM,
/*  DiB */  KickoffTacklerNUM,
/*  FS  */  KickoffTacklerNUM,
/*  SS  */  KickoffTacklerNUM,
END_PLAY_DS



PLAY(KickoffStackRight)
{
	KICKOFF,
	DefenseNoPlayInitNUM,
	KICKOFF_RIGHT_KICKING_FORM_NUM,	//bug # 1538 -left or right - depends on Off or Def

/*Kicker*/  KOKickerNUM,
/*  LC  */  KickoffTacklerNUM,
/*  LE  */  KickoffTacklerNUM,
/*  LT  */  KickoffTacklerNUM,
/*  RT  */  KickoffTacklerNUM,
/*  RE  */  KickoffTacklerNUM,
/*  RC  */  KickoffTacklerNUM,
/*  NB  */  KickoffTacklerNUM,
/*  DiB */  KickoffTacklerNUM,
/*  FS  */  KickoffTacklerNUM,
/*  SS  */  KickoffTacklerNUM,
END_PLAY_DS





/**********************   EDITED PLAYS   *******************/
//   Reserve space for edited plays

	EDITEDPLACEHOLDER	// 24 plays for team 0
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER


	EDITEDPLACEHOLDER	// 24 plays for team 1
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER

	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER
	EDITEDPLACEHOLDER



/*******************  EASTER   EGG (TESTING) PLAYS ***********************/

PLAY(OffSpeedTest)			// Easter  Egg play
{
	TEST,
	SpeedTestInitNUM,
	OFF_RACE_FORM_NUM,

/*  QB  */  RaceScriptNUM,	//TwitchScriptNUM, //QBDropBackMediumNUM,
/*  RR  */  RaceScriptNUM,
/*  LR  */  RaceScriptNUM,
/*  RTE */  RaceScriptNUM,
/*  LTE */  RaceScriptNUM,
/*  HB  */  RaceScriptNUM,
/*  RT  */  RaceScriptNUM,
/*  LT  */  RaceScriptNUM,
/*  RG  */  RaceScriptNUM,
/*  LG  */  RaceScriptNUM,
/*  CENT*/  RaceScriptNUM
END_PLAY_DS

PLAY(OffAccelTest)  		// Easter  Egg play
{
	TEST,
	AccelTestInitNUM,
	OFF_RACE_FORM_NUM,

/*  QB  */  RaceScriptNUM,	//QBDropBackMediumNUM,
/*  RR  */  RaceScriptNUM,
/*  LR  */  RaceScriptNUM,
/*  RTE */  RaceScriptNUM,
/*  LTE */  RaceScriptNUM,
/*  HB  */  RaceScriptNUM,
/*  RT  */  RaceScriptNUM,
/*  LT  */  RaceScriptNUM,
/*  RG  */  RaceScriptNUM,
/*  LG  */  RaceScriptNUM,
/*  CENT*/  RaceScriptNUM
END_PLAY_DS



PLAY(OffBlocking)      		// Easter  Egg play
{
	TEST,
	SetReceivers231451NUM,
	OFF_ONE_MAN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/* LSLOT*/  NoDefenseNUM,
/*  LR  */  NoDefenseNUM,
/*  RTE */  NoDefenseNUM,
/*  FB  */  NoDefenseNUM,
/*  HB  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RG  */  NoDefenseNUM,
/*  LG  */  NoDefenseNUM,
/*  CENT*/  OLPassBlockNUM	//OLRunBlockRightNUM
END_PLAY_DS


PLAY(OffBlocking4)     		// Easter  Egg play
{
	TEST,
	SetFakeReceivers23145NUM,
	OFF_ONE_MAN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/* LSLOT*/  NoDefenseNUM,
/*  LR  */  NoDefenseNUM,
/*  RTE */  NoDefenseNUM,
/*  FB  */  NoDefenseNUM,
/*  HB  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RG  */  NoDefenseNUM,
/*  LG  */  NoDefenseNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(OffSpeedTest)     		// Easter  Egg play
{
	TEST,
	SpeedTestInitNUM,
	OFF_RACE_FORM_NUM,

/*  QB  */  Twitch2ScriptNUM,
/*  RR  */  RaceScriptNUM,
/*  LR  */  RaceScriptNUM,
/*  RTE */  RaceScriptNUM,
/*  LTE */  RaceScriptNUM,
/*  HB  */  RaceScriptNUM,
/*  RT  */  RaceScriptNUM,
/*  LT  */  RaceScriptNUM,
/*  RG  */  RaceScriptNUM,
/*  LG  */  RaceScriptNUM,
/*  CENT*/  RaceScriptNUM
END_PLAY_DS

PLAY(OffAccelTest)     		// Easter  Egg play
{
	TEST,
	AccelTestInitNUM,
	OFF_RACE_FORM_NUM,

/*  QB  */  RaceScriptNUM,	//QBDropBackMediumNUM,
/*  RR  */  RaceScriptNUM,
/*  LR  */  RaceScriptNUM,
/*  RTE */  RaceScriptNUM,
/*  LTE */  RaceScriptNUM,
/*  HB  */  RaceScriptNUM,
/*  RT  */  RaceScriptNUM,
/*  LT  */  RaceScriptNUM,
/*  RG  */  RaceScriptNUM,
/*  LG  */  RaceScriptNUM,
/*  CENT*/  RaceScriptNUM
END_PLAY_DS



PLAY(OffBlocking)      		// Easter  Egg play
{
	TEST,
	SetFakeReceivers23145NUM,
	OFF_ONE_MAN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/* LSLOT*/  NoDefenseNUM,
/*  LR  */  NoDefenseNUM,
/*  RTE */  NoDefenseNUM,
/*  FB  */  NoDefenseNUM,
/*  HB  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RG  */  NoDefenseNUM,
/*  LG  */  NoDefenseNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS


PLAY(OffBlocking4)     		// Easter  Egg play
{
	TEST,
	SetFakeReceivers23145NUM,
	OFF_ONE_MAN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/* LSLOT*/  NoDefenseNUM,
/*  LR  */  NoDefenseNUM,
/*  RTE */  NoDefenseNUM,
/*  FB  */  NoDefenseNUM,
/*  HB  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RG  */  NoDefenseNUM,
/*  LG  */  NoDefenseNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS



PLAY(OffSpeedTest)     		// Easter  Egg play
{
	TEST,
	SpeedTestInitNUM,
	OFF_RACE_FORM_NUM,

/*  QB  */  RaceScriptNUM, //QBDropBackMediumNUM,
/*  RR  */  RaceScriptNUM,
/*  LR  */  RaceScriptNUM,
/*  RTE */  RaceScriptNUM,
/*  LTE */  RaceScriptNUM,
/*  HB  */  RaceScriptNUM,
/*  RT  */  RaceScriptNUM,
/*  LT  */  RaceScriptNUM,
/*  RG  */  RaceScriptNUM,
/*  LG  */  RaceScriptNUM,
/*  CENT*/  RaceScriptNUM
END_PLAY_DS

PLAY(OffAccelTest)     		// Easter  Egg play
{
	TEST,
	AccelTestInitNUM,
	OFF_RACE_FORM_NUM,

/*  QB  */  RaceScriptNUM,	//QBDropBackMediumNUM,
/*  RR  */  RaceScriptNUM,
/*  LR  */  RaceScriptNUM,
/*  RTE */  RaceScriptNUM,
/*  LTE */  RaceScriptNUM,
/*  HB  */  RaceScriptNUM,
/*  RT  */  RaceScriptNUM,
/*  LT  */  RaceScriptNUM,
/*  RG  */  RaceScriptNUM,
/*  LG  */  RaceScriptNUM,
/*  CENT*/  RaceScriptNUM
END_PLAY_DS



PLAY(OffBlocking)      		// Easter  Egg play
{
	TEST,
	SetFakeReceivers23145NUM,
	OFF_ONE_MAN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/* LSLOT*/  NoDefenseNUM,
/*  LR  */  NoDefenseNUM,
/*  RTE */  NoDefenseNUM,
/*  FB  */  NoDefenseNUM,
/*  HB  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RG  */  NoDefenseNUM,
/*  LG  */  NoDefenseNUM,
/*  CENT*/  OLPassBlockNUM	//OLRunBlockRightNUM
END_PLAY_DS


PLAY(OffBlocking4)     		// Easter  Egg play
{
	TEST,
	SetFakeReceivers23145NUM,
	OFF_ONE_MAN_FORM_NUM,

/*  QB  */  QBShotGunRollOutRightNUM,
/* LSLOT*/  NoDefenseNUM,
/*  LR  */  NoDefenseNUM,
/*  RTE */  NoDefenseNUM,
/*  FB  */  NoDefenseNUM,
/*  HB  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RG  */  NoDefenseNUM,
/*  LG  */  NoDefenseNUM,
/*  CENT*/  OLRunBlockRightNUM
END_PLAY_DS




	/**********************  TEAM 1 (AWAY) edited plays	*/

PLAY(DefDummyGoalline1)			// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS


PLAY(DefDummy43)			// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS

PLAY(DefDummy34)    		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_3_4_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS


PLAY(DefNickelDummy)			// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS

PLAY(DefDimeDummy)      		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS


PLAY(DefDime3MLDummy)   		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_DIME_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS

PLAY(DefDummyGoalline1) 		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_GOALINE_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS


PLAY(DefDummy43)        		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_4_3_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS

PLAY(DefDummy34)        		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_3_4_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS


PLAY(DefNickelDummy)    		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_NICKEL_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS

PLAY(DefDimeDummy)      		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_DIME_4MANLINE_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS




PLAY(DefDummyDummy9)    		// Easter  Egg play
{
	TEST,
	DefenseNoPlayInitNUM,
	DEF_DUMMY_FORM_NUM,

/*  MLB */  NoDefenseNUM,
/*  LC  */  NoDefenseNUM,
/*  LE  */  NoDefenseNUM,
/*  LT  */  NoDefenseNUM,
/*  RT  */  NoDefenseNUM,
/*  RE  */  NoDefenseNUM,
/*  RC  */  NoDefenseNUM,
/*  NB  */  NoDefenseNUM,
/*  DiB */  NoDefenseNUM,
/*  FS  */  NoDefenseNUM,
/*  SS  */  NoDefenseNUM
END_PLAY_DS




};	/***** End of "ThePlays" array	************/







/********************************************************************

				 A U D I B L E S

	Each formation has 3 audibles

********************************************************************/


UWORD DefensiveAudibles[MAX_DEFFORMS_FOR_AUDIBLES][MAX_PLAYS_PER_AUDIBLEFORM]
 = {	// each form has 3 audibles
/*  **********************/

	DefGoalLineOutsideCrunchNUM,
	DefGoalLineGoalLineManNUM,
	DefGoalLineGoalLineDeepNUM,
/*
	DefGoalLineCheatLeftNUM,
	DefGoalLineShortZoneNUM,
	DefGoalLineCheatRightNUM,

	DefGoalLineSafetyGambleNUM,
	DefGoalLineFakeGambleNUM,
	DefGoalLineJamMiddleNUM,

	DefGoalLineGoalLineManNUM,
	DefGoalLineShadowBackfieldNUM,
	DefGoalLineOutsideContainNUM,
*/
/*  **************************************/
	Def43OutsideInBlitzNUM,
	Def43ManToManNUM,
	Def43TwoDeepZoneNUM,
/*
	Def43SSBlitzNUM,
	Def433DeepSafetyNUM,
	Def43FakeSSBlitzNUM,

	Def43ManToManNUM,
	Def43ZoneLeftNUM,
	Def43WideZoneNUM,

	Def43CombatZoneNUM,
	Def43TwoDeepZoneNUM,
	Def43LeftBlitzNUM,
*/
/*  **************************************/
	Def34SuicideBlitzNUM,
	Def34InsideBlitzNUM,
	Def34DeepCloudNUM,
/*
	Def34FakeSafetyBlitzNUM,
	Def34DeepSkyNUM,
	Def34SafetyBlitzNUM,

	Def34StraightUpManNUM,
	Def34CBBlitzNUM,
	Def34CenterFieldZoneNUM,

	Def34SuicideBlitzNUM,
	Def34ShadowZoneNUM,
	Def34OutsideBlitzNUM,
*/
/*  **************************************/
	DefNickelBigDogEatNUM,
	DefNickelNickelManNUM,
	DefNickelNickelPreventNUM,
/*
	DefNickelKeyOnHBNUM,
	DefNickelMiddleZoneNUM,
	DefNickelDoubleRightNUM,

	DefNickelBigDogEatNUM,
	DefNickelBumpAndRunNUM,
	DefNickelCornerCushionNUM,

	DefNickelQBSpyNUM,
	DefNickelFakeNickelBlitzNUM,
	DefNickelNickelBlitzNUM,
*/
/*  **************************************/
	DefDimeDoubleCBBlitzNUM,
	DefDimeDimeManNUM,
	DefDimeFourDeepNUM,
/*
	DefDimePreventRightNUM,
	DefDimeInsideBlitzNUM,
	DefDimeDoubleWidesNUM,

	DefDimeBlitzManNUM,
	DefDimeDoubleCBBlitzNUM,
	DefDimePreventLeftNUM,

	DefDimeFakeSafetyBlitzNUM,
	DefDimeBlitzZoneNUM,
	DefDimeTwoSafetyBlitzNUM,
*/

};

UBYTE OffensiveAudibles[MAX_OFFFORMS_FOR_AUDIBLES][MAX_PLAYS_PER_AUDIBLEFORM]
 = {	// each form has 3 audibles
	GoalLineGoalLineFloodNUM,
	GoalLineFBDiveNUM,
	GoalLineOptionPassNUM,



//	GoalLineNakedBootlegNUM,
//	GoalLineHBLeapNUM,
//	GoalLineGoalLineFloodNUM,

//	GoalLineTECornerNUM,
//	GoalLineOptionLeadNUM,
//	GoalLineCounterSurgeNUM,

//	GoalLinePAFadeNUM,
//	GoalLineHBPowerNUM,
//	GoalLineHBTrapNUM,




/* 12 **************************************/

	WishBone10YardCurlNUM,	//SHORT
	WishBonePowerHBDiveNUM,			   //RUN
	WishBoneTEBombNUM,			   //LONG

//	WishBonePowerHBDiveNUM,
//	WishBoneHBScreenNUM,
//	WishBoneStudentBodySweepNUM,

//	WishBone10YardCurlNUM,
//	WishBoneMisdirectionNUM,
//	WishBonePASeemNUM,

//	WishBoneQuickPitchNUM,
//	WishBoneTEBombNUM,
//	WishBoneWrapAroundDrawNUM,



/* 24 **************************************/

	PowerIFBOffTackleNUM,
	PowerIRollOutNUM,
	PowerIPitchSweepNUM,

//	PowerIPowerHBDiveNUM,
//	PowerIHBScreenNUM,
//	PowerIDoubleOptionNUM,

//  PowerI10YardCurlNUM,
//	PowerIFBMisdirectionNUM,
//	PowerIPASeemNUM,

//	PowerIFBQuickPitchNUM,
//	PowerITEBombNUM,
//	PowerIWrapAroundDrawNUM,


/* 36 **************************************/
	NearFar10YardCurlNUM,
	NearFarHBOffTackleNUM,
	NearFarTEBombNUM,

//	NearFarPowerHBRunNUM,
//	NearFarFBScreenNUM,
//	NearFarFBSweepNUM,

//	NearFar10YardCurlNUM,
//	NearFarHBMisdirectionNUM,
//	NearFarPASeemNUM,

//	NearFarFBQuickPitchNUM,
//	NearFarTEBombNUM,
//	NearFarWrapAroundDrawNUM,



/* 48 **************************************/
	ISlotSlantCrossNUM,
	ISlotHBRunMiddleNUM,
	ISlotBombNUM,
/*
	ISlotBombNUM,
	ISlotFBPowerNUM,
	ISlotPAReverseNUM,

	ISlotCornerFadeNUM,
	ISlotQBDrawNUM,
	ISlotTEFlyNUM,

	ISlotTEScreenNUM,
	ISlotTheOptionNUM,
	ISlotCenterTrapNUM,
*/
/* 60 **************************************/
	SingleBackShortPostNUM,
	SingleBackSweepNUM,
	SingleBackCornerPostNUM,
/*
	SingleBack10YardCurlsNUM,
	SingleBackSweepNUM,
	SingleBackRollOutFloodNUM,

	SingleBackWrapAroundDrawNUM,
	SingleBackScreenNUM,
	SingleBackPABootLegNUM,

	SingleBackTECornerNUM,
	SingleBackCounterPitchNUM,
	SingleBackPowerLeadNUM,
*/
/* 72 **************************************/
	HBackQuickOutsNUM,
	HBackHBCenterTrapNUM,
	HBackBombNUM,
/*
	HBackCrackBackSweepNUM,
	HBackHBCenterTrapNUM,
	HBackHBFlatNUM,

	HBackFleaFlickerNUM,
	HBackPACrossesNUM,
	HBackQuickOutsNUM,

	HBackBombNUM,
	HBackTheOptionNUM,
	HBackTEScreenNUM,
  */
/* 84 **************************************/


	IFormQuickSlantNUM,
	IFormFBPunchNUM,
	IFormLongBombNUM,
/*
	IFormFBPunchNUM,
	IFormStrongPitchNUM,
	IFormPARollOutNUM,

	IFormQuickSlantNUM,
	IFormQuickPitchWeakNUM,
	IFormOutAndUpsNUM,

	IFormHBScreenNUM,
	IFormPowerBlastNUM,
	IFormPAHBFlyNUM,
*/
/* 96 **************************************/

	ProSetQuickSlantNUM,
	ProSetFBPunchNUM,
	ProSetLongBombNUM,
/*
	ProSetFBPunchNUM,
	ProSetStrongPitchNUM,
	ProSetPARollOutNUM,

	ProSetQuickSlantNUM,
	ProSetQuickPitchWeakNUM,
	ProSetOutAndUpsNUM,

	ProSetHBScreenNUM,
	ProSetPowerBlastNUM,
	ProSetPAHBFlyNUM,
*/
/* 108 **************************************/

	WestCoastShortPostNUM,
	WestCoastOffTackleNUM,
	WestCoastBombNUM,

/*	WestCoastRollOutFloodNUM,
	WestCoastMotionPitchNUM,
	WestCoast10YardCurlNUM,
*
	WestCoastPassBackRightNUM,
	WestCoastReverseNUM,
	WestCoastPASlantNUM,

	WestCoastBombNUM,
	WestCoastNoBackPassNUM,
	WestCoastQBDrawNUM,

	WestCoastFleaFlickerNUM,
	WestCoastShortPostNUM,
	WestCoastOffTackleNUM,
*/
/* 120 **************************************/
	ShotGunShortCrossNUM,
	ShotGunHBSnapNUM,
	ShotGunHailMaryNUM,
/*
	ShotGunShortCrossNUM,
	ShotGunDeepCurlNUM,
	ShotGunHailMaryNUM,

	ShotGunShovelPassNUM,
	ShotGunPoochKickNUM,
	ShotGunDeepCrossNUM,

	ShotGunWRScreenNUM,
	ShotGunDelayedDrawNUM,
	ShotGunShortClearoutNUM,
*/
/* 132 **************************************/

	TripsSlantCrossNUM,
	TripsCenterTrapNUM,
	TripsPostIsoNUM,
/*
	TripsSlantCrossNUM,
	TripsTheOptionNUM,
	TripsPickPassNUM,

	TripsPACrossNUM,
	TripsCenterTrapNUM,
	TripsFleaFlickerNUM,

	TripsOutAndUnderNUM,
	TripsReverseNUM,
	TripsFlankerCurlNUM,
*/
/* 144 **************************************/

	RunAndShootShortShootNUM,
	RunAndShootOffGuardNUM,
	RunAndShootBombNUM,
/*
	RunAndShootPACrossNUM,
	RunAndShootFleaFlickerNUM,
	RunAndShootCenterTrapNUM,

	RunAndShootLongShootNUM,
	RunAndShootBombNUM,
	RunAndShootTheOptionNUM,

	RunAndShootMotionFlatNUM,
	RunAndShootReverseNUM,
	RunAndShootHBCurlNUM,
*/

};



/********************* End Of File - FBPlays.c   ********************/


